﻿(()=>{
//REPLACE_ITEMS_START//
//version=2.1.1//
class RIF {
    static Match(string, replaceMatch, rString) {
        return ((replaceMatch === 'full' && string === rString) || (replaceMatch === 'inc' && string.includes(rString)) || false)
    }
    constructor(input = {}) {
        this.items = [document]
        this.mode = input.mode || 'text'
        this.match = input.match || 'full'
        this.replaceFunctions = input.func || []
        this.fullReplace = input.full || false
    }
    st = (obj) => {
        this.mode = obj.mode || this.mode
        this.match = obj.match || this.match
        this.replaceFunctions = obj.func ? [...this.replaceFunctions, ...obj.func] : this.replaceFunctions
        this.fullReplace = obj.full || this.fullReplace
    }
    get before() {
        this.items = this.items
            .filter(item => item && item.previousElementSibling)
            .map(item => item.previousElementSibling);
        return this
    }
    get next() {
        this.items = this.items
            .filter(item => item && item.nextElementSibling)
            .map(item => item.nextElementSibling);
        return this
    }
    get first() {
        this.items = this.items
            .filter(item => item && item.firstElementChild)
            .map(item => item.firstElementChild);
        return this
    }
    get all() {
        this.items = this.items
            .filter(item => item && item.children && item.children.length)
            .map(item => Array.from(item.children))
            .reduce((acc, children) => acc.concat(children), []);
        return this
    }
    index = (index) => {
        this.items = this.items
            .filter(item => item && item.children && item.children.length)
            .map(item => item.children[index]);
        return this
    }
    haveStyle = (styles) => {
        this.items = this.items
            .filter(item => { try { let style_ = item.getAttribute("style"); return style_ && style_.includes(styles) } catch { return false } });
        return this
    }
    isStyle = (styles) => {
        this.items = this.items
            .filter(item => { try { let style_ = item.getAttribute("style"); return style_ && (style_ === styles) } catch { return false } });
        return this
    }
    isClass = (ClassList) => {
        this.items = this.items
            .filter(item => item && item.classList === ClassList);
        return this
    }
    isId = (Id) => {
        this.items = this.items
            .filter(item => item && item.id === Id);
        return this
    }
    class = (className) => {
        this.items = this.items
            .filter(item => (item))
            .map(item => Array.from(item.querySelectorAll(`.${className}`)))
            .reduce((acc, children) => acc.concat(children), []);
        return this
    }
    id = (idValue) => {
        this.items = this.items
            .filter(item => (item))
            .map(item => Array.from(item.querySelectorAll(`#${idValue}`)))
            .reduce((acc, children) => acc.concat(children), []);
        return this
    }
    hasHtml = (html) => {
        if (html === '*') { return this }

        this.items = this.items
            .filter(item => (item.innerHTML.includes(html)))
        return this
    }
    isHtml = (html) => {
        this.items = this.items
            .filter(item => (item.innerHTML === html))
        return this
    }
    get fontCN() {
        this.replaceFunctions.push((div) => {
            div.style.fontFamily = "Noto Sans SC"
        })
        return this
    }


    REPLACE = (replaceObject) => {
        let mode = (
            (this.mode === 'html') ? 'innerHTML' :
                (this.mode === 'text') ? 'textContent' :
                    'error'
        )
        if (mode == 'error') { console.log('mode错误:', this.mode) }

        for (const [key, value] of Object.entries(replaceObject)) {
            this.items.forEach(item => {
                if (item && RIF.Match(item[mode], this.match, key)) {
                    if (this.match === 'full') {
                        item[mode] = value
                    } else if (this.match === 'inc') {
                        if (this.fullReplace) { item[mode] = value } else {
                            item[mode] = item[mode].replace(new RegExp(`${key}`, 'g'), value)
                        }
                    }
                    this.replaceFunctions.forEach(func => func(item))
                    window.__LOGGING__ += 1
                }
            })
        }
    }
    get click() {
        this.items.forEach(item => {
            const allProps = Object.keys(item);
            for (const prop of allProps) {
                if (prop.startsWith('__reactProps')) {
                    try { item[prop].onClick() } catch { }
                }
            }
        })

    }
    get enable() {
        this.items = this.items.forEach(item => {
            if (!(item.classList.contains(this.STATE))) { this.click }
        })
        return this
    }
    get disable() {
        this.items = this.items.forEach(item => {
            if (item.classList.contains(this.STATE)) { this.click }
        })
        return this
    }
    state = (STATE) => {
        this.STATE = STATE
        return this
    }
    get q() {
        const self = this
        return {
            to: (html) => {
                return {
                    get select() {
                        return self.class('button_KVN.button_KVN.multi-select_Roq').hasHtml(html).state('selected');
                    },
                    get CGE_chicked() {
                        return self.class('title_vqR').hasHtml(html).before.class('toggle_cca.item-mouse-states_Fmi.toggle_CGE').state('checked')
                    },
                    CGE_value: (value) => {
                        self.class('title_vqR').hasHtml(html).next.class('input_JvC.item-states_QjV')
                        self.items = self.items.forEach(item => {
                            item.value = value
                        })
                        return self
                    },
                    get obj() {
                        self.class('editor-item_VnW.editor-item-base_sYx.editor-widget_QQl').first.first.isHtml(html).next.state('checked')
                        return self
                    },
                    get clear() {
                        return self.class('button_WPv.button_dLA').hasHtml(html)
                    },
                    get picker() {
                        return self.class('picker-toggle_d6k')
                    }
                };
            }
        };
    }
}

function rif(...args) { return new RIF(...args) }
function RE(...args) {
    return args.reduce((result, value, index, array) => {
        if (index % 2 === 0) {
            const key = array[index];
            const val = array[index + 1];
            result.set(key, val);
        }
        return result;
    }, new Map());
}
function replaceContent() {
    window.__LOGGING__ = 0
    let addinfo = ''

    let time1 = new Date().getTime()
    try {
        const MAIN = {
            主界面: {
                版本: rif({ match: 'inc' }).class('version_VJt')
            },
            悬浮框: {
                标题: rif().class('balloon_qJY.balloon_H23.up_ehW.center_hug.anchored-balloon_AYp.up_el0').class('title_lCJ'),
                内容: rif().class('balloon_qJY.balloon_H23.up_ehW.center_hug.anchored-balloon_AYp.up_el0').class('paragraphs_nbD.description_dNa').first,
                提示: rif().class('tooltip-fade-in_S9n'),
                提示2: rif().class('value_uLz')
            },
            工具框: {
                标签: rif().class('tool-options-panel_Se6').class('label_RZX'),
                值: rif().class('tool-options-panel_Se6').class('number-field__Hd')
            },
            设置: {
                选项: rif().class('menu_hb1.child-opacity-transition_nkS').class('item_pq7.primary_Q54').first,
                标签: rif().class('option-page_CW8.option-section_VzQ').class('main-column_D0A').class('content_gqa').class('label_DGc.label_ZLb'),
                分类: rif().class('option-page_CW8.option-section_VzQ').class('main-column_D0A').class('breadcrumbs_xcd').class('label_sAz.label-level-1'),
                标题: rif().class('option-page_CW8.option-section_VzQ').class('info-column_uQ0').class('info-title_a3p'),
                描述: rif().class('option-page_CW8.option-section_VzQ').class('info-column_uQ0').class('info-description_wwd'),
                TAB: rif().class('option-page_CW8.option-section_VzQ').class('main-column_D0A').class('tab_P7S')
            },
            下拉框: {
                标签: rif().class('dropdown-item_sZT'),
                值: rif().class('dropdown-toggle_V9z').class('label_l_4')
            },
            按钮: rif().class('button_WWa.button_SH8'),
            工具栏: {
                资产详情: {
                    标题: rif().class('asset-detail-panel_hf8.detail-panel_izf').class('title-bar_I7O.child-opacity-transition_nkS').class('title_qub'),
                    描述: rif().class('asset-detail-panel_hf8.detail-panel_izf').class('content_rep.row_H0d.child-opacity-transition_nkS').class('column_dTT').class('paragraphs_nbD.description_ZQn').first
                }
            }
        }
        const 开发者模式 = {
            顶栏: {
                按钮: rif().class('tab-bar_b_c').class('button_BNH').fontCN
            },

            内容: {
                标签: rif().class('content_gqa').class('label_KyX').fontCN,
                按钮: rif().class('content_gqa').class('button_k8s').fontCN,
                标题: rif().class('content_gqa').class('title_Xkf').fontCN,
                值: rif().class('content_gqa').class('value_fMT').fontCN,
                折叠: rif().class('content_gqa').class('label_qS_').fontCN,
                控制值: rif().class('content_gqa').class('control_b3l').fontCN,
            }
        }
        const HOOKUI = {
            顶栏: {
                名称: rif({ mode: 'html', match: 'inc' }).class('content_XD5.content_AD7.child-opacity-transition_nkS').class('row_B8G')
            },
            面板: {
                标题: rif().class('title-bar_PF4').class('title_SVH.title_zQN'),
                内容: rif().class('content_XD5.content_AD7.child-opacity-transition_nkS'),
                标签: rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('label_DGc.label_ZLb'),
                标签2: rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('row_S2v'),
                标签_p: rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('row_S2v').all,
                头: rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('header_Ld7'),
                头描述: rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('header_MP_.header_8H_'),
                项目: rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('header-content_SqG.header-content_wUX').all,
            }
        }

        const 编辑器 = {
            通用: [
                rif().class('content_yeu').class('header-label_H79'),
                rif().class('content_yeu').class('toggle-label_UK9'),
                rif().class('content_yeu').class('label_OqN'),
                rif().class('content_yeu').class('label_BbZ'),
                rif().class('picker-popup_pUb').hasHtml.class('name_u39'),
                rif().class('content_yeu.content_AD7').class('page-view_PUO').class('name_u39'),

                rif().class('content_yeu').class('label_tNr'),
                rif().class('content_yeu').class('picker-toggle_d6k'),
                rif().class('dropdown-item_Hjk'),
                rif().class('label_tNr'),
                rif().class('toggle-flags-button_T7X'),
                rif().class('header_IuN').class('title_zQN'),
                rif().class('button_WPv')
            ],

            通用inc: [
                rif({match:'inc'}).class('content_yeu').class('header-label_H79'),
                rif({match:'inc'}).class('content_yeu').class('toggle-label_UK9'),
                rif({match:'inc'}).class('content_yeu').class('label_OqN'),
                rif({match:'inc'}).class('content_yeu').class('label_BbZ'),
                rif({match:'inc'}).class('picker-popup_pUb').class('name_u39'),
                rif({match:'inc'}).class('content_yeu.content_AD7').class('page-view_PUO').class('name_u39'),

                rif({match:'inc'}).class('content_yeu').class('label_tNr'),
                rif({match:'inc'}).class('content_yeu').class('picker-toggle_d6k'),
                rif({match:'inc'}).class('dropdown-item_Hjk'),
                rif({match:'inc'}).class('label_tNr'),
                rif({match:'inc'}).class('toggle-flags-button_T7X')

            ],

        }
        const REPLACE_ITEM_NEW = {
            开发者模式_模拟: RE(
                [开发者模式.内容.标签], {
                'Active tool': '激活工具',
                'Selected': '选中',
                'Taxi Starting Fee': '出租车起步价',
                'High-Speed Highways': '高速公路',
                'Advanced Pollution Management': '高级污染管理',
                'PreRelease Programs': '释前教育',
                'City Promotion': '城市宣传',
                'Allow gameplay manipulation': '允许游戏中操控',
                'Debug toggle': '调试选中',
                'Bypass validation results': '无碰撞',
                'Parallel Road':'并列',
                'Elevation':'高度',
                'Elevation Step':'高度阶段',
                'Sim speed': '模拟速度',
                'Smooth speed': '平滑速度',
                'Interpolation offset': '插值偏移',
                'Step Time (ms)': '步进时间 (ms)',
                'Disable trips': '禁用行程',
                'Debug Lifepath Chirps ': '调试生命周期轨迹',
                'Birth Chance': '出生几率',
                'Snap guide lines':'对齐导线',
                'Snap zone grid': '对齐功能区',

                'Atmosphere': '大气层',
                'Biome': '生态群落',
                'Water sim speed': '水模拟速度',
                'Time step override': '时间步长',
                'Time Step': '时间步长',
                'Current Time Step': '当前时间步长',
                'Max Velocity': '最大速度',
                'Use Active Cells Culling': '使用活动单元剔除',
                'Water Grid Size Multiplier': '水格大小',
                'Water grid size': '水格大小',
                'Flow number of Downscale': '流动降阶数量',
                'Blur flow': '流动模糊',
                'Enable flow Dounscale':'启用流动降阶',
                'Flow limiter for render': '流动渲染限制器',
                'Max Water Flow Length for render': '最大渲染水流长度',
                'Water Flow Render Multiplier': '水流渲染倍增',
                'Climate time': '气候时间',
                'Override Climate time': '气候时间 覆盖',
                'Current climate': '当前气候',
                'Current season': '当前季节',
                'Temperature': '温度',
                'Override Temperature': '覆盖 温度',
                'Snow sim speed': '雪模拟速度',
                'Cloudiness': '云',
                'Override Cloudiness': '云 覆盖',
                'Aurora': '极光',
                'Override Aurora': '极光 覆盖',
                'Precipitation volume scale': '降水量比例',
                'Global VFX time from Simulation time': '全局视觉效果时间与模拟时间关联',
                'Weather VFX time from Simulation time': '天气视觉效果时间与模拟时间关联',
                'Temperature Electricity Consumption Multiplier': '气温电力消耗倍增',
                'Time/Date': '时间/日期',
                'Latitude': '纬度',
                'Longitude': '经度',
                'Day of year': '天 (年)',
                'Day of year (Moon)': '天 (日夜)',
                'Time of day': '时间',
                'Time of day multiplier': '时间流速倍增',
                'Number of lunar cycles per year': '每年的月球周期数',
                'Override time for debug': '时间 覆盖',
                'Superfast building spawning': '超快速 建筑生成',
                'Superfast area-prop spawning': '超快速 区域道具生成',
                'Superfast leveling': '超快速 建筑升级',
                'Select entity': '选择实体',
                'Water Pipe Fluid Flow': '水管液体流动',
                'Disable Water consumption': '禁用水消耗',
                'Disable Sewage generation': '禁用污水生成',
                'Ground Multiplier': '地面污染',
                'Ground Radius': '地面污染范围',
                'Air Radius': '空气污染范围',
                'Noise Radius': '噪音污染范围',
                'Net Noise Radius': '道路 噪音污染范围',
                'Net Noise Multiplier': '道路 噪音污染',
                'Net Air Multiplier': '道路 空气污染',
                'Air Multiplier': '空气污染',
                'Noise Multiplier': '噪音污染',
                'Wind Advection Speed': '风平流速度',
                'Air Fade': '空气污染消退',
                'Ground Fade': '地面污染消退',
                'Plant Air Multiplier': '植物 空气污染倍增',
                'Plant Ground Multiplier': '植物 地面污染倍增',
                'Plant Fade': '植物 消退',
                'Fertility Ground Multiplier': '沃土 地面污染',
                'Distance Expotent': '距离指数',
                'Danger Level': '危险等级',
                'Precipitation': '降水',
                'Override Precipitation': '降水 覆盖',
                'Average temperature': '平均温度',
                'Average precipitation': '平均降水量',
                'Average cloudiness': '平均多云程度',
                'Yearly average temperature': '年均温度',
                'Freezing temperature': '冰点温度',
                'Temperature base height': '温度基准',
                'Snap existing geometry': '对齐现有物体',
                'Snap 90 degree angles': '对齐90度角',
                'Snap road side': '对齐道路两侧',
                'Snap building side': '对齐建筑两侧',
                'Bypass confirmation': '跳过确认',
                'Type': '类别',
                'Mode': '模式',
                'Overwrite existing zone': '覆盖现有区域',
                'Snap cell length': '对齐单元格长度',

            },
                [开发者模式.内容.标题], {
                'Climate time': '气候时间',
                'Temperature': '温度',
                'Precipitation': '降水',
                'Cloudiness': '云',
                'Aurora': '极光'
            },
                [开发者模式.内容.按钮], {
                'Save game': '保存游戏',
                'Load game': '加载游戏',
                'Remove residents/vehicles': '移除居民/车辆',
                'Cleanup obsolete entities': '清理过时实体',

                'Save water': '保存水',
                'Load water': '加载水',
                'Restart water': '重启水',
                'Water to sealevel': '水位调整为海平面(危险)',
                'Reload Water Sources': '重新加载水源(危险)',
                'Override Temperature': '气温',
                'Advance time 1h': '提前1小时',
                'Advance time 12h': '提前12小时',
                'Advance time 6d': '提前6天',
                'Give max resource': '获取最大资源',
                'Print age debug': '打印年龄调试信息',
                'Print school debug': '打印学校调试信息',
                'Print company debug': '打印公司调试信息',
                'Print trade debug': '打印贸易调试信息',
                'Remove extra companies': '移除额外的公司',
                'Print null households': '打印空户调试信息',
                'Calc customers': '计算顾客',
                'Calc eligible': '计算符合条件者',
                'Calc students from OC': '计算OC中的学生',
                'Happiness factors': '幸福因素',
                'Reset land value': '重置土地价值',
                'Reset rents': '重置租金',
                'Reset services': '重置服务',
                'Reset trade costs': '重置贸易成本',
                'Reset transfers': '重置转账',
                'Reset trip neededs': '重置行程需求',
                'Reset storages': '重置存储',
                'Follow selected citizen': '跟随选定居民',
                'Age selected citizen': '年龄调整选定居民',
                'Trigger Test Life Event': '触发测试生活事件',
                'Discard statistics': '丢弃统计信息',
                'Print commuter distribution': '打印通勤分布',
                'Reset Electricity': '重置电力',
                'Reset pollution': '重置污染',
                'Traveling': '旅行中',
                'VisitAttractions': '参观景点',
                'Sightseeing': '观光',
                'Lightning Strike': '雷击',
                'Valentines Day': '情人节',
                'Flood': '洪水',
                'Tsunami': '海啸',
                'Tornado': '龙卷风',
                'Rocket Launch': '火箭发射',
                'Building Collapse': '建筑倒塌',
                'Robbery': '抢劫',
                'Generic Sickness': '一般疾病',
                'Sudden Death': '突然死亡',
                'Severe Injury': '严重伤害',
                'Hail Storm': '冰雹风暴',
                'Lose Control Accident': '失控事故',
                'Forest Fire': '森林火灾',
                'Building Fire': '建筑火灾',
                'Export heightmap': '导出高程图',
                'Create Chirps': '创建轨迹',
                'Check property rent errors': '检查租金错误',
                'Fix property rent errors': '修复租金错误',
                'Fix invalid Enabled Effects': '修复无效的启用效果',
                'Remove snow': '移除雪',
                'Save Wind': '保存风',
                'Load Wind': '加载风',
                'Reset Wind': '重置风',
                'Select next': '选择下一个',
            },
                [开发者模式.内容.值], {
                'Default Tool': '默认工具',
                'Area Tool': '区域工具',
                'Bulldoze Tool': '推土机',
                'Upgrade Tool': '升级工具',
                'Anarchy Tool': '无碰撞工具',
                'Tree 控制ler Tool': '树木控制器',
                'Line Tool': '条形工具',
                'Zone Tool': '功能区工具',
                'Water Tool': '水源工具',
                'Flood Fill': '填充',
                'Marquee': '滚动',
                'Paint': '涂刷'
            },
                [开发者模式.内容.折叠], {
                'Policies': '政策',
                'Diversity': '多样性',
                'Water': '水',
                'Weather & climate': '天气 与 气候',
                'Electricty & Water': '电力 与 水资源',
                'Time': '时间',
                'Economy': '经济',
                'Pollution': '污染',
                'Start event': '开始事件',
                'Terrain': '地形',
                'Triggers': '触发器',
                'Error Check': '错误检查',
                'Season stats': '季节统计',
                'Temperature stats': '温度统计'
            },
                [开发者模式.内容.控制值], {
                'Atmosphere1Prefab': '大气层1预制体',
                'GrasslandBiomePrefab': '草原生态群落预制体',
                'SeasonSummer': '夏季季节',
                'Oil Lot - Navigation': '石油地块 - 导航',
                'Ore Lot - Navigation': '矿石地块 - 导航',
                'Agriculture Lot - Field': '农业地块 - 田地',
                'Oil Lot': '石油区域',
                'Ore Lot': '矿石区域',
                'Agriculture Lot': '农业区域',
                'Forestry Lot': '林业区域',
                'Extractor Lot': '提取器区域',
                'District Area': '市辖区域',
                'Clear Area': '清除区域',
                'Clip Surface': '裁剪地面',
                'Walking Area': '行走区域',
                'Map Tile': '地图瓦片',
                'Water Tile': '水瓦片',
                'Hangaround Area': '待遇区域',
                'Park Area': '公园区域',
                'Gympark Area': '健身公园区域',
                'Placeholder': ' 占位符',
                'Oil Surface Placeholder': '石油地面',
                'Ore Surface Placeholder': '矿石地面',
                'Agriculture Surface': '农业地面',
                'Concrete Surface': '混凝土地面',
                'Grass Surface': '草地地面',
                'Pavement Surface': '人行道地面',
                'Sand Surface': '沙地地面',
                'Tiles Surface': '瓷砖地面',
                'Forestry Surface': '林业地面',
                'Landfill Surface': '垃圾填埋地面',
                'Oil Surface 01': '石油地面',
                'Ore Surface 01': '矿石地面',
                'Landfill Site Lot': '垃圾填埋场区域',
            }
            ),
            开发者模式_游戏玩法: RE(
                [开发者模式.内容.标签], {
                'Tutorials enabled': '启用教程',
                'Freeze tutorials': '冻结教程',
                'Active tutorial list': '当前教程列表',
                'Active tutorial': '当前教程',
                'Show developer info': '显示开发者信息',
                'Show unspawned objects': '显示未生成的对象',
                'Show markers': '显示标记',
                'Lefthand traffic': '靠左行驶',
                'Default theme': '默认主题',
                'Hospital service fee': '医院服务费',
                'Basic education service fee': '基础教育服务费',
                'Secondary education service fee': '中等教育服务费',
                'Higher education service fee': '高等教育服务费',
                'Water usage fee': '水费',
                'Garbage collection fee': '垃圾清理费',
                'Electricity fee': '电费',
                'Public transport fee': '公共交通费'
            },
                [开发者模式.内容.按钮], {
                'Skip tutorial phase': '跳过教程阶段',
                'Show all tutorials in advisor': '在顾问中显示所有教程',
                'Skip active tutorial list': '跳过当前教程列表',
                'Select next theme': '选择下一个主题',
                'Unlock all': '解锁全部',
                'Get 200 XP': '获取200经验值',
                'Next MS': '下一个MS',
                'Get 500k money': '获得500,000钱',
            },
                [开发者模式.内容.控制值], {
                'North American': '北美',
                'European': '欧洲'
            }
            ),
            开发者模式_渲染: RE(
                [开发者模式.内容.标签], {
                'Fullscreen Debug Mode': '全屏调试模式',
                'Max Overdraw Count': '最大过度绘制计数',
                'Max Quad Cost': '最大四边形成本',
                'Max Vertex Density': '最大顶点密度',
                'Min Motion Vector Length (in pixels)': '运动矢量长度（以像素为单位）',
                'Mip Maps': 'Mip贴图',
                'Terrain Texture': '地形纹理',
                'False Color Mode': '伪彩模式',
                'Freeze Camera For Culling': '冻结摄像头以进行剔除',
                'Waveform': '波形',
                'Exposure': '曝光',
                'Parade mode': '巡游模式',
                'Vectorscope': '矢量范围',
                'Size': '大小',
                'NVUnityPlugin Version': 'NVUnity插件版本',
                'NGX API Version': 'NGX API版本',
                'Device Status': '设备状态',
                'DLSS Supported': 'DLSS支持',
                'DLSS Injection Point': 'DLSS注入点',
                'Clear Render Targets At Creation': '在创建时清除渲染目标',
                'Disable Pass Culling': '禁用通行剔除',
                'Immediate Mode': '即时模式',
                'Enable Logging': '启用日志记录',
            },
                [开发者模式.内容.值], {
                'Control': '控制',
                'No Visible Camera': '无可见摄像头'
            },
                [开发者模式.内容.标题], {
                'Color Monitors': '色彩监视器',
                '#WaveformContainer': '波形容器',
                '#VectorscopeContainer': '矢量范围容器',
                'NVIDIA device debug view': 'NVIDIA设备调试视图',
                'HDRP Render Graph': 'HDRP渲染图',
                'DLSS Slot ID': 'DLSS 槽位 ID',
                'Status': '状态',
                'Input resolution': '输入分辨率',
                'Output resolution': '输出分辨率',
                'Quality': '质量',
            },
                [开发者模式.内容.按钮], {
                'Log Frame Information': '记录帧信息',
                'Log Resources': '记录资源'
            },
            ),
            开发者模式_游戏渲染: RE(
                [开发者模式.内容.标签], {
                'Texture Debug Mode': '纹理调试模式',
                'Entity culling': '实体剔除',
                'Effect culling': '效果剔除',
                'Batch allocation': '批量分配',
                'Batch upload': '批量上传',
                'Batch groups': '批量分组',
                'Batch renderers': '批量渲染器',
                'Batch materials': '批量材质',
                'Batch meshes': '批量网格',
                'Area triangle buffer': '区域三角形缓冲',
                'Procedural skeleton buffer': '程序骨架缓冲',
                'Procedural skeleton upload': '程序骨架上传',
                'Procedural emissive buffer': '程序自发光缓冲',
                'Procedural emissive upload': '程序自发光上传',
                'Animation shape buffer': '动画形状缓冲',
                'Animation bone buffer': '动画骨骼缓冲',
                'Animation frame buffer': '动画帧缓冲',
                'Animation index buffer': '动画索引缓冲',
                'Animation meta buffer': '动画元数据缓冲',
                'Level of detail': '细节级别',
                'Disable lod models': '禁用LOD模型',
                'Disable mesh loading': '禁用网格加载',
                'Force mesh unloading': '强制卸载网格',
                'Strict mesh memory budget': '严格的网格内存限制',
                'Long cross fade': '淡入淡出',
                'Debug': '调试',
                'Punctual Lights': '点光源',
                'Max Punctual Lights': '最大 点光源 数量',
                'Punctual Lights Cookies': '点光源 Cookies',
                'Enable Min-Max light culling optim': '启用最小-最大点光源光照剔除优化',
                'Max Distance Culling Scale': '最大距离剔除比例',
                'Min Distance Culling Scale': '最小距离剔除比例',
                'Number of punctual lights': '点光源数量',
                'Tri count': '三角形数量',
                'Foliage': '植被',
                'DebugBlit': '调试Blit',
                'Tunnel Pass': '隧道通道',
                'Outlines Pass': '轮廓通道',
                'Dynamic Resolution': '动态分辨率',
                'Upscale Filter': '升采样滤镜',
                'Auto Adaptive': '自适应',
                'CBT Max Depth': 'CBT最大深度',

                'All': '全部',
                'Shader Graphs/AreaDecalShader': '表面',
                'BH/SG_CurvedShader': '栅栏',
                'BH/Overlay/CurvedOverlayShader': '曲线覆盖',
                'BH/Decals/CurvedDecalShader': '道路 - 线',
                'BH/Decals/CurvedDecalDeteriorationShader': '道路 - 车辙印',
                'BH/Pipeline/CurvedPipelineShader': '曲线管道',
                'BH/SG_DefaultShader': 'SG_默认',
                'BH/SG_BaseShader': 'SG_基础',
                'BH/NetCompositionMeshLitShader': '道路',
                'BH/Pipeline/DefaultPipelineShader': '管道 (头)',
                'BH/Decals/DefaultDecalShader': '道路 - 标贴',
                'BH/Impostors/Render/SG_ImpostorTree': '远距离树木',
                'BH/SG_VegRootShader': '植被根',
                'BH/SG_VegLeavesShader': '植被叶',
                'Shader Graphs/ZoneBlock': '功能区',
                'BH/SG_WinShader': '建筑 - 窗户',
                'BH/GlsShader': '建筑 - 玻璃',
                'BH/WatShader': '建筑 - 水',

                'Didimo/HDRP/SG_CharacterSkin': '角色 - 皮肤',
                'Didimo/HDRP/HDRPGenericCrowd': 'HDRP通用群体',
                'Didimo/HDRP/SG_CharacterCloth': '角色 - 衣服',
                'Didimo/HDRP/SG_CharacterGeneric': '角色 - 饰品',
                'BH/Characters/SG_HairCardsDyed': '角色 - 头发',
                'BH/GraShader': 'BH/GraShader',

                'Scale': '渲染精度'
            },
                [开发者模式.内容.值], {
                'Catmull Rom': 'Catmull-Rom',
            },
                [开发者模式.内容.按钮], {
                'Refresh splatmap': '刷新地表纹理图',
            },
                [开发者模式.内容.折叠], {
                'Scale': '缩放',
                'Shaders': '着色器',
                'Custom passes': '自定义通道',
            },
                [开发者模式.内容.控制值], {
                'Scale': '渲染精度',
                'Unknown': '未知',
                'False': '否',
                'BeforePost': '后处理前'
            }
            ),
            开发者模式_工具: RE(
                [开发者模式.内容.标签], {
                'Physical Objects': '物理对象',
                'Marker Objects': '标记对象',
                'Interpolated Positions': '插值位置',
                'Net Connections': '网络连接',
                'Group Connections': '组连接',
                'District Connections': '区域连接',
                'Lot Heights': '地块高度',
                'Draw Nodes': '绘制节点',
                'Draw Edges': '绘制边缘',
                'Draw Outlines': '绘制轮廓',
                'Standalone Lanes': '独立车道',
                'Slave Lanes': '从属车道',
                'Master Lanes': '主车道',
                'Connection Lanes': '连接车道',
                'Draw Overlaps': '绘制重叠',
                'Draw Reserved': '绘制保留',
                'Draw Blocked': '绘制阻塞',
                'Draw Condition': '绘制条件',
                'Draw Signals': '绘制信号',
                'Draw Priorities': '绘制优先级',
                'Show positions': '显示位置',
                'Spot Lights Cones': '聚光灯锥形',
                'Show active water cell': '显示活动水格',
                'Fixed Height': '固定高度',
                'Draw Pivots': '绘制枢轴',
                'Draw Grids': '绘制网格',
                'Vacant Lots': '空地块',
                'Lots': '地块',
                'Districts': '区域',
                'Map Tiles': '地图瓦片',
                'Spaces': '空间',
                'Surfaces': '表面',
                'Lane Connections': '车道连接',
                'Humans': '人类',
                'Animals': '动物',
                'Cars': '汽车',
                'Trains': '火车',
                'Ships': '船只',
                'Aircrafts': '飞机',
                'Workplaces': '工作场所',
                'Services': '服务',
                'UneducatedCitizens': '未受教育的市民',
                'EducatedCitizens': '受过教育的市民',
                'OutsideConnection': '外部连接',
                'ConvenienceFoodStore': '便利食品店',
                'GrainSupply': '谷物供应',
                'VegetableSupply': '蔬菜供应',
                'WoodSupply': '木材供应',
                'TextilesSupply': '纺织品供应',
                'ConvenienceFoodSupply': '便利食品供应',
                'PaperSupply': '纸张供应',
                'VehiclesSupply': '车辆供应',
                'OilSupply': '石油供应',
                'PetrochemicalsSupply': '石化产品供应',
                'OreSupply': '矿石供应',
                'MetalsSupply': '金属供应',
                'ElectronicsSupply': '电子产品供应',
                'Attractiveness': '吸引力',
                'PlasticsSupply': '塑料供应',
                'CoalSupply': '煤炭供应',
                'StoneSupply': '石材供应',
                'LivestockSupply': '牲畜供应',
                'CottonSupply': '棉花供应',
                'SteelSupply': '钢铁供应',
                'MineralSupply': '矿物供应',
                'ChemicalSupply': '化学品供应',
                'MachinerySupply': '机械设备供应',
                'BeveragesSupply': '饮料供应',
                'TimberSupply': '木材供应',
                'Taxi': '出租车',
                'Healthcare': '医疗保健',
                'FireRescue': '消防救援',
                'Police': '警察',
                'Park': '公园',
                'PostService': '邮政服务',
                'Education': '教育',
                'EmergencyShelter': '紧急避难所',
                'Welfare': '福利',
                'Draw Graph': '绘制图表',
                'Show Restrictions': '显示限制',
                'Show time cost': '显示时间成本',
                'Show behavior cost': '显示行为成本',
                'Show money cost': '显示金钱成本',
                'Show comfort cost': '显示舒适度成本',
                'Visualize Queries': '可视化查询',
                'Static Objects': '静态对象',
                'Moving Objects': '移动对象',
                'Nets': '网络',
                'Lanes': '车道',
                'Zones': '区域',
                'Areas': '地区',
                'Routes': '路径',
                'Effects': '效果',
                'Local Effects': '局部效应',
                'Land value': '地价',
                'StorageLeveling': '存储水准',
                'Leveling': '水准',
                'Buildings': '建筑物',
                'Residential worth': '住宅价值',
                'Commercial worth': '商业价值',
                'Industrial worth': '工业价值',
                'Untaxed income': '免税收入',
                'Storage used': '存储使用',
                'Ground pollution': '地面污染',
                'Air pollution': '空气污染',
                'Noise pollution': '噪音污染',
                'Forest': '森林',
                'Accumulated Garbage': '累积垃圾',
                'Produce Garbage': '产生垃圾',
                'Show Surface Boxes': '显示表面框',
                'Show Culling Boxes': '显示裁剪框',
                'Land value (Cell)': '区块地价',
                'Land value (Edge)': '隐藏地价',
                'Strict':'严格模式',
                'Buildable Area':'可建造区域',

                'Object Debug System': '物件 调试系统',
                'Net Debug System': '道路 调试系统',
                'Lane Debug System': '车道 调试系统',
                'Light Debug System': '光照 调试系统',
                'Water Culling Debug System': '水裁剪 调试系统',
                'Zone Debug System': '功能区 调试系统',
                'Area Debug System': '区域 调试系统',
                'Route Debug System': '路径 调试系统',
                'Navigation Debug System': '导航 调试系统',
                'Audio Grouping Debug System': '音频分组 调试系统',
                'Availability Debug System': '可用率 调试系统',
                'Density Debug System': '密度 调试系统',
                'Coverage Debug System': '覆盖 调试系统',
                'Path Debug System': '路径 调试系统',
                'Pathfinding Debug System': '寻路 调试系统',
                'Search Tree Debug System': '搜索树 调试系统',
                'Terrain Attractiveness Debug System': '地形吸引力 调试系统',
                'Land Value Debug System': '土地价值 调试系统',
                'Economy Debug System': '经济 调试系统',
                'Pollution Debug System': '污染 调试系统',
                'Ground Water Debug System': '地下水 调试系统',
                'Soil Water Debug System': '土壤水分 调试系统',
                'Natural Resource Debug System': '自然资源 调试系统',
                'Garbage Debug System': '垃圾 调试系统',
                'Terrain Debug System': '地形 调试系统',
                'Water Debug System': '水 调试系统',
                'Wind Debug System': '风 调试系统',
                'Event Debug System': '事件 调试系统',
                'Buildable Area Debug System': '可建造区域 调试系统'
            },
            [rif({func:[(i)=>{i.style.color = 'red'}]}).class('content_gqa').class('label_KyX').fontCN], {
                'Tradecost Debug System': '(危险) 贸易成本 调试系统'
            }
            ),
            开发者模式_main: RE(
                [开发者模式.顶栏.按钮], {
                'Display Stats': '显示数据',
                'Thumbnails': '缩略图',
                'Asset database': '数据',
                'Notifications': '通知',
                'ECS Components': 'ECS 组件',
                'Scene Flow': '场景流程',
                'GameRendering': '游戏渲染',
                'Gameplay': '游戏玩法',
                'Localization': '本地化',
                'UI Bindings': 'UI 绑定',
                'Watches': '监视器',
                'Radio': '无线电',
                'Climate': '气候',
                'Simulation': '模拟',
                'Pathfind': '寻路',
                'Serialization': '序列化',
                'Gizmos': '工具',
                'Camera': '摄像机',
                'Input': '输入',
                'Decals': '标贴',
                'Material': '材质',
                'Lighting': '光照',
                'Rendering': '渲染',
                'Profiler Metrics': '性能分析指标',
                'Main Camera': '主摄像机',
                'Virtual Texturing': '虚拟纹理',
                'Volume': '音量',
            },
                [开发者模式.内容.标签], {
                'Fullscreen Debug': '全屏调试'
            },
                [开发者模式.内容.值], {
                'None': '无',
            },
            [rif({func:[(i)=>{i.style.color = '#8B0000'}]}).class('content_gqa').class('value_fMT').fontCN], {
                'Disabled': '关闭'
            },
            [rif({func:[(i)=>{i.style.color = 'green'}]}).class('content_gqa').class('value_fMT').fontCN], {
                'Enabled': '开启'
            }

            ),
            信息隐现: RE(
                [HOOKUI.顶栏.名称], {
                'InfoLoom: Demographics': '信息隐现: 人口分布',
                'InfoLoom: Workforce': '信息隐现: 劳动力结构',
                'InfoLoom: Workplaces': '信息隐现: 工作场所',
                'InfoLoom: Demand Factors': '信息隐现: 建筑需求',
                'InfoLoom: Commercial Data': '信息隐现: 商业信息',
                'InfoLoom: Residential Data': '信息隐现: 住宅数据',
                'InfoLoom: Industrial and Office Data':'信息隐现: 工业和办公数据'
            },
                [HOOKUI.面板.标题], {
                'Demographics': '人口统计',
                'Demand': '需求',
                'Workforce Structure': '劳动力结构',
                'Workplace Distribution': '工作场所分布',
                'Commercial Data': '商业数据',
                'Residential Data': '住宅数据',
                'Industrial and Office Data': '工业和办公数据'
            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('row_S2v').isStyle('width: 60.000000%; justify-content: center; ')], {
                'All Citizens': '所有市民',
                '- Locals': '- 本地居民',
                '- Tourists': '- 游客',
                '- Commuters': '- 通勤者',
                '- Moving Away': '- 搬离中',
                'Population': '人口',
                'Oldest citizen': '最年长市民',
                'Students': '学生',
                'Workers': '工人',
                'Homeless': '无家可归',
                'Dead': '死亡'
            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').index(2).all], {
                'Work': '工作',
                'Elementary': '小学',
                'High school': '中学',
                'College': '学院制大学',
                'University': '综合性大学',
                'Other': '其他'
            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('symbol_aAH').next], {
                'Education': '教育',
                'Uneducated': '无学历',
                'Poorly Educated': '低学历',
                'Highly Educated': '极高学历',
                'Well Educated': '高学历',
                'Educated': '普通学历',
                'TOTAL': '总计',
                'Companies':'公司'
            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('labels_L7Q.row_S2v').class('row_S2v').haveStyle('justify-content: center')], {
                'Total': '总计',
                'Workers': '工人',
                'Unemployed': '失业',
                'Under': '在读',
                'Outside': '在外',
                'Homeless': '无家可归',

                'City': '服务',
                'Sales': '销售',
                'Leisure': '休闲',
                'Extract': '开采',
                'Industry': '工业',
                'Office': '办公',
                'Employees': '员工',
                'Open': '招聘',
                'Commute':'通勤',
            },
                [rif().class('infoview-panel-section_RXJ').class('left_Lgw.row_S2v')], {
                'BUILDING DEMAND': '建筑需求',
                'Residential Low': '低密度住宅',
                'Residential Medium': '中密度住宅',
                'Residential High': '高密度住宅',
                'Commercial': '商业',
                'Industrial': '工业',
                'Storage': '仓储',
                'Office': '办公',

                'RESIDENTIAL LOW': '低密度住宅',
                'RESIDENTIAL MEDIUM': '中密度住宅',
                'RESIDENTIAL HIGH': '高密度住宅',
                'COMMERCIAL': '商业',
                'INDUSTRIAL': '工业',
                'OFFICE': '办公',

                'EmptyBuildings': '空置建筑',
                'Happiness': '幸福度',
                'Taxes': '税收',
                'Unemployment': '失业率',
                'UneducatedWorkforce': '未受教育劳动力',
                'EducatedWorkforce': '受教育劳动力',
                'LocalDemand': '本地需求',
                'LocalInputs': '本地资源',
                'Homelessness': '无家可归',
                'Students': '学生',
                'Warehouses': '仓库',
                'PetrolDemand': '汽油需求',
                'TouristDemand': '游客需求',
                'PetrolLocalDemand':'汽油本地需求'
            }, [HOOKUI.面板.标签2], {
                'PROPERTYLESS COMPANIES': '破产公司',
                'EMPTY BUILDINGS': '空置建筑',
                'Standard': '标准',
                'Educated': '受过教育的',
                'Uneducated': '未受教育的',
                'No demand for:': '没有需求:',
                'conv.food': '方便食品',
                'food': '食物',
                'meals': '餐饮',
                'paper': '纸张',
                'furniture': '家具',
                'vehicles': '车辆',
                'lodging': '住宿',
                'petrochemicals': '石油化工',
                'plastics': '塑料',
                'electronics': '电子产品',
                'chemicals': '化学品',
                'pharmaceuticals': '药品',
                'beverages': '饮料',
                'textiles': '纺织品',
                'entertainment': '娱乐',
                'recreation': '休闲',
                'LOW': '低密度',
                'MEDIUM': '中密度',
                'HIGH': '高密度',

                'Total properties': '总财产',
                '- Occupied properties': '- 已占用财产',
                '= Empty properties': '= 空财产',
                "No demand at 10%": '无需求时为10%',
                'BUILDING DEMAND': '建筑需求',
                'STUDY POSITIONS': '学习位置',
                'HOUSEHOLDS': '家庭',

                'INDUSTRIAL': '工业',
                'OFFICE': '办公',

                'timber': '木材',
                'metals': '金属',
                'steel': '钢铁',
                'minerals': '矿石',
                'concrete': '混凝土',
                'machinery': '机械'
            },
                [HOOKUI.面板.标签_p], {
                'AVERAGE TAX RATE': '平均税率',
                '10% is the neutral rate': '正常为10%',
                'SERVICE UTILIZATION': '服务利用率',
                '30% is the neutral ratio': '正常为30%',
                'SALES CAPACITY': '销售能力',
                '100% when capacity = consumption': '当销售=消费时为100%',
                'EMPLOYEE CAPACITY RATIO': '员工容量',
                '75% is the neutral ratio': '正常为75%',
                'HAPPINESS': '幸福度',
                '50 is neutral': '正常为50%',
                'UNEMPLOYMENT': '失业率',
                '10% is neutral': '正常为10%',
                'HOMELESS': '无家可归',
                '0 is neutral': '正常为0%',

                "TAX RATE (weighted)": '税率（加权）',
                '10 % is neutral': '正常为10%',
                'HOUSEHOLD DEMAND': '家庭需求',
                'STUDENT CHANCE': '上学几率',

                'LOCAL DEMAND (ind)': '本地需求（工业）',
                '100% when production = demand': '生产=需求时为100%',
                'INPUT UTILIZATION (ind)': '输入利用率（工业）',
                '110% is the neutral ratio, capped at 400%': '110%是中性比率，上限为400%',
                '72% is the neutral ratio': '正常为72%',
                'Empty buildings': '空建筑',
                'Propertyless companies': '无物业公司',
                'DEMANDED TYPES': '需求类型'

            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').first.first.index(11).first], {
                'AVAILABLE WORKFORCE': '可用劳动力'
            },
            [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').first.first.index(13).first.all], {
                'STORAGE': '储存',
                'The game will spawn warehouses when DEMANDED TYPES exist.': '当存在需求类型时，游戏将生成仓库。'
            }
            ),
            失业监视器: RE(
                [HOOKUI.面板.标题], {
                'Unemployment': '失业监视器'
            },
                [HOOKUI.顶栏.名称], {
                'Unemployment Data': '失业监视器',
                'Unemployment Monitor': '失业监视器',
            },
                [rif().class('panel_YqS').index(1).first.all.first.haveStyle('flex: 1.000000')], {
                'Unemployed': '失业',
                'Under Employed': '低收入就业',
                'Homeless Households': '无家可归家庭'
            },
                [rif().class('panel_YqS').index(1).index(1).all.first.haveStyle('font-weight')], {
                'TO': '总',
                'UN': '无',
                'PO': '低',
                'ED': '中',
                'WE': '高',
                'HI': '极高',
            },
                [rif().class('panel_YqS').index(1).index(1).index(6)], {
                'Total': '所有',
                'Uneducated': '无学历',
                'Poorly Educated': '低学历',
                'Well Educated': '高学历',
                'Highly Educated': '极高学历',
                'Educated': '普通学历',
            }
            ),
            城市监视器: RE(
                [HOOKUI.面板.标题, HOOKUI.顶栏.名称], {
                'City Monitor': '城市监视器',
            },
                [rif().class('content_1xS.focusable_GEc.item-focused_FuT').class('labels_L7Q.row_S2v').class('uppercase_RJI.left_Lgw.row_S2v'), rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('label_VSW.label_T__')], {
                'Electricity Availability': '电力资源可用性',
                'Water Availability': '水资源可用率',
                'Sewage': '污水处理',
                'Landfill Usage': '垃圾填埋使用率',
                'Healthcare Availability': '医疗资源可用率',
                'Average Health': '平均健康状况',
                'Cemetery Availability': '公墓资源可用率',
                'Fire Hazard': '火灾危险',
                'Crime Rate': '犯罪率',
                'Jail Availability': '监狱资源可用率',
                'Elementary School Availability': '小学资源可用率',
                'High School Availability': '中学资源可用率',
                'College Availability': '学院制大学资源可用率',
                'University Availability': '综合性大学资源可用率'
            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').class('button_WWa')], {
                'Settings': '设置',
                'Meters': '完成'
            }
            ),
            条形工具: RE(
                [rif().class('tool-options-panel_Se6').id('line-tool-title')], {//
                'Line Tool': '条形工具',//
            },
                [MAIN.工具框.标签], {
                'Options': '设置',
                'Rotation': '旋转'
            },
                [MAIN.悬浮框.标题], {
                'Single item': '放置单个物件'
            },
                [MAIN.悬浮框.内容], {
                'Place one object at a time using the standard game tool.': '使用标准游戏工具一次放置一个对象。'

            },
                [rif().id('line-tool-title')], {
                'Line tool': '条形工具'
            }


            ),
            树木控制器: RE(
                [MAIN.悬浮框.提示], {
                'Right Click to Apply.': '右键以应用'

            },
                [MAIN.工具框.标签], {
                'Age': '树木年龄',
                'Selection': '选择',
                'Radius': '范围',
                'Tool Mode': '工具模式',
                'Sets': '集合',
                'Change':'改变模式'
            },
                [MAIN.设置.选项], {
                'Tree Controller': '树木控制器'
            },
                [MAIN.设置.标签, MAIN.设置.标题], {
                'Deciduous trees use Dead Model during Winter': '在冬季:落叶树使用枯木模型',
                'Disable Tree Growth': '禁用树木自然生长',
                'Age Selection Technique': '树木年龄随机方法',
                'Color Variation Set': '颜色变化集'
            },
                [MAIN.设置.描述], {
                'Will temporarily make all non-lumber industry deciduous trees use the dead model and pause growth during winter.':
                    '会暂时性的把所有 (非林场) 的落叶树转换为枯木模型',

                'Disable tree growth for the entire map except for lumber industry.':
                    '禁用整个地图的 (非林场) 树木的自然生长',

                'Sets of seasonal colors for Trees and Wild bushes. Vanilla is the base game. Yenyang\'s is my curated colors. Custom uses CSV files in the mod folder.': '树木和野生灌木的季节性颜色集。【原版】 是基础游戏的颜色。【Yenyang的颜色集】 是我策划的颜色。【自定义】 使用模组文件夹中的 CSV 文件',

                'After confirmation this will reload CSV files.':
                    '确认后，将重新加载 CSV 文件。',

                'Removes Tree Controller mod components and resets tree and bush model states. Only necessary during Winter and very end of Autumn. Must use reset button to undo setting change.':
                    '移除树木控制器模组的组件并重置树木和灌木模型状态。仅在冬季和秋季末尾非常需要。必须使用重置按钮来撤销设置更改。',

                'After confirmation this will reset Tree Controller Settings.':
                    '确认后，将重置树木控制器设置。',

                "When multiple Tree Ages are selected, one will be selected using this option. Equal Distribution is just a random selection. Forest Distribution randomly selects using the editor's approximation for a forest.":
                    '当选择多个树龄时，将使用此选项选择一个。平均分布仅是随机选择。森林分布随机使用编辑器对森林的近似值进行选择。'

            },
                [MAIN.下拉框.标签, MAIN.下拉框.值], {
                'Random: Equal Weight': '随机：完全随机',
                'Random: Weighted': '随机：按游戏编辑器',
                'Vanilla': '原版',
                'Yenyang\'s': 'Yenyang的颜色集',
                'Custom': '自定义'
            },
                [MAIN.按钮, MAIN.设置.标题], {
                'Reload CSVs': '重载CSV颜色集',
                'Safely Remove': '安全移除',
                'Reset Tree Controller Settings': '重置 树木控制器 模组设置'
            }
            ),
            车辆计数器: RE(
                [HOOKUI.面板.标题, HOOKUI.顶栏.名称], {
                'Vehicle Counter': '车辆计数器'
            },
                [HOOKUI.面板.标签], {
                'Active vehicles': '激活的车辆'
            },
                [MAIN.按钮], {
                'Remove vehicles': '移除车辆'
            }
            ),
            传统风味: RE(
                [HOOKUI.顶栏.名称], {
                'Legacy Flavour': '传统风味'
            }
            ),
            限速模组: RE(
                [HOOKUI.顶栏.名称], {
                'Speed Limit': '限速模组',
            },
                [HOOKUI.面板.标题], {
                'Speed Limit Editor': '限速模组:修改器'
            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').first], {
                'No Road Selected': '没有道路被选择'
            }
            ),
            出行解锁: RE(
                [HOOKUI.面板.标题, HOOKUI.顶栏.名称], {
                'Traffic Unlocker': '出行解锁'
            },
                [HOOKUI.面板.标签], {
                'Population': '人口',
                'Traffic Reduction': '交通抑制系数',
                'Work Probability': '工作概率',
                'School Probability': '上学概率',
                'Leisure Probability': '休闲概率'
            }
            ),
            道路扩展升级: RE(
                [MAIN.工具栏.资产详情.标题], {
                'Quay': '护坡',
                'Retaining Wall': '护墙',
                'Elevated': '高架',
                'Tunnel': '隧道'
            },
                [MAIN.工具栏.资产详情.描述], {
                'A quay, if you installed this mod you know what it is :)': '护坡，如果你安装了这个模组，你知道它是什么:)',
                'A retaining wall, if you installed this mod you know what it is :)': '护墙，如果你安装了这个模组，你知道它是什么:)',
                'Elevated mode, kind of similar to bridges': '高架模式，有点类似于桥梁',
                'Tunnel mode, it might not look perfect but it works.': '隧道模式，它可能看起来不完美，但它能工作。'
            }
            ),
            更难的经济: RE(
                [MAIN.设置.选项], {
                'Economy Fixer': '难度更高的经济'
            },
                [MAIN.设置.分类], {
                'Gameplay Options': '游戏中设置'
            },
                [MAIN.设置.标签, MAIN.设置.标题], {
                'Economy Difficulty': '经济难度',
                'Bulldozing Building Costs Money': '拆除建筑需要拆迁费',
                'Bulldoze & De-zoning Causes Demolition': '推土机或取消功能区会导致建筑变成废墟'
            },
                [MAIN.设置.描述], {
                'Higher difficulty results in decreased subsidies, milestone rewards, income & higher expenses.': '更高的难度会导致减少补贴、里程碑奖励、收入和增加开支。',
                'Adds a monthly maintenance fee for demolition buildings. This fee is based on how many residents are getting evicted, how high the land value is, and how large is the building itself.': '为拆迁建筑添加了一个月度维护费用。该费用基于有多少居民被驱逐、土地价值有多高以及建筑本身有多大。',
                'Bulldozing a building or de-zoning an area will cause the buildings to collapse instead of disappearing, collapsed buildings take time to be cleaned up and affect nearby happiness. You can pay a small fee to immediately raze collapsed buildings.': '推倒建筑或取消区域划分将导致建筑物崩溃而不是消失，崩溃的建筑需要时间清理，并影响附近的幸福度。你可以支付一小笔费用立即夷平崩溃的建筑物。'
            },
                [MAIN.下拉框.值, MAIN.下拉框.标签], {
                'Easy': '简单',
                'Medium': '普通',
                'Hard': '困难',
                'Good Luck': '祝你好运',
            }
            ),
            图像叠加: RE(
                [MAIN.设置.选项], {
                'Image Overlay': '图像叠加'
            },
                [MAIN.设置.标签, MAIN.设置.标题], {
                'Overlay X-position': '图像X坐标',
                'Overlay Z-position': "图像Y坐标"
            },
                [MAIN.设置.描述], {
                'The X (east-west) coordinate of the center of the overlay image projection, in meters.  This can also be changed in-game using the left and right arrow keys while holding down control (for 1m increments) or shift (for 10m increments).': '覆盖图像投影中心的X坐标（东西方向），以米为单位。这也可以在游戏中使用左右箭头键进行更改，同时按住Control键（以1m为增量）或Shift键（以10m为增量）。',
                'The Z (north-south) coordinate of the center of the overlay image projection, in meters.  This can also be changed in-game using the up and down arrow keys while holding down control (for 1m increments) or shift (for 10m increments).': '覆盖图像投影中心的Z坐标（南北方向），以米为单位。这也可以在游戏中使用上下箭头键进行更改，同时按住Control键（以1m为增量）或Shift键（以10m为增量）',
                'Resets the overlay position to the center of the map.': '将覆盖位置重置为地图中心。'
            },
                [MAIN.下拉框.值, MAIN.下拉框.标签], {
                'None': '无',
            },
                [MAIN.按钮, MAIN.设置.标题], {
                'Reset overlay position': "重置覆盖位置"
            }
            ),
            无碰撞: RE(
                [MAIN.工具框.标签], {
                'Anarchy': '无碰撞'
            },
                [MAIN.设置.选项], {
                'Anarchy': '无碰撞'
            },
                [MAIN.设置.标签, MAIN.设置.标题], {
                'Always enable Anarchy with Bulldoze Tool': '始终启用推土机无碰撞',
                'Show Tooltip': '显示工具提示框',
                'Flaming Chirper': '燃烧小鸟',
                'Tool Icon': '工具图标',
                'Prevent Accidental Prop Culling': '防止意外的道具遗失',
                'Prop Refresh Frequency': '道具刷新频率',
                'Allow Placing Multiple Unique Buildings':'允许放置多个独特建筑',
                'Minimum Clearance Below Elevated Networks': '高架网络下的最小空间距离'

            },
                [MAIN.设置.描述], {
                'With this option enabled the Bulldoze Tool will always have anarchy enabled.': '启用此选项后，清障工具将始终启用无碰撞状态。',
                'With this option enabled a tooltip with Ⓐ will be shown when Anarchy is active for appropriate tools.': '启用此选项后，对适当的工具启用无碰撞时将显示带有Ⓐ的工具提示。',
                'With this option enabled the Chirper will be on fire when Anarchy is active for appropriate tools. Image Credit: Bad Peanut.': '微谈小鸟 将着火。 图片来源：Bad Peanut。  ',
                'With this option enabled a icon row with a single button for Anarchy will show up when using appropriate tools.': '启用此选项后，使用适当的工具时将显示一个包含单个无碰撞按  钮的图标显示。',
                'Upon confirmation this will reset the settings for Anarchy mod.': '确认后，这将重置 无碰撞模组 的设置。',
                'This will routinely trigger a graphical refresh to props placed with Anarchy that have been culled to prevent accidental culling of props. This affects performance.': '这将定期触发对使用 无碰撞 放置的被剔除的道具进行图形刷新，以防止意外的道具遗失。这会影响性能。',
                'This is number of frames between graphical refreshes to props placed with Anarchy to prevent accidental culling. Higher numbers will have better performance, but longer possible time that props may be missing.': '这是在 Anarchy 下放置的道具之间的图形刷新之间的帧数，以防止意外的剔除。数字越大，性能越好，但可能遗失道具的时间越长。',
                "If props placed with Anarchy have been accidently culled, you can press this button to bring them back now. This doesn't negatively effect performance.": '如果使用 无碰撞 放置的道具被意外剔除，您可以按下此按钮立即将它们恢复。这不会对性能产生负面影响。',
                'This allows you to place multiple copies of unique buildings using the normal UI menu with or without Anarchy enabled. The effects of these buildings stack!':'这允许您使用正常的 UI 菜单放置多个独特建筑，无论是否启用 Anarchy。这些建筑的效果叠加！',
                'With the net tool and Anarchy enabled you can violate the clearance of other networks. Zoning under low bridges can spawn buildings while doing this. This setting gives you some control over the minimum space below a low bridge. It would be better to just remove the zoning.':'当启用道路工具和 无碰撞 mod 时，您可以违反其他网络的空间限制。在低桥下划定区域可能会在执行此操作时生成建筑物。此设置允许您对低桥下的最小空间进行一些控制。最好是删除区域规划。'
            },
                [MAIN.按钮, MAIN.设置.标题], {
                'Reset Anarchy Settings': '重置 无碰撞模组 设置',
                'Refresh Props': '刷新道具',
            },
                [MAIN.悬浮框.标题], {
                'Anarchy': '无碰撞',
                'Gameplay Manipulation': '游戏中操纵',
                'Bypass Confirmation': '绕过确认',
                'Target Markers': '标记',
                'Target Surfaces': '地面/表面'
            },
                [MAIN.悬浮框.内容], {
                "Disables error checks for tools and does not display errors. When applicable, you can place vegetation and props (with DevUI 'Add Object' menu) overlapping or inside the boundaries of other objects and close together.":
                    '禁用工具错误检查，不显示错误。在适用的情况下，您可以将植被和道具（使用DevUI的“添加对象”菜单）放置在其他对象的边界重叠或内部并靠近一起。',
                "Allows you to use the bulldozer on moving objects such as vehicles or cims.":
                    '许在移动对象（如车辆或市民）上使用推土机。',
                "Disables the prompt for whether you are sure you want to demolish a building.":
                    '禁用是否确定要拆除建筑物的提示。',
                "Shows and EXCLUSIVELY targets markers and invisible roads. With this and anarchy enabled you can demolish invisible roads, but SAVE FIRST! You cannot demolish invisible roads within buildings.":
                    '同时启用这个和无碰撞时，您可以拆除不可见道路，但记得先保存游戏！您不能在建筑物内拆除不可见的道路。',
                "Makes the bulldozer EXCLUSIVELY target surfaces so you can remove them in one click. With Anarchy on you can bulldoze surfaces within buidings. You must turn this off to bulldoze anything else.":
                    '启用无碰撞后，您可以在建筑物内使用推土机清理地面/表面。您必须关闭此选项以回归正常推土机功能。'
            }

            ),
            建筑尺寸自定义: RE(
                [HOOKUI.面板.标题, HOOKUI.顶栏.名称], {
                'Zone Spawn Custom': '建筑尺寸自定义'
            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS.content_BIL').class('toggle_cca.toggle_ATa').next], {
                'Residential': '住宅区',
                'Commercial': '商业区',
                'Industrial': '工业区',
                'Office': '办公区'
            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS.content_BIL').class('toggle_cca.toggle_ATa').next.next.first], {
                'Detail': '细节'
            },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS.content_BIL').class('info-section_I7V').class('field_vGA')], {
                'Min': '最小',
                'Max': '最大'
            }
            ),
            地图纹理替换: RE(
                [HOOKUI.面板.标题, HOOKUI.顶栏.名称], {
                'Map Texture Replacer': '地图纹理替换'
            },
                [rif({ match: 'inc' }).class('content_XD5.content_AD7.child-opacity-transition_nkS').class('label_DGc.label_ZLb')], {
                'Pack Loaded': '加载的纹理包',
                'None': '无',
                'Grass Diffuse': '草地漫反射',
                'Grass Normal': '草地法线',
                'Dirt Diffuse': '泥土漫反射',
                'Dirt Normal': '泥土法线',
                'Cliff Diffuse': '悬崖漫反射',
                'Cliff Normal': '悬崖法线'
            },
                [MAIN.按钮], {
                'Load Texture Pack': '加载纹理包',
                'Select Image': '选择图像',
                'Reset': '重置'
            }
            ),
            全部区块解锁: RE(
                [MAIN.设置.选项], {
                '529 Tiles': '全部区块解锁'
            },
            ),
            无限刷子尺寸: RE(
                [MAIN.设置.选项], {
                    'Brush Size Unlimiter': '无限刷子尺寸'
                },
                [MAIN.设置.标签, MAIN.设置.标题], {
                    'Maximum Brush Size': '最大刷子大小',
                    'Hide Object Placement Preview With Large Brush Sizes': '巨型刷子下隐藏预览',
                },
                [rif({ match: 'inc', full: true }).class('option-page_CW8.option-section_VzQ').class('info-column_uQ0').class('info-description_wwd')], {
                    'Sets the maximum size the brush can be set to in the game/dev UI.':
                    '设置最大刷子大小限制  注意:刷子越大，性能消耗越高',

                    'Warning: Disabling this will make large object brushes with high strengths extremely laggy.':
                    '-启用此选项可大幅提高在使用大型对象刷子(≥2500大小)时的性能，通过在悬停时临时将刷子强度设置为0  警告：禁用此选项将使具有高强度的大型对象刷子非常卡顿。  如果存在兼容性问题，请禁用',
                }
            ),
            额外景观工具: RE(
                [MAIN.工具框.标签], {
                'Brush': '笔刷',
                'Brush Rotation': '笔刷角度',
                'Show Markers':'显示标记'
            },
                [MAIN.工具框.值], {
                'Custom 01': '自定义 01',
                'Mountain 01': '山脉 01',
                'Mountain 02': '山脉 02',
                'Mountain 03': '山脉 03',
                'Default Brush': '默认',
                'Mountain02Brush': '山脉 02',
                'TriangleBrush': '三角',
                'Mountain01Brush': '山脉 01',
                'Mesa01Brush': '台地 01',
                'RectangleBrush': '矩形',
                'PeakBrush': '峰',
                'TendrilBrush01': '卷曲 01',
                'TendrilBrush02': '卷曲 02',
                'MountainsBrush': '山脉',
                'Mountain03Brush': '山脉 03',
                'Mountain04Brush': '山脉 04',
                'TendrilBrush03': '卷曲 03',
                'River01Brush': '河流 01'
            },
                [MAIN.工具栏.资产详情.标题], {
                'SubServices.NAME[Surfaces]': '地面',
                'Decals':'标识'
            },
                [MAIN.工具栏.资产详情.描述], {
                'Assets.SUB_SERVICE_DESCRIPTION[Surfaces]': '一些地面/地表,无碰撞体积',
                'Decals':'标识'
            }
            ),
            扩展热键: RE(
                [HOOKUI.顶栏.名称], {
                'ExtendedHotkeys': '扩展热键'
            },
                [HOOKUI.面板.标题], {
                'Extended Hotkeys': '扩展热键'
            },
                [HOOKUI.面板.头], {
                'General': '常规',
                'Mouse Wheel': '鼠标滚轮',
                'Hotkeys': '快捷键'
            },
                [HOOKUI.面板.头描述], {

                'Extended actions with your mouse wheel while in net tool placing roads.': '在网工具放置道路时，使用鼠标滚轮进行扩展操作。',
                'Awesome actions with your keyboard.': '使用键盘进行出色的操作。'
            },
                [HOOKUI.面板.项目], {
                '升降步进卷轴': '高度阶段',
                '海拔重置': '高度重置',
                'Scroll elevation step level.': '高度阶段调整。',
                'Tool Modes': '工具模式',
                'Straight': '直线',
                'Curve': '曲线',
                'Complex Curve': '复杂曲线',
                'Continuous': '连续曲线',
                'Grid': '网格'
            }
            ),
            扩展提示框: RE(
                [HOOKUI.顶栏.名称], {
                'ExtendedTooltip': '扩展提示框'
            },
                [HOOKUI.面板.标题], {
                'Extended Tooltip': '扩展提示框'
            },
                [HOOKUI.面板.项目], {
                '无政府状态': '无碰撞状态',
                '如果启用了无政府模式，则会显示一个指示器。': '如果启用了无碰撞，则会显示一个指示器。',
            }
            ),
            随处开采: RE(
                [MAIN.设置.选项], {
                    'Extract Anywhere': '随处开采'
                },
                [MAIN.设置.标签, MAIN.设置.标题],{
                    "Can all extractors extract anywhere?":'可随处开采',
                    "Extraction radius multiplier": "采集半径倍增器",
                    'Textile Fibres': '棉花',
                    'Grain': '粮食',
                    'Vegetables': '蔬菜',
                    'Oil': '石油',
                    'Coal': '煤炭',
                    'Ore': '矿石'
                },
                [MAIN.设置.描述],{
                    "Toggle all extractors' abilities to extract resources without the need for a natural resource deposit.": 
                    '切换所有开采专门产业无需自然资源即可提取资源的能力。',

                    'Set the multiplier for the area sizes of all extractors.': 
                    '设置所有开采专门产业区域大小倍增。',

                    'Toggle whether or not textile fibres can be extracted without requiring fertile land. Turning this on means that extraction does not require fertile land.':
                    '切换棉花是否可以在不需要沃土的情况下种植。启用此选项表示不需要沃土。',

                    'Toggle whether or not grain can be extracted without requiring fertile land. Turning this on means that extraction does not require fertile land.':
                    '切换谷物是否可以在不需要沃土的情况下种植。启用此选项表示不需要沃土。',

                    'Toggle whether or not vegetables can be extracted without requiring fertile land. Turning this on means that extraction does not require fertile land.':
                    '切换蔬菜是否可以在不需要沃土的情况下种植。启用此选项表示不需要沃土。',

                    "Set the multiplier for the area size of the extractors. The default is 1 (base area size is 300). This will affect the following resource extractors: textile fibres, grain, livestock, vegetables.":
                    '设置专门产业区域大小的倍增。默认值为1（基础区域大小为300）。这将影响以下专门产业：棉花、谷物、牲畜、蔬菜。',

                    "Set the multiplier for the area size of the extractors. The default is 1 (base area size is 400). This will affect the following resource extractors: forestry.":
                    '设置专门产业区域大小的倍增。默认值为1（基础区域大小为400）。这将影响以下专门产业：林业。',

                    'Toggle whether or not oil can be extracted without requiring an oil deposit. Turning this on means that extraction does not require an oil deposit.':
                    '切换是否可以在不需要石油资源的情况下提取石油。启用此选项表示不需要石油资源。',

                    'Set the multiplier for the area size of the extractors. The default is 1 (base area size is 300). This will affect the following resource extractors: oil.':
                    '设置专门产业区域大小的倍增。默认值为1（基础区域大小为300）。这将影响以下专门产业：石油。',

                    'Toggle whether or not coal can be extracted without requiring an ore deposit. Turning this on means that extraction does not require an ore deposit.':
                    '切换是否可以在不需要矿脉的情况下开采煤炭。启用此选项表示不需要矿脉。',

                    'Toggle whether or not ore can be extracted without requiring an ore deposit. Turning this on means that extraction does not require an ore deposit.':
                    '切换是否可以在不需要矿脉的情况下开采矿石。启用此选项表示不需要矿脉。',

                    'Set the multiplier for the area size of the extractors. The default is 1 (base area size is 400). This will affect the following resource extractors: coal, ore, stone.':
                    '设置提取器区域大小的倍增器。默认值为1（基础区域大小为400）。这将影响以下专门产业：煤炭、矿石、石头。'

                },
                [MAIN.按钮, MAIN.设置.标题], {
                    'Reset to default': '重置为默认'
                },
                [MAIN.设置.TAB],{
                    'General': '常规',
                    'Fertile Land': '沃土',
                    'Forest': '林业',
                    'Oil': '石油',
                    'Ore': '矿石'
                },
                [MAIN.设置.分类],{
                    'Extract Anywhere': '随处开采'
                }


            ),
            // RICO: RE(
            //     [MAIN.工具栏.资产详情.描述,MAIN.工具栏.资产详情.标题],{
            //         'Residential Low Ploppable':'低密度住宅',
            //         'Residential Med Ploppable':'中密度住宅',
            //         'Residential High Ploppable':'高密度住宅',
            //         'Residential Row Ploppable':'中密度联排住宅',
            //         'Residential Low Rent Ploppable':'廉租公寓',
            //         'Mixed Ploppable':'混合型住宅',
            //         'Commercial Low Ploppable':'低密度商业',
            //         'Commercial High Ploppable':'高密度商业',
            //         'Office Low Ploppable':'低密度办公',
            //         'Office High Ploppable':'高密度办公',
            //         'Manufacturing Ploppable':'工厂',
            //         'Warehouse Ploppable':'仓库'
            //     },
            //     [rif({match:'inc',fullReplace:false}).class('asset-detail-panel_hf8.detail-panel_izf').class('title-bar_I7O.child-opacity-transition_nkS').class('title_qub')],{
            //         'EU_':'欧洲',
            //         'NA_':'北美',
            //         'ResidentialLowRent':'廉租公寓',
            //         'ResidentialLow':'低密度住宅 ',
            //         'ResidentialMed':'中密度住宅 ',
            //         'ResidentialHigh':'高密度住宅 ',
            //         'ResidentialRow':'中密度联排住宅',
            //         'MixedRight':'混合型住宅',
            //         'CommercialLow':'低密度商业',
            //         'CommercialHigh':'高密度商业',
            //         'Commercial':'商业',
            //         'GasStation':'加油站',
            //         'Motel':"旅馆",
            //         'OfficeLow':'低密度办公',
            //         'OfficeHigh':'高密度办公',
            //         'IndustrialManufacturingWarehouse':'仓库',
            //         'IndustrialManufacturing':'工厂',

            //         '_L':' 等级',
            //         '_ploppable':'',
            //         'Assets.NAME':''
            //     }
            // ),
            // 交通自定义: RE(
            //     [MAIN.设置.选项], {
            //         'CityPlayer Traffic Custom': '交通自定义'
            //     },
            //     [MAIN.设置.标签, MAIN.设置.标题],{
            //         'Use Rush Hour': '开启高峰时间',
            //         'Rush Hour Traffic Strength': '高峰交通强度',
            //         'Randomly Dummy Traffic - Car (On/Off)': '随机虚拟交通 - 汽车（开/关）',
            //         'Randomly Dummy Traffic - Train (On/Off)': '随机虚拟交通 - 火车（开/关）',
            //         'Randomly Dummy Traffic - Airplane (On/Off)': '随机虚拟交通 - 飞机（开/关）',
            //         'Randomly Dummy Traffic - Watercraft (On/Off)': '随机虚拟交通 - 水上交通工具（开/关）',
            //         'Taxi Preference': '出租车偏好',
            //         'PublicTransport Preference': '公共交通偏好',
            //         'PersonalCar Preference': '私家车偏好',
            //         'Buying PersonalCar Preference': '购买私家车偏好'

            //     },
            //     [MAIN.设置.分类],{
            //         'CityPlayer Traffic Custom': '交通自定义',
            //         'RUSH HOUR CUSTOM MOD': '高峰时间定制',
            //         'RANDOM TRAFFIC CUSTOM MOD': '随机虚拟交通定制',
            //         'CITIZEN TRANSPORTAION PREFERENCE CUSTOM MOD': '居民交通偏好定制',
            //         'EXPERIMAENTAL MOD': '实验性模组'
            //     },
            //     [MAIN.按钮, MAIN.设置.标题],{
            //         'RESET SETTINGS':'重置设置'

            //     },
            //     [MAIN.下拉框.值,MAIN.下拉框.标签],{
            //         'Very Low':'非常低',
            //         'Low':'低',
            //         'High':'高',
            //         'Very High':'非常高'
            //     },
            //     [MAIN.设置.描述],{
            //         "Reset 'CityPlayer Traffic Custom Mod' settings.":'重置城市玩家交通定制模组设置',
            //         "Creates Rush Hours for Cars and Trucks between Outside-Cities. This option can make game more difficult. (Rush hour varies in severity depending on the size of the city)":'在城市之间为汽车和卡车创建高峰时间。此选项可能使游戏更加困难。（高峰时间的严重程度取决于城市的大小）',
            //         "Control Strength of Rush Hour. (Default:3,  Min:1 Max:5)":'控制高峰时间的强度。（默认值：3，最小值：1 最大值：5）',
            //         "Turn On/Off randomly generated dummy Car Vehicles.":'打开/关闭随机生成的虚拟汽车交通。',
            //         "Turn On/Off randomly generated dummy Train Vehicles.":'打开/关闭随机生成的虚拟火车交通。',
            //         "Turn On/Off randomly generated dummy Airplane Vehicles.":'打开/关闭随机生成的虚拟飞机交通。',
            //         "Turn On/Off randomly generated dummy Watercraft Vehicles.":'打开/关闭随机生成的虚拟水上交通。',
            //         "Control Taxi preferences.(If set up to 'None', citizens don't use Taxi.)":"控制出租车偏好。（如果设置为“无”，市民不使用出租车。）",
            //         "Control PublicTransport preferences.":'控制公共交通偏好。',
            //         "Control Personal Car preferences.(If citizens not have own car, they don't use Personal Car)":'控制个人汽车偏好。（如果市民没有自己的汽车，他们不使用个人汽车。）',
            //         "Control Buying Personal Car preferences.(The higher preference, the more likely to buy a Personal Car.)":'控制购买个人汽车的偏好。（偏好值越高，购买个人汽车的可能性越大。）'
            //     }
            // ),
            // TWEAKUI: RE(
            //     [HOOKUI.顶栏.名称,HOOKUI.面板.标题],{
            //         'TweakUI':'调整 UI',
            //     },
            //     [rif().class('label_VSW').all],{
            //         'Transportation Overview Height': '交通总览高度',
            //         'Asset Menu Rows': '资产菜单行数'
            //     },
            //     [rif().class('description_VWf').class('paragraphs_nbD').all],{
            //         'Change the height of the transportation overview.': '更改交通总览的高度。',
            //         'Change the number of rows on the tool asset menu.': '更改工具资产菜单上的行数。'
            //     },
            //     [rif().class('tab-bar_oPw').class('tab_Hrb')],{
            //         'Settings':'设置'
            //     }

            // ),
            色彩调整: RE(
                [MAIN.设置.选项],{
                    'ColorAdjustments':'色彩调整'
                }
            ),
            水景工具:RE(
                [MAIN.设置.选项],{
                    'Water Features':'水景工具'
                },
                [MAIN.设置.标签,MAIN.设置.标题],{
                    'Enable Seasonal Streams': '启用季节性河流',
                    'Simulate Snow Melt': '模拟雪融化',
                    'Constant Flow Rate': '恒定流速',
                    'Seasonality': '季节性',
                    'Stormwater Effects': '雨水效果',
                    'Minimum Multiplier': '最小倍增器',
                    'Maximum Multiplier': '最大倍增器',

                    'Try Smaller Radii': '尝试较小的半径',
                    'Add Detention Basins (Restart Required)': '添加滞留池（需要重新启动）',
                    'Add Retention Basins (Restart Required)': '添加保留池（需要重新启动）',
                    'Evaporation Rate': '蒸发率',

                    'Enable Waves and Tides': '启用波浪和潮汐',
                    'Wave Height': '波浪高度',
                    'Wave Frequency': '波浪频率',
                    'Tide Height': '潮汐高度',
                    'Tide Classification': '潮汐分类',
                    'Damping': '阻尼'
                },
                [MAIN.设置.TAB],{
                    'Seasonal Streams': '季节性溪流',
                    'Water Tool': '水工具',
                    'Waves and Tides': '波浪和潮汐'
                },
                [MAIN.按钮,MAIN.设置.标题],{
                    'Reset Seasonal Streams Settings': '重置季节性溪流设置',
                    'Water Clean Up Cycle': '水清理周期',
                    'Reset Water Tool Settings': '重置水工具设置',
                    'Reset Waves and Tides Settings': '重置波浪和潮汐设置'
                },
                [MAIN.设置.描述],{
                    "Seasonal streams takes Streams (Modified Constant Rate Water Sources) and ties them to the climate and weather for the map. For example, if your map features a dry summer, then these water sources will decrease during the summer. Seasonal streams by it-self should not cause flooding since it treats the map's default water source amount as a maximum unless you change it. All aspects are optional and adjustable in the mod's settings.":
                    '季节性河流将水流（修改后的常定流水源）与地图的气候和天气联系起来。例如，如果你的地图有一个干燥的夏天，那么这些水源在夏天会减少。季节性河流本身不应该引起洪水，因为它将地图的默认水源量视为最大值，除非你进行更改。所有方面都可以在模组的设置中进行选择和调整。',

                    "Simulate snow accumulation and snow melt. Snow melt is not currently tied to snow visuals. This affects Constant Rate Water Sources, Detention and Retention basins.":
                    '模拟雪的积累和融化。目前，雪融化与雪的视觉效果没有直接关联。这会影响常定流水源、蓄水和保水盆地。',

                    "Constant flow rate from  Streams (Modified Constant Rate Water Sources) unaffected by season or weather.":
                    '来自水流（修改后的常定流水源）的常定流速，不受季节或天气的影响。',

                    "Streams (Modified Constant Rate Water Sources) flowrates will increase by this percentage during the season with the highest mean seasonal precipitation. Other seasons will be proportional.":
                    '在具有最高季节降水平均值的季节，水流（修改后的常定流水源）的流速将增加这个百分比。其他季节将成比例增加。',

                    "Streams (Modified Constant Rate Water Sources) flowrates will increase by this percentage when current precipitation (rain) is at a maximum. Less precipitation is proportional.":
                    '在当前降水（雨）达到最大值时，水流（修改后的常定流水源）的流速将增加这个百分比。降水较少时成比例增加。',

                    "Minimum multiplier applied to stream flowrates.":
                    '应用于流速的最小倍增器。',

                    "Maximum multiplier applied to stream flowrates.":
                    '应用于流速的最大倍增器。',

                    "On confirmation, resets Seasonal Streams Settings.":
                    '确认后，将重置季节性河流设置。',

                    "Lets you try to make a water source with a radius smaller than 5m. It will not always work, but will be increased to a radius that does work.":
                    '允许你尝试制作半径小于5米的水源。它不总是有效的，但会增加到有效的半径。',

                    "Custom modded water source that rises with precipitation and snowmelt and slowly drains when the weather is dry. They have a maximum water surface elevation but no minimum water surface elevation. You may need to adjust the global evaporation rate in the settings for desirable infiltration of the pond water.":
                    '自定义修改的水源，随着降水和融雪而上涨，在天气干燥时缓慢排水。它们具有最大水面高度，但没有最小水面高度。你可能需要在设置中调整全局蒸发速率，以便池塘水的渗透效果理想。',

                    "Custom modded water source that rises with precipitation and snowmelt and slowly drains when the weather is dry. They have a maximum water surface elevation and a minimum water surface elevation. You may need to adjust the global evaporation rate in the settings for desirable infiltration of the pond water.":
                    '自定义修改的水源，随着降水和融雪而上涨，在天气干燥时缓慢排水。它们具有最大水面高度和最小水面高度。你可能需要在设置中调整全局蒸发速率，以便池塘水的渗透效果理想。',

                    "Should probably leave at default unless you are using detention or retention basins. Actual evaporation rate is 1000x smaller but this gives you control over the rate. This is global and you may want to rebalance and increase flows of water sources after increasing it.":
                    '除非你正在使用蓄水池或保水池，否则最好保持默认值。实际蒸发速率要小1000倍，但这使你能够控制速率。这是全局的，你可能想在增加后重新平衡和增加水源的流量。',

                    "This will increase the rate of evaporation by 1000x FOR THE WHOLE MAP for a short amount of time before returning to normal. For cleaning up water messes but USE AT YOUR OWN RISK! Lakes with an target elevation below the ground level are a safer way to remove water.":
                    '这将在整个地图上短时间内将蒸发速率提高1000倍，然后恢复正常。用于清理水的混乱，但使用需谨慎！具有目标高程低于地面水平的湖泊是更安全的排水方式。',

                    "On confirmation, resets Water Tool Settings.":
                    '点击确认后，将重置水工具设置。',

                    "This feature is dependent on map design. Maps with a sea water source and a single shoreline work best. The point of the waves feature is to make the shore move in and out and make sand along the shoreline. A better way to make beaches is to just paint them with surface painter instead. Waves exacerbate the magnitude of the water surface. Tides happen once or twice a day. Waves and tides are always lower than the original sea level and do not cause flooding.":
                    '此功能依赖于地图设计。具有海水源和单个海岸线的地图效果最佳。波浪功能的目的是使海岸线进出，并在沿海形成沙滩。更好的制作海滩的方式是使用表面绘图工具直接绘制。波浪加剧了水面的幅度。潮汐每天发生一到两次。波浪和潮汐始终低于原始海平面，不会引起洪水。',

                    "On confirmation, resets Waves and Tides Settings.":
                    '点击确认后，将重置波浪和潮汐设置。',

                    'Waves are generated at the map boundary where there is a Sea water source. Once generated they head towards shore. Maps were not necessarily designed for these waves, and the waves exacerbate the water surface. Waves are lower than the sea level from the original map and do not cause flooding. Maps such as San Francisco with shallow seas will need waves and tides with smaller heights to avoid large swathes of non-playable area becoming dry sand.':
                    '海浪在地图边界的海水源处生成。一旦生成，它们就朝着岸边前进。地图不一定是为这些波浪设计的，而波浪使水面恶化。波浪低于原始地图的海平面，不会造成洪水。像旧金山这样海域较浅的地图将需要较小高度的波浪和潮汐，以避免大片非可玩区域变成干沙。',

                    'Frequency for waves per day.':
                    '每天的波浪频率。',

                    'Tides are the biggest waves and they cause the sea to rise and fall along the shore. Tides can add sandy graphics along shorelines but the sand may not persist the entire time between low tide and high tide. Tides are lower than the sea level from the original map and do not cause flooding. Maps such as San Francisco with shallow seas will need waves and tides with smaller heights to avoid large swathes of non-playable area becoming dry sand. ':
                    '潮汐是最大的波浪，它们使海水沿岸升降。潮汐可以在海岸线上添加沙质图形，但沙子可能不会在低潮和高潮之间的整个时间内持续存在。潮汐低于原始地图的海平面，不会造成洪水。像旧金山这样海域较浅的地图将需要较小高度的波浪和潮汐，以避免大片非可玩区域变成干沙。',

                    'Diurnal tides have one high and one low tide per day. Semidiurnal has two high tides and two low tides per day.':
                    '白天潮汐每天有一次高潮和一次低潮。半日潮有每天两次高潮和两次低潮。',

                    'A higher value makes waves stronger while a lower value makes waves weaker. Stronger waves reach farther into the map. Weak waves may disperse before reaching shore. Vanilla is 9950 Recommended 9980-9999. The actual value is 10000x less.':
                    '更高的值使波浪更强，而较低的值使波浪更弱。较强的波浪能够延伸到地图更远的地方。较弱的波浪可能在到达岸边之前就散开。原版是9950，推荐值为9980-9999。实际值是其10000倍之一。'
                },
                [MAIN.工具框.标签],{
                    "Flow":"流量",
                    'Depth':'深度'
                },
                [MAIN.悬浮框.标题],{
                    "Reduce Flow/Depth/Elevation": '减少流量/深度/高程',
                    'Increase Flow/Depth/Elevation': '增加流量/深度/高程',
                    'Flow/Depth/Elevation Rate of Change': '流量/深度/高程变化率',
                    'Reduce Radius': '减小半径',
                    'Increase Radius': '增加半径',
                    'Radius Rate of Change': '半径变化率'

                },
                [MAIN.悬浮框.内容],{
                    "Reduces the flow for Streams. Decreases the depth or elevation for rivers, seas, and lakes. Reduces the max depth for retention and detention basins.":
                    '减小河流的流量。减小河流、海洋和湖泊的深度或高程。减小蓄水和滞水池的最大深度。',

                    "Increases the flow for Streams. Increases the depth or elevation for rivers, seas, and lakes. Increases the max depth for retention and detention basins.":
                    '增加河流的流量。增加河流、海洋和湖泊的深度或高程。增加蓄水和滞水池的最大深度。',

                    "Changes the rate in which the increase and decrease buttons work for Flow, Depth and Elevation.":
                    '改变流量、深度和高程的增加和减少按钮的工作速率。',

                    "Reduces the radius.":'减小半径。',
                    "Increases the radius..":'增加半径。',
                    'Changes the rate in which the increase and decrease buttons work for Radius.':'改变增加和减少按钮在半径上的工作速率。'
                },
                [MAIN.工具栏.资产详情.标题],{
                    'Stream - Constant or Variable Rate Water Source': '小溪 - 恒定或可变速水源',
                    'River - Border River Water Source': '河流 - 边界河水源',
                    'Lake - Constant Level Water Source': '湖泊 - 恒定水平水源',
                    'Sea - Border Sea Water Source': '海洋 - 边界海水源',
                    'Water Tool':'水景工具'
                },
                [MAIN.工具栏.资产详情.描述],{
                    'Emits water depending on the settings for this mod. With Seasonal Streams disabled, the flow rate will be constant. With Seasonal Streams enabled the flow rate will vary with season, precipitation, and snowmelt depending on your settings. Left click to place within playable area. Hover over and right click to remove.':
                    '根据此mod的设置释放水。如果禁用了季节性流，流量将保持恒定。启用季节性流时，流量将根据您的设置随季节、降水和融雪而变化。左键单击以放置在可玩区域内。悬停并右键单击以移除。',
                    'Has a constant level and controls water flowing into or out of the border. While near the border, the source will snap to the border. Right click to designate the target elevation. Left click to place. Hover over and right click to remove.':
                    '具有恒定水平并控制流入或流出边界的水。靠近边界时，水源会捕捉到边界。右键单击以指定目标高程。左键单击以放置。悬停并右键单击以移除。',
                    'Fills quickly until it gets to the desired level and then maintains that level. If it has a target elevation below the ground level, it can drain water faster than evaporation. Right click to designate the target elevation. Left click to place within playable area. Hover over and right click to remove.':
                    '快速填充直到达到所需水平，然后保持该水平。如果目标高程低于地面水平，它可以比蒸发更快地排水。右键单击以指定目标高程。左键单击以放置在可玩区域内。悬停并右键单击以移除。',
                    'Controls water flowing into or out of the border and the lowest sea controls sea level. With Waves and Tides disabled, it will maintain constant level. With Waves and Tides enabled the sea level rises and falls below the original sea level. Right click to designate the elevation. Left click to place if the radius touches a border. Hover over and right click to remove.':
                    '控制流入或流出边界的水，最低海域控制海平面。如果禁用了波浪和潮汐，它将保持恒定水平。启用波浪和潮汐时，海平面将在原始海平面以下升降。右键单击以指定高程。如果半径触及边界，则左键单击以放置。悬停并右键单击以移除。',
                    'Water tool allows you to add and remove water sources from your map.':'水景工具允许您在地图上添加和移除水源。'
                },
                [MAIN.悬浮框.提示2],{
                    "Rivers must be placed near map border.":
                    "河流必须靠近地图边界。",
                    "Right click to designate the water surface elevation.":
                    "右键单击以指定水面高程。",
                    "Sea water sources must touch the map border.":
                    "海水源必须接触地图边界。",
                    'This water source must be placed inside the playable map.':
                    '水源必须在地图内'
                },
                [MAIN.下拉框.值,MAIN.下拉框.标签],{
                    'Semidiurnal': '半日潮',
                    'Diurnal': '昼夜潮'
                }
            ),
            // 终极监视器: RE(
            //     [HOOKUI.面板.标题, HOOKUI.顶栏.名称], {
            //         'City Monitor': '城市监视器',
            //     },
            //     [rif().class('panel_YqS').index(1).first.all.index(1).index(1)], {
            //         'Electricity': '电力资源可用性',
            //         'Water': '水资源可用率',
            //         'Sewage': '污水处理',
            //         'Garbage Processing': '垃圾处理',
            //         'Fire Hazard': '火灾危险',
            //         'Crime Rate': '犯罪率',
            //         'Traffic Flow': '交通流量',
            //         'Parking Availability': '停车位可用性',
            //         'Healthcare Efficiency': '医疗效率',
            //         'Deathcare Efficiency': '殡仪服务效率',
            //         'Imprisonment Capacity': '监狱容量',
            //         'Education Availability': '教育可用性',
            //         'Income Efficiency': '收入效率',
            //         'Monthly Population Growth': '每月人口增长',
            //         'Avg. Pollution': '平均污染'
            //     },
            //     [HOOKUI.面板.标题], {
            //         'City': '城市监视器'
            //     }
            // ), 
            额外景观工具扩展_地面: RE(
                [MAIN.悬浮框.内容,MAIN.悬浮框.标题],{
                    'Surfaces':'地面'
                },
                [MAIN.工具栏.资产详情.标题,MAIN.工具栏.资产详情.描述],{
                    'Concrete': '混凝土',
                    'Ground': '地面',
                    'Tiles': '瓷砖',
                    'Wood': '木材'
                },
                [MAIN.工具栏.资产详情.标题],{
                    'Asphalt 001': '沥青 001',
                    'Asphalt 002': '沥青 002',
                    'Cracked Asphalt': '破裂的沥青',
                    'Polished Concrete': '抛光混凝土',
                    'Weathered Asphalt': '风化的沥青',
                    'Grass 001': '草地 001',
                    'Snow': '雪',
                    'Scattered Leaves': '散落的树叶',
                    'Sand': '沙子',
                    'Rocky Sand': '岩石沙',
                    'Wet Sand': '湿沙',
                    'Mulch': '覆盖物',
                    'Mud': '泥巴',
                    'Grass Checkered Lawn': '格子草坪',
                    'Podzol': '灰土',

                    'Dark Grey Ceramic Tile': '深灰色陶瓷砖',
                    'Yellow & Grey Paving Stone': '黄灰色铺路石',
                    'White & Grey Plaza Paving Stone': '白灰色广场铺路石',
                    'Red Brick': '红砖',
                    'Hexagonal Grey Paving Stone': '六角灰色铺路石',
                    'Hexagonal Dark Grey Paving Stone': '六角深灰色铺路石',
                    'Herringbone Grey Paving Stone 002': '人字形灰色铺路石 002',
                    'Herringbone Grey Paving Stone 003': '人字形灰色铺路石 003',
                    'Grey Walking stone': '灰色行走石',
                    'Grey Paving Stone': '灰色铺路石',
                    'Grey Ceramic Tile': '灰色陶瓷砖',
                    'Grey Brick': '灰色砖',
                    'Eco Pavement': '生态铺路',
                    'Herringbone Grey Paving Stone 001': '人字形灰色铺路石 001',
                    'Wood 001': '木头 001',
                    'Wood 002': '木头 002',
                    'Wood 003': '木头 003'
                }
            ),
            额外景观工具扩展_资产: RE(
                [MAIN.悬浮框.内容,MAIN.悬浮框.标题],{
                    'Props':'道具'
                }
            ),
            更好的推土机: RE(
                [MAIN.悬浮框.内容],{
                    'Shows and EXCLUSIVELY targets markers and invisible roads. With this enabled you can demolish invisible networks, invisible parking decals, various spots, points, and spawners, but SAVE FIRST! You cannot demolish these within buildings.':
                    '显示并且专门针对标记和看不见的道路。启用此功能后，您可以拆除看不见的网络、看不见的停车标记、各种点、点和生成器，但是请先保存！您不能在建筑物内拆除这些。',

                    'Makes the bulldozer EXCLUSIVELY target surfaces and spaces inside or outside of buildings so you can remove them in one click. You must turn this off to bulldoze anything else.':
                    '使推土机专门针对建筑物内外的表面和空间，以便您可以一键移除它们。您必须关闭此功能才能拆除其他任何东西。'
                }
            ),
            树木风力控制器: RE(
                [HOOKUI.面板.标题,HOOKUI.顶栏.名称],{
                    'Tree Wind Controller':'树木风力控制器'
                },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').first.first.first.first],{
                    'Disable All Wind:':'关闭所有风'
                },
                [rif().class('content_XD5.content_AD7.child-opacity-transition_nkS').first.all.first],{
                    'Wind Strength:':'风强度',
                    'Wind Strength Variance:':'风力变化',
                    'Wind Strength Variance Period:':'风力变化周期',
                    'Wind Direction:':'风向',
                    'Wind Direction Variance:':'风向变化',
                    'Wind Direction Variance Period:':'风向变化周期'
                }
            ),
            地图编辑器_气候: RE(
                [rif().class('list-item_qRg.item_H00').class('name_u39'),rif().class('control_Hds').class('picker-toggle_d6k'),开发者模式.内容.控制值], {
                'ContinentalCorralRichesClimate': '陆地珊瑚气候',
                'ContinentalGreatHighlandsClimate': '陆地高地气候',
                'ContinentalLakelandClimate': '陆地湖泊气候',
                'ContinentalMountainVillageClimate': '陆地山村气候',
                'ContinentalTampereClimate': '陆地坦佩雷气候',
                'PolarSweepingPlainsClimate': '极地平原气候',
                'PolarTwinMountainClimate': '极地山地气候',
                'PolarWindyFjordsClimate': '极地峡湾气候',
                'TemperateArchipelagoHavenClimate': '温带群岛气候',
                'TemperateBarrierIslandClimate': '温带障碍岛气候',
                'TemperateSanFranciscoClimate': '温和的旧金山气候',
                'TemperateSunshinePeninsulaClimate': '温带阳光半岛气候',
                'TemperateWaterwayPassClimate': '温带航道气候',
                'TemperateRiverDeltaClimate': '温带河三角洲气候'
                }
            ),
            交通运输管理器: RE(
                [MAIN.设置.选项],{
                    'Extended T. Manager (v0.1.2)':'交通运输管理器'
                },
                [MAIN.设置.标签,MAIN.设置.标题],{
                    'Logging Level': '日志级别',
                    'Show this mod errors on UI': '在用户界面上显示此模组的错误',
                    'Mod Version': '模组版本'
                },
                [MAIN.设置.描述],{
                    'Changes the log level of this mod. Verbose mode generates A LOT of logging, be careful.':'更改此模组的日志级别。详细模式会生成大量日志，请小心。',
                    'Only disable it on emergencies!':'仅在紧急情况下禁用它！',
                    "The current mod version.\n\nIf version ends with 'B', it's a version compiled for BepInEx framework.":"当前模组版本。\n\n如果版本以'B'结尾，则是为 BepInEx 框架编译的版本。"
                    
                }
            ),
            模组工具链: RE(
                [MAIN.设置.标签],{
                    '工具链状态':'模组开发工具，非必要不需要安装'
                }
            ),
            可放置自长建筑: RE(
                [MAIN.设置.选项],{
                    'Plop the Growables':'可放置自长建筑'
                },
                [MAIN.设置.标签,MAIN.设置.标题],{
                    'Disable building levelling':'禁用建筑升级'
                },
                [MAIN.设置.描述],{
                    'Prevents buildings from changing levels, so that they keep their appearance.':'阻止建筑改变级别，使其保持原貌。'

                }
            ),
            额外UI界面: RE(
                [MAIN.设置.选项],{
                    'Extra UI Screens (v0.1.1)':'额外UI界面'
                },
                [MAIN.设置.TAB],{
                    'Monitors':'显示器',
                    'About':"关于",
                    'Meshes':'网格'

                },
                [
                    rif({match:'inc'}).class('option-page_CW8.option-section_VzQ').class('main-column_D0A').class('content_gqa').class('label_DGc.label_ZLb'),
                    rif({match:'inc'}).class('option-page_CW8.option-section_VzQ').class('info-column_uQ0').class('info-title_a3p')],{
                    'Use Monitor':'使用显示器'
                },
                [MAIN.设置.描述],{
                    'Create a EUIS overlay over the main screen. Use Ctrl+Tab to alternate between EUIS and game screens.':'在主屏幕上创建一个EUIS覆盖层。使用Ctrl+Tab在EUIS和游戏屏幕之间进行切换。'

                }
            ),
            编辑器: RE(
                编辑器.通用,{
                    'Building Prefab':'建筑资产',
                    'Meshes':'网格',
                    'Mesh':'网格',
                    'Position':'位置',
                    'Rotation':'旋转',
                    'Require State': '需求状态',
                    'Circular': '圆形资产',
                    'Access Type': '访问类型',
                    'Lot Width': '区域宽度',
                    'Lot Depth': '区域长度',
                    'Name': '名称',
                    'Front': '前',
                    'LeftCorner': '左',
                    'RightCorner': '右',
                    'LeftAndRightCorner': '左/右',
                    'LeftAndBackCorner': '左/后',
                    'RightAndBackCorner': '右/后',
                    'FrontAndBack': '前后',
                    'All': '全部',

                    'None': '无',
                    'Child': '儿童',
                    'Teen': '青少年',
                    'Adult': '成年人',
                    'Elderly': '老年人',
                    'Dead': '死亡',
                    'Stump': '树桩',
                    'Empty': '空',
                    'Full': '满',
                    'Clear': '清理',
                    'Track': '轨道',
                    'Partial1': '部分1',
                    'Partial2': '部分2',
                    'LefthandTraffic': '左侧通行',
                    'RighthandTraffic': '右侧通行',
                    'Cold': '寒冷',
                    'Warm': '温暖',
                    'Home': '居住地',
                    'Homeless': '无家可归',
                    'Motorcycle': '摩托车',
                    'Forward': '向前',
                    'Backward': '向后',

                    'Service Consumption': '服务消耗',
                    'Upkeep': '维护',
                    'Electricity Consumption': '电力消耗',
                    'Water Consumption': '用水量',
                    'Garbage Accumulation': '垃圾积累',
                    'Telecom Need': '电信需求',

                    'Service Object': '服务对象',
                    'Service': '服务',
                    'Communications': '通信',
                    'Education & Research': '教育与研究',
                    'Electricity': '电力',
                    'Fire & Rescue': '消防与救援',
                    'Garbage Management': '垃圾管理',
                    'Health & Deathcare': '健康与死亡护理',
                    'Landscaping': '园林绿化',
                    'Parks & Recreation': '公园与娱乐',
                    'Police & Administration': '警察与行政',
                    'Roads': '道路',
                    'Transportation': '交通',
                    'Water & Sewage': '供水与污水',

                    'Placeable Object': '可放置对象',
                    'Construction Cost': '建造费用',
                    'XP Reward': '经验奖励',
                    'Service Coverage': '服务覆盖范围',
                    'Range': '范围',
                    'Capacity': '容量',
                    'Magnitude': '大小',
                    'City Service Building': '城市服务建筑',
                    'Upkeeps': '维护费用',
                    'Park': '公园',
                    'Maintenance Pool': '维护池',
                    'Allow Homeless': '允许无家可归者',
                    'Attraction': '吸引力',
                    'Attractiveness': '吸引力',
                    'Leisure Provider': '休闲提供',
                    'Efficiency': '效率',
                    'Leisure Type': '休闲类型',

                    'UI Object': 'UI对象',
                    'Group': '组',
                    'Priority': '优先级',
                    'Icon': '图标',
                    'Large Icon': '大图标',
                    'Is Debug Object': '是否为调试对象',
                    'Administration': '行政管理',
                    'AirTransportGroup': '航空运输组',
                    'Areas': '区域',
                    'AreasGroup': '区域组',
                    'Budget': '预算',
                    'Business': '业务',
                    'CitizensCategory': '市民类别',
                    'CityCategory': '城市类别',
                    'CommunicationGroup': '通信组',
                    'Communications': '通信',
                    'CommunicationsPost': '通信邮件',
                    'CommunicationsTelecom': '通信电信',
                    'CompanyCount': '公司数量',
                    'Deathcare': '死亡护理',
                    'DisasterControl': '灾难控制',
                    'EconomyGroup': '经济组',
                    'Education': '教育',
                    'Education & Research': '教育和研究',
                    'EducationGroup': '教育组',
                    'Electricity': '电力',
                    'ElectricityGroup': '电力组',
                    'Employment': '就业',
                    'Expenses': '支出',
                    'Fire & Rescue': '消防和救援',
                    'Fire&RescueGroup': '消防和救援组',
                    'Garbage Management': '垃圾管理',
                    'GarbageManagement': '垃圾管理',
                    'Happiness': '幸福',
                    'Health & Deathcare': '健康与殡葬',
                    'Health&DeathcareGroup': '健康与殡葬',
                    'Healthcare': '医疗保健',
                    'HotelRooms': '酒店客房',
                    'lmmaterial Goods': '非物质商品',
                    'Income': '收入',
                    'InfoViewGroup': '信息视图组',
                    'InfoViewsCategory': '信息视图类别',
                    'Interface&ToolsCategory': '界面和工具类别',
                    'Jobs': '工作',
                    'Landscaping': '景观',
                    'LandscapingGroup': '景观组',
                    'LargeParks': '大型公园',
                    'LargeSportsParks': '大型体育公园',
                    'MapTileGroup': '地图瓦片组',
                    'Marker Object Prefabs': '标记对象资产',
                    'Material Goods': '物质商品',
                    'Materials': '材料',
                    'NotificationsGroup': '通知组',
                    'Parks & Recreation': '公园与娱乐',
                    'Parks&RecreationGroup': '公园与娱乐组',
                    'Pathways': '路径',
                    'PhotoModeGroup': '照片模式组',
                    'Police': '警察',
                    'Police & Administration': '警察与行政',
                    'Police&AdministrationGroup': '警察与行政组',
                    'Population': '人口',
                    'PopulationDecline': '人口减少',
                    'PopulationGrowth': '人口增长',
                    'Post': '邮政',
                    'ProgressionGroup': '进展组',
                    'PublicTransport': '公共交通',
                    'Research': '研究',
                    'RoadTransportGroup': '道路运输组',
                    'Roads': '道路',
                    'RoadsGroup': '道路组',
                    'RoadsHighways': '高速公路',
                    'RoadsIntersections': '道路交叉口',
                    'RoadsLargeRoads': '大型道路',
                    'RoadsMediumRoads': '中型道路',
                    'RoadsParking': '停车场',
                    'RoadsRoundabouts': '环形交叉路口',
                    'RoadsServices': '服务道路',
                    'RoadsSmallRoads': '小型道路',
                    'Services': '服务',
                    'Services Toolbar Group': '服务工具栏组',
                    'ServicesCategory': '服务类别',
                    'Signatures': '标志性',
                    'SignaturesCommercial': '商业标志性',
                    'Signatureslndustrial': '工业标志性',
                    'SignaturesLandmarks': '地标标志性',
                    'SignaturesOffice': '办公标志性',
                    'SignaturesResidential': '住宅标志性',
                    'SignaturesResidentialMixed': '混合住宅标志性',
                    'Spaces': '空间',
                    'SportsParks': '体育公园',
                    'Terraforming': '地形塑造',
                    'Tools Toolbar Group': '工具栏组',
                    'Tourism': '旅游业',
                    'TouristAttractions': '旅游景点',
                    'TrainGroup': '火车组',
                    'Transportation': '交通',
                    'TransportationAir': '空中交通',
                    'TransportationGroup': '交通组',
                    'TransportationRoad': '道路交通',
                    'TransportationSubway': '地铁交通',
                    'TransportationTrain': '火车交通',
                    'TransportationTram': '有轨电车交通',
                    'TransportationWater': '水上交通',
                    'Vegetation': '植被',
                    'Water & Sewage': '水和污水',
                    'Water&SewageGroup': '水和污水组',
                    'WaterTool': '水工具',
                    'WaterTransportationGroup': '水上交通组',
                    'Wealth': '财富',
                    'Workers': '工人',
                    'Zones': '区域',
                    'Zones Toolbar Group': '区域工具栏组',
                    'ZonesCommercial': '商业区',
                    'ZonesExtractors': '提取区',
                    'ZonesIndustrial': '工业区',
                    'ZonesOffice': '办公区',
                    'ZonesResidential': '居住区',
                    'ZoningGroup': '区域组',

                    'Object Sub Objects': '对象子对象',
                    'Object Sub Nets': '对象子网',
                    'Invert When': '反转条件',
                    'Sub Nets': '子线段',
                    'Net Prefab': '线段资产',
                    'Bezier Curve': '贝塞尔曲线',
                    'Node Index': '节点索引',
                    'Parent Mesh': '父网格',
                    'Upgrades': '升级',
                    'Sub Objects': '子对象',
                    'Object': '对象',
                    'Parent Mesh': '父网格',
                    'Group Index': '组索引',
                    'Probability': '概率',

                    'Effect Source': '效果源',
                    'Effects': '效果',
                    'Animation Curves': '动画曲线',
                    'Effect': '效果',
                    'Position Offset': '位置偏移',
                    'Scale': '比例',
                    'Intensity': '强度',
                    'Parent Mesh': '父网格',
                    'AnimationIndex': '动画索引',
                    'Unlockable': '可解锁',
                    'Require All': '需要全部',
                    'Require Any': '需要任意',
                    'Ignore Dependencies': '忽略依赖关系',
                    'Object Sub Areas': '对象子区域',
                    'Sub Areas': '子区域',
                    'Area Prefab': '区域资产',
                    'Node Positions': '节点位置',
                    'Parent Meshes': '父网格',

                    'Resources': '资源',
                    'Resource': '资源',
                    'Amount': '数量',
                    'Scale With Usage': '使用比例缩放',
                    'Pollution': '污染',
                    'Ground Pollution': '地面污染',
                    'Air Pollution': '空气污染',
                    'Noise Pollution': '噪音污染',
                    'Scale With Renters': '随租客数量缩放',
                    'Transport Station': '交通站点',
                    'Car Refuel Types': '汽车加油类型',
                    'Train Refuel Types': '火车加油类型',
                    'Watercraft Refuel Types': '水上交通工具加油类型',
                    'Aircraft Refuel Types': '飞机加油类型',
                    'Comfort Factor': '舒适因子',
                    'Fuel': '燃料',
                    'Electricity': '电力',
                    'FuelAndElectricity': '燃料和电力',
                    'Obsolete Identifiers': '已过时标识符',
                    'Building Terraform Override': '建筑地形改造覆盖',
                    'Level Min Offset': '平整最小偏移',
                    'Level Max Offset': '平整最大偏移',
                    'Level Front Left': '左前平整',
                    'Level Front Right': '右前平整',
                    'Level Back Left': '左后平整',
                    'Level Back Right': '右后平整',
                    'Smooth Min Offset': '平滑最小偏移',
                    'Smooth Max Offset': '平滑最大偏移',
                    'Height Offset': '高度偏移',
                    'Additional Smooth Areas': '额外平滑区域',
                    'Dont Raise': '不提升',
                    'Dont Lower': '不降低',
                    'School':'学校',
                    'Student Capacity': '学生容量',
                    'Level': '等级',
                    'Graduation Modifier': '毕业修改器',
                    'Student Wellbeing': '学生生活质量',
                    'Student Health': '学生健康',
                    'Service Fee Collector': '服务费收集器',
                    'Object Sub Lanes': '对象子车道',
                    'Sub Lanes': '子车道',
                    'Lane Prefab': '车道资产',
                    'Building Terraform Override': '建筑地形覆盖',
                    'Level Min Offset': '等级最小偏移',
                    'Level Max Offset': '等级最大偏移',
                    'Level Front Left': '前左等级',
                    'Level Front Right': '前右等级',
                    'Level Back Left': '后左等级',
                    'Level Back Right': '后右等级',
                    'Smooth Min Offset': '平滑最小偏移',
                    'Smooth Max Offset': '平滑最大偏移',
                    'Height Offset': '高度偏移',
                    'Additional Smooth Areas': '额外平滑区域',
                    'Dont Raise': '不提升',
                    'Dont Lower': '不降低',
                    'Prison': '监狱',
                    'Prison Van Capacity': '监狱车辆容量',
                    'Prisoner Capacity': '囚犯容量',
                    'Prisoner Wellbeing': '囚犯福祉',
                    'Prisoner Health': '囚犯健康',
                    'Local Effects': '局部影响',
                    'Type': '类型',
                    'Mode': '模式',
                    'Delta': '增量',
                    'Radius Combine Mode': '半径组合模式',
                    'Radius': '半径',
                    'Prefab Identifiers': '资产标识符',
                    'Power Plant': '发电厂',
                    'Electricity Production': '电力生产',
                    'Resource Consumer': '资源消耗',
                    'No Resource Notification Prefab': '无资源通知 资产',
                    'Storage Limit': '存储限制',

                    'Spawnable Building': '自长建筑',
                    'Zone Type': '区域类型',
                    'Level': '等级',
                    'Building Properties': '建筑属性',
                    'Residential Properties': '住宅属性',
                    'Allowed Sold': '允许销售',
                    'Allowed Manufactured': '允许制造',
                    'Allowed Stored': '允许存储',
                    'Space Multiplier': '空间倍增',
                    'NoResource': '无资源',
                    'Money': '金钱',
                    'Grain': '粮食',
                    'ConvenienceFood': '便利食品',
                    'Food': '食物',
                    'Vegetables': '蔬菜',
                    'Meals': '餐点',
                    'Wood': '木材',
                    'Timber': '木材',
                    'Paper': '纸张',
                    'Furniture': '家具',
                    'Vehicles': '车辆',
                    'Lodging': '住宿',
                    'UnsortedMail': '未分类邮件',
                    'LocalMail': '本地邮件',
                    'OutgoingMail': '外发邮件',
                    'Oil': '石油',
                    'Petrochemicals': '石化产品',
                    'Ore': '矿石',
                    'Plastics': '塑料',
                    'Metals': '金属',
                    'Electronics': '电子产品',
                    'Software': '软件',
                    'Coal': '煤炭',
                    'Stone': '石头',
                    'Livestock': '牲畜',
                    'Cotton': '棉花',
                    'Steel': '钢铁',
                    'Minerals': '矿物',
                    'Concrete': '混凝土',
                    'Machinery': '机械',
                    'Chemicals': '化学品',
                    'Pharmaceuticals': '药品',
                    'Beverages': '饮料',
                    'Textiles': '纺织品',
                    'Telecom': '电信',
                    'Financial': '金融',
                    'Media': '媒体',
                    'Entertainment': '娱乐',
                    'Recreation': '娱乐',
                    'Garbage': '垃圾',
                    'Count': '数量',
                    'Static Object Prefab': '静态对象资产',
                    'Tree Objec': '树木对象',
                    'Wood Amount': '木材数量',
                    'Standing Object': '站立对象',
                    'Leg Size': '根部尺寸',
                    'Circular Leg': '圆形根部',
                    'Sub Object Default Probability': '子对象默认概率',
                    'Default Probability': '默认概率',
                    'Rotation Symmetry': '旋转对称',
                    'Car Prefab': '汽车资产',
                    'Size Class': '尺寸类别',
                    'Energy Type': '能源类型',
                    'Max Speed': '最大速度',
                    'Acceleration': '加速度',
                    'Braking': '刹车',
                    'Turning': '转向',
                    'Stiffness': '刚度',
                    'Small': '小型',
                    'Medium': '中型',
                    'Large': '大型',
                    'Personal Car': '私家车',
                    'Passenger Capacity': '乘客容量',
                    'Baggage Capacity': '行李容量',
                    'Cost To Drive': '驾驶成本',
                    'Vehicle Side Effects': '车辆副作用',
                    'Road Wear': '路面磨损',
                    'Noise Pollution': '噪音污染',
                    'Air Pollution': '空气污染',
                    'Activity Location': '活动位置',
                    'Locations': '位置',
                    'Animated Prop Name': '动画道具名称',
                    'Require Authorization': '需要授权',
                    'Activity': '活动',
                    'Bench Sitting Location': '长椅坐着位置',
                    'Boarding Location': '上车位置',
                    'Disembarking Location': '下车位置',
                    'Driving Location': '驾驶位置',
                    'Entrance Location': '入口位置',
                    'Garage Spot Location': '车库停车位位置',
                    'Producing Location': '生产位置',
                    'PullUp Location': '停靠位置',
                    'Road Prefab': '道路资产',
                    'Sections': '区段',
                    'Node': '节点',
                    'Intersection': '交叉路口',
                    'DeadEnd': '死胡同',
                    'Crosswalk': '人行横道',
                    'BusStop': '公交车站',
                    'Median': '中央分隔带',
                    'TrainStop': '火车站',
                    'OppositeTrainStop': '对面火车站',
                    'Inverted': '倒置',
                    'TaxiStand': '出租车站',
                    'LevelCrossing': '道路平交道',
                    'Elevated': '高架',
                    'Tunnel': '隧道',
                    'Raised': '高起',
                    'Lowered': '下降',
                    'LowTransition': '低过渡',
                    'HighTransition': '高过渡',
                    'WideMedian': '宽中央分隔带',
                    'TramTrack': '有轨电车轨道',
                    'TramStop': '有轨电车站',
                    'OppositeTramTrack': '对面有轨电车轨道',
                    'OppositeTramStop': '对面有轨电车站',
                    'MedianBreak': '中央分隔带中断',
                    'ShipStop': '船只停靠点',
                    'Sidewalk': '人行道',
                    'Edge': '边缘',
                    'SubwayStop': '地铁站',
                    'OppositeSubwayStop': '对面地铁站',
                    'MiddlePlatform': '中间站台',
                    'Underground': '地下',
                    'Roundabout': '环形交叉口',
                    'OppositeSidewalk': '对面人行道',
                    'SoundBarrier': '隔音墙',
                    'Overhead': '架空',
                    'TrafficLights': '交通信号灯',
                    'PublicTransportLane': '公共交通车道',
                    'OppositePublicTransport': '对面公共交通',
                    'Spillway': '泄洪道',
                    'MiddleGrass': '中央草地',
                    'MiddleTrees': '中央树木',
                    'WideSidewalk': '宽人行道',
                    'SideGrass': '边缘草地',
                    'SideTrees': '边缘树木',
                    'OppositeGrass': '对面草地',
                    'OppositeTrees': '对面树木',
                    'Opening': '开口',
                    'Front': '前方',
                    'Back': '后方',
                    'Flipped': '翻转',
                    'RemoveTrafficLights': '移除交通信号灯',
                    'AllWayStop': '四路停车标志',
                    'Pavement': '人行道',
                    'Gravel': '碎石路',
                    'Tiles': '瓷砖',
                    'ForbidLeftTurn': '禁止左转',
                    'ForbidRightTurn': '禁止右转',
                    'OppositeWideSidewalk': '对面宽人行道',
                    'OppositeForbidLeftTurn': '对面禁止左转',
                    'OppositeForbidRightTurn': '对面禁止右转',
                    'OppositeSoundBarrier': '对面隔音墙',
                    'SidePlatform': '侧面站台',
                    'AddCrosswalk': '添加人行横道',
                    'RemoveCrosswalk': '移除人行横道',
                    'Lighting': '照明',
                    'OppositeBusStop': '对面公交站',
                    'OppositeTaxiStand': '对面出租车站',
                    'OppositeRaised': '对面高起',
                    'OppositeLowered': '对面下降',
                    'OppositeLowTransition': '对面低过渡',
                    'OppositeHighTransition': '对面高过渡',
                    'OppositeShipStop': '对面船只停靠点',
                    'OppositePlatform': '对面站台',
                    'OppositeAddCrosswalk': '对面添加人行横道',
                    'OppositeRemoveCrosswalk': '对面移除人行横道',
                    'Inside': '内部',
                    'ForbidStraight': '禁止直行',
                    'OppositeForbidStraight': '对面禁止直行',
                    'Require None': '需要 不存在:',
                    'Invert': '反转',
                    'Flip': '翻转',
                    'Median': '中央分隔带',
                    'Offset': '偏移',
                    'Set State': '设置状态',
                    'Match Type': '匹配类型',
                    'Both': '两者',
                    'Any': '任意',
                    'Exclusive': '唯一',
                    'Max Slope Steepness': '最大坡度陡峭程度',
                    'Aggregate Type': '聚合类型',
                    'Invert Mode': '反转模式',
                    'Road Type': '道路类型',
                    'Speed Limit': '速度限制',
                    'Zone Block': '区块',
                    'Traffic Lights': '交通信号灯',
                    'Highway Rules': '高速公路规则',
                    'InvertLefthandTraffic': '反转左侧交通',
                    'FlipLefthandTraffic': '翻转左侧交通',
                    'InvertRighthandTraffic': '反转右侧交通',
                    'FlipRighthandTraffic': '翻转右侧交通',
                    'KeepOriginal': '保留原始',
                    'Alley': '巷子',
                    'Bridge': '桥梁',
                    'Dam': '大坝',
                    'Golden Gate Bridge': '金门大桥',
                    'Grand Bridge': '大桥',
                    'Highway': '高速公路',
                    'Invisible Pathway': '隐形路径',
                    'Pathway': '小径',
                    'Public Transport Lane': '公共交通车道',
                    'Runway': '跑道',
                    'Seaway': '航道',
                    'Street': '街道',
                    'Subway Track': '地铁轨道',
                    'Taxiway': '滑行道',
                    'Train Track': '铁路',
                    'Tram Track': '有轨电车轨道',
                    'Placement': '放置',
                    'FixedIndex': '固定索引',
                    'Anchor Top': '锚定顶部',
                    'Anchor Center': '锚定中心',
                    'Require Elevated': '需要高架',
                    'Require Outside Connection': '需要市外连接',
                    'Require Dead End': '需要死胡同',
                    'Require Orphan': '需要孤立',
                    'Placeable Net': '可放置网络',
                    'Elevation Range': '高程范围',
                    'Allow Parallel Mode': '允许并列模式',
                    'Underground Prefab': '地下资产',
                    'Electricity Connection': '电力连接',
                    'Voltage': '电压',
                    'Direction': '方向',
                    'Low': '低',
                    'High': '高',
                    'Invalid': '无效',
                    'Select Nothing/Everything': '选择无/全部',
                    'Forward': '向前',
                    'Backward': '向后',
                    'Both': '两者',
                    'Water Pipe Connection': '水管连接',
                    'Fresh Capacity': '清水容量',
                    'Sewage Capacity': '污水容量',
                    'Storm Capacity': '雨水容量',
                    'Net Pollution': '道路污染',
                    'Noise Pollution Factor': '噪音污染因子',
                    'Air Pollution Factor': '空气污染因子',
                    'Underground Net Sections': '地下网络部分',
                    'Unlock On Build':'依赖建筑解锁',
                    'Deathcare Facility': '丧葬设施',
                    'Hearse Capacity': '救护车容量',
                    'Storage Capacity': '存储容量',
                    'Processing Rate': '处理速率',
                    'Long Term Storage': '长期存储',
                    'Workplace': '工作场所',
                    'Workplaces': '工作场所',
                    'Complexity': '复杂度',
                    'Evening Shift Probability': '晚班概率',
                    'Night Shift Probability': '夜班概率',
                    'Manual': '手动',
                    'Simple': '简单',
                    'Complex': '复杂',
                    'Hitech': '高科技',
                    'Commercial': '商业',
                    'Citylndoors': '城市室内',
                    'Travel': '旅行',
                    'CityPark': '城市公园',
                    'CityBeach': '城市海滩',
                    'Attractions': '景点',
                    'Relaxation': '放松',
                    'Sightseeing': '观光',
                    'Never': '从不',
                    'Unlocks': '解锁',
                    'Company Object': '公司对象',
                    'Select Company': '选择公司',
                    'Companies': '公司',
                    'Commercial_Bar': '商业_酒吧',
                    'Commercial_BookStore': '商业_书店',
                    'Commercial_ChemicalStore': '商业_化学品商店',
                    'Commercial_ConvenienceFoodStore': '商业_便利食品店',
                    'Commercial_DrugStore': '商业_药店',
                    'Commercial_ElectronicsStore': '商业_电子产品商店',
                    'Commercial_FashionStore': '商业_时装店',
                    'Commercial_FoodStore': '商业_食品商店',
                    'Commercial_FurnitureStore': '商业_家具商店',
                    'Commercial_GasStation': '商业_加油站',
                    'Commercial_Hotel': '商业_酒店',
                    'Commercial_LiquorStore': '商业_酒水店',
                    'Commercial_PlasticsStore': '商业_塑料制品商店',
                    'Commercial_RecreactionStore': '商业_娱乐用品店',
                    'Commercial_Restaurant': '商业_餐厅',
                    'Commercial_VehicleStore': '商业_车辆商店',
                    'Industrial_BeverageFromGrainFactory': '工业_谷物饮料工厂',
                    'Industrial_BeverageFromVegetablesFactory': '工业_蔬菜饮料工厂',
                    'Industrial_BioRefinery': '工业_生物炼制厂',
                    'Industrial_ChemicalFactory': '工业_化学品工厂',
                    'Industrial_CoalMine': '工业_煤矿',
                    'Industrial_ConcreteFactory': '工业_混凝土工厂',
                    'Industrial_ConvenienceFoodFromGrainFactory': '工业_便利食品(从谷物)工厂',
                    'Industrial_ConvenienceFoodFromLivestockFactory': '工业_便利食品(从牲畜)工厂',
                    'Industrial_CottonExtractor': '工业_棉花提取器',
                    'Industrial_ElectronicsFactory': '工业_电子产品工厂',
                    'Industrial_FoodFactory': '工业_食品工厂',
                    'Industrial_ForestryExtractor': '工业_林业提取器',
                    'Industrial_FurnitureFactory': '工业_家具工厂',
                    'Industrial_GrainExtractor': '工业_谷物提取器',
                    'Industrial_LivestockExtractor': '工业_牲畜提取器',
                    'Industrial_MachineryFactory': '工业_机械工厂',
                    'Industrial_MetalSmelter': '工业_金属冶炼厂',
                    'Industrial_MineralPlant': '工业_矿产加工厂',
                    'Industrial_OilExtractor': '工业_石油提取器',
                    'Industrial_OilRefinery': '工业_石油精炼厂',
                    'Industrial_OreExtractor': '工业_矿石提取器',
                    'Industrial_PaperMill': '工业_造纸厂',
                    'Industrial_PharmaceuticalsFactory': '工业_制药厂',
                    'Industrial_PlasticsFactory': '工业_塑料制品工厂',
                    'Industrial_SawMill': '工业_锯木厂',
                    'Industrial_SteelPlant': '工业_钢铁厂',
                    'Industrial_StoneQuarry': '工业_石材采石场',
                    'Industrial_TextileFromCottonFactory': '工业_纺织品(从棉花)工厂',
                    'Industrial_TextileFromLivestockFactory': '工业_纺织品(从牲畜)工厂',
                    'Industrial_TextileFromPetrochemicalsFactory': '工业_纺织品(从石油化工产品)工厂',
                    'Industrial_VegetableExtractor': '工业_蔬菜提取器',
                    'Industrial_VehicleFactory': '工业_车辆工厂',
                    'Industrial_WarehouseBeverages': '工业_饮料仓库',
                    'Industrial_WarehouseChemicals': '工业_化学品仓库',
                    'Industrial_WarehouseCoal': '工业_煤仓库',
                    'Industrial_WarehouseConcrete': '工业_混凝土仓库',
                    'Industrial_WarehouseConvenienceFood': '工业_便利食品仓库',
                    'Industrial_WarehouseCotton': '工业_棉花仓库',
                    'Industrial_WarehouseElectronics': '工业_电子产品仓库',
                    'Industrial_WarehouseFood': '工业_食品仓库',
                    'Industrial_WarehouseFurniture': '工业_家具仓库',
                    'Industrial_WarehouseGrain': '工业_谷物仓库',
                    'Industrial_WarehouseLivestock': '工业_牲畜仓库',
                    'Industrial_WarehouseMachinery': '工业_机械仓库',
                    'Industrial_WarehouseMetals': '工业_金属仓库',
                    'Industrial_WarehouseMinerals': '工业_矿产仓库',
                    'Industrial_WarehouseOil': '工业_石油仓库',
                    'Industrial_WarehouseOre': '工业_矿石仓库',
                    'Industrial_WarehousePaper': '工业_纸张仓库',
                    'Industrial_WarehousePetrochemicals': '工业_石化产品仓库',
                    'Industrial_WarehousePharmaceuticals': '工业_制药产品仓库',
                    'Industrial_WarehousePlastics': '工业_塑料仓库',
                    'Industrial_WarehouseSteel': '工业_钢铁仓库',
                    'Industrial_WarehouseStone': '工业_石材仓库',
                    'Industrial_WarehouseTextiles': '工业_纺织品仓库',
                    'Industrial_WarehouseTimber': '工业_木材仓库',
                    'Industrial_WarehouseVegetables': '工业_蔬菜仓库',
                    'Industrial_WarehouseVehicles': '工业_车辆仓库',
                    'Industrial_WarehouseWood': '工业_木材仓库',
                    'Office_Bank': '办公_银行',
                    'Office_MediaCompany': '办公_传媒公司',
                    'Office_SoftwareCompany': '办公_软件公司',
                    'Office_TelecomCompany': '办公_电信公司',
                    'Fire Station': '消防站',
                    'Fire Engine Capacity': '消防车辆容量',
                    'Fire Helicopter Capacity': '消防直升机容量',
                    'Disaster Response Capacity': '灾害响应容量',
                    'Vehicle Efficiency': '车辆效率',
                    'Transformer': '变压器',
                    'Solar Powered': '太阳能供电',
                    'Production': '生产',
                    'Battery': '电池',
                    'Power Output': '功率输出',
                    'Water Pumping Station': '水泵站',
                    'Purification': '净化',
                    'Allowed Water Types': '允许的水类型',
                    'Groundwater': '地下水',
                    'SurfaceWater': '地表水',
                    'Shoreline Object': '岸线物体',
                    'Shoreline Offset': '岸线偏移',
                    'Allow Dryland': '允许干地',
                    'Service Upgrade': '服务升级',
                    'Buildings': '建筑物',
                    'Upgrade Cost': '升级成本',
                    'Max Placement Offset': '最大放置偏移',
                    'Public Transport': '公共交通',
                    'Transport Type': '运输类型',
                    'Purposes': '用途',
                    'Maintenance Range': '维护范围',
                    'Bus': '公共汽车',
                    'Train': '火车',
                    'Taxi': '出租车',
                    'Tram': '有轨电车',
                    'Ship': '船',
                    'Helicopter': '直升飞机',
                    'Airplane': '飞机',
                    'Subway': '地铁',
                    'Rocket': '火箭',
                    'TransportLine': '运输线路',
                    'Evacuation': '疏散',
                    'PrisonerTransport': '囚犯运输',
                    'Other': '其他',
                    'Gender': '性别',
                    'Move Speed': '移动速度',
                    'Domesticated': '驯化',
                    'Idle Time': '空闲时间',
                    'Min Group Member Count': '最小组成员数',
                    'Max Group Member Count': '最大组成员数',
                    'Spawnable Object': '可生成对象',
                    'Placeholders': '占位符',
                    'Randomization Group': '随机化组',
                    'Selected Sound': '选择声音',
                    'Bear Species': '熊种',
                    'Chicken Species': '鸡种',
                    'Cow Species': '牛种',
                    'Deer Species': '鹿种',
                    'Dolphin Species': '海豚种',
                    'Eagle Species': '鹰种',
                    'Goose Species': '鹅种',
                    'Horse Species': '马种',
                    'Moose Species': '驼鹿种',
                    'PergolaStyle01': '凉亭风格01',
                    'Pig Species': '猪种',
                    'Seagull Species': '海鸥种',
                    'Shark Species': '鲨鱼种',
                    'Sheep Species': '绵羊种',
                    'Sidewalk Prop Group': '人行道道具组',
                    'Marker Object Prefab': '标记对象资产',
                    'Creature Spawner': '生物生成器',
                    'Max Group Count': '最大组数',
                    'Spawn Location': '生成位置',
                    'Connection Type': '连接类型',
                    'Track Types': '轨道类型',
                    'Road Types': '道路类型',
                    'Road': '道路',
                    'Pedestrian': '行人',
                    'Cargo': '货物',
                    'Air': '空中',
                    'Parking': '停车',
                    'Train': '火车',
                    'Tram': '有轨电车',
                    'Subway': '地铁',
                    'Car': '汽车',
                    'Watercraft': '水上交通工具',
                    'Helicopter': '直升飞机',
                    'Airplane': '飞机',
                    'Editor Asset Category Override': '编辑器资产类别覆盖',
                    'Include Categories': '包括类别',
                    'Exclude Categories': '排除类别',
                    'Attached Object': '附加对象',
                    'Attach Type': '附加类型',
                    'Attach Offset': '附加偏移',
                    'Animation Index': '动画索引',
                    'Street Light Object': '路灯对象',
                    'PDXAccount':'p社账号',
                    'BeachProperties':'海滩DLC',
                    'Localization': '本地化',
                    'Objects': '对象',
                    'Policies': '政策',
                    'Prefabs': '资产',
                    'Routes': '路线',
                    'Themes': '主题',
                    'Tools': '工具',
                    'UI': '用户界面',
                    'Achievement Filter': '成就过滤器',
                    'Object Achievement Component': '对象成就组件',
                    'Building Efficiency': '建筑效率',
                    'City Effects': '城市效应',
                    'CityServices': '城市服务',
                    'Extractor Facility': '提取设施',
                    'Initial Resources': '初始资源',
                    'Placeholder Building': '占位建筑',
                    'Pollution Modifier': '污染修正器',
                    'Resource Consumption': '资源消耗',
                    'Resource Producer': '资源生产者',
                    'Signature Building': '标志性建筑',
                    'Localization': '本地化',
                    'Random Gendered Localization': '随机性别本地化',
                    'Random Localization': '随机本地化',
                    'Brand Object': '品牌对象',
                    'Crane Object': '起重机对象',
                    'Destructible Object': '可摧毁对象',
                    'Electricity Outside Connection': '电力外部连接',
                    'Floating Object': '漂浮物体',
                    'Hovering Object': '悬浮物体',
                    'Lane Block': '车道阻塞',
                    'Lane Direction Object': '车道方向对象',
                    'Net Object': '网络对象',
                    'Outside Connection': '外部连接',
                    'Pillar Object': '柱状物体',
                    'Placeholder Object': '占位对象',
                    'Plant Object': '植物对象',
                    'Quantity Object': '数量对象',
                    'Renter Object': '租户对象',
                    'Spawnable Brand Dummy': '可生成品牌虚拟',
                    'Traffic Light Object': '交通灯对象',
                    'Traffic Sign Object': '交通标志对象',
                    'Tree Object': '树木对象',
                    'Underwater Object': '水下对象',
                    'Unique Object': '独特对象',
                    'Utility Object': '实用对象',
                    'Water Pipe Outside Connection': '水管外部连接',
                    'Water Source': '水源',
                    'Weather Object': '天气对象',
                    'Default Policies': '默认政策',
                    'Content': '内容',
                    'To Be Removed': '待删除',
                    'Unlocking': '解锁',
                    'Mail Box': '邮箱',
                    'Transport Stop': '交通站',
                    'Theme Object': '主题对象',
                    'Editor Container': '编辑器容器',
                    'Valid For': '有效',
                    'Not Valid For': '无效',
                    'Relative': '相对',
                    'Absolute': '绝对',
                    'InverseRelative': '反向相对',
                    'CrimeAccumulation': '犯罪累积',
                    'DisasterWarningTime': '灾害警告时间',
                    'DisasterDamageRate': '灾害伤害率',
                    'DiseaseProbability': '疾病概率',
                    'ParkEntertainment': '公园娱乐',
                    'CriminalMonitorProbability': '犯罪监视概率',
                    'IndustrialAirPollution': '工业空气污染',
                    'IndustrialGroundPollution': '工业地面污染',
                    'IndustrialGarbage': '工业垃圾',
                    'RecoveryFailChange': '恢复失败机率',
                    'OreResourceAmount': '矿石资源量',
                    'OilResourceAmount': '石油资源量',
                    'UniversityInterest': '大学兴趣',
                    'OfficeSoftwareDemand': '办公软件需求',
                    'IndustrialElectronicsDemand': '工业电子产品需求',
                    'OfficeSoftwareEfficiency': '办公软件效率',
                    'IndustrialElectronicsEfficiency': '工业电子产品效率',
                    'TelecomCapacity': '电信容量',
                    'HighwayTrafficSafety': '高速公路交通安全',
                    'PrisonTime': '监狱时间',
                    'CrimeProbability': '犯罪概率',
                    'CollegeGraduation': '大专毕业率',
                    'UniversityGraduation': '大学毕业率',
                    'ImportCost': '进口成本',
                    'LoanInterest': '贷款利率',
                    'BuildingLevelingCost': '建筑拆除成本',
                    'ExportCost': '出口成本',
                    'TaxiStartingFee': '出租车起步费',
                    'IndustrialEfficiency': '工业效率',
                    'OfficeEfficiency': '办公效率',
                    'PollutionHealthAffect': '污染对健康的影响',
                    'HospitalEfficiency': '医院效率',
                    'Administration Building': '行政大楼',
                    'Cargo Transport Station': '货物运输站',
                    'Disaster Facility': '灾害设施',
                    'Early Disaster Warning Syst': '早期灾害预警系统',
                    'Emergency Generator': '应急发电机',
                    'Emergency Shelter': '应急避难所',
                    'Firewatch Tower': '火灾监控塔',
                    'Garbage Facility': '垃圾处理设施',
                    'Garbage Powered': '垃圾发电',
                    'Ground Water Powered': '地下水发电',
                    'Hospital': '医院',
                    'Maintenance Depot': '维修车间',
                    'Parking Facility': '停车设施',
                    'Police Station': '警察局',
                    'Post Facility': '邮局',
                    'Research Facility': '研究设施',
                    'Sewage Outlet': '污水排放口',
                    'Telecom Facility': '电信设施',
                    'Traffic Spawner': '交通生成器',
                    'Transport Depot': '运输车间',
                    'Water Powered': '水力发电',
                    'Water Tower': '水塔',
                    'Welfare Office': '社会保障局',
                    'Wind Powered': '风力发电',
                    'Traded Resources': '交易资源',
                    'Transports': '运输',
                    'Loading Factor': '装载系数',
                    'Transport Interval': '运输间隔',
                    'Activation Threshold': '激活阈值',
                    'Shelter Capacity': '庇护所容量',
                    'Vehicle Capacity': '车辆容量',
                    'Garbage Capacity': '垃圾容量',
                    'Transport Capacity': '运输容量',
                    'Processing Speed': '处理速度',
                    'Industrial Waste Only': '仅限工业废物',
                    'Production Per Unit': '每单位生产',
                    'Maximum Ground Water': '最大地下水',
                    'Ambulance Capacity': '救护车容量',
                    'Medical Helicopter Capacity': '医疗直升机容量',
                    'Patient Capacity': '病人容量',
                    'Treatment Bonus': '治疗奖励',
                    'Health Range': '健康范围',
                    'Treat Diseases': '治疗疾病',
                    'Treat Injuries': '治疗伤害',
                    'Maintenance Type': '维护类型',
                    'Garage Marker Capacity': '车库标记容量',
                    'Patrol Car Capacity': '巡逻车容量',
                    'Police Helicopter Capacity': '警用直升机容量',
                    'Jail Capacity': '监狱容量',
                    'Patrol': '巡逻',
                    'Emergency': '应急',
                    'Intelligence': '情报',
                    'Post Van Capacity': '邮政面包车容量',
                    'Post Truck Capacity': '邮政卡车容量',
                    'Mail Storage Capacity': '邮件存储容量',
                    'Mail Box Capacity': '邮箱容量',
                    'Sorting Rate': '分拣速率',
                    'Allow Submerged': '允许水下',
                    'Network Capacity': '网络容量',
                    'Penetrate Terrain': '穿透地形',
                    'Track Type': '轨道类型',
                    'Spawn Rate': '生成速率',
                    'No Slow Vehicles': '无缓慢车辆',
                    'Energy Types': '能源类型',
                    'Vehicle Capacity': '车辆容量',
                    'Production Duration': '生产持续时间',
                    'Maintenance Duration': '维护持续时间',
                    'Dispatch Center': '调度中心',
                    'Production Factor': '生产因子',
                    'Capacity Factor': '容量因子',
                    'Maximum Wind': '最大风速',
                    'Rotation Range': '旋转范围',
                    'Initial Resources': '初始资源',
                    'Value': '价值',
                    'Building Type': '建筑类型',
                    'Hospital': '医院',
                    'PowerPlant': '发电厂',
                    'FreshWaterBuilding': '污水处理厂',
                    'SewageBuilding': '污水处理厂',
                    'StormWaterBuilding': '雨水处理厂',
                    'TransportDepot': '交通仓库',
                    'TransportStation': '交通站点',
                    'GarbageFacility': '垃圾处理设施',
                    'FireStation': '消防站',
                    'PoliceStation': '警察局',
                    'RoadMaintenanceDepot': '道路维护仓库',
                    'PostFacility': '邮政设施',
                    'TelecomFacility': '电信设施',
                    'EmergencyShelter': '紧急避难所',
                    'DisasterFacility': '灾难设施',
                    'FirewatchTower': '防火观察塔',
                    'DeathcareFacility': '死亡护理设施',
                    'AdminBuilding': '行政建筑',
                    'WelfareOffice': '社会保障局',
                    'ResearchFacility': '研究设施',
                    'ParkMaintenanceDepot': '公园维护仓库',
                    'ParkingFacility': '停车设施',
                    'ResidentialBuilding': '住宅建筑',
                    'CommercialBuilding': '商业建筑',
                    'IndustrialBuilding': '工业建筑',
                    'OfficeBuilding': '办公楼',
                    'SignatureResidential': '标志性住宅',
                    'ExtractorBuilding': '采集器建筑',
                    'SignatureCommercial': '标志性商业',
                    'SignatureIndustrial': '标志性工业',
                    'SignatureOffice': '标志性办公',
                    'LandValueSources': '土地价值来源',
                    'EUCommercialHigh': '欧洲高级商业',
                    'EUCommercialLow': '欧洲低级商业',
                    'EUResidentialHigh': '欧洲高级住宅',
                    'EUResidentialLow': '欧洲低级住宅',
                    'EUResidentialLowWaterfront': '欧洲低级住宅（水边）',
                    'EUResidentialMedium': '欧洲中级住宅',
                    'EUResidentialMediumRow': '欧洲中级住宅（排屋）',
                    'EUResidentialMixed': '欧洲混合住宅',
                    'IndustrialAgriculture': '工业农业',
                    'IndustrialForestry': '工业林业',
                    'IndustrialManufacturing': '工业制造',
                    'IndustrialOil': '工业石油',
                    'IndustrialOre': '工业矿石',
                    'NACommercialHigh': '北美高级商业',
                    'NACommercialLow': '北美低级商业',
                    'NAResidentialHigh': '北美高级住宅',
                    'NAResidentialLow': '北美低级住宅',
                    'NAResidentialLowWaterfront': '北美低级住宅（水边）',
                    'NAResidentialMedium': '北美中级住宅',
                    'NAResidentialMediumRow': '北美中级住宅（排屋）',
                    'NAResidentialMixed': '北美混合住宅',
                    'OfficeHigh': '高级办公楼',
                    'OfficeLow': '低级办公楼',
                    'ResidentialLowRent': '住宅低租金',
                    'Unzoned': '未划分区域',
                    'GroundPollutionMultiplier': '地面污染乘数',
                    'AirPollutionMultiplier': '空气污染乘数',
                    'NoisePollutionMultiplier': '噪音污染乘数',
                    'Consumptions': '消耗量',
                    'Consumption': '消耗',
                    'ProductionRate': '生产速率',
                    'UnlockEventImage': '解锁事件图片',
                    'LocalizationID': '本地化ID',
                    'MaleID': '男性ID',
                    'FemaleID': '女性ID',
                    'Brand': '品牌',
                    'DistanceRange': '距离范围',
                    'FireHazard': '火灾危险',
                    'StructuralIntegrity': '结构完整性',
                    'FloatingOffset': '浮动偏移',
                    'FixedToBottom': '固定在底部',
                    'HoveringHeight': '悬浮高度',
                    'Left': '左',
                    'Right': '右',
                    'Straight': '直线',
                    'Merge': '合并',
                    'Gentle': '缓和',
                    'Square': '正方形',
                    'UTurn': 'U型转弯',
                    'SetCompositionState': '设置组成状态',
                    'RequireRoad': '需要道路',
                    'TrackPassThrough': '轨道穿越',
                    'TradedResources': '交易资源',
                    'Commuting': '通勤',
                    'TransferType': '转移类型',
                    'Remoteness': '偏远度',
                    'VerticalPillarOffsetRange': '垂直柱偏移范围',
                    'Vertical': '垂直',
                    'Horizontal': '水平',
                    'Standalone': '独立',
                    'Base': '基础',
                    'RandomizeGroupIndex': '随机化组索引',
                    'MapFeature': '地图特征',
                    'Area': '区域',
                    'BuildableLand': '可建造土地',
                    'FertileLand': '肥沃土地',
                    'Forest': '森林',
                    'GroundWater': '地下水',
                    'RequireEmpty': '需要空地',
                    'RequireRenter': '需要租户',
                    'RequireGoodWealth': '需要良好财富',
                    'RequireDogs': '需要狗',
                    'RequireHomeless': '需要无家可归者',
                    'RequireChildren': '需要儿童',
                    'RequireTeens': '需要青少年',
                    'VehicleLeft': '左侧车辆',
                    'VehicleRight': '右侧车辆',
                    'CrossingLeft': '左侧人行横道',
                    'CrossingRight': '右侧人行横道',
                    'AllowFlipped': '允许翻转',
                    'ReachOffset': '达到偏移',
                    'Stop': '停止',
                    'Yield': '让行',
                    'NoTurnLeft': '禁止左转',
                    'NoTurnRight': '禁止右转',
                    'NoUTurnLeft': '禁止左转弯',
                    'NoUTurnRight': '禁止右转弯',
                    'DoNotEnter': '禁止通行',
                    'Motorway': '高速公路',
                    'Oneway': '单行道',
                    'SpeedLimit': '速度限制',
                    'BusOnly': '仅公交',
                    'TaxiOnly': '仅出租车',
                    'RoundaboutCounterclockwise': '逆时针环岛',
                    'RoundaboutClockwise': '顺时针环岛',
                    'UtilityType': '公用事业类型',
                    'UtilityPosition': '公用事业位置',
                    'WaterPipe': '给水管道',
                    'SewagePipe': '污水管道',
                    'StormwaterPipe': '雨水管道',
                    'LowVoltageLine': '低电压线路',
                    'Fence': '围栏',
                    'Catenary': '接触网',
                    'HighVoltageLine': '高电压线路',
                    'Polluted': '受污染的',
                    'RequireSnow': '需要雪',
                    'ForbidSnow': '禁止雪',
                    'LandmarkBuildings': '地标建筑',
                    'SanFranciscoSet': '旧金山套装',
                    'ReplaceWith': '替换为',
                    'MailCapacity': '邮件容量',
                    'AccessConnectionType': '接入连接类型',
                    'RouteConnectionType': '路线连接类型',
                    'AccessTrackType': '接入轨道类型',
                    'RouteTrackType': '路线轨道类型',
                    'AccessRoadType': '接入道路类型',
                    'RouteRoadType': '路线道路类型',
                    'EnterDistance': '进入距离',
                    'ExitDistance': '退出距离',
                    'AccessDistance': '接入距离',
                    'BoardingTime': '上车时间',
                    'LoadingFactor': '装载因子',
                    'PassengerTransport': '乘客运输',
                    'CargoTransport': '货物运输',
                    'Theme': '主题',
                    'Achievements':'成就',
                    'Early Disaster Warning System':'灾害预警系统',
                    'Modifiers': '修改器',
                    'Multiplier': '倍增器',
                    'Upkeep Modifier': '维护费修改器',
                    'Section': '部分',
                    'Edge States': '边缘状态',
                    'Node States': '节点状态',
                    'Net Sub Objects': '网络子对象',
                    'Net Upgrade': '网络升级',
                    'Overhead Net Sections': '高架网络部分',
                    'Fixed Index': '固定索引',
                    'Net': '网络',
                    'Unset State': '未设置状态',
                    'Ambulance': '救护车',
                    'Car Tractor': '车载拖拉机',
                    'Cargo Transport': '货物运输',
                    'Delivery Truck': '送货卡车',
                    'Fire Engine': '消防车',
                    'Garbage Truck': '垃圾车',
                    'Hearse': '灵车',
                    'Maintenance Vehicle': '维修车辆',
                    'Police Car': '警车',
                    'Post Van': '邮政货车',
                    'Work Vehicle': '工作车辆',
                    'Cargo Capacity': '货物容量',
                    'Max Resource Count': '最大资源数量',
                    'Transported Resources': '运输资源',
                    'Trailer Type': '拖车类型',
                    'Fixed Trailer': '固定拖车',
                    'Towbar': '拖车连接器',
                    'Semi': '半挂车',
                    'Fixed': '固定',
                    'Extinguishing Rate': '灭火速率',
                    'Extinguishing Spread': '灭火传播',
                    'Extinguishing Capacity': '灭火容量',
                    'Destroyed Clear Duration': '清除被毁持续时间',
                    'Unload Rate': '卸货速率',
                    'Maintenance Capacity': '维护容量',
                    'Maintenance Rate': '维护速率',
                    'Criminal Capacity': '罪犯容量',
                    'Crime Reduction Rate': '犯罪减少率',
                    'Shift Duration': '换班持续时间',
                    'Mail Capacity': '邮件容量',
                    'Work Type': '工作类型',
                    'Map Feature': '地图特征',
                    'Max Work Amount': '最大工作量',
                    'Lot Prefab': '地块预制体',
                    'Color': '颜色',
                    'Edge Color': '边缘颜色',
                    'Selection Color': '选中颜色',
                    'Selection Edge Color': '选中边缘颜色',
                    'Max Radius': '最大半径',
                    'Range Color': '范围颜色',
                    'Area Sub Objects': '区域子对象',
                    'Enclosed Area': '封闭区域',
                    'Extractor Area': '提取区域',
                    'Hangaround Area': '闲逛区域',
                    'Master Area': '主区域',
                    'Navigation Area': '导航区域',
                    'Placeholder Area': '占位符区域',
                    'Rendered Area': '渲染区域',
                    'Spawnable Area': '可生成区域',
                    'Storage Area': '存储区域',
                    'Terrain Area': '地形区域',
                    'Border Lane Type': '边界车道类型',
                    'Counter Clock Wise': '逆时针',
                    'Map Feature': '地图特征',
                    'Activities': '活动',
                    'Slave Areas': '从区域',
                    'Secondary Type': '次要类型',
                    'Roundness': '圆滑度',
                    'Lod Bias': 'LOD偏差',
                    'Renderer Priority': '渲染器优先级',
                    'Decal Layer Mask': '贴花层遮罩',
                    'Terrain': '地形',
                    'Creatures': '生物',
                    'Stored Resources': '存储资源',
                    'Slope Width': '坡宽',
                    'Noise Scale': '噪声比例',
                    'Noise Factor': '噪声因子',
                    'Surface Prefab': '表面预制体',
                    'Vertical Pillar Offset Range': '垂直柱偏移范围',
                    'Content Prerequisite': '内容先决条件',
                    'Manual Unlockable': '手动可解锁',
                    'Walk Speed': '步行速度',
                    'Run Speed': '奔跑速度',
                    'Creatures': '生物',
                    'Resident': '居民',
                    'Age': '年龄',
                    'Width': '宽度',
                    'Depth': '深度',
                    'Up Keep Cost': '维护成本',
                    'Asset Stamp Prefab': '资产图章预制体',
                    'Layer': '图层',
                    'Default': '默认',
                    'Fence Prefab': '栅栏预制体',
                    'Ground Max Speed': '地面最大速度',
                    'Ground Acceleration': '地面加速度',
                    'Ground Braking': '地面制动',
                    'Ground Turning': '地面转向',
                    'Flying Speed': '飞行速度',
                    'Flying Acceleration': '飞行加速度',
                    'Flying Braking': '飞行制动',
                    'Flying Turning': '飞行转向',
                    'Flying Angular Acceleration': '飞行角加速度',
                    'Climb Angle': '攀爬角度',
                    'Slow Pitch Angle': '缓慢俯仰角',
                    'Turning Roll Factor': '转向滚动系数',
                    'Airplane Prefab': '飞机预制体',
                    'Train Car Prefab': '火车车厢预制体',
                    'Bogie Offset': '转向架偏移',
                    'Angular Acceleration': '角加速度',
                    'Watercraft Prefab': '水上交通工具预制体',
                    'Multiple Unit Train Car Prefab': '多节火车车厢预制体',
                    'Min Multiple Unit Count': '最小多节车辆数量',
                    'Max Multiple Unit Count': '最大多节车辆数量',
                    'Carriages': '车厢',
                    'Carriage': '车厢',
                    'Min Count': '最小数量',
                    'Max Count': '最大数量',
                    'Add Reversed End Carriage': '添加反向尾部车厢',
                    'Car Trailer Prefab': '汽车拖车预制体',
                    'Work Vehicle': '工作车辆',
                    'Object Mesh Info': '物体网格信息',
                    'Render Prefab': '渲染预制体',
                    'Color Properties': '颜色属性',
                    'Color Variations': '颜色变化',
                    'Channels Binding': '通道绑定',
                    'Variation Groups': '变体组',
                    'Variation Ranges': '变体范围',
                    'Alpha Ranges': 'Alpha 范围',
                    'External Color Source': '外部颜色来源',
                    'Colors': '颜色',
                    'Variation Group': '变体组',
                    'Channel Id': '通道标识',
                    'Can Be Modified By External': '可由外部修改',
                    'Emissive Properties': '发光属性',
                    'Single Lights': '单个灯光',
                    'Multi Lights': '多个灯光',
                    'Signal Group Animations': '信号组动画',
                    'Purpose': '目的',
                    'Color': '颜色',
                    'Color Off': '关闭时颜色',
                    'Luminance': '亮度',
                    'Response Time': '响应时间',
                    'Materialld': '材料 ID',
                    'Base Properties': '基本属性',
                    'Base Type': '基本类型',
                    'Use Min Bounds': '使用最小边界',
                    'Latitude': '纬度',
                    'Longitude': '经度',
                    'FreezingTemperature': '冰点温度',
                    'DefaultWeather': '默认天气',
                    'DefaultWeathers': '默认天气',
                    'Seasons': '季节',
                    'Prefab': '预制体',
                    'Name ID': '名称 ID',
                    'Icon Path': '图标路径',
                    'Start Time': '开始时间',
                    'Temp Night Day': '夜间白天温度',
                    'Temp Deviation Night Day': '夜间白天温度偏差',
                    'Cloud Chance': '云量几率',
                    'Cloud Amount': '云量',
                    'Cloud Amount Deviation': '云量偏差',
                    'Precipitation Chance': '降水几率',
                    'Precipitation Amount': '降水量',
                    'Precipitation Amount Deviation': '降水量偏差',
                    'Turbulence': '湍流',
                    'Aurora Amount': '极光数量',
                    'Aurora Chance': '极光几率',
                    'Edit Climate': '编辑气候',
                    'Load climate prefab…': '加载气候预制体...'
                    
                },




                编辑器.通用inc,{
                    'Element ':'元素',
                    'EU_ChimneyStyle0': '欧洲烟囱风格0',
                    'EU_FenceResidentialPieceStyle0': '欧洲住宅围栏块风格0',
                    'EU_WallPylonStyle0': '欧洲墙体支架风格0',
                    'EU_WindowGuardRailingStyle0': '欧洲窗户护栏风格0',
                    'EU_WindowHatchStyle0': '欧洲窗户舱口风格0',
                    'EU_WindowOrnamentStyle0': '欧洲窗户装饰风格0',
                    'FencelndustrialHighStyle0': '工业围栏高风格0',
                    'FencelndustrialLowStyle0': '工业围栏低风格0',
                    'FenceResidentialHighStyle0': '住宅围栏高风格0',
                    'FenceResidentialLowStyle0': '住宅围栏低风格0',
                    'FireEscapeStyle0': '消防逃生梯风格0',
                    'GymParkStyle0': '健身公园风格0',
                    'LadderStyle0': '梯子风格0',
                    'LightpoleParkStyle0': '公园路灯风格0',
                    'LogPileStyle0': '圆木堆风格0',
                    'NA_ChimneyResidentialStyle0': '北美住宅烟囱风格0',
                    'NA_FenceResidentialPieceStyle0': '北美住宅围栏块风格0',
                    'NA_WindowHatchStyle0': '北美窗户舱口风格0',
                    'OutdoorSofaStyle0': '户外沙发风格0',
                    'PergolaStyle0': '凉亭风格0',
                    'SkateParkStyle0': '滑板公园风格0',
                    'SportParkStyle0': '体育公园风格0',
                    'StaircaseSpiralStyle0': '螺旋楼梯风格0',
                    'StreetLightStyle0': '路灯风格0',
                    'TableSetCommercialStyle0': '商业桌椅组风格0',
                    'TableSetStyle0': '桌椅组风格0',
                    'TennisCourtStyle0': '网球场风格0',
                    'VentilationDuctStyle0': '通风管道风格0'
                },
                [rif({func:[(i)=>{i.style.display = 'none'}]}).class('beta-banner_qiZ')],{
                    '包含地图创建工具的Beta版本编辑器':''
                }
            ),



        }
        for (const [ObjName, ObjReItems] of Object.entries(REPLACE_ITEM_NEW)) {
            for (const [ReFunc, ReStrs] of ObjReItems) {
                ReFunc.forEach(func => func.REPLACE(ReStrs))
            }
        }
        

        

    } catch (err) { addinfo += err ; console.log(err)}
    let time2 = new Date().getTime()
    if (window.__LOGGING__ && document.getElementsByClassName('fps-display_t30').length) {
        if (!document.getElementById('I18loginfo')) {
            let targetDiv = document.getElementsByClassName('fps-display_t30')[0]
            let infoDiv = document.createElement("div")
            infoDiv.innerHTML = `全局汉化: ${window.__LOGGING__} 段字符 , 耗时 ${time2 - time1} ms`
            infoDiv.id = 'I18loginfo'
            infoDiv.style.fontFamily = "Noto Sans SC"
            infoDiv.style.justifyContent = 'flex-end'
            targetDiv.appendChild(infoDiv);
        } else {
            document.getElementById('I18loginfo').innerHTML = `全局汉化: ${window.__LOGGING__} 段字符 , 耗时 ${time2 - time1} ms`

        }
    }
    try{
    if(rif().class('header_IuN.header_Bpo.child-opacity-transition_nkS').class('title-bar_PF4').items.length){
        let E = rif().class('header_IuN.header_Bpo.child-opacity-transition_nkS').class('title-bar_PF4').items[0]
        let child = E.children[4]
        E.removeChild(child)
        }
    }catch{}

}


setInterval(replaceContent, 135);

const testi18 = async (Func) => {
    function delay(ms) { return new Promise(resolve => setTimeout(resolve, ms)); }
    let clearTime = 0
    while (clearTime < 20) {
        await delay(200)
        try {
            Func()
        } catch { }
        clearTime +=1
    }
}
//REPLACE_ITEMS_END//
var e={611:(e,t,n)=>{var r;r=function(e,t,n){"use strict";var r=function(){this.events={}},i=function(e,t){this.code=e,this.context=t},o=void 0!==t;if((t=t||{})._Initialized)return t;var a=[2,0,2,0];for(var s in r.prototype._createClear=function(e,n,r,i){return function(){var o=e.events[n];if(o){var a=-1;if(void 0===r){for(var s=0;s<o.length;++s)if(void 0!==o[s].wasInCPP){a=s;break}}else a=o.indexOf(r);-1!=a&&(o.splice(a,1),0===o.length&&delete e.events[n])}else void 0!==t.RemoveOnHandler&&t.RemoveOnHandler(n,r,i||t)}},r.prototype.on=function(e,t,n){var r=this.events[e];void 0===r&&(r=this.events[e]=[]);var o=new i(t,n||this);return r.push(o),{clear:this._createClear(this,e,o,n)}},r.prototype.off=function(e,n,r){var i=this.events[e];if(void 0!==i){var o;r=r||this;var a=i.length;for(o=0;o<a;++o){var s=i[o];if(s.code==n&&s.context==r)break}o<a&&(i.splice(o,1),0===i.length&&delete this.events[e])}else t.RemoveOnHandler(e,n,r||this)},r.prototype.trigger=function(e){var t=this.events[e];if(void 0!==t){var n=Array.prototype.slice.call(arguments,1);return t.forEach((function(e){e.code.apply(e.context,n)})),!0}return!1},t.isAttached=o,t.isAttached||(r.prototype.on=function(e,t,n){var r=this.events[e];this.browserCallbackOn&&this.browserCallbackOn(e,t,n),void 0===r&&(r=this.events[e]=[]);var o=new i(t,n||this);return r.push(o),{clear:this._createClear(this,e,o)}},r.prototype.off=function(e,t,n){var r=this.events[e];if(void 0!==r){var i;n=n||this;var o=r.length;for(i=0;i<o;++i){var a=r[i];if(a.code==t&&a.context==n)break}i<o&&(r.splice(i,1),0===r.length&&(delete this.events[e],this.browserCallbackOff&&this.browserCallbackOff(e,t,n)))}},t.SendMessage=function(e,n){var r=Array.prototype.slice.call(arguments,2),i=t._ActiveRequests[n];delete t._ActiveRequests[n],window.setTimeout((function(){var n=t._mocks[e];void 0!==n&&i.resolve(n.apply(t,r))}),16)},t.TriggerEvent=function(){var e=Array.prototype.slice.call(arguments);return window.setTimeout((function(){var n=t._mocks[e[0]];void 0!==n&&n.apply(t,e.slice(1))}),16),void 0!==t._mocks[e[0]]},t.BindingsReady=function(){t._OnReady()},t.createJSModel=function(t,n){e[t]=n},t.updateWholeModel=function(){},t.synchronizeModels=function(){},t.enableImmediateLayout=function(){},t.isImmediateLayoutEnabled=function(){return!0},t.executeImmediateLayoutSync=function(){},t._mocks={},t._mockImpl=function(e,t,n,r){t&&(this._mocks[e]=t);var i=t.toString().replace("function "+t.name+"(",""),o=i.indexOf(")"),a=i.substr(0,o);this.browserCallbackMock&&this.browserCallbackMock(e,a,n,Boolean(r))},t.mock=function(e,t,n){this._mockImpl(e,t,!0,n)}),t.events={},r.prototype)t[s]=r.prototype[s];return t.isAttached&&(t.on=function(e,n,r){return n?(t.AddOrRemoveOnHandler(e,n,r||t),{clear:this._createClear(this,e,n,r)}):(console.error("No handler specified for engine.on"),{clear:function(){}})}),t.whenReady=new Promise((function(e){t.on("Ready",e)})),t._trigger=r.prototype.trigger,t.trigger=function(){this._trigger.apply(this,arguments)||this.TriggerEvent.apply(this,arguments)},t.isAttached&&(t.mock=function(){}),t._BindingsReady=!1,t._WindowLoaded=!1,t._RequestId=0,t._ActiveRequests={},t.call=function(){t._RequestId++;var e=t._RequestId,n=Array.prototype.slice.call(arguments);return n.splice(1,0,e),new Promise((function(r,i){t._ActiveRequests[e]={resolve:r,reject:i},t.SendMessage.apply(t,n)}))},t._Result=function(e){var n=t._ActiveRequests[e];if(void 0!==n){delete t._ActiveRequests[e];var r=Array.prototype.slice.call(arguments);r.shift(),n.resolve.apply(n,r)}},t._Reject=function(e){var n=t._ActiveRequests[e];void 0!==n&&(delete t._ActiveRequests[e],requestAnimationFrame((function(){return n.reject("No handler registered")})))},t._ForEachError=function(e,t){for(var n=e.length,r=0;r<n;++r)t(e[r].first,e[r].second)},t._TriggerError=function(e){t.trigger("Error",e)},t._OnError=function(e,n){if(null===e||0===e)t._ForEachError(n,t._TriggerError);else{var r=t._ActiveRequests[e];delete t._ActiveRequests[e],r.reject(new Error(n[0].second))}if(n.length)throw new Error(n[0].second)},t._OnReady=function(){t._BindingsReady=!0,t._WindowLoaded&&t.trigger("Ready")},t._OnWindowLoaded=function(){t._WindowLoaded=!0,t._BindingsReady&&t.trigger("Ready")},n?e.addEventListener("load",(function(){t._OnWindowLoaded()})):t._WindowLoaded=!0,t.on("_Result",t._Result,t),t.on("_Reject",t._Reject,t),t.on("_OnReady",t._OnReady,t),t.on("_OnError",t._OnError,t),t.dependency=new WeakMap,t.hasAttachedUpdateListner=!1,t.onUpdateWholeModel=function(e){(t.dependency.get(e)||[]).forEach((function(e){return t.updateWholeModel(e)}))},t.createObservableModel=function(e){var n={set:function(n,r,i){t.updateWholeModel(window[e]),n[r]=i}};t.createJSModel(e,new Proxy({},n))},t.addSynchronizationDependency=function(e,n){t.hasAttachedUpdateListner||(t.addDataBindEventListner("updateWholeModel",t.onUpdateWholeModel),t.hasAttachedUpdateListner=!0);var r=t.dependency.get(e);r||(r=[],t.dependency.set(e,r)),r.push(n)},t.removeSynchronizationDependency=function(e,n){var r=t.dependency.get(e)||[];r.splice(r.indexOf(n),1)},t.BindingsReady(a[0],a[1],a[2],a[3]),t._Initialized=!0,t},e.exports?e.exports=r(n.g,n.g.engine,!1):engine=r(window,window.engine,!0)},580:()=>{function e(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function t(t){return function(t){if(Array.isArray(t))return e(t)}(t)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(t)||function(t,n){if(!t)return;if("string"==typeof t)return e(t,n);var r=Object.prototype.toString.call(t).slice(8,-1);"Object"===r&&t.constructor&&(r=t.constructor.name);if("Map"===r||"Set"===r)return Array.from(r);if("Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r))return e(t,n)}(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var n,r;document&&document.location&&document.location.hostname||document.location||Object.defineProperty(document,"location",{get:function(){return{hostname:""}}}),void 0===document.body.clientWidth&&(Object.defineProperty(Element.prototype,"clientHeight",{get:function(){return this.offsetHeight}}),Object.defineProperty(Element.prototype,"clientWidth",{get:function(){return this.offsetWidth}})),CanvasRenderingContext2D.prototype.resetTransform||(CanvasRenderingContext2D.prototype.resetTransform=function(){this.setTransform(1,0,0,1,0,0)}),CanvasRenderingContext2D.prototype.setLineDash||(CanvasRenderingContext2D.prototype.setLineDash=function(){}),window.addEventListener=(n=window.addEventListener,function(e){for(var r=arguments.length,i=new Array(r>1?r-1:0),o=1;o<r;o++)i[o-1]=arguments[o];"test"!=e&&n.apply(void 0,[e].concat(t(i)))}),window.removeEventListener=(r=window.removeEventListener,function(e){for(var n=arguments.length,i=new Array(n>1?n-1:0),o=1;o<n;o++)i[o-1]=arguments[o];"test"!=e&&r.apply(void 0,[e].concat(t(i)))})},4:e=>{var t=.1,n="function"==typeof Float32Array;function r(e,t){return 1-3*t+3*e}function i(e,t){return 3*t-6*e}function o(e){return 3*e}function a(e,t,n){return((r(t,n)*e+i(t,n))*e+o(t))*e}function s(e,t,n){return 3*r(t,n)*e*e+2*i(t,n)*e+o(t)}function l(e){return e}e.exports=function(e,r,i,o){if(!(0<=e&&e<=1&&0<=i&&i<=1))throw new Error("bezier x values must be in [0, 1] range");if(e===r&&i===o)return l;for(var c=n?new Float32Array(11):new Array(11),u=0;u<11;++u)c[u]=a(u*t,e,i);function d(n){for(var r=0,o=1;10!==o&&c[o]<=n;++o)r+=t;--o;var l=r+(n-c[o])/(c[o+1]-c[o])*t,u=s(l,e,i);return u>=.001?function(e,t,n,r){for(var i=0;i<4;++i){var o=s(t,n,r);if(0===o)return t;t-=(a(t,n,r)-e)/o}return t}(n,l,e,i):0===u?l:function(e,t,n,r,i){var o,s,l=0;do{(o=a(s=t+(n-t)/2,r,i)-e)>0?n=s:t=s}while(Math.abs(o)>1e-7&&++l<10);return s}(n,r,r+t,e,i)}return function(e){return 0===e?0:1===e?1:a(d(e),r,o)}}},80:(e,t)=>{var n;!function(){"use strict";var r={}.hasOwnProperty;function i(){for(var e=[],t=0;t<arguments.length;t++){var n=arguments[t];if(n){var o=typeof n;if("string"===o||"number"===o)e.push(n);else if(Array.isArray(n)){if(n.length){var a=i.apply(null,n);a&&e.push(a)}}else if("object"===o){if(n.toString!==Object.prototype.toString&&!n.toString.toString().includes("[native code]")){e.push(n.toString());continue}for(var s in n)r.call(n,s)&&n[s]&&e.push(s)}}}return e.join(" ")}e.exports?(i.default=i,e.exports=i):void 0===(n=function(){return i}.apply(t,[]))||(e.exports=n)}()},516:(e,t,n)=>{"use strict";var r=n(504),i=n(712);function o(e){for(var t="https://reactjs.org/docs/error-decoder.html?invariant="+e,n=1;n<arguments.length;n++)t+="&args[]="+encodeURIComponent(arguments[n]);return"Minified React error #"+e+"; visit "+t+" for the full message or use the non-minified dev environment for full errors and additional helpful warnings."}var a=new Set,s={};function l(e,t){c(e,t),c(e+"Capture",t)}function c(e,t){for(s[e]=t,e=0;e<t.length;e++)a.add(t[e])}var u=!("undefined"==typeof window||void 0===window.document||void 0===window.document.createElement),d=Object.prototype.hasOwnProperty,f=/^[:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD][:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\-.0-9\u00B7\u0300-\u036F\u203F-\u2040]*$/,m={},g={};function h(e,t,n,r,i,o,a){this.acceptsBooleans=2===t||3===t||4===t,this.attributeName=r,this.attributeNamespace=i,this.mustUseProperty=n,this.propertyName=e,this.type=t,this.sanitizeURL=o,this.removeEmptyString=a}var p={};"children dangerouslySetInnerHTML defaultValue defaultChecked innerHTML suppressContentEditableWarning suppressHydrationWarning style".split(" ").forEach((function(e){p[e]=new h(e,0,!1,e,null,!1,!1)})),[["acceptCharset","accept-charset"],["className","class"],["htmlFor","for"],["httpEquiv","http-equiv"]].forEach((function(e){var t=e[0];p[t]=new h(t,1,!1,e[1],null,!1,!1)})),["contentEditable","draggable","spellCheck","value"].forEach((function(e){p[e]=new h(e,2,!1,e.toLowerCase(),null,!1,!1)})),["autoReverse","externalResourcesRequired","focusable","preserveAlpha"].forEach((function(e){p[e]=new h(e,2,!1,e,null,!1,!1)})),"allowFullScreen async autoFocus autoPlay controls default defer disabled disablePictureInPicture disableRemotePlayback formNoValidate hidden loop noModule noValidate open playsInline readOnly required reversed scoped seamless itemScope".split(" ").forEach((function(e){p[e]=new h(e,3,!1,e.toLowerCase(),null,!1,!1)})),["checked","multiple","muted","selected"].forEach((function(e){p[e]=new h(e,3,!0,e,null,!1,!1)})),["capture","download"].forEach((function(e){p[e]=new h(e,4,!1,e,null,!1,!1)})),["cols","rows","size","span"].forEach((function(e){p[e]=new h(e,6,!1,e,null,!1,!1)})),["rowSpan","start"].forEach((function(e){p[e]=new h(e,5,!1,e.toLowerCase(),null,!1,!1)}));var v=/[\-:]([a-z])/g;function b(e){return e[1].toUpperCase()}function y(e,t,n,r){var i=p.hasOwnProperty(t)?p[t]:null;(null!==i?0!==i.type:r||!(2<t.length)||"o"!==t[0]&&"O"!==t[0]||"n"!==t[1]&&"N"!==t[1])&&(function(e,t,n,r){if(null==t||function(e,t,n,r){if(null!==n&&0===n.type)return!1;switch(typeof t){case"function":case"symbol":return!0;case"boolean":return!r&&(null!==n?!n.acceptsBooleans:"data-"!==(e=e.toLowerCase().slice(0,5))&&"aria-"!==e);default:return!1}}(e,t,n,r))return!0;if(r)return!1;if(null!==n)switch(n.type){case 3:return!t;case 4:return!1===t;case 5:return isNaN(t);case 6:return isNaN(t)||1>t}return!1}(t,n,i,r)&&(n=null),r||null===i?function(e){return!!d.call(g,e)||!d.call(m,e)&&(f.test(e)?g[e]=!0:(m[e]=!0,!1))}(t)&&(null===n?e.removeAttribute(t):e.setAttribute(t,""+n)):i.mustUseProperty?e[i.propertyName]=null===n?3!==i.type&&"":n:(t=i.attributeName,r=i.attributeNamespace,null===n?e.removeAttribute(t):(n=3===(i=i.type)||4===i&&!0===n?"":""+n,r?e.setAttributeNS(r,t,n):e.setAttribute(t,n))))}"accent-height alignment-baseline arabic-form baseline-shift cap-height clip-path clip-rule color-interpolation color-interpolation-filters color-profile color-rendering dominant-baseline enable-background fill-opacity fill-rule flood-color flood-opacity font-family font-size font-size-adjust font-stretch font-style font-variant font-weight glyph-name glyph-orientation-horizontal glyph-orientation-vertical horiz-adv-x horiz-origin-x image-rendering letter-spacing lighting-color marker-end marker-mid marker-start overline-position overline-thickness paint-order panose-1 pointer-events rendering-intent shape-rendering stop-color stop-opacity strikethrough-position strikethrough-thickness stroke-dasharray stroke-dashoffset stroke-linecap stroke-linejoin stroke-miterlimit stroke-opacity stroke-width text-anchor text-decoration text-rendering underline-position underline-thickness unicode-bidi unicode-range units-per-em v-alphabetic v-hanging v-ideographic v-mathematical vector-effect vert-adv-y vert-origin-x vert-origin-y word-spacing writing-mode xmlns:xlink x-height".split(" ").forEach((function(e){var t=e.replace(v,b);p[t]=new h(t,1,!1,e,null,!1,!1)})),"xlink:actuate xlink:arcrole xlink:role xlink:show xlink:title xlink:type".split(" ").forEach((function(e){var t=e.replace(v,b);p[t]=new h(t,1,!1,e,"http://www.w3.org/1999/xlink",!1,!1)})),["xml:base","xml:lang","xml:space"].forEach((function(e){var t=e.replace(v,b);p[t]=new h(t,1,!1,e,"http://www.w3.org/XML/1998/namespace",!1,!1)})),["tabIndex","crossOrigin"].forEach((function(e){p[e]=new h(e,1,!1,e.toLowerCase(),null,!1,!1)})),p.xlinkHref=new h("xlinkHref",1,!1,"xlink:href","http://www.w3.org/1999/xlink",!0,!1),["src","href","action","formAction"].forEach((function(e){p[e]=new h(e,1,!1,e.toLowerCase(),null,!0,!0)}));var x=r.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED,_=Symbol.for("react.element"),j=Symbol.for("react.portal"),O=Symbol.for("react.fragment"),E=Symbol.for("react.strict_mode"),S=Symbol.for("react.profiler"),T=Symbol.for("react.provider"),I=Symbol.for("react.context"),w=Symbol.for("react.forward_ref"),P=Symbol.for("react.suspense"),C=Symbol.for("react.suspense_list"),N=Symbol.for("react.memo"),A=Symbol.for("react.lazy");Symbol.for("react.scope"),Symbol.for("react.debug_trace_mode");var L=Symbol.for("react.offscreen");Symbol.for("react.legacy_hidden"),Symbol.for("react.cache"),Symbol.for("react.tracing_marker");var M=Symbol.iterator;function k(e){return null===e||"object"!=typeof e?null:"function"==typeof(e=M&&e[M]||e["@@iterator"])?e:null}var R,D=Object.assign;function F(e){if(void 0===R)try{throw Error()}catch(e){var t=e.stack.trim().match(/\n( *(at )?)/);R=t&&t[1]||""}return"\n"+R+e}var U=!1;function G(e,t){if(!e||U)return"";U=!0;var n=Error.prepareStackTrace;Error.prepareStackTrace=void 0;try{if(t)if(t=function(){throw Error()},Object.defineProperty(t.prototype,"props",{set:function(){throw Error()}}),"object"==typeof Reflect&&Reflect.construct){try{Reflect.construct(t,[])}catch(e){var r=e}Reflect.construct(e,[],t)}else{try{t.call()}catch(e){r=e}e.call(t.prototype)}else{try{throw Error()}catch(e){r=e}e()}}catch(t){if(t&&r&&"string"==typeof t.stack){for(var i=t.stack.split("\n"),o=r.stack.split("\n"),a=i.length-1,s=o.length-1;1<=a&&0<=s&&i[a]!==o[s];)s--;for(;1<=a&&0<=s;a--,s--)if(i[a]!==o[s]){if(1!==a||1!==s)do{if(a--,0>--s||i[a]!==o[s]){var l="\n"+i[a].replace(" at new "," at ");return e.displayName&&l.includes("<anonymous>")&&(l=l.replace("<anonymous>",e.displayName)),l}}while(1<=a&&0<=s);break}}}finally{U=!1,Error.prepareStackTrace=n}return(e=e?e.displayName||e.name:"")?F(e):""}function B(e){switch(e.tag){case 5:return F(e.type);case 16:return F("Lazy");case 13:return F("Suspense");case 19:return F("SuspenseList");case 0:case 2:case 15:return e=G(e.type,!1);case 11:return e=G(e.type.render,!1);case 1:return e=G(e.type,!0);default:return""}}function V(e){if(null==e)return null;if("function"==typeof e)return e.displayName||e.name||null;if("string"==typeof e)return e;switch(e){case O:return"Fragment";case j:return"Portal";case S:return"Profiler";case E:return"StrictMode";case P:return"Suspense";case C:return"SuspenseList"}if("object"==typeof e)switch(e.$$typeof){case I:return(e.displayName||"Context")+".Consumer";case T:return(e._context.displayName||"Context")+".Provider";case w:var t=e.render;return(e=e.displayName)||(e=""!==(e=t.displayName||t.name||"")?"ForwardRef("+e+")":"ForwardRef"),e;case N:return null!==(t=e.displayName||null)?t:V(e.type)||"Memo";case A:t=e._payload,e=e._init;try{return V(e(t))}catch(e){}}return null}function H(e){var t=e.type;switch(e.tag){case 24:return"Cache";case 9:return(t.displayName||"Context")+".Consumer";case 10:return(t._context.displayName||"Context")+".Provider";case 18:return"DehydratedFragment";case 11:return e=(e=t.render).displayName||e.name||"",t.displayName||(""!==e?"ForwardRef("+e+")":"ForwardRef");case 7:return"Fragment";case 5:return t;case 4:return"Portal";case 3:return"Root";case 6:return"Text";case 16:return V(t);case 8:return t===E?"StrictMode":"Mode";case 22:return"Offscreen";case 12:return"Profiler";case 21:return"Scope";case 13:return"Suspense";case 19:return"SuspenseList";case 25:return"TracingMarker";case 1:case 0:case 17:case 2:case 14:case 15:if("function"==typeof t)return t.displayName||t.name||null;if("string"==typeof t)return t}return null}function K(e){switch(typeof e){case"boolean":case"number":case"string":case"undefined":case"object":return e;default:return""}}function W(e){var t=e.type;return(e=e.nodeName)&&"input"===e.toLowerCase()&&("checkbox"===t||"radio"===t)}function z(e){e._valueTracker||(e._valueTracker=function(e){var t=W(e)?"checked":"value",n=Object.getOwnPropertyDescriptor(e.constructor.prototype,t),r=""+e[t];if(!e.hasOwnProperty(t)&&void 0!==n&&"function"==typeof n.get&&"function"==typeof n.set){var i=n.get,o=n.set;return Object.defineProperty(e,t,{configurable:!0,get:function(){return i.call(this)},set:function(e){r=""+e,o.call(this,e)}}),Object.defineProperty(e,t,{enumerable:n.enumerable}),{getValue:function(){return r},setValue:function(e){r=""+e},stopTracking:function(){e._valueTracker=null,delete e[t]}}}}(e))}function Y(e){if(!e)return!1;var t=e._valueTracker;if(!t)return!0;var n=t.getValue(),r="";return e&&(r=W(e)?e.checked?"true":"false":e.value),(e=r)!==n&&(t.setValue(e),!0)}function $(e){if(void 0===(e=e||("undefined"!=typeof document?document:void 0)))return null;try{return e.activeElement||e.body}catch(t){return e.body}}function q(e,t){var n=t.checked;return D({},t,{defaultChecked:void 0,defaultValue:void 0,value:void 0,checked:null!=n?n:e._wrapperState.initialChecked})}function X(e,t){var n=null==t.defaultValue?"":t.defaultValue,r=null!=t.checked?t.checked:t.defaultChecked;n=K(null!=t.value?t.value:n),e._wrapperState={initialChecked:r,initialValue:n,controlled:"checkbox"===t.type||"radio"===t.type?null!=t.checked:null!=t.value}}function Q(e,t){null!=(t=t.checked)&&y(e,"checked",t,!1)}function Z(e,t){Q(e,t);var n=K(t.value),r=t.type;if(null!=n)"number"===r?(0===n&&""===e.value||e.value!=n)&&(e.value=""+n):e.value!==""+n&&(e.value=""+n);else if("submit"===r||"reset"===r)return void e.removeAttribute("value");t.hasOwnProperty("value")?ee(e,t.type,n):t.hasOwnProperty("defaultValue")&&ee(e,t.type,K(t.defaultValue)),null==t.checked&&null!=t.defaultChecked&&(e.defaultChecked=!!t.defaultChecked)}function J(e,t,n){if(t.hasOwnProperty("value")||t.hasOwnProperty("defaultValue")){var r=t.type;if(!("submit"!==r&&"reset"!==r||void 0!==t.value&&null!==t.value))return;t=""+e._wrapperState.initialValue,n||t===e.value||(e.value=t),e.defaultValue=t}""!==(n=e.name)&&(e.name=""),e.defaultChecked=!!e._wrapperState.initialChecked,""!==n&&(e.name=n)}function ee(e,t,n){"number"===t&&$(e.ownerDocument)===e||(null==n?e.defaultValue=""+e._wrapperState.initialValue:e.defaultValue!==""+n&&(e.defaultValue=""+n))}var te=Array.isArray;function ne(e,t,n,r){if(e=e.options,t){t={};for(var i=0;i<n.length;i++)t["$"+n[i]]=!0;for(n=0;n<e.length;n++)i=t.hasOwnProperty("$"+e[n].value),e[n].selected!==i&&(e[n].selected=i),i&&r&&(e[n].defaultSelected=!0)}else{for(n=""+K(n),t=null,i=0;i<e.length;i++){if(e[i].value===n)return e[i].selected=!0,void(r&&(e[i].defaultSelected=!0));null!==t||e[i].disabled||(t=e[i])}null!==t&&(t.selected=!0)}}function re(e,t){if(null!=t.dangerouslySetInnerHTML)throw Error(o(91));return D({},t,{value:void 0,defaultValue:void 0,children:""+e._wrapperState.initialValue})}function ie(e,t){var n=t.value;if(null==n){if(n=t.children,t=t.defaultValue,null!=n){if(null!=t)throw Error(o(92));if(te(n)){if(1<n.length)throw Error(o(93));n=n[0]}t=n}null==t&&(t=""),n=t}e._wrapperState={initialValue:K(n)}}function oe(e,t){var n=K(t.value),r=K(t.defaultValue);null!=n&&((n=""+n)!==e.value&&(e.value=n),null==t.defaultValue&&e.defaultValue!==n&&(e.defaultValue=n)),null!=r&&(e.defaultValue=""+r)}function ae(e){var t=e.textContent;t===e._wrapperState.initialValue&&""!==t&&null!==t&&(e.value=t)}function se(e){switch(e){case"svg":return"http://www.w3.org/2000/svg";case"math":return"http://www.w3.org/1998/Math/MathML";default:return"http://www.w3.org/1999/xhtml"}}function le(e,t){return null==e||"http://www.w3.org/1999/xhtml"===e?se(t):"http://www.w3.org/2000/svg"===e&&"foreignObject"===t?"http://www.w3.org/1999/xhtml":e}var ce,ue,de=(ue=function(e,t){if("http://www.w3.org/2000/svg"!==e.namespaceURI||"innerHTML"in e)e.innerHTML=t;else{for((ce=ce||document.createElement("div")).innerHTML="<svg>"+t.valueOf().toString()+"</svg>",t=ce.firstChild;e.firstChild;)e.removeChild(e.firstChild);for(;t.firstChild;)e.appendChild(t.firstChild)}},"undefined"!=typeof MSApp&&MSApp.execUnsafeLocalFunction?function(e,t,n,r){MSApp.execUnsafeLocalFunction((function(){return ue(e,t)}))}:ue);function fe(e,t){if(t){var n=e.firstChild;if(n&&n===e.lastChild&&3===n.nodeType)return void(n.nodeValue=t)}e.textContent=t}var me={animationIterationCount:!0,aspectRatio:!0,borderImageOutset:!0,borderImageSlice:!0,borderImageWidth:!0,boxFlex:!0,boxFlexGroup:!0,boxOrdinalGroup:!0,columnCount:!0,columns:!0,flex:!0,flexGrow:!0,flexPositive:!0,flexShrink:!0,flexNegative:!0,flexOrder:!0,gridArea:!0,gridRow:!0,gridRowEnd:!0,gridRowSpan:!0,gridRowStart:!0,gridColumn:!0,gridColumnEnd:!0,gridColumnSpan:!0,gridColumnStart:!0,fontWeight:!0,lineClamp:!0,lineHeight:!0,opacity:!0,order:!0,orphans:!0,tabSize:!0,widows:!0,zIndex:!0,zoom:!0,fillOpacity:!0,floodOpacity:!0,stopOpacity:!0,strokeDasharray:!0,strokeDashoffset:!0,strokeMiterlimit:!0,strokeOpacity:!0,strokeWidth:!0},ge=["Webkit","ms","Moz","O"];function he(e,t,n){return null==t||"boolean"==typeof t||""===t?"":n||"number"!=typeof t||0===t||me.hasOwnProperty(e)&&me[e]?(""+t).trim():t+"px"}function pe(e,t){for(var n in e=e.style,t)if(t.hasOwnProperty(n)){var r=0===n.indexOf("--"),i=he(n,t[n],r);"float"===n&&(n="cssFloat"),r?e.setProperty(n,i):e[n]=i}}Object.keys(me).forEach((function(e){ge.forEach((function(t){t=t+e.charAt(0).toUpperCase()+e.substring(1),me[t]=me[e]}))}));var ve=D({menuitem:!0},{area:!0,base:!0,br:!0,col:!0,embed:!0,hr:!0,img:!0,input:!0,keygen:!0,link:!0,meta:!0,param:!0,source:!0,track:!0,wbr:!0});function be(e,t){if(t){if(ve[e]&&(null!=t.children||null!=t.dangerouslySetInnerHTML))throw Error(o(137,e));if(null!=t.dangerouslySetInnerHTML){if(null!=t.children)throw Error(o(60));if("object"!=typeof t.dangerouslySetInnerHTML||!("__html"in t.dangerouslySetInnerHTML))throw Error(o(61))}if(null!=t.style&&"object"!=typeof t.style)throw Error(o(62))}}function ye(e,t){if(-1===e.indexOf("-"))return"string"==typeof t.is;switch(e){case"annotation-xml":case"color-profile":case"font-face":case"font-face-src":case"font-face-uri":case"font-face-format":case"font-face-name":case"missing-glyph":return!1;default:return!0}}var xe=null;function _e(e){return(e=e.target||e.srcElement||window).correspondingUseElement&&(e=e.correspondingUseElement),3===e.nodeType?e.parentNode:e}var je=null,Oe=null,Ee=null;function Se(e){if(e=yi(e)){if("function"!=typeof je)throw Error(o(280));var t=e.stateNode;t&&(t=_i(t),je(e.stateNode,e.type,t))}}function Te(e){Oe?Ee?Ee.push(e):Ee=[e]:Oe=e}function Ie(){if(Oe){var e=Oe,t=Ee;if(Ee=Oe=null,Se(e),t)for(e=0;e<t.length;e++)Se(t[e])}}function we(e,t){return e(t)}function Pe(){}var Ce=!1;function Ne(e,t,n){if(Ce)return e(t,n);Ce=!0;try{return we(e,t,n)}finally{Ce=!1,(null!==Oe||null!==Ee)&&(Pe(),Ie())}}function Ae(e,t){var n=e.stateNode;if(null===n)return null;var r=_i(n);if(null===r)return null;n=r[t];e:switch(t){case"onClick":case"onClickCapture":case"onDoubleClick":case"onDoubleClickCapture":case"onMouseDown":case"onMouseDownCapture":case"onMouseMove":case"onMouseMoveCapture":case"onMouseUp":case"onMouseUpCapture":case"onMouseEnter":(r=!r.disabled)||(r=!("button"===(e=e.type)||"input"===e||"select"===e||"textarea"===e)),e=!r;break e;default:e=!1}if(e)return null;if(n&&"function"!=typeof n)throw Error(o(231,t,typeof n));return n}var Le=!1;if(u)try{var Me={};Object.defineProperty(Me,"passive",{get:function(){Le=!0}}),window.addEventListener("test",Me,Me),window.removeEventListener("test",Me,Me)}catch(ue){Le=!1}function ke(e,t,n,r,i,o,a,s,l){var c=Array.prototype.slice.call(arguments,3);try{t.apply(n,c)}catch(e){this.onError(e)}}var Re=!1,De=null,Fe=!1,Ue=null,Ge={onError:function(e){Re=!0,De=e}};function Be(e,t,n,r,i,o,a,s,l){Re=!1,De=null,ke.apply(Ge,arguments)}function Ve(e){var t=e,n=e;if(e.alternate)for(;t.return;)t=t.return;else{e=t;do{0!=(4098&(t=e).flags)&&(n=t.return),e=t.return}while(e)}return 3===t.tag?n:null}function He(e){if(13===e.tag){var t=e.memoizedState;if(null===t&&(null!==(e=e.alternate)&&(t=e.memoizedState)),null!==t)return t.dehydrated}return null}function Ke(e){if(Ve(e)!==e)throw Error(o(188))}function We(e){return null!==(e=function(e){var t=e.alternate;if(!t){if(null===(t=Ve(e)))throw Error(o(188));return t!==e?null:e}for(var n=e,r=t;;){var i=n.return;if(null===i)break;var a=i.alternate;if(null===a){if(null!==(r=i.return)){n=r;continue}break}if(i.child===a.child){for(a=i.child;a;){if(a===n)return Ke(i),e;if(a===r)return Ke(i),t;a=a.sibling}throw Error(o(188))}if(n.return!==r.return)n=i,r=a;else{for(var s=!1,l=i.child;l;){if(l===n){s=!0,n=i,r=a;break}if(l===r){s=!0,r=i,n=a;break}l=l.sibling}if(!s){for(l=a.child;l;){if(l===n){s=!0,n=a,r=i;break}if(l===r){s=!0,r=a,n=i;break}l=l.sibling}if(!s)throw Error(o(189))}}if(n.alternate!==r)throw Error(o(190))}if(3!==n.tag)throw Error(o(188));return n.stateNode.current===n?e:t}(e))?ze(e):null}function ze(e){if(5===e.tag||6===e.tag)return e;for(e=e.child;null!==e;){var t=ze(e);if(null!==t)return t;e=e.sibling}return null}var Ye=i.unstable_scheduleCallback,$e=i.unstable_cancelCallback,qe=i.unstable_shouldYield,Xe=i.unstable_requestPaint,Qe=i.unstable_now,Ze=i.unstable_getCurrentPriorityLevel,Je=i.unstable_ImmediatePriority,et=i.unstable_UserBlockingPriority,tt=i.unstable_NormalPriority,nt=i.unstable_LowPriority,rt=i.unstable_IdlePriority,it=null,ot=null;var at=Math.clz32?Math.clz32:function(e){return e>>>=0,0===e?32:31-(st(e)/lt|0)|0},st=Math.log,lt=Math.LN2;var ct=64,ut=4194304;function dt(e){switch(e&-e){case 1:return 1;case 2:return 2;case 4:return 4;case 8:return 8;case 16:return 16;case 32:return 32;case 64:case 128:case 256:case 512:case 1024:case 2048:case 4096:case 8192:case 16384:case 32768:case 65536:case 131072:case 262144:case 524288:case 1048576:case 2097152:return 4194240&e;case 4194304:case 8388608:case 16777216:case 33554432:case 67108864:return 130023424&e;case 134217728:return 134217728;case 268435456:return 268435456;case 536870912:return 536870912;case 1073741824:return 1073741824;default:return e}}function ft(e,t){var n=e.pendingLanes;if(0===n)return 0;var r=0,i=e.suspendedLanes,o=e.pingedLanes,a=268435455&n;if(0!==a){var s=a&~i;0!==s?r=dt(s):0!==(o&=a)&&(r=dt(o))}else 0!==(a=n&~i)?r=dt(a):0!==o&&(r=dt(o));if(0===r)return 0;if(0!==t&&t!==r&&0==(t&i)&&((i=r&-r)>=(o=t&-t)||16===i&&0!=(4194240&o)))return t;if(0!=(4&r)&&(r|=16&n),0!==(t=e.entangledLanes))for(e=e.entanglements,t&=r;0<t;)i=1<<(n=31-at(t)),r|=e[n],t&=~i;return r}function mt(e,t){switch(e){case 1:case 2:case 4:return t+250;case 8:case 16:case 32:case 64:case 128:case 256:case 512:case 1024:case 2048:case 4096:case 8192:case 16384:case 32768:case 65536:case 131072:case 262144:case 524288:case 1048576:case 2097152:return t+5e3;default:return-1}}function gt(e){return 0!==(e=-1073741825&e.pendingLanes)?e:1073741824&e?1073741824:0}function ht(){var e=ct;return 0==(4194240&(ct<<=1))&&(ct=64),e}function pt(e){for(var t=[],n=0;31>n;n++)t.push(e);return t}function vt(e,t,n){e.pendingLanes|=t,536870912!==t&&(e.suspendedLanes=0,e.pingedLanes=0),(e=e.eventTimes)[t=31-at(t)]=n}function bt(e,t){var n=e.entangledLanes|=t;for(e=e.entanglements;n;){var r=31-at(n),i=1<<r;i&t|e[r]&t&&(e[r]|=t),n&=~i}}var yt=0;function xt(e){return 1<(e&=-e)?4<e?0!=(268435455&e)?16:536870912:4:1}var _t,jt,Ot,Et,St,Tt=!1,It=[],wt=null,Pt=null,Ct=null,Nt=new Map,At=new Map,Lt=[],Mt="mousedown mouseup touchcancel touchend touchstart auxclick dblclick pointercancel pointerdown pointerup dragend dragstart drop compositionend compositionstart keydown keypress keyup input textInput copy cut paste click change contextmenu reset submit".split(" ");function kt(e,t){switch(e){case"focusin":case"focusout":wt=null;break;case"dragenter":case"dragleave":Pt=null;break;case"mouseover":case"mouseout":Ct=null;break;case"pointerover":case"pointerout":Nt.delete(t.pointerId);break;case"gotpointercapture":case"lostpointercapture":At.delete(t.pointerId)}}function Rt(e,t,n,r,i,o){return null===e||e.nativeEvent!==o?(e={blockedOn:t,domEventName:n,eventSystemFlags:r,nativeEvent:o,targetContainers:[i]},null!==t&&(null!==(t=yi(t))&&jt(t)),e):(e.eventSystemFlags|=r,t=e.targetContainers,null!==i&&-1===t.indexOf(i)&&t.push(i),e)}function Dt(e){var t=bi(e.target);if(null!==t){var n=Ve(t);if(null!==n)if(13===(t=n.tag)){if(null!==(t=He(n)))return e.blockedOn=t,void St(e.priority,(function(){Ot(n)}))}else if(3===t&&n.stateNode.current.memoizedState.isDehydrated)return void(e.blockedOn=3===n.tag?n.stateNode.containerInfo:null)}e.blockedOn=null}function Ft(e){if(null!==e.blockedOn)return!1;for(var t=e.targetContainers;0<t.length;){var n=qt(e.domEventName,e.eventSystemFlags,t[0],e.nativeEvent);if(null!==n)return null!==(t=yi(n))&&jt(t),e.blockedOn=n,!1;var r=new(n=e.nativeEvent).constructor(n.type,n);xe=r,n.target.dispatchEvent(r),xe=null,t.shift()}return!0}function Ut(e,t,n){Ft(e)&&n.delete(t)}function Gt(){Tt=!1,null!==wt&&Ft(wt)&&(wt=null),null!==Pt&&Ft(Pt)&&(Pt=null),null!==Ct&&Ft(Ct)&&(Ct=null),Nt.forEach(Ut),At.forEach(Ut)}function Bt(e,t){e.blockedOn===t&&(e.blockedOn=null,Tt||(Tt=!0,i.unstable_scheduleCallback(i.unstable_NormalPriority,Gt)))}function Vt(e){function t(t){return Bt(t,e)}if(0<It.length){Bt(It[0],e);for(var n=1;n<It.length;n++){var r=It[n];r.blockedOn===e&&(r.blockedOn=null)}}for(null!==wt&&Bt(wt,e),null!==Pt&&Bt(Pt,e),null!==Ct&&Bt(Ct,e),Nt.forEach(t),At.forEach(t),n=0;n<Lt.length;n++)(r=Lt[n]).blockedOn===e&&(r.blockedOn=null);for(;0<Lt.length&&null===(n=Lt[0]).blockedOn;)Dt(n),null===n.blockedOn&&Lt.shift()}var Ht=x.ReactCurrentBatchConfig,Kt=!0;function Wt(e,t,n,r){var i=yt,o=Ht.transition;Ht.transition=null;try{yt=1,Yt(e,t,n,r)}finally{yt=i,Ht.transition=o}}function zt(e,t,n,r){var i=yt,o=Ht.transition;Ht.transition=null;try{yt=4,Yt(e,t,n,r)}finally{yt=i,Ht.transition=o}}function Yt(e,t,n,r){if(Kt){var i=qt(e,t,n,r);if(null===i)Kr(e,t,r,$t,n),kt(e,r);else if(function(e,t,n,r,i){switch(t){case"focusin":return wt=Rt(wt,e,t,n,r,i),!0;case"dragenter":return Pt=Rt(Pt,e,t,n,r,i),!0;case"mouseover":return Ct=Rt(Ct,e,t,n,r,i),!0;case"pointerover":var o=i.pointerId;return Nt.set(o,Rt(Nt.get(o)||null,e,t,n,r,i)),!0;case"gotpointercapture":return o=i.pointerId,At.set(o,Rt(At.get(o)||null,e,t,n,r,i)),!0}return!1}(i,e,t,n,r))r.stopPropagation();else if(kt(e,r),4&t&&-1<Mt.indexOf(e)){for(;null!==i;){var o=yi(i);if(null!==o&&_t(o),null===(o=qt(e,t,n,r))&&Kr(e,t,r,$t,n),o===i)break;i=o}null!==i&&r.stopPropagation()}else Kr(e,t,r,null,n)}}var $t=null;function qt(e,t,n,r){if($t=null,null!==(e=bi(e=_e(r))))if(null===(t=Ve(e)))e=null;else if(13===(n=t.tag)){if(null!==(e=He(t)))return e;e=null}else if(3===n){if(t.stateNode.current.memoizedState.isDehydrated)return 3===t.tag?t.stateNode.containerInfo:null;e=null}else t!==e&&(e=null);return $t=e,null}function Xt(e){switch(e){case"cancel":case"click":case"close":case"contextmenu":case"copy":case"cut":case"auxclick":case"dblclick":case"dragend":case"dragstart":case"drop":case"focusin":case"focusout":case"input":case"invalid":case"keydown":case"keypress":case"keyup":case"mousedown":case"mouseup":case"paste":case"pause":case"play":case"pointercancel":case"pointerdown":case"pointerup":case"ratechange":case"reset":case"resize":case"seeked":case"submit":case"touchcancel":case"touchend":case"touchstart":case"volumechange":case"change":case"selectionchange":case"textInput":case"compositionstart":case"compositionend":case"compositionupdate":case"beforeblur":case"afterblur":case"beforeinput":case"blur":case"fullscreenchange":case"focus":case"hashchange":case"popstate":case"select":case"selectstart":return 1;case"drag":case"dragenter":case"dragexit":case"dragleave":case"dragover":case"mousemove":case"mouseout":case"mouseover":case"pointermove":case"pointerout":case"pointerover":case"scroll":case"toggle":case"touchmove":case"wheel":case"mouseenter":case"mouseleave":case"pointerenter":case"pointerleave":return 4;case"message":switch(Ze()){case Je:return 1;case et:return 4;case tt:case nt:return 16;case rt:return 536870912;default:return 16}default:return 16}}var Qt=null,Zt=null,Jt=null;function en(){if(Jt)return Jt;var e,t,n=Zt,r=n.length,i="value"in Qt?Qt.value:Qt.textContent,o=i.length;for(e=0;e<r&&n[e]===i[e];e++);var a=r-e;for(t=1;t<=a&&n[r-t]===i[o-t];t++);return Jt=i.slice(e,1<t?1-t:void 0)}function tn(e){var t=e.keyCode;return"charCode"in e?0===(e=e.charCode)&&13===t&&(e=13):e=t,10===e&&(e=13),32<=e||13===e?e:0}function nn(){return!0}function rn(){return!1}function on(e){function t(t,n,r,i,o){for(var a in this._reactName=t,this._targetInst=r,this.type=n,this.nativeEvent=i,this.target=o,this.currentTarget=null,e)e.hasOwnProperty(a)&&(t=e[a],this[a]=t?t(i):i[a]);return this.isDefaultPrevented=(null!=i.defaultPrevented?i.defaultPrevented:!1===i.returnValue)?nn:rn,this.isPropagationStopped=rn,this}return D(t.prototype,{preventDefault:function(){this.defaultPrevented=!0;var e=this.nativeEvent;e&&(e.preventDefault?e.preventDefault():"unknown"!=typeof e.returnValue&&(e.returnValue=!1),this.isDefaultPrevented=nn)},stopPropagation:function(){var e=this.nativeEvent;e&&(e.stopPropagation?e.stopPropagation():"unknown"!=typeof e.cancelBubble&&(e.cancelBubble=!0),this.isPropagationStopped=nn)},persist:function(){},isPersistent:nn}),t}var an,sn,ln,cn={eventPhase:0,bubbles:0,cancelable:0,timeStamp:function(e){return e.timeStamp||Date.now()},defaultPrevented:0,isTrusted:0},un=on(cn),dn=D({},cn,{view:0,detail:0}),fn=on(dn),mn=D({},dn,{screenX:0,screenY:0,clientX:0,clientY:0,pageX:0,pageY:0,ctrlKey:0,shiftKey:0,altKey:0,metaKey:0,getModifierState:Sn,button:0,buttons:0,relatedTarget:function(e){return void 0===e.relatedTarget?e.fromElement===e.srcElement?e.toElement:e.fromElement:e.relatedTarget},movementX:function(e){return"movementX"in e?e.movementX:(e!==ln&&(ln&&"mousemove"===e.type?(an=e.screenX-ln.screenX,sn=e.screenY-ln.screenY):sn=an=0,ln=e),an)},movementY:function(e){return"movementY"in e?e.movementY:sn}}),gn=on(mn),hn=on(D({},mn,{dataTransfer:0})),pn=on(D({},dn,{relatedTarget:0})),vn=on(D({},cn,{animationName:0,elapsedTime:0,pseudoElement:0})),bn=D({},cn,{clipboardData:function(e){return"clipboardData"in e?e.clipboardData:window.clipboardData}}),yn=on(bn),xn=on(D({},cn,{data:0})),_n={Esc:"Escape",Spacebar:" ",Left:"ArrowLeft",Up:"ArrowUp",Right:"ArrowRight",Down:"ArrowDown",Del:"Delete",Win:"OS",Menu:"ContextMenu",Apps:"ContextMenu",Scroll:"ScrollLock",MozPrintableKey:"Unidentified"},jn={8:"Backspace",9:"Tab",12:"Clear",13:"Enter",16:"Shift",17:"Control",18:"Alt",19:"Pause",20:"CapsLock",27:"Escape",32:" ",33:"PageUp",34:"PageDown",35:"End",36:"Home",37:"ArrowLeft",38:"ArrowUp",39:"ArrowRight",40:"ArrowDown",45:"Insert",46:"Delete",112:"F1",113:"F2",114:"F3",115:"F4",116:"F5",117:"F6",118:"F7",119:"F8",120:"F9",121:"F10",122:"F11",123:"F12",144:"NumLock",145:"ScrollLock",224:"Meta"},On={Alt:"altKey",Control:"ctrlKey",Meta:"metaKey",Shift:"shiftKey"};function En(e){var t=this.nativeEvent;return t.getModifierState?t.getModifierState(e):!!(e=On[e])&&!!t[e]}function Sn(){return En}var Tn=D({},dn,{key:function(e){if(e.key){var t=_n[e.key]||e.key;if("Unidentified"!==t)return t}return"keypress"===e.type?13===(e=tn(e))?"Enter":String.fromCharCode(e):"keydown"===e.type||"keyup"===e.type?jn[e.keyCode]||"Unidentified":""},code:0,location:0,ctrlKey:0,shiftKey:0,altKey:0,metaKey:0,repeat:0,locale:0,getModifierState:Sn,charCode:function(e){return"keypress"===e.type?tn(e):0},keyCode:function(e){return"keydown"===e.type||"keyup"===e.type?e.keyCode:0},which:function(e){return"keypress"===e.type?tn(e):"keydown"===e.type||"keyup"===e.type?e.keyCode:0}}),In=on(Tn),wn=on(D({},mn,{pointerId:0,width:0,height:0,pressure:0,tangentialPressure:0,tiltX:0,tiltY:0,twist:0,pointerType:0,isPrimary:0})),Pn=on(D({},dn,{touches:0,targetTouches:0,changedTouches:0,altKey:0,metaKey:0,ctrlKey:0,shiftKey:0,getModifierState:Sn})),Cn=on(D({},cn,{propertyName:0,elapsedTime:0,pseudoElement:0})),Nn=D({},mn,{deltaX:function(e){return"deltaX"in e?e.deltaX:"wheelDeltaX"in e?-e.wheelDeltaX:0},deltaY:function(e){return"deltaY"in e?e.deltaY:"wheelDeltaY"in e?-e.wheelDeltaY:"wheelDelta"in e?-e.wheelDelta:0},deltaZ:0,deltaMode:0}),An=on(Nn),Ln=[9,13,27,32],Mn=u&&"CompositionEvent"in window,kn=null;u&&"documentMode"in document&&(kn=document.documentMode);var Rn=u&&"TextEvent"in window&&!kn,Dn=u&&(!Mn||kn&&8<kn&&11>=kn),Fn=String.fromCharCode(32),Un=!1;function Gn(e,t){switch(e){case"keyup":return-1!==Ln.indexOf(t.keyCode);case"keydown":return 229!==t.keyCode;case"keypress":case"mousedown":case"focusout":return!0;default:return!1}}function Bn(e){return"object"==typeof(e=e.detail)&&"data"in e?e.data:null}var Vn=!1;var Hn={color:!0,date:!0,datetime:!0,"datetime-local":!0,email:!0,month:!0,number:!0,password:!0,range:!0,search:!0,tel:!0,text:!0,time:!0,url:!0,week:!0};function Kn(e){var t=e&&e.nodeName&&e.nodeName.toLowerCase();return"input"===t?!!Hn[e.type]:"textarea"===t}function Wn(e,t,n,r){Te(r),0<(t=zr(t,"onChange")).length&&(n=new un("onChange","change",null,n,r),e.push({event:n,listeners:t}))}var zn=null,Yn=null;function $n(e){Fr(e,0)}function qn(e){if(Y(xi(e)))return e}function Xn(e,t){if("change"===e)return t}var Qn=!1;if(u){var Zn;if(u){var Jn="oninput"in document;if(!Jn){var er=document.createElement("div");er.setAttribute("oninput","return;"),Jn="function"==typeof er.oninput}Zn=Jn}else Zn=!1;Qn=Zn&&(!document.documentMode||9<document.documentMode)}function tr(){zn&&(zn.detachEvent("onpropertychange",nr),Yn=zn=null)}function nr(e){if("value"===e.propertyName&&qn(Yn)){var t=[];Wn(t,Yn,e,_e(e)),Ne($n,t)}}function rr(e,t,n){"focusin"===e?(tr(),Yn=n,(zn=t).attachEvent("onpropertychange",nr)):"focusout"===e&&tr()}function ir(e){if("selectionchange"===e||"keyup"===e||"keydown"===e)return qn(Yn)}function or(e,t){if("click"===e)return qn(t)}function ar(e,t){if("input"===e||"change"===e)return qn(t)}var sr="function"==typeof Object.is?Object.is:function(e,t){return e===t&&(0!==e||1/e==1/t)||e!=e&&t!=t};function lr(e,t){if(sr(e,t))return!0;if("object"!=typeof e||null===e||"object"!=typeof t||null===t)return!1;var n=Object.keys(e),r=Object.keys(t);if(n.length!==r.length)return!1;for(r=0;r<n.length;r++){var i=n[r];if(!d.call(t,i)||!sr(e[i],t[i]))return!1}return!0}function cr(e){for(;e&&e.firstChild;)e=e.firstChild;return e}function ur(e,t){var n,r=cr(e);for(e=0;r;){if(3===r.nodeType){if(n=e+r.textContent.length,e<=t&&n>=t)return{node:r,offset:t-e};e=n}e:{for(;r;){if(r.nextSibling){r=r.nextSibling;break e}r=r.parentNode}r=void 0}r=cr(r)}}function dr(e,t){return!(!e||!t)&&(e===t||(!e||3!==e.nodeType)&&(t&&3===t.nodeType?dr(e,t.parentNode):"contains"in e?e.contains(t):!!e.compareDocumentPosition&&!!(16&e.compareDocumentPosition(t))))}function fr(){for(var e=window,t=$();t instanceof e.HTMLIFrameElement;){try{var n="string"==typeof t.contentWindow.location.href}catch(e){n=!1}if(!n)break;t=$((e=t.contentWindow).document)}return t}function mr(e){var t=e&&e.nodeName&&e.nodeName.toLowerCase();return t&&("input"===t&&("text"===e.type||"search"===e.type||"tel"===e.type||"url"===e.type||"password"===e.type)||"textarea"===t||"true"===e.contentEditable)}function gr(e){var t=fr(),n=e.focusedElem,r=e.selectionRange;if(t!==n&&n&&n.ownerDocument&&dr(n.ownerDocument.documentElement,n)){if(null!==r&&mr(n))if(t=r.start,void 0===(e=r.end)&&(e=t),"selectionStart"in n)n.selectionStart=t,n.selectionEnd=Math.min(e,n.value.length);else if((e=(t=n.ownerDocument||document)&&t.defaultView||window).getSelection){e=e.getSelection();var i=n.textContent.length,o=Math.min(r.start,i);r=void 0===r.end?o:Math.min(r.end,i),!e.extend&&o>r&&(i=r,r=o,o=i),i=ur(n,o);var a=ur(n,r);i&&a&&(1!==e.rangeCount||e.anchorNode!==i.node||e.anchorOffset!==i.offset||e.focusNode!==a.node||e.focusOffset!==a.offset)&&((t=t.createRange()).setStart(i.node,i.offset),e.removeAllRanges(),o>r?(e.addRange(t),e.extend(a.node,a.offset)):(t.setEnd(a.node,a.offset),e.addRange(t)))}for(t=[],e=n;e=e.parentNode;)1===e.nodeType&&t.push({element:e,left:e.scrollLeft,top:e.scrollTop});for("function"==typeof n.focus&&n.focus(),n=0;n<t.length;n++)(e=t[n]).element.scrollLeft=e.left,e.element.scrollTop=e.top}}var hr=u&&"documentMode"in document&&11>=document.documentMode,pr=null,vr=null,br=null,yr=!1;function xr(e,t,n){var r=n.window===n?n.document:9===n.nodeType?n:n.ownerDocument;yr||null==pr||pr!==$(r)||("selectionStart"in(r=pr)&&mr(r)?r={start:r.selectionStart,end:r.selectionEnd}:r={anchorNode:(r=(r.ownerDocument&&r.ownerDocument.defaultView||window).getSelection()).anchorNode,anchorOffset:r.anchorOffset,focusNode:r.focusNode,focusOffset:r.focusOffset},br&&lr(br,r)||(br=r,0<(r=zr(vr,"onSelect")).length&&(t=new un("onSelect","select",null,t,n),e.push({event:t,listeners:r}),t.target=pr)))}function _r(e,t){var n={};return n[e.toLowerCase()]=t.toLowerCase(),n["Webkit"+e]="webkit"+t,n["Moz"+e]="moz"+t,n}var jr={animationend:_r("Animation","AnimationEnd"),animationiteration:_r("Animation","AnimationIteration"),animationstart:_r("Animation","AnimationStart"),transitionend:_r("Transition","TransitionEnd")},Or={},Er={};function Sr(e){if(Or[e])return Or[e];if(!jr[e])return e;var t,n=jr[e];for(t in n)if(n.hasOwnProperty(t)&&t in Er)return Or[e]=n[t];return e}u&&(Er=document.createElement("div").style,"AnimationEvent"in window||(delete jr.animationend.animation,delete jr.animationiteration.animation,delete jr.animationstart.animation),"TransitionEvent"in window||delete jr.transitionend.transition);var Tr=Sr("animationend"),Ir=Sr("animationiteration"),wr=Sr("animationstart"),Pr=Sr("transitionend"),Cr=new Map,Nr="abort auxClick cancel canPlay canPlayThrough click close contextMenu copy cut drag dragEnd dragEnter dragExit dragLeave dragOver dragStart drop durationChange emptied encrypted ended error gotPointerCapture input invalid keyDown keyPress keyUp load loadedData loadedMetadata loadStart lostPointerCapture mouseDown mouseMove mouseOut mouseOver mouseUp paste pause play playing pointerCancel pointerDown pointerMove pointerOut pointerOver pointerUp progress rateChange reset resize seeked seeking stalled submit suspend timeUpdate touchCancel touchEnd touchStart volumeChange scroll toggle touchMove waiting wheel".split(" ");function Ar(e,t){Cr.set(e,t),l(t,[e])}for(var Lr=0;Lr<Nr.length;Lr++){var Mr=Nr[Lr];Ar(Mr.toLowerCase(),"on"+(Mr[0].toUpperCase()+Mr.slice(1)))}Ar(Tr,"onAnimationEnd"),Ar(Ir,"onAnimationIteration"),Ar(wr,"onAnimationStart"),Ar("dblclick","onDoubleClick"),Ar("focusin","onFocus"),Ar("focusout","onBlur"),Ar(Pr,"onTransitionEnd"),c("onMouseEnter",["mouseout","mouseover"]),c("onMouseLeave",["mouseout","mouseover"]),c("onPointerEnter",["pointerout","pointerover"]),c("onPointerLeave",["pointerout","pointerover"]),l("onChange","change click focusin focusout input keydown keyup selectionchange".split(" ")),l("onSelect","focusout contextmenu dragend focusin keydown keyup mousedown mouseup selectionchange".split(" ")),l("onBeforeInput",["compositionend","keypress","textInput","paste"]),l("onCompositionEnd","compositionend focusout keydown keypress keyup mousedown".split(" ")),l("onCompositionStart","compositionstart focusout keydown keypress keyup mousedown".split(" ")),l("onCompositionUpdate","compositionupdate focusout keydown keypress keyup mousedown".split(" "));var kr="abort canplay canplaythrough durationchange emptied encrypted ended error loadeddata loadedmetadata loadstart pause play playing progress ratechange resize seeked seeking stalled suspend timeupdate volumechange waiting".split(" "),Rr=new Set("cancel close invalid load scroll toggle".split(" ").concat(kr));function Dr(e,t,n){var r=e.type||"unknown-event";e.currentTarget=n,function(e,t,n,r,i,a,s,l,c){if(Be.apply(this,arguments),Re){if(!Re)throw Error(o(198));var u=De;Re=!1,De=null,Fe||(Fe=!0,Ue=u)}}(r,t,void 0,e),e.currentTarget=null}function Fr(e,t){t=0!=(4&t);for(var n=0;n<e.length;n++){var r=e[n],i=r.event;r=r.listeners;e:{var o=void 0;if(t)for(var a=r.length-1;0<=a;a--){var s=r[a],l=s.instance,c=s.currentTarget;if(s=s.listener,l!==o&&i.isPropagationStopped())break e;Dr(i,s,c),o=l}else for(a=0;a<r.length;a++){if(l=(s=r[a]).instance,c=s.currentTarget,s=s.listener,l!==o&&i.isPropagationStopped())break e;Dr(i,s,c),o=l}}}if(Fe)throw e=Ue,Fe=!1,Ue=null,e}function Ur(e,t){var n=t[hi];void 0===n&&(n=t[hi]=new Set);var r=e+"__bubble";n.has(r)||(Hr(t,e,2,!1),n.add(r))}function Gr(e,t,n){var r=0;t&&(r|=4),Hr(n,e,r,t)}var Br="_reactListening"+Math.random().toString(36).slice(2);function Vr(e){if(!e[Br]){e[Br]=!0,a.forEach((function(t){"selectionchange"!==t&&(Rr.has(t)||Gr(t,!1,e),Gr(t,!0,e))}));var t=9===e.nodeType?e:e.ownerDocument;null===t||t[Br]||(t[Br]=!0,Gr("selectionchange",!1,t))}}function Hr(e,t,n,r){switch(Xt(t)){case 1:var i=Wt;break;case 4:i=zt;break;default:i=Yt}n=i.bind(null,t,n,e),i=void 0,!Le||"touchstart"!==t&&"touchmove"!==t&&"wheel"!==t||(i=!0),r?void 0!==i?e.addEventListener(t,n,{capture:!0,passive:i}):e.addEventListener(t,n,!0):void 0!==i?e.addEventListener(t,n,{passive:i}):e.addEventListener(t,n,!1)}function Kr(e,t,n,r,i){var o=r;if(0==(1&t)&&0==(2&t)&&null!==r)e:for(;;){if(null===r)return;var a=r.tag;if(3===a||4===a){var s=r.stateNode.containerInfo;if(s===i||8===s.nodeType&&s.parentNode===i)break;if(4===a)for(a=r.return;null!==a;){var l=a.tag;if((3===l||4===l)&&((l=a.stateNode.containerInfo)===i||8===l.nodeType&&l.parentNode===i))return;a=a.return}for(;null!==s;){if(null===(a=bi(s)))return;if(5===(l=a.tag)||6===l){r=o=a;continue e}s=s.parentNode}}r=r.return}Ne((function(){var r=o,i=_e(n),a=[];e:{var s=Cr.get(e);if(void 0!==s){var l=un,c=e;switch(e){case"keypress":if(0===tn(n))break e;case"keydown":case"keyup":l=In;break;case"focusin":c="focus",l=pn;break;case"focusout":c="blur",l=pn;break;case"beforeblur":case"afterblur":l=pn;break;case"click":if(2===n.button)break e;case"auxclick":case"dblclick":case"mousedown":case"mousemove":case"mouseup":case"mouseout":case"mouseover":case"contextmenu":l=gn;break;case"drag":case"dragend":case"dragenter":case"dragexit":case"dragleave":case"dragover":case"dragstart":case"drop":l=hn;break;case"touchcancel":case"touchend":case"touchmove":case"touchstart":l=Pn;break;case Tr:case Ir:case wr:l=vn;break;case Pr:l=Cn;break;case"scroll":l=fn;break;case"wheel":l=An;break;case"copy":case"cut":case"paste":l=yn;break;case"gotpointercapture":case"lostpointercapture":case"pointercancel":case"pointerdown":case"pointermove":case"pointerout":case"pointerover":case"pointerup":l=wn}var u=0!=(4&t),d=!u&&"scroll"===e,f=u?null!==s?s+"Capture":null:s;u=[];for(var m,g=r;null!==g;){var h=(m=g).stateNode;if(5===m.tag&&null!==h&&(m=h,null!==f&&(null!=(h=Ae(g,f))&&u.push(Wr(g,h,m)))),d)break;g=g.return}0<u.length&&(s=new l(s,c,null,n,i),a.push({event:s,listeners:u}))}}if(0==(7&t)){if(l="mouseout"===e||"pointerout"===e,(!(s="mouseover"===e||"pointerover"===e)||n===xe||!(c=n.relatedTarget||n.fromElement)||!bi(c)&&!c[gi])&&(l||s)&&(s=i.window===i?i:(s=i.ownerDocument)?s.defaultView||s.parentWindow:window,l?(l=r,null!==(c=(c=n.relatedTarget||n.toElement)?bi(c):null)&&(c!==(d=Ve(c))||5!==c.tag&&6!==c.tag)&&(c=null)):(l=null,c=r),l!==c)){if(u=gn,h="onMouseLeave",f="onMouseEnter",g="mouse","pointerout"!==e&&"pointerover"!==e||(u=wn,h="onPointerLeave",f="onPointerEnter",g="pointer"),d=null==l?s:xi(l),m=null==c?s:xi(c),(s=new u(h,g+"leave",l,n,i)).target=d,s.relatedTarget=m,h=null,bi(i)===r&&((u=new u(f,g+"enter",c,n,i)).target=m,u.relatedTarget=d,h=u),d=h,l&&c)e:{for(f=c,g=0,m=u=l;m;m=Yr(m))g++;for(m=0,h=f;h;h=Yr(h))m++;for(;0<g-m;)u=Yr(u),g--;for(;0<m-g;)f=Yr(f),m--;for(;g--;){if(u===f||null!==f&&u===f.alternate)break e;u=Yr(u),f=Yr(f)}u=null}else u=null;null!==l&&$r(a,s,l,u,!1),null!==c&&null!==d&&$r(a,d,c,u,!0)}if("select"===(l=(s=r?xi(r):window).nodeName&&s.nodeName.toLowerCase())||"input"===l&&"file"===s.type)var p=Xn;else if(Kn(s))if(Qn)p=ar;else{p=ir;var v=rr}else(l=s.nodeName)&&"input"===l.toLowerCase()&&("checkbox"===s.type||"radio"===s.type)&&(p=or);switch(p&&(p=p(e,r))?Wn(a,p,n,i):(v&&v(e,s,r),"focusout"===e&&(v=s._wrapperState)&&v.controlled&&"number"===s.type&&ee(s,"number",s.value)),v=r?xi(r):window,e){case"focusin":(Kn(v)||"true"===v.contentEditable)&&(pr=v,vr=r,br=null);break;case"focusout":br=vr=pr=null;break;case"mousedown":yr=!0;break;case"contextmenu":case"mouseup":case"dragend":yr=!1,xr(a,n,i);break;case"selectionchange":if(hr)break;case"keydown":case"keyup":xr(a,n,i)}var b;if(Mn)e:{switch(e){case"compositionstart":var y="onCompositionStart";break e;case"compositionend":y="onCompositionEnd";break e;case"compositionupdate":y="onCompositionUpdate";break e}y=void 0}else Vn?Gn(e,n)&&(y="onCompositionEnd"):"keydown"===e&&229===n.keyCode&&(y="onCompositionStart");y&&(Dn&&"ko"!==n.locale&&(Vn||"onCompositionStart"!==y?"onCompositionEnd"===y&&Vn&&(b=en()):(Zt="value"in(Qt=i)?Qt.value:Qt.textContent,Vn=!0)),0<(v=zr(r,y)).length&&(y=new xn(y,e,null,n,i),a.push({event:y,listeners:v}),b?y.data=b:null!==(b=Bn(n))&&(y.data=b))),(b=Rn?function(e,t){switch(e){case"compositionend":return Bn(t);case"keypress":return 32!==t.which?null:(Un=!0,Fn);case"textInput":return(e=t.data)===Fn&&Un?null:e;default:return null}}(e,n):function(e,t){if(Vn)return"compositionend"===e||!Mn&&Gn(e,t)?(e=en(),Jt=Zt=Qt=null,Vn=!1,e):null;switch(e){case"paste":default:return null;case"keypress":if(!(t.ctrlKey||t.altKey||t.metaKey)||t.ctrlKey&&t.altKey){if(t.char&&1<t.char.length)return t.char;if(t.which)return String.fromCharCode(t.which)}return null;case"compositionend":return Dn&&"ko"!==t.locale?null:t.data}}(e,n))&&(0<(r=zr(r,"onBeforeInput")).length&&(i=new xn("onBeforeInput","beforeinput",null,n,i),a.push({event:i,listeners:r}),i.data=b))}Fr(a,t)}))}function Wr(e,t,n){return{instance:e,listener:t,currentTarget:n}}function zr(e,t){for(var n=t+"Capture",r=[];null!==e;){var i=e,o=i.stateNode;5===i.tag&&null!==o&&(i=o,null!=(o=Ae(e,n))&&r.unshift(Wr(e,o,i)),null!=(o=Ae(e,t))&&r.push(Wr(e,o,i))),e=e.return}return r}function Yr(e){if(null===e)return null;do{e=e.return}while(e&&5!==e.tag);return e||null}function $r(e,t,n,r,i){for(var o=t._reactName,a=[];null!==n&&n!==r;){var s=n,l=s.alternate,c=s.stateNode;if(null!==l&&l===r)break;5===s.tag&&null!==c&&(s=c,i?null!=(l=Ae(n,o))&&a.unshift(Wr(n,l,s)):i||null!=(l=Ae(n,o))&&a.push(Wr(n,l,s))),n=n.return}0!==a.length&&e.push({event:t,listeners:a})}var qr=/\r\n?/g,Xr=/\u0000|\uFFFD/g;function Qr(e){return("string"==typeof e?e:""+e).replace(qr,"\n").replace(Xr,"")}function Zr(e,t,n){if(t=Qr(t),Qr(e)!==t&&n)throw Error(o(425))}function Jr(){}var ei=null,ti=null;function ni(e,t){return"textarea"===e||"noscript"===e||"string"==typeof t.children||"number"==typeof t.children||"object"==typeof t.dangerouslySetInnerHTML&&null!==t.dangerouslySetInnerHTML&&null!=t.dangerouslySetInnerHTML.__html}var ri="function"==typeof setTimeout?setTimeout:void 0,ii="function"==typeof clearTimeout?clearTimeout:void 0,oi="function"==typeof Promise?Promise:void 0,ai="function"==typeof queueMicrotask?queueMicrotask:void 0!==oi?function(e){return oi.resolve(null).then(e).catch(si)}:ri;function si(e){setTimeout((function(){throw e}))}function li(e,t){var n=t,r=0;do{var i=n.nextSibling;if(e.removeChild(n),i&&8===i.nodeType)if("/$"===(n=i.data)){if(0===r)return e.removeChild(i),void Vt(t);r--}else"$"!==n&&"$?"!==n&&"$!"!==n||r++;n=i}while(n);Vt(t)}function ci(e){for(;null!=e;e=e.nextSibling){var t=e.nodeType;if(1===t||3===t)break;if(8===t){if("$"===(t=e.data)||"$!"===t||"$?"===t)break;if("/$"===t)return null}}return e}function ui(e){e=e.previousSibling;for(var t=0;e;){if(8===e.nodeType){var n=e.data;if("$"===n||"$!"===n||"$?"===n){if(0===t)return e;t--}else"/$"===n&&t++}e=e.previousSibling}return null}var di=Math.random().toString(36).slice(2),fi="__reactFiber$"+di,mi="__reactProps$"+di,gi="__reactContainer$"+di,hi="__reactEvents$"+di,pi="__reactListeners$"+di,vi="__reactHandles$"+di;function bi(e){var t=e[fi];if(t)return t;for(var n=e.parentNode;n;){if(t=n[gi]||n[fi]){if(n=t.alternate,null!==t.child||null!==n&&null!==n.child)for(e=ui(e);null!==e;){if(n=e[fi])return n;e=ui(e)}return t}n=(e=n).parentNode}return null}function yi(e){return!(e=e[fi]||e[gi])||5!==e.tag&&6!==e.tag&&13!==e.tag&&3!==e.tag?null:e}function xi(e){if(5===e.tag||6===e.tag)return e.stateNode;throw Error(o(33))}function _i(e){return e[mi]||null}var ji=[],Oi=-1;function Ei(e){return{current:e}}function Si(e){0>Oi||(e.current=ji[Oi],ji[Oi]=null,Oi--)}function Ti(e,t){Oi++,ji[Oi]=e.current,e.current=t}var Ii={},wi=Ei(Ii),Pi=Ei(!1),Ci=Ii;function Ni(e,t){var n=e.type.contextTypes;if(!n)return Ii;var r=e.stateNode;if(r&&r.__reactInternalMemoizedUnmaskedChildContext===t)return r.__reactInternalMemoizedMaskedChildContext;var i,o={};for(i in n)o[i]=t[i];return r&&((e=e.stateNode).__reactInternalMemoizedUnmaskedChildContext=t,e.__reactInternalMemoizedMaskedChildContext=o),o}function Ai(e){return null!=(e=e.childContextTypes)}function Li(){Si(Pi),Si(wi)}function Mi(e,t,n){if(wi.current!==Ii)throw Error(o(168));Ti(wi,t),Ti(Pi,n)}function ki(e,t,n){var r=e.stateNode;if(t=t.childContextTypes,"function"!=typeof r.getChildContext)return n;for(var i in r=r.getChildContext())if(!(i in t))throw Error(o(108,H(e)||"Unknown",i));return D({},n,r)}function Ri(e){return e=(e=e.stateNode)&&e.__reactInternalMemoizedMergedChildContext||Ii,Ci=wi.current,Ti(wi,e),Ti(Pi,Pi.current),!0}function Di(e,t,n){var r=e.stateNode;if(!r)throw Error(o(169));n?(e=ki(e,t,Ci),r.__reactInternalMemoizedMergedChildContext=e,Si(Pi),Si(wi),Ti(wi,e)):Si(Pi),Ti(Pi,n)}var Fi=null,Ui=!1,Gi=!1;function Bi(e){null===Fi?Fi=[e]:Fi.push(e)}function Vi(){if(!Gi&&null!==Fi){Gi=!0;var e=0,t=yt;try{var n=Fi;for(yt=1;e<n.length;e++){var r=n[e];do{r=r(!0)}while(null!==r)}Fi=null,Ui=!1}catch(t){throw null!==Fi&&(Fi=Fi.slice(e+1)),Ye(Je,Vi),t}finally{yt=t,Gi=!1}}return null}var Hi=[],Ki=0,Wi=null,zi=0,Yi=[],$i=0,qi=null,Xi=1,Qi="";function Zi(e,t){Hi[Ki++]=zi,Hi[Ki++]=Wi,Wi=e,zi=t}function Ji(e,t,n){Yi[$i++]=Xi,Yi[$i++]=Qi,Yi[$i++]=qi,qi=e;var r=Xi;e=Qi;var i=32-at(r)-1;r&=~(1<<i),n+=1;var o=32-at(t)+i;if(30<o){var a=i-i%5;o=(r&(1<<a)-1).toString(32),r>>=a,i-=a,Xi=1<<32-at(t)+i|n<<i|r,Qi=o+e}else Xi=1<<o|n<<i|r,Qi=e}function eo(e){null!==e.return&&(Zi(e,1),Ji(e,1,0))}function to(e){for(;e===Wi;)Wi=Hi[--Ki],Hi[Ki]=null,zi=Hi[--Ki],Hi[Ki]=null;for(;e===qi;)qi=Yi[--$i],Yi[$i]=null,Qi=Yi[--$i],Yi[$i]=null,Xi=Yi[--$i],Yi[$i]=null}var no=null,ro=null,io=!1,oo=null;function ao(e,t){var n=Ac(5,null,null,0);n.elementType="DELETED",n.stateNode=t,n.return=e,null===(t=e.deletions)?(e.deletions=[n],e.flags|=16):t.push(n)}function so(e,t){switch(e.tag){case 5:var n=e.type;return null!==(t=1!==t.nodeType||n.toLowerCase()!==t.nodeName.toLowerCase()?null:t)&&(e.stateNode=t,no=e,ro=ci(t.firstChild),!0);case 6:return null!==(t=""===e.pendingProps||3!==t.nodeType?null:t)&&(e.stateNode=t,no=e,ro=null,!0);case 13:return null!==(t=8!==t.nodeType?null:t)&&(n=null!==qi?{id:Xi,overflow:Qi}:null,e.memoizedState={dehydrated:t,treeContext:n,retryLane:1073741824},(n=Ac(18,null,null,0)).stateNode=t,n.return=e,e.child=n,no=e,ro=null,!0);default:return!1}}function lo(e){return 0!=(1&e.mode)&&0==(128&e.flags)}function co(e){if(io){var t=ro;if(t){var n=t;if(!so(e,t)){if(lo(e))throw Error(o(418));t=ci(n.nextSibling);var r=no;t&&so(e,t)?ao(r,n):(e.flags=-4097&e.flags|2,io=!1,no=e)}}else{if(lo(e))throw Error(o(418));e.flags=-4097&e.flags|2,io=!1,no=e}}}function uo(e){for(e=e.return;null!==e&&5!==e.tag&&3!==e.tag&&13!==e.tag;)e=e.return;no=e}function fo(e){if(e!==no)return!1;if(!io)return uo(e),io=!0,!1;var t;if((t=3!==e.tag)&&!(t=5!==e.tag)&&(t="head"!==(t=e.type)&&"body"!==t&&!ni(e.type,e.memoizedProps)),t&&(t=ro)){if(lo(e))throw mo(),Error(o(418));for(;t;)ao(e,t),t=ci(t.nextSibling)}if(uo(e),13===e.tag){if(!(e=null!==(e=e.memoizedState)?e.dehydrated:null))throw Error(o(317));e:{for(e=e.nextSibling,t=0;e;){if(8===e.nodeType){var n=e.data;if("/$"===n){if(0===t){ro=ci(e.nextSibling);break e}t--}else"$"!==n&&"$!"!==n&&"$?"!==n||t++}e=e.nextSibling}ro=null}}else ro=no?ci(e.stateNode.nextSibling):null;return!0}function mo(){for(var e=ro;e;)e=ci(e.nextSibling)}function go(){ro=no=null,io=!1}function ho(e){null===oo?oo=[e]:oo.push(e)}var po=x.ReactCurrentBatchConfig;function vo(e,t){if(e&&e.defaultProps){for(var n in t=D({},t),e=e.defaultProps)void 0===t[n]&&(t[n]=e[n]);return t}return t}var bo=Ei(null),yo=null,xo=null,_o=null;function jo(){_o=xo=yo=null}function Oo(e){var t=bo.current;Si(bo),e._currentValue=t}function Eo(e,t,n){for(;null!==e;){var r=e.alternate;if((e.childLanes&t)!==t?(e.childLanes|=t,null!==r&&(r.childLanes|=t)):null!==r&&(r.childLanes&t)!==t&&(r.childLanes|=t),e===n)break;e=e.return}}function So(e,t){yo=e,_o=xo=null,null!==(e=e.dependencies)&&null!==e.firstContext&&(0!=(e.lanes&t)&&(xs=!0),e.firstContext=null)}function To(e){var t=e._currentValue;if(_o!==e)if(e={context:e,memoizedValue:t,next:null},null===xo){if(null===yo)throw Error(o(308));xo=e,yo.dependencies={lanes:0,firstContext:e}}else xo=xo.next=e;return t}var Io=null;function wo(e){null===Io?Io=[e]:Io.push(e)}function Po(e,t,n,r){var i=t.interleaved;return null===i?(n.next=n,wo(t)):(n.next=i.next,i.next=n),t.interleaved=n,Co(e,r)}function Co(e,t){e.lanes|=t;var n=e.alternate;for(null!==n&&(n.lanes|=t),n=e,e=e.return;null!==e;)e.childLanes|=t,null!==(n=e.alternate)&&(n.childLanes|=t),n=e,e=e.return;return 3===n.tag?n.stateNode:null}var No=!1;function Ao(e){e.updateQueue={baseState:e.memoizedState,firstBaseUpdate:null,lastBaseUpdate:null,shared:{pending:null,interleaved:null,lanes:0},effects:null}}function Lo(e,t){e=e.updateQueue,t.updateQueue===e&&(t.updateQueue={baseState:e.baseState,firstBaseUpdate:e.firstBaseUpdate,lastBaseUpdate:e.lastBaseUpdate,shared:e.shared,effects:e.effects})}function Mo(e,t){return{eventTime:e,lane:t,tag:0,payload:null,callback:null,next:null}}function ko(e,t,n){var r=e.updateQueue;if(null===r)return null;if(r=r.shared,0!=(2&Pl)){var i=r.pending;return null===i?t.next=t:(t.next=i.next,i.next=t),r.pending=t,Co(e,n)}return null===(i=r.interleaved)?(t.next=t,wo(r)):(t.next=i.next,i.next=t),r.interleaved=t,Co(e,n)}function Ro(e,t,n){if(null!==(t=t.updateQueue)&&(t=t.shared,0!=(4194240&n))){var r=t.lanes;n|=r&=e.pendingLanes,t.lanes=n,bt(e,n)}}function Do(e,t){var n=e.updateQueue,r=e.alternate;if(null!==r&&n===(r=r.updateQueue)){var i=null,o=null;if(null!==(n=n.firstBaseUpdate)){do{var a={eventTime:n.eventTime,lane:n.lane,tag:n.tag,payload:n.payload,callback:n.callback,next:null};null===o?i=o=a:o=o.next=a,n=n.next}while(null!==n);null===o?i=o=t:o=o.next=t}else i=o=t;return n={baseState:r.baseState,firstBaseUpdate:i,lastBaseUpdate:o,shared:r.shared,effects:r.effects},void(e.updateQueue=n)}null===(e=n.lastBaseUpdate)?n.firstBaseUpdate=t:e.next=t,n.lastBaseUpdate=t}function Fo(e,t,n,r){var i=e.updateQueue;No=!1;var o=i.firstBaseUpdate,a=i.lastBaseUpdate,s=i.shared.pending;if(null!==s){i.shared.pending=null;var l=s,c=l.next;l.next=null,null===a?o=c:a.next=c,a=l;var u=e.alternate;null!==u&&((s=(u=u.updateQueue).lastBaseUpdate)!==a&&(null===s?u.firstBaseUpdate=c:s.next=c,u.lastBaseUpdate=l))}if(null!==o){var d=i.baseState;for(a=0,u=c=l=null,s=o;;){var f=s.lane,m=s.eventTime;if((r&f)===f){null!==u&&(u=u.next={eventTime:m,lane:0,tag:s.tag,payload:s.payload,callback:s.callback,next:null});e:{var g=e,h=s;switch(f=t,m=n,h.tag){case 1:if("function"==typeof(g=h.payload)){d=g.call(m,d,f);break e}d=g;break e;case 3:g.flags=-65537&g.flags|128;case 0:if(null==(f="function"==typeof(g=h.payload)?g.call(m,d,f):g))break e;d=D({},d,f);break e;case 2:No=!0}}null!==s.callback&&0!==s.lane&&(e.flags|=64,null===(f=i.effects)?i.effects=[s]:f.push(s))}else m={eventTime:m,lane:f,tag:s.tag,payload:s.payload,callback:s.callback,next:null},null===u?(c=u=m,l=d):u=u.next=m,a|=f;if(null===(s=s.next)){if(null===(s=i.shared.pending))break;s=(f=s).next,f.next=null,i.lastBaseUpdate=f,i.shared.pending=null}}if(null===u&&(l=d),i.baseState=l,i.firstBaseUpdate=c,i.lastBaseUpdate=u,null!==(t=i.shared.interleaved)){i=t;do{a|=i.lane,i=i.next}while(i!==t)}else null===o&&(i.shared.lanes=0);Dl|=a,e.lanes=a,e.memoizedState=d}}function Uo(e,t,n){if(e=t.effects,t.effects=null,null!==e)for(t=0;t<e.length;t++){var r=e[t],i=r.callback;if(null!==i){if(r.callback=null,r=n,"function"!=typeof i)throw Error(o(191,i));i.call(r)}}}var Go=(new r.Component).refs;function Bo(e,t,n,r){n=null==(n=n(r,t=e.memoizedState))?t:D({},t,n),e.memoizedState=n,0===e.lanes&&(e.updateQueue.baseState=n)}var Vo={isMounted:function(e){return!!(e=e._reactInternals)&&Ve(e)===e},enqueueSetState:function(e,t,n){e=e._reactInternals;var r=tc(),i=nc(e),o=Mo(r,i);o.payload=t,null!=n&&(o.callback=n),null!==(t=ko(e,o,i))&&(rc(t,e,i,r),Ro(t,e,i))},enqueueReplaceState:function(e,t,n){e=e._reactInternals;var r=tc(),i=nc(e),o=Mo(r,i);o.tag=1,o.payload=t,null!=n&&(o.callback=n),null!==(t=ko(e,o,i))&&(rc(t,e,i,r),Ro(t,e,i))},enqueueForceUpdate:function(e,t){e=e._reactInternals;var n=tc(),r=nc(e),i=Mo(n,r);i.tag=2,null!=t&&(i.callback=t),null!==(t=ko(e,i,r))&&(rc(t,e,r,n),Ro(t,e,r))}};function Ho(e,t,n,r,i,o,a){return"function"==typeof(e=e.stateNode).shouldComponentUpdate?e.shouldComponentUpdate(r,o,a):!t.prototype||!t.prototype.isPureReactComponent||(!lr(n,r)||!lr(i,o))}function Ko(e,t,n){var r=!1,i=Ii,o=t.contextType;return"object"==typeof o&&null!==o?o=To(o):(i=Ai(t)?Ci:wi.current,o=(r=null!=(r=t.contextTypes))?Ni(e,i):Ii),t=new t(n,o),e.memoizedState=null!==t.state&&void 0!==t.state?t.state:null,t.updater=Vo,e.stateNode=t,t._reactInternals=e,r&&((e=e.stateNode).__reactInternalMemoizedUnmaskedChildContext=i,e.__reactInternalMemoizedMaskedChildContext=o),t}function Wo(e,t,n,r){e=t.state,"function"==typeof t.componentWillReceiveProps&&t.componentWillReceiveProps(n,r),"function"==typeof t.UNSAFE_componentWillReceiveProps&&t.UNSAFE_componentWillReceiveProps(n,r),t.state!==e&&Vo.enqueueReplaceState(t,t.state,null)}function zo(e,t,n,r){var i=e.stateNode;i.props=n,i.state=e.memoizedState,i.refs=Go,Ao(e);var o=t.contextType;"object"==typeof o&&null!==o?i.context=To(o):(o=Ai(t)?Ci:wi.current,i.context=Ni(e,o)),i.state=e.memoizedState,"function"==typeof(o=t.getDerivedStateFromProps)&&(Bo(e,t,o,n),i.state=e.memoizedState),"function"==typeof t.getDerivedStateFromProps||"function"==typeof i.getSnapshotBeforeUpdate||"function"!=typeof i.UNSAFE_componentWillMount&&"function"!=typeof i.componentWillMount||(t=i.state,"function"==typeof i.componentWillMount&&i.componentWillMount(),"function"==typeof i.UNSAFE_componentWillMount&&i.UNSAFE_componentWillMount(),t!==i.state&&Vo.enqueueReplaceState(i,i.state,null),Fo(e,n,i,r),i.state=e.memoizedState),"function"==typeof i.componentDidMount&&(e.flags|=4194308)}function Yo(e,t,n){if(null!==(e=n.ref)&&"function"!=typeof e&&"object"!=typeof e){if(n._owner){if(n=n._owner){if(1!==n.tag)throw Error(o(309));var r=n.stateNode}if(!r)throw Error(o(147,e));var i=r,a=""+e;return null!==t&&null!==t.ref&&"function"==typeof t.ref&&t.ref._stringRef===a?t.ref:(t=function(e){var t=i.refs;t===Go&&(t=i.refs={}),null===e?delete t[a]:t[a]=e},t._stringRef=a,t)}if("string"!=typeof e)throw Error(o(284));if(!n._owner)throw Error(o(290,e))}return e}function $o(e,t){throw e=Object.prototype.toString.call(t),Error(o(31,"[object Object]"===e?"object with keys {"+Object.keys(t).join(", ")+"}":e))}function qo(e){return(0,e._init)(e._payload)}function Xo(e){function t(t,n){if(e){var r=t.deletions;null===r?(t.deletions=[n],t.flags|=16):r.push(n)}}function n(n,r){if(!e)return null;for(;null!==r;)t(n,r),r=r.sibling;return null}function r(e,t){for(e=new Map;null!==t;)null!==t.key?e.set(t.key,t):e.set(t.index,t),t=t.sibling;return e}function i(e,t){return(e=Mc(e,t)).index=0,e.sibling=null,e}function a(t,n,r){return t.index=r,e?null!==(r=t.alternate)?(r=r.index)<n?(t.flags|=2,n):r:(t.flags|=2,n):(t.flags|=1048576,n)}function s(t){return e&&null===t.alternate&&(t.flags|=2),t}function l(e,t,n,r){return null===t||6!==t.tag?((t=Fc(n,e.mode,r)).return=e,t):((t=i(t,n)).return=e,t)}function c(e,t,n,r){var o=n.type;return o===O?d(e,t,n.props.children,r,n.key):null!==t&&(t.elementType===o||"object"==typeof o&&null!==o&&o.$$typeof===A&&qo(o)===t.type)?((r=i(t,n.props)).ref=Yo(e,t,n),r.return=e,r):((r=kc(n.type,n.key,n.props,null,e.mode,r)).ref=Yo(e,t,n),r.return=e,r)}function u(e,t,n,r){return null===t||4!==t.tag||t.stateNode.containerInfo!==n.containerInfo||t.stateNode.implementation!==n.implementation?((t=Uc(n,e.mode,r)).return=e,t):((t=i(t,n.children||[])).return=e,t)}function d(e,t,n,r,o){return null===t||7!==t.tag?((t=Rc(n,e.mode,r,o)).return=e,t):((t=i(t,n)).return=e,t)}function f(e,t,n){if("string"==typeof t&&""!==t||"number"==typeof t)return(t=Fc(""+t,e.mode,n)).return=e,t;if("object"==typeof t&&null!==t){switch(t.$$typeof){case _:return(n=kc(t.type,t.key,t.props,null,e.mode,n)).ref=Yo(e,null,t),n.return=e,n;case j:return(t=Uc(t,e.mode,n)).return=e,t;case A:return f(e,(0,t._init)(t._payload),n)}if(te(t)||k(t))return(t=Rc(t,e.mode,n,null)).return=e,t;$o(e,t)}return null}function m(e,t,n,r){var i=null!==t?t.key:null;if("string"==typeof n&&""!==n||"number"==typeof n)return null!==i?null:l(e,t,""+n,r);if("object"==typeof n&&null!==n){switch(n.$$typeof){case _:return n.key===i?c(e,t,n,r):null;case j:return n.key===i?u(e,t,n,r):null;case A:return m(e,t,(i=n._init)(n._payload),r)}if(te(n)||k(n))return null!==i?null:d(e,t,n,r,null);$o(e,n)}return null}function g(e,t,n,r,i){if("string"==typeof r&&""!==r||"number"==typeof r)return l(t,e=e.get(n)||null,""+r,i);if("object"==typeof r&&null!==r){switch(r.$$typeof){case _:return c(t,e=e.get(null===r.key?n:r.key)||null,r,i);case j:return u(t,e=e.get(null===r.key?n:r.key)||null,r,i);case A:return g(e,t,n,(0,r._init)(r._payload),i)}if(te(r)||k(r))return d(t,e=e.get(n)||null,r,i,null);$o(t,r)}return null}function h(i,o,s,l){for(var c=null,u=null,d=o,h=o=0,p=null;null!==d&&h<s.length;h++){d.index>h?(p=d,d=null):p=d.sibling;var v=m(i,d,s[h],l);if(null===v){null===d&&(d=p);break}e&&d&&null===v.alternate&&t(i,d),o=a(v,o,h),null===u?c=v:u.sibling=v,u=v,d=p}if(h===s.length)return n(i,d),io&&Zi(i,h),c;if(null===d){for(;h<s.length;h++)null!==(d=f(i,s[h],l))&&(o=a(d,o,h),null===u?c=d:u.sibling=d,u=d);return io&&Zi(i,h),c}for(d=r(i,d);h<s.length;h++)null!==(p=g(d,i,h,s[h],l))&&(e&&null!==p.alternate&&d.delete(null===p.key?h:p.key),o=a(p,o,h),null===u?c=p:u.sibling=p,u=p);return e&&d.forEach((function(e){return t(i,e)})),io&&Zi(i,h),c}function p(i,s,l,c){var u=k(l);if("function"!=typeof u)throw Error(o(150));if(null==(l=u.call(l)))throw Error(o(151));for(var d=u=null,h=s,p=s=0,v=null,b=l.next();null!==h&&!b.done;p++,b=l.next()){h.index>p?(v=h,h=null):v=h.sibling;var y=m(i,h,b.value,c);if(null===y){null===h&&(h=v);break}e&&h&&null===y.alternate&&t(i,h),s=a(y,s,p),null===d?u=y:d.sibling=y,d=y,h=v}if(b.done)return n(i,h),io&&Zi(i,p),u;if(null===h){for(;!b.done;p++,b=l.next())null!==(b=f(i,b.value,c))&&(s=a(b,s,p),null===d?u=b:d.sibling=b,d=b);return io&&Zi(i,p),u}for(h=r(i,h);!b.done;p++,b=l.next())null!==(b=g(h,i,p,b.value,c))&&(e&&null!==b.alternate&&h.delete(null===b.key?p:b.key),s=a(b,s,p),null===d?u=b:d.sibling=b,d=b);return e&&h.forEach((function(e){return t(i,e)})),io&&Zi(i,p),u}return function e(r,o,a,l){if("object"==typeof a&&null!==a&&a.type===O&&null===a.key&&(a=a.props.children),"object"==typeof a&&null!==a){switch(a.$$typeof){case _:e:{for(var c=a.key,u=o;null!==u;){if(u.key===c){if((c=a.type)===O){if(7===u.tag){n(r,u.sibling),(o=i(u,a.props.children)).return=r,r=o;break e}}else if(u.elementType===c||"object"==typeof c&&null!==c&&c.$$typeof===A&&qo(c)===u.type){n(r,u.sibling),(o=i(u,a.props)).ref=Yo(r,u,a),o.return=r,r=o;break e}n(r,u);break}t(r,u),u=u.sibling}a.type===O?((o=Rc(a.props.children,r.mode,l,a.key)).return=r,r=o):((l=kc(a.type,a.key,a.props,null,r.mode,l)).ref=Yo(r,o,a),l.return=r,r=l)}return s(r);case j:e:{for(u=a.key;null!==o;){if(o.key===u){if(4===o.tag&&o.stateNode.containerInfo===a.containerInfo&&o.stateNode.implementation===a.implementation){n(r,o.sibling),(o=i(o,a.children||[])).return=r,r=o;break e}n(r,o);break}t(r,o),o=o.sibling}(o=Uc(a,r.mode,l)).return=r,r=o}return s(r);case A:return e(r,o,(u=a._init)(a._payload),l)}if(te(a))return h(r,o,a,l);if(k(a))return p(r,o,a,l);$o(r,a)}return"string"==typeof a&&""!==a||"number"==typeof a?(a=""+a,null!==o&&6===o.tag?(n(r,o.sibling),(o=i(o,a)).return=r,r=o):(n(r,o),(o=Fc(a,r.mode,l)).return=r,r=o),s(r)):n(r,o)}}var Qo=Xo(!0),Zo=Xo(!1),Jo={},ea=Ei(Jo),ta=Ei(Jo),na=Ei(Jo);function ra(e){if(e===Jo)throw Error(o(174));return e}function ia(e,t){switch(Ti(na,t),Ti(ta,e),Ti(ea,Jo),e=t.nodeType){case 9:case 11:t=(t=t.documentElement)?t.namespaceURI:le(null,"");break;default:t=le(t=(e=8===e?t.parentNode:t).namespaceURI||null,e=e.tagName)}Si(ea),Ti(ea,t)}function oa(){Si(ea),Si(ta),Si(na)}function aa(e){ra(na.current);var t=ra(ea.current),n=le(t,e.type);t!==n&&(Ti(ta,e),Ti(ea,n))}function sa(e){ta.current===e&&(Si(ea),Si(ta))}var la=Ei(0);function ca(e){for(var t=e;null!==t;){if(13===t.tag){var n=t.memoizedState;if(null!==n&&(null===(n=n.dehydrated)||"$?"===n.data||"$!"===n.data))return t}else if(19===t.tag&&void 0!==t.memoizedProps.revealOrder){if(0!=(128&t.flags))return t}else if(null!==t.child){t.child.return=t,t=t.child;continue}if(t===e)break;for(;null===t.sibling;){if(null===t.return||t.return===e)return null;t=t.return}t.sibling.return=t.return,t=t.sibling}return null}var ua=[];function da(){for(var e=0;e<ua.length;e++)ua[e]._workInProgressVersionPrimary=null;ua.length=0}var fa=x.ReactCurrentDispatcher,ma=x.ReactCurrentBatchConfig,ga=0,ha=null,pa=null,va=null,ba=!1,ya=!1,xa=0,_a=0;function ja(){throw Error(o(321))}function Oa(e,t){if(null===t)return!1;for(var n=0;n<t.length&&n<e.length;n++)if(!sr(e[n],t[n]))return!1;return!0}function Ea(e,t,n,r,i,a){if(ga=a,ha=t,t.memoizedState=null,t.updateQueue=null,t.lanes=0,fa.current=null===e||null===e.memoizedState?ss:ls,e=n(r,i),ya){a=0;do{if(ya=!1,xa=0,25<=a)throw Error(o(301));a+=1,va=pa=null,t.updateQueue=null,fa.current=cs,e=n(r,i)}while(ya)}if(fa.current=as,t=null!==pa&&null!==pa.next,ga=0,va=pa=ha=null,ba=!1,t)throw Error(o(300));return e}function Sa(){var e=0!==xa;return xa=0,e}function Ta(){var e={memoizedState:null,baseState:null,baseQueue:null,queue:null,next:null};return null===va?ha.memoizedState=va=e:va=va.next=e,va}function Ia(){if(null===pa){var e=ha.alternate;e=null!==e?e.memoizedState:null}else e=pa.next;var t=null===va?ha.memoizedState:va.next;if(null!==t)va=t,pa=e;else{if(null===e)throw Error(o(310));e={memoizedState:(pa=e).memoizedState,baseState:pa.baseState,baseQueue:pa.baseQueue,queue:pa.queue,next:null},null===va?ha.memoizedState=va=e:va=va.next=e}return va}function wa(e,t){return"function"==typeof t?t(e):t}function Pa(e){var t=Ia(),n=t.queue;if(null===n)throw Error(o(311));n.lastRenderedReducer=e;var r=pa,i=r.baseQueue,a=n.pending;if(null!==a){if(null!==i){var s=i.next;i.next=a.next,a.next=s}r.baseQueue=i=a,n.pending=null}if(null!==i){a=i.next,r=r.baseState;var l=s=null,c=null,u=a;do{var d=u.lane;if((ga&d)===d)null!==c&&(c=c.next={lane:0,action:u.action,hasEagerState:u.hasEagerState,eagerState:u.eagerState,next:null}),r=u.hasEagerState?u.eagerState:e(r,u.action);else{var f={lane:d,action:u.action,hasEagerState:u.hasEagerState,eagerState:u.eagerState,next:null};null===c?(l=c=f,s=r):c=c.next=f,ha.lanes|=d,Dl|=d}u=u.next}while(null!==u&&u!==a);null===c?s=r:c.next=l,sr(r,t.memoizedState)||(xs=!0),t.memoizedState=r,t.baseState=s,t.baseQueue=c,n.lastRenderedState=r}if(null!==(e=n.interleaved)){i=e;do{a=i.lane,ha.lanes|=a,Dl|=a,i=i.next}while(i!==e)}else null===i&&(n.lanes=0);return[t.memoizedState,n.dispatch]}function Ca(e){var t=Ia(),n=t.queue;if(null===n)throw Error(o(311));n.lastRenderedReducer=e;var r=n.dispatch,i=n.pending,a=t.memoizedState;if(null!==i){n.pending=null;var s=i=i.next;do{a=e(a,s.action),s=s.next}while(s!==i);sr(a,t.memoizedState)||(xs=!0),t.memoizedState=a,null===t.baseQueue&&(t.baseState=a),n.lastRenderedState=a}return[a,r]}function Na(){}function Aa(e,t){var n=ha,r=Ia(),i=t(),a=!sr(r.memoizedState,i);if(a&&(r.memoizedState=i,xs=!0),r=r.queue,Ka(ka.bind(null,n,r,e),[e]),r.getSnapshot!==t||a||null!==va&&1&va.memoizedState.tag){if(n.flags|=2048,Ua(9,Ma.bind(null,n,r,i,t),void 0,null),null===Cl)throw Error(o(349));0!=(30&ga)||La(n,t,i)}return i}function La(e,t,n){e.flags|=16384,e={getSnapshot:t,value:n},null===(t=ha.updateQueue)?(t={lastEffect:null,stores:null},ha.updateQueue=t,t.stores=[e]):null===(n=t.stores)?t.stores=[e]:n.push(e)}function Ma(e,t,n,r){t.value=n,t.getSnapshot=r,Ra(t)&&Da(e)}function ka(e,t,n){return n((function(){Ra(t)&&Da(e)}))}function Ra(e){var t=e.getSnapshot;e=e.value;try{var n=t();return!sr(e,n)}catch(e){return!0}}function Da(e){var t=Co(e,1);null!==t&&rc(t,e,1,-1)}function Fa(e){var t=Ta();return"function"==typeof e&&(e=e()),t.memoizedState=t.baseState=e,e={pending:null,interleaved:null,lanes:0,dispatch:null,lastRenderedReducer:wa,lastRenderedState:e},t.queue=e,e=e.dispatch=ns.bind(null,ha,e),[t.memoizedState,e]}function Ua(e,t,n,r){return e={tag:e,create:t,destroy:n,deps:r,next:null},null===(t=ha.updateQueue)?(t={lastEffect:null,stores:null},ha.updateQueue=t,t.lastEffect=e.next=e):null===(n=t.lastEffect)?t.lastEffect=e.next=e:(r=n.next,n.next=e,e.next=r,t.lastEffect=e),e}function Ga(){return Ia().memoizedState}function Ba(e,t,n,r){var i=Ta();ha.flags|=e,i.memoizedState=Ua(1|t,n,void 0,void 0===r?null:r)}function Va(e,t,n,r){var i=Ia();r=void 0===r?null:r;var o=void 0;if(null!==pa){var a=pa.memoizedState;if(o=a.destroy,null!==r&&Oa(r,a.deps))return void(i.memoizedState=Ua(t,n,o,r))}ha.flags|=e,i.memoizedState=Ua(1|t,n,o,r)}function Ha(e,t){return Ba(8390656,8,e,t)}function Ka(e,t){return Va(2048,8,e,t)}function Wa(e,t){return Va(4,2,e,t)}function za(e,t){return Va(4,4,e,t)}function Ya(e,t){return"function"==typeof t?(e=e(),t(e),function(){t(null)}):null!=t?(e=e(),t.current=e,function(){t.current=null}):void 0}function $a(e,t,n){return n=null!=n?n.concat([e]):null,Va(4,4,Ya.bind(null,t,e),n)}function qa(){}function Xa(e,t){var n=Ia();t=void 0===t?null:t;var r=n.memoizedState;return null!==r&&null!==t&&Oa(t,r[1])?r[0]:(n.memoizedState=[e,t],e)}function Qa(e,t){var n=Ia();t=void 0===t?null:t;var r=n.memoizedState;return null!==r&&null!==t&&Oa(t,r[1])?r[0]:(e=e(),n.memoizedState=[e,t],e)}function Za(e,t,n){return 0==(21&ga)?(e.baseState&&(e.baseState=!1,xs=!0),e.memoizedState=n):(sr(n,t)||(n=ht(),ha.lanes|=n,Dl|=n,e.baseState=!0),t)}function Ja(e,t){var n=yt;yt=0!==n&&4>n?n:4,e(!0);var r=ma.transition;ma.transition={};try{e(!1),t()}finally{yt=n,ma.transition=r}}function es(){return Ia().memoizedState}function ts(e,t,n){var r=nc(e);if(n={lane:r,action:n,hasEagerState:!1,eagerState:null,next:null},rs(e))is(t,n);else if(null!==(n=Po(e,t,n,r))){rc(n,e,r,tc()),os(n,t,r)}}function ns(e,t,n){var r=nc(e),i={lane:r,action:n,hasEagerState:!1,eagerState:null,next:null};if(rs(e))is(t,i);else{var o=e.alternate;if(0===e.lanes&&(null===o||0===o.lanes)&&null!==(o=t.lastRenderedReducer))try{var a=t.lastRenderedState,s=o(a,n);if(i.hasEagerState=!0,i.eagerState=s,sr(s,a)){var l=t.interleaved;return null===l?(i.next=i,wo(t)):(i.next=l.next,l.next=i),void(t.interleaved=i)}}catch(e){}null!==(n=Po(e,t,i,r))&&(rc(n,e,r,i=tc()),os(n,t,r))}}function rs(e){var t=e.alternate;return e===ha||null!==t&&t===ha}function is(e,t){ya=ba=!0;var n=e.pending;null===n?t.next=t:(t.next=n.next,n.next=t),e.pending=t}function os(e,t,n){if(0!=(4194240&n)){var r=t.lanes;n|=r&=e.pendingLanes,t.lanes=n,bt(e,n)}}var as={readContext:To,useCallback:ja,useContext:ja,useEffect:ja,useImperativeHandle:ja,useInsertionEffect:ja,useLayoutEffect:ja,useMemo:ja,useReducer:ja,useRef:ja,useState:ja,useDebugValue:ja,useDeferredValue:ja,useTransition:ja,useMutableSource:ja,useSyncExternalStore:ja,useId:ja,unstable_isNewReconciler:!1},ss={readContext:To,useCallback:function(e,t){return Ta().memoizedState=[e,void 0===t?null:t],e},useContext:To,useEffect:Ha,useImperativeHandle:function(e,t,n){return n=null!=n?n.concat([e]):null,Ba(4194308,4,Ya.bind(null,t,e),n)},useLayoutEffect:function(e,t){return Ba(4194308,4,e,t)},useInsertionEffect:function(e,t){return Ba(4,2,e,t)},useMemo:function(e,t){var n=Ta();return t=void 0===t?null:t,e=e(),n.memoizedState=[e,t],e},useReducer:function(e,t,n){var r=Ta();return t=void 0!==n?n(t):t,r.memoizedState=r.baseState=t,e={pending:null,interleaved:null,lanes:0,dispatch:null,lastRenderedReducer:e,lastRenderedState:t},r.queue=e,e=e.dispatch=ts.bind(null,ha,e),[r.memoizedState,e]},useRef:function(e){return e={current:e},Ta().memoizedState=e},useState:Fa,useDebugValue:qa,useDeferredValue:function(e){return Ta().memoizedState=e},useTransition:function(){var e=Fa(!1),t=e[0];return e=Ja.bind(null,e[1]),Ta().memoizedState=e,[t,e]},useMutableSource:function(){},useSyncExternalStore:function(e,t,n){var r=ha,i=Ta();if(io){if(void 0===n)throw Error(o(407));n=n()}else{if(n=t(),null===Cl)throw Error(o(349));0!=(30&ga)||La(r,t,n)}i.memoizedState=n;var a={value:n,getSnapshot:t};return i.queue=a,Ha(ka.bind(null,r,a,e),[e]),r.flags|=2048,Ua(9,Ma.bind(null,r,a,n,t),void 0,null),n},useId:function(){var e=Ta(),t=Cl.identifierPrefix;if(io){var n=Qi;t=":"+t+"R"+(n=(Xi&~(1<<32-at(Xi)-1)).toString(32)+n),0<(n=xa++)&&(t+="H"+n.toString(32)),t+=":"}else t=":"+t+"r"+(n=_a++).toString(32)+":";return e.memoizedState=t},unstable_isNewReconciler:!1},ls={readContext:To,useCallback:Xa,useContext:To,useEffect:Ka,useImperativeHandle:$a,useInsertionEffect:Wa,useLayoutEffect:za,useMemo:Qa,useReducer:Pa,useRef:Ga,useState:function(){return Pa(wa)},useDebugValue:qa,useDeferredValue:function(e){return Za(Ia(),pa.memoizedState,e)},useTransition:function(){return[Pa(wa)[0],Ia().memoizedState]},useMutableSource:Na,useSyncExternalStore:Aa,useId:es,unstable_isNewReconciler:!1},cs={readContext:To,useCallback:Xa,useContext:To,useEffect:Ka,useImperativeHandle:$a,useInsertionEffect:Wa,useLayoutEffect:za,useMemo:Qa,useReducer:Ca,useRef:Ga,useState:function(){return Ca(wa)},useDebugValue:qa,useDeferredValue:function(e){var t=Ia();return null===pa?t.memoizedState=e:Za(t,pa.memoizedState,e)},useTransition:function(){return[Ca(wa)[0],Ia().memoizedState]},useMutableSource:Na,useSyncExternalStore:Aa,useId:es,unstable_isNewReconciler:!1};function us(e,t){try{var n="",r=t;do{n+=B(r),r=r.return}while(r);var i=n}catch(e){i="\nError generating stack: "+e.message+"\n"+e.stack}return{value:e,source:t,stack:i,digest:null}}function ds(e,t,n){return{value:e,source:null,stack:null!=n?n:null,digest:null!=t?t:null}}function fs(e,t){try{console.error(t.value)}catch(e){setTimeout((function(){throw e}))}}var ms="function"==typeof WeakMap?WeakMap:Map;function gs(e,t,n){(n=Mo(-1,n)).tag=3,n.payload={element:null};var r=t.value;return n.callback=function(){Wl||(Wl=!0,zl=r),fs(0,t)},n}function hs(e,t,n){(n=Mo(-1,n)).tag=3;var r=e.type.getDerivedStateFromError;if("function"==typeof r){var i=t.value;n.payload=function(){return r(i)},n.callback=function(){fs(0,t)}}var o=e.stateNode;return null!==o&&"function"==typeof o.componentDidCatch&&(n.callback=function(){fs(0,t),"function"!=typeof r&&(null===Yl?Yl=new Set([this]):Yl.add(this));var e=t.stack;this.componentDidCatch(t.value,{componentStack:null!==e?e:""})}),n}function ps(e,t,n){var r=e.pingCache;if(null===r){r=e.pingCache=new ms;var i=new Set;r.set(t,i)}else void 0===(i=r.get(t))&&(i=new Set,r.set(t,i));i.has(n)||(i.add(n),e=Tc.bind(null,e,t,n),t.then(e,e))}function vs(e){do{var t;if((t=13===e.tag)&&(t=null===(t=e.memoizedState)||null!==t.dehydrated),t)return e;e=e.return}while(null!==e);return null}function bs(e,t,n,r,i){return 0==(1&e.mode)?(e===t?e.flags|=65536:(e.flags|=128,n.flags|=131072,n.flags&=-52805,1===n.tag&&(null===n.alternate?n.tag=17:((t=Mo(-1,1)).tag=2,ko(n,t,1))),n.lanes|=1),e):(e.flags|=65536,e.lanes=i,e)}var ys=x.ReactCurrentOwner,xs=!1;function _s(e,t,n,r){t.child=null===e?Zo(t,null,n,r):Qo(t,e.child,n,r)}function js(e,t,n,r,i){n=n.render;var o=t.ref;return So(t,i),r=Ea(e,t,n,r,o,i),n=Sa(),null===e||xs?(io&&n&&eo(t),t.flags|=1,_s(e,t,r,i),t.child):(t.updateQueue=e.updateQueue,t.flags&=-2053,e.lanes&=~i,Ws(e,t,i))}function Os(e,t,n,r,i){if(null===e){var o=n.type;return"function"!=typeof o||Lc(o)||void 0!==o.defaultProps||null!==n.compare||void 0!==n.defaultProps?((e=kc(n.type,null,r,t,t.mode,i)).ref=t.ref,e.return=t,t.child=e):(t.tag=15,t.type=o,Es(e,t,o,r,i))}if(o=e.child,0==(e.lanes&i)){var a=o.memoizedProps;if((n=null!==(n=n.compare)?n:lr)(a,r)&&e.ref===t.ref)return Ws(e,t,i)}return t.flags|=1,(e=Mc(o,r)).ref=t.ref,e.return=t,t.child=e}function Es(e,t,n,r,i){if(null!==e){var o=e.memoizedProps;if(lr(o,r)&&e.ref===t.ref){if(xs=!1,t.pendingProps=r=o,0==(e.lanes&i))return t.lanes=e.lanes,Ws(e,t,i);0!=(131072&e.flags)&&(xs=!0)}}return Is(e,t,n,r,i)}function Ss(e,t,n){var r=t.pendingProps,i=r.children,o=null!==e?e.memoizedState:null;if("hidden"===r.mode)if(0==(1&t.mode))t.memoizedState={baseLanes:0,cachePool:null,transitions:null},Ti(Ml,Ll),Ll|=n;else{if(0==(1073741824&n))return e=null!==o?o.baseLanes|n:n,t.lanes=t.childLanes=1073741824,t.memoizedState={baseLanes:e,cachePool:null,transitions:null},t.updateQueue=null,Ti(Ml,Ll),Ll|=e,null;t.memoizedState={baseLanes:0,cachePool:null,transitions:null},r=null!==o?o.baseLanes:n,Ti(Ml,Ll),Ll|=r}else null!==o?(r=o.baseLanes|n,t.memoizedState=null):r=n,Ti(Ml,Ll),Ll|=r;return _s(e,t,i,n),t.child}function Ts(e,t){var n=t.ref;(null===e&&null!==n||null!==e&&e.ref!==n)&&(t.flags|=512,t.flags|=2097152)}function Is(e,t,n,r,i){var o=Ai(n)?Ci:wi.current;return o=Ni(t,o),So(t,i),n=Ea(e,t,n,r,o,i),r=Sa(),null===e||xs?(io&&r&&eo(t),t.flags|=1,_s(e,t,n,i),t.child):(t.updateQueue=e.updateQueue,t.flags&=-2053,e.lanes&=~i,Ws(e,t,i))}function ws(e,t,n,r,i){if(Ai(n)){var o=!0;Ri(t)}else o=!1;if(So(t,i),null===t.stateNode)Ks(e,t),Ko(t,n,r),zo(t,n,r,i),r=!0;else if(null===e){var a=t.stateNode,s=t.memoizedProps;a.props=s;var l=a.context,c=n.contextType;"object"==typeof c&&null!==c?c=To(c):c=Ni(t,c=Ai(n)?Ci:wi.current);var u=n.getDerivedStateFromProps,d="function"==typeof u||"function"==typeof a.getSnapshotBeforeUpdate;d||"function"!=typeof a.UNSAFE_componentWillReceiveProps&&"function"!=typeof a.componentWillReceiveProps||(s!==r||l!==c)&&Wo(t,a,r,c),No=!1;var f=t.memoizedState;a.state=f,Fo(t,r,a,i),l=t.memoizedState,s!==r||f!==l||Pi.current||No?("function"==typeof u&&(Bo(t,n,u,r),l=t.memoizedState),(s=No||Ho(t,n,s,r,f,l,c))?(d||"function"!=typeof a.UNSAFE_componentWillMount&&"function"!=typeof a.componentWillMount||("function"==typeof a.componentWillMount&&a.componentWillMount(),"function"==typeof a.UNSAFE_componentWillMount&&a.UNSAFE_componentWillMount()),"function"==typeof a.componentDidMount&&(t.flags|=4194308)):("function"==typeof a.componentDidMount&&(t.flags|=4194308),t.memoizedProps=r,t.memoizedState=l),a.props=r,a.state=l,a.context=c,r=s):("function"==typeof a.componentDidMount&&(t.flags|=4194308),r=!1)}else{a=t.stateNode,Lo(e,t),s=t.memoizedProps,c=t.type===t.elementType?s:vo(t.type,s),a.props=c,d=t.pendingProps,f=a.context,"object"==typeof(l=n.contextType)&&null!==l?l=To(l):l=Ni(t,l=Ai(n)?Ci:wi.current);var m=n.getDerivedStateFromProps;(u="function"==typeof m||"function"==typeof a.getSnapshotBeforeUpdate)||"function"!=typeof a.UNSAFE_componentWillReceiveProps&&"function"!=typeof a.componentWillReceiveProps||(s!==d||f!==l)&&Wo(t,a,r,l),No=!1,f=t.memoizedState,a.state=f,Fo(t,r,a,i);var g=t.memoizedState;s!==d||f!==g||Pi.current||No?("function"==typeof m&&(Bo(t,n,m,r),g=t.memoizedState),(c=No||Ho(t,n,c,r,f,g,l)||!1)?(u||"function"!=typeof a.UNSAFE_componentWillUpdate&&"function"!=typeof a.componentWillUpdate||("function"==typeof a.componentWillUpdate&&a.componentWillUpdate(r,g,l),"function"==typeof a.UNSAFE_componentWillUpdate&&a.UNSAFE_componentWillUpdate(r,g,l)),"function"==typeof a.componentDidUpdate&&(t.flags|=4),"function"==typeof a.getSnapshotBeforeUpdate&&(t.flags|=1024)):("function"!=typeof a.componentDidUpdate||s===e.memoizedProps&&f===e.memoizedState||(t.flags|=4),"function"!=typeof a.getSnapshotBeforeUpdate||s===e.memoizedProps&&f===e.memoizedState||(t.flags|=1024),t.memoizedProps=r,t.memoizedState=g),a.props=r,a.state=g,a.context=l,r=c):("function"!=typeof a.componentDidUpdate||s===e.memoizedProps&&f===e.memoizedState||(t.flags|=4),"function"!=typeof a.getSnapshotBeforeUpdate||s===e.memoizedProps&&f===e.memoizedState||(t.flags|=1024),r=!1)}return Ps(e,t,n,r,o,i)}function Ps(e,t,n,r,i,o){Ts(e,t);var a=0!=(128&t.flags);if(!r&&!a)return i&&Di(t,n,!1),Ws(e,t,o);r=t.stateNode,ys.current=t;var s=a&&"function"!=typeof n.getDerivedStateFromError?null:r.render();return t.flags|=1,null!==e&&a?(t.child=Qo(t,e.child,null,o),t.child=Qo(t,null,s,o)):_s(e,t,s,o),t.memoizedState=r.state,i&&Di(t,n,!0),t.child}function Cs(e){var t=e.stateNode;t.pendingContext?Mi(0,t.pendingContext,t.pendingContext!==t.context):t.context&&Mi(0,t.context,!1),ia(e,t.containerInfo)}function Ns(e,t,n,r,i){return go(),ho(i),t.flags|=256,_s(e,t,n,r),t.child}var As,Ls,Ms,ks,Rs={dehydrated:null,treeContext:null,retryLane:0};function Ds(e){return{baseLanes:e,cachePool:null,transitions:null}}function Fs(e,t,n){var r,i=t.pendingProps,a=la.current,s=!1,l=0!=(128&t.flags);if((r=l)||(r=(null===e||null!==e.memoizedState)&&0!=(2&a)),r?(s=!0,t.flags&=-129):null!==e&&null===e.memoizedState||(a|=1),Ti(la,1&a),null===e)return co(t),null!==(e=t.memoizedState)&&null!==(e=e.dehydrated)?(0==(1&t.mode)?t.lanes=1:"$!"===e.data?t.lanes=8:t.lanes=1073741824,null):(l=i.children,e=i.fallback,s?(i=t.mode,s=t.child,l={mode:"hidden",children:l},0==(1&i)&&null!==s?(s.childLanes=0,s.pendingProps=l):s=Dc(l,i,0,null),e=Rc(e,i,n,null),s.return=t,e.return=t,s.sibling=e,t.child=s,t.child.memoizedState=Ds(n),t.memoizedState=Rs,e):Us(t,l));if(null!==(a=e.memoizedState)&&null!==(r=a.dehydrated))return function(e,t,n,r,i,a,s){if(n)return 256&t.flags?(t.flags&=-257,Gs(e,t,s,r=ds(Error(o(422))))):null!==t.memoizedState?(t.child=e.child,t.flags|=128,null):(a=r.fallback,i=t.mode,r=Dc({mode:"visible",children:r.children},i,0,null),(a=Rc(a,i,s,null)).flags|=2,r.return=t,a.return=t,r.sibling=a,t.child=r,0!=(1&t.mode)&&Qo(t,e.child,null,s),t.child.memoizedState=Ds(s),t.memoizedState=Rs,a);if(0==(1&t.mode))return Gs(e,t,s,null);if("$!"===i.data){if(r=i.nextSibling&&i.nextSibling.dataset)var l=r.dgst;return r=l,Gs(e,t,s,r=ds(a=Error(o(419)),r,void 0))}if(l=0!=(s&e.childLanes),xs||l){if(null!==(r=Cl)){switch(s&-s){case 4:i=2;break;case 16:i=8;break;case 64:case 128:case 256:case 512:case 1024:case 2048:case 4096:case 8192:case 16384:case 32768:case 65536:case 131072:case 262144:case 524288:case 1048576:case 2097152:case 4194304:case 8388608:case 16777216:case 33554432:case 67108864:i=32;break;case 536870912:i=268435456;break;default:i=0}0!==(i=0!=(i&(r.suspendedLanes|s))?0:i)&&i!==a.retryLane&&(a.retryLane=i,Co(e,i),rc(r,e,i,-1))}return pc(),Gs(e,t,s,r=ds(Error(o(421))))}return"$?"===i.data?(t.flags|=128,t.child=e.child,t=wc.bind(null,e),i._reactRetry=t,null):(e=a.treeContext,ro=ci(i.nextSibling),no=t,io=!0,oo=null,null!==e&&(Yi[$i++]=Xi,Yi[$i++]=Qi,Yi[$i++]=qi,Xi=e.id,Qi=e.overflow,qi=t),t=Us(t,r.children),t.flags|=4096,t)}(e,t,l,i,r,a,n);if(s){s=i.fallback,l=t.mode,r=(a=e.child).sibling;var c={mode:"hidden",children:i.children};return 0==(1&l)&&t.child!==a?((i=t.child).childLanes=0,i.pendingProps=c,t.deletions=null):(i=Mc(a,c)).subtreeFlags=14680064&a.subtreeFlags,null!==r?s=Mc(r,s):(s=Rc(s,l,n,null)).flags|=2,s.return=t,i.return=t,i.sibling=s,t.child=i,i=s,s=t.child,l=null===(l=e.child.memoizedState)?Ds(n):{baseLanes:l.baseLanes|n,cachePool:null,transitions:l.transitions},s.memoizedState=l,s.childLanes=e.childLanes&~n,t.memoizedState=Rs,i}return e=(s=e.child).sibling,i=Mc(s,{mode:"visible",children:i.children}),0==(1&t.mode)&&(i.lanes=n),i.return=t,i.sibling=null,null!==e&&(null===(n=t.deletions)?(t.deletions=[e],t.flags|=16):n.push(e)),t.child=i,t.memoizedState=null,i}function Us(e,t){return(t=Dc({mode:"visible",children:t},e.mode,0,null)).return=e,e.child=t}function Gs(e,t,n,r){return null!==r&&ho(r),Qo(t,e.child,null,n),(e=Us(t,t.pendingProps.children)).flags|=2,t.memoizedState=null,e}function Bs(e,t,n){e.lanes|=t;var r=e.alternate;null!==r&&(r.lanes|=t),Eo(e.return,t,n)}function Vs(e,t,n,r,i){var o=e.memoizedState;null===o?e.memoizedState={isBackwards:t,rendering:null,renderingStartTime:0,last:r,tail:n,tailMode:i}:(o.isBackwards=t,o.rendering=null,o.renderingStartTime=0,o.last=r,o.tail=n,o.tailMode=i)}function Hs(e,t,n){var r=t.pendingProps,i=r.revealOrder,o=r.tail;if(_s(e,t,r.children,n),0!=(2&(r=la.current)))r=1&r|2,t.flags|=128;else{if(null!==e&&0!=(128&e.flags))e:for(e=t.child;null!==e;){if(13===e.tag)null!==e.memoizedState&&Bs(e,n,t);else if(19===e.tag)Bs(e,n,t);else if(null!==e.child){e.child.return=e,e=e.child;continue}if(e===t)break e;for(;null===e.sibling;){if(null===e.return||e.return===t)break e;e=e.return}e.sibling.return=e.return,e=e.sibling}r&=1}if(Ti(la,r),0==(1&t.mode))t.memoizedState=null;else switch(i){case"forwards":for(n=t.child,i=null;null!==n;)null!==(e=n.alternate)&&null===ca(e)&&(i=n),n=n.sibling;null===(n=i)?(i=t.child,t.child=null):(i=n.sibling,n.sibling=null),Vs(t,!1,i,n,o);break;case"backwards":for(n=null,i=t.child,t.child=null;null!==i;){if(null!==(e=i.alternate)&&null===ca(e)){t.child=i;break}e=i.sibling,i.sibling=n,n=i,i=e}Vs(t,!0,n,null,o);break;case"together":Vs(t,!1,null,null,void 0);break;default:t.memoizedState=null}return t.child}function Ks(e,t){0==(1&t.mode)&&null!==e&&(e.alternate=null,t.alternate=null,t.flags|=2)}function Ws(e,t,n){if(null!==e&&(t.dependencies=e.dependencies),Dl|=t.lanes,0==(n&t.childLanes))return null;if(null!==e&&t.child!==e.child)throw Error(o(153));if(null!==t.child){for(n=Mc(e=t.child,e.pendingProps),t.child=n,n.return=t;null!==e.sibling;)e=e.sibling,(n=n.sibling=Mc(e,e.pendingProps)).return=t;n.sibling=null}return t.child}function zs(e,t){if(!io)switch(e.tailMode){case"hidden":t=e.tail;for(var n=null;null!==t;)null!==t.alternate&&(n=t),t=t.sibling;null===n?e.tail=null:n.sibling=null;break;case"collapsed":n=e.tail;for(var r=null;null!==n;)null!==n.alternate&&(r=n),n=n.sibling;null===r?t||null===e.tail?e.tail=null:e.tail.sibling=null:r.sibling=null}}function Ys(e){var t=null!==e.alternate&&e.alternate.child===e.child,n=0,r=0;if(t)for(var i=e.child;null!==i;)n|=i.lanes|i.childLanes,r|=14680064&i.subtreeFlags,r|=14680064&i.flags,i.return=e,i=i.sibling;else for(i=e.child;null!==i;)n|=i.lanes|i.childLanes,r|=i.subtreeFlags,r|=i.flags,i.return=e,i=i.sibling;return e.subtreeFlags|=r,e.childLanes=n,t}function $s(e,t,n){var r=t.pendingProps;switch(to(t),t.tag){case 2:case 16:case 15:case 0:case 11:case 7:case 8:case 12:case 9:case 14:return Ys(t),null;case 1:case 17:return Ai(t.type)&&Li(),Ys(t),null;case 3:return r=t.stateNode,oa(),Si(Pi),Si(wi),da(),r.pendingContext&&(r.context=r.pendingContext,r.pendingContext=null),null!==e&&null!==e.child||(fo(t)?t.flags|=4:null===e||e.memoizedState.isDehydrated&&0==(256&t.flags)||(t.flags|=1024,null!==oo&&(sc(oo),oo=null))),Ls(e,t),Ys(t),null;case 5:sa(t);var i=ra(na.current);if(n=t.type,null!==e&&null!=t.stateNode)Ms(e,t,n,r,i),e.ref!==t.ref&&(t.flags|=512,t.flags|=2097152);else{if(!r){if(null===t.stateNode)throw Error(o(166));return Ys(t),null}if(e=ra(ea.current),fo(t)){r=t.stateNode,n=t.type;var a=t.memoizedProps;switch(r[fi]=t,r[mi]=a,e=0!=(1&t.mode),n){case"dialog":Ur("cancel",r),Ur("close",r);break;case"iframe":case"object":case"embed":Ur("load",r);break;case"video":case"audio":for(i=0;i<kr.length;i++)Ur(kr[i],r);break;case"source":Ur("error",r);break;case"img":case"image":case"link":Ur("error",r),Ur("load",r);break;case"details":Ur("toggle",r);break;case"input":X(r,a),Ur("invalid",r);break;case"select":r._wrapperState={wasMultiple:!!a.multiple},Ur("invalid",r);break;case"textarea":ie(r,a),Ur("invalid",r)}for(var l in be(n,a),i=null,a)if(a.hasOwnProperty(l)){var c=a[l];"children"===l?"string"==typeof c?r.textContent!==c&&(!0!==a.suppressHydrationWarning&&Zr(r.textContent,c,e),i=["children",c]):"number"==typeof c&&r.textContent!==""+c&&(!0!==a.suppressHydrationWarning&&Zr(r.textContent,c,e),i=["children",""+c]):s.hasOwnProperty(l)&&null!=c&&"onScroll"===l&&Ur("scroll",r)}switch(n){case"input":z(r),J(r,a,!0);break;case"textarea":z(r),ae(r);break;case"select":case"option":break;default:"function"==typeof a.onClick&&(r.onclick=Jr)}r=i,t.updateQueue=r,null!==r&&(t.flags|=4)}else{l=9===i.nodeType?i:i.ownerDocument,"http://www.w3.org/1999/xhtml"===e&&(e=se(n)),"http://www.w3.org/1999/xhtml"===e?"script"===n?((e=l.createElement("div")).innerHTML="<script><\/script>",e=e.removeChild(e.firstChild)):"string"==typeof r.is?e=l.createElement(n,{is:r.is}):(e=l.createElement(n),"select"===n&&(l=e,r.multiple?l.multiple=!0:r.size&&(l.size=r.size))):e=l.createElementNS(e,n),e[fi]=t,e[mi]=r,As(e,t,!1,!1),t.stateNode=e;e:{switch(l=ye(n,r),n){case"dialog":Ur("cancel",e),Ur("close",e),i=r;break;case"iframe":case"object":case"embed":Ur("load",e),i=r;break;case"video":case"audio":for(i=0;i<kr.length;i++)Ur(kr[i],e);i=r;break;case"source":Ur("error",e),i=r;break;case"img":case"image":case"link":Ur("error",e),Ur("load",e),i=r;break;case"details":Ur("toggle",e),i=r;break;case"input":X(e,r),i=q(e,r),Ur("invalid",e);break;case"option":default:i=r;break;case"select":e._wrapperState={wasMultiple:!!r.multiple},i=D({},r,{value:void 0}),Ur("invalid",e);break;case"textarea":ie(e,r),i=re(e,r),Ur("invalid",e)}for(a in be(n,i),c=i)if(c.hasOwnProperty(a)){var u=c[a];"style"===a?pe(e,u):"dangerouslySetInnerHTML"===a?null!=(u=u?u.__html:void 0)&&de(e,u):"children"===a?"string"==typeof u?("textarea"!==n||""!==u)&&fe(e,u):"number"==typeof u&&fe(e,""+u):"suppressContentEditableWarning"!==a&&"suppressHydrationWarning"!==a&&"autoFocus"!==a&&(s.hasOwnProperty(a)?null!=u&&"onScroll"===a&&Ur("scroll",e):null!=u&&y(e,a,u,l))}switch(n){case"input":z(e),J(e,r,!1);break;case"textarea":z(e),ae(e);break;case"option":null!=r.value&&e.setAttribute("value",""+K(r.value));break;case"select":e.multiple=!!r.multiple,null!=(a=r.value)?ne(e,!!r.multiple,a,!1):null!=r.defaultValue&&ne(e,!!r.multiple,r.defaultValue,!0);break;default:"function"==typeof i.onClick&&(e.onclick=Jr)}switch(n){case"button":case"input":case"select":case"textarea":r=!!r.autoFocus;break e;case"img":r=!0;break e;default:r=!1}}r&&(t.flags|=4)}null!==t.ref&&(t.flags|=512,t.flags|=2097152)}return Ys(t),null;case 6:if(e&&null!=t.stateNode)ks(e,t,e.memoizedProps,r);else{if("string"!=typeof r&&null===t.stateNode)throw Error(o(166));if(n=ra(na.current),ra(ea.current),fo(t)){if(r=t.stateNode,n=t.memoizedProps,r[fi]=t,(a=r.nodeValue!==n)&&null!==(e=no))switch(e.tag){case 3:Zr(r.nodeValue,n,0!=(1&e.mode));break;case 5:!0!==e.memoizedProps.suppressHydrationWarning&&Zr(r.nodeValue,n,0!=(1&e.mode))}a&&(t.flags|=4)}else(r=(9===n.nodeType?n:n.ownerDocument).createTextNode(r))[fi]=t,t.stateNode=r}return Ys(t),null;case 13:if(Si(la),r=t.memoizedState,null===e||null!==e.memoizedState&&null!==e.memoizedState.dehydrated){if(io&&null!==ro&&0!=(1&t.mode)&&0==(128&t.flags))mo(),go(),t.flags|=98560,a=!1;else if(a=fo(t),null!==r&&null!==r.dehydrated){if(null===e){if(!a)throw Error(o(318));if(!(a=null!==(a=t.memoizedState)?a.dehydrated:null))throw Error(o(317));a[fi]=t}else go(),0==(128&t.flags)&&(t.memoizedState=null),t.flags|=4;Ys(t),a=!1}else null!==oo&&(sc(oo),oo=null),a=!0;if(!a)return 65536&t.flags?t:null}return 0!=(128&t.flags)?(t.lanes=n,t):((r=null!==r)!==(null!==e&&null!==e.memoizedState)&&r&&(t.child.flags|=8192,0!=(1&t.mode)&&(null===e||0!=(1&la.current)?0===kl&&(kl=3):pc())),null!==t.updateQueue&&(t.flags|=4),Ys(t),null);case 4:return oa(),Ls(e,t),null===e&&Vr(t.stateNode.containerInfo),Ys(t),null;case 10:return Oo(t.type._context),Ys(t),null;case 19:if(Si(la),null===(a=t.memoizedState))return Ys(t),null;if(r=0!=(128&t.flags),null===(l=a.rendering))if(r)zs(a,!1);else{if(0!==kl||null!==e&&0!=(128&e.flags))for(e=t.child;null!==e;){if(null!==(l=ca(e))){for(t.flags|=128,zs(a,!1),null!==(r=l.updateQueue)&&(t.updateQueue=r,t.flags|=4),t.subtreeFlags=0,r=n,n=t.child;null!==n;)e=r,(a=n).flags&=14680066,null===(l=a.alternate)?(a.childLanes=0,a.lanes=e,a.child=null,a.subtreeFlags=0,a.memoizedProps=null,a.memoizedState=null,a.updateQueue=null,a.dependencies=null,a.stateNode=null):(a.childLanes=l.childLanes,a.lanes=l.lanes,a.child=l.child,a.subtreeFlags=0,a.deletions=null,a.memoizedProps=l.memoizedProps,a.memoizedState=l.memoizedState,a.updateQueue=l.updateQueue,a.type=l.type,e=l.dependencies,a.dependencies=null===e?null:{lanes:e.lanes,firstContext:e.firstContext}),n=n.sibling;return Ti(la,1&la.current|2),t.child}e=e.sibling}null!==a.tail&&Qe()>Hl&&(t.flags|=128,r=!0,zs(a,!1),t.lanes=4194304)}else{if(!r)if(null!==(e=ca(l))){if(t.flags|=128,r=!0,null!==(n=e.updateQueue)&&(t.updateQueue=n,t.flags|=4),zs(a,!0),null===a.tail&&"hidden"===a.tailMode&&!l.alternate&&!io)return Ys(t),null}else 2*Qe()-a.renderingStartTime>Hl&&1073741824!==n&&(t.flags|=128,r=!0,zs(a,!1),t.lanes=4194304);a.isBackwards?(l.sibling=t.child,t.child=l):(null!==(n=a.last)?n.sibling=l:t.child=l,a.last=l)}return null!==a.tail?(t=a.tail,a.rendering=t,a.tail=t.sibling,a.renderingStartTime=Qe(),t.sibling=null,n=la.current,Ti(la,r?1&n|2:1&n),t):(Ys(t),null);case 22:case 23:return fc(),r=null!==t.memoizedState,null!==e&&null!==e.memoizedState!==r&&(t.flags|=8192),r&&0!=(1&t.mode)?0!=(1073741824&Ll)&&(Ys(t),6&t.subtreeFlags&&(t.flags|=8192)):Ys(t),null;case 24:case 25:return null}throw Error(o(156,t.tag))}function qs(e,t){switch(to(t),t.tag){case 1:return Ai(t.type)&&Li(),65536&(e=t.flags)?(t.flags=-65537&e|128,t):null;case 3:return oa(),Si(Pi),Si(wi),da(),0!=(65536&(e=t.flags))&&0==(128&e)?(t.flags=-65537&e|128,t):null;case 5:return sa(t),null;case 13:if(Si(la),null!==(e=t.memoizedState)&&null!==e.dehydrated){if(null===t.alternate)throw Error(o(340));go()}return 65536&(e=t.flags)?(t.flags=-65537&e|128,t):null;case 19:return Si(la),null;case 4:return oa(),null;case 10:return Oo(t.type._context),null;case 22:case 23:return fc(),null;default:return null}}As=function(e,t){for(var n=t.child;null!==n;){if(5===n.tag||6===n.tag)e.appendChild(n.stateNode);else if(4!==n.tag&&null!==n.child){n.child.return=n,n=n.child;continue}if(n===t)break;for(;null===n.sibling;){if(null===n.return||n.return===t)return;n=n.return}n.sibling.return=n.return,n=n.sibling}},Ls=function(){},Ms=function(e,t,n,r){var i=e.memoizedProps;if(i!==r){e=t.stateNode,ra(ea.current);var o,a=null;switch(n){case"input":i=q(e,i),r=q(e,r),a=[];break;case"select":i=D({},i,{value:void 0}),r=D({},r,{value:void 0}),a=[];break;case"textarea":i=re(e,i),r=re(e,r),a=[];break;default:"function"!=typeof i.onClick&&"function"==typeof r.onClick&&(e.onclick=Jr)}for(u in be(n,r),n=null,i)if(!r.hasOwnProperty(u)&&i.hasOwnProperty(u)&&null!=i[u])if("style"===u){var l=i[u];for(o in l)l.hasOwnProperty(o)&&(n||(n={}),n[o]="")}else"dangerouslySetInnerHTML"!==u&&"children"!==u&&"suppressContentEditableWarning"!==u&&"suppressHydrationWarning"!==u&&"autoFocus"!==u&&(s.hasOwnProperty(u)?a||(a=[]):(a=a||[]).push(u,null));for(u in r){var c=r[u];if(l=null!=i?i[u]:void 0,r.hasOwnProperty(u)&&c!==l&&(null!=c||null!=l))if("style"===u)if(l){for(o in l)!l.hasOwnProperty(o)||c&&c.hasOwnProperty(o)||(n||(n={}),n[o]="");for(o in c)c.hasOwnProperty(o)&&l[o]!==c[o]&&(n||(n={}),n[o]=c[o])}else n||(a||(a=[]),a.push(u,n)),n=c;else"dangerouslySetInnerHTML"===u?(c=c?c.__html:void 0,l=l?l.__html:void 0,null!=c&&l!==c&&(a=a||[]).push(u,c)):"children"===u?"string"!=typeof c&&"number"!=typeof c||(a=a||[]).push(u,""+c):"suppressContentEditableWarning"!==u&&"suppressHydrationWarning"!==u&&(s.hasOwnProperty(u)?(null!=c&&"onScroll"===u&&Ur("scroll",e),a||l===c||(a=[])):(a=a||[]).push(u,c))}n&&(a=a||[]).push("style",n);var u=a;(t.updateQueue=u)&&(t.flags|=4)}},ks=function(e,t,n,r){n!==r&&(t.flags|=4)};var Xs=!1,Qs=!1,Zs="function"==typeof WeakSet?WeakSet:Set,Js=null;function el(e,t){var n=e.ref;if(null!==n)if("function"==typeof n)try{n(null)}catch(n){Sc(e,t,n)}else n.current=null}function tl(e,t,n){try{n()}catch(n){Sc(e,t,n)}}var nl=!1;function rl(e,t,n){var r=t.updateQueue;if(null!==(r=null!==r?r.lastEffect:null)){var i=r=r.next;do{if((i.tag&e)===e){var o=i.destroy;i.destroy=void 0,void 0!==o&&tl(t,n,o)}i=i.next}while(i!==r)}}function il(e,t){if(null!==(t=null!==(t=t.updateQueue)?t.lastEffect:null)){var n=t=t.next;do{if((n.tag&e)===e){var r=n.create;n.destroy=r()}n=n.next}while(n!==t)}}function ol(e){var t=e.ref;if(null!==t){var n=e.stateNode;e.tag,e=n,"function"==typeof t?t(e):t.current=e}}function al(e){var t=e.alternate;null!==t&&(e.alternate=null,al(t)),e.child=null,e.deletions=null,e.sibling=null,5===e.tag&&(null!==(t=e.stateNode)&&(delete t[fi],delete t[mi],delete t[hi],delete t[pi],delete t[vi])),e.stateNode=null,e.return=null,e.dependencies=null,e.memoizedProps=null,e.memoizedState=null,e.pendingProps=null,e.stateNode=null,e.updateQueue=null}function sl(e){return 5===e.tag||3===e.tag||4===e.tag}function ll(e){e:for(;;){for(;null===e.sibling;){if(null===e.return||sl(e.return))return null;e=e.return}for(e.sibling.return=e.return,e=e.sibling;5!==e.tag&&6!==e.tag&&18!==e.tag;){if(2&e.flags)continue e;if(null===e.child||4===e.tag)continue e;e.child.return=e,e=e.child}if(!(2&e.flags))return e.stateNode}}function cl(e,t,n){var r=e.tag;if(5===r||6===r)e=e.stateNode,t?8===n.nodeType?n.parentNode.insertBefore(e,t):n.insertBefore(e,t):(8===n.nodeType?(t=n.parentNode).insertBefore(e,n):(t=n).appendChild(e),null!=(n=n._reactRootContainer)||null!==t.onclick||(t.onclick=Jr));else if(4!==r&&null!==(e=e.child))for(cl(e,t,n),e=e.sibling;null!==e;)cl(e,t,n),e=e.sibling}function ul(e,t,n){var r=e.tag;if(5===r||6===r)e=e.stateNode,t?n.insertBefore(e,t):n.appendChild(e);else if(4!==r&&null!==(e=e.child))for(ul(e,t,n),e=e.sibling;null!==e;)ul(e,t,n),e=e.sibling}var dl=null,fl=!1;function ml(e,t,n){for(n=n.child;null!==n;)gl(e,t,n),n=n.sibling}function gl(e,t,n){if(ot&&"function"==typeof ot.onCommitFiberUnmount)try{ot.onCommitFiberUnmount(it,n)}catch(e){}switch(n.tag){case 5:Qs||el(n,t);case 6:var r=dl,i=fl;dl=null,ml(e,t,n),fl=i,null!==(dl=r)&&(fl?(e=dl,n=n.stateNode,8===e.nodeType?e.parentNode.removeChild(n):e.removeChild(n)):dl.removeChild(n.stateNode));break;case 18:null!==dl&&(fl?(e=dl,n=n.stateNode,8===e.nodeType?li(e.parentNode,n):1===e.nodeType&&li(e,n),Vt(e)):li(dl,n.stateNode));break;case 4:r=dl,i=fl,dl=n.stateNode.containerInfo,fl=!0,ml(e,t,n),dl=r,fl=i;break;case 0:case 11:case 14:case 15:if(!Qs&&(null!==(r=n.updateQueue)&&null!==(r=r.lastEffect))){i=r=r.next;do{var o=i,a=o.destroy;o=o.tag,void 0!==a&&(0!=(2&o)||0!=(4&o))&&tl(n,t,a),i=i.next}while(i!==r)}ml(e,t,n);break;case 1:if(!Qs&&(el(n,t),"function"==typeof(r=n.stateNode).componentWillUnmount))try{r.props=n.memoizedProps,r.state=n.memoizedState,r.componentWillUnmount()}catch(e){Sc(n,t,e)}ml(e,t,n);break;case 21:ml(e,t,n);break;case 22:1&n.mode?(Qs=(r=Qs)||null!==n.memoizedState,ml(e,t,n),Qs=r):ml(e,t,n);break;default:ml(e,t,n)}}function hl(e){var t=e.updateQueue;if(null!==t){e.updateQueue=null;var n=e.stateNode;null===n&&(n=e.stateNode=new Zs),t.forEach((function(t){var r=Pc.bind(null,e,t);n.has(t)||(n.add(t),t.then(r,r))}))}}function pl(e,t){var n=t.deletions;if(null!==n)for(var r=0;r<n.length;r++){var i=n[r];try{var a=e,s=t,l=s;e:for(;null!==l;){switch(l.tag){case 5:dl=l.stateNode,fl=!1;break e;case 3:case 4:dl=l.stateNode.containerInfo,fl=!0;break e}l=l.return}if(null===dl)throw Error(o(160));gl(a,s,i),dl=null,fl=!1;var c=i.alternate;null!==c&&(c.return=null),i.return=null}catch(e){Sc(i,t,e)}}if(12854&t.subtreeFlags)for(t=t.child;null!==t;)vl(t,e),t=t.sibling}function vl(e,t){var n=e.alternate,r=e.flags;switch(e.tag){case 0:case 11:case 14:case 15:if(pl(t,e),bl(e),4&r){try{rl(3,e,e.return),il(3,e)}catch(t){Sc(e,e.return,t)}try{rl(5,e,e.return)}catch(t){Sc(e,e.return,t)}}break;case 1:pl(t,e),bl(e),512&r&&null!==n&&el(n,n.return);break;case 5:if(pl(t,e),bl(e),512&r&&null!==n&&el(n,n.return),32&e.flags){var i=e.stateNode;try{fe(i,"")}catch(t){Sc(e,e.return,t)}}if(4&r&&null!=(i=e.stateNode)){var a=e.memoizedProps,s=null!==n?n.memoizedProps:a,l=e.type,c=e.updateQueue;if(e.updateQueue=null,null!==c)try{"input"===l&&"radio"===a.type&&null!=a.name&&Q(i,a),ye(l,s);var u=ye(l,a);for(s=0;s<c.length;s+=2){var d=c[s],f=c[s+1];"style"===d?pe(i,f):"dangerouslySetInnerHTML"===d?de(i,f):"children"===d?fe(i,f):y(i,d,f,u)}switch(l){case"input":Z(i,a);break;case"textarea":oe(i,a);break;case"select":var m=i._wrapperState.wasMultiple;i._wrapperState.wasMultiple=!!a.multiple;var g=a.value;null!=g?ne(i,!!a.multiple,g,!1):m!==!!a.multiple&&(null!=a.defaultValue?ne(i,!!a.multiple,a.defaultValue,!0):ne(i,!!a.multiple,a.multiple?[]:"",!1))}i[mi]=a}catch(t){Sc(e,e.return,t)}}break;case 6:if(pl(t,e),bl(e),4&r){if(null===e.stateNode)throw Error(o(162));i=e.stateNode,a=e.memoizedProps;try{i.nodeValue=a}catch(t){Sc(e,e.return,t)}}break;case 3:if(pl(t,e),bl(e),4&r&&null!==n&&n.memoizedState.isDehydrated)try{Vt(t.containerInfo)}catch(t){Sc(e,e.return,t)}break;case 4:default:pl(t,e),bl(e);break;case 13:pl(t,e),bl(e),8192&(i=e.child).flags&&(a=null!==i.memoizedState,i.stateNode.isHidden=a,!a||null!==i.alternate&&null!==i.alternate.memoizedState||(Vl=Qe())),4&r&&hl(e);break;case 22:if(d=null!==n&&null!==n.memoizedState,1&e.mode?(Qs=(u=Qs)||d,pl(t,e),Qs=u):pl(t,e),bl(e),8192&r){if(u=null!==e.memoizedState,(e.stateNode.isHidden=u)&&!d&&0!=(1&e.mode))for(Js=e,d=e.child;null!==d;){for(f=Js=d;null!==Js;){switch(g=(m=Js).child,m.tag){case 0:case 11:case 14:case 15:rl(4,m,m.return);break;case 1:el(m,m.return);var h=m.stateNode;if("function"==typeof h.componentWillUnmount){r=m,n=m.return;try{t=r,h.props=t.memoizedProps,h.state=t.memoizedState,h.componentWillUnmount()}catch(e){Sc(r,n,e)}}break;case 5:el(m,m.return);break;case 22:if(null!==m.memoizedState){jl(f);continue}}null!==g?(g.return=m,Js=g):jl(f)}d=d.sibling}e:for(d=null,f=e;;){if(5===f.tag){if(null===d){d=f;try{i=f.stateNode,u?"function"==typeof(a=i.style).setProperty?a.setProperty("display","none","important"):a.display="none":(l=f.stateNode,s=null!=(c=f.memoizedProps.style)&&c.hasOwnProperty("display")?c.display:null,l.style.display=he("display",s))}catch(t){Sc(e,e.return,t)}}}else if(6===f.tag){if(null===d)try{f.stateNode.nodeValue=u?"":f.memoizedProps}catch(t){Sc(e,e.return,t)}}else if((22!==f.tag&&23!==f.tag||null===f.memoizedState||f===e)&&null!==f.child){f.child.return=f,f=f.child;continue}if(f===e)break e;for(;null===f.sibling;){if(null===f.return||f.return===e)break e;d===f&&(d=null),f=f.return}d===f&&(d=null),f.sibling.return=f.return,f=f.sibling}}break;case 19:pl(t,e),bl(e),4&r&&hl(e);case 21:}}function bl(e){var t=e.flags;if(2&t){try{e:{for(var n=e.return;null!==n;){if(sl(n)){var r=n;break e}n=n.return}throw Error(o(160))}switch(r.tag){case 5:var i=r.stateNode;32&r.flags&&(fe(i,""),r.flags&=-33),ul(e,ll(e),i);break;case 3:case 4:var a=r.stateNode.containerInfo;cl(e,ll(e),a);break;default:throw Error(o(161))}}catch(t){Sc(e,e.return,t)}e.flags&=-3}4096&t&&(e.flags&=-4097)}function yl(e,t,n){Js=e,xl(e,t,n)}function xl(e,t,n){for(var r=0!=(1&e.mode);null!==Js;){var i=Js,o=i.child;if(22===i.tag&&r){var a=null!==i.memoizedState||Xs;if(!a){var s=i.alternate,l=null!==s&&null!==s.memoizedState||Qs;s=Xs;var c=Qs;if(Xs=a,(Qs=l)&&!c)for(Js=i;null!==Js;)l=(a=Js).child,22===a.tag&&null!==a.memoizedState?Ol(i):null!==l?(l.return=a,Js=l):Ol(i);for(;null!==o;)Js=o,xl(o,t,n),o=o.sibling;Js=i,Xs=s,Qs=c}_l(e)}else 0!=(8772&i.subtreeFlags)&&null!==o?(o.return=i,Js=o):_l(e)}}function _l(e){for(;null!==Js;){var t=Js;if(0!=(8772&t.flags)){var n=t.alternate;try{if(0!=(8772&t.flags))switch(t.tag){case 0:case 11:case 15:Qs||il(5,t);break;case 1:var r=t.stateNode;if(4&t.flags&&!Qs)if(null===n)r.componentDidMount();else{var i=t.elementType===t.type?n.memoizedProps:vo(t.type,n.memoizedProps);r.componentDidUpdate(i,n.memoizedState,r.__reactInternalSnapshotBeforeUpdate)}var a=t.updateQueue;null!==a&&Uo(t,a,r);break;case 3:var s=t.updateQueue;if(null!==s){if(n=null,null!==t.child)switch(t.child.tag){case 5:case 1:n=t.child.stateNode}Uo(t,s,n)}break;case 5:var l=t.stateNode;if(null===n&&4&t.flags){n=l;var c=t.memoizedProps;switch(t.type){case"button":case"input":case"select":case"textarea":c.autoFocus&&n.focus();break;case"img":c.src&&(n.src=c.src)}}break;case 6:case 4:case 12:case 19:case 17:case 21:case 22:case 23:case 25:break;case 13:if(null===t.memoizedState){var u=t.alternate;if(null!==u){var d=u.memoizedState;if(null!==d){var f=d.dehydrated;null!==f&&Vt(f)}}}break;default:throw Error(o(163))}Qs||512&t.flags&&ol(t)}catch(e){Sc(t,t.return,e)}}if(t===e){Js=null;break}if(null!==(n=t.sibling)){n.return=t.return,Js=n;break}Js=t.return}}function jl(e){for(;null!==Js;){var t=Js;if(t===e){Js=null;break}var n=t.sibling;if(null!==n){n.return=t.return,Js=n;break}Js=t.return}}function Ol(e){for(;null!==Js;){var t=Js;try{switch(t.tag){case 0:case 11:case 15:var n=t.return;try{il(4,t)}catch(e){Sc(t,n,e)}break;case 1:var r=t.stateNode;if("function"==typeof r.componentDidMount){var i=t.return;try{r.componentDidMount()}catch(e){Sc(t,i,e)}}var o=t.return;try{ol(t)}catch(e){Sc(t,o,e)}break;case 5:var a=t.return;try{ol(t)}catch(e){Sc(t,a,e)}}}catch(e){Sc(t,t.return,e)}if(t===e){Js=null;break}var s=t.sibling;if(null!==s){s.return=t.return,Js=s;break}Js=t.return}}var El,Sl=Math.ceil,Tl=x.ReactCurrentDispatcher,Il=x.ReactCurrentOwner,wl=x.ReactCurrentBatchConfig,Pl=0,Cl=null,Nl=null,Al=0,Ll=0,Ml=Ei(0),kl=0,Rl=null,Dl=0,Fl=0,Ul=0,Gl=null,Bl=null,Vl=0,Hl=1/0,Kl=null,Wl=!1,zl=null,Yl=null,$l=!1,ql=null,Xl=0,Ql=0,Zl=null,Jl=-1,ec=0;function tc(){return 0!=(6&Pl)?Qe():-1!==Jl?Jl:Jl=Qe()}function nc(e){return 0==(1&e.mode)?1:0!=(2&Pl)&&0!==Al?Al&-Al:null!==po.transition?(0===ec&&(ec=ht()),ec):0!==(e=yt)?e:e=void 0===(e=window.event)?16:Xt(e.type)}function rc(e,t,n,r){if(50<Ql)throw Ql=0,Zl=null,Error(o(185));vt(e,n,r),0!=(2&Pl)&&e===Cl||(e===Cl&&(0==(2&Pl)&&(Fl|=n),4===kl&&lc(e,Al)),ic(e,r),1===n&&0===Pl&&0==(1&t.mode)&&(Hl=Qe()+500,Ui&&Vi()))}function ic(e,t){var n=e.callbackNode;!function(e,t){for(var n=e.suspendedLanes,r=e.pingedLanes,i=e.expirationTimes,o=e.pendingLanes;0<o;){var a=31-at(o),s=1<<a,l=i[a];-1===l?0!=(s&n)&&0==(s&r)||(i[a]=mt(s,t)):l<=t&&(e.expiredLanes|=s),o&=~s}}(e,t);var r=ft(e,e===Cl?Al:0);if(0===r)null!==n&&$e(n),e.callbackNode=null,e.callbackPriority=0;else if(t=r&-r,e.callbackPriority!==t){if(null!=n&&$e(n),1===t)0===e.tag?function(e){Ui=!0,Bi(e)}(cc.bind(null,e)):Bi(cc.bind(null,e)),ai((function(){0==(6&Pl)&&Vi()})),n=null;else{switch(xt(r)){case 1:n=Je;break;case 4:n=et;break;case 16:default:n=tt;break;case 536870912:n=rt}n=Cc(n,oc.bind(null,e))}e.callbackPriority=t,e.callbackNode=n}}function oc(e,t){if(Jl=-1,ec=0,0!=(6&Pl))throw Error(o(327));var n=e.callbackNode;if(Oc()&&e.callbackNode!==n)return null;var r=ft(e,e===Cl?Al:0);if(0===r)return null;if(0!=(30&r)||0!=(r&e.expiredLanes)||t)t=vc(e,r);else{t=r;var i=Pl;Pl|=2;var a=hc();for(Cl===e&&Al===t||(Kl=null,Hl=Qe()+500,mc(e,t));;)try{yc();break}catch(t){gc(e,t)}jo(),Tl.current=a,Pl=i,null!==Nl?t=0:(Cl=null,Al=0,t=kl)}if(0!==t){if(2===t&&(0!==(i=gt(e))&&(r=i,t=ac(e,i))),1===t)throw n=Rl,mc(e,0),lc(e,r),ic(e,Qe()),n;if(6===t)lc(e,r);else{if(i=e.current.alternate,0==(30&r)&&!function(e){for(var t=e;;){if(16384&t.flags){var n=t.updateQueue;if(null!==n&&null!==(n=n.stores))for(var r=0;r<n.length;r++){var i=n[r],o=i.getSnapshot;i=i.value;try{if(!sr(o(),i))return!1}catch(e){return!1}}}if(n=t.child,16384&t.subtreeFlags&&null!==n)n.return=t,t=n;else{if(t===e)break;for(;null===t.sibling;){if(null===t.return||t.return===e)return!0;t=t.return}t.sibling.return=t.return,t=t.sibling}}return!0}(i)&&(2===(t=vc(e,r))&&(0!==(a=gt(e))&&(r=a,t=ac(e,a))),1===t))throw n=Rl,mc(e,0),lc(e,r),ic(e,Qe()),n;switch(e.finishedWork=i,e.finishedLanes=r,t){case 0:case 1:throw Error(o(345));case 2:case 5:jc(e,Bl,Kl);break;case 3:if(lc(e,r),(130023424&r)===r&&10<(t=Vl+500-Qe())){if(0!==ft(e,0))break;if(((i=e.suspendedLanes)&r)!==r){tc(),e.pingedLanes|=e.suspendedLanes&i;break}e.timeoutHandle=ri(jc.bind(null,e,Bl,Kl),t);break}jc(e,Bl,Kl);break;case 4:if(lc(e,r),(4194240&r)===r)break;for(t=e.eventTimes,i=-1;0<r;){var s=31-at(r);a=1<<s,(s=t[s])>i&&(i=s),r&=~a}if(r=i,10<(r=(120>(r=Qe()-r)?120:480>r?480:1080>r?1080:1920>r?1920:3e3>r?3e3:4320>r?4320:1960*Sl(r/1960))-r)){e.timeoutHandle=ri(jc.bind(null,e,Bl,Kl),r);break}jc(e,Bl,Kl);break;default:throw Error(o(329))}}}return ic(e,Qe()),e.callbackNode===n?oc.bind(null,e):null}function ac(e,t){var n=Gl;return e.current.memoizedState.isDehydrated&&(mc(e,t).flags|=256),2!==(e=vc(e,t))&&(t=Bl,Bl=n,null!==t&&sc(t)),e}function sc(e){null===Bl?Bl=e:Bl.push.apply(Bl,e)}function lc(e,t){for(t&=~Ul,t&=~Fl,e.suspendedLanes|=t,e.pingedLanes&=~t,e=e.expirationTimes;0<t;){var n=31-at(t),r=1<<n;e[n]=-1,t&=~r}}function cc(e){if(0!=(6&Pl))throw Error(o(327));Oc();var t=ft(e,0);if(0==(1&t))return ic(e,Qe()),null;var n=vc(e,t);if(0!==e.tag&&2===n){var r=gt(e);0!==r&&(t=r,n=ac(e,r))}if(1===n)throw n=Rl,mc(e,0),lc(e,t),ic(e,Qe()),n;if(6===n)throw Error(o(345));return e.finishedWork=e.current.alternate,e.finishedLanes=t,jc(e,Bl,Kl),ic(e,Qe()),null}function uc(e,t){var n=Pl;Pl|=1;try{return e(t)}finally{0===(Pl=n)&&(Hl=Qe()+500,Ui&&Vi())}}function dc(e){null!==ql&&0===ql.tag&&0==(6&Pl)&&Oc();var t=Pl;Pl|=1;var n=wl.transition,r=yt;try{if(wl.transition=null,yt=1,e)return e()}finally{yt=r,wl.transition=n,0==(6&(Pl=t))&&Vi()}}function fc(){Ll=Ml.current,Si(Ml)}function mc(e,t){e.finishedWork=null,e.finishedLanes=0;var n=e.timeoutHandle;if(-1!==n&&(e.timeoutHandle=-1,ii(n)),null!==Nl)for(n=Nl.return;null!==n;){var r=n;switch(to(r),r.tag){case 1:null!=(r=r.type.childContextTypes)&&Li();break;case 3:oa(),Si(Pi),Si(wi),da();break;case 5:sa(r);break;case 4:oa();break;case 13:case 19:Si(la);break;case 10:Oo(r.type._context);break;case 22:case 23:fc()}n=n.return}if(Cl=e,Nl=e=Mc(e.current,null),Al=Ll=t,kl=0,Rl=null,Ul=Fl=Dl=0,Bl=Gl=null,null!==Io){for(t=0;t<Io.length;t++)if(null!==(r=(n=Io[t]).interleaved)){n.interleaved=null;var i=r.next,o=n.pending;if(null!==o){var a=o.next;o.next=i,r.next=a}n.pending=r}Io=null}return e}function gc(e,t){for(;;){var n=Nl;try{if(jo(),fa.current=as,ba){for(var r=ha.memoizedState;null!==r;){var i=r.queue;null!==i&&(i.pending=null),r=r.next}ba=!1}if(ga=0,va=pa=ha=null,ya=!1,xa=0,Il.current=null,null===n||null===n.return){kl=1,Rl=t,Nl=null;break}e:{var a=e,s=n.return,l=n,c=t;if(t=Al,l.flags|=32768,null!==c&&"object"==typeof c&&"function"==typeof c.then){var u=c,d=l,f=d.tag;if(0==(1&d.mode)&&(0===f||11===f||15===f)){var m=d.alternate;m?(d.updateQueue=m.updateQueue,d.memoizedState=m.memoizedState,d.lanes=m.lanes):(d.updateQueue=null,d.memoizedState=null)}var g=vs(s);if(null!==g){g.flags&=-257,bs(g,s,l,0,t),1&g.mode&&ps(a,u,t),c=u;var h=(t=g).updateQueue;if(null===h){var p=new Set;p.add(c),t.updateQueue=p}else h.add(c);break e}if(0==(1&t)){ps(a,u,t),pc();break e}c=Error(o(426))}else if(io&&1&l.mode){var v=vs(s);if(null!==v){0==(65536&v.flags)&&(v.flags|=256),bs(v,s,l,0,t),ho(us(c,l));break e}}a=c=us(c,l),4!==kl&&(kl=2),null===Gl?Gl=[a]:Gl.push(a),a=s;do{switch(a.tag){case 3:a.flags|=65536,t&=-t,a.lanes|=t,Do(a,gs(0,c,t));break e;case 1:l=c;var b=a.type,y=a.stateNode;if(0==(128&a.flags)&&("function"==typeof b.getDerivedStateFromError||null!==y&&"function"==typeof y.componentDidCatch&&(null===Yl||!Yl.has(y)))){a.flags|=65536,t&=-t,a.lanes|=t,Do(a,hs(a,l,t));break e}}a=a.return}while(null!==a)}_c(n)}catch(e){t=e,Nl===n&&null!==n&&(Nl=n=n.return);continue}break}}function hc(){var e=Tl.current;return Tl.current=as,null===e?as:e}function pc(){0!==kl&&3!==kl&&2!==kl||(kl=4),null===Cl||0==(268435455&Dl)&&0==(268435455&Fl)||lc(Cl,Al)}function vc(e,t){var n=Pl;Pl|=2;var r=hc();for(Cl===e&&Al===t||(Kl=null,mc(e,t));;)try{bc();break}catch(t){gc(e,t)}if(jo(),Pl=n,Tl.current=r,null!==Nl)throw Error(o(261));return Cl=null,Al=0,kl}function bc(){for(;null!==Nl;)xc(Nl)}function yc(){for(;null!==Nl&&!qe();)xc(Nl)}function xc(e){var t=El(e.alternate,e,Ll);e.memoizedProps=e.pendingProps,null===t?_c(e):Nl=t,Il.current=null}function _c(e){var t=e;do{var n=t.alternate;if(e=t.return,0==(32768&t.flags)){if(null!==(n=$s(n,t,Ll)))return void(Nl=n)}else{if(null!==(n=qs(n,t)))return n.flags&=32767,void(Nl=n);if(null===e)return kl=6,void(Nl=null);e.flags|=32768,e.subtreeFlags=0,e.deletions=null}if(null!==(t=t.sibling))return void(Nl=t);Nl=t=e}while(null!==t);0===kl&&(kl=5)}function jc(e,t,n){var r=yt,i=wl.transition;try{wl.transition=null,yt=1,function(e,t,n,r){do{Oc()}while(null!==ql);if(0!=(6&Pl))throw Error(o(327));n=e.finishedWork;var i=e.finishedLanes;if(null===n)return null;if(e.finishedWork=null,e.finishedLanes=0,n===e.current)throw Error(o(177));e.callbackNode=null,e.callbackPriority=0;var a=n.lanes|n.childLanes;if(function(e,t){var n=e.pendingLanes&~t;e.pendingLanes=t,e.suspendedLanes=0,e.pingedLanes=0,e.expiredLanes&=t,e.mutableReadLanes&=t,e.entangledLanes&=t,t=e.entanglements;var r=e.eventTimes;for(e=e.expirationTimes;0<n;){var i=31-at(n),o=1<<i;t[i]=0,r[i]=-1,e[i]=-1,n&=~o}}(e,a),e===Cl&&(Nl=Cl=null,Al=0),0==(2064&n.subtreeFlags)&&0==(2064&n.flags)||$l||($l=!0,Cc(tt,(function(){return Oc(),null}))),a=0!=(15990&n.flags),0!=(15990&n.subtreeFlags)||a){a=wl.transition,wl.transition=null;var s=yt;yt=1;var l=Pl;Pl|=4,Il.current=null,function(e,t){if(ei=Kt,mr(e=fr())){if("selectionStart"in e)var n={start:e.selectionStart,end:e.selectionEnd};else e:{var r=(n=(n=e.ownerDocument)&&n.defaultView||window).getSelection&&n.getSelection();if(r&&0!==r.rangeCount){n=r.anchorNode;var i=r.anchorOffset,a=r.focusNode;r=r.focusOffset;try{n.nodeType,a.nodeType}catch(e){n=null;break e}var s=0,l=-1,c=-1,u=0,d=0,f=e,m=null;t:for(;;){for(var g;f!==n||0!==i&&3!==f.nodeType||(l=s+i),f!==a||0!==r&&3!==f.nodeType||(c=s+r),3===f.nodeType&&(s+=f.nodeValue.length),null!==(g=f.firstChild);)m=f,f=g;for(;;){if(f===e)break t;if(m===n&&++u===i&&(l=s),m===a&&++d===r&&(c=s),null!==(g=f.nextSibling))break;m=(f=m).parentNode}f=g}n=-1===l||-1===c?null:{start:l,end:c}}else n=null}n=n||{start:0,end:0}}else n=null;for(ti={focusedElem:e,selectionRange:n},Kt=!1,Js=t;null!==Js;)if(e=(t=Js).child,0!=(1028&t.subtreeFlags)&&null!==e)e.return=t,Js=e;else for(;null!==Js;){t=Js;try{var h=t.alternate;if(0!=(1024&t.flags))switch(t.tag){case 0:case 11:case 15:case 5:case 6:case 4:case 17:break;case 1:if(null!==h){var p=h.memoizedProps,v=h.memoizedState,b=t.stateNode,y=b.getSnapshotBeforeUpdate(t.elementType===t.type?p:vo(t.type,p),v);b.__reactInternalSnapshotBeforeUpdate=y}break;case 3:var x=t.stateNode.containerInfo;1===x.nodeType?x.textContent="":9===x.nodeType&&x.documentElement&&x.removeChild(x.documentElement);break;default:throw Error(o(163))}}catch(e){Sc(t,t.return,e)}if(null!==(e=t.sibling)){e.return=t.return,Js=e;break}Js=t.return}h=nl,nl=!1}(e,n),vl(n,e),gr(ti),Kt=!!ei,ti=ei=null,e.current=n,yl(n,e,i),Xe(),Pl=l,yt=s,wl.transition=a}else e.current=n;if($l&&($l=!1,ql=e,Xl=i),a=e.pendingLanes,0===a&&(Yl=null),function(e){if(ot&&"function"==typeof ot.onCommitFiberRoot)try{ot.onCommitFiberRoot(it,e,void 0,128==(128&e.current.flags))}catch(e){}}(n.stateNode),ic(e,Qe()),null!==t)for(r=e.onRecoverableError,n=0;n<t.length;n++)i=t[n],r(i.value,{componentStack:i.stack,digest:i.digest});if(Wl)throw Wl=!1,e=zl,zl=null,e;0!=(1&Xl)&&0!==e.tag&&Oc(),a=e.pendingLanes,0!=(1&a)?e===Zl?Ql++:(Ql=0,Zl=e):Ql=0,Vi()}(e,t,n,r)}finally{wl.transition=i,yt=r}return null}function Oc(){if(null!==ql){var e=xt(Xl),t=wl.transition,n=yt;try{if(wl.transition=null,yt=16>e?16:e,null===ql)var r=!1;else{if(e=ql,ql=null,Xl=0,0!=(6&Pl))throw Error(o(331));var i=Pl;for(Pl|=4,Js=e.current;null!==Js;){var a=Js,s=a.child;if(0!=(16&Js.flags)){var l=a.deletions;if(null!==l){for(var c=0;c<l.length;c++){var u=l[c];for(Js=u;null!==Js;){var d=Js;switch(d.tag){case 0:case 11:case 15:rl(8,d,a)}var f=d.child;if(null!==f)f.return=d,Js=f;else for(;null!==Js;){var m=(d=Js).sibling,g=d.return;if(al(d),d===u){Js=null;break}if(null!==m){m.return=g,Js=m;break}Js=g}}}var h=a.alternate;if(null!==h){var p=h.child;if(null!==p){h.child=null;do{var v=p.sibling;p.sibling=null,p=v}while(null!==p)}}Js=a}}if(0!=(2064&a.subtreeFlags)&&null!==s)s.return=a,Js=s;else e:for(;null!==Js;){if(0!=(2048&(a=Js).flags))switch(a.tag){case 0:case 11:case 15:rl(9,a,a.return)}var b=a.sibling;if(null!==b){b.return=a.return,Js=b;break e}Js=a.return}}var y=e.current;for(Js=y;null!==Js;){var x=(s=Js).child;if(0!=(2064&s.subtreeFlags)&&null!==x)x.return=s,Js=x;else e:for(s=y;null!==Js;){if(0!=(2048&(l=Js).flags))try{switch(l.tag){case 0:case 11:case 15:il(9,l)}}catch(e){Sc(l,l.return,e)}if(l===s){Js=null;break e}var _=l.sibling;if(null!==_){_.return=l.return,Js=_;break e}Js=l.return}}if(Pl=i,Vi(),ot&&"function"==typeof ot.onPostCommitFiberRoot)try{ot.onPostCommitFiberRoot(it,e)}catch(e){}r=!0}return r}finally{yt=n,wl.transition=t}}return!1}function Ec(e,t,n){e=ko(e,t=gs(0,t=us(n,t),1),1),t=tc(),null!==e&&(vt(e,1,t),ic(e,t))}function Sc(e,t,n){if(3===e.tag)Ec(e,e,n);else for(;null!==t;){if(3===t.tag){Ec(t,e,n);break}if(1===t.tag){var r=t.stateNode;if("function"==typeof t.type.getDerivedStateFromError||"function"==typeof r.componentDidCatch&&(null===Yl||!Yl.has(r))){t=ko(t,e=hs(t,e=us(n,e),1),1),e=tc(),null!==t&&(vt(t,1,e),ic(t,e));break}}t=t.return}}function Tc(e,t,n){var r=e.pingCache;null!==r&&r.delete(t),t=tc(),e.pingedLanes|=e.suspendedLanes&n,Cl===e&&(Al&n)===n&&(4===kl||3===kl&&(130023424&Al)===Al&&500>Qe()-Vl?mc(e,0):Ul|=n),ic(e,t)}function Ic(e,t){0===t&&(0==(1&e.mode)?t=1:(t=ut,0==(130023424&(ut<<=1))&&(ut=4194304)));var n=tc();null!==(e=Co(e,t))&&(vt(e,t,n),ic(e,n))}function wc(e){var t=e.memoizedState,n=0;null!==t&&(n=t.retryLane),Ic(e,n)}function Pc(e,t){var n=0;switch(e.tag){case 13:var r=e.stateNode,i=e.memoizedState;null!==i&&(n=i.retryLane);break;case 19:r=e.stateNode;break;default:throw Error(o(314))}null!==r&&r.delete(t),Ic(e,n)}function Cc(e,t){return Ye(e,t)}function Nc(e,t,n,r){this.tag=e,this.key=n,this.sibling=this.child=this.return=this.stateNode=this.type=this.elementType=null,this.index=0,this.ref=null,this.pendingProps=t,this.dependencies=this.memoizedState=this.updateQueue=this.memoizedProps=null,this.mode=r,this.subtreeFlags=this.flags=0,this.deletions=null,this.childLanes=this.lanes=0,this.alternate=null}function Ac(e,t,n,r){return new Nc(e,t,n,r)}function Lc(e){return!(!(e=e.prototype)||!e.isReactComponent)}function Mc(e,t){var n=e.alternate;return null===n?((n=Ac(e.tag,t,e.key,e.mode)).elementType=e.elementType,n.type=e.type,n.stateNode=e.stateNode,n.alternate=e,e.alternate=n):(n.pendingProps=t,n.type=e.type,n.flags=0,n.subtreeFlags=0,n.deletions=null),n.flags=14680064&e.flags,n.childLanes=e.childLanes,n.lanes=e.lanes,n.child=e.child,n.memoizedProps=e.memoizedProps,n.memoizedState=e.memoizedState,n.updateQueue=e.updateQueue,t=e.dependencies,n.dependencies=null===t?null:{lanes:t.lanes,firstContext:t.firstContext},n.sibling=e.sibling,n.index=e.index,n.ref=e.ref,n}function kc(e,t,n,r,i,a){var s=2;if(r=e,"function"==typeof e)Lc(e)&&(s=1);else if("string"==typeof e)s=5;else e:switch(e){case O:return Rc(n.children,i,a,t);case E:s=8,i|=8;break;case S:return(e=Ac(12,n,t,2|i)).elementType=S,e.lanes=a,e;case P:return(e=Ac(13,n,t,i)).elementType=P,e.lanes=a,e;case C:return(e=Ac(19,n,t,i)).elementType=C,e.lanes=a,e;case L:return Dc(n,i,a,t);default:if("object"==typeof e&&null!==e)switch(e.$$typeof){case T:s=10;break e;case I:s=9;break e;case w:s=11;break e;case N:s=14;break e;case A:s=16,r=null;break e}throw Error(o(130,null==e?e:typeof e,""))}return(t=Ac(s,n,t,i)).elementType=e,t.type=r,t.lanes=a,t}function Rc(e,t,n,r){return(e=Ac(7,e,r,t)).lanes=n,e}function Dc(e,t,n,r){return(e=Ac(22,e,r,t)).elementType=L,e.lanes=n,e.stateNode={isHidden:!1},e}function Fc(e,t,n){return(e=Ac(6,e,null,t)).lanes=n,e}function Uc(e,t,n){return(t=Ac(4,null!==e.children?e.children:[],e.key,t)).lanes=n,t.stateNode={containerInfo:e.containerInfo,pendingChildren:null,implementation:e.implementation},t}function Gc(e,t,n,r,i){this.tag=t,this.containerInfo=e,this.finishedWork=this.pingCache=this.current=this.pendingChildren=null,this.timeoutHandle=-1,this.callbackNode=this.pendingContext=this.context=null,this.callbackPriority=0,this.eventTimes=pt(0),this.expirationTimes=pt(-1),this.entangledLanes=this.finishedLanes=this.mutableReadLanes=this.expiredLanes=this.pingedLanes=this.suspendedLanes=this.pendingLanes=0,this.entanglements=pt(0),this.identifierPrefix=r,this.onRecoverableError=i,this.mutableSourceEagerHydrationData=null}function Bc(e,t,n,r,i,o,a,s,l){return e=new Gc(e,t,n,s,l),1===t?(t=1,!0===o&&(t|=8)):t=0,o=Ac(3,null,null,t),e.current=o,o.stateNode=e,o.memoizedState={element:r,isDehydrated:n,cache:null,transitions:null,pendingSuspenseBoundaries:null},Ao(o),e}function Vc(e){if(!e)return Ii;e:{if(Ve(e=e._reactInternals)!==e||1!==e.tag)throw Error(o(170));var t=e;do{switch(t.tag){case 3:t=t.stateNode.context;break e;case 1:if(Ai(t.type)){t=t.stateNode.__reactInternalMemoizedMergedChildContext;break e}}t=t.return}while(null!==t);throw Error(o(171))}if(1===e.tag){var n=e.type;if(Ai(n))return ki(e,n,t)}return t}function Hc(e,t,n,r,i,o,a,s,l){return(e=Bc(n,r,!0,e,0,o,0,s,l)).context=Vc(null),n=e.current,(o=Mo(r=tc(),i=nc(n))).callback=null!=t?t:null,ko(n,o,i),e.current.lanes=i,vt(e,i,r),ic(e,r),e}function Kc(e,t,n,r){var i=t.current,o=tc(),a=nc(i);return n=Vc(n),null===t.context?t.context=n:t.pendingContext=n,(t=Mo(o,a)).payload={element:e},null!==(r=void 0===r?null:r)&&(t.callback=r),null!==(e=ko(i,t,a))&&(rc(e,i,a,o),Ro(e,i,a)),a}function Wc(e){return(e=e.current).child?(e.child.tag,e.child.stateNode):null}function zc(e,t){if(null!==(e=e.memoizedState)&&null!==e.dehydrated){var n=e.retryLane;e.retryLane=0!==n&&n<t?n:t}}function Yc(e,t){zc(e,t),(e=e.alternate)&&zc(e,t)}El=function(e,t,n){if(null!==e)if(e.memoizedProps!==t.pendingProps||Pi.current)xs=!0;else{if(0==(e.lanes&n)&&0==(128&t.flags))return xs=!1,function(e,t,n){switch(t.tag){case 3:Cs(t),go();break;case 5:aa(t);break;case 1:Ai(t.type)&&Ri(t);break;case 4:ia(t,t.stateNode.containerInfo);break;case 10:var r=t.type._context,i=t.memoizedProps.value;Ti(bo,r._currentValue),r._currentValue=i;break;case 13:if(null!==(r=t.memoizedState))return null!==r.dehydrated?(Ti(la,1&la.current),t.flags|=128,null):0!=(n&t.child.childLanes)?Fs(e,t,n):(Ti(la,1&la.current),null!==(e=Ws(e,t,n))?e.sibling:null);Ti(la,1&la.current);break;case 19:if(r=0!=(n&t.childLanes),0!=(128&e.flags)){if(r)return Hs(e,t,n);t.flags|=128}if(null!==(i=t.memoizedState)&&(i.rendering=null,i.tail=null,i.lastEffect=null),Ti(la,la.current),r)break;return null;case 22:case 23:return t.lanes=0,Ss(e,t,n)}return Ws(e,t,n)}(e,t,n);xs=0!=(131072&e.flags)}else xs=!1,io&&0!=(1048576&t.flags)&&Ji(t,zi,t.index);switch(t.lanes=0,t.tag){case 2:var r=t.type;Ks(e,t),e=t.pendingProps;var i=Ni(t,wi.current);So(t,n),i=Ea(null,t,r,e,i,n);var a=Sa();return t.flags|=1,"object"==typeof i&&null!==i&&"function"==typeof i.render&&void 0===i.$$typeof?(t.tag=1,t.memoizedState=null,t.updateQueue=null,Ai(r)?(a=!0,Ri(t)):a=!1,t.memoizedState=null!==i.state&&void 0!==i.state?i.state:null,Ao(t),i.updater=Vo,t.stateNode=i,i._reactInternals=t,zo(t,r,e,n),t=Ps(null,t,r,!0,a,n)):(t.tag=0,io&&a&&eo(t),_s(null,t,i,n),t=t.child),t;case 16:r=t.elementType;e:{switch(Ks(e,t),e=t.pendingProps,r=(i=r._init)(r._payload),t.type=r,i=t.tag=function(e){if("function"==typeof e)return Lc(e)?1:0;if(null!=e){if((e=e.$$typeof)===w)return 11;if(e===N)return 14}return 2}(r),e=vo(r,e),i){case 0:t=Is(null,t,r,e,n);break e;case 1:t=ws(null,t,r,e,n);break e;case 11:t=js(null,t,r,e,n);break e;case 14:t=Os(null,t,r,vo(r.type,e),n);break e}throw Error(o(306,r,""))}return t;case 0:return r=t.type,i=t.pendingProps,Is(e,t,r,i=t.elementType===r?i:vo(r,i),n);case 1:return r=t.type,i=t.pendingProps,ws(e,t,r,i=t.elementType===r?i:vo(r,i),n);case 3:e:{if(Cs(t),null===e)throw Error(o(387));r=t.pendingProps,i=(a=t.memoizedState).element,Lo(e,t),Fo(t,r,null,n);var s=t.memoizedState;if(r=s.element,a.isDehydrated){if(a={element:r,isDehydrated:!1,cache:s.cache,pendingSuspenseBoundaries:s.pendingSuspenseBoundaries,transitions:s.transitions},t.updateQueue.baseState=a,t.memoizedState=a,256&t.flags){t=Ns(e,t,r,n,i=us(Error(o(423)),t));break e}if(r!==i){t=Ns(e,t,r,n,i=us(Error(o(424)),t));break e}for(ro=ci(t.stateNode.containerInfo.firstChild),no=t,io=!0,oo=null,n=Zo(t,null,r,n),t.child=n;n;)n.flags=-3&n.flags|4096,n=n.sibling}else{if(go(),r===i){t=Ws(e,t,n);break e}_s(e,t,r,n)}t=t.child}return t;case 5:return aa(t),null===e&&co(t),r=t.type,i=t.pendingProps,a=null!==e?e.memoizedProps:null,s=i.children,ni(r,i)?s=null:null!==a&&ni(r,a)&&(t.flags|=32),Ts(e,t),_s(e,t,s,n),t.child;case 6:return null===e&&co(t),null;case 13:return Fs(e,t,n);case 4:return ia(t,t.stateNode.containerInfo),r=t.pendingProps,null===e?t.child=Qo(t,null,r,n):_s(e,t,r,n),t.child;case 11:return r=t.type,i=t.pendingProps,js(e,t,r,i=t.elementType===r?i:vo(r,i),n);case 7:return _s(e,t,t.pendingProps,n),t.child;case 8:case 12:return _s(e,t,t.pendingProps.children,n),t.child;case 10:e:{if(r=t.type._context,i=t.pendingProps,a=t.memoizedProps,s=i.value,Ti(bo,r._currentValue),r._currentValue=s,null!==a)if(sr(a.value,s)){if(a.children===i.children&&!Pi.current){t=Ws(e,t,n);break e}}else for(null!==(a=t.child)&&(a.return=t);null!==a;){var l=a.dependencies;if(null!==l){s=a.child;for(var c=l.firstContext;null!==c;){if(c.context===r){if(1===a.tag){(c=Mo(-1,n&-n)).tag=2;var u=a.updateQueue;if(null!==u){var d=(u=u.shared).pending;null===d?c.next=c:(c.next=d.next,d.next=c),u.pending=c}}a.lanes|=n,null!==(c=a.alternate)&&(c.lanes|=n),Eo(a.return,n,t),l.lanes|=n;break}c=c.next}}else if(10===a.tag)s=a.type===t.type?null:a.child;else if(18===a.tag){if(null===(s=a.return))throw Error(o(341));s.lanes|=n,null!==(l=s.alternate)&&(l.lanes|=n),Eo(s,n,t),s=a.sibling}else s=a.child;if(null!==s)s.return=a;else for(s=a;null!==s;){if(s===t){s=null;break}if(null!==(a=s.sibling)){a.return=s.return,s=a;break}s=s.return}a=s}_s(e,t,i.children,n),t=t.child}return t;case 9:return i=t.type,r=t.pendingProps.children,So(t,n),r=r(i=To(i)),t.flags|=1,_s(e,t,r,n),t.child;case 14:return i=vo(r=t.type,t.pendingProps),Os(e,t,r,i=vo(r.type,i),n);case 15:return Es(e,t,t.type,t.pendingProps,n);case 17:return r=t.type,i=t.pendingProps,i=t.elementType===r?i:vo(r,i),Ks(e,t),t.tag=1,Ai(r)?(e=!0,Ri(t)):e=!1,So(t,n),Ko(t,r,i),zo(t,r,i,n),Ps(null,t,r,!0,e,n);case 19:return Hs(e,t,n);case 22:return Ss(e,t,n)}throw Error(o(156,t.tag))};var $c="function"==typeof reportError?reportError:function(e){console.error(e)};function qc(e){this._internalRoot=e}function Xc(e){this._internalRoot=e}function Qc(e){return!(!e||1!==e.nodeType&&9!==e.nodeType&&11!==e.nodeType)}function Zc(e){return!(!e||1!==e.nodeType&&9!==e.nodeType&&11!==e.nodeType&&(8!==e.nodeType||" react-mount-point-unstable "!==e.nodeValue))}function Jc(){}function eu(e,t,n,r,i){var o=n._reactRootContainer;if(o){var a=o;if("function"==typeof i){var s=i;i=function(){var e=Wc(a);s.call(e)}}Kc(t,a,e,i)}else a=function(e,t,n,r,i){if(i){if("function"==typeof r){var o=r;r=function(){var e=Wc(a);o.call(e)}}var a=Hc(t,r,e,0,null,!1,0,"",Jc);return e._reactRootContainer=a,e[gi]=a.current,Vr(8===e.nodeType?e.parentNode:e),dc(),a}for(;i=e.lastChild;)e.removeChild(i);if("function"==typeof r){var s=r;r=function(){var e=Wc(l);s.call(e)}}var l=Bc(e,0,!1,null,0,!1,0,"",Jc);return e._reactRootContainer=l,e[gi]=l.current,Vr(8===e.nodeType?e.parentNode:e),dc((function(){Kc(t,l,n,r)})),l}(n,t,e,i,r);return Wc(a)}Xc.prototype.render=qc.prototype.render=function(e){var t=this._internalRoot;if(null===t)throw Error(o(409));Kc(e,t,null,null)},Xc.prototype.unmount=qc.prototype.unmount=function(){var e=this._internalRoot;if(null!==e){this._internalRoot=null;var t=e.containerInfo;dc((function(){Kc(null,e,null,null)})),t[gi]=null}},Xc.prototype.unstable_scheduleHydration=function(e){if(e){var t=Et();e={blockedOn:null,target:e,priority:t};for(var n=0;n<Lt.length&&0!==t&&t<Lt[n].priority;n++);Lt.splice(n,0,e),0===n&&Dt(e)}},_t=function(e){switch(e.tag){case 3:var t=e.stateNode;if(t.current.memoizedState.isDehydrated){var n=dt(t.pendingLanes);0!==n&&(bt(t,1|n),ic(t,Qe()),0==(6&Pl)&&(Hl=Qe()+500,Vi()))}break;case 13:dc((function(){var t=Co(e,1);if(null!==t){var n=tc();rc(t,e,1,n)}})),Yc(e,1)}},jt=function(e){if(13===e.tag){var t=Co(e,134217728);if(null!==t)rc(t,e,134217728,tc());Yc(e,134217728)}},Ot=function(e){if(13===e.tag){var t=nc(e),n=Co(e,t);if(null!==n)rc(n,e,t,tc());Yc(e,t)}},Et=function(){return yt},St=function(e,t){var n=yt;try{return yt=e,t()}finally{yt=n}},je=function(e,t,n){switch(t){case"input":if(Z(e,n),t=n.name,"radio"===n.type&&null!=t){for(n=e;n.parentNode;)n=n.parentNode;for(n=n.querySelectorAll("input[name="+JSON.stringify(""+t)+'][type="radio"]'),t=0;t<n.length;t++){var r=n[t];if(r!==e&&r.form===e.form){var i=_i(r);if(!i)throw Error(o(90));Y(r),Z(r,i)}}}break;case"textarea":oe(e,n);break;case"select":null!=(t=n.value)&&ne(e,!!n.multiple,t,!1)}},we=uc,Pe=dc;var tu={usingClientEntryPoint:!1,Events:[yi,xi,_i,Te,Ie,uc]},nu={findFiberByHostInstance:bi,bundleType:0,version:"18.2.0",rendererPackageName:"react-dom"},ru={bundleType:nu.bundleType,version:nu.version,rendererPackageName:nu.rendererPackageName,rendererConfig:nu.rendererConfig,overrideHookState:null,overrideHookStateDeletePath:null,overrideHookStateRenamePath:null,overrideProps:null,overridePropsDeletePath:null,overridePropsRenamePath:null,setErrorHandler:null,setSuspenseHandler:null,scheduleUpdate:null,currentDispatcherRef:x.ReactCurrentDispatcher,findHostInstanceByFiber:function(e){return null===(e=We(e))?null:e.stateNode},findFiberByHostInstance:nu.findFiberByHostInstance||function(){return null},findHostInstancesForRefresh:null,scheduleRefresh:null,scheduleRoot:null,setRefreshHandler:null,getCurrentFiber:null,reconcilerVersion:"18.2.0-next-9e3b772b8-20220608"};if("undefined"!=typeof __REACT_DEVTOOLS_GLOBAL_HOOK__){var iu=__REACT_DEVTOOLS_GLOBAL_HOOK__;if(!iu.isDisabled&&iu.supportsFiber)try{it=iu.inject(ru),ot=iu}catch(ue){}}t.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED=tu,t.createPortal=function(e,t){var n=2<arguments.length&&void 0!==arguments[2]?arguments[2]:null;if(!Qc(t))throw Error(o(200));return function(e,t,n){var r=3<arguments.length&&void 0!==arguments[3]?arguments[3]:null;return{$$typeof:j,key:null==r?null:""+r,children:e,containerInfo:t,implementation:n}}(e,t,null,n)},t.createRoot=function(e,t){if(!Qc(e))throw Error(o(299));var n=!1,r="",i=$c;return null!=t&&(!0===t.unstable_strictMode&&(n=!0),void 0!==t.identifierPrefix&&(r=t.identifierPrefix),void 0!==t.onRecoverableError&&(i=t.onRecoverableError)),t=Bc(e,1,!1,null,0,n,0,r,i),e[gi]=t.current,Vr(8===e.nodeType?e.parentNode:e),new qc(t)},t.findDOMNode=function(e){if(null==e)return null;if(1===e.nodeType)return e;var t=e._reactInternals;if(void 0===t){if("function"==typeof e.render)throw Error(o(188));throw e=Object.keys(e).join(","),Error(o(268,e))}return e=null===(e=We(t))?null:e.stateNode},t.flushSync=function(e){return dc(e)},t.hydrate=function(e,t,n){if(!Zc(t))throw Error(o(200));return eu(null,e,t,!0,n)},t.hydrateRoot=function(e,t,n){if(!Qc(e))throw Error(o(405));var r=null!=n&&n.hydratedSources||null,i=!1,a="",s=$c;if(null!=n&&(!0===n.unstable_strictMode&&(i=!0),void 0!==n.identifierPrefix&&(a=n.identifierPrefix),void 0!==n.onRecoverableError&&(s=n.onRecoverableError)),t=Hc(t,null,e,1,null!=n?n:null,i,0,a,s),e[gi]=t.current,Vr(e),r)for(e=0;e<r.length;e++)i=(i=(n=r[e])._getVersion)(n._source),null==t.mutableSourceEagerHydrationData?t.mutableSourceEagerHydrationData=[n,i]:t.mutableSourceEagerHydrationData.push(n,i);return new Xc(t)},t.render=function(e,t,n){if(!Zc(t))throw Error(o(200));return eu(null,e,t,!1,n)},t.unmountComponentAtNode=function(e){if(!Zc(e))throw Error(o(40));return!!e._reactRootContainer&&(dc((function(){eu(null,null,e,!1,(function(){e._reactRootContainer=null,e[gi]=null}))})),!0)},t.unstable_batchedUpdates=uc,t.unstable_renderSubtreeIntoContainer=function(e,t,n,r){if(!Zc(n))throw Error(o(200));if(null==e||void 0===e._reactInternals)throw Error(o(38));return eu(e,t,n,!1,r)},t.version="18.2.0-next-9e3b772b8-20220608"},352:(e,t,n)=>{"use strict";var r=n(104);t.createRoot=r.createRoot,t.hydrateRoot=r.hydrateRoot},104:(e,t,n)=>{"use strict";!function e(){if("undefined"!=typeof __REACT_DEVTOOLS_GLOBAL_HOOK__&&"function"==typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.checkDCE)try{__REACT_DEVTOOLS_GLOBAL_HOOK__.checkDCE(e)}catch(e){console.error(e)}}(),e.exports=n(516)},808:(e,t,n)=>{"use strict";var r=n(504),i=Symbol.for("react.element"),o=Symbol.for("react.fragment"),a=Object.prototype.hasOwnProperty,s=r.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner,l={key:!0,ref:!0,__self:!0,__source:!0};function c(e,t,n){var r,o={},c=null,u=null;for(r in void 0!==n&&(c=""+n),void 0!==t.key&&(c=""+t.key),void 0!==t.ref&&(u=t.ref),t)a.call(t,r)&&!l.hasOwnProperty(r)&&(o[r]=t[r]);if(e&&e.defaultProps)for(r in t=e.defaultProps)void 0===o[r]&&(o[r]=t[r]);return{$$typeof:i,type:e,key:c,ref:u,props:o,_owner:s.current}}t.Fragment=o,t.jsx=c,t.jsxs=c},28:(e,t)=>{"use strict";var n=Symbol.for("react.element"),r=Symbol.for("react.portal"),i=Symbol.for("react.fragment"),o=Symbol.for("react.strict_mode"),a=Symbol.for("react.profiler"),s=Symbol.for("react.provider"),l=Symbol.for("react.context"),c=Symbol.for("react.forward_ref"),u=Symbol.for("react.suspense"),d=Symbol.for("react.memo"),f=Symbol.for("react.lazy"),m=Symbol.iterator;var g={isMounted:function(){return!1},enqueueForceUpdate:function(){},enqueueReplaceState:function(){},enqueueSetState:function(){}},h=Object.assign,p={};function v(e,t,n){this.props=e,this.context=t,this.refs=p,this.updater=n||g}function b(){}function y(e,t,n){this.props=e,this.context=t,this.refs=p,this.updater=n||g}v.prototype.isReactComponent={},v.prototype.setState=function(e,t){if("object"!=typeof e&&"function"!=typeof e&&null!=e)throw Error("setState(...): takes an object of state variables to update or a function which returns an object of state variables.");this.updater.enqueueSetState(this,e,t,"setState")},v.prototype.forceUpdate=function(e){this.updater.enqueueForceUpdate(this,e,"forceUpdate")},b.prototype=v.prototype;var x=y.prototype=new b;x.constructor=y,h(x,v.prototype),x.isPureReactComponent=!0;var _=Array.isArray,j=Object.prototype.hasOwnProperty,O={current:null},E={key:!0,ref:!0,__self:!0,__source:!0};function S(e,t,r){var i,o={},a=null,s=null;if(null!=t)for(i in void 0!==t.ref&&(s=t.ref),void 0!==t.key&&(a=""+t.key),t)j.call(t,i)&&!E.hasOwnProperty(i)&&(o[i]=t[i]);var l=arguments.length-2;if(1===l)o.children=r;else if(1<l){for(var c=Array(l),u=0;u<l;u++)c[u]=arguments[u+2];o.children=c}if(e&&e.defaultProps)for(i in l=e.defaultProps)void 0===o[i]&&(o[i]=l[i]);return{$$typeof:n,type:e,key:a,ref:s,props:o,_owner:O.current}}function T(e){return"object"==typeof e&&null!==e&&e.$$typeof===n}var I=/\/+/g;function w(e,t){return"object"==typeof e&&null!==e&&null!=e.key?function(e){var t={"=":"=0",":":"=2"};return"$"+e.replace(/[=:]/g,(function(e){return t[e]}))}(""+e.key):t.toString(36)}function P(e,t,i,o,a){var s=typeof e;"undefined"!==s&&"boolean"!==s||(e=null);var l=!1;if(null===e)l=!0;else switch(s){case"string":case"number":l=!0;break;case"object":switch(e.$$typeof){case n:case r:l=!0}}if(l)return a=a(l=e),e=""===o?"."+w(l,0):o,_(a)?(i="",null!=e&&(i=e.replace(I,"$&/")+"/"),P(a,t,i,"",(function(e){return e}))):null!=a&&(T(a)&&(a=function(e,t){return{$$typeof:n,type:e.type,key:t,ref:e.ref,props:e.props,_owner:e._owner}}(a,i+(!a.key||l&&l.key===a.key?"":(""+a.key).replace(I,"$&/")+"/")+e)),t.push(a)),1;if(l=0,o=""===o?".":o+":",_(e))for(var c=0;c<e.length;c++){var u=o+w(s=e[c],c);l+=P(s,t,i,u,a)}else if(u=function(e){return null===e||"object"!=typeof e?null:"function"==typeof(e=m&&e[m]||e["@@iterator"])?e:null}(e),"function"==typeof u)for(e=u.call(e),c=0;!(s=e.next()).done;)l+=P(s=s.value,t,i,u=o+w(s,c++),a);else if("object"===s)throw t=String(e),Error("Objects are not valid as a React child (found: "+("[object Object]"===t?"object with keys {"+Object.keys(e).join(", ")+"}":t)+"). If you meant to render a collection of children, use an array instead.");return l}function C(e,t,n){if(null==e)return e;var r=[],i=0;return P(e,r,"","",(function(e){return t.call(n,e,i++)})),r}function N(e){if(-1===e._status){var t=e._result;(t=t()).then((function(t){0!==e._status&&-1!==e._status||(e._status=1,e._result=t)}),(function(t){0!==e._status&&-1!==e._status||(e._status=2,e._result=t)})),-1===e._status&&(e._status=0,e._result=t)}if(1===e._status)return e._result.default;throw e._result}var A={current:null},L={transition:null},M={ReactCurrentDispatcher:A,ReactCurrentBatchConfig:L,ReactCurrentOwner:O};t.Children={map:C,forEach:function(e,t,n){C(e,(function(){t.apply(this,arguments)}),n)},count:function(e){var t=0;return C(e,(function(){t++})),t},toArray:function(e){return C(e,(function(e){return e}))||[]},only:function(e){if(!T(e))throw Error("React.Children.only expected to receive a single React element child.");return e}},t.Component=v,t.Fragment=i,t.Profiler=a,t.PureComponent=y,t.StrictMode=o,t.Suspense=u,t.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED=M,t.cloneElement=function(e,t,r){if(null==e)throw Error("React.cloneElement(...): The argument must be a React element, but you passed "+e+".");var i=h({},e.props),o=e.key,a=e.ref,s=e._owner;if(null!=t){if(void 0!==t.ref&&(a=t.ref,s=O.current),void 0!==t.key&&(o=""+t.key),e.type&&e.type.defaultProps)var l=e.type.defaultProps;for(c in t)j.call(t,c)&&!E.hasOwnProperty(c)&&(i[c]=void 0===t[c]&&void 0!==l?l[c]:t[c])}var c=arguments.length-2;if(1===c)i.children=r;else if(1<c){l=Array(c);for(var u=0;u<c;u++)l[u]=arguments[u+2];i.children=l}return{$$typeof:n,type:e.type,key:o,ref:a,props:i,_owner:s}},t.createContext=function(e){return(e={$$typeof:l,_currentValue:e,_currentValue2:e,_threadCount:0,Provider:null,Consumer:null,_defaultValue:null,_globalName:null}).Provider={$$typeof:s,_context:e},e.Consumer=e},t.createElement=S,t.createFactory=function(e){var t=S.bind(null,e);return t.type=e,t},t.createRef=function(){return{current:null}},t.forwardRef=function(e){return{$$typeof:c,render:e}},t.isValidElement=T,t.lazy=function(e){return{$$typeof:f,_payload:{_status:-1,_result:e},_init:N}},t.memo=function(e,t){return{$$typeof:d,type:e,compare:void 0===t?null:t}},t.startTransition=function(e){var t=L.transition;L.transition={};try{e()}finally{L.transition=t}},t.unstable_act=function(){throw Error("act(...) is not supported in production builds of React.")},t.useCallback=function(e,t){return A.current.useCallback(e,t)},t.useContext=function(e){return A.current.useContext(e)},t.useDebugValue=function(){},t.useDeferredValue=function(e){return A.current.useDeferredValue(e)},t.useEffect=function(e,t){return A.current.useEffect(e,t)},t.useId=function(){return A.current.useId()},t.useImperativeHandle=function(e,t,n){return A.current.useImperativeHandle(e,t,n)},t.useInsertionEffect=function(e,t){return A.current.useInsertionEffect(e,t)},t.useLayoutEffect=function(e,t){return A.current.useLayoutEffect(e,t)},t.useMemo=function(e,t){return A.current.useMemo(e,t)},t.useReducer=function(e,t,n){return A.current.useReducer(e,t,n)},t.useRef=function(e){return A.current.useRef(e)},t.useState=function(e){return A.current.useState(e)},t.useSyncExternalStore=function(e,t,n){return A.current.useSyncExternalStore(e,t,n)},t.useTransition=function(){return A.current.useTransition()},t.version="18.2.0"},504:(e,t,n)=>{"use strict";e.exports=n(28)},624:(e,t,n)=>{"use strict";e.exports=n(808)},928:function(e){e.exports=function(){"use strict";var e=void 0;"undefined"!=typeof window&&(e=window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||window.msRequestAnimationFrame||window.oRequestAnimationFrame),e||"undefined"==typeof process||"node"!==process.title||(e=setImmediate);var t=e=e||function(e){window.setTimeout(e,1e3/60)},n=Array.prototype.concat,r=Array.prototype.slice;function i(e,t){for(var i=arguments.length,o=Array(i>2?i-2:0),a=2;a<i;a++)o[a-2]=arguments[a];return function(){for(var i=arguments.length,a=Array(i),s=0;s<i;s++)a[s]=arguments[s];e.apply(t,n.call(o,r.call(a)))}}function o(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])}function a(e){return t(e)}function s(e,t){var n=e.indexOf(t);-1!==n&&e.splice(n,1)}var l={};function c(e){if(l[e])return l[e];var t=e.replace("#","");3===t.length&&(t=t[0]+t[0]+t[1]+t[1]+t[2]+t[2]);var n=t.match(/.{2}/g);if(!n||n.length<3)throw new Error("Expected a color string of format #rrggbb");var r={r:parseInt(n[0],16),g:parseInt(n[1],16),b:parseInt(n[2],16)};return l[e]=r,r}function u(e,t,n){var r=e.toString(16),i=t.toString(16),o=n.toString(16);return"#"+(r=r.length<2?"0"+r:r)+(i=i.length<2?"0"+i:i)+(o=o.length<2?"0"+o:o)}var d=Object.freeze({bind:i,extend:o,onFrame:a,removeFirst:s,hexToRGB:c,rgbToHex:u});function f(e,t,n,r,i){return r+(e-t)/(n-t)*(i-r)}function m(e,t,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:0,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:1,o=arguments[5],a=c(t),s=c(n),l=Math.floor(f(e,r,i,a.r,s.r)),d=Math.floor(f(e,r,i,a.g,s.g)),m=Math.floor(f(e,r,i,a.b,s.b));return o?"rgb("+l+","+d+","+m+")":u(l,d,m)}function g(e){return e*Math.PI/180}function h(e){return 180*e/Math.PI}var p=Object.freeze({mapValueInRange:f,interpolateColor:m,degreesToRadians:g,radiansToDegrees:h});function v(e){return 3.62*(e-30)+194}function b(e){return(e-194)/3.62+30}function y(e){return 3*(e-8)+25}function x(e){return(e-25)/3+8}var _=Object.freeze({tensionFromOrigamiValue:v,origamiValueFromTension:b,frictionFromOrigamiValue:y,origamiFromFriction:x}),j=function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")},O=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},E=function(){function e(){j(this,e),this.springSystem=null}return e.prototype.run=function(){var e=I.call(this);a((function(){e.loop(Date.now())}))},e}(),S=function(){function e(t){j(this,e),this.springSystem=null,this.time=0,this.running=!1,this.timestep=t||16.667}return e.prototype.run=function(){var e=I.call(this);if(!this.running){for(this.running=!0;!e.getIsIdle();)e.loop(this.time+=this.timestep);this.running=!1}},e}(),T=function(){function e(){j(this,e),this.springSystem=null,this.time=0,this.running=!1}return e.prototype.run=function(){},e.prototype.step=function(e){I.call(this).loop(this.time+=e)},e}();function I(){if(null==this.springSystem)throw new Error("cannot run looper without a springSystem");return this.springSystem}var w=Object.freeze({AnimationLooper:E,SimulationLooper:S,SteppingSimulationLooper:T}),P=function(){function e(t,n){j(this,e),this.bounciness=t,this.speed=n;var r=this.normalize(t/1.7,0,20);r=this.projectNormal(r,0,.8);var i=this.normalize(n/1.7,0,20);this.bouncyTension=this.projectNormal(i,.5,200),this.bouncyFriction=this.quadraticOutInterpolation(r,this.b3Nobounce(this.bouncyTension),.01)}return e.prototype.normalize=function(e,t,n){return(e-t)/(n-t)},e.prototype.projectNormal=function(e,t,n){return t+e*(n-t)},e.prototype.linearInterpolation=function(e,t,n){return e*n+(1-e)*t},e.prototype.quadraticOutInterpolation=function(e,t,n){return this.linearInterpolation(2*e-e*e,t,n)},e.prototype.b3Friction1=function(e){return 7e-4*Math.pow(e,3)-.031*Math.pow(e,2)+.64*e+1.28},e.prototype.b3Friction2=function(e){return 44e-6*Math.pow(e,3)-.006*Math.pow(e,2)+.36*e+2},e.prototype.b3Friction3=function(e){return 45e-8*Math.pow(e,3)-332e-6*Math.pow(e,2)+.1078*e+5.84},e.prototype.b3Nobounce=function(e){return e<=18?this.b3Friction1(e):e>18&&e<=44?this.b3Friction2(e):this.b3Friction3(e)},e}(),C=function(){function e(t,n){j(this,e),this.tension=t,this.friction=n}return e.fromOrigamiTensionAndFriction=function(t,n){return new e(v(t),y(n))},e.fromBouncinessAndSpeed=function(t,n){var r=new P(t,n);return e.fromOrigamiTensionAndFriction(r.bouncyTension,r.bouncyFriction)},e.coastingConfigWithOrigamiFriction=function(t){return new e(0,y(t))},e}();C.DEFAULT_ORIGAMI_SPRING_CONFIG=C.fromOrigamiTensionAndFriction(40,7);var N=function e(){j(this,e),this.position=0,this.velocity=0},A=function(){function e(t){j(this,e),this.listeners=[],this._startValue=0,this._currentState=new N,this._displacementFromRestThreshold=.001,this._endValue=0,this._overshootClampingEnabled=!1,this._previousState=new N,this._restSpeedThreshold=.001,this._tempState=new N,this._timeAccumulator=0,this._wasAtRest=!0,this._id="s"+e._ID++,this._springSystem=t}return e.prototype.destroy=function(){this.listeners=[],this._springSystem.deregisterSpring(this)},e.prototype.getId=function(){return this._id},e.prototype.setSpringConfig=function(e){return this._springConfig=e,this},e.prototype.getSpringConfig=function(){return this._springConfig},e.prototype.setCurrentValue=function(e,t){return this._startValue=e,this._currentState.position=e,t||this.setAtRest(),this.notifyPositionUpdated(!1,!1),this},e.prototype.getStartValue=function(){return this._startValue},e.prototype.getCurrentValue=function(){return this._currentState.position},e.prototype.getCurrentDisplacementDistance=function(){return this.getDisplacementDistanceForState(this._currentState)},e.prototype.getDisplacementDistanceForState=function(e){return Math.abs(this._endValue-e.position)},e.prototype.setEndValue=function(e){if(this._endValue===e&&this.isAtRest())return this;this._startValue=this.getCurrentValue(),this._endValue=e,this._springSystem.activateSpring(this.getId());for(var t=0,n=this.listeners.length;t<n;t++){var r=this.listeners[t].onSpringEndStateChange;r&&r(this)}return this},e.prototype.getEndValue=function(){return this._endValue},e.prototype.setVelocity=function(e){return e===this._currentState.velocity||(this._currentState.velocity=e,this._springSystem.activateSpring(this.getId())),this},e.prototype.getVelocity=function(){return this._currentState.velocity},e.prototype.setRestSpeedThreshold=function(e){return this._restSpeedThreshold=e,this},e.prototype.getRestSpeedThreshold=function(){return this._restSpeedThreshold},e.prototype.setRestDisplacementThreshold=function(e){this._displacementFromRestThreshold=e},e.prototype.getRestDisplacementThreshold=function(){return this._displacementFromRestThreshold},e.prototype.setOvershootClampingEnabled=function(e){return this._overshootClampingEnabled=e,this},e.prototype.isOvershootClampingEnabled=function(){return this._overshootClampingEnabled},e.prototype.isOvershooting=function(){var e=this._startValue,t=this._endValue;return this._springConfig.tension>0&&(e<t&&this.getCurrentValue()>t||e>t&&this.getCurrentValue()<t)},e.prototype.advance=function(t,n){var r=this.isAtRest();if(!r||!this._wasAtRest){var i=n;n>e.MAX_DELTA_TIME_SEC&&(i=e.MAX_DELTA_TIME_SEC),this._timeAccumulator+=i;for(var o=this._springConfig.tension,a=this._springConfig.friction,s=this._currentState.position,l=this._currentState.velocity,c=this._tempState.position,u=this._tempState.velocity,d=void 0,f=void 0,m=void 0,g=void 0,h=void 0,p=void 0,v=void 0,b=void 0;this._timeAccumulator>=e.SOLVER_TIMESTEP_SEC;)this._timeAccumulator-=e.SOLVER_TIMESTEP_SEC,this._timeAccumulator<e.SOLVER_TIMESTEP_SEC&&(this._previousState.position=s,this._previousState.velocity=l),d=l,f=o*(this._endValue-c)-a*l,c=s+d*e.SOLVER_TIMESTEP_SEC*.5,m=u=l+f*e.SOLVER_TIMESTEP_SEC*.5,g=o*(this._endValue-c)-a*u,c=s+m*e.SOLVER_TIMESTEP_SEC*.5,h=u=l+g*e.SOLVER_TIMESTEP_SEC*.5,p=o*(this._endValue-c)-a*u,c=s+h*e.SOLVER_TIMESTEP_SEC,v=u=l+p*e.SOLVER_TIMESTEP_SEC,b=1/6*(f+2*(g+p)+(o*(this._endValue-c)-a*u)),s+=1/6*(d+2*(m+h)+v)*e.SOLVER_TIMESTEP_SEC,l+=b*e.SOLVER_TIMESTEP_SEC;this._tempState.position=c,this._tempState.velocity=u,this._currentState.position=s,this._currentState.velocity=l,this._timeAccumulator>0&&this._interpolate(this._timeAccumulator/e.SOLVER_TIMESTEP_SEC),(this.isAtRest()||this._overshootClampingEnabled&&this.isOvershooting())&&(this._springConfig.tension>0?(this._startValue=this._endValue,this._currentState.position=this._endValue):(this._endValue=this._currentState.position,this._startValue=this._endValue),this.setVelocity(0),r=!0);var y=!1;this._wasAtRest&&(this._wasAtRest=!1,y=!0);var x=!1;r&&(this._wasAtRest=!0,x=!0),this.notifyPositionUpdated(y,x)}},e.prototype.notifyPositionUpdated=function(e,t){for(var n=0,r=this.listeners.length;n<r;n++){var i=this.listeners[n];e&&i.onSpringActivate&&i.onSpringActivate(this),i.onSpringUpdate&&i.onSpringUpdate(this),t&&i.onSpringAtRest&&i.onSpringAtRest(this)}},e.prototype.systemShouldAdvance=function(){return!this.isAtRest()||!this.wasAtRest()},e.prototype.wasAtRest=function(){return this._wasAtRest},e.prototype.isAtRest=function(){return Math.abs(this._currentState.velocity)<this._restSpeedThreshold&&(this.getDisplacementDistanceForState(this._currentState)<=this._displacementFromRestThreshold||0===this._springConfig.tension)},e.prototype.setAtRest=function(){return this._endValue=this._currentState.position,this._tempState.position=this._currentState.position,this._currentState.velocity=0,this},e.prototype._interpolate=function(e){this._currentState.position=this._currentState.position*e+this._previousState.position*(1-e),this._currentState.velocity=this._currentState.velocity*e+this._previousState.velocity*(1-e)},e.prototype.getListeners=function(){return this.listeners},e.prototype.addListener=function(e){return this.listeners.push(e),this},e.prototype.removeListener=function(e){return s(this.listeners,e),this},e.prototype.removeAllListeners=function(){return this.listeners=[],this},e.prototype.currentValueIsApproximately=function(e){return Math.abs(this.getCurrentValue()-e)<=this.getRestDisplacementThreshold()},e}();A._ID=0,A.MAX_DELTA_TIME_SEC=.064,A.SOLVER_TIMESTEP_SEC=.001;var L=function(){function e(t){j(this,e),this.listeners=[],this._activeSprings=[],this._idleSpringIndices=[],this._isIdle=!0,this._lastTimeMillis=-1,this._springRegistry={},this.looper=t||new E,this.looper.springSystem=this}return e.prototype.setLooper=function(e){this.looper=e,e.springSystem=this},e.prototype.createSpring=function(e,t){var n=void 0;return n=void 0===e||void 0===t?C.DEFAULT_ORIGAMI_SPRING_CONFIG:C.fromOrigamiTensionAndFriction(e,t),this.createSpringWithConfig(n)},e.prototype.createSpringWithBouncinessAndSpeed=function(e,t){var n=void 0;return n=void 0===e||void 0===t?C.DEFAULT_ORIGAMI_SPRING_CONFIG:C.fromBouncinessAndSpeed(e,t),this.createSpringWithConfig(n)},e.prototype.createSpringWithConfig=function(e){var t=new A(this);return this.registerSpring(t),t.setSpringConfig(e),t},e.prototype.getIsIdle=function(){return this._isIdle},e.prototype.getSpringById=function(e){return this._springRegistry[e]},e.prototype.getAllSprings=function(){var e=[];for(var t in this._springRegistry)this._springRegistry.hasOwnProperty(t)&&e.push(this._springRegistry[t]);return e},e.prototype.registerSpring=function(e){this._springRegistry[e.getId()]=e},e.prototype.deregisterSpring=function(e){s(this._activeSprings,e),delete this._springRegistry[e.getId()]},e.prototype.advance=function(e,t){for(;this._idleSpringIndices.length>0;)this._idleSpringIndices.pop();for(var n=0,r=this._activeSprings.length;n<r;n++){var i=this._activeSprings[n];i.systemShouldAdvance()?i.advance(e/1e3,t/1e3):this._idleSpringIndices.push(this._activeSprings.indexOf(i))}for(;this._idleSpringIndices.length>0;){var o=this._idleSpringIndices.pop();o>=0&&this._activeSprings.splice(o,1)}},e.prototype.loop=function(e){var t=void 0;-1===this._lastTimeMillis&&(this._lastTimeMillis=e-1);var n=e-this._lastTimeMillis;this._lastTimeMillis=e;var r=0,i=this.listeners.length;for(r=0;r<i;r++)(t=this.listeners[r]).onBeforeIntegrate&&t.onBeforeIntegrate(this);for(this.advance(e,n),0===this._activeSprings.length&&(this._isIdle=!0,this._lastTimeMillis=-1),r=0;r<i;r++)(t=this.listeners[r]).onAfterIntegrate&&t.onAfterIntegrate(this);this._isIdle||this.looper.run()},e.prototype.activateSpring=function(e){var t=this._springRegistry[e];-1===this._activeSprings.indexOf(t)&&this._activeSprings.push(t),this.getIsIdle()&&(this._isIdle=!1,this.looper.run())},e.prototype.addListener=function(e){this.listeners.push(e)},e.prototype.removeListener=function(e){s(this.listeners,e)},e.prototype.removeAllListeners=function(){this.listeners=[]},e}();return O({},w,{OrigamiValueConverter:_,MathUtil:p,Spring:A,SpringConfig:C,SpringSystem:L,util:O({},d,p)})}()},328:(e,t)=>{"use strict";function n(e,t){var n=e.length;e.push(t);e:for(;0<n;){var r=n-1>>>1,i=e[r];if(!(0<o(i,t)))break e;e[r]=t,e[n]=i,n=r}}function r(e){return 0===e.length?null:e[0]}function i(e){if(0===e.length)return null;var t=e[0],n=e.pop();if(n!==t){e[0]=n;e:for(var r=0,i=e.length,a=i>>>1;r<a;){var s=2*(r+1)-1,l=e[s],c=s+1,u=e[c];if(0>o(l,n))c<i&&0>o(u,l)?(e[r]=u,e[c]=n,r=c):(e[r]=l,e[s]=n,r=s);else{if(!(c<i&&0>o(u,n)))break e;e[r]=u,e[c]=n,r=c}}}return t}function o(e,t){var n=e.sortIndex-t.sortIndex;return 0!==n?n:e.id-t.id}if("object"==typeof performance&&"function"==typeof performance.now){var a=performance;t.unstable_now=function(){return a.now()}}else{var s=Date,l=s.now();t.unstable_now=function(){return s.now()-l}}var c=[],u=[],d=1,f=null,m=3,g=!1,h=!1,p=!1,v="function"==typeof setTimeout?setTimeout:null,b="function"==typeof clearTimeout?clearTimeout:null,y="undefined"!=typeof setImmediate?setImmediate:null;function x(e){for(var t=r(u);null!==t;){if(null===t.callback)i(u);else{if(!(t.startTime<=e))break;i(u),t.sortIndex=t.expirationTime,n(c,t)}t=r(u)}}function _(e){if(p=!1,x(e),!h)if(null!==r(c))h=!0,L(j);else{var t=r(u);null!==t&&M(_,t.startTime-e)}}function j(e,n){h=!1,p&&(p=!1,b(T),T=-1),g=!0;var o=m;try{for(x(n),f=r(c);null!==f&&(!(f.expirationTime>n)||e&&!P());){var a=f.callback;if("function"==typeof a){f.callback=null,m=f.priorityLevel;var s=a(f.expirationTime<=n);n=t.unstable_now(),"function"==typeof s?f.callback=s:f===r(c)&&i(c),x(n)}else i(c);f=r(c)}if(null!==f)var l=!0;else{var d=r(u);null!==d&&M(_,d.startTime-n),l=!1}return l}finally{f=null,m=o,g=!1}}"undefined"!=typeof navigator&&void 0!==navigator.scheduling&&void 0!==navigator.scheduling.isInputPending&&navigator.scheduling.isInputPending.bind(navigator.scheduling);var O,E=!1,S=null,T=-1,I=5,w=-1;function P(){return!(t.unstable_now()-w<I)}function C(){if(null!==S){var e=t.unstable_now();w=e;var n=!0;try{n=S(!0,e)}finally{n?O():(E=!1,S=null)}}else E=!1}if("function"==typeof y)O=function(){y(C)};else if("undefined"!=typeof MessageChannel){var N=new MessageChannel,A=N.port2;N.port1.onmessage=C,O=function(){A.postMessage(null)}}else O=function(){v(C,0)};function L(e){S=e,E||(E=!0,O())}function M(e,n){T=v((function(){e(t.unstable_now())}),n)}t.unstable_IdlePriority=5,t.unstable_ImmediatePriority=1,t.unstable_LowPriority=4,t.unstable_NormalPriority=3,t.unstable_Profiling=null,t.unstable_UserBlockingPriority=2,t.unstable_cancelCallback=function(e){e.callback=null},t.unstable_continueExecution=function(){h||g||(h=!0,L(j))},t.unstable_forceFrameRate=function(e){0>e||125<e?console.error("forceFrameRate takes a positive int between 0 and 125, forcing frame rates higher than 125 fps is not supported"):I=0<e?Math.floor(1e3/e):5},t.unstable_getCurrentPriorityLevel=function(){return m},t.unstable_getFirstCallbackNode=function(){return r(c)},t.unstable_next=function(e){switch(m){case 1:case 2:case 3:var t=3;break;default:t=m}var n=m;m=t;try{return e()}finally{m=n}},t.unstable_pauseExecution=function(){},t.unstable_requestPaint=function(){},t.unstable_runWithPriority=function(e,t){switch(e){case 1:case 2:case 3:case 4:case 5:break;default:e=3}var n=m;m=e;try{return t()}finally{m=n}},t.unstable_scheduleCallback=function(e,i,o){var a=t.unstable_now();switch("object"==typeof o&&null!==o?o="number"==typeof(o=o.delay)&&0<o?a+o:a:o=a,e){case 1:var s=-1;break;case 2:s=250;break;case 5:s=1073741823;break;case 4:s=1e4;break;default:s=5e3}return e={id:d++,callback:i,priorityLevel:e,startTime:o,expirationTime:s=o+s,sortIndex:-1},o>a?(e.sortIndex=o,n(u,e),null===r(c)&&e===r(u)&&(p?(b(T),T=-1):p=!0,M(_,o-a))):(e.sortIndex=s,n(c,e),h||g||(h=!0,L(j))),e},t.unstable_shouldYield=P,t.unstable_wrapCallback=function(e){var t=m;return function(){var n=m;m=t;try{return e.apply(this,arguments)}finally{m=n}}}},712:(e,t,n)=>{"use strict";e.exports=n(328)}},t={};function n(r){var i=t[r];if(void 0!==i)return i.exports;var o=t[r]={exports:{}};return e[r].call(o.exports,o,o.exports,n),o.exports}n.n=e=>{var t=e&&e.__esModule?()=>e.default:()=>e;return n.d(t,{a:t}),t},n.d=(e,t)=>{for(var r in t)n.o(t,r)&&!n.o(e,r)&&Object.defineProperty(e,r,{enumerable:!0,get:t[r]})},n.g=function(){if("object"==typeof globalThis)return globalThis;try{return this||new Function("return this")()}catch(e){if("object"==typeof window)return window}}(),n.o=(e,t)=>Object.prototype.hasOwnProperty.call(e,t),n.r=e=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},(()=>{"use strict";var e={};n.r(e),n.d(e,{Animation:()=>Br,Animations:()=>Vr,ArcElement:()=>qo,BarController:()=>ci,BarElement:()=>ma,BasePlatform:()=>Bi,BasicPlatform:()=>Vi,BubbleController:()=>ui,CategoryScale:()=>gs,Chart:()=>Ko,Colors:()=>_a,DatasetController:()=>ei,Decimation:()=>Ea,DomPlatform:()=>ro,DoughnutController:()=>di,Element:()=>oo,Filler:()=>Ba,Interaction:()=>Ii,Legend:()=>Wa,LineController:()=>fi,LineElement:()=>ia,LinearScale:()=>bs,LogarithmicScale:()=>Es,PieController:()=>gi,PointElement:()=>aa,PolarAreaController:()=>mi,RadarController:()=>hi,RadialLinearScale:()=>Ls,Scale:()=>ho,ScatterController:()=>pi,SubTitle:()=>qa,Ticks:()=>dn,TimeScale:()=>Bs,TimeSeriesScale:()=>Hs,Title:()=>Ya,Tooltip:()=>us,_adapters:()=>xi,_detectPlatform:()=>io,animator:()=>Fr,controllers:()=>vi,defaults:()=>vn,elements:()=>ga,layouts:()=>Gi,plugins:()=>ds,registerables:()=>Ws,registry:()=>bo,scales:()=>Ks});var t={};n.r(t),n.d(t,{bindValue:()=>fl,call:()=>yl,trigger:()=>bl,useValue:()=>xl});var r={};n.r(r),n.d(r,{Localized:()=>ku,LocalizedBounds:()=>Ou,LocalizedDate:()=>Yu,LocalizedDuration:()=>od,LocalizedEntityName:()=>gd,LocalizedFraction:()=>Pu,LocalizedNumber:()=>su,LocalizedPercentage:()=>bd,LocalizedString:()=>kc,Unit:()=>$c,useLocalization:()=>vc});var i={};n.r(i),n.d(i,{AdvisorItemType:()=>ah,TutorialPhaseType:()=>sh,activateTutorial:()=>zg,activateTutorialPhase:()=>Yg,activateTutorialTag:()=>th,activeTutorial$:()=>Vg,activeTutorialList$:()=>Mg,activeTutorialPhase$:()=>Hg,advisorPanelVisible$:()=>lh,completeActiveTutorial:()=>Qg,completeActiveTutorialPhase:()=>Xg,completeIntro:()=>Zg,completeListIntro:()=>Jg,completeListOutro:()=>eh,forceTutorial:()=>$g,listIntroActive$:()=>Kg,listOutroActive$:()=>Wg,nextTutorial$:()=>kg,setTutorialListFocused:()=>Gg,toggleAdvisorPanel:()=>ch,toggleTutorialListFocus:()=>qg,triggerTutorialTag:()=>nh,tutorialCategories$:()=>Dg,tutorialGroups$:()=>Fg,tutorialIntroActive$:()=>Lg,tutorialListFocused$:()=>Ug,tutorialPending$:()=>Rg,tutorials$:()=>Bg,tutorialsEnabled$:()=>Ag,useTutorialTag:()=>oh,useTutorialTagActivation:()=>rh,useTutorialTagTrigger:()=>ih});var o={};n.r(o),n.d(o,{activeInfoview$:()=>ry,ageData$:()=>e_,arrestedCriminals$:()=>Ox,attractiveness$:()=>Ux,availableFertility$:()=>m_,availableForest$:()=>f_,availableOil$:()=>u_,availableOre$:()=>d_,averageAirPollution$:()=>mx,averageCrimeProbability$:()=>vx,averageFireHazard$:()=>px,averageGroundPollution$:()=>fx,averageHealth$:()=>Ky,averageHotelPrice$:()=>Gx,averageLandValue$:()=>Nx,averageNoisePollution$:()=>hx,averageWaterPollution$:()=>gx,batteryCharge$:()=>hy,birthRate$:()=>Qx,cemeteryAvailability$:()=>ex,cemeteryCapacity$:()=>zy,cemeteryUse$:()=>Wy,clearActiveInfoview:()=>oy,collectedMail$:()=>Kx,collegeAvailability$:()=>By,collegeCapacity$:()=>Ay,collegeEligible$:()=>wy,collegeStudents$:()=>Dy,commercialLevels$:()=>Lx,commercialProfitability$:()=>t_,crimePerMonth$:()=>Px,crimeProbability$:()=>_x,crimeProducers$:()=>xx,criminals$:()=>wx,deathRate$:()=>Yy,deathcareAvailability$:()=>Jy,deliveredMail$:()=>Wx,educationData$:()=>My,electricityAvailability$:()=>fy,electricityConsumption$:()=>sy,electricityExport$:()=>uy,electricityImport$:()=>dy,electricityProduction$:()=>ly,electricityTrade$:()=>gy,electricityTransmission$:()=>my,electricityTransmitted$:()=>cy,elementaryAvailability$:()=>Uy,elementaryCapacity$:()=>Cy,elementaryEligible$:()=>Ty,elementaryStudents$:()=>ky,employed$:()=>$x,employeesData$:()=>__,escapedRate$:()=>Cx,fertilityExtractionRate$:()=>v_,fertilityRenewalRate$:()=>y_,forestExtractionRate$:()=>p_,forestRenewalRate$:()=>b_,garbageProcessingRate$:()=>tx,garbageProductionRate$:()=>ox,healthcareAvailability$:()=>Zy,highSchoolAvailability$:()=>Gy,highSchoolCapacity$:()=>Ny,highSchoolEligible$:()=>Iy,highSchoolStudents$:()=>Ry,inJail$:()=>Ex,inPrison$:()=>Ix,industrialLevels$:()=>Mx,industrialProfitability$:()=>n_,infoviews$:()=>ny,jailAvailability$:()=>bx,jailCapacity$:()=>jx,jobs$:()=>qx,landfillAvailability$:()=>ix,landfillCapacity$:()=>nx,mailProductionRate$:()=>Hx,movedAway$:()=>Jx,movedIn$:()=>Zx,officeLevels$:()=>kx,officeProfitability$:()=>r_,oilExtractionRate$:()=>g_,oreExtractionRate$:()=>h_,parkedCars$:()=>cx,parkingAvailability$:()=>ux,parkingCapacity$:()=>sx,parkingIncome$:()=>lx,patientCapacity$:()=>Qy,patientCount$:()=>Xy,population$:()=>Yx,postServiceAvailability$:()=>zx,prisonAvailability$:()=>yx,prisonCapacity$:()=>Sx,prisoners$:()=>Tx,processingAvailability$:()=>rx,processingRate$:()=>$y,residentialLevels$:()=>Ax,setActiveInfoview:()=>iy,setInfomodeActive:()=>ay,sewageAvailability$:()=>Oy,sewageCapacity$:()=>by,sewageConsumption$:()=>yy,sewageExport$:()=>jy,shelterAvailability$:()=>Fx,shelterCapacity$:()=>Dx,shelteredCount$:()=>Rx,sickCount$:()=>qy,storedGarbage$:()=>ax,topExportColors$:()=>l_,topExportData$:()=>c_,topExportNames$:()=>s_,topImportColors$:()=>o_,topImportData$:()=>a_,topImportNames$:()=>i_,tourismRate$:()=>Bx,trafficFlow$:()=>dx,transportSummaries$:()=>Hy,unemployment$:()=>Xx,universityAvailability$:()=>Vy,universityCapacity$:()=>Ly,universityEligible$:()=>Py,universityStudents$:()=>Fy,useInfoviewToggle:()=>E_,waterAvailability$:()=>Ey,waterCapacity$:()=>py,waterConsumption$:()=>vy,waterExport$:()=>xy,waterImport$:()=>_y,waterTrade$:()=>Sy,weatherEffect$:()=>Vx,workers$:()=>O_,workplacesData$:()=>x_,worksplaces$:()=>j_});var a={};n.r(a),n.d(a,{CityInfoPanelTab:()=>z_,EconomyPanelTab:()=>K_,GamePanelType:()=>M_,GameScreen:()=>S_,LayoutPosition:()=>I_,ProgressionPanelTab:()=>k_,TransportationOverviewPanelTab:()=>$_,activeGamePanel$:()=>R_,activeGameScreen$:()=>w_,activePanelPosition$:()=>F_,blockingPanelActive$:()=>D_,canUseSaveSystem$:()=>C_,closeActiveGamePanel:()=>V_,closeGamePanel:()=>B_,setActiveGameScreen:()=>P_,showCityInfoPanel:()=>q_,showEconomyPanel:()=>Y_,showFreeCameraScreen:()=>L_,showGamePanel:()=>G_,showLifePathDetail:()=>J_,showLifePathList:()=>Z_,showMainScreen:()=>N_,showPauseScreen:()=>A_,showProgressionPanel:()=>W_,showTransportationOverviewPanel:()=>X_,toggleGamePanel:()=>U_,toggleInfoviewMenu:()=>H_,toggleLifePathPanel:()=>Q_,toggleRadioPanel:()=>ej,toggleTransportationOverviewPanel:()=>tj});var s={};n.r(s),n.d(s,{Button:()=>VO,ConfirmationDialog:()=>OO,Dropdown:()=>SE,DropdownItem:()=>RE,DropdownToggle:()=>CE,FloatingButton:()=>KO,FormattedParagraphs:()=>Fv,FormattedText:()=>Iv,Icon:()=>LS,MarkdownRenderer:()=>FS,MarkupRenderer:()=>gv,MenuButton:()=>HO,Panel:()=>CS,PanelFoldout:()=>jS,PanelSection:()=>qE,PanelSectionRow:()=>SS,Portal:()=>MS,Scrollable:()=>gE,Tooltip:()=>jh});var l={};n.r(l);var c={};n.r(c),n.d(c,{focusEntity:()=>VS,focusedEntity$:()=>BS});var u={};n.r(u),n.d(u,{addLike:()=>zS,chirpAdded$:()=>WS,chirps$:()=>KS,removeLike:()=>YS,selectLink:()=>$S});var d={};n.r(d),n.d(d,{addKeyFrame:()=>gT,availableCloudTargets$:()=>ST,captureKey:()=>uT,cinematicCameraSequenceAssets$:()=>ET,deleteCinematicCameraSequence:()=>jT,getControllerDelta:()=>pT,getControllerPanDelta:()=>bT,getControllerZoomDelta:()=>vT,group:()=>ZS,lastLoadedCinematicCameraSequence$:()=>OT,loadCinematicCameraSequence:()=>_T,loop$:()=>nT,modifierAnimationCurveData$:()=>PT,moveKeyFrame:()=>fT,onAfterPlaybackDurationChange:()=>aT,playbackDuration$:()=>JS,playing$:()=>iT,removeCameraTransformKey:()=>dT,removeKeyFrame:()=>mT,resetCinematicCameraSequence:()=>hT,saveCinematicCameraSequence:()=>xT,selectCloudTarget:()=>IT,selectedCloudTarget$:()=>TT,setPlaybackDuration:()=>oT,setTimelinePosition:()=>sT,stopPlayback:()=>lT,timelineLength$:()=>tT,timelinePosition$:()=>eT,toggleCurveEditorFocus:()=>yT,toggleLoop:()=>rT,togglePlayback:()=>cT,transformAnimationCurveData$:()=>wT,useCinematicCameraBindings:()=>CT});var f={};n.r(f),n.d(f,{commercialDemand$:()=>kT,commercialFactors$:()=>BT,happiness$:()=>KT,happinessFactors$:()=>WT,industrialDemand$:()=>RT,industrialFactors$:()=>VT,officeDemand$:()=>DT,officeFactors$:()=>HT,residentialHighDemand$:()=>MT,residentialHighFactors$:()=>GT,residentialLowDemand$:()=>AT,residentialLowFactors$:()=>FT,residentialMediumDemand$:()=>LT,residentialMediumFactors$:()=>UT});var m={};n.r(m),n.d(m,{WeatherType:()=>zT,seasonNameId$:()=>$T,temperature$:()=>XT,weather$:()=>qT});var g={};n.r(g),n.d(g,{expenseItems$:()=>nI,expenseValues$:()=>rI,getItemValue:()=>iI,incomeItems$:()=>eI,incomeValues$:()=>tI,totalExpenses$:()=>JT,totalIncome$:()=>ZT});var h={};n.r(h),n.d(h,{acceptLoanOffer:()=>uI,currentLoan$:()=>sI,loanLimit$:()=>aI,loanOffer$:()=>lI,requestLoanOffer:()=>cI,resetLoanOffer:()=>dI});var p={};n.r(p),n.d(p,{maxProgress$:()=>mI,resourceCategories$:()=>gI,resourceData$:()=>bI,resourceDetails$:()=>hI,resources$:()=>pI,services$:()=>vI});var v={};n.r(v),n.d(v,{resetService:()=>EI,serviceDetails$:()=>_I,services$:()=>xI,setServiceBudget:()=>jI,setServiceFee:()=>OI});var b={};n.r(b),n.d(b,{eventMap$:()=>TI,events$:()=>II,onCloseJournal:()=>PI,onOpenJournal:()=>wI});var y={};n.r(y);var x={};n.r(x),n.d(x,{LifePathItemType:()=>CI,followCitizen:()=>RI,followedCitizens$:()=>AI,lifePathDetails$:()=>LI,lifePathItems$:()=>MI,maxFollowedCitizens$:()=>kI,unfollowCitizen:()=>DI});var _={};n.r(_),n.d(_,{MapTileStatus:()=>FI,availableWater$:()=>VI,buildableLand$:()=>BI,disableMapTileSelection:()=>qI,mapTileSelectionEnabled$:()=>GI,permitCost$:()=>YI,permits$:()=>zI,purchaseFlags$:()=>WI,purchaseMapTiles:()=>XI,purchasePrice$:()=>KI,resources$:()=>HI,setMapTileSelectionEnabled:()=>$I});var j={};n.r(j),n.d(j,{PhotoWidgetType:()=>aw,adjustments$:()=>dw,cinematicCameraVisible$:()=>sw,group:()=>QI,orbitCameraActive$:()=>tw,overlayHidden$:()=>JI,resetCamera:()=>ZI,root:()=>uw,selectTab:()=>iw,selectedTab$:()=>cw,setOverlayHidden:()=>ew,tabs$:()=>lw,takeScreenshot:()=>rw,toggleCinematicCamera:()=>ow,toggleOrbitCameraActive:()=>nw});var O={};n.r(O),n.d(O,{cityPolicies$:()=>mw,setCityPolicy:()=>hw,setPolicy:()=>vw});var E={};n.r(E),n.d(E,{emptyPrefabDetails:()=>Sw,manualUITags$:()=>Ew,prefabDetails$:()=>Ow,themes$:()=>jw});var S={};n.r(S),n.d(S,{CityModifierType:()=>yw,LocalModifierType:()=>xw,PrefabEffectType:()=>bw});var T={};n.r(T),n.d(T,{CONSUMPTION_PROPERTY:()=>Iw,ELECTRICITY_PROPERTY:()=>Cw,POLLUTION_PROPERTY:()=>ww,Pollution:()=>Tw,TRANSPORT_STOP_PROPERTY:()=>Lw,Voltage:()=>Pw});var I={};n.r(I),n.d(I,{AreaType:()=>Nw,PrefabRequirementType:()=>Aw});var w={};n.r(w),n.d(w,{devPoints$:()=>kw,nodeDetails$:()=>Uw,nodes$:()=>Fw,purchaseNode:()=>Vw,selectedDevTree$:()=>Gw,selectedNode$:()=>Bw,serviceDetails$:()=>Dw,services$:()=>Rw});var P={};n.r(P),n.d(P,{isFeatureLocked:()=>zw,lockedFeatures$:()=>Hw,useFeatureLocked:()=>Ww,useFeatureUnlocking:()=>Kw});var C={};n.r(C),n.d(C,{MilestoneUnlockType:()=>mP,achievedMilestone$:()=>pP,achievedMilestoneXP$:()=>vP,clearUnlockedMilestone:()=>EP,defaultMilestoneDetails:()=>hP,maxMilestoneReached$:()=>_P,milestoneDetails$:()=>SP,milestoneUnlocks$:()=>TP,milestones$:()=>jP,nextMilestoneXP$:()=>bP,totalXP$:()=>yP,unlockDetails$:()=>IP,unlockedMilestone$:()=>OP,xpMessageAdded$:()=>xP});var N={};n.r(N),n.d(N,{clearUnlockedSignatures:()=>CP,unlockedSignatures$:()=>PP});var A={};n.r(A),n.d(A,{currentSegment$:()=>KP,emergencyFocusable$:()=>FP,emergencyMessage$:()=>UP,emergencyMode$:()=>DP,focusEmergency:()=>tC,muted$:()=>kP,networks$:()=>VP,paused$:()=>MP,playNext:()=>eC,playPrevious:()=>JP,radioEnabled$:()=>AP,segmentChanged$:()=>WP,selectNetwork:()=>nC,selectStation:()=>rC,selectedNetwork$:()=>GP,selectedStation$:()=>BP,setMuted:()=>qP,setPaused:()=>YP,setSkipAds:()=>QP,setVolume:()=>zP,skipAds$:()=>RP,stations$:()=>HP,toggleMuted:()=>XP,togglePaused:()=>$P,toggleSkipAds:()=>ZP,volume$:()=>LP});var L={};n.r(L),n.d(L,{DeveloperSubsectionType:()=>bC,HouseholdSidebarVariant:()=>RC,LINE_STOP:()=>DC,LINE_VEHICLE:()=>FC,MailSectionType:()=>vC,Pollution:()=>pC,SectionType:()=>hC,activeSelection$:()=>jC,bottomSections$:()=>TC,clearSelection:()=>kC,developerSection$:()=>wC,householdSidebarSection$:()=>CC,lineVisualizerSection$:()=>PC,middleSections$:()=>SC,selectEntity:()=>LC,selectedEntity$:()=>xC,selectedInfoPosition$:()=>OC,selectedRoute$:()=>AC,selectedUITag$:()=>_C,setSelectedRoute:()=>MC,titleSection$:()=>IC,tooltipTags$:()=>NC,topSections$:()=>EC,useGeneratedTooltipParagraphs:()=>BC,useTooltipParagraph:()=>UC,useTooltipParagraphs:()=>GC});var M={};n.r(M),n.d(M,{activeCategory$:()=>YC,activeGroup$:()=>zC,addStat:()=>nN,clearStats:()=>iN,removeStat:()=>rN,sampleCount$:()=>WC,sampleRange$:()=>KC,selectedStatistics$:()=>JC,setSampleRange:()=>oN,stacked$:()=>$C,statGroupsMap$:()=>QC,statLabels$:()=>XC,statUnlockingRequirements$:()=>eN,statisticsCategories$:()=>qC,statsData$:()=>ZC,updatesPerDay$:()=>tN});var k={};n.r(k),n.d(k,{areaResourceTaxRanges$:()=>pN,areaResources$:()=>vN,areaTaxEffects$:()=>hN,areaTaxIncomes$:()=>gN,areaTaxRates$:()=>mN,areaTypes$:()=>fN,maxTaxRate:()=>dN,minTaxRate:()=>uN,resourceTaxIncomes:()=>yN,resourceTaxRates:()=>bN,setAreaTaxRate:()=>jN,setResourceTaxRate:()=>ON,setTaxRate:()=>_N,taxEffect:()=>lN,taxIncome:()=>cN,taxRate:()=>sN,taxResourceInfos:()=>xN});var R={};n.r(R),n.d(R,{LightingState:()=>EN,calculateDateFromDays:()=>DN,calculateDateFromTicks:()=>FN,calculateDateTimeFromTicks:()=>UN,calculateMinutesSinceMidnightFromTicks:()=>GN,calculateTimeFromMinutesSinceMidnight:()=>RN,dateEquals:()=>kN,day$:()=>wN,lightingState$:()=>PN,setSimulationPaused:()=>LN,setSimulationSpeed:()=>MN,simulationPaused$:()=>CN,simulationPausedBarrier$:()=>AN,simulationSpeed$:()=>NN,ticks$:()=>IN,timeSettings$:()=>TN});var D={};n.r(D),n.d(D,{AREA_TOOL:()=>jA,BULLDOZE_TOOL:()=>yA,DEFAULT_TOOL:()=>xA,NET_TOOL:()=>OA,OBJECT_TOOL:()=>EA,ROUTE_TOOL:()=>wA,SELECTION_TOOL:()=>IA,TERRAIN_TOOL:()=>TA,UPGRADE_TOOL:()=>SA,ZONE_TOOL:()=>_A,activeTool$:()=>VN,allSnapMask$:()=>zN,allowBrush$:()=>PA,availableSnapMask$:()=>KN,brushAngle$:()=>MA,brushSize$:()=>AA,brushSizeMax$:()=>RA,brushSizeMin$:()=>kA,brushStrength$:()=>LA,brushes$:()=>NA,bulldozeConfirmationRequested$:()=>HN,changeElevation:()=>uA,color$:()=>oA,colorSupported$:()=>iA,confirmBulldoze:()=>cA,elevation$:()=>qN,elevationDown:()=>fA,elevationDownDisabled$:()=>nA,elevationRange$:()=>$N,elevationScroll:()=>mA,elevationStep$:()=>XN,elevationUp:()=>dA,elevationUpDisabled$:()=>rA,parallelMode$:()=>ZN,parallelModeSupported$:()=>QN,parallelOffset$:()=>JN,selectBrush:()=>DA,selectTool:()=>sA,selectToolMode:()=>lA,selectedBrush$:()=>CA,selectedSnapMask$:()=>WN,setBrushAngle:()=>GA,setBrushSize:()=>FA,setBrushStrength:()=>UA,setColor:()=>aA,setElevationStep:()=>gA,setParallelOffset:()=>vA,setSelectedSnapMask:()=>hA,setUndergroundMode:()=>bA,snapOptionNames$:()=>YN,toggleParallelMode:()=>pA,undergroundMode$:()=>tA,undergroundModeSupported$:()=>eA});var F={};n.r(F),n.d(F,{ToolbarItemType:()=>BA,assetCategories$:()=>KA,assets$:()=>WA,clearAssetSelection:()=>tL,selectAsset:()=>eL,selectAssetCategory:()=>JA,selectAssetMenu:()=>ZA,selectTheme:()=>QA,selectedAsset$:()=>XA,selectedAssetCategory$:()=>qA,selectedAssetMenu$:()=>$A,selectedTheme$:()=>YA,themes$:()=>zA,toolbarGroups$:()=>HA});var U={};n.r(U),n.d(U,{cityName$:()=>aL,money$:()=>iL,moneyDelta$:()=>oL,moneyTrendThresholds$:()=>cL,population$:()=>nL,populationDelta$:()=>rL,populationTrendThresholds$:()=>lL,setCityName:()=>uL,unlimitedMoney$:()=>sL});var G={};n.r(G),n.d(G,{cargoTypes$:()=>mL,deleteLine:()=>bL,hideLine:()=>OL,passengerTypes$:()=>fL,renameLine:()=>yL,resetVisibility:()=>SL,selectLine:()=>vL,selectedCargoType$:()=>pL,selectedPassengerType$:()=>hL,setLineActive:()=>_L,setLineColor:()=>xL,setLineSchedule:()=>EL,setSelectedCargoType:()=>wL,setSelectedPassengerType:()=>IL,showLine:()=>jL,toggleHighlight:()=>TL,transportLines$:()=>gL});var B={};n.r(B),n.d(B,{clearUpgradeSelection:()=>kL,selectUpgrade:()=>ML,selectedUpgrade$:()=>AL,upgradeDetails$:()=>NL,upgrades$:()=>CL,upgrading$:()=>LL});var V={};n.r(V),n.d(V,{budget:()=>l,camera:()=>c,chirper:()=>u,cinematic:()=>d,cityInfo:()=>f,climate:()=>m,devTree:()=>w,economyBudget:()=>g,event:()=>b,feature:()=>P,game:()=>a,infoview:()=>o,infoviewTypes:()=>y,life:()=>x,loan:()=>h,map:()=>_,milestone:()=>C,photo:()=>j,policy:()=>O,prefab:()=>E,prefabEffects:()=>S,prefabProperties:()=>T,prefabRequirements:()=>I,production:()=>p,radio:()=>A,selectedInfo:()=>L,service:()=>v,signatureBuilding:()=>N,statistics:()=>M,taxation:()=>k,time:()=>R,tool:()=>D,toolbar:()=>F,toolbarBottom:()=>U,transport:()=>G,tutorial:()=>i,upgrade:()=>B});var H={};n.r(H),n.d(H,{entityEquals:()=>Qs,entityKey:()=>qs,formatLargeNumber:()=>Wu,isNullOrEmpty:()=>Zs,parseEntityKey:()=>Xs,shallowEqual:()=>el,useCssLength:()=>YO,useFormattedLargeNumber:()=>zu,useMemoizedValue:()=>rl,useRem:()=>zO});var K={};n.r(K),n.d(K,{ActionHintLayout:()=>vk,ActiveFocusDiv:()=>Yv,AutoNavigationScope:()=>Ap,BackConsumer:()=>ap,ControlIcon:()=>mk,EventInputProvider:()=>Rk,ExpandConsumer:()=>op,FOCUS_AUTO:()=>Kh,FOCUS_DISABLED:()=>Hh,FocusActivation:()=>yd,FocusBoundary:()=>Tg,FocusContext:()=>jd,FocusControllerBase:()=>lg,FocusDisabled:()=>GL,FocusKeyOverride:()=>hj,FocusNode:()=>Sg,FocusRoot:()=>wj,FocusScope:()=>pj,FocusSymbol:()=>Wh,GamepadAxis:()=>uk,GamepadButton:()=>ck,GamepadPointerEventProvider:()=>Uk,InputActionBarrier:()=>mb,InputActionConsumer:()=>rp,InputActionHints:()=>dk,InputContext:()=>Xh,InputControllerImpl:()=>Zh,InputStack:()=>Ak,MultiChildFocusController:()=>hp,NativeInputProvider:()=>Vk,NavigationDirection:()=>gp,NavigationScope:()=>Ip,PassiveFocusDiv:()=>zv,PointerBarrier:()=>tE,RootInputControllerImpl:()=>Jh,SelectConsumer:()=>ip,SelectableFocusBoundary:()=>HL,defaultInputController:()=>qh,disabledFocusController:()=>Od,focusAnchorBottom:()=>Ep,focusAnchorCenter:()=>_p,focusAnchorLeft:()=>Op,focusAnchorRight:()=>Sp,focusAnchorTop:()=>jp,gamepadButtonFromString:()=>xk,getClosestKey:()=>yp,getClosestKeyInDirection:()=>xp,getElementFocusPosition:()=>Tp,inputActionNames$:()=>Sk,navActions:()=>fb,onInputActionPerformed$:()=>Tk,onInputActionReleased$:()=>Ik,refocusClosestKey:()=>Pp,refocusClosestKeyIfNoFocus:()=>wp,setInputActionPriority:()=>wk,transformNavigationInput:()=>bp,useElementFocusController:()=>Hp,useEntityFocusChangeListener:()=>DL,useFocusCallback:()=>Eg,useFocusChangeListener:()=>RL,useFocused:()=>jg,useFocusedRef:()=>Og,useGamepadType:()=>yk,useInputControlIcon:()=>bk,useInputController:()=>Qh,useKeyFocusController:()=>mj,useMultiChildFocusController:()=>mp,usePassThroughFocusController:()=>bg,useRootFocusController:()=>Tj,useStringFocusChangeListener:()=>FL,useUniqueFocusKey:()=>zh});var W={};n.r(W),n.d(W,{findModule:()=>Yk,getModule:()=>$k});var z=n(624),Y=n(504);function $(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function q(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function X(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}function Q(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){q(e,t,n[t])}))}return e}function Z(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function J(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function ee(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||ne(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function te(e){return function(e){if(Array.isArray(e))return $(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||ne(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function ne(e,t){if(e){if("string"==typeof e)return $(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?$(e,t):void 0}}var re=new Map,ie={},oe={get:function(e,t){var n=re.get(e);if(n&&n[t])return n[t];throw"Module ".concat(e,"@").concat(t," was not found.")},add:function(e,t){if(re.has(e))throw"Module ".concat(e," was already registered. If you want to override the exports of this module use the override API");re.set(e,t)},override:function(e,t,n){var r=re.get(e);if(!r)throw"Module ".concat(e," was not found.");ie[e]||(ie[e]={}),ie[e][t]||(ie[e][t]=r[t]),r[t]=n},extend:function(e,t,n){var r=re.get(e);if(!r)throw"Module ".concat(e," was not found.");if(e.includes(".scss")){if(!n&&"object"!=typeof t)throw"Extending ".concat(e," SCSS without callback requires passing single argument with scss module classes.");if(n)this.override(e,"classes",n(r.classes));else{var i=Q({},r.classes),o=!0,a=!1,s=void 0;try{for(var l,c=Object.keys(t)[Symbol.iterator]();!(o=(l=c.next()).done);o=!0){var u=l.value;i[u]||(i[u]=""),i[u]+=" ".concat(t[u]),this.override(e,"classes",i)}}catch(e){a=!0,s=e}finally{try{o||null==c.return||c.return()}finally{if(a)throw s}}}}else{if(!n||"function"!=typeof n||"string"!=typeof t)throw"Extending ".concat(e," requires 2 arguments, name of extended export and extend callback taking current value and returning new");this.override(e,t,n(r[t]))}},append:function(e,t,n){var r,i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:void 0,o="function"==typeof t,a="function"==typeof n,s=o?"game-ui/modding/modding-hook.tsx":e,l=o?"ModdingHook":t,c=o?e:void 0,u=a?i:n;o?r=t:a&&(r=n),this.extend(s,l,(function(e){var t=function(t){if(c&&c!==t.name)return(0,z.jsx)(e,Q({},t));var n=t||{},o=n.children,a=J(n,["children"]);if("number"==typeof i&&-1!==u){var s=Y.Children.count(o),l=i<0?s+(i+1):i;return(0,z.jsxs)(e,Z(Q({},a),{children:[Y.Children.map(o,(function(e,t){return l===t||0===t&&l<0?(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(r,{}),e]}):e})),l>=s&&(0,z.jsx)(z.Fragment,{children:(0,z.jsx)(r,{})})]}))}return(0,z.jsxs)(e,Z(Q({},a),{children:[o,(0,z.jsx)(z.Fragment,{children:(0,z.jsx)(r,{})})]}))};return t.displayName="Extended ".concat(l).concat(o?":".concat(c):"","+"),t}))},registry:re,find:function(e){var t=[],n=!0,r=!1,i=void 0;try{for(var o,a=re[Symbol.iterator]();!(n=(o=a.next()).done);n=!0){var s=ee(o.value,2),l=s[0],c=s[1],u=[];for(var d in c)(X(e,RegExp)?e.test(d):d.includes(e))&&u.push(d);u.length?t.push([l].concat(te(u))):(X(e,RegExp)?e.test(l):l.includes(e))&&t.push([l])}}catch(e){r=!0,i=e}finally{try{n||null==a.return||a.return()}finally{if(r)throw i}}return t},reset:function(){var e=!0,t=!1,n=void 0;try{for(var r,i=Object.keys(ie)[Symbol.iterator]();!(e=(r=i.next()).done);e=!0){var o=r.value,a=!0,s=!1,l=void 0;try{for(var c,u=Object.keys(ie[o])[Symbol.iterator]();!(a=(c=u.next()).done);a=!0){var d=c.value;this.override(o,d,ie[o][d])}}catch(e){s=!0,l=e}finally{try{a||null==u.return||u.return()}finally{if(s)throw l}}}}catch(e){t=!0,n=e}finally{try{e||null==i.return||i.return()}finally{if(t)throw n}}}},ae=n(352);let se={"app-container":"app-container_Y5l",appContainer:"app-container_Y5l"};oe.add("game-ui/common/app/app-container.module.scss",{get classes(){return se},set classes(e){Object.assign(se,e)}});const le=se;function ce(){var e=document.createElement("div");return e.className=le.appContainer,document.body.appendChild(e),e}oe.add("game-ui/common/app/app-container.ts",{get createAppContainer(){return ce},set createAppContainer(e){ce=e}});n(580);var ue=n(104);function de(){}const fe=(()=>{let e=0;return()=>e++})();function me(e){return null==e}function ge(e){if(Array.isArray&&Array.isArray(e))return!0;const t=Object.prototype.toString.call(e);return"[object"===t.slice(0,7)&&"Array]"===t.slice(-6)}function he(e){return null!==e&&"[object Object]"===Object.prototype.toString.call(e)}function pe(e){return("number"==typeof e||e instanceof Number)&&isFinite(+e)}function ve(e,t){return pe(e)?e:t}function be(e,t){return void 0===e?t:e}const ye=(e,t)=>"string"==typeof e&&e.endsWith("%")?parseFloat(e)/100*t:+e;function xe(e,t,n){if(e&&"function"==typeof e.call)return e.apply(n,t)}function _e(e,t,n,r){let i,o,a;if(ge(e))if(o=e.length,r)for(i=o-1;i>=0;i--)t.call(n,e[i],i);else for(i=0;i<o;i++)t.call(n,e[i],i);else if(he(e))for(a=Object.keys(e),o=a.length,i=0;i<o;i++)t.call(n,e[a[i]],a[i])}function je(e,t){let n,r,i,o;if(!e||!t||e.length!==t.length)return!1;for(n=0,r=e.length;n<r;++n)if(i=e[n],o=t[n],i.datasetIndex!==o.datasetIndex||i.index!==o.index)return!1;return!0}function Oe(e){if(ge(e))return e.map(Oe);if(he(e)){const t=Object.create(null),n=Object.keys(e),r=n.length;let i=0;for(;i<r;++i)t[n[i]]=Oe(e[n[i]]);return t}return e}function Ee(e){return-1===["__proto__","prototype","constructor"].indexOf(e)}function Se(e,t,n,r){if(!Ee(e))return;const i=t[e],o=n[e];he(i)&&he(o)?Te(i,o,r):t[e]=Oe(o)}function Te(e,t,n){const r=ge(t)?t:[t],i=r.length;if(!he(e))return e;const o=(n=n||{}).merger||Se;let a;for(let t=0;t<i;++t){if(a=r[t],!he(a))continue;const i=Object.keys(a);for(let t=0,r=i.length;t<r;++t)o(i[t],e,a,n)}return e}function Ie(e,t){return Te(e,t,{merger:we})}function we(e,t,n){if(!Ee(e))return;const r=t[e],i=n[e];he(r)&&he(i)?Ie(r,i):Object.prototype.hasOwnProperty.call(t,e)||(t[e]=Oe(i))}const Pe={"":e=>e,x:e=>e.x,y:e=>e.y};function Ce(e,t){const n=Pe[t]||(Pe[t]=function(e){const t=function(e){const t=e.split("."),n=[];let r="";for(const e of t)r+=e,r.endsWith("\\")?r=r.slice(0,-1)+".":(n.push(r),r="");return n}(e);return e=>{for(const n of t){if(""===n)break;e=e&&e[n]}return e}}(t));return n(e)}function Ne(e){return e.charAt(0).toUpperCase()+e.slice(1)}const Ae=e=>void 0!==e,Le=e=>"function"==typeof e,Me=(e,t)=>{if(e.size!==t.size)return!1;for(const n of e)if(!t.has(n))return!1;return!0};const ke=Math.PI,Re=2*ke,De=Re+ke,Fe=Number.POSITIVE_INFINITY,Ue=ke/180,Ge=ke/2,Be=ke/4,Ve=2*ke/3,He=Math.log10,Ke=Math.sign;function We(e,t,n){return Math.abs(e-t)<n}function ze(e){const t=Math.round(e);e=We(e,t,e/1e3)?t:e;const n=Math.pow(10,Math.floor(He(e))),r=e/n;return(r<=1?1:r<=2?2:r<=5?5:10)*n}function Ye(e){return!isNaN(parseFloat(e))&&isFinite(e)}function $e(e,t,n){let r,i,o;for(r=0,i=e.length;r<i;r++)o=e[r][n],isNaN(o)||(t.min=Math.min(t.min,o),t.max=Math.max(t.max,o))}function qe(e){return e*(ke/180)}function Xe(e){return e*(180/ke)}function Qe(e){if(!pe(e))return;let t=1,n=0;for(;Math.round(e*t)/t!==e;)t*=10,n++;return n}function Ze(e,t){const n=t.x-e.x,r=t.y-e.y,i=Math.sqrt(n*n+r*r);let o=Math.atan2(r,n);return o<-.5*ke&&(o+=Re),{angle:o,distance:i}}function Je(e,t){return Math.sqrt(Math.pow(t.x-e.x,2)+Math.pow(t.y-e.y,2))}function et(e,t){return(e-t+De)%Re-ke}function tt(e){return(e%Re+Re)%Re}function nt(e,t,n,r){const i=tt(e),o=tt(t),a=tt(n),s=tt(o-i),l=tt(a-i),c=tt(i-o),u=tt(i-a);return i===o||i===a||r&&o===a||s>l&&c<u}function rt(e,t,n){return Math.max(t,Math.min(n,e))}function it(e,t,n,r=1e-6){return e>=Math.min(t,n)-r&&e<=Math.max(t,n)+r}function ot(e,t,n){n=n||(n=>e[n]<t);let r,i=e.length-1,o=0;for(;i-o>1;)r=o+i>>1,n(r)?o=r:i=r;return{lo:o,hi:i}}const at=(e,t,n,r)=>ot(e,n,r?r=>{const i=e[r][t];return i<n||i===n&&e[r+1][t]===n}:r=>e[r][t]<n),st=(e,t,n)=>ot(e,n,(r=>e[r][t]>=n));const lt=["push","pop","shift","splice","unshift"];function ct(e,t){const n=e._chartjs;if(!n)return;const r=n.listeners,i=r.indexOf(t);-1!==i&&r.splice(i,1),r.length>0||(lt.forEach((t=>{delete e[t]})),delete e._chartjs)}function ut(e){const t=new Set;let n,r;for(n=0,r=e.length;n<r;++n)t.add(e[n]);return t.size===r?e:Array.from(t)}const dt="undefined"==typeof window?function(e){return e()}:window.requestAnimationFrame;function ft(e,t){let n=!1;return function(...r){n||(n=!0,dt.call(window,(()=>{n=!1,e.apply(t,r)})))}}const mt=e=>"start"===e?"left":"end"===e?"right":"center",gt=(e,t,n)=>"start"===e?t:"end"===e?n:(t+n)/2;function ht(e,t,n){const r=t.length;let i=0,o=r;if(e._sorted){const{iScale:a,_parsed:s}=e,l=a.axis,{min:c,max:u,minDefined:d,maxDefined:f}=a.getUserBounds();d&&(i=rt(Math.min(at(s,a.axis,c).lo,n?r:at(t,l,a.getPixelForValue(c)).lo),0,r-1)),o=f?rt(Math.max(at(s,a.axis,u,!0).hi+1,n?0:at(t,l,a.getPixelForValue(u),!0).hi+1),i,r)-i:r-i}return{start:i,count:o}}function pt(e){const{xScale:t,yScale:n,_scaleRanges:r}=e,i={xmin:t.min,xmax:t.max,ymin:n.min,ymax:n.max};if(!r)return e._scaleRanges=i,!0;const o=r.xmin!==t.min||r.xmax!==t.max||r.ymin!==n.min||r.ymax!==n.max;return Object.assign(r,i),o}const vt=e=>0===e||1===e,bt=(e,t,n)=>-Math.pow(2,10*(e-=1))*Math.sin((e-t)*Re/n),yt=(e,t,n)=>Math.pow(2,-10*e)*Math.sin((e-t)*Re/n)+1,xt={linear:e=>e,easeInQuad:e=>e*e,easeOutQuad:e=>-e*(e-2),easeInOutQuad:e=>(e/=.5)<1?.5*e*e:-.5*(--e*(e-2)-1),easeInCubic:e=>e*e*e,easeOutCubic:e=>(e-=1)*e*e+1,easeInOutCubic:e=>(e/=.5)<1?.5*e*e*e:.5*((e-=2)*e*e+2),easeInQuart:e=>e*e*e*e,easeOutQuart:e=>-((e-=1)*e*e*e-1),easeInOutQuart:e=>(e/=.5)<1?.5*e*e*e*e:-.5*((e-=2)*e*e*e-2),easeInQuint:e=>e*e*e*e*e,easeOutQuint:e=>(e-=1)*e*e*e*e+1,easeInOutQuint:e=>(e/=.5)<1?.5*e*e*e*e*e:.5*((e-=2)*e*e*e*e+2),easeInSine:e=>1-Math.cos(e*Ge),easeOutSine:e=>Math.sin(e*Ge),easeInOutSine:e=>-.5*(Math.cos(ke*e)-1),easeInExpo:e=>0===e?0:Math.pow(2,10*(e-1)),easeOutExpo:e=>1===e?1:1-Math.pow(2,-10*e),easeInOutExpo:e=>vt(e)?e:e<.5?.5*Math.pow(2,10*(2*e-1)):.5*(2-Math.pow(2,-10*(2*e-1))),easeInCirc:e=>e>=1?e:-(Math.sqrt(1-e*e)-1),easeOutCirc:e=>Math.sqrt(1-(e-=1)*e),easeInOutCirc:e=>(e/=.5)<1?-.5*(Math.sqrt(1-e*e)-1):.5*(Math.sqrt(1-(e-=2)*e)+1),easeInElastic:e=>vt(e)?e:bt(e,.075,.3),easeOutElastic:e=>vt(e)?e:yt(e,.075,.3),easeInOutElastic(e){const t=.1125;return vt(e)?e:e<.5?.5*bt(2*e,t,.45):.5+.5*yt(2*e-1,t,.45)},easeInBack(e){const t=1.70158;return e*e*((t+1)*e-t)},easeOutBack(e){const t=1.70158;return(e-=1)*e*((t+1)*e+t)+1},easeInOutBack(e){let t=1.70158;return(e/=.5)<1?e*e*((1+(t*=1.525))*e-t)*.5:.5*((e-=2)*e*((1+(t*=1.525))*e+t)+2)},easeInBounce:e=>1-xt.easeOutBounce(1-e),easeOutBounce(e){const t=7.5625,n=2.75;return e<1/n?t*e*e:e<2/n?t*(e-=1.5/n)*e+.75:e<2.5/n?t*(e-=2.25/n)*e+.9375:t*(e-=2.625/n)*e+.984375},easeInOutBounce:e=>e<.5?.5*xt.easeInBounce(2*e):.5*xt.easeOutBounce(2*e-1)+.5};var _t=xt;function jt(e){return e+.5|0}const Ot=(e,t,n)=>Math.max(Math.min(e,n),t);function Et(e){return Ot(jt(2.55*e),0,255)}function St(e){return Ot(jt(255*e),0,255)}function Tt(e){return Ot(jt(e/2.55)/100,0,1)}function It(e){return Ot(jt(100*e),0,100)}const wt={0:0,1:1,2:2,3:3,4:4,5:5,6:6,7:7,8:8,9:9,A:10,B:11,C:12,D:13,E:14,F:15,a:10,b:11,c:12,d:13,e:14,f:15},Pt=[..."0123456789ABCDEF"],Ct=e=>Pt[15&e],Nt=e=>Pt[(240&e)>>4]+Pt[15&e],At=e=>(240&e)>>4==(15&e);function Lt(e){var t=(e=>At(e.r)&&At(e.g)&&At(e.b)&&At(e.a))(e)?Ct:Nt;return e?"#"+t(e.r)+t(e.g)+t(e.b)+((e,t)=>e<255?t(e):"")(e.a,t):void 0}const Mt=/^(hsla?|hwb|hsv)\(\s*([-+.e\d]+)(?:deg)?[\s,]+([-+.e\d]+)%[\s,]+([-+.e\d]+)%(?:[\s,]+([-+.e\d]+)(%)?)?\s*\)$/;function kt(e,t,n){const r=t*Math.min(n,1-n),i=(t,i=(t+e/30)%12)=>n-r*Math.max(Math.min(i-3,9-i,1),-1);return[i(0),i(8),i(4)]}function Rt(e,t,n){const r=(r,i=(r+e/60)%6)=>n-n*t*Math.max(Math.min(i,4-i,1),0);return[r(5),r(3),r(1)]}function Dt(e,t,n){const r=kt(e,1,.5);let i;for(t+n>1&&(i=1/(t+n),t*=i,n*=i),i=0;i<3;i++)r[i]*=1-t-n,r[i]+=t;return r}function Ft(e){const t=e.r/255,n=e.g/255,r=e.b/255,i=Math.max(t,n,r),o=Math.min(t,n,r),a=(i+o)/2;let s,l,c;return i!==o&&(c=i-o,l=a>.5?c/(2-i-o):c/(i+o),s=function(e,t,n,r,i){return e===i?(t-n)/r+(t<n?6:0):t===i?(n-e)/r+2:(e-t)/r+4}(t,n,r,c,i),s=60*s+.5),[0|s,l||0,a]}function Ut(e,t,n,r){return(Array.isArray(t)?e(t[0],t[1],t[2]):e(t,n,r)).map(St)}function Gt(e,t,n){return Ut(kt,e,t,n)}function Bt(e){return(e%360+360)%360}function Vt(e){const t=Mt.exec(e);let n,r=255;if(!t)return;t[5]!==n&&(r=t[6]?Et(+t[5]):St(+t[5]));const i=Bt(+t[2]),o=+t[3]/100,a=+t[4]/100;return n="hwb"===t[1]?function(e,t,n){return Ut(Dt,e,t,n)}(i,o,a):"hsv"===t[1]?function(e,t,n){return Ut(Rt,e,t,n)}(i,o,a):Gt(i,o,a),{r:n[0],g:n[1],b:n[2],a:r}}const Ht={x:"dark",Z:"light",Y:"re",X:"blu",W:"gr",V:"medium",U:"slate",A:"ee",T:"ol",S:"or",B:"ra",C:"lateg",D:"ights",R:"in",Q:"turquois",E:"hi",P:"ro",O:"al",N:"le",M:"de",L:"yello",F:"en",K:"ch",G:"arks",H:"ea",I:"ightg",J:"wh"},Kt={OiceXe:"f0f8ff",antiquewEte:"faebd7",aqua:"ffff",aquamarRe:"7fffd4",azuY:"f0ffff",beige:"f5f5dc",bisque:"ffe4c4",black:"0",blanKedOmond:"ffebcd",Xe:"ff",XeviTet:"8a2be2",bPwn:"a52a2a",burlywood:"deb887",caMtXe:"5f9ea0",KartYuse:"7fff00",KocTate:"d2691e",cSO:"ff7f50",cSnflowerXe:"6495ed",cSnsilk:"fff8dc",crimson:"dc143c",cyan:"ffff",xXe:"8b",xcyan:"8b8b",xgTMnPd:"b8860b",xWay:"a9a9a9",xgYF:"6400",xgYy:"a9a9a9",xkhaki:"bdb76b",xmagFta:"8b008b",xTivegYF:"556b2f",xSange:"ff8c00",xScEd:"9932cc",xYd:"8b0000",xsOmon:"e9967a",xsHgYF:"8fbc8f",xUXe:"483d8b",xUWay:"2f4f4f",xUgYy:"2f4f4f",xQe:"ced1",xviTet:"9400d3",dAppRk:"ff1493",dApskyXe:"bfff",dimWay:"696969",dimgYy:"696969",dodgerXe:"1e90ff",fiYbrick:"b22222",flSOwEte:"fffaf0",foYstWAn:"228b22",fuKsia:"ff00ff",gaRsbSo:"dcdcdc",ghostwEte:"f8f8ff",gTd:"ffd700",gTMnPd:"daa520",Way:"808080",gYF:"8000",gYFLw:"adff2f",gYy:"808080",honeyMw:"f0fff0",hotpRk:"ff69b4",RdianYd:"cd5c5c",Rdigo:"4b0082",ivSy:"fffff0",khaki:"f0e68c",lavFMr:"e6e6fa",lavFMrXsh:"fff0f5",lawngYF:"7cfc00",NmoncEffon:"fffacd",ZXe:"add8e6",ZcSO:"f08080",Zcyan:"e0ffff",ZgTMnPdLw:"fafad2",ZWay:"d3d3d3",ZgYF:"90ee90",ZgYy:"d3d3d3",ZpRk:"ffb6c1",ZsOmon:"ffa07a",ZsHgYF:"20b2aa",ZskyXe:"87cefa",ZUWay:"778899",ZUgYy:"778899",ZstAlXe:"b0c4de",ZLw:"ffffe0",lime:"ff00",limegYF:"32cd32",lRF:"faf0e6",magFta:"ff00ff",maPon:"800000",VaquamarRe:"66cdaa",VXe:"cd",VScEd:"ba55d3",VpurpN:"9370db",VsHgYF:"3cb371",VUXe:"7b68ee",VsprRggYF:"fa9a",VQe:"48d1cc",VviTetYd:"c71585",midnightXe:"191970",mRtcYam:"f5fffa",mistyPse:"ffe4e1",moccasR:"ffe4b5",navajowEte:"ffdead",navy:"80",Tdlace:"fdf5e6",Tive:"808000",TivedBb:"6b8e23",Sange:"ffa500",SangeYd:"ff4500",ScEd:"da70d6",pOegTMnPd:"eee8aa",pOegYF:"98fb98",pOeQe:"afeeee",pOeviTetYd:"db7093",papayawEp:"ffefd5",pHKpuff:"ffdab9",peru:"cd853f",pRk:"ffc0cb",plum:"dda0dd",powMrXe:"b0e0e6",purpN:"800080",YbeccapurpN:"663399",Yd:"ff0000",Psybrown:"bc8f8f",PyOXe:"4169e1",saddNbPwn:"8b4513",sOmon:"fa8072",sandybPwn:"f4a460",sHgYF:"2e8b57",sHshell:"fff5ee",siFna:"a0522d",silver:"c0c0c0",skyXe:"87ceeb",UXe:"6a5acd",UWay:"708090",UgYy:"708090",snow:"fffafa",sprRggYF:"ff7f",stAlXe:"4682b4",tan:"d2b48c",teO:"8080",tEstN:"d8bfd8",tomato:"ff6347",Qe:"40e0d0",viTet:"ee82ee",JHt:"f5deb3",wEte:"ffffff",wEtesmoke:"f5f5f5",Lw:"ffff00",LwgYF:"9acd32"};let Wt;function zt(e){Wt||(Wt=function(){const e={},t=Object.keys(Kt),n=Object.keys(Ht);let r,i,o,a,s;for(r=0;r<t.length;r++){for(a=s=t[r],i=0;i<n.length;i++)o=n[i],s=s.replace(o,Ht[o]);o=parseInt(Kt[a],16),e[s]=[o>>16&255,o>>8&255,255&o]}return e}(),Wt.transparent=[0,0,0,0]);const t=Wt[e.toLowerCase()];return t&&{r:t[0],g:t[1],b:t[2],a:4===t.length?t[3]:255}}const Yt=/^rgba?\(\s*([-+.\d]+)(%)?[\s,]+([-+.e\d]+)(%)?[\s,]+([-+.e\d]+)(%)?(?:[\s,/]+([-+.e\d]+)(%)?)?\s*\)$/;const $t=e=>e<=.0031308?12.92*e:1.055*Math.pow(e,1/2.4)-.055,qt=e=>e<=.04045?e/12.92:Math.pow((e+.055)/1.055,2.4);function Xt(e,t,n){if(e){let r=Ft(e);r[t]=Math.max(0,Math.min(r[t]+r[t]*n,0===t?360:1)),r=Gt(r),e.r=r[0],e.g=r[1],e.b=r[2]}}function Qt(e,t){return e?Object.assign(t||{},e):e}function Zt(e){var t={r:0,g:0,b:0,a:255};return Array.isArray(e)?e.length>=3&&(t={r:e[0],g:e[1],b:e[2],a:255},e.length>3&&(t.a=St(e[3]))):(t=Qt(e,{r:0,g:0,b:0,a:1})).a=St(t.a),t}function Jt(e){return"r"===e.charAt(0)?function(e){const t=Yt.exec(e);let n,r,i,o=255;if(t){if(t[7]!==n){const e=+t[7];o=t[8]?Et(e):Ot(255*e,0,255)}return n=+t[1],r=+t[3],i=+t[5],n=255&(t[2]?Et(n):Ot(n,0,255)),r=255&(t[4]?Et(r):Ot(r,0,255)),i=255&(t[6]?Et(i):Ot(i,0,255)),{r:n,g:r,b:i,a:o}}}(e):Vt(e)}class en{constructor(e){if(e instanceof en)return e;const t=typeof e;let n;var r,i,o;"object"===t?n=Zt(e):"string"===t&&(o=(r=e).length,"#"===r[0]&&(4===o||5===o?i={r:255&17*wt[r[1]],g:255&17*wt[r[2]],b:255&17*wt[r[3]],a:5===o?17*wt[r[4]]:255}:7!==o&&9!==o||(i={r:wt[r[1]]<<4|wt[r[2]],g:wt[r[3]]<<4|wt[r[4]],b:wt[r[5]]<<4|wt[r[6]],a:9===o?wt[r[7]]<<4|wt[r[8]]:255})),n=i||zt(e)||Jt(e)),this._rgb=n,this._valid=!!n}get valid(){return this._valid}get rgb(){var e=Qt(this._rgb);return e&&(e.a=Tt(e.a)),e}set rgb(e){this._rgb=Zt(e)}rgbString(){return this._valid?(e=this._rgb)&&(e.a<255?`rgba(${e.r}, ${e.g}, ${e.b}, ${Tt(e.a)})`:`rgb(${e.r}, ${e.g}, ${e.b})`):void 0;var e}hexString(){return this._valid?Lt(this._rgb):void 0}hslString(){return this._valid?function(e){if(!e)return;const t=Ft(e),n=t[0],r=It(t[1]),i=It(t[2]);return e.a<255?`hsla(${n}, ${r}%, ${i}%, ${Tt(e.a)})`:`hsl(${n}, ${r}%, ${i}%)`}(this._rgb):void 0}mix(e,t){if(e){const n=this.rgb,r=e.rgb;let i;const o=t===i?.5:t,a=2*o-1,s=n.a-r.a,l=((a*s==-1?a:(a+s)/(1+a*s))+1)/2;i=1-l,n.r=255&l*n.r+i*r.r+.5,n.g=255&l*n.g+i*r.g+.5,n.b=255&l*n.b+i*r.b+.5,n.a=o*n.a+(1-o)*r.a,this.rgb=n}return this}interpolate(e,t){return e&&(this._rgb=function(e,t,n){const r=qt(Tt(e.r)),i=qt(Tt(e.g)),o=qt(Tt(e.b));return{r:St($t(r+n*(qt(Tt(t.r))-r))),g:St($t(i+n*(qt(Tt(t.g))-i))),b:St($t(o+n*(qt(Tt(t.b))-o))),a:e.a+n*(t.a-e.a)}}(this._rgb,e._rgb,t)),this}clone(){return new en(this.rgb)}alpha(e){return this._rgb.a=St(e),this}clearer(e){return this._rgb.a*=1-e,this}greyscale(){const e=this._rgb,t=jt(.3*e.r+.59*e.g+.11*e.b);return e.r=e.g=e.b=t,this}opaquer(e){return this._rgb.a*=1+e,this}negate(){const e=this._rgb;return e.r=255-e.r,e.g=255-e.g,e.b=255-e.b,this}lighten(e){return Xt(this._rgb,2,e),this}darken(e){return Xt(this._rgb,2,-e),this}saturate(e){return Xt(this._rgb,1,e),this}desaturate(e){return Xt(this._rgb,1,-e),this}rotate(e){return function(e,t){var n=Ft(e);n[0]=Bt(n[0]+t),n=Gt(n),e.r=n[0],e.g=n[1],e.b=n[2]}(this._rgb,e),this}}function tn(e){return new en(e)}function nn(e){if(e&&"object"==typeof e){const t=e.toString();return"[object CanvasPattern]"===t||"[object CanvasGradient]"===t}return!1}function rn(e){return nn(e)?e:tn(e)}function on(e){return nn(e)?e:tn(e).saturate(.5).darken(.1).hexString()}const an=["x","y","borderWidth","radius","tension"],sn=["color","borderColor","backgroundColor"];const ln=new Map;function cn(e,t,n){return function(e,t){t=t||{};const n=e+JSON.stringify(t);let r=ln.get(n);return r||(r=new Intl.NumberFormat(e,t),ln.set(n,r)),r}(t,n).format(e)}const un={values:e=>ge(e)?e:""+e,numeric(e,t,n){if(0===e)return"0";const r=this.chart.options.locale;let i,o=e;if(n.length>1){const t=Math.max(Math.abs(n[0].value),Math.abs(n[n.length-1].value));(t<1e-4||t>1e15)&&(i="scientific"),o=function(e,t){let n=t.length>3?t[2].value-t[1].value:t[1].value-t[0].value;Math.abs(n)>=1&&e!==Math.floor(e)&&(n=e-Math.floor(e));return n}(e,n)}const a=He(Math.abs(o)),s=Math.max(Math.min(-1*Math.floor(a),20),0),l={notation:i,minimumFractionDigits:s,maximumFractionDigits:s};return Object.assign(l,this.options.ticks.format),cn(e,r,l)},logarithmic(e,t,n){if(0===e)return"0";const r=n[t].significand||e/Math.pow(10,Math.floor(He(e)));return[1,2,3,5,10,15].includes(r)||t>.8*n.length?un.numeric.call(this,e,t,n):""}};var dn={formatters:un};const fn=Object.create(null),mn=Object.create(null);function gn(e,t){if(!t)return e;const n=t.split(".");for(let t=0,r=n.length;t<r;++t){const r=n[t];e=e[r]||(e[r]=Object.create(null))}return e}function hn(e,t,n){return"string"==typeof t?Te(gn(e,t),n):Te(gn(e,""),t)}class pn{constructor(e,t){this.animation=void 0,this.backgroundColor="rgba(0,0,0,0.1)",this.borderColor="rgba(0,0,0,0.1)",this.color="#666",this.datasets={},this.devicePixelRatio=e=>e.chart.platform.getDevicePixelRatio(),this.elements={},this.events=["mousemove","mouseout","click","touchstart","touchmove"],this.font={family:"'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",size:12,style:"normal",lineHeight:1.2,weight:null},this.hover={},this.hoverBackgroundColor=(e,t)=>on(t.backgroundColor),this.hoverBorderColor=(e,t)=>on(t.borderColor),this.hoverColor=(e,t)=>on(t.color),this.indexAxis="x",this.interaction={mode:"nearest",intersect:!0,includeInvisible:!1},this.maintainAspectRatio=!0,this.onHover=null,this.onClick=null,this.parsing=!0,this.plugins={},this.responsive=!0,this.scale=void 0,this.scales={},this.showLine=!0,this.drawActiveElementsOnTop=!0,this.describe(e),this.apply(t)}set(e,t){return hn(this,e,t)}get(e){return gn(this,e)}describe(e,t){return hn(mn,e,t)}override(e,t){return hn(fn,e,t)}route(e,t,n,r){const i=gn(this,e),o=gn(this,n),a="_"+t;Object.defineProperties(i,{[a]:{value:i[t],writable:!0},[t]:{enumerable:!0,get(){const e=this[a],t=o[r];return he(e)?Object.assign({},t,e):be(e,t)},set(e){this[a]=e}}})}apply(e){e.forEach((e=>e(this)))}}var vn=new pn({_scriptable:e=>!e.startsWith("on"),_indexable:e=>"events"!==e,hover:{_fallback:"interaction"},interaction:{_scriptable:!1,_indexable:!1}},[function(e){e.set("animation",{delay:void 0,duration:1e3,easing:"easeOutQuart",fn:void 0,from:void 0,loop:void 0,to:void 0,type:void 0}),e.describe("animation",{_fallback:!1,_indexable:!1,_scriptable:e=>"onProgress"!==e&&"onComplete"!==e&&"fn"!==e}),e.set("animations",{colors:{type:"color",properties:sn},numbers:{type:"number",properties:an}}),e.describe("animations",{_fallback:"animation"}),e.set("transitions",{active:{animation:{duration:400}},resize:{animation:{duration:0}},show:{animations:{colors:{from:"transparent"},visible:{type:"boolean",duration:0}}},hide:{animations:{colors:{to:"transparent"},visible:{type:"boolean",easing:"linear",fn:e=>0|e}}}})},function(e){e.set("layout",{autoPadding:!0,padding:{top:0,right:0,bottom:0,left:0}})},function(e){e.set("scale",{display:!0,offset:!1,reverse:!1,beginAtZero:!1,bounds:"ticks",grace:0,grid:{display:!0,lineWidth:1,drawOnChartArea:!0,drawTicks:!0,tickLength:8,tickWidth:(e,t)=>t.lineWidth,tickColor:(e,t)=>t.color,offset:!1},border:{display:!0,dash:[],dashOffset:0,width:1},title:{display:!1,text:"",padding:{top:4,bottom:4}},ticks:{minRotation:0,maxRotation:50,mirror:!1,textStrokeWidth:0,textStrokeColor:"",padding:3,display:!0,autoSkip:!0,autoSkipPadding:3,labelOffset:0,callback:dn.formatters.values,minor:{},major:{},align:"center",crossAlign:"near",showLabelBackdrop:!1,backdropColor:"rgba(255, 255, 255, 0.75)",backdropPadding:2}}),e.route("scale.ticks","color","","color"),e.route("scale.grid","color","","borderColor"),e.route("scale.border","color","","borderColor"),e.route("scale.title","color","","color"),e.describe("scale",{_fallback:!1,_scriptable:e=>!e.startsWith("before")&&!e.startsWith("after")&&"callback"!==e&&"parser"!==e,_indexable:e=>"borderDash"!==e&&"tickBorderDash"!==e&&"dash"!==e}),e.describe("scales",{_fallback:"scale"}),e.describe("scale.ticks",{_scriptable:e=>"backdropPadding"!==e&&"callback"!==e,_indexable:e=>"backdropPadding"!==e})}]);function bn(e,t,n,r,i){let o=t[i];return o||(o=t[i]=e.measureText(i).width,n.push(i)),o>r&&(r=o),r}function yn(e,t,n,r){let i=(r=r||{}).data=r.data||{},o=r.garbageCollect=r.garbageCollect||[];r.font!==t&&(i=r.data={},o=r.garbageCollect=[],r.font=t),e.save(),e.font=t;let a=0;const s=n.length;let l,c,u,d,f;for(l=0;l<s;l++)if(d=n[l],null!=d&&!0!==ge(d))a=bn(e,i,o,a,d);else if(ge(d))for(c=0,u=d.length;c<u;c++)f=d[c],null==f||ge(f)||(a=bn(e,i,o,a,f));e.restore();const m=o.length/2;if(m>n.length){for(l=0;l<m;l++)delete i[o[l]];o.splice(0,m)}return a}function xn(e,t,n){const r=e.currentDevicePixelRatio,i=0!==n?Math.max(n/2,.5):0;return Math.round((t-i)*r)/r+i}function _n(e,t){(t=t||e.getContext("2d")).save(),t.resetTransform(),t.clearRect(0,0,e.width,e.height),t.restore()}function jn(e,t,n,r){On(e,t,n,r,null)}function On(e,t,n,r,i){let o,a,s,l,c,u,d,f;const m=t.pointStyle,g=t.rotation,h=t.radius;let p=(g||0)*Ue;if(m&&"object"==typeof m&&(o=m.toString(),"[object HTMLImageElement]"===o||"[object HTMLCanvasElement]"===o))return e.save(),e.translate(n,r),e.rotate(p),e.drawImage(m,-m.width/2,-m.height/2,m.width,m.height),void e.restore();if(!(isNaN(h)||h<=0)){switch(e.beginPath(),m){default:i?e.ellipse(n,r,i/2,h,0,0,Re):e.arc(n,r,h,0,Re),e.closePath();break;case"triangle":u=i?i/2:h,e.moveTo(n+Math.sin(p)*u,r-Math.cos(p)*h),p+=Ve,e.lineTo(n+Math.sin(p)*u,r-Math.cos(p)*h),p+=Ve,e.lineTo(n+Math.sin(p)*u,r-Math.cos(p)*h),e.closePath();break;case"rectRounded":c=.516*h,l=h-c,a=Math.cos(p+Be)*l,d=Math.cos(p+Be)*(i?i/2-c:l),s=Math.sin(p+Be)*l,f=Math.sin(p+Be)*(i?i/2-c:l),e.arc(n-d,r-s,c,p-ke,p-Ge),e.arc(n+f,r-a,c,p-Ge,p),e.arc(n+d,r+s,c,p,p+Ge),e.arc(n-f,r+a,c,p+Ge,p+ke),e.closePath();break;case"rect":if(!g){l=Math.SQRT1_2*h,u=i?i/2:l,e.rect(n-u,r-l,2*u,2*l);break}p+=Be;case"rectRot":d=Math.cos(p)*(i?i/2:h),a=Math.cos(p)*h,s=Math.sin(p)*h,f=Math.sin(p)*(i?i/2:h),e.moveTo(n-d,r-s),e.lineTo(n+f,r-a),e.lineTo(n+d,r+s),e.lineTo(n-f,r+a),e.closePath();break;case"crossRot":p+=Be;case"cross":d=Math.cos(p)*(i?i/2:h),a=Math.cos(p)*h,s=Math.sin(p)*h,f=Math.sin(p)*(i?i/2:h),e.moveTo(n-d,r-s),e.lineTo(n+d,r+s),e.moveTo(n+f,r-a),e.lineTo(n-f,r+a);break;case"star":d=Math.cos(p)*(i?i/2:h),a=Math.cos(p)*h,s=Math.sin(p)*h,f=Math.sin(p)*(i?i/2:h),e.moveTo(n-d,r-s),e.lineTo(n+d,r+s),e.moveTo(n+f,r-a),e.lineTo(n-f,r+a),p+=Be,d=Math.cos(p)*(i?i/2:h),a=Math.cos(p)*h,s=Math.sin(p)*h,f=Math.sin(p)*(i?i/2:h),e.moveTo(n-d,r-s),e.lineTo(n+d,r+s),e.moveTo(n+f,r-a),e.lineTo(n-f,r+a);break;case"line":a=i?i/2:Math.cos(p)*h,s=Math.sin(p)*h,e.moveTo(n-a,r-s),e.lineTo(n+a,r+s);break;case"dash":e.moveTo(n,r),e.lineTo(n+Math.cos(p)*(i?i/2:h),r+Math.sin(p)*h)}e.fill(),t.borderWidth>0&&e.stroke()}}function En(e,t,n){return n=n||.5,!t||e&&e.x>t.left-n&&e.x<t.right+n&&e.y>t.top-n&&e.y<t.bottom+n}function Sn(e,t){e.save(),e.beginPath(),e.rect(t.left,t.top,t.right-t.left,t.bottom-t.top),e.clip()}function Tn(e){e.restore()}function In(e,t,n,r,i){if(!t)return e.lineTo(n.x,n.y);if("middle"===i){const r=(t.x+n.x)/2;e.lineTo(r,t.y),e.lineTo(r,n.y)}else"after"===i!=!!r?e.lineTo(t.x,n.y):e.lineTo(n.x,t.y);e.lineTo(n.x,n.y)}function wn(e,t,n,r){if(!t)return e.lineTo(n.x,n.y);e.bezierCurveTo(r?t.cp1x:t.cp2x,r?t.cp1y:t.cp2y,r?n.cp2x:n.cp1x,r?n.cp2y:n.cp1y,n.x,n.y)}function Pn(e,t,n,r,i,o={}){const a=ge(t)?t:[t],s=o.strokeWidth>0&&""!==o.strokeColor;let l,c;for(e.save(),e.font=i.string,function(e,t){t.translation&&e.translate(t.translation[0],t.translation[1]);me(t.rotation)||e.rotate(t.rotation);t.color&&(e.fillStyle=t.color);t.textAlign&&(e.textAlign=t.textAlign);t.textBaseline&&(e.textBaseline=t.textBaseline)}(e,o),l=0;l<a.length;++l)c=a[l],o.backdrop&&Nn(e,o.backdrop),s&&(o.strokeColor&&(e.strokeStyle=o.strokeColor),me(o.strokeWidth)||(e.lineWidth=o.strokeWidth),e.strokeText(c,n,r,o.maxWidth)),e.fillText(c,n,r,o.maxWidth),Cn(e,n,r,c,o),r+=i.lineHeight;e.restore()}function Cn(e,t,n,r,i){if(i.strikethrough||i.underline){const o=e.measureText(r),a=t-o.actualBoundingBoxLeft,s=t+o.actualBoundingBoxRight,l=n-o.actualBoundingBoxAscent,c=n+o.actualBoundingBoxDescent,u=i.strikethrough?(l+c)/2:c;e.strokeStyle=e.fillStyle,e.beginPath(),e.lineWidth=i.decorationWidth||2,e.moveTo(a,u),e.lineTo(s,u),e.stroke()}}function Nn(e,t){const n=e.fillStyle;e.fillStyle=t.color,e.fillRect(t.left,t.top,t.width,t.height),e.fillStyle=n}function An(e,t){const{x:n,y:r,w:i,h:o,radius:a}=t;e.arc(n+a.topLeft,r+a.topLeft,a.topLeft,-Ge,ke,!0),e.lineTo(n,r+o-a.bottomLeft),e.arc(n+a.bottomLeft,r+o-a.bottomLeft,a.bottomLeft,ke,Ge,!0),e.lineTo(n+i-a.bottomRight,r+o),e.arc(n+i-a.bottomRight,r+o-a.bottomRight,a.bottomRight,Ge,0,!0),e.lineTo(n+i,r+a.topRight),e.arc(n+i-a.topRight,r+a.topRight,a.topRight,0,-Ge,!0),e.lineTo(n+a.topLeft,r)}const Ln=/^(normal|(\d+(?:\.\d+)?)(px|em|%)?)$/,Mn=/^(normal|italic|initial|inherit|unset|(oblique( -?[0-9]?[0-9]deg)?))$/;function kn(e,t){const n=(""+e).match(Ln);if(!n||"normal"===n[1])return 1.2*t;switch(e=+n[2],n[3]){case"px":return e;case"%":e/=100}return t*e}const Rn=e=>+e||0;function Dn(e,t){const n={},r=he(t),i=r?Object.keys(t):t,o=he(e)?r?n=>be(e[n],e[t[n]]):t=>e[t]:()=>e;for(const e of i)n[e]=Rn(o(e));return n}function Fn(e){return Dn(e,{top:"y",right:"x",bottom:"y",left:"x"})}function Un(e){return Dn(e,["topLeft","topRight","bottomLeft","bottomRight"])}function Gn(e){const t=Fn(e);return t.width=t.left+t.right,t.height=t.top+t.bottom,t}function Bn(e,t){e=e||{},t=t||vn.font;let n=be(e.size,t.size);"string"==typeof n&&(n=parseInt(n,10));let r=be(e.style,t.style);r&&!(""+r).match(Mn)&&(console.warn('Invalid font style specified: "'+r+'"'),r=void 0);const i={family:be(e.family,t.family),lineHeight:kn(be(e.lineHeight,t.lineHeight),n),size:n,style:r,weight:be(e.weight,t.weight),string:""};return i.string=function(e){return!e||me(e.size)||me(e.family)?null:(e.style?e.style+" ":"")+(e.weight?e.weight+" ":"")+e.size+"px "+e.family}(i),i}function Vn(e,t,n,r){let i,o,a,s=!0;for(i=0,o=e.length;i<o;++i)if(a=e[i],void 0!==a&&(void 0!==t&&"function"==typeof a&&(a=a(t),s=!1),void 0!==n&&ge(a)&&(a=a[n%a.length],s=!1),void 0!==a))return r&&!s&&(r.cacheable=!1),a}function Hn(e,t){return Object.assign(Object.create(e),t)}function Kn(e,t=[""],n=e,r,i=(()=>e[0])){Ae(r)||(r=tr("_fallback",e));const o={[Symbol.toStringTag]:"Object",_cacheable:!0,_scopes:e,_rootScopes:n,_fallback:r,_getTarget:i,override:i=>Kn([i,...e],t,n,r)};return new Proxy(o,{deleteProperty:(t,n)=>(delete t[n],delete t._keys,delete e[0][n],!0),get:(n,r)=>qn(n,r,(()=>function(e,t,n,r){let i;for(const o of t)if(i=tr(Yn(o,e),n),Ae(i))return $n(e,i)?Jn(n,r,e,i):i}(r,t,e,n))),getOwnPropertyDescriptor:(e,t)=>Reflect.getOwnPropertyDescriptor(e._scopes[0],t),getPrototypeOf:()=>Reflect.getPrototypeOf(e[0]),has:(e,t)=>nr(e).includes(t),ownKeys:e=>nr(e),set(e,t,n){const r=e._storage||(e._storage=i());return e[t]=r[t]=n,delete e._keys,!0}})}function Wn(e,t,n,r){const i={_cacheable:!1,_proxy:e,_context:t,_subProxy:n,_stack:new Set,_descriptors:zn(e,r),setContext:t=>Wn(e,t,n,r),override:i=>Wn(e.override(i),t,n,r)};return new Proxy(i,{deleteProperty:(t,n)=>(delete t[n],delete e[n],!0),get:(e,t,n)=>qn(e,t,(()=>function(e,t,n){const{_proxy:r,_context:i,_subProxy:o,_descriptors:a}=e;let s=r[t];Le(s)&&a.isScriptable(t)&&(s=function(e,t,n,r){const{_proxy:i,_context:o,_subProxy:a,_stack:s}=n;if(s.has(e))throw new Error("Recursion detected: "+Array.from(s).join("->")+"->"+e);s.add(e),t=t(o,a||r),s.delete(e),$n(e,t)&&(t=Jn(i._scopes,i,e,t));return t}(t,s,e,n));ge(s)&&s.length&&(s=function(e,t,n,r){const{_proxy:i,_context:o,_subProxy:a,_descriptors:s}=n;if(Ae(o.index)&&r(e))t=t[o.index%t.length];else if(he(t[0])){const n=t,r=i._scopes.filter((e=>e!==n));t=[];for(const l of n){const n=Jn(r,i,e,l);t.push(Wn(n,o,a&&a[e],s))}}return t}(t,s,e,a.isIndexable));$n(t,s)&&(s=Wn(s,i,o&&o[t],a));return s}(e,t,n))),getOwnPropertyDescriptor:(t,n)=>t._descriptors.allKeys?Reflect.has(e,n)?{enumerable:!0,configurable:!0}:void 0:Reflect.getOwnPropertyDescriptor(e,n),getPrototypeOf:()=>Reflect.getPrototypeOf(e),has:(t,n)=>Reflect.has(e,n),ownKeys:()=>Reflect.ownKeys(e),set:(t,n,r)=>(e[n]=r,delete t[n],!0)})}function zn(e,t={scriptable:!0,indexable:!0}){const{_scriptable:n=t.scriptable,_indexable:r=t.indexable,_allKeys:i=t.allKeys}=e;return{allKeys:i,scriptable:n,indexable:r,isScriptable:Le(n)?n:()=>n,isIndexable:Le(r)?r:()=>r}}const Yn=(e,t)=>e?e+Ne(t):t,$n=(e,t)=>he(t)&&"adapters"!==e&&(null===Object.getPrototypeOf(t)||t.constructor===Object);function qn(e,t,n){if(Object.prototype.hasOwnProperty.call(e,t))return e[t];const r=n();return e[t]=r,r}function Xn(e,t,n){return Le(e)?e(t,n):e}const Qn=(e,t)=>!0===e?t:"string"==typeof e?Ce(t,e):void 0;function Zn(e,t,n,r,i){for(const o of t){const t=Qn(n,o);if(t){e.add(t);const o=Xn(t._fallback,n,i);if(Ae(o)&&o!==n&&o!==r)return o}else if(!1===t&&Ae(r)&&n!==r)return null}return!1}function Jn(e,t,n,r){const i=t._rootScopes,o=Xn(t._fallback,n,r),a=[...e,...i],s=new Set;s.add(r);let l=er(s,a,n,o||n,r);return null!==l&&((!Ae(o)||o===n||(l=er(s,a,o,l,r),null!==l))&&Kn(Array.from(s),[""],i,o,(()=>function(e,t,n){const r=e._getTarget();t in r||(r[t]={});const i=r[t];if(ge(i)&&he(n))return n;return i||{}}(t,n,r))))}function er(e,t,n,r,i){for(;n;)n=Zn(e,t,n,r,i);return n}function tr(e,t){for(const n of t){if(!n)continue;const t=n[e];if(Ae(t))return t}}function nr(e){let t=e._keys;return t||(t=e._keys=function(e){const t=new Set;for(const n of e)for(const e of Object.keys(n).filter((e=>!e.startsWith("_"))))t.add(e);return Array.from(t)}(e._scopes)),t}function rr(e,t,n,r){const{iScale:i}=e,{key:o="r"}=this._parsing,a=new Array(r);let s,l,c,u;for(s=0,l=r;s<l;++s)c=s+n,u=t[c],a[s]={r:i.parse(Ce(u,o),c)};return a}const ir=Number.EPSILON||1e-14,or=(e,t)=>t<e.length&&!e[t].skip&&e[t],ar=e=>"x"===e?"y":"x";function sr(e,t,n,r){const i=e.skip?t:e,o=t,a=n.skip?t:n,s=Je(o,i),l=Je(a,o);let c=s/(s+l),u=l/(s+l);c=isNaN(c)?0:c,u=isNaN(u)?0:u;const d=r*c,f=r*u;return{previous:{x:o.x-d*(a.x-i.x),y:o.y-d*(a.y-i.y)},next:{x:o.x+f*(a.x-i.x),y:o.y+f*(a.y-i.y)}}}function lr(e,t="x"){const n=ar(t),r=e.length,i=Array(r).fill(0),o=Array(r);let a,s,l,c=or(e,0);for(a=0;a<r;++a)if(s=l,l=c,c=or(e,a+1),l){if(c){const e=c[t]-l[t];i[a]=0!==e?(c[n]-l[n])/e:0}o[a]=s?c?Ke(i[a-1])!==Ke(i[a])?0:(i[a-1]+i[a])/2:i[a-1]:i[a]}!function(e,t,n){const r=e.length;let i,o,a,s,l,c=or(e,0);for(let u=0;u<r-1;++u)l=c,c=or(e,u+1),l&&c&&(We(t[u],0,ir)?n[u]=n[u+1]=0:(i=n[u]/t[u],o=n[u+1]/t[u],s=Math.pow(i,2)+Math.pow(o,2),s<=9||(a=3/Math.sqrt(s),n[u]=i*a*t[u],n[u+1]=o*a*t[u])))}(e,i,o),function(e,t,n="x"){const r=ar(n),i=e.length;let o,a,s,l=or(e,0);for(let c=0;c<i;++c){if(a=s,s=l,l=or(e,c+1),!s)continue;const i=s[n],u=s[r];a&&(o=(i-a[n])/3,s[`cp1${n}`]=i-o,s[`cp1${r}`]=u-o*t[c]),l&&(o=(l[n]-i)/3,s[`cp2${n}`]=i+o,s[`cp2${r}`]=u+o*t[c])}}(e,o,t)}function cr(e,t,n){return Math.max(Math.min(e,n),t)}function ur(e,t,n,r,i){let o,a,s,l;if(t.spanGaps&&(e=e.filter((e=>!e.skip))),"monotone"===t.cubicInterpolationMode)lr(e,i);else{let n=r?e[e.length-1]:e[0];for(o=0,a=e.length;o<a;++o)s=e[o],l=sr(n,s,e[Math.min(o+1,a-(r?0:1))%a],t.tension),s.cp1x=l.previous.x,s.cp1y=l.previous.y,s.cp2x=l.next.x,s.cp2y=l.next.y,n=s}t.capBezierPoints&&function(e,t){let n,r,i,o,a,s=En(e[0],t);for(n=0,r=e.length;n<r;++n)a=o,o=s,s=n<r-1&&En(e[n+1],t),o&&(i=e[n],a&&(i.cp1x=cr(i.cp1x,t.left,t.right),i.cp1y=cr(i.cp1y,t.top,t.bottom)),s&&(i.cp2x=cr(i.cp2x,t.left,t.right),i.cp2y=cr(i.cp2y,t.top,t.bottom)))}(e,n)}function dr(){return"undefined"!=typeof window&&"undefined"!=typeof document}function fr(e){let t=e.parentNode;return t&&"[object ShadowRoot]"===t.toString()&&(t=t.host),t}function mr(e,t,n){let r;return"string"==typeof e?(r=parseInt(e,10),-1!==e.indexOf("%")&&(r=r/100*t.parentNode[n])):r=e,r}const gr=e=>e.ownerDocument.defaultView.getComputedStyle(e,null);const hr=["top","right","bottom","left"];function pr(e,t,n){const r={};n=n?"-"+n:"";for(let i=0;i<4;i++){const o=hr[i];r[o]=parseFloat(e[t+"-"+o+n])||0}return r.width=r.left+r.right,r.height=r.top+r.bottom,r}const vr=(e,t,n)=>(e>0||t>0)&&(!n||!n.shadowRoot);function br(e,t){if("native"in e)return e;const{canvas:n,currentDevicePixelRatio:r}=t,i=gr(n),o="border-box"===i.boxSizing,a=pr(i,"padding"),s=pr(i,"border","width"),{x:l,y:c,box:u}=function(e,t){const n=e.touches,r=n&&n.length?n[0]:e,{offsetX:i,offsetY:o}=r;let a,s,l=!1;if(vr(i,o,e.target))a=i,s=o;else{const e=t.getBoundingClientRect();a=r.clientX-e.left,s=r.clientY-e.top,l=!0}return{x:a,y:s,box:l}}(e,n),d=a.left+(u&&s.left),f=a.top+(u&&s.top);let{width:m,height:g}=t;return o&&(m-=a.width+s.width,g-=a.height+s.height),{x:Math.round((l-d)/m*n.width/r),y:Math.round((c-f)/g*n.height/r)}}const yr=e=>Math.round(10*e)/10;function xr(e,t,n,r){const i=gr(e),o=pr(i,"margin"),a=mr(i.maxWidth,e,"clientWidth")||Fe,s=mr(i.maxHeight,e,"clientHeight")||Fe,l=function(e,t,n){let r,i;if(void 0===t||void 0===n){const o=fr(e);if(o){const e=o.getBoundingClientRect(),a=gr(o),s=pr(a,"border","width"),l=pr(a,"padding");t=e.width-l.width-s.width,n=e.height-l.height-s.height,r=mr(a.maxWidth,o,"clientWidth"),i=mr(a.maxHeight,o,"clientHeight")}else t=e.clientWidth,n=e.clientHeight}return{width:t,height:n,maxWidth:r||Fe,maxHeight:i||Fe}}(e,t,n);let{width:c,height:u}=l;if("content-box"===i.boxSizing){const e=pr(i,"border","width"),t=pr(i,"padding");c-=t.width+e.width,u-=t.height+e.height}c=Math.max(0,c-o.width),u=Math.max(0,r?Math.floor(c/r):u-o.height),c=yr(Math.min(c,a,l.maxWidth)),u=yr(Math.min(u,s,l.maxHeight)),c&&!u&&(u=yr(c/2));return(void 0!==t||void 0!==n)&&r&&l.height&&u>l.height&&(u=l.height,c=yr(Math.floor(u*r))),{width:c,height:u}}function _r(e,t,n){const r=t||1,i=Math.floor(e.height*r),o=Math.floor(e.width*r);e.height=i/r,e.width=o/r;const a=e.canvas;return a.style&&(n||!a.style.height&&!a.style.width)&&(a.style.height=`${e.height}px`,a.style.width=`${e.width}px`),(e.currentDevicePixelRatio!==r||a.height!==i||a.width!==o)&&(e.currentDevicePixelRatio=r,a.height=i,a.width=o,e.ctx.setTransform(r,0,0,r,0,0),!0)}const jr=function(){let e=!1;try{const t={get passive(){return e=!0,!1}};window.addEventListener("test",null,t),window.removeEventListener("test",null,t)}catch(e){}return e}();function Or(e,t){const n=function(e,t){return gr(e).getPropertyValue(t)}(e,t),r=n&&n.match(/^(\d+)(\.\d+)?px$/);return r?+r[1]:void 0}function Er(e,t,n,r){return{x:e.x+n*(t.x-e.x),y:e.y+n*(t.y-e.y)}}function Sr(e,t,n,r){return{x:e.x+n*(t.x-e.x),y:"middle"===r?n<.5?e.y:t.y:"after"===r?n<1?e.y:t.y:n>0?t.y:e.y}}function Tr(e,t,n,r){const i={x:e.cp2x,y:e.cp2y},o={x:t.cp1x,y:t.cp1y},a=Er(e,i,n),s=Er(i,o,n),l=Er(o,t,n),c=Er(a,s,n),u=Er(s,l,n);return Er(c,u,n)}function Ir(e,t,n){return e?function(e,t){return{x:n=>e+e+t-n,setWidth(e){t=e},textAlign:e=>"center"===e?e:"right"===e?"left":"right",xPlus:(e,t)=>e-t,leftForLtr:(e,t)=>e-t}}(t,n):{x:e=>e,setWidth(e){},textAlign:e=>e,xPlus:(e,t)=>e+t,leftForLtr:(e,t)=>e}}function wr(e,t){let n,r;"ltr"!==t&&"rtl"!==t||(n=e.canvas.style,r=[n.getPropertyValue("direction"),n.getPropertyPriority("direction")],n.setProperty("direction",t,"important"),e.prevTextDirection=r)}function Pr(e,t){void 0!==t&&(delete e.prevTextDirection,e.canvas.style.setProperty("direction",t[0],t[1]))}function Cr(e){return"angle"===e?{between:nt,compare:et,normalize:tt}:{between:it,compare:(e,t)=>e-t,normalize:e=>e}}function Nr({start:e,end:t,count:n,loop:r,style:i}){return{start:e%n,end:t%n,loop:r&&(t-e+1)%n==0,style:i}}function Ar(e,t,n){if(!n)return[e];const{property:r,start:i,end:o}=n,a=t.length,{compare:s,between:l,normalize:c}=Cr(r),{start:u,end:d,loop:f,style:m}=function(e,t,n){const{property:r,start:i,end:o}=n,{between:a,normalize:s}=Cr(r),l=t.length;let c,u,{start:d,end:f,loop:m}=e;if(m){for(d+=l,f+=l,c=0,u=l;c<u&&a(s(t[d%l][r]),i,o);++c)d--,f--;d%=l,f%=l}return f<d&&(f+=l),{start:d,end:f,loop:m,style:e.style}}(e,t,n),g=[];let h,p,v,b=!1,y=null;const x=()=>b||l(i,v,h)&&0!==s(i,v),_=()=>!b||0===s(o,h)||l(o,v,h);for(let e=u,n=u;e<=d;++e)p=t[e%a],p.skip||(h=c(p[r]),h!==v&&(b=l(h,i,o),null===y&&x()&&(y=0===s(h,i)?e:n),null!==y&&_()&&(g.push(Nr({start:y,end:e,loop:f,count:a,style:m})),y=null),n=e,v=h));return null!==y&&g.push(Nr({start:y,end:d,loop:f,count:a,style:m})),g}function Lr(e,t){const n=[],r=e.segments;for(let i=0;i<r.length;i++){const o=Ar(r[i],e.points,t);o.length&&n.push(...o)}return n}function Mr(e,t,n,r){return r&&r.setContext&&n?function(e,t,n,r){const i=e._chart.getContext(),o=kr(e.options),{_datasetIndex:a,options:{spanGaps:s}}=e,l=n.length,c=[];let u=o,d=t[0].start,f=d;function m(e,t,r,i){const o=s?-1:1;if(e!==t){for(e+=l;n[e%l].skip;)e-=o;for(;n[t%l].skip;)t+=o;e%l!=t%l&&(c.push({start:e%l,end:t%l,loop:r,style:i}),u=i,d=t%l)}}for(const e of t){d=s?d:e.start;let t,o=n[d%l];for(f=d+1;f<=e.end;f++){const s=n[f%l];t=kr(r.setContext(Hn(i,{type:"segment",p0:o,p1:s,p0DataIndex:(f-1)%l,p1DataIndex:f%l,datasetIndex:a}))),Rr(t,u)&&m(d,f-1,e.loop,u),o=s,u=t}d<f-1&&m(d,f-1,e.loop,u)}return c}(e,t,n,r):t}function kr(e){return{backgroundColor:e.backgroundColor,borderCapStyle:e.borderCapStyle,borderDash:e.borderDash,borderDashOffset:e.borderDashOffset,borderJoinStyle:e.borderJoinStyle,borderWidth:e.borderWidth,borderColor:e.borderColor}}function Rr(e,t){return t&&JSON.stringify(e)!==JSON.stringify(t)}class Dr{constructor(){this._request=null,this._charts=new Map,this._running=!1,this._lastDate=void 0}_notify(e,t,n,r){const i=t.listeners[r],o=t.duration;i.forEach((r=>r({chart:e,initial:t.initial,numSteps:o,currentStep:Math.min(n-t.start,o)})))}_refresh(){this._request||(this._running=!0,this._request=dt.call(window,(()=>{this._update(),this._request=null,this._running&&this._refresh()})))}_update(e=Date.now()){let t=0;this._charts.forEach(((n,r)=>{if(!n.running||!n.items.length)return;const i=n.items;let o,a=i.length-1,s=!1;for(;a>=0;--a)o=i[a],o._active?(o._total>n.duration&&(n.duration=o._total),o.tick(e),s=!0):(i[a]=i[i.length-1],i.pop());s&&(r.draw(),this._notify(r,n,e,"progress")),i.length||(n.running=!1,this._notify(r,n,e,"complete"),n.initial=!1),t+=i.length})),this._lastDate=e,0===t&&(this._running=!1)}_getAnims(e){const t=this._charts;let n=t.get(e);return n||(n={running:!1,initial:!0,items:[],listeners:{complete:[],progress:[]}},t.set(e,n)),n}listen(e,t,n){this._getAnims(e).listeners[t].push(n)}add(e,t){t&&t.length&&this._getAnims(e).items.push(...t)}has(e){return this._getAnims(e).items.length>0}start(e){const t=this._charts.get(e);t&&(t.running=!0,t.start=Date.now(),t.duration=t.items.reduce(((e,t)=>Math.max(e,t._duration)),0),this._refresh())}running(e){if(!this._running)return!1;const t=this._charts.get(e);return!!(t&&t.running&&t.items.length)}stop(e){const t=this._charts.get(e);if(!t||!t.items.length)return;const n=t.items;let r=n.length-1;for(;r>=0;--r)n[r].cancel();t.items=[],this._notify(e,t,Date.now(),"complete")}remove(e){return this._charts.delete(e)}}var Fr=new Dr;const Ur="transparent",Gr={boolean:(e,t,n)=>n>.5?t:e,color(e,t,n){const r=rn(e||Ur),i=r.valid&&rn(t||Ur);return i&&i.valid?i.mix(r,n).hexString():t},number:(e,t,n)=>e+(t-e)*n};class Br{constructor(e,t,n,r){const i=t[n];r=Vn([e.to,r,i,e.from]);const o=Vn([e.from,i,r]);this._active=!0,this._fn=e.fn||Gr[e.type||typeof o],this._easing=_t[e.easing]||_t.linear,this._start=Math.floor(Date.now()+(e.delay||0)),this._duration=this._total=Math.floor(e.duration),this._loop=!!e.loop,this._target=t,this._prop=n,this._from=o,this._to=r,this._promises=void 0}active(){return this._active}update(e,t,n){if(this._active){this._notify(!1);const r=this._target[this._prop],i=n-this._start,o=this._duration-i;this._start=n,this._duration=Math.floor(Math.max(o,e.duration)),this._total+=i,this._loop=!!e.loop,this._to=Vn([e.to,t,r,e.from]),this._from=Vn([e.from,r,t])}}cancel(){this._active&&(this.tick(Date.now()),this._active=!1,this._notify(!1))}tick(e){const t=e-this._start,n=this._duration,r=this._prop,i=this._from,o=this._loop,a=this._to;let s;if(this._active=i!==a&&(o||t<n),!this._active)return this._target[r]=a,void this._notify(!0);t<0?this._target[r]=i:(s=t/n%2,s=o&&s>1?2-s:s,s=this._easing(Math.min(1,Math.max(0,s))),this._target[r]=this._fn(i,a,s))}wait(){const e=this._promises||(this._promises=[]);return new Promise(((t,n)=>{e.push({res:t,rej:n})}))}_notify(e){const t=e?"res":"rej",n=this._promises||[];for(let e=0;e<n.length;e++)n[e][t]()}}class Vr{constructor(e,t){this._chart=e,this._properties=new Map,this.configure(t)}configure(e){if(!he(e))return;const t=Object.keys(vn.animation),n=this._properties;Object.getOwnPropertyNames(e).forEach((r=>{const i=e[r];if(!he(i))return;const o={};for(const e of t)o[e]=i[e];(ge(i.properties)&&i.properties||[r]).forEach((e=>{e!==r&&n.has(e)||n.set(e,o)}))}))}_animateOptions(e,t){const n=t.options,r=function(e,t){if(!t)return;let n=e.options;if(!n)return void(e.options=t);n.$shared&&(e.options=n=Object.assign({},n,{$shared:!1,$animations:{}}));return n}(e,n);if(!r)return[];const i=this._createAnimations(r,n);return n.$shared&&function(e,t){const n=[],r=Object.keys(t);for(let t=0;t<r.length;t++){const i=e[r[t]];i&&i.active()&&n.push(i.wait())}return Promise.all(n)}(e.options.$animations,n).then((()=>{e.options=n}),(()=>{})),i}_createAnimations(e,t){const n=this._properties,r=[],i=e.$animations||(e.$animations={}),o=Object.keys(t),a=Date.now();let s;for(s=o.length-1;s>=0;--s){const l=o[s];if("$"===l.charAt(0))continue;if("options"===l){r.push(...this._animateOptions(e,t));continue}const c=t[l];let u=i[l];const d=n.get(l);if(u){if(d&&u.active()){u.update(d,c,a);continue}u.cancel()}d&&d.duration?(i[l]=u=new Br(d,e,l,c),r.push(u)):e[l]=c}return r}update(e,t){if(0===this._properties.size)return void Object.assign(e,t);const n=this._createAnimations(e,t);return n.length?(Fr.add(this._chart,n),!0):void 0}}function Hr(e,t){const n=e&&e.options||{},r=n.reverse,i=void 0===n.min?t:0,o=void 0===n.max?t:0;return{start:r?o:i,end:r?i:o}}function Kr(e,t){const n=[],r=e._getSortedDatasetMetas(t);let i,o;for(i=0,o=r.length;i<o;++i)n.push(r[i].index);return n}function Wr(e,t,n,r={}){const i=e.keys,o="single"===r.mode;let a,s,l,c;if(null!==t){for(a=0,s=i.length;a<s;++a){if(l=+i[a],l===n){if(r.all)continue;break}c=e.values[l],pe(c)&&(o||0===t||Ke(t)===Ke(c))&&(t+=c)}return t}}function zr(e,t){const n=e&&e.options.stacked;return n||void 0===n&&void 0!==t.stack}function Yr(e,t,n){const r=e[t]||(e[t]={});return r[n]||(r[n]={})}function $r(e,t,n,r){for(const i of t.getMatchingVisibleMetas(r).reverse()){const t=e[i.index];if(n&&t>0||!n&&t<0)return i.index}return null}function qr(e,t){const{chart:n,_cachedMeta:r}=e,i=n._stacks||(n._stacks={}),{iScale:o,vScale:a,index:s}=r,l=o.axis,c=a.axis,u=function(e,t,n){return`${e.id}.${t.id}.${n.stack||n.type}`}(o,a,r),d=t.length;let f;for(let e=0;e<d;++e){const n=t[e],{[l]:o,[c]:d}=n;f=(n._stacks||(n._stacks={}))[c]=Yr(i,u,o),f[s]=d,f._top=$r(f,a,!0,r.type),f._bottom=$r(f,a,!1,r.type)}}function Xr(e,t){const n=e.scales;return Object.keys(n).filter((e=>n[e].axis===t)).shift()}function Qr(e,t){const n=e.controller.index,r=e.vScale&&e.vScale.axis;if(r){t=t||e._parsed;for(const e of t){const t=e._stacks;if(!t||void 0===t[r]||void 0===t[r][n])return;delete t[r][n]}}}const Zr=e=>"reset"===e||"none"===e,Jr=(e,t)=>t?e:Object.assign({},e);class ei{static defaults={};static datasetElementType=null;static dataElementType=null;constructor(e,t){this.chart=e,this._ctx=e.ctx,this.index=t,this._cachedDataOpts={},this._cachedMeta=this.getMeta(),this._type=this._cachedMeta.type,this.options=void 0,this._parsing=!1,this._data=void 0,this._objectData=void 0,this._sharedOptions=void 0,this._drawStart=void 0,this._drawCount=void 0,this.enableOptionSharing=!1,this.supportsDecimation=!1,this.$context=void 0,this._syncList=[],this.datasetElementType=new.target.datasetElementType,this.dataElementType=new.target.dataElementType,this.initialize()}initialize(){const e=this._cachedMeta;this.configure(),this.linkScales(),e._stacked=zr(e.vScale,e),this.addElements(),this.options.fill&&!this.chart.isPluginEnabled("filler")&&console.warn("Tried to use the 'fill' option without the 'Filler' plugin enabled. Please import and register the 'Filler' plugin and make sure it is not disabled in the options")}updateIndex(e){this.index!==e&&Qr(this._cachedMeta),this.index=e}linkScales(){const e=this.chart,t=this._cachedMeta,n=this.getDataset(),r=(e,t,n,r)=>"x"===e?t:"r"===e?r:n,i=t.xAxisID=be(n.xAxisID,Xr(e,"x")),o=t.yAxisID=be(n.yAxisID,Xr(e,"y")),a=t.rAxisID=be(n.rAxisID,Xr(e,"r")),s=t.indexAxis,l=t.iAxisID=r(s,i,o,a),c=t.vAxisID=r(s,o,i,a);t.xScale=this.getScaleForId(i),t.yScale=this.getScaleForId(o),t.rScale=this.getScaleForId(a),t.iScale=this.getScaleForId(l),t.vScale=this.getScaleForId(c)}getDataset(){return this.chart.data.datasets[this.index]}getMeta(){return this.chart.getDatasetMeta(this.index)}getScaleForId(e){return this.chart.scales[e]}_getOtherScale(e){const t=this._cachedMeta;return e===t.iScale?t.vScale:t.iScale}reset(){this._update("reset")}_destroy(){const e=this._cachedMeta;this._data&&ct(this._data,this),e._stacked&&Qr(e)}_dataCheck(){const e=this.getDataset(),t=e.data||(e.data=[]),n=this._data;if(he(t))this._data=function(e){const t=Object.keys(e),n=new Array(t.length);let r,i,o;for(r=0,i=t.length;r<i;++r)o=t[r],n[r]={x:o,y:e[o]};return n}(t);else if(n!==t){if(n){ct(n,this);const e=this._cachedMeta;Qr(e),e._parsed=[]}t&&Object.isExtensible(t)&&function(e,t){e._chartjs?e._chartjs.listeners.push(t):(Object.defineProperty(e,"_chartjs",{configurable:!0,enumerable:!1,value:{listeners:[t]}}),lt.forEach((t=>{const n="_onData"+Ne(t),r=e[t];Object.defineProperty(e,t,{configurable:!0,enumerable:!1,value(...t){const i=r.apply(this,t);return e._chartjs.listeners.forEach((e=>{"function"==typeof e[n]&&e[n](...t)})),i}})})))}(t,this),this._syncList=[],this._data=t}}addElements(){const e=this._cachedMeta;this._dataCheck(),this.datasetElementType&&(e.dataset=new this.datasetElementType)}buildOrUpdateElements(e){const t=this._cachedMeta,n=this.getDataset();let r=!1;this._dataCheck();const i=t._stacked;t._stacked=zr(t.vScale,t),t.stack!==n.stack&&(r=!0,Qr(t),t.stack=n.stack),this._resyncElements(e),(r||i!==t._stacked)&&qr(this,t._parsed)}configure(){const e=this.chart.config,t=e.datasetScopeKeys(this._type),n=e.getOptionScopes(this.getDataset(),t,!0);this.options=e.createResolver(n,this.getContext()),this._parsing=this.options.parsing,this._cachedDataOpts={}}parse(e,t){const{_cachedMeta:n,_data:r}=this,{iScale:i,_stacked:o}=n,a=i.axis;let s,l,c,u=0===e&&t===r.length||n._sorted,d=e>0&&n._parsed[e-1];if(!1===this._parsing)n._parsed=r,n._sorted=!0,c=r;else{c=ge(r[e])?this.parseArrayData(n,r,e,t):he(r[e])?this.parseObjectData(n,r,e,t):this.parsePrimitiveData(n,r,e,t);const i=()=>null===l[a]||d&&l[a]<d[a];for(s=0;s<t;++s)n._parsed[s+e]=l=c[s],u&&(i()&&(u=!1),d=l);n._sorted=u}o&&qr(this,c)}parsePrimitiveData(e,t,n,r){const{iScale:i,vScale:o}=e,a=i.axis,s=o.axis,l=i.getLabels(),c=i===o,u=new Array(r);let d,f,m;for(d=0,f=r;d<f;++d)m=d+n,u[d]={[a]:c||i.parse(l[m],m),[s]:o.parse(t[m],m)};return u}parseArrayData(e,t,n,r){const{xScale:i,yScale:o}=e,a=new Array(r);let s,l,c,u;for(s=0,l=r;s<l;++s)c=s+n,u=t[c],a[s]={x:i.parse(u[0],c),y:o.parse(u[1],c)};return a}parseObjectData(e,t,n,r){const{xScale:i,yScale:o}=e,{xAxisKey:a="x",yAxisKey:s="y"}=this._parsing,l=new Array(r);let c,u,d,f;for(c=0,u=r;c<u;++c)d=c+n,f=t[d],l[c]={x:i.parse(Ce(f,a),d),y:o.parse(Ce(f,s),d)};return l}getParsed(e){return this._cachedMeta._parsed[e]}getDataElement(e){return this._cachedMeta.data[e]}applyStack(e,t,n){const r=this.chart,i=this._cachedMeta,o=t[e.axis];return Wr({keys:Kr(r,!0),values:t._stacks[e.axis]},o,i.index,{mode:n})}updateRangeFromParsed(e,t,n,r){const i=n[t.axis];let o=null===i?NaN:i;const a=r&&n._stacks[t.axis];r&&a&&(r.values=a,o=Wr(r,i,this._cachedMeta.index)),e.min=Math.min(e.min,o),e.max=Math.max(e.max,o)}getMinMax(e,t){const n=this._cachedMeta,r=n._parsed,i=n._sorted&&e===n.iScale,o=r.length,a=this._getOtherScale(e),s=((e,t,n)=>e&&!t.hidden&&t._stacked&&{keys:Kr(n,!0),values:null})(t,n,this.chart),l={min:Number.POSITIVE_INFINITY,max:Number.NEGATIVE_INFINITY},{min:c,max:u}=function(e){const{min:t,max:n,minDefined:r,maxDefined:i}=e.getUserBounds();return{min:r?t:Number.NEGATIVE_INFINITY,max:i?n:Number.POSITIVE_INFINITY}}(a);let d,f;function m(){f=r[d];const t=f[a.axis];return!pe(f[e.axis])||c>t||u<t}for(d=0;d<o&&(m()||(this.updateRangeFromParsed(l,e,f,s),!i));++d);if(i)for(d=o-1;d>=0;--d)if(!m()){this.updateRangeFromParsed(l,e,f,s);break}return l}getAllParsedValues(e){const t=this._cachedMeta._parsed,n=[];let r,i,o;for(r=0,i=t.length;r<i;++r)o=t[r][e.axis],pe(o)&&n.push(o);return n}getMaxOverflow(){return!1}getLabelAndValue(e){const t=this._cachedMeta,n=t.iScale,r=t.vScale,i=this.getParsed(e);return{label:n?""+n.getLabelForValue(i[n.axis]):"",value:r?""+r.getLabelForValue(i[r.axis]):""}}_update(e){const t=this._cachedMeta;this.update(e||"default"),t._clip=function(e){let t,n,r,i;return he(e)?(t=e.top,n=e.right,r=e.bottom,i=e.left):t=n=r=i=e,{top:t,right:n,bottom:r,left:i,disabled:!1===e}}(be(this.options.clip,function(e,t,n){if(!1===n)return!1;const r=Hr(e,n),i=Hr(t,n);return{top:i.end,right:r.end,bottom:i.start,left:r.start}}(t.xScale,t.yScale,this.getMaxOverflow())))}update(e){}draw(){const e=this._ctx,t=this.chart,n=this._cachedMeta,r=n.data||[],i=t.chartArea,o=[],a=this._drawStart||0,s=this._drawCount||r.length-a,l=this.options.drawActiveElementsOnTop;let c;for(n.dataset&&n.dataset.draw(e,i,a,s),c=a;c<a+s;++c){const t=r[c];t.hidden||(t.active&&l?o.push(t):t.draw(e,i))}for(c=0;c<o.length;++c)o[c].draw(e,i)}getStyle(e,t){const n=t?"active":"default";return void 0===e&&this._cachedMeta.dataset?this.resolveDatasetElementOptions(n):this.resolveDataElementOptions(e||0,n)}getContext(e,t,n){const r=this.getDataset();let i;if(e>=0&&e<this._cachedMeta.data.length){const t=this._cachedMeta.data[e];i=t.$context||(t.$context=function(e,t,n){return Hn(e,{active:!1,dataIndex:t,parsed:void 0,raw:void 0,element:n,index:t,mode:"default",type:"data"})}(this.getContext(),e,t)),i.parsed=this.getParsed(e),i.raw=r.data[e],i.index=i.dataIndex=e}else i=this.$context||(this.$context=function(e,t){return Hn(e,{active:!1,dataset:void 0,datasetIndex:t,index:t,mode:"default",type:"dataset"})}(this.chart.getContext(),this.index)),i.dataset=r,i.index=i.datasetIndex=this.index;return i.active=!!t,i.mode=n,i}resolveDatasetElementOptions(e){return this._resolveElementOptions(this.datasetElementType.id,e)}resolveDataElementOptions(e,t){return this._resolveElementOptions(this.dataElementType.id,t,e)}_resolveElementOptions(e,t="default",n){const r="active"===t,i=this._cachedDataOpts,o=e+"-"+t,a=i[o],s=this.enableOptionSharing&&Ae(n);if(a)return Jr(a,s);const l=this.chart.config,c=l.datasetElementScopeKeys(this._type,e),u=r?[`${e}Hover`,"hover",e,""]:[e,""],d=l.getOptionScopes(this.getDataset(),c),f=Object.keys(vn.elements[e]),m=l.resolveNamedOptions(d,f,(()=>this.getContext(n,r)),u);return m.$shared&&(m.$shared=s,i[o]=Object.freeze(Jr(m,s))),m}_resolveAnimations(e,t,n){const r=this.chart,i=this._cachedDataOpts,o=`animation-${t}`,a=i[o];if(a)return a;let s;if(!1!==r.options.animation){const r=this.chart.config,i=r.datasetAnimationScopeKeys(this._type,t),o=r.getOptionScopes(this.getDataset(),i);s=r.createResolver(o,this.getContext(e,n,t))}const l=new Vr(r,s&&s.animations);return s&&s._cacheable&&(i[o]=Object.freeze(l)),l}getSharedOptions(e){if(e.$shared)return this._sharedOptions||(this._sharedOptions=Object.assign({},e))}includeOptions(e,t){return!t||Zr(e)||this.chart._animationsDisabled}_getSharedOptions(e,t){const n=this.resolveDataElementOptions(e,t),r=this._sharedOptions,i=this.getSharedOptions(n),o=this.includeOptions(t,i)||i!==r;return this.updateSharedOptions(i,t,n),{sharedOptions:i,includeOptions:o}}updateElement(e,t,n,r){Zr(r)?Object.assign(e,n):this._resolveAnimations(t,r).update(e,n)}updateSharedOptions(e,t,n){e&&!Zr(t)&&this._resolveAnimations(void 0,t).update(e,n)}_setStyle(e,t,n,r){e.active=r;const i=this.getStyle(t,r);this._resolveAnimations(t,n,r).update(e,{options:!r&&this.getSharedOptions(i)||i})}removeHoverStyle(e,t,n){this._setStyle(e,n,"active",!1)}setHoverStyle(e,t,n){this._setStyle(e,n,"active",!0)}_removeDatasetHoverStyle(){const e=this._cachedMeta.dataset;e&&this._setStyle(e,void 0,"active",!1)}_setDatasetHoverStyle(){const e=this._cachedMeta.dataset;e&&this._setStyle(e,void 0,"active",!0)}_resyncElements(e){const t=this._data,n=this._cachedMeta.data;for(const[e,t,n]of this._syncList)this[e](t,n);this._syncList=[];const r=n.length,i=t.length,o=Math.min(i,r);o&&this.parse(0,o),i>r?this._insertElements(r,i-r,e):i<r&&this._removeElements(i,r-i)}_insertElements(e,t,n=!0){const r=this._cachedMeta,i=r.data,o=e+t;let a;const s=e=>{for(e.length+=t,a=e.length-1;a>=o;a--)e[a]=e[a-t]};for(s(i),a=e;a<o;++a)i[a]=new this.dataElementType;this._parsing&&s(r._parsed),this.parse(e,t),n&&this.updateElements(i,e,t,"reset")}updateElements(e,t,n,r){}_removeElements(e,t){const n=this._cachedMeta;if(this._parsing){const r=n._parsed.splice(e,t);n._stacked&&Qr(n,r)}n.data.splice(e,t)}_sync(e){if(this._parsing)this._syncList.push(e);else{const[t,n,r]=e;this[t](n,r)}this.chart._dataChanges.push([this.index,...e])}_onDataPush(){const e=arguments.length;this._sync(["_insertElements",this.getDataset().data.length-e,e])}_onDataPop(){this._sync(["_removeElements",this._cachedMeta.data.length-1,1])}_onDataShift(){this._sync(["_removeElements",0,1])}_onDataSplice(e,t){t&&this._sync(["_removeElements",e,t]);const n=arguments.length-2;n&&this._sync(["_insertElements",e,n])}_onDataUnshift(){this._sync(["_insertElements",0,arguments.length])}}function ti(e){const t=e.iScale,n=function(e,t){if(!e._cache.$bar){const n=e.getMatchingVisibleMetas(t);let r=[];for(let t=0,i=n.length;t<i;t++)r=r.concat(n[t].controller.getAllParsedValues(e));e._cache.$bar=ut(r.sort(((e,t)=>e-t)))}return e._cache.$bar}(t,e.type);let r,i,o,a,s=t._length;const l=()=>{32767!==o&&-32768!==o&&(Ae(a)&&(s=Math.min(s,Math.abs(o-a)||s)),a=o)};for(r=0,i=n.length;r<i;++r)o=t.getPixelForValue(n[r]),l();for(a=void 0,r=0,i=t.ticks.length;r<i;++r)o=t.getPixelForTick(r),l();return s}function ni(e,t,n,r){return ge(e)?function(e,t,n,r){const i=n.parse(e[0],r),o=n.parse(e[1],r),a=Math.min(i,o),s=Math.max(i,o);let l=a,c=s;Math.abs(a)>Math.abs(s)&&(l=s,c=a),t[n.axis]=c,t._custom={barStart:l,barEnd:c,start:i,end:o,min:a,max:s}}(e,t,n,r):t[n.axis]=n.parse(e,r),t}function ri(e,t,n,r){const i=e.iScale,o=e.vScale,a=i.getLabels(),s=i===o,l=[];let c,u,d,f;for(c=n,u=n+r;c<u;++c)f=t[c],d={},d[i.axis]=s||i.parse(a[c],c),l.push(ni(f,d,o,c));return l}function ii(e){return e&&void 0!==e.barStart&&void 0!==e.barEnd}function oi(e,t,n,r){let i=t.borderSkipped;const o={};if(!i)return void(e.borderSkipped=o);if(!0===i)return void(e.borderSkipped={top:!0,right:!0,bottom:!0,left:!0});const{start:a,end:s,reverse:l,top:c,bottom:u}=function(e){let t,n,r,i,o;return e.horizontal?(t=e.base>e.x,n="left",r="right"):(t=e.base<e.y,n="bottom",r="top"),t?(i="end",o="start"):(i="start",o="end"),{start:n,end:r,reverse:t,top:i,bottom:o}}(e);"middle"===i&&n&&(e.enableBorderRadius=!0,(n._top||0)===r?i=c:(n._bottom||0)===r?i=u:(o[ai(u,a,s,l)]=!0,i=c)),o[ai(i,a,s,l)]=!0,e.borderSkipped=o}function ai(e,t,n,r){var i,o,a;return r?(a=n,e=si(e=(i=e)===(o=t)?a:i===a?o:i,n,t)):e=si(e,t,n),e}function si(e,t,n){return"start"===e?t:"end"===e?n:e}function li(e,{inflateAmount:t},n){e.inflateAmount="auto"===t?1===n?.33:0:t}class ci extends ei{static id="bar";static defaults={datasetElementType:!1,dataElementType:"bar",categoryPercentage:.8,barPercentage:.9,grouped:!0,animations:{numbers:{type:"number",properties:["x","y","base","width","height"]}}};static overrides={scales:{_index_:{type:"category",offset:!0,grid:{offset:!0}},_value_:{type:"linear",beginAtZero:!0}}};parsePrimitiveData(e,t,n,r){return ri(e,t,n,r)}parseArrayData(e,t,n,r){return ri(e,t,n,r)}parseObjectData(e,t,n,r){const{iScale:i,vScale:o}=e,{xAxisKey:a="x",yAxisKey:s="y"}=this._parsing,l="x"===i.axis?a:s,c="x"===o.axis?a:s,u=[];let d,f,m,g;for(d=n,f=n+r;d<f;++d)g=t[d],m={},m[i.axis]=i.parse(Ce(g,l),d),u.push(ni(Ce(g,c),m,o,d));return u}updateRangeFromParsed(e,t,n,r){super.updateRangeFromParsed(e,t,n,r);const i=n._custom;i&&t===this._cachedMeta.vScale&&(e.min=Math.min(e.min,i.min),e.max=Math.max(e.max,i.max))}getMaxOverflow(){return 0}getLabelAndValue(e){const t=this._cachedMeta,{iScale:n,vScale:r}=t,i=this.getParsed(e),o=i._custom,a=ii(o)?"["+o.start+", "+o.end+"]":""+r.getLabelForValue(i[r.axis]);return{label:""+n.getLabelForValue(i[n.axis]),value:a}}initialize(){this.enableOptionSharing=!0,super.initialize();this._cachedMeta.stack=this.getDataset().stack}update(e){const t=this._cachedMeta;this.updateElements(t.data,0,t.data.length,e)}updateElements(e,t,n,r){const i="reset"===r,{index:o,_cachedMeta:{vScale:a}}=this,s=a.getBasePixel(),l=a.isHorizontal(),c=this._getRuler(),{sharedOptions:u,includeOptions:d}=this._getSharedOptions(t,r);for(let f=t;f<t+n;f++){const t=this.getParsed(f),n=i||me(t[a.axis])?{base:s,head:s}:this._calculateBarValuePixels(f),m=this._calculateBarIndexPixels(f,c),g=(t._stacks||{})[a.axis],h={horizontal:l,base:n.base,enableBorderRadius:!g||ii(t._custom)||o===g._top||o===g._bottom,x:l?n.head:m.center,y:l?m.center:n.head,height:l?m.size:Math.abs(n.size),width:l?Math.abs(n.size):m.size};d&&(h.options=u||this.resolveDataElementOptions(f,e[f].active?"active":r));const p=h.options||e[f].options;oi(h,p,g,o),li(h,p,c.ratio),this.updateElement(e[f],f,h,r)}}_getStacks(e,t){const{iScale:n}=this._cachedMeta,r=n.getMatchingVisibleMetas(this._type).filter((e=>e.controller.options.grouped)),i=n.options.stacked,o=[],a=e=>{const n=e.controller.getParsed(t),r=n&&n[e.vScale.axis];if(me(r)||isNaN(r))return!0};for(const n of r)if((void 0===t||!a(n))&&((!1===i||-1===o.indexOf(n.stack)||void 0===i&&void 0===n.stack)&&o.push(n.stack),n.index===e))break;return o.length||o.push(void 0),o}_getStackCount(e){return this._getStacks(void 0,e).length}_getStackIndex(e,t,n){const r=this._getStacks(e,n),i=void 0!==t?r.indexOf(t):-1;return-1===i?r.length-1:i}_getRuler(){const e=this.options,t=this._cachedMeta,n=t.iScale,r=[];let i,o;for(i=0,o=t.data.length;i<o;++i)r.push(n.getPixelForValue(this.getParsed(i)[n.axis],i));const a=e.barThickness;return{min:a||ti(t),pixels:r,start:n._startPixel,end:n._endPixel,stackCount:this._getStackCount(),scale:n,grouped:e.grouped,ratio:a?1:e.categoryPercentage*e.barPercentage}}_calculateBarValuePixels(e){const{_cachedMeta:{vScale:t,_stacked:n},options:{base:r,minBarLength:i}}=this,o=r||0,a=this.getParsed(e),s=a._custom,l=ii(s);let c,u,d=a[t.axis],f=0,m=n?this.applyStack(t,a,n):d;m!==d&&(f=m-d,m=d),l&&(d=s.barStart,m=s.barEnd-s.barStart,0!==d&&Ke(d)!==Ke(s.barEnd)&&(f=0),f+=d);const g=me(r)||l?f:r;let h=t.getPixelForValue(g);if(c=this.chart.getDataVisibility(e)?t.getPixelForValue(f+m):h,u=c-h,Math.abs(u)<i){u=function(e,t,n){return 0!==e?Ke(e):(t.isHorizontal()?1:-1)*(t.min>=n?1:-1)}(u,t,o)*i,d===o&&(h-=u/2);const e=t.getPixelForDecimal(0),n=t.getPixelForDecimal(1),r=Math.min(e,n),a=Math.max(e,n);h=Math.max(Math.min(h,a),r),c=h+u}if(h===t.getPixelForValue(o)){const e=Ke(u)*t.getLineWidthForValue(o)/2;h+=e,u-=e}return{size:u,base:h,head:c,center:c+u/2}}_calculateBarIndexPixels(e,t){const n=t.scale,r=this.options,i=r.skipNull,o=be(r.maxBarThickness,1/0);let a,s;if(t.grouped){const n=i?this._getStackCount(e):t.stackCount,l="flex"===r.barThickness?function(e,t,n,r){const i=t.pixels,o=i[e];let a=e>0?i[e-1]:null,s=e<i.length-1?i[e+1]:null;const l=n.categoryPercentage;null===a&&(a=o-(null===s?t.end-t.start:s-o)),null===s&&(s=o+o-a);const c=o-(o-Math.min(a,s))/2*l;return{chunk:Math.abs(s-a)/2*l/r,ratio:n.barPercentage,start:c}}(e,t,r,n):function(e,t,n,r){const i=n.barThickness;let o,a;return me(i)?(o=t.min*n.categoryPercentage,a=n.barPercentage):(o=i*r,a=1),{chunk:o/r,ratio:a,start:t.pixels[e]-o/2}}(e,t,r,n),c=this._getStackIndex(this.index,this._cachedMeta.stack,i?e:void 0);a=l.start+l.chunk*c+l.chunk/2,s=Math.min(o,l.chunk*l.ratio)}else a=n.getPixelForValue(this.getParsed(e)[n.axis],e),s=Math.min(o,t.min*t.ratio);return{base:a-s/2,head:a+s/2,center:a,size:s}}draw(){const e=this._cachedMeta,t=e.vScale,n=e.data,r=n.length;let i=0;for(;i<r;++i)null!==this.getParsed(i)[t.axis]&&n[i].draw(this._ctx)}}class ui extends ei{static id="bubble";static defaults={datasetElementType:!1,dataElementType:"point",animations:{numbers:{type:"number",properties:["x","y","borderWidth","radius"]}}};static overrides={scales:{x:{type:"linear"},y:{type:"linear"}}};initialize(){this.enableOptionSharing=!0,super.initialize()}parsePrimitiveData(e,t,n,r){const i=super.parsePrimitiveData(e,t,n,r);for(let e=0;e<i.length;e++)i[e]._custom=this.resolveDataElementOptions(e+n).radius;return i}parseArrayData(e,t,n,r){const i=super.parseArrayData(e,t,n,r);for(let e=0;e<i.length;e++){const r=t[n+e];i[e]._custom=be(r[2],this.resolveDataElementOptions(e+n).radius)}return i}parseObjectData(e,t,n,r){const i=super.parseObjectData(e,t,n,r);for(let e=0;e<i.length;e++){const r=t[n+e];i[e]._custom=be(r&&r.r&&+r.r,this.resolveDataElementOptions(e+n).radius)}return i}getMaxOverflow(){const e=this._cachedMeta.data;let t=0;for(let n=e.length-1;n>=0;--n)t=Math.max(t,e[n].size(this.resolveDataElementOptions(n))/2);return t>0&&t}getLabelAndValue(e){const t=this._cachedMeta,n=this.chart.data.labels||[],{xScale:r,yScale:i}=t,o=this.getParsed(e),a=r.getLabelForValue(o.x),s=i.getLabelForValue(o.y),l=o._custom;return{label:n[e]||"",value:"("+a+", "+s+(l?", "+l:"")+")"}}update(e){const t=this._cachedMeta.data;this.updateElements(t,0,t.length,e)}updateElements(e,t,n,r){const i="reset"===r,{iScale:o,vScale:a}=this._cachedMeta,{sharedOptions:s,includeOptions:l}=this._getSharedOptions(t,r),c=o.axis,u=a.axis;for(let d=t;d<t+n;d++){const t=e[d],n=!i&&this.getParsed(d),f={},m=f[c]=i?o.getPixelForDecimal(.5):o.getPixelForValue(n[c]),g=f[u]=i?a.getBasePixel():a.getPixelForValue(n[u]);f.skip=isNaN(m)||isNaN(g),l&&(f.options=s||this.resolveDataElementOptions(d,t.active?"active":r),i&&(f.options.radius=0)),this.updateElement(t,d,f,r)}}resolveDataElementOptions(e,t){const n=this.getParsed(e);let r=super.resolveDataElementOptions(e,t);r.$shared&&(r=Object.assign({},r,{$shared:!1}));const i=r.radius;return"active"!==t&&(r.radius=0),r.radius+=be(n&&n._custom,i),r}}class di extends ei{static id="doughnut";static defaults={datasetElementType:!1,dataElementType:"arc",animation:{animateRotate:!0,animateScale:!1},animations:{numbers:{type:"number",properties:["circumference","endAngle","innerRadius","outerRadius","startAngle","x","y","offset","borderWidth","spacing"]}},cutout:"50%",rotation:0,circumference:360,radius:"100%",spacing:0,indexAxis:"r"};static descriptors={_scriptable:e=>"spacing"!==e,_indexable:e=>"spacing"!==e};static overrides={aspectRatio:1,plugins:{legend:{labels:{generateLabels(e){const t=e.data;if(t.labels.length&&t.datasets.length){const{labels:{pointStyle:n,color:r}}=e.legend.options;return t.labels.map(((t,i)=>{const o=e.getDatasetMeta(0).controller.getStyle(i);return{text:t,fillStyle:o.backgroundColor,strokeStyle:o.borderColor,fontColor:r,lineWidth:o.borderWidth,pointStyle:n,hidden:!e.getDataVisibility(i),index:i}}))}return[]}},onClick(e,t,n){n.chart.toggleDataVisibility(t.index),n.chart.update()}}}};constructor(e,t){super(e,t),this.enableOptionSharing=!0,this.innerRadius=void 0,this.outerRadius=void 0,this.offsetX=void 0,this.offsetY=void 0}linkScales(){}parse(e,t){const n=this.getDataset().data,r=this._cachedMeta;if(!1===this._parsing)r._parsed=n;else{let i,o,a=e=>+n[e];if(he(n[e])){const{key:e="value"}=this._parsing;a=t=>+Ce(n[t],e)}for(i=e,o=e+t;i<o;++i)r._parsed[i]=a(i)}}_getRotation(){return qe(this.options.rotation-90)}_getCircumference(){return qe(this.options.circumference)}_getRotationExtents(){let e=Re,t=-Re;for(let n=0;n<this.chart.data.datasets.length;++n)if(this.chart.isDatasetVisible(n)&&this.chart.getDatasetMeta(n).type===this._type){const r=this.chart.getDatasetMeta(n).controller,i=r._getRotation(),o=r._getCircumference();e=Math.min(e,i),t=Math.max(t,i+o)}return{rotation:e,circumference:t-e}}update(e){const t=this.chart,{chartArea:n}=t,r=this._cachedMeta,i=r.data,o=this.getMaxBorderWidth()+this.getMaxOffset(i)+this.options.spacing,a=Math.max((Math.min(n.width,n.height)-o)/2,0),s=Math.min(((e,t)=>"string"==typeof e&&e.endsWith("%")?parseFloat(e)/100:+e/t)(this.options.cutout,a),1),l=this._getRingWeight(this.index),{circumference:c,rotation:u}=this._getRotationExtents(),{ratioX:d,ratioY:f,offsetX:m,offsetY:g}=function(e,t,n){let r=1,i=1,o=0,a=0;if(t<Re){const s=e,l=s+t,c=Math.cos(s),u=Math.sin(s),d=Math.cos(l),f=Math.sin(l),m=(e,t,r)=>nt(e,s,l,!0)?1:Math.max(t,t*n,r,r*n),g=(e,t,r)=>nt(e,s,l,!0)?-1:Math.min(t,t*n,r,r*n),h=m(0,c,d),p=m(Ge,u,f),v=g(ke,c,d),b=g(ke+Ge,u,f);r=(h-v)/2,i=(p-b)/2,o=-(h+v)/2,a=-(p+b)/2}return{ratioX:r,ratioY:i,offsetX:o,offsetY:a}}(u,c,s),h=(n.width-o)/d,p=(n.height-o)/f,v=Math.max(Math.min(h,p)/2,0),b=ye(this.options.radius,v),y=(b-Math.max(b*s,0))/this._getVisibleDatasetWeightTotal();this.offsetX=m*b,this.offsetY=g*b,r.total=this.calculateTotal(),this.outerRadius=b-y*this._getRingWeightOffset(this.index),this.innerRadius=Math.max(this.outerRadius-y*l,0),this.updateElements(i,0,i.length,e)}_circumference(e,t){const n=this.options,r=this._cachedMeta,i=this._getCircumference();return t&&n.animation.animateRotate||!this.chart.getDataVisibility(e)||null===r._parsed[e]||r.data[e].hidden?0:this.calculateCircumference(r._parsed[e]*i/Re)}updateElements(e,t,n,r){const i="reset"===r,o=this.chart,a=o.chartArea,s=o.options.animation,l=(a.left+a.right)/2,c=(a.top+a.bottom)/2,u=i&&s.animateScale,d=u?0:this.innerRadius,f=u?0:this.outerRadius,{sharedOptions:m,includeOptions:g}=this._getSharedOptions(t,r);let h,p=this._getRotation();for(h=0;h<t;++h)p+=this._circumference(h,i);for(h=t;h<t+n;++h){const t=this._circumference(h,i),n=e[h],o={x:l+this.offsetX,y:c+this.offsetY,startAngle:p,endAngle:p+t,circumference:t,outerRadius:f,innerRadius:d};g&&(o.options=m||this.resolveDataElementOptions(h,n.active?"active":r)),p+=t,this.updateElement(n,h,o,r)}}calculateTotal(){const e=this._cachedMeta,t=e.data;let n,r=0;for(n=0;n<t.length;n++){const i=e._parsed[n];null===i||isNaN(i)||!this.chart.getDataVisibility(n)||t[n].hidden||(r+=Math.abs(i))}return r}calculateCircumference(e){const t=this._cachedMeta.total;return t>0&&!isNaN(e)?Re*(Math.abs(e)/t):0}getLabelAndValue(e){const t=this._cachedMeta,n=this.chart,r=n.data.labels||[],i=cn(t._parsed[e],n.options.locale);return{label:r[e]||"",value:i}}getMaxBorderWidth(e){let t=0;const n=this.chart;let r,i,o,a,s;if(!e)for(r=0,i=n.data.datasets.length;r<i;++r)if(n.isDatasetVisible(r)){o=n.getDatasetMeta(r),e=o.data,a=o.controller;break}if(!e)return 0;for(r=0,i=e.length;r<i;++r)s=a.resolveDataElementOptions(r),"inner"!==s.borderAlign&&(t=Math.max(t,s.borderWidth||0,s.hoverBorderWidth||0));return t}getMaxOffset(e){let t=0;for(let n=0,r=e.length;n<r;++n){const e=this.resolveDataElementOptions(n);t=Math.max(t,e.offset||0,e.hoverOffset||0)}return t}_getRingWeightOffset(e){let t=0;for(let n=0;n<e;++n)this.chart.isDatasetVisible(n)&&(t+=this._getRingWeight(n));return t}_getRingWeight(e){return Math.max(be(this.chart.data.datasets[e].weight,1),0)}_getVisibleDatasetWeightTotal(){return this._getRingWeightOffset(this.chart.data.datasets.length)||1}}class fi extends ei{static id="line";static defaults={datasetElementType:"line",dataElementType:"point",showLine:!0,spanGaps:!1};static overrides={scales:{_index_:{type:"category"},_value_:{type:"linear"}}};initialize(){this.enableOptionSharing=!0,this.supportsDecimation=!0,super.initialize()}update(e){const t=this._cachedMeta,{dataset:n,data:r=[],_dataset:i}=t,o=this.chart._animationsDisabled;let{start:a,count:s}=ht(t,r,o);this._drawStart=a,this._drawCount=s,pt(t)&&(a=0,s=r.length),n._chart=this.chart,n._datasetIndex=this.index,n._decimated=!!i._decimated,n.points=r;const l=this.resolveDatasetElementOptions(e);this.options.showLine||(l.borderWidth=0),l.segment=this.options.segment,this.updateElement(n,void 0,{animated:!o,options:l},e),this.updateElements(r,a,s,e)}updateElements(e,t,n,r){const i="reset"===r,{iScale:o,vScale:a,_stacked:s,_dataset:l}=this._cachedMeta,{sharedOptions:c,includeOptions:u}=this._getSharedOptions(t,r),d=o.axis,f=a.axis,{spanGaps:m,segment:g}=this.options,h=Ye(m)?m:Number.POSITIVE_INFINITY,p=this.chart._animationsDisabled||i||"none"===r,v=t+n,b=e.length;let y=t>0&&this.getParsed(t-1);for(let n=0;n<b;++n){const m=e[n],b=p?m:{};if(n<t||n>=v){b.skip=!0;continue}const x=this.getParsed(n),_=me(x[f]),j=b[d]=o.getPixelForValue(x[d],n),O=b[f]=i||_?a.getBasePixel():a.getPixelForValue(s?this.applyStack(a,x,s):x[f],n);b.skip=isNaN(j)||isNaN(O)||_,b.stop=n>0&&Math.abs(x[d]-y[d])>h,g&&(b.parsed=x,b.raw=l.data[n]),u&&(b.options=c||this.resolveDataElementOptions(n,m.active?"active":r)),p||this.updateElement(m,n,b,r),y=x}}getMaxOverflow(){const e=this._cachedMeta,t=e.dataset,n=t.options&&t.options.borderWidth||0,r=e.data||[];if(!r.length)return n;const i=r[0].size(this.resolveDataElementOptions(0)),o=r[r.length-1].size(this.resolveDataElementOptions(r.length-1));return Math.max(n,i,o)/2}draw(){const e=this._cachedMeta;e.dataset.updateControlPoints(this.chart.chartArea,e.iScale.axis),super.draw()}}class mi extends ei{static id="polarArea";static defaults={dataElementType:"arc",animation:{animateRotate:!0,animateScale:!0},animations:{numbers:{type:"number",properties:["x","y","startAngle","endAngle","innerRadius","outerRadius"]}},indexAxis:"r",startAngle:0};static overrides={aspectRatio:1,plugins:{legend:{labels:{generateLabels(e){const t=e.data;if(t.labels.length&&t.datasets.length){const{labels:{pointStyle:n,color:r}}=e.legend.options;return t.labels.map(((t,i)=>{const o=e.getDatasetMeta(0).controller.getStyle(i);return{text:t,fillStyle:o.backgroundColor,strokeStyle:o.borderColor,fontColor:r,lineWidth:o.borderWidth,pointStyle:n,hidden:!e.getDataVisibility(i),index:i}}))}return[]}},onClick(e,t,n){n.chart.toggleDataVisibility(t.index),n.chart.update()}}},scales:{r:{type:"radialLinear",angleLines:{display:!1},beginAtZero:!0,grid:{circular:!0},pointLabels:{display:!1},startAngle:0}}};constructor(e,t){super(e,t),this.innerRadius=void 0,this.outerRadius=void 0}getLabelAndValue(e){const t=this._cachedMeta,n=this.chart,r=n.data.labels||[],i=cn(t._parsed[e].r,n.options.locale);return{label:r[e]||"",value:i}}parseObjectData(e,t,n,r){return rr.bind(this)(e,t,n,r)}update(e){const t=this._cachedMeta.data;this._updateRadius(),this.updateElements(t,0,t.length,e)}getMinMax(){const e=this._cachedMeta,t={min:Number.POSITIVE_INFINITY,max:Number.NEGATIVE_INFINITY};return e.data.forEach(((e,n)=>{const r=this.getParsed(n).r;!isNaN(r)&&this.chart.getDataVisibility(n)&&(r<t.min&&(t.min=r),r>t.max&&(t.max=r))})),t}_updateRadius(){const e=this.chart,t=e.chartArea,n=e.options,r=Math.min(t.right-t.left,t.bottom-t.top),i=Math.max(r/2,0),o=(i-Math.max(n.cutoutPercentage?i/100*n.cutoutPercentage:1,0))/e.getVisibleDatasetCount();this.outerRadius=i-o*this.index,this.innerRadius=this.outerRadius-o}updateElements(e,t,n,r){const i="reset"===r,o=this.chart,a=o.options.animation,s=this._cachedMeta.rScale,l=s.xCenter,c=s.yCenter,u=s.getIndexAngle(0)-.5*ke;let d,f=u;const m=360/this.countVisibleElements();for(d=0;d<t;++d)f+=this._computeAngle(d,r,m);for(d=t;d<t+n;d++){const t=e[d];let n=f,g=f+this._computeAngle(d,r,m),h=o.getDataVisibility(d)?s.getDistanceFromCenterForValue(this.getParsed(d).r):0;f=g,i&&(a.animateScale&&(h=0),a.animateRotate&&(n=g=u));const p={x:l,y:c,innerRadius:0,outerRadius:h,startAngle:n,endAngle:g,options:this.resolveDataElementOptions(d,t.active?"active":r)};this.updateElement(t,d,p,r)}}countVisibleElements(){const e=this._cachedMeta;let t=0;return e.data.forEach(((e,n)=>{!isNaN(this.getParsed(n).r)&&this.chart.getDataVisibility(n)&&t++})),t}_computeAngle(e,t,n){return this.chart.getDataVisibility(e)?qe(this.resolveDataElementOptions(e,t).angle||n):0}}class gi extends di{static id="pie";static defaults={cutout:0,rotation:0,circumference:360,radius:"100%"}}class hi extends ei{static id="radar";static defaults={datasetElementType:"line",dataElementType:"point",indexAxis:"r",showLine:!0,elements:{line:{fill:"start"}}};static overrides={aspectRatio:1,scales:{r:{type:"radialLinear"}}};getLabelAndValue(e){const t=this._cachedMeta.vScale,n=this.getParsed(e);return{label:t.getLabels()[e],value:""+t.getLabelForValue(n[t.axis])}}parseObjectData(e,t,n,r){return rr.bind(this)(e,t,n,r)}update(e){const t=this._cachedMeta,n=t.dataset,r=t.data||[],i=t.iScale.getLabels();if(n.points=r,"resize"!==e){const t=this.resolveDatasetElementOptions(e);this.options.showLine||(t.borderWidth=0);const o={_loop:!0,_fullLoop:i.length===r.length,options:t};this.updateElement(n,void 0,o,e)}this.updateElements(r,0,r.length,e)}updateElements(e,t,n,r){const i=this._cachedMeta.rScale,o="reset"===r;for(let a=t;a<t+n;a++){const t=e[a],n=this.resolveDataElementOptions(a,t.active?"active":r),s=i.getPointPositionForValue(a,this.getParsed(a).r),l=o?i.xCenter:s.x,c=o?i.yCenter:s.y,u={x:l,y:c,angle:s.angle,skip:isNaN(l)||isNaN(c),options:n};this.updateElement(t,a,u,r)}}}class pi extends ei{static id="scatter";static defaults={datasetElementType:!1,dataElementType:"point",showLine:!1,fill:!1};static overrides={interaction:{mode:"point"},scales:{x:{type:"linear"},y:{type:"linear"}}};getLabelAndValue(e){const t=this._cachedMeta,n=this.chart.data.labels||[],{xScale:r,yScale:i}=t,o=this.getParsed(e),a=r.getLabelForValue(o.x),s=i.getLabelForValue(o.y);return{label:n[e]||"",value:"("+a+", "+s+")"}}update(e){const t=this._cachedMeta,{data:n=[]}=t,r=this.chart._animationsDisabled;let{start:i,count:o}=ht(t,n,r);if(this._drawStart=i,this._drawCount=o,pt(t)&&(i=0,o=n.length),this.options.showLine){const{dataset:i,_dataset:o}=t;i._chart=this.chart,i._datasetIndex=this.index,i._decimated=!!o._decimated,i.points=n;const a=this.resolveDatasetElementOptions(e);a.segment=this.options.segment,this.updateElement(i,void 0,{animated:!r,options:a},e)}this.updateElements(n,i,o,e)}addElements(){const{showLine:e}=this.options;!this.datasetElementType&&e&&(this.datasetElementType=this.chart.registry.getElement("line")),super.addElements()}updateElements(e,t,n,r){const i="reset"===r,{iScale:o,vScale:a,_stacked:s,_dataset:l}=this._cachedMeta,c=this.resolveDataElementOptions(t,r),u=this.getSharedOptions(c),d=this.includeOptions(r,u),f=o.axis,m=a.axis,{spanGaps:g,segment:h}=this.options,p=Ye(g)?g:Number.POSITIVE_INFINITY,v=this.chart._animationsDisabled||i||"none"===r;let b=t>0&&this.getParsed(t-1);for(let c=t;c<t+n;++c){const t=e[c],n=this.getParsed(c),g=v?t:{},y=me(n[m]),x=g[f]=o.getPixelForValue(n[f],c),_=g[m]=i||y?a.getBasePixel():a.getPixelForValue(s?this.applyStack(a,n,s):n[m],c);g.skip=isNaN(x)||isNaN(_)||y,g.stop=c>0&&Math.abs(n[f]-b[f])>p,h&&(g.parsed=n,g.raw=l.data[c]),d&&(g.options=u||this.resolveDataElementOptions(c,t.active?"active":r)),v||this.updateElement(t,c,g,r),b=n}this.updateSharedOptions(u,r,c)}getMaxOverflow(){const e=this._cachedMeta,t=e.data||[];if(!this.options.showLine){let e=0;for(let n=t.length-1;n>=0;--n)e=Math.max(e,t[n].size(this.resolveDataElementOptions(n))/2);return e>0&&e}const n=e.dataset,r=n.options&&n.options.borderWidth||0;if(!t.length)return r;const i=t[0].size(this.resolveDataElementOptions(0)),o=t[t.length-1].size(this.resolveDataElementOptions(t.length-1));return Math.max(r,i,o)/2}}var vi=Object.freeze({__proto__:null,BarController:ci,BubbleController:ui,DoughnutController:di,LineController:fi,PolarAreaController:mi,PieController:gi,RadarController:hi,ScatterController:pi});function bi(){throw new Error("This method is not implemented: Check that a complete date adapter is provided.")}class yi{static override(e){Object.assign(yi.prototype,e)}constructor(e){this.options=e||{}}init(){}formats(){return bi()}parse(){return bi()}format(){return bi()}add(){return bi()}diff(){return bi()}startOf(){return bi()}endOf(){return bi()}}var xi={_date:yi};function _i(e,t,n,r){const{controller:i,data:o,_sorted:a}=e,s=i._cachedMeta.iScale;if(s&&t===s.axis&&"r"!==t&&a&&o.length){const e=s._reversePixels?st:at;if(!r)return e(o,t,n);if(i._sharedOptions){const r=o[0],i="function"==typeof r.getRange&&r.getRange(t);if(i){const r=e(o,t,n-i),a=e(o,t,n+i);return{lo:r.lo,hi:a.hi}}}}return{lo:0,hi:o.length-1}}function ji(e,t,n,r,i){const o=e.getSortedVisibleDatasetMetas(),a=n[t];for(let e=0,n=o.length;e<n;++e){const{index:n,data:s}=o[e],{lo:l,hi:c}=_i(o[e],t,a,i);for(let e=l;e<=c;++e){const t=s[e];t.skip||r(t,n,e)}}}function Oi(e,t,n,r,i){const o=[];if(!i&&!e.isPointInArea(t))return o;return ji(e,n,t,(function(n,a,s){(i||En(n,e.chartArea,0))&&n.inRange(t.x,t.y,r)&&o.push({element:n,datasetIndex:a,index:s})}),!0),o}function Ei(e,t,n,r,i,o){let a=[];const s=function(e){const t=-1!==e.indexOf("x"),n=-1!==e.indexOf("y");return function(e,r){const i=t?Math.abs(e.x-r.x):0,o=n?Math.abs(e.y-r.y):0;return Math.sqrt(Math.pow(i,2)+Math.pow(o,2))}}(n);let l=Number.POSITIVE_INFINITY;return ji(e,n,t,(function(n,c,u){const d=n.inRange(t.x,t.y,i);if(r&&!d)return;const f=n.getCenterPoint(i);if(!(!!o||e.isPointInArea(f))&&!d)return;const m=s(t,f);m<l?(a=[{element:n,datasetIndex:c,index:u}],l=m):m===l&&a.push({element:n,datasetIndex:c,index:u})})),a}function Si(e,t,n,r,i,o){return o||e.isPointInArea(t)?"r"!==n||r?Ei(e,t,n,r,i,o):function(e,t,n,r){let i=[];return ji(e,n,t,(function(e,n,o){const{startAngle:a,endAngle:s}=e.getProps(["startAngle","endAngle"],r),{angle:l}=Ze(e,{x:t.x,y:t.y});nt(l,a,s)&&i.push({element:e,datasetIndex:n,index:o})})),i}(e,t,n,i):[]}function Ti(e,t,n,r,i){const o=[],a="x"===n?"inXRange":"inYRange";let s=!1;return ji(e,n,t,((e,r,l)=>{e[a](t[n],i)&&(o.push({element:e,datasetIndex:r,index:l}),s=s||e.inRange(t.x,t.y,i))})),r&&!s?[]:o}var Ii={evaluateInteractionItems:ji,modes:{index(e,t,n,r){const i=br(t,e),o=n.axis||"x",a=n.includeInvisible||!1,s=n.intersect?Oi(e,i,o,r,a):Si(e,i,o,!1,r,a),l=[];return s.length?(e.getSortedVisibleDatasetMetas().forEach((e=>{const t=s[0].index,n=e.data[t];n&&!n.skip&&l.push({element:n,datasetIndex:e.index,index:t})})),l):[]},dataset(e,t,n,r){const i=br(t,e),o=n.axis||"xy",a=n.includeInvisible||!1;let s=n.intersect?Oi(e,i,o,r,a):Si(e,i,o,!1,r,a);if(s.length>0){const t=s[0].datasetIndex,n=e.getDatasetMeta(t).data;s=[];for(let e=0;e<n.length;++e)s.push({element:n[e],datasetIndex:t,index:e})}return s},point:(e,t,n,r)=>Oi(e,br(t,e),n.axis||"xy",r,n.includeInvisible||!1),nearest(e,t,n,r){const i=br(t,e),o=n.axis||"xy",a=n.includeInvisible||!1;return Si(e,i,o,n.intersect,r,a)},x:(e,t,n,r)=>Ti(e,br(t,e),"x",n.intersect,r),y:(e,t,n,r)=>Ti(e,br(t,e),"y",n.intersect,r)}};const wi=["left","top","right","bottom"];function Pi(e,t){return e.filter((e=>e.pos===t))}function Ci(e,t){return e.filter((e=>-1===wi.indexOf(e.pos)&&e.box.axis===t))}function Ni(e,t){return e.sort(((e,n)=>{const r=t?n:e,i=t?e:n;return r.weight===i.weight?r.index-i.index:r.weight-i.weight}))}function Ai(e,t){const n=function(e){const t={};for(const n of e){const{stack:e,pos:r,stackWeight:i}=n;if(!e||!wi.includes(r))continue;const o=t[e]||(t[e]={count:0,placed:0,weight:0,size:0});o.count++,o.weight+=i}return t}(e),{vBoxMaxWidth:r,hBoxMaxHeight:i}=t;let o,a,s;for(o=0,a=e.length;o<a;++o){s=e[o];const{fullSize:a}=s.box,l=n[s.stack],c=l&&s.stackWeight/l.weight;s.horizontal?(s.width=c?c*r:a&&t.availableWidth,s.height=i):(s.width=r,s.height=c?c*i:a&&t.availableHeight)}return n}function Li(e,t,n,r){return Math.max(e[n],t[n])+Math.max(e[r],t[r])}function Mi(e,t){e.top=Math.max(e.top,t.top),e.left=Math.max(e.left,t.left),e.bottom=Math.max(e.bottom,t.bottom),e.right=Math.max(e.right,t.right)}function ki(e,t,n,r){const{pos:i,box:o}=n,a=e.maxPadding;if(!he(i)){n.size&&(e[i]-=n.size);const t=r[n.stack]||{size:0,count:1};t.size=Math.max(t.size,n.horizontal?o.height:o.width),n.size=t.size/t.count,e[i]+=n.size}o.getPadding&&Mi(a,o.getPadding());const s=Math.max(0,t.outerWidth-Li(a,e,"left","right")),l=Math.max(0,t.outerHeight-Li(a,e,"top","bottom")),c=s!==e.w,u=l!==e.h;return e.w=s,e.h=l,n.horizontal?{same:c,other:u}:{same:u,other:c}}function Ri(e,t){const n=t.maxPadding;function r(e){const r={left:0,top:0,right:0,bottom:0};return e.forEach((e=>{r[e]=Math.max(t[e],n[e])})),r}return r(e?["left","right"]:["top","bottom"])}function Di(e,t,n,r){const i=[];let o,a,s,l,c,u;for(o=0,a=e.length,c=0;o<a;++o){s=e[o],l=s.box,l.update(s.width||t.w,s.height||t.h,Ri(s.horizontal,t));const{same:a,other:d}=ki(t,n,s,r);c|=a&&i.length,u=u||d,l.fullSize||i.push(s)}return c&&Di(i,t,n,r)||u}function Fi(e,t,n,r,i){e.top=n,e.left=t,e.right=t+r,e.bottom=n+i,e.width=r,e.height=i}function Ui(e,t,n,r){const i=n.padding;let{x:o,y:a}=t;for(const s of e){const e=s.box,l=r[s.stack]||{count:1,placed:0,weight:1},c=s.stackWeight/l.weight||1;if(s.horizontal){const r=t.w*c,o=l.size||e.height;Ae(l.start)&&(a=l.start),e.fullSize?Fi(e,i.left,a,n.outerWidth-i.right-i.left,o):Fi(e,t.left+l.placed,a,r,o),l.start=a,l.placed+=r,a=e.bottom}else{const r=t.h*c,a=l.size||e.width;Ae(l.start)&&(o=l.start),e.fullSize?Fi(e,o,i.top,a,n.outerHeight-i.bottom-i.top):Fi(e,o,t.top+l.placed,a,r),l.start=o,l.placed+=r,o=e.right}}t.x=o,t.y=a}var Gi={addBox(e,t){e.boxes||(e.boxes=[]),t.fullSize=t.fullSize||!1,t.position=t.position||"top",t.weight=t.weight||0,t._layers=t._layers||function(){return[{z:0,draw(e){t.draw(e)}}]},e.boxes.push(t)},removeBox(e,t){const n=e.boxes?e.boxes.indexOf(t):-1;-1!==n&&e.boxes.splice(n,1)},configure(e,t,n){t.fullSize=n.fullSize,t.position=n.position,t.weight=n.weight},update(e,t,n,r){if(!e)return;const i=Gn(e.options.layout.padding),o=Math.max(t-i.width,0),a=Math.max(n-i.height,0),s=function(e){const t=function(e){const t=[];let n,r,i,o,a,s;for(n=0,r=(e||[]).length;n<r;++n)i=e[n],({position:o,options:{stack:a,stackWeight:s=1}}=i),t.push({index:n,box:i,pos:o,horizontal:i.isHorizontal(),weight:i.weight,stack:a&&o+a,stackWeight:s});return t}(e),n=Ni(t.filter((e=>e.box.fullSize)),!0),r=Ni(Pi(t,"left"),!0),i=Ni(Pi(t,"right")),o=Ni(Pi(t,"top"),!0),a=Ni(Pi(t,"bottom")),s=Ci(t,"x"),l=Ci(t,"y");return{fullSize:n,leftAndTop:r.concat(o),rightAndBottom:i.concat(l).concat(a).concat(s),chartArea:Pi(t,"chartArea"),vertical:r.concat(i).concat(l),horizontal:o.concat(a).concat(s)}}(e.boxes),l=s.vertical,c=s.horizontal;_e(e.boxes,(e=>{"function"==typeof e.beforeLayout&&e.beforeLayout()}));const u=l.reduce(((e,t)=>t.box.options&&!1===t.box.options.display?e:e+1),0)||1,d=Object.freeze({outerWidth:t,outerHeight:n,padding:i,availableWidth:o,availableHeight:a,vBoxMaxWidth:o/2/u,hBoxMaxHeight:a/2}),f=Object.assign({},i);Mi(f,Gn(r));const m=Object.assign({maxPadding:f,w:o,h:a,x:i.left,y:i.top},i),g=Ai(l.concat(c),d);Di(s.fullSize,m,d,g),Di(l,m,d,g),Di(c,m,d,g)&&Di(l,m,d,g),function(e){const t=e.maxPadding;function n(n){const r=Math.max(t[n]-e[n],0);return e[n]+=r,r}e.y+=n("top"),e.x+=n("left"),n("right"),n("bottom")}(m),Ui(s.leftAndTop,m,d,g),m.x+=m.w,m.y+=m.h,Ui(s.rightAndBottom,m,d,g),e.chartArea={left:m.left,top:m.top,right:m.left+m.w,bottom:m.top+m.h,height:m.h,width:m.w},_e(s.chartArea,(t=>{const n=t.box;Object.assign(n,e.chartArea),n.update(m.w,m.h,{left:0,top:0,right:0,bottom:0})}))}};class Bi{acquireContext(e,t){}releaseContext(e){return!1}addEventListener(e,t,n){}removeEventListener(e,t,n){}getDevicePixelRatio(){return 1}getMaximumSize(e,t,n,r){return t=Math.max(0,t||e.width),n=n||e.height,{width:t,height:Math.max(0,r?Math.floor(t/r):n)}}isAttached(e){return!0}updateConfig(e){}}class Vi extends Bi{acquireContext(e){return e&&e.getContext&&e.getContext("2d")||null}updateConfig(e){e.options.animation=!1}}const Hi="$chartjs",Ki={touchstart:"mousedown",touchmove:"mousemove",touchend:"mouseup",pointerenter:"mouseenter",pointerdown:"mousedown",pointermove:"mousemove",pointerup:"mouseup",pointerleave:"mouseout",pointerout:"mouseout"},Wi=e=>null===e||""===e;const zi=!!jr&&{passive:!0};function Yi(e,t,n){e.canvas.removeEventListener(t,n,zi)}function $i(e,t){for(const n of e)if(n===t||n.contains(t))return!0}function qi(e,t,n){const r=e.canvas,i=new MutationObserver((e=>{let t=!1;for(const n of e)t=t||$i(n.addedNodes,r),t=t&&!$i(n.removedNodes,r);t&&n()}));return i.observe(document,{childList:!0,subtree:!0}),i}function Xi(e,t,n){const r=e.canvas,i=new MutationObserver((e=>{let t=!1;for(const n of e)t=t||$i(n.removedNodes,r),t=t&&!$i(n.addedNodes,r);t&&n()}));return i.observe(document,{childList:!0,subtree:!0}),i}const Qi=new Map;let Zi=0;function Ji(){const e=window.devicePixelRatio;e!==Zi&&(Zi=e,Qi.forEach(((t,n)=>{n.currentDevicePixelRatio!==e&&t()})))}function eo(e,t,n){const r=e.canvas,i=r&&fr(r);if(!i)return;const o=ft(((e,t)=>{const r=i.clientWidth;n(e,t),r<i.clientWidth&&n()}),window),a=new ResizeObserver((e=>{const t=e[0],n=t.contentRect.width,r=t.contentRect.height;0===n&&0===r||o(n,r)}));return a.observe(i),function(e,t){Qi.size||window.addEventListener("resize",Ji),Qi.set(e,t)}(e,o),a}function to(e,t,n){n&&n.disconnect(),"resize"===t&&function(e){Qi.delete(e),Qi.size||window.removeEventListener("resize",Ji)}(e)}function no(e,t,n){const r=e.canvas,i=ft((t=>{null!==e.ctx&&n(function(e,t){const n=Ki[e.type]||e.type,{x:r,y:i}=br(e,t);return{type:n,chart:t,native:e,x:void 0!==r?r:null,y:void 0!==i?i:null}}(t,e))}),e);return function(e,t,n){e.addEventListener(t,n,zi)}(r,t,i),i}class ro extends Bi{acquireContext(e,t){const n=e&&e.getContext&&e.getContext("2d");return n&&n.canvas===e?(function(e,t){const n=e.style,r=e.getAttribute("height"),i=e.getAttribute("width");if(e[Hi]={initial:{height:r,width:i,style:{display:n.display,height:n.height,width:n.width}}},n.display=n.display||"block",n.boxSizing=n.boxSizing||"border-box",Wi(i)){const t=Or(e,"width");void 0!==t&&(e.width=t)}if(Wi(r))if(""===e.style.height)e.height=e.width/(t||2);else{const t=Or(e,"height");void 0!==t&&(e.height=t)}}(e,t),n):null}releaseContext(e){const t=e.canvas;if(!t[Hi])return!1;const n=t[Hi].initial;["height","width"].forEach((e=>{const r=n[e];me(r)?t.removeAttribute(e):t.setAttribute(e,r)}));const r=n.style||{};return Object.keys(r).forEach((e=>{t.style[e]=r[e]})),t.width=t.width,delete t[Hi],!0}addEventListener(e,t,n){this.removeEventListener(e,t);const r=e.$proxies||(e.$proxies={}),i={attach:qi,detach:Xi,resize:eo}[t]||no;r[t]=i(e,t,n)}removeEventListener(e,t){const n=e.$proxies||(e.$proxies={}),r=n[t];if(!r)return;({attach:to,detach:to,resize:to}[t]||Yi)(e,t,r),n[t]=void 0}getDevicePixelRatio(){return window.devicePixelRatio}getMaximumSize(e,t,n,r){return xr(e,t,n,r)}isAttached(e){const t=fr(e);return!(!t||!t.isConnected)}}function io(e){return!dr()||"undefined"!=typeof OffscreenCanvas&&e instanceof OffscreenCanvas?Vi:ro}class oo{static defaults={};static defaultRoutes=void 0;active=!1;tooltipPosition(e){const{x:t,y:n}=this.getProps(["x","y"],e);return{x:t,y:n}}hasValue(){return Ye(this.x)&&Ye(this.y)}getProps(e,t){const n=this.$animations;if(!t||!n)return this;const r={};return e.forEach((e=>{r[e]=n[e]&&n[e].active()?n[e]._to:this[e]})),r}}function ao(e,t){const n=e.options.ticks,r=function(e){const t=e.options.offset,n=e._tickSize(),r=e._length/n+(t?0:1),i=e._maxLength/n;return Math.floor(Math.min(r,i))}(e),i=Math.min(n.maxTicksLimit||r,r),o=n.major.enabled?function(e){const t=[];let n,r;for(n=0,r=e.length;n<r;n++)e[n].major&&t.push(n);return t}(t):[],a=o.length,s=o[0],l=o[a-1],c=[];if(a>i)return function(e,t,n,r){let i,o=0,a=n[0];for(r=Math.ceil(r),i=0;i<e.length;i++)i===a&&(t.push(e[i]),o++,a=n[o*r])}(t,c,o,a/i),c;const u=function(e,t,n){const r=function(e){const t=e.length;let n,r;if(t<2)return!1;for(r=e[0],n=1;n<t;++n)if(e[n]-e[n-1]!==r)return!1;return r}(e),i=t.length/n;if(!r)return Math.max(i,1);const o=function(e){const t=[],n=Math.sqrt(e);let r;for(r=1;r<n;r++)e%r==0&&(t.push(r),t.push(e/r));return n===(0|n)&&t.push(n),t.sort(((e,t)=>e-t)).pop(),t}(r);for(let e=0,t=o.length-1;e<t;e++){const t=o[e];if(t>i)return t}return Math.max(i,1)}(o,t,i);if(a>0){let e,n;const r=a>1?Math.round((l-s)/(a-1)):null;for(so(t,c,u,me(r)?0:s-r,s),e=0,n=a-1;e<n;e++)so(t,c,u,o[e],o[e+1]);return so(t,c,u,l,me(r)?t.length:l+r),c}return so(t,c,u),c}function so(e,t,n,r,i){const o=be(r,0),a=Math.min(be(i,e.length),e.length);let s,l,c,u=0;for(n=Math.ceil(n),i&&(s=i-r,n=s/Math.floor(s/n)),c=o;c<0;)u++,c=Math.round(o+u*n);for(l=Math.max(o,0);l<a;l++)l===c&&(t.push(e[l]),u++,c=Math.round(o+u*n))}const lo=(e,t,n)=>"top"===t||"left"===t?e[t]+n:e[t]-n;function co(e,t){const n=[],r=e.length/t,i=e.length;let o=0;for(;o<i;o+=r)n.push(e[Math.floor(o)]);return n}function uo(e,t,n){const r=e.ticks.length,i=Math.min(t,r-1),o=e._startPixel,a=e._endPixel,s=1e-6;let l,c=e.getPixelForTick(i);if(!(n&&(l=1===r?Math.max(c-o,a-c):0===t?(e.getPixelForTick(1)-c)/2:(c-e.getPixelForTick(i-1))/2,c+=i<t?l:-l,c<o-s||c>a+s)))return c}function fo(e){return e.drawTicks?e.tickLength:0}function mo(e,t){if(!e.display)return 0;const n=Bn(e.font,t),r=Gn(e.padding);return(ge(e.text)?e.text.length:1)*n.lineHeight+r.height}function go(e,t,n){let r=mt(e);return(n&&"right"!==t||!n&&"right"===t)&&(r=(e=>"left"===e?"right":"right"===e?"left":e)(r)),r}class ho extends oo{constructor(e){super(),this.id=e.id,this.type=e.type,this.options=void 0,this.ctx=e.ctx,this.chart=e.chart,this.top=void 0,this.bottom=void 0,this.left=void 0,this.right=void 0,this.width=void 0,this.height=void 0,this._margins={left:0,right:0,top:0,bottom:0},this.maxWidth=void 0,this.maxHeight=void 0,this.paddingTop=void 0,this.paddingBottom=void 0,this.paddingLeft=void 0,this.paddingRight=void 0,this.axis=void 0,this.labelRotation=void 0,this.min=void 0,this.max=void 0,this._range=void 0,this.ticks=[],this._gridLineItems=null,this._labelItems=null,this._labelSizes=null,this._length=0,this._maxLength=0,this._longestTextCache={},this._startPixel=void 0,this._endPixel=void 0,this._reversePixels=!1,this._userMax=void 0,this._userMin=void 0,this._suggestedMax=void 0,this._suggestedMin=void 0,this._ticksLength=0,this._borderValue=0,this._cache={},this._dataLimitsCached=!1,this.$context=void 0}init(e){this.options=e.setContext(this.getContext()),this.axis=e.axis,this._userMin=this.parse(e.min),this._userMax=this.parse(e.max),this._suggestedMin=this.parse(e.suggestedMin),this._suggestedMax=this.parse(e.suggestedMax)}parse(e,t){return e}getUserBounds(){let{_userMin:e,_userMax:t,_suggestedMin:n,_suggestedMax:r}=this;return e=ve(e,Number.POSITIVE_INFINITY),t=ve(t,Number.NEGATIVE_INFINITY),n=ve(n,Number.POSITIVE_INFINITY),r=ve(r,Number.NEGATIVE_INFINITY),{min:ve(e,n),max:ve(t,r),minDefined:pe(e),maxDefined:pe(t)}}getMinMax(e){let t,{min:n,max:r,minDefined:i,maxDefined:o}=this.getUserBounds();if(i&&o)return{min:n,max:r};const a=this.getMatchingVisibleMetas();for(let s=0,l=a.length;s<l;++s)t=a[s].controller.getMinMax(this,e),i||(n=Math.min(n,t.min)),o||(r=Math.max(r,t.max));return n=o&&n>r?r:n,r=i&&n>r?n:r,{min:ve(n,ve(r,n)),max:ve(r,ve(n,r))}}getPadding(){return{left:this.paddingLeft||0,top:this.paddingTop||0,right:this.paddingRight||0,bottom:this.paddingBottom||0}}getTicks(){return this.ticks}getLabels(){const e=this.chart.data;return this.options.labels||(this.isHorizontal()?e.xLabels:e.yLabels)||e.labels||[]}beforeLayout(){this._cache={},this._dataLimitsCached=!1}beforeUpdate(){xe(this.options.beforeUpdate,[this])}update(e,t,n){const{beginAtZero:r,grace:i,ticks:o}=this.options,a=o.sampleSize;this.beforeUpdate(),this.maxWidth=e,this.maxHeight=t,this._margins=n=Object.assign({left:0,right:0,top:0,bottom:0},n),this.ticks=null,this._labelSizes=null,this._gridLineItems=null,this._labelItems=null,this.beforeSetDimensions(),this.setDimensions(),this.afterSetDimensions(),this._maxLength=this.isHorizontal()?this.width+n.left+n.right:this.height+n.top+n.bottom,this._dataLimitsCached||(this.beforeDataLimits(),this.determineDataLimits(),this.afterDataLimits(),this._range=function(e,t,n){const{min:r,max:i}=e,o=ye(t,(i-r)/2),a=(e,t)=>n&&0===e?0:e+t;return{min:a(r,-Math.abs(o)),max:a(i,o)}}(this,i,r),this._dataLimitsCached=!0),this.beforeBuildTicks(),this.ticks=this.buildTicks()||[],this.afterBuildTicks();const s=a<this.ticks.length;this._convertTicksToLabels(s?co(this.ticks,a):this.ticks),this.configure(),this.beforeCalculateLabelRotation(),this.calculateLabelRotation(),this.afterCalculateLabelRotation(),o.display&&(o.autoSkip||"auto"===o.source)&&(this.ticks=ao(this,this.ticks),this._labelSizes=null,this.afterAutoSkip()),s&&this._convertTicksToLabels(this.ticks),this.beforeFit(),this.fit(),this.afterFit(),this.afterUpdate()}configure(){let e,t,n=this.options.reverse;this.isHorizontal()?(e=this.left,t=this.right):(e=this.top,t=this.bottom,n=!n),this._startPixel=e,this._endPixel=t,this._reversePixels=n,this._length=t-e,this._alignToPixels=this.options.alignToPixels}afterUpdate(){xe(this.options.afterUpdate,[this])}beforeSetDimensions(){xe(this.options.beforeSetDimensions,[this])}setDimensions(){this.isHorizontal()?(this.width=this.maxWidth,this.left=0,this.right=this.width):(this.height=this.maxHeight,this.top=0,this.bottom=this.height),this.paddingLeft=0,this.paddingTop=0,this.paddingRight=0,this.paddingBottom=0}afterSetDimensions(){xe(this.options.afterSetDimensions,[this])}_callHooks(e){this.chart.notifyPlugins(e,this.getContext()),xe(this.options[e],[this])}beforeDataLimits(){this._callHooks("beforeDataLimits")}determineDataLimits(){}afterDataLimits(){this._callHooks("afterDataLimits")}beforeBuildTicks(){this._callHooks("beforeBuildTicks")}buildTicks(){return[]}afterBuildTicks(){this._callHooks("afterBuildTicks")}beforeTickToLabelConversion(){xe(this.options.beforeTickToLabelConversion,[this])}generateTickLabels(e){const t=this.options.ticks;let n,r,i;for(n=0,r=e.length;n<r;n++)i=e[n],i.label=xe(t.callback,[i.value,n,e],this)}afterTickToLabelConversion(){xe(this.options.afterTickToLabelConversion,[this])}beforeCalculateLabelRotation(){xe(this.options.beforeCalculateLabelRotation,[this])}calculateLabelRotation(){const e=this.options,t=e.ticks,n=this.ticks.length,r=t.minRotation||0,i=t.maxRotation;let o,a,s,l=r;if(!this._isVisible()||!t.display||r>=i||n<=1||!this.isHorizontal())return void(this.labelRotation=r);const c=this._getLabelSizes(),u=c.widest.width,d=c.highest.height,f=rt(this.chart.width-u,0,this.maxWidth);o=e.offset?this.maxWidth/n:f/(n-1),u+6>o&&(o=f/(n-(e.offset?.5:1)),a=this.maxHeight-fo(e.grid)-t.padding-mo(e.title,this.chart.options.font),s=Math.sqrt(u*u+d*d),l=Xe(Math.min(Math.asin(rt((c.highest.height+6)/o,-1,1)),Math.asin(rt(a/s,-1,1))-Math.asin(rt(d/s,-1,1)))),l=Math.max(r,Math.min(i,l))),this.labelRotation=l}afterCalculateLabelRotation(){xe(this.options.afterCalculateLabelRotation,[this])}afterAutoSkip(){}beforeFit(){xe(this.options.beforeFit,[this])}fit(){const e={width:0,height:0},{chart:t,options:{ticks:n,title:r,grid:i}}=this,o=this._isVisible(),a=this.isHorizontal();if(o){const o=mo(r,t.options.font);if(a?(e.width=this.maxWidth,e.height=fo(i)+o):(e.height=this.maxHeight,e.width=fo(i)+o),n.display&&this.ticks.length){const{first:t,last:r,widest:i,highest:o}=this._getLabelSizes(),s=2*n.padding,l=qe(this.labelRotation),c=Math.cos(l),u=Math.sin(l);if(a){const t=n.mirror?0:u*i.width+c*o.height;e.height=Math.min(this.maxHeight,e.height+t+s)}else{const t=n.mirror?0:c*i.width+u*o.height;e.width=Math.min(this.maxWidth,e.width+t+s)}this._calculatePadding(t,r,u,c)}}this._handleMargins(),a?(this.width=this._length=t.width-this._margins.left-this._margins.right,this.height=e.height):(this.width=e.width,this.height=this._length=t.height-this._margins.top-this._margins.bottom)}_calculatePadding(e,t,n,r){const{ticks:{align:i,padding:o},position:a}=this.options,s=0!==this.labelRotation,l="top"!==a&&"x"===this.axis;if(this.isHorizontal()){const a=this.getPixelForTick(0)-this.left,c=this.right-this.getPixelForTick(this.ticks.length-1);let u=0,d=0;s?l?(u=r*e.width,d=n*t.height):(u=n*e.height,d=r*t.width):"start"===i?d=t.width:"end"===i?u=e.width:"inner"!==i&&(u=e.width/2,d=t.width/2),this.paddingLeft=Math.max((u-a+o)*this.width/(this.width-a),0),this.paddingRight=Math.max((d-c+o)*this.width/(this.width-c),0)}else{let n=t.height/2,r=e.height/2;"start"===i?(n=0,r=e.height):"end"===i&&(n=t.height,r=0),this.paddingTop=n+o,this.paddingBottom=r+o}}_handleMargins(){this._margins&&(this._margins.left=Math.max(this.paddingLeft,this._margins.left),this._margins.top=Math.max(this.paddingTop,this._margins.top),this._margins.right=Math.max(this.paddingRight,this._margins.right),this._margins.bottom=Math.max(this.paddingBottom,this._margins.bottom))}afterFit(){xe(this.options.afterFit,[this])}isHorizontal(){const{axis:e,position:t}=this.options;return"top"===t||"bottom"===t||"x"===e}isFullSize(){return this.options.fullSize}_convertTicksToLabels(e){let t,n;for(this.beforeTickToLabelConversion(),this.generateTickLabels(e),t=0,n=e.length;t<n;t++)me(e[t].label)&&(e.splice(t,1),n--,t--);this.afterTickToLabelConversion()}_getLabelSizes(){let e=this._labelSizes;if(!e){const t=this.options.ticks.sampleSize;let n=this.ticks;t<n.length&&(n=co(n,t)),this._labelSizes=e=this._computeLabelSizes(n,n.length)}return e}_computeLabelSizes(e,t){const{ctx:n,_longestTextCache:r}=this,i=[],o=[];let a,s,l,c,u,d,f,m,g,h,p,v=0,b=0;for(a=0;a<t;++a){if(c=e[a].label,u=this._resolveTickFontOptions(a),n.font=d=u.string,f=r[d]=r[d]||{data:{},gc:[]},m=u.lineHeight,g=h=0,me(c)||ge(c)){if(ge(c))for(s=0,l=c.length;s<l;++s)p=c[s],me(p)||ge(p)||(g=bn(n,f.data,f.gc,g,p),h+=m)}else g=bn(n,f.data,f.gc,g,c),h=m;i.push(g),o.push(h),v=Math.max(g,v),b=Math.max(h,b)}!function(e,t){_e(e,(e=>{const n=e.gc,r=n.length/2;let i;if(r>t){for(i=0;i<r;++i)delete e.data[n[i]];n.splice(0,r)}}))}(r,t);const y=i.indexOf(v),x=o.indexOf(b),_=e=>({width:i[e]||0,height:o[e]||0});return{first:_(0),last:_(t-1),widest:_(y),highest:_(x),widths:i,heights:o}}getLabelForValue(e){return e}getPixelForValue(e,t){return NaN}getValueForPixel(e){}getPixelForTick(e){const t=this.ticks;return e<0||e>t.length-1?null:this.getPixelForValue(t[e].value)}getPixelForDecimal(e){this._reversePixels&&(e=1-e);const t=this._startPixel+e*this._length;return function(e){return rt(e,-32768,32767)}(this._alignToPixels?xn(this.chart,t,0):t)}getDecimalForPixel(e){const t=(e-this._startPixel)/this._length;return this._reversePixels?1-t:t}getBasePixel(){return this.getPixelForValue(this.getBaseValue())}getBaseValue(){const{min:e,max:t}=this;return e<0&&t<0?t:e>0&&t>0?e:0}getContext(e){const t=this.ticks||[];if(e>=0&&e<t.length){const n=t[e];return n.$context||(n.$context=function(e,t,n){return Hn(e,{tick:n,index:t,type:"tick"})}(this.getContext(),e,n))}return this.$context||(this.$context=Hn(this.chart.getContext(),{scale:this,type:"scale"}))}_tickSize(){const e=this.options.ticks,t=qe(this.labelRotation),n=Math.abs(Math.cos(t)),r=Math.abs(Math.sin(t)),i=this._getLabelSizes(),o=e.autoSkipPadding||0,a=i?i.widest.width+o:0,s=i?i.highest.height+o:0;return this.isHorizontal()?s*n>a*r?a/n:s/r:s*r<a*n?s/n:a/r}_isVisible(){const e=this.options.display;return"auto"!==e?!!e:this.getMatchingVisibleMetas().length>0}_computeGridLineItems(e){const t=this.axis,n=this.chart,r=this.options,{grid:i,position:o,border:a}=r,s=i.offset,l=this.isHorizontal(),c=this.ticks.length+(s?1:0),u=fo(i),d=[],f=a.setContext(this.getContext()),m=f.display?f.width:0,g=m/2,h=function(e){return xn(n,e,m)};let p,v,b,y,x,_,j,O,E,S,T,I;if("top"===o)p=h(this.bottom),_=this.bottom-u,O=p-g,S=h(e.top)+g,I=e.bottom;else if("bottom"===o)p=h(this.top),S=e.top,I=h(e.bottom)-g,_=p+g,O=this.top+u;else if("left"===o)p=h(this.right),x=this.right-u,j=p-g,E=h(e.left)+g,T=e.right;else if("right"===o)p=h(this.left),E=e.left,T=h(e.right)-g,x=p+g,j=this.left+u;else if("x"===t){if("center"===o)p=h((e.top+e.bottom)/2+.5);else if(he(o)){const e=Object.keys(o)[0],t=o[e];p=h(this.chart.scales[e].getPixelForValue(t))}S=e.top,I=e.bottom,_=p+g,O=_+u}else if("y"===t){if("center"===o)p=h((e.left+e.right)/2);else if(he(o)){const e=Object.keys(o)[0],t=o[e];p=h(this.chart.scales[e].getPixelForValue(t))}x=p-g,j=x-u,E=e.left,T=e.right}const w=be(r.ticks.maxTicksLimit,c),P=Math.max(1,Math.ceil(c/w));for(v=0;v<c;v+=P){const e=this.getContext(v),t=i.setContext(e),r=a.setContext(e),o=t.lineWidth,c=t.color,u=r.dash||[],f=r.dashOffset,m=t.tickWidth,g=t.tickColor,h=t.tickBorderDash||[],p=t.tickBorderDashOffset;b=uo(this,v,s),void 0!==b&&(y=xn(n,b,o),l?x=j=E=T=y:_=O=S=I=y,d.push({tx1:x,ty1:_,tx2:j,ty2:O,x1:E,y1:S,x2:T,y2:I,width:o,color:c,borderDash:u,borderDashOffset:f,tickWidth:m,tickColor:g,tickBorderDash:h,tickBorderDashOffset:p}))}return this._ticksLength=c,this._borderValue=p,d}_computeLabelItems(e){const t=this.axis,n=this.options,{position:r,ticks:i}=n,o=this.isHorizontal(),a=this.ticks,{align:s,crossAlign:l,padding:c,mirror:u}=i,d=fo(n.grid),f=d+c,m=u?-c:f,g=-qe(this.labelRotation),h=[];let p,v,b,y,x,_,j,O,E,S,T,I,w="middle";if("top"===r)_=this.bottom-m,j=this._getXAxisLabelAlignment();else if("bottom"===r)_=this.top+m,j=this._getXAxisLabelAlignment();else if("left"===r){const e=this._getYAxisLabelAlignment(d);j=e.textAlign,x=e.x}else if("right"===r){const e=this._getYAxisLabelAlignment(d);j=e.textAlign,x=e.x}else if("x"===t){if("center"===r)_=(e.top+e.bottom)/2+f;else if(he(r)){const e=Object.keys(r)[0],t=r[e];_=this.chart.scales[e].getPixelForValue(t)+f}j=this._getXAxisLabelAlignment()}else if("y"===t){if("center"===r)x=(e.left+e.right)/2-f;else if(he(r)){const e=Object.keys(r)[0],t=r[e];x=this.chart.scales[e].getPixelForValue(t)}j=this._getYAxisLabelAlignment(d).textAlign}"y"===t&&("start"===s?w="top":"end"===s&&(w="bottom"));const P=this._getLabelSizes();for(p=0,v=a.length;p<v;++p){b=a[p],y=b.label;const e=i.setContext(this.getContext(p));O=this.getPixelForTick(p)+i.labelOffset,E=this._resolveTickFontOptions(p),S=E.lineHeight,T=ge(y)?y.length:1;const t=T/2,n=e.color,s=e.textStrokeColor,c=e.textStrokeWidth;let d,f=j;if(o?(x=O,"inner"===j&&(f=p===v-1?this.options.reverse?"left":"right":0===p?this.options.reverse?"right":"left":"center"),I="top"===r?"near"===l||0!==g?-T*S+S/2:"center"===l?-P.highest.height/2-t*S+S:-P.highest.height+S/2:"near"===l||0!==g?S/2:"center"===l?P.highest.height/2-t*S:P.highest.height-T*S,u&&(I*=-1),0===g||e.showLabelBackdrop||(x+=S/2*Math.sin(g))):(_=O,I=(1-T)*S/2),e.showLabelBackdrop){const t=Gn(e.backdropPadding),n=P.heights[p],r=P.widths[p];let i=I-t.top,o=0-t.left;switch(w){case"middle":i-=n/2;break;case"bottom":i-=n}switch(j){case"center":o-=r/2;break;case"right":o-=r}d={left:o,top:i,width:r+t.width,height:n+t.height,color:e.backdropColor}}h.push({rotation:g,label:y,font:E,color:n,strokeColor:s,strokeWidth:c,textOffset:I,textAlign:f,textBaseline:w,translation:[x,_],backdrop:d})}return h}_getXAxisLabelAlignment(){const{position:e,ticks:t}=this.options;if(-qe(this.labelRotation))return"top"===e?"left":"right";let n="center";return"start"===t.align?n="left":"end"===t.align?n="right":"inner"===t.align&&(n="inner"),n}_getYAxisLabelAlignment(e){const{position:t,ticks:{crossAlign:n,mirror:r,padding:i}}=this.options,o=e+i,a=this._getLabelSizes().widest.width;let s,l;return"left"===t?r?(l=this.right+i,"near"===n?s="left":"center"===n?(s="center",l+=a/2):(s="right",l+=a)):(l=this.right-o,"near"===n?s="right":"center"===n?(s="center",l-=a/2):(s="left",l=this.left)):"right"===t?r?(l=this.left+i,"near"===n?s="right":"center"===n?(s="center",l-=a/2):(s="left",l-=a)):(l=this.left+o,"near"===n?s="left":"center"===n?(s="center",l+=a/2):(s="right",l=this.right)):s="right",{textAlign:s,x:l}}_computeLabelArea(){if(this.options.ticks.mirror)return;const e=this.chart,t=this.options.position;return"left"===t||"right"===t?{top:0,left:this.left,bottom:e.height,right:this.right}:"top"===t||"bottom"===t?{top:this.top,left:0,bottom:this.bottom,right:e.width}:void 0}drawBackground(){const{ctx:e,options:{backgroundColor:t},left:n,top:r,width:i,height:o}=this;t&&(e.save(),e.fillStyle=t,e.fillRect(n,r,i,o),e.restore())}getLineWidthForValue(e){const t=this.options.grid;if(!this._isVisible()||!t.display)return 0;const n=this.ticks.findIndex((t=>t.value===e));if(n>=0){return t.setContext(this.getContext(n)).lineWidth}return 0}drawGrid(e){const t=this.options.grid,n=this.ctx,r=this._gridLineItems||(this._gridLineItems=this._computeGridLineItems(e));let i,o;const a=(e,t,r)=>{r.width&&r.color&&(n.save(),n.lineWidth=r.width,n.strokeStyle=r.color,n.setLineDash(r.borderDash||[]),n.lineDashOffset=r.borderDashOffset,n.beginPath(),n.moveTo(e.x,e.y),n.lineTo(t.x,t.y),n.stroke(),n.restore())};if(t.display)for(i=0,o=r.length;i<o;++i){const e=r[i];t.drawOnChartArea&&a({x:e.x1,y:e.y1},{x:e.x2,y:e.y2},e),t.drawTicks&&a({x:e.tx1,y:e.ty1},{x:e.tx2,y:e.ty2},{color:e.tickColor,width:e.tickWidth,borderDash:e.tickBorderDash,borderDashOffset:e.tickBorderDashOffset})}}drawBorder(){const{chart:e,ctx:t,options:{border:n,grid:r}}=this,i=n.setContext(this.getContext()),o=n.display?i.width:0;if(!o)return;const a=r.setContext(this.getContext(0)).lineWidth,s=this._borderValue;let l,c,u,d;this.isHorizontal()?(l=xn(e,this.left,o)-o/2,c=xn(e,this.right,a)+a/2,u=d=s):(u=xn(e,this.top,o)-o/2,d=xn(e,this.bottom,a)+a/2,l=c=s),t.save(),t.lineWidth=i.width,t.strokeStyle=i.color,t.beginPath(),t.moveTo(l,u),t.lineTo(c,d),t.stroke(),t.restore()}drawLabels(e){if(!this.options.ticks.display)return;const t=this.ctx,n=this._computeLabelArea();n&&Sn(t,n);const r=this._labelItems||(this._labelItems=this._computeLabelItems(e));let i,o;for(i=0,o=r.length;i<o;++i){const e=r[i],n=e.font;Pn(t,e.label,0,e.textOffset,n,e)}n&&Tn(t)}drawTitle(){const{ctx:e,options:{position:t,title:n,reverse:r}}=this;if(!n.display)return;const i=Bn(n.font),o=Gn(n.padding),a=n.align;let s=i.lineHeight/2;"bottom"===t||"center"===t||he(t)?(s+=o.bottom,ge(n.text)&&(s+=i.lineHeight*(n.text.length-1))):s+=o.top;const{titleX:l,titleY:c,maxWidth:u,rotation:d}=function(e,t,n,r){const{top:i,left:o,bottom:a,right:s,chart:l}=e,{chartArea:c,scales:u}=l;let d,f,m,g=0;const h=a-i,p=s-o;if(e.isHorizontal()){if(f=gt(r,o,s),he(n)){const e=Object.keys(n)[0],r=n[e];m=u[e].getPixelForValue(r)+h-t}else m="center"===n?(c.bottom+c.top)/2+h-t:lo(e,n,t);d=s-o}else{if(he(n)){const e=Object.keys(n)[0],r=n[e];f=u[e].getPixelForValue(r)-p+t}else f="center"===n?(c.left+c.right)/2-p+t:lo(e,n,t);m=gt(r,a,i),g="left"===n?-Ge:Ge}return{titleX:f,titleY:m,maxWidth:d,rotation:g}}(this,s,t,a);Pn(e,n.text,0,0,i,{color:n.color,maxWidth:u,rotation:d,textAlign:go(a,t,r),textBaseline:"middle",translation:[l,c]})}draw(e){this._isVisible()&&(this.drawBackground(),this.drawGrid(e),this.drawBorder(),this.drawTitle(),this.drawLabels(e))}_layers(){const e=this.options,t=e.ticks&&e.ticks.z||0,n=be(e.grid&&e.grid.z,-1),r=be(e.border&&e.border.z,0);return this._isVisible()&&this.draw===ho.prototype.draw?[{z:n,draw:e=>{this.drawBackground(),this.drawGrid(e),this.drawTitle()}},{z:r,draw:()=>{this.drawBorder()}},{z:t,draw:e=>{this.drawLabels(e)}}]:[{z:t,draw:e=>{this.draw(e)}}]}getMatchingVisibleMetas(e){const t=this.chart.getSortedVisibleDatasetMetas(),n=this.axis+"AxisID",r=[];let i,o;for(i=0,o=t.length;i<o;++i){const o=t[i];o[n]!==this.id||e&&o.type!==e||r.push(o)}return r}_resolveTickFontOptions(e){return Bn(this.options.ticks.setContext(this.getContext(e)).font)}_maxDigits(){const e=this._resolveTickFontOptions(0).lineHeight;return(this.isHorizontal()?this.width:this.height)/e}}class po{constructor(e,t,n){this.type=e,this.scope=t,this.override=n,this.items=Object.create(null)}isForType(e){return Object.prototype.isPrototypeOf.call(this.type.prototype,e.prototype)}register(e){const t=Object.getPrototypeOf(e);let n;(function(e){return"id"in e&&"defaults"in e})(t)&&(n=this.register(t));const r=this.items,i=e.id,o=this.scope+"."+i;if(!i)throw new Error("class does not have id: "+e);return i in r||(r[i]=e,function(e,t,n){const r=Te(Object.create(null),[n?vn.get(n):{},vn.get(t),e.defaults]);vn.set(t,r),e.defaultRoutes&&function(e,t){Object.keys(t).forEach((n=>{const r=n.split("."),i=r.pop(),o=[e].concat(r).join("."),a=t[n].split("."),s=a.pop(),l=a.join(".");vn.route(o,i,l,s)}))}(t,e.defaultRoutes);e.descriptors&&vn.describe(t,e.descriptors)}(e,o,n),this.override&&vn.override(e.id,e.overrides)),o}get(e){return this.items[e]}unregister(e){const t=this.items,n=e.id,r=this.scope;n in t&&delete t[n],r&&n in vn[r]&&(delete vn[r][n],this.override&&delete fn[n])}}class vo{constructor(){this.controllers=new po(ei,"datasets",!0),this.elements=new po(oo,"elements"),this.plugins=new po(Object,"plugins"),this.scales=new po(ho,"scales"),this._typedRegistries=[this.controllers,this.scales,this.elements]}add(...e){this._each("register",e)}remove(...e){this._each("unregister",e)}addControllers(...e){this._each("register",e,this.controllers)}addElements(...e){this._each("register",e,this.elements)}addPlugins(...e){this._each("register",e,this.plugins)}addScales(...e){this._each("register",e,this.scales)}getController(e){return this._get(e,this.controllers,"controller")}getElement(e){return this._get(e,this.elements,"element")}getPlugin(e){return this._get(e,this.plugins,"plugin")}getScale(e){return this._get(e,this.scales,"scale")}removeControllers(...e){this._each("unregister",e,this.controllers)}removeElements(...e){this._each("unregister",e,this.elements)}removePlugins(...e){this._each("unregister",e,this.plugins)}removeScales(...e){this._each("unregister",e,this.scales)}_each(e,t,n){[...t].forEach((t=>{const r=n||this._getRegistryForType(t);n||r.isForType(t)||r===this.plugins&&t.id?this._exec(e,r,t):_e(t,(t=>{const r=n||this._getRegistryForType(t);this._exec(e,r,t)}))}))}_exec(e,t,n){const r=Ne(e);xe(n["before"+r],[],n),t[e](n),xe(n["after"+r],[],n)}_getRegistryForType(e){for(let t=0;t<this._typedRegistries.length;t++){const n=this._typedRegistries[t];if(n.isForType(e))return n}return this.plugins}_get(e,t,n){const r=t.get(e);if(void 0===r)throw new Error('"'+e+'" is not a registered '+n+".");return r}}var bo=new vo;class yo{constructor(){this._init=[]}notify(e,t,n,r){"beforeInit"===t&&(this._init=this._createDescriptors(e,!0),this._notify(this._init,e,"install"));const i=r?this._descriptors(e).filter(r):this._descriptors(e),o=this._notify(i,e,t,n);return"afterDestroy"===t&&(this._notify(i,e,"stop"),this._notify(this._init,e,"uninstall")),o}_notify(e,t,n,r){r=r||{};for(const i of e){const e=i.plugin;if(!1===xe(e[n],[t,r,i.options],e)&&r.cancelable)return!1}return!0}invalidate(){me(this._cache)||(this._oldCache=this._cache,this._cache=void 0)}_descriptors(e){if(this._cache)return this._cache;const t=this._cache=this._createDescriptors(e);return this._notifyStateChanges(e),t}_createDescriptors(e,t){const n=e&&e.config,r=be(n.options&&n.options.plugins,{}),i=function(e){const t={},n=[],r=Object.keys(bo.plugins.items);for(let e=0;e<r.length;e++)n.push(bo.getPlugin(r[e]));const i=e.plugins||[];for(let e=0;e<i.length;e++){const r=i[e];-1===n.indexOf(r)&&(n.push(r),t[r.id]=!0)}return{plugins:n,localIds:t}}(n);return!1!==r||t?function(e,{plugins:t,localIds:n},r,i){const o=[],a=e.getContext();for(const s of t){const t=s.id,l=xo(r[t],i);null!==l&&o.push({plugin:s,options:_o(e.config,{plugin:s,local:n[t]},l,a)})}return o}(e,i,r,t):[]}_notifyStateChanges(e){const t=this._oldCache||[],n=this._cache,r=(e,t)=>e.filter((e=>!t.some((t=>e.plugin.id===t.plugin.id))));this._notify(r(t,n),e,"stop"),this._notify(r(n,t),e,"start")}}function xo(e,t){return t||!1!==e?!0===e?{}:e:null}function _o(e,{plugin:t,local:n},r,i){const o=e.pluginScopeKeys(t),a=e.getOptionScopes(r,o);return n&&t.defaults&&a.push(t.defaults),e.createResolver(a,i,[""],{scriptable:!1,indexable:!1,allKeys:!0})}function jo(e,t){const n=vn.datasets[e]||{};return((t.datasets||{})[e]||{}).indexAxis||t.indexAxis||n.indexAxis||"x"}function Oo(e,t){if("x"===e||"y"===e||"r"===e)return e;var n;if(e=t.axis||("top"===(n=t.position)||"bottom"===n?"x":"left"===n||"right"===n?"y":void 0)||e.length>1&&Oo(e[0].toLowerCase(),t))return e;throw new Error(`Cannot determine type of '${name}' axis. Please provide 'axis' or 'position' option.`)}function Eo(e){const t=e.options||(e.options={});t.plugins=be(t.plugins,{}),t.scales=function(e,t){const n=fn[e.type]||{scales:{}},r=t.scales||{},i=jo(e.type,t),o=Object.create(null);return Object.keys(r).forEach((e=>{const t=r[e];if(!he(t))return console.error(`Invalid scale configuration for scale: ${e}`);if(t._proxy)return console.warn(`Ignoring resolver passed as options for scale: ${e}`);const a=Oo(e,t),s=function(e,t){return e===t?"_index_":"_value_"}(a,i),l=n.scales||{};o[e]=Ie(Object.create(null),[{axis:a},t,l[a],l[s]])})),e.data.datasets.forEach((n=>{const i=n.type||e.type,a=n.indexAxis||jo(i,t),s=(fn[i]||{}).scales||{};Object.keys(s).forEach((e=>{const t=function(e,t){let n=e;return"_index_"===e?n=t:"_value_"===e&&(n="x"===t?"y":"x"),n}(e,a),i=n[t+"AxisID"]||t;o[i]=o[i]||Object.create(null),Ie(o[i],[{axis:t},r[i],s[e]])}))})),Object.keys(o).forEach((e=>{const t=o[e];Ie(t,[vn.scales[t.type],vn.scale])})),o}(e,t)}function So(e){return(e=e||{}).datasets=e.datasets||[],e.labels=e.labels||[],e}const To=new Map,Io=new Set;function wo(e,t){let n=To.get(e);return n||(n=t(),To.set(e,n),Io.add(n)),n}const Po=(e,t,n)=>{const r=Ce(t,n);void 0!==r&&e.add(r)};class Co{constructor(e){this._config=function(e){return(e=e||{}).data=So(e.data),Eo(e),e}(e),this._scopeCache=new Map,this._resolverCache=new Map}get platform(){return this._config.platform}get type(){return this._config.type}set type(e){this._config.type=e}get data(){return this._config.data}set data(e){this._config.data=So(e)}get options(){return this._config.options}set options(e){this._config.options=e}get plugins(){return this._config.plugins}update(){const e=this._config;this.clearCache(),Eo(e)}clearCache(){this._scopeCache.clear(),this._resolverCache.clear()}datasetScopeKeys(e){return wo(e,(()=>[[`datasets.${e}`,""]]))}datasetAnimationScopeKeys(e,t){return wo(`${e}.transition.${t}`,(()=>[[`datasets.${e}.transitions.${t}`,`transitions.${t}`],[`datasets.${e}`,""]]))}datasetElementScopeKeys(e,t){return wo(`${e}-${t}`,(()=>[[`datasets.${e}.elements.${t}`,`datasets.${e}`,`elements.${t}`,""]]))}pluginScopeKeys(e){const t=e.id;return wo(`${this.type}-plugin-${t}`,(()=>[[`plugins.${t}`,...e.additionalOptionScopes||[]]]))}_cachedScopes(e,t){const n=this._scopeCache;let r=n.get(e);return r&&!t||(r=new Map,n.set(e,r)),r}getOptionScopes(e,t,n){const{options:r,type:i}=this,o=this._cachedScopes(e,n),a=o.get(t);if(a)return a;const s=new Set;t.forEach((t=>{e&&(s.add(e),t.forEach((t=>Po(s,e,t)))),t.forEach((e=>Po(s,r,e))),t.forEach((e=>Po(s,fn[i]||{},e))),t.forEach((e=>Po(s,vn,e))),t.forEach((e=>Po(s,mn,e)))}));const l=Array.from(s);return 0===l.length&&l.push(Object.create(null)),Io.has(t)&&o.set(t,l),l}chartOptionScopes(){const{options:e,type:t}=this;return[e,fn[t]||{},vn.datasets[t]||{},{type:t},vn,mn]}resolveNamedOptions(e,t,n,r=[""]){const i={$shared:!0},{resolver:o,subPrefixes:a}=No(this._resolverCache,e,r);let s=o;if(function(e,t){const{isScriptable:n,isIndexable:r}=zn(e);for(const i of t){const t=n(i),o=r(i),a=(o||t)&&e[i];if(t&&(Le(a)||Ao(a))||o&&ge(a))return!0}return!1}(o,t)){i.$shared=!1;s=Wn(o,n=Le(n)?n():n,this.createResolver(e,n,a))}for(const e of t)i[e]=s[e];return i}createResolver(e,t,n=[""],r){const{resolver:i}=No(this._resolverCache,e,n);return he(t)?Wn(i,t,void 0,r):i}}function No(e,t,n){let r=e.get(t);r||(r=new Map,e.set(t,r));const i=n.join();let o=r.get(i);if(!o){o={resolver:Kn(t,n),subPrefixes:n.filter((e=>!e.toLowerCase().includes("hover")))},r.set(i,o)}return o}const Ao=e=>he(e)&&Object.getOwnPropertyNames(e).reduce(((t,n)=>t||Le(e[n])),!1);const Lo=["top","bottom","left","right","chartArea"];function Mo(e,t){return"top"===e||"bottom"===e||-1===Lo.indexOf(e)&&"x"===t}function ko(e,t){return function(n,r){return n[e]===r[e]?n[t]-r[t]:n[e]-r[e]}}function Ro(e){const t=e.chart,n=t.options.animation;t.notifyPlugins("afterRender"),xe(n&&n.onComplete,[e],t)}function Do(e){const t=e.chart,n=t.options.animation;xe(n&&n.onProgress,[e],t)}function Fo(e){return dr()&&"string"==typeof e?e=document.getElementById(e):e&&e.length&&(e=e[0]),e&&e.canvas&&(e=e.canvas),e}const Uo={},Go=e=>{const t=Fo(e);return Object.values(Uo).filter((e=>e.canvas===t)).pop()};function Bo(e,t,n){const r=Object.keys(e);for(const i of r){const r=+i;if(r>=t){const o=e[i];delete e[i],(n>0||r>t)&&(e[r+n]=o)}}}class Vo{static defaults=vn;static instances=Uo;static overrides=fn;static registry=bo;static version="4.0.1";static getChart=Go;static register(...e){bo.add(...e),Ho()}static unregister(...e){bo.remove(...e),Ho()}constructor(e,t){const n=this.config=new Co(t),r=Fo(e),i=Go(r);if(i)throw new Error("Canvas is already in use. Chart with ID '"+i.id+"' must be destroyed before the canvas with ID '"+i.canvas.id+"' can be reused.");const o=n.createResolver(n.chartOptionScopes(),this.getContext());this.platform=new(n.platform||io(r)),this.platform.updateConfig(n);const a=this.platform.acquireContext(r,o.aspectRatio),s=a&&a.canvas,l=s&&s.height,c=s&&s.width;this.id=fe(),this.ctx=a,this.canvas=s,this.width=c,this.height=l,this._options=o,this._aspectRatio=this.aspectRatio,this._layers=[],this._metasets=[],this._stacks=void 0,this.boxes=[],this.currentDevicePixelRatio=void 0,this.chartArea=void 0,this._active=[],this._lastEvent=void 0,this._listeners={},this._responsiveListeners=void 0,this._sortedMetasets=[],this.scales={},this._plugins=new yo,this.$proxies={},this._hiddenIndices={},this.attached=!1,this._animationsDisabled=void 0,this.$context=void 0,this._doResize=function(e,t){let n;return function(...r){return t?(clearTimeout(n),n=setTimeout(e,t,r)):e.apply(this,r),t}}((e=>this.update(e)),o.resizeDelay||0),this._dataChanges=[],Uo[this.id]=this,a&&s?(Fr.listen(this,"complete",Ro),Fr.listen(this,"progress",Do),this._initialize(),this.attached&&this.update()):console.error("Failed to create chart: can't acquire context from the given item")}get aspectRatio(){const{options:{aspectRatio:e,maintainAspectRatio:t},width:n,height:r,_aspectRatio:i}=this;return me(e)?t&&i?i:r?n/r:null:e}get data(){return this.config.data}set data(e){this.config.data=e}get options(){return this._options}set options(e){this.config.options=e}get registry(){return bo}_initialize(){return this.notifyPlugins("beforeInit"),this.options.responsive?this.resize():_r(this,this.options.devicePixelRatio),this.bindEvents(),this.notifyPlugins("afterInit"),this}clear(){return _n(this.canvas,this.ctx),this}stop(){return Fr.stop(this),this}resize(e,t){Fr.running(this)?this._resizeBeforeDraw={width:e,height:t}:this._resize(e,t)}_resize(e,t){const n=this.options,r=this.canvas,i=n.maintainAspectRatio&&this.aspectRatio,o=this.platform.getMaximumSize(r,e,t,i),a=n.devicePixelRatio||this.platform.getDevicePixelRatio(),s=this.width?"resize":"attach";this.width=o.width,this.height=o.height,this._aspectRatio=this.aspectRatio,_r(this,a,!0)&&(this.notifyPlugins("resize",{size:o}),xe(n.onResize,[this,o],this),this.attached&&this._doResize(s)&&this.render())}ensureScalesHaveIDs(){_e(this.options.scales||{},((e,t)=>{e.id=t}))}buildOrUpdateScales(){const e=this.options,t=e.scales,n=this.scales,r=Object.keys(n).reduce(((e,t)=>(e[t]=!1,e)),{});let i=[];t&&(i=i.concat(Object.keys(t).map((e=>{const n=t[e],r=Oo(e,n),i="r"===r,o="x"===r;return{options:n,dposition:i?"chartArea":o?"bottom":"left",dtype:i?"radialLinear":o?"category":"linear"}})))),_e(i,(t=>{const i=t.options,o=i.id,a=Oo(o,i),s=be(i.type,t.dtype);void 0!==i.position&&Mo(i.position,a)===Mo(t.dposition)||(i.position=t.dposition),r[o]=!0;let l=null;if(o in n&&n[o].type===s)l=n[o];else{l=new(bo.getScale(s))({id:o,type:s,ctx:this.ctx,chart:this}),n[l.id]=l}l.init(i,e)})),_e(r,((e,t)=>{e||delete n[t]})),_e(n,(e=>{Gi.configure(this,e,e.options),Gi.addBox(this,e)}))}_updateMetasets(){const e=this._metasets,t=this.data.datasets.length,n=e.length;if(e.sort(((e,t)=>e.index-t.index)),n>t){for(let e=t;e<n;++e)this._destroyDatasetMeta(e);e.splice(t,n-t)}this._sortedMetasets=e.slice(0).sort(ko("order","index"))}_removeUnreferencedMetasets(){const{_metasets:e,data:{datasets:t}}=this;e.length>t.length&&delete this._stacks,e.forEach(((e,n)=>{0===t.filter((t=>t===e._dataset)).length&&this._destroyDatasetMeta(n)}))}buildOrUpdateControllers(){const e=[],t=this.data.datasets;let n,r;for(this._removeUnreferencedMetasets(),n=0,r=t.length;n<r;n++){const r=t[n];let i=this.getDatasetMeta(n);const o=r.type||this.config.type;if(i.type&&i.type!==o&&(this._destroyDatasetMeta(n),i=this.getDatasetMeta(n)),i.type=o,i.indexAxis=r.indexAxis||jo(o,this.options),i.order=r.order||0,i.index=n,i.label=""+r.label,i.visible=this.isDatasetVisible(n),i.controller)i.controller.updateIndex(n),i.controller.linkScales();else{const t=bo.getController(o),{datasetElementType:r,dataElementType:a}=vn.datasets[o];Object.assign(t,{dataElementType:bo.getElement(a),datasetElementType:r&&bo.getElement(r)}),i.controller=new t(this,n),e.push(i.controller)}}return this._updateMetasets(),e}_resetElements(){_e(this.data.datasets,((e,t)=>{this.getDatasetMeta(t).controller.reset()}),this)}reset(){this._resetElements(),this.notifyPlugins("reset")}update(e){const t=this.config;t.update();const n=this._options=t.createResolver(t.chartOptionScopes(),this.getContext()),r=this._animationsDisabled=!n.animation;if(this._updateScales(),this._checkEventBindings(),this._updateHiddenIndices(),this._plugins.invalidate(),!1===this.notifyPlugins("beforeUpdate",{mode:e,cancelable:!0}))return;const i=this.buildOrUpdateControllers();this.notifyPlugins("beforeElementsUpdate");let o=0;for(let e=0,t=this.data.datasets.length;e<t;e++){const{controller:t}=this.getDatasetMeta(e),n=!r&&-1===i.indexOf(t);t.buildOrUpdateElements(n),o=Math.max(+t.getMaxOverflow(),o)}o=this._minPadding=n.layout.autoPadding?o:0,this._updateLayout(o),r||_e(i,(e=>{e.reset()})),this._updateDatasets(e),this.notifyPlugins("afterUpdate",{mode:e}),this._layers.sort(ko("z","_idx"));const{_active:a,_lastEvent:s}=this;s?this._eventHandler(s,!0):a.length&&this._updateHoverStyles(a,a,!0),this.render()}_updateScales(){_e(this.scales,(e=>{Gi.removeBox(this,e)})),this.ensureScalesHaveIDs(),this.buildOrUpdateScales()}_checkEventBindings(){const e=this.options,t=new Set(Object.keys(this._listeners)),n=new Set(e.events);Me(t,n)&&!!this._responsiveListeners===e.responsive||(this.unbindEvents(),this.bindEvents())}_updateHiddenIndices(){const{_hiddenIndices:e}=this,t=this._getUniformDataChanges()||[];for(const{method:n,start:r,count:i}of t){Bo(e,r,"_removeElements"===n?-i:i)}}_getUniformDataChanges(){const e=this._dataChanges;if(!e||!e.length)return;this._dataChanges=[];const t=this.data.datasets.length,n=t=>new Set(e.filter((e=>e[0]===t)).map(((e,t)=>t+","+e.splice(1).join(",")))),r=n(0);for(let e=1;e<t;e++)if(!Me(r,n(e)))return;return Array.from(r).map((e=>e.split(","))).map((e=>({method:e[1],start:+e[2],count:+e[3]})))}_updateLayout(e){if(!1===this.notifyPlugins("beforeLayout",{cancelable:!0}))return;Gi.update(this,this.width,this.height,e);const t=this.chartArea,n=t.width<=0||t.height<=0;this._layers=[],_e(this.boxes,(e=>{n&&"chartArea"===e.position||(e.configure&&e.configure(),this._layers.push(...e._layers()))}),this),this._layers.forEach(((e,t)=>{e._idx=t})),this.notifyPlugins("afterLayout")}_updateDatasets(e){if(!1!==this.notifyPlugins("beforeDatasetsUpdate",{mode:e,cancelable:!0})){for(let e=0,t=this.data.datasets.length;e<t;++e)this.getDatasetMeta(e).controller.configure();for(let t=0,n=this.data.datasets.length;t<n;++t)this._updateDataset(t,Le(e)?e({datasetIndex:t}):e);this.notifyPlugins("afterDatasetsUpdate",{mode:e})}}_updateDataset(e,t){const n=this.getDatasetMeta(e),r={meta:n,index:e,mode:t,cancelable:!0};!1!==this.notifyPlugins("beforeDatasetUpdate",r)&&(n.controller._update(t),r.cancelable=!1,this.notifyPlugins("afterDatasetUpdate",r))}render(){!1!==this.notifyPlugins("beforeRender",{cancelable:!0})&&(Fr.has(this)?this.attached&&!Fr.running(this)&&Fr.start(this):(this.draw(),Ro({chart:this})))}draw(){let e;if(this._resizeBeforeDraw){const{width:e,height:t}=this._resizeBeforeDraw;this._resize(e,t),this._resizeBeforeDraw=null}if(this.clear(),this.width<=0||this.height<=0)return;if(!1===this.notifyPlugins("beforeDraw",{cancelable:!0}))return;const t=this._layers;for(e=0;e<t.length&&t[e].z<=0;++e)t[e].draw(this.chartArea);for(this._drawDatasets();e<t.length;++e)t[e].draw(this.chartArea);this.notifyPlugins("afterDraw")}_getSortedDatasetMetas(e){const t=this._sortedMetasets,n=[];let r,i;for(r=0,i=t.length;r<i;++r){const i=t[r];e&&!i.visible||n.push(i)}return n}getSortedVisibleDatasetMetas(){return this._getSortedDatasetMetas(!0)}_drawDatasets(){if(!1===this.notifyPlugins("beforeDatasetsDraw",{cancelable:!0}))return;const e=this.getSortedVisibleDatasetMetas();for(let t=e.length-1;t>=0;--t)this._drawDataset(e[t]);this.notifyPlugins("afterDatasetsDraw")}_drawDataset(e){const t=this.ctx,n=e._clip,r=!n.disabled,i=function(e){const{xScale:t,yScale:n}=e;if(t&&n)return{left:t.left,right:t.right,top:n.top,bottom:n.bottom}}(e)||this.chartArea,o={meta:e,index:e.index,cancelable:!0};!1!==this.notifyPlugins("beforeDatasetDraw",o)&&(r&&Sn(t,{left:!1===n.left?0:i.left-n.left,right:!1===n.right?this.width:i.right+n.right,top:!1===n.top?0:i.top-n.top,bottom:!1===n.bottom?this.height:i.bottom+n.bottom}),e.controller.draw(),r&&Tn(t),o.cancelable=!1,this.notifyPlugins("afterDatasetDraw",o))}isPointInArea(e){return En(e,this.chartArea,this._minPadding)}getElementsAtEventForMode(e,t,n,r){const i=Ii.modes[t];return"function"==typeof i?i(this,e,n,r):[]}getDatasetMeta(e){const t=this.data.datasets[e],n=this._metasets;let r=n.filter((e=>e&&e._dataset===t)).pop();return r||(r={type:null,data:[],dataset:null,controller:null,hidden:null,xAxisID:null,yAxisID:null,order:t&&t.order||0,index:e,_dataset:t,_parsed:[],_sorted:!1},n.push(r)),r}getContext(){return this.$context||(this.$context=Hn(null,{chart:this,type:"chart"}))}getVisibleDatasetCount(){return this.getSortedVisibleDatasetMetas().length}isDatasetVisible(e){const t=this.data.datasets[e];if(!t)return!1;const n=this.getDatasetMeta(e);return"boolean"==typeof n.hidden?!n.hidden:!t.hidden}setDatasetVisibility(e,t){this.getDatasetMeta(e).hidden=!t}toggleDataVisibility(e){this._hiddenIndices[e]=!this._hiddenIndices[e]}getDataVisibility(e){return!this._hiddenIndices[e]}_updateVisibility(e,t,n){const r=n?"show":"hide",i=this.getDatasetMeta(e),o=i.controller._resolveAnimations(void 0,r);Ae(t)?(i.data[t].hidden=!n,this.update()):(this.setDatasetVisibility(e,n),o.update(i,{visible:n}),this.update((t=>t.datasetIndex===e?r:void 0)))}hide(e,t){this._updateVisibility(e,t,!1)}show(e,t){this._updateVisibility(e,t,!0)}_destroyDatasetMeta(e){const t=this._metasets[e];t&&t.controller&&t.controller._destroy(),delete this._metasets[e]}_stop(){let e,t;for(this.stop(),Fr.remove(this),e=0,t=this.data.datasets.length;e<t;++e)this._destroyDatasetMeta(e)}destroy(){this.notifyPlugins("beforeDestroy");const{canvas:e,ctx:t}=this;this._stop(),this.config.clearCache(),e&&(this.unbindEvents(),_n(e,t),this.platform.releaseContext(t),this.canvas=null,this.ctx=null),delete Uo[this.id],this.notifyPlugins("afterDestroy")}toBase64Image(...e){return this.canvas.toDataURL(...e)}bindEvents(){this.bindUserEvents(),this.options.responsive?this.bindResponsiveEvents():this.attached=!0}bindUserEvents(){const e=this._listeners,t=this.platform,n=(n,r)=>{t.addEventListener(this,n,r),e[n]=r},r=(e,t,n)=>{e.offsetX=t,e.offsetY=n,this._eventHandler(e)};_e(this.options.events,(e=>n(e,r)))}bindResponsiveEvents(){this._responsiveListeners||(this._responsiveListeners={});const e=this._responsiveListeners,t=this.platform,n=(n,r)=>{t.addEventListener(this,n,r),e[n]=r},r=(n,r)=>{e[n]&&(t.removeEventListener(this,n,r),delete e[n])},i=(e,t)=>{this.canvas&&this.resize(e,t)};let o;const a=()=>{r("attach",a),this.attached=!0,this.resize(),n("resize",i),n("detach",o)};o=()=>{this.attached=!1,r("resize",i),this._stop(),this._resize(0,0),n("attach",a)},t.isAttached(this.canvas)?a():o()}unbindEvents(){_e(this._listeners,((e,t)=>{this.platform.removeEventListener(this,t,e)})),this._listeners={},_e(this._responsiveListeners,((e,t)=>{this.platform.removeEventListener(this,t,e)})),this._responsiveListeners=void 0}updateHoverStyle(e,t,n){const r=n?"set":"remove";let i,o,a,s;for("dataset"===t&&(i=this.getDatasetMeta(e[0].datasetIndex),i.controller["_"+r+"DatasetHoverStyle"]()),a=0,s=e.length;a<s;++a){o=e[a];const t=o&&this.getDatasetMeta(o.datasetIndex).controller;t&&t[r+"HoverStyle"](o.element,o.datasetIndex,o.index)}}getActiveElements(){return this._active||[]}setActiveElements(e){const t=this._active||[],n=e.map((({datasetIndex:e,index:t})=>{const n=this.getDatasetMeta(e);if(!n)throw new Error("No dataset found at index "+e);return{datasetIndex:e,element:n.data[t],index:t}}));!je(n,t)&&(this._active=n,this._lastEvent=null,this._updateHoverStyles(n,t))}notifyPlugins(e,t,n){return this._plugins.notify(this,e,t,n)}isPluginEnabled(e){return 1===this._plugins._cache.filter((t=>t.plugin.id===e)).length}_updateHoverStyles(e,t,n){const r=this.options.hover,i=(e,t)=>e.filter((e=>!t.some((t=>e.datasetIndex===t.datasetIndex&&e.index===t.index)))),o=i(t,e),a=n?e:i(e,t);o.length&&this.updateHoverStyle(o,r.mode,!1),a.length&&r.mode&&this.updateHoverStyle(a,r.mode,!0)}_eventHandler(e,t){const n={event:e,replay:t,cancelable:!0,inChartArea:this.isPointInArea(e)},r=t=>(t.options.events||this.options.events).includes(e.native.type);if(!1===this.notifyPlugins("beforeEvent",n,r))return;const i=this._handleEvent(e,t,n.inChartArea);return n.cancelable=!1,this.notifyPlugins("afterEvent",n,r),(i||n.changed)&&this.render(),this}_handleEvent(e,t,n){const{_active:r=[],options:i}=this,o=t,a=this._getActiveElements(e,r,n,o),s=function(e){return"mouseup"===e.type||"click"===e.type||"contextmenu"===e.type}(e),l=function(e,t,n,r){return n&&"mouseout"!==e.type?r?t:e:null}(e,this._lastEvent,n,s);n&&(this._lastEvent=null,xe(i.onHover,[e,a,this],this),s&&xe(i.onClick,[e,a,this],this));const c=!je(a,r);return(c||t)&&(this._active=a,this._updateHoverStyles(a,r,t)),this._lastEvent=l,c}_getActiveElements(e,t,n,r){if("mouseout"===e.type)return[];if(!n)return t;const i=this.options.hover;return this.getElementsAtEventForMode(e,i.mode,i,r)}}function Ho(){return _e(Vo.instances,(e=>e._plugins.invalidate()))}var Ko=Vo;function Wo(e,t,n,r){const i=function(e){return Dn(e,["outerStart","outerEnd","innerStart","innerEnd"])}(e.options.borderRadius),o=(n-t)/2,a=Math.min(o,r*t/2),s=e=>{const t=(n-Math.min(o,e))*r/2;return rt(e,0,Math.min(o,t))};return{outerStart:s(i.outerStart),outerEnd:s(i.outerEnd),innerStart:rt(i.innerStart,0,a),innerEnd:rt(i.innerEnd,0,a)}}function zo(e,t,n,r){return{x:n+e*Math.cos(t),y:r+e*Math.sin(t)}}function Yo(e,t,n,r,i,o){const{x:a,y:s,startAngle:l,pixelMargin:c,innerRadius:u}=t,d=Math.max(t.outerRadius+r+n-c,0),f=u>0?u+r+n+c:0;let m=0;const g=i-l;if(r){const e=((u>0?u-r:0)+(d>0?d-r:0))/2;m=(g-(0!==e?g*e/(e+r):g))/2}const h=(g-Math.max(.001,g*d-n/ke)/d)/2,p=l+h+m,v=i-h-m,{outerStart:b,outerEnd:y,innerStart:x,innerEnd:_}=Wo(t,f,d,v-p),j=d-b,O=d-y,E=p+b/j,S=v-y/O,T=f+x,I=f+_,w=p+x/T,P=v-_/I;if(e.beginPath(),o){const t=(E+S)/2;if(e.arc(a,s,d,E,t),e.arc(a,s,d,t,S),y>0){const t=zo(O,S,a,s);e.arc(t.x,t.y,y,S,v+Ge)}const n=zo(I,v,a,s);if(e.lineTo(n.x,n.y),_>0){const t=zo(I,P,a,s);e.arc(t.x,t.y,_,v+Ge,P+Math.PI)}const r=(v-_/f+(p+x/f))/2;if(e.arc(a,s,f,v-_/f,r,!0),e.arc(a,s,f,r,p+x/f,!0),x>0){const t=zo(T,w,a,s);e.arc(t.x,t.y,x,w+Math.PI,p-Ge)}const i=zo(j,p,a,s);if(e.lineTo(i.x,i.y),b>0){const t=zo(j,E,a,s);e.arc(t.x,t.y,b,p-Ge,E)}}else{e.moveTo(a,s);const t=Math.cos(E)*d+a,n=Math.sin(E)*d+s;e.lineTo(t,n);const r=Math.cos(S)*d+a,i=Math.sin(S)*d+s;e.lineTo(r,i)}e.closePath()}function $o(e,t,n,r,i){const{fullCircles:o,startAngle:a,circumference:s,options:l}=t,{borderWidth:c,borderJoinStyle:u}=l,d="inner"===l.borderAlign;if(!c)return;d?(e.lineWidth=2*c,e.lineJoin=u||"round"):(e.lineWidth=c,e.lineJoin=u||"bevel");let f=t.endAngle;if(o){Yo(e,t,n,r,f,i);for(let t=0;t<o;++t)e.stroke();isNaN(s)||(f=a+(s%Re||Re))}d&&function(e,t,n){const{startAngle:r,pixelMargin:i,x:o,y:a,outerRadius:s,innerRadius:l}=t;let c=i/s;e.beginPath(),e.arc(o,a,s,r-c,n+c),l>i?(c=i/l,e.arc(o,a,l,n+c,r-c,!0)):e.arc(o,a,i,n+Ge,r-Ge),e.closePath(),e.clip()}(e,t,f),o||(Yo(e,t,n,r,f,i),e.stroke())}class qo extends oo{static id="arc";static defaults={borderAlign:"center",borderColor:"#fff",borderJoinStyle:void 0,borderRadius:0,borderWidth:2,offset:0,spacing:0,angle:void 0,circular:!0};static defaultRoutes={backgroundColor:"backgroundColor"};constructor(e){super(),this.options=void 0,this.circumference=void 0,this.startAngle=void 0,this.endAngle=void 0,this.innerRadius=void 0,this.outerRadius=void 0,this.pixelMargin=0,this.fullCircles=0,e&&Object.assign(this,e)}inRange(e,t,n){const r=this.getProps(["x","y"],n),{angle:i,distance:o}=Ze(r,{x:e,y:t}),{startAngle:a,endAngle:s,innerRadius:l,outerRadius:c,circumference:u}=this.getProps(["startAngle","endAngle","innerRadius","outerRadius","circumference"],n),d=this.options.spacing/2,f=be(u,s-a)>=Re||nt(i,a,s),m=it(o,l+d,c+d);return f&&m}getCenterPoint(e){const{x:t,y:n,startAngle:r,endAngle:i,innerRadius:o,outerRadius:a}=this.getProps(["x","y","startAngle","endAngle","innerRadius","outerRadius","circumference"],e),{offset:s,spacing:l}=this.options,c=(r+i)/2,u=(o+a+l+s)/2;return{x:t+Math.cos(c)*u,y:n+Math.sin(c)*u}}tooltipPosition(e){return this.getCenterPoint(e)}draw(e){const{options:t,circumference:n}=this,r=(t.offset||0)/4,i=(t.spacing||0)/2,o=t.circular;if(this.pixelMargin="inner"===t.borderAlign?.33:0,this.fullCircles=n>Re?Math.floor(n/Re):0,0===n||this.innerRadius<0||this.outerRadius<0)return;e.save();const a=(this.startAngle+this.endAngle)/2;e.translate(Math.cos(a)*r,Math.sin(a)*r);const s=r*(1-Math.sin(Math.min(ke,n||0)));e.fillStyle=t.backgroundColor,e.strokeStyle=t.borderColor,function(e,t,n,r,i){const{fullCircles:o,startAngle:a,circumference:s}=t;let l=t.endAngle;if(o){Yo(e,t,n,r,l,i);for(let t=0;t<o;++t)e.fill();isNaN(s)||(l=a+(s%Re||Re))}Yo(e,t,n,r,l,i),e.fill()}(e,this,s,i,o),$o(e,this,s,i,o),e.restore()}}function Xo(e,t,n=t){e.lineCap=be(n.borderCapStyle,t.borderCapStyle),e.setLineDash(be(n.borderDash,t.borderDash)),e.lineDashOffset=be(n.borderDashOffset,t.borderDashOffset),e.lineJoin=be(n.borderJoinStyle,t.borderJoinStyle),e.lineWidth=be(n.borderWidth,t.borderWidth),e.strokeStyle=be(n.borderColor,t.borderColor)}function Qo(e,t,n){e.lineTo(n.x,n.y)}function Zo(e,t,n={}){const r=e.length,{start:i=0,end:o=r-1}=n,{start:a,end:s}=t,l=Math.max(i,a),c=Math.min(o,s),u=i<a&&o<a||i>s&&o>s;return{count:r,start:l,loop:t.loop,ilen:c<l&&!u?r+c-l:c-l}}function Jo(e,t,n,r){const{points:i,options:o}=t,{count:a,start:s,loop:l,ilen:c}=Zo(i,n,r),u=function(e){return e.stepped?In:e.tension||"monotone"===e.cubicInterpolationMode?wn:Qo}(o);let d,f,m,{move:g=!0,reverse:h}=r||{};for(d=0;d<=c;++d)f=i[(s+(h?c-d:d))%a],f.skip||(g?(e.moveTo(f.x,f.y),g=!1):u(e,m,f,h,o.stepped),m=f);return l&&(f=i[(s+(h?c:0))%a],u(e,m,f,h,o.stepped)),!!l}function ea(e,t,n,r){const i=t.points,{count:o,start:a,ilen:s}=Zo(i,n,r),{move:l=!0,reverse:c}=r||{};let u,d,f,m,g,h,p=0,v=0;const b=e=>(a+(c?s-e:e))%o,y=()=>{m!==g&&(e.lineTo(p,g),e.lineTo(p,m),e.lineTo(p,h))};for(l&&(d=i[b(0)],e.moveTo(d.x,d.y)),u=0;u<=s;++u){if(d=i[b(u)],d.skip)continue;const t=d.x,n=d.y,r=0|t;r===f?(n<m?m=n:n>g&&(g=n),p=(v*p+t)/++v):(y(),e.lineTo(t,n),f=r,v=0,m=g=n),h=n}y()}function ta(e){const t=e.options,n=t.borderDash&&t.borderDash.length;return!(e._decimated||e._loop||t.tension||"monotone"===t.cubicInterpolationMode||t.stepped||n)?ea:Jo}const na="function"==typeof Path2D;function ra(e,t,n,r){na&&!t.options.segment?function(e,t,n,r){let i=t._path;i||(i=t._path=new Path2D,t.path(i,n,r)&&i.closePath()),Xo(e,t.options),e.stroke(i)}(e,t,n,r):function(e,t,n,r){const{segments:i,options:o}=t,a=ta(t);for(const s of i)Xo(e,o,s.style),e.beginPath(),a(e,t,s,{start:n,end:n+r-1})&&e.closePath(),e.stroke()}(e,t,n,r)}class ia extends oo{static id="line";static defaults={borderCapStyle:"butt",borderDash:[],borderDashOffset:0,borderJoinStyle:"miter",borderWidth:3,capBezierPoints:!0,cubicInterpolationMode:"default",fill:!1,spanGaps:!1,stepped:!1,tension:0};static defaultRoutes={backgroundColor:"backgroundColor",borderColor:"borderColor"};static descriptors={_scriptable:!0,_indexable:e=>"borderDash"!==e&&"fill"!==e};constructor(e){super(),this.animated=!0,this.options=void 0,this._chart=void 0,this._loop=void 0,this._fullLoop=void 0,this._path=void 0,this._points=void 0,this._segments=void 0,this._decimated=!1,this._pointsUpdated=!1,this._datasetIndex=void 0,e&&Object.assign(this,e)}updateControlPoints(e,t){const n=this.options;if((n.tension||"monotone"===n.cubicInterpolationMode)&&!n.stepped&&!this._pointsUpdated){const r=n.spanGaps?this._loop:this._fullLoop;ur(this._points,n,e,r,t),this._pointsUpdated=!0}}set points(e){this._points=e,delete this._segments,delete this._path,this._pointsUpdated=!1}get points(){return this._points}get segments(){return this._segments||(this._segments=function(e,t){const n=e.points,r=e.options.spanGaps,i=n.length;if(!i)return[];const o=!!e._loop,{start:a,end:s}=function(e,t,n,r){let i=0,o=t-1;if(n&&!r)for(;i<t&&!e[i].skip;)i++;for(;i<t&&e[i].skip;)i++;for(i%=t,n&&(o+=i);o>i&&e[o%t].skip;)o--;return o%=t,{start:i,end:o}}(n,i,o,r);return Mr(e,!0===r?[{start:a,end:s,loop:o}]:function(e,t,n,r){const i=e.length,o=[];let a,s=t,l=e[t];for(a=t+1;a<=n;++a){const n=e[a%i];n.skip||n.stop?l.skip||(r=!1,o.push({start:t%i,end:(a-1)%i,loop:r}),t=s=n.stop?a:null):(s=a,l.skip&&(t=a)),l=n}return null!==s&&o.push({start:t%i,end:s%i,loop:r}),o}(n,a,s<a?s+i:s,!!e._fullLoop&&0===a&&s===i-1),n,t)}(this,this.options.segment))}first(){const e=this.segments,t=this.points;return e.length&&t[e[0].start]}last(){const e=this.segments,t=this.points,n=e.length;return n&&t[e[n-1].end]}interpolate(e,t){const n=this.options,r=e[t],i=this.points,o=Lr(this,{property:t,start:r,end:r});if(!o.length)return;const a=[],s=function(e){return e.stepped?Sr:e.tension||"monotone"===e.cubicInterpolationMode?Tr:Er}(n);let l,c;for(l=0,c=o.length;l<c;++l){const{start:c,end:u}=o[l],d=i[c],f=i[u];if(d===f){a.push(d);continue}const m=s(d,f,Math.abs((r-d[t])/(f[t]-d[t])),n.stepped);m[t]=e[t],a.push(m)}return 1===a.length?a[0]:a}pathSegment(e,t,n){return ta(this)(e,this,t,n)}path(e,t,n){const r=this.segments,i=ta(this);let o=this._loop;t=t||0,n=n||this.points.length-t;for(const a of r)o&=i(e,this,a,{start:t,end:t+n-1});return!!o}draw(e,t,n,r){const i=this.options||{};(this.points||[]).length&&i.borderWidth&&(e.save(),ra(e,this,n,r),e.restore()),this.animated&&(this._pointsUpdated=!1,this._path=void 0)}}function oa(e,t,n,r){const i=e.options,{[n]:o}=e.getProps([n],r);return Math.abs(t-o)<i.radius+i.hitRadius}class aa extends oo{static id="point";static defaults={borderWidth:1,hitRadius:1,hoverBorderWidth:1,hoverRadius:4,pointStyle:"circle",radius:3,rotation:0};static defaultRoutes={backgroundColor:"backgroundColor",borderColor:"borderColor"};constructor(e){super(),this.options=void 0,this.parsed=void 0,this.skip=void 0,this.stop=void 0,e&&Object.assign(this,e)}inRange(e,t,n){const r=this.options,{x:i,y:o}=this.getProps(["x","y"],n);return Math.pow(e-i,2)+Math.pow(t-o,2)<Math.pow(r.hitRadius+r.radius,2)}inXRange(e,t){return oa(this,e,"x",t)}inYRange(e,t){return oa(this,e,"y",t)}getCenterPoint(e){const{x:t,y:n}=this.getProps(["x","y"],e);return{x:t,y:n}}size(e){let t=(e=e||this.options||{}).radius||0;t=Math.max(t,t&&e.hoverRadius||0);return 2*(t+(t&&e.borderWidth||0))}draw(e,t){const n=this.options;this.skip||n.radius<.1||!En(this,t,this.size(n)/2)||(e.strokeStyle=n.borderColor,e.lineWidth=n.borderWidth,e.fillStyle=n.backgroundColor,jn(e,n,this.x,this.y))}getRange(){const e=this.options||{};return e.radius+e.hitRadius}}function sa(e,t){const{x:n,y:r,base:i,width:o,height:a}=e.getProps(["x","y","base","width","height"],t);let s,l,c,u,d;return e.horizontal?(d=a/2,s=Math.min(n,i),l=Math.max(n,i),c=r-d,u=r+d):(d=o/2,s=n-d,l=n+d,c=Math.min(r,i),u=Math.max(r,i)),{left:s,top:c,right:l,bottom:u}}function la(e,t,n,r){return e?0:rt(t,n,r)}function ca(e){const t=sa(e),n=t.right-t.left,r=t.bottom-t.top,i=function(e,t,n){const r=e.options.borderWidth,i=e.borderSkipped,o=Fn(r);return{t:la(i.top,o.top,0,n),r:la(i.right,o.right,0,t),b:la(i.bottom,o.bottom,0,n),l:la(i.left,o.left,0,t)}}(e,n/2,r/2),o=function(e,t,n){const{enableBorderRadius:r}=e.getProps(["enableBorderRadius"]),i=e.options.borderRadius,o=Un(i),a=Math.min(t,n),s=e.borderSkipped,l=r||he(i);return{topLeft:la(!l||s.top||s.left,o.topLeft,0,a),topRight:la(!l||s.top||s.right,o.topRight,0,a),bottomLeft:la(!l||s.bottom||s.left,o.bottomLeft,0,a),bottomRight:la(!l||s.bottom||s.right,o.bottomRight,0,a)}}(e,n/2,r/2);return{outer:{x:t.left,y:t.top,w:n,h:r,radius:o},inner:{x:t.left+i.l,y:t.top+i.t,w:n-i.l-i.r,h:r-i.t-i.b,radius:{topLeft:Math.max(0,o.topLeft-Math.max(i.t,i.l)),topRight:Math.max(0,o.topRight-Math.max(i.t,i.r)),bottomLeft:Math.max(0,o.bottomLeft-Math.max(i.b,i.l)),bottomRight:Math.max(0,o.bottomRight-Math.max(i.b,i.r))}}}}function ua(e,t,n,r){const i=null===t,o=null===n,a=e&&!(i&&o)&&sa(e,r);return a&&(i||it(t,a.left,a.right))&&(o||it(n,a.top,a.bottom))}function da(e,t){e.rect(t.x,t.y,t.w,t.h)}function fa(e,t,n={}){const r=e.x!==n.x?-t:0,i=e.y!==n.y?-t:0,o=(e.x+e.w!==n.x+n.w?t:0)-r,a=(e.y+e.h!==n.y+n.h?t:0)-i;return{x:e.x+r,y:e.y+i,w:e.w+o,h:e.h+a,radius:e.radius}}class ma extends oo{static id="bar";static defaults={borderSkipped:"start",borderWidth:0,borderRadius:0,inflateAmount:"auto",pointStyle:void 0};static defaultRoutes={backgroundColor:"backgroundColor",borderColor:"borderColor"};constructor(e){super(),this.options=void 0,this.horizontal=void 0,this.base=void 0,this.width=void 0,this.height=void 0,this.inflateAmount=void 0,e&&Object.assign(this,e)}draw(e){const{inflateAmount:t,options:{borderColor:n,backgroundColor:r}}=this,{inner:i,outer:o}=ca(this),a=(s=o.radius).topLeft||s.topRight||s.bottomLeft||s.bottomRight?An:da;var s;e.save(),o.w===i.w&&o.h===i.h||(e.beginPath(),a(e,fa(o,t,i)),e.clip(),a(e,fa(i,-t,o)),e.fillStyle=n,e.fill("evenodd")),e.beginPath(),a(e,fa(i,t)),e.fillStyle=r,e.fill(),e.restore()}inRange(e,t,n){return ua(this,e,t,n)}inXRange(e,t){return ua(this,e,null,t)}inYRange(e,t){return ua(this,null,e,t)}getCenterPoint(e){const{x:t,y:n,base:r,horizontal:i}=this.getProps(["x","y","base","horizontal"],e);return{x:i?(t+r)/2:t,y:i?n:(n+r)/2}}getRange(e){return"x"===e?this.width/2:this.height/2}}var ga=Object.freeze({__proto__:null,ArcElement:qo,LineElement:ia,PointElement:aa,BarElement:ma});const ha=["rgb(54, 162, 235)","rgb(255, 99, 132)","rgb(255, 159, 64)","rgb(255, 205, 86)","rgb(75, 192, 192)","rgb(153, 102, 255)","rgb(201, 203, 207)"],pa=ha.map((e=>e.replace("rgb(","rgba(").replace(")",", 0.5)")));function va(e){return ha[e%ha.length]}function ba(e){return pa[e%pa.length]}function ya(e){return"doughnut"===e||"pie"===e?function(){let e=0;return t=>{t.backgroundColor=t.data.map((()=>va(e++)))}}():"polarArea"===e?function(){let e=0;return t=>{t.backgroundColor=t.data.map((()=>ba(e++)))}}():(e,t)=>{e.borderColor=va(t),e.backgroundColor=ba(t)}}function xa(e){let t;for(t in e)if(e[t].borderColor||e[t].backgroundColor)return!0;return!1}var _a={id:"colors",defaults:{enabled:!0},beforeLayout(e,t,n){if(!n.enabled)return;const{type:r,options:{elements:i},data:{datasets:o}}=e.config;if(xa(o)||i&&xa(i))return;const a=ya(r);o.forEach(a)}};function ja(e){if(e._decimated){const t=e._data;delete e._decimated,delete e._data,Object.defineProperty(e,"data",{value:t})}}function Oa(e){e.data.datasets.forEach((e=>{ja(e)}))}var Ea={id:"decimation",defaults:{algorithm:"min-max",enabled:!1},beforeElementsUpdate:(e,t,n)=>{if(!n.enabled)return void Oa(e);const r=e.width;e.data.datasets.forEach(((t,i)=>{const{_data:o,indexAxis:a}=t,s=e.getDatasetMeta(i),l=o||t.data;if("y"===Vn([a,e.options.indexAxis]))return;if(!s.controller.supportsDecimation)return;const c=e.scales[s.xAxisID];if("linear"!==c.type&&"time"!==c.type)return;if(e.options.parsing)return;let{start:u,count:d}=function(e,t){const n=t.length;let r,i=0;const{iScale:o}=e,{min:a,max:s,minDefined:l,maxDefined:c}=o.getUserBounds();return l&&(i=rt(at(t,o.axis,a).lo,0,n-1)),r=c?rt(at(t,o.axis,s).hi+1,i,n)-i:n-i,{start:i,count:r}}(s,l);if(d<=(n.threshold||4*r))return void ja(t);let f;switch(me(o)&&(t._data=l,delete t.data,Object.defineProperty(t,"data",{configurable:!0,enumerable:!0,get:function(){return this._decimated},set:function(e){this._data=e}})),n.algorithm){case"lttb":f=function(e,t,n,r,i){const o=i.samples||r;if(o>=n)return e.slice(t,t+n);const a=[],s=(n-2)/(o-2);let l=0;const c=t+n-1;let u,d,f,m,g,h=t;for(a[l++]=e[h],u=0;u<o-2;u++){let r,i=0,o=0;const c=Math.floor((u+1)*s)+1+t,p=Math.min(Math.floor((u+2)*s)+1,n)+t,v=p-c;for(r=c;r<p;r++)i+=e[r].x,o+=e[r].y;i/=v,o/=v;const b=Math.floor(u*s)+1+t,y=Math.min(Math.floor((u+1)*s)+1,n)+t,{x,y:_}=e[h];for(f=m=-1,r=b;r<y;r++)m=.5*Math.abs((x-i)*(e[r].y-_)-(x-e[r].x)*(o-_)),m>f&&(f=m,d=e[r],g=r);a[l++]=d,h=g}return a[l++]=e[c],a}(l,u,d,r,n);break;case"min-max":f=function(e,t,n,r){let i,o,a,s,l,c,u,d,f,m,g=0,h=0;const p=[],v=t+n-1,b=e[t].x,y=e[v].x-b;for(i=t;i<t+n;++i){o=e[i],a=(o.x-b)/y*r,s=o.y;const t=0|a;if(t===l)s<f?(f=s,c=i):s>m&&(m=s,u=i),g=(h*g+o.x)/++h;else{const n=i-1;if(!me(c)&&!me(u)){const t=Math.min(c,u),r=Math.max(c,u);t!==d&&t!==n&&p.push({...e[t],x:g}),r!==d&&r!==n&&p.push({...e[r],x:g})}i>0&&n!==d&&p.push(e[n]),p.push(o),l=t,h=0,f=m=s,c=u=d=i}}return p}(l,u,d,r);break;default:throw new Error(`Unsupported decimation algorithm '${n.algorithm}'`)}t._decimated=f}))},destroy(e){Oa(e)}};function Sa(e,t,n,r){if(r)return;let i=t[e],o=n[e];return"angle"===e&&(i=tt(i),o=tt(o)),{property:e,start:i,end:o}}function Ta(e,t,n){for(;t>e;t--){const e=n[t];if(!isNaN(e.x)&&!isNaN(e.y))break}return t}function Ia(e,t,n,r){return e&&t?r(e[n],t[n]):e?e[n]:t?t[n]:0}function wa(e,t){let n=[],r=!1;return ge(e)?(r=!0,n=e):n=function(e,t){const{x:n=null,y:r=null}=e||{},i=t.points,o=[];return t.segments.forEach((({start:e,end:t})=>{t=Ta(e,t,i);const a=i[e],s=i[t];null!==r?(o.push({x:a.x,y:r}),o.push({x:s.x,y:r})):null!==n&&(o.push({x:n,y:a.y}),o.push({x:n,y:s.y}))})),o}(e,t),n.length?new ia({points:n,options:{tension:0},_loop:r,_fullLoop:r}):null}function Pa(e){return e&&!1!==e.fill}function Ca(e,t,n){let r=e[t].fill;const i=[t];let o;if(!n)return r;for(;!1!==r&&-1===i.indexOf(r);){if(!pe(r))return r;if(o=e[r],!o)return!1;if(o.visible)return r;i.push(r),r=o.fill}return!1}function Na(e,t,n){const r=function(e){const t=e.options,n=t.fill;let r=be(n&&n.target,n);void 0===r&&(r=!!t.backgroundColor);if(!1===r||null===r)return!1;if(!0===r)return"origin";return r}(e);if(he(r))return!isNaN(r.value)&&r;let i=parseFloat(r);return pe(i)&&Math.floor(i)===i?function(e,t,n,r){"-"!==e&&"+"!==e||(n=t+n);if(n===t||n<0||n>=r)return!1;return n}(r[0],t,i,n):["origin","start","end","stack","shape"].indexOf(r)>=0&&r}function Aa(e,t,n){const r=[];for(let i=0;i<n.length;i++){const o=n[i],{first:a,last:s,point:l}=La(o,t,"x");if(!(!l||a&&s))if(a)r.unshift(l);else if(e.push(l),!s)break}e.push(...r)}function La(e,t,n){const r=e.interpolate(t,n);if(!r)return{};const i=r[n],o=e.segments,a=e.points;let s=!1,l=!1;for(let e=0;e<o.length;e++){const t=o[e],r=a[t.start][n],c=a[t.end][n];if(it(i,r,c)){s=i===r,l=i===c;break}}return{first:s,last:l,point:r}}class Ma{constructor(e){this.x=e.x,this.y=e.y,this.radius=e.radius}pathSegment(e,t,n){const{x:r,y:i,radius:o}=this;return t=t||{start:0,end:Re},e.arc(r,i,o,t.end,t.start,!0),!n.bounds}interpolate(e){const{x:t,y:n,radius:r}=this,i=e.angle;return{x:t+Math.cos(i)*r,y:n+Math.sin(i)*r,angle:i}}}function ka(e){const{chart:t,fill:n,line:r}=e;if(pe(n))return function(e,t){const n=e.getDatasetMeta(t),r=n&&e.isDatasetVisible(t);return r?n.dataset:null}(t,n);if("stack"===n)return function(e){const{scale:t,index:n,line:r}=e,i=[],o=r.segments,a=r.points,s=function(e,t){const n=[],r=e.getMatchingVisibleMetas("line");for(let e=0;e<r.length;e++){const i=r[e];if(i.index===t)break;i.hidden||n.unshift(i.dataset)}return n}(t,n);s.push(wa({x:null,y:t.bottom},r));for(let e=0;e<o.length;e++){const t=o[e];for(let e=t.start;e<=t.end;e++)Aa(i,a[e],s)}return new ia({points:i,options:{}})}(e);if("shape"===n)return!0;const i=function(e){const t=e.scale||{};if(t.getPointPositionForValue)return function(e){const{scale:t,fill:n}=e,r=t.options,i=t.getLabels().length,o=r.reverse?t.max:t.min,a=function(e,t,n){let r;return r="start"===e?n:"end"===e?t.options.reverse?t.min:t.max:he(e)?e.value:t.getBaseValue(),r}(n,t,o),s=[];if(r.grid.circular){const e=t.getPointPositionForValue(0,o);return new Ma({x:e.x,y:e.y,radius:t.getDistanceFromCenterForValue(a)})}for(let e=0;e<i;++e)s.push(t.getPointPositionForValue(e,a));return s}(e);return function(e){const{scale:t={},fill:n}=e,r=function(e,t){let n=null;return"start"===e?n=t.bottom:"end"===e?n=t.top:he(e)?n=t.getPixelForValue(e.value):t.getBasePixel&&(n=t.getBasePixel()),n}(n,t);if(pe(r)){const e=t.isHorizontal();return{x:e?r:null,y:e?null:r}}return null}(e)}(e);return i instanceof Ma?i:wa(i,r)}function Ra(e,t,n){const r=ka(t),{line:i,scale:o,axis:a}=t,s=i.options,l=s.fill,c=s.backgroundColor,{above:u=c,below:d=c}=l||{};r&&i.points.length&&(Sn(e,n),function(e,t){const{line:n,target:r,above:i,below:o,area:a,scale:s}=t,l=n._loop?"angle":t.axis;e.save(),"x"===l&&o!==i&&(Da(e,r,a.top),Fa(e,{line:n,target:r,color:i,scale:s,property:l}),e.restore(),e.save(),Da(e,r,a.bottom));Fa(e,{line:n,target:r,color:o,scale:s,property:l}),e.restore()}(e,{line:i,target:r,above:u,below:d,area:n,scale:o,axis:a}),Tn(e))}function Da(e,t,n){const{segments:r,points:i}=t;let o=!0,a=!1;e.beginPath();for(const s of r){const{start:r,end:l}=s,c=i[r],u=i[Ta(r,l,i)];o?(e.moveTo(c.x,c.y),o=!1):(e.lineTo(c.x,n),e.lineTo(c.x,c.y)),a=!!t.pathSegment(e,s,{move:a}),a?e.closePath():e.lineTo(u.x,n)}e.lineTo(t.first().x,n),e.closePath(),e.clip()}function Fa(e,t){const{line:n,target:r,property:i,color:o,scale:a}=t,s=function(e,t,n){const r=e.segments,i=e.points,o=t.points,a=[];for(const e of r){let{start:r,end:s}=e;s=Ta(r,s,i);const l=Sa(n,i[r],i[s],e.loop);if(!t.segments){a.push({source:e,target:l,start:i[r],end:i[s]});continue}const c=Lr(t,l);for(const t of c){const r=Sa(n,o[t.start],o[t.end],t.loop),s=Ar(e,i,r);for(const e of s)a.push({source:e,target:t,start:{[n]:Ia(l,r,"start",Math.max)},end:{[n]:Ia(l,r,"end",Math.min)}})}}return a}(n,r,i);for(const{source:t,target:l,start:c,end:u}of s){const{style:{backgroundColor:s=o}={}}=t,d=!0!==r;e.save(),e.fillStyle=s,Ua(e,a,d&&Sa(i,c,u)),e.beginPath();const f=!!n.pathSegment(e,t);let m;if(d){f?e.closePath():Ga(e,r,u,i);const t=!!r.pathSegment(e,l,{move:f,reverse:!0});m=f&&t,m||Ga(e,r,c,i)}e.closePath(),e.fill(m?"evenodd":"nonzero"),e.restore()}}function Ua(e,t,n){const{top:r,bottom:i}=t.chart.chartArea,{property:o,start:a,end:s}=n||{};"x"===o&&(e.beginPath(),e.rect(a,r,s-a,i-r),e.clip())}function Ga(e,t,n,r){const i=t.interpolate(n,r);i&&e.lineTo(i.x,i.y)}var Ba={id:"filler",afterDatasetsUpdate(e,t,n){const r=(e.data.datasets||[]).length,i=[];let o,a,s,l;for(a=0;a<r;++a)o=e.getDatasetMeta(a),s=o.dataset,l=null,s&&s.options&&s instanceof ia&&(l={visible:e.isDatasetVisible(a),index:a,fill:Na(s,a,r),chart:e,axis:o.controller.options.indexAxis,scale:o.vScale,line:s}),o.$filler=l,i.push(l);for(a=0;a<r;++a)l=i[a],l&&!1!==l.fill&&(l.fill=Ca(i,a,n.propagate))},beforeDraw(e,t,n){const r="beforeDraw"===n.drawTime,i=e.getSortedVisibleDatasetMetas(),o=e.chartArea;for(let t=i.length-1;t>=0;--t){const n=i[t].$filler;n&&(n.line.updateControlPoints(o,n.axis),r&&n.fill&&Ra(e.ctx,n,o))}},beforeDatasetsDraw(e,t,n){if("beforeDatasetsDraw"!==n.drawTime)return;const r=e.getSortedVisibleDatasetMetas();for(let t=r.length-1;t>=0;--t){const n=r[t].$filler;Pa(n)&&Ra(e.ctx,n,e.chartArea)}},beforeDatasetDraw(e,t,n){const r=t.meta.$filler;Pa(r)&&"beforeDatasetDraw"===n.drawTime&&Ra(e.ctx,r,e.chartArea)},defaults:{propagate:!0,drawTime:"beforeDatasetDraw"}};const Va=(e,t)=>{let{boxHeight:n=t,boxWidth:r=t}=e;return e.usePointStyle&&(n=Math.min(n,t),r=e.pointStyleWidth||Math.min(r,t)),{boxWidth:r,boxHeight:n,itemHeight:Math.max(t,n)}};class Ha extends oo{constructor(e){super(),this._added=!1,this.legendHitBoxes=[],this._hoveredItem=null,this.doughnutMode=!1,this.chart=e.chart,this.options=e.options,this.ctx=e.ctx,this.legendItems=void 0,this.columnSizes=void 0,this.lineWidths=void 0,this.maxHeight=void 0,this.maxWidth=void 0,this.top=void 0,this.bottom=void 0,this.left=void 0,this.right=void 0,this.height=void 0,this.width=void 0,this._margins=void 0,this.position=void 0,this.weight=void 0,this.fullSize=void 0}update(e,t,n){this.maxWidth=e,this.maxHeight=t,this._margins=n,this.setDimensions(),this.buildLabels(),this.fit()}setDimensions(){this.isHorizontal()?(this.width=this.maxWidth,this.left=this._margins.left,this.right=this.width):(this.height=this.maxHeight,this.top=this._margins.top,this.bottom=this.height)}buildLabels(){const e=this.options.labels||{};let t=xe(e.generateLabels,[this.chart],this)||[];e.filter&&(t=t.filter((t=>e.filter(t,this.chart.data)))),e.sort&&(t=t.sort(((t,n)=>e.sort(t,n,this.chart.data)))),this.options.reverse&&t.reverse(),this.legendItems=t}fit(){const{options:e,ctx:t}=this;if(!e.display)return void(this.width=this.height=0);const n=e.labels,r=Bn(n.font),i=r.size,o=this._computeTitleHeight(),{boxWidth:a,itemHeight:s}=Va(n,i);let l,c;t.font=r.string,this.isHorizontal()?(l=this.maxWidth,c=this._fitRows(o,i,a,s)+10):(c=this.maxHeight,l=this._fitCols(o,r,a,s)+10),this.width=Math.min(l,e.maxWidth||this.maxWidth),this.height=Math.min(c,e.maxHeight||this.maxHeight)}_fitRows(e,t,n,r){const{ctx:i,maxWidth:o,options:{labels:{padding:a}}}=this,s=this.legendHitBoxes=[],l=this.lineWidths=[0],c=r+a;let u=e;i.textAlign="left",i.textBaseline="middle";let d=-1,f=-c;return this.legendItems.forEach(((e,m)=>{const g=n+t/2+i.measureText(e.text).width;(0===m||l[l.length-1]+g+2*a>o)&&(u+=c,l[l.length-(m>0?0:1)]=0,f+=c,d++),s[m]={left:0,top:f,row:d,width:g,height:r},l[l.length-1]+=g+a})),u}_fitCols(e,t,n,r){const{ctx:i,maxHeight:o,options:{labels:{padding:a}}}=this,s=this.legendHitBoxes=[],l=this.columnSizes=[],c=o-e;let u=a,d=0,f=0,m=0,g=0;return this.legendItems.forEach(((e,o)=>{const{itemWidth:h,itemHeight:p}=function(e,t,n,r,i){const o=function(e,t,n,r){let i=e.text;i&&"string"!=typeof i&&(i=i.reduce(((e,t)=>e.length>t.length?e:t)));return t+n.size/2+r.measureText(i).width}(r,e,t,n),a=function(e,t,n){let r=e;"string"!=typeof t.text&&(r=Ka(t,n));return r}(i,r,t.lineHeight);return{itemWidth:o,itemHeight:a}}(n,t,i,e,r);o>0&&f+p+2*a>c&&(u+=d+a,l.push({width:d,height:f}),m+=d+a,g++,d=f=0),s[o]={left:m,top:f,col:g,width:h,height:p},d=Math.max(d,h),f+=p+a})),u+=d,l.push({width:d,height:f}),u}adjustHitBoxes(){if(!this.options.display)return;const e=this._computeTitleHeight(),{legendHitBoxes:t,options:{align:n,labels:{padding:r},rtl:i}}=this,o=Ir(i,this.left,this.width);if(this.isHorizontal()){let i=0,a=gt(n,this.left+r,this.right-this.lineWidths[i]);for(const s of t)i!==s.row&&(i=s.row,a=gt(n,this.left+r,this.right-this.lineWidths[i])),s.top+=this.top+e+r,s.left=o.leftForLtr(o.x(a),s.width),a+=s.width+r}else{let i=0,a=gt(n,this.top+e+r,this.bottom-this.columnSizes[i].height);for(const s of t)s.col!==i&&(i=s.col,a=gt(n,this.top+e+r,this.bottom-this.columnSizes[i].height)),s.top=a,s.left+=this.left+r,s.left=o.leftForLtr(o.x(s.left),s.width),a+=s.height+r}}isHorizontal(){return"top"===this.options.position||"bottom"===this.options.position}draw(){if(this.options.display){const e=this.ctx;Sn(e,this),this._draw(),Tn(e)}}_draw(){const{options:e,columnSizes:t,lineWidths:n,ctx:r}=this,{align:i,labels:o}=e,a=vn.color,s=Ir(e.rtl,this.left,this.width),l=Bn(o.font),{padding:c}=o,u=l.size,d=u/2;let f;this.drawTitle(),r.textAlign=s.textAlign("left"),r.textBaseline="middle",r.lineWidth=.5,r.font=l.string;const{boxWidth:m,boxHeight:g,itemHeight:h}=Va(o,u),p=this.isHorizontal(),v=this._computeTitleHeight();f=p?{x:gt(i,this.left+c,this.right-n[0]),y:this.top+c+v,line:0}:{x:this.left+c,y:gt(i,this.top+v+c,this.bottom-t[0].height),line:0},wr(this.ctx,e.textDirection);const b=h+c;this.legendItems.forEach(((y,x)=>{r.strokeStyle=y.fontColor,r.fillStyle=y.fontColor;const _=r.measureText(y.text).width,j=s.textAlign(y.textAlign||(y.textAlign=o.textAlign)),O=m+d+_;let E=f.x,S=f.y;s.setWidth(this.width),p?x>0&&E+O+c>this.right&&(S=f.y+=b,f.line++,E=f.x=gt(i,this.left+c,this.right-n[f.line])):x>0&&S+b>this.bottom&&(E=f.x=E+t[f.line].width+c,f.line++,S=f.y=gt(i,this.top+v+c,this.bottom-t[f.line].height));if(function(e,t,n){if(isNaN(m)||m<=0||isNaN(g)||g<0)return;r.save();const i=be(n.lineWidth,1);if(r.fillStyle=be(n.fillStyle,a),r.lineCap=be(n.lineCap,"butt"),r.lineDashOffset=be(n.lineDashOffset,0),r.lineJoin=be(n.lineJoin,"miter"),r.lineWidth=i,r.strokeStyle=be(n.strokeStyle,a),r.setLineDash(be(n.lineDash,[])),o.usePointStyle){const a={radius:g*Math.SQRT2/2,pointStyle:n.pointStyle,rotation:n.rotation,borderWidth:i},l=s.xPlus(e,m/2);On(r,a,l,t+d,o.pointStyleWidth&&m)}else{const o=t+Math.max((u-g)/2,0),a=s.leftForLtr(e,m),l=Un(n.borderRadius);r.beginPath(),Object.values(l).some((e=>0!==e))?An(r,{x:a,y:o,w:m,h:g,radius:l}):r.rect(a,o,m,g),r.fill(),0!==i&&r.stroke()}r.restore()}(s.x(E),S,y),E=((e,t,n,r)=>e===(r?"left":"right")?n:"center"===e?(t+n)/2:t)(j,E+m+d,p?E+O:this.right,e.rtl),function(e,t,n){Pn(r,n.text,e,t+h/2,l,{strikethrough:n.hidden,textAlign:s.textAlign(n.textAlign)})}(s.x(E),S,y),p)f.x+=O+c;else if("string"!=typeof y.text){const e=l.lineHeight;f.y+=Ka(y,e)}else f.y+=b})),Pr(this.ctx,e.textDirection)}drawTitle(){const e=this.options,t=e.title,n=Bn(t.font),r=Gn(t.padding);if(!t.display)return;const i=Ir(e.rtl,this.left,this.width),o=this.ctx,a=t.position,s=n.size/2,l=r.top+s;let c,u=this.left,d=this.width;if(this.isHorizontal())d=Math.max(...this.lineWidths),c=this.top+l,u=gt(e.align,u,this.right-d);else{const t=this.columnSizes.reduce(((e,t)=>Math.max(e,t.height)),0);c=l+gt(e.align,this.top,this.bottom-t-e.labels.padding-this._computeTitleHeight())}const f=gt(a,u,u+d);o.textAlign=i.textAlign(mt(a)),o.textBaseline="middle",o.strokeStyle=t.color,o.fillStyle=t.color,o.font=n.string,Pn(o,t.text,f,c,n)}_computeTitleHeight(){const e=this.options.title,t=Bn(e.font),n=Gn(e.padding);return e.display?t.lineHeight+n.height:0}_getLegendItemAt(e,t){let n,r,i;if(it(e,this.left,this.right)&&it(t,this.top,this.bottom))for(i=this.legendHitBoxes,n=0;n<i.length;++n)if(r=i[n],it(e,r.left,r.left+r.width)&&it(t,r.top,r.top+r.height))return this.legendItems[n];return null}handleEvent(e){const t=this.options;if(!function(e,t){if(("mousemove"===e||"mouseout"===e)&&(t.onHover||t.onLeave))return!0;if(t.onClick&&("click"===e||"mouseup"===e))return!0;return!1}(e.type,t))return;const n=this._getLegendItemAt(e.x,e.y);if("mousemove"===e.type||"mouseout"===e.type){const o=this._hoveredItem,a=(i=n,null!==(r=o)&&null!==i&&r.datasetIndex===i.datasetIndex&&r.index===i.index);o&&!a&&xe(t.onLeave,[e,o,this],this),this._hoveredItem=n,n&&!a&&xe(t.onHover,[e,n,this],this)}else n&&xe(t.onClick,[e,n,this],this);var r,i}}function Ka(e,t){return t*(e.text?e.text.length+.5:0)}var Wa={id:"legend",_element:Ha,start(e,t,n){const r=e.legend=new Ha({ctx:e.ctx,options:n,chart:e});Gi.configure(e,r,n),Gi.addBox(e,r)},stop(e){Gi.removeBox(e,e.legend),delete e.legend},beforeUpdate(e,t,n){const r=e.legend;Gi.configure(e,r,n),r.options=n},afterUpdate(e){const t=e.legend;t.buildLabels(),t.adjustHitBoxes()},afterEvent(e,t){t.replay||e.legend.handleEvent(t.event)},defaults:{display:!0,position:"top",align:"center",fullSize:!0,reverse:!1,weight:1e3,onClick(e,t,n){const r=t.datasetIndex,i=n.chart;i.isDatasetVisible(r)?(i.hide(r),t.hidden=!0):(i.show(r),t.hidden=!1)},onHover:null,onLeave:null,labels:{color:e=>e.chart.options.color,boxWidth:40,padding:10,generateLabels(e){const t=e.data.datasets,{labels:{usePointStyle:n,pointStyle:r,textAlign:i,color:o,useBorderRadius:a,borderRadius:s}}=e.legend.options;return e._getSortedDatasetMetas().map((e=>{const l=e.controller.getStyle(n?0:void 0),c=Gn(l.borderWidth);return{text:t[e.index].label,fillStyle:l.backgroundColor,fontColor:o,hidden:!e.visible,lineCap:l.borderCapStyle,lineDash:l.borderDash,lineDashOffset:l.borderDashOffset,lineJoin:l.borderJoinStyle,lineWidth:(c.width+c.height)/4,strokeStyle:l.borderColor,pointStyle:r||l.pointStyle,rotation:l.rotation,textAlign:i||l.textAlign,borderRadius:a&&(s||l.borderRadius),datasetIndex:e.index}}),this)}},title:{color:e=>e.chart.options.color,display:!1,position:"center",text:""}},descriptors:{_scriptable:e=>!e.startsWith("on"),labels:{_scriptable:e=>!["generateLabels","filter","sort"].includes(e)}}};class za extends oo{constructor(e){super(),this.chart=e.chart,this.options=e.options,this.ctx=e.ctx,this._padding=void 0,this.top=void 0,this.bottom=void 0,this.left=void 0,this.right=void 0,this.width=void 0,this.height=void 0,this.position=void 0,this.weight=void 0,this.fullSize=void 0}update(e,t){const n=this.options;if(this.left=0,this.top=0,!n.display)return void(this.width=this.height=this.right=this.bottom=0);this.width=this.right=e,this.height=this.bottom=t;const r=ge(n.text)?n.text.length:1;this._padding=Gn(n.padding);const i=r*Bn(n.font).lineHeight+this._padding.height;this.isHorizontal()?this.height=i:this.width=i}isHorizontal(){const e=this.options.position;return"top"===e||"bottom"===e}_drawArgs(e){const{top:t,left:n,bottom:r,right:i,options:o}=this,a=o.align;let s,l,c,u=0;return this.isHorizontal()?(l=gt(a,n,i),c=t+e,s=i-n):("left"===o.position?(l=n+e,c=gt(a,r,t),u=-.5*ke):(l=i-e,c=gt(a,t,r),u=.5*ke),s=r-t),{titleX:l,titleY:c,maxWidth:s,rotation:u}}draw(){const e=this.ctx,t=this.options;if(!t.display)return;const n=Bn(t.font),r=n.lineHeight/2+this._padding.top,{titleX:i,titleY:o,maxWidth:a,rotation:s}=this._drawArgs(r);Pn(e,t.text,0,0,n,{color:t.color,maxWidth:a,rotation:s,textAlign:mt(t.align),textBaseline:"middle",translation:[i,o]})}}var Ya={id:"title",_element:za,start(e,t,n){!function(e,t){const n=new za({ctx:e.ctx,options:t,chart:e});Gi.configure(e,n,t),Gi.addBox(e,n),e.titleBlock=n}(e,n)},stop(e){const t=e.titleBlock;Gi.removeBox(e,t),delete e.titleBlock},beforeUpdate(e,t,n){const r=e.titleBlock;Gi.configure(e,r,n),r.options=n},defaults:{align:"center",display:!1,font:{weight:"bold"},fullSize:!0,padding:10,position:"top",text:"",weight:2e3},defaultRoutes:{color:"color"},descriptors:{_scriptable:!0,_indexable:!1}};const $a=new WeakMap;var qa={id:"subtitle",start(e,t,n){const r=new za({ctx:e.ctx,options:n,chart:e});Gi.configure(e,r,n),Gi.addBox(e,r),$a.set(e,r)},stop(e){Gi.removeBox(e,$a.get(e)),$a.delete(e)},beforeUpdate(e,t,n){const r=$a.get(e);Gi.configure(e,r,n),r.options=n},defaults:{align:"center",display:!1,font:{weight:"normal"},fullSize:!0,padding:0,position:"top",text:"",weight:1500},defaultRoutes:{color:"color"},descriptors:{_scriptable:!0,_indexable:!1}};const Xa={average(e){if(!e.length)return!1;let t,n,r=0,i=0,o=0;for(t=0,n=e.length;t<n;++t){const n=e[t].element;if(n&&n.hasValue()){const e=n.tooltipPosition();r+=e.x,i+=e.y,++o}}return{x:r/o,y:i/o}},nearest(e,t){if(!e.length)return!1;let n,r,i,o=t.x,a=t.y,s=Number.POSITIVE_INFINITY;for(n=0,r=e.length;n<r;++n){const r=e[n].element;if(r&&r.hasValue()){const e=Je(t,r.getCenterPoint());e<s&&(s=e,i=r)}}if(i){const e=i.tooltipPosition();o=e.x,a=e.y}return{x:o,y:a}}};function Qa(e,t){return t&&(ge(t)?Array.prototype.push.apply(e,t):e.push(t)),e}function Za(e){return("string"==typeof e||e instanceof String)&&e.indexOf("\n")>-1?e.split("\n"):e}function Ja(e,t){const{element:n,datasetIndex:r,index:i}=t,o=e.getDatasetMeta(r).controller,{label:a,value:s}=o.getLabelAndValue(i);return{chart:e,label:a,parsed:o.getParsed(i),raw:e.data.datasets[r].data[i],formattedValue:s,dataset:o.getDataset(),dataIndex:i,datasetIndex:r,element:n}}function es(e,t){const n=e.chart.ctx,{body:r,footer:i,title:o}=e,{boxWidth:a,boxHeight:s}=t,l=Bn(t.bodyFont),c=Bn(t.titleFont),u=Bn(t.footerFont),d=o.length,f=i.length,m=r.length,g=Gn(t.padding);let h=g.height,p=0,v=r.reduce(((e,t)=>e+t.before.length+t.lines.length+t.after.length),0);if(v+=e.beforeBody.length+e.afterBody.length,d&&(h+=d*c.lineHeight+(d-1)*t.titleSpacing+t.titleMarginBottom),v){h+=m*(t.displayColors?Math.max(s,l.lineHeight):l.lineHeight)+(v-m)*l.lineHeight+(v-1)*t.bodySpacing}f&&(h+=t.footerMarginTop+f*u.lineHeight+(f-1)*t.footerSpacing);let b=0;const y=function(e){p=Math.max(p,n.measureText(e).width+b)};return n.save(),n.font=c.string,_e(e.title,y),n.font=l.string,_e(e.beforeBody.concat(e.afterBody),y),b=t.displayColors?a+2+t.boxPadding:0,_e(r,(e=>{_e(e.before,y),_e(e.lines,y),_e(e.after,y)})),b=0,n.font=u.string,_e(e.footer,y),n.restore(),p+=g.width,{width:p,height:h}}function ts(e,t,n,r){const{x:i,width:o}=n,{width:a,chartArea:{left:s,right:l}}=e;let c="center";return"center"===r?c=i<=(s+l)/2?"left":"right":i<=o/2?c="left":i>=a-o/2&&(c="right"),function(e,t,n,r){const{x:i,width:o}=r,a=n.caretSize+n.caretPadding;return"left"===e&&i+o+a>t.width||"right"===e&&i-o-a<0||void 0}(c,e,t,n)&&(c="center"),c}function ns(e,t,n){const r=n.yAlign||t.yAlign||function(e,t){const{y:n,height:r}=t;return n<r/2?"top":n>e.height-r/2?"bottom":"center"}(e,n);return{xAlign:n.xAlign||t.xAlign||ts(e,t,n,r),yAlign:r}}function rs(e,t,n,r){const{caretSize:i,caretPadding:o,cornerRadius:a}=e,{xAlign:s,yAlign:l}=n,c=i+o,{topLeft:u,topRight:d,bottomLeft:f,bottomRight:m}=Un(a);let g=function(e,t){let{x:n,width:r}=e;return"right"===t?n-=r:"center"===t&&(n-=r/2),n}(t,s);const h=function(e,t,n){let{y:r,height:i}=e;return"top"===t?r+=n:r-="bottom"===t?i+n:i/2,r}(t,l,c);return"center"===l?"left"===s?g+=c:"right"===s&&(g-=c):"left"===s?g-=Math.max(u,f)+i:"right"===s&&(g+=Math.max(d,m)+i),{x:rt(g,0,r.width-t.width),y:rt(h,0,r.height-t.height)}}function is(e,t,n){const r=Gn(n.padding);return"center"===t?e.x+e.width/2:"right"===t?e.x+e.width-r.right:e.x+r.left}function os(e){return Qa([],Za(e))}function as(e,t){const n=t&&t.dataset&&t.dataset.tooltip&&t.dataset.tooltip.callbacks;return n?e.override(n):e}const ss={beforeTitle:de,title(e){if(e.length>0){const t=e[0],n=t.chart.data.labels,r=n?n.length:0;if(this&&this.options&&"dataset"===this.options.mode)return t.dataset.label||"";if(t.label)return t.label;if(r>0&&t.dataIndex<r)return n[t.dataIndex]}return""},afterTitle:de,beforeBody:de,beforeLabel:de,label(e){if(this&&this.options&&"dataset"===this.options.mode)return e.label+": "+e.formattedValue||e.formattedValue;let t=e.dataset.label||"";t&&(t+=": ");const n=e.formattedValue;return me(n)||(t+=n),t},labelColor(e){const t=e.chart.getDatasetMeta(e.datasetIndex).controller.getStyle(e.dataIndex);return{borderColor:t.borderColor,backgroundColor:t.backgroundColor,borderWidth:t.borderWidth,borderDash:t.borderDash,borderDashOffset:t.borderDashOffset,borderRadius:0}},labelTextColor(){return this.options.bodyColor},labelPointStyle(e){const t=e.chart.getDatasetMeta(e.datasetIndex).controller.getStyle(e.dataIndex);return{pointStyle:t.pointStyle,rotation:t.rotation}},afterLabel:de,afterBody:de,beforeFooter:de,footer:de,afterFooter:de};function ls(e,t,n,r){const i=e[t].call(n,r);return void 0===i?ss[t].call(n,r):i}class cs extends oo{static positioners=Xa;constructor(e){super(),this.opacity=0,this._active=[],this._eventPosition=void 0,this._size=void 0,this._cachedAnimations=void 0,this._tooltipItems=[],this.$animations=void 0,this.$context=void 0,this.chart=e.chart,this.options=e.options,this.dataPoints=void 0,this.title=void 0,this.beforeBody=void 0,this.body=void 0,this.afterBody=void 0,this.footer=void 0,this.xAlign=void 0,this.yAlign=void 0,this.x=void 0,this.y=void 0,this.height=void 0,this.width=void 0,this.caretX=void 0,this.caretY=void 0,this.labelColors=void 0,this.labelPointStyles=void 0,this.labelTextColors=void 0}initialize(e){this.options=e,this._cachedAnimations=void 0,this.$context=void 0}_resolveAnimations(){const e=this._cachedAnimations;if(e)return e;const t=this.chart,n=this.options.setContext(this.getContext()),r=n.enabled&&t.options.animation&&n.animations,i=new Vr(this.chart,r);return r._cacheable&&(this._cachedAnimations=Object.freeze(i)),i}getContext(){return this.$context||(this.$context=(e=this.chart.getContext(),t=this,n=this._tooltipItems,Hn(e,{tooltip:t,tooltipItems:n,type:"tooltip"})));var e,t,n}getTitle(e,t){const{callbacks:n}=t,r=ls(n,"beforeTitle",this,e),i=ls(n,"title",this,e),o=ls(n,"afterTitle",this,e);let a=[];return a=Qa(a,Za(r)),a=Qa(a,Za(i)),a=Qa(a,Za(o)),a}getBeforeBody(e,t){return os(ls(t.callbacks,"beforeBody",this,e))}getBody(e,t){const{callbacks:n}=t,r=[];return _e(e,(e=>{const t={before:[],lines:[],after:[]},i=as(n,e);Qa(t.before,Za(ls(i,"beforeLabel",this,e))),Qa(t.lines,ls(i,"label",this,e)),Qa(t.after,Za(ls(i,"afterLabel",this,e))),r.push(t)})),r}getAfterBody(e,t){return os(ls(t.callbacks,"afterBody",this,e))}getFooter(e,t){const{callbacks:n}=t,r=ls(n,"beforeFooter",this,e),i=ls(n,"footer",this,e),o=ls(n,"afterFooter",this,e);let a=[];return a=Qa(a,Za(r)),a=Qa(a,Za(i)),a=Qa(a,Za(o)),a}_createItems(e){const t=this._active,n=this.chart.data,r=[],i=[],o=[];let a,s,l=[];for(a=0,s=t.length;a<s;++a)l.push(Ja(this.chart,t[a]));return e.filter&&(l=l.filter(((t,r,i)=>e.filter(t,r,i,n)))),e.itemSort&&(l=l.sort(((t,r)=>e.itemSort(t,r,n)))),_e(l,(t=>{const n=as(e.callbacks,t);r.push(ls(n,"labelColor",this,t)),i.push(ls(n,"labelPointStyle",this,t)),o.push(ls(n,"labelTextColor",this,t))})),this.labelColors=r,this.labelPointStyles=i,this.labelTextColors=o,this.dataPoints=l,l}update(e,t){const n=this.options.setContext(this.getContext()),r=this._active;let i,o=[];if(r.length){const e=Xa[n.position].call(this,r,this._eventPosition);o=this._createItems(n),this.title=this.getTitle(o,n),this.beforeBody=this.getBeforeBody(o,n),this.body=this.getBody(o,n),this.afterBody=this.getAfterBody(o,n),this.footer=this.getFooter(o,n);const t=this._size=es(this,n),a=Object.assign({},e,t),s=ns(this.chart,n,a),l=rs(n,a,s,this.chart);this.xAlign=s.xAlign,this.yAlign=s.yAlign,i={opacity:1,x:l.x,y:l.y,width:t.width,height:t.height,caretX:e.x,caretY:e.y}}else 0!==this.opacity&&(i={opacity:0});this._tooltipItems=o,this.$context=void 0,i&&this._resolveAnimations().update(this,i),e&&n.external&&n.external.call(this,{chart:this.chart,tooltip:this,replay:t})}drawCaret(e,t,n,r){const i=this.getCaretPosition(e,n,r);t.lineTo(i.x1,i.y1),t.lineTo(i.x2,i.y2),t.lineTo(i.x3,i.y3)}getCaretPosition(e,t,n){const{xAlign:r,yAlign:i}=this,{caretSize:o,cornerRadius:a}=n,{topLeft:s,topRight:l,bottomLeft:c,bottomRight:u}=Un(a),{x:d,y:f}=e,{width:m,height:g}=t;let h,p,v,b,y,x;return"center"===i?(y=f+g/2,"left"===r?(h=d,p=h-o,b=y+o,x=y-o):(h=d+m,p=h+o,b=y-o,x=y+o),v=h):(p="left"===r?d+Math.max(s,c)+o:"right"===r?d+m-Math.max(l,u)-o:this.caretX,"top"===i?(b=f,y=b-o,h=p-o,v=p+o):(b=f+g,y=b+o,h=p+o,v=p-o),x=b),{x1:h,x2:p,x3:v,y1:b,y2:y,y3:x}}drawTitle(e,t,n){const r=this.title,i=r.length;let o,a,s;if(i){const l=Ir(n.rtl,this.x,this.width);for(e.x=is(this,n.titleAlign,n),t.textAlign=l.textAlign(n.titleAlign),t.textBaseline="middle",o=Bn(n.titleFont),a=n.titleSpacing,t.fillStyle=n.titleColor,t.font=o.string,s=0;s<i;++s)t.fillText(r[s],l.x(e.x),e.y+o.lineHeight/2),e.y+=o.lineHeight+a,s+1===i&&(e.y+=n.titleMarginBottom-a)}}_drawColorBox(e,t,n,r,i){const o=this.labelColors[n],a=this.labelPointStyles[n],{boxHeight:s,boxWidth:l,boxPadding:c}=i,u=Bn(i.bodyFont),d=is(this,"left",i),f=r.x(d),m=s<u.lineHeight?(u.lineHeight-s)/2:0,g=t.y+m;if(i.usePointStyle){const t={radius:Math.min(l,s)/2,pointStyle:a.pointStyle,rotation:a.rotation,borderWidth:1},n=r.leftForLtr(f,l)+l/2,c=g+s/2;e.strokeStyle=i.multiKeyBackground,e.fillStyle=i.multiKeyBackground,jn(e,t,n,c),e.strokeStyle=o.borderColor,e.fillStyle=o.backgroundColor,jn(e,t,n,c)}else{e.lineWidth=he(o.borderWidth)?Math.max(...Object.values(o.borderWidth)):o.borderWidth||1,e.strokeStyle=o.borderColor,e.setLineDash(o.borderDash||[]),e.lineDashOffset=o.borderDashOffset||0;const t=r.leftForLtr(f,l-c),n=r.leftForLtr(r.xPlus(f,1),l-c-2),a=Un(o.borderRadius);Object.values(a).some((e=>0!==e))?(e.beginPath(),e.fillStyle=i.multiKeyBackground,An(e,{x:t,y:g,w:l,h:s,radius:a}),e.fill(),e.stroke(),e.fillStyle=o.backgroundColor,e.beginPath(),An(e,{x:n,y:g+1,w:l-2,h:s-2,radius:a}),e.fill()):(e.fillStyle=i.multiKeyBackground,e.fillRect(t,g,l,s),e.strokeRect(t,g,l,s),e.fillStyle=o.backgroundColor,e.fillRect(n,g+1,l-2,s-2))}e.fillStyle=this.labelTextColors[n]}drawBody(e,t,n){const{body:r}=this,{bodySpacing:i,bodyAlign:o,displayColors:a,boxHeight:s,boxWidth:l,boxPadding:c}=n,u=Bn(n.bodyFont);let d=u.lineHeight,f=0;const m=Ir(n.rtl,this.x,this.width),g=function(n){t.fillText(n,m.x(e.x+f),e.y+d/2),e.y+=d+i},h=m.textAlign(o);let p,v,b,y,x,_,j;for(t.textAlign=o,t.textBaseline="middle",t.font=u.string,e.x=is(this,h,n),t.fillStyle=n.bodyColor,_e(this.beforeBody,g),f=a&&"right"!==h?"center"===o?l/2+c:l+2+c:0,y=0,_=r.length;y<_;++y){for(p=r[y],v=this.labelTextColors[y],t.fillStyle=v,_e(p.before,g),b=p.lines,a&&b.length&&(this._drawColorBox(t,e,y,m,n),d=Math.max(u.lineHeight,s)),x=0,j=b.length;x<j;++x)g(b[x]),d=u.lineHeight;_e(p.after,g)}f=0,d=u.lineHeight,_e(this.afterBody,g),e.y-=i}drawFooter(e,t,n){const r=this.footer,i=r.length;let o,a;if(i){const s=Ir(n.rtl,this.x,this.width);for(e.x=is(this,n.footerAlign,n),e.y+=n.footerMarginTop,t.textAlign=s.textAlign(n.footerAlign),t.textBaseline="middle",o=Bn(n.footerFont),t.fillStyle=n.footerColor,t.font=o.string,a=0;a<i;++a)t.fillText(r[a],s.x(e.x),e.y+o.lineHeight/2),e.y+=o.lineHeight+n.footerSpacing}}drawBackground(e,t,n,r){const{xAlign:i,yAlign:o}=this,{x:a,y:s}=e,{width:l,height:c}=n,{topLeft:u,topRight:d,bottomLeft:f,bottomRight:m}=Un(r.cornerRadius);t.fillStyle=r.backgroundColor,t.strokeStyle=r.borderColor,t.lineWidth=r.borderWidth,t.beginPath(),t.moveTo(a+u,s),"top"===o&&this.drawCaret(e,t,n,r),t.lineTo(a+l-d,s),t.quadraticCurveTo(a+l,s,a+l,s+d),"center"===o&&"right"===i&&this.drawCaret(e,t,n,r),t.lineTo(a+l,s+c-m),t.quadraticCurveTo(a+l,s+c,a+l-m,s+c),"bottom"===o&&this.drawCaret(e,t,n,r),t.lineTo(a+f,s+c),t.quadraticCurveTo(a,s+c,a,s+c-f),"center"===o&&"left"===i&&this.drawCaret(e,t,n,r),t.lineTo(a,s+u),t.quadraticCurveTo(a,s,a+u,s),t.closePath(),t.fill(),r.borderWidth>0&&t.stroke()}_updateAnimationTarget(e){const t=this.chart,n=this.$animations,r=n&&n.x,i=n&&n.y;if(r||i){const n=Xa[e.position].call(this,this._active,this._eventPosition);if(!n)return;const o=this._size=es(this,e),a=Object.assign({},n,this._size),s=ns(t,e,a),l=rs(e,a,s,t);r._to===l.x&&i._to===l.y||(this.xAlign=s.xAlign,this.yAlign=s.yAlign,this.width=o.width,this.height=o.height,this.caretX=n.x,this.caretY=n.y,this._resolveAnimations().update(this,l))}}_willRender(){return!!this.opacity}draw(e){const t=this.options.setContext(this.getContext());let n=this.opacity;if(!n)return;this._updateAnimationTarget(t);const r={width:this.width,height:this.height},i={x:this.x,y:this.y};n=Math.abs(n)<.001?0:n;const o=Gn(t.padding),a=this.title.length||this.beforeBody.length||this.body.length||this.afterBody.length||this.footer.length;t.enabled&&a&&(e.save(),e.globalAlpha=n,this.drawBackground(i,e,r,t),wr(e,t.textDirection),i.y+=o.top,this.drawTitle(i,e,t),this.drawBody(i,e,t),this.drawFooter(i,e,t),Pr(e,t.textDirection),e.restore())}getActiveElements(){return this._active||[]}setActiveElements(e,t){const n=this._active,r=e.map((({datasetIndex:e,index:t})=>{const n=this.chart.getDatasetMeta(e);if(!n)throw new Error("Cannot find a dataset at index "+e);return{datasetIndex:e,element:n.data[t],index:t}})),i=!je(n,r),o=this._positionChanged(r,t);(i||o)&&(this._active=r,this._eventPosition=t,this._ignoreReplayEvents=!0,this.update(!0))}handleEvent(e,t,n=!0){if(t&&this._ignoreReplayEvents)return!1;this._ignoreReplayEvents=!1;const r=this.options,i=this._active||[],o=this._getActiveElements(e,i,t,n),a=this._positionChanged(o,e),s=t||!je(o,i)||a;return s&&(this._active=o,(r.enabled||r.external)&&(this._eventPosition={x:e.x,y:e.y},this.update(!0,t))),s}_getActiveElements(e,t,n,r){const i=this.options;if("mouseout"===e.type)return[];if(!r)return t;const o=this.chart.getElementsAtEventForMode(e,i.mode,i,n);return i.reverse&&o.reverse(),o}_positionChanged(e,t){const{caretX:n,caretY:r,options:i}=this,o=Xa[i.position].call(this,e,t);return!1!==o&&(n!==o.x||r!==o.y)}}var us={id:"tooltip",_element:cs,positioners:Xa,afterInit(e,t,n){n&&(e.tooltip=new cs({chart:e,options:n}))},beforeUpdate(e,t,n){e.tooltip&&e.tooltip.initialize(n)},reset(e,t,n){e.tooltip&&e.tooltip.initialize(n)},afterDraw(e){const t=e.tooltip;if(t&&t._willRender()){const n={tooltip:t};if(!1===e.notifyPlugins("beforeTooltipDraw",{...n,cancelable:!0}))return;t.draw(e.ctx),e.notifyPlugins("afterTooltipDraw",n)}},afterEvent(e,t){if(e.tooltip){const n=t.replay;e.tooltip.handleEvent(t.event,n,t.inChartArea)&&(t.changed=!0)}},defaults:{enabled:!0,external:null,position:"average",backgroundColor:"rgba(0,0,0,0.8)",titleColor:"#fff",titleFont:{weight:"bold"},titleSpacing:2,titleMarginBottom:6,titleAlign:"left",bodyColor:"#fff",bodySpacing:2,bodyFont:{},bodyAlign:"left",footerColor:"#fff",footerSpacing:2,footerMarginTop:6,footerFont:{weight:"bold"},footerAlign:"left",padding:6,caretPadding:2,caretSize:5,cornerRadius:6,boxHeight:(e,t)=>t.bodyFont.size,boxWidth:(e,t)=>t.bodyFont.size,multiKeyBackground:"#fff",displayColors:!0,boxPadding:0,borderColor:"rgba(0,0,0,0)",borderWidth:0,animation:{duration:400,easing:"easeOutQuart"},animations:{numbers:{type:"number",properties:["x","y","width","height","caretX","caretY"]},opacity:{easing:"linear",duration:200}},callbacks:ss},defaultRoutes:{bodyFont:"font",footerFont:"font",titleFont:"font"},descriptors:{_scriptable:e=>"filter"!==e&&"itemSort"!==e&&"external"!==e,_indexable:!1,callbacks:{_scriptable:!1,_indexable:!1},animation:{_fallback:!1},animations:{_fallback:"animation"}},additionalOptionScopes:["interaction"]},ds=Object.freeze({__proto__:null,Colors:_a,Decimation:Ea,Filler:Ba,Legend:Wa,SubTitle:qa,Title:Ya,Tooltip:us});function fs(e,t,n,r){const i=e.indexOf(t);if(-1===i)return((e,t,n,r)=>("string"==typeof t?(n=e.push(t)-1,r.unshift({index:n,label:t})):isNaN(t)&&(n=null),n))(e,t,n,r);return i!==e.lastIndexOf(t)?n:i}function ms(e){const t=this.getLabels();return e>=0&&e<t.length?t[e]:e}class gs extends ho{static id="category";static defaults={ticks:{callback:ms}};constructor(e){super(e),this._startValue=void 0,this._valueRange=0,this._addedLabels=[]}init(e){const t=this._addedLabels;if(t.length){const e=this.getLabels();for(const{index:n,label:r}of t)e[n]===r&&e.splice(n,1);this._addedLabels=[]}super.init(e)}parse(e,t){if(me(e))return null;const n=this.getLabels();return((e,t)=>null===e?null:rt(Math.round(e),0,t))(t=isFinite(t)&&n[t]===e?t:fs(n,e,be(t,e),this._addedLabels),n.length-1)}determineDataLimits(){const{minDefined:e,maxDefined:t}=this.getUserBounds();let{min:n,max:r}=this.getMinMax(!0);"ticks"===this.options.bounds&&(e||(n=0),t||(r=this.getLabels().length-1)),this.min=n,this.max=r}buildTicks(){const e=this.min,t=this.max,n=this.options.offset,r=[];let i=this.getLabels();i=0===e&&t===i.length-1?i:i.slice(e,t+1),this._valueRange=Math.max(i.length-(n?0:1),1),this._startValue=this.min-(n?.5:0);for(let n=e;n<=t;n++)r.push({value:n});return r}getLabelForValue(e){return ms.call(this,e)}configure(){super.configure(),this.isHorizontal()||(this._reversePixels=!this._reversePixels)}getPixelForValue(e){return"number"!=typeof e&&(e=this.parse(e)),null===e?NaN:this.getPixelForDecimal((e-this._startValue)/this._valueRange)}getPixelForTick(e){const t=this.ticks;return e<0||e>t.length-1?null:this.getPixelForValue(t[e].value)}getValueForPixel(e){return Math.round(this._startValue+this.getDecimalForPixel(e)*this._valueRange)}getBasePixel(){return this.bottom}}function hs(e,t){const n=[],{bounds:r,step:i,min:o,max:a,precision:s,count:l,maxTicks:c,maxDigits:u,includeBounds:d}=e,f=i||1,m=c-1,{min:g,max:h}=t,p=!me(o),v=!me(a),b=!me(l),y=(h-g)/(u+1);let x,_,j,O,E=ze((h-g)/m/f)*f;if(E<1e-14&&!p&&!v)return[{value:g},{value:h}];O=Math.ceil(h/E)-Math.floor(g/E),O>m&&(E=ze(O*E/m/f)*f),me(s)||(x=Math.pow(10,s),E=Math.ceil(E*x)/x),"ticks"===r?(_=Math.floor(g/E)*E,j=Math.ceil(h/E)*E):(_=g,j=h),p&&v&&i&&function(e,t){const n=Math.round(e);return n-t<=e&&n+t>=e}((a-o)/i,E/1e3)?(O=Math.round(Math.min((a-o)/E,c)),E=(a-o)/O,_=o,j=a):b?(_=p?o:_,j=v?a:j,O=l-1,E=(j-_)/O):(O=(j-_)/E,O=We(O,Math.round(O),E/1e3)?Math.round(O):Math.ceil(O));const S=Math.max(Qe(E),Qe(_));x=Math.pow(10,me(s)?S:s),_=Math.round(_*x)/x,j=Math.round(j*x)/x;let T=0;for(p&&(d&&_!==o?(n.push({value:o}),_<o&&T++,We(Math.round((_+T*E)*x)/x,o,ps(o,y,e))&&T++):_<o&&T++);T<O;++T)n.push({value:Math.round((_+T*E)*x)/x});return v&&d&&j!==a?n.length&&We(n[n.length-1].value,a,ps(a,y,e))?n[n.length-1].value=a:n.push({value:a}):v&&j!==a||n.push({value:j}),n}function ps(e,t,{horizontal:n,minRotation:r}){const i=qe(r),o=(n?Math.sin(i):Math.cos(i))||.001,a=.75*t*(""+e).length;return Math.min(t/o,a)}class vs extends ho{constructor(e){super(e),this.start=void 0,this.end=void 0,this._startValue=void 0,this._endValue=void 0,this._valueRange=0}parse(e,t){return me(e)||("number"==typeof e||e instanceof Number)&&!isFinite(+e)?null:+e}handleTickRangeOptions(){const{beginAtZero:e}=this.options,{minDefined:t,maxDefined:n}=this.getUserBounds();let{min:r,max:i}=this;const o=e=>r=t?r:e,a=e=>i=n?i:e;if(e){const e=Ke(r),t=Ke(i);e<0&&t<0?a(0):e>0&&t>0&&o(0)}if(r===i){let t=0===i?1:Math.abs(.05*i);a(i+t),e||o(r-t)}this.min=r,this.max=i}getTickLimit(){const e=this.options.ticks;let t,{maxTicksLimit:n,stepSize:r}=e;return r?(t=Math.ceil(this.max/r)-Math.floor(this.min/r)+1,t>1e3&&(console.warn(`scales.${this.id}.ticks.stepSize: ${r} would result generating up to ${t} ticks. Limiting to 1000.`),t=1e3)):(t=this.computeTickLimit(),n=n||11),n&&(t=Math.min(n,t)),t}computeTickLimit(){return Number.POSITIVE_INFINITY}buildTicks(){const e=this.options,t=e.ticks;let n=this.getTickLimit();n=Math.max(2,n);const r=hs({maxTicks:n,bounds:e.bounds,min:e.min,max:e.max,precision:t.precision,step:t.stepSize,count:t.count,maxDigits:this._maxDigits(),horizontal:this.isHorizontal(),minRotation:t.minRotation||0,includeBounds:!1!==t.includeBounds},this._range||this);return"ticks"===e.bounds&&$e(r,this,"value"),e.reverse?(r.reverse(),this.start=this.max,this.end=this.min):(this.start=this.min,this.end=this.max),r}configure(){const e=this.ticks;let t=this.min,n=this.max;if(super.configure(),this.options.offset&&e.length){const r=(n-t)/Math.max(e.length-1,1)/2;t-=r,n+=r}this._startValue=t,this._endValue=n,this._valueRange=n-t}getLabelForValue(e){return cn(e,this.chart.options.locale,this.options.ticks.format)}}class bs extends vs{static id="linear";static defaults={ticks:{callback:dn.formatters.numeric}};determineDataLimits(){const{min:e,max:t}=this.getMinMax(!0);this.min=pe(e)?e:0,this.max=pe(t)?t:1,this.handleTickRangeOptions()}computeTickLimit(){const e=this.isHorizontal(),t=e?this.width:this.height,n=qe(this.options.ticks.minRotation),r=(e?Math.sin(n):Math.cos(n))||.001,i=this._resolveTickFontOptions(0);return Math.ceil(t/Math.min(40,i.lineHeight/r))}getPixelForValue(e){return null===e?NaN:this.getPixelForDecimal((e-this._startValue)/this._valueRange)}getValueForPixel(e){return this._startValue+this.getDecimalForPixel(e)*this._valueRange}}const ys=e=>Math.floor(He(e)),xs=(e,t)=>Math.pow(10,ys(e)+t);function _s(e){return 1===e/Math.pow(10,ys(e))}function js(e,t,n){const r=Math.pow(10,n),i=Math.floor(e/r);return Math.ceil(t/r)-i}function Os(e,{min:t,max:n}){t=ve(e.min,t);const r=[],i=ys(t);let o=function(e,t){let n=ys(t-e);for(;js(e,t,n)>10;)n++;for(;js(e,t,n)<10;)n--;return Math.min(n,ys(e))}(t,n),a=o<0?Math.pow(10,Math.abs(o)):1;const s=Math.pow(10,o),l=i>o?Math.pow(10,i):0,c=Math.round((t-l)*a)/a,u=Math.floor((t-l)/s/10)*s*10;let d=Math.floor((c-u)/Math.pow(10,o)),f=ve(e.min,Math.round((l+u+d*Math.pow(10,o))*a)/a);for(;f<n;)r.push({value:f,major:_s(f),significand:d}),d>=10?d=d<15?15:20:d++,d>=20&&(o++,d=2,a=o>=0?1:a),f=Math.round((l+u+d*Math.pow(10,o))*a)/a;const m=ve(e.max,f);return r.push({value:m,major:_s(m),significand:d}),r}class Es extends ho{static id="logarithmic";static defaults={ticks:{callback:dn.formatters.logarithmic,major:{enabled:!0}}};constructor(e){super(e),this.start=void 0,this.end=void 0,this._startValue=void 0,this._valueRange=0}parse(e,t){const n=vs.prototype.parse.apply(this,[e,t]);if(0!==n)return pe(n)&&n>0?n:null;this._zero=!0}determineDataLimits(){const{min:e,max:t}=this.getMinMax(!0);this.min=pe(e)?Math.max(0,e):null,this.max=pe(t)?Math.max(0,t):null,this.options.beginAtZero&&(this._zero=!0),this._zero&&this.min!==this._suggestedMin&&!pe(this._userMin)&&(this.min=e===xs(this.min,0)?xs(this.min,-1):xs(this.min,0)),this.handleTickRangeOptions()}handleTickRangeOptions(){const{minDefined:e,maxDefined:t}=this.getUserBounds();let n=this.min,r=this.max;const i=t=>n=e?n:t,o=e=>r=t?r:e;n===r&&(n<=0?(i(1),o(10)):(i(xs(n,-1)),o(xs(r,1)))),n<=0&&i(xs(r,-1)),r<=0&&o(xs(n,1)),this.min=n,this.max=r}buildTicks(){const e=this.options,t=Os({min:this._userMin,max:this._userMax},this);return"ticks"===e.bounds&&$e(t,this,"value"),e.reverse?(t.reverse(),this.start=this.max,this.end=this.min):(this.start=this.min,this.end=this.max),t}getLabelForValue(e){return void 0===e?"0":cn(e,this.chart.options.locale,this.options.ticks.format)}configure(){const e=this.min;super.configure(),this._startValue=He(e),this._valueRange=He(this.max)-He(e)}getPixelForValue(e){return void 0!==e&&0!==e||(e=this.min),null===e||isNaN(e)?NaN:this.getPixelForDecimal(e===this.min?0:(He(e)-this._startValue)/this._valueRange)}getValueForPixel(e){const t=this.getDecimalForPixel(e);return Math.pow(10,this._startValue+t*this._valueRange)}}function Ss(e){const t=e.ticks;if(t.display&&e.display){const e=Gn(t.backdropPadding);return be(t.font&&t.font.size,vn.font.size)+e.height}return 0}function Ts(e,t,n,r,i){return e===r||e===i?{start:t-n/2,end:t+n/2}:e<r||e>i?{start:t-n,end:t}:{start:t,end:t+n}}function Is(e){const t={l:e.left+e._padding.left,r:e.right-e._padding.right,t:e.top+e._padding.top,b:e.bottom-e._padding.bottom},n=Object.assign({},t),r=[],i=[],o=e._pointLabels.length,a=e.options.pointLabels,s=a.centerPointLabels?ke/o:0;for(let d=0;d<o;d++){const o=a.setContext(e.getPointLabelContext(d));i[d]=o.padding;const f=e.getPointPosition(d,e.drawingArea+i[d],s),m=Bn(o.font),g=(l=e.ctx,c=m,u=ge(u=e._pointLabels[d])?u:[u],{w:yn(l,c.string,u),h:u.length*c.lineHeight});r[d]=g;const h=tt(e.getIndexAngle(d)+s),p=Math.round(Xe(h));ws(n,t,h,Ts(p,f.x,g.w,0,180),Ts(p,f.y,g.h,90,270))}var l,c,u;e.setCenterPoint(t.l-n.l,n.r-t.r,t.t-n.t,n.b-t.b),e._pointLabelItems=function(e,t,n){const r=[],i=e._pointLabels.length,o=e.options,a=Ss(o)/2,s=e.drawingArea,l=o.pointLabels.centerPointLabels?ke/i:0;for(let o=0;o<i;o++){const i=e.getPointPosition(o,s+a+n[o],l),c=Math.round(Xe(tt(i.angle+Ge))),u=t[o],d=Ns(i.y,u.h,c),f=Ps(c),m=Cs(i.x,u.w,f);r.push({x:i.x,y:d,textAlign:f,left:m,top:d,right:m+u.w,bottom:d+u.h})}return r}(e,r,i)}function ws(e,t,n,r,i){const o=Math.abs(Math.sin(n)),a=Math.abs(Math.cos(n));let s=0,l=0;r.start<t.l?(s=(t.l-r.start)/o,e.l=Math.min(e.l,t.l-s)):r.end>t.r&&(s=(r.end-t.r)/o,e.r=Math.max(e.r,t.r+s)),i.start<t.t?(l=(t.t-i.start)/a,e.t=Math.min(e.t,t.t-l)):i.end>t.b&&(l=(i.end-t.b)/a,e.b=Math.max(e.b,t.b+l))}function Ps(e){return 0===e||180===e?"center":e<180?"left":"right"}function Cs(e,t,n){return"right"===n?e-=t:"center"===n&&(e-=t/2),e}function Ns(e,t,n){return 90===n||270===n?e-=t/2:(n>270||n<90)&&(e-=t),e}function As(e,t,n,r){const{ctx:i}=e;if(n)i.arc(e.xCenter,e.yCenter,t,0,Re);else{let n=e.getPointPosition(0,t);i.moveTo(n.x,n.y);for(let o=1;o<r;o++)n=e.getPointPosition(o,t),i.lineTo(n.x,n.y)}}class Ls extends vs{static id="radialLinear";static defaults={display:!0,animate:!0,position:"chartArea",angleLines:{display:!0,lineWidth:1,borderDash:[],borderDashOffset:0},grid:{circular:!1},startAngle:0,ticks:{showLabelBackdrop:!0,callback:dn.formatters.numeric},pointLabels:{backdropColor:void 0,backdropPadding:2,display:!0,font:{size:10},callback:e=>e,padding:5,centerPointLabels:!1}};static defaultRoutes={"angleLines.color":"borderColor","pointLabels.color":"color","ticks.color":"color"};static descriptors={angleLines:{_fallback:"grid"}};constructor(e){super(e),this.xCenter=void 0,this.yCenter=void 0,this.drawingArea=void 0,this._pointLabels=[],this._pointLabelItems=[]}setDimensions(){const e=this._padding=Gn(Ss(this.options)/2),t=this.width=this.maxWidth-e.width,n=this.height=this.maxHeight-e.height;this.xCenter=Math.floor(this.left+t/2+e.left),this.yCenter=Math.floor(this.top+n/2+e.top),this.drawingArea=Math.floor(Math.min(t,n)/2)}determineDataLimits(){const{min:e,max:t}=this.getMinMax(!1);this.min=pe(e)&&!isNaN(e)?e:0,this.max=pe(t)&&!isNaN(t)?t:0,this.handleTickRangeOptions()}computeTickLimit(){return Math.ceil(this.drawingArea/Ss(this.options))}generateTickLabels(e){vs.prototype.generateTickLabels.call(this,e),this._pointLabels=this.getLabels().map(((e,t)=>{const n=xe(this.options.pointLabels.callback,[e,t],this);return n||0===n?n:""})).filter(((e,t)=>this.chart.getDataVisibility(t)))}fit(){const e=this.options;e.display&&e.pointLabels.display?Is(this):this.setCenterPoint(0,0,0,0)}setCenterPoint(e,t,n,r){this.xCenter+=Math.floor((e-t)/2),this.yCenter+=Math.floor((n-r)/2),this.drawingArea-=Math.min(this.drawingArea/2,Math.max(e,t,n,r))}getIndexAngle(e){return tt(e*(Re/(this._pointLabels.length||1))+qe(this.options.startAngle||0))}getDistanceFromCenterForValue(e){if(me(e))return NaN;const t=this.drawingArea/(this.max-this.min);return this.options.reverse?(this.max-e)*t:(e-this.min)*t}getValueForDistanceFromCenter(e){if(me(e))return NaN;const t=e/(this.drawingArea/(this.max-this.min));return this.options.reverse?this.max-t:this.min+t}getPointLabelContext(e){const t=this._pointLabels||[];if(e>=0&&e<t.length){const n=t[e];return function(e,t,n){return Hn(e,{label:n,index:t,type:"pointLabel"})}(this.getContext(),e,n)}}getPointPosition(e,t,n=0){const r=this.getIndexAngle(e)-Ge+n;return{x:Math.cos(r)*t+this.xCenter,y:Math.sin(r)*t+this.yCenter,angle:r}}getPointPositionForValue(e,t){return this.getPointPosition(e,this.getDistanceFromCenterForValue(t))}getBasePosition(e){return this.getPointPositionForValue(e||0,this.getBaseValue())}getPointLabelPosition(e){const{left:t,top:n,right:r,bottom:i}=this._pointLabelItems[e];return{left:t,top:n,right:r,bottom:i}}drawBackground(){const{backgroundColor:e,grid:{circular:t}}=this.options;if(e){const n=this.ctx;n.save(),n.beginPath(),As(this,this.getDistanceFromCenterForValue(this._endValue),t,this._pointLabels.length),n.closePath(),n.fillStyle=e,n.fill(),n.restore()}}drawGrid(){const e=this.ctx,t=this.options,{angleLines:n,grid:r,border:i}=t,o=this._pointLabels.length;let a,s,l;if(t.pointLabels.display&&function(e,t){const{ctx:n,options:{pointLabels:r}}=e;for(let i=t-1;i>=0;i--){const t=r.setContext(e.getPointLabelContext(i)),o=Bn(t.font),{x:a,y:s,textAlign:l,left:c,top:u,right:d,bottom:f}=e._pointLabelItems[i],{backdropColor:m}=t;if(!me(m)){const e=Un(t.borderRadius),r=Gn(t.backdropPadding);n.fillStyle=m;const i=c-r.left,o=u-r.top,a=d-c+r.width,s=f-u+r.height;Object.values(e).some((e=>0!==e))?(n.beginPath(),An(n,{x:i,y:o,w:a,h:s,radius:e}),n.fill()):n.fillRect(i,o,a,s)}Pn(n,e._pointLabels[i],a,s+o.lineHeight/2,o,{color:t.color,textAlign:l,textBaseline:"middle"})}}(this,o),r.display&&this.ticks.forEach(((e,t)=>{if(0!==t){s=this.getDistanceFromCenterForValue(e.value);const n=this.getContext(t),a=r.setContext(n),l=i.setContext(n);!function(e,t,n,r,i){const o=e.ctx,a=t.circular,{color:s,lineWidth:l}=t;!a&&!r||!s||!l||n<0||(o.save(),o.strokeStyle=s,o.lineWidth=l,o.setLineDash(i.dash),o.lineDashOffset=i.dashOffset,o.beginPath(),As(e,n,a,r),o.closePath(),o.stroke(),o.restore())}(this,a,s,o,l)}})),n.display){for(e.save(),a=o-1;a>=0;a--){const r=n.setContext(this.getPointLabelContext(a)),{color:i,lineWidth:o}=r;o&&i&&(e.lineWidth=o,e.strokeStyle=i,e.setLineDash(r.borderDash),e.lineDashOffset=r.borderDashOffset,s=this.getDistanceFromCenterForValue(t.ticks.reverse?this.min:this.max),l=this.getPointPosition(a,s),e.beginPath(),e.moveTo(this.xCenter,this.yCenter),e.lineTo(l.x,l.y),e.stroke())}e.restore()}}drawBorder(){}drawLabels(){const e=this.ctx,t=this.options,n=t.ticks;if(!n.display)return;const r=this.getIndexAngle(0);let i,o;e.save(),e.translate(this.xCenter,this.yCenter),e.rotate(r),e.textAlign="center",e.textBaseline="middle",this.ticks.forEach(((r,a)=>{if(0===a&&!t.reverse)return;const s=n.setContext(this.getContext(a)),l=Bn(s.font);if(i=this.getDistanceFromCenterForValue(this.ticks[a].value),s.showLabelBackdrop){e.font=l.string,o=e.measureText(r.label).width,e.fillStyle=s.backdropColor;const t=Gn(s.backdropPadding);e.fillRect(-o/2-t.left,-i-l.size/2-t.top,o+t.width,l.size+t.height)}Pn(e,r.label,0,-i,l,{color:s.color})})),e.restore()}drawTitle(){}}const Ms={millisecond:{common:!0,size:1,steps:1e3},second:{common:!0,size:1e3,steps:60},minute:{common:!0,size:6e4,steps:60},hour:{common:!0,size:36e5,steps:24},day:{common:!0,size:864e5,steps:30},week:{common:!1,size:6048e5,steps:4},month:{common:!0,size:2628e6,steps:12},quarter:{common:!1,size:7884e6,steps:4},year:{common:!0,size:3154e7}},ks=Object.keys(Ms);function Rs(e,t){return e-t}function Ds(e,t){if(me(t))return null;const n=e._adapter,{parser:r,round:i,isoWeekday:o}=e._parseOpts;let a=t;return"function"==typeof r&&(a=r(a)),pe(a)||(a="string"==typeof r?n.parse(a,r):n.parse(a)),null===a?null:(i&&(a="week"!==i||!Ye(o)&&!0!==o?n.startOf(a,i):n.startOf(a,"isoWeek",o)),+a)}function Fs(e,t,n,r){const i=ks.length;for(let o=ks.indexOf(e);o<i-1;++o){const e=Ms[ks[o]],i=e.steps?e.steps:Number.MAX_SAFE_INTEGER;if(e.common&&Math.ceil((n-t)/(i*e.size))<=r)return ks[o]}return ks[i-1]}function Us(e,t,n){if(n){if(n.length){const{lo:r,hi:i}=ot(n,t);e[n[r]>=t?n[r]:n[i]]=!0}}else e[t]=!0}function Gs(e,t,n){const r=[],i={},o=t.length;let a,s;for(a=0;a<o;++a)s=t[a],i[s]=a,r.push({value:s,major:!1});return 0!==o&&n?function(e,t,n,r){const i=e._adapter,o=+i.startOf(t[0].value,r),a=t[t.length-1].value;let s,l;for(s=o;s<=a;s=+i.add(s,1,r))l=n[s],l>=0&&(t[l].major=!0);return t}(e,r,i,n):r}class Bs extends ho{static id="time";static defaults={bounds:"data",adapters:{},time:{parser:!1,unit:!1,round:!1,isoWeekday:!1,minUnit:"millisecond",displayFormats:{}},ticks:{source:"auto",callback:!1,major:{enabled:!1}}};constructor(e){super(e),this._cache={data:[],labels:[],all:[]},this._unit="day",this._majorUnit=void 0,this._offsets={},this._normalized=!1,this._parseOpts=void 0}init(e,t={}){const n=e.time||(e.time={}),r=this._adapter=new xi._date(e.adapters.date);r.init(t),Ie(n.displayFormats,r.formats()),this._parseOpts={parser:n.parser,round:n.round,isoWeekday:n.isoWeekday},super.init(e),this._normalized=t.normalized}parse(e,t){return void 0===e?null:Ds(this,e)}beforeLayout(){super.beforeLayout(),this._cache={data:[],labels:[],all:[]}}determineDataLimits(){const e=this.options,t=this._adapter,n=e.time.unit||"day";let{min:r,max:i,minDefined:o,maxDefined:a}=this.getUserBounds();function s(e){o||isNaN(e.min)||(r=Math.min(r,e.min)),a||isNaN(e.max)||(i=Math.max(i,e.max))}o&&a||(s(this._getLabelBounds()),"ticks"===e.bounds&&"labels"===e.ticks.source||s(this.getMinMax(!1))),r=pe(r)&&!isNaN(r)?r:+t.startOf(Date.now(),n),i=pe(i)&&!isNaN(i)?i:+t.endOf(Date.now(),n)+1,this.min=Math.min(r,i-1),this.max=Math.max(r+1,i)}_getLabelBounds(){const e=this.getLabelTimestamps();let t=Number.POSITIVE_INFINITY,n=Number.NEGATIVE_INFINITY;return e.length&&(t=e[0],n=e[e.length-1]),{min:t,max:n}}buildTicks(){const e=this.options,t=e.time,n=e.ticks,r="labels"===n.source?this.getLabelTimestamps():this._generate();"ticks"===e.bounds&&r.length&&(this.min=this._userMin||r[0],this.max=this._userMax||r[r.length-1]);const i=this.min,o=function(e,t,n){let r=0,i=e.length;for(;r<i&&e[r]<t;)r++;for(;i>r&&e[i-1]>n;)i--;return r>0||i<e.length?e.slice(r,i):e}(r,i,this.max);return this._unit=t.unit||(n.autoSkip?Fs(t.minUnit,this.min,this.max,this._getLabelCapacity(i)):function(e,t,n,r,i){for(let o=ks.length-1;o>=ks.indexOf(n);o--){const n=ks[o];if(Ms[n].common&&e._adapter.diff(i,r,n)>=t-1)return n}return ks[n?ks.indexOf(n):0]}(this,o.length,t.minUnit,this.min,this.max)),this._majorUnit=n.major.enabled&&"year"!==this._unit?function(e){for(let t=ks.indexOf(e)+1,n=ks.length;t<n;++t)if(Ms[ks[t]].common)return ks[t]}(this._unit):void 0,this.initOffsets(r),e.reverse&&o.reverse(),Gs(this,o,this._majorUnit)}afterAutoSkip(){this.options.offsetAfterAutoskip&&this.initOffsets(this.ticks.map((e=>+e.value)))}initOffsets(e=[]){let t,n,r=0,i=0;this.options.offset&&e.length&&(t=this.getDecimalForValue(e[0]),r=1===e.length?1-t:(this.getDecimalForValue(e[1])-t)/2,n=this.getDecimalForValue(e[e.length-1]),i=1===e.length?n:(n-this.getDecimalForValue(e[e.length-2]))/2);const o=e.length<3?.5:.25;r=rt(r,0,o),i=rt(i,0,o),this._offsets={start:r,end:i,factor:1/(r+1+i)}}_generate(){const e=this._adapter,t=this.min,n=this.max,r=this.options,i=r.time,o=i.unit||Fs(i.minUnit,t,n,this._getLabelCapacity(t)),a=be(r.ticks.stepSize,1),s="week"===o&&i.isoWeekday,l=Ye(s)||!0===s,c={};let u,d,f=t;if(l&&(f=+e.startOf(f,"isoWeek",s)),f=+e.startOf(f,l?"day":o),e.diff(n,t,o)>1e5*a)throw new Error(t+" and "+n+" are too far apart with stepSize of "+a+" "+o);const m="data"===r.ticks.source&&this.getDataTimestamps();for(u=f,d=0;u<n;u=+e.add(u,a,o),d++)Us(c,u,m);return u!==n&&"ticks"!==r.bounds&&1!==d||Us(c,u,m),Object.keys(c).sort(((e,t)=>e-t)).map((e=>+e))}getLabelForValue(e){const t=this._adapter,n=this.options.time;return n.tooltipFormat?t.format(e,n.tooltipFormat):t.format(e,n.displayFormats.datetime)}_tickFormatFunction(e,t,n,r){const i=this.options,o=i.ticks.callback;if(o)return xe(o,[e,t,n],this);const a=i.time.displayFormats,s=this._unit,l=this._majorUnit,c=s&&a[s],u=l&&a[l],d=n[t],f=l&&u&&d&&d.major;return this._adapter.format(e,r||(f?u:c))}generateTickLabels(e){let t,n,r;for(t=0,n=e.length;t<n;++t)r=e[t],r.label=this._tickFormatFunction(r.value,t,e)}getDecimalForValue(e){return null===e?NaN:(e-this.min)/(this.max-this.min)}getPixelForValue(e){const t=this._offsets,n=this.getDecimalForValue(e);return this.getPixelForDecimal((t.start+n)*t.factor)}getValueForPixel(e){const t=this._offsets,n=this.getDecimalForPixel(e)/t.factor-t.end;return this.min+n*(this.max-this.min)}_getLabelSize(e){const t=this.options.ticks,n=this.ctx.measureText(e).width,r=qe(this.isHorizontal()?t.maxRotation:t.minRotation),i=Math.cos(r),o=Math.sin(r),a=this._resolveTickFontOptions(0).size;return{w:n*i+a*o,h:n*o+a*i}}_getLabelCapacity(e){const t=this.options.time,n=t.displayFormats,r=n[t.unit]||n.millisecond,i=this._tickFormatFunction(e,0,Gs(this,[e],this._majorUnit),r),o=this._getLabelSize(i),a=Math.floor(this.isHorizontal()?this.width/o.w:this.height/o.h)-1;return a>0?a:1}getDataTimestamps(){let e,t,n=this._cache.data||[];if(n.length)return n;const r=this.getMatchingVisibleMetas();if(this._normalized&&r.length)return this._cache.data=r[0].controller.getAllParsedValues(this);for(e=0,t=r.length;e<t;++e)n=n.concat(r[e].controller.getAllParsedValues(this));return this._cache.data=this.normalize(n)}getLabelTimestamps(){const e=this._cache.labels||[];let t,n;if(e.length)return e;const r=this.getLabels();for(t=0,n=r.length;t<n;++t)e.push(Ds(this,r[t]));return this._cache.labels=this._normalized?e:this.normalize(e)}normalize(e){return ut(e.sort(Rs))}}function Vs(e,t,n){let r,i,o,a,s=0,l=e.length-1;n?(t>=e[s].pos&&t<=e[l].pos&&({lo:s,hi:l}=at(e,"pos",t)),({pos:r,time:o}=e[s]),({pos:i,time:a}=e[l])):(t>=e[s].time&&t<=e[l].time&&({lo:s,hi:l}=at(e,"time",t)),({time:r,pos:o}=e[s]),({time:i,pos:a}=e[l]));const c=i-r;return c?o+(a-o)*(t-r)/c:o}var Hs=class extends Bs{static id="timeseries";static defaults=Bs.defaults;constructor(e){super(e),this._table=[],this._minPos=void 0,this._tableRange=void 0}initOffsets(){const e=this._getTimestampsForTable(),t=this._table=this.buildLookupTable(e);this._minPos=Vs(t,this.min),this._tableRange=Vs(t,this.max)-this._minPos,super.initOffsets(e)}buildLookupTable(e){const{min:t,max:n}=this,r=[],i=[];let o,a,s,l,c;for(o=0,a=e.length;o<a;++o)l=e[o],l>=t&&l<=n&&r.push(l);if(r.length<2)return[{time:t,pos:0},{time:n,pos:1}];for(o=0,a=r.length;o<a;++o)c=r[o+1],s=r[o-1],l=r[o],Math.round((c+s)/2)!==l&&i.push({time:l,pos:o/(a-1)});return i}_getTimestampsForTable(){let e=this._cache.all||[];if(e.length)return e;const t=this.getDataTimestamps(),n=this.getLabelTimestamps();return e=t.length&&n.length?this.normalize(t.concat(n)):t.length?t:n,e=this._cache.all=e,e}getDecimalForValue(e){return(Vs(this._table,e)-this._minPos)/this._tableRange}getValueForPixel(e){const t=this._offsets,n=this.getDecimalForPixel(e)/t.factor-t.end;return Vs(this._table,n*this._tableRange+this._minPos,!0)}},Ks=Object.freeze({__proto__:null,CategoryScale:gs,LinearScale:bs,LogarithmicScale:Es,RadialLinearScale:Ls,TimeScale:Bs,TimeSeriesScale:Hs});const Ws=[vi,ga,ds,Ks];var zs=n(611),Ys=n.n(zs);function $s(e,t){return e===t}function qs(e){var t=e.index,n=e.version;return"".concat(t.toFixed(0),":").concat(n.toFixed(0))}function Xs(e){if("string"==typeof e){var t=e.split(":");if(2===t.length){var n=parseInt(t[0]),r=parseInt(t[1]);if(!isNaN(n)&&!isNaN(r))return{index:n,version:r}}}}function Qs(e,t){return e===t||null!=e&&null!=t&&e.index===t.index&&e.version===t.version}function Zs(e){return null==e||0===e.trim().length}var Js=Object.prototype.hasOwnProperty;function el(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:1;if(Object.is(e,t))return!0;if(n<=0||"object"!=typeof e||null===e||"object"!=typeof t||null===t)return!1;var r=Object.keys(e),i=Object.keys(t);if(r.length!==i.length)return!1;for(var o=0;o<r.length;o++)if(!Js.call(t,r[o])||!el(e[r[o]],t[r[o]],n-1))return!1;return!0}function tl(e){if("object"==typeof e&&null!=e){var t=e.length||0===e.length?[]:{},n=!0,r=!1,i=void 0;try{for(var o,a=Object.keys(e).sort((function(e,t){return e.localeCompare(t)}))[Symbol.iterator]();!(n=(o=a.next()).done);n=!0){var s=o.value;t[s]=tl(e[s])}}catch(e){r=!0,i=e}finally{try{n||null==a.return||a.return()}finally{if(r)throw i}}return JSON.stringify(t)}return e}function nl(e){if("object"==typeof e&&null!=e){var t=e.length||0===e.length?[]:{},n=!0,r=!1,i=void 0;try{for(var o,a=Object.keys(e).sort((function(e,t){return e.localeCompare(t)}))[Symbol.iterator]();!(n=(o=a.next()).done);n=!0){var s=o.value;"__Type"!==s&&(t[s]=tl(e[s]))}}catch(e){r=!0,i=e}finally{try{n||null==a.return||a.return()}finally{if(r)throw i}}return JSON.stringify(t)}return e}function rl(e,t){var n=(0,Y.useRef)(e);return t(e,n.current)||(n.current=e),n.current}function il(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function ol(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function al(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function sl(e,t,n){return t&&al(e.prototype,t),n&&al(e,n),e}function ll(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function cl(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||dl(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function ul(e){return function(e){if(Array.isArray(e))return il(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||dl(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/utils/equality.ts",{get defaultEqualityComparer(){return $s},set defaultEqualityComparer(e){$s=e},get entityKey(){return qs},set entityKey(e){qs=e},get parseEntityKey(){return Xs},set parseEntityKey(e){Xs=e},get entityEquals(){return Qs},set entityEquals(e){Qs=e},get isNullOrEmpty(){return Zs},set isNullOrEmpty(e){Zs=e},get shallowEqual(){return el},set shallowEqual(e){el=e},get stringifySorted(){return tl},set stringifySorted(e){tl=e},get stringifySortedIgnoreBindingType(){return nl},set stringifySortedIgnoreBindingType(e){nl=e},get useMemoizedValue(){return rl},set useMemoizedValue(e){rl=e}});function dl(e,t){if(e){if("string"==typeof e)return il(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?il(e,t):void 0}}function fl(e,t,n){return new Sl("".concat(e,".").concat(t),n)}function ml(e){return new Tl(e)}function gl(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:nl;return new Il("".concat(e,".").concat(t),n)}function hl(e,t){return new Al("".concat(e,".").concat(t))}function pl(e,t){var n="".concat(e,".").concat(t);return function(){return Ys().trigger(n)}}function vl(e,t){var n,r="".concat(e,".").concat(t);return function(){for(var e=arguments.length,t=new Array(e),i=0;i<e;i++)t[i]=arguments[i];return(n=Ys()).trigger.apply(n,[r].concat(ul(t)))}}function bl(e,t){for(var n=arguments.length,r=new Array(n>2?n-2:0),i=2;i<n;i++)r[i-2]=arguments[i];var o;(o=Ys()).trigger.apply(o,["".concat(e,".").concat(t)].concat(ul(r)))}function yl(e,t){for(var n=arguments.length,r=new Array(n>2?n-2:0),i=2;i<n;i++)r[i-2]=arguments[i];var o;return(o=Ys()).call.apply(o,["".concat(e,".").concat(t)].concat(ul(r)))}function xl(e){var t=(0,Y.useMemo)((function(){return e.subscribe()}),[e]),n=cl((0,Y.useState)(t.value),2),r=n[0],i=n[1];return(0,Y.useEffect)((function(){return i(t.value),t.setChangeListener(i),function(){return t.dispose()}}),[t]),r}function _l(e,t,n){var r=(0,Y.useMemo)((function(){return e.subscribe()}),[e]),i=cl((0,Y.useReducer)(t,t(n,r.value)),2),o=i[0],a=i[1];return(0,Y.useEffect)((function(){return a(r.value),r.setChangeListener(a),function(){return r.dispose()}}),[r,t]),o}function jl(e){var t=(0,Y.useMemo)((function(){return e.subscribe()}),[e]),n=(0,Y.useRef)(t.value);return(0,Y.useEffect)((function(){return n.current=t.value,t.setChangeListener((function(e){n.current=e})),function(){return t.dispose()}}),[t]),n}function Ol(e,t){var n=(0,Y.useMemo)((function(){return e.subscribe(t)}),[e,t]),r=cl((0,Y.useState)(n.value),2),i=r[0],o=r[1];return(0,Y.useEffect)((function(){return o(n.value),n.setChangeListener(o),function(){return n.dispose()}}),[n]),i}function El(e,t){var n=(0,Y.useMemo)((function(){return t.map((function(t){return e.subscribe(t)}))}),[e,t]),r=cl((0,Y.useState)(ul(n.map((function(e){return e.value})))),2),i=r[0],o=r[1],a=(0,Y.useCallback)((function(){o(ul(n.map((function(e){return e.value}))))}),[n]);return(0,Y.useEffect)((function(){return o(ul(n.map((function(e){return e.value})))),n.map((function(e){return e.setChangeListener(a)})),function(){n.map((function(e){return e.dispose()}))}}),[n,a]),i}var Sl=function(){function e(t,n){var r=this;ol(this,e),this.fallbackValue=n,this.listeners=[],this.connections=null,this.disposed=!1,this._value=void 0,this.subscribe=function(e){if(r.disposed)throw new Error("cannot subscribe to a disposed binding!");r.connect();var t=new wl(e);r.listeners.push(t);var n=r;return{get value(){return n.getValueUnsafe()},setChangeListener:t.set,dispose:function(){var e=n.listeners.indexOf(t);-1!==e&&(n.listeners.splice(e,1),0===n.listeners.length&&n.disconnect())}}},this.dispose=function(){r.disposed=!0,r.listeners.splice(0,r.listeners.length),r.disconnect()},this.onUpdate=function(e){if(e!==r._value){r._value=e;var t=!0,n=!1,i=void 0;try{for(var o,a=r.listeners[Symbol.iterator]();!(t=(o=a.next()).done);t=!0){o.value.call(e)}}catch(e){n=!0,i=e}finally{try{t||null==a.return||a.return()}finally{if(n)throw i}}}},this.onPatch=function(e,t){if(0===e.length)r.onUpdate(t);else{if(!Cl(r._value))throw new Error("cannot patch object of type ".concat(null!=r._value?(l=r._value)&&"undefined"!=typeof Symbol&&l.constructor===Symbol?"symbol":typeof l:r._value,"!"));for(var n=Pl(r._value),i=n,o=0;o<e.length-1;o++){var a=e[o],s=i[a];if(!Cl(s))throw new Error("'".concat(e.slice(0,o+1).join("->"),"' is not a container"));i[a]=Pl(s),i=i[a]}i[e[e.length-1]]=t,r.onUpdate(n)}var l},this.subscribeTrigger="".concat(t,".subscribe"),this.unsubscribeTrigger="".concat(t,".unsubscribe"),this.updateTrigger="".concat(t,".update"),this.patchTrigger="".concat(t,".patch"),this._value=n}var t=e.prototype;return t.connect=function(){if(null==this.connections&&(this.connections=[Ys().on(this.updateTrigger,this.onUpdate),Ys().on(this.patchTrigger,this.onPatch)],Ys().trigger(this.subscribeTrigger),void 0===this._value))throw new Error("'".concat(this.updateTrigger,"' was not called after subscribe!\nDid you forget to add the binding on the C# side?"))},t.disconnect=function(){if(null!=this.connections){var e=!0,t=!1,n=void 0;try{for(var r,i=this.connections[Symbol.iterator]();!(e=(r=i.next()).done);e=!0){r.value.clear()}}catch(e){t=!0,n=e}finally{try{e||null==i.return||i.return()}finally{if(t)throw n}}this.connections=null,Ys().trigger(this.unsubscribeTrigger),this._value=this.fallbackValue}},t.getValueUnsafe=function(){if(void 0===this._value)throw new Error("'".concat(this.updateTrigger,"' was not called before getValueUnsafe!"));return this._value},sl(e,[{key:"value",get:function(){if(null!=this.connections)return this.getValueUnsafe();this.connect();var e=this.getValueUnsafe();return this.disconnect(),e}}]),e}(),Tl=function(){function e(t){var n=this;ol(this,e),this.listeners=[],this.disposed=!1,this.subscribe=function(e){if(n.disposed)throw new Error("cannot subscribe to a disposed binding!");var t=new wl(e);n.listeners.push(t);var r=n;return{get value(){return r._value},setChangeListener:t.set,dispose:function(){var e=r.listeners.indexOf(t);-1!==e&&r.listeners.splice(e,1)}}},this.dispose=function(){n.disposed=!0,n.listeners.splice(0,n.listeners.length)},this.update=function(e){if(e!==n._value){n._value=e;var t=!0,r=!1,i=void 0;try{for(var o,a=n.listeners[Symbol.iterator]();!(t=(o=a.next()).done);t=!0){o.value.call(e)}}catch(e){r=!0,i=e}finally{try{t||null==a.return||a.return()}finally{if(r)throw i}}}},this._value=t}return sl(e,[{key:"registered",get:function(){return!0}},{key:"value",get:function(){return this._value}}]),e}(),Il=function(){function e(t,n){var r=this;ol(this,e),this.keyStringifier=n,this.entries=new Map,this.updateConnection=null,this.disposed=!1,this.getValue=function(e){var t=r.getConnection(e);if(null!=t)return r.getValueUnsafe(t);var n=r.connect(e),i=r.getValueUnsafe(n);return r.disconnect(e),i},this.subscribe=function(e,t){if(r.disposed)throw new Error("cannot subscribe to a disposed binding!");var n=r.connect(e),i=new wl(t);n.listeners.push(i);var o=r;return{get value(){return o.getValueUnsafe(n)},setChangeListener:i.set,dispose:function(){var t=n.listeners.indexOf(i);-1!==t&&(n.listeners.splice(t,1),0===n.listeners.length&&o.disconnect(e))}}},this.dispose=function(){r.disposed=!0,r.disconnectAll()},this.onUpdate=function(e,t){var n=r.getConnection(e);if(null!=n){if(t!==n.value){n.value=t;var i=!0,o=!1,a=void 0;try{for(var s,l=n.listeners[Symbol.iterator]();!(i=(s=l.next()).done);i=!0){s.value.call(t)}}catch(e){o=!0,a=e}finally{try{i||null==l.return||l.return()}finally{if(o)throw a}}}}else console.warn("'".concat(r.updateTrigger,"' was called on already unsubscribed key!"))},this.subscribeTrigger="".concat(t,".subscribeMapEntry"),this.unsubscribeTrigger="".concat(t,".unsubscribeMapEntry"),this.updateTrigger="".concat(t,".updateMapEntry")}var t=e.prototype;return t.getConnection=function(e){var t=this.keyStringifier(e);return this.entries.get(t)},t.connect=function(e){var t=this.keyStringifier(e),n=this.entries.get(t);if(null!=n)return n;if(null==this.updateConnection&&(this.updateConnection=Ys().on(this.updateTrigger,this.onUpdate)),n={key:e,value:void 0,listeners:[]},this.entries.set(t,n),Ys().trigger(this.subscribeTrigger,e),void 0===n.value)throw new Error("'".concat(this.updateTrigger,"' was not called after subscribing the key '").concat(t,"'!\nDid you forget to add the binding on the C# side?"));return n},t.disconnectAll=function(){var e=!0,t=!1,n=void 0;try{for(var r,i=this.entries.values()[Symbol.iterator]();!(e=(r=i.next()).done);e=!0){var o=r.value;Ys().trigger(this.unsubscribeTrigger,o.key)}}catch(e){t=!0,n=e}finally{try{e||null==i.return||i.return()}finally{if(t)throw n}}this.entries.clear(),null!=this.updateConnection&&(this.updateConnection.clear(),this.updateConnection=null)},t.disconnect=function(e){var t=this.keyStringifier(e);null!=this.entries.get(t)&&(this.entries.delete(t),0===this.entries.size&&null!=this.updateConnection&&(this.updateConnection.clear(),this.updateConnection=null),Ys().trigger(this.unsubscribeTrigger,e))},t.getValueUnsafe=function(e){if(void 0===e.value)throw new Error("'".concat(this.updateTrigger,"' was not called before getValueUnsafe!"));return e.value},e}(),wl=function e(t){var n=this;ol(this,e),this.listener=t,this.set=function(e){n.listener=e},this.call=function(e){null!=n.listener&&n.listener(e)}};function Pl(e){return Array.isArray(e)?ul(e):function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){ll(e,t,n[t])}))}return e}({},e)}function Cl(e){return null!=e&&"object"==typeof e}var Nl,Al=function(){function e(t){var n=this;ol(this,e),this.listeners=[],this.updateConnection=null,this.disposed=!1,this.subscribe=function(e){if(n.disposed)throw new Error("cannot subscribe to a disposed binding!");return n.listeners.includes(e)||n.listeners.push(e),n.subscribeValue(),{dispose:function(){var t=n.listeners.indexOf(e);-1!==t&&(n.listeners.splice(t,1),0===n.listeners.length&&n.unsubscribeValue())}}},this.dispose=function(){n.disposed=!0,n.listeners.splice(0,n.listeners.length),n.unsubscribeValue()},this.onUpdate=function(e){var t=!0,r=!1,i=void 0;try{for(var o,a=n.listeners[Symbol.iterator]();!(t=(o=a.next()).done);t=!0){(0,o.value)(e)}}catch(e){r=!0,i=e}finally{try{t||null==a.return||a.return()}finally{if(r)throw i}}},this.subscribeTrigger="".concat(t,".subscribe"),this.unsubscribeTrigger="".concat(t,".unsubscribe"),this.updateTrigger="".concat(t,".update")}var t=e.prototype;return t.subscribeValue=function(){null==this.updateConnection&&(this.updateConnection=Ys().on(this.updateTrigger,this.onUpdate),Ys().trigger(this.subscribeTrigger))},t.unsubscribeValue=function(){null!=this.updateConnection&&(this.updateConnection.clear(),this.updateConnection=null,Ys().trigger(this.unsubscribeTrigger))},e}();function Ll(e,t){return e.replace(/{((?!\d)[\w$]+)}/g,(function(e,n){var r=t[n];return"string"==typeof r?r:e}))}oe.add("game-ui/common/data-binding/binding.ts",{get bindValue(){return fl},set bindValue(e){fl=e},get bindLocalValue(){return ml},set bindLocalValue(e){ml=e},get bindMap(){return gl},set bindMap(e){gl=e},get bindEvent(){return hl},set bindEvent(e){hl=e},get bindTrigger(){return pl},set bindTrigger(e){pl=e},get bindTriggerWithArgs(){return vl},set bindTriggerWithArgs(e){vl=e},get trigger(){return bl},set trigger(e){bl=e},get call(){return yl},set call(e){yl=e},get useValue(){return xl},set useValue(e){xl=e},get useReducedValue(){return _l},set useReducedValue(e){_l=e},get useValueRef(){return jl},set useValueRef(e){jl=e},get useMapValue(){return Ol},set useMapValue(e){Ol=e},get useMapValues(){return El},set useMapValues(e){El=e}}),oe.add("game-ui/api/index.ts",{}),oe.add("game-ui/common/utils/substitute.ts",{get substitute(){return Ll},set substitute(e){Ll=e}}),function(e){e.ButtonWithConfirmation="Game.UI.Menu.ButtonWithConfirmation",e.InputBindingField="Game.UI.Menu.InputBindingField",e.ScreenResolutionDropdownField="Game.UI.Menu.ScreenResolutionDropdownField",e.DropdownField="Game.UI.Widgets.DropdownField",e.ModdingToolchainButton="Game.UI.Menu.ModdingToolchainButton",e.ModdingToolchainDependency="Game.UI.Menu.ModdingToolchainDependency"}(Nl||(Nl={}));var Ml,kl,Rl,Dl,Fl,Ul,Gl="options",Bl=fl(Gl,"pages"),Vl=fl(Gl,"children"),Hl=fl(Gl,"activePage"),Kl=fl(Gl,"activeSection"),Wl=fl(Gl,"displayConfirmationVisible"),zl=fl(Gl,"displayConfirmationTime"),Yl=fl(Gl,"interfaceStyle"),$l=fl(Gl,"interfaceTransparency"),ql=fl(Gl,"interfaceScaling",!0),Xl=fl(Gl,"textScale"),Ql=fl(Gl,"unlockHighlightsEnabled"),Zl=fl(Gl,"chirperPopupsEnabled"),Jl=fl(Gl,"inputHintsType"),ec=(fl(Gl,"radioVolume"),fl(Gl,"progress")),tc=fl(Gl,"progressType"),nc=fl(Gl,"moddingToolState"),rc=fl(Gl,"buttonState"),ic=fl(Gl,"unitSettings");function oc(e){bl(e.group,"rebindInput",e.path)}function ac(e){bl(e.group,"unsetInputBinding",e.path)}function sc(e,t){bl(Gl,"selectPage",e,t,arguments.length>2&&void 0!==arguments[2]&&arguments[2])}function lc(e,t){bl(Gl,"filteredWidgets",e,t||null)}function cc(e,t){bl("options","dependencyAction",e.path,t)}!function(e){e[e.Off=0]="Off",e[e.Bar=1]="Bar",e[e.Spin=2]="Spin"}(Ml||(Ml={})),function(e){e[e.AutoDetect=0]="AutoDetect",e[e.Xbox=1]="Xbox",e[e.PS=2]="PS"}(kl||(kl={})),function(e){e[e.Idle=0]="Idle",e[e.Downloading=1]="Downloading",e[e.Installing=2]="Installing",e[e.WaitingForLicense=3]="WaitingForLicense",e[e.WaitingForClose=4]="WaitingForClose",e[e.Updating=5]="Updating",e[e.Uninstalling=6]="Uninstalling",e[e.NotEnoughSpaceError=7]="NotEnoughSpaceError",e[e.DownloadError=8]="DownloadError",e[e.InstallError=9]="InstallError",e[e.GetLicenseError=10]="GetLicenseError",e[e.CloseError=11]="CloseError",e[e.DeployError=12]="DeployError",e[e.UnistallError=13]="UnistallError"}(Rl||(Rl={})),function(e){e[e.Install=0]="Install",e[e.Uninstall=1]="Uninstall",e[e.Update=2]="Update",e[e.Repair=3]="Repair",e[e.Cancel=4]="Cancel"}(Dl||(Dl={})),function(e){e[e.None=0]="None",e[e.Install=2]="Install",e[e.Update=4]="Update",e[e.Repair=8]="Repair",e[e.Uninstall=16]="Uninstall"}(Fl||(Fl={})),function(e){e[e.Unknown=-1]="Unknown",e[e.Installed=0]="Installed",e[e.NotInstalled=1]="NotInstalled",e[e.Outdated=2]="Outdated",e[e.Installing=3]="Installing",e[e.Downloading=4]="Downloading",e[e.Removing=5]="Removing",e[e.Queued=6]="Queued"}(Ul||(Ul={}));var uc,dc,fc,mc=pl(Gl,"confirmDisplay"),gc=pl(Gl,"revertDisplay");!function(e){e[e.TwentyFourHours=0]="TwentyFourHours",e[e.TwelveHours=1]="TwelveHours"}(uc||(uc={})),function(e){e[e.Celsius=0]="Celsius",e[e.Fahrenheit=1]="Fahrenheit",e[e.Kelvin=2]="Kelvin"}(dc||(dc={})),function(e){e[e.Metric=0]="Metric",e[e.Freedom=1]="Freedom"}(fc||(fc={}));var hc={timeFormat:uc.TwentyFourHours,temperatureUnit:dc.Celsius,unitSystem:fc.Metric};oe.add("game-ui/menu/data-binding/options-bindings.ts",{get OptionsWidgetType(){return Nl},set OptionsWidgetType(e){Nl=e},get pages(){return pages},set pages(e){pages=e},get optionsWidgets(){return optionsWidgets},set optionsWidgets(e){optionsWidgets=e},get selectedPage(){return selectedPage},set selectedPage(e){selectedPage=e},get selectedSection(){return selectedSection},set selectedSection(e){selectedSection=e},get displayConfirmationVisible(){return displayConfirmationVisible},set displayConfirmationVisible(e){displayConfirmationVisible=e},get displayConfirmationTime(){return displayConfirmationTime},set displayConfirmationTime(e){displayConfirmationTime=e},get interfaceStyle(){return interfaceStyle},set interfaceStyle(e){interfaceStyle=e},get interfaceTransparency(){return interfaceTransparency},set interfaceTransparency(e){interfaceTransparency=e},get interfaceScaling(){return interfaceScaling},set interfaceScaling(e){interfaceScaling=e},get textScale(){return textScale},set textScale(e){textScale=e},get unlockHighlightsEnabled(){return unlockHighlightsEnabled},set unlockHighlightsEnabled(e){unlockHighlightsEnabled=e},get chirperPopupsEnabled(){return chirperPopupsEnabled},set chirperPopupsEnabled(e){chirperPopupsEnabled=e},get inputHintsType(){return inputHintsType},set inputHintsType(e){inputHintsType=e},get radioVolume(){return radioVolume},set radioVolume(e){radioVolume=e},get moddingToolProgress(){return moddingToolProgress},set moddingToolProgress(e){moddingToolProgress=e},get moddingToolProgressType(){return moddingToolProgressType},set moddingToolProgressType(e){moddingToolProgressType=e},get moddingToolState(){return moddingToolState},set moddingToolState(e){moddingToolState=e},get moddingToolButtonState(){return moddingToolButtonState},set moddingToolButtonState(e){moddingToolButtonState=e},get unitSettings(){return unitSettings},set unitSettings(e){unitSettings=e},get rebindInput(){return oc},set rebindInput(e){oc=e},get unsetInputBinding(){return ac},set unsetInputBinding(e){ac=e},get selectPage(){return sc},set selectPage(e){sc=e},get filteredWidgets(){return lc},set filteredWidgets(e){lc=e},get dependencyAction(){return cc},set dependencyAction(e){cc=e},get ProgressType(){return Ml},set ProgressType(e){Ml=e},get InputHintsType(){return kl},set InputHintsType(e){kl=e},get ModdingToolchainStatus(){return Rl},set ModdingToolchainStatus(e){Rl=e},get ModdingToolchainButtonState(){return Dl},set ModdingToolchainButtonState(e){Dl=e},get ModdingToolchainDeploymentAction(){return Fl},set ModdingToolchainDeploymentAction(e){Fl=e},get ModdingToolchainDependencyState(){return Ul},set ModdingToolchainDependencyState(e){Ul=e},get confirmDisplay(){return mc},set confirmDisplay(e){mc=e},get revertDisplay(){return gc},set revertDisplay(e){gc=e},get TimeFormat(){return uc},set TimeFormat(e){uc=e},get TemperatureUnit(){return dc},set TemperatureUnit(e){dc=e},get UnitSystem(){return fc},set UnitSystem(e){fc=e},get defaultUnitSettings(){return hc},set defaultUnitSettings(e){hc=e}});var pc=(0,Y.createContext)({translate:function(){return null},unitSettings:hc});function vc(){var e=(0,Y.useContext)(pc),t=(0,Y.useRef)(!0);return t.current=!0,(0,Y.useMemo)((function(){var n=new Map;return{translate:function(r,i){var o=n.get(r);return void 0===o&&(t.current&&(t.current=!1,n.clear()),o=e.translate(r,i),n.set(r,o)),o},unitSettings:e.unitSettings}}),[e])}function bc(e){var t=vc(),n=rl(e,xc);return(0,Y.useMemo)((function(){return yc(t,n)}),[t,n])}function yc(e,t,n){return null==t?"":(0,Y.isValidElement)(t)?_c(t.type)?t.type.renderString(e,t.props):function(e){return e.type===Y.Fragment}(t)?Y.Children.toArray(t.props.children).map((function(t){return yc(e,t,n)})).join(n):"[".concat((r=t.type,null!==(o=null!==(i=r.displayName)&&void 0!==i?i:r.name)&&void 0!==o?o:String(r)),"/]"):String(t);var r,i,o}function xc(e,t){return(0,Y.isValidElement)(e)&&(0,Y.isValidElement)(t)&&_c(e.type)&&_c(t.type)?e.type.propsAreEqual(e.props,t.props):Object.is(e,t)}function _c(e){return"function"==typeof e.renderString&&"function"==typeof e.propsAreEqual}function jc(e,t,n){var r=function(e){var n=vc(),r=(0,Y.useMemo)((function(){return t(n,e)}),[n,e]);return(0,z.jsx)(z.Fragment,{children:r})};return Object.assign((0,Y.memo)(r,n),{displayName:e,renderString:t,propsAreEqual:n})}oe.add("game-ui/common/localization/localization.tsx",{get LocalizationContext(){return pc},set LocalizationContext(e){pc=e},get useCachedLocalization(){return vc},set useCachedLocalization(e){vc=e}}),oe.add("game-ui/common/localization/loc-component.tsx",{get useTranslation(){return bc},set useTranslation(e){bc=e},get renderLocElement(){return yc},set renderLocElement(e){yc=e},get areLocElementsEqual(){return xc},set areLocElementsEqual(e){xc=e},get createLocComponent(){return jc},set createLocComponent(e){jc=e}});var Oc,Ec="l10n";!function(e){e[e.None=0]="None",e[e.Id=1]="Id",e[e.Fallback=2]="Fallback"}(Oc||(Oc={}));var Sc,Tc=fl(Ec,"locales"),Ic=fl(Ec,"debugMode",Oc.None),wc=hl(Ec,"activeDictionaryChanged"),Pc=gl(Ec,"indexCounts");function Cc(e){bl(Ec,"selectLocale",e)}function Nc(e){return{__Type:Sc.String,id:e,value:null,args:null}}function Ac(e){return{__Type:Sc.String,id:null,value:e,args:null}}function Lc(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Mc(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Lc(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Lc(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}!function(e){e.Bounds="Game.UI.Localization.LocalizedBounds",e.Fraction="Game.UI.Localization.LocalizedFraction",e.Number="Game.UI.Localization.LocalizedNumber",e.String="Game.UI.Localization.LocalizedString"}(Sc||(Sc={})),oe.add("game-ui/common/localization/localization-bindings.ts",{get LocalizationDebugMode(){return Oc},set LocalizationDebugMode(e){Oc=e},get locales(){return locales},set locales(e){locales=e},get debugMode(){return debugMode},set debugMode(e){debugMode=e},get activeDictionaryChanged(){return activeDictionaryChanged},set activeDictionaryChanged(e){activeDictionaryChanged=e},get indexCounts(){return indexCounts},set indexCounts(e){indexCounts=e},get selectLocale(){return Cc},set selectLocale(e){Cc=e},get LocElementType(){return Sc},set LocElementType(e){Sc=e},get locStrId(){return Nc},set locStrId(e){Nc=e},get locStrValue(){return Ac},set locStrValue(e){Ac=e}});var kc=jc("LocalizedString",(function(e,t){return Rc(e,t.id,t.fallback,t.args)}),(function(e,t){return e.id===t.id&&e.fallback===t.fallback&&function(e,t){if(Object.is(e,t))return!0;if(null==e||null==t)return e===t;var n=Object.keys(e),r=Object.keys(t);if(n.length!==r.length)return!1;return n.every((function(n){return Object.prototype.hasOwnProperty.call(t,n)&&xc(e[n],t[n])}))}(e.args,t.args)}));function Rc(e,t,n,r){var i,o=null!=t?null!==(i=e.translate(t,n))&&void 0!==i?i:t:null!=n?n:"";if(null!=r){var a=function(e,t){return Object.fromEntries(Object.entries(t).map((function(t){var n=Mc(t,2),r=n[0],i=n[1];return[r,yc(e,i)]})))}(e,r);return Ll(o,a)}return o}function Dc(e,t,n){return!!Object.is(t,n)||e.every((function(e){return xc(t[e],n[e])}))}function Fc(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Uc(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function Gc(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function Bc(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Fc(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Fc(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Vc(e){var t=Object.entries(e).map((function(e){var t=Bc(e,2),n=t[0];return[n,Hc(n,t[1])]}));return Object.fromEntries(t)}function Hc(e,t){var n=Object.entries(t).map((function(t){var n=Bc(t,2),r=n[0],i=n[1],o="".concat(e,".").concat(r);return[r,jc(o,i.create(o),i.propsAreEqual.bind(i))]}));return Object.fromEntries(n)}oe.add("game-ui/common/localization/localized-string.tsx",{get LocalizedString(){return kc},set LocalizedString(e){kc=e},get renderLocalizedString(){return Rc},set renderLocalizedString(e){Rc=e},get areArgsEqual(){return Dc},set areArgsEqual(e){Dc=e}});var Kc=function(){function e(){for(var t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];Uc(this,e),this.argNames=n}var t=e.prototype;return t.create=function(e){return function(t,n){var r=n.fallback,i=Gc(n,["fallback"]);return Rc(t,e,r,i)}},t.propsAreEqual=function(e,t){return void 0!==e&&void 0!==t?Dc(this.argNames,e,t):e===t},e}(),Wc=function(){function e(){for(var t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];Uc(this,e),this.argNames=n}var t=e.prototype;return t.create=function(e){return function(t,n){var r=n.hash,i=n.fallback,o=Gc(n,["hash","fallback"]);return Rc(t,"".concat(e,"[").concat(r,"]"),i,o)}},t.propsAreEqual=function(e,t){return e.hash===t.hash&&Dc(this.argNames,e,t)},e}(),zc=function(){function e(){for(var t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];Uc(this,e),this.argNames=n}var t=e.prototype;return t.create=function(e){return function(t,n){var r=n.index,i=n.fallback,o=Gc(n,["index","fallback"]);return Rc(t,"".concat(e,":").concat(r),i,o)}},t.propsAreEqual=function(e,t){return e.index===t.index&&Dc(this.argNames,e,t)},e}(),Yc=function(){function e(){for(var t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];Uc(this,e),this.argNames=n}var t=e.prototype;return t.create=function(e){return function(t,n){var r=n.hash,i=n.index,o=n.fallback,a=Gc(n,["hash","index","fallback"]);return Rc(t,"".concat(e,"[").concat(r,"]:").concat(i),o,a)}},t.propsAreEqual=function(e,t){return e.hash===t.hash&&e.index===t.index&&Dc(this.argNames,e,t)},e}();oe.add("game-ui/common/localization/loc-dictionary.tsx",{get createLocDictionary(){return Vc},set createLocDictionary(e){Vc=e},get Single(){return Kc},set Single(e){Kc=e},get Hashed(){return Wc},set Hashed(e){Wc=e},get Indexed(){return zc},set Indexed(e){zc=e},get HashedIndexed(){return Yc},set HashedIndexed(e){Yc=e}});var $c,qc=Vc({Achievements:{DESCRIPTION:new Wc,TITLE:new Wc},AirPollutionInfoPanel:{AVERAGE_AIR_POLLUTION:new Kc},AnimationCurve:{TIME_LABEL:new Kc,VALUE_LABEL:new Kc},Asset:{DESCRIPTION:new Wc,NAME:new Wc},Assets:{ADDRESS_NAME_FORMAT:new Kc("NUMBER","ROAD"),ALLEY_NAME:new zc,ANIMAL_NAME_DOG:new zc,BIOME:new Wc,BRIDGE_NAME:new zc,CITIZEN_NAME_FEMALE:new zc,CITIZEN_NAME_FORMAT:new Kc("FIRST_NAME","LAST_NAME"),CITIZEN_NAME_MALE:new zc,CITIZEN_SURNAME_FEMALE:new zc,CITIZEN_SURNAME_HOUSEHOLD:new zc,CITIZEN_SURNAME_MALE:new zc,CITY_NAME:new zc,CLIMATE:new Wc,DAM_NAME:new zc,DESCRIPTION:new Wc,DISTRICT_NAME:new zc,DISTRICT_NAME_NEW:new Kc,HIGHWAY_NAME:new zc,NAME:new Wc,NAMED_ADDRESS_NAME_FORMAT:new Kc("NAME","NUMBER","ROAD"),ROUTE_NAME:new Wc("NUMBER"),STREET_NAME:new zc,SUB_SERVICE_DESCRIPTION:new Wc,THEME:new Wc,UPGRADE_DESCRIPTION:new Wc,UPGRADE_NAME:new Wc},Budget:{TOOLTIP_DESCRIPTION:new Wc,TOOLTIP_DESCRIPTION_TAX:new Wc,TOOLTIP_DESCRIPTION_TAX_RATE:new Kc,TOOLTIP_TITLE:new Wc,TOOLTIP_TITLE_TAX:new Wc,TOOLTIP_TITLE_TAX_RATE:new Kc,TOOLTIP_UPKEEPS_PIECHART:new Kc},Chirper:{AIR_POLLUTION_HIGH:new zc,AIR_POLLUTION_NEGATIVE:new zc,AURORA_BOREALIS:new zc,BIRTH_RATE_DOWN:new zc,BIRTH_RATE_UP:new zc,BRAND:new Yc,BRAND_RENTED_AGRICULTURE:new zc("LINK_1"),BRAND_RENTED_BANK:new zc("LINK_1"),BRAND_RENTED_BAR:new zc("LINK_1"),BRAND_RENTED_FACTORY:new zc("LINK_1"),BRAND_RENTED_FORESTRY:new zc("LINK_1"),BRAND_RENTED_GAS_STATION:new zc("LINK_1"),BRAND_RENTED_HOTEL:new zc("LINK_1"),BRAND_RENTED_MINE:new zc("LINK_1"),BRAND_RENTED_OFFICE:new zc("LINK_1"),BRAND_RENTED_OIL:new zc("LINK_1"),BRAND_RENTED_RESTAURANT:new zc("LINK_1"),BRAND_RENTED_STORE:new zc("LINK_1"),BRAND_RENTED_WAREHOUSE:new zc("LINK_1"),CITY_SERVICE_EDUCATION_EXPORT:new zc,CITY_SERVICE_EDUCATION_IMPORT:new zc,CITY_SERVICE_ELECTRICITY_EXPORT:new zc,CITY_SERVICE_ELECTRICITY_IMPORT:new zc,CITY_SERVICE_FIRE_RESCUE_EXPORT:new zc,CITY_SERVICE_FIRE_RESCUE_IMPORT:new zc,CITY_SERVICE_GARBAGE_IMPORT:new zc,CITY_SERVICE_HEALTHCARE_EXPORT:new zc,CITY_SERVICE_HEALTHCARE_IMPORT:new zc,CITY_SERVICE_POLICE_EXPORT:new zc,CITY_SERVICE_POLICE_IMPORT:new zc,CITY_SERVICE_POST_EXPORT:new zc,CITY_SERVICE_POST_IMPORT:new zc,CITY_SERVICE_WATER_SEWAGE_EXPORT:new zc,CITY_SERVICE_WATER_SEWAGE_IMPORT:new zc,COMMERCIAL_LEVEL_DOWN:new zc,COMMERCIAL_LEVEL_UP:new zc,CRIME_NEGATIVE:new zc,CRIME_RATE_HIGH:new zc,DIRTY_WATER:new zc,ELECTRICITY_BLACKOUTS:new zc,FIRST_POWER_PLANT:new zc("LINK_TARGET_0"),GARBAGE_PILING_UP:new zc,GOOD_EDUCATION_SERVICE:new zc,GOOD_WELFARE_SERVICE_COVERAGE:new zc,GROUND_POLLUTION_NEGATIVE:new zc,HIGHEST_TEMP_15:new zc,HIGHEST_TEMP_NEG_15:new zc,HIGH_DEATH_RATE:new zc,HOUSING_SHORTAGE:new zc,INDUSTRIAL_LEVEL_DOWN:new zc,INDUSTRIAL_LEVEL_UP:new zc,LEISURE_TIME_NEGATIVE:new zc,LEISURE_TIME_POSITIVE:new zc,LOWEST_TEMP_15:new zc,LOWEST_TEMP_20:new zc,LOW_DEATH_RATE:new zc,LOW_HEALTH:new zc,LOW_NUMBER_OF_WORKERS:new zc,LOW_WELLBEING:new zc,MOSTLY_CLOUDY_WEATHER:new zc,MOSTLY_RAINY_WEATHER:new zc,MOSTLY_SNOWY_WEATHER:new zc,MOSTLY_STORMY_WEATHER:new zc,MOSTLY_SUNNY_WEATHER:new zc,NOISE_POLLUTION:new zc,NOISE_POLLUTION_NEGATIVE:new zc,NO_ELECTRICITY:new zc,NO_WATER:new zc,NO_WATER_SERVICE:new zc,OFFICE_LEVEL_DOWN:new zc,OFFICE_LEVEL_UP:new zc,OPENING_MESSAGE:new Kc,PANEL_TITLE:new Kc,PARK_COVERAGE:new zc,POLICE_CRIME_RATE_HIGH:new zc,POLICIES:new Yc,POLICIES_SERVICE:new Yc,POOR_EDUCATION_SERVICE:new zc,RELIABLE_ELECTRICITY_SUPPLY:new zc,RELIABLE_HEALTHCARE:new zc,RELIABLE_INTERNET_SERVICE:new zc,RELIABLE_POST_SERVICE:new zc,RESIDENTIAL_LEVEL_DOWN:new zc,RESIDENTIAL_LEVEL_UP:new zc,SERVICES_CITIZEN:new Yc,SERVICES_COMMUNICATIONS:new Yc,SERVICES_ELECTRICITY:new Yc,SERVICES_GARBAGE:new Yc,SERVICES_ROADS:new Yc,SERVICES_TRANSPORTATION:new Yc,SERVICES_WATER:new Yc,SEWAGE_NEGATIVE:new zc,SMALL_HOME:new zc,STORAGES_FILLING_UP:new zc,TEMPERATURE_COLDER:new zc,TOURISM_DOWN_20:new zc,TOURISM_UP_20:new zc,TRAFFIC_ACCIDENT_NEARBY:new zc,TRAFFIC_JAMS:new zc,UNCONNECTED_CITY:new zc,UNEMPLOYMENT_RATE_HIGH:new zc,UNPAID_LOAN:new zc,UNRELIABLE_ELECTRICITY_SUPPLY:new zc,UNRELIABLE_HEALTHCARE:new zc,UNRELIABLE_INTERNET_SERVICE:new zc,UNRELIABLE_POST_SERVICE:new zc,VALENTINE_DAY:new zc,WATER_NEGATIVE_SERVICE_COVERAGE:new zc,WATER_POLLUTION_NEGATIVE:new zc},CinematicCamera:{CAPTURE:new Kc,DELETE_DISCLAIMER:new Kc("NAME"),DELETE_KEY:new Kc,DELETE_TOOLTIP:new Kc,FOCAL_LENGTH:new Kc,HIDE_UI:new Kc,KEY_FORMAT:new Kc("KEY"),LOAD:new Kc,LOAD_TOOLTIP:new Kc,LOOP:new Kc,NEW_SEQUENCE_PLACEHOLDER:new Kc,OVERRIDE_DISCLAIMER:new Kc("NAME"),PLAYBACK_DURATION:new Kc,RESET_TOOLTIP:new Kc,SAVE:new Kc,SAVE_LOAD_TOOLTIP:new Kc,SAVE_TOOLTIP:new Kc,SEGMENT_DURATION:new Kc,SIMULATION_SPEED:new Kc,TITLE:new Kc,UNSAVED_DISCLAIMER:new Kc},CityInfoPanel:{DEMAND_DESCRIPTION:new Wc,DEMAND_FACTOR:new Wc,DEMAND_FACTOR_NEGATIVE:new Wc,DEMAND_FACTOR_POSITIVE:new Wc,DEMAND_TITLE:new Wc,HAPPINESS:new Kc,TAB:new Wc,TITLE:new Kc,TOOLTIP_DESCRIPTION_DEMAND:new Wc,TOOLTIP_HAPPINESS_DESCRIPTION:new Kc,TOOLTIP_HAPPINESS_TITLE:new Kc,TOOLTIP_POLICIES_DESCRIPTION:new Kc,TOOLTIP_POLICIES_TITLE:new Kc,TOOLTIP_TITLE_DEMAND:new Wc},Climate:{SEASON:new Wc},Common:{ACTION:new Wc,BOUNDS_CELSIUS:new Kc("MIN","MAX"),BOUNDS_FAHRENHEIT:new Kc("MIN","MAX"),BOUNDS_KELVIN:new Kc("MIN","MAX"),BOUNDS_KILOWATT:new Kc("MIN","MAX"),BOUNDS_MEGAWATT:new Kc("MIN","MAX"),BOUNDS_PERCENT:new Kc("MIN","MAX"),BOUNDS_TEMPERATURE:new Kc("MIN","MAX"),CANCEL:new Kc,CLEAR_SEARCH_TOOLTIP:new Kc,CLOSE:new Kc,CONFIRMATION:new Kc,CONTINUE:new Kc,DATE_TIME_FORMAT:new Kc("MONTH","YEAR","HOUR","MINUTE"),DECIMAL_SEPARATOR:new Kc,DELETE_TOOLTIP:new Kc,DIALOG_ACTION:new Wc,DIALOG_MESSAGE:new Wc,DIALOG_TITLE:new Wc,DISABLE:new Kc,DLC_TITLE:new Wc,DONT_SHOW_AGAIN:new Kc,ENABLE:new Kc,ERROR:new Kc,ERROR_DIALOG_CONTINUE:new Kc,ERROR_DIALOG_COPY_DETAILS:new Kc,ERROR_DIALOG_QUIT_GAME:new Kc,ERROR_DIALOG_SAVE_QUIT_GAME:new Kc,ERROR_DIALOG_TITLE:new Kc,EXIT_DIALOG_TEXT:new Kc,EXIT_DIALOG_TITLE:new Kc,EXIT_TO_DESKTOP:new Kc,EXIT_TO_MENU:new Kc,FOCUS:new Kc,FRACTION_BODIES_PER_MONTH:new Kc("VALUE","TOTAL"),FRACTION_CUBIC_METER:new Kc("VALUE","TOTAL"),FRACTION_CUBIC_METER_PER_MONTH:new Kc("VALUE","TOTAL"),FRACTION_GALLON:new Kc("VALUE","TOTAL"),FRACTION_GALLON_PER_MONTH:new Kc("VALUE","TOTAL"),FRACTION_INTEGER:new Kc("VALUE","TOTAL"),FRACTION_INTEGER_PER_MONTH:new Kc("VALUE","TOTAL"),FRACTION_KG:new Kc("VALUE","TOTAL"),FRACTION_KG_PER_MONTH:new Kc("VALUE","TOTAL"),FRACTION_KILOWATT:new Kc("VALUE","TOTAL"),FRACTION_KILOWATT_HOURS:new Kc("VALUE","TOTAL"),FRACTION_MEGAWATT:new Kc("VALUE","TOTAL"),FRACTION_MEGAWATT_HOURS:new Kc("VALUE","TOTAL"),FRACTION_POUND:new Kc("VALUE","TOTAL"),FRACTION_POUND_PER_MONTH:new Kc("VALUE","TOTAL"),FRACTION_SHORT_TON:new Kc("VALUE","TOTAL"),FRACTION_SHORT_TON_PER_MONTH:new Kc("VALUE","TOTAL"),FRACTION_TON:new Kc("VALUE","TOTAL"),FRACTION_TON_PER_MONTH:new Kc("VALUE","TOTAL"),FRACTION_XP:new Kc("VALUE","TOTAL"),GO_BACK_TOOLTIP:new Kc,HAPPINESS_FACTORS:new Kc,HAPPINESS_FACTOR_NEGATIVE:new Wc,HAPPINESS_FACTOR_POSITIVE:new Wc,INFORMATION:new Kc,INFOVIEW_MENU_TOGGLE_TOOLTIP:new Kc,LANGUAGE_NAME:new Kc,LOCKED:new Kc,MEDIUM_DATE_FORMAT:new Kc("MONTH","YEAR"),MONTH:new zc,MONTH_SHORT:new zc,NO:new Kc,NONE:new Kc,OK:new Kc,PAUSE_MENU_TOGGLE_TOOLTIP:new Kc,SAVEABILITY_REASON:new Wc,SELECT:new Kc,SUBMIT:new Kc,THOUSANDS_SEPARATOR:new Kc,TIMESTAMP_FORMAT:new Kc,TIMESTAMP_FORMAT_12:new Kc,TIME_FORMAT:new Kc("HOUR","MINUTE"),TIME_FORMAT_12:new Kc("HOUR","MINUTE","PERIOD"),TIME_PERIOD_AM:new Kc,TIME_PERIOD_PM:new Kc,UNLOCKED:new Kc,VALUE_ACRE:new Kc("SIGN","VALUE"),VALUE_ANGLE:new Kc("SIGN","VALUE"),VALUE_BYTE:new Kc("SIGN","VALUE"),VALUE_CELSIUS:new Kc("SIGN","VALUE"),VALUE_CUBIC_METER:new Kc("SIGN","VALUE"),VALUE_CUBIC_METER_PER_MONTH:new Kc("SIGN","VALUE"),VALUE_FAHRENHEIT:new Kc("SIGN","VALUE"),VALUE_FOOT:new Kc("SIGN","VALUE"),VALUE_GALLON:new Kc("SIGN","VALUE"),VALUE_GALLON_PER_MONTH:new Kc("SIGN","VALUE"),VALUE_GIGABIT_PER_SECOND:new Kc("SIGN","VALUE"),VALUE_GIGABYTE:new Kc("SIGN","VALUE"),VALUE_KELVIN:new Kc("SIGN","VALUE"),VALUE_KG_PER_MONTH:new Kc("SIGN","VALUE"),VALUE_KILOBYTE:new Kc("SIGN","VALUE"),VALUE_KILOGRAM:new Kc("SIGN","VALUE"),VALUE_KILOMETER:new Kc("SIGN","VALUE"),VALUE_KILOTON:new Kc("SIGN","VALUE"),VALUE_KILOWATT:new Kc("SIGN","VALUE"),VALUE_MEGABYTE:new Kc("SIGN","VALUE"),VALUE_MEGAWATT:new Kc("SIGN","VALUE"),VALUE_MEGAWATT_HOURS:new Kc("SIGN","VALUE"),VALUE_METER:new Kc("SIGN","VALUE"),VALUE_MILE:new Kc("SIGN","VALUE"),VALUE_MILLION:new Kc("SIGN","VALUE"),VALUE_MONEY:new Kc("SIGN","VALUE"),VALUE_MONEY_PER_CELL:new Kc("SIGN","VALUE"),VALUE_MONEY_PER_HOUR:new Kc("SIGN","VALUE"),VALUE_MONEY_PER_KILOMETER:new Kc("SIGN","VALUE"),VALUE_MONEY_PER_KILOMETER_PER_MONTH:new Kc("SIGN","VALUE"),VALUE_MONEY_PER_MILE:new Kc("SIGN","VALUE"),VALUE_MONEY_PER_MILE_PER_MONTH:new Kc("SIGN","VALUE"),VALUE_MONEY_PER_MONTH:new Kc("SIGN","VALUE"),VALUE_MONTH:new Kc("VALUE"),VALUE_MONTHS:new Kc("VALUE"),VALUE_PERCENT:new Kc("SIGN","VALUE"),VALUE_PER_HOUR:new Kc("SIGN","VALUE"),VALUE_PER_MONTH:new Kc("SIGN","VALUE"),VALUE_PER_SQUARE_METER:new Kc("SIGN","VALUE"),VALUE_POUND:new Kc("SIGN","VALUE"),VALUE_POUND_PER_MONTH:new Kc("SIGN","VALUE"),VALUE_SHORT_KILOTON:new Kc("SIGN","VALUE"),VALUE_SHORT_TON:new Kc("SIGN","VALUE"),VALUE_SHORT_TON_PER_CELL:new Kc("SIGN","VALUE"),VALUE_SHORT_TON_PER_MONTH:new Kc("SIGN","VALUE"),VALUE_SQUARE_FOOT:new Kc("SIGN","VALUE"),VALUE_SQUARE_KILOMETER:new Kc("SIGN","VALUE"),VALUE_SQUARE_METER:new Kc("SIGN","VALUE"),VALUE_TEMPERATURE:new Kc("SIGN","VALUE"),VALUE_TERABYTE:new Kc("SIGN","VALUE"),VALUE_THOUSAND:new Kc("SIGN","VALUE"),VALUE_TON:new Kc("SIGN","VALUE"),VALUE_TON_PER_CELL:new Kc("SIGN","VALUE"),VALUE_TON_PER_MONTH:new Kc("SIGN","VALUE"),VALUE_XP:new Kc("SIGN","VALUE"),VALUE_YARD:new Kc("SIGN","VALUE"),VALUE_YEAR:new Kc("VALUE"),VALUE_YEARS:new Kc("VALUE"),WARNING:new Kc,YES:new Kc},CompanyInfoPanel:{COMMERCIAL_PROFITABILITY:new Kc,INDUSTRIAL_PROFITABILITY:new Kc,OFFICE_PROFITABILITY:new Kc},DisasterInfoPanel:{CAPACITY:new Kc,EVACUATED:new Kc,SHELTER_AVAILABILITY:new Kc},EconomyPanel:{BUDGET_BALANCE_LABEL:new Wc,BUDGET_ITEM:new Wc,BUDGET_ITEM_DESCRIPTION:new Wc,BUDGET_LOANS_BUTTON_ACCEPT:new Kc,BUDGET_LOANS_LABEL_AMOUNT:new Kc,BUDGET_LOANS_LABEL_CURRENT_INTEREST:new Kc,BUDGET_LOANS_LABEL_DAILY_INTEREST:new Kc,BUDGET_LOANS_LABEL_DAILY_PAYMENT:new Kc,BUDGET_LOANS_LABEL_DAYS_REMAINING:new Kc,BUDGET_LOANS_LABEL_GET_MORE:new Kc,BUDGET_LOANS_LABEL_NEW_LOAN:new Kc,BUDGET_LOANS_LABEL_PAY_BACK:new Kc,BUDGET_SUB_ITEM:new Wc,BUDGET_TITLE_LOANS:new Kc,EXPENSES_SECTION_TITLE:new Kc,INCOME_SECTION_TITLE:new Kc,LOAN_CHART_BUDGET_WARNING:new Kc,LOAN_CHART_BUDGET_WARNING_MODIFIED:new Kc,LOAN_CHART_DEFICIT:new Kc("TOTAL"),LOAN_CHART_LEGEND_EXPENSES:new Kc,LOAN_CHART_LEGEND_INCOME:new Kc,LOAN_CHART_LEGEND_LOAN_INTEREST:new Kc,LOAN_CHART_RELATIVE_COST:new Kc("RELATIVE_LOAN_COST"),LOAN_CHART_REMAINING_SURPLUS:new Kc("TOTAL"),LOAN_CHART_SURPLUS:new Kc("TOTAL"),LOAN_FORM_ACCEPT:new Kc,LOAN_FORM_LESS_LABEL:new Kc,LOAN_FORM_LIMIT:new Kc("LOAN_LIMIT"),LOAN_FORM_MORE_LABEL:new Kc,LOAN_FORM_RESET:new Kc,LOAN_PAGE_DESCRIPTION:new Kc,LOAN_PAGE_TITLE:new Kc,LOAN_TABLE_AMOUNT:new Kc,LOAN_TABLE_INTEREST_RATE:new Kc,LOAN_TABLE_MONTHLY_COST:new Kc,MONTHLY_BALANCE:new Kc,PRODUCTION_LABEL_EXPORT:new Kc,PRODUCTION_LABEL_IMPORT:new Kc,PRODUCTION_LABEL_INTERNAL:new Kc,PRODUCTION_LABEL_TOTAL:new Kc,PRODUCTION_PAGE_DEFICIT:new Kc,PRODUCTION_PAGE_EXPORT:new Kc,PRODUCTION_PAGE_IMPORT:new Kc,PRODUCTION_PAGE_PRODUCTION:new Kc,PRODUCTION_PAGE_PRODUCTIONLINK:new Wc,PRODUCTION_PAGE_SURPLUS:new Kc,PRODUCTION_TAB_IMMATERIAL:new Kc,PRODUCTION_TAB_MATERIAL:new Kc,PRODUCTION_TOOLTIP_COMMERCIAL_CONSUMPTION:new Kc,PRODUCTION_TOOLTIP_COMMERCIAL_WEALTH:new Kc,PRODUCTION_TOOLTIP_INDUSTRIAL_CONSUMPTION:new Kc,PRODUCTION_TOOLTIP_INDUSTRIAL_PRODUCTION:new Kc,PRODUCTION_TOOLTIP_INDUSTRIAL_WEALTH:new Kc,PRODUCTION_TOOLTIP_OFFICE_CONSUMPTION:new Kc,PRODUCTION_TOOLTIP_OFFICE_WEALTH:new Kc,RESOURCE_CATEGORY:new Wc,SERVICES_BUILDING_EMPLOYMENT_LABEL:new Kc,SERVICES_FEES_LABEL_DAILY_EXPENSES:new Kc,SERVICES_FEES_LABEL_DAILY_INCOME:new Kc,SERVICES_FEES_LABEL_EXPORT:new Kc,SERVICES_FEES_LABEL_FEES:new Kc,SERVICES_FEES_LABEL_IMPORT:new Kc,SERVICES_FEES_LABEL_SERVICE_FEE:new Kc,SERVICES_LABEL_TOTAL:new Kc,SERVICES_LABEL_UPKEEP:new Kc,SERVICES_LABEL_WAGES:new Kc,SERVICES_RESOURCE_FEE_CONSUMPTION:new Wc,SERVICES_RESOURCE_FEE_DESCRIPTION:new Wc,SERVICES_RESOURCE_FEE_EFFICIENCY:new Kc,SERVICES_RESOURCE_FEE_HAPPINESS:new Kc,SERVICES_RESOURCE_FEE_LABEL:new Wc,SERVICES_RESOURCE_LABEL:new Wc,SERVICES_TITLE_BUDGET:new Kc,SERVICES_TITLE_BUDGETS:new Kc,SERVICES_TITLE_BUILDINGS:new Kc,SERVICES_TITLE_EXPENSES:new Kc,SERVICES_TITLE_IMPORT_BUDGET:new Kc,SERVICES_TITLE_INCOME:new Kc,SERVICES_TITLE_INFO:new Kc,SERVICES_TITLE_QUALITY:new Kc,SERVICE_BUDGET_EFFICIENCY:new Kc,SERVICE_BUDGET_SLIDER_DESCRIPTION:new Wc,SERVICE_BUDGET_SLIDER_TITLE:new Wc,SERVICE_DESCRIPTION:new Wc,SERVICE_EXPORT_REVENUE_DESCRIPTION:new Kc,SERVICE_FEES_REVENUE_DESCRIPTION:new Kc,SERVICE_IMPORT_EXPENSE_DESCRIPTION:new Kc,SERVICE_UPKEEP_EXPENSE_DESCRIPTION:new Kc,TAB:new Wc,TAXATION_COMMERCIAL_TITLE:new Kc,TAXATION_INDUSTRIAL_TITLE:new Kc,TAXATION_OFFICE_TITLE:new Kc,TAXATION_RESIDENTIAL_LABEL_JOBLEVEL:new Kc,TAXATION_RESIDENTIAL_SLIDER_JOBLEVEL:new zc,TAXATION_RESIDENTIAL_TITLE:new Kc,TAXATION_TAX_GROUP:new Wc,TAX_AREA_COLUMN_TITLE:new Kc,TAX_AREA_DESCRIPTION:new Wc,TAX_AREA_TITLE:new Wc,TAX_INCOME_ESTIMATE_TITLE:new Kc,TAX_INCOME_TOTAL_TITLE:new Kc,TAX_RANGE:new Kc("MIN","MAX"),TAX_RATE_TITLE:new Kc,TITLE:new Kc},Editor:{ACTIVE_TOOLTIP:new Kc,ADD_COMPONENT:new Kc,ADD_COMPONENT_NAMED:new Kc("NAME"),ADD_FAVORITE:new Kc,ADD_TRANSLATION:new Kc,ASSETS:new Kc,ASSET_CATEGORY_TITLE:new Wc,BACK_TO_EDITOR:new Kc,BETA_BANNER:new Kc,BORDER_RIVER_WATER_SOURCES:new Kc,BORDER_SEA_WATER_SOURCES:new Kc,CAMERA_ANGLE:new Kc,CAMERA_PIVOT:new Kc,CAMERA_STARTING_POSITION:new Kc,CAMERA_ZOOM:new Kc,CAPTURE_CAMERA_POSITION:new Kc,CHANGE_PREFAB_TYPE:new Kc,CHECKLIST:new Kc,CHECKLIST_AIR_CONNECTION:new Kc,CHECKLIST_ELECTRICITY_CONNECTION:new Kc,CHECKLIST_FERTILE:new Kc,CHECKLIST_FOREST:new Kc,CHECKLIST_NAME:new Kc,CHECKLIST_OIL:new Kc,CHECKLIST_OPTIONAL:new Kc,CHECKLIST_ORE:new Kc,CHECKLIST_REQUIRED:new Kc,CHECKLIST_ROAD_CONNECTION:new Kc,CHECKLIST_STARTING_TILES:new Kc,CHECKLIST_TRAIN_CONNECTION:new Kc,CHECKLIST_WATER:new Kc,CLEAR:new Kc,CLEAR_ALL:new Kc,CLEAR_RESOURCE:new Wc,CLIMATE:new Kc,CLIMATE_SETTINGS:new Kc,CLOUDINESS:new Kc,COMPONENT_TYPES:new Kc,CONSTANT_LEVEL_WATER_SOURCES:new Kc,CONSTANT_RATE_WATER_SOURCES:new Kc,CURRENT_YEAR_AS_DEFAULT:new Kc,DELETE_COMPONENT:new Kc,DRIVES:new Kc,DUPLICATE_TEMPLATE:new Kc,DUPLICATE_TEMPLATE_TOOLTIP:new Kc,ELEMENT_COUNT:new Kc("COUNT"),EXPORT_HEIGHTMAP:new Kc,EXPORT_WORLDMAP:new Kc,FILE_NAME:new Kc,FILTERS:new Kc,FLOOD_HEIGHT:new Kc,HEIGHT:new Kc,HEIGHTMAPS:new Kc,HEIGHT_OFFSET:new Kc,HEIGHT_SCALE:new Kc,IMPORT:new Kc,IMPORTING:new Kc,IMPORT_HEIGHTMAP:new Kc,IMPORT_RESOURCE:new Wc,IMPORT_WORLDMAP:new Kc,INCORRECT_HEIGHTMAP_MESSAGE:new Kc("WIDTH","HEIGHT"),INCORRECT_HEIGHTMAP_TITLE:new Kc,INSTALOD_LABEL:new Kc,LIST_ADD_ITEM:new Kc,LIST_COUNT:new Kc("COUNT"),LIST_ITEM_COLLAPSE:new Kc,LIST_ITEM_DELETE:new Kc,LIST_ITEM_DUPLICATE:new Kc,LIST_ITEM_EXPAND:new Kc,LIST_ITEM_MOVE_DOWN:new Kc,LIST_ITEM_MOVE_UP:new Kc,LIST_PAGE_COUNT:new Kc("PAGE","PAGE_COUNT","COUNT"),LOAD:new Kc,LOAD_MAP:new Kc,LOCATE:new Kc,MAP:new Kc,MAP_DESCRIPTION:new Kc,MAP_NAME:new Kc,MAP_NAME_AS_DEFAULT:new Kc,MAP_OFFSET:new Kc,MAP_SETTINGS:new Kc,MAP_SIZE:new Kc,MATERIALS:new Kc,NEW_MAP:new Kc,NEXT_PAGE:new Kc,NONE_VALUE:new Kc,OBJECTCONTAINER:new Kc,OPEN_DIRECTORY:new Kc,PAGE_FORMAT:new Kc("CURRENT","TOTAL"),POLLUTION:new Kc,POSITION:new Kc,PREVIEW:new Kc,PREVIOUS_PAGE:new Kc,PROCESSING:new Kc,RADIUS:new Kc,REMOVE_FAVORITE:new Kc,REMOVE_WORLDMAP:new Kc,RESET_CLOUDINESS:new Kc,RESET_TIME_OF_DAY:new Kc,RESET_TIME_OF_YEAR:new Kc,RESOURCES:new Kc,RESOURCE_TEXTURE_LABEL:new Kc,RESOURCE_TOOLS:new Kc,SAVE:new Kc,SAVE_MAP:new Kc,SAVE_MAP_SHARE:new Kc,SAVE_SHARE:new Kc,SEARCH_PLACEHOLDER:new Kc,SELECT_DIRECTORY:new Kc,SELECT_STARTING_TILES:new Kc,SELECT_TEMPLATE:new Kc,STARTING_MONTH:new Kc,STARTING_TIME:new Kc,STARTING_YEAR:new Kc,STOP_SELECTING_STARTING_TILES:new Kc,TERRAIN_TOOLS:new Kc,THEME:new Kc,THUMBNAIL:new Kc,TIME_OF_DAY:new Kc,TIME_OF_YEAR:new Kc,TOOL:new Wc,UNIQUE_MAP_ID:new Kc,WATER:new Kc,WATER_RATE:new Kc,WATER_SETTINGS:new Kc,WATER_SIMULATION_SPEED:new Kc,WIDGETS:new Wc,WORKSPACE:new Kc,WORLD_OFFSET:new Kc,WORLD_SIZE:new Kc},EducationInfoPanel:{AVAILABILITY:new Wc,EDUCATION_DISTRIBUTION:new Kc,EDUCATION_LEVEL:new Wc,ELIGIBLE:new Kc,LEVEL:new Wc,STUDENTS:new Wc,STUDENT_COUNT:new Kc},ElectricityInfoPanel:{BATTERY_CHARGE:new Kc,ELECTRICITY_AVAILABILITY:new Kc,ELECTRICITY_EXPORT:new Kc,ELECTRICITY_IMPORT:new Kc,ELECTRICITY_TRADE:new Kc,ELECTRICITY_TRANSMISSION:new Kc,ELECTRICITY_TRANSMITTED:new Kc,TEMPERATURE_EFFECT:new Kc},EventJournal:{EFFECT:new Wc,EVENT_TITLE:new Wc,OPENING_MESSAGE:new Kc,PANEL_TITLE:new Kc},FireAndRescueInfoPanel:{AVERAGE_FIRE_HAZARD:new Kc},GameListScreen:{BIOME_LABEL:new Kc,BUILDABLE_AREA_LABEL:new Kc,CITY_DETAILS_SECTION:new Kc,CLIMATE_LABEL:new Kc,CONFIRM_OVERWRITE_MESSAGE:new Kc,CONFIRM_UNSAVED_MESSAGE:new Kc,CONNECTIONS_LABEL:new Kc,EQUATOR:new Kc,GAME_OPTION:new Wc,GAME_OPTIONS_SECTION:new Kc,GAME_OPTION_DESCRIPTION:new Wc,HEMISPHERE_N:new Kc,HEMISPHERE_S:new Kc,INVALID_NAME_MESSAGE:new Kc,LAST_MODIFIED_LABEL:new Kc,LATITUDE_LABEL:new Kc,LOAD_GAME_BUTTON:new Kc,LOAD_GAME_SCREEN_TITLE:new Kc,MAP_DETAILS_SECTION:new Kc,MAP_FILTER:new Wc,MAP_LABEL:new Kc,MONEY_LABEL:new Kc,NEW_GAME_SCREEN_TITLE:new Kc,POPULATION_LABEL:new Kc,RESOURCES_LABEL:new Kc,SAVE_GAME_BUTTON:new Kc,SAVE_GAME_SCREEN_TITLE:new Kc,SAVE_NAME_LABEL:new Kc,START_GAME_BUTTON:new Kc,THEME_LABEL:new Kc,TUTORIAL_OPTIONS:new Kc,WATER_AVAILABILITY_LABEL:new Kc,XP_LABEL:new Kc},GarbageInfoPanel:{GARBAGE_RATE:new Kc,LANDFILL_AVAILABILITY:new Kc,PROCESSING_STATUS:new Kc,STORED_GARBAGE:new Kc},GroundPollutionInfoPanel:{AVERAGE_GROUND_POLLUTION:new Kc},HealthcareInfoPanel:{AVERAGE_HEALTH:new Kc,CEMETERY_AVAILABILITY:new Kc,CREMATORIUM_AVAILABILITY:new Kc,DEATH_RATE:new Kc,HEALTHCARE_AVAILABILITY:new Kc,N_A:new Kc,OCCUPIED:new Kc,PATIENTS:new Kc,PROCESSING_RATE:new Kc,SICK_OR_INJURED:new Kc},ISO:{COUNTRY:new Wc},InfoPanels:{CAPACITY:new Kc,CONSUMPTION:new Kc,OUTPUT:new Kc,PROCESSING:new Kc,PRODUCTION:new Kc,STORED:new Kc},Infoviews:{AVAILABILITY:new Kc,AVERAGE_AIR_POLLUTION_TOOLTIP:new Kc,AVERAGE_COMMERCIAL_PROFIT_TOOLTIP:new Kc,AVERAGE_FIRE_HAZARD_TOOLTIP:new Kc,AVERAGE_GROUND_POLLUTION_TOOLTIP:new Kc,AVERAGE_INDUSTRIAL_PROFIT_TOOLTIP:new Kc,AVERAGE_LAND_VALUE_TOOLTIP:new Kc,AVERAGE_NOISE_POLLUTION_TOOLTIP:new Kc,AVERAGE_OFFICE_PROFIT_TOOLTIP:new Kc,AVERAGE_WATER_POLLUTION_TOOLTIP:new Kc,BATTERY_CHARGE_TOOLTIP:new Kc,CEMETERY_AVAILABILITY_TOOLTIP:new Kc,CITY_ATTRACTIVENESS_TOOLTIP:new Kc,CLOSE_INFO_VIEW:new Kc,COLLEGE_AVAILABILITY_TOOLTIP:new Kc,COMMERCIAL_LEVEL_TOOLTIP:new Kc,CREMATORIUM_AVAILABILITY_TOOLTIP:new Kc,CRIME_PROBABILITY_TOOLTIP:new Kc,EDUCATION_DISTRIBUTION_TOOLTIP:new Kc,ELECTRICITY_AVAILABILITY_TOOLTIP:new Kc,ELECTRICITY_TRADE_TOOLTIP:new Kc,ELECTRICITY_TRANSMISSION_TOOLTIP:new Kc,ELEMENTARY_SCHOOL_AVAILABILITY_TOOLTIP:new Kc,EXPORT_DISTRIBUTION_TOOLTIP:new Kc,FERTILE_LAND_RESOURCE_TOOLTIP:new Kc,GARBAGE_PROCESSING_STATUS_TOOLTIP:new Kc,HAPPINESS_FACTORS_TOOLTIP:new Kc,HEALTHCARE_AVAILABILITY_TOOLTIP:new Kc,HIGH_SCHOOL_AVAILABILITY_TOOLTIP:new Kc,IMPORT_DISTRIBUTION_TOOLTIP:new Kc,INDUSTRIAL_LEVEL_TOOLTIP:new Kc,INFOMODE:new Wc,INFOMODE_TOOLTIP:new Wc,INFOMODE_TYPE:new Wc,INFOVIEW:new Wc,JAIL_AVAILABILITY_TOOLTIP:new Kc,LABEL:new Wc,LABEL_VALUE_FORMAT:new Kc("LABEL","VALUE"),LANDFILL_AVAILABILITY_TOOLTIP:new Kc,MAIL_SERVICE_AVAILABILITY_TOOLTIP:new Kc,MAP_LEGEND:new Kc,OFFICE_LEVEL_TOOLTIP:new Kc,OIL_RESOURCE_TOOLTIP:new Kc,ORE_RESOURCE_TOOLTIP:new Kc,PARKING_AVAILABILITY_TOOLTIP:new Kc,POPULATION_DISTRIBUTION_TOOLTIP:new Kc,POPULATION_STATISTICS_TOOLTIP:new Kc,PRISON_AVAILABILITY_TOOLTIP:new Kc,REMOVE_USER_INFOVIEW_BUTTON_TOOLTIP:new Kc,RESIDENTIAL_LEVEL_TOOLTIP:new Kc,SEWAGE_TRADE_TOOLTIP:new Kc,SEWAGE_TREATMENT_TOOLTIP:new Kc,SHELTER_AVAILABILITY_TOOLTIP:new Kc,TITLE_INFOVIEWS:new Kc,TRAFFIC_FLOW:new Kc,UNIVERSITY_AVAILABILITY_TOOLTIP:new Kc,USER_INFOMODE_SELECTOR_TOOLTIP:new Kc,WATER_AVAILABILITY_TOOLTIP:new Kc,WATER_STORAGE_TOOLTIP:new Kc,WATER_TRADE_TOOLTIP:new Kc,WOOD_RESOURCE_TOOLTIP:new Kc,WORKPLACE_DISTRIBUTION_TOOLTIP:new Kc},LandValueInfoPanel:{AVERAGE_LAND_VALUE:new Kc},LevelInfoPanel:{COMMERCIAL:new Kc,INDUSTRIAL:new Kc,LEVEL1:new Kc,LEVEL2:new Kc,LEVEL3:new Kc,LEVEL4:new Kc,LEVEL5:new Kc,OFFICE:new Kc,RESIDENTIAL:new Kc},LifePath:{BACK_BUTTON_TOOLTIP:new Kc,CITIZEN_BECAME_UNEMPLOYED:new zc("LINK_1"),CITIZEN_BIRTH:new Kc,CITIZEN_COMMITED_ROBBERY:new zc,CITIZEN_DIED:new zc,CITIZEN_FAILED_SCHOOL:new zc("LINK_1"),CITIZEN_GOT_ARRESTED:new zc,CITIZEN_GOT_INJURED:new zc,CITIZEN_GOT_INJURED_BY_EVENT:new zc("LINK_1"),CITIZEN_GOT_IN_DANGER_BY_EVENT:new zc("LINK_1"),CITIZEN_GOT_SICK:new zc,CITIZEN_GOT_SICK_BY_EVENT:new zc("LINK_1"),CITIZEN_GOT_TRAPPED:new zc,CITIZEN_GOT_TRAPPED_BY_EVENT:new zc("LINK_1"),CITIZEN_GRADUATED:new zc("LINK_1"),CITIZEN_IN_DANGER:new zc,CITIZEN_LOST_FAMILY_MEMBER:new zc("LINK_1"),CITIZEN_MADE_BABY_COUPLE:new zc("LINK_1","LINK_2"),CITIZEN_MADE_BABY_SINGLE:new zc("LINK_1"),CITIZEN_MOVED_HOUSE:new zc("LINK_1"),CITIZEN_MOVED_OUT_OF_CITY:new zc("LINK_1"),CITIZEN_PARTNERED_UP:new zc("LINK_1"),CITIZEN_SENTENCED_TO_PRISON:new zc,CITIZEN_SEPARATED:new zc("LINK_1"),CITIZEN_STARTED_SCHOOL:new zc("LINK_1"),CITIZEN_STARTED_WORKING:new zc("LINK_1"),DETAIL_PANEL_TITLE:new Kc("NAME"),LIST_PANEL_TITLE:new Kc,MAX_EXCEEDED_WARNING:new Kc,OCCUPATION:new Kc("OCCUPATION","WORKPLACE_LINK","WORKPLACE_NAME"),OPENING_MESSAGE:new Kc,TOURIST_LEFT_CITY:new zc("LINK_1"),UNFOLLOW_BUTTON_TOOLTIP:new Kc},Loading:{HINTMESSAGE:new zc,LOADING_TITLE:new Kc},Main:{TOOLTIP_DESCRIPTION_ADVISOR:new Kc,TOOLTIP_DESCRIPTION_CAMERA_MODES:new Kc,TOOLTIP_DESCRIPTION_CHIRPER:new Kc,TOOLTIP_DESCRIPTION_CINEMATIC_CAMERA:new Kc,TOOLTIP_DESCRIPTION_CITY_ECONOMY:new Kc,TOOLTIP_DESCRIPTION_CITY_INFO:new Kc,TOOLTIP_DESCRIPTION_CITY_NAME:new Kc,TOOLTIP_DESCRIPTION_CITY_STATISTICS:new Kc,TOOLTIP_DESCRIPTION_CURRENT_MILESTONE:new Kc,TOOLTIP_DESCRIPTION_DATE:new Kc,TOOLTIP_DESCRIPTION_DEMAND:new Kc,TOOLTIP_DESCRIPTION_ELEVATION_LOWER:new Kc,TOOLTIP_DESCRIPTION_ELEVATION_RAISE:new Kc,TOOLTIP_DESCRIPTION_EVENT_JOURNAL:new Kc,TOOLTIP_DESCRIPTION_FOLLOWED_CITIZENS:new Kc,TOOLTIP_DESCRIPTION_FREE_CAMERA:new Kc,TOOLTIP_DESCRIPTION_GAME_SPEED:new Kc,TOOLTIP_DESCRIPTION_INFO_VIEWS:new Kc,TOOLTIP_DESCRIPTION_LINES_OVERVIEW:new Kc,TOOLTIP_DESCRIPTION_MAP_TILES:new Kc,TOOLTIP_DESCRIPTION_MAX_MILESTONE:new Kc,TOOLTIP_DESCRIPTION_MONEY:new Kc,TOOLTIP_DESCRIPTION_NOTIFICATIONS:new Kc,TOOLTIP_DESCRIPTION_PAUSE:new Kc,TOOLTIP_DESCRIPTION_PAUSE_MENU:new Kc,TOOLTIP_DESCRIPTION_PHOTO_MODE:new Kc,TOOLTIP_DESCRIPTION_PLAY:new Kc,TOOLTIP_DESCRIPTION_POPULATION:new Kc,TOOLTIP_DESCRIPTION_PROGRESSION:new Kc,TOOLTIP_DESCRIPTION_RADIO:new Kc,TOOLTIP_DESCRIPTION_UNDERGROUND:new Kc,TOOLTIP_DESCRIPTION_UNLIMITED_MONEY:new Kc,TOOLTIP_DESCRIPTION_WEATHER:new Kc,TOOLTIP_DESCRIPTION_XP:new Kc,TOOLTIP_TITLE_ADVISOR:new Kc,TOOLTIP_TITLE_CAMERA_MODES:new Kc,TOOLTIP_TITLE_CHIRPER:new Kc,TOOLTIP_TITLE_CINEMATIC_CAMERA:new Kc,TOOLTIP_TITLE_CITY_ECONOMY:new Kc,TOOLTIP_TITLE_CITY_INFO:new Kc,TOOLTIP_TITLE_CITY_NAME:new Kc,TOOLTIP_TITLE_CITY_STATISTICS:new Kc,TOOLTIP_TITLE_CURRENT_MILESTONE:new Kc,TOOLTIP_TITLE_DATE:new Kc,TOOLTIP_TITLE_DEMAND:new Kc,TOOLTIP_TITLE_ELEVATION_LOWER:new Kc,TOOLTIP_TITLE_ELEVATION_RAISE:new Kc,TOOLTIP_TITLE_EVENT_JOURNAL:new Kc,TOOLTIP_TITLE_FOLLOWED_CITIZENS:new Kc,TOOLTIP_TITLE_FREE_CAMERA:new Kc,TOOLTIP_TITLE_GAME_SPEED:new Kc,TOOLTIP_TITLE_INFO_VIEWS:new Kc,TOOLTIP_TITLE_LINES_OVERVIEW:new Kc,TOOLTIP_TITLE_MAP_TILES:new Kc,TOOLTIP_TITLE_MONEY:new Kc,TOOLTIP_TITLE_NOTIFICATIONS:new Kc,TOOLTIP_TITLE_PAUSE:new Kc,TOOLTIP_TITLE_PAUSE_MENU:new Kc,TOOLTIP_TITLE_PHOTO_MODE:new Kc,TOOLTIP_TITLE_PLAY:new Kc,TOOLTIP_TITLE_POPULATION:new Kc,TOOLTIP_TITLE_PROGRESSION:new Kc,TOOLTIP_TITLE_RADIO:new Kc,TOOLTIP_TITLE_UNDERGROUND:new Kc,TOOLTIP_TITLE_WEATHER:new Kc,TOOLTIP_TITLE_XP:new Kc},MapTilePurchase:{AVAILABLE_EXPANSION_PERMITS:new Kc("VALUE"),AVAILABLE_WATER:new Kc,BUILDABLE_AREA:new Kc,COST:new Kc,PERMITS_USED:new Kc,PURCHASE_STATUS:new Wc,PURCHASE_STATUS_TOOLTIP:new Wc,RESOURCE:new Wc,RESOURCES:new Kc,TITLE:new Kc,TOOLTIP_COST:new Kc,TOOLTIP_RESOURCE:new Wc,TOOLTIP_TILES:new Kc,TOOLTIP_TITLE_COST:new Kc,TOOLTIP_TITLE_RESOURCE:new Wc,TOOLTIP_TITLE_TILES:new Kc},Maps:{MAP_DESCRIPTION:new Wc,MAP_TITLE:new Wc,OUTSIDE_CONNECTIONS:new Wc,RESOURCE:new Wc},Menu:{ACHIEVEMENTS_WARNING_GAME_OPTIONS:new Kc,ACHIEVEMENTS_WARNING_MODS:new Kc,ACHIEVEMENTS_WARNING_PAST_OPTIONS:new Kc,APPLICATION_QUIT_MESSAGE:new Kc,ASSET_ADD_EXTERNAL_LINK:new Kc,ASSET_ADD_LINK:new Kc,ASSET_ADD_PREVIEW_SCREENSHOT:new Kc,ASSET_CHANGELOG:new Kc,ASSET_COMPLETE:new Kc,ASSET_COPY_ID:new Kc,ASSET_ERROR_DESCRIPTION:new Kc,ASSET_ERROR_EMPTY_CHANGELOG:new Kc,ASSET_ERROR_LINK:new Kc,ASSET_ERROR_NAME:new Kc,ASSET_EXISTING_ID:new Kc,ASSET_EXTERNAL_LINKS:new Kc,ASSET_EXTERNAL_LINK_TYPE:new Wc,ASSET_EXTERNAL_LINK_URL:new Kc,ASSET_FAILURE:new Kc,ASSET_FORUM_LINK:new Kc("INDEX"),ASSET_FORUM_LINKS:new Kc,ASSET_FORUM_LINK_LABEL:new Kc,ASSET_LONG_DESCRIPTION:new Kc,ASSET_NAME:new Kc,ASSET_PREPARING:new Kc,ASSET_PREVIEW_SCREENSHOTS:new Kc,ASSET_REMOVE_PREVIEW_SCREENSHOT:new Kc,ASSET_SCREENSHOT_EMPTY_SUBTITLE:new Kc,ASSET_SCREENSHOT_EMPTY_TITLE:new Kc,ASSET_SHORT_DESCRIPTION:new Kc,ASSET_SUBMITTING:new Kc,ASSET_TYPE:new Wc,ASSET_UPDATE_EXISTING:new Kc,ASSET_UPLOAD:new Kc,ASSET_UPLOAD_ID:new Kc("ID"),ASSET_VERSION:new Kc,BACK:new Kc,BETA_LABEL:new Kc,CITY_NAME_LABEL:new Kc,CLOUD_TARGET:new Wc,CLOUD_TARGET_LABEL:new Kc,CONFIRM_DELETE_SAVE_WARNING:new Kc,CONTINUE_GAME:new Kc,CREDITS:new Kc,DLC_TAB:new Kc,EDITOR:new Kc,EMPTY_SLOT:new Kc,EXIT_APPLICATION:new Kc,EXIT_GAME:new Kc,GDKCLOUD_SAVE:new Kc,LOAD_GAME:new Kc,LOAD_GAME_BUTTON:new Kc,MAP_OPTIONS:new Kc,MODS_TAB:new Kc,NAME_FIELD_PLACEHOLDER:new Kc,NEWS_PANEL_TITLE:new Kc,NEW_GAME:new Kc,NOTIFICATIONS_OPENING_MESSAGE:new Kc,NOTIFICATIONS_TITLE:new Kc,NOTIFICATION_DESCRIPTION:new Wc,NOTIFICATION_TITLE:new Wc,OPTIONS:new Kc,PARADOXCLOUD_SAVE:new Kc,PDX_MODS:new Kc,RANDOM_CITY_NAME_BUTTON_TOOLTIP:new Kc,READONLY_SAVE:new Kc,RESUME_GAME:new Kc,SAVE_GAME:new Kc,SAVE_LIST:new Kc,SAVE_OPTIONS:new Kc,SAVE_ORDERING:new Wc,SAVE_ORDERING_LABEL:new Kc,SELECT_MAP_BUTTON:new Kc,SIMULATION_DATE_LABEL:new Kc,START_GAME_BUTTON:new Kc,STEAMCLOUD_SAVE:new Kc,SWITCH_USER:new Kc,UNLIMITED_MONEY_LABEL:new Kc},NaturalResourcesInfoPanel:{AVAILABLE:new Kc,FERTILITY:new Kc,FOREST:new Kc,OIL:new Kc,ORE:new Kc,RATE:new Kc,RENEWAL_RATE:new Kc},NoisePollutionInfoPanel:{AVERAGE_NOISE_POLLUTION:new Kc},Notifications:{DESCRIPTION:new Wc,TITLE:new Wc},Options:{ANTIALIASINGMETHOD:new Wc,AUTORELOADMODE:new Wc,AUTOSAVECOUNT:new Wc,AUTOSAVEINTERVAL:new Wc,CURSORMODE:new Wc,DEPTHOFFIELDMODE:new Wc,DEPTHOFFIELDRESOLUTION:new Wc,DESCRIPTION_BOX_TITLE:new Kc,DISPLAYMODE:new Wc,DISPLAY_MODE:new Wc,DISPLAY_SETTINGS_CONFIRM:new Kc,DISPLAY_SETTINGS_PROMPT:new Kc,DISPLAY_SETTINGS_REVERT:new Kc("TIME"),DLSSQUALITY:new Wc,DYNRESUPSCALEFILTER:new Wc,ERROR_TOOLCHAIN:new Kc,ERROR_TOOLCHAIN_DEPENDENCY_DOWNLOAD:new Kc("DEPENDENCY_NAME"),ERROR_TOOLCHAIN_DEPENDENCY_DOWNLOAD_DETAILS:new Kc("DEPENDENCY_NAME","DETAILS"),ERROR_TOOLCHAIN_DEPENDENCY_INSTALL:new Kc("DEPENDENCY_NAME"),ERROR_TOOLCHAIN_DEPENDENCY_INSTALL_DETAILS:new Kc("DEPENDENCY_NAME","DETAILS"),ERROR_TOOLCHAIN_DEPENDENCY_UNINSTALL:new Kc("DEPENDENCY_NAME"),ERROR_TOOLCHAIN_DEPENDENCY_UNINSTALL_DETAILS:new Kc("DEPENDENCY_NAME","DETAILS"),ERROR_TOOLCHAIN_INSTALL_UNKNOWN:new Kc,ERROR_TOOLCHAIN_NO_SPACE:new Kc,ERROR_TOOLCHAIN_NO_SPACE_DETAILS:new Kc("DETAILS"),ERROR_TOOLCHAIN_UNINSTALL_UNKNOWN:new Kc,FILTERMODE:new Wc,FPSMODE:new Wc,FSR2QUALITY:new Wc,GROUP:new Wc,INPUTHINTSTYPE:new Wc,INPUT_CONFLICT_NO_RESOLUTION:new Kc("CONTROL","BINDING"),INPUT_CONFLICT_PROMPT:new Kc("CONTROL","BINDING"),INPUT_CONFLICT_TITLE:new Kc,INPUT_CONTROL:new Wc,INPUT_CONTROL_PS:new Wc,INPUT_CONTROL_UNSET:new Kc,INPUT_MODIFIER_SEPARATOR:new Kc,INPUT_REBIND_PROMPT:new Wc,INPUT_REBIND_PROMPT_PS:new Wc,INPUT_REBIND_TITLE:new Kc("BINDING"),INTERFACE_STYLE:new Wc,LEVEL:new Wc,MOD_TOOLCHAIN_STATUS:new Wc,MSAASAMPLES:new Wc,OPTION:new Wc,OPTION_DESCRIPTION:new Wc,PERFORMANCEPREFERENCE:new Wc,SCREEN_RESOLUTION_FORMAT:new Kc("WIDTH","HEIGHT","REFRESH_RATE"),SCREEN_TITLE:new Kc,SEARCH:new Wc,SECTION:new Wc,SKINNING:new Wc,SMAAQUALITYLEVEL:new Wc,STATE_TOOLCHAIN:new Wc("VERSION"),SWAP_BINDINGS:new Kc,TAB:new Wc,TEMPERATUREUNIT:new Wc,TIMEFORMAT:new Wc,UNITSYSTEM:new Wc,UNSET_BINDINGS:new Kc,UNSET_BINDING_TOOLTIP:new Kc,WARNING:new Wc,WARN_TOOLCHAIN_DEPENDENCY_UNINSTALL:new Kc("DEPENDENCY_NAME"),WARN_TOOLCHAIN_DOTNET_UNINSTALL:new Kc("DOTNET_VERSION"),WARN_TOOLCHAIN_INSTALL:new Kc("UNITY_VERSION","HOST"),WARN_TOOLCHAIN_INSTALL_DOTNET:new Kc("DOTNET_VERSION","HOST"),WARN_TOOLCHAIN_INSTALL_MOD_PROJECT:new Kc,WARN_TOOLCHAIN_INSTALL_NEW:new Kc("DEPENDENCIES"),WARN_TOOLCHAIN_INSTALL_NODEJS:new Kc("NODEJS_VERSION","HOST"),WARN_TOOLCHAIN_INSTALL_PROJECT_TEMPLATE:new Kc,WARN_TOOLCHAIN_INSTALL_UNITY:new Kc("UNITY_VERSION","HOST"),WARN_TOOLCHAIN_INSTALL_UNITY_LICENSE:new Kc,WARN_TOOLCHAIN_MIN_VERSION:new Kc("MIN_VERSION"),WARN_TOOLCHAIN_NODEJS_UNINSTALL:new Kc("NODEJS_VERSION"),WARN_TOOLCHAIN_UNINSTALL:new Kc("UNITY_VERSION"),WARN_TOOLCHAIN_UNINSTALL_NEW:new Kc("DEPENDENCIES"),WARN_TOOLCHAIN_UNITY_LICENSE_RETURN:new Kc,WARN_TOOLCHAIN_UNITY_UNINSTALL:new Kc("UNITY_VERSION")},OutsideConnectionsInfoPanel:{TOP_EXPORTS:new Kc,TOP_IMPORTS:new Kc},Overlay:{BACK_ACTION:new Kc,CHANGE_USER_ACTION:new Kc,CONTROLLER_DISCONNECTED:new Kc,CONTROLLER_PAIRING_CHANGED:new Kc,CORRUPT_SAVE_DATA:new Kc,DELETED_ITEMS:new Kc,ENGAGEMENT_PROMPT_GAMEPAD:new Kc,ENGAGEMENT_PROMPT_KEYBOARD:new Kc,PLEASE_LOG_IN:new Kc,PLEASE_WAIT:new Kc,PRESS_ANY_KEY_ACTION:new Kc,PROCEED_ACTION:new Kc,QUIT_ACTION:new Kc,START_GAME_ACTION:new Kc,SWITCH_USER:new Kc,USER_LOGGED_OUT:new Kc,VALIDATION:new Kc},Paradox:{ACCOUNT_LINK_CONFIRMATION_TEXT:new Wc,ACCOUNT_LINK_OVERWRITE_TITLE:new Kc,ACCOUNT_LINK_PROMPT_SHORT:new Wc,ACCOUNT_LINK_PROMPT_TEXT:new Wc,ACCOUNT_LINK_PROMPT_TITLE:new Kc,BIRTH_DATE_DAY_FIELD_LABEL:new Kc,BIRTH_DATE_FIELD_LABEL:new Kc,BIRTH_DATE_MONTH_FIELD_LABEL:new Kc,BIRTH_DATE_YEAR_FIELD_LABEL:new Kc,COUNTRY_FIELD_LABEL:new Kc,EMAIL_FIELD_LABEL:new Kc,ERROR:new Wc,FORGOT_PASSWORD_LINK:new Kc,LINK_ACCOUNT_BUTTON:new Kc,LOADING:new Kc,LOGIN_BUTTON:new Kc,LOGIN_FORM_TITLE:new Kc,LOGIN_FROM_REGISTRATION_LINK:new Kc,LOGIN_INCENTIVE:new Kc,LOGOUT_BUTTON:new Kc,MARKETING_PERMISSION_TOGGLE_LABEL:new Kc,MODS_NEED_INTERNET:new Kc,NO_INTERNET_CONNECTION:new Kc,PARADOX_ACCOUNT:new Kc,PASSWORD_FIELD_LABEL:new Kc,PASSWORD_RESET_CONFIRMATION_TEXT:new Kc("EMAIL"),PDX_ACCOUNT_LINK_OVERWRITE_PROMPT_TEXT:new Wc,PDX_MODS_BUTTON:new Kc,PDX_PLATFORM_ACCOUNT_LINK_OVERWRITE_PROMPT_TEXT:new Wc,PLATFORM_ACCOUNT_LINK_OVERWRITE_PROMPT_TEXT:new Wc,PRIVACY_POLICY:new Kc,REGISTRATION_CONFIRMATION_TEXT:new Kc,REGISTRATION_CONFIRMATION_TITLE:new Kc,REGISTRATION_FORM_TITLE:new Kc,REGISTRATION_FROM_LOGIN_LINK:new Kc,REGISTRATION_HINT:new Kc,REMEMBER_ME_TOGGLE_LABEL:new Kc,SDK_DISABLED:new Kc,SKIP_BUTTON:new Kc,SUBMIT_REGISTRATION_BUTTON:new Kc,TERMS_OF_USE:new Kc,TERMS_PRIVACY_NOTICE:new Kc,UGC_DISABLED:new Kc,UNKNOWN_ERROR:new Kc,UNLINK_ACCOUNT_BUTTON:new Kc},PhotoMode:{CAPTURE_PROPERTY_TOOLTIP:new Kc,CLOUDEROSIONNOISE:new Wc,DEPTHOFFIELDMODE:new Wc,ENABLE_PROPERTY_TOOLTIP:new Kc,ENVIRONMENT_DISCLAIMER:new Kc,FILMGRAINLOOKUP:new Wc,GATEFITMODE:new Wc,HIDE_UI:new Kc,PROPERTY_LIMIT_MAX:new Kc,PROPERTY_LIMIT_MIN:new Kc,PROPERTY_TITLE:new Wc,PROPERTY_TOOLTIP:new Wc,RESET_PROPERTY_TOOLTIP:new Kc,SENSORTYPE:new Wc,TAB:new Wc,TAKE_PHOTO:new Kc,TITLE:new Kc,TOGGLE_FIRST_PERSON_MODE:new Kc,TOGGLE_ORBIT_MODE:new Kc},PoliceInfoPanel:{ARRESTED_CRIMINALS:new Kc,AVERAGE_CRIME_PROBABILITY:new Kc,CRIME_SUCCESS_RATE:new Kc,CURRENT_NUMBER_OF_CRIMINALS:new Kc,IN_JAIL:new Kc,IN_PRISON:new Kc,JAIL_AVAILABILITY:new Kc,NUMBER_OF_CRIMES_PER_MONTH:new Kc,PRISONERS:new Kc,PRISON_AVAILABILITY:new Kc},Policy:{DESCRIPTION:new Wc,TITLE:new Wc},PopulationInfoPanel:{ADULTS:new Kc,AGE_DISTRIBUTION:new Kc,BIRTH_RATE:new Kc,CHILDREN:new Kc,DEATH_RATE:new Kc,EMPLOYED:new Kc,JOBS:new Kc,MOVED_AWAY:new Kc,MOVED_IN:new Kc,POPULATION:new Kc,SENIORS:new Kc,TEENS:new Kc,UNEMPLOYMENT:new Kc},PostInfoPanel:{COLLECTED_MAIL:new Kc,DELIVERED_MAIL:new Kc,MAIL_RATE:new Kc,MAIL_SERVICE_AVAILABILITY:new Kc},Progression:{AVAILABLE_DEV_POINTS:new Kc("VALUE"),BUILDING_UNLOCK_EVENT_PANEL_TITLE:new Kc,BUILD_LATER_BUTTON:new Kc,BUILD_NOW_BUTTON:new Kc,DEVELOPMENT_POINTS_FIELD_LABEL:new Kc,DEV_TREE_UNLOCK_BADGE:new Kc,HAPPINESS_REQUIREMENT:new Kc("VALUE"),INCLUDES_LABEL:new Kc,LOAN_LIMIT:new Kc,MAP_TILES_FIELD_LABEL:new Kc,MAX_MILESTONE_FIELD_LABEL:new Kc,MILESTONE_DESCRIPTION:new zc,MILESTONE_DETAIL_SUBTITLE:new Kc("INDEX"),MILESTONE_NAME:new zc,MILESTONE_PROGRESS:new Kc("CURRENT","TARGET"),MILESTONE_REWARDS_LABEL:new Kc,MILESTONE_UNLOCK_PANEL_TITLE_PRIMARY:new Kc("INDEX"),MILESTONE_UNLOCK_PANEL_TITLE_SECONDARY:new Kc,MILESTONE_UNLOCK_REQUIREMENT:new Kc("INDEX","NAME"),NODE_DESCRIPTION:new Wc,NODE_DEV_POINTS_REQUIREMENT:new Kc,NODE_LOCKED:new Kc,NODE_MILESTONE_REQUIREMENT:new Kc("INDEX"),NODE_NAME:new Wc,NODE_PARENT_REQUIREMENT:new Kc,NODE_UNLOCKED:new Kc,NODE_UNLOCK_REQUIREMENT:new Kc("NAME"),OBJECT_BUILT_REQUIREMENT:new Wc("CURRENT","TARGET"),PANEL_TITLE:new Kc,POINTS_LABEL:new Kc("POINTS"),POPULATION_REQUIREMENT:new Kc("VALUE"),PROCESSING_REQUIREMENT:new Kc("RESOURCE","CURRENT","TARGET"),PROGRESSION_PANEL_BUTTON:new Kc,PURCHASE_BUTTON_AVAILABLE:new Kc,PURCHASE_BUTTON_LOCKED:new Kc,PURCHASE_BUTTON_MILESTONE:new Kc("MILESTONE"),PURCHASE_BUTTON_POINTS:new Kc,PURCHASE_BUTTON_UNLOCKED:new Kc,PURCHASE_COST:new Kc("COST"),RADIO_MAST_REQUIREMENT:new Kc("CURRENT","TARGET"),REQUIREMENT:new Kc,REQUIREMENTS:new Kc,REQUIRES_ALL:new Kc,REQUIRES_ANY:new Kc,REWARD_FIELD_LABEL:new Kc,STRICT_OBJECT_BUILT_REQUIREMENT:new Kc("NAME","CURRENT","TARGET"),TAB_TITLE:new Wc,TOOLTIP_DESCRIPTION_EXPANSION_PERMITS:new Kc,TOOLTIP_DESCRIPTION_MONEY:new Kc,TOOLTIP_DESCRIPTION_POINTS:new Kc,TOOLTIP_DESCRIPTION_POINTS_COST:new Kc,TOOLTIP_DESCRIPTION_TAB:new Wc,TOOLTIP_TITLE_EXPANSION_PERMITS:new Kc,TOOLTIP_TITLE_MONEY:new Kc,TOOLTIP_TITLE_POINTS:new Kc,TOOLTIP_TITLE_POINTS_COST:new Kc,TOOLTIP_TITLE_TAB:new Wc,TUTORIAL_REQUIREMENT:new Kc,UNLOCK_NODE_BUTTON:new Kc,XP_REASON:new Wc,ZONE_BUILT_REQUIREMENT_CELLS:new Kc("ZONE","CURRENT","TARGET"),ZONE_BUILT_REQUIREMENT_CELLS_LEVEL:new Kc("LEVEL","ZONE","CURRENT","TARGET"),ZONE_BUILT_REQUIREMENT_COUNT:new Kc("ZONE","CURRENT","TARGET"),ZONE_BUILT_REQUIREMENT_COUNT_LEVEL:new Kc("LEVEL","ZONE","CURRENT","TARGET")},Properties:{ADJUST_HAPPINESS_MODIFIER_EFFECT:new Kc("DELTA","TYPE","TARGET"),ADJUST_HAPPINESS_MODIFIER_TARGET:new Wc,ADJUST_HAPPINESS_MODIFIER_TYPE:new Wc,AMBULANCE_COUNT:new Kc,ATTRACTION_EFFECT:new Kc("VALUE"),ATTRACTIVENESS:new Kc,BATTERY_CAPACITY:new Kc,BATTERY_POWER_OUTPUT:new Kc,CARGO_CAPACITY:new Kc,CITY_MODIFIER:new Wc,CITY_MODIFIER_EFFECT:new Kc("DELTA","TYPE"),COMFORT:new Kc,CONSTRUCTION_COST:new Kc,DECEASED_PROCESSING_CAPACITY:new Kc,DECEASED_STORAGE:new Kc,ELECTRICITY_CONSUMPTION:new Kc,EVACUATION_BUS_COUNT:new Kc,FIRE_ENGINE_COUNT:new Kc,FIRE_HELICOPTER_COUNT:new Kc,GARBAGE_ACCUMULATION:new Kc,GARBAGE_PROCESSING_CAPACITY:new Kc,GARBAGE_STORAGE:new Kc,GARBAGE_TRUCK_COUNT:new Kc,HEARSE_COUNT:new Kc,JAIL_CAPACITY:new Kc,LEISURE_PROVIDER_EFFECT:new Kc("EFFICIENCY","TYPE"),LEISURE_TYPE:new Wc,LOCAL_MODIFIER:new Wc,LOCAL_MODIFIER_EFFECT:new Kc("DELTA","TYPE","RADIUS"),MAIL_BOX_CAPACITY:new Kc,MAIL_SORTING_RATE:new Kc,MAIL_STORAGE_CAPACITY:new Kc,MAINTENANCE_VEHICLES:new Kc,MAP_RESOURCE:new Wc,MAX_UPKEEP:new Kc,MEDICAL_HELICOPTER_COUNT:new Kc,NETWORK_CAPACITY:new Kc,NETWORK_RANGE:new Kc,PATIENT_CAPACITY:new Kc,PATROL_CAR_COUNT:new Kc,POLICE_HELICOPTER_COUNT:new Kc,POST_TRUCK_COUNT:new Kc,POST_VAN_COUNT:new Kc,POWER_LINE_CAPACITY:new Kc,POWER_PLANT_OUTPUT:new Kc,POWER_VOLTAGE_FORMAT:new Kc("VALUE","VOLTAGE"),PRISON_VAN_COUNT:new Kc,REQUIRED_RESOURCE:new Kc,RESOURCE_CONSUMPTION:new Kc,SEWAGE_CAPACITY:new Kc,SEWAGE_PIPE_CAPACITY:new Kc,SEWAGE_PURIFICATION_RATE:new Kc,SHELTER_CAPACITY:new Kc,STUDENT_CAPACITY:new Kc,TRANSFORMER_CAPACITY:new Kc,TRANSFORMER_INPUT:new Kc,TRANSFORMER_OUTPUT:new Kc,TRANSPORT_STOP_COUNT:new Wc,TRANSPORT_VEHICLE_COUNT:new Kc,UPKEEP:new Kc,VOLTAGE:new zc,WATER_CAPACITY:new Kc,WATER_CONSUMPTION:new Kc,WATER_PIPES:new Kc,WATER_PIPE_CAPACITY:new Kc,WATER_PIPE_TYPE:new Wc,WATER_PURIFICATION_RATE:new Kc,WATER_STORAGE:new Kc},Radio:{ADS_BUTTON_TOOLTIP:new Kc,EMERGENCY_MESSAGE:new Wc,FOCUS_EMERGENCY:new Kc,MUTE:new Kc,NETWORK_DESCRIPTION:new Wc,NETWORK_TITLE:new Wc,NEXT_BUTTON_TOOLTIP:new Kc,PANEL_TITLE:new Kc,PAUSE_BUTTON_TOOLTIP:new Kc,PLAY_BUTTON_TOOLTIP:new Kc,PREVIOUS_BUTTON_TOOLTIP:new Kc,PROGRAM_TITLE:new Kc,UNMUTE:new Kc,VOLUME_BUTTON_TOOLTIP:new Kc},Resources:{TITLE:new Wc},RoadsInfoPanel:{PARKED_CARS:new Kc,PARKING_AVAILABILITY:new Kc,PARKING_INCOME:new Kc,TRAFFIC_FLOW:new Kc},SelectedInfoPanel:{ACTIVE_VEHICLES:new Kc,ADVISER:new Kc,AIR_POLLUTION:new Kc,ALL_IS_WELL:new Kc,ANIMAL_TITLE:new Wc,ANIMAL_TYPE:new Wc,ATTRACTIVENESS:new Kc,ATTRACTIVENESS_BASE:new Kc,ATTRACTIVENESS_FACTORS:new Wc,AVERAGE_HOUSEHOLD_WEALTH:new Kc,BATTERY_STATE_CHARGING:new Kc,BATTERY_STATE_DISCHARGING:new Kc,BATTERY_STATE_IDLE:new Kc,BEGIN_EMPTYING:new Kc,BUILDING_FOR_RENT:new Kc,CARGO_TITLE:new Wc,CARGO_TOOLTIP:new Kc,CARGO_TRANSPORT_ROUTE:new Kc,CARGO_TRANSPORT_VEHICLE_TITLE:new Kc,CITIZEN_AGE:new Wc,CITIZEN_AGE_FEMALE:new Wc,CITIZEN_AGE_MALE:new Wc,CITIZEN_AGE_TITLE:new Kc,CITIZEN_CONDITION:new Kc,CITIZEN_CONDITION_DESCRIPTION:new Wc,CITIZEN_CONDITION_TITLE:new Wc,CITIZEN_CONDITION_TITLE_FEMALE:new Wc,CITIZEN_CONDITION_TITLE_MALE:new Wc,CITIZEN_DESTINATION:new Wc,CITIZEN_EDUCATION:new Wc,CITIZEN_EDUCATION_FEMALE:new Wc,CITIZEN_EDUCATION_MALE:new Wc,CITIZEN_EDUCATION_TITLE:new Kc,CITIZEN_HAPPINESS:new Kc,CITIZEN_HAPPINESS_DESCRIPTION:new Wc,CITIZEN_HAPPINESS_TITLE:new Wc,CITIZEN_HAPPINESS_TITLE_FEMALE:new Wc,CITIZEN_HAPPINESS_TITLE_MALE:new Wc,CITIZEN_HOUSEHOLD:new Kc,CITIZEN_JOB_LEVEL:new Wc,CITIZEN_JOB_TITLE:new Kc,CITIZEN_OCCUPATION:new Wc,CITIZEN_OCCUPATION_FEMALE:new Wc,CITIZEN_OCCUPATION_MALE:new Wc,CITIZEN_OCCUPATION_TITLE:new Kc,CITIZEN_RESIDENCE:new Wc,CITIZEN_SCHOOL_TITLE:new zc,CITIZEN_STATE:new Wc,CITIZEN_STATE_FEMALE:new Wc,CITIZEN_STATE_MALE:new Wc,CITIZEN_TYPE:new Wc,CITIZEN_TYPE_FEMALE:new Wc,CITIZEN_TYPE_MALE:new Wc,CITIZEN_WEALTH:new Wc,CITIZEN_WEALTH_FEMALE:new Wc,CITIZEN_WEALTH_MALE:new Wc,CITIZEN_WEALTH_TITLE:new Kc,CITIZEN_WORKPLACE:new Wc,CLOSE:new Kc,COLOR:new Kc,COMPANY:new Kc,COMPANY_EXTRACTED:new Wc,COMPANY_PRODUCES:new Kc,COMPANY_PROFITABILITY_TITLE:new Wc,COMPANY_REQUIRES:new Kc,COMPANY_SELLS:new Kc,COMPANY_STORES:new Kc,CONFIRM_DELETE_WARNING:new Kc,CREATE_DISTRICT:new Kc,DEATHCARE_BODIES:new Kc,DEATHCARE_PROCESSING_SPEED:new Kc,DEATHCARE_TITLE:new Kc,DEATHCARE_VEHICLES:new Wc,DEATHCARE_VEHICLE_DEAD:new Kc,DEATHCARE_VEHICLE_TITLE:new Kc,DELETE:new Kc,DELIVERY_VEHICLE_TITLE:new Wc,DESTINATION:new Kc,DESTROYED:new Kc,DESTROYED_DESCRIPTION:new Wc,DESTROYED_STATUS:new Wc,DESTROYED_TREE:new Kc,DESTROYED_TREE_DESCRIPTION:new Wc,DETAILS:new Kc,DEVELOPER_INFO_TITLE:new Kc,DISPATCHED_VEHICLES:new Kc,DRIVER:new Kc,DURATION_GREATER_YEAR:new Kc,EDUCATED:new Kc,EDUCATION:new Kc,EDUCATION_DROPOUT_RATE:new Kc,EDUCATION_GRADUATION_TIME:new Kc,EDUCATION_LEVELS:new Wc,EDUCATION_NO_GRADUATIONS:new Kc,EDUCATION_STUDENTS:new Kc,EFFICIENCY:new Kc,EFFICIENCY_FACTORS:new Wc,ELECTRICITY_BATTERY_CAPACITY:new Kc,ELECTRICITY_BATTERY_CHARGE:new Kc,ELECTRICITY_BATTERY_FLOW:new Kc,ELECTRICITY_BATTERY_STATE:new Kc,ELECTRICITY_POWER_PRODUCTION:new Kc,ELECTRICITY_POWER_USAGE:new Kc,ELECTRICITY_TITLE:new Kc,ELECTRICITY_TRANSFORMER_CAPACITY:new Kc,EMPLOYEES:new Kc,EMPLOYEE_COUNT:new Kc("AMOUNT"),EMPTY_IN:new Kc("DURATION"),EXPENSES:new Kc,FIRE_TITLE:new Kc,FIRE_VEHICLES:new Wc,FIRE_VEHICLE_TITLE:new Wc,FOCUS:new Kc,FOLLOW_CITIZEN:new Kc,FULL_IN:new Kc("DURATION"),GARBAGE_MANAGEMENT_PROCESSING_SPEED:new Kc,GARBAGE_MANAGEMENT_STORAGE_LABEL:new Wc,GARBAGE_MANAGEMENT_STORED_GARBAGE:new Kc,GARBAGE_MANAGEMENT_TITLE:new Kc,GARBAGE_MANAGEMENT_VEHICLES:new Wc,GARBAGE_VEHICLE_TITLE:new Wc,GRAVES_IN_USE:new Kc,GROUND_POLLUTION:new Kc,HEALTHCARE_PATIENTS:new Kc,HEALTHCARE_TITLE:new Kc,HEALTHCARE_VEHICLES:new Wc,HEALTHCARE_VEHICLE_PATIENT:new Kc,HEALTHCARE_VEHICLE_TITLE:new Wc,HIGHTLY_EDUCATED:new Kc,HOUSEHOLDS:new Kc,HOUSEHOLD_MEMBERS:new Kc,LEVEL:new Kc,LEVEL_MAX:new Kc,LEVEL_PROGRESS:new Kc,LINE:new Kc,LINES:new Kc,LINE_USAGE:new Kc,LINE_VISUALIZER_LENGTH:new Kc,LINE_VISUALIZER_STOPS:new Kc,LINE_VISUALIZER_TITLE:new Kc,LINE_VISUALIZER_VEHICLES:new Kc,LOAD_TITLE:new Wc,LOCAL_SERVICES_NONE_ASSIGNED:new Kc,LOCAL_SERVICES_TITLE:new Kc,LOT_TOOL_TOOLTIP:new Kc,MAIL_PROCESSING_SPEED:new Kc,MAIL_SORTING_SPEED:new Kc,MAIL_STORED_MAIL:new Wc,MAIL_TITLE:new Kc,MAIL_VEHICLES:new Wc,MAINTENANCED_VEHICLES:new Kc,MAINTENANCE_VEHICLE_TITLE:new Kc,MAX_FOLLOWED_CITIZENS_REACHED:new Kc,NEXT_STOP:new Kc,NOISE_POLLUTION:new Kc,NOTIFICATIONS:new Kc,NO_ACTIVE_POLICIES:new Kc,OPEN_POSITIONS:new Kc,OPERATING_DISTRICTS:new Kc,ORIGIN:new Kc,OUTSIDE_CONNECTION:new Kc,OUT_OF_SERVICE:new Kc,OWNED_BY:new Kc,PARKING_FEE:new Kc,PARKING_PARKED:new Kc,PARKING_TITLE:new Kc,PARK_MAINTENANCE:new Kc,PARK_TITLE:new Kc,PASSENGERS:new Wc,PASSENGERS_TITLE:new Kc,PASSENGERS_TOOLTIP:new Kc,POLICE_PRISONERS:new Kc,POLICE_TITLE:new Kc,POLICE_VEHICLES:new Wc,POLICE_VEHICLE_CRIMINAL:new Kc,POLICE_VEHICLE_TITLE:new Wc,POLICIES:new Kc,POLLUTION:new Kc,POLLUTION_LEVELS:new zc,POLLUTION_LEVELS_AIR:new Kc,POLLUTION_LEVELS_GROUND:new Kc,POLLUTION_LEVELS_NOISE:new Kc,POORLY_EDUCATED:new Kc,POST_VEHICLE_TITLE:new Kc,PRISON_PRISONERS:new Kc,PRISON_TITLE:new Kc,PRISON_VEHICLES:new Wc,PRIVATE_VEHICLE_TITLE:new Wc,PRODUCTION:new Kc,PUBLIC_TRANSPORT_LINE:new Kc,PUBLIC_TRANSPORT_VEHICLE_TITLE:new Wc,REBUILD:new Kc,RELOCATE:new Kc,REMOVE_OPERATING_DISTRICT:new Kc,RESIDENTS:new Kc,RESOURCE:new Wc,ROAD_CONDITION:new Kc,ROAD_CONDITION_FORMAT:new Kc("WORST","BEST","AVG"),ROAD_LENGTH:new Kc,ROAD_TRAFFIC_FLOW:new Kc,ROAD_TRAFFIC_VOLUME:new Kc,ROAD_UPKEEP:new Kc,ROUTE:new Kc,SCHEDULE:new Kc,SCHEDULE_CONTINUOUS_TOOLTIP:new Wc,SCHEDULE_DAY_TOOLTIP:new Wc,SCHEDULE_NIGHT_TOOLTIP:new Wc,SELECT_OPERATING_DISTRICT:new Kc,SELECT_VEHICLE:new Kc,SELECT_VEHICLE_SECONDARY:new Wc,SEWAGE_OUTLET_USAGE:new Kc,SEWAGE_PROCESSING_CAPACITY:new Kc,SEWAGE_PURIFICATION_RATE:new Kc,SEWAGE_STORAGE:new Kc,SEWAGE_TITLE:new Kc,SHELTER_OCCUPANTS:new Kc,SHELTER_TITLE:new Kc,SHELTER_VEHICLES:new Wc,STOP_EMPTYING:new Kc,TICKET_PRICE:new Kc,TICKET_PRICE_FREE:new Kc,TOOLTIP:new Wc,TOOLTIP_TITLE:new Wc,TRAFFIC_ACCIDENT:new Kc,UNDER_CONSTRUCTION:new Kc,UNEDUCATED:new Kc,UNFOCUS:new Kc,UNFOLLOW_CITIZEN:new Kc,UPGRADE:new Kc,UPGRADES:new Kc,UPGRADE_ALREADY_BUILT:new Kc,UPGRADE_LOCKED:new Kc,UPGRADE_LOCKED_LABEL:new Kc,UPGRADE_NO_MONEY_LABEL:new Kc,UPGRADE_PURCHASED_LABEL:new Kc,UPGRADE_TYPE_LABEL:new Wc,UPKEEP:new Kc,UPKEEPFORMAT:new Kc("RESOURCE","AMOUNT"),UPKEEP_MAINTENANCE:new Kc("BUILDING"),UPKEEP_MAINTENANCE_INACTIVE:new Kc("BUILDING"),UPKEEP_TOTAL:new Kc,VEHICLES:new Wc,VEHICLE_COUNT:new Kc,VEHICLE_STATE:new Kc,VEHICLE_STATES:new Wc,WAGES:new Kc,WAITING_PASSENGERS:new Kc,WAREHOUSE_STORAGE:new Kc,WATER_OUTPUT:new Kc,WATER_PUMPING_CAPACITY:new Kc,WATER_PUMP_POLLUTION:new Kc,WATER_PUMP_USAGE:new Kc,WATER_STORAGE:new Kc,WATER_STORAGE_CHANGE:new Kc("TIME","CHANGE"),WATER_STORAGE_FULL_IN:new Kc,WATER_STORAGE_LASTS:new Kc,WATER_TITLE:new Kc,WELL_EDUCATED:new Kc,WORKPLACES:new Kc,WORKPLACE_COUNT:new Kc("AMOUNT"),WORK_SHIFT:new Kc},Services:{DESCRIPTION:new Wc,NAME:new Wc},Statistics:{PANEL_TITLE:new Kc,STATISTIC:new Wc},StatisticsPanel:{STAT_TITLE:new Wc,TIME_SCALE:new zc,TIME_SCALE_NOW:new Kc,TIME_SCALE_TITLE:new Kc},SubServices:{NAME:new Wc},ToolOptions:{COLOR_TITLE:new Wc,COLOR_TOOLTIP:new Wc,TOOLTIP:new Wc,TOOLTIP_DECREASE_BRUSH_SIZE:new Kc,TOOLTIP_DECREASE_BRUSH_STRENGTH:new Kc,TOOLTIP_DECREASE_ELEVATION:new Kc,TOOLTIP_DESCRIPTION:new Wc,TOOLTIP_ELEVATION_STEP:new Kc,TOOLTIP_INCREASE_BRUSH_SIZE:new Kc,TOOLTIP_INCREASE_BRUSH_STRENGTH:new Kc,TOOLTIP_INCREASE_ELEVATION:new Kc,TOOLTIP_SNAP_ALL:new Kc,TOOLTIP_TITLE:new Wc},Toolbar:{ASSET_ALREADY_BUILT:new Kc,BRUSH_SIZE:new Kc,BRUSH_STRENGTH:new Kc,CALENDAR_PANEL_TOGGLE_TOOLTIP:new Kc,CHIRPER_PANEL_TOGGLE_TOOLTIP:new Kc,CITY_INFO_PANEL_TOGGLE_TOOLTIP:new Kc,CITY_NAME_FIELD_TOOLTIP:new Kc,CURRENT_TREND:new Kc,DECREASE_PARALLEL_OFFSET:new Kc,ECONOMY_PANEL_TOGGLE_TOOLTIP:new Kc,ELEVATION_TITLE:new Kc,INCREASE_PARALLEL_OFFSET:new Kc,JOURNAL_PANEL_TOGGLE_TOOLTIP:new Kc,LIFEPATH_PANEL_TOGGLE_TOOLTIP:new Kc,MAP_TILE_PURCHASE_TOGGLE_TOOLTIP:new Kc,MONEY_FIELD_TOOLTIP:new Kc,PARALLEL_MODE_TITLE:new Kc,PARALLEL_OFFSET_TITLE:new Kc,PARALLEL_ROAD_TITLE:new Kc,PAUSE_BUTTON_TOOLTIP:new Kc,PHOTO_MODE_TOGGLE_TOOLTIP:new Kc,PLAY_BUTTON_TOOLTIP:new Kc,POPULATION_FIELD_TOOLTIP:new Kc,PROGRESSION_PANEL_TOGGLE_TOOLTIP:new Kc,SIMULATION_PAUSED:new Kc,SNAPPING_TITLE:new Kc,SPEED_BUTTON_TOOLTIP:new Kc,STATISTICS_PANEL_TOGGLE_TOOLTIP:new Kc,THEME_PANEL_TITLE:new Kc,TOGGLE_PARALLEL_MODE:new Kc,TOGGLE_UNDERGROUND_MODE:new Kc,TOOL_MODE_TITLE:new Kc,TOOL_OPTIONS_PANEL_TITLE:new Kc,UNDERGROUND_MODE_TITLE:new Kc,XP_MESSAGE:new Kc("XP","REASON"),XP_PROGRESS:new Kc("CURRENT","NEXT")},Tools:{BATTERY_CHARGE:new Kc,BATTERY_FLOW:new Kc,CONFIRM_BULLDOZE_WARNING:new Kc,CONSTRUCTION_COST_LABEL:new Kc,ELECTRICITY_CONSUMPTION_LABEL:new Kc,ELECTRICITY_FLOW_LABEL:new Kc,ELECTRICITY_PRODUCTION_LABEL:new Kc,EXTRACTOR_CLIMATE_REQUIRED_AVAILABLE:new Kc,EXTRACTOR_CLIMATE_REQUIRED_UNAVAILABLE:new Kc,EXTRACTOR_MAP_FEATURE_REQUIRED_AVAILABLE:new Kc,EXTRACTOR_MAP_FEATURE_REQUIRED_MISSING:new Kc,EXTRACTOR_PRODUCTION_DEFICIT:new Kc,EXTRACTOR_PRODUCTION_SURPLUS:new Kc,GROUNDWATER_VOLUME:new Kc,GROUND_WATER_RESERVOIR_USAGE:new Kc,INFO:new Wc,MOVING_OBJECT:new Kc("OBJECT"),REFUND_AMOUNT_LABEL:new Kc,RESOURCES_LABEL:new Kc,SELECTING_DISTRICTS:new Kc,SEWAGE_CONSUMPTION_LABEL:new Kc,SEWAGE_FLOW_LABEL:new Kc,STORAGECAPACITY_LABEL:new Kc,TOOL_MODE:new Wc,WARNING:new Wc,WATER_CONSUMPTION_LABEL:new Kc,WATER_FLOW_LABEL:new Kc,WATER_OUTPUT_LABEL:new Kc,WATER_REFRESH_RATE_LABEL:new Kc},TourismInfoPanel:{ATTRACTIVENESS:new Kc,AVERAGE_HOTEL_PRICE:new Kc,TOURISM_RATE:new Kc,WEATHER_EFFECT:new Kc},Transport:{LEGEND_ACTIVE:new Kc,LEGEND_ACTIVITY:new Kc,LEGEND_CARGO:new Kc,LEGEND_COLOR:new Kc,LEGEND_DELETE:new Kc,LEGEND_FOCUS:new Kc,LEGEND_LENGTH:new Kc,LEGEND_NAME:new Kc,LEGEND_PASSENGERS:new Wc,LEGEND_SHOW:new Kc,LEGEND_STOPS:new Wc,LEGEND_USAGE:new Kc,LEGEND_VEHICLES:new Wc,LEGEND_VISIBLE:new Kc,LINES:new Wc,LINES_OVERVIEW_BUTTON:new Kc,LINES_OVERVIEW_TITLE:new Kc,NO_LINES:new Kc,NO_ROUTES:new Kc,ROUTES:new Wc,TAB:new Wc,TOOLTIP_ACTIVE:new Wc,TOOLTIP_COLOR:new Wc,TOOLTIP_DELETE:new Wc,TOOLTIP_DETAILS:new Wc,TOOLTIP_SCHEDULE:new Wc,TOOLTIP_VISIBLE:new Wc},TransportInfoPanel:{CARGO_LABEL:new Kc,CARGO_TRANSPORT_TITLE:new Kc,CITIZENS:new Kc,LINES:new Kc,PUBLIC_TRANSPORT_TITLE:new Kc,ROUTES_LABEL:new Kc,SUMMARY_TOOLTIP_CARGO:new Wc,SUMMARY_TOOLTIP_PUBLICTRANSPORT:new Wc,TOTAL:new Kc,TOURISTS:new Kc},Tutorials:{ADVISOR_TITLE:new Kc,BEFORE_STARTING:new Kc,BEFORE_STARTING_CONFIRM:new Kc,BEGIN_WITH_TUTORIALS:new Kc,BUTTON_TOOLTIP_DONE:new Kc,BUTTON_TOOLTIP_NEXT:new Kc,BUTTON_TOOLTIP_PREVIOUS:new Kc,DESCRIPTION:new Wc,DESCRIPTION_GAMEPAD:new Wc,DESCRIPTION_KEYBOARD:new Wc,DISABLE_CONFIRMATION_TEXT:new Kc,DISABLE_CONFIRMATION_TEXT_GAMEPAD:new Kc,ENABLE_TUTORIALS_CONFIRM:new Kc,HINTS_TITLE:new Kc,INTRO:new Kc,INTRO_SUBTITLE:new Kc,INTRO_TITLE:new Kc,LIST_REMINDER_DESCRIPTION:new Kc,LIST_REMINDER_TITLE:new Kc,TASKS:new Kc,TITLE:new Wc,TODO_INTRO:new Kc,TODO_INTRO_CONFIRM:new Kc,TODO_OUTRO:new Kc,TODO_OUTRO_CONTINUE:new Kc,TODO_OUTRO_GAMEPAD:new Kc,TODO_OUTRO_NEW_CITY:new Kc,TRIGGER:new Wc},UpgradesMenu:{TITLE:new Kc},VirtualKeyboard:{TITLE:new Wc},WaterInfoPanel:{SEWAGE_TRADE:new Kc,SEWAGE_TREATMENT:new Kc,STORMWATER_TREATMENT:new Kc,WATER_AVAILABILITY:new Kc,WATER_EXPORT:new Kc,WATER_IMPORT:new Kc,WATER_STORAGE:new Kc,WATER_TRADE:new Kc},WaterPollutionInfoPanel:{AVERAGE_WATER_POLLUTION:new Kc},WhatsNew:{BEACH_PROPERTIES_P1_DESCRIPTION:new Kc,BEACH_PROPERTIES_P1_HEADER:new Kc,BEACH_PROPERTIES_P1_TITLE:new Kc,BEACH_PROPERTIES_P2_DESCRIPTION:new Kc,BEACH_PROPERTIES_P2_HEADER:new Kc,BEACH_PROPERTIES_P2_TITLE:new Kc,BEACH_PROPERTIES_P3_DESCRIPTION:new Kc,BEACH_PROPERTIES_P3_HEADER:new Kc,BEACH_PROPERTIES_P3_TITLE:new Kc,WHATS_NEW:new Kc},WorkplacesInfoPanel:{AVAILABILITY:new Kc,WORKERS:new Kc,WORKPLACES:new Kc,WORKPLACE_DISTRIBUTION:new Kc},ZoningFactors:{NEGATIVE:new Wc,PANEL_TITLE:new Kc,POSITIVE:new Wc}});function Xc(e){return 9*e/5+32}function Qc(e){return e+273.16}function Zc(e){return 264.172*e}function Jc(e){return e/.45359237}function eu(e){return e/907.18474}function tu(e){return e/.9144}function nu(e){return e/1.609344}function ru(e){return e/.092903}function iu(e){return e/4046.873}function ou(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}oe.add("game-ui/common/localization/loc.generated.ts",{get Loc(){return qc},set Loc(e){qc=e}}),function(e){e.Integer="integer",e.IntegerRounded="integerRounded",e.IntegerPerMonth="integerPerMonth",e.IntegerPerHour="integerPerHour",e.FloatSingleFraction="floatSingleFraction",e.FloatTwoFractions="floatTwoFractions",e.FloatThreeFractions="floatThreeFractions",e.Percentage="percentage",e.PercentageSingleFraction="percentageSingleFraction",e.Angle="angle",e.Length="length",e.Area="area",e.Volume="volume",e.VolumePerMonth="volumePerMonth",e.Weight="weight",e.WeightPerCell="weightPerCell",e.WeightPerMonth="weightPerMonth",e.Power="power",e.Energy="energy",e.DataRate="dataRate",e.DataBytes="dataBytes",e.DataMegabytes="dataMegabytes",e.Money="money",e.MoneyPerCell="moneyPerCell",e.MoneyPerMonth="moneyPerMonth",e.MoneyPerHour="moneyPerHour",e.MoneyPerDistance="moneyPerDistance",e.MoneyPerDistancePerMonth="moneyPerDistancePerMonth",e.BodiesPerMonth="bodiesPerMonth",e.XP="xp",e.Temperature="temperature",e.NetElevation="netElevation"}($c||($c={})),oe.add("game-ui/common/localization/unit.ts",{get Unit(){return $c},set Unit(e){$c=e}}),oe.add("game-ui/common/localization/units-us-customary.ts",{get fahrenheit(){return Xc},set fahrenheit(e){Xc=e},get kelvin(){return Qc},set kelvin(e){Qc=e},get gallons(){return Zc},set gallons(e){Zc=e},get pounds(){return Jc},set pounds(e){Jc=e},get shortTons(){return eu},set shortTons(e){eu=e},get yards(){return tu},set yards(e){tu=e},get miles(){return nu},set miles(e){nu=e},get squareFeet(){return ru},set squareFeet(e){ru=e},get acres(){return iu},set acres(e){iu=e}});var au,su=jc("LocalizedNumber",(function(e,t){var n=t.value,r=t.unit,i=void 0===r?$c.Integer:r,o=t.signed,a=void 0!==o&&o;return cu(i)(e,n,a)}),(function(e,t){return e.value===t.value&&e.unit===t.unit&&e.signed===t.signed}));function lu(e,t){var n=vc();return(0,Y.useMemo)((function(){var r=cu(e);return function(e){return r(n,e,t)}}),[n,t,e])}function cu(e){var t;return null!==(t=uu[e])&&void 0!==t?t:function(t,n){return"".concat(n," <").concat(e,">")}}var uu=(ou(au={},$c.Integer,(function(e,t,n){return du(e,t,n,!0)})),ou(au,$c.IntegerRounded,(function(e,t,n){return Math.abs(t)<1e3?du(e,t,n,!0):Math.abs(t)<1e6?hu(e,t/1e3,qc.Common.VALUE_THOUSAND,n,1):hu(e,t/1e6,qc.Common.VALUE_MILLION,n,1)})),ou(au,$c.IntegerPerMonth,(function(e,t,n){return fu(e,t,qc.Common.VALUE_PER_MONTH,n)})),ou(au,$c.IntegerPerHour,(function(e,t,n){return fu(e,t,qc.Common.VALUE_PER_HOUR,n)})),ou(au,$c.FloatSingleFraction,(function(e,t,n){return gu(e,t,n,1)})),ou(au,$c.FloatTwoFractions,(function(e,t,n){return gu(e,t,n,2)})),ou(au,$c.FloatThreeFractions,(function(e,t,n){return gu(e,t,n,3)})),ou(au,$c.Percentage,(function(e,t,n){return fu(e,t,qc.Common.VALUE_PERCENT,n,!1)})),ou(au,$c.PercentageSingleFraction,(function(e,t,n){return hu(e,t,qc.Common.VALUE_PERCENT,n,1,!1)})),ou(au,$c.Length,(function(e,t,n){return e.unitSettings.unitSystem===fc.Metric?Math.abs(t)<1e3?fu(e,t,qc.Common.VALUE_METER,n):hu(e,t/1e3,qc.Common.VALUE_KILOMETER,n,1):Math.abs(t)<1609?fu(e,tu(t),qc.Common.VALUE_YARD,n):hu(e,nu(t/1e3),qc.Common.VALUE_MILE,n,1)})),ou(au,$c.NetElevation,(function(e,t,n){return e.unitSettings.unitSystem===fc.Metric?hu(e,t,qc.Common.VALUE_METER,n,2):hu(e,3*t,qc.Common.VALUE_FOOT,n,2)})),ou(au,$c.Area,(function(e,t,n){return e.unitSettings.unitSystem===fc.Metric?Math.abs(t)<1e5?fu(e,t,qc.Common.VALUE_SQUARE_METER,n):hu(e,t/1e6,qc.Common.VALUE_SQUARE_KILOMETER,n,1):Math.abs(t)<1e5?fu(e,ru(t),qc.Common.VALUE_SQUARE_FOOT,n):hu(e,iu(t),qc.Common.VALUE_ACRE,n,1)})),ou(au,$c.Volume,(function(e,t,n){return e.unitSettings.unitSystem===fc.Metric?hu(e,t,qc.Common.VALUE_CUBIC_METER,n,1):fu(e,Zc(t),qc.Common.VALUE_GALLON,n)})),ou(au,$c.VolumePerMonth,(function(e,t,n){return e.unitSettings.unitSystem===fc.Metric?hu(e,t,qc.Common.VALUE_CUBIC_METER_PER_MONTH,n,1):hu(e,Zc(t),qc.Common.VALUE_GALLON_PER_MONTH,n,1)})),ou(au,$c.Weight,(function(e,t,n){return e.unitSettings.unitSystem===fc.Metric?Math.abs(t)<100?fu(e,t,qc.Common.VALUE_KILOGRAM,n):Math.abs(t)<1e7?hu(e,t/1e3,qc.Common.VALUE_TON,n,1):hu(e,t/1e6,qc.Common.VALUE_KILOTON,n,1):Math.abs(t)<100?fu(e,Jc(t),qc.Common.VALUE_POUND,n):Math.abs(t)<9071847.4?hu(e,eu(t),qc.Common.VALUE_SHORT_TON,n,1):hu(e,eu(t)/1e6,qc.Common.VALUE_SHORT_KILOTON,n,1)})),ou(au,$c.WeightPerCell,(function(e,t,n){return e.unitSettings.unitSystem===fc.Metric?hu(e,t/1e3,qc.Common.VALUE_TON_PER_CELL,n,1):hu(e,eu(t),qc.Common.VALUE_SHORT_TON_PER_CELL,n,1)})),ou(au,$c.WeightPerMonth,(function(e,t,n){return e.unitSettings.unitSystem===fc.Metric?Math.abs(t)<100?hu(e,t,qc.Common.VALUE_KG_PER_MONTH,n,1):hu(e,t/1e3,qc.Common.VALUE_TON_PER_MONTH,n,1):Math.abs(t)<100?hu(e,Jc(t),qc.Common.VALUE_POUND_PER_MONTH,n,1):hu(e,eu(t),qc.Common.VALUE_SHORT_TON_PER_MONTH,n,1)})),ou(au,$c.Power,(function(e,t,n){return Math.abs(t)<1e4?hu(e,t/10,qc.Common.VALUE_KILOWATT,n,1):hu(e,t/1e4,qc.Common.VALUE_MEGAWATT,n,2)})),ou(au,$c.Energy,(function(e,t,n){return hu(e,t/1e4,qc.Common.VALUE_MEGAWATT_HOURS,n,1)})),ou(au,$c.DataRate,(function(e,t,n){return hu(e,t,qc.Common.VALUE_GIGABIT_PER_SECOND,n,1)})),ou(au,$c.DataBytes,(function(e,t,n){return bu(e,t,pu,n,1)})),ou(au,$c.DataMegabytes,(function(e,t,n){return bu(e,1024*t*1024,vu,n,1)})),ou(au,$c.Money,(function(e,t,n){return fu(e,t,qc.Common.VALUE_MONEY,n)})),ou(au,$c.MoneyPerCell,(function(e,t,n){return hu(e,t,qc.Common.VALUE_MONEY_PER_CELL,n,1)})),ou(au,$c.MoneyPerMonth,(function(e,t,n){return fu(e,t,qc.Common.VALUE_MONEY_PER_MONTH,n)})),ou(au,$c.MoneyPerHour,(function(e,t,n){return fu(e,t,qc.Common.VALUE_MONEY_PER_HOUR,n)})),ou(au,$c.MoneyPerDistance,(function(e,t,n){return e.unitSettings.unitSystem===fc.Metric?fu(e,t,qc.Common.VALUE_MONEY_PER_KILOMETER,n):fu(e,t/1.6,qc.Common.VALUE_MONEY_PER_MILE,n)})),ou(au,$c.MoneyPerDistancePerMonth,(function(e,t,n){return e.unitSettings.unitSystem===fc.Metric?fu(e,t,qc.Common.VALUE_MONEY_PER_KILOMETER_PER_MONTH,n):fu(e,t/1.6,qc.Common.VALUE_MONEY_PER_MILE_PER_MONTH,n)})),ou(au,$c.XP,(function(e,t,n){return fu(e,t,qc.Common.VALUE_XP,n)})),ou(au,$c.Temperature,(function(e,t,n){switch(e.unitSettings.temperatureUnit){case dc.Celsius:return fu(e,t,qc.Common.VALUE_CELSIUS,n);case dc.Fahrenheit:return fu(e,Xc(t),qc.Common.VALUE_FAHRENHEIT,n);case dc.Kelvin:return fu(e,Qc(t),qc.Common.VALUE_KELVIN,n)}})),ou(au,$c.Angle,(function(e,t,n){return hu(e,t,qc.Common.VALUE_ANGLE,n,1)})),au);function du(e,t){var n=!(arguments.length>3&&void 0!==arguments[3])||arguments[3];return xu(t,arguments.length>2&&void 0!==arguments[2]&&arguments[2])+mu(e,t,n)}function fu(e,t,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3],i=!(arguments.length>4&&void 0!==arguments[4])||arguments[4];return n.renderString(e,{SIGN:xu(t,r),VALUE:mu(e,t,i)})}function mu(e,t,n){if(n){var r=qc.Common.THOUSANDS_SEPARATOR.renderString(e,{});return Math.abs(t).toFixed(0).replace(/\B(?=(\d{3})+(?!\d))/g,r)}return Math.abs(t).toFixed(0)}function gu(e,t){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1,r=!(arguments.length>4&&void 0!==arguments[4])||arguments[4],i=!(arguments.length>5&&void 0!==arguments[5])||arguments[5];return xu(t,arguments.length>2&&void 0!==arguments[2]&&arguments[2])+yu(e,t,n,r,i)}function hu(e,t,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3],i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:1,o=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],a=!(arguments.length>6&&void 0!==arguments[6])||arguments[6];return n.renderString(e,{SIGN:xu(t,r),VALUE:yu(e,t,i,o,a)})}var pu=[[0,qc.Common.VALUE_BYTE],[1,qc.Common.VALUE_KILOBYTE],[2,qc.Common.VALUE_MEGABYTE],[3,qc.Common.VALUE_GIGABYTE],[4,qc.Common.VALUE_TERABYTE]],vu=[[2,qc.Common.VALUE_MEGABYTE],[3,qc.Common.VALUE_GIGABYTE],[4,qc.Common.VALUE_TERABYTE]];function bu(e,t,n){for(var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3],i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:1,o=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],a=!(arguments.length>6&&void 0!==arguments[6])||arguments[6],s=n[n.length-1][1],l=t/Math.pow(1024,n[n.length-1][0]),c=0;c<n.length;++c){var u=Math.pow(1024,n[c][0]);if(Math.abs(t)<512*u){s=n[c][1],l=t/u;break}}return s.renderString(e,{SIGN:xu(t,r),VALUE:yu(e,l,i,o,a)})}function yu(e,t,n,r,i){t=Math.abs(t);var o,a=qc.Common.DECIMAL_SEPARATOR.renderString(e,{});if(t<100){var s=Math.pow(10,-n);0!==t&&t<s&&(t=s),o=t.toFixed(n),i&&(o=o.replace(/\.0+$|(\.\d*?[1-9])0+$/g,"$1")),o=o.replace(".",a)}else o=t.toFixed(0);if(r){var l=qc.Common.THOUSANDS_SEPARATOR.renderString(e,{});o=o.replace(/\B(?=(\d{3})+(?!\d))/g,l)}return o}function xu(e,t){return e<0?"-":e>0?t?"+":"":t?"±":""}function _u(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}oe.add("game-ui/common/localization/localized-number.tsx",{get LocalizedNumber(){return su},set LocalizedNumber(e){su=e},get useNumberFormat(){return lu},set useNumberFormat(e){lu=e},get formatInteger(){return du},set formatInteger(e){du=e},get formatFloat(){return gu},set formatFloat(e){gu=e},get sign(){return xu},set sign(e){xu=e}});var ju,Ou=jc("LocalizedBounds",(function(e,t){var n=t.min,r=t.max,i=t.unit,o=void 0===i?$c.Integer:i;return n!==r?function(e){var t;return null!==(t=Eu[e])&&void 0!==t?t:function(t,n,r){return"".concat(n,"–").concat(r," <").concat(e,">")}}(o)(e,n,r):su.renderString(e,{value:r,unit:o})}),(function(e,t){return e.min===t.min&&e.max===t.max&&e.unit===t.unit}));var Eu=(_u(ju={},$c.Power,(function(e,t,n){return Math.abs(n)<1e4?Tu(e,t/10,n/10,qc.Common.BOUNDS_KILOWATT,1):Tu(e,t/1e4,n/1e4,qc.Common.BOUNDS_MEGAWATT,1)})),_u(ju,$c.PercentageSingleFraction,(function(e,t,n){return Tu(e,t,n,qc.Common.BOUNDS_PERCENT,1)})),_u(ju,$c.Temperature,(function(e,t,n){switch(e.unitSettings.temperatureUnit){case dc.Celsius:return Su(e,t,n,qc.Common.BOUNDS_CELSIUS);case dc.Fahrenheit:return Su(e,Xc(t),Xc(n),qc.Common.BOUNDS_FAHRENHEIT);case dc.Kelvin:return Su(e,Qc(t),Qc(n),qc.Common.BOUNDS_KELVIN)}})),ju);function Su(e,t,n,r){var i=!(arguments.length>4&&void 0!==arguments[4])||arguments[4];return r.renderString(e,{MIN:du(e,t,!1,i),MAX:du(e,n,!1,i)})}function Tu(e,t,n,r){var i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:1,o=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],a=!(arguments.length>6&&void 0!==arguments[6])||arguments[6];return r.renderString(e,{MIN:gu(e,t,!1,i,o,a),MAX:gu(e,n,!1,i,o,a)})}function Iu(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}oe.add("game-ui/common/localization/localized-bounds.tsx",{get LocalizedBounds(){return Ou},set LocalizedBounds(e){Ou=e}});var wu,Pu=jc("LocalizedFraction",(function(e,t){var n=t.value,r=t.total,i=t.unit;return function(e){var t;return null!==(t=Cu[e])&&void 0!==t?t:function(t,n,r){return"".concat(n," / ").concat(r," <").concat(e,">")}}(void 0===i?$c.Integer:i)(e,n,r)}),(function(e,t){return e.value===t.value&&e.total===t.total&&e.unit===t.unit}));var Cu=(Iu(wu={},$c.Volume,(function(e,t,n){return e.unitSettings.unitSystem===fc.Metric?Au(e,t,n,qc.Common.FRACTION_CUBIC_METER,1):Au(e,Zc(t),Zc(n),qc.Common.FRACTION_GALLON,1)})),Iu(wu,$c.VolumePerMonth,(function(e,t,n){return e.unitSettings.unitSystem===fc.Metric?Au(e,t,n,qc.Common.FRACTION_CUBIC_METER_PER_MONTH,1):Au(e,Zc(t),Zc(n),qc.Common.FRACTION_GALLON_PER_MONTH,1)})),Iu(wu,$c.Weight,(function(e,t,n){return e.unitSettings.unitSystem===fc.Metric?Math.abs(n)<100?Nu(e,t,n,qc.Common.FRACTION_KG):Au(e,t/1e3,n/1e3,qc.Common.FRACTION_TON,2):Math.abs(n)<100?Nu(e,Jc(t),Jc(n),qc.Common.FRACTION_POUND):Au(e,eu(t),eu(n),qc.Common.FRACTION_SHORT_TON,2)})),Iu(wu,$c.WeightPerMonth,(function(e,t,n){return e.unitSettings.unitSystem===fc.Metric?Math.abs(n)<100?Nu(e,t,n,qc.Common.FRACTION_KG_PER_MONTH):Au(e,t/1e3,n/1e3,qc.Common.FRACTION_TON_PER_MONTH,2):Math.abs(n)<100?Nu(e,Jc(t),Jc(n),qc.Common.FRACTION_POUND_PER_MONTH):Au(e,eu(t),eu(n),qc.Common.FRACTION_SHORT_TON_PER_MONTH,2)})),Iu(wu,$c.Power,(function(e,t,n){return Math.abs(n)<1e4?Au(e,t/10,n/10,qc.Common.FRACTION_KILOWATT,1):Au(e,t/1e4,n/1e4,qc.Common.FRACTION_MEGAWATT,2)})),Iu(wu,$c.Energy,(function(e,t,n){return Math.abs(n)<1e4?Au(e,t/10,n/10,qc.Common.FRACTION_KILOWATT_HOURS,1):Au(e,t/1e4,n/1e4,qc.Common.FRACTION_MEGAWATT_HOURS,2)})),Iu(wu,$c.BodiesPerMonth,(function(e,t,n){return Nu(e,t,n,qc.Common.FRACTION_BODIES_PER_MONTH)})),Iu(wu,$c.XP,(function(e,t,n){return Nu(e,t,n,qc.Common.FRACTION_XP)})),Iu(wu,$c.Integer,(function(e,t,n){return Nu(e,t,n,qc.Common.FRACTION_INTEGER)})),Iu(wu,$c.IntegerPerMonth,(function(e,t,n){return Nu(e,t,n,qc.Common.FRACTION_INTEGER_PER_MONTH)})),wu);function Nu(e,t,n,r){var i=!(arguments.length>4&&void 0!==arguments[4])||arguments[4];return r.renderString(e,{VALUE:du(e,t,!1,i),TOTAL:du(e,n,!1,i)})}function Au(e,t,n,r){var i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:1,o=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],a=!(arguments.length>6&&void 0!==arguments[6])||arguments[6];return r.renderString(e,{VALUE:gu(e,t,!1,i,o,a),TOTAL:gu(e,n,!1,i,o,a)})}function Lu(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Mu(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Lu(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Lu(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/localization/localized-fraction.tsx",{get LocalizedFraction(){return Pu},set LocalizedFraction(e){Pu=e}});var ku=jc("Localized",(function(e,t){return Ru(e,t.value)}),(function(e,t){return Du(e.value,t.value)}));function Ru(e,t){switch(t.__Type){case Sc.Bounds:return Ou.renderString(e,t);case Sc.Fraction:return Pu.renderString(e,t);case Sc.Number:return su.renderString(e,t);case Sc.String:return Fu(e,t.id,t.value,t.args);default:return"<INVALID TYPE>"}}function Du(e,t){if(e.__Type!==t.__Type)return!1;switch(e.__Type){case Sc.Bounds:return Ou.propsAreEqual(e,t);case Sc.Fraction:return Pu.propsAreEqual(e,t);case Sc.Number:return su.propsAreEqual(e,t);case Sc.String:return function(e,t){return e.id===t.id&&e.value===t.value&&function(e,t){if(Object.is(e,t))return!0;if(null==e||null==t)return e===t;var n=Object.keys(e),r=Object.keys(t);if(n.length!==r.length)return!1;return n.every((function(n){return Object.prototype.hasOwnProperty.call(t,n)&&Du(e[n],t[n])}))}(e.args,t.args)}(e,t);default:return!0}}function Fu(e,t,n,r){var i,o=null!=t?null!==(i=e.translate(t,n))&&void 0!==i?i:t:null!=n?n:"";if(null!=r){var a=function(e,t){return Object.fromEntries(Object.entries(t).map((function(t){var n=Mu(t,2),r=n[0],i=n[1];return[r,Ru(e,i)]})))}(e,r);return Ll(o,a)}return o}function Uu(e){return null==e?"":e.replace(/\B([A-Z])/g," $1").replace(/^([a-z])/g,(function(e,t){return t.toUpperCase()}))}function Gu(e){return null==e?"":e.replace(/\B([A-Z])/g," $1").toUpperCase()}function Bu(e){return e.toFixed(0)}function Vu(e,t){return e.toFixed(0).padStart(t,"0").substr(0,t)}function Hu(e){return null==e||0===e.length?"":1===e.length?e.toUpperCase():e.charAt(0).toUpperCase()+e.slice(1)}oe.add("game-ui/common/localization/localized.tsx",{get Localized(){return ku},set Localized(e){ku=e},get renderLocalized(){return Ru},set renderLocalized(e){Ru=e},get renderStringElement(){return Fu},set renderStringElement(e){Fu=e}});var Ku=["{VALUE}k","{VALUE}m","{VALUE}b"];function Wu(e){if(Math.abs(Math.round(e))<1e3)return e.toFixed(0);for(var t=0;t<Ku.length;++t){var n=1e3*Math.pow(10,3*t);if(Math.round(Math.abs(e)/n)<1e3)return Ll(Ku[t],{VALUE:(e/n).toFixed(0)})}var r=Math.pow(10,3*Ku.length);return Ll(Ku[Ku.length-1],{VALUE:(e/r).toFixed(0)})}function zu(e){return(0,Y.useMemo)((function(){return Wu(e)}),[e])}oe.add("game-ui/common/utils/format.ts",{get makePretty(){return Uu},set makePretty(e){Uu=e},get makePrettyUppercase(){return Gu},set makePrettyUppercase(e){Gu=e},get formatInteger(){return Bu},set formatInteger(e){Bu=e},get formatFixedLengthInt(){return Vu},set formatFixedLengthInt(e){Vu=e},get capitalize(){return Hu},set capitalize(e){Hu=e},get formatLargeNumber(){return Wu},set formatLargeNumber(e){Wu=e},get useFormattedLargeNumber(){return zu},set useFormattedLargeNumber(e){zu=e}});var Yu=jc("LocalizedDate",(function(e,t){return qu(e,t.value)}),(function(e,t){return e.value.month===t.value.month&&e.value.year===t.value.year}));function $u(){var e=vc();return(0,Y.useCallback)((function(t){return qu(e,t)}),[e])}function qu(e,t){var n=t.year,r=t.month;return qc.Common.MEDIUM_DATE_FORMAT.renderString(e,{MONTH:td(e,r),YEAR:n.toFixed()})}var Xu=jc("LocalizedTime",(function(e,t){return Zu(e,t.value)}),(function(e,t){return e.value.hour===t.value.hour&&e.value.minute===t.value.minute}));function Qu(){var e=vc();return(0,Y.useCallback)((function(t){return Zu(e,t)}),[e])}function Zu(e,t){var n=t.hour,r=t.minute;return e.unitSettings.timeFormat===uc.TwentyFourHours?qc.Common.TIME_FORMAT.renderString(e,{HOUR:Vu(n,2),MINUTE:Vu(r,2)}):qc.Common.TIME_FORMAT_12.renderString(e,{HOUR:Vu(n%12||12,2),MINUTE:Vu(r,2),PERIOD:rd(e,n)})}var Ju=jc("LocalizedDateTime",(function(e,t){return ed(e,t.value)}),(function(e,t){return e.value.month===t.value.month&&e.value.year===t.value.year&&e.value.hour===t.value.hour&&e.value.minute===t.value.minute}));function ed(e,t){return"".concat(qu(e,t)," ").concat(Zu(e,t))}function td(e,t){return qc.Common.MONTH_SHORT.renderString(e,{index:t})}var nd=jc("LocalizedTimestamp",(function(e,t){return function(e,t){var n=e.unitSettings.timeFormat===uc.TwentyFourHours?qc.Common.TIMESTAMP_FORMAT.renderString(e,{}):qc.Common.TIMESTAMP_FORMAT_12.renderString(e,{});return n.replace(/(yyyy|MM|M|dd|d|HH|H|hh|h|mm|aa)/g,(function(n){var r=new Date(t);switch(n){case"yyyy":return Bu(r.getFullYear());case"MM":return Vu(r.getMonth()+1,2);case"M":return Bu(r.getMonth()+1);case"dd":return Vu(r.getDate(),2);case"d":return Bu(r.getDate());case"HH":return Vu(r.getHours(),2);case"H":return Bu(r.getHours());case"hh":return Vu(r.getHours()%12||12,2);case"h":return Bu(r.getHours()%12||12);case"mm":return Vu(r.getMinutes(),2);case"aa":return rd(e,r.getHours());default:return n}}))}(e,t.value)}),(function(e,t){return e.value===t.value}));function rd(e,t){return t<12?qc.Common.TIME_PERIOD_AM.renderString(e,{}):qc.Common.TIME_PERIOD_PM.renderString(e,{})}oe.add("game-ui/common/localization/localized-date.tsx",{get LocalizedDate(){return Yu},set LocalizedDate(e){Yu=e},get useDateFormat(){return $u},set useDateFormat(e){$u=e},get LocalizedTime(){return Xu},set LocalizedTime(e){Xu=e},get useTimeFormat(){return Qu},set useTimeFormat(e){Qu=e},get LocalizedDateTime(){return Ju},set LocalizedDateTime(e){Ju=e},get formatDateTime(){return ed},set formatDateTime(e){ed=e},get LocalizedTimestamp(){return nd},set LocalizedTimestamp(e){nd=e}});var id,od=jc("LocalizedDuration",(function(e,t){var n=t.value,r=t.daysPerYear,i=t.maxMonths,o=void 0===i?r:i,a=Math.round(n);if(a>=o){var s=Math.round(n/r);return 1!==s?qc.Common.VALUE_YEARS.renderString(e,{VALUE:(0,z.jsx)(su,{value:s,unit:$c.Integer})}):qc.Common.VALUE_YEAR.renderString(e,{VALUE:(0,z.jsx)(su,{value:s,unit:$c.Integer})})}if(a>1)return qc.Common.VALUE_MONTHS.renderString(e,{VALUE:(0,z.jsx)(su,{value:n,unit:$c.Integer})});if(n>23.5/24)return qc.Common.VALUE_MONTH.renderString(e,{VALUE:(0,z.jsx)(su,{value:n,unit:$c.Integer})});var l=Math.floor(24*n),c=Math.floor(60*(24*n-l));return qc.Common.TIME_FORMAT.renderString(e,{HOUR:Vu(l,2),MINUTE:Vu(c,2)})}),(function(e,t){return e.value===t.value&&e.daysPerYear===t.daysPerYear}));function ad(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function sd(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function ld(e){return e.__Type}function cd(e,t){if(null==e)return!1;var n=e.__Type;return"string"==typeof n&&(n===t||n.startsWith(t+","))}function ud(e,t){return sd(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){ad(e,t,n[t])}))}return e}({},e),{__Type:t})}function dd(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function fd(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return dd(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return dd(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function md(e){return cd(e,id.Formatted)}oe.add("game-ui/common/localization/localized-duration.tsx",{get LocalizedDuration(){return od},set LocalizedDuration(e){od=e}}),oe.add("game-ui/common/data-binding/binding-utils.ts",{get getType(){return ld},set getType(e){ld=e},get isBindingType(){return cd},set isBindingType(e){cd=e},get typed(){return ud},set typed(e){ud=e}}),function(e){e.Custom="names.CustomName",e.Localized="names.LocalizedName",e.Formatted="names.FormattedName"}(id||(id={}));var gd=(0,Y.memo)((function(e){var t=hd(e.value);return(0,z.jsx)(z.Fragment,{children:t})}),(function(e,t){return el(e,t,3)}));function hd(e){var t=pd();return(0,Y.useMemo)((function(){return t(e)}),[e,t])}function pd(){var e=vc();return(0,Y.useCallback)((function(t){if(null!=t){if(function(e){return cd(e,id.Custom)}(t))return t.name;if(md(t)||function(e){return cd(e,id.Localized)}(t)){var n=e.translate(t.nameId);if(null!=n){if(md(t)){var r=null!=t.nameArgs?function(e,t){return Object.entries(t).reduce((function(t,n){var r,i=fd(n,2),o=i[0],a=i[1];return t[o]=null!==(r=e.translate(a))&&void 0!==r?r:a,t}),{})}(e,t.nameArgs):null;if(null!=r)return Ll(n,r)}return n}return t.nameId}}return""}),[e])}function vd(e,t){return el(e,t,2)}oe.add("game-ui/common/localization/localized-entity-name.tsx",{get LocalizedEntityName(){return gd},set LocalizedEntityName(e){gd=e},get useLocalizedName(){return hd},set useLocalizedName(e){hd=e},get useNameFormat(){return pd},set useNameFormat(e){pd=e},get nameEquals(){return vd},set nameEquals(e){vd=e}});var bd=jc("LocalizedPercentage",(function(e,t){var n=t.value,r=t.max;return su.renderString(e,{value:n>0&&r>0?Math.max(1,100*n/r):0,unit:$c.Percentage})}),(function(e,t){return e.value===t.value&&e.max===t.max}));oe.add("game-ui/common/localization/localized-percentage.tsx",{get LocalizedPercentage(){return bd},set LocalizedPercentage(e){bd=e}}),oe.add("game-ui/common/localization/index.ts",{});var yd,xd=n(80),_d=n.n(xd);!function(e){e.Always="always",e.AnyChildren="anyChildren",e.FocusedChild="focusedChild"}(yd||(yd={}));var jd=(0,Y.createContext)({isChildFocused:function(){return!0},registerChild:function(){},unregisterChild:function(){},attachCallback:function(e){return e(!0,null)},detachCallback:function(e){return e(!1,null)},attachTo:function(){},detach:function(){},getBounds:function(){return null},getFocusedBounds:function(){return null},debugTrace:function(){return"<-- ROOT"},deepDebugTrace:function(){return"ROOT"}}),Od={isChildFocused:function(){return!1},registerChild:function(){},unregisterChild:function(){},attachCallback:function(){},detachCallback:function(){},attachTo:function(){},detach:function(){},getBounds:function(){return null},getFocusedBounds:function(){return null},debugTrace:function(){return"<-- DISABLED"},deepDebugTrace:function(){return"ROOT"}};function Ed(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Sd(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Ed(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ed(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/focus/controller/focus-controller.ts",{get FocusActivation(){return yd},set FocusActivation(e){yd=e},get FocusContext(){return jd},set FocusContext(e){jd=e},get disabledFocusController(){return Od},set disabledFocusController(e){Od=e}});var Td={entries:function(){return[]},has:function(){return!1},get:function(){},register:function(){},unregister:function(){},attachCallback:function(){},detachCallback:function(){}};function Id(){return Y.createContext(Td)}function wd(e,t){var n=(0,Y.useContext)(e),r=(0,Y.useRef)(null);return(0,Y.useCallback)((function(e){e!==r.current&&(null!=r.current&&n.unregister(t,r.current),null!=e&&n.register(t,e),r.current=e)}),[t,n])}function Pd(e,t){var n=(0,Y.useContext)(e),r=Sd((0,Y.useState)(n.get(t)),2),i=r[0],o=r[1];return(0,Y.useEffect)((function(){o(n.get(t));var e={onRegister:function(e,n){e===t&&o(n)},onUnregister:function(e,n){e===t&&o(void 0)}};return n.attachCallback(e),function(){return n.detachCallback(e)}}),[t,n]),i}var Cd,Nd=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this._elements=new Map,this._callbacks=[]}var t=e.prototype;return t.has=function(e){return this._elements.has(e)},t.get=function(e){return this._elements.get(e)},t.entries=function(){return this._elements},t.register=function(e,t){if(this._elements.has(e))console.warn("Duplicate element '".concat(String(e),"' registered!"));else{this._elements.set(e,t);var n=!0,r=!1,i=void 0;try{for(var o,a=this._callbacks[Symbol.iterator]();!(n=(o=a.next()).done);n=!0){o.value.onRegister(e,t)}}catch(e){r=!0,i=e}finally{try{n||null==a.return||a.return()}finally{if(r)throw i}}}},t.unregister=function(e,t){if(this._elements.get(e)===t){this._elements.delete(e);var n=!0,r=!1,i=void 0;try{for(var o,a=this._callbacks[Symbol.iterator]();!(n=(o=a.next()).done);n=!0){o.value.onUnregister(e,t)}}catch(e){r=!0,i=e}finally{try{n||null==a.return||a.return()}finally{if(r)throw i}}}},t.attachCallback=function(e){this._callbacks.includes(e)?console.warn("Element registry callback already attached!"):this._callbacks.push(e)},t.detachCallback=function(e){var t=this._callbacks.indexOf(e);-1!==t?this._callbacks.splice(t,1):console.warn("Element registry callback not attached!")},e}();oe.add("game-ui/common/utils/element-registry.tsx",{get defaultRegistry(){return Td},set defaultRegistry(e){Td=e},get createElementRegistryContext(){return Id},set createElementRegistryContext(e){Id=e},get useRegisteredElementRef(){return wd},set useRegisteredElementRef(e){wd=e},get useRegisteredElement(){return Pd},set useRegisteredElement(e){Pd=e},get ElementRegistryImpl(){return Nd},set ElementRegistryImpl(e){Nd=e}}),function(e){e[e.in=0]="in",e[e.enter=1]="enter",e[e.exit=2]="exit"}(Cd||(Cd={}));var Ad={state:Cd.in,onMount:function(){},onUnmount:function(){}},Ld=Y.createContext(Ad),Md=Y.createContext(!1);function kd(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Rd(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||Fd(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Dd(e){return function(e){if(Array.isArray(e))return kd(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||Fd(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Fd(e,t){if(e){if("string"==typeof e)return kd(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?kd(e,t):void 0}}oe.add("game-ui/common/animations/transition-context.tsx",{get TransitionState(){return Cd},set TransitionState(e){Cd=e},get defaultContext(){return Ad},set defaultContext(e){Ad=e},get TransitionContext(){return Ld},set TransitionContext(e){Ld=e},get ExitTransitionActive(){return Md},set ExitTransitionActive(e){Md=e}});var Ud=function(e){var t=e.skipInitial,n=void 0===t||t,r=e.children,i=(0,Y.useRef)(n);(0,Y.useEffect)((function(){return function(){i.current=!1}}),[r]);var o=(0,Y.useMemo)((function(){var e=new Nd;return e.attachCallback({onRegister:function(){},onUnregister:function(e){c((function(t){return Bd(t,e)}))}}),e}),[]),a=(0,Y.useRef)(null),s=Rd((0,Y.useState)((function(){return function(e){var t=new Array(Y.Children.count(e));return Y.Children.forEach(e,(function(e,n){t[n]=e})),t}(r)})),2),l=s[0],c=s[1];(0,Y.useEffect)((function(){var e=function(e){var t=new Set;return Y.Children.forEach(e,(function(e){var n=Vd(e);null!=n&&t.add(n)})),t}(r);if(null!=a.current){c((function(t){return function(e,t,n){var r,i=new Map,o=[];Y.Children.forEach(e,(function(e){var t=Vd(e);null!=t&&(n.has(t)?(i.set(t,o),o=[]):o.push(e))}));var a=[];return Y.Children.forEach(t,(function(e){var t=Vd(e);if(null!=t){var n,r=i.get(t);if(r)(n=a).push.apply(n,Dd(r))}a.push(e)})),(r=a).push.apply(r,Dd(o)),a}(t,r,e)}));var t=!0,n=!1,i=void 0;try{for(var s,l=function(){var t=s.value;if(!e.has(t)){var n=o.get(t);n?n(Cd.exit):c((function(e){return Bd(e,t)}))}},u=a.current.values()[Symbol.iterator]();!(t=(s=u.next()).done);t=!0)l()}catch(e){n=!0,i=e}finally{try{t||null==u.return||u.return()}finally{if(n)throw i}}var d=!0,f=!1,m=void 0;try{for(var g,h=e.values()[Symbol.iterator]();!(d=(g=h.next()).done);d=!0){var p=g.value;if(!a.current.has(p)){var v=o.get(p);v&&v(Cd.enter)}}}catch(e){f=!0,m=e}finally{try{d||null==h.return||h.return()}finally{if(f)throw m}}}a.current=e}),[r,o]);var u=(0,Y.useContext)(Md);return(0,z.jsx)(Ld.Provider,{value:Ad,children:l.map((function(e){var t=Vd(e);if(null!=t){var n=!a.current||a.current.has(t);return(0,z.jsx)(Gd,{transitionKey:t,exiting:u||!n,transitionRegistry:o,skipInitialRef:i,children:e},t)}return e}))})},Gd=function(e){var t=e.transitionKey,n=e.transitionRegistry,r=e.skipInitialRef,i=e.exiting,o=e.children,a=Rd((0,Y.useState)(null==t||r.current?Cd.in:Cd.enter),2),s=a[0],l=a[1],c=(0,Y.useCallback)((function(){null!=t&&n.register(t,l)}),[t,n]),u=(0,Y.useCallback)((function(){null!=t&&n.unregister(t,l)}),[t,n]),d=(0,Y.useMemo)((function(){return{state:s,onMount:c,onUnmount:u}}),[c,u,s]),f=(0,Y.useContext)(jd);return(0,z.jsx)(Ld.Provider,{value:d,children:(0,z.jsx)(Md.Provider,{value:i,children:(0,z.jsx)(jd.Provider,{value:i?Od:f,children:o})})})};function Bd(e,t){return e.filter((function(e){return Vd(e)!==t}))}function Vd(e){return null!==e&&"object"==typeof e?e.key:null}function Hd(e,t){return(0,Y.useCallback)((function(n){Kd(e,n),Kd(t,n)}),[e,t])}function Kd(e,t){"function"==typeof e?e(t):null!=e&&(e.current=t)}function Wd(e){return(0,Y.isValidElement)(e)}function zd(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Yd(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){zd(e,t,n[t])}))}return e}function $d(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function qd(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}oe.add("game-ui/common/animations/transition-group-coordinator.tsx",{get TransitionGroupCoordinator(){return Ud},set TransitionGroupCoordinator(e){Ud=e}}),oe.add("game-ui/common/hooks/use-merged-ref.tsx",{get useMergedRef(){return Hd},set useMergedRef(e){Hd=e},get setRef(){return Kd},set setRef(e){Kd=e}}),oe.add("game-ui/common/utils/react.ts",{get isValidRefElement(){return Wd},set isValidRefElement(e){Wd=e}});var Xd=Y.createContext(null),Qd=function(e){var t=e.children;if(!Wd(t))throw new Error("DOMNodeProvider requires a single child react element!");var n=(0,Y.useContext)(Xd),r=Hd(t.ref,null==n?void 0:n.ref),i=Yd({},t.props.style,null==n?void 0:n.style),o=_d()(t.props.className,null==n?void 0:n.className),a=$d(Yd({},t.props),{className:o,style:i,ref:r});return(0,z.jsx)(Xd.Provider,{value:null,children:Y.cloneElement(t,a)})},Zd=Y.memo(Y.forwardRef((function(e,t){var n=e.style,r=e.className,i=e.children;if(!Wd(i))throw new Error("DOMNodeModifier requires a single child react element!");var o,a=(0,Y.useContext)(Xd),s=(0,Y.useMemo)((function(){return{ref:function(e){Kd(i.ref,e),Kd(t,e),null!=(null==a?void 0:a.ref)&&a.ref(e)},style:Yd({},null==a?void 0:a.style,n),className:_d()(null==a?void 0:a.className,r)}}),[i.ref,r,a,t,n]);return(0,z.jsx)(Xd.Provider,{value:s,children:(o=i,"object"!=typeof o||"function"!=typeof o.type?(0,z.jsx)(Qd,{children:i}):i)})})),(function(e,t){var n=e.style,r=qd(e,["style"]),i=t.style;return el(r,qd(t,["style"]))&&el(n,i)}));oe.add("game-ui/common/dom-node/dom-node.tsx",{get DOMNodeContext(){return Xd},set DOMNodeContext(e){Xd=e},get DOMNodeProvider(){return Qd},set DOMNodeProvider(e){Qd=e},get DOMNodeModifier(){return Zd},set DOMNodeModifier(e){Zd=e}});var Jd=-2147483648,ef=2147483647,tf=4294967295,nf=-3402823e32,rf=3402823e32;function of(e,t,n){return e<=t?t:e>=n?n:e}function af(e,t,n){return e+(t-e)*n}function sf(e,t){var n=Math.pow(10,t);return Math.round((e+Number.EPSILON)*n)/n}var lf={x:0,y:0},cf={x:-1,y:0},uf={x:0,y:1},df={x:1,y:0},ff={x:0,y:-1};function mf(e,t){return e.x===t.x&&e.y===t.y}function gf(e,t,n){return{x:of(e.x,t,n),y:of(e.y,t,n)}}function hf(e){var t=yf(e);return 0===t?lf:{x:e.x/t,y:e.y/t}}function pf(e,t){return{x:e.x-t.x,y:e.y-t.y}}function vf(e,t,n){return{x:e.x+(t.x-e.x)*n,y:e.y+(t.y-e.y)*n}}function bf(e){return{x:Math.trunc(e.x),y:Math.trunc(e.y)}}function yf(e){return Math.sqrt(xf(e))}function xf(e){return e.x*e.x+e.y*e.y}function _f(e,t){var n=e.x,r=e.y;return"(".concat(sf(n,t),", ").concat(sf(r,t),")")}function jf(e){return{x:e.clientX,y:e.clientY}}var Of={x:0,y:0,z:0};function Ef(e,t){return e.x===t.x&&e.y===t.y&&e.z===t.z}function Sf(e,t){var n=e.x,r=e.y,i=e.z;return"(".concat(sf(n,t),", ").concat(sf(r,t),", ").concat(sf(i,t),")")}var Tf={x:0,y:0,z:0,w:0};function If(e,t){return e.x===t.x&&e.y===t.y&&e.z===t.z&&e.w===t.w}function wf(e,t){var n=e.x,r=e.y,i=e.z,o=e.w;return"(".concat(sf(n,t),", ").concat(sf(r,t),", ").concat(sf(i,t),", ").concat(sf(o,t),")")}var Pf={min:0,max:0};function Cf(e,t){return e.min===t.min&&e.max===t.max}var Nf={min:lf,max:lf};function Af(e,t){return mf(e.min,t.min)&&mf(e.max,t.max)}var Lf={min:Of,max:Of};function Mf(e,t){return Ef(e.min,t.min)&&Ef(e.max,t.max)}var kf=[0,0];function Rf(e,t){return e[0]===t[0]&&e[1]===t[1]}function Df(e){return BigInt(e[1])<<32n|BigInt(e[0])}function Ff(e){return[Number(0xffffffffn&e),Number(e>>32n&0xffffffffn)]}function Uf(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Gf(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Uf(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Uf(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Bf(e){return{x:e.offsetWidth,y:e.offsetHeight}}function Vf(e){return{x:e.clientWidth,y:e.clientHeight}}function Hf(e){return{x:e.scrollWidth,y:e.scrollHeight}}function Kf(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:Bf,n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],r=Gf((0,Y.useState)(null),2),i=r[0],o=r[1],a=(0,Y.useCallback)((function(){if(null!=e.current){var n=t(e.current);o((function(e){return null!=e&&mf(n,e)?e:n}))}else o(null)}),[e,t]);return Yf(a,n),(0,Y.useEffect)((function(){if(n){var e=window.requestAnimationFrame((function(){e=window.requestAnimationFrame((function(){e=0,a()})),a()}));return function(){return window.cancelAnimationFrame(e)}}o(null)}),[n,a]),i}function Wf(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],n=Gf((0,Y.useState)(null),2),r=n[0],i=n[1],o=(0,Y.useCallback)((function(){if(null!=e.current){var t=e.current.getBoundingClientRect();i((function(e){return null!=e&&(n=t,r=e,Math.abs(n.top-r.top)<.1&&Math.abs(n.bottom-r.bottom)<.1&&Math.abs(n.left-r.left)<.1&&Math.abs(n.right-r.right)<.1&&Math.abs(n.width-r.width)<.1&&Math.abs(n.height-r.height)<.1)?e:t;var n,r}))}else i(null)}),[e]);return Yf(o,t),(0,Y.useEffect)((function(){if(t){var e=window.requestAnimationFrame((function(){e=window.requestAnimationFrame((function(){e=0,o()})),o()}));return function(){window.cancelAnimationFrame(e)}}i(null)}),[t,o]),r}oe.add("game-ui/common/math.ts",{get INT_MIN_VALUE(){return Jd},set INT_MIN_VALUE(e){Jd=e},get INT_MAX_VALUE(){return ef},set INT_MAX_VALUE(e){ef=e},get UINT_MAX_VALUE(){return tf},set UINT_MAX_VALUE(e){tf=e},get FLOAT_MIN_VALUE(){return nf},set FLOAT_MIN_VALUE(e){nf=e},get FLOAT_MAX_VALUE(){return rf},set FLOAT_MAX_VALUE(e){rf=e},get clamp(){return of},set clamp(e){of=e},get lerp(){return af},set lerp(e){af=e},get roundDecimal(){return sf},set roundDecimal(e){sf=e},get zero2(){return lf},set zero2(e){lf=e},get left(){return cf},set left(e){cf=e},get up(){return uf},set up(e){uf=e},get right(){return df},set right(e){df=e},get down(){return ff},set down(e){ff=e},get number2Equals(){return mf},set number2Equals(e){mf=e},get clamp2(){return gf},set clamp2(e){gf=e},get normalize2(){return hf},set normalize2(e){hf=e},get difference2(){return pf},set difference2(e){pf=e},get lerp2(){return vf},set lerp2(e){vf=e},get trunc2(){return bf},set trunc2(e){bf=e},get distance2(){return yf},set distance2(e){yf=e},get distanceSqr2(){return xf},set distanceSqr2(e){xf=e},get formatNumber2(){return _f},set formatNumber2(e){_f=e},get fromMouseEvent(){return jf},set fromMouseEvent(e){jf=e},get zero3(){return Of},set zero3(e){Of=e},get number3Equals(){return Ef},set number3Equals(e){Ef=e},get formatNumber3(){return Sf},set formatNumber3(e){Sf=e},get zero4(){return Tf},set zero4(e){Tf=e},get number4Equals(){return If},set number4Equals(e){If=e},get formatNumber4(){return wf},set formatNumber4(e){wf=e},get zeroBounds1(){return Pf},set zeroBounds1(e){Pf=e},get bounds1Equals(){return Cf},set bounds1Equals(e){Cf=e},get zeroBounds2(){return Nf},set zeroBounds2(e){Nf=e},get bounds2Equals(){return Af},set bounds2Equals(e){Af=e},get zeroBounds3(){return Lf},set zeroBounds3(e){Lf=e},get bounds3Equals(){return Mf},set bounds3Equals(e){Mf=e},get zeroLong(){return kf},set zeroLong(e){kf=e},get longEquals(){return Rf},set longEquals(e){Rf=e},get longToBigInt(){return Df},set longToBigInt(e){Df=e},get bigIntToLong(){return Ff},set bigIntToLong(e){Ff=e}});var zf=["top","right","bottom","left","width","height","size","weight"];function Yf(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],n=(0,Y.useRef)(!1);(0,Y.useEffect)((function(){if(t){n.current=!0;var r=0,i=function(){n.current&&0===r&&(r=window.requestAnimationFrame((function(){r=window.requestAnimationFrame((function(){r=0,e()}))})))},o=new MutationObserver(i);o.observe(document,{attributes:!0,childList:!0,characterData:!0,subtree:!0});var a=function(e){if(function(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}(e.target,HTMLElement)){var t=window.getComputedStyle(e.target).transitionProperty;zf.some((function(e){return t.includes(e)}))&&i()}};document.addEventListener("transitionend",a);var s=function(){n.current&&(window.cancelAnimationFrame(r),r=window.requestAnimationFrame((function(){r=window.requestAnimationFrame((function(){r=0,e()}))})))};return window.addEventListener("resize",s),function(){n.current=!1,o.disconnect(),document.removeEventListener("transitionend",a),window.removeEventListener("resize",s),window.cancelAnimationFrame(r)}}}),[t,e])}function $f(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function qf(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return $f(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return $f(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/hooks/resize-events.tsx",{get OFFSET_SIZE(){return Bf},set OFFSET_SIZE(e){Bf=e},get CLIENT_SIZE(){return Vf},set CLIENT_SIZE(e){Vf=e},get SCROLL_SIZE(){return Hf},set SCROLL_SIZE(e){Hf=e},get useElementSize(){return Kf},set useElementSize(e){Kf=e},get useElementRect(){return Wf},set useElementRect(e){Wf=e},get useResizeEventListener(){return Yf},set useResizeEventListener(e){Yf=e}});const Xf=function(){var e=!(arguments.length>0&&void 0!==arguments[0])||arguments[0],t=qf((0,Y.useState)({x:window.innerWidth,y:window.innerHeight}),2),n=t[0],r=t[1];return(0,Y.useEffect)((function(){if(e){var t=function(){var e={x:window.innerWidth,y:window.innerHeight};r((function(t){return mf(e,t)?t:e}))};return t(),window.addEventListener("resize",t),function(){return window.removeEventListener("resize",t)}}}),[e,r]),n};function Qf(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Zf(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Qf(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Qf(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/hooks/use-window-size.ts",{});var Jf=(0,Y.createContext)(document.body),em=function(e){var t=e.children;if(!Wd(t))throw new Error("PortalContainerProvider requires a single child react element!");var n=(0,Y.useContext)(Jf),r=Zf((0,Y.useState)(null),2),i=r[0],o=r[1];return(0,z.jsx)(Jf.Provider,{value:null!=i?i:n,children:(0,z.jsx)(Zd,{ref:o,children:t})})},tm=function(e){var t=e.children,n=nm();return ue.createPortal(t,n)};function nm(){return(0,Y.useContext)(Jf)}oe.add("game-ui/common/portal/portal.tsx",{get PortalContainerProvider(){return em},set PortalContainerProvider(e){em=e},get Portal(){return tm},set Portal(e){tm=e},get usePortalContainer(){return nm},set usePortalContainer(e){nm=e}});var rm=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this._callback=null}var t=e.prototype;return t.complete=function(){this._callback=null},t.cancel=function(){this._callback&&(this._callback(),this._callback=null)},t.onCancel=function(e){this._callback&&this._callback(),this._callback=e},e}();function im(){var e=(0,Y.useMemo)((function(){return new rm}),[]);return(0,Y.useEffect)((function(){return function(){return e.cancel()}}),[e]),e}function om(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function am(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function sm(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}function lm(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){am(e,t,n[t])}))}return e}function cm(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function um(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return om(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return om(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function dm(e){if(!sm(e,Element))return 0;var t=window.getComputedStyle(e),n=t.transitionDuration.split(/,\s?/),r=t.transitionDelay.split(/,\s?/);if(n.length<=1&&r.length<=1)return pm(hm(n,0))+pm(hm(r,0));for(var i=0,o=Math.max(n.length,r.length),a=0;a<o;a++){var s=pm(hm(n,a)),l=pm(hm(r,a));i=Math.max(i,s+l)}return i}function fm(e,t){if(!sm(e,Element))return null;var n=window.getComputedStyle(e),r=n.transitionProperty.split(/,\s?/),i=n.transitionDuration.split(/,\s?/),o=n.transitionDelay.split(/,\s?/),a=n.transitionTimingFunction.split(/,(?![^(]*\))\s?/),s=r.indexOf(t);if(-1===s)return null;var l=vm(hm(a,s));return null==l?null:{duration:pm(hm(i,s)),delay:pm(hm(o,s)),timingFunction:l}}function mm(e,t,n){if(!sm(e,Element))return{};var r=window.getComputedStyle(e),i=r.transitionProperty.split(/,\s?/),o=r.transitionDuration.split(/,\s?/),a=r.transitionDelay.split(/,\s?/),s=r.transitionTimingFunction.split(/,(?![^(]*\))\s?/),l=i.indexOf(t);return-1===l?{}:{transitionProperty:r.transitionProperty,transitionDuration:i.map((function(e,t){var r;return t===l?n.duration+"ms":null!==(r=hm(o,t))&&void 0!==r?r:"0ms"})).join(", "),transitionDelay:i.map((function(e,t){var r;return t===l?n.delay+"ms":null!==(r=hm(a,t))&&void 0!==r?r:"0ms"})).join(", "),transitionTimingFunction:i.map((function(e,t){var r;return t===l?ym(n.timingFunction):null!==(r=hm(s,t))&&void 0!==r?r:"ease"})).join(", ")}}function gm(e,t){if(t<e.delay)return cm(lm({},e),{delay:e.delay-t});if(e.duration>0||t<e.delay+e.duration){var n=(t-e.delay)/e.duration;return{delay:0,duration:(1-n)*e.duration,timingFunction:bm(e.timingFunction,n)}}return cm(lm({},e),{duration:0,delay:0})}function hm(e,t){return 1===e.length?e[0]:e.length>t?e[t]:void 0}function pm(e){if(null==e)return 0;if(e.endsWith("ms")){var t=parseFloat(e.substr(0,e.length-2));return isNaN(t)?0:t}if(e.endsWith("s")){var n=1e3*parseFloat(e.substr(0,e.length-1));return isNaN(n)?0:n}var r=parseFloat(e);return isNaN(r)?0:r}function vm(e){if(null==e)return null;if("linear"===e)return[0,0,1,1];if("ease"===e)return[.25,.1,.25,1];if("ease-in"===e)return[.42,0,1,1];if("ease-out"===e)return[0,0,.58,1];if("ease-in-out"===e)return[.42,0,.58,1];var t=e.match(/^cubic-bezier\((-?[0-9]*\.?[0-9]*),\s?(-?[0-9]*\.?[0-9]*),\s?(-?[0-9]*\.?[0-9]*),\s?(-?[0-9]*\.?[0-9]*)\)$/);return null!=t?[parseFloat(t[1]),parseFloat(t[2]),parseFloat(t[3]),parseFloat(t[4])]:null}function bm(e,t){var n=um(e,4),r=n[0],i=n[1],o={x:n[2],y:n[3]},a=vf({x:r,y:i},o,t),s=vf(o,{x:1,y:1},t),l=vf(a,s,t);return[l.x,l.y,s.x,s.y]}function ym(e){var t=um(e,4),n=t[0],r=t[1],i=t[2],o=t[3];return"cubic-bezier(".concat(n,", ").concat(r,", ").concat(i,", ").concat(o,")")}function xm(e,t){return new Promise((function(n,r){var i=window.setTimeout((function(){t.complete(),n(!0)}),e);t.onCancel((function(){window.clearTimeout(i),n(!1)}))}))}function _m(e){return new Promise((function(t,n){var r=window.requestAnimationFrame((function(n){e.complete(),t(!0)}));e.onCancel((function(){window.cancelAnimationFrame(r),t(!1)}))}))}function jm(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Om(e,t,n,r,i,o,a){try{var s=e[o](a),l=s.value}catch(e){return void n(e)}s.done?t(l):Promise.resolve(l).then(r,i)}function Em(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Sm(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Em(e,t,n[t])}))}return e}function Tm(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Im(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return jm(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return jm(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/utils/cancel-token.ts",{get CancelToken(){return rm},set CancelToken(e){rm=e},get useCancelToken(){return im},set useCancelToken(e){im=e}}),oe.add("game-ui/common/utils/css-transitions.ts",{get getCssTransitionTime(){return dm},set getCssTransitionTime(e){dm=e},get getCssTransition(){return fm},set getCssTransition(e){fm=e},get getModifiedTransitionStyles(){return mm},set getModifiedTransitionStyles(e){mm=e},get splitCssTransition(){return gm},set splitCssTransition(e){gm=e},get parseBezier(){return vm},set parseBezier(e){vm=e},get splitBezier(){return bm},set splitBezier(e){bm=e},get formatBezier(){return ym},set formatBezier(e){ym=e}}),oe.add("game-ui/common/utils/promise.ts",{get delay(){return xm},set delay(e){xm=e},get nextFrame(){return _m},set nextFrame(e){_m=e}});var wm=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}},Pm={},Cm=function(e){var t=e.styles,n=e.enterDuration,r=e.exitDuration,i=e.children;if(!Wd(i))throw new Error("ClassNameTransition requires a single child react element!");var o=null!=t?t:Pm,a=(0,Y.useContext)(Ld),s=a.state,l=a.onMount,c=a.onUnmount,u=(0,Y.useRef)(null),d=Hd(i.ref,u),f=(0,Y.useRef)(!1),m=Im((0,Y.useState)(function(e,t){switch(e){case Cd.enter:return t.enter;case Cd.exit:return t.exit;default:return null}}(s,o)),2),g=m[0],h=m[1],p=(0,Y.useCallback)((function(e){f.current&&h(e)}),[]),v=(0,Y.useRef)(g);return v.current=g,(0,Y.useEffect)((function(){return f.current||(f.current=!0,l()),function(){f.current&&(f.current=!1,c())}}),[l,c]),(0,Y.useEffect)((function(){var e,t=new rm;return(e=function(){return wm(this,(function(e){switch(e.label){case 0:return s!==Cd.enter?[3,5]:(p(o.enter),[4,_m(t)]);case 1:return e.sent()?[4,_m(t)]:[2];case 2:return e.sent()?(p(o.enterActive),[4,_m(t)]):[2];case 3:return e.sent()?[4,xm(null!=n?n:dm(u.current),t)]:[2];case 4:return e.sent()?(p(null),[3,11]):[2];case 5:return s!==Cd.exit?[3,11]:null!=v.current?[3,8]:(p(o.exit),[4,_m(t)]);case 6:return e.sent()?[4,_m(t)]:[2];case 7:if(!e.sent())return[2];e.label=8;case 8:return p(o.exitActive),[4,_m(t)];case 9:return e.sent()?[4,xm(null!=r?r:dm(u.current),t)]:[2];case 10:if(!e.sent())return[2];f.current&&(f.current=!1,c()),e.label=11;case 11:return[2]}}))},function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){Om(o,r,i,a,s,"next",e)}function s(e){Om(o,r,i,a,s,"throw",e)}a(void 0)}))})(),function(){t.cancel(),p(null)}}),[n,r,c,s,o.enter,o.enterActive,o.exit,o.exitActive,p]),(0,z.jsx)(Ld.Provider,{value:Ad,children:Y.cloneElement(i,Tm(Sm({},i.props),{ref:d,className:_d()(i.props.className,o.base,g)}))})};oe.add("game-ui/common/animations/class-name-transition.tsx",{get emptyStyles(){return Pm},set emptyStyles(e){Pm=e},get ClassNameTransition(){return Cm},set ClassNameTransition(e){Cm=e}});let Nm={balloon:"balloon_H23",up:"up_ehW",start:"start_wu1",down:"down_ztr",center:"center_hug",end:"end_EKq",left:"left_LHd",right:"right_JdH",bounds:"bounds__AO",container:"container_jfe",arrow:"arrow_Xfn",content:"content_JQV"};oe.add("game-ui/common/balloon/balloon.module.scss",{get classes(){return Nm},set classes(e){Object.assign(Nm,e)}});const Am=Nm;let Lm={balloon:"balloon_DNs balloon_H23",base:"base_uUu",enter:"enter_ZTs","enter-active":"enter-active_bJR",enterActive:"enter-active_bJR","exit-active":"exit-active_AqC",exitActive:"exit-active_AqC",container:"container_sGN container_jfe",arrow:"arrow_tFt arrow_Xfn",content:"content_HM0 content_JQV"};oe.add("game-ui/common/balloon/themes/default-balloon.module.scss",{get classes(){return Lm},set classes(e){Object.assign(Lm,e)}});const Mm=Lm;function km(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var Rm=Y.forwardRef((function(e,t){var n=e.direction,r=e.alignment,i=e.theme,o=void 0===i?Mm:i,a=e.className,s=e.style,l=e.children,c=(0,Y.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){km(e,t,n[t])}))}return e}({},Am,o)}),[o]);return(0,z.jsx)(Cm,{styles:c,children:(0,z.jsx)("div",{ref:t,style:s,className:_d()(c.balloon,null!=n&&c[n],null!=r&&c[r],a),children:(0,z.jsxs)("div",{className:c.bounds,children:[(0,z.jsx)("div",{className:c.container,children:(0,z.jsx)("div",{className:c.arrow})}),(0,z.jsx)("div",{className:c.content,children:l})]})})})}));oe.add("game-ui/common/balloon/balloon.tsx",{get Balloon(){return Rm},set Balloon(e){Rm=e}});let Dm={"anchored-balloon":"anchored-balloon_AYp",anchoredBalloon:"anchored-balloon_AYp",hidden:"hidden_W0n",up:"up_el0",down:"down_Xl7",left:"left_SI8",right:"right_RQp"};oe.add("game-ui/common/balloon/anchored-balloon.module.scss",{get classes(){return Dm},set classes(e){Object.assign(Dm,e)}});const Fm=Dm;var Um=function(e){var t=e.visible,n=e.direction,r=void 0===n?"up":n,i=e.alignment,o=void 0===i?"center":i,a=e.theme,s=e.content,l=e.balloonKey,c=void 0===l?"anchored-balloon":l,u=e.className,d=e.children;if(!Wd(d))throw new Error("AnchoredBalloon requires a single child react element!");var f=(0,Y.useRef)(null),m=(0,Y.useRef)(null),g=Xf(t),h=Wf(f,t),p=Kf(m,Bf,t),v=(0,Y.useMemo)((function(){return t&&h&&p?function(e,t,n,r,i){var o=r,a=i,s=Bm(e,t,o,a),l=s.y<0,c=s.y+t.y>n.y,u=s.x<0,d=s.x+t.x>n.x;if(!(l||c||u||d))return{direction:o,alignment:a,style:Km(s)};a="left"===o||"right"===o?Gm(a,l,c):Gm(a,u,d);"up"===o?l&&(o="down"):"down"===o?c&&(o="up"):"left"===o?u&&(o="right"):"right"===o&&d&&(o="left");if(s=Bm(e,t,o,a),l=s.y<0,c=s.y+t.y>n.y,u=s.x<0,d=s.x+t.x>n.x,!(l||c||u||d))return{direction:o,alignment:a,style:Km(s)};a="left"===o||"right"===o?Gm(a,l,c):Gm(a,u,d);return s=Bm(e,t,o,a),{direction:o,alignment:a,style:Km(s)}}(h,p,g,r,o):null}),[t,h,p,g,r,o]);return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(Zd,{ref:f,children:d}),(0,z.jsx)(Ud,{children:t&&(0,z.jsx)(tm,{children:(0,z.jsx)(Rm,{ref:m,direction:null==v?void 0:v.direction,alignment:null==v?void 0:v.alignment,theme:a,className:_d()(u,Fm.anchoredBalloon,null==v&&Fm.hidden,null!=v&&Fm[v.direction]),style:null==v?void 0:v.style,children:s},c)},"balloon")})]})};function Gm(e,t,n){if(t){if("start"===e)return"center";if("center"===e)return"end"}else if(n){if("center"===e)return"start";if("end"===e)return"center"}return e}function Bm(e,t,n,r){return"up"===n?{x:Vm(e,t,r),y:e.top-t.y}:"down"===n?{x:Vm(e,t,r),y:e.bottom}:"left"===n?{x:e.left-t.x,y:Hm(e,t,r)}:"right"===n?{x:e.right,y:Hm(e,t,r)}:lf}function Vm(e,t,n){return"start"===n?(e.left+e.right)/2-t.x:"end"===n?(e.left+e.right)/2:(e.left+e.right-t.x)/2}function Hm(e,t,n){return"start"===n?(e.top+e.bottom)/2-t.y:"end"===n?(e.top+e.bottom)/2:(e.top+e.bottom-t.y)/2}function Km(e){return{left:"".concat(e.x.toFixed(0),"px"),top:"".concat(e.y.toFixed(0),"px"),"--posX":"".concat(e.x.toFixed(0),"px"),"--posY":"".concat(e.y.toFixed(0),"px")}}oe.add("game-ui/common/balloon/anchored-balloon.tsx",{get AnchoredBalloon(){return Um},set AnchoredBalloon(e){Um=e}});var Wm,zm,Ym="input";!function(e){e[e.keyboardAndMouse=0]="keyboardAndMouse",e[e.gamepad=1]="gamepad"}(Wm||(Wm={})),function(e){e[e.Xbox=0]="Xbox",e[e.PS=1]="PS"}(zm||(zm={}));var $m=fl(Ym,"mouseOverUI",!0),qm=fl(Ym,"controlScheme",Wm.gamepad),Xm=fl(Ym,"gamepadPointerPosition"),Qm=fl(Ym,"cameraMoving",!1),Zm=hl(Ym,"cameraBarrier"),Jm=hl(Ym,"toolBarrier"),eg=fl(Ym,"hints"),tg=vl(Ym,"onInputHintPerformed"),ng=gl(Ym,"tutorialHints"),rg=fl(Ym,"gamepadType"),ig=vl(Ym,"setActiveTextFieldRect"),og=fl(Ym,"useTextFieldInputBarrier");function ag(e){bl(Ym,"onGamepadPointerEvent",e)}function sg(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}oe.add("game-ui/common/data-binding/input-bindings.ts",{get ControlScheme(){return Wm},set ControlScheme(e){Wm=e},get GamepadType(){return zm},set GamepadType(e){zm=e},get mouseOverUI(){return mouseOverUI},set mouseOverUI(e){mouseOverUI=e},get controlScheme(){return controlScheme},set controlScheme(e){controlScheme=e},get gamepadPointerPosition(){return gamepadPointerPosition},set gamepadPointerPosition(e){gamepadPointerPosition=e},get cameraMoving(){return cameraMoving},set cameraMoving(e){cameraMoving=e},get cameraBarrier(){return cameraBarrier},set cameraBarrier(e){cameraBarrier=e},get toolBarrier(){return toolBarrier},set toolBarrier(e){toolBarrier=e},get inputHints(){return inputHints},set inputHints(e){inputHints=e},get onInputHintPerformed(){return tg},set onInputHintPerformed(e){tg=e},get tutorialHints(){return tutorialHints},set tutorialHints(e){tutorialHints=e},get gamepadType(){return gamepadType},set gamepadType(e){gamepadType=e},get setActiveTextFieldRect(){return ig},set setActiveTextFieldRect(e){ig=e},get requireTextFieldInputBarrier(){return requireTextFieldInputBarrier},set requireTextFieldInputBarrier(e){requireTextFieldInputBarrier=e},get onGamepadPointerEvent(){return ag},set onGamepadPointerEvent(e){ag=e}});var lg=function(){function e(){var t=!(arguments.length>0&&void 0!==arguments[0])||arguments[0],n=this;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.propagateCurrent=t,this._parentController=null,this._enabled=!1,this._focusKey=null,this._lastFocused=!1,this.callbacks=[],this.isChildFocused=function(e){return n.focused&&n.isChildFocusedImpl(e)},this.attachCallback=function(e){n.callbacks.includes(e)?console.error("".concat(n.constructor.name,": Focus callback already attached to controller!\n").concat(n.debugTrace())):(n.callbacks.push(e),n._lastFocused&&e(!0,n.propagateCurrent?n:null))},this.detachCallback=function(e){var t=n.callbacks.indexOf(e);-1!==t?(n.callbacks.splice(t,1),n._lastFocused&&e(!1,n.propagateCurrent?n:null)):console.error("".concat(n.constructor.name,": Focus callback not attached to controller!\n").concat(n.debugTrace()))},this.updateChildren=function(e){if(n._lastFocused){var t=!0,r=!1,i=void 0;try{for(var o,a=n.callbacks[Symbol.iterator]();!(t=(o=a.next()).done);t=!0){(0,o.value)(!0,e)}}catch(e){r=!0,i=e}finally{try{t||null==a.return||a.return()}finally{if(r)throw i}}}},this.onFocusUpdate=function(e,t){var r=e&&n.focused;if(r!==n._lastFocused){n._lastFocused=r;var i=!0,o=!1,a=void 0;try{for(var s,l=n.callbacks[Symbol.iterator]();!(i=(s=l.next()).done);i=!0){(0,s.value)(n._lastFocused,n.propagateCurrent?t:null)}}catch(e){o=!0,a=e}finally{try{i||null==l.return||l.return()}finally{if(o)throw a}}r&&n.onFocusEnterImpl(t)}}}var t,n,r,i=e.prototype;return i.attachTo=function(e){null==this._parentController?(this._parentController=e,this._tryAttach()):console.error("".concat(this.constructor.name,": The controller has already been attached to a parent!\n").concat(this.debugTrace()))},i.detach=function(){null!=this._parentController?(this._tryDetach(),this._parentController=null):console.error("".concat(this.constructor.name,": The controller is not attached to parent!\n").concat(this.debugTrace()))},i.onFocusEnterImpl=function(e){},i._tryAttach=function(){this._enabled&&null!=this._parentController&&null!=this._focusKey&&(this._parentController.registerChild(this._focusKey,this),this._parentController.attachCallback(this.onFocusUpdate))},i._tryDetach=function(){this._enabled&&null!=this._parentController&&null!=this._focusKey&&(this._parentController.detachCallback(this.onFocusUpdate),this._parentController.unregisterChild(this._focusKey))},i.debugTrace=function(){var e="<-- ".concat(this.debugName);return null!=this._parentController&&(e+="\n",e+=this._parentController.debugTrace()),e},i.deepDebugTrace=function(){var e="--\x3e ".concat(this.debugName);return null!=this.debugFocusedChild&&(e+="\n",e+=this.debugFocusedChild.deepDebugTrace()),e},t=e,n=[{key:"focused",get:function(){return this._enabled&&null!=this._parentController&&null!=this._focusKey&&this._parentController.isChildFocused(this._focusKey)}},{key:"enabled",get:function(){return this._enabled},set:function(e){e!==this._enabled&&(this._tryDetach(),this._enabled=e,this._tryAttach())}},{key:"focusKey",get:function(){return this._focusKey},set:function(e){e!==this._focusKey&&(this._tryDetach(),this._focusKey=e,this._tryAttach())}},{key:"debugName",get:function(){var e,t;return null!==(t=null===(e=this._focusKey)||void 0===e?void 0:e.toString())&&void 0!==t?t:"<no-key>"}}],n&&sg(t.prototype,n),r&&sg(t,r),e}();function cg(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function ug(e,t,n){return ug="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(e,t,n){var r=hg(e,t);if(r){var i=Object.getOwnPropertyDescriptor(r,t);return i.get?i.get.call(n):i.value}},ug(e,t,n||e)}function dg(e){return dg=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)},dg(e)}function fg(e,t){return!t||"object"!==pg(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function mg(e,t,n,r){return mg="undefined"!=typeof Reflect&&Reflect.set?Reflect.set:function(e,t,n,r){var i,o=hg(e,t);if(o){if((i=Object.getOwnPropertyDescriptor(o,t)).set)return i.set.call(r,n),!0;if(!i.writable)return!1}if(i=Object.getOwnPropertyDescriptor(r,t)){if(!i.writable)return!1;i.value=n,Object.defineProperty(r,t,i)}else!function(e,t,n){t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n}(r,t,n);return!0},mg(e,t,n,r)}function gg(e,t){return gg=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e},gg(e,t)}function hg(e,t){for(;!Object.prototype.hasOwnProperty.call(e,t)&&null!==(e=dg(e)););return e}oe.add("game-ui/common/focus/controller/focus-controller-base.ts",{get FocusControllerBase(){return lg},set FocusControllerBase(e){lg=e}});var pg=function(e){return e&&"undefined"!=typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};function vg(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,r=dg(e);if(t){var i=dg(this).constructor;n=Reflect.construct(r,arguments,i)}else n=r.apply(this,arguments);return fg(this,n)}}function bg(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],r=(0,Y.useMemo)((function(){return new yg}),[]);return(0,Y.useEffect)((function(){r.debugName=e}),[r,e]),(0,Y.useEffect)((function(){r.childFocused=n}),[r,n]),(0,Y.useEffect)((function(){r.enabled=t}),[r,t]),r}var yg=function(e){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&gg(e,t)}(o,e);var t,n,r,i=vg(o);function o(){var e;return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,o),(e=i.apply(this,arguments)).childElement=null,e._childFocused=!1,e._debugName="PassThroughFocusController",e.isChildFocusedImpl=function(t){return e._childFocused&&t===e.focusKey},e.registerChild=function(t,n){null==e.focusKey?(e.childElement=n,e.focusKey=t):console.error("Cannot register second focus key '".concat(t,"'! PassThroughFocusControllers can only host a single child.\nRegistered key: ").concat(e.focusKey,"\n").concat(e.debugTrace()))},e.unregisterChild=function(t){e.focusKey===t?(e.focusKey=null,e.childElement=null):console.error("Attempted to unregister mismatching focus key '".concat(t,"' from a PassThroughFocusController!\nRegistered key: ").concat(e.focusKey,"\n").concat(e.debugTrace(),")"))},e.getBounds=function(){var t,n;return null!==(n=null===(t=e.childElement)||void 0===t?void 0:t.getBounds())&&void 0!==n?n:null},e}return o.prototype.getFocusedBounds=function(){var e,t;return null!==(t=null===(e=this.childElement)||void 0===e?void 0:e.getFocusedBounds())&&void 0!==t?t:null},t=o,n=[{key:"enabled",get:function(){return ug(dg(o.prototype),"enabled",this)},set:function(e){!function(e,t,n,r,i){if(!mg(e,t,n,r||e)&&i)throw new Error("failed to set property")}(dg(o.prototype),"enabled",e,this,!0)}},{key:"childFocused",get:function(){return this._childFocused},set:function(e){e!==this._childFocused&&(this._childFocused=e,this.updateChildren(this))}},{key:"debugName",get:function(){return this._debugName},set:function(e){this._debugName=e}},{key:"debugFocusedChild",get:function(){return this.childElement}}],n&&cg(t.prototype,n),r&&cg(t,r),o}(lg);function xg(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function _g(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return xg(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return xg(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function jg(e){var t=_g((0,Y.useState)(!1),2),n=t[0],r=t[1];return(0,Y.useEffect)((function(){return e.attachCallback(r),function(){return e.detachCallback(r)}}),[e]),n}function Og(e){var t=(0,Y.useRef)(!1);return(0,Y.useEffect)((function(){var n=function(e){t.current=e};return e.attachCallback(n),function(){return e.detachCallback(n)}}),[e]),t}function Eg(e,t){(0,Y.useEffect)((function(){if(null!=t)return e.attachCallback(t),function(){return e.detachCallback(t)}}),[t,e])}oe.add("game-ui/common/focus/controller/pass-through-focus-controller.tsx",{get usePassThroughFocusController(){return bg},set usePassThroughFocusController(e){bg=e}}),oe.add("game-ui/common/focus/focus-hooks.tsx",{get useFocused(){return jg},set useFocused(e){jg=e},get useFocusedRef(){return Og},set useFocusedRef(e){Og=e},get useFocusCallback(){return Eg},set useFocusCallback(e){Eg=e}});var Sg=function(e){var t=e.controller,n=e.children,r=(0,Y.useContext)(jd);return(0,Y.useEffect)((function(){t.attachTo(r)}),[t,r]),(0,Y.useLayoutEffect)((function(){return function(){return t.detach()}}),[t,r]),(0,z.jsx)(jd.Provider,{value:t,children:n})};oe.add("game-ui/common/focus/focus-node.tsx",{get FocusNode(){return Sg},set FocusNode(e){Sg=e}});var Tg=function(e){var t=e.disabled,n=e.children,r=e.onFocusChange,i=bg("FocusBoundary",!t);return Eg(i,r),(0,z.jsx)(Sg,{controller:i,children:n})};function Ig(){return _l(qm,wg,!1)}function wg(e,t){return t===Wm.keyboardAndMouse}function Pg(){return _l(qm,Cg,!1)}function Cg(e,t){return t===Wm.gamepad}oe.add("game-ui/common/focus/focus-boundary.tsx",{get FocusBoundary(){return Tg},set FocusBoundary(e){Tg=e}}),oe.add("game-ui/common/hooks/use-control-scheme.tsx",{get useKeyboardAndMouseActive(){return Ig},set useKeyboardAndMouseActive(e){Ig=e},get useGamepadActive(){return Pg},set useGamepadActive(e){Pg=e}});var Ng="tutorials",Ag=fl(Ng,"tutorialsEnabled"),Lg=fl(Ng,"introActive"),Mg=fl(Ng,"activeList"),kg=fl(Ng,"next"),Rg=fl(Ng,"pending"),Dg=fl(Ng,"categories"),Fg=gl(Ng,"groups"),Ug=ml(!1),Gg=function(e){Ug.update(e)},Bg=gl(Ng,"tutorials"),Vg=fl(Ng,"activeTutorial"),Hg=fl(Ng,"activeTutorialPhase"),Kg=fl(Ng,"listIntroActive"),Wg=fl(Ng,"listOutroActive"),zg=vl(Ng,"activateTutorial"),Yg=vl(Ng,"activateTutorialPhase"),$g=vl(Ng,"forceTutorial"),qg=function(){return Gg(!Ug.value)},Xg=pl(Ng,"completeActiveTutorialPhase"),Qg=pl(Ng,"completeActiveTutorial"),Zg=vl(Ng,"completeIntro"),Jg=pl(Ng,"completeListIntro"),eh=pl(Ng,"completeListOutro"),th=vl(Ng,"setTutorialTagActive"),nh=vl(Ng,"activateTutorialTrigger"),rh=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];(0,Y.useEffect)((function(){if(e&&t)return th(e,!0),function(){th(e,!1)}}),[t,e])},ih=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];(0,Y.useEffect)((function(){e&&t&&nh(e)}),[e,t])};function oh(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];(0,Y.useEffect)((function(){if(e&&t)return nh(e),th(e,!0),function(){th(e,!1)}}),[t,e])}var ah,sh,lh=ml(!1);function ch(){lh.update(!lh.value)}function uh(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function dh(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return uh(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return uh(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}!function(e){e[e.Tutorial=0]="Tutorial",e[e.Group=1]="Group"}(ah||(ah={})),function(e){e[e.Balloon=0]="Balloon",e[e.Card=1]="Card",e[e.CenterCard=2]="CenterCard"}(sh||(sh={})),oe.add("game-ui/game/data-binding/tutorial-bindings.ts",{get tutorialsEnabled(){return tutorialsEnabled},set tutorialsEnabled(e){tutorialsEnabled=e},get tutorialIntroActive(){return tutorialIntroActive},set tutorialIntroActive(e){tutorialIntroActive=e},get activeTutorialList(){return activeTutorialList},set activeTutorialList(e){activeTutorialList=e},get nextTutorial(){return nextTutorial},set nextTutorial(e){nextTutorial=e},get tutorialPending(){return tutorialPending},set tutorialPending(e){tutorialPending=e},get tutorialCategories(){return tutorialCategories},set tutorialCategories(e){tutorialCategories=e},get tutorialGroups(){return tutorialGroups},set tutorialGroups(e){tutorialGroups=e},get tutorialListFocused(){return tutorialListFocused},set tutorialListFocused(e){tutorialListFocused=e},get setTutorialListFocused(){return Gg},set setTutorialListFocused(e){Gg=e},get tutorials(){return tutorials},set tutorials(e){tutorials=e},get activeTutorial(){return activeTutorial},set activeTutorial(e){activeTutorial=e},get activeTutorialPhase(){return activeTutorialPhase},set activeTutorialPhase(e){activeTutorialPhase=e},get listIntroActive(){return listIntroActive},set listIntroActive(e){listIntroActive=e},get listOutroActive(){return listOutroActive},set listOutroActive(e){listOutroActive=e},get activateTutorial(){return zg},set activateTutorial(e){zg=e},get activateTutorialPhase(){return Yg},set activateTutorialPhase(e){Yg=e},get forceTutorial(){return $g},set forceTutorial(e){$g=e},get toggleTutorialListFocus(){return qg},set toggleTutorialListFocus(e){qg=e},get completeActiveTutorialPhase(){return Xg},set completeActiveTutorialPhase(e){Xg=e},get completeActiveTutorial(){return Qg},set completeActiveTutorial(e){Qg=e},get completeIntro(){return Zg},set completeIntro(e){Zg=e},get completeListIntro(){return Jg},set completeListIntro(e){Jg=e},get completeListOutro(){return eh},set completeListOutro(e){eh=e},get activateTutorialTag(){return th},set activateTutorialTag(e){th=e},get triggerTutorialTag(){return nh},set triggerTutorialTag(e){nh=e},get useTutorialTagActivation(){return rh},set useTutorialTagActivation(e){rh=e},get useTutorialTagTrigger(){return ih},set useTutorialTagTrigger(e){ih=e},get useTutorialTag(){return oh},set useTutorialTag(e){oh=e},get advisorPanelVisible(){return advisorPanelVisible},set advisorPanelVisible(e){advisorPanelVisible=e},get toggleAdvisorPanel(){return ch},set toggleAdvisorPanel(e){ch=e},get AdvisorItemType(){return ah},set AdvisorItemType(e){ah=e},get TutorialPhaseType(){return sh},set TutorialPhaseType(e){sh=e}});var fh=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.activeBlinkTags=new Array,this.activeBalloonTags=new Array,this.mountedBlinkComponents=new Map,this.mountedBalloonComponents=new Map,this.blinkTagsDirty=!0,this.balloonTagsDirty=!0}var t=e.prototype;return t.activateTags=function(e,t){var n=this;this.activeBlinkTags.length=0,this.activeBalloonTags.length=0,null!==e&&e.forEach((function(e){return n.activeBlinkTags.push(e.map((function(e){return e.toLowerCase()})))})),null!==t&&t.forEach((function(e){return n.activeBalloonTags.push(e.toLowerCase())})),this.refreshBlinkTags(),this.refreshBalloonTags()},t.mountBlinkListener=function(e,t){this.mountedBlinkComponents.set(e.toLowerCase(),t),this.blinkTagsDirty=!0},t.mountBalloonListener=function(e,t,n,r){this.mountedBalloonComponents.set(e.toLowerCase(),[t,n,r]),this.balloonTagsDirty=!0},t.unmountBlinkListener=function(e){this.mountedBlinkComponents.delete(e.toLowerCase()),this.blinkTagsDirty=!0},t.unmountBalloonListener=function(e){this.mountedBalloonComponents.delete(e.toLowerCase()),this.balloonTagsDirty=!0},t.refreshBlinkTags=function(){var e=this.FindTopBlinkTags();this.mountedBlinkComponents.forEach((function(t,n){return t(null!=e&&void 0!==e.find((function(e){return e.split("|").map((function(e){return e.trim()})).includes(n)})))})),this.blinkTagsDirty=!1},t.refreshBalloonTags=function(){var e=this,t=dh(this.FindTopBalloonTag(),2),n=t[0],r=t[1];this.mountedBalloonComponents.forEach((function(t,i){var o=dh(t,3),a=o[0],s=o[1],l=o[2],c=!1,u=null==n?void 0:n.split("|").map((function(e){return e.trim()}));if(void 0!==u){var d=u.indexOf(i);if(d>0){for(var f=!0,m=d-1;m>=0;m--)e.mountedBalloonComponents.has(u[m])&&(f=!1);c=f}else c=0===d}a(c),s(c&&n!==e.activeBalloonTags[0]),l(r)})),this.balloonTagsDirty=!1},t.isBlinkTagsDirty=function(){return this.blinkTagsDirty},t.isBalloonTagsDirty=function(){return this.balloonTagsDirty},t.FindTopBlinkTags=function(){for(var e=0;e<this.activeBlinkTags.length;++e)for(var t=0;t<this.activeBlinkTags[e].length;t++)if(this.mountedBlinkComponents.has(this.activeBlinkTags[e][t]))return this.activeBlinkTags[e];return null},t.FindTopBalloonTag=function(){for(var e,t=this,n=function(e){for(var n=t.activeBalloonTags[e].split("|").map((function(e){return e.trim()})),r=0;r<n.length;r++)if(t.mountedBalloonComponents.has(n[r]))return{v:[t.activeBalloonTags[e],e]}},r=0;r<this.activeBalloonTags.length;++r){var i=n(r);if("object"==((e=i)&&"undefined"!=typeof Symbol&&e.constructor===Symbol?"symbol":typeof e))return i.v}return[null,-1]},e}();oe.add("game-ui/game/components/tutorials/tutorial-target/tutorial-target-manager.ts",{get TutorialTargetManager(){return fh},set TutorialTargetManager(e){fh=e}});var mh=new fh,gh=Y.createContext(mh),hh=Y.createContext(!1),ph=function(e){var t,n=e.children,r=xl(Hg),i=null!=r&&r.type===sh.Balloon?r.balloonTargets.map((function(e){return e.uiTag})):null,o=(null==r||null===(t=r.trigger)||void 0===t?void 0:t.active)?r.trigger.blinkTags:null;return vh(o,i),(0,z.jsx)(gh.Provider,{value:mh,children:n})},vh=function(e,t){var n=(0,Y.useContext)(gh);(0,Y.useEffect)((function(){return n.activateTags(e,t),function(){return n.activateTags(null,null)}}),[n,e,t]),(0,Y.useEffect)((function(){var e=0,t=function(){n.isBalloonTagsDirty()&&n.refreshBalloonTags(),n.isBlinkTagsDirty()&&n.refreshBlinkTags(),e=window.requestAnimationFrame(t)};return t(),function(){return window.cancelAnimationFrame(e)}}),[n])};oe.add("game-ui/game/components/tutorials/tutorial-target/tutorial-context.tsx",{get TutorialContext(){return gh},set TutorialContext(e){gh=e},get TooltipDisableContext(){return hh},set TooltipDisableContext(e){hh=e},get TutorialTargetProvider(){return ph},set TutorialTargetProvider(e){ph=e}});let bh={balloon:"balloon_qJY balloon_H23",enter:"enter_ZTk","enter-active":"enter-active_AJs",enterActive:"enter-active_AJs","exit-active":"exit-active_RfZ",exitActive:"exit-active_RfZ",container:"container_zgM container_jfe",arrow:"arrow_SVb arrow_Xfn",content:"content_A82 content_JQV"};oe.add("game-ui/common/tooltip/tooltip.module.scss",{get classes(){return bh},set classes(e){Object.assign(bh,e)}});const yh=bh;function xh(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function _h(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return xh(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return xh(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var jh=function(e){var t=e.tooltip,n=e.disabled,r=e.theme,i=void 0===r?yh:r,o=e.direction,a=e.alignment,s=e.className,l=e.children;if(!(0,Y.isValidElement)(l))throw new Error("Tooltip requires a single child react element!");var c=_h((0,Y.useState)(!1),2),u=c[0],d=c[1],f=(0,Y.useCallback)((function(){return d(!0)}),[]),m=(0,Y.useCallback)((function(){return d(!1)}),[]),g=(0,Y.useCallback)((function(){return d(!1)}),[]),h=_h((0,Y.useState)(!1),2),p=h[0],v=h[1],b=(0,Y.useCallback)((function(e){return v(e)}),[]),y=Pg();(0,Y.useEffect)((function(){if(y&&p){var e=Qm.subscribe((function(e){e&&v(!1)}));return function(){return e.dispose()}}}),[y,p]);var x=(0,Y.useRef)(null),_=(0,Y.useCallback)((function(e){x.current!==e&&(null!=x.current&&(x.current.removeEventListener("mouseover",f),x.current.removeEventListener("mouseleave",m),x.current.removeEventListener("mousedown",g)),null!=e&&(e.addEventListener("mouseover",f),e.addEventListener("mouseleave",m),e.addEventListener("mousedown",g)),x.current=e)}),[g,m,f]),j=!!t&&Y.Children.count(l)>0,O=(0,Y.useContext)(hh);return(0,z.jsx)(z.Fragment,{children:(0,z.jsx)(Tg,{onFocusChange:b,children:(0,z.jsx)(Um,{visible:(y&&p||u)&&j&&!n&&!O,direction:o,alignment:a,theme:i,content:t,className:s,children:(0,z.jsx)(Zd,{ref:_,children:l})})})})};oe.add("game-ui/common/tooltip/tooltip.tsx",{get Tooltip(){return jh},set Tooltip(e){jh=e}});var Oh,Eh,Sh,Th="app";!function(e){e[e.Off=0]="Off",e[e.Simple=1]="Simple",e[e.Advanced=2]="Advanced",e[e.Precise=3]="Precise"}(Oh||(Oh={})),function(e){e[e.Warning=0]="Warning",e[e.Error=1]="Error"}(Eh||(Eh={})),function(e){e[e.Quit=1]="Quit",e[e.SaveAndQuit=2]="SaveAndQuit"}(Sh||(Sh={}));var Ih=fl(Th,"ready"),wh=fl(Th,"activeUI"),Ph=fl(Th,"bodyClassNames",""),Ch=fl(Th,"fpsMode"),Nh=fl(Th,"frameStats"),Ah=fl(Th,"activeLocale","en-US"),Lh=fl(Th,"currentError"),Mh=fl(Th,"backgroundProcessMessage",null),kh=hl(Th,"confirmationDialog");function Rh(e){bl(Th,"confirmationDialogCallback",e)}function Dh(e,t){bl(Th,"dismissableConfirmationDialogCallback",e,t)}function Fh(){bl(Th,"exitApplication")}function Uh(){bl(Th,"saveBackupAndExitApplication")}function Gh(e){bl(Th,"setClipboard",e)}function Bh(){bl(Th,"dismissCurrentError")}var Vh=fl(Th,"activeUIModsLocation");oe.add("game-ui/common/data-binding/app-bindings.ts",{get FPSMode(){return Oh},set FPSMode(e){Oh=e},get Severity(){return Eh},set Severity(e){Eh=e},get Actions(){return Sh},set Actions(e){Sh=e},get ready(){return ready},set ready(e){ready=e},get activeUI(){return activeUI},set activeUI(e){activeUI=e},get bodyClassNames(){return bodyClassNames},set bodyClassNames(e){bodyClassNames=e},get fpsMode(){return fpsMode},set fpsMode(e){fpsMode=e},get frameStats(){return frameStats},set frameStats(e){frameStats=e},get activeLocale(){return activeLocale},set activeLocale(e){activeLocale=e},get currentError(){return currentError},set currentError(e){currentError=e},get backgroundProcessMessage(){return backgroundProcessMessage},set backgroundProcessMessage(e){backgroundProcessMessage=e},get confirmationDialog(){return confirmationDialog},set confirmationDialog(e){confirmationDialog=e},get confirmationDialogCallback(){return Rh},set confirmationDialogCallback(e){Rh=e},get dismissableConfirmationDialogCallback(){return Dh},set dismissableConfirmationDialogCallback(e){Dh=e},get exitApplication(){return Fh},set exitApplication(e){Fh=e},get saveBackupAndExitApplication(){return Uh},set saveBackupAndExitApplication(e){Uh=e},get setClipboard(){return Gh},set setClipboard(e){Gh=e},get dismissCurrentError(){return Bh},set dismissCurrentError(e){Bh=e},get activeUIModsLocation(){return activeUIModsLocation},set activeUIModsLocation(e){activeUIModsLocation=e}});var Hh=Symbol("FOCUS_DISABLED"),Kh=Symbol("FOCUS_AUTO"),Wh=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.debugName=t,this.r=Math.floor(1e6*Math.random())}return e.prototype.toString=function(){return"".concat(this.debugName,":").concat(this.r)},e}();function zh(e,t){return(0,Y.useMemo)((function(){return e===Hh?null:e===Kh?new Wh(t):e}),[e,t])}function Yh(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function $h(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}oe.add("game-ui/common/focus/focus-key.ts",{get FOCUS_DISABLED(){return Hh},set FOCUS_DISABLED(e){Hh=e},get FOCUS_AUTO(){return Kh},set FOCUS_AUTO(e){Kh=e},get FocusSymbol(){return Wh},set FocusSymbol(e){Wh=e},get useUniqueFocusKey(){return zh},set useUniqueFocusKey(e){zh=e}});var qh={attachChild:function(){},detachChild:function(){},transformStack:function(){},setDirty:function(){}},Xh=Y.createContext(qh);function Qh(e,t){var n=(0,Y.useContext)(Xh),r=(0,Y.useMemo)((function(){return new Zh}),[]);return(0,Y.useEffect)((function(){r.transformer=t}),[r,t]),(0,Y.useEffect)((function(){if(e)return r.attachTo(n),function(){return r.detach()}}),[e,r,n]),r}var Zh=function(){function e(){Yh(this,e),this._parent=null,this._child=null,this._transformer=null}var t,n,r,i=e.prototype;return i.attachTo=function(e){this._parent=e,this._parent.attachChild(this)},i.detach=function(){null!=this._parent?(this._parent.detachChild(this),this._parent=null):console.error("The input controller is not attached to parent!")},i.attachChild=function(e){this._child!==e&&(this._child=e,this.setDirty())},i.detachChild=function(e){this._child===e&&(this._child=null,this.setDirty())},i.transformStack=function(e){null!=this._transformer&&this._transformer(e),null!=this._child&&this._child.transformStack(e)},i.setDirty=function(){null!=this._parent&&this._parent.setDirty()},t=e,n=[{key:"transformer",get:function(){return this._transformer},set:function(e){this._transformer!==e&&(this._transformer=e,this.setDirty())}}],n&&$h(t.prototype,n),r&&$h(t,r),e}(),Jh=function(){function e(t,n){Yh(this,e),this.stack=t,this.onStackChanged=n,this._child=null}var t=e.prototype;return t.attachChild=function(e){this._child!==e&&(this._child=e,this.setDirty())},t.detachChild=function(e){this._child===e&&(this._child=null,this.setDirty())},t.transformStack=function(){},t.setDirty=function(){this.stack.clear(),null!=this._child&&this._child.transformStack(this.stack),this.onStackChanged()},e}();function ep(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function tp(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function np(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return ep(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return ep(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/input-events/input-controller.ts",{get defaultInputController(){return qh},set defaultInputController(e){qh=e},get InputContext(){return Xh},set InputContext(e){Xh=e},get useInputController(){return Qh},set useInputController(e){Qh=e},get InputControllerImpl(){return Zh},set InputControllerImpl(e){Zh=e},get RootInputControllerImpl(){return Jh},set RootInputControllerImpl(e){Jh=e}});var rp=Y.memo((function(e){var t=e.actions,n=e.disabled,r=e.children,i=bg("InputActionConsumer"),o=jg(i),a=(0,Y.useCallback)((function(e){if(null!=t)for(var n=Object.entries(t),r=n.length-1;r>=0;r--){var i=np(n[r],2),o=i[0],a=i[1];null!=a&&e.push(o,a)}}),[t]),s=Qh(o,n?null:a);return(0,z.jsx)(Sg,{controller:i,children:(0,z.jsx)(Xh.Provider,{value:s,children:r})})}),(function(e,t){e.actions;var n=tp(e,["actions"]);t.actions;return el(n,tp(t,["actions"]))&&el(e.actions,t.actions)})),ip=function(e){var t=e.disabled,n=e.children,r=e.onAction,i=(0,Y.useMemo)((function(){return{Select:r}}),[r]);return(0,z.jsx)(rp,{actions:i,disabled:t,children:n})},op=function(e){var t=e.expanded,n=e.expandable,r=e.disabled,i=e.children,o=e.onAction,a=(0,Y.useMemo)((function(){return function(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}({},t?"Collapse Group":"Expand Group",n?o:null)}),[n,t,o]);return(0,z.jsx)(rp,{actions:a,disabled:r,children:i})},ap=function(e){var t=e.disabled,n=e.children,r=e.onAction,i=(0,Y.useMemo)((function(){return{Back:r}}),[r]);return(0,z.jsx)(rp,{actions:i,disabled:t,children:n})};function sp(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function lp(e){return lp=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)},lp(e)}function cp(e,t){return!t||"object"!==dp(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function up(e,t){return up=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e},up(e,t)}oe.add("game-ui/common/input-events/input-action-consumer.tsx",{get InputActionConsumer(){return rp},set InputActionConsumer(e){rp=e},get SelectConsumer(){return ip},set SelectConsumer(e){ip=e},get ExpandConsumer(){return op},set ExpandConsumer(e){op=e},get BackConsumer(){return ap},set BackConsumer(e){ap=e}});var dp=function(e){return e&&"undefined"!=typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};function fp(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,r=lp(e);if(t){var i=lp(this).constructor;n=Reflect.construct(r,arguments,i)}else n=r.apply(this,arguments);return cp(this,n)}}function mp(e,t){return(0,Y.useMemo)((function(){return new hp(e,t)}),[e,t])}var gp,hp=function(e){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&up(e,t)}(n,e);var t=fp(n);function n(e,r){var i;return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,n),(i=t.call(this)).activation=r,i.children=new Map,i._focusedChildKey=null,i.onRefocus=null,i.isChildFocusedImpl=function(e){return e===i._focusedChildKey&&i.children.has(i._focusedChildKey)},i.registerChild=function(e,t){i.children.has(e)?console.error("The focus key '".concat(String(e),"' has already been registered in this MultiChildFocusController!\n").concat(i.debugTrace())):(i.children.set(e,t),i.enabled||(i.activation===yd.FocusedChild?i.enabled=i._focusedChildKey===e:i.activation===yd.AnyChildren&&(i.enabled=!0)),!i.onRefocus||!i.focused||null!=i._focusedChildKey&&i.children.has(i._focusedChildKey)||i.onRefocus(null))},i.unregisterChild=function(e){var t=i.children.get(e);null!=t?(i.enabled&&(i.activation===yd.FocusedChild?i.enabled=i._focusedChildKey!==e:i.activation===yd.AnyChildren&&(i.enabled=i.children.size>0)),i.children.delete(e),i.onRefocus&&i.focused&&e===i.focusedChildKey&&i.onRefocus(t)):console.error("Attempted to unregister mismatching focus key '".concat(String(e),"' from a MultiChildFocusController!\n").concat(i.debugTrace()))},i.enabled=r===yd.Always,i.focusKey=e,i}var r,i,o,a=n.prototype;return a.has=function(e){return this.children.has(e)},a.get=function(e){return this.children.get(e)},a.entries=function(){return this.children},a.getBounds=function(){var e=0,t=0,n=0,r=0,i=!1,o=!0,a=!1,s=void 0;try{for(var l,c=this.children.values()[Symbol.iterator]();!(o=(l=c.next()).done);o=!0){var u=l.value.getBounds();null!=u&&(i?(e=Math.min(u.left,e),t=Math.min(u.top,t),n=Math.max(u.right,n),r=Math.max(u.bottom,r)):(e=u.left,t=u.top,n=u.right,r=u.bottom,i=!0))}}catch(e){a=!0,s=e}finally{try{o||null==c.return||c.return()}finally{if(a)throw s}}return i?{left:e,top:t,right:n,bottom:r,width:n-e,height:r-t}:null},a.getFocusedBounds=function(){if(null!=this._focusedChildKey){var e=this.children.get(this._focusedChildKey);if(null!=e)return e.getFocusedBounds()}return null},a.onFocusEnterImpl=function(e){null!=this.onRefocus&&this.onRefocus(e)},r=n,(i=[{key:"focusedChildKey",get:function(){return this._focusedChildKey},set:function(e){if(e!==this._focusedChildKey){var t=null!=this._focusedChildKey?this.children.get(this._focusedChildKey):void 0,n=null!=e&&this.children.has(e);n||(this.enabled=this.activation!==yd.FocusedChild),this._focusedChildKey=e,n?this.enabled?this.updateChildren(null!=t?t:null):this.enabled=!0:(null!=this.onRefocus&&this.onRefocus(null!=t?t:null),null!=t&&this.updateChildren(null!=t?t:null))}}},{key:"debugFocusedChild",get:function(){var e;return null!=this._focusedChildKey&&null!==(e=this.children.get(this._focusedChildKey))&&void 0!==e?e:null}}])&&sp(r.prototype,i),o&&sp(r,o),n}(lg);function pp(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function vp(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return pp(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return pp(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function bp(e,t){switch(t){case gp.Horizontal:return Math.abs(e.x)>Math.abs(e.y)?{x:Math.sign(e.x),y:0}:lf;case gp.Vertical:return Math.abs(e.y)>Math.abs(e.x)?{x:0,y:Math.sign(e.y)}:lf;case gp.Both:return hf(e);default:return lf}}function yp(e,t,n){var r=Number.MAX_VALUE,i=null,o=!0,a=!1,s=void 0;try{for(var l,c=e.entries()[Symbol.iterator]();!(o=(l=c.next()).done);o=!0){var u=vp(l.value,2),d=u[0],f=Tp(u[1].getBounds(),n);if(null!=f){var m=f.x-t.x,g=f.y-t.y,h=m*m+g*g;h<r&&(r=h,i=d)}}}catch(e){a=!0,s=e}finally{try{o||null==c.return||c.return()}finally{if(a)throw s}}return i}function xp(e,t,n,r,i){var o=null,a=Number.MAX_VALUE,s=!0,l=!1,c=void 0;try{for(var u,d=e.entries()[Symbol.iterator]();!(s=(u=d.next()).done);s=!0){var f=vp(u.value,2),m=f[0],g=f[1];if(m!==i){var h=g.getBounds();if(null!=h){var p=Tp(h,r);if(null!=p){var v=p.x-t.x,b=p.y-t.y;if(!(v*n.x-b*n.y<=0)){var y={x:of(t.x,h.left,h.right),y:of(t.y,h.top,h.bottom)},x=y.x-t.x,_=y.y-t.y,j=x*n.x-_*n.y,O=_*n.x+x*n.y,E=1*j+5*Math.abs(O);E<a&&(o=m,a=E)}}}}}}catch(e){l=!0,c=e}finally{try{s||null==d.return||d.return()}finally{if(l)throw c}}return o}oe.add("game-ui/common/focus/controller/multi-child-focus-controller.tsx",{get useMultiChildFocusController(){return mp},set useMultiChildFocusController(e){mp=e},get MultiChildFocusController(){return hp},set MultiChildFocusController(e){hp=e}}),function(e){e.Horizontal="horizontal",e.Vertical="vertical",e.Both="both",e.None="none"}(gp||(gp={}));var _p={x:.5,y:.5},jp={x:.5,y:0},Op={x:0,y:.5},Ep={x:.5,y:1},Sp={x:1,y:.5};function Tp(e,t){return null!=e?{x:e.left*(1-t.x)+e.right*t.x,y:e.top*(1-t.y)+e.bottom*t.y}:null}oe.add("game-ui/common/focus/navigation.ts",{get NavigationDirection(){return gp},set NavigationDirection(e){gp=e},get transformNavigationInput(){return bp},set transformNavigationInput(e){bp=e},get getClosestKey(){return yp},set getClosestKey(e){yp=e},get getClosestKeyInDirection(){return xp},set getClosestKeyInDirection(e){xp=e},get focusAnchorCenter(){return _p},set focusAnchorCenter(e){_p=e},get focusAnchorTop(){return jp},set focusAnchorTop(e){jp=e},get focusAnchorLeft(){return Op},set focusAnchorLeft(e){Op=e},get focusAnchorBottom(){return Ep},set focusAnchorBottom(e){Ep=e},get focusAnchorRight(){return Sp},set focusAnchorRight(e){Sp=e},get getElementFocusPosition(){return Tp},set getElementFocusPosition(e){Tp=e}});var Ip=function(e){var t=e.focusKey,n=void 0===t?Kh:t,r=e.debugName,i=void 0===r?"NavigationScope":r,o=e.focused,a=e.direction,s=void 0===a?gp.Both:a,l=e.activation,c=void 0===l?yd.AnyChildren:l,u=e.children,d=e.onChange,f=e.onRefocus,m=mp(zh(n,i),c);(0,Y.useEffect)((function(){m.focusedChildKey=o}),[m,o]),(0,Y.useEffect)((function(){if(null!=f)return!m.focused||null!=m.focusedChildKey&&m.has(m.focusedChildKey)||d(f(m,null)),m.onRefocus=function(e){d(f(m,e))},function(){m.onRefocus=null}}),[m,d,f]);var g=(0,Y.useCallback)((function(e){var t=null!==m.focusedChildKey&&m.get(m.focusedChildKey);if(null===m.focusedChildKey||!t){var n=yp(m,lf,_p);return null!=n&&(d(n),!0)}var r={x:.5+.5*e.x,y:.5-.5*e.y},i=Tp(t.getFocusedBounds(),r);if(null!=i){var o=xp(m,i,e,_p,m.focusedChildKey);return null!=o&&(d(o),!0)}}),[m,d]),h=s===gp.Both||s===gp.Horizontal,p=s===gp.Both||s===gp.Vertical,v=(0,Y.useMemo)((function(){return{"Move Horizontal":h?function(e){return g({x:e,y:0})}:null,"Move Vertical":p?function(e){return g({x:0,y:e})}:null}}),[h,p,g]);return(0,z.jsx)(rp,{actions:v,children:(0,z.jsx)(Sg,{controller:m,children:u})})};function wp(e,t){return null!=e.focusedChildKey&&e.has(e.focusedChildKey)?e.focusedChildKey:Pp(e,t)}function Pp(e,t){if(null==t&&null!=e.focusedChildKey&&e.has(e.focusedChildKey))return e.focusedChildKey;var n,r=lf;null!=t&&(r=null!==(n=Tp(t.getFocusedBounds(),_p))&&void 0!==n?n:lf);return yp(e,r,_p)}function Cp(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Np(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Cp(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Cp(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/focus/navigation-scope.tsx",{get NavigationScope(){return Ip},set NavigationScope(e){Ip=e},get refocusClosestKeyIfNoFocus(){return wp},set refocusClosestKeyIfNoFocus(e){wp=e},get refocusClosestKey(){return Pp},set refocusClosestKey(e){Pp=e}});var Ap=function(e){var t=e.focusKey,n=void 0===t?Kh:t,r=e.initialFocused,i=e.direction,o=e.activation,a=e.children,s=e.onRefocus,l=void 0===s?Pp:s,c=Np((0,Y.useState)(null!=r?r:null),2),u=c[0],d=c[1];return(0,z.jsx)(Ip,{focusKey:n,focused:u,direction:i,activation:o,debugName:"AutoNavigationScope",onChange:d,onRefocus:l,children:a})};oe.add("game-ui/common/focus/auto-navigation-scope.tsx",{get AutoNavigationScope(){return Ap},set AutoNavigationScope(e){Ap=e}});var Lp,Mp="audio";function kp(e){null!=e&&bl(Mp,"playSound",e,arguments.length>1&&void 0!==arguments[1]?arguments[1]:1)}!function(e){e.selectItem="select-item",e.dragSlider="drag-slider",e.hoverItem="hover-item",e.expandPanel="expand-panel",e.grabSlider="grabSlider",e.selectDropdown="select-dropdown",e.selectToggle="select-toggle",e.focusInputField="focus-input-field",e.signatureBuildingEvent="signature-building-event",e.bulldoze="bulldoze",e.bulldozeEnd="bulldoze-end",e.relocateBuilding="relocate-building",e.mapTilePurchaseMode="map-tile-purchase-mode",e.mapTilePurchaseModeEnd="map-tile-purchase-mode-end",e.xpEvent="xp-event",e.milestoneEvent="milestone-event",e.economy="economy",e.chirpEvent="chirp-event",e.likeChirp="like-chirp",e.chirper="chirper",e.purchase="purchase",e.enableBuilding="enable-building",e.disableBuilding="disable-building",e.pauseSimulation="pause-simulation",e.resumeSimulation="resume-simulation",e.simulationSpeed1="simulation-speed-1",e.simulationSpeed2="simulation-speed-2",e.simulationSpeed3="simulation-speed-3",e.togglePolicy="toggle-policy",e.takeLoan="take-loan",e.removeItem="remove-item",e.toggleInfoMode="toggle-info-mode",e.takePhoto="take-photo",e.tutorialTriggerCompleteEvent="tutorial-trigger-complete-event",e.selectRadioNetwork="select-radio-network",e.selectRadioStation="select-radio-station",e.generateRandomName="generate-random-name",e.decreaseElevation="decrease-elevation",e.increaseElevation="increase-elevation",e.selectPreviousItem="select-previous-item",e.selectNextItem="select-next-item",e.openPanel="open-panel",e.closePanel="close-panel",e.openMenu="open-menu",e.closeMenu="close-menu"}(Lp||(Lp={})),oe.add("game-ui/common/data-binding/audio-bindings.ts",{get UISound(){return Lp},set UISound(e){Lp=e},get playUISound(){return kp},set playUISound(e){kp=e}});var Rp=Y.createContext({scrollTo:function(){},scrollBy:function(){},smoothScrollTo:function(){},scrollIntoView:function(){},updateThumbs:function(){}});function Dp(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function Fp(e){return Fp=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)},Fp(e)}function Up(e,t){return!t||"object"!==Bp(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function Gp(e,t){return Gp=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e},Gp(e,t)}oe.add("game-ui/common/scrolling/scrollable-context.ts",{get ScrollableContext(){return Rp},set ScrollableContext(e){Rp=e}});var Bp=function(e){return e&&"undefined"!=typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};function Vp(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,r=Fp(e);if(t){var i=Fp(this).constructor;n=Reflect.construct(r,arguments,i)}else n=r.apply(this,arguments);return Up(this,n)}}function Hp(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:yd.Always,r=arguments.length>3&&void 0!==arguments[3]&&arguments[3],i=(0,Y.useCallback)((function(){var e;return(null===(e=t.current)||void 0===e?void 0:e.getBoundingClientRect())||null}),[t]),o=(0,Y.useMemo)((function(){return new Kp(e,i,n,r)}),[e,i,n,r]),a=(0,Y.useContext)(Rp),s=jl(qm);return Eg(o,(0,Y.useCallback)((function(e){e&&s.current===Wm.gamepad&&null!=t.current&&a.scrollIntoView(t.current)}),[s,t,a])),o}var Kp=function(e){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&Gp(e,t)}(o,e);var t,n,r,i=Vp(o);function o(e,t,n,r){var a;return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,o),(a=i.call(this)).getBounds=t,a.activation=n,a.allowChildren=r,a.childFocusKey=null,a.childElement=null,a.isChildFocusedImpl=function(e){return e===a.childFocusKey},a.registerChild=function(e,t){a.allowChildren?null==a.childFocusKey?(a.childFocusKey=e,a.childElement=t,a.activation!==yd.Always&&(a.enabled=!0)):console.error("Cannot register second child '".concat(e,"'. This focus node can only host a single child!\nRegistered key: ").concat(a.childFocusKey,"\n").concat(a.debugTrace())):console.error("".concat(a.focusKey,": Cannot register child '").concat(e,"'. Children are not allowed in this focus node!"))},a.unregisterChild=function(e){a.childFocusKey===e?(a.childFocusKey=null,a.childElement=null,a.activation!==yd.Always&&(a.enabled=!1)):console.error("Attempted to unregister mismatching focus key '".concat(e,"'!\nRegistered key: ").concat(a.childFocusKey,"\n").concat(a.debugTrace()))},a.enabled=a.activation===yd.Always,a.focusKey=e,a}return o.prototype.getFocusedBounds=function(){var e,t;return null!==(t=null===(e=this.childElement)||void 0===e?void 0:e.getFocusedBounds())&&void 0!==t?t:this.getBounds()},t=o,(n=[{key:"debugFocusedChild",get:function(){return this.childElement}}])&&Dp(t.prototype,n),r&&Dp(t,r),o}(lg);function Wp(e,t,n){if(e.current){var r=window.getComputedStyle(e.current).getPropertyValue(t),i=window.getComputedStyle(e.current).getPropertyValue(n);r&&"none"!==r&&i&&(e.current.style.animation="",window.requestAnimationFrame((function(){return window.requestAnimationFrame((function(){e.current&&(e.current.style.animationName=r,e.current.style.animationDuration=i)}))})))}}function zp(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Yp(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){zp(e,t,n[t])}))}return e}function $p(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function qp(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}oe.add("game-ui/common/focus/controller/element-focus-context.tsx",{get useElementFocusController(){return Hp},set useElementFocusController(e){Hp=e}}),oe.add("game-ui/common/utils/animation.ts",{get playCssAnimation(){return Wp},set playCssAnimation(e){Wp=e}});var Xp={select:Lp.selectItem,hover:Lp.hoverItem,focus:Lp.hoverItem},Qp=(0,Y.forwardRef)((function(e,t){var n=e.focusKey,r=e.debugName,i=void 0===r?"Button":r,o=e.selected,a=e.disabled,s=e.theme,l=e.sounds,c=void 0===l?Xp:l,u=e.selectAction,d=void 0===u?"Select":u,f=e.selectSound,m=e.className,g=e.onClick,h=e.onMouseEnter,p=e.onSelect,v=e.children,b=qp(e,["focusKey","debugName","selected","disabled","theme","sounds","selectAction","selectSound","className","onClick","onMouseEnter","onSelect","children"]),y=(0,Y.useRef)(null),x=Hd(t,y),_=Hp(zh(null!=n?n:a?Hh:Kh,i),y),j=jg(_),O=Pg(),E=(0,Y.useMemo)((function(){return void 0!==f?$p(Yp({},c),{select:f}):c}),[f,c]),S=(0,Y.useMemo)((function(){return null!=p?zp({},d,(function(){Wp(y,"--selectAnimation","--selectDuration"),kp(null==E?void 0:E.select),p()})):null}),[p,d,null==E?void 0:E.select]),T=(0,Y.useCallback)((function(e){(p||g)&&(a||kp(null==E?void 0:E.select),p&&p(),g&&g(e),e.stopPropagation())}),[a,g,p,null==E?void 0:E.select]),I=(0,Y.useCallback)((function(e){a||kp(null==E?void 0:E.hover),h&&h(e)}),[a,null==E?void 0:E.hover,h]);return(0,Y.useEffect)((function(){j&&O&&kp(null==E?void 0:E.focus)}),[j,O,null==E?void 0:E.focus]),(0,z.jsx)(rp,{actions:S,disabled:a,children:(0,z.jsx)(Sg,{controller:_,children:(0,z.jsx)(Qd,{children:(0,z.jsx)("button",$p(Yp({},b),{ref:x,disabled:a,className:_d()(null==s?void 0:s.button,o&&"selected",j&&O&&"focused",m),onClick:T,onMouseEnter:I,children:v}))})})})}));oe.add("game-ui/common/input/button/button.tsx",{get defaultButtonSounds(){return Xp},set defaultButtonSounds(e){Xp=e},get Button(){return Qp},set Button(e){Qp=e}});let Zp={button:"button_HeP",negative:"negative_ocn"};oe.add("game-ui/common/input/button/themes/dialog-button.module.scss",{get classes(){return Zp},set classes(e){Object.assign(Zp,e)}});const Jp=Zp;let ev={button:"button_Ylt"};oe.add("game-ui/common/input/button/themes/paradox-primary-button.module.scss",{get classes(){return ev},set classes(e){Object.assign(ev,e)}});const tv=ev;let nv={button:"button_Yp5"};oe.add("game-ui/common/input/button/themes/paradox-secondary-button.module.scss",{get classes(){return nv},set classes(e){Object.assign(nv,e)}});const rv=nv;function iv(e){e.stopPropagation()}oe.add("game-ui/common/utils/cancel-click.ts",{get cancelClick(){return iv},set cancelClick(e){iv=e}});var ov=Y.forwardRef((function(e,t){var n=e.focusKey,r=e.debugName,i=void 0===r?"Toggle":r,o=e.checked,a=e.disabled,s=void 0!==a&&a,l=e.style,c=e.toggleSound,u=void 0===c?Lp.selectToggle:c,d=e.className,f=e.children,m=e.onChange,g=e.onMouseOver,h=e.onMouseLeave,p=(0,Y.useCallback)((function(){m&&(kp(u),m(!o))}),[o,m,u]),v=(0,Y.useCallback)((function(e){p(),m&&!s&&iv(e)}),[s,p,m]),b=(0,Y.useRef)(null),y=Hd(t,b),x=Hp(zh(null!=n?n:s?Hh:Kh,i),b),_=jg(x),j=Pg();return(0,z.jsx)(ip,{onAction:s?void 0:p,children:(0,z.jsx)(Sg,{controller:x,children:(0,z.jsx)("div",{ref:y,onClick:s?void 0:v,onMouseOver:g,onMouseLeave:h,style:l,className:_d()(d,o?"checked":"unchecked",s&&"disabled",_&&j&&"focused"),children:f})})})}));oe.add("game-ui/common/input/toggle/toggle.tsx",{get Toggle(){return ov},set Toggle(e){ov=e}});let av={toggle:"toggle_cca item-mouse-states_Fmi",checkmark:"checkmark_NXV"};oe.add("game-ui/common/input/toggle/checkbox/checkbox.module.scss",{get classes(){return av},set classes(e){Object.assign(av,e)}});const sv=av;function lv(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function cv(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){lv(e,t,n[t])}))}return e}function uv(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function dv(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var fv=function(e){var t=e.checked,n=e.disabled,r=e.theme,i=e.className,o=dv(e,["checked","disabled","theme","className"]),a=(0,Y.useMemo)((function(){return cv({},sv,r)}),[r]);return(0,z.jsx)(ov,uv(cv({},o),{checked:t,disabled:n,className:_d()(a.toggle,i),children:(0,z.jsx)("div",{className:_d()(a.checkmark,t&&"checked",n&&"disabled")})}))};oe.add("game-ui/common/input/toggle/checkbox/checkbox.tsx",{get Checkbox(){return fv},set Checkbox(e){fv=e}});var mv=/\s/,gv=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.linkRenderer=t}return e.prototype.render=function(e){for(var t=[],n=0,r=-1,i=-1,o=Ev.None,a=0;a<e.length;a++)switch(e[a]){case"-":0===a&&" "===e[a+1]&&(o=Ev.ListItem);break;case"<":-1===i&&(r=a,i=-1);break;case"|":-1!==r&&-1===i&&(i=a);break;case">":if(-1!==r){n<r&&t.push(hv(e,n,r,null));var s=e.substring(r+1,-1!==i?i:a),l=a<e.length-1&&mv.test(e[a+1])?e[a+1]:null,c=hv(e,-1!==i?i+1:r+1,a,l),u=null!=this.linkRenderer?this.linkRenderer(s,c,r):void 0;void 0!==u?t.push((0,z.jsxs)("span",{children:[u,l]},r)):t.push((0,z.jsx)(Pv,{linkData:s,children:c},r)),n=a+1,r=-1,i=-1}}return n<e.length&&t.push(hv(e,n,e.length,null)),[t,o,[]]},e}();function hv(e,t,n,r){for(var i=[],o=t,a=!1,s=-1,l=t;l<n;l++)if("*"===e[l])if(a)if(-1===s)s=l-1,a=!1;else{o<s&&i.push(e.substring(o,s));var c=e.substring(s+2,l-1);l<n-1?mv.test(e[l+1])&&(c+=e[l+1]):null!=r&&(c+=r),i.push((0,z.jsx)("b",{children:c},s)),o=l+1,s=-1,a=!1}else a=!0;else a=!1;if(o<n){var u=e.substring(o,n);null!=r&&(u+=r),i.push(u)}return i}oe.add("game-ui/common/text/renderers/markup-renderer.tsx",{get MarkupRenderer(){return gv},set MarkupRenderer(e){gv=e}});let pv={h1:"h1_YPD",h2:"h2_TYz",h3:"h3__p1",h4:"h4_Gmc",h5:"h5_QKx",h6:"h6__nd",link:"link_jpN",p:"p_CKq","list-item":"list-item_xk2",listItem:"list-item_xk2"};oe.add("game-ui/common/text/formatted-text.module.scss",{get classes(){return pv},set classes(e){Object.assign(pv,e)}});const vv=pv;function bv(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function yv(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function xv(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){yv(e,t,n[t])}))}return e}function _v(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function jv(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function Ov(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return bv(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return bv(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Ev;!function(e){e[e.None=0]="None",e[e.Heading1=1]="Heading1",e[e.Heading2=2]="Heading2",e[e.Heading3=3]="Heading3",e[e.Heading4=4]="Heading4",e[e.Heading5=5]="Heading5",e[e.Heading6=6]="Heading6",e[e.ListItem=7]="ListItem"}(Ev||(Ev={}));var Sv=(0,Y.createContext)({theme:vv,onLinkSelect:void 0}),Tv=new gv,Iv=function(e){var t=e.focusKey,n=e.text,r=void 0===n?"":n,i=e.theme,o=e.renderer,a=void 0===o?Tv:o,s=e.className,l=e.onLinkSelect,c=jv(e,["focusKey","text","theme","renderer","className","onLinkSelect"]),u=(0,Y.useMemo)((function(){return xv({},vv,i)}),[i]),d=(0,Y.useMemo)((function(){return{theme:u,onLinkSelect:l}}),[l,u]),f=bc(r),m=Ov((0,Y.useMemo)((function(){return a.render(f)}),[a,f]),2),g=m[0],h=m[1];return(0,z.jsx)(Ap,{focusKey:t,children:(0,z.jsx)(Sv.Provider,{value:d,children:(0,z.jsx)("p",_v(xv({},c),{className:_d()(wv(u,h),s),cohinline:"cohinline",children:g}))})})};function wv(e,t){switch(t){case Ev.None:return e.p;case Ev.Heading1:return e.h1;case Ev.Heading2:return e.h2;case Ev.Heading3:return e.h3;case Ev.Heading4:return e.h4;case Ev.Heading5:return e.h5;case Ev.Heading6:return e.h6;case Ev.ListItem:return e.listItem;default:return}}var Pv=function(e){var t=e.linkData,n=e.children,r=(0,Y.useContext)(Sv),i=(0,Y.useCallback)((function(){r.onLinkSelect&&r.onLinkSelect(t)}),[r,t]);return""!==t?(0,z.jsx)(Qp,{className:r.theme.link,onSelect:i,children:n}):(0,z.jsx)(z.Fragment,{children:n})};oe.add("game-ui/common/text/formatted-text.tsx",{get ParagraphStyle(){return Ev},set ParagraphStyle(e){Ev=e},get FormattedTextContext(){return Sv},set FormattedTextContext(e){Sv=e},get FormattedText(){return Iv},set FormattedText(e){Iv=e},get Link(){return Pv},set Link(e){Pv=e}});let Cv={paragraphs:"paragraphs_nbD"};oe.add("game-ui/common/text/formatted-paragraphs.module.scss",{get classes(){return Cv},set classes(e){Object.assign(Cv,e)}});const Nv=Cv;function Av(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Lv(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Mv(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Lv(e,t,n[t])}))}return e}function kv(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Rv(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function Dv(e){return function(e){if(Array.isArray(e))return Av(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return Av(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Av(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Fv=function(e){var t=e.focusKey,n=e.text,r=e.theme,i=e.renderer,o=e.className,a=e.children,s=e.onLinkSelect,l=e.maxLineLength,c=e.splitLineLength,u=Rv(e,["focusKey","text","theme","renderer","className","children","onLinkSelect","maxLineLength","splitLineLength"]),d=(0,Y.useMemo)((function(){return Mv({},Nv,r)}),[r]),f=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],n=arguments.length>2?arguments[2]:void 0,r=arguments.length>3?arguments[3]:void 0,i=vc();return(0,Y.useMemo)((function(){return Y.Children.toArray(e).flatMap((function(e){return Bv(yc(i,e,"\n"),t,!1,n,r)}))}),[e,i,n,r,t])}(Y.Children.count(a)>0?a:n,!0,l,c);return(0,z.jsx)("div",kv(Mv({},u),{className:_d()(d.paragraphs,o),children:(0,z.jsx)(Ap,{focusKey:t,children:f.map((function(e,t){return(0,z.jsx)(Iv,{text:e,theme:d,renderer:i,onLinkSelect:s},t)}))})}))};var Uv=150,Gv=function(e,t){var n=e,r=[];do{var i=n.substring(0,t).lastIndexOf(" ");-1===i?(r.push(n.substring(0,t)),n=n.substring(t)):(r.push(n.substring(0,i)),n=n.substring(i))}while(n.length>t);return n.length>0&&r.push(n),r};function Bv(e){var t,n=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],i=arguments.length>3?arguments[3]:void 0,o=arguments.length>4?arguments[4]:void 0,a=e.split(/\r\n|\r|\n/);n&&(a=a.filter((function(e,t,n){var i;return""!==e.trim()||r&&""===(null===(i=n[t+1])||void 0===i?void 0:i.trim())})));var s=[];return a.forEach((function(e){return void 0!==i&&e.length>i?(t=s).push.apply(t,Dv(Gv(e,null!=o?o:Uv))):s.push(e)})),s}function Vv(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Hv(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Vv(e,t,n[t])}))}return e}function Kv(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Wv(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}oe.add("game-ui/common/text/formatted-paragraphs.tsx",{get FormattedParagraphs(){return Fv},set FormattedParagraphs(e){Fv=e},get splitParagraphs(){return Bv},set splitParagraphs(e){Bv=e}});var zv=Y.forwardRef((function(e,t){var n=e.className,r=e.focusSound,i=e.children,o=e.onFocusChange,a=Wv(e,["className","focusSound","children","onFocusChange"]),s=bg("PassiveFocusDiv");Eg(s,o);var l=jg(s),c=Pg();return(0,Y.useEffect)((function(){l&&c&&kp(r)}),[r,l,c]),(0,z.jsx)(Sg,{controller:s,children:(0,z.jsx)(Qd,{children:(0,z.jsx)("div",Kv(Hv({},a),{ref:t,className:_d()(n,l&&c&&"focused"),children:i}))})})})),Yv=Y.forwardRef((function(e,t){var n=e.focusKey,r=void 0===n?Kh:n,i=e.debugName,o=void 0===i?"ActiveFocusDiv":i,a=e.activation,s=void 0===a?yd.Always:a,l=e.focusSound,c=e.className,u=e.children,d=e.onFocusChange,f=Wv(e,["focusKey","debugName","activation","focusSound","className","children","onFocusChange"]),m=(0,Y.useRef)(null),g=Hd(t,m),h=Hp(zh(r,o),m,s,!0);Eg(h,d);var p=jg(h),v=Pg();return(0,Y.useEffect)((function(){p&&v&&kp(l)}),[l,p,v]),(0,z.jsx)(Sg,{controller:h,children:(0,z.jsx)(Qd,{children:(0,z.jsx)("div",Kv(Hv({},f),{ref:g,className:_d()(c,p&&v&&"focused"),children:u}))})})}));oe.add("game-ui/common/focus/focus-div.tsx",{get PassiveFocusDiv(){return zv},set PassiveFocusDiv(e){zv=e},get ActiveFocusDiv(){return Yv},set ActiveFocusDiv(e){Yv=e}});const $v=function(e){return e.currentTarget.src="Media/Placeholder.svg"};oe.add("game-ui/common/image/missing-icon-handler.ts",{});let qv={"tinted-icon":"tinted-icon_iKo",tintedIcon:"tinted-icon_iKo"};oe.add("game-ui/common/image/tinted-icon.module.scss",{get classes(){return qv},set classes(e){Object.assign(qv,e)}});const Xv=qv;function Qv(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Zv(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Qv(e,t,n[t])}))}return e}function Jv(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function eb(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var tb=Y.forwardRef((function(e,t){var n=e.src,r=e.className,i=e.style,o=eb(e,["src","className","style"]);return(0,z.jsx)("div",Jv(Zv({},o),{ref:t,className:_d()(n&&Xv.tintedIcon,r),style:Jv(Zv({},i),{maskImage:n?"url(".concat(n,")"):void 0})}))}));oe.add("game-ui/common/image/tinted-icon.tsx",{get TintedIcon(){return tb},set TintedIcon(e){tb=e}});let nb={button:"button_M6C",icon:"icon_PhD"};oe.add("game-ui/common/input/button/icon-button.module.scss",{get classes(){return nb},set classes(e){Object.assign(nb,e)}});const rb=nb;function ib(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function ob(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){ib(e,t,n[t])}))}return e}function ab(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function sb(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var lb=Y.forwardRef((function(e,t){var n=e.src,r=e.tinted,i=e.theme,o=e.className,a=e.children,s=sb(e,["src","tinted","theme","className","children"]),l=(0,Y.useMemo)((function(){return ob({},rb,i)}),[i]);return(0,z.jsxs)(Qp,ab(ob({ref:t},s),{className:_d()(l.button,o),theme:l,children:[r?(0,z.jsx)(tb,{src:n,className:l.icon}):(0,z.jsx)("img",{src:n,className:l.icon,onError:$v}),a]}))}));oe.add("game-ui/common/input/button/icon-button.tsx",{get IconButton(){return lb},set IconButton(e){lb=e}});let cb={button:"button_bvQ"};oe.add("game-ui/common/input/button/themes/round-highlight-button.module.scss",{get classes(){return cb},set classes(e){Object.assign(cb,e)}});const ub=cb;var db=["Debug UI"],fb=["Move Horizontal","Move Vertical","Select","Back","Switch Tab"],mb=Y.memo((function(e){var t=e.includes,n=e.excludes,r=void 0===n?db:n,i=e.disabled,o=e.children,a=bg("InputActionBarrier"),s=jg(a),l=(0,Y.useCallback)((function(e){null!=t?e.removeWhere((function(e){return t.includes(e)})):null!=r?e.removeWhere((function(e){return!r.includes(e)})):e.clear()}),[t,r]),c=Qh(s,i?null:l);return(0,z.jsx)(Sg,{controller:a,children:(0,z.jsx)(Xh.Provider,{value:c,children:o})})}),(function(e,t){return el(e,t)&&el(e.includes,t.includes)&&el(e.excludes,t.excludes)}));function gb(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function hb(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function pb(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){hb(e,t,n[t])}))}return e}function vb(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function bb(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return gb(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return gb(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/input-events/input-action-barrier.tsx",{get navActions(){return fb},set navActions(e){fb=e},get InputActionBarrier(){return mb},set InputActionBarrier(e){mb=e}});var yb=Y.forwardRef((function(e,t){var n=e.focusKey,r=e.debugName,i=void 0===r?"TextInput":r,o=e.type,a=void 0===o?"text":o,s=e.value,l=void 0===s?"":s,c=e.selectAllOnFocus,u=void 0===c||c,d=e.placeholder,f=void 0===d?"":d,m=e.vkTitle,g=void 0===m?"":m,h=e.vkDescription,p=void 0===h?"":h,v=e.disabled,b=e.className,y=e.multiline,x=e.onFocus,_=e.onBlur,j=e.onKeyDown,O=e.onChange,E=e.onMouseUp,S=vb(e,["focusKey","debugName","type","value","selectAllOnFocus","placeholder","vkTitle","vkDescription","disabled","className","multiline","onFocus","onBlur","onKeyDown","onChange","onMouseUp"]),T=(0,Y.useRef)(null),I=Hd(t,T),w=Hp(zh(null!=n?n:v?Hh:Kh,i),T),P=jg(w),C=Pg(),N=xl(og),A=bb((0,Y.useState)(!1),2),L=A[0],M=A[1],k=(0,Y.useMemo)((function(){return L?{Back:function(){null!=T.current&&document.activeElement===T.current&&T.current.blur()}}:{Select:function(){if(null!=T.current){var e=T.current.getBoundingClientRect();ig(e.x,e.y,e.width,e.height),Wp(T,"--selectAnimation","--selectDuration"),T.current.focus();var t=T.current.value.length;T.current.setSelectionRange(u?0:t,t)}}}}),[L,u]),R=(0,Y.useCallback)((function(e){D.current=!1,(!y&&13===e.keyCode||27===e.keyCode)&&e.currentTarget.blur(),e.stopPropagation(),j&&j(e)}),[y,j]),D=(0,Y.useRef)(!1),F=(0,Y.useCallback)((function(e){D.current=!1,O&&O(e)}),[O]),U=(0,Y.useCallback)((function(e){M(!0),D.current=!0,x&&x(e),kp(Lp.focusInputField)}),[x]),G=(0,Y.useCallback)((function(){return kp(Lp.hoverItem)}),[]),B=(0,Y.useCallback)((function(e){D.current&&(null!=T.current&&T.current.selectionStart===T.current.selectionEnd&&T.current.select(),D.current=!1),E&&E(e)}),[E]),V=(0,Y.useCallback)((function(e){M(!1),_&&_(e)}),[_]);(0,Y.useEffect)((function(){C&&!P&&T.current&&T.current.blur()}),[P,C]);var H=bc(f),K=!L&&!l&&H,W=bc(g),$=bc(p),q=void 0!==y?"textarea":"input",X=(0,z.jsx)(rp,{actions:k,children:(0,z.jsx)(Sg,{controller:w,children:(0,z.jsx)(q,pb({ref:I,type:"password"===a&&K?"text":a,value:K?H:l,disabled:v,className:_d()(b,P&&C&&"focused",K&&"placeholder"),"vk-title":W,"vk-description":$,"vk-type":a,rows:"number"==typeof y?y:5,onFocus:U,onBlur:V,onKeyDown:R,onChange:F,onMouseUp:B,onMouseEnter:G},S))})});return N&&C?(0,z.jsx)(mb,{disabled:!L||!C,children:X}):X}));oe.add("game-ui/common/input/text/text-input.tsx",{get TextInput(){return yb},set TextInput(e){yb=e}});var xb="paradox",_b=fl(xb,"requestActive"),jb=fl(xb,"loggedIn"),Ob=fl(xb,"accountLinkState"),Eb=fl(xb,"accountLinkProvider"),Sb=fl(xb,"userName"),Tb=fl(xb,"hasInternetConnection"),Ib=fl(xb,"pdxSDKEnabled");function wb(){bl(xb,"linkAccount")}function Pb(){bl(xb,"unlinkAccount")}function Cb(){bl(xb,"logout")}var Nb,Ab=fl(xb,"activeDialogs");function Lb(){bl(xb,"closeActiveDialog")}function Mb(){bl(xb,"showLoginForm")}function kb(e){bl(xb,"submitPasswordReset",e)}function Rb(e){bl(xb,"submitLoginForm",ud(e,"Game.UI.Menu.ParadoxBindings+LoginFormData"))}!function(e){e.Login="Game.UI.Menu.ParadoxBindings+LoginDialog",e.Registration="Game.UI.Menu.ParadoxBindings+RegistrationDialog",e.AccountLink="Game.UI.Menu.ParadoxBindings+AccountLinkDialog",e.AccountLinkOverwrite="Game.UI.Menu.ParadoxBindings+AccountLinkOverwriteDialog",e.LegalDocument="Game.UI.Menu.ParadoxBindings+LegalDocumentDialog",e.Confirmation="Game.UI.Menu.ParadoxBindings+ConfirmationDialog",e.Error="Game.UI.Menu.ParadoxBindings+ErrorDialog"}(Nb||(Nb={}));var Db,Fb=fl(xb,"countryCodes");function Ub(){bl(xb,"showRegistrationForm")}function Gb(e){bl(xb,"showLink",e)}function Bb(e){bl(xb,"submitRegistrationForm",ud(e,"Game.UI.Menu.ParadoxBindings+RegistrationFormData"))}function Vb(){bl(xb,"confirmAccountLink")}function Hb(){bl(xb,"confirmAccountLinkOverwrite")}function Kb(){bl(xb,"markLegalDocumentAsViewed")}function Wb(){bl(xb,"showTermsOfUse")}function zb(){bl(xb,"showPrivacyPolicy")}!function(e){e[e.hidden=0]="hidden",e[e.unlinked=1]="unlinked",e[e.linked=2]="linked"}(Db||(Db={})),oe.add("game-ui/menu/data-binding/paradox-bindings.ts",{get requestActive(){return requestActive},set requestActive(e){requestActive=e},get loggedIn(){return loggedIn},set loggedIn(e){loggedIn=e},get accountLinkState(){return accountLinkState},set accountLinkState(e){accountLinkState=e},get accountLinkProvider(){return accountLinkProvider},set accountLinkProvider(e){accountLinkProvider=e},get userName(){return userName},set userName(e){userName=e},get hasInternetConnection(){return hasInternetConnection},set hasInternetConnection(e){hasInternetConnection=e},get pdxSDKEnabled(){return pdxSDKEnabled},set pdxSDKEnabled(e){pdxSDKEnabled=e},get linkAccount(){return wb},set linkAccount(e){wb=e},get unlinkAccount(){return Pb},set unlinkAccount(e){Pb=e},get logout(){return Cb},set logout(e){Cb=e},get activeDialogs(){return activeDialogs},set activeDialogs(e){activeDialogs=e},get closeActiveDialog(){return Lb},set closeActiveDialog(e){Lb=e},get ParadoxDialogType(){return Nb},set ParadoxDialogType(e){Nb=e},get showLoginForm(){return Mb},set showLoginForm(e){Mb=e},get submitPasswordReset(){return kb},set submitPasswordReset(e){kb=e},get submitLoginForm(){return Rb},set submitLoginForm(e){Rb=e},get countryCodes(){return countryCodes},set countryCodes(e){countryCodes=e},get showRegistrationForm(){return Ub},set showRegistrationForm(e){Ub=e},get showLink(){return Gb},set showLink(e){Gb=e},get submitRegistrationForm(){return Bb},set submitRegistrationForm(e){Bb=e},get confirmAccountLink(){return Vb},set confirmAccountLink(e){Vb=e},get confirmAccountLinkOverwrite(){return Hb},set confirmAccountLinkOverwrite(e){Hb=e},get markLegalDocumentAsViewed(){return Kb},set markLegalDocumentAsViewed(e){Kb=e},get ShowTermsOfUse(){return Wb},set ShowTermsOfUse(e){Wb=e},get ShowPrivacyPolicy(){return zb},set ShowPrivacyPolicy(e){zb=e},get AccountLinkState(){return Db},set AccountLinkState(e){Db=e}});let Yb={"paradox-dialog":"paradox-dialog_wt7",paradoxDialog:"paradox-dialog_wt7",wide:"wide_h40",header:"header_G7_","close-button":"close-button_FeS",closeButton:"close-button_FeS",content:"content_hZD","form-container":"form-container_Lw7",formContainer:"form-container_Lw7","icon-row":"icon-row_rFk",iconRow:"icon-row_rFk",icon:"icon_Bz_",title:"title_dnP","button-row":"button-row_tSi",buttonRow:"button-row_tSi","flex-row":"flex-row_a_W",flexRow:"flex-row_a_W","form-row":"form-row_LB0",formRow:"form-row_LB0","form-row-label":"form-row-label_xO0",formRowLabel:"form-row-label_xO0","light-field":"light-field_CGM",lightField:"light-field_CGM","dark-field":"dark-field_bE7",darkField:"dark-field_bE7","form-field":"form-field_D62",formField:"form-field_D62",invalid:"invalid_LPr",placeholder:"placeholder_U9A","forgot-password-link":"forgot-password-link_Wch",forgotPasswordLink:"forgot-password-link_Wch","day-field":"day-field_fHK",dayField:"day-field_fHK","month-field":"month-field_Um1",monthField:"month-field_Um1","year-field":"year-field_l7n",yearField:"year-field_l7n","labeled-toggle":"labeled-toggle_Hn2",labeledToggle:"labeled-toggle_Hn2",toggle:"toggle_Zwc","primary-button":"primary-button_klN",primaryButton:"primary-button_klN",focused:"focused_vZY",hint:"hint_PBH",label:"label_Ujn",terms:"terms_p0E",divider:"divider_ms0","document-scrollable":"document-scrollable_EHj",documentScrollable:"document-scrollable_EHj","document-text":"document-text_T4G",documentText:"document-text_T4G"};oe.add("game-ui/menu/components/paradox/dialogs/paradox-dialog.module.scss",{get classes(){return Yb},set classes(e){Object.assign(Yb,e)}});const $b=Yb;var qb=function(e){var t=e.wide,n=e.onClose,r=e.children,i=Pg();return(0,z.jsx)(ap,{onAction:n,children:(0,z.jsxs)("div",{className:_d()($b.paradoxDialog,t&&$b.wide),children:[(0,z.jsx)("div",{className:$b.header,children:!i&&n&&(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:"Media/Glyphs/Close.svg",theme:ub,className:$b.closeButton,onSelect:n})}),(0,z.jsx)("div",{className:$b.content,children:r})]})})},Xb=function(e){var t=e.icon,n=e.titleId,r=e.messageId,i=e.messageArgs,o=e.children;return(0,z.jsx)(qb,{onClose:Lb,children:(0,z.jsxs)(Ap,{children:[t&&(0,z.jsx)("div",{className:$b.iconRow,children:(0,z.jsx)("img",{src:t,className:$b.icon})}),n&&(0,z.jsx)("div",{className:$b.title,children:(0,z.jsx)(kc,{id:n})}),r&&(0,z.jsx)("p",{children:(0,z.jsx)(kc,{id:r,args:i})}),o]})})},Qb=function(e){var t=e.type,n=e.value,r=e.placeholder,i=e.invalid,o=e.className,a=e.vkTitle,s=e.onChange,l=(0,Y.useCallback)((function(e){return s(e.target.value)}),[s]);return(0,z.jsx)(yb,{type:t,value:n,placeholder:r,vkTitle:a,className:_d()($b.formField,i&&$b.invalid,o),onChange:l})},Zb=function(e){var t=e.value,n=e.label,r=e.invalid,i=e.disabled,o=e.onChange;return(0,z.jsxs)(Yv,{className:$b.labeledToggle,children:[(0,z.jsx)(fv,{checked:t,disabled:i,className:_d()($b.toggle,r&&$b.invalid),onChange:o}),(0,z.jsx)("div",{className:$b.label,children:n})]})};function Jb(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];(0,Y.useEffect)((function(){if(!e){var t=Zm.subscribe((function(){}));return function(){return null==t?void 0:t.dispose()}}}),[e])}function ey(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];(0,Y.useEffect)((function(){if(!e){var t=Jm.subscribe((function(){}));return function(){return null==t?void 0:t.dispose()}}}),[e])}oe.add("game-ui/menu/components/paradox/dialogs/paradox-dialog.tsx",{get ParadoxDialog(){return qb},set ParadoxDialog(e){qb=e},get MessageDialog(){return Xb},set MessageDialog(e){Xb=e},get FormField(){return Qb},set FormField(e){Qb=e},get LabeledToggle(){return Zb},set LabeledToggle(e){Zb=e}}),oe.add("game-ui/common/hooks/use-camera-action-barrier.tsx",{get useCameraActionBarrier(){return Jb},set useCameraActionBarrier(e){Jb=e}}),oe.add("game-ui/common/hooks/use-tool-action-barrier.tsx",{get useToolActionBarrier(){return ey},set useToolActionBarrier(e){ey=e}});var ty=ud({index:0,version:0},"Unity.Entities.Entity");oe.add("game-ui/common/data-binding/common-types.ts",{get nullEntity(){return ty},set nullEntity(e){ty=e}});var ny=fl("infoviews","infoviews"),ry=fl("infoviews","activeInfoview");function iy(e){bl("infoviews","setActiveInfoview",e)}function oy(){iy(ty)}function ay(e,t,n){bl("infoviews","setInfomodeActive",e,t,n)}var sy=fl("electricityInfo","electricityConsumption"),ly=fl("electricityInfo","electricityProduction"),cy=fl("electricityInfo","electricityTransmitted"),uy=fl("electricityInfo","electricityExport"),dy=fl("electricityInfo","electricityImport"),fy=fl("electricityInfo","electricityAvailability"),my=fl("electricityInfo","electricityTransmission"),gy=fl("electricityInfo","electricityTrade"),hy=fl("electricityInfo","batteryCharge"),py=fl("waterInfo","waterCapacity"),vy=fl("waterInfo","waterConsumption"),by=fl("waterInfo","sewageCapacity"),yy=fl("waterInfo","sewageConsumption"),xy=fl("waterInfo","waterExport"),_y=fl("waterInfo","waterImport"),jy=fl("waterInfo","sewageExport"),Oy=fl("waterInfo","sewageAvailability"),Ey=fl("waterInfo","waterAvailability"),Sy=fl("waterInfo","waterTrade"),Ty=fl("educationInfo","elementaryEligible"),Iy=fl("educationInfo","highSchoolEligible"),wy=fl("educationInfo","collegeEligible"),Py=fl("educationInfo","universityEligible"),Cy=fl("educationInfo","elementaryCapacity"),Ny=fl("educationInfo","highSchoolCapacity"),Ay=fl("educationInfo","collegeCapacity"),Ly=fl("educationInfo","universityCapacity"),My=fl("educationInfo","educationData"),ky=fl("educationInfo","elementaryStudentCount"),Ry=fl("educationInfo","highSchoolStudentCount"),Dy=fl("educationInfo","collegeStudentCount"),Fy=fl("educationInfo","universityStudentCount"),Uy=fl("educationInfo","elementaryAvailability"),Gy=fl("educationInfo","highSchoolAvailability"),By=fl("educationInfo","collegeAvailability"),Vy=fl("educationInfo","universityAvailability"),Hy=fl("transportInfo","summaries"),Ky=fl("healthcareInfo","averageHealth"),Wy=fl("healthcareInfo","cemeteryUse"),zy=fl("healthcareInfo","cemeteryCapacity"),Yy=fl("healthcareInfo","deathRate"),$y=fl("healthcareInfo","processingRate"),qy=fl("healthcareInfo","sickCount"),Xy=fl("healthcareInfo","patientCount"),Qy=fl("healthcareInfo","patientCapacity"),Zy=fl("healthcareInfo","healthcareAvailability"),Jy=fl("healthcareInfo","deathcareAvailability"),ex=fl("healthcareInfo","cemeteryAvailability"),tx=fl("garbageInfo","processingRate"),nx=fl("garbageInfo","capacity"),rx=fl("garbageInfo","processingAvailability"),ix=fl("garbageInfo","landfillAvailability"),ox=fl("garbageInfo","productionRate"),ax=fl("garbageInfo","storedGarbage"),sx=fl("roadsInfo","parkingCapacity"),lx=fl("roadsInfo","parkingIncome"),cx=fl("roadsInfo","parkedCars"),ux=fl("roadsInfo","parkingAvailability"),dx=fl("trafficInfo","trafficFlow"),fx=fl("pollutionInfo","averageGroundPollution"),mx=fl("pollutionInfo","averageAirPollution"),gx=fl("pollutionInfo","averageWaterPollution"),hx=fl("pollutionInfo","averageNoisePollution"),px=fl("fireAndRescueInfo","averageFireHazard"),vx=fl("policeInfo","averageCrimeProbability"),bx=fl("policeInfo","jailAvailability"),yx=fl("policeInfo","prisonAvailability"),xx=fl("policeInfo","crimeProducers"),_x=fl("policeInfo","crimeProbability"),jx=fl("policeInfo","jailCapacity"),Ox=fl("policeInfo","arrestedCriminals"),Ex=fl("policeInfo","inJail"),Sx=fl("policeInfo","prisonCapacity"),Tx=fl("policeInfo","prisoners"),Ix=fl("policeInfo","inPrison"),wx=fl("policeInfo","criminals"),Px=fl("policeInfo","crimePerMonth"),Cx=fl("policeInfo","escapedRate"),Nx=fl("landValueInfo","averageLandValue"),Ax=fl("levelInfo","residential"),Lx=fl("levelInfo","commercial"),Mx=fl("levelInfo","industrial"),kx=fl("levelInfo","office"),Rx=fl("disasterInfo","shelteredCount"),Dx=fl("disasterInfo","shelterCapacity"),Fx=fl("disasterInfo","shelterAvailability"),Ux=fl("tourismInfo","attractiveness"),Gx=fl("tourismInfo","averageHotelPrice"),Bx=fl("tourismInfo","tourismRate"),Vx=fl("tourismInfo","weatherEffect"),Hx=fl("postInfo","mailProductionRate"),Kx=fl("postInfo","collectedMail"),Wx=fl("postInfo","deliveredMail"),zx=fl("postInfo","postServiceAvailability"),Yx=fl("populationInfo","population"),$x=fl("populationInfo","employed"),qx=fl("populationInfo","jobs"),Xx=fl("populationInfo","unemployment"),Qx=fl("populationInfo","birthRate"),Zx=fl("populationInfo","movedIn"),Jx=fl("populationInfo","movedAway"),e_=fl("populationInfo","ageData"),t_=fl("companyInfoview","commercialProfitability"),n_=fl("companyInfoview","industrialProfitability"),r_=fl("companyInfoview","officeProfitability"),i_=fl("outsideInfo","topImportNames"),o_=fl("outsideInfo","topImportColors"),a_=fl("outsideInfo","topImportData"),s_=fl("outsideInfo","topExportNames"),l_=fl("outsideInfo","topExportColors"),c_=fl("outsideInfo","topExportData"),u_=fl("naturalResourceInfo","availableOil"),d_=fl("naturalResourceInfo","availableOre"),f_=fl("naturalResourceInfo","availableForest"),m_=fl("naturalResourceInfo","availableFertility"),g_=fl("naturalResourceInfo","oilExtractionRate"),h_=fl("naturalResourceInfo","oreExtractionRate"),p_=fl("naturalResourceInfo","forestExtractionRate"),v_=fl("naturalResourceInfo","fertilityExtractionRate"),b_=fl("naturalResourceInfo","forestRenewalRate"),y_=fl("naturalResourceInfo","fertilityRenewalRate"),x_=fl("workplaces","workplacesData"),__=fl("workplaces","employeesData"),j_=fl("workplaces","workplaces"),O_=fl("workplaces","employees");function E_(e){var t=xl(ry),n=xl(ny),r=(0,Y.useMemo)((function(){return n.find((function(t){return t.id===e}))}),[e,n]),i=(0,Y.useMemo)((function(){return!!r&&Qs(r.entity,null==t?void 0:t.entity)}),[null==t?void 0:t.entity,r]),o=(0,Y.useMemo)((function(){return!r||r.locked}),[r]),a=(0,Y.useCallback)((function(){r&&iy(i?ty:r.entity)}),[r,i]);if(!o&&r)return a}oe.add("game-ui/game/data-binding/infoview-bindings.ts",{get infoviews(){return infoviews},set infoviews(e){infoviews=e},get activeInfoview(){return activeInfoview},set activeInfoview(e){activeInfoview=e},get setActiveInfoview(){return iy},set setActiveInfoview(e){iy=e},get clearActiveInfoview(){return oy},set clearActiveInfoview(e){oy=e},get setInfomodeActive(){return ay},set setInfomodeActive(e){ay=e},get electricityConsumption(){return electricityConsumption},set electricityConsumption(e){electricityConsumption=e},get electricityProduction(){return electricityProduction},set electricityProduction(e){electricityProduction=e},get electricityTransmitted(){return electricityTransmitted},set electricityTransmitted(e){electricityTransmitted=e},get electricityExport(){return electricityExport},set electricityExport(e){electricityExport=e},get electricityImport(){return electricityImport},set electricityImport(e){electricityImport=e},get electricityAvailability(){return electricityAvailability},set electricityAvailability(e){electricityAvailability=e},get electricityTransmission(){return electricityTransmission},set electricityTransmission(e){electricityTransmission=e},get electricityTrade(){return electricityTrade},set electricityTrade(e){electricityTrade=e},get batteryCharge(){return batteryCharge},set batteryCharge(e){batteryCharge=e},get waterCapacity(){return waterCapacity},set waterCapacity(e){waterCapacity=e},get waterConsumption(){return waterConsumption},set waterConsumption(e){waterConsumption=e},get sewageCapacity(){return sewageCapacity},set sewageCapacity(e){sewageCapacity=e},get sewageConsumption(){return sewageConsumption},set sewageConsumption(e){sewageConsumption=e},get waterExport(){return waterExport},set waterExport(e){waterExport=e},get waterImport(){return waterImport},set waterImport(e){waterImport=e},get sewageExport(){return sewageExport},set sewageExport(e){sewageExport=e},get sewageAvailability(){return sewageAvailability},set sewageAvailability(e){sewageAvailability=e},get waterAvailability(){return waterAvailability},set waterAvailability(e){waterAvailability=e},get waterTrade(){return waterTrade},set waterTrade(e){waterTrade=e},get elementaryEligible(){return elementaryEligible},set elementaryEligible(e){elementaryEligible=e},get highSchoolEligible(){return highSchoolEligible},set highSchoolEligible(e){highSchoolEligible=e},get collegeEligible(){return collegeEligible},set collegeEligible(e){collegeEligible=e},get universityEligible(){return universityEligible},set universityEligible(e){universityEligible=e},get elementaryCapacity(){return elementaryCapacity},set elementaryCapacity(e){elementaryCapacity=e},get highSchoolCapacity(){return highSchoolCapacity},set highSchoolCapacity(e){highSchoolCapacity=e},get collegeCapacity(){return collegeCapacity},set collegeCapacity(e){collegeCapacity=e},get universityCapacity(){return universityCapacity},set universityCapacity(e){universityCapacity=e},get educationData(){return educationData},set educationData(e){educationData=e},get elementaryStudents(){return elementaryStudents},set elementaryStudents(e){elementaryStudents=e},get highSchoolStudents(){return highSchoolStudents},set highSchoolStudents(e){highSchoolStudents=e},get collegeStudents(){return collegeStudents},set collegeStudents(e){collegeStudents=e},get universityStudents(){return universityStudents},set universityStudents(e){universityStudents=e},get elementaryAvailability(){return elementaryAvailability},set elementaryAvailability(e){elementaryAvailability=e},get highSchoolAvailability(){return highSchoolAvailability},set highSchoolAvailability(e){highSchoolAvailability=e},get collegeAvailability(){return collegeAvailability},set collegeAvailability(e){collegeAvailability=e},get universityAvailability(){return universityAvailability},set universityAvailability(e){universityAvailability=e},get transportSummaries(){return transportSummaries},set transportSummaries(e){transportSummaries=e},get averageHealth(){return averageHealth},set averageHealth(e){averageHealth=e},get cemeteryUse(){return cemeteryUse},set cemeteryUse(e){cemeteryUse=e},get cemeteryCapacity(){return cemeteryCapacity},set cemeteryCapacity(e){cemeteryCapacity=e},get deathRate(){return deathRate},set deathRate(e){deathRate=e},get processingRate(){return processingRate},set processingRate(e){processingRate=e},get sickCount(){return sickCount},set sickCount(e){sickCount=e},get patientCount(){return patientCount},set patientCount(e){patientCount=e},get patientCapacity(){return patientCapacity},set patientCapacity(e){patientCapacity=e},get healthcareAvailability(){return healthcareAvailability},set healthcareAvailability(e){healthcareAvailability=e},get deathcareAvailability(){return deathcareAvailability},set deathcareAvailability(e){deathcareAvailability=e},get cemeteryAvailability(){return cemeteryAvailability},set cemeteryAvailability(e){cemeteryAvailability=e},get garbageProcessingRate(){return garbageProcessingRate},set garbageProcessingRate(e){garbageProcessingRate=e},get landfillCapacity(){return landfillCapacity},set landfillCapacity(e){landfillCapacity=e},get processingAvailability(){return processingAvailability},set processingAvailability(e){processingAvailability=e},get landfillAvailability(){return landfillAvailability},set landfillAvailability(e){landfillAvailability=e},get garbageProductionRate(){return garbageProductionRate},set garbageProductionRate(e){garbageProductionRate=e},get storedGarbage(){return storedGarbage},set storedGarbage(e){storedGarbage=e},get parkingCapacity(){return parkingCapacity},set parkingCapacity(e){parkingCapacity=e},get parkingIncome(){return parkingIncome},set parkingIncome(e){parkingIncome=e},get parkedCars(){return parkedCars},set parkedCars(e){parkedCars=e},get parkingAvailability(){return parkingAvailability},set parkingAvailability(e){parkingAvailability=e},get trafficFlow(){return trafficFlow},set trafficFlow(e){trafficFlow=e},get averageGroundPollution(){return averageGroundPollution},set averageGroundPollution(e){averageGroundPollution=e},get averageAirPollution(){return averageAirPollution},set averageAirPollution(e){averageAirPollution=e},get averageWaterPollution(){return averageWaterPollution},set averageWaterPollution(e){averageWaterPollution=e},get averageNoisePollution(){return averageNoisePollution},set averageNoisePollution(e){averageNoisePollution=e},get averageFireHazard(){return averageFireHazard},set averageFireHazard(e){averageFireHazard=e},get averageCrimeProbability(){return averageCrimeProbability},set averageCrimeProbability(e){averageCrimeProbability=e},get jailAvailability(){return jailAvailability},set jailAvailability(e){jailAvailability=e},get prisonAvailability(){return prisonAvailability},set prisonAvailability(e){prisonAvailability=e},get crimeProducers(){return crimeProducers},set crimeProducers(e){crimeProducers=e},get crimeProbability(){return crimeProbability},set crimeProbability(e){crimeProbability=e},get jailCapacity(){return jailCapacity},set jailCapacity(e){jailCapacity=e},get arrestedCriminals(){return arrestedCriminals},set arrestedCriminals(e){arrestedCriminals=e},get inJail(){return inJail},set inJail(e){inJail=e},get prisonCapacity(){return prisonCapacity},set prisonCapacity(e){prisonCapacity=e},get prisoners(){return prisoners},set prisoners(e){prisoners=e},get inPrison(){return inPrison},set inPrison(e){inPrison=e},get criminals(){return criminals},set criminals(e){criminals=e},get crimePerMonth(){return crimePerMonth},set crimePerMonth(e){crimePerMonth=e},get escapedRate(){return escapedRate},set escapedRate(e){escapedRate=e},get averageLandValue(){return averageLandValue},set averageLandValue(e){averageLandValue=e},get residentialLevels(){return residentialLevels},set residentialLevels(e){residentialLevels=e},get commercialLevels(){return commercialLevels},set commercialLevels(e){commercialLevels=e},get industrialLevels(){return industrialLevels},set industrialLevels(e){industrialLevels=e},get officeLevels(){return officeLevels},set officeLevels(e){officeLevels=e},get shelteredCount(){return shelteredCount},set shelteredCount(e){shelteredCount=e},get shelterCapacity(){return shelterCapacity},set shelterCapacity(e){shelterCapacity=e},get shelterAvailability(){return shelterAvailability},set shelterAvailability(e){shelterAvailability=e},get attractiveness(){return attractiveness},set attractiveness(e){attractiveness=e},get averageHotelPrice(){return averageHotelPrice},set averageHotelPrice(e){averageHotelPrice=e},get tourismRate(){return tourismRate},set tourismRate(e){tourismRate=e},get weatherEffect(){return weatherEffect},set weatherEffect(e){weatherEffect=e},get mailProductionRate(){return mailProductionRate},set mailProductionRate(e){mailProductionRate=e},get collectedMail(){return collectedMail},set collectedMail(e){collectedMail=e},get deliveredMail(){return deliveredMail},set deliveredMail(e){deliveredMail=e},get postServiceAvailability(){return postServiceAvailability},set postServiceAvailability(e){postServiceAvailability=e},get population(){return population},set population(e){population=e},get employed(){return employed},set employed(e){employed=e},get jobs(){return jobs},set jobs(e){jobs=e},get unemployment(){return unemployment},set unemployment(e){unemployment=e},get birthRate(){return birthRate},set birthRate(e){birthRate=e},get movedIn(){return movedIn},set movedIn(e){movedIn=e},get movedAway(){return movedAway},set movedAway(e){movedAway=e},get ageData(){return ageData},set ageData(e){ageData=e},get commercialProfitability(){return commercialProfitability},set commercialProfitability(e){commercialProfitability=e},get industrialProfitability(){return industrialProfitability},set industrialProfitability(e){industrialProfitability=e},get officeProfitability(){return officeProfitability},set officeProfitability(e){officeProfitability=e},get topImportNames(){return topImportNames},set topImportNames(e){topImportNames=e},get topImportColors(){return topImportColors},set topImportColors(e){topImportColors=e},get topImportData(){return topImportData},set topImportData(e){topImportData=e},get topExportNames(){return topExportNames},set topExportNames(e){topExportNames=e},get topExportColors(){return topExportColors},set topExportColors(e){topExportColors=e},get topExportData(){return topExportData},set topExportData(e){topExportData=e},get availableOil(){return availableOil},set availableOil(e){availableOil=e},get availableOre(){return availableOre},set availableOre(e){availableOre=e},get availableForest(){return availableForest},set availableForest(e){availableForest=e},get availableFertility(){return availableFertility},set availableFertility(e){availableFertility=e},get oilExtractionRate(){return oilExtractionRate},set oilExtractionRate(e){oilExtractionRate=e},get oreExtractionRate(){return oreExtractionRate},set oreExtractionRate(e){oreExtractionRate=e},get forestExtractionRate(){return forestExtractionRate},set forestExtractionRate(e){forestExtractionRate=e},get fertilityExtractionRate(){return fertilityExtractionRate},set fertilityExtractionRate(e){fertilityExtractionRate=e},get forestRenewalRate(){return forestRenewalRate},set forestRenewalRate(e){forestRenewalRate=e},get fertilityRenewalRate(){return fertilityRenewalRate},set fertilityRenewalRate(e){fertilityRenewalRate=e},get workplacesData(){return workplacesData},set workplacesData(e){workplacesData=e},get employeesData(){return employeesData},set employeesData(e){employeesData=e},get worksplaces(){return worksplaces},set worksplaces(e){worksplaces=e},get workers(){return workers},set workers(e){workers=e},get useInfoviewToggle(){return E_},set useInfoviewToggle(e){E_=e}});var S_,T_="game";!function(e){e[e.main=0]="main",e[e.freeCamera=1]="freeCamera",e[e.pauseMenu=10]="pauseMenu",e[e.saveGame=11]="saveGame",e[e.newGame=12]="newGame",e[e.loadGame=13]="loadGame",e[e.options=14]="options"}(S_||(S_={}));var I_,w_=fl(T_,"activeScreen"),P_=vl(T_,"setActiveScreen"),C_=fl(T_,"canUseSaveSystem");function N_(){P_(S_.main)}function A_(){P_(S_.pauseMenu)}function L_(){P_(S_.freeCamera)}!function(e){e[e.Undefined=0]="Undefined",e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=3]="Right"}(I_||(I_={}));var M_,k_,R_=fl(T_,"activePanel"),D_=fl(T_,"blockingPanelActive"),F_=fl(T_,"activePanelPosition"),U_=vl(T_,"togglePanel"),G_=vl(T_,"showPanel"),B_=vl(T_,"closePanel"),V_=pl(T_,"closeActivePanel");function H_(){cd(R_.value,M_.InfoviewMenu)?(oy(),B_(M_.InfoviewMenu)):G_(M_.InfoviewMenu)}!function(e){e.InfoviewMenu="Game.UI.InGame.InfoviewMenu",e.Progression="Game.UI.InGame.ProgressionPanel",e.Economy="Game.UI.InGame.EconomyPanel",e.CityInfo="Game.UI.InGame.CityInfoPanel",e.Statistics="Game.UI.InGame.StatisticsPanel",e.TransportationOverview="Game.UI.InGame.TransportationOverviewPanel",e.Chirper="Game.UI.InGame.ChirperPanel",e.LifePath="Game.UI.InGame.LifePathPanel",e.Journal="Game.UI.InGame.JournalPanel",e.Radio="Game.UI.InGame.RadioPanel",e.PhotoMode="Game.UI.InGame.PhotoModePanel",e.CinematicCamera="Game.UI.InGame.CinematicCameraPanel",e.Notifications="Game.UI.InGame.NotificationsPanel"}(M_||(M_={})),function(e){e[e.Development=0]="Development",e[e.Milestones=1]="Milestones",e[e.Achievements=2]="Achievements"}(k_||(k_={}));var K_,W_=vl(T_,"showProgressionPanel");!function(e){e[e.Budget=0]="Budget",e[e.Loan=1]="Loan",e[e.Taxation=2]="Taxation",e[e.Services=3]="Services",e[e.Production=4]="Production"}(K_||(K_={}));var z_,Y_=vl(T_,"showEconomyPanel");!function(e){e[e.Demand=0]="Demand",e[e.Policies=1]="Policies"}(z_||(z_={}));var $_,q_=vl(T_,"showCityInfoPanel"),X_=vl(T_,"showTransportationOverviewPanel");function Q_(){U_(M_.LifePath)}function Z_(){G_(M_.LifePath)}!function(e){e[e.PublicTransport=0]="PublicTransport",e[e.Cargo=1]="Cargo"}($_||($_={}));var J_=vl(T_,"showLifePathDetail");function ej(){U_(M_.Radio)}function tj(){U_(M_.TransportationOverview)}oe.add("game-ui/game/data-binding/game-bindings.ts",{get GameScreen(){return S_},set GameScreen(e){S_=e},get activeGameScreen(){return activeGameScreen},set activeGameScreen(e){activeGameScreen=e},get setActiveGameScreen(){return P_},set setActiveGameScreen(e){P_=e},get canUseSaveSystem(){return canUseSaveSystem},set canUseSaveSystem(e){canUseSaveSystem=e},get showMainScreen(){return N_},set showMainScreen(e){N_=e},get showPauseScreen(){return A_},set showPauseScreen(e){A_=e},get showFreeCameraScreen(){return L_},set showFreeCameraScreen(e){L_=e},get LayoutPosition(){return I_},set LayoutPosition(e){I_=e},get activeGamePanel(){return activeGamePanel},set activeGamePanel(e){activeGamePanel=e},get blockingPanelActive(){return blockingPanelActive},set blockingPanelActive(e){blockingPanelActive=e},get activePanelPosition(){return activePanelPosition},set activePanelPosition(e){activePanelPosition=e},get toggleGamePanel(){return U_},set toggleGamePanel(e){U_=e},get showGamePanel(){return G_},set showGamePanel(e){G_=e},get closeGamePanel(){return B_},set closeGamePanel(e){B_=e},get closeActiveGamePanel(){return V_},set closeActiveGamePanel(e){V_=e},get GamePanelType(){return M_},set GamePanelType(e){M_=e},get toggleInfoviewMenu(){return H_},set toggleInfoviewMenu(e){H_=e},get ProgressionPanelTab(){return k_},set ProgressionPanelTab(e){k_=e},get showProgressionPanel(){return W_},set showProgressionPanel(e){W_=e},get EconomyPanelTab(){return K_},set EconomyPanelTab(e){K_=e},get showEconomyPanel(){return Y_},set showEconomyPanel(e){Y_=e},get CityInfoPanelTab(){return z_},set CityInfoPanelTab(e){z_=e},get showCityInfoPanel(){return q_},set showCityInfoPanel(e){q_=e},get showTransportationOverviewPanel(){return X_},set showTransportationOverviewPanel(e){X_=e},get TransportationOverviewPanelTab(){return $_},set TransportationOverviewPanelTab(e){$_=e},get toggleLifePathPanel(){return Q_},set toggleLifePathPanel(e){Q_=e},get showLifePathList(){return Z_},set showLifePathList(e){Z_=e},get showLifePathDetail(){return J_},set showLifePathDetail(e){J_=e},get toggleRadioPanel(){return ej},set toggleRadioPanel(e){ej=e},get toggleTransportationOverviewPanel(){return tj},set toggleTransportationOverviewPanel(e){tj=e}});let nj={"panel-backdrop":"panel-backdrop_HbC",panelBackdrop:"panel-backdrop_HbC"};oe.add("game-ui/common/panel/panel-backdrop.module.scss",{get classes(){return nj},set classes(e){Object.assign(nj,e)}});const rj=nj;var ij=function(e){var t=e.className,n=e.children,r=e.onMouseDown,i=xl(w_);ey(),Jb(i===S_.freeCamera);var o=(0,Y.useCallback)((function(e){e.target===e.currentTarget&&r&&r()}),[r]);return(0,z.jsx)(oj.Provider,{value:!0,children:(0,z.jsx)("div",{className:_d()(rj.panelBackdrop,t),onMouseDown:o,children:n})})},oj=Y.createContext(!1),aj=function(){var e=(0,Y.useContext)(oj);return(0,Y.useMemo)((function(){if(e)return{zIndex:1e4}}),[e])};function sj(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function lj(e){return lj=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)},lj(e)}function cj(e,t){return!t||"object"!==dj(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function uj(e,t){return uj=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e},uj(e,t)}oe.add("game-ui/common/panel/panel-backdrop.tsx",{get PanelBackdrop(){return ij},set PanelBackdrop(e){ij=e},get usePanelBackdropStyle(){return aj},set usePanelBackdropStyle(e){aj=e}});var dj=function(e){return e&&"undefined"!=typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};function fj(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,r=lj(e);if(t){var i=lj(this).constructor;n=Reflect.construct(r,arguments,i)}else n=r.apply(this,arguments);return cj(this,n)}}function mj(e){return(0,Y.useMemo)((function(){return new gj(e)}),[e])}var gj=function(e){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&uj(e,t)}(o,e);var t,n,r,i=fj(o);function o(e){var t;return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,o),(t=i.call(this)).childFocusKey=null,t.childElement=null,t.isChildFocusedImpl=function(e){return e===t.childFocusKey},t.registerChild=function(e,n){null==t.childFocusKey?(t.childFocusKey=e,t.childElement=n,t.enabled=!0):console.error("Cannot register second focus key '".concat(e,"'! KeyFocusControllers can only host a single child.\nRegistered key: ").concat(t.childFocusKey,"\n").concat(t.debugTrace()))},t.unregisterChild=function(e){t.childFocusKey===e?(t.enabled=!1,t.childFocusKey=null,t.childElement=null):console.error("Attempted to unregister mismatching focus key '".concat(e,"' from a KeyFocusController!\nRegistered key: ").concat(t.childFocusKey,"\n").concat(t.debugTrace()))},t.getBounds=function(){var e,n;return null!==(n=null===(e=t.childElement)||void 0===e?void 0:e.getBounds())&&void 0!==n?n:null},t.focusKey=e,t}return o.prototype.getFocusedBounds=function(){var e,t;return null!==(t=null===(e=this.childElement)||void 0===e?void 0:e.getFocusedBounds())&&void 0!==t?t:null},t=o,(n=[{key:"debugFocusedChild",get:function(){return this.childElement}}])&&sj(t.prototype,n),r&&sj(t,r),o}(lg);oe.add("game-ui/common/focus/controller/key-focus-controller.tsx",{get useKeyFocusController(){return mj},set useKeyFocusController(e){mj=e}});var hj=function(e){var t=e.focusKey,n=void 0===t?Kh:t,r=e.children,i=mj(zh(n,"FocusKeyOverride"));return(0,z.jsx)(Sg,{controller:i,children:r})};oe.add("game-ui/common/focus/focus-key-override.tsx",{get FocusKeyOverride(){return hj},set FocusKeyOverride(e){hj=e}});var pj=function(e){var t=e.focusKey,n=void 0===t?Kh:t,r=e.debugName,i=void 0===r?"FocusScope":r,o=e.focused,a=e.activation,s=void 0===a?yd.FocusedChild:a,l=e.children,c=mp(zh(n,i),s);return(0,Y.useEffect)((function(){c.focusedChildKey=o}),[c,o]),(0,z.jsx)(Sg,{controller:c,children:l})};oe.add("game-ui/common/focus/focus-scope.tsx",{get FocusScope(){return pj},set FocusScope(e){pj=e}});var vj={enter:Lp.openPanel,exit:Lp.closePanel},bj={enter:Lp.openMenu,exit:Lp.closeMenu};function yj(e){var t=(0,Y.useContext)(Ld).state;(0,Y.useEffect)((function(){t===Cd.enter?kp(null==e?void 0:e.enter):t===Cd.exit&&kp(null==e?void 0:e.exit)}),[t,null==e?void 0:e.enter,null==e?void 0:e.exit])}function xj(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function _j(e){return _j=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)},_j(e)}function jj(e,t){return!t||"object"!==Ej(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function Oj(e,t){return Oj=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e},Oj(e,t)}oe.add("game-ui/common/animations/transition-sounds.tsx",{get panelTransitionSounds(){return vj},set panelTransitionSounds(e){vj=e},get menuTransitionSounds(){return bj},set menuTransitionSounds(e){bj=e},get useTransitionSounds(){return yj},set useTransitionSounds(e){yj=e}});var Ej=function(e){return e&&"undefined"!=typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};function Sj(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,r=_j(e);if(t){var i=_j(this).constructor;n=Reflect.construct(r,arguments,i)}else n=r.apply(this,arguments);return jj(this,n)}}function Tj(){return(0,Y.useMemo)((function(){return new Ij}),[])}var Ij=function(e){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&Oj(e,t)}(o,e);var t,n,r,i=Sj(o);function o(){var e;return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,o),(e=i.call(this,!1)).childElement=null,e.isChildFocusedImpl=function(t){return t===e.focusKey},e.registerChild=function(t,n){null==e.focusKey?(e.focusKey=t,e.childElement=n):console.error("Cannot register second focus key '".concat(t,"'! RootFocusControllers can only host a single child.\nRegistered key: ").concat(e.focusKey,"\n").concat(e.debugTrace()))},e.unregisterChild=function(t){e.focusKey===t?(e.focusKey=null,e.childElement=null):console.error("Attempted to unregister mismatching focus key '".concat(t,"' from a RootFocusController!\nRegistered key: ").concat(e.focusKey,"\n").concat(e.debugTrace(),")"))},e.getBounds=function(){return null},e.enabled=!0,e}return o.prototype.getFocusedBounds=function(){return null},t=o,(n=[{key:"debugName",get:function(){return"<root>"}},{key:"debugFocusedChild",get:function(){return this.childElement}}])&&xj(t.prototype,n),r&&xj(t,r),o}(lg);oe.add("game-ui/common/focus/controller/root-focus-controller.tsx",{get useRootFocusController(){return Tj},set useRootFocusController(e){Tj=e}});var wj=function(e){var t=e.children,n=Tj();return(0,z.jsx)(Sg,{controller:n,children:t})};function Pj(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,n=(0,Y.useRef)(e);return el(e,n.current,t)||(n.current=e),n.current}function Cj(e){var t=!0,n=!1,r=void 0;try{for(var i,o=Object.values(e)[Symbol.iterator]();!(t=(i=o.next()).done);t=!0){var a=i.value;(new Image).src=a.replaceAll('"',"")}}catch(e){n=!0,r=e}finally{try{t||null==o.return||o.return()}finally{if(n)throw r}}return e}function Nj(e){var t=Pj(e,1);return(0,Y.useMemo)((function(){return Cj(t)}),[t])}oe.add("game-ui/common/focus/focus-root.tsx",{get FocusRoot(){return wj},set FocusRoot(e){wj=e}}),oe.add("game-ui/common/hooks/use-shallow-memoize.tsx",{get useShallowMemoize(){return Pj},set useShallowMemoize(e){Pj=e}}),oe.add("game-ui/common/image/preload.ts",{get preloadImages(){return Cj},set preloadImages(e){Cj=e},get usePreloadedImages(){return Nj},set usePreloadedImages(e){Nj=e}});let Aj={closeIcon:'"Media/Glyphs/Close.svg"',toggleIcon:'"Media/Glyphs/ThickStrokeArrowRight.svg"',toggleIconExpanded:'"Media/Glyphs/ThickStrokeArrowDown.svg"',panel:"panel_YqS",header:"header_Bpo child-opacity-transition_nkS",content:"content_AD7 child-opacity-transition_nkS",footer:"footer_pD5 child-opacity-transition_nkS","title-bar":"title-bar_PF4",titleBar:"title-bar_PF4",title:"title_zQN",icon:"icon_OVK","icon-space":"icon-space_h_f",iconSpace:"icon-space_h_f","close-button":"close-button_wKK",closeButton:"close-button_wKK",toggle:"toggle_Q44"};oe.add("game-ui/common/panel/panel.module.scss",{get classes(){return Aj},set classes(e){Object.assign(Aj,e)}});const Lj=Aj;Cj([Lj.closeIcon,Lj.toggleIcon,Lj.toggleIconExpanded]);var Mj=Y.createContext({theme:Lj}),kj=Y.createContext({expanded:!0,toggleExpanded:function(){},theme:Lj});function Rj(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Dj(e){return(0,Y.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Rj(e,t,n[t])}))}return e}({},Lj,e)}),[e])}oe.add("game-ui/common/panel/panel-context.ts",{get PanelContext(){return Mj},set PanelContext(e){Mj=e},get CollapsiblePanelContext(){return kj},set CollapsiblePanelContext(e){kj=e}}),oe.add("game-ui/common/panel/panel-theme.ts",{get usePanelTheme(){return Dj},set usePanelTheme(e){Dj=e}});let Fj={header:"header_H_U header_Bpo child-opacity-transition_nkS",content:"content_XD5 content_AD7 child-opacity-transition_nkS",footer:"footer_Pa9 footer_pD5 child-opacity-transition_nkS",title:"title_SVH title_zQN"};oe.add("game-ui/common/panel/themes/default.module.scss",{get classes(){return Fj},set classes(e){Object.assign(Fj,e)}});const Uj=Fj;let Gj={enter:"enter__zh enter_kO6","enter-active":"enter-active_YAb enter-active_lrI",enterActive:"enter-active_YAb enter-active_lrI",exit:"exit_KiP exit_Von","exit-active":"exit-active_g0a exit-active_jtN",exitActive:"exit-active_g0a exit-active_jtN"};oe.add("game-ui/common/panel/themes/panel-transition.module.scss",{get classes(){return Gj},set classes(e){Object.assign(Gj,e)}});const Bj=Gj;function Vj(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Hj(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Vj(e,t,n[t])}))}return e}function Kj(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Wj(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var zj=new Wh("PanelHeader"),Yj=new Wh("PanelContent"),$j=new Wh("PanelFooter"),qj=(0,Y.forwardRef)((function(e,t){var n=e.focusKey,r=e.header,i=e.footer,o=e.theme,a=void 0===o?Uj:o,s=e.transition,l=void 0===s?Bj:s,c=e.transitionSounds,u=e.className,d=e.contentClassName,f=e.children,m=e.onClose,g=e.allowFocusExit,h=Wj(e,["focusKey","header","footer","theme","transition","transitionSounds","className","contentClassName","children","onClose","allowFocusExit"]);yj(c);var p=Dj(a),v=Y.Children.count(r)>0,b=Y.Children.count(f)>0,y=Y.Children.count(i)>0,x=(0,Y.useMemo)((function(){return{theme:p,onClose:m}}),[p,m]),_=(0,z.jsx)(ap,{onAction:m,children:(0,z.jsx)(Mj.Provider,{value:x,children:(0,z.jsx)(Cm,{styles:l,children:(0,z.jsx)(Yv,Kj(Hj({ref:t,focusKey:n,className:_d()(p.panel,u)},h),{children:(0,z.jsxs)(Ap,{initialFocused:Yj,children:[v&&(0,z.jsx)(hj,{focusKey:zj,children:(0,z.jsx)("div",{className:p.header,children:r})}),b&&(0,z.jsx)(hj,{focusKey:Yj,children:(0,z.jsx)("div",{className:_d()(p.content,d),children:f})}),y&&(0,z.jsx)(hj,{focusKey:$j,children:(0,z.jsx)("div",{className:p.footer,children:i})})]})}))})})});return g?_:(0,z.jsx)(wj,{children:_})}));oe.add("game-ui/common/panel/panel.tsx",{get Panel(){return qj},set Panel(e){qj=e}});let Xj={header:"header_jAe header_Bpo child-opacity-transition_nkS",content:"content_VBF content_AD7 child-opacity-transition_nkS",footer:"footer_CZr footer_pD5 child-opacity-transition_nkS",title:"title_ctd title_zQN"};oe.add("game-ui/common/panel/themes/dark-opaque.module.scss",{get classes(){return Xj},set classes(e){Object.assign(Xj,e)}});const Qj=Xj;function Zj(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Jj(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function eO(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var tO=function(e){var t=e.icon,n=e.theme,r=e.className,i=e.children,o=e.onCloseOverride,a=eO(e,["icon","theme","className","children","onCloseOverride"]),s=(0,Y.useContext)(Mj),l=Pg(),c=null!=o?o:s.onClose,u=!l&&null!=c,d=null!=n?n:s.theme;return(0,z.jsxs)("div",Jj(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Zj(e,t,n[t])}))}return e}({},a),{className:_d()(d.titleBar,r),children:[null!=t?(0,z.jsx)("img",{src:t,className:d.icon}):u&&(0,z.jsx)("div",{className:d.iconSpace}),(0,z.jsx)("div",{className:d.title,children:i}),u?(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:d.closeIcon,theme:ub,className:d.closeButton,onSelect:c,onMouseDown:function(e){e.preventDefault(),e.stopPropagation()}}):null!=t&&(0,z.jsx)("div",{className:d.iconSpace})]}))};oe.add("game-ui/common/panel/panel-title-bar.tsx",{get PanelTitleBar(){return tO},set PanelTitleBar(e){tO=e}});let nO={dialog:"dialog_E8_",wide:"wide_XFu",row:"row_L6K","pdx-title":"pdx-title_qXw",pdxTitle:"pdx-title_qXw","pdx-button-row":"pdx-button-row_Dor",pdxButtonRow:"pdx-button-row_Dor",message:"message_SFv row_L6K","error-message":"error-message_r4_",errorMessage:"error-message_r4_",paragraphs:"paragraphs_MnN paragraphs_nbD",buttons:"buttons_lZi row_L6K",button:"button_gJo",footer:"footer_Q7P row_L6K","footer-label":"footer-label_AHF",footerLabel:"footer-label_AHF","buttons-vertical":"buttons-vertical_Zha row_L6K",buttonsVertical:"buttons-vertical_Zha row_L6K","button-ok":"button-ok_IS9 button_gJo",buttonOk:"button-ok_IS9 button_gJo","error-dialog":"error-dialog_iaV",errorDialog:"error-dialog_iaV","icon-layout":"icon-layout_cZT row_L6K",iconLayout:"icon-layout_cZT row_L6K",icon:"icon_JQd","main-column":"main-column_Jzk",mainColumn:"main-column_Jzk","error-details":"error-details_RaN row_L6K",errorDetails:"error-details_RaN row_L6K",content:"content_Aju","copy-button":"copy-button_V8I",copyButton:"copy-button_V8I"};oe.add("game-ui/common/panel/dialog/dialog.module.scss",{get classes(){return nO},set classes(e){Object.assign(nO,e)}});const rO=nO;function iO(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function oO(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||sO(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function aO(e){return function(e){if(Array.isArray(e))return iO(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||sO(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function sO(e,t){if(e){if("string"==typeof e)return iO(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?iO(e,t):void 0}}var lO=function(e){var t=e.wide,n=e.title,r=e.buttons,i=e.theme,o=void 0===i?Qj:i,a=e.onClose,s=e.children;return(0,z.jsx)(ij,{children:(0,z.jsxs)(qj,{theme:o,header:n&&(0,z.jsx)(tO,{children:n}),className:_d()(rO.dialog,t&&rO.wide),onClose:a,children:[(0,z.jsx)("div",{className:rO.message,children:s}),r]})})},cO=new Wh("CHILDREN_KEY"),uO=new Wh("DIALOG_KEY"),dO=Y.createContext({showDialog:function(){},closeAll:function(){}}),fO=Y.createContext({onClose:function(){}}),mO=function(e){var t=e.children,n=oO((0,Y.useState)([]),2),r=n[0],i=n[1],o=(0,Y.useMemo)((function(){return{showDialog:function(e){return i((function(t){return aO(t).concat([e])}))},closeAll:function(){return i([])}}}),[]),a=(0,Y.useMemo)((function(){return{onClose:function(){return i((function(e){return e.slice(0,e.length-1)}))}}}),[]);return(0,z.jsx)(dO.Provider,{value:o,children:(0,z.jsxs)(pj,{focused:r.length>0?uO:cO,children:[(0,z.jsx)(hj,{focusKey:cO,children:t}),(0,z.jsx)(hj,{focusKey:uO,children:(0,z.jsx)(fO.Provider,{value:a,children:r.length>0&&r[r.length-1]})})]})})};function gO(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function hO(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function pO(){return pO=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},pO.apply(this,arguments)}function vO(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){hO(e,t,n[t])}))}return e}function bO(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function yO(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return gO(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return gO(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/panel/dialog/dialog.tsx",{get Dialog(){return lO},set Dialog(e){lO=e},get DialogStack(){return dO},set DialogStack(e){dO=e},get DialogContext(){return fO},set DialogContext(e){fO=e},get DialogRenderer(){return mO},set DialogRenderer(e){mO=e}});var xO=new Wh("CANCEL_KEY"),_O=function(e){var t=pO({},function(e){if(null==e)throw new TypeError("Cannot destructure "+e);return e}(e)),n=yO((0,Y.useState)(!1),2),r=n[0],i=n[1],o=(0,Y.useContext)(fO),a=(0,Y.useCallback)((function(e){o.onClose(),t.dismissable?Dh(e,r):Rh(e)}),[o,r,t.dismissable]);return"Paradox"===t.skin?(0,z.jsx)(ij,{children:(0,z.jsx)(qb,{onClose:function(){return a(-1)},children:(0,z.jsxs)(Ap,{children:[t.title&&(0,z.jsx)("div",{className:rO.pdxTitle,children:(0,z.jsx)(ku,{value:t.title})}),(0,z.jsx)(Fv,{theme:rO,children:(0,z.jsx)(ku,{value:t.message})}),(0,z.jsx)("div",{className:rO.pdxButtonRow,children:(0,z.jsx)(jO,vO({dismissed:r,setDismissed:i,callback:a},t))})]})})}):(0,z.jsx)(lO,{title:t.title&&(0,z.jsx)(ku,{value:t.title}),buttons:(0,z.jsx)(jO,vO({dismissed:r,setDismissed:i,callback:a},t)),onClose:function(){return a(1)},children:(0,z.jsx)(Fv,{theme:rO,children:(0,z.jsx)(ku,{value:t.message})})})},jO=function(e){var t=e.dismissed,n=e.setDismissed,r=e.callback,i=bO(e,["dismissed","setDismissed","callback"]);return(0,z.jsx)(ap,{onAction:function(){return r(1)},children:(0,z.jsxs)(Ap,{initialFocused:i.hasCancelAction?xO:null,children:[(0,z.jsxs)("div",{className:rO.buttons,children:[(0,z.jsx)(Qp,{theme:"Paradox"===i.skin?tv:Jp,className:_d()("Default"===i.skin&&rO.button),onSelect:function(){return r(0)},children:(0,z.jsx)(ku,{value:i.confirmAction})}),i.otherActions.map((function(e,t){return(0,z.jsx)(Qp,{theme:"Paradox"===i.skin?tv:Jp,className:_d()("Default"===i.skin&&rO.button),onSelect:function(){return r(t+2)},children:(0,z.jsx)(ku,{value:e})},t)})),i.hasCancelAction&&(0,z.jsx)(Qp,{focusKey:xO,theme:"Paradox"===i.skin?rv:Jp,className:_d()("Default"===i.skin&&rO.button,"Default"===i.skin&&Jp.negative),onSelect:function(){return r(1)},children:(0,z.jsx)(ku,{value:i.cancelAction})})]}),i.dismissable&&(0,z.jsxs)("div",{className:rO.footer,children:[(0,z.jsx)(fv,{checked:t,onChange:n}),(0,z.jsx)("div",{className:rO.footerLabel,children:(0,z.jsx)(qc.Common.DONT_SHOW_AGAIN,{})})]})]})})},OO=function(e){var t=e.title,n=e.message,r=e.confirm,i=e.cancel,o=e.onConfirm,a=e.onCancel,s=e.dismissable,l=void 0!==s&&s,c=e.cancellable,u=void 0===c||c,d=(0,Y.useContext)(fO),f=yO((0,Y.useState)(!1),2),m=f[0],g=f[1],h=(0,Y.useCallback)((function(){d.onClose(),a&&a()}),[d,a]),p=(0,Y.useCallback)((function(){d.onClose(),o(m)}),[d,m,o]);return(0,z.jsx)(ap,{onAction:h,children:(0,z.jsx)(lO,{title:t,buttons:(0,z.jsxs)(Ap,{initialFocused:xO,children:[(0,z.jsxs)("div",{className:rO.buttons,children:[(0,z.jsx)(Qp,{theme:Jp,className:rO.button,onSelect:p,children:null!=r?r:(0,z.jsx)(qc.Common.YES,{})}),u&&(0,z.jsx)(Qp,{focusKey:xO,theme:Jp,className:_d()(rO.button,Jp.negative),onSelect:h,children:null!=i?i:(0,z.jsx)(qc.Common.NO,{})})]}),l&&(0,z.jsxs)("div",{className:rO.footer,children:[(0,z.jsx)(fv,{checked:m,onChange:g}),(0,z.jsx)("div",{className:rO.footerLabel,children:(0,z.jsx)(qc.Common.DONT_SHOW_AGAIN,{})})]})]}),onClose:h,children:(0,z.jsx)(Fv,{theme:rO,children:n})})})};oe.add("game-ui/common/panel/dialog/confirmation-dialog.tsx",{get GameTriggeredConfirmationDialog(){return _O},set GameTriggeredConfirmationDialog(e){_O=e},get UITriggeredConfirmationDialog(){return OO},set UITriggeredConfirmationDialog(e){OO=e}});let EO={button:"button_ke4",icon:"icon_be5"};oe.add("game-ui/common/input/button/floating-icon-button.module.scss",{get classes(){return EO},set classes(e){Object.assign(EO,e)}});const SO=EO;function TO(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function IO(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function wO(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var PO=function(e){var t=e.theme,n=e.children,r=wO(e,["theme","children"]);return(0,z.jsx)(lb,IO(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){TO(e,t,n[t])}))}return e}({},r),{theme:t,children:(0,z.jsx)("div",{className:t.label,children:n})}))};oe.add("game-ui/common/input/button/labeled-icon-button.tsx",{get LabeledIconButton(){return PO},set LabeledIconButton(e){PO=e}});let CO={button:"button_d0d"};oe.add("game-ui/common/input/button/themes/default-button.module.scss",{get classes(){return CO},set classes(e){Object.assign(CO,e)}});const NO=CO;let AO={button:"button_7tF"};oe.add("game-ui/common/input/button/themes/flat-button.module.scss",{get classes(){return AO},set classes(e){Object.assign(AO,e)}});const LO=AO;let MO={button:"button_GME"};oe.add("game-ui/common/input/button/themes/primary-button.module.scss",{get classes(){return MO},set classes(e){Object.assign(MO,e)}});const kO=MO;let RO={button:"button_uFa child-opacity-transition_nkS",icon:"icon_zVk",label:"label_NLv"};oe.add("game-ui/menu/themes/menu-item.module.scss",{get classes(){return RO},set classes(e){Object.assign(RO,e)}});const DO=RO;function FO(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function UO(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){FO(e,t,n[t])}))}return e}function GO(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var BO={flat:LO,primary:kO,round:ub,menu:DO,default:NO,icon:rb,floating:SO},VO=function(e){var t=e.variant,n=void 0===t?"default":t,r=BO[n];return e.src?r.label?(0,z.jsx)(PO,GO(UO({theme:r},e),{src:e.src})):("default"===n&&(r=BO.icon),(0,z.jsx)(lb,GO(UO({theme:r},e),{src:e.src}))):(0,z.jsx)(Qp,UO({theme:r},e))},HO=function(e){var t=e.src||"Media/Glyphs/Credits.svg";return(0,z.jsx)(VO,GO(UO({tinted:!0,variant:"menu"},e),{src:t}))},KO=function(e){var t=e.src||"Media/Glyphs/Credits.svg";return(0,z.jsx)(VO,GO(UO({tinted:!0,variant:"floating"},e),{src:t}))};oe.add("game-ui/ui/button.tsx",{get Button(){return VO},set Button(e){VO=e},get MenuButton(){return HO},set MenuButton(e){HO=e},get FloatingButton(){return KO},set FloatingButton(e){KO=e}});var WO=function(){return window.innerHeight>.5625*window.innerWidth?window.innerWidth/1920:window.innerHeight/1080};function zO(){var e=Xf();return xl(ql)?e.y>.5625*e.x?e.x/1920:e.y/1080:1}function YO(e){var t=zO();if(e.endsWith("rem"))return parseFloat(e.substring(0,e.length-3))*t;if(e.endsWith("px"))return parseFloat(e.substring(0,e.length-2));throw Error("Unsupport length syntax: ".concat(e))}const $O=zO;function qO(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}oe.add("game-ui/common/hooks/use-rem.ts",{get getRem(){return WO},set getRem(e){WO=e},get useRem(){return zO},set useRem(e){zO=e},get useCssLength(){return YO},set useCssLength(e){YO=e}});var XO=Y.createContext(!0),QO=function(e){var t=e.visible,n=e.direction,r=void 0===n?"down":n,i=e.minHeight,o=void 0===i?0:i,a=e.minWidth,s=void 0===a?0:a,l=e.className,c=e.content,u=e.children,d=e.style,f=(0,Y.useRef)(null),m=(0,Y.useRef)(null),g=Wf(f,t),h=Wf(m,t&&null!=m),p=Xf(t),v=$O(),b=(0,Y.useMemo)((function(){var e=o*v,n=!0===s?(null==g?void 0:g.width)||0:s*v;return t&&null!=g?function(e,t,n,r,i,o){var a=t.y-e.bottom,s=e.top;r>0&&("down"===n&&a<r&&a<s?n="up":s<r&&s<a&&(n="down"));var l=null!=o?Math.max(e.left+o.width-t.x,0):0;return"up"===n?{position:"absolute",left:e.left-l,bottom:t.y-e.top,maxHeight:s,minWidth:i,visibility:o&&o.width>0?"inherit":"hidden"}:{position:"absolute",left:e.left-l,top:e.bottom,maxHeight:a,minWidth:i,visibility:o&&o.width>0?"inherit":"hidden"}}(g,p,r,e,n,h):ZO}),[o,v,s,g,t,p,r,h]),y=function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){qO(e,t,n[t])}))}return e}({},b,d);return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(Zd,{ref:f,children:u}),t&&(0,z.jsx)(tm,{children:(0,z.jsx)(XO.Provider,{value:t&&null!=g,children:(0,z.jsx)("div",{className:l,style:y,ref:m,children:c})})},"popup")]})},ZO={position:"absolute",visibility:"hidden"};oe.add("game-ui/common/anchored-popup/anchored-popup.tsx",{get AnchoredPopupVisibleContext(){return XO},set AnchoredPopupVisibleContext(e){XO=e},get AnchoredPopup(){return QO},set AnchoredPopup(e){QO=e}});let JO={"pointer-barrier":"pointer-barrier_etG",pointerBarrier:"pointer-barrier_etG"};oe.add("game-ui/common/input-events/pointer-barrier/pointer-barrier.module.scss",{get classes(){return JO},set classes(e){Object.assign(JO,e)}});const eE=JO;var tE=function(e){var t=e.onClick;return(0,z.jsx)(tm,{children:(0,z.jsx)("div",{className:eE.pointerBarrier,onClick:t})})};oe.add("game-ui/common/input-events/pointer-barrier/pointer-barrier.tsx",{get PointerBarrier(){return tE},set PointerBarrier(e){tE=e}});var nE=n(4),rE=n.n(nE);function iE(e,t,n,r,i,o){var a=$O();(0,Y.useEffect)((function(){var s,l,c=(null==o?void 0:o.current)||0,u=!1;if(window.cancelAnimationFrame(c),e&&t.current&&i){var d=function(f){if(e&&t.current&&i){if(void 0===s&&(s=f),f-s<i.delay)return c=window.requestAnimationFrame(d),void(void 0!==o&&(o.current=c));void 0===l&&(l=f);var m=(f-l)/1e3,g=Math.round(i.speed*m*a),h="Vertical"===n?t.current.scrollHeight-t.current.offsetHeight:t.current.scrollWidth-t.current.offsetWidth;if(h<i.minOverflow*a)return t.current.scrollTop=0,void r();var p=u?h-g:g;"Vertical"===n?p!==t.current.scrollTop&&(t.current.scrollTop=p,r()):p!==t.current.scrollLeft&&(t.current.scrollLeft=p,r()),!u&&p<h||u&&p>0?(c=window.requestAnimationFrame(d),void 0!==o&&(o.current=c)):i.repeat&&(u=!u,s=void 0,l=void 0,c=window.requestAnimationFrame(d),void 0!==o&&(o.current=c))}};return c=window.requestAnimationFrame(d),void 0!==o&&(o.current=c),function(){return window.cancelAnimationFrame(c)}}}),[o,t,n,e,r,a,i])}function oE(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function aE(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return oE(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return oE(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function sE(e,t,n){var r=aE((0,Y.useState)(!1),2),i=r[0],o=r[1],a=aE((0,Y.useState)(),2),s=a[0],l=a[1],c=(0,Y.useCallback)((function(t){e(t)&&(l(t.currentTarget),t.preventDefault(),o(!0))}),[e,l]),u=(0,Y.useCallback)((function(e){e.preventDefault(),t({clientX:e.clientX,clientY:e.clientY,currentTarget:s})}),[t,s]),d=(0,Y.useCallback)((function(e){e.preventDefault(),o(!1),n({clientX:e.clientX,clientY:e.clientY,currentTarget:s})}),[n,s]);return(0,Y.useEffect)((function(){if(i)return document.addEventListener("mousemove",u),document.addEventListener("mouseup",d),function(){document.removeEventListener("mousemove",u),document.removeEventListener("mouseup",d)}}),[i,u,d]),[i,c]}oe.add("game-ui/common/hooks/use-auto-scroll.tsx",{get useAutoScroll(){return iE},set useAutoScroll(e){iE=e}}),oe.add("game-ui/common/hooks/use-mouse-drag-events.tsx",{get useMouseDragEvents(){return sE},set useMouseDragEvents(e){sE=e}});let lE={scrollable:"scrollable_DXr",viewport:"viewport_bY2",content:"content_gqa",x:"x_TNK",y:"y_SMM","track-visible-y":"track-visible-y_RCA",trackVisibleY:"track-visible-y_RCA",track:"track_e3O","track-visible-x":"track-visible-x_qNT",trackVisibleX:"track-visible-x_qNT",thumb:"thumb_Cib",pressed:"pressed_iMJ","bottom-padding":"bottom-padding_JS3",bottomPadding:"bottom-padding_JS3"};oe.add("game-ui/common/scrolling/scrollable.module.scss",{get classes(){return lE},set classes(e){Object.assign(lE,e)}});const cE=lE;function uE(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function dE(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return uE(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return uE(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var fE=rE()(.445,.05,.55,.95),mE={speed:20,delay:3e3,repeat:!0,minOverflow:8},gE=(0,Y.forwardRef)((function(e,t){var n=e.horizontal,r=void 0!==n&&n,i=e.vertical,o=void 0===i||i,a=e.trackVisibility,s=void 0===a?"scrollable":a,l=e.overshootX,c=void 0===l?.05:l,u=e.overshootY,d=void 0===u?.05:u,f=e.smooth,m=void 0===f||f,g=e.controller,h=e.className,p=e.style,v=e.children,b=e.onScroll,y=e.autoScroll,x=void 0!==y&&y,_=e.autoScrollSettings,j=void 0===_?mE:_,O=dE((0,Y.useState)(x),2),E=O[0],S=O[1],T=dE((0,Y.useState)(!1),2),I=T[0],w=T[1],P=dE((0,Y.useState)(!1),2),C=P[0],N=P[1],A=(0,Y.useRef)(null),L=Hd(t,A),M=(0,Y.useRef)(null),k=(0,Y.useRef)(null),R=(0,Y.useRef)(null),D=(0,Y.useRef)(null),F=(0,Y.useCallback)((function(){if(A.current&&M.current&&k.current){var e=A.current.offsetWidth,t=A.current.scrollWidth,n=of(A.current.scrollLeft,0,t-e),r=M.current.offsetWidth;if(0!==e&&0!==t&&0!==r){var i=t-1>e;if(w(i),i){var o=of(r*e/t,Math.min(20,r/2),r),a=n/(t-e)*(r-o);k.current.style.width="".concat(o,"px"),k.current.style.left="".concat(a,"px")}}}}),[]),U=(0,Y.useCallback)((function(){if(A.current&&R.current&&D.current){var e=A.current.offsetHeight,t=A.current.scrollHeight,n=of(A.current.scrollTop,0,t-e),r=R.current.offsetHeight;if(0!==e&&0!==t&&0!==r){var i=t-1>e;if(N(i),i){var o=of(r*e/t,Math.min(20,r/2),r),a=n/(t-e)*(r-o);D.current.style.height="".concat(o,"px"),D.current.style.top="".concat(a,"px")}}}}),[]),G=(0,Y.useCallback)((function(){r&&F(),o&&U()}),[r,F,U,o]),B=(0,Y.useCallback)((function(){S(!1)}),[]),V=(0,Y.useCallback)((function(){S(!0)}),[]),H=(0,Y.useCallback)((function(){b&&b(),G()}),[b,G]),K=(0,Y.useRef)(0),W=(0,Y.useRef)(0),$=(0,Y.useCallback)((function(e){var t=e.clientX;if(S(!1),!k.current)return!1;var n=k.current.getBoundingClientRect(),r=n.width,i=n.left;return 0!==r&&(K.current=(t-i)/r,!0)}),[]),q=(0,Y.useCallback)((function(e){var t=e.clientY;if(S(!1),!D.current)return!1;var n=D.current.getBoundingClientRect(),r=n.height,i=n.top;return 0!==r&&(W.current=(t-i)/r,!0)}),[]),X=(0,Y.useCallback)((function(e){var t=e.clientX;if(A.current&&M.current&&k.current){var n=A.current.offsetWidth,r=A.current.scrollWidth,i=M.current.getBoundingClientRect(),o=k.current.getBoundingClientRect();if(0!==n&&0!==r&&0!==i.width){var a=i.width-o.width;if(0!==a){var s=A.current.scrollLeft,l=of((t-i.left-o.width*K.current)/a,0,1)*(r-n);s!==l&&(A.current.scrollLeft=l,b&&b(),F())}}}}),[b,F]),Q=(0,Y.useCallback)((function(e){var t=e.clientY;if(A.current&&R.current&&D.current){var n=A.current.offsetHeight,r=A.current.scrollHeight,i=R.current.getBoundingClientRect(),o=D.current.getBoundingClientRect();if(0!==n&&0!==r&&0!==i.height){var a=i.height-o.height;if(0!==a){var s=A.current.scrollTop,l=of((t-i.top-o.height*W.current)/a,0,1)*(r-n);s!==l&&(A.current.scrollTop=l,b&&b(),U())}}}}),[b,U]),Z=(0,Y.useCallback)((function(){S(!0)}),[]),J=dE(sE($,X,Z),2),ee=J[0],te=J[1],ne=dE(sE(q,Q,Z),2),re=ne[0],ie=ne[1];Yf(G),(0,Y.useEffect)((function(){var e=window.requestAnimationFrame((function(){e=window.requestAnimationFrame((function(){e=0,G()}))}));return function(){window.cancelAnimationFrame(e)}}),[G]);var oe=(0,Y.useRef)(0),ae=(0,Y.useCallback)((function(e,t){A.current&&(window.cancelAnimationFrame(oe.current),e=of(e,0,A.current.scrollWidth-A.current.offsetWidth),t=of(t,0,A.current.scrollHeight-A.current.offsetHeight),e===A.current.scrollLeft&&t===A.current.scrollTop||(A.current.scrollLeft=e,A.current.scrollTop=t,b&&b()),G())}),[b,G]),se=(0,Y.useCallback)((function(e,t){if(A.current){window.cancelAnimationFrame(oe.current);var n=performance.now(),r=A.current.scrollLeft,i=A.current.scrollTop,o=function(a){if(A.current){var s=(a-n)/175;if(s<1){var l=fE(s),c=of(Math.round(r+(e-r)*l),0,A.current.scrollWidth-A.current.offsetWidth),u=of(Math.round(i+(t-i)*l),0,A.current.scrollHeight-A.current.offsetHeight);u===i&&c===r||b&&b(),A.current.scrollLeft=c,A.current.scrollTop=u,G(),oe.current=window.requestAnimationFrame(o)}else A.current.scrollLeft=e,A.current.scrollTop=t,G()}};oe.current=window.requestAnimationFrame(o)}}),[b,G]);(0,Y.useEffect)((function(){return function(){return window.cancelAnimationFrame(oe.current)}}),[]);var le=(0,Y.useMemo)((function(){return{updateThumbs:function(){window.requestAnimationFrame((function(){window.requestAnimationFrame(G)}))},scrollTo:function(e,t){ae(e,t)},scrollBy:function(e,t){A.current&&ae(A.current.scrollLeft+e,A.current.scrollTop+t)},smoothScrollTo:function(e,t){se(e,t)},scrollIntoView:function(e){if(A.current){var t=A.current.getBoundingClientRect(),n=e.getBoundingClientRect(),i=A.current.scrollLeft,a=A.current.scrollTop;if(r){var s=t.width*c;n.left<t.left+s?i=Math.floor(A.current.scrollLeft+n.left-t.left-s):n.right>t.right-s&&(i=Math.ceil(A.current.scrollLeft+n.right-t.right+s)),i=of(i,0,Math.ceil(A.current.scrollWidth-t.width))}if(o){var l=t.height*d;n.top<t.top+l?a=Math.floor(A.current.scrollTop+n.top-t.top-l):n.bottom>t.bottom-l&&(a=Math.ceil(A.current.scrollTop+n.bottom-t.bottom+l)),a=of(a,0,Math.ceil(A.current.scrollHeight-t.height))}i===A.current.scrollLeft&&a===A.current.scrollTop||(m?se(i,a):ae(i,a))}}}}),[G,ae,se,r,o,c,d,m]);return(0,Y.useEffect)((function(){if(g)return g._attachCallback(le),function(){return g._detachCallback(le)}}),[g,le]),(0,Y.useEffect)((function(){return S(x)}),[x]),iE(x&&E,A,o?"Vertical":"Horizontal",G,j,oe),(0,z.jsxs)("div",{className:_d()(cE.scrollable,r&&cE.x,o&&cE.y,r&&(I||"always"===s)&&cE.trackVisibleX,o&&(C||"always"===s)&&cE.trackVisibleY,h),style:p,onMouseEnter:B,onMouseLeave:V,children:[(0,z.jsx)("div",{ref:L,className:cE.content,onScroll:H,onMouseOver:G,children:(0,z.jsxs)(Rp.Provider,{value:le,children:[v,null!=v&&(0,z.jsx)("div",{className:cE.bottomPadding})]})}),r&&(0,z.jsx)("div",{ref:M,className:_d()(cE.track,cE.x),children:(0,z.jsx)("div",{ref:k,className:_d()(cE.thumb,cE.x,ee&&cE.pressed),onMouseDown:te})}),o&&(0,z.jsx)("div",{ref:R,className:_d()(cE.track,cE.y),children:(0,z.jsx)("div",{ref:D,className:_d()(cE.thumb,cE.y,re&&cE.pressed),onMouseDown:ie})})]})}));oe.add("game-ui/common/scrolling/scrollable.tsx",{get Scrollable(){return gE},set Scrollable(e){gE=e}});let hE={hiddenIcon:'"Media/Glyphs/StrokeArrowDown.svg"',visibleIcon:'"Media/Glyphs/StrokeArrowUp.svg"',"dropdown-toggle":"dropdown-toggle_prl",dropdownToggle:"dropdown-toggle_prl",label:"label_l_4","dropdown-popup":"dropdown-popup_mMv",dropdownPopup:"dropdown-popup_mMv","dropdown-menu":"dropdown-menu_Swd",dropdownMenu:"dropdown-menu_Swd"};oe.add("game-ui/common/input/dropdown/dropdown.module.scss",{get classes(){return hE},set classes(e){Object.assign(hE,e)}});const pE=hE;let vE={"dropdown-toggle":"dropdown-toggle_bN9",dropdownToggle:"dropdown-toggle_bN9",label:"label_REA",indicator:"indicator_lzV","dropdown-popup":"dropdown-popup_duR",dropdownPopup:"dropdown-popup_duR","dropdown-menu":"dropdown-menu_rL4",dropdownMenu:"dropdown-menu_rL4",scrollable:"scrollable_MVT","dropdown-item":"dropdown-item_t3P",dropdownItem:"dropdown-item_t3P"};oe.add("game-ui/common/input/dropdown/themes/default.module.scss",{get classes(){return vE},set classes(e){Object.assign(vE,e)}});const bE=vE;function yE(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function xE(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function _E(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return yE(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return yE(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var jE=(0,Y.createContext)({visible:!1,theme:bE,show:function(){},hide:function(){},toggle:function(){}}),OE=new Wh("DROPDOWN_TOGGLE"),EE=new Wh("DROPDOWN_MENU"),SE=function(e){var t=e.focusKey,n=e.initialFocused,r=e.theme,i=void 0===r?bE:r,o=e.content,a=e.children,s=(0,Y.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){xE(e,t,n[t])}))}return e}({},pE,i)}),[i]),l=_E((0,Y.useState)(!1),2),c=l[0],u=l[1],d=(0,Y.useRef)(null),f=(0,Y.useMemo)((function(){return{visible:c,theme:s,show:function(){return u(!0)},hide:function(){return u(!1)},toggle:function(){return u((function(e){return!e}))}}}),[c,s]);(0,Y.useEffect)((function(){if(c){var e=function(e){if(d.current){var t=d.current.getBoundingClientRect();(e.clientX<t.left||e.clientX>t.right||e.clientY<t.top||e.clientY>t.bottom)&&u(!1)}};return document.addEventListener("mousedown",e),function(){return document.removeEventListener("mousedown",e)}}}),[c]);var m=aj(),g=(0,z.jsx)(zv,{className:null==s?void 0:s.dropdownMenu,ref:d,children:(0,z.jsx)(Ap,{focusKey:EE,initialFocused:n,children:(0,z.jsx)(gE,{className:s.scrollable,children:o})})});return(0,z.jsxs)(z.Fragment,{children:[c&&(0,z.jsx)(tE,{onClick:f.hide}),(0,z.jsx)(mb,{includes:fb,disabled:!c,children:(0,z.jsx)(ap,{onAction:f.hide,disabled:!c,children:(0,z.jsx)(pj,{focusKey:t,focused:c?EE:OE,activation:yd.AnyChildren,children:(0,z.jsx)(jE.Provider,{value:f,children:(0,z.jsx)(QO,{visible:c,className:s.dropdownPopup,content:g,minHeight:300,minWidth:!0,style:m,children:(0,z.jsx)(hj,{focusKey:OE,children:a})})})})})})]})};function TE(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function IE(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){TE(e,t,n[t])}))}return e}function wE(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function PE(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}oe.add("game-ui/common/input/dropdown/dropdown.tsx",{get DropdownContext(){return jE},set DropdownContext(e){jE=e},get DROPDOWN_TOGGLE_KEY(){return OE},set DROPDOWN_TOGGLE_KEY(e){OE=e},get DROPDOWN_MENU_KEY(){return EE},set DROPDOWN_MENU_KEY(e){EE=e},get Dropdown(){return SE},set Dropdown(e){SE=e}});var CE=function(e){var t=e.theme,n=e.children,r=PE(e,["theme","children"]),i=(0,Y.useContext)(jE),o=null!=t?t:i.theme;return(0,z.jsxs)(NE,wE(IE({},r),{theme:t,children:[(0,z.jsx)("div",{className:o.label,children:n}),o.indicator&&(0,z.jsxs)(z.Fragment,{children:[i.visible&&o.visibleIcon&&(0,z.jsx)(tb,{src:o.visibleIcon,className:o.indicator}),!i.visible&&o.hiddenIcon&&(0,z.jsx)(tb,{src:o.hiddenIcon,className:o.indicator})]})]}))},NE=function(e){var t=e.theme,n=e.sounds,r=e.selectSound,i=void 0===r?Lp.selectDropdown:r,o=e.className,a=e.children,s=PE(e,["theme","sounds","selectSound","className","children"]),l=(0,Y.useContext)(jE),c=null!=t?t:l.theme,u=Pg();return(0,z.jsx)(Qp,wE(IE({},s),{focusKey:OE,className:_d()(c.dropdownToggle,o,l.visible&&"active",l.visible&&u&&"focused"),sounds:n,selectSound:i,onSelect:l.toggle,children:a}))};function AE(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}oe.add("game-ui/common/input/dropdown/dropdown-toggle.tsx",{get DropdownToggle(){return CE},set DropdownToggle(e){CE=e},get DropdownToggleBase(){return NE},set DropdownToggleBase(e){NE=e}});var LE,ME,kE=(LE=function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){AE(e,t,n[t])}))}return e}({},Xp),ME=null!=(ME={hover:null})?ME:{},Object.getOwnPropertyDescriptors?Object.defineProperties(LE,Object.getOwnPropertyDescriptors(ME)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(ME)).forEach((function(e){Object.defineProperty(LE,e,Object.getOwnPropertyDescriptor(ME,e))})),LE);function RE(e){var t=e.focusKey,n=e.value,r=e.selected,i=e.theme,o=e.sounds,a=void 0===o?kE:o,s=e.className,l=e.onChange,c=e.onToggleSelected,u=e.closeOnSelect,d=void 0===u||u,f=e.children,m=(0,Y.useContext)(jE),g=null!=i?i:m.theme,h=(0,Y.useCallback)((function(){r?c&&c(n):l&&l(n),d&&m.hide()}),[r,d,m,l,n,c]),p=null!=t?t:"string"==typeof n||"number"==typeof n?n:void 0;return(0,z.jsx)(Qp,{focusKey:p,sounds:a,className:_d()(g.dropdownItem,r&&"selected",s),onSelect:h,children:f||" "})}function DE(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function FE(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return DE(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return DE(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/input/dropdown/items/dropdown-item.tsx",{get defaultDropdownItemSounds(){return kE},set defaultDropdownItemSounds(e){kE=e},get DropdownItem(){return RE},set DropdownItem(e){RE=e}});var UE=function(e){var t=e.onDrag,n=e.children,r=FE((0,Y.useState)(lf),2),i=r[0],o=r[1],a=FE(sE((0,Y.useCallback)((function(e){var n=function(e,t,n){if(n){var r=n.getBoundingClientRect();return{x:e-r.left,y:t-r.top}}return lf}(e.clientX,e.clientY,e.currentTarget);return o(n),t(e.clientX,e.clientY,n.x,n.y),!0}),[t,o]),(0,Y.useCallback)((function(e){t(e.clientX,e.clientY,i.x,i.y)}),[t,i]),(0,Y.useCallback)((function(e){t(e.clientX,e.clientY,i.x,i.y)}),[t,i])),2)[1];return(0,z.jsx)(z.Fragment,{children:Y.Children.map(n,(function(e){return Y.isValidElement(e)?Y.cloneElement(e,{onMouseDown:a}):(0,z.jsx)("div",{onMouseDown:a,children:e})}))})};function GE(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function BE(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function VE(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){BE(e,t,n[t])}))}return e}function HE(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function KE(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function WE(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return GE(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return GE(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/input/drag-handle.tsx",{get DragHandle(){return UE},set DragHandle(e){UE=e}});var zE=function(e){var t=e.header,n=e.initialPosition,r=void 0===n?{x:.5,y:.5}:n,i=e.className,o=e.style,a=e.children,s=KE(e,["header","initialPosition","className","style","children"]),l=WE((0,Y.useState)(r),2),c=l[0],u=l[1],d=Xf(),f=(0,Y.useRef)(null),m=Wf(f),g=(0,Y.useCallback)((function(e,t,n,r){e=Math.min(Math.max(e,0),d.x),t=Math.min(Math.max(t,0),d.y),null!=m&&u(function(e,t,n){return{x:e.x/(n.x-t.width),y:e.y/(n.y-t.height)}}({x:e-n,y:t-r},m,d))}),[u,d,m]);return(0,z.jsx)(qj,HE(VE({},s),{ref:f,header:t?(0,z.jsx)(UE,{onDrag:g,children:t}):void 0,className:_d()("draggable-panel",i),style:HE(VE({},o),{visibility:m?"inherit":"hidden",left:m?c.x*(d.x-m.width):0,top:m?c.y*(d.y-m.height):0}),children:a}))};oe.add("game-ui/common/panel/draggable-panel/draggable-panel.tsx",{get DraggablePanel(){return zE},set DraggablePanel(e){zE=e}});let YE={"info-section":"info-section_I7V",infoSection:"info-section_I7V",content:"content_Cdk item-focused_FuT",column:"column_aPB",divider:"divider_rfM","no-margin":"no-margin_K7I",noMargin:"no-margin_K7I","disable-focus-highlight":"disable-focus-highlight_ik3",disableFocusHighlight:"disable-focus-highlight_ik3","info-wrap-box":"info-wrap-box_Rt4",infoWrapBox:"info-wrap-box_Rt4"};oe.add("game-ui/game/components/selected-info-panel/shared-components/info-section/info-section.module.scss",{get classes(){return YE},set classes(e){Object.assign(YE,e)}});const $E=YE;var qE=function(e){var t=e.focusKey,n=e.tooltip,r=e.disableFocus,i=void 0!==r&&r,o=e.className,a=e.children;return(0,z.jsx)("div",{className:_d()($E.infoSection,o),children:(0,z.jsx)(jh,{tooltip:n,direction:"right",alignment:"center",children:i?(0,z.jsx)(zv,{className:_d()($E.content,$E.disableFocusHighlight),children:(0,z.jsx)(Ap,{children:a})}):(0,z.jsx)(Yv,{focusKey:t,className:$E.content,children:(0,z.jsx)(Ap,{children:a})})})})},XE=function(e){var t=e.noMargin,n=void 0!==t&&t;return(0,z.jsx)("div",{className:_d()($E.divider,n&&$E.noMargin)})};function QE(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function ZE(e,t,n,r,i,o,a){try{var s=e[o](a),l=s.value}catch(e){return void n(e)}s.done?t(l):Promise.resolve(l).then(r,i)}function JE(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function eS(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}function tS(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){JE(e,t,n[t])}))}return e}function nS(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function rS(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return QE(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return QE(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/game/components/selected-info-panel/shared-components/info-section/info-section.tsx",{get InfoSection(){return qE},set InfoSection(e){qE=e},get Divider(){return XE},set Divider(e){XE=e}});var iS=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}},oS={},aS=function(e){var t=e.styles,n=e.enterDuration,r=e.exitDuration,i=e.enterExpandHeight,o=void 0===i||i,a=e.exitCollapseHeight,s=void 0===a||a,l=e.children;if(!Wd(l))throw new Error("HeightTransition requires a single child react element!");var c=null!=t?t:oS,u=(0,Y.useContext)(Ld),d=u.state,f=u.onMount,m=u.onUnmount,g=(0,Y.useContext)(Rp),h=(0,Y.useRef)(null),p=Hd(l.ref,h),v=(0,Y.useRef)(!1),b=rS((0,Y.useState)(function(e,t){switch(e){case Cd.enter:return t.enter;case Cd.exit:return t.exit;default:return null}}(d,c)),2),y=b[0],x=b[1],_=(0,Y.useRef)(y);_.current=y;var j=(0,Y.useCallback)((function(e){v.current&&x(e)}),[]),O=rS((0,Y.useState)(d===Cd.enter&&o?{height:"0px"}:{}),2),E=O[0],S=O[1],T=(0,Y.useCallback)((function(e){v.current&&S(e)}),[]);return(0,Y.useEffect)((function(){return v.current||(v.current=!0,f()),function(){v.current&&(v.current=!1,m())}}),[f,m]),(0,Y.useEffect)((function(){var e,t=new rm;return(e=function(){var e,i,a,l,u,f;return iS(this,(function(p){switch(p.label){case 0:return d!==Cd.enter?[3,10]:(j(c.enter),o&&eS(h.current,HTMLElement)&&(e=h.current.offsetHeight,T((function(t){return null==t?{height:e+"px"}:t}))),[4,_m(t)]);case 1:return p.sent()?[4,_m(t)]:[2];case 2:return p.sent()?(j(c.enterActive),[4,_m(t)]):[2];case 3:if(!p.sent())return[2];if(i=null!=n?n:dm(h.current),!o)return[3,7];a=performance.now(),l=fm(h.current,"height"),u=0,eS(h.current,HTMLElement)&&(u=h.current.scrollHeight,T({height:u+"px"})),p.label=4;case 4:return performance.now()-a<=i?(eS(h.current,HTMLElement)&&(f=h.current.scrollHeight,u<f&&(T(null!=l?nS(tS({},mm(h.current,"height",gm(l,performance.now()-a))),{height:f+"px"}):{height:f+"px"}),u=f)),[4,_m(t)]):[3,6];case 5:return p.sent()?[3,4]:[2];case 6:return[3,9];case 7:return[4,xm(i,t)];case 8:if(!p.sent())return[2];p.label=9;case 9:return o&&g.updateThumbs(),j(null),T(null),[3,16];case 10:return d!==Cd.exit?[3,16]:null!=_.current?[3,13]:(j(c.exit),s&&eS(h.current,HTMLElement)&&T({height:h.current.offsetHeight+"px"}),[4,_m(t)]);case 11:return p.sent()?[4,_m(t)]:[2];case 12:if(!p.sent())return[2];p.label=13;case 13:return j(c.exitActive),[4,_m(t)];case 14:return p.sent()?(s&&eS(h.current,HTMLElement)&&T({height:"0px"}),[4,xm(null!=r?r:dm(h.current),t)]):[2];case 15:if(!p.sent())return[2];s&&g.updateThumbs(),v.current&&(v.current=!1,m()),p.label=16;case 16:return[2]}}))},function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){ZE(o,r,i,a,s,"next",e)}function s(e){ZE(o,r,i,a,s,"throw",e)}a(void 0)}))})(),function(){t.cancel(),j(null),T(null)}}),[n,o,s,r,m,g,d,c.enter,c.enterActive,c.exit,c.exitActive,j,T]),(0,z.jsx)(Ld.Provider,{value:Ad,children:Y.cloneElement(l,nS(tS({},l.props),{ref:p,className:_d()(l.props.className,c.base,y),style:tS({},l.props.style,E)}))})};function sS(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function lS(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return sS(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return sS(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/animations/height-transition.tsx",{get emptyStyles(){return oS},set emptyStyles(e){oS=e},get HeightTransition(){return aS},set HeightTransition(e){aS=e}});var cS=function(e){var t=e.in,n=e.skipInitial,r=void 0===n||n,i=e.onEnter,o=e.onExit,a=e.children,s=(0,Y.useRef)(r);(0,Y.useEffect)((function(){t||(s.current=!1)}),[t]);var l=t?s.current?Cd.in:Cd.enter:Cd.exit,c=lS((0,Y.useState)(0),2),u=c[0],d=c[1],f=t||u>0,m=(0,Y.useRef)(i);m.current=i;var g=(0,Y.useRef)(o);g.current=o,(0,Y.useEffect)((function(){if(f)return m.current&&m.current(),function(){g.current&&g.current()}}),[f]);var h=(0,Y.useCallback)((function(){return d((function(e){return e+1}))}),[]),p=(0,Y.useCallback)((function(){return d((function(e){return e-1}))}),[]),v=(0,Y.useMemo)((function(){return{state:l,onMount:h,onUnmount:p}}),[h,p,l]),b=(0,Y.useContext)(Md),y=(0,Y.useContext)(jd);return(0,z.jsx)(Ld.Provider,{value:v,children:(0,z.jsx)(Md.Provider,{value:b||!t,children:(0,z.jsx)(jd.Provider,{value:t?y:Od,children:f&&a})})})};oe.add("game-ui/common/animations/transition-coordinator.tsx",{get TransitionCoordinator(){return cS},set TransitionCoordinator(e){cS=e}});let uS={"foldout-item":"foldout-item_wOF",foldoutItem:"foldout-item_wOF",header:"header_8H_ item-mouse-states_Fmi item-focused_FuT","header-content":"header-content_wUX",headerContent:"header-content_wUX","disable-active-state":"disable-active-state_w8a",disableActiveState:"disable-active-state_w8a","disable-mouse-states":"disable-mouse-states_js5",disableMouseStates:"disable-mouse-states_js5",icon:"icon_I32",toggle:"toggle_yQv",content:"content_mJm",enter:"enter_sm5",exit:"exit_ScE","exit-active":"exit-active_LGX",exitActive:"exit-active_LGX","enter-active":"enter-active_jNk",enterActive:"enter-active_jNk"};oe.add("game-ui/common/foldout/foldout-item.module.scss",{get classes(){return uS},set classes(e){Object.assign(uS,e)}});const dS=uS;var fS=Y.createContext({theme:dS});function mS(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function gS(e){return(0,Y.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){mS(e,t,n[t])}))}return e}({},dS,e)}),[e])}function hS(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function pS(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return hS(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return hS(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/foldout/foldout-context.ts",{get FoldoutContext(){return fS},set FoldoutContext(e){fS=e}}),oe.add("game-ui/common/foldout/foldout-theme.ts",{get useFoldoutTheme(){return gS},set useFoldoutTheme(e){gS=e}});var vS=function(e){var t=e.header,n=e.theme,r=void 0===n?dS:n,i=e.type,o=void 0===i?"Item":i,a=e.nesting,s=void 0===a?0:a,l=e.initialExpanded,c=void 0!==l&&l,u=e.expandFromContent,d=void 0!==u&&u,f=e.onSelect,m=e.onToggleExpanded,g=e.className,h=e.children,p=gS(r),v=Y.Children.count(h)>0,b=pS((0,Y.useState)(c),2),y=b[0],x=b[1],_=(0,Y.useCallback)((function(){kp(Lp.expandPanel),x((function(e){return!e})),m&&m(!y)}),[y,m]),j=(0,Y.useCallback)((function(){f&&(kp(Lp.selectItem),f())}),[f]),O=!v&&!f,E=(0,Y.useMemo)((function(){return{theme:p,expandable:v,expanded:y,onToggleExpanded:_,onSelect:j}}),[v,y,j,_,p]);return(0,z.jsx)(fS.Provider,{value:E,children:(0,z.jsxs)("div",{style:yS(s),className:_d()(p.foldoutItem,v&&p.expandable,y&&p.expanded,"Item"===o&&p.item,"Group"===o&&p.group,"Category"===o&&p.category,O&&p.disableMouseStates,g),children:[(0,z.jsx)(ip,{onAction:j,disabled:v,children:(0,z.jsx)(op,{expandable:v,disabled:!v,expanded:y,onAction:_,children:t})}),(0,z.jsx)(op,{expandable:v,disabled:!v||!d,expanded:y,onAction:_,children:(0,z.jsx)(cS,{in:v&&y,children:(0,z.jsx)(aS,{styles:dS,children:(0,z.jsx)("div",{className:_d()(p.content,"foldout-expanded"),children:(0,z.jsx)(Ap,{children:h})})})})})]})})},bS=function(e){var t=e.icon,n=e.children,r=(0,Y.useContext)(fS),i=(0,Y.useCallback)((function(){return kp(Lp.hoverItem)}),[]),o=(0,Y.useCallback)((function(){r.expandable?r.onToggleExpanded&&r.onToggleExpanded():r.onSelect&&r.onSelect()}),[r]);return(0,z.jsxs)(Yv,{className:r.theme.header,onMouseEnter:i,onClick:o,children:[(0,z.jsx)("div",{className:r.theme.icon,children:t}),(0,z.jsx)("div",{className:r.theme.headerContent,children:n}),r.expandable&&(0,z.jsx)(tb,{className:r.theme.toggle,src:r.expanded?"Media/Glyphs/ThickStrokeArrowDown.svg":"Media/Glyphs/ThickStrokeArrowRight.svg"})]})};function yS(e){return{"--nesting":e}}oe.add("game-ui/common/foldout/foldout-item.tsx",{get FoldoutItem(){return vS},set FoldoutItem(e){vS=e},get FoldoutItemHeader(){return bS},set FoldoutItemHeader(e){bS=e}});let xS={"foldout-item":"foldout-item_Ha3 foldout-item_wOF",foldoutItem:"foldout-item_Ha3 foldout-item_wOF",header:"header_o7z header_8H_ item-mouse-states_Fmi item-focused_FuT","disable-active-state":"disable-active-state_UBt disable-active-state_w8a",disableActiveState:"disable-active-state_UBt disable-active-state_w8a","disable-mouse-states":"disable-mouse-states_ivb disable-mouse-states_js5",disableMouseStates:"disable-mouse-states_ivb disable-mouse-states_js5","header-content":"header-content_t6v header-content_wUX",headerContent:"header-content_t6v header-content_wUX",icon:"icon_p5g icon_I32",toggle:"toggle_r8A toggle_yQv"};oe.add("game-ui/common/foldout/themes/info-section-foldout.module.scss",{get classes(){return xS},set classes(e){Object.assign(xS,e)}});const _S=xS;var jS=function(e){var t=e.header,n=e.initialExpanded,r=e.expandFromContent,i=e.focusKey,o=e.tooltip,a=e.disableFocus,s=void 0!==a&&a,l=e.className,c=e.onToggleExpanded,u=e.children;return(0,z.jsx)(vS,{header:(0,z.jsx)(jh,{tooltip:o,direction:"right",alignment:"center",children:(0,z.jsx)(bS,{children:t})}),theme:_S,initialExpanded:n,expandFromContent:r,onToggleExpanded:c,className:_d()($E.infoSection,l),children:s?(0,z.jsx)(zv,{className:_d()($E.content,$E.disableFocusHighlight),children:(0,z.jsx)(Ap,{children:u})}):(0,z.jsx)(Yv,{focusKey:i,className:$E.content,children:(0,z.jsx)(Ap,{children:u})})})};oe.add("game-ui/game/components/selected-info-panel/shared-components/info-section/info-section-foldout.tsx",{get InfoSectionFoldout(){return jS},set InfoSectionFoldout(e){jS=e}});let OS={"info-row":"info-row_QQ9 item-focused_FuT",infoRow:"info-row_QQ9 item-focused_FuT","disable-focus-highlight":"disable-focus-highlight_I85",disableFocusHighlight:"disable-focus-highlight_I85",link:"link_ICj",tooltipRow:"tooltipRow_uIh",left:"left_RyE",hasIcon:"hasIcon_iZ3",right:"right_ZUb",icon:"icon_ugE",uppercase:"uppercase_f0y",subRow:"subRow_NJI"};oe.add("game-ui/game/components/selected-info-panel/shared-components/info-row/info-row.module.scss",{get classes(){return OS},set classes(e){Object.assign(OS,e)}});const ES=OS;var SS=function(e){var t=e.icon,n=e.left,r=e.right,i=e.tooltip,o=e.link,a=e.uppercase,s=void 0!==a&&a,l=e.subRow,c=void 0!==l&&l,u=e.disableFocus,d=void 0!==u&&u,f=e.className;return(0,z.jsx)(jh,{tooltip:i,direction:"right",alignment:"center",children:o?(0,z.jsxs)("div",{className:_d()(ES.infoRow,c&&ES.subRow,o&&ES.link,f),children:[t&&(0,z.jsx)("img",{src:t,className:_d()(ES.icon,o&&ES.link)}),n&&(0,z.jsx)("div",{className:_d()(ES.left,s&&ES.uppercase,o&&ES.link,t&&ES.hasIcon),children:n}),o&&(0,z.jsx)(Yv,{className:_d()(ES.right,o&&ES.link),children:o}),r&&(0,z.jsx)("div",{className:_d()(ES.right,o&&ES.link),children:r})]}):d?(0,z.jsxs)(zv,{className:_d()(ES.infoRow,c&&ES.subRow,ES.disableFocusHighlight,f),children:[t&&(0,z.jsx)("img",{src:t,className:ES.icon}),n&&(0,z.jsx)("div",{className:_d()(ES.left,s&&ES.uppercase),children:n}),r&&(0,z.jsx)("div",{className:_d()(ES.right),children:r})]}):(0,z.jsxs)(Yv,{focusKey:d?Hh:Kh,className:_d()(ES.infoRow,c&&ES.subRow,f),children:[t&&(0,z.jsx)("img",{src:t,className:ES.icon}),n&&(0,z.jsx)("div",{className:_d()(ES.left,s&&ES.uppercase),children:n}),r&&(0,z.jsx)("div",{className:_d()(ES.right),children:r})]})})},TS=function(e){var t=e.icon,n=e.left,r=e.right,i=e.uppercase,o=void 0!==i&&i,a=e.subRow,s=void 0!==a&&a;return(0,z.jsxs)("div",{className:_d()(ES.infoRow,ES.tooltipRow,s&&ES.subRow),children:[t&&(0,z.jsx)("img",{src:t,className:_d()(ES.icon)}),n&&(0,z.jsx)("div",{className:_d()(ES.left,o&&ES.uppercase,t&&ES.hasIcon),children:n}),r&&(0,z.jsx)("div",{className:_d()(ES.right),children:r})]})};function IS(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function wS(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function PS(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}oe.add("game-ui/game/components/selected-info-panel/shared-components/info-row/info-row.tsx",{get InfoRow(){return SS},set InfoRow(e){SS=e},get TooltipRow(){return TS},set TooltipRow(e){TS=e}});var CS=function(e){var t=e.children,n=e.draggable,r=e.header,i=PS(e,["children","draggable","header"]),o=n?zE:qj,a=r||n?(0,z.jsx)(tO,{children:r||" "}):null;return(0,z.jsx)(o,wS(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){IS(e,t,n[t])}))}return e}({header:a},i),{children:(0,z.jsx)(Ap,{children:(0,z.jsx)(gE,{children:t})})}))};oe.add("game-ui/ui/panel.tsx",{get Panel(){return CS},set Panel(e){CS=e}});let NS={icon:"icon_VQU",iconImg:"iconImg_ThV"};oe.add("game-ui/ui/icon.module.scss",{get classes(){return NS},set classes(e){Object.assign(NS,e)}});const AS=NS;var LS=function(e){var t=e.tinted,n=e.className,r=e.src;return(0,z.jsx)("div",{className:_d()(n,AS.icon),children:t?(0,z.jsx)(tb,{src:r,className:AS.iconImg}):(0,z.jsx)("img",{src:r,className:_d()(AS.iconImg)})})};oe.add("game-ui/ui/icon.tsx",{get Icon(){return LS},set Icon(e){LS=e}});var MS=tm;MS.usePortalContainer=nm,MS.ContainerProvider=em,oe.add("game-ui/ui/portal.tsx",{get Portal(){return MS},set Portal(e){MS=e}});var kS=/^(#+)\s+/,RS=/\s/;function DS(){return(0,Y.useMemo)((function(){return new FS}),[])}var FS=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return e.prototype.render=function(e){var t=[];e=e.replace(/<br>/gim,"␤");var n=Ev.None,r=new Array,i=0,o=kS.exec(e);null!=o&&(n=of(o[1].length,1,6),i=o[0].length);for(var a=-1,s=-1,l=-1,c=-1,u=0;u<e.length;u++)switch(e[u]){case"␤":e=e.substring(0,u)+" "+e.substring(u+1),t.push((0,z.jsx)("br",{},u));break;case"!":u<e.length-1&&-1===s&&(a=u);break;case"[":s=u,l=-1,c=-1;break;case"]":-1!==s&&-1===l?l=u:a=-1;break;case"(":-1!==s&&-1!==l&&-1===c&&(l===u-1?c=u:(a=-1,s=-1,l=-1));break;case")":if(-1!==c){if(-1===a){i<s&&t.push(US(e,i,s,null));var d=US(e,s+1,l,u<e.length-1&&RS.test(e[u+1])?e[u+1]:null),f=e.substring(c+1,u);t.push((0,z.jsx)(Pv,{linkData:f,children:d},s))}else{var m=e.substring(s+1,l),g=e.substring(c+1,u);t.push((0,z.jsx)("img",{alt:m,src:g},a)),r.push(g)}i=u+1,a=-1,s=-1,l=-1,c=-1}break;default:-1!==a&&-1===s&&(a=-1)}return i<e.length&&t.push(US(e,i,e.length,null)),[t,n,r]},e}();function US(e,t,n,r){for(var i=[],o=t,a=!1,s=-1,l=t;l<n;l++)if("*"===e[l])if(a)if(-1===s)s=l-1,a=!1;else{o<s&&i.push(e.substring(o,s));var c=e.substring(s+2,l-1);l<n-1?RS.test(e[l+1])&&(c+=e[l+1]):null!=r&&(c+=r),i.push((0,z.jsx)("b",{children:c},s)),o=l+1,s=-1,a=!1}else a=!0;else a=!1;if(o<n){var u=e.substring(o,n);null!=r&&(u+=r),i.push(u)}return i}oe.add("game-ui/common/text/renderers/markdown-renderer.tsx",{get useMarkdownRenderer(){return DS},set useMarkdownRenderer(e){DS=e},get MarkdownRenderer(){return FS},set MarkdownRenderer(e){FS=e}}),oe.add("game-ui/ui/index.ts",{}),oe.add("game-ui/game/data-binding/budget-panel-types.ts",{});var GS="camera",BS=fl(GS,"focusedEntity");function VS(e){bl(GS,"focusEntity",e)}oe.add("game-ui/game/data-binding/camera-bindings.ts",{get focusedEntity(){return focusedEntity},set focusedEntity(e){focusedEntity=e},get focusEntity(){return VS},set focusEntity(e){VS=e}});var HS="chirper",KS=fl(HS,"chirps"),WS=hl(HS,"chirpAdded");function zS(e){bl(HS,"addLike",e)}function YS(e){bl(HS,"removeLike",e)}function $S(e){bl(HS,"selectLink",e)}function qS(e,t,n,r,i,o,a){try{var s=e[o](a),l=s.value}catch(e){return void n(e)}s.done?t(l):Promise.resolve(l).then(r,i)}function XS(e){return function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){qS(o,r,i,a,s,"next",e)}function s(e){qS(o,r,i,a,s,"throw",e)}a(void 0)}))}}oe.add("game-ui/game/data-binding/chirper-bindings.ts",{get chirps(){return chirps},set chirps(e){chirps=e},get chirpAdded(){return chirpAdded},set chirpAdded(e){chirpAdded=e},get addLike(){return zS},set addLike(e){zS=e},get removeLike(){return YS},set removeLike(e){YS=e},get selectLink(){return $S},set selectLink(e){$S=e}});var QS=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}},ZS="cinematicCamera",JS=fl(ZS,"playbackDuration"),eT=fl(ZS,"timelinePosition"),tT=fl(ZS,"timelineLength"),nT=fl(ZS,"loop"),rT=vl(ZS,"toggleLoop"),iT=fl(ZS,"playing"),oT=function(e){return bl(ZS,"setPlaybackDuration",e)},aT=pl(ZS,"onAfterPlaybackDurationChange"),sT=function(e){return bl(ZS,"setTimelinePosition",e)},lT=function(){return bl(ZS,"stopPlayback")},cT=function(){return bl(ZS,"togglePlayback")},uT=function(e,t){return bl(ZS,"captureKey",e,t)},dT=function(e,t){return bl(ZS,"removeCameraTransformKey",e,t)},fT=function(e,t,n,r){return yl(ZS,"moveKeyFrame",e,t,n,r)},mT=function(e,t,n){return bl(ZS,"removeKeyFrame",e,t,n)},gT=function(e,t,n,r){return yl(ZS,"addKeyFrame",e,t,n,r)},hT=function(){return bl(ZS,"reset")},pT=function(){return yl(ZS,"getControllerDelta")},vT=function(){return yl(ZS,"getControllerZoomDelta")},bT=function(){return yl(ZS,"getControllerPanDelta")},yT=function(e){return bl(ZS,"toggleCurveEditorFocus",e)},xT=vl(ZS,"save"),_T=vl(ZS,"load"),jT=vl(ZS,"delete"),OT=fl(ZS,"lastLoaded"),ET=fl(ZS,"assets"),ST=fl(ZS,"availableCloudTargets"),TT=fl(ZS,"selectedCloudTarget"),IT=vl(ZS,"selectCloudTarget"),wT=fl(ZS,"transformAnimationCurves"),PT=fl(ZS,"modifierAnimationCurves"),CT=function(e,t){return(0,Y.useMemo)((function(){return{onAddKeyframe:(n=XS((function(n,r,i){return QS(this,(function(o){switch(o.label){case 0:return void 0===i||-1===i?[3,2]:[4,gT(e,n,r,null!=t?t:i)];case 1:return[2,o.sent()];case 2:return[2,-1]}}))})),function(e,t,r){return n.apply(this,arguments)}),onMoveKeyframe:function(){var n=XS((function(n,r,i,o){return QS(this,(function(i){switch(i.label){case 0:return null==o?[3,2]:[4,fT(e,null!=t?t:o,n,r)];case 1:return[2,i.sent()];case 2:return[2,-1]}}))}));return function(e,t,r,i){return n.apply(this,arguments)}}(),onRemoveKeyframe:function(n,r){null!=r&&mT(e,null!=t?t:r,n)},onSetKeyframes:function(e,t){throw new Error("Function not implemented.")}};var n}),[t,e])};oe.add("game-ui/game/data-binding/cinematic-camera-bindings.ts",{get group(){return ZS},set group(e){ZS=e},get playbackDuration(){return playbackDuration},set playbackDuration(e){playbackDuration=e},get timelinePosition(){return timelinePosition},set timelinePosition(e){timelinePosition=e},get timelineLength(){return timelineLength},set timelineLength(e){timelineLength=e},get loop(){return loop},set loop(e){loop=e},get toggleLoop(){return rT},set toggleLoop(e){rT=e},get playing(){return playing},set playing(e){playing=e},get setPlaybackDuration(){return oT},set setPlaybackDuration(e){oT=e},get onAfterPlaybackDurationChange(){return aT},set onAfterPlaybackDurationChange(e){aT=e},get setTimelinePosition(){return sT},set setTimelinePosition(e){sT=e},get stopPlayback(){return lT},set stopPlayback(e){lT=e},get togglePlayback(){return cT},set togglePlayback(e){cT=e},get captureKey(){return uT},set captureKey(e){uT=e},get removeCameraTransformKey(){return dT},set removeCameraTransformKey(e){dT=e},get moveKeyFrame(){return fT},set moveKeyFrame(e){fT=e},get removeKeyFrame(){return mT},set removeKeyFrame(e){mT=e},get addKeyFrame(){return gT},set addKeyFrame(e){gT=e},get resetCinematicCameraSequence(){return hT},set resetCinematicCameraSequence(e){hT=e},get getControllerDelta(){return pT},set getControllerDelta(e){pT=e},get getControllerZoomDelta(){return vT},set getControllerZoomDelta(e){vT=e},get getControllerPanDelta(){return bT},set getControllerPanDelta(e){bT=e},get toggleCurveEditorFocus(){return yT},set toggleCurveEditorFocus(e){yT=e},get saveCinematicCameraSequence(){return xT},set saveCinematicCameraSequence(e){xT=e},get loadCinematicCameraSequence(){return _T},set loadCinematicCameraSequence(e){_T=e},get deleteCinematicCameraSequence(){return jT},set deleteCinematicCameraSequence(e){jT=e},get lastLoadedCinematicCameraSequence(){return lastLoadedCinematicCameraSequence},set lastLoadedCinematicCameraSequence(e){lastLoadedCinematicCameraSequence=e},get cinematicCameraSequenceAssets(){return cinematicCameraSequenceAssets},set cinematicCameraSequenceAssets(e){cinematicCameraSequenceAssets=e},get availableCloudTargets(){return availableCloudTargets},set availableCloudTargets(e){availableCloudTargets=e},get selectedCloudTarget(){return selectedCloudTarget},set selectedCloudTarget(e){selectedCloudTarget=e},get selectCloudTarget(){return IT},set selectCloudTarget(e){IT=e},get transformAnimationCurveData(){return transformAnimationCurveData},set transformAnimationCurveData(e){transformAnimationCurveData=e},get modifierAnimationCurveData(){return modifierAnimationCurveData},set modifierAnimationCurveData(e){modifierAnimationCurveData=e},get useCinematicCameraBindings(){return CT},set useCinematicCameraBindings(e){CT=e}});var NT="cityInfo",AT=fl(NT,"residentialLowDemand"),LT=fl(NT,"residentialMediumDemand"),MT=fl(NT,"residentialHighDemand"),kT=fl(NT,"commercialDemand"),RT=fl(NT,"industrialDemand"),DT=fl(NT,"officeDemand"),FT=fl(NT,"residentialLowFactors"),UT=fl(NT,"residentialMediumFactors"),GT=fl(NT,"residentialHighFactors"),BT=fl(NT,"commercialFactors"),VT=fl(NT,"industrialFactors"),HT=fl(NT,"officeFactors"),KT=fl(NT,"happiness"),WT=fl(NT,"happinessFactors");oe.add("game-ui/game/data-binding/city-info-bindings.ts",{get residentialLowDemand(){return residentialLowDemand},set residentialLowDemand(e){residentialLowDemand=e},get residentialMediumDemand(){return residentialMediumDemand},set residentialMediumDemand(e){residentialMediumDemand=e},get residentialHighDemand(){return residentialHighDemand},set residentialHighDemand(e){residentialHighDemand=e},get commercialDemand(){return commercialDemand},set commercialDemand(e){commercialDemand=e},get industrialDemand(){return industrialDemand},set industrialDemand(e){industrialDemand=e},get officeDemand(){return officeDemand},set officeDemand(e){officeDemand=e},get residentialLowFactors(){return residentialLowFactors},set residentialLowFactors(e){residentialLowFactors=e},get residentialMediumFactors(){return residentialMediumFactors},set residentialMediumFactors(e){residentialMediumFactors=e},get residentialHighFactors(){return residentialHighFactors},set residentialHighFactors(e){residentialHighFactors=e},get commercialFactors(){return commercialFactors},set commercialFactors(e){commercialFactors=e},get industrialFactors(){return industrialFactors},set industrialFactors(e){industrialFactors=e},get officeFactors(){return officeFactors},set officeFactors(e){officeFactors=e},get happiness(){return happiness},set happiness(e){happiness=e},get happinessFactors(){return happinessFactors},set happinessFactors(e){happinessFactors=e}});var zT,YT="climate",$T=fl(YT,"seasonNameId"),qT=fl(YT,"weather"),XT=fl(YT,"temperature");!function(e){e[e.Clear=0]="Clear",e[e.Few=1]="Few",e[e.Scattered=2]="Scattered",e[e.Broken=3]="Broken",e[e.Overcast=4]="Overcast",e[e.Rain=5]="Rain",e[e.Snow=6]="Snow",e[e.Hail=7]="Hail",e[e.Storm=8]="Storm"}(zT||(zT={})),oe.add("game-ui/game/data-binding/climate-bindings.ts",{get seasonNameId(){return seasonNameId},set seasonNameId(e){seasonNameId=e},get weather(){return weather},set weather(e){weather=e},get temperature(){return temperature},set temperature(e){temperature=e},get WeatherType(){return zT},set WeatherType(e){zT=e}});var QT="budget",ZT=fl(QT,"totalIncome"),JT=fl(QT,"totalExpenses"),eI=fl(QT,"incomeItems"),tI=fl(QT,"incomeValues"),nI=fl(QT,"expenseItems"),rI=fl(QT,"expenseValues");function iI(e,t){return e.sources.reduce((function(e,n){return e+t[n.index]}),0)}oe.add("game-ui/game/data-binding/economy/budget-bindings.ts",{get totalIncome(){return totalIncome},set totalIncome(e){totalIncome=e},get totalExpenses(){return totalExpenses},set totalExpenses(e){totalExpenses=e},get incomeItems(){return incomeItems},set incomeItems(e){incomeItems=e},get incomeValues(){return incomeValues},set incomeValues(e){incomeValues=e},get expenseItems(){return expenseItems},set expenseItems(e){expenseItems=e},get expenseValues(){return expenseValues},set expenseValues(e){expenseValues=e},get getItemValue(){return iI},set getItemValue(e){iI=e}});var oI="loan",aI=fl(oI,"loanLimit"),sI=fl(oI,"currentLoan"),lI=fl(oI,"loanOffer");function cI(e){bl(oI,"requestLoanOffer",e)}function uI(){bl(oI,"acceptLoanOffer")}function dI(){bl(oI,"resetLoanOffer")}oe.add("game-ui/game/data-binding/economy/loan-bindings.ts",{get loanLimit(){return loanLimit},set loanLimit(e){loanLimit=e},get currentLoan(){return currentLoan},set currentLoan(e){currentLoan=e},get loanOffer(){return loanOffer},set loanOffer(e){loanOffer=e},get requestLoanOffer(){return cI},set requestLoanOffer(e){cI=e},get acceptLoanOffer(){return uI},set acceptLoanOffer(e){uI=e},get resetLoanOffer(){return dI},set resetLoanOffer(e){dI=e}});var fI="production",mI=fl(fI,"maxProgress"),gI=fl(fI,"resourceCategories"),hI=gl(fI,"resourceDetails"),pI=gl(fI,"resources"),vI=gl(fI,"services"),bI=gl(fI,"data");oe.add("game-ui/game/data-binding/economy/production-bindings.ts",{get maxProgress(){return maxProgress},set maxProgress(e){maxProgress=e},get resourceCategories(){return resourceCategories},set resourceCategories(e){resourceCategories=e},get resourceDetails(){return resourceDetails},set resourceDetails(e){resourceDetails=e},get resources(){return resources},set resources(e){resources=e},get services(){return services},set services(e){services=e},get resourceData(){return resourceData},set resourceData(e){resourceData=e}});var yI="serviceBudget",xI=fl(yI,"services"),_I=gl(yI,"serviceDetails");function jI(e,t){bl(yI,"setServiceBudget",e,t)}function OI(e,t){bl(yI,"setServiceFee",e,t)}function EI(e){bl(yI,"resetService",e)}oe.add("game-ui/game/data-binding/economy/service-budget-bindings.ts",{get services(){return services},set services(e){services=e},get serviceDetails(){return serviceDetails},set serviceDetails(e){serviceDetails=e},get setServiceBudget(){return jI},set setServiceBudget(e){jI=e},get setServiceFee(){return OI},set setServiceFee(e){OI=e},get resetService(){return EI},set resetService(e){EI=e}});var SI="eventJournal",TI=gl(SI,"eventMap"),II=fl(SI,"events");function wI(){bl(SI,"openJournal")}function PI(){bl(SI,"closeJournal")}oe.add("game-ui/game/data-binding/event-journal-bindings.ts",{get eventMap(){return eventMap},set eventMap(e){eventMap=e},get events(){return events},set events(e){events=e},get onOpenJournal(){return wI},set onOpenJournal(e){wI=e},get onCloseJournal(){return PI},set onCloseJournal(e){PI=e}}),oe.add("game-ui/game/data-binding/infoview-types.ts",{});var CI,NI="lifePath";!function(e){e.Chirp="chirper.Chirp",e.LogEntry="lifePath.LifePathEvent"}(CI||(CI={}));var AI=fl(NI,"followedCitizens"),LI=gl(NI,"lifePathDetails"),MI=gl(NI,"lifePathItems"),kI=fl(NI,"maxFollowedCitizens");function RI(e){bl(NI,"followCitizen",e)}function DI(e){bl(NI,"unfollowCitizen",e)}oe.add("game-ui/game/data-binding/life-path-bindings.ts",{get LifePathItemType(){return CI},set LifePathItemType(e){CI=e},get followedCitizens(){return followedCitizens},set followedCitizens(e){followedCitizens=e},get lifePathDetails(){return lifePathDetails},set lifePathDetails(e){lifePathDetails=e},get lifePathItems(){return lifePathItems},set lifePathItems(e){lifePathItems=e},get maxFollowedCitizens(){return maxFollowedCitizens},set maxFollowedCitizens(e){maxFollowedCitizens=e},get followCitizen(){return RI},set followCitizen(e){RI=e},get unfollowCitizen(){return DI},set unfollowCitizen(e){DI=e}});var FI,UI="mapTiles",GI=fl(UI,"mapTileSelectionEnabled"),BI=fl(UI,"buildableLand"),VI=fl(UI,"water"),HI=fl(UI,"resources"),KI=fl(UI,"purchasePrice"),WI=fl(UI,"purchaseFlags"),zI=fl(UI,"expansionPermits"),YI=fl(UI,"expansionPermitCost");function $I(e){bl(UI,"setMapTileSelectionEnabled",e)}function qI(){$I(!1)}function XI(){bl(UI,"purchaseMapTiles")}!function(e){e[e.None=0]="None",e[e.NoSelection=1]="NoSelection",e[e.InsufficientFunds=2]="InsufficientFunds",e[e.InsufficientPermits=4]="InsufficientPermits"}(FI||(FI={})),oe.add("game-ui/game/data-binding/map-tile-bindings.ts",{get mapTileSelectionEnabled(){return mapTileSelectionEnabled},set mapTileSelectionEnabled(e){mapTileSelectionEnabled=e},get buildableLand(){return buildableLand},set buildableLand(e){buildableLand=e},get availableWater(){return availableWater},set availableWater(e){availableWater=e},get resources(){return resources},set resources(e){resources=e},get purchasePrice(){return purchasePrice},set purchasePrice(e){purchasePrice=e},get purchaseFlags(){return purchaseFlags},set purchaseFlags(e){purchaseFlags=e},get permits(){return permits},set permits(e){permits=e},get permitCost(){return permitCost},set permitCost(e){permitCost=e},get setMapTileSelectionEnabled(){return $I},set setMapTileSelectionEnabled(e){$I=e},get disableMapTileSelection(){return qI},set disableMapTileSelection(e){qI=e},get purchaseMapTiles(){return XI},set purchaseMapTiles(e){XI=e},get MapTileStatus(){return FI},set MapTileStatus(e){FI=e}});var QI="photoMode";function ZI(){bl(QI,"resetCamera")}var JI=fl(QI,"overlayHidden");function ew(e){bl(QI,"setOverlayHidden",e)}var tw=fl(QI,"orbitCameraActive");function nw(){bl(QI,"toggleOrbitCameraActive")}function rw(){bl(QI,"takeScreenshot")}function iw(e){bl(QI,"selectTab",e)}function ow(e){bl(QI,"setCinematicCameraVisible",e)}var aw,sw=fl(QI,"cinematicCameraVisible"),lw=fl(QI,"tabs"),cw=fl(QI,"activeTab");!function(e){e.DropdownField="Game.UI.Widgets.DropdownField"}(aw||(aw={}));var uw={group:QI,path:[]},dw=fl(QI,"children");oe.add("game-ui/game/data-binding/photo-mode-bindings.ts",{get group(){return QI},set group(e){QI=e},get resetCamera(){return ZI},set resetCamera(e){ZI=e},get overlayHidden(){return overlayHidden},set overlayHidden(e){overlayHidden=e},get setOverlayHidden(){return ew},set setOverlayHidden(e){ew=e},get orbitCameraActive(){return orbitCameraActive},set orbitCameraActive(e){orbitCameraActive=e},get toggleOrbitCameraActive(){return nw},set toggleOrbitCameraActive(e){nw=e},get takeScreenshot(){return rw},set takeScreenshot(e){rw=e},get selectTab(){return iw},set selectTab(e){iw=e},get toggleCinematicCamera(){return ow},set toggleCinematicCamera(e){ow=e},get cinematicCameraVisible(){return cinematicCameraVisible},set cinematicCameraVisible(e){cinematicCameraVisible=e},get tabs(){return tabs},set tabs(e){tabs=e},get selectedTab(){return selectedTab},set selectedTab(e){selectedTab=e},get PhotoWidgetType(){return aw},set PhotoWidgetType(e){aw=e},get root(){return uw},set root(e){uw=e},get adjustments(){return adjustments},set adjustments(e){adjustments=e}});var fw="policies",mw=fl(fw,"cityPolicies"),gw=vl(fw,"setCityPolicy");function hw(e,t){gw(e,t,arguments.length>2&&void 0!==arguments[2]?arguments[2]:0)}var pw=vl(fw,"setPolicy");function vw(e,t){pw(e,t,arguments.length>2&&void 0!==arguments[2]?arguments[2]:0)}oe.add("game-ui/game/data-binding/policy-bindings.ts",{get cityPolicies(){return cityPolicies},set cityPolicies(e){cityPolicies=e},get setCityPolicy(){return hw},set setCityPolicy(e){hw=e},get setPolicy(){return vw},set setPolicy(e){vw=e}});var bw,yw,xw,_w="prefabs",jw=fl(_w,"themes"),Ow=gl(_w,"prefabDetails"),Ew=fl(_w,"manualUITags"),Sw={entity:ty,name:"",uiTag:"",icon:"Media/Placeholder.svg",dlc:null,preview:null,titleId:"",descriptionId:null,locked:!1,uniquePlaced:!1,constructionCost:null,effects:[],properties:[],requirements:{requireAny:[],requireAll:[]}};oe.add("game-ui/game/data-binding/prefab/prefab-bindings.ts",{get themes(){return themes},set themes(e){themes=e},get prefabDetails(){return prefabDetails},set prefabDetails(e){prefabDetails=e},get manualUITags(){return manualUITags},set manualUITags(e){manualUITags=e},get emptyPrefabDetails(){return Sw},set emptyPrefabDetails(e){Sw=e}}),function(e){e.CityModifier="prefabs.CityModifierEffect",e.LocalModifier="prefabs.LocalModifierEffect",e.LeisureProvider="prefabs.LeisureProviderEffect",e.AdjustHappinessEffect="prefabs.AdjustHappinessEffect"}(bw||(bw={})),function(e){e.Attractiveness="Attractiveness",e.CrimeAccumulation="CrimeAccumulation",e.PoliceStationUpkeep="PoliceStationUpkeep",e.DisasterWarningTime="DisasterWarningTime",e.DisasterDamageRate="DisasterDamageRate",e.DiseaseProbability="DiseaseProbability",e.ParkEntertainment="ParkEntertainment",e.CriminalMonitorProbability="CriminalMonitorProbability",e.IndustrialAirPollution="IndustrialAirPollution",e.IndustrialGroundPollution="IndustrialGroundPollution",e.IndustrialGarbage="IndustrialGarbage",e.RecoveryFailChange="RecoveryFailChange",e.OreResourceAmount="OreResourceAmount",e.OilResourceAmount="OilResourceAmount",e.UniversityInterest="UniversityInterest",e.OfficeSoftwareDemand="OfficeSoftwareDemand",e.IndustrialElectronicsDemand="IndustrialElectronicsDemand",e.OfficeSoftwareEfficiency="OfficeSoftwareEfficiency",e.IndustrialElectronicsEfficiency="IndustrialElectronicsEfficiency",e.TelecomCapacity="TelecomCapacity",e.Entertainment="Entertainment",e.HighwayTrafficSafety="HighwayTrafficSafety",e.PrisonTime="PrisonTime",e.CrimeProbability="CrimeProbability",e.CollegeGraduation="CollegeGraduation",e.UniversityGraduation="UniversityGraduation",e.ImportCost="ImportCost",e.LoanInterest="LoanInterest",e.BuildingLevelingCost="BuildingLevelingCost",e.ExportCost="ExportCost",e.TaxiStartingFee="TaxiStartingFee",e.IndustrialEfficiency="IndustrialEfficiency",e.OfficeEfficiency="OfficeEfficiency",e.PollutionHealthAffect="PollutionHealthAffect",e.HospitalEfficiency="HospitalEfficiency"}(yw||(yw={})),function(e){e.CrimeAccumulation="CrimeAccumulation",e.ForestFireResponseTime="ForestFireResponseTime",e.ForestFireHazard="ForestFireHazard",e.Wellbeing="Wellbeing",e.Health="Health"}(xw||(xw={})),oe.add("game-ui/game/data-binding/prefab/prefab-effects.ts",{get PrefabEffectType(){return bw},set PrefabEffectType(e){bw=e},get CityModifierType(){return yw},set CityModifierType(e){yw=e},get LocalModifierType(){return xw},set LocalModifierType(e){xw=e}});var Tw,Iw="prefabs.ConsumptionProperty",ww="prefabs.PollutionProperty";!function(e){e[e.none=0]="none",e[e.low=1]="low",e[e.medium=2]="medium",e[e.high=3]="high"}(Tw||(Tw={}));var Pw,Cw="prefabs.ElectricityProperty";!function(e){e[e.low=0]="low",e[e.high=1]="high",e[e.both=2]="both"}(Pw||(Pw={}));var Nw,Aw,Lw="prefabs.TransportStopProperty";oe.add("game-ui/game/data-binding/prefab/prefab-properties.ts",{get CONSUMPTION_PROPERTY(){return Iw},set CONSUMPTION_PROPERTY(e){Iw=e},get POLLUTION_PROPERTY(){return ww},set POLLUTION_PROPERTY(e){ww=e},get Pollution(){return Tw},set Pollution(e){Tw=e},get ELECTRICITY_PROPERTY(){return Cw},set ELECTRICITY_PROPERTY(e){Cw=e},get Voltage(){return Pw},set Voltage(e){Pw=e},get TRANSPORT_STOP_PROPERTY(){return Lw},set TRANSPORT_STOP_PROPERTY(e){Lw=e}}),function(e){e[e.none=0]="none",e[e.residential=1]="residential",e[e.commercial=2]="commercial",e[e.industrial=3]="industrial"}(Nw||(Nw={})),function(e){e.Milestone="prefabs.MilestoneRequirement",e.DevTreeNode="prefabs.DevTreeNodeRequirement",e.StrictObjectBuilt="prefabs.StrictObjectBuiltRequirement",e.ZoneBuilt="prefabs.ZoneBuiltRequirement",e.Citizen="prefabs.CitizenRequirement",e.Processing="prefabs.ProcessingRequirement",e.ObjectBuilt="prefabs.ObjectBuiltRequirement",e.Unlock="prefabs.UnlockRequirement",e.Tutorial="prefabs.TutorialRequirement"}(Aw||(Aw={})),oe.add("game-ui/game/data-binding/prefab/prefab-requirements.ts",{get AreaType(){return Nw},set AreaType(e){Nw=e},get PrefabRequirementType(){return Aw},set PrefabRequirementType(e){Aw=e}});var Mw="devTree",kw=fl(Mw,"points"),Rw=fl(Mw,"services"),Dw=gl(Mw,"serviceDetails"),Fw=gl(Mw,"nodes"),Uw=gl(Mw,"nodeDetails"),Gw=ml(ty),Bw=ml(ty);function Vw(e){bl(Mw,"purchaseNode",e)}oe.add("game-ui/game/data-binding/progression/dev-tree-bindings.ts",{get devPoints(){return devPoints},set devPoints(e){devPoints=e},get services(){return services},set services(e){services=e},get serviceDetails(){return serviceDetails},set serviceDetails(e){serviceDetails=e},get nodes(){return nodes},set nodes(e){nodes=e},get nodeDetails(){return nodeDetails},set nodeDetails(e){nodeDetails=e},get selectedDevTree(){return selectedDevTree},set selectedDevTree(e){selectedDevTree=e},get selectedNode(){return selectedNode},set selectedNode(e){selectedNode=e},get purchaseNode(){return Vw},set purchaseNode(e){Vw=e}});var Hw=fl("feature","lockedFeatures");function Kw(e){var t=(0,Y.useCallback)((function(t,n){var r;return{locked:void 0!==n.find((function(t){return t.name===e})),requirements:(null===(r=n.find((function(t){return t.name===e})))||void 0===r?void 0:r.requirements)||{requireAny:[],requireAll:[]}}}),[e]),n=_l(Hw,t,{locked:!1,requirements:{requireAny:[],requireAll:[]}});return{locked:n.locked,requirements:n.requirements}}function Ww(e){var t=(0,Y.useCallback)((function(t,n){return void 0!==n.find((function(t){return t.name===e}))}),[e]);return _l(Hw,t,!1)}function zw(e){var t;return void 0!==(null===(t=Hw.value)||void 0===t?void 0:t.find((function(t){return t.name===e})))}function Yw(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function $w(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}oe.add("game-ui/game/data-binding/progression/feature-bindings.ts",{get lockedFeatures(){return lockedFeatures},set lockedFeatures(e){lockedFeatures=e},get useFeatureUnlocking(){return Kw},set useFeatureUnlocking(e){Kw=e},get useFeatureLocked(){return Ww},set useFeatureLocked(e){Ww=e},get isFeatureLocked(){return zw},set isFeatureLocked(e){zw=e}});var qw={r:0,g:0,b:0,a:1},Xw={r:1,g:1,b:1,a:1},Qw={r:0,g:0,b:0,a:0};function Zw(e,t,n){return{r:e/255,g:t/255,b:n/255,a:1}}function Jw(e,t,n,r){return{r:e/255,g:t/255,b:n/255,a:r}}function eP(e,t){return Math.abs(e.r-t.r)<.001&&Math.abs(e.g-t.g)<.001&&Math.abs(e.b-t.b)<.001&&Math.abs(e.a-t.a)<.001}function tP(e){var t=e.r,n=e.g,r=e.b;return Math.max(t,n,r)===Math.min(t,n,r)}function nP(e,t){return $w(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Yw(e,t,n[t])}))}return e}({},e),{a:t})}function rP(e){var t=e.r,n=e.g,r=e.b,i=e.a;return"rgba(".concat(Math.round(255*t),",").concat(Math.round(255*n),",").concat(Math.round(255*r),",").concat(i.toString().replace(",","."),")")}function iP(e){if(null==e)return null;var t=e.match(/^rgba\((\d+),\s*(\d+),\s*(\d+),\s*(\d+(?:\.\d+)?)\)$/);return t&&5===t.length?{r:of(parseInt(t[1])/255,0,1),g:of(parseInt(t[2])/255,0,1),b:of(parseInt(t[3])/255,0,1),a:of(parseFloat(t[4]),0,1)}:null}function oP(e){var t=e.r,n=e.g,r=e.b;return aP(t)+aP(n)+aP(r)}function aP(e){var t=Math.round(255*e).toString(16).toUpperCase();return 1===t.length?"0"+t:t}function sP(e){e=e.replace(/^#?([a-f\d])([a-f\d])([a-f\d])$/i,(function(e,t,n,r){return t+t+n+n+r+r}));var t=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})?$/i.exec(e);if(!t)return null;var n=t.length>3&&parseInt(t[4],16)?parseInt(t[4],16)/255:1;return{r:parseInt(t[1],16)/255,g:parseInt(t[2],16)/255,b:parseInt(t[3],16)/255,a:n}}function lP(e){var t=e.h,n=e.s,r=e.v,i=e.a,o=0,a=0,s=0,l=Math.floor(6*t),c=6*t-l,u=r*(1-n),d=r*(1-c*n),f=r*(1-(1-c)*n);switch(l%6){case 0:o=r,a=f,s=u;break;case 1:o=d,a=r,s=u;break;case 2:o=u,a=r,s=f;break;case 3:o=u,a=d,s=r;break;case 4:o=f,a=u,s=r;break;case 5:o=r,a=u,s=d}return{r:o,g:a,b:s,a:i}}function cP(e){var t=e.r,n=e.g,r=e.b,i=e.a,o=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,a=Math.max(t,n,r),s=Math.min(t,n,r),l=a-s,c=o,u=0===a?0:l/a,d=a;if(a!==s){switch(a){case t:c=(n-r)/l+(n<r?6:0);break;case n:c=(r-t)/l+2;break;case r:c=(t-n)/l+4}c/=6}return{h:c,s:u,v:d,a:i}}function uP(e,t,n){return{r:af(e.r,t.r,n),g:af(e.g,t.g,n),b:af(e.b,t.b,n),a:af(e.a,t.a,n)}}function dP(e,t,n){return{h:af(e.h,t.h,n),s:af(e.s,t.s,n),v:af(e.v,t.v,n),a:af(e.a,t.a,n)}}function fP(e){return"linear-gradient(".concat(arguments.length>1&&void 0!==arguments[1]?arguments[1]:"to right",", ").concat(e.stops.map((function(e){return"".concat("string"==typeof e.color?e.color:rP(e.color)," ").concat(100*e.offset,"%")})).join(","),")")}oe.add("game-ui/common/color.ts",{get black(){return qw},set black(e){qw=e},get white(){return Xw},set white(e){Xw=e},get transparent(){return Qw},set transparent(e){Qw=e},get rgb(){return Zw},set rgb(e){Zw=e},get rgba(){return Jw},set rgba(e){Jw=e},get isColorEqual(){return eP},set isColorEqual(e){eP=e},get isAchromatic(){return tP},set isAchromatic(e){tP=e},get withAlpha(){return nP},set withAlpha(e){nP=e},get formatColor(){return rP},set formatColor(e){rP=e},get parseRgba(){return iP},set parseRgba(e){iP=e},get formatHexColor(){return oP},set formatHexColor(e){oP=e},get parseHexColor(){return sP},set parseHexColor(e){sP=e},get hsvaToRgba(){return lP},set hsvaToRgba(e){lP=e},get rgbaToHsva(){return cP},set rgbaToHsva(e){cP=e},get lerpColor(){return uP},set lerpColor(e){uP=e},get lerpHsva(){return dP},set lerpHsva(e){dP=e},get buildCssLinearGradient(){return fP},set buildCssLinearGradient(e){fP=e}});var mP,gP="milestone",hP={entity:ty,index:0,xpRequirement:0,reward:0,devTreePoints:0,mapTiles:0,loanLimit:0,image:"Media/Placeholder.svg",backgroundColor:Qw,accentColor:{r:.18,g:.235,b:.337,a:1},textColor:Xw,locked:!1};!function(e){e.Feature="milestone.Feature",e.Service="milestone.Service",e.Zone="milestone.Asset",e.Policy="milestone.Policy"}(mP||(mP={}));var pP=fl(gP,"achievedMilestone"),vP=fl(gP,"achievedMilestoneXP"),bP=fl(gP,"nextMilestoneXP"),yP=fl(gP,"totalXP"),xP=hl(gP,"xpMessageAdded"),_P=fl(gP,"maxMilestoneReached"),jP=fl(gP,"milestones"),OP=fl(gP,"unlockedMilestone",ty);function EP(){bl(gP,"clearUnlockedMilestone")}var SP=gl(gP,"milestoneDetails"),TP=gl(gP,"milestoneUnlocks"),IP=gl(gP,"unlockDetails");oe.add("game-ui/game/data-binding/progression/milestone-bindings.ts",{get defaultMilestoneDetails(){return hP},set defaultMilestoneDetails(e){hP=e},get MilestoneUnlockType(){return mP},set MilestoneUnlockType(e){mP=e},get achievedMilestone(){return achievedMilestone},set achievedMilestone(e){achievedMilestone=e},get achievedMilestoneXP(){return achievedMilestoneXP},set achievedMilestoneXP(e){achievedMilestoneXP=e},get nextMilestoneXP(){return nextMilestoneXP},set nextMilestoneXP(e){nextMilestoneXP=e},get totalXP(){return totalXP},set totalXP(e){totalXP=e},get xpMessageAdded(){return xpMessageAdded},set xpMessageAdded(e){xpMessageAdded=e},get maxMilestoneReached(){return maxMilestoneReached},set maxMilestoneReached(e){maxMilestoneReached=e},get milestones(){return milestones},set milestones(e){milestones=e},get unlockedMilestone(){return unlockedMilestone},set unlockedMilestone(e){unlockedMilestone=e},get clearUnlockedMilestone(){return EP},set clearUnlockedMilestone(e){EP=e},get milestoneDetails(){return milestoneDetails},set milestoneDetails(e){milestoneDetails=e},get milestoneUnlocks(){return milestoneUnlocks},set milestoneUnlocks(e){milestoneUnlocks=e},get unlockDetails(){return unlockDetails},set unlockDetails(e){unlockDetails=e}});var wP="signatureBuildings",PP=fl(wP,"unlockedSignatures");function CP(){bl(wP,"clearUnlockedSignatures")}oe.add("game-ui/game/data-binding/progression/signature-building-bindings.ts",{get unlockedSignatures(){return unlockedSignatures},set unlockedSignatures(e){unlockedSignatures=e},get clearUnlockedSignatures(){return CP},set clearUnlockedSignatures(e){CP=e}});var NP="radio",AP=fl(NP,"enabled"),LP=fl(NP,"volume"),MP=fl(NP,"paused"),kP=fl(NP,"muted"),RP=fl(NP,"skipAds"),DP=fl(NP,"emergencyMode"),FP=fl(NP,"emergencyFocusable"),UP=fl(NP,"emergencyMessage"),GP=fl(NP,"selectedNetwork"),BP=fl(NP,"selectedStation"),VP=fl(NP,"networks"),HP=fl(NP,"stations"),KP=fl(NP,"currentSegment"),WP=hl(NP,"segmentChanged");function zP(e){bl(NP,"setVolume",e)}function YP(e){bl(NP,"setPaused",e)}function $P(){YP(!MP.value)}function qP(e){bl(NP,"setMuted",e)}function XP(){qP(!kP.value)}function QP(e){bl(NP,"setSkipAds",e)}function ZP(){QP(!RP.value)}function JP(){bl(NP,"playPrevious")}function eC(){bl(NP,"playNext")}function tC(){bl(NP,"focusEmergency")}function nC(e){bl(NP,"selectNetwork",e)}function rC(e){bl(NP,"selectStation",e)}function iC(e){return null==e||0===e.length?null:e[0]}function oC(e,t){return null==e||0===e.length||null==e[0]?null:e[0][t]}function aC(e,t,n){var r=sC(t,e.length,n);return null!=r?e[r]:null}function sC(e,t,n){return 0===t?null:-1===e?0:e===t-1?n?0:e:e+1}function lC(e,t,n){var r=cC(t,e.length,n);return null!=r?e[r]:null}function cC(e,t,n){return 0===t?null:-1===e?0:0===e?n?t-1:0:e-1}oe.add("game-ui/game/data-binding/radio-bindings.ts",{get radioEnabled(){return radioEnabled},set radioEnabled(e){radioEnabled=e},get volume(){return volume},set volume(e){volume=e},get paused(){return paused},set paused(e){paused=e},get muted(){return muted},set muted(e){muted=e},get skipAds(){return skipAds},set skipAds(e){skipAds=e},get emergencyMode(){return emergencyMode},set emergencyMode(e){emergencyMode=e},get emergencyFocusable(){return emergencyFocusable},set emergencyFocusable(e){emergencyFocusable=e},get emergencyMessage(){return emergencyMessage},set emergencyMessage(e){emergencyMessage=e},get selectedNetwork(){return selectedNetwork},set selectedNetwork(e){selectedNetwork=e},get selectedStation(){return selectedStation},set selectedStation(e){selectedStation=e},get networks(){return networks},set networks(e){networks=e},get stations(){return stations},set stations(e){stations=e},get currentSegment(){return currentSegment},set currentSegment(e){currentSegment=e},get segmentChanged(){return segmentChanged},set segmentChanged(e){segmentChanged=e},get setVolume(){return zP},set setVolume(e){zP=e},get setPaused(){return YP},set setPaused(e){YP=e},get togglePaused(){return $P},set togglePaused(e){$P=e},get setMuted(){return qP},set setMuted(e){qP=e},get toggleMuted(){return XP},set toggleMuted(e){XP=e},get setSkipAds(){return QP},set setSkipAds(e){QP=e},get toggleSkipAds(){return ZP},set toggleSkipAds(e){ZP=e},get playPrevious(){return JP},set playPrevious(e){JP=e},get playNext(){return eC},set playNext(e){eC=e},get focusEmergency(){return tC},set focusEmergency(e){tC=e},get selectNetwork(){return nC},set selectNetwork(e){nC=e},get selectStation(){return rC},set selectStation(e){rC=e}});var uC=function(e,t){for(var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:0,r=new Array(t),i=n;i<n+t;++i)r[i-n]=e(i);return r};function dC(e,t){return e.some((function(e){return(e.length>t.length?e:t).every((function(n,r){return e[r]===t[r]}))}))}function fC(e){return null!=e}function mC(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function gC(e){return function(e){if(Array.isArray(e))return mC(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return mC(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return mC(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/utils/arrays.ts",{get firstOrNull(){return iC},set firstOrNull(e){iC=e},get firstPropertyOrNull(){return oC},set firstPropertyOrNull(e){oC=e},get getNextItem(){return aC},set getNextItem(e){aC=e},get getNextIndex(){return sC},set getNextIndex(e){sC=e},get getPreviousItem(){return lC},set getPreviousItem(e){lC=e},get getPreviousIndex(){return cC},set getPreviousIndex(e){cC=e},get mapRange(){return uC},set mapRange(e){uC=e},get containsArray(){return dC},set containsArray(e){dC=e},get notNull(){return fC},set notNull(e){fC=e}});var hC,pC,vC,bC,yC="selectedInfo",xC=fl(yC,"selectedEntity"),_C=fl(yC,"selectedUITag"),jC=fl(yC,"activeSelection"),OC=fl(yC,"position"),EC=fl(yC,"topSections"),SC=fl(yC,"middleSections"),TC=fl(yC,"bottomSections"),IC=fl(yC,"titleSection"),wC=fl(yC,"developerSection"),PC=fl(yC,"lineVisualizerSection"),CC=fl(yC,"householdSidebarSection"),NC=fl(yC,"tooltipTags"),AC=fl(yC,"selectedRoute"),LC=vl(yC,"selectEntity"),MC=vl(yC,"setSelectedRoute"),kC=pl(yC,"clearSelection");!function(e){e.Resource="Game.UI.InGame.ResourceSection",e.LocalServices="Game.UI.InGame.LocalServicesSection",e.Actions="Game.UI.InGame.ActionsSection",e.Description="Game.UI.InGame.DescriptionSection",e.Developer="Game.UI.InGame.DeveloperSection",e.Residents="Game.UI.InGame.ResidentsSection",e.HouseholdSidebar="Game.UI.InGame.HouseholdSidebarSection",e.Districts="Game.UI.InGame.DistrictsSection",e.Title="Game.UI.InGame.TitleSection",e.Notifications="Game.UI.InGame.NotificationsSection",e.Policies="Game.UI.InGame.PoliciesSection",e.Profitability="Game.UI.InGame.ProfitabilitySection",e.AverageHappiness="Game.UI.InGame.AverageHappinessSection",e.Schedule="Game.UI.InGame.ScheduleSection",e.Line="Game.UI.InGame.LineSection",e.Lines="Game.UI.InGame.LinesSection",e.Color="Game.UI.InGame.ColorSection",e.LineVisualizer="Game.UI.InGame.LineVisualizerSection",e.TicketPrice="Game.UI.InGame.TicketPriceSection",e.VehicleCount="Game.UI.InGame.VehicleCountSection",e.Attractiveness="Game.UI.InGame.AttractivenessSection",e.Efficiency="Game.UI.InGame.EfficiencySection",e.Employees="Game.UI.InGame.EmployeesSection",e.Upkeep="Game.UI.InGame.UpkeepSection",e.Level="Game.UI.InGame.LevelSection",e.Education="Game.UI.InGame.EducationSection",e.Pollution="Game.UI.InGame.PollutionSection",e.Healthcare="Game.UI.InGame.HealthcareSection",e.Deathcare="Game.UI.InGame.DeathcareSection",e.Garbage="Game.UI.InGame.GarbageSection",e.Police="Game.UI.InGame.PoliceSection",e.Vehicles="Game.UI.InGame.VehiclesSection",e.DispatchedVehicles="Game.UI.InGame.DispatchedVehiclesSection",e.Electricity="Game.UI.InGame.ElectricitySection",e.Transformer="Game.UI.InGame.TransformerSection",e.Battery="Game.UI.InGame.BatterySection",e.Water="Game.UI.InGame.WaterSection",e.Sewage="Game.UI.InGame.SewageSection",e.Fire="Game.UI.InGame.FireSection",e.Prison="Game.UI.InGame.PrisonSection",e.Shelter="Game.UI.InGame.ShelterSection",e.Parking="Game.UI.InGame.ParkingSection",e.Park="Game.UI.InGame.ParkSection",e.Mail="Game.UI.InGame.MailSection",e.Road="Game.UI.InGame.RoadSection",e.Company="Game.UI.InGame.CompanySection",e.Storage="Game.UI.InGame.StorageSection",e.PrivateVehicle="Game.UI.InGame.PrivateVehicleSection",e.PublicTransportVehicle="Game.UI.InGame.PublicTransportVehicleSection",e.CargoTransportVehicle="Game.UI.InGame.CargoTransportVehicleSection",e.DeliveryVehicle="Game.UI.InGame.DeliveryVehicleSection",e.HealthcareVehicle="Game.UI.InGame.HealthcareVehicleSection",e.FireVehicle="Game.UI.InGame.FireVehicleSection",e.PoliceVehicle="Game.UI.InGame.PoliceVehicleSection",e.MaintenanceVehicle="Game.UI.InGame.MaintenanceVehicleSection",e.DeathcareVehicle="Game.UI.InGame.DeathcareVehicleSection",e.PostVehicle="Game.UI.InGame.PostVehicleSection",e.GarbageVehicle="Game.UI.InGame.GarbageVehicleSection",e.Passengers="Game.UI.InGame.PassengersSection",e.Cargo="Game.UI.InGame.CargoSection",e.Load="Game.UI.InGame.LoadSection",e.Status="Game.UI.InGame.StatusSection",e.Citizen="Game.UI.InGame.CitizenSection",e.DummyHuman="Game.UI.InGame.DummyHumanSection",e.Animal="Game.UI.InGame.AnimalSection",e.SelectVehicles="Game.UI.InGame.SelectVehiclesSection",e.DestroyedBuilding="Game.UI.InGame.DestroyedBuildingSection",e.DestroyedTree="Game.UI.InGame.DestroyedTreeSection",e.Comfort="Game.UI.InGame.ComfortSection"}(hC||(hC={})),function(e){e[e.none=0]="none",e[e.low=1]="low",e[e.medium=2]="medium",e[e.high=3]="high"}(pC||(pC={})),function(e){e[e.PostFacility=0]="PostFacility",e[e.MailBox=1]="MailBox"}(vC||(vC={})),function(e){e.GenericInfo="Game.UI.InGame.GenericInfo",e.CapacityInfo="Game.UI.InGame.CapacityInfo",e.InfoList="Game.UI.InGame.InfoList"}(bC||(bC={}));var RC,DC="Game.UI.InGame.LineVisualizerSection+LineStop",FC="Game.UI.InGame.LineVisualizerSection+LineVehicle";function UC(e){var t=vc();return(0,Y.useMemo)((function(){var n=VC(t,e);return""!==n?n:null}),[t,e])}function GC(e){var t=vc();return(0,Y.useMemo)((function(){var n=e.filter(fC).map((function(e){return VC(t,e)})).filter((function(e){return""!==e}));return n.length>0?n:null}),[e,t])}function BC(e,t,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3],i=vc(),o=xl(NC);return(0,Y.useMemo)((function(){var a=[r?"":VC(i,e)].concat(gC(t.map((function(t){return VC(i,e+t)}))),gC(o.filter((function(e){return n.includes(e)})).map((function(t){return VC(i,e+t)})))).filter((function(e){return""!==e}));return a.length>0?a:null}),[i,o,e,r,n,t])}function VC(e,t){return qc.SelectedInfoPanel.TOOLTIP.renderString(e,{hash:t,fallback:""})}!function(e){e.Citizen="Citizen",e.Household="Household",e.Building="Building"}(RC||(RC={})),oe.add("game-ui/game/data-binding/selected-info-bindings.ts",{get selectedEntity(){return selectedEntity},set selectedEntity(e){selectedEntity=e},get selectedUITag(){return selectedUITag},set selectedUITag(e){selectedUITag=e},get activeSelection(){return activeSelection},set activeSelection(e){activeSelection=e},get selectedInfoPosition(){return selectedInfoPosition},set selectedInfoPosition(e){selectedInfoPosition=e},get topSections(){return topSections},set topSections(e){topSections=e},get middleSections(){return middleSections},set middleSections(e){middleSections=e},get bottomSections(){return bottomSections},set bottomSections(e){bottomSections=e},get titleSection(){return titleSection},set titleSection(e){titleSection=e},get developerSection(){return developerSection},set developerSection(e){developerSection=e},get lineVisualizerSection(){return lineVisualizerSection},set lineVisualizerSection(e){lineVisualizerSection=e},get householdSidebarSection(){return householdSidebarSection},set householdSidebarSection(e){householdSidebarSection=e},get tooltipTags(){return tooltipTags},set tooltipTags(e){tooltipTags=e},get selectedRoute(){return selectedRoute},set selectedRoute(e){selectedRoute=e},get selectEntity(){return LC},set selectEntity(e){LC=e},get setSelectedRoute(){return MC},set setSelectedRoute(e){MC=e},get clearSelection(){return kC},set clearSelection(e){kC=e},get SectionType(){return hC},set SectionType(e){hC=e},get Pollution(){return pC},set Pollution(e){pC=e},get MailSectionType(){return vC},set MailSectionType(e){vC=e},get DeveloperSubsectionType(){return bC},set DeveloperSubsectionType(e){bC=e},get LINE_STOP(){return DC},set LINE_STOP(e){DC=e},get LINE_VEHICLE(){return FC},set LINE_VEHICLE(e){FC=e},get HouseholdSidebarVariant(){return RC},set HouseholdSidebarVariant(e){RC=e},get useTooltipParagraph(){return UC},set useTooltipParagraph(e){UC=e},get useTooltipParagraphs(){return GC},set useTooltipParagraphs(e){GC=e},get useGeneratedTooltipParagraphs(){return BC},set useGeneratedTooltipParagraphs(e){BC=e}});var HC="statistics",KC=fl(HC,"sampleRange"),WC=fl(HC,"sampleCount"),zC=fl(HC,"activeGroup"),YC=fl(HC,"activeCategory"),$C=fl(HC,"stacked"),qC=fl(HC,"categories"),XC=fl(HC,"dataLabels"),QC=gl(HC,"groups"),ZC=fl(HC,"data"),JC=fl(HC,"selectedStatistics"),eN=gl(HC,"unlockingRequirements"),tN=fl(HC,"updatesPerDay");function nN(e){bl(HC,"addStat",ud(e,"Game.UI.InGame.StatisticsUISystem+StatItem"))}function rN(e){bl(HC,"removeStat",ud(e,"Game.UI.InGame.StatisticsUISystem+StatItem"))}function iN(){bl(HC,"clearStats")}function oN(e){bl(HC,"setSampleRange",e)}oe.add("game-ui/game/data-binding/statistics-bindings.ts",{get sampleRange(){return sampleRange},set sampleRange(e){sampleRange=e},get sampleCount(){return sampleCount},set sampleCount(e){sampleCount=e},get activeGroup(){return activeGroup},set activeGroup(e){activeGroup=e},get activeCategory(){return activeCategory},set activeCategory(e){activeCategory=e},get stacked(){return stacked},set stacked(e){stacked=e},get statisticsCategories(){return statisticsCategories},set statisticsCategories(e){statisticsCategories=e},get statLabels(){return statLabels},set statLabels(e){statLabels=e},get statGroupsMap(){return statGroupsMap},set statGroupsMap(e){statGroupsMap=e},get statsData(){return statsData},set statsData(e){statsData=e},get selectedStatistics(){return selectedStatistics},set selectedStatistics(e){selectedStatistics=e},get statUnlockingRequirements(){return statUnlockingRequirements},set statUnlockingRequirements(e){statUnlockingRequirements=e},get updatesPerDay(){return updatesPerDay},set updatesPerDay(e){updatesPerDay=e},get addStat(){return nN},set addStat(e){nN=e},get removeStat(){return rN},set removeStat(e){rN=e},get clearStats(){return iN},set clearStats(e){iN=e},get setSampleRange(){return oN},set setSampleRange(e){oN=e}});var aN="taxation",sN=fl(aN,"taxRate"),lN=fl(aN,"taxEffect"),cN=fl(aN,"taxIncome"),uN=fl(aN,"minTaxRate"),dN=fl(aN,"maxTaxRate"),fN=fl(aN,"areaTypes"),mN=gl(aN,"areaTaxRates"),gN=gl(aN,"areaTaxIncomes"),hN=gl(aN,"areaTaxEffects"),pN=gl(aN,"areaResourceTaxRanges"),vN=gl(aN,"areaResources"),bN=gl(aN,"resourceTaxRates"),yN=gl(aN,"resourceTaxIncomes"),xN=gl(aN,"taxResourceInfos"),_N=function(e){bl(aN,"setTaxRate",e)},jN=function(e,t){bl(aN,"setAreaTaxRate",e,t)},ON=function(e,t,n){bl(aN,"setResourceTaxRate",e,t,n)};oe.add("game-ui/game/data-binding/taxation-bindings.ts",{get taxRate(){return sN},set taxRate(e){sN=e},get taxEffect(){return lN},set taxEffect(e){lN=e},get taxIncome(){return cN},set taxIncome(e){cN=e},get minTaxRate(){return uN},set minTaxRate(e){uN=e},get maxTaxRate(){return dN},set maxTaxRate(e){dN=e},get areaTypes(){return areaTypes},set areaTypes(e){areaTypes=e},get areaTaxRates(){return areaTaxRates},set areaTaxRates(e){areaTaxRates=e},get areaTaxIncomes(){return areaTaxIncomes},set areaTaxIncomes(e){areaTaxIncomes=e},get areaTaxEffects(){return areaTaxEffects},set areaTaxEffects(e){areaTaxEffects=e},get areaResourceTaxRanges(){return areaResourceTaxRanges},set areaResourceTaxRanges(e){areaResourceTaxRanges=e},get areaResources(){return areaResources},set areaResources(e){areaResources=e},get resourceTaxRates(){return bN},set resourceTaxRates(e){bN=e},get resourceTaxIncomes(){return yN},set resourceTaxIncomes(e){yN=e},get taxResourceInfos(){return xN},set taxResourceInfos(e){xN=e},get setTaxRate(){return _N},set setTaxRate(e){_N=e},get setAreaTaxRate(){return jN},set setAreaTaxRate(e){jN=e},get setResourceTaxRate(){return ON},set setResourceTaxRate(e){ON=e}});var EN,SN="time",TN=fl(SN,"timeSettings"),IN=fl(SN,"ticks"),wN=fl(SN,"day"),PN=fl(SN,"lightingState"),CN=fl(SN,"simulationPaused"),NN=fl(SN,"simulationSpeed"),AN=hl(SN,"simulationPausedBarrier");function LN(e){bl(SN,"setSimulationPaused",e)}function MN(e){bl(SN,"setSimulationSpeed",e)}function kN(e,t){return e.year===t.year&&e.month===t.month}function RN(e){var t=e%60;return{hour:(e-t)/60%24,minute:t}}function DN(e,t){return FN(e,t*e.ticksPerDay)}function FN(e,t){var n=e.epochTicks+t,r=Math.floor(n/e.ticksPerDay);return{year:e.epochYear+Math.floor(r/e.daysPerYear),month:BN(r,e.daysPerYear)}}function UN(e,t){var n=e.epochTicks+t,r=Math.floor(n/e.ticksPerDay),i=e.epochYear+Math.floor(r/e.daysPerYear),o=BN(r,e.daysPerYear),a=BN(n,e.ticksPerDay);return{year:i,month:o,hour:Math.trunc(a/e.ticksPerDay*24),minute:Math.trunc(BN(a/e.ticksPerDay*1440,60))}}function GN(e,t){var n=BN(e.epochTicks+t,e.ticksPerDay);return 60*Math.trunc(n/e.ticksPerDay*24)+Math.trunc(BN(n/e.ticksPerDay*1440,60))}function BN(e,t){return(e%t+t)%t}!function(e){e[e.Dawn=0]="Dawn",e[e.Sunrise=1]="Sunrise",e[e.Day=2]="Day",e[e.Sunset=3]="Sunset",e[e.Dusk=4]="Dusk",e[e.Night=5]="Night"}(EN||(EN={})),oe.add("game-ui/game/data-binding/time-bindings.ts",{get timeSettings(){return timeSettings},set timeSettings(e){timeSettings=e},get ticks(){return ticks},set ticks(e){ticks=e},get day(){return day},set day(e){day=e},get lightingState(){return lightingState},set lightingState(e){lightingState=e},get simulationPaused(){return simulationPaused},set simulationPaused(e){simulationPaused=e},get simulationSpeed(){return simulationSpeed},set simulationSpeed(e){simulationSpeed=e},get simulationPausedBarrier(){return simulationPausedBarrier},set simulationPausedBarrier(e){simulationPausedBarrier=e},get setSimulationPaused(){return LN},set setSimulationPaused(e){LN=e},get setSimulationSpeed(){return MN},set setSimulationSpeed(e){MN=e},get LightingState(){return EN},set LightingState(e){EN=e},get dateEquals(){return kN},set dateEquals(e){kN=e},get calculateTimeFromMinutesSinceMidnight(){return RN},set calculateTimeFromMinutesSinceMidnight(e){RN=e},get calculateDateFromDays(){return DN},set calculateDateFromDays(e){DN=e},get calculateDateFromTicks(){return FN},set calculateDateFromTicks(e){FN=e},get calculateDateTimeFromTicks(){return UN},set calculateDateTimeFromTicks(e){UN=e},get calculateMinutesSinceMidnightFromTicks(){return GN},set calculateMinutesSinceMidnightFromTicks(e){GN=e}});var VN=fl("tool","activeTool"),HN=hl("tool","bulldozeConfirmationRequested"),KN=fl("tool","availableSnapMask"),WN=fl("tool","selectedSnapMask"),zN=fl("tool","allSnapMask"),YN=fl("tool","snapOptionNames"),$N=fl("tool","elevationRange"),qN=fl("tool","elevation"),XN=fl("tool","elevationStep"),QN=fl("tool","parallelModeSupported"),ZN=fl("tool","parallelMode"),JN=fl("tool","parallelOffset"),eA=fl("tool","undergroundModeSupported"),tA=fl("tool","undergroundMode"),nA=fl("tool","elevationDownDisabled"),rA=fl("tool","elevationUpDisabled"),iA=fl("tool","colorSupported"),oA=fl("tool","color");function aA(e){bl("tool","setColor",e)}function sA(e){bl("tool","selectTool",e)}function lA(e){bl("tool","selectToolMode",e)}function cA(e){bl("tool","confirmBulldoze",e)}function uA(e){e<0?fA():e>0&&dA()}function dA(){bl("tool","elevationUp")}function fA(){bl("tool","elevationDown")}function mA(){bl("tool","elevationScroll")}function gA(e){bl("tool","setElevationStep",e)}function hA(e){bl("tool","setSelectedSnapMask",e)}function pA(){bl("tool","toggleParallelMode")}function vA(e){bl("tool","setParallelOffset",e)}function bA(e){bl("tool","setUndergroundMode",e)}var yA="Bulldoze Tool",xA="Default Tool",_A="Zone Tool",jA="Area Tool",OA="Net Tool",EA="Object Tool",SA="Upgrade Tool",TA="Terrain Tool",IA="Selection Tool",wA="Route Tool",PA=fl("tool","allowBrush"),CA=fl("tool","selectedBrush"),NA=fl("tool","brushes"),AA=fl("tool","brushSize"),LA=fl("tool","brushStrength"),MA=fl("tool","brushAngle"),kA=fl("tool","brushSizeMin"),RA=fl("tool","brushSizeMax");function DA(e){bl("tool","selectBrush",e)}function FA(e){bl("tool","setBrushSize",e)}function UA(e){bl("tool","setBrushStrength",e)}function GA(e){bl("tool","setBrushAngle",e)}oe.add("game-ui/game/data-binding/tool-bindings.ts",{get activeTool(){return activeTool},set activeTool(e){activeTool=e},get bulldozeConfirmationRequested(){return bulldozeConfirmationRequested},set bulldozeConfirmationRequested(e){bulldozeConfirmationRequested=e},get availableSnapMask(){return availableSnapMask},set availableSnapMask(e){availableSnapMask=e},get selectedSnapMask(){return selectedSnapMask},set selectedSnapMask(e){selectedSnapMask=e},get allSnapMask(){return allSnapMask},set allSnapMask(e){allSnapMask=e},get snapOptionNames(){return snapOptionNames},set snapOptionNames(e){snapOptionNames=e},get elevationRange(){return elevationRange},set elevationRange(e){elevationRange=e},get elevation(){return elevation},set elevation(e){elevation=e},get elevationStep(){return elevationStep},set elevationStep(e){elevationStep=e},get parallelModeSupported(){return parallelModeSupported},set parallelModeSupported(e){parallelModeSupported=e},get parallelMode(){return parallelMode},set parallelMode(e){parallelMode=e},get parallelOffset(){return parallelOffset},set parallelOffset(e){parallelOffset=e},get undergroundModeSupported(){return undergroundModeSupported},set undergroundModeSupported(e){undergroundModeSupported=e},get undergroundMode(){return undergroundMode},set undergroundMode(e){undergroundMode=e},get elevationDownDisabled(){return elevationDownDisabled},set elevationDownDisabled(e){elevationDownDisabled=e},get elevationUpDisabled(){return elevationUpDisabled},set elevationUpDisabled(e){elevationUpDisabled=e},get colorSupported(){return colorSupported},set colorSupported(e){colorSupported=e},get color(){return color},set color(e){color=e},get setColor(){return aA},set setColor(e){aA=e},get selectTool(){return sA},set selectTool(e){sA=e},get selectToolMode(){return lA},set selectToolMode(e){lA=e},get confirmBulldoze(){return cA},set confirmBulldoze(e){cA=e},get changeElevation(){return uA},set changeElevation(e){uA=e},get elevationUp(){return dA},set elevationUp(e){dA=e},get elevationDown(){return fA},set elevationDown(e){fA=e},get elevationScroll(){return mA},set elevationScroll(e){mA=e},get setElevationStep(){return gA},set setElevationStep(e){gA=e},get setSelectedSnapMask(){return hA},set setSelectedSnapMask(e){hA=e},get toggleParallelMode(){return pA},set toggleParallelMode(e){pA=e},get setParallelOffset(){return vA},set setParallelOffset(e){vA=e},get setUndergroundMode(){return bA},set setUndergroundMode(e){bA=e},get BULLDOZE_TOOL(){return yA},set BULLDOZE_TOOL(e){yA=e},get DEFAULT_TOOL(){return xA},set DEFAULT_TOOL(e){xA=e},get ZONE_TOOL(){return _A},set ZONE_TOOL(e){_A=e},get AREA_TOOL(){return jA},set AREA_TOOL(e){jA=e},get NET_TOOL(){return OA},set NET_TOOL(e){OA=e},get OBJECT_TOOL(){return EA},set OBJECT_TOOL(e){EA=e},get UPGRADE_TOOL(){return SA},set UPGRADE_TOOL(e){SA=e},get TERRAIN_TOOL(){return TA},set TERRAIN_TOOL(e){TA=e},get SELECTION_TOOL(){return IA},set SELECTION_TOOL(e){IA=e},get ROUTE_TOOL(){return wA},set ROUTE_TOOL(e){wA=e},get allowBrush(){return allowBrush},set allowBrush(e){allowBrush=e},get selectedBrush(){return selectedBrush},set selectedBrush(e){selectedBrush=e},get brushes(){return brushes},set brushes(e){brushes=e},get brushSize(){return brushSize},set brushSize(e){brushSize=e},get brushStrength(){return brushStrength},set brushStrength(e){brushStrength=e},get brushAngle(){return brushAngle},set brushAngle(e){brushAngle=e},get brushSizeMin(){return brushSizeMin},set brushSizeMin(e){brushSizeMin=e},get brushSizeMax(){return brushSizeMax},set brushSizeMax(e){brushSizeMax=e},get selectBrush(){return DA},set selectBrush(e){DA=e},get setBrushSize(){return FA},set setBrushSize(e){FA=e},get setBrushStrength(){return UA},set setBrushStrength(e){UA=e},get setBrushAngle(){return GA},set setBrushAngle(e){GA=e}});var BA,VA="toolbar";!function(e){e[e.asset=0]="asset",e[e.menu=1]="menu"}(BA||(BA={}));var HA=fl(VA,"toolbarGroups"),KA=gl(VA,"assetCategories"),WA=gl(VA,"assets"),zA=fl(VA,"themes"),YA=fl(VA,"selectedTheme"),$A=fl(VA,"selectedAssetMenu"),qA=fl(VA,"selectedAssetCategory"),XA=fl(VA,"selectedAsset"),QA=vl(VA,"selectTheme"),ZA=vl(VA,"selectAssetMenu"),JA=vl(VA,"selectAssetCategory"),eL=vl(VA,"selectAsset"),tL=pl(VA,"clearAssetSelection");oe.add("game-ui/game/data-binding/toolbar-bindings.ts",{get ToolbarItemType(){return BA},set ToolbarItemType(e){BA=e},get toolbarGroups(){return toolbarGroups},set toolbarGroups(e){toolbarGroups=e},get assetCategories(){return assetCategories},set assetCategories(e){assetCategories=e},get assets(){return assets},set assets(e){assets=e},get themes(){return themes},set themes(e){themes=e},get selectedTheme(){return selectedTheme},set selectedTheme(e){selectedTheme=e},get selectedAssetMenu(){return selectedAssetMenu},set selectedAssetMenu(e){selectedAssetMenu=e},get selectedAssetCategory(){return selectedAssetCategory},set selectedAssetCategory(e){selectedAssetCategory=e},get selectedAsset(){return selectedAsset},set selectedAsset(e){selectedAsset=e},get selectTheme(){return QA},set selectTheme(e){QA=e},get selectAssetMenu(){return ZA},set selectAssetMenu(e){ZA=e},get selectAssetCategory(){return JA},set selectAssetCategory(e){JA=e},get selectAsset(){return eL},set selectAsset(e){eL=e},get clearAssetSelection(){return tL},set clearAssetSelection(e){tL=e}});var nL=fl("toolbarBottom","population"),rL=fl("toolbarBottom","populationDelta"),iL=fl("toolbarBottom","money"),oL=fl("toolbarBottom","moneyDelta"),aL=fl("toolbarBottom","cityName"),sL=fl("toolbarBottom","unlimitedMoney"),lL=fl("toolbarBottom","populationTrendThresholds"),cL=fl("toolbarBottom","moneyTrendThresholds");function uL(e){bl("toolbarBottom","setCityName",e)}oe.add("game-ui/game/data-binding/toolbar-bottom-bindings.ts",{get population(){return population},set population(e){population=e},get populationDelta(){return populationDelta},set populationDelta(e){populationDelta=e},get money(){return money},set money(e){money=e},get moneyDelta(){return moneyDelta},set moneyDelta(e){moneyDelta=e},get cityName(){return cityName},set cityName(e){cityName=e},get unlimitedMoney(){return unlimitedMoney},set unlimitedMoney(e){unlimitedMoney=e},get populationTrendThresholds(){return populationTrendThresholds},set populationTrendThresholds(e){populationTrendThresholds=e},get moneyTrendThresholds(){return moneyTrendThresholds},set moneyTrendThresholds(e){moneyTrendThresholds=e},get setCityName(){return uL},set setCityName(e){uL=e}});var dL="transportationOverview",fL=fl(dL,"passengerTypes"),mL=fl(dL,"cargoTypes"),gL=fl(dL,"lines"),hL=fl(dL,"selectedPassengerType"),pL=fl(dL,"selectedCargoType"),vL=vl(dL,"select"),bL=vl(dL,"delete"),yL=vl(dL,"rename"),xL=vl(dL,"setColor"),_L=vl(dL,"setActive"),jL=vl(dL,"showLine"),OL=vl(dL,"hideLine"),EL=vl(dL,"setSchedule"),SL=pl(dL,"resetVisibility"),TL=vl(dL,"toggleHighlight"),IL=vl(dL,"setSelectedPassengerType"),wL=vl(dL,"setSelectedCargoType");oe.add("game-ui/game/data-binding/transport-bindings.ts",{get passengerTypes(){return passengerTypes},set passengerTypes(e){passengerTypes=e},get cargoTypes(){return cargoTypes},set cargoTypes(e){cargoTypes=e},get transportLines(){return transportLines},set transportLines(e){transportLines=e},get selectedPassengerType(){return selectedPassengerType},set selectedPassengerType(e){selectedPassengerType=e},get selectedCargoType(){return selectedCargoType},set selectedCargoType(e){selectedCargoType=e},get selectLine(){return vL},set selectLine(e){vL=e},get deleteLine(){return bL},set deleteLine(e){bL=e},get renameLine(){return yL},set renameLine(e){yL=e},get setLineColor(){return xL},set setLineColor(e){xL=e},get setLineActive(){return _L},set setLineActive(e){_L=e},get showLine(){return jL},set showLine(e){jL=e},get hideLine(){return OL},set hideLine(e){OL=e},get setLineSchedule(){return EL},set setLineSchedule(e){EL=e},get resetVisibility(){return SL},set resetVisibility(e){SL=e},get toggleHighlight(){return TL},set toggleHighlight(e){TL=e},get setSelectedPassengerType(){return IL},set setSelectedPassengerType(e){IL=e},get setSelectedCargoType(){return wL},set setSelectedCargoType(e){wL=e}});var PL="upgradeMenu",CL=gl(PL,"upgrades"),NL=gl(PL,"upgradeDetails"),AL=fl(PL,"selectedUpgrade"),LL=fl(PL,"upgrading");function ML(e,t){bl(PL,"selectUpgrade",e,t)}function kL(){bl(PL,"clearUpgradeSelection")}function RL(e,t){return(0,Y.useCallback)((function(n){if(null!=n){var r=e(n);null!=r&&t(r)}}),[e,t])}function DL(e){return RL(Xs,e)}function FL(e){return RL(UL,e)}function UL(e){return"string"==typeof e?e:null}oe.add("game-ui/game/data-binding/upgrade-bindings.ts",{get upgrades(){return upgrades},set upgrades(e){upgrades=e},get upgradeDetails(){return upgradeDetails},set upgradeDetails(e){upgradeDetails=e},get selectedUpgrade(){return selectedUpgrade},set selectedUpgrade(e){selectedUpgrade=e},get upgrading(){return upgrading},set upgrading(e){upgrading=e},get selectUpgrade(){return ML},set selectUpgrade(e){ML=e},get clearUpgradeSelection(){return kL},set clearUpgradeSelection(e){kL=e}}),oe.add("game-ui/common/focus/focus-change-listener.tsx",{get useFocusChangeListener(){return RL},set useFocusChangeListener(e){RL=e},get useEntityFocusChangeListener(){return DL},set useEntityFocusChangeListener(e){DL=e},get useStringFocusChangeListener(){return FL},set useStringFocusChangeListener(e){FL=e}});var GL=function(e){var t=e.disabled,n=void 0===t||t,r=e.children,i=(0,Y.useContext)(jd);return(0,z.jsx)(jd.Provider,{value:n?Od:i,children:r})};function BL(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function VL(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return BL(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return BL(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/focus/focus-disabled.tsx",{get FocusDisabled(){return GL},set FocusDisabled(e){GL=e}});var HL=function(e){var t=e.children,n=VL((0,Y.useState)(!1),2),r=n[0],i=n[1],o=bg("SelectableFocusBoundary",!0,r);Eg(o,(0,Y.useCallback)((function(e){e||i(!1)}),[]));var a=(0,Y.useMemo)((function(){return{Select:function(){return i(!r)},Back:r?function(){return i(!1)}:null}}),[r]);return(0,z.jsx)(mb,{includes:fb,disabled:!r,children:(0,z.jsx)(rp,{actions:a,children:(0,z.jsx)(Sg,{controller:o,children:t})})})};function KL(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function WL(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return KL(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return KL(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function zL(e){var t=WL((0,Y.useState)(e),2),n=t[0],r=t[1],i=(0,Y.useContext)(Md);return(0,Y.useEffect)((function(){if(!i){var t=window.requestAnimationFrame((function(){i||r(e)}));return function(){return window.cancelAnimationFrame(t)}}}),[i,e]),n}oe.add("game-ui/common/focus/selectable-focus-boundary.tsx",{get SelectableFocusBoundary(){return HL},set SelectableFocusBoundary(e){HL=e}}),oe.add("game-ui/common/focus/index.ts",{});var YL=function(e){var t=zL(e.children);return(0,z.jsx)(z.Fragment,{children:t})};oe.add("game-ui/common/animations/use-exit-transition-lock.tsx",{get useExitTransitionLock(){return zL},set useExitTransitionLock(e){zL=e},get ExitTransitionLock(){return YL},set ExitTransitionLock(e){YL=e}});var $L="user",qL=fl($L,"switchPromptVisible"),XL=fl($L,"avatar"),QL=fl($L,"userID"),ZL=fl($L,"switchUserHintOverload");function JL(){bl($L,"switchUser")}function eM(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function tM(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return eM(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return eM(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/data-binding/user-bindings.ts",{get switchPromptVisible(){return switchPromptVisible},set switchPromptVisible(e){switchPromptVisible=e},get avatar(){return avatar},set avatar(e){avatar=e},get userID(){return userID},set userID(e){userID=e},get switchUserHintOverload(){return switchUserHintOverload},set switchUserHintOverload(e){switchUserHintOverload=e},get switchUser(){return JL},set switchUser(e){JL=e}});var nM=function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.time=t,this.refCount=0},rM=Y.createContext(new Map);function iM(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],n=(0,Y.useContext)(rM),r=tM((0,Y.useState)(0),2),i=r[0],o=r[1];return(0,Y.useEffect)((function(){if(t){var r,i=performance.now(),a=null!==(r=n.get(e))&&void 0!==r?r:new nM(i);return 0===a.refCount&&n.set(e,a),a.refCount++,o(Math.min(a.time-i,0)),function(){a.refCount--,0===a.refCount&&n.delete(e)}}}),[t,n,e]),i+"ms"}oe.add("game-ui/common/animations/animation-sync.tsx",{get AnimationSyncContext(){return rM},set AnimationSyncContext(e){rM=e},get useAnimationSyncDelay(){return iM},set useAnimationSyncDelay(e){iM=e}});let oM={balloon:"balloon_YD_ balloon_DNs balloon_H23",base:"base_CfJ",enter:"enter_ek6","exit-active":"exit-active_s_4",exitActive:"exit-active_s_4","enter-active":"enter-active_QVu",enterActive:"enter-active_QVu",exit:"exit_RYd",container:"container_p5S container_sGN container_jfe",arrow:"arrow_WhB arrow_tFt arrow_Xfn",content:"content_Bye content_HM0 content_JQV"};oe.add("game-ui/common/balloon/themes/tutorial-balloon.module.scss",{get classes(){return oM},set classes(e){Object.assign(oM,e)}});const aM=oM;let sM={"fixed-ratio-image":"fixed-ratio-image_XTW",fixedRatioImage:"fixed-ratio-image_XTW",ratio:"ratio_xCj",image:"image_EBv"};oe.add("game-ui/common/image/fixed-ratio-image.module.scss",{get classes(){return sM},set classes(e){Object.assign(sM,e)}});const lM=sM;function cM(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function uM(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){cM(e,t,n[t])}))}return e}function dM(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function fM(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var mM=function(e){var t=e.src,n=e.className,r=e.onError,i=fM(e,["src","className","onError"]);return(0,z.jsxs)("div",dM(uM({},i),{className:_d()(lM.fixedRatioImage,n),children:[(0,z.jsx)("div",{className:lM.ratio}),(0,z.jsx)("img",{src:t,className:lM.image,onError:r})]}))},gM=function(e){var t=e.src,n=e.className,r=e.onImageError,i=fM(e,["src","className","onImageError"]);return(0,z.jsxs)(Qp,dM(uM({},i),{className:_d()(lM.fixedRatioImage,n),children:[(0,z.jsx)("div",{className:lM.ratio}),(0,z.jsx)("img",{src:t,className:lM.image,onError:r})]}))};oe.add("game-ui/common/image/fixed-ratio-image.tsx",{get FixedRatioImage(){return mM},set FixedRatioImage(e){mM=e},get FixedRatioImageButton(){return gM},set FixedRatioImageButton(e){gM=e}});var hM=jc("LocalizedInputPath",(function(e,t){var n=t.group,r=t.path,i=t.gamepadType;if(r.length>0){var o=qc.Options.INPUT_MODIFIER_SEPARATOR.renderString(e,{fallback:" + "});return r.map((function(t){var r="".concat(n,".").concat(t),o=qc.Options.INPUT_CONTROL.renderString(e,{hash:r,fallback:t});return i===zm.PS&&"Gamepad"===n?qc.Options.INPUT_CONTROL_PS.renderString(e,{hash:r,fallback:o}):o})).join(o)}return qc.Options.INPUT_CONTROL_UNSET.renderString(e,{})}),(function(e,t){return e.group===t.group&&el(e.path,t.path)}));oe.add("game-ui/common/localization/localized-input-path.tsx",{get LocalizedInputPath(){return hM},set LocalizedInputPath(e){hM=e}});let pM={"keyboard-input-hint":"keyboard-input-hint_eiZ",keyboardInputHint:"keyboard-input-hint_eiZ",icon:"icon_Mm0"};oe.add("game-ui/game/components/tutorials/tutorial-input-hints/tutorial-input-hint.module.scss",{get classes(){return pM},set classes(e){Object.assign(pM,e)}});const vM=pM;function bM(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function yM(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return bM(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return bM(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var xM="inputAction:",_M=new gv((function(e,t,n){if(e.startsWith(xM)){var r=yM(function(e){if(e.endsWith("]")){var t=e.lastIndexOf("[");if(t<e.length-1){var n=parseInt(e.substring(t+1,e.length-1));return isNaN(n)?[e,void 0]:[e.substring(0,t),n]}}return[e,void 0]}(e.substring(12).trim()),2),i=r[0],o=r[1];return(0,z.jsx)(jM,{linkData:i,bindingIndex:o},n)}}));function jM(e){var t=e.linkData,n=e.bindingIndex,r=xl(qm),i=(0,Y.useMemo)((function(){var e=t.indexOf("/");return e>=0&&t.length>=e+1?{map:t.substring(0,e),action:t.substring(e+1),controlScheme:r}:{map:"",action:"",controlScheme:r}}),[r,t]),o=Ol(ng,i),a=(0,Y.useMemo)((function(){return void 0!==n&&n>=0&&n<o.length?[o[n]]:o}),[n,o]);return(0,z.jsx)(z.Fragment,{children:r===Wm.gamepad?a.map((function(e,n){return(0,z.jsx)(EM,{hint:e},t+n)})):a.map((function(e,n){return(0,z.jsx)(OM,{hint:e},t+n)}))})}var OM=function(e){var t=e.hint;return(0,z.jsx)("span",{className:vM.keyboardInputHint,children:(0,z.jsx)("b",{children:(0,z.jsx)(hM,{group:t.name,path:t.bindings})})})},EM=function(e){var t=e.hint;return(0,z.jsxs)(z.Fragment,{children:[t.modifiers.map((function(e){return(0,z.jsx)(SM,{path:e,modifier:!0},e)})),t.bindings.map((function(e){return(0,z.jsx)(SM,{path:e},e)}))]})},SM=function(e){var t=e.path,n=e.modifier,r=bk(t);return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)("img",{src:r||"",className:vM.icon}),n&&"+"]})};oe.add("game-ui/game/components/tutorials/tutorial-input-hints/tutorial-input-hint.tsx",{get tutorialTextRenderer(){return _M},set tutorialTextRenderer(e){_M=e}});let TM={"trigger-item":"trigger-item_rd_",triggerItem:"trigger-item_rd_",completed:"completed_V8G",checkbox:"checkbox_Y9N",label:"label_vR9"};oe.add("game-ui/game/components/tutorials/tutorial-layout/trigger-item/trigger-item.module.scss",{get classes(){return TM},set classes(e){Object.assign(TM,e)}});const IM=TM;var wM=function(e){var t=e.trigger;return(0,Y.useEffect)((function(){t.completed&&kp(Lp.tutorialTriggerCompleteEvent)}),[t.completed]),(0,z.jsxs)("div",{className:_d()(IM.triggerItem,t.completed&&IM.completed),children:[(0,z.jsx)(fv,{checked:t.completed||t.preCompleted,className:IM.checkbox,focusKey:Hh}),(0,z.jsx)(Iv,{text:(0,z.jsx)(qc.Tutorials.TRIGGER,{hash:t.name}),renderer:_M,className:IM.label})]})};oe.add("game-ui/game/components/tutorials/tutorial-layout/trigger-item/trigger-item.tsx",{get TriggerItem(){return wM},set TriggerItem(e){wM=e}});let PM={"tutorial-layout":"tutorial-layout_iuN",tutorialLayout:"tutorial-layout_iuN",image:"image_NyN",columns:"columns_ITy","icon-column":"icon-column_K_S",iconColumn:"icon-column_K_S","content-column":"content-column_ygV",contentColumn:"content-column_ygV",top:"top_4SL",icon:"icon_Qax",content:"content_p9h",scrollable:"scrollable_ErH",title:"title_JUj","close-button":"close-button_K6M",closeButton:"close-button_K6M",description:"description_Dj3",rows:"rows_vbh",row:"row_yh5",triggers:"triggers_Da1 row_yh5",bottom:"bottom_oC7 row_yh5",pages:"pages_kqp"};oe.add("game-ui/game/components/tutorials/tutorial-layout/tutorial-layout.module.scss",{get classes(){return PM},set classes(e){Object.assign(PM,e)}});const CM=PM;function NM(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function AM(e){return(0,Y.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){NM(e,t,n[t])}))}return e}({},CM,e)}),[e])}function LM(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function MM(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return LM(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return LM(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function kM(e,t){var n;return!e.mandatory||(null===(n=t.trigger)||void 0===n?void 0:n.preCompleted)||null==t.trigger||e.advisorActivation||t.completed}function RM(e,t){return DM(e,t)>0}function DM(e,t){return e.phases.findIndex((function(e){return Qs(e.entity,t.entity)}))}function FM(){var e=Vg.value,t=Hg.value;if(null!=e&&null!=t){var n=DM(e,t),r=MM(UM(e,n),2),i=r[0];r[1];if(i>0)Yg(e.entity,e.phases[n-1].entity);else if(n>0){var o=e.phases.findIndex((function(e){var t;return null===(t=e.trigger)||void 0===t?void 0:t.phaseBranching}));o>=0&&Yg(e.entity,e.phases[o].entity)}}}function UM(e,t){var n=e.phases.length,r=e.phases.findIndex((function(e){var t;return null==e||null===(t=e.trigger)||void 0===t?void 0:t.phaseBranching}));if(r<0)return[t,n];if(t<=r)return[t,r+1];for(var i=-1,o=-1,a=r+1;a<n;a++){var s=e.phases[a];if(((null==s?void 0:s.forcesCompletion)||a===n-1)&&a>=t){o=a;break}}for(var l=n-1;l>r;l--){var c=e.phases[l];if((null==c?void 0:c.isBranch)&&l<=t){i=l;break}}return[t-i,o-i+1]}function GM(){var e=xl(Ag),t=xl(Vg),n=_l(Mg,BM,!1);return(0,Y.useMemo)((function(){return!(n||(null==t?void 0:t.mandatory)&&e)}),[null==t?void 0:t.mandatory,n,e])}function BM(e,t){return null!=t}oe.add("game-ui/game/components/tutorials/tutorial-layout/tutorial-theme.tsx",{get useTutorialTheme(){return AM},set useTutorialTheme(e){AM=e}}),oe.add("game-ui/game/components/tutorials/tutorial-layout/tutorial-utils.ts",{get tutorialSkipAvailable(){return kM},set tutorialSkipAvailable(e){kM=e},get previousTutorialPhaseAvailable(){return RM},set previousTutorialPhaseAvailable(e){RM=e},get activatePreviousTutorialPhase(){return FM},set activatePreviousTutorialPhase(e){FM=e},get getBranchIndices(){return UM},set getBranchIndices(e){UM=e},get useAdvisorPanelAvailable(){return GM},set useAdvisorPanelAvailable(e){GM=e}});let VM={item:"item_Lji",button:"button_iQJ item_Lji",animate:"animate_fHa",blink:"blink_HHL",none:"none_bxA",icon:"icon_G81",pages:"pages_Lzi item_Lji",label:"label_FEJ",divider:"divider_bFc"};oe.add("game-ui/game/components/tutorials/tutorial-layout/tutorial-action-button.module.scss",{get classes(){return VM},set classes(e){Object.assign(VM,e)}});const HM=VM;function KM(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function WM(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return KM(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return KM(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var zM=function(e){var t=e.tutorial,n=e.phase,r=e.pagesVisible,i=e.theme,o=e.closeable,a=void 0!==o&&o,s=e.scrollable,l=void 0!==s&&s,c=e.disableTooltips,u=void 0!==c&&c,d=e.className,f=t.phases.findIndex((function(e){return Qs(e.entity,n.entity)})),m=WM((0,Y.useMemo)((function(){return UM(t,f)}),[f,t]),2),g=m[0],h=m[1],p=kM(t,n),v=f>0,b=bc(Pg()?(0,z.jsx)(qc.Tutorials.DESCRIPTION_GAMEPAD,{hash:n.name,fallback:""}):(0,z.jsx)(qc.Tutorials.DESCRIPTION_KEYBOARD,{hash:n.name,fallback:""})),y=bc((0,z.jsx)(qc.Tutorials.DESCRIPTION,{hash:n.name})),x=!t.completed&&!t.advisorActivation,_=n.descriptionVisible?b||y:null,j=function(e){var t=yk();return t!==zm.PS||Zs(e.overrideImagePS)?t!==zm.Xbox||Zs(e.overrideImageXbox)?e.image:e.overrideImageXbox:e.overrideImagePS}(n);return(0,z.jsx)(YM,{theme:i,image:j,icon:n.icon,title:n.titleVisible?(0,z.jsx)(qc.Tutorials.TITLE,{hash:n.name}):void 0,description:n.descriptionVisible?_:null,onClose:a?Qg:void 0,scrollable:l,trigger:n.trigger,pagesVisible:r,phaseIndex:g,phaseCount:h,nextVisible:p,previousVisible:v,handleActivatePreviousPhase:FM,handleActivateNextPhase:Xg,animateButton:x,className:d,disableTooltips:u})};var YM=function(e){var t=e.theme,n=void 0===t?CM:t,r=e.className,i=e.image,o=e.icon,a=e.title,s=e.autoScroll,l=void 0===s||s,c=e.description,u=e.onClose,d=e.scrollable,f=e.trigger,m=e.pagesVisible,g=e.phaseIndex,h=void 0===g?0:g,p=e.phaseCount,v=void 0===p?1:p,b=e.nextVisible,y=e.previousVisible,x=e.handleActivatePreviousPhase,_=e.handleActivateNextPhase,j=e.animateButton,O=e.disableTooltips,E=AM(n),S=m&&-1!==h&&v>1,T=h+1===v,I=Pg(),w=a||c?(0,z.jsxs)(z.Fragment,{children:[(0,z.jsxs)("div",{className:E.top,children:[a&&(0,z.jsx)("div",{className:E.title,children:a}),!I&&u&&(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:"Media/Glyphs/Close.svg",theme:ub,className:E.closeButton,onSelect:u})]}),c&&(0,z.jsx)("div",{className:E.description,children:(0,z.jsx)(Fv,{renderer:_M,children:c})})]}):void 0;return(0,z.jsxs)("div",{className:_d()(E.tutorialLayout,r),children:[i&&(0,z.jsx)(mM,{src:i,className:E.image}),(o||w)&&(0,z.jsxs)("div",{className:E.columns,children:[o&&(0,z.jsx)("div",{className:E.iconColumn,children:(0,z.jsx)("img",{src:o,className:E.icon})}),(0,z.jsx)("div",{className:E.contentColumn,children:d?(0,z.jsx)(gE,{autoScroll:l,className:E.scrollable,children:w}):(0,z.jsx)("div",{className:E.content,children:w})})]}),((null==f?void 0:f.displayUI)||y||b||S)&&(0,z.jsxs)("div",{className:E.rows,children:[(null==f?void 0:f.displayUI)&&(0,z.jsx)("div",{className:E.triggers,children:(0,z.jsx)(wM,{trigger:f})}),I||!y&&!b?S&&(0,z.jsx)("div",{className:E.bottom,children:(0,z.jsx)("div",{className:E.pages,children:(0,z.jsx)(Pu,{value:h+1,total:v})})}):(0,z.jsxs)("div",{className:E.bottom,children:[y&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(jh,{tooltip:!O&&(0,z.jsx)(qc.Tutorials.BUTTON_TOOLTIP_PREVIOUS,{}),children:(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:"Media/Glyphs/FilledArrowLeft.svg",theme:HM,onSelect:x})}),(S||b)&&(0,z.jsx)("div",{className:HM.divider})]}),S&&(0,z.jsx)("div",{className:HM.pages,children:(0,z.jsx)("div",{className:HM.label,children:(0,z.jsx)(Pu,{value:h+1,total:v})})}),b&&(0,z.jsxs)(z.Fragment,{children:[S&&(0,z.jsx)("div",{className:HM.divider}),(0,z.jsx)(jh,{tooltip:O?void 0:T?(0,z.jsx)(qc.Tutorials.BUTTON_TOOLTIP_DONE,{}):(0,z.jsx)(qc.Tutorials.BUTTON_TOOLTIP_NEXT,{}),children:(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:T?"Media/Glyphs/Checkmark.svg":"Media/Glyphs/FilledArrowRight.svg",theme:HM,className:_d()(j&&HM.animate),onSelect:_})})]})]})]})]})};oe.add("game-ui/game/components/tutorials/tutorial-layout/tutorial-layout.tsx",{get TutorialLayout(){return zM},set TutorialLayout(e){zM=e},get TutorialPhaseLayoutImpl(){return YM},set TutorialPhaseLayoutImpl(e){YM=e}});let $M={image:"image_GQL image_NyN"};oe.add("game-ui/game/components/tutorials/tutorial-balloon/tutorial-balloon.module.scss",{get classes(){return $M},set classes(e){Object.assign($M,e)}});const qM=$M;var XM=function(e){var t=e.tutorial,n=e.phase,r=e.direction,i=e.alignment,o=e.children,a=null!=t&&null!=n&&(0,z.jsx)(zM,{tutorial:t,phase:n,pagesVisible:!0,theme:qM,closeable:t.completed||t.advisorActivation||!t.mandatory,disableTooltips:!0});return(0,z.jsx)(Um,{balloonKey:null==n?void 0:n.name,theme:aM,visible:null!=t,content:(0,z.jsx)(YL,{children:a}),direction:r,alignment:i,children:o})};oe.add("game-ui/game/components/tutorials/tutorial-balloon/tutorial-balloon.tsx",{get TutorialBalloon(){return XM},set TutorialBalloon(e){XM=e}});let QM={"tutorial-blink-active":"tutorial-blink-active_s4x",tutorialBlinkActive:"tutorial-blink-active_s4x","tutorial-blink":"tutorial-blink_EvY",tutorialBlink:"tutorial-blink_EvY"};oe.add("game-ui/game/components/tutorials/tutorial-target/tutorial-target.module.scss",{get classes(){return QM},set classes(e){Object.assign(QM,e)}});const ZM=QM;function JM(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function ek(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return JM(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return JM(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var tk=function(e){var t,n,r=e.uiTag,i=e.active,o=void 0===i||i,a=e.disableBlinking,s=void 0!==a&&a,l=e.children;if(!Y.isValidElement(l))throw new Error("TutorialGuideTarget requires a single child react element!");var c=xl(Vg),u=xl(Hg),d=nk(r,o),f=ek(rk(r,o),3),m=f[0],g=f[1],h=f[2],p=!s&&(d||g),v=iM(ZM.tutorialBlink,p),b={tutorial:m?c:null,phase:m?u:null,balloonDirection:m&&h>=0?null===(t=null==u?void 0:u.balloonTargets[h])||void 0===t?void 0:t.direction:void 0,balloonAlignment:m&&h>=0?null===(n=null==u?void 0:u.balloonTargets[h])||void 0===n?void 0:n.alignment:void 0,disableTooltips:m,animationDelay:p?{animationDelay:v}:void 0,className:p?ZM.tutorialBlinkActive:void 0};return(0,z.jsx)(hh.Provider,{value:b.disableTooltips,children:(0,z.jsx)(XM,{tutorial:b.tutorial,phase:b.phase,direction:b.balloonDirection,alignment:b.balloonAlignment,children:(0,z.jsx)(Zd,{style:b.animationDelay,className:b.className,children:l})})})},nk=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],n=ek((0,Y.useState)(!1),2),r=n[0],i=n[1],o=(0,Y.useContext)(gh);return(0,Y.useEffect)((function(){if(void 0!==e&&""!==e&&t)return o.mountBlinkListener(e,i),function(){return o.unmountBlinkListener(e)};i(!1)}),[o,e,t]),r},rk=function(e,t){var n=ek((0,Y.useState)(!1),2),r=n[0],i=n[1],o=ek((0,Y.useState)(!1),2),a=o[0],s=o[1],l=ek((0,Y.useState)(-1),2),c=l[0],u=l[1],d=(0,Y.useContext)(gh);return(0,Y.useEffect)((function(){if(void 0!==e&&""!==e&&t)return d.mountBalloonListener(e,i,s,u),function(){return d.unmountBalloonListener(e)};i(!1)}),[d,e,t]),[r,a,c]};oe.add("game-ui/game/components/tutorials/tutorial-target/tutorial-target.tsx",{get TutorialTarget(){return tk},set TutorialTarget(e){tk=e}});let ik={"action-guide":"action-guide_eqv",actionGuide:"action-guide_eqv",fadeIn:"fadeIn_d4x",item:"item_p05","button-icon":"button-icon_N8P",buttonIcon:"button-icon_N8P","item-clickable":"item-clickable_sKM item-mouse-states_Fmi",itemClickable:"item-clickable_sKM item-mouse-states_Fmi","button-text":"button-text_U4q",buttonText:"button-text_U4q",plus:"plus_ITh",label:"label_MOA"};oe.add("game-ui/common/input-events/action-hints/action-hints.module.scss",{get classes(){return ik},set classes(e){Object.assign(ik,e)}});const ok=ik;function ak(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function sk(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function lk(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var ck,uk,dk=function(e){var t=e.disabled,n=e.specifiedActions,r=e.className,i=e.labels,o=void 0===i||i,a=zL(xl(eg)),s=(0,Y.useMemo)((function(){return void 0!==n?a.filter((function(e){return n.includes(e.name)})):a}),[a,n]);return(0,z.jsx)("div",{className:_d()(ok.actionGuide,r),children:t?null:s.map((function(e,t){return(0,z.jsx)(fk,{item:e,label:o,onSelect:tg},t)}))})},fk=function(e){var t,n=e.item,r=e.label,i=e.onSelect,o=xl(ZL),a=(0,Y.useCallback)((function(){i&&i(n.name)}),[n.name,i]),s=n.name;if("Switch User"===s)s=o||n.name;return(0,z.jsx)(tk,{uiTag:(null===(t=Ew.value)||void 0===t?void 0:t.actionHints)+"+"+n.name,children:(0,z.jsxs)(vk,{className:ok.item,onSelect:a,children:[n.modifiers.map((function(e,t){return(0,z.jsx)(mk,{path:e,modifier:!0},t)})),n.bindings.map((function(e,t){return(0,z.jsx)(mk,{path:e},t)})),r?(0,z.jsx)("div",{className:ok.label,children:(0,z.jsx)(qc.Common.ACTION,{hash:s})}):null]})})},mk=function(e){var t=e.path,n=e.modifier,r=bk(t);return(0,z.jsxs)(z.Fragment,{children:[null!=r?(0,z.jsx)("img",{src:r,className:ok.buttonIcon}):(0,z.jsx)(gk,{path:t}),n&&(0,z.jsx)("div",{className:ok.plus,children:"+"})]})},gk=function(e){var t=e.path,n=hk(t),r=pk(t);return(0,z.jsx)("div",{className:ok.buttonText,children:(0,z.jsx)(hM,{group:n,path:r})})},hk=function(e){return(0,Y.useMemo)((function(){var t=e.indexOf("<"),n=e.indexOf(">");return t>=0&&n>t?e.substring(t+1,n):e}),[e])},pk=function(e){return(0,Y.useMemo)((function(){var t=e.indexOf("/");return t>=0?e.substring(t+1).split("/"):[e]}),[e])},vk=function(e){var t=e.children,n=e.className,r=lk(e,["children","className"]);return(0,z.jsx)(Qp,sk(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){ak(e,t,n[t])}))}return e}({className:_d()(ok.item,n,!r.disabled&&ok.itemClickable),focusKey:Hh},r),{children:t}))};function bk(e){var t=yk();return(0,Y.useMemo)((function(){switch(t){case zm.Xbox:switch(e){case"<Gamepad>/leftStick":return"Media/Gamepad/Xbox/LeftStick.svg";case"<Gamepad>/rightStick":return"Media/Gamepad/Xbox/RightStick.svg";case"<Gamepad>/leftStick/up":return"Media/Gamepad/Xbox/LstickUp.svg";case"<Gamepad>/leftStick/down":return"Media/Gamepad/Xbox/LstickDown.svg";case"<Gamepad>/leftStick/left":return"Media/Gamepad/Xbox/LstickLeft.svg";case"<Gamepad>/leftStick/right":return"Media/Gamepad/Xbox/LstickRight.svg";case"<Gamepad>/rightStick/up":return"Media/Gamepad/Xbox/RstickUp.svg";case"<Gamepad>/rightStick/down":return"Media/Gamepad/Xbox/RstickDown.svg";case"<Gamepad>/rightStick/left":return"Media/Gamepad/Xbox/RstickLeft.svg";case"<Gamepad>/rightStick/right":return"Media/Gamepad/Xbox/RstickRight.svg";case"<Gamepad>/dpad":return"Media/Gamepad/Xbox/Dpad.svg";case"<Gamepad>/dpad/x":return"Media/Gamepad/Xbox/DpadX.svg";case"<Gamepad>/dpad/y":return"Media/Gamepad/Xbox/DpadY.svg";case"<Gamepad>/dpad/up":return"Media/Gamepad/Xbox/DpadUp.svg";case"<Gamepad>/dpad/down":return"Media/Gamepad/Xbox/DpadDown.svg";case"<Gamepad>/dpad/left":return"Media/Gamepad/Xbox/DpadLeft.svg";case"<Gamepad>/dpad/right":return"Media/Gamepad/Xbox/DpadRight.svg";case"<Gamepad>/buttonNorth":return"Media/Gamepad/Xbox/North.svg";case"<Gamepad>/buttonSouth":return"Media/Gamepad/Xbox/South.svg";case"<Gamepad>/buttonWest":return"Media/Gamepad/Xbox/West.svg";case"<Gamepad>/buttonEast":return"Media/Gamepad/Xbox/East.svg";case"<Gamepad>/leftShoulder":return"Media/Gamepad/Xbox/LeftShoulder.svg";case"<Gamepad>/rightShoulder":return"Media/Gamepad/Xbox/RightShoulder.svg";case"<Gamepad>/leftTrigger":return"Media/Gamepad/Xbox/LeftTrigger.svg";case"<Gamepad>/rightTrigger":return"Media/Gamepad/Xbox/RightTrigger.svg";case"<Gamepad>/start":return"Media/Gamepad/Xbox/Start.svg";case"<Gamepad>/select":return"Media/Gamepad/Xbox/Select.svg";case"<Gamepad>/leftStickPress":return"Media/Gamepad/Xbox/LstickPress.svg";case"<Gamepad>/rightStickPress":return"Media/Gamepad/Xbox/RstickPress.svg";default:return null}case zm.PS:switch(e){case"<Gamepad>/leftStick":return"Media/Gamepad/PS/PS_Lstick.svg";case"<Gamepad>/rightStick":return"Media/Gamepad/PS/PS_Rstick.svg";case"<Gamepad>/leftStick/up":return"Media/Gamepad/PS/PS_LstickUp.svg";case"<Gamepad>/leftStick/down":return"Media/Gamepad/PS/PS_LstickDown.svg";case"<Gamepad>/leftStick/left":return"Media/Gamepad/PS/PS_LstickLeft.svg";case"<Gamepad>/leftStick/right":return"Media/Gamepad/PS/PS_LstickRight.svg";case"<Gamepad>/rightStick/up":return"Media/Gamepad/PS/PS_RstickUp.svg";case"<Gamepad>/rightStick/down":return"Media/Gamepad/PS/PS_RstickDown.svg";case"<Gamepad>/rightStick/left":return"Media/Gamepad/PS/PS_RstickLeft.svg";case"<Gamepad>/rightStick/right":return"Media/Gamepad/PS/PS_RstickRight.svg";case"<Gamepad>/dpad":return"Media/Gamepad/PS/PS_Dpad.svg";case"<Gamepad>/dpad/x":return"Media/Gamepad/PS/PS_DpadX.svg";case"<Gamepad>/dpad/y":return"Media/Gamepad/PS/PS_DpadY.svg";case"<Gamepad>/dpad/up":return"Media/Gamepad/PS/PS_DpadUp.svg";case"<Gamepad>/dpad/down":return"Media/Gamepad/PS/PS_DpadDown.svg";case"<Gamepad>/dpad/left":return"Media/Gamepad/PS/PS_DpadLeft.svg";case"<Gamepad>/dpad/right":return"Media/Gamepad/PS/PS_DpadRight.svg";case"<Gamepad>/buttonNorth":return"Media/Gamepad/PS/PS_triangle.svg";case"<Gamepad>/buttonSouth":return"Media/Gamepad/PS/PS_X.svg";case"<Gamepad>/buttonWest":return"Media/Gamepad/PS/PS_square.svg";case"<Gamepad>/buttonEast":return"Media/Gamepad/PS/PS_O.svg";case"<Gamepad>/leftShoulder":return"Media/Gamepad/PS/PS_L1.svg";case"<Gamepad>/rightShoulder":return"Media/Gamepad/PS/PS_R1.svg";case"<Gamepad>/leftTrigger":return"Media/Gamepad/PS/PS_L2.svg";case"<Gamepad>/rightTrigger":return"Media/Gamepad/PS/PS_R2.svg";case"<Gamepad>/start":return"Media/Gamepad/PS/PS_Options.svg";case"<Gamepad>/select":return"Media/Gamepad/PS/PS_Create.svg";case"<Gamepad>/leftStickPress":return"Media/Gamepad/PS/PS_LStickPress.svg";case"<Gamepad>/rightStickPress":return"Media/Gamepad/PS/PS_RStickPress.svg";case"<Gamepad>/touchpadButton":case"<DualShockGamepad>/touchpadButton":return"Media/Gamepad/PS/PS_Touchpad.svg";default:return null}}}),[t,e])}function yk(){var e=xl(Jl),t=xl(rg);switch(e){case kl.AutoDetect:return t;case kl.PS:return zm.PS;case kl.Xbox:return zm.Xbox}}function xk(e){return ck[e]}oe.add("game-ui/common/input-events/action-hints/action-hints.tsx",{get InputActionHints(){return dk},set InputActionHints(e){dk=e},get ControlIcon(){return mk},set ControlIcon(e){mk=e},get ActionHintLayout(){return vk},set ActionHintLayout(e){vk=e},get useInputControlIcon(){return bk},set useInputControlIcon(e){bk=e},get useGamepadType(){return yk},set useGamepadType(e){yk=e}}),function(e){e[e.buttonSouth=0]="buttonSouth",e[e.buttonEast=1]="buttonEast",e[e.buttonWest=2]="buttonWest",e[e.buttonNorth=3]="buttonNorth",e[e.leftShoulder=4]="leftShoulder",e[e.rightShoulder=5]="rightShoulder",e[e.leftTrigger=6]="leftTrigger",e[e.rightTrigger=7]="rightTrigger",e[e.select=8]="select",e[e.start=9]="start",e[e.leftStickPress=10]="leftStickPress",e[e.rightStickPress=11]="rightStickPress",e[e.up=12]="up",e[e.down=13]="down",e[e.left=14]="left",e[e.right=15]="right"}(ck||(ck={})),function(e){e[e.leftStickX=0]="leftStickX",e[e.leftStickY=1]="leftStickY",e[e.RightStickX=2]="RightStickX",e[e.RightStickY=3]="RightStickY"}(uk||(uk={})),oe.add("game-ui/common/input-events/devices/gamepad.ts",{get GamepadButton(){return ck},set GamepadButton(e){ck=e},get gamepadButtonFromString(){return xk},set gamepadButtonFromString(e){xk=e},get GamepadAxis(){return uk},set GamepadAxis(e){uk=e}});let _k={"input-stack-debug-display":"input-stack-debug-display_lFP",inputStackDebugDisplay:"input-stack-debug-display_lFP"};oe.add("game-ui/common/input-events/debug/input-stack-debug-display.module.scss",{get classes(){return _k},set classes(e){Object.assign(_k,e)}});const jk=_k;var Ok=function(e){var t=e.actions;return(0,z.jsx)("div",{className:jk.inputStackDebugDisplay,children:t})};oe.add("game-ui/common/input-events/debug/input-stack-debug-display.tsx",{get InputStackDebugDisplay(){return Ok},set InputStackDebugDisplay(e){Ok=e}});var Ek="input",Sk=fl(Ek,"actionNames"),Tk=hl(Ek,"onActionPerformed"),Ik=hl(Ek,"onActionReleased");function wk(e,t){bl(Ek,"setActionPriority",e,t)}function Pk(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Ck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function Nk(e){return function(e){if(Array.isArray(e))return Pk(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return Pk(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Pk(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/input-events/input-bindings.ts",{get inputActionNames(){return inputActionNames},set inputActionNames(e){inputActionNames=e},get onInputActionPerformed(){return onInputActionPerformed},set onInputActionPerformed(e){onInputActionPerformed=e},get onInputActionReleased(){return onInputActionReleased},set onInputActionReleased(e){onInputActionReleased=e},get setInputActionPriority(){return wk},set setInputActionPriority(e){wk=e}});var Ak=function(){function e(){Ck(this,e),this._items=[]}var t=e.prototype;return t.contains=function(e){return-1!==this.indexOf(e)},t.indexOf=function(e){return this._items.findIndex((function(t){return t.action===e}))},t.push=function(e,t){this._items=Nk(this._items).concat([new Lk(e,t)])},t.removeWhere=function(e){this._items=this._items.filter((function(t){return!e(t.action)}))},t.clear=function(){this._items=[]},t.dispatchInputEvent=function(e,t){for(var n=this._items.length-1;n>=0;n--){var r=this._items[n];if(r.action===e)if(!1!==r.callback(t))return!0}return!1},t.debugPrint=function(){console.log("Input Stack:\n".concat(this._items.map((function(e){return e.action})).join("\n")))},e}(),Lk=function e(t,n){Ck(this,e),this.action=t,this.callback=n};function Mk(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function kk(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Mk(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Mk(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/input-events/input-stack.tsx",{get InputStack(){return Ak},set InputStack(e){Ak=e}});var Rk=function(e){var t=e.children,n=(0,Y.useMemo)((function(){return new Ak}),[]),r=xl(Sk),i=(0,Y.useRef)(r);i.current=r;var o=kk((0,Y.useState)([]),2),a=(o[0],o[1],(0,Y.useCallback)((function(){for(var e=i.current,t=0;t<e.length;t++)wk(t,n.indexOf(e[t]))}),[n]));(0,Y.useEffect)((function(){a()}),[r,a]);var s=(0,Y.useMemo)((function(){return new Jh(n,a)}),[n,a]);return(0,Y.useEffect)((function(){var e=Tk.subscribe((function(e){n.dispatchInputEvent(e.action,e.value)}));return function(){return e.dispose()}}),[n]),(0,Y.useEffect)((function(){var e=Ik.subscribe((function(e){n.dispatchInputEvent(e.action,e.value)}));return function(){return e.dispose()}}),[n]),(0,z.jsxs)(Xh.Provider,{value:s,children:[t,false]})};function Dk(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];(0,Y.useEffect)((function(){if(t){var n=0,r=function(){e(),n=window.requestAnimationFrame(r)};return n=window.requestAnimationFrame(r),function(){return window.cancelAnimationFrame(n)}}}),[e,t])}oe.add("game-ui/common/input-events/providers/event-input-provider.tsx",{get EventInputProvider(){return Rk},set EventInputProvider(e){Rk=e}}),oe.add("game-ui/common/utils/use-loop.ts",{get useLoop(){return Dk},set useLoop(e){Dk=e}});var Fk,Uk=function(e){var t=e.children,n=Pg(),r=xl(Xm);return Dk((0,Y.useCallback)((function(){ag(document.elementFromPoint(r.x,r.y)!==document.body)}),[r.x,r.y]),n),(0,z.jsx)(z.Fragment,{children:t})};function Gk(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Bk(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Gk(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Gk(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/input-events/providers/gamepad-pointer-event-provider.tsx",{get GamepadPointerEventProvider(){return Uk},set GamepadPointerEventProvider(e){Uk=e}}),function(e){e[e.buttonSouth=0]="buttonSouth",e[e.buttonEast=1]="buttonEast",e[e.buttonWest=2]="buttonWest",e[e.buttonNorth=3]="buttonNorth",e[e.leftShoulder=4]="leftShoulder",e[e.rightShoulder=5]="rightShoulder",e[e.leftTrigger=6]="leftTrigger",e[e.rightTrigger=7]="rightTrigger",e[e.select=8]="select",e[e.start=9]="start",e[e.leftStickPress=10]="leftStickPress",e[e.rightStickPress=11]="rightStickPress",e[e.up=12]="up",e[e.down=13]="down",e[e.left=14]="left",e[e.right=15]="right"}(Fk||(Fk={}));var Vk=function(e){var t=e.children,n=(0,Y.useMemo)((function(){return new Ak}),[]);(0,Y.useEffect)((function(){var e,t=zk(Fk.buttonSouth,!1),r=zk(Fk.buttonEast,!1),i=zk(Fk.buttonNorth,!1),o=zk(Fk.leftShoulder,!1),a=zk(Fk.rightShoulder,!1),s=zk(Fk.select,!1),l=zk(Fk.start,!1),c=zk(Fk.up,!0),u=zk(Fk.down,!0),d=zk(Fk.left,!0),f=zk(Fk.right,!0),m=function(g){try{1===t(g)&&Hk(n,[{action:"Select",value:null},{action:"Save Game",value:null}]),1===r(g)&&n.dispatchInputEvent("Back",null);var h=i(g);1===h?n.dispatchInputEvent("Debug Multiplier",1):-1===h&&n.dispatchInputEvent("Debug Multiplier",0),1===o(g)&&Hk(n,[{action:"Switch Tab",value:-1},{action:"Switch Ordering",value:-1}]),1===a(g)&&Hk(n,[{action:"Switch Tab",value:1},{action:"Switch Ordering",value:1}]),1===s(g)&&n.dispatchInputEvent("Debug UI",null),1===l(g)&&Hk(n,[{action:"Pause Menu",value:null},{action:"Start Game",value:null},{action:"Load Game",value:null}]),1===c(g)&&n.dispatchInputEvent("Move Vertical",1),1===u(g)&&n.dispatchInputEvent("Move Vertical",-1),1===d(g)&&Hk(n,[{action:"Move Horizontal",value:-1},{action:"Debug Change Field",value:-1},{action:"Change Slider Value",value:-1}]),1===f(g)&&Hk(n,[{action:"Move Horizontal",value:1},{action:"Debug Change Field",value:1},{action:"Change Slider Value",value:1}])}catch(e){console.error(e)}e=window.requestAnimationFrame(m)},g=function(e){27===e.keyCode?Hk(n,[{action:"Back",value:null},{action:"Pause Menu",value:null}]):9===e.keyCode?n.dispatchInputEvent("Debug UI",null):16===e.keyCode?n.dispatchInputEvent("Debug Multiplier",1):32===e.keyCode?Hk(n,[{action:"Pause Simulation",value:null},{action:"Resume Simulation",value:null}]):66===e.keyCode&&n.dispatchInputEvent("Bulldozer",null)},h=function(e){16===e.keyCode&&n.dispatchInputEvent("Debug Multiplier",0)};return e=window.requestAnimationFrame(m),window.addEventListener("keydown",g),window.addEventListener("keyup",h),function(){window.cancelAnimationFrame(e),window.removeEventListener("keydown",g),window.removeEventListener("keyup",h)}}),[n]);var r=Bk((0,Y.useState)([]),2),i=r[0],o=r[1],a=(0,Y.useCallback)((function(){o(n._items.map((function(e){return e.action})))}),[n]),s=(0,Y.useMemo)((function(){return new Jh(n,a)}),[n,a]);return(0,z.jsxs)(Xh.Provider,{value:s,children:[t,(0,z.jsx)(Ok,{actions:i})]})};function Hk(e,t){for(var n=-1,r=Number.MAX_SAFE_INTEGER,i=0;i<t.length;i++){var o=e.indexOf(t[i].action);-1!==o&&o<r&&(n=i,r=o)}if(-1!==n){var a=t[n];return e.dispatchInputEvent(a.action,a.value)}return!1}var Kk=500,Wk=100;function zk(e,t){var n=!1,r=0;return function(i){var o=navigator.getGamepads();if(o.length>0&&null!=o[0]&&o[0].buttons.length>e)if(o[0].buttons[e].pressed){if(!n)return n=!0,r=i+Kk,1;if(t){var a=i-r;if(a>0)return a<Kk?r+=Wk:r=i+Wk,1}}else if(n)return n=!1,-1;return 0}}oe.add("game-ui/common/input-events/providers/native-input-provider.tsx",{get NativeInputProvider(){return Vk},set NativeInputProvider(e){Vk=e}}),oe.add("game-ui/common/input-events/index.ts",{});var Yk=oe.find,$k=oe.get;Object.defineProperties(window,{React:{value:Y},ReactDOM:{value:ue},ReactDOMClient:{value:ae},"cs2/api":{value:t},"cs2/bindings":{value:V},"cs2/l10n":{value:r},"cs2/ui":{value:s},"cs2/utils":{value:H},"cs2/input":{value:K},"cs2/modding":{value:W},"cohtml/cohtml":{value:Ys()},"chart.js":{value:e}});var qk=function(e,t){var n=new XMLHttpRequest;n.open("GET",e,!0),n.onreadystatechange=function(){if(200===n.status){var r;n.abort();var i=document.createElement("link");i.rel="stylesheet",i.id=(null===(r=e.split("/").pop())||void 0===r?void 0:r.replace(".css",""))||"",i.href=e,i.onload=t,document.head.appendChild(i)}},n.send()};function Xk(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Qk(e,t,n,r,i,o,a){try{var s=e[o](a),l=s.value}catch(e){return void n(e)}s.done?t(l):Promise.resolve(l).then(r,i)}function Zk(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Xk(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Xk(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/modding/utils/load-css.tsx",{get loadCss(){return qk},set loadCss(e){qk=e}});var Jk=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}},eR=[],tR=function(e){oe.reset();var t=!0,n=!1,r=void 0;try{for(var i,o=e[Symbol.iterator]();!(t=(i=o.next()).done);t=!0){(0,i.value)(oe)}}catch(e){n=!0,r=e}finally{try{t||null==o.return||o.return()}finally{if(n)throw r}}},nR=function(){var e=xl(Vh),t=Zk((0,Y.useState)(!1),2),n=t[0],r=t[1],i=Zk((0,Y.useState)(eR),2),o=i[0],a=i[1];return(0,Y.useEffect)((function(){var t=0,n=(null==e?void 0:e.length)||0;function i(){var o;return o=function(){var i,o;return Jk(this,(function(s){return i=[],o=function(){++t===n&&n>0&&(tR(i),a(i),r(!0))},e.forEach((function(e){import(e).then((function(t){if(i.push(t.default),t.hasCSS){n++;var r=e.replace(".mjs",".css");qk(r,o)}o()})).catch((function(e){o()}))})),[2]}))},i=function(){var e=this,t=arguments;return new Promise((function(n,r){var i=o.apply(e,t);function a(e){Qk(i,n,r,a,s,"next",e)}function s(e){Qk(i,n,r,a,s,"throw",e)}a(void 0)}))},i.apply(this,arguments)}e&&e.length?function(){i.apply(this,arguments)}():(tR(eR),a(eR),r(!0))}),[e]),{ready:n,registry:o,mods:e}},rR=new Wh("CONTINUE_KEY"),iR=function(e){var t=e.severity,n=void 0===t?Eh.Error:t,r=e.title,i=e.message,o=e.errorDetails,a=e.canQuit,s=void 0===a||a,l=e.canSaveAndQuit,c=void 0===l||l,u=(0,Y.useContext)(fO),d=(0,Y.useCallback)((function(){return Gh((null!=i?i:"")+"\n"+(null!=o?o:""))}),[i,o]);return(0,z.jsx)(ij,{children:(0,z.jsx)(qj,{theme:Qj,header:(0,z.jsx)(tO,{children:null!=r?r:(0,z.jsx)(qc.Common.ERROR_DIALOG_TITLE,{})}),className:rO.errorDialog,onClose:u.onClose,children:(0,z.jsxs)(Ap,{initialFocused:rR,children:[(0,z.jsxs)("div",{className:rO.iconLayout,children:[(0,z.jsx)("img",{src:oR(n),className:rO.icon}),(0,z.jsxs)("div",{className:rO.mainColumn,children:[(0,z.jsx)("div",{className:rO.errorMessage,style:{maxHeight:.5*screen.availHeight},children:i}),null!=o&&(0,z.jsxs)("div",{className:rO.errorDetails,children:[(0,z.jsx)(gE,{className:rO.content,children:o}),(0,z.jsx)(lb,{tinted:!0,src:"Media/Glyphs/Copy.svg",className:rO.copyButton,onSelect:d})]})]})]}),(0,z.jsxs)("div",{className:rO.buttons,children:[(0,z.jsx)(Qp,{focusKey:rR,theme:Jp,className:rO.button,onSelect:u.onClose,children:(0,z.jsx)(qc.Common.ERROR_DIALOG_CONTINUE,{})}),s&&(0,z.jsx)(Qp,{theme:Jp,className:rO.button,onSelect:Fh,children:(0,z.jsx)(qc.Common.ERROR_DIALOG_QUIT_GAME,{})}),c&&(0,z.jsx)(Qp,{theme:Jp,className:rO.button,onSelect:Uh,children:(0,z.jsx)(qc.Common.ERROR_DIALOG_SAVE_QUIT_GAME,{})})]})]})})})};function oR(e){return e===Eh.Warning?"Media/Misc/Warning.svg":"Media/Misc/Error.svg"}oe.add("game-ui/common/panel/dialog/error-dialog.tsx",{get ErrorDialog(){return iR},set ErrorDialog(e){iR=e}});var aR=new Wh("CHILDREN_KEY"),sR=new Wh("DIALOG_KEY"),lR=function(e){var t,n=e.children,r=xl(Lh),i=(0,Y.useMemo)((function(){return{onClose:function(){return Bh()}}}),[]);return(0,z.jsxs)(pj,{focused:null!=r?sR:aR,children:[(0,z.jsx)(hj,{focusKey:aR,children:n}),(0,z.jsx)(hj,{focusKey:sR,children:(0,z.jsx)(fO.Provider,{value:i,children:null!=r&&(0,z.jsx)(iR,{severity:r.severity,title:cR(r),message:(t=r,(0,z.jsx)(Fv,{children:(0,z.jsx)(ku,{value:t.localizedMessage})})),errorDetails:r.errorDetails,canQuit:0!=(r.actions&Sh.Quit),canSaveAndQuit:0!=(r.actions&Sh.SaveAndQuit)})})})]})};function cR(e){return(0,z.jsx)(ku,{value:e.localizedTitle})}function uR(e,t){return t>0?e.positive:t<0?e.negative:void 0}function dR(e){mR(document.documentElement,e)}function fR(e){mR(document.body,e)}function mR(e,t){(0,Y.useInsertionEffect)((function(){if(null!=t){var n=t.split(" "),r=!0,i=!1,o=void 0;try{for(var a,s=n[Symbol.iterator]();!(r=(a=s.next()).done);r=!0){var l=a.value;e.classList.add(l)}}catch(e){i=!0,o=e}finally{try{r||null==s.return||s.return()}finally{if(i)throw o}}return function(){var t=!0,r=!1,i=void 0;try{for(var o,a=n[Symbol.iterator]();!(t=(o=a.next()).done);t=!0){var s=o.value;e.classList.remove(s)}}catch(e){r=!0,i=e}finally{try{t||null==a.return||a.return()}finally{if(r)throw i}}}}}),[e,t])}oe.add("game-ui/common/panel/dialog/error-dialog-renderer.tsx",{get ErrorDialogRenderer(){return lR},set ErrorDialogRenderer(e){lR=e}}),oe.add("game-ui/common/utils/class-name.tsx",{get signStyle(){return uR},set signStyle(e){uR=e},get useRootClassName(){return dR},set useRootClassName(e){dR=e},get useBodyClassName(){return fR},set useBodyClassName(e){fR=e}});var gR,hR,pR="debug",vR=fl(pR,"enabled"),bR=fl(pR,"visible"),yR=fl(pR,"panels"),xR=fl(pR,"selectedIndex"),_R=fl(pR,"selectedPanel"),jR=fl(pR,"children"),OR=fl(pR,"observedBinding"),ER=hl(pR,"bindingTriggered"),SR=fl(pR,"developerInfoVisible"),TR=fl(pR,"watches");function IR(){bl(pR,"show")}function wR(){bl(pR,"hide")}function PR(){bl(pR,"selectPreviousPanel")}function CR(e){bl(pR,"selectPanel",e)}function NR(){bl(pR,"selectNextPanel")}!function(e){e[e.Unknown=0]="Unknown",e[e.Trigger=1]="Trigger",e[e.Event=2]="Event",e[e.Value=3]="Value"}(gR||(gR={})),function(e){e.History="debug.HistoryWatch",e.Distribution="debug.DistributionWatch"}(hR||(hR={})),oe.add("game-ui/debug/data-binding/debug-bindings.ts",{get enabled(){return enabled},set enabled(e){enabled=e},get visible(){return visible},set visible(e){visible=e},get panels(){return panels},set panels(e){panels=e},get selectedIndex(){return selectedIndex},set selectedIndex(e){selectedIndex=e},get selectedPanel(){return selectedPanel},set selectedPanel(e){selectedPanel=e},get debugChildren(){return debugChildren},set debugChildren(e){debugChildren=e},get observedBinding(){return observedBinding},set observedBinding(e){observedBinding=e},get bindingTriggered(){return bindingTriggered},set bindingTriggered(e){bindingTriggered=e},get developerInfoVisible(){return developerInfoVisible},set developerInfoVisible(e){developerInfoVisible=e},get watches(){return watches},set watches(e){watches=e},get showDebugUI(){return IR},set showDebugUI(e){IR=e},get hideDebugUI(){return wR},set hideDebugUI(e){wR=e},get selectPreviousPanel(){return PR},set selectPreviousPanel(e){PR=e},get selectPanel(){return CR},set selectPanel(e){CR=e},get selectNextPanel(){return NR},set selectNextPanel(e){NR=e},get DebugBindingType(){return gR},set DebugBindingType(e){gR=e},get DebugWatchType(){return hR},set DebugWatchType(e){hR=e}});let AR={button:"button_BNH"};oe.add("game-ui/debug/themes/tab.module.scss",{get classes(){return AR},set classes(e){Object.assign(AR,e)}});const LR=AR;function MR(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function kR(e){return function(e){if(Array.isArray(e))return MR(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return MR(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return MR(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function RR(e,t){return(0,Y.useCallback)((function(){for(var n=arguments.length,r=new Array(n),i=0;i<n;i++)r[i]=arguments[i];return e.apply(void 0,[t].concat(kR(r)))}),[e,t])}var DR,FR,UR,GR;function BR(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function VR(e){return function(e){if(Array.isArray(e))return BR(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return BR(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return BR(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function HR(e,t){return VR(e).concat([t])}function KR(e){return(0,Y.useMemo)((function(){return e.join(".")}),[e])}function WR(e){var t=e.displayName,n=e.value,r=e.disabled;return{displayName:t,value:Df(n),disabled:r}}function zR(e){bl(e.group,"invoke",e.path)}function YR(e,t){bl(e.group,"setValue",e.path,t)}function $R(e,t){bl(e.group,"setExpanded",e.path,t)}function qR(e){bl(e.group,"invoke",e.path)}function XR(e){bl(e.group,"addListElement",e.path)}function QR(e,t){bl(e.group,"duplicateListElement",e.path,t)}function ZR(e,t,n){bl(e.group,"moveListElement",e.path,t,n)}function JR(e,t){bl(e.group,"deleteListElement",e.path,t)}function eD(e){bl(e.group,"clearList",e.path)}function tD(e,t){bl(e.group,"setCurrentPageIndex",e.path,t)}function nD(e,t,n,r){return yl(e,"moveKeyframe",t,n,r,arguments.length>4&&void 0!==arguments[4]&&arguments[4],arguments.length>5&&void 0!==arguments[5]?arguments[5]:0)}function rD(e,t,n,r){return yl(e,"addKeyframe",t,n,r,arguments.length>4&&void 0!==arguments[4]?arguments[4]:0)}function iD(e,t,n){bl(e,"removeKeyframe",t,n,arguments.length>3&&void 0!==arguments[3]?arguments[3]:0)}function oD(e,t,n){bl(e,"setKeyframes",t,n,arguments.length>3&&void 0!==arguments[3]?arguments[3]:0)}function aD(e,t,n){return yl(e,"addSeason",t,n)}function sD(e,t,n){return yl(e,"onUpdateSeason",t,n)}function lD(e,t,n){bl(e,"deleteSeason",t,n)}function cD(e){return(0,Y.useMemo)((function(){return{group:e,path:[]}}),[e])}function uD(e,t){return(0,Y.useMemo)((function(){return{group:e.group,path:HR(e.path,t)}}),[e.group,e.path,t])}function dD(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function fD(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){dD(e,t,n[t])}))}return e}function mD(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function gD(e,t){return t}function hD(e){return qs(e.entity)}function pD(e){var t=e.components,n=e.data,r=e.props,i=t[n.__Type];return null!=i?Y.createElement(i,fD({},n,null!=r?r:{})):(0,z.jsx)(yD,{typeName:n.__Type})}function vD(e){var t=e.components,n=e.data,r=e.props,i=e.keyProvider,o=void 0===i?gD:i;return(0,z.jsx)(z.Fragment,{children:n.map((function(e,n){if(null!=e){var i=o(e,n),a=t[e.__Type];return null!=a?Y.createElement(a,mD(fD({},e,null!=r?r:{}),{key:i})):(0,z.jsx)(yD,{typeName:e.__Type},i)}}))})}function bD(e,t,n,r){var i=e[t.__Type];return null!=i?Y.createElement(i,fD({},t,null!=n?n:{},null!=r?{key:r}:{})):void 0}oe.add("game-ui/common/utils/element-callback.ts",{get useElementCallback(){return RR},set useElementCallback(e){RR=e}}),function(e){e.IntArrowField="Game.UI.Debug.IntArrowField",e.UIntArrowField="Game.UI.Debug.UIntArrowField",e.FloatArrowField="Game.UI.Debug.FloatArrowField",e.Image="Game.UI.Debug.Image"}(DR||(DR={})),oe.add("game-ui/debug/data-binding/debug-widgets.ts",{get DebugWidgetType(){return DR},set DebugWidgetType(e){DR=e}}),function(e){e.Column="Game.UI.Widgets.Column",e.Row="Game.UI.Widgets.Row",e.Scrollable="Game.UI.Widgets.Scrollable",e.PageView="Game.UI.Widgets.PageView",e.PageLayout="Game.UI.Widgets.PageLayout",e.Divider="Game.UI.Widgets.Divider",e.Label="Game.UI.Widgets.Label",e.Breadcrumbs="Game.UI.Widgets.Breadcrumbs",e.Button="Game.UI.Widgets.Button",e.ButtonRow="Game.UI.Widgets.ButtonRow",e.IconButton="Game.UI.Widgets.IconButton",e.IconButtonGroup="Game.UI.Widgets.IconButtonGroup",e.Group="Game.UI.Widgets.Group",e.ExpandableGroup="Game.UI.Widgets.ExpandableGroup",e.PagedList="Game.UI.Widgets.PagedList",e.ValueField="Game.UI.Widgets.ValueField",e.LocalizedValueField="Game.UI.Widgets.LocalizedValueField",e.ToggleField="Game.UI.Widgets.ToggleField",e.IntInputField="Game.UI.Widgets.IntInputField",e.IntSliderField="Game.UI.Widgets.IntSliderField",e.Int2InputField="Game.UI.Widgets.Int2InputField",e.Int3InputField="Game.UI.Widgets.Int3InputField",e.Int4InputField="Game.UI.Widgets.Int4InputField",e.UIntInputField="Game.UI.Widgets.UIntInputField",e.UIntSliderField="Game.UI.Widgets.UIntSliderField",e.TimeSliderField="Game.UI.Widgets.TimeSliderField",e.TimeBoundsSliderField="Game.UI.Widgets.TimeBoundsSliderField",e.FloatInputField="Game.UI.Widgets.FloatInputField",e.FloatSliderField="Game.UI.Widgets.FloatSliderField",e.Float2InputField="Game.UI.Widgets.Float2InputField",e.Float2SliderField="Game.UI.Widgets.Float2SliderField",e.Float3InputField="Game.UI.Widgets.Float3InputField",e.Float3SliderField="Game.UI.Widgets.Float3SliderField",e.EulerAnglesField="Game.UI.Widgets.EulerAnglesField",e.Float4InputField="Game.UI.Widgets.Float4InputField",e.Float4SliderField="Game.UI.Widgets.Float4SliderField",e.Bounds1SliderField="Game.UI.Widgets.Bounds1SliderField",e.Bounds1InputField="Game.UI.Widgets.Bounds1InputField",e.Bounds2InputField="Game.UI.Widgets.Bounds2InputField",e.Bounds3InputField="Game.UI.Widgets.Bounds3InputField",e.Bezier4x3Field="Game.UI.Widgets.Bezier4x3Field",e.StringInputField="Game.UI.Widgets.StringInputField",e.ColorField="Game.UI.Widgets.ColorField",e.AnimationCurveField="Game.UI.Widgets.AnimationCurveField",e.EnumField="Game.UI.Widgets.EnumField",e.FlagsField="Game.UI.Widgets.FlagsField",e.PopupValueField="Game.UI.Widgets.PopupValueField",e.DropdownField="Game.UI.Widgets.DropdownField",e.DirectoryPickerButton="Game.UI.Widgets.DirectoryPickerButton",e.SeasonsField="Game.UI.Widgets.SeasonsField",e.ImageField="Game.UI.Widgets.ImageField"}(FR||(FR={})),function(e){e[e.Vertical=0]="Vertical",e[e.Horizontal=1]="Horizontal"}(UR||(UR={})),function(e){e[e.Title=0]="Title",e[e.Cotnainer=1]="Cotnainer"}(GR||(GR={})),oe.add("game-ui/widgets/data-binding/widget-bindings.ts",{get WidgetType(){return FR},set WidgetType(e){FR=e},get combinePath(){return HR},set combinePath(e){HR=e},get usePathFocusKey(){return KR},set usePathFocusKey(e){KR=e},get ScrollableDirection(){return UR},set ScrollableDirection(e){UR=e},get TooltipPos(){return GR},set TooltipPos(e){GR=e},get toBigIntMember(){return WR},set toBigIntMember(e){WR=e},get invoke(){return zR},set invoke(e){zR=e},get setValue(){return YR},set setValue(e){YR=e},get setExpanded(){return $R},set setExpanded(e){$R=e},get openDirectory(){return qR},set openDirectory(e){qR=e},get addListElement(){return XR},set addListElement(e){XR=e},get duplicateListElement(){return QR},set duplicateListElement(e){QR=e},get moveListElement(){return ZR},set moveListElement(e){ZR=e},get deleteListElement(){return JR},set deleteListElement(e){JR=e},get clearList(){return eD},set clearList(e){eD=e},get setCurrentPageIndex(){return tD},set setCurrentPageIndex(e){tD=e},get moveKeyframe(){return nD},set moveKeyframe(e){nD=e},get addKeyframe(){return rD},set addKeyframe(e){rD=e},get removeKeyframe(){return iD},set removeKeyframe(e){iD=e},get setKeyframes(){return oD},set setKeyframes(e){oD=e},get addSeason(){return aD},set addSeason(e){aD=e},get updateSeason(){return sD},set updateSeason(e){sD=e},get deleteSeason(){return lD},set deleteSeason(e){lD=e}}),oe.add("game-ui/widgets/components/widget-props.ts",{get useRootId(){return cD},set useRootId(e){cD=e},get useWidgetId(){return uD},set useWidgetId(e){uD=e}});var yD=function(e){var t=e.typeName;return(0,z.jsx)("div",{style:{backgroundColor:"red",color:"yellow"},children:"Unknown element type ".concat(t)})};function xD(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function _D(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){xD(e,t,n[t])}))}return e}function jD(e){var t=e.parent,n=e.components,r=e.data,i=r.props.__Type,o=n[i];return null!=o?(0,z.jsx)(ED.Provider,{value:n,children:(0,z.jsx)(o,_D({parent:t},r))}):(0,z.jsx)(yD,{typeName:i})}function OD(e){var t=e.parent,n=e.components,r=e.data;return(0,z.jsx)(ED.Provider,{value:n,children:null!=(null==r?void 0:r.map)?r.map((function(e){if(null!=e&&!e.props.hidden){var r=e.path,i=e.props.__Type,o=n[i];return null!=o?(0,z.jsx)(o,_D({parent:t},e),r):(0,z.jsx)(yD,{typeName:i},r)}})):JSON.stringify(r)})}oe.add("game-ui/common/typed-renderer/typed-renderer.tsx",{get entityKeyProvider(){return hD},set entityKeyProvider(e){hD=e},get TypedRenderer(){return pD},set TypedRenderer(e){pD=e},get TypedListRenderer(){return vD},set TypedListRenderer(e){vD=e},get renderTyped(){return bD},set renderTyped(e){bD=e},get UnknownElement(){return yD},set UnknownElement(e){yD=e}});var ED=(0,Y.createContext)({});oe.add("game-ui/widgets/components/widget-renderer.tsx",{get WidgetRenderer(){return jD},set WidgetRenderer(e){jD=e},get WidgetListRenderer(){return OD},set WidgetListRenderer(e){OD=e},get WidgetComponentMapContext(){return ED},set WidgetComponentMapContext(e){ED=e}});let SD={button:"button_hxl button_k8s"};oe.add("game-ui/debug/widgets/button/button.module.scss",{get classes(){return SD},set classes(e){Object.assign(SD,e)}});const TD=SD;var ID=function(e){var t=e.parent,n=e.path,r=e.props,i=uD(t,n),o=RR(zR,i),a=KR(i.path);return(0,z.jsx)(wD,{onSelect:o,focusKey:a,children:(0,z.jsx)(ku,{value:r.displayName})})};function wD(e){var t=e.focusKey,n=e.children,r=e.onSelect;return(0,z.jsx)(Qp,{focusKey:t,theme:TD,onSelect:r,children:n||" "})}oe.add("game-ui/debug/widgets/button/button.tsx",{get BoundDebugButton(){return ID},set BoundDebugButton(e){ID=e}});let PD={title:"title_Xkf",children:"children_HxX"};oe.add("game-ui/debug/widgets/container/container.module.scss",{get classes(){return PD},set classes(e){Object.assign(PD,e)}});const CD=PD;var ND=function(e){var t=e.parent,n=e.path,r=e.children,i=e.props,o=uD(t,n),a=(0,Y.useContext)(ED);return(0,z.jsx)(AD,{title:(0,z.jsx)(ku,{value:i.displayName}),children:(0,z.jsx)(OD,{parent:o,components:a,data:r})})},AD=function(e){var t=e.title,n=e.children;return(0,z.jsxs)("div",{className:CD.container,children:[t&&(0,z.jsx)("div",{className:CD.title,children:t}),(0,z.jsx)("div",{className:CD.children,children:n})]})};oe.add("game-ui/debug/widgets/container/container.tsx",{get BoundContainer(){return ND},set BoundContainer(e){ND=e},get Container(){return AD},set Container(e){AD=e}});let LD={button:"button__Wn",value:"value_fMT"};oe.add("game-ui/debug/widgets/fields/arrow-control/arrow-control.module.scss",{get classes(){return LD},set classes(e){Object.assign(LD,e)}});const MD=LD;function kD(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function RD(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return kD(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return kD(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var DD=function(e){var t=e.onSelectLeft,n=e.onSelectRight,r=e.children,i=(0,Y.useRef)(!1),o=RD((0,Y.useState)(!1),2),a=o[0],s=o[1];(0,Y.useEffect)((function(){a||(i.current=!1)}),[a]);var l=(0,Y.useMemo)((function(){return{"Debug Change Field":function(e){e<0?t(i.current):n(i.current)},"Debug Multiplier":function(e){i.current=e>0}}}),[t,n]),c=(0,Y.useCallback)((function(){return t(i.current)}),[t]),u=(0,Y.useCallback)((function(){return n(i.current)}),[n]);return(0,z.jsx)(Tg,{onFocusChange:s,children:(0,z.jsxs)(rp,{actions:l,children:[(0,z.jsx)(Qp,{focusKey:Hh,className:MD.button,onSelect:c,children:"<"}),(0,z.jsx)(Yv,{className:MD.value,children:r}),(0,z.jsx)(Qp,{focusKey:Hh,className:MD.button,onSelect:u,children:">"})]})})};oe.add("game-ui/debug/widgets/fields/arrow-control/arrow-control.tsx",{get ArrowControl(){return DD},set ArrowControl(e){DD=e}});let FD={field:"field_vGA",label:"label_KyX",control:"control_b3l"};oe.add("game-ui/debug/widgets/fields/field-layout/field-layout.module.scss",{get classes(){return FD},set classes(e){Object.assign(FD,e)}});const UD=FD;var GD=function(e){var t=e.label,n=e.children;return(0,z.jsxs)(Yv,{className:UD.field,children:[(0,z.jsx)("div",{className:UD.label,children:t||" "}),(0,z.jsx)("div",{className:UD.control,children:n})]})};oe.add("game-ui/debug/widgets/fields/field-layout/field-layout.tsx",{get FieldLayout(){return GD},set FieldLayout(e){GD=e}});var BD=function(e){var t=e.label,n=e.value,r=e.min,i=e.max,o=e.step,a=void 0===o?1:o,s=e.stepMultiplier,l=void 0===s?10:s,c=e.onChange,u=(0,Y.useCallback)((function(e){var t=n-(e?l:a);null!=r&&(t=Math.max(r,t)),null!=i&&(t=Math.min(t,i)),t!==n&&c(t)}),[a,l,i,r,c,n]),d=(0,Y.useCallback)((function(e){var t=n+(e?l:a);null!=r&&(t=Math.max(r,t)),null!=i&&(t=Math.min(t,i)),t!==n&&c(t)}),[a,l,i,r,c,n]);return(0,z.jsx)(GD,{label:t,children:(0,z.jsx)(DD,{onSelectLeft:u,onSelectRight:d,children:"".concat(n)})})},VD=function(e){var t=e.label,n=e.value,r=e.min,i=e.max,o=e.step,a=void 0===o?1:o,s=e.stepMultiplier,l=void 0===s?10:s,c=e.fractionDigits,u=void 0===c?0:c,d=e.onChange,f=(0,Y.useCallback)((function(e){var t=n-(e?l:a);null!=r&&(t=Math.max(r,t)),null!=i&&(t=Math.min(t,i)),t!==n&&d(t)}),[a,l,i,r,d,n]),m=(0,Y.useCallback)((function(e){var t=n+(e?l:a);null!=r&&(t=Math.max(r,t)),null!=i&&(t=Math.min(t,i)),t!==n&&d(t)}),[a,l,i,r,d,n]);return(0,z.jsx)(GD,{label:t,children:(0,z.jsx)(DD,{onSelectLeft:f,onSelectRight:m,children:"".concat(n.toFixed(u))})})};oe.add("game-ui/debug/widgets/fields/arrow-field.tsx",{get IntArrowField(){return BD},set IntArrowField(e){BD=e},get FloatArrowField(){return VD},set FloatArrowField(e){VD=e}});let HD={"foldout-button":"foldout-button_Ugi",foldoutButton:"foldout-button_Ugi",arrow:"arrow_wFy",expanded:"expanded_S2V",label:"label_qS_",value:"value_ypy"};oe.add("game-ui/debug/widgets/foldout/foldout.module.scss",{get classes(){return HD},set classes(e){Object.assign(HD,e)}});const KD=HD;function WD(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function zD(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return WD(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return WD(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var YD=function(e){var t=e.parent,n=e.path,r=e.children,i=e.props,o=uD(t,n),a=(0,Y.useContext)(ED),s=RR($R,o);return(0,z.jsx)($D,{title:(0,z.jsx)(ku,{value:i.displayName}),opened:i.expanded,onOpenedChange:s,children:(0,z.jsx)(OD,{parent:o,components:a,data:r})})},$D=function(e){var t=e.title,n=e.value,r=e.opened,i=e.children,o=e.onOpenedChange,a=(0,Y.useCallback)((function(){return o(!r)}),[o,r]);return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsxs)(Qp,{onSelect:a,className:_d()(KD.foldoutButton,r&&KD.expanded),children:[(0,z.jsx)("div",{className:KD.arrow}),(0,z.jsx)("div",{className:KD.label,children:t}),n&&(0,z.jsx)("div",{className:KD.value,children:n})]}),r&&(0,z.jsx)(AD,{title:null,children:i})]})},qD=function(e){var t=e.title,n=e.value,r=e.children,i=zD((0,Y.useState)(!1),2),o=i[0],a=i[1];return(0,z.jsx)($D,{title:t,value:n,opened:o,onOpenedChange:a,children:r})};oe.add("game-ui/debug/widgets/foldout/foldout.tsx",{get BoundFoldout(){return YD},set BoundFoldout(e){YD=e},get Foldout(){return $D},set Foldout(e){$D=e},get StatefulFoldout(){return qD},set StatefulFoldout(e){qD=e}});let XD={slider:"slider_pUS","track-bounds":"track-bounds_H8_",trackBounds:"track-bounds_H8_","range-bounds":"range-bounds_lNt",rangeBounds:"range-bounds_lNt",range:"range_iUN","thumb-container":"thumb-container_aso",thumbContainer:"thumb-container_aso"};oe.add("game-ui/common/input/slider/slider.module.scss",{get classes(){return XD},set classes(e){Object.assign(XD,e)}});const QD=XD;let ZD={slider:"slider_g0V slider_pUS",compact:"compact_pTl",thumb:"thumb_WZt",range:"range_K3G range_iUN"};oe.add("game-ui/common/input/slider/themes/default.module.scss",{get classes(){return ZD},set classes(e){Object.assign(ZD,e)}});const JD=ZD;function eF(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function tF(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function nF(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return eF(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return eF(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var rF={dragStart:Lp.grabSlider,drag:Lp.dragSlider},iF={dragStart:Lp.grabSlider,drag:Lp.dragSlider,scaleDragVolume:!0},oF=Y.forwardRef((function(e,t){var n=e.focusKey,r=e.debugName,i=void 0===r?"Slider":r,o=e.value,a=e.start,s=e.end,l=e.gamepadStep,c=e.disabled,u=e.vertical,d=void 0!==u&&u,f=e.sounds,m=void 0===f?rF:f,g=e.thumb,h=e.theme,p=void 0===h?JD:h,v=e.className,b=e.style,y=e.children,x=e.noFill,_=e.valueTransformer,j=void 0===_?aF:_,O=e.onChange,E=e.onDragStart,S=e.onDragEnd,T=e.onMouseOver,I=e.onMouseLeave,w=(0,Y.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){tF(e,t,n[t])}))}return e}({},QD,p)}),[p]),P=null!=g?g:w.thumb?(0,z.jsx)("div",{className:w.thumb}):void 0,C=(0,Y.useRef)(null),N=Hd(t,C),A=Hp(zh(null!=n?n:c?Hh:Kh,i),C),L=jg(A),M=Pg(),k=s-a,R=0!==k?(o-a)/k:0,D=null!=l&&l>0?l/k:.05,F=(0,Y.useMemo)((function(){return{"Change Slider Value":null!=O?function(e){if(0!==e){var t=j(a,s,R+e*D);t!==o&&(O(t),kp(null==m?void 0:m.drag,(null==m?void 0:m.scaleDragVolume)&&0!==k?(o-a)/k:1))}}:null}}),[O,j,a,s,R,D,o,null==m?void 0:m.drag,null==m?void 0:m.scaleDragVolume,k]),U=(0,Y.useRef)(null),G=(0,Y.useRef)(0),B=(0,Y.useCallback)((function(e){var t=e.clientX,n=e.clientY;if(c||!U.current)return!1;if(function(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}(document.activeElement,HTMLElement)&&document.activeElement.blur(),kp(null==m?void 0:m.dragStart),E&&E(),O){var r=j(a,s,cF(U.current,t,n,G.current,d));r!==o&&O(r)}return!0}),[c,s,O,E,a,null==m?void 0:m.dragStart,o,j,d]),V=(0,Y.useCallback)((function(e){var t=e.clientX,n=e.clientY;if(!c&&O&&U.current){var r=j(a,s,cF(U.current,t,n,G.current,d));r!==o&&(O(r),kp(null==m?void 0:m.drag,(null==m?void 0:m.scaleDragVolume)&&0!==k?(o-a)/k:1))}}),[c,O,j,a,s,d,o,null==m?void 0:m.drag,null==m?void 0:m.scaleDragVolume,k]),H=nF(sE(B,V,(0,Y.useCallback)((function(){G.current=0,S&&S()}),[S])),2),K=H[0],W=H[1],$=(0,Y.useCallback)((function(e){if(U.current)if(d){var t=U.current.getBoundingClientRect(),n=t.top+t.height*(1-R);G.current=e.clientY-n}else{var r=U.current.getBoundingClientRect(),i=r.left+r.width*R;G.current=e.clientX-i}}),[R,d]),q="".concat(100*of(R,0,1),"%");return(0,z.jsx)(rp,{actions:F,disabled:c,children:(0,z.jsx)(Sg,{controller:A,children:(0,z.jsxs)("div",{ref:N,className:_d()(w.slider,d?"vertical":"horizontal",c&&"disabled",L&&M&&"focused",K&&"dragging",v),style:b,onMouseDown:c?void 0:W,children:[y,(0,z.jsx)("div",{ref:U,className:w.trackBounds,onMouseOver:T,onMouseLeave:I,children:(0,z.jsxs)("div",{className:w.rangeBounds,style:tF({},d?"height":"width",q),children:[!x&&(0,z.jsx)("div",{className:w.range}),P&&(0,z.jsx)("div",{className:w.thumbContainer,onClick:c?void 0:iv,onMouseDown:c?void 0:$,onMouseOver:T,onMouseLeave:I,children:P})]})})]})})})}));function aF(e,t,n){return of(e+n*(t-e),Math.min(e,t),Math.max(e,t))}function sF(e,t,n){return of(Math.round(e+n*(t-e)),Math.min(e,t),Math.max(e,t))}function lF(e){return(0,Y.useCallback)((function(t,n,r){return of(t+Math.round(r*(n-t)/e)*e,Math.min(t,n),Math.max(t,n))}),[e])}function cF(e,t,n,r,i){var o=e.getBoundingClientRect(),a=o.top,s=o.left,l=o.width,c=o.height;return i?(c-(n-a-r))/c:(t-s-r)/l}oe.add("game-ui/common/input/slider/slider.tsx",{get defaultSliderSounds(){return rF},set defaultSliderSounds(e){rF=e},get volumeSliderSounds(){return iF},set volumeSliderSounds(e){iF=e},get Slider(){return oF},set Slider(e){oF=e},get intTransformer(){return sF},set intTransformer(e){sF=e},get useStepTransformer(){return lF},set useStepTransformer(e){lF=e}});let uF={slider:"slider_HvX slider_pUS",value:"value_Ob7",range:"range_LNR range_iUN"};oe.add("game-ui/debug/themes/slider.module.scss",{get classes(){return uF},set classes(e){Object.assign(uF,e)}});const dF=uF;function fF(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function mF(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){fF(e,t,n[t])}))}return e}function gF(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var hF=function(e){var t=e.label,n=e.value,r=e.min,i=e.max,o=e.step,a=void 0===o?1:o,s=e.onChange,l=lF(a);return(0,z.jsx)(GD,{label:t,children:(0,z.jsx)(oF,{value:n,start:r,end:i,valueTransformer:l,theme:dF,onChange:s,children:(0,z.jsx)("div",{className:dF.value,children:"".concat(n)})})})},pF=function(e){var t=e.label,n=e.value,r=e.min,i=e.max,o=e.step,a=e.fractionDigits,s=e.onChange,l=lF(o||1);return(0,z.jsx)(GD,{label:t,children:(0,z.jsx)(oF,{value:n,start:r,end:i,valueTransformer:l,theme:dF,onChange:s,children:(0,z.jsx)("div",{className:dF.value,children:"".concat(n.toFixed(a))})})})},vF=function(e){var t=e.label,n=e.value,r=e.step,i=e.fractionDigits,o=e.min,a=e.max,s=e.onChange,l=(0,Y.useCallback)((function(e){return s(gF(mF({},n),{x:e}))}),[s,n]),c=(0,Y.useCallback)((function(e){return s(gF(mF({},n),{y:e}))}),[s,n]);return(0,z.jsxs)(qD,{title:t,value:_f(n,null!=i?i:1),children:[(0,z.jsx)(pF,{label:"X",value:n.x,min:o,max:a,onChange:l,step:r,fractionDigits:i}),(0,z.jsx)(pF,{label:"Y",value:n.y,min:o,max:a,onChange:c,step:r,fractionDigits:i})]})},bF=function(e){var t=e.label,n=e.value,r=e.step,i=e.fractionDigits,o=e.min,a=e.max,s=e.onChange,l=(0,Y.useCallback)((function(e){return s(gF(mF({},n),{x:e}))}),[s,n]),c=(0,Y.useCallback)((function(e){return s(gF(mF({},n),{y:e}))}),[s,n]),u=(0,Y.useCallback)((function(e){return s(gF(mF({},n),{z:e}))}),[s,n]);return(0,z.jsxs)(qD,{title:t,value:Sf(n,null!=i?i:1),children:[(0,z.jsx)(pF,{label:"X",value:n.x,min:o,max:a,onChange:l,step:r,fractionDigits:i}),(0,z.jsx)(pF,{label:"Y",value:n.y,min:o,max:a,onChange:c,step:r,fractionDigits:i}),(0,z.jsx)(pF,{label:"Z",value:n.z,min:o,max:a,onChange:u,step:r,fractionDigits:i})]})},yF=function(e){var t=e.label,n=e.value,r=e.step,i=e.fractionDigits,o=e.min,a=e.max,s=e.onChange,l=(0,Y.useCallback)((function(e){return s(gF(mF({},n),{x:e}))}),[s,n]),c=(0,Y.useCallback)((function(e){return s(gF(mF({},n),{y:e}))}),[s,n]),u=(0,Y.useCallback)((function(e){return s(gF(mF({},n),{z:e}))}),[s,n]),d=(0,Y.useCallback)((function(e){return s(gF(mF({},n),{w:e}))}),[s,n]);return(0,z.jsxs)(qD,{title:t,value:wf(n,null!=i?i:1),children:[(0,z.jsx)(pF,{label:"X",value:n.x,min:o,max:a,onChange:l,step:r,fractionDigits:i}),(0,z.jsx)(pF,{label:"Y",value:n.y,min:o,max:a,onChange:c,step:r,fractionDigits:i}),(0,z.jsx)(pF,{label:"Z",value:n.z,min:o,max:a,onChange:u,step:r,fractionDigits:i}),(0,z.jsx)(pF,{label:"W",value:n.w,min:o,max:a,onChange:d,step:r,fractionDigits:i})]})};oe.add("game-ui/debug/widgets/fields/slider-field.tsx",{get IntSliderField(){return hF},set IntSliderField(e){hF=e},get FloatSliderField(){return pF},set FloatSliderField(e){pF=e},get Float2SliderField(){return vF},set Float2SliderField(e){vF=e},get Float3SliderField(){return bF},set Float3SliderField(e){bF=e},get Float4SliderField(){return yF},set Float4SliderField(e){yF=e}});let xF={"swatch-title":"swatch-title_d15",swatchTitle:"swatch-title_d15","swatch-alpha":"swatch-alpha_MYB",swatchAlpha:"swatch-alpha_MYB",swatch:"swatch_OaZ",label:"label_FVu"};oe.add("game-ui/debug/widgets/fields/color-field/color-field.module.scss",{get classes(){return xF},set classes(e){Object.assign(xF,e)}});const _F=xF;function jF(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function OF(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){jF(e,t,n[t])}))}return e}function EF(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var SF=function(e){var t=e.label,n=e.value,r=e.showAlpha,i=e.onChange,o=(0,Y.useCallback)((function(e){return i(EF(OF({},n),{r:e}))}),[i,n]),a=(0,Y.useCallback)((function(e){return i(EF(OF({},n),{g:e}))}),[i,n]),s=(0,Y.useCallback)((function(e){return i(EF(OF({},n),{b:e}))}),[i,n]),l=(0,Y.useCallback)((function(e){return i(EF(OF({},n),{a:e}))}),[i,n]);return(0,z.jsxs)(qD,{title:(0,z.jsxs)("div",{className:_F.swatchTitle,children:[(0,z.jsx)("div",{className:_F.swatchAlpha,children:(0,z.jsx)("div",{className:_F.swatch,style:{backgroundColor:rP(n)}})}),(0,z.jsx)("div",{className:_F.label,children:t})]}),children:[(0,z.jsx)(pF,{label:"Red",value:n.r,onChange:o,min:0,max:1,step:.001,fractionDigits:3}),(0,z.jsx)(pF,{label:"Green",value:n.g,onChange:a,min:0,max:1,step:.001,fractionDigits:3}),(0,z.jsx)(pF,{label:"Blue",value:n.b,onChange:s,min:0,max:1,step:.001,fractionDigits:3}),r&&(0,z.jsx)(pF,{label:"Alpha",value:n.a,onChange:l,min:0,max:1,step:.001,fractionDigits:3})]})};oe.add("game-ui/debug/widgets/fields/color-field/color-field.tsx",{get ColorField(){return SF},set ColorField(e){SF=e}});let TF={toggle:"toggle_x2y"};oe.add("game-ui/debug/widgets/fields/toggle-field/toggle-field.module.scss",{get classes(){return TF},set classes(e){Object.assign(TF,e)}});const IF=TF;var wF=function(e){var t=e.label,n=e.value,r=e.onChange;return(0,z.jsx)(GD,{label:t,children:(0,z.jsx)(fv,{checked:n,className:IF.toggle,onChange:r})})};oe.add("game-ui/debug/widgets/fields/toggle-field/toggle-field.tsx",{get ToggleField(){return wF},set ToggleField(e){wF=e}});var PF=function(e){var t=e.label,n=e.value,r=e.enumMembers,i=e.onChange,o=(0,Y.useMemo)((function(){return r.findIndex((function(e){return Rf(e.value,n)}))}),[r,n]),a=(0,Y.useCallback)((function(){var e=lC(r,o,!0);null!=e&&i(e.value)}),[r,i,o]),s=(0,Y.useCallback)((function(){var e=aC(r,o,!0);null!=e&&i(e.value)}),[r,i,o]);return(0,z.jsx)(GD,{label:t,children:(0,z.jsx)(DD,{onSelectLeft:a,onSelectRight:s,children:-1!==o?(0,z.jsx)(ku,{value:r[o].displayName}):"".concat(o)})})},CF=function(e){var t=e.label,n=e.value,r=e.enumMembers,i=e.onChange,o=(0,Y.useCallback)((function(e,t){i(Ff(t?Df(n)|Df(e.value):Df(n)&~Df(e.value)))}),[i,n]);return(0,z.jsx)(qD,{title:t,children:r.filter((function(e){return!Rf(e.value,kf)})).map((function(e,t){return(0,z.jsx)(NF,{enumMember:e,checked:(Df(n)&Df(e.value))===Df(e.value),onChange:o},t)}))})},NF=function(e){var t=e.enumMember,n=e.checked,r=e.onChange,i=(0,Y.useCallback)((function(e){return r(t,e)}),[t,r]);return(0,z.jsx)(wF,{label:(0,z.jsx)(ku,{value:t.displayName}),value:n,onChange:i})};oe.add("game-ui/debug/widgets/fields/enum-field.tsx",{get EnumField(){return PF},set EnumField(e){PF=e},get BitField(){return CF},set BitField(e){CF=e}});let AF={"text-input":"text-input_Y20",textInput:"text-input_Y20"};oe.add("game-ui/debug/widgets/fields/input-field/input-field.module.scss",{get classes(){return AF},set classes(e){Object.assign(AF,e)}});const LF=AF;function MF(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function kF(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return MF(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return MF(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var RF=function(e){var t=e.label,n=e.value,r=e.onChange,i=kF((0,Y.useState)(n),2),o=i[0],a=i[1];(0,Y.useEffect)((function(){return a(n)}),[n]);var s=(0,Y.useCallback)((function(){r(o)}),[r,o]),l=(0,Y.useCallback)((function(e){a(e.target.value)}),[]);return(0,z.jsx)(GD,{label:t,children:(0,z.jsx)(yb,{value:o,className:LF.textInput,onChange:l,onBlur:s})})},DF=function(e){var t=e.label,n=e.value,r=e.onChange,i=kF((0,Y.useState)(n.toString()),2),o=i[0],a=i[1];(0,Y.useEffect)((function(){return a(n.toString())}),[n]);var s=(0,Y.useCallback)((function(){var e=Number(o);isNaN(e)||r(e)}),[r,o]),l=(0,Y.useCallback)((function(e){""!==e.target.value&&isNaN(Number(e.target.value))||a(e.target.value)}),[]);return(0,z.jsx)(GD,{label:t,children:(0,z.jsx)(yb,{value:o,className:LF.textInput,onChange:l,onBlur:s})})};oe.add("game-ui/debug/widgets/fields/input-field/input-field.tsx",{get StringInputField(){return RF},set StringInputField(e){RF=e},get IntInputField(){return DF},set IntInputField(e){DF=e}});var FF=function(e){var t=e.props;return(0,z.jsx)(GD,{label:(0,z.jsx)(ku,{value:t.displayName}),children:t.value})};oe.add("game-ui/debug/widgets/fields/value-field.tsx",{get BoundValueField(){return FF},set BoundValueField(e){FF=e}});let UF={image:"image_BEo"};oe.add("game-ui/debug/widgets/image/image.module.scss",{get classes(){return UF},set classes(e){Object.assign(UF,e)}});const GF=UF;var BF=function(e){var t=e.props;return(0,z.jsx)(GD,{label:(0,z.jsx)(ku,{value:t.displayName}),children:(0,z.jsx)("img",{src:t.uri,className:GF.image})})};function VF(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function HF(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}oe.add("game-ui/debug/widgets/image/image.tsx",{get BoundImage(){return BF},set BoundImage(e){BF=e}});var KF,WF=function(e){var t=e.parent,n=e.data;return(0,z.jsx)(OD,{parent:t,components:zF,data:n})},zF=(VF(KF={},FR.Group,ND),VF(KF,FR.ExpandableGroup,YD),VF(KF,FR.Button,ID),VF(KF,FR.ValueField,FF),VF(KF,FR.ToggleField,YF(wF)),VF(KF,FR.IntSliderField,YF(hF)),VF(KF,DR.IntArrowField,YF(BD)),VF(KF,FR.IntInputField,YF(DF)),VF(KF,FR.UIntSliderField,YF(hF)),VF(KF,DR.UIntArrowField,YF(BD)),VF(KF,FR.FloatSliderField,YF(pF)),VF(KF,DR.FloatArrowField,YF(VD)),VF(KF,FR.Float2SliderField,YF(vF)),VF(KF,FR.Float3SliderField,YF(bF)),VF(KF,FR.Float4SliderField,YF(yF)),VF(KF,FR.EnumField,YF(PF)),VF(KF,FR.FlagsField,YF(CF)),VF(KF,FR.ColorField,YF(SF)),VF(KF,FR.StringInputField,YF(RF)),VF(KF,DR.Image,BF),KF);function YF(e){var t,n=function(t){var n=t.parent,r=t.path,i=t.props,o=RR(YR,uD(n,r));return(0,z.jsx)(e,HF(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){VF(e,t,n[t])}))}return e}({},i),{label:(0,z.jsx)(ku,{value:i.displayName}),onChange:o}))};return n.displayName=null!==(t=e.displayName)&&void 0!==t?t:e.name,n}oe.add("game-ui/debug/widgets/debug-widget-renderer.tsx",{get DebugWidgetListRenderer(){return WF},set DebugWidgetListRenderer(e){WF=e},get debugWidgetComponents(){return zF},set debugWidgetComponents(e){zF=e}});let $F={title:"title_f1a",value:"value_bvH"};oe.add("game-ui/debug/components/debug-binding-output/debug-binding-output.module.scss",{get classes(){return $F},set classes(e){Object.assign($F,e)}});const qF=$F;function XF(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function QF(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return XF(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return XF(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var ZF=function(e){var t=e.binding,n=e.className,r=QF((0,Y.useState)(0),2),i=r[0],o=r[1],a=QF((0,Y.useState)(""),2),s=a[0],l=a[1];return(0,Y.useEffect)((function(){var e=function(e){l(JSON.stringify(e,null,2)),o((function(e){return e+1}))};if(t.debugType===gR.Event){var n=hl(t.group,t.name),r=n.subscribe(e);return function(){r.dispose(),n.dispose()}}if(t.debugType===gR.Value){var i=fl(t.group,t.name,"undefined"),a=i.subscribe();return l(JSON.stringify(a.value,null,2)),o(0),a.setChangeListener(e),function(){a.dispose(),i.dispose()}}}),[t.group,t.name,t.debugType]),(0,z.jsxs)("div",{className:_d()(qF.debugBindingOutput,n),children:[(0,z.jsx)("div",{className:qF.title,children:"".concat(t.group,".").concat(t.name,", Update Count: ").concat(i)}),(0,z.jsx)("div",{className:qF.value,children:s})]})};oe.add("game-ui/debug/components/debug-binding-output/debug-binding-output.tsx",{get DebugBindingOutput(){return ZF},set DebugBindingOutput(e){ZF=e}});let JF={"fps-display":"fps-display_t30",fpsDisplay:"fps-display_t30",value:"value_vNu",graph:"graph_EEa"};oe.add("game-ui/debug/components/fps-display/fps-display.module.scss",{get classes(){return JF},set classes(e){Object.assign(JF,e)}});const eU=JF;var tU=function(){switch(xl(Ch)){case Oh.Simple:return(0,z.jsx)(nU,{});case Oh.Advanced:return(0,z.jsx)(oU,{});case Oh.Precise:return(0,z.jsx)(aU,{});default:return null}},nU=function(){var e=xl(Nh);return(0,z.jsx)("div",{className:eU.fpsDisplay,children:(0,z.jsx)("div",{className:eU.value,children:"".concat(e.fps.toFixed(0).padStart(3," ")," FPS")})})},rU=250,iU=50,oU=function(){var e=xl(Nh),t=e.fps>0?1e3/e.fps:0,n=jl(Nh),r=(0,Y.useRef)(null);return(0,Y.useEffect)((function(){for(var e=new Array(rU),t=e.length-1,i=30,o=0;o<e.length;o++)e[o]=0;var a=0;return function o(){var s;t=(t+1)%e.length,e[t]=n.current.fps,i=Math.max(n.current.fps,i);var l=null===(s=r.current)||void 0===s?void 0:s.getContext("2d");if(null!=l){l.fillStyle="rgb(0, 0, 0)",l.fillRect(0,0,l.canvas.width,l.canvas.height);for(var c=0;c<e.length;c++){var u=e[(e.length+t-c)%e.length],d=u/i*iU;l.fillStyle=rP(fU(u)),l.fillRect(rU-c-1,iU-d,1,d)}}a=window.requestAnimationFrame(o)}(),function(){return window.cancelAnimationFrame(a)}}),[n]),(0,z.jsx)(z.Fragment,{children:(0,z.jsxs)("div",{className:eU.fpsDisplay,children:[(0,z.jsx)("canvas",{ref:r,className:eU.graph,width:rU,height:iU}),(0,z.jsxs)("div",{className:eU.value,children:["Frame: ".concat(t.toFixed(2).padStart(7," "),"ms"),"".concat(e.fps.toFixed(2)," FPS")]})]})})},aU=function(){var e=xl(Nh),t=jl(Nh),n=(0,Y.useRef)(null);return(0,Y.useEffect)((function(){for(var e=new Array(rU),r=e.length-1,i=30,o=0;o<e.length;o++)e[o]=0;var a=0;return function o(){var s;r=(r+1)%e.length,e[r]=t.current.fps,i=Math.max(t.current.fps,i);var l=null===(s=n.current)||void 0===s?void 0:s.getContext("2d");if(null!=l){l.fillStyle="rgb(0, 0, 0)",l.fillRect(0,0,l.canvas.width,l.canvas.height);for(var c=0;c<e.length;c++){var u=e[(e.length+r-c)%e.length],d=u/i*iU;l.fillStyle=rP(fU(u)),l.fillRect(rU-c-1,iU-d,1,d)}}a=window.requestAnimationFrame(o)}(),function(){return window.cancelAnimationFrame(a)}}),[t]),(0,z.jsx)(z.Fragment,{children:(0,z.jsxs)("div",{className:eU.fpsDisplay,children:[(0,z.jsx)("canvas",{ref:n,className:eU.graph,width:rU,height:iU}),(0,z.jsxs)("div",{className:eU.value,children:["CPU Main: ".concat(e.cpuMainThreadTime.toFixed(2).padStart(5," "),"ms    Render: ").concat(e.cpuRenderThreadTime.toFixed(2).padStart(5," "),"ms"),"GPU: ".concat(e.gpuTime.toFixed(2).padStart(5," "),"ms     Total: ").concat(e.fullFameTime.toFixed(2).padStart(5," "),"ms"),"".concat(e.fps.toFixed(2)," FPS")]})]})})},sU=20,lU=4,cU={r:0,g:1,b:0,a:1},uU={r:1,g:1,b:0,a:1},dU={r:1,g:0,b:0,a:1};function fU(e){var t=of((e-lU)/(sU-lU),0,1);return t<.5?uP(dU,uU,2*t):uP(uU,cU,2*t-1)}oe.add("game-ui/debug/components/fps-display/fps-display.tsx",{get FpsDisplay(){return tU},set FpsDisplay(e){tU=e}});let mU={"color-legend":"color-legend_Bzi",colorLegend:"color-legend_Bzi",symbol:"symbol_aAH",value:"value_rfe"};oe.add("game-ui/common/charts/legends/color-legend.module.scss",{get classes(){return mU},set classes(e){Object.assign(mU,e)}});const gU=mU;var hU=function(e){var t=e.color,n=e.label,r=e.className,i=e.children;return(0,z.jsxs)("div",{className:_d()(gU.colorLegend,r),children:[(0,z.jsx)(pU,{color:t}),(0,z.jsx)("div",{className:gU.label,children:n}),Y.Children.count(i)>0&&(0,z.jsx)("div",{className:gU.value,children:i})]})},pU=function(e){var t=e.color,n=e.className;return(0,z.jsx)("div",{className:_d()(gU.symbol,n),style:{backgroundColor:t}})};function vU(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function bU(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function yU(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){bU(e,t,n[t])}))}return e}function xU(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function _U(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function jU(e){return function(e){if(Array.isArray(e))return vU(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return vU(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return vU(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function OU(e){var t,n=e.type,r=e.data,i=e.options,o=e.mergeCallback,a=void 0===o?SU:o,s=_U(e,["type","data","options","mergeCallback"]),l=(0,Y.useRef)(null),c=(0,Y.useRef)(null),u=(0,Y.useRef)(null),d=null!==(t=Kf(u))&&void 0!==t?t:lf,f=d.x>0&&d.y>0,m=$O(),g=(0,Y.useCallback)((function(e){e.canvas.style.width=100*Math.trunc(d.x)/d.x+"%",e.canvas.style.height=100*Math.trunc(d.y)/d.y+"%"}),[d]),h=(0,Y.useMemo)((function(){return xU(yU({},i),{responsive:!1,maintainAspectRatio:!1,devicePixelRatio:m,onResize:g})}),[m,g,i]);return(0,Y.useEffect)((function(){if(f)if(null!=c.current&&(c.current.canvas===l.current&&c.current.config.type===n||(c.current.destroy(),c.current=null)),null==c.current){if(null==l.current)return;var e={datasets:[]};EU(e,r,a),c.current=new Ko(l.current,{type:n,data:e,options:h})}else EU(c.current.data,r,a),c.current.options=h,c.current.update()}),[f,n,r,h,a]),(0,Y.useEffect)((function(){null!=c.current&&f&&(c.current.resize(d.x/m,d.y/m),c.current.update("none"),g(c.current))}),[f,d,m,g]),(0,Y.useEffect)((function(){return function(){null!=c.current&&c.current.destroy()}}),[]),(0,z.jsx)("div",xU(yU({ref:u},s),{children:(0,z.jsx)("canvas",{ref:l})}))}function EU(e,t,n){t!==e&&Object.assign(e,xU(yU({},t),{datasets:t.datasets.map((function(t){var r=e.datasets.find((function(e){return e.label===t.label&&e.type===t.type}));if(null!=r){if(t!==r){var i=n(r.data,t.data);Object.assign(r,xU(yU({},t),{mergedData:i}))}return r}return xU(yU({},t),{data:jU(t.data)})}))}))}function SU(e,t){var n=new Array(t.length);return Object.assign(n,e,t),n}function TU(e,t){for(var n=0,r=0;r<t.length;r++){for(var i=yU({},t[r]),o=0;n<e.length&&!(e[n].x>i.x);n++)e[n].x!==i.x&&o++;n>0&&e[n-1].x===i.x?(e[n-1]=i,0!==o&&(e.splice(n-1-o,o),n-=o)):(e.splice(n-o,o,i),n++,n-=o)}var a=e.length-n;return a>0&&e.splice(n,a),e}oe.add("game-ui/common/charts/legends/color-legend.tsx",{get ColorLegend(){return hU},set ColorLegend(e){hU=e},get ColorLegendSymbol(){return pU},set ColorLegendSymbol(e){pU=e}}),Ko.register(ia,ma,aa,ci,fi,pi,gs,bs,Ba,us,Wa),Ko.defaults.font.family="Overpass",Ko.defaults.responsive=!1,Ko.defaults.maintainAspectRatio=!1,Ko.defaults.animation=!1,Ko.defaults.plugins.tooltip.enabled=!1,Ko.defaults.plugins.legend.display=!1,Ko.defaults.events=[],Ko.defaults.transitions.resize.animation.duration=0,Ko.defaults.scales.linear.ticks.callback=function(e){return e.toString()},oe.add("game-ui/common/charts/responsive-chart/responsive-chart.tsx",{get ResponsiveChart(){return OU},set ResponsiveChart(e){OU=e},get defaultMergeCallback(){return SU},set defaultMergeCallback(e){SU=e},get xyMergeCallback(){return TU},set xyMergeCallback(e){TU=e}});let IU={"watches-output":"watches-output_GMe",watchesOutput:"watches-output_GMe",chart:"chart_u1n",legend:"legend_obt","legend-item":"legend-item_Osn",legendItem:"legend-item_Osn"};oe.add("game-ui/debug/components/watches-output/watches-output.module.scss",{get classes(){return IU},set classes(e){Object.assign(IU,e)}});const wU=IU;var PU=function(e){var t=e.watches,n=e.className,r=t.filter((function(e){return e.__Type===hR.History})),i=t.filter((function(e){return e.__Type===hR.Distribution}));return(0,z.jsxs)("div",{className:_d()(wU.watchesOutput,n),children:[r.length>0&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(CU,{watches:r}),(0,z.jsx)("div",{className:wU.legend,children:r.map((function(e,t){return(0,z.jsx)(hU,{color:e.color,label:e.name,className:wU.legendItem},t)}))})]}),i.length>0&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(NU,{watches:i}),(0,z.jsx)("div",{className:wU.legend,children:i.map((function(e,t){return(0,z.jsx)(hU,{color:e.color,label:e.name,className:wU.legendItem},t)}))})]})]})},CU=function(e){var t=e.watches,n=(0,Y.useMemo)((function(){return{datasets:t.map((function(e,t){return{label:e.name,showLine:!0,data:e.history.filter((function(e){return 0!==e.x})),borderColor:e.color}}))}}),[t]),r=function(){var e=xl(Xl);return(0,Y.useMemo)((function(){return{layout:{padding:{top:15,right:30,left:30,bottom:30}},elements:{line:{tension:0,borderWidth:2,backgroundColor:"transparent"},point:{radius:0}},scales:{x:{type:"linear",beginAtZero:!1,grid:{display:!1},ticks:{display:!1}},y:{beginAtZero:!0,ticks:{font:{size:10*e},color:"white",maxTicksLimit:10,callback:function(e){return Bu(e)}}}}}}),[e])}();return(0,z.jsx)(OU,{type:"scatter",data:n,options:r,className:wU.chart})},NU=function(e){var t=e.watches,n=(0,Y.useMemo)((function(){return{datasets:t.map((function(e,t){return{label:e.name,showLine:!0,data:e.buckets.map((function(e){return{x:af(e.min,e.max,.5),y:e.count}})),borderColor:e.color,stepped:"middle"}}))}}),[t]),r=function(){var e=xl(Xl);return(0,Y.useMemo)((function(){return{layout:{padding:{top:15,right:30,left:30,bottom:30}},elements:{line:{tension:0,borderWidth:2,backgroundColor:"transparent"},point:{radius:0}},scales:{x:{type:"linear",beginAtZero:!1,ticks:{font:{size:10*e},color:"white",maxTicksLimit:25,callback:function(e){return Bu(e)}}},y:{beginAtZero:!0,ticks:{font:{size:10*e},color:"white",maxTicksLimit:10,callback:function(e){return Bu(e)}}}}}}),[e])}();return(0,z.jsx)(OU,{type:"scatter",data:n,options:r,className:wU.chart})};oe.add("game-ui/debug/components/watches-output/watches-output.tsx",{get WatchesOutput(){return PU},set WatchesOutput(e){PU=e},get HistoryChart(){return CU},set HistoryChart(e){CU=e},get DistributionChart(){return NU},set DistributionChart(e){NU=e}});let AU={"debug-ui":"debug-ui_M_y",debugUi:"debug-ui_M_y",inspector:"inspector_GbW","output-column":"output-column_py9",outputColumn:"output-column_py9",output:"output_NHr","tab-bar":"tab-bar_b_c",tabBar:"tab-bar_b_c","title-bar":"title-bar_Yno",titleBar:"title-bar_Yno",title:"title_HzQ",scrollable:"scrollable_ivK"};oe.add("game-ui/debug/components/debug-ui.module.scss",{get classes(){return AU},set classes(e){Object.assign(AU,e)}});const LU=AU;var MU=new Wh("CHILDREN"),kU=new Wh("DEBUG_UI"),RU=function(e){var t=e.children,n=xl(vR),r=xl(bR),i=(0,Y.useMemo)((function(){return{"Debug UI":function(){r?wR():IR()}}}),[r]),o=(0,Y.useCallback)((function(){return wR()}),[]);return(0,z.jsxs)(z.Fragment,{children:[n?(0,z.jsx)(rp,{actions:i,children:(0,z.jsxs)(pj,{focused:r?kU:MU,children:[(0,z.jsx)(hj,{focusKey:MU,children:t}),r&&(0,z.jsx)(DU,{onClose:o})]})}):t,(0,z.jsx)(tU,{})]})},DU=function(e){var t=e.onClose,n=xl(yR),r=xl(xR),i=xl(_R),o=xl(jR),a=xl(CN),s=(0,Y.useMemo)((function(){return{Back:function(){return t()},"Switch Tab":function(e){e<0?PR():NR()},"Pause Simulation":a?null:function(){kp(Lp.pauseSimulation),LN(!0)},"Resume Simulation":a?function(){kp(Lp.resumeSimulation),LN(!1)}:null}}),[t,a]);(0,Y.useEffect)((function(){var e=function(e){e.repeat||(37===e.keyCode?(PR(),e.preventDefault()):39===e.keyCode&&(NR(),e.preventDefault()))};return document.addEventListener("keydown",e),function(){return document.removeEventListener("keydown",e)}}),[]),(0,Y.useEffect)((function(){var e=ER.subscribe((function(e){e.debugType===gR.Trigger&&bl(e.group,e.name)}));return function(){return e.dispose()}}),[]);var l=xl(OR),c=xl(TR),u=cD("debug");return(0,z.jsx)(rp,{actions:s,children:(0,z.jsxs)(Yv,{focusKey:kU,className:LU.debugUi,children:[(0,z.jsxs)("div",{className:LU.inspector,children:[(0,z.jsx)("div",{className:LU.tabBar,children:n.map((function(e,t){return(0,z.jsx)(FU,{index:t,name:e,selected:t===r},t)}))}),(0,z.jsx)(gE,{smooth:!1,className:LU.scrollable,children:(0,z.jsx)(Ap,{children:null!=o&&(0,z.jsx)(WF,{parent:u,data:o})})},null==i?void 0:i.displayName)]}),(0,z.jsxs)(gE,{className:LU.outputColumn,children:[null!=l&&(0,z.jsx)(ZF,{binding:l,className:LU.output}),c.length>0&&(0,z.jsx)(PU,{watches:c,className:LU.output})]})]})})},FU=function(e){var t=e.index,n=e.name,r=e.selected,i=(0,Y.useCallback)((function(){return CR(t)}),[t]);return(0,z.jsx)(Qp,{focusKey:Hh,selected:r,theme:LR,onSelect:i,children:n})};function UU(e){for(var t=document.body.classList.length-1;t>=0;t--){var n=document.body.classList[t];n.startsWith("style--")&&document.body.classList.remove(n)}document.body.classList.add("style--"+e)}function GU(e){var t=1-.75*BU(e,1);document.documentElement.style.setProperty("--panelOpacityNormal",t.toString().replace(",","."));var n=BU(t,.66);document.documentElement.style.setProperty("--panelOpacityDark",n.toString().replace(",",".")),0===e?document.body.classList.add("no-panel-blur"):document.body.classList.remove("no-panel-blur")}function BU(e,t){return-t*e*e+(1+t)*e}function VU(e){document.documentElement.style.setProperty("--fontScale",e.toString().replace(",","."))}function HU(e){document.documentElement.style.fontSize=e?"":"1px"}function KU(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function WU(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return KU(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return KU(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/debug/components/debug-ui.tsx",{get DebugUIRenderer(){return RU},set DebugUIRenderer(e){RU=e},get DebugUI(){return DU},set DebugUI(e){DU=e}}),oe.add("game-ui/common/app/interface.ts",{get applyInterfaceStyle(){return UU},set applyInterfaceStyle(e){UU=e},get applyInterfaceTransparency(){return GU},set applyInterfaceTransparency(e){GU=e},get applyTextScale(){return VU},set applyTextScale(e){VU=e},get applyInterfaceScalingEnabled(){return HU},set applyInterfaceScalingEnabled(e){HU=e}});var zU=function(){var e=WU((0,Y.useState)(1),2),t=e[0],n=e[1],r=lF(.1);return(0,Y.useEffect)((function(){return VU(t)}),[t]),(0,z.jsxs)("div",{style:{position:"absolute",top:0,left:0,width:150,padding:10,backgroundColor:"rgba(0,0,0,0.5)",zIndex:9999,fontSize:10},children:[(0,z.jsx)(oF,{focusKey:Hh,value:t,start:1,end:2,valueTransformer:r,style:{pointerEvents:"auto"},onChange:n}),Math.round(100*t)]})};function YU(){var e=!(arguments.length>0&&void 0!==arguments[0])||arguments[0];(0,Y.useEffect)((function(){if(e){var t=function(e){82!==e.keyCode&&116!==e.keyCode||!e.metaKey&&!e.ctrlKey||window.location.reload()};return window.addEventListener("keydown",t),function(){return window.removeEventListener("keydown",t)}}}),[e])}oe.add("game-ui/debug/components/text-scale-slider/text-scale-slider.tsx",{get TextScaleSlider(){return zU},set TextScaleSlider(e){zU=e}}),oe.add("game-ui/debug/debug-shortcuts.ts",{get useDebugShortcuts(){return YU},set useDebugShortcuts(e){YU=e}});var $U,qU,XU="menu";!function(e){e[e.Menu=0]="Menu",e[e.NewGame=1]="NewGame",e[e.LoadGame=2]="LoadGame",e[e.Options=3]="Options",e[e.Credits=4]="Credits"}($U||($U={})),function(e){e[e.None=-1]="None",e[e.Default=0]="Default",e[e.Custom=1]="Custom"}(qU||(qU={}));var QU,ZU=fl(XU,"activeScreen"),JU=fl(XU,"gameVersion"),eG=fl(XU,"canContinueGame"),tG=fl(XU,"hasCompletedTutorials"),nG=fl(XU,"showTutorials"),rG=fl(XU,"modsEnabled"),iG=fl(XU,"pdxModsUIEnabled"),oG=fl(XU,"hideEditorButton"),aG=fl(XU,"hideModsUIButton"),sG=fl(XU,"displayModdingBetaBanners"),lG=fl(XU,"savePreview"),cG=fl(XU,"mapName"),uG=fl(XU,"lastSaveName"),dG=fl(XU,"defaultGameOptions"),fG=fl(XU,"canExitGame"),mG=fl(XU,"saveGameSlots"),gG=fl(XU,"isModsUIActive"),hG=fl(XU,"themes"),pG=fl(XU,"maps"),vG=fl(XU,"availableMapFilters"),bG=fl(XU,"selectedMapFilter"),yG=fl(XU,"saves"),xG=fl(XU,"creditFiles"),_G=fl(XU,"saveabilityStatus");function jG(e){bl(XU,"setActiveScreen",e)}function OG(){bl(XU,"continueGame")}function EG(e){bl(XU,"newGame",e)}function SG(e,t){bl(XU,"loadGame",e,t)}function TG(e){bl(XU,"saveGame",e)}function IG(e){bl(XU,"deleteSave",e)}function wG(e){bl(XU,"shareSave",e)}function PG(e){bl(XU,"shareMap",e)}function CG(){bl(XU,"startEditor")}function NG(){bl(XU,"exitToMainMenu")}function AG(){bl(XU,"showPdxModsUI")}function LG(e){bl(XU,"onSaveGameScreenVisibilityChanged",e)}function MG(e){bl(XU,"applyTutorialSettings",e===QU.Continue||e===QU.Reset,e===QU.Reset)}function kG(){var e=xl(nG);return(0,Y.useState)(e?QU.Continue:QU.Disable)}!function(e){e[e.Continue=0]="Continue",e[e.Reset=1]="Reset",e[e.Disable=2]="Disable"}(QU||(QU={}));var RG=pl(XU,"quicksave"),DG=vl(XU,"quickload"),FG=fl(XU,"availableCloudTargets"),UG=fl(XU,"selectedCloudTarget"),GG=fl(XU,"dismissLoadGameConfirmation"),BG=vl(XU,"selectCloudTarget"),VG=vl(XU,"selectMapFilter");oe.add("game-ui/menu/data-binding/menu-bindings.ts",{get MenuScreen(){return $U},set MenuScreen(e){$U=e},get MapFilter(){return qU},set MapFilter(e){qU=e},get activeMenuScreen(){return activeMenuScreen},set activeMenuScreen(e){activeMenuScreen=e},get gameVersion(){return gameVersion},set gameVersion(e){gameVersion=e},get canContinueGame(){return canContinueGame},set canContinueGame(e){canContinueGame=e},get hasCompletedTutorials(){return hasCompletedTutorials},set hasCompletedTutorials(e){hasCompletedTutorials=e},get tutorialsEnabled(){return tutorialsEnabled},set tutorialsEnabled(e){tutorialsEnabled=e},get modsEnabled(){return modsEnabled},set modsEnabled(e){modsEnabled=e},get pdxModsUIEnabled(){return pdxModsUIEnabled},set pdxModsUIEnabled(e){pdxModsUIEnabled=e},get hideEditor(){return hideEditor},set hideEditor(e){hideEditor=e},get hideModsUI(){return hideModsUI},set hideModsUI(e){hideModsUI=e},get displayModdingBetaBanners(){return displayModdingBetaBanners},set displayModdingBetaBanners(e){displayModdingBetaBanners=e},get savePreview(){return savePreview},set savePreview(e){savePreview=e},get mapName(){return mapName},set mapName(e){mapName=e},get lastSaveName(){return lastSaveName},set lastSaveName(e){lastSaveName=e},get defaultGameOptions(){return defaultGameOptions},set defaultGameOptions(e){defaultGameOptions=e},get canExitGame(){return canExitGame},set canExitGame(e){canExitGame=e},get saveGameSlots(){return saveGameSlots},set saveGameSlots(e){saveGameSlots=e},get modsUIActive(){return modsUIActive},set modsUIActive(e){modsUIActive=e},get themes(){return themes},set themes(e){themes=e},get maps(){return maps},set maps(e){maps=e},get availableMapFilters(){return availableMapFilters},set availableMapFilters(e){availableMapFilters=e},get selectedMapFilter(){return selectedMapFilter},set selectedMapFilter(e){selectedMapFilter=e},get saves(){return saves},set saves(e){saves=e},get creditFiles(){return creditFiles},set creditFiles(e){creditFiles=e},get saveability(){return saveability},set saveability(e){saveability=e},get setActiveMenuScreen(){return jG},set setActiveMenuScreen(e){jG=e},get continueGame(){return OG},set continueGame(e){OG=e},get newGame(){return EG},set newGame(e){EG=e},get loadGame(){return SG},set loadGame(e){SG=e},get saveGame(){return TG},set saveGame(e){TG=e},get deleteSave(){return IG},set deleteSave(e){IG=e},get shareSave(){return wG},set shareSave(e){wG=e},get shareMap(){return PG},set shareMap(e){PG=e},get startEditor(){return CG},set startEditor(e){CG=e},get exitToMainMenu(){return NG},set exitToMainMenu(e){NG=e},get showPdxModsUI(){return AG},set showPdxModsUI(e){AG=e},get onSaveGameScreenVisibilityChanged(){return LG},set onSaveGameScreenVisibilityChanged(e){LG=e},get TutorialState(){return QU},set TutorialState(e){QU=e},get applyTutorialSettings(){return MG},set applyTutorialSettings(e){MG=e},get useTutorialSettingsState(){return kG},set useTutorialSettingsState(e){kG=e},get quicksave(){return RG},set quicksave(e){RG=e},get quickload(){return DG},set quickload(e){DG=e},get availableCloudTargets(){return availableCloudTargets},set availableCloudTargets(e){availableCloudTargets=e},get selectedCloudTarget(){return selectedCloudTarget},set selectedCloudTarget(e){selectedCloudTarget=e},get dismissLoadGameConfirmation(){return dismissLoadGameConfirmation},set dismissLoadGameConfirmation(e){dismissLoadGameConfirmation=e},get selectCloudTarget(){return BG},set selectCloudTarget(e){BG=e},get selectMapFilter(){return VG},set selectMapFilter(e){VG=e}});var HG=function(e){var t=e.children;return(0,z.jsx)(KG,{binding:sG,children:t})},KG=function(e){var t=e.children;return xl(e.binding)?(0,z.jsx)(z.Fragment,{children:t}):null};oe.add("game-ui/common/beta-element/beta-element.tsx",{get ModdingBetaElement(){return HG},set ModdingBetaElement(e){HG=e},get BetaElement(){return KG},set BetaElement(e){KG=e}});let WG={"beta-banner":"beta-banner_qiZ",betaBanner:"beta-banner_qiZ"};oe.add("game-ui/common/beta-element/beta-banner/beta-banner.module.scss",{get classes(){return WG},set classes(e){Object.assign(WG,e)}});const zG=WG;var YG=function(){return(0,z.jsx)(HG,{children:(0,z.jsx)($G,{children:(0,z.jsx)(qc.Editor.BETA_BANNER,{})})})},$G=function(e){var t=e.children;return(0,z.jsx)("div",{className:zG.betaBanner,children:t})};oe.add("game-ui/common/beta-element/beta-banner/beta-banner.tsx",{get ModdingBetaBanner(){return YG},set ModdingBetaBanner(e){YG=e},get BetaBanner(){return $G},set BetaBanner(e){$G=e}});var qG,XG,QG="editorPanel";!function(e){e.EditorSection="Game.UI.Editor.EditorSection",e.Compass="Game.UI.Editor.Compass",e.SeasonWheel="Game.UI.Editor.SeasonWheel",e.TimeOfDayWeightsChart="Game.UI.Editor.TimeOfDayWeightsChart",e.ItemPicker="Game.UI.Editor.ItemPicker",e.ItemPickerFooter="Game.UI.Editor.ItemPickerFooter",e.SearchField="Game.UI.Editor.SearchField",e.PopupSearchField="Game.UI.Editor.PopupSearchField",e.LocalizationField="Game.UI.Editor.LocalizationField",e.FilterMenu="Game.UI.Editor.FilterMenu",e.HierarchyMenu="Game.UI.Editor.HierarchyMenu",e.SeasonsField="Game.UI.Editor.SeasonsField",e.ModdingBetaBanner="Game.UI.Editor.ModdingBetaBanner",e.ErrorLabel="Game.UI.Editor.ErrorLabel",e.StringInputFieldWithError="Game.UI.Editor.StringInputFieldWithError",e.ExternalLinkField="Game.UI.Editor.ExternalLinkField",e.ProgressIndicator="Game.UI.Editor.ProgressIndicator",e.LargeIconButton="Game.UI.Editor.LargeIconButton"}(qG||(qG={})),function(e){e[e.Loading=0]="Loading",e[e.Success=1]="Success",e[e.Failure=2]="Failure"}(XG||(XG={}));var ZG=fl(QG,"active"),JG=fl(QG,"title"),eB=fl(QG,"width"),tB=fl(QG,"children"),nB=vl(QG,"setWidth"),rB=pl(QG,"cancel"),iB=pl(QG,"close");function oB(e){bl(e.group,"deleteEditorSection",e.path)}function aB(e,t){bl(e.group,"setEditorSectionActive",e.path,t)}function sB(e,t){bl(e.group,"setSelectedSeason",e.path,t)}function lB(e,t,n){bl(e.group,"setSeasonStartTimeOfYear",e.path,t,n)}function cB(e,t,n){bl(e.group,"setVisibleItemRange",e.path,t,n)}function uB(e,t){bl(e.group,"setItemSelected",e.path,t)}function dB(e,t,n){bl(e.group,"setItemFavorite",e.path,t,n)}function fB(e,t,n){bl(e.group,"setSearchFavorite",e.path,t,n)}function mB(e,t,n,r){bl(e.group,"setLocalizationEntry",e.path,t,n,r)}function gB(e){bl(e.group,"addLocalizationEntry",e.path)}function hB(e,t){bl(e.group,"removeLocalizationEntry",e.path,t)}function pB(e,t,n){bl(e.group,"toggleFilter",e.path,t,n)}function vB(e){bl(e.group,"clearFilters",e.path)}function bB(e,t,n){bl(e.group,"setHierarchyItemExpanded",e.path,t,n)}function yB(e,t,n){bl(e.group,"setHierarchyItemSelected",e.path,t,n)}function xB(e,t,n){bl(e.group,"setHierarchyRenderedRange",e.path,t,n)}function _B(e){bl(e.group,"addExternalLink",e.path)}function jB(e,t){bl(e.group,"removeExternalLink",e.path,t)}function OB(e,t,n,r){bl(e.group,"setExternalLink",e.path,t,n,r)}oe.add("game-ui/editor/data-binding/editor-panel-bindings.ts",{get editorPanelGroup(){return QG},set editorPanelGroup(e){QG=e},get EditorWidgetType(){return qG},set EditorWidgetType(e){qG=e},get ProgressIndicatorState(){return XG},set ProgressIndicatorState(e){XG=e},get editorPanelActive(){return editorPanelActive},set editorPanelActive(e){editorPanelActive=e},get editorPanelTitle(){return editorPanelTitle},set editorPanelTitle(e){editorPanelTitle=e},get editorPanelWidth(){return editorPanelWidth},set editorPanelWidth(e){editorPanelWidth=e},get editorPanelChildren(){return editorPanelChildren},set editorPanelChildren(e){editorPanelChildren=e},get setWidth(){return nB},set setWidth(e){nB=e},get cancel(){return rB},set cancel(e){rB=e},get close(){return iB},set close(e){iB=e},get deleteEditorSection(){return oB},set deleteEditorSection(e){oB=e},get setEditorSectionActive(){return aB},set setEditorSectionActive(e){aB=e},get setSelectedSeason(){return sB},set setSelectedSeason(e){sB=e},get setSeasonStartTimeOfYear(){return lB},set setSeasonStartTimeOfYear(e){lB=e},get setVisibleItemRange(){return cB},set setVisibleItemRange(e){cB=e},get setItemSelected(){return uB},set setItemSelected(e){uB=e},get setItemFavorite(){return dB},set setItemFavorite(e){dB=e},get setSearchFavorite(){return fB},set setSearchFavorite(e){fB=e},get setLocalizationEntry(){return mB},set setLocalizationEntry(e){mB=e},get addLocalizationEntry(){return gB},set addLocalizationEntry(e){gB=e},get removeLocalizationEntry(){return hB},set removeLocalizationEntry(e){hB=e},get toggleFilter(){return pB},set toggleFilter(e){pB=e},get clearFilters(){return vB},set clearFilters(e){vB=e},get setHierarchyItemExpanded(){return bB},set setHierarchyItemExpanded(e){bB=e},get setHierarchyItemSelected(){return yB},set setHierarchyItemSelected(e){yB=e},get setHierarchyVisibleRange(){return xB},set setHierarchyVisibleRange(e){xB=e},get addExternalLink(){return _B},set addExternalLink(e){_B=e},get removeExternalLink(){return jB},set removeExternalLink(e){jB=e},get setExternalLink(){return OB},set setExternalLink(e){OB=e}});let EB={button:"button_WPv"};oe.add("game-ui/editor/themes/editor-button.module.scss",{get classes(){return EB},set classes(e){Object.assign(EB,e)}});const SB=EB;let TB={"editor-button-row":"editor-button-row_NuZ editor-widget_QQl",editorButtonRow:"editor-button-row_NuZ editor-widget_QQl",button:"button_dLA"};oe.add("game-ui/editor/widgets/button/button.module.scss",{get classes(){return TB},set classes(e){Object.assign(TB,e)}});const IB=TB;function wB(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function PB(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){wB(e,t,n[t])}))}return e}function CB(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var NB=function(e){return(0,z.jsx)(MB,{children:(0,z.jsx)(LB,PB({},e))})},AB=function(e){var t=e.parent,n=e.path,r=e.children,i=uD(t,n);return(0,z.jsx)(MB,{children:r.map((function(e){var t=e.path,n=CB(e,["path"]);return(0,z.jsx)(LB,PB({parent:i,path:t},n),t)}))})},LB=function(e){var t=e.parent,n=e.path,r=e.props,i=RR(zR,uD(t,n));return r.hidden?null:(0,z.jsx)(kB,{disabled:r.disabled,onSelect:i,tooltip:r.tooltip,children:(0,z.jsx)(ku,{value:r.displayName})})},MB=function(e){var t=e.children;return(0,z.jsx)("div",{className:IB.editorButtonRow,children:t})},kB=function(e){var t=e.disabled,n=e.className,r=e.children,i=e.onSelect,o=e.tooltip;return(0,z.jsx)(jh,{tooltip:me(o)?null:(0,z.jsx)(ku,{value:o}),children:(0,z.jsx)(Qp,{disabled:t,theme:SB,className:_d()(IB.button,n),onSelect:i,children:r})})};oe.add("game-ui/editor/widgets/button/button.tsx",{get BoundButton(){return NB},set BoundButton(e){NB=e},get BoundButtonRow(){return AB},set BoundButtonRow(e){AB=e},get EditorButtonRow(){return MB},set EditorButtonRow(e){MB=e},get EditorButton(){return kB},set EditorButton(e){kB=e}});let RB={"dropdown-toggle":"dropdown-toggle_Iei dropdown-toggle_prl",dropdownToggle:"dropdown-toggle_Iei dropdown-toggle_prl",indicator:"indicator_Not","dropdown-menu":"dropdown-menu_cSm dropdown-menu_Swd",dropdownMenu:"dropdown-menu_cSm dropdown-menu_Swd","dropdown-item":"dropdown-item_Hjk undefined",dropdownItem:"dropdown-item_Hjk undefined","toggle-flags-button":"toggle-flags-button_T7X undefined",toggleFlagsButton:"toggle-flags-button_T7X undefined","dropdown-flag-item":"dropdown-flag-item_uJx dropdown-flag-item_EcT",dropdownFlagItem:"dropdown-flag-item_uJx dropdown-flag-item_EcT",toggle:"toggle_qtt toggle_RyX",label:"label_tNr"};oe.add("game-ui/editor/themes/editor-dropdown.module.scss",{get classes(){return RB},set classes(e){Object.assign(RB,e)}});const DB=RB;let FB={pickerMinHeight:"400rem","editor-item-base":"editor-item-base_sYx editor-widget_QQl",editorItemBase:"editor-item-base_sYx editor-widget_QQl",centered:"centered_t1M","editor-item":"editor-item_VnW editor-item-base_sYx editor-widget_QQl",editorItem:"editor-item_VnW editor-item-base_sYx editor-widget_QQl",row:"row_d2o",label:"label_BbZ",control:"control_Hds",children:"children_ab1",toggle:"toggle_wf6",input:"input_Wfi","picker-toggle":"picker-toggle_d6k",pickerToggle:"picker-toggle_d6k","dropdown-toggle":"dropdown-toggle_kaj",dropdownToggle:"dropdown-toggle_kaj","directory-button":"directory-button_ayP",directoryButton:"directory-button_ayP","directory-icon":"directory-icon_NVL",directoryIcon:"directory-icon_NVL","vector-label":"vector-label_fxy",vectorLabel:"vector-label_fxy","vector-input":"vector-input_B11 input_Wfi",vectorInput:"vector-input_B11 input_Wfi","slider-container":"slider-container_Q_K",sliderContainer:"slider-container_Q_K",slider:"slider_ROT","slider-input":"slider-input_DXM input_Wfi",sliderInput:"slider-input_DXM input_Wfi",picker:"picker_Ij2","picker-popup":"picker-popup_pUb",pickerPopup:"picker-popup_pUb",swatch:"swatch_wOH",alpha:"alpha_Sth","group-children":"group-children_Zwx",groupChildren:"group-children_Zwx","expandable-header":"expandable-header_hQZ",expandableHeader:"expandable-header_hQZ","header-label":"header-label_H79",headerLabel:"header-label_H79","header-summary":"header-summary_U_C",headerSummary:"header-summary_U_C","expandable-children":"expandable-children_e7j",expandableChildren:"expandable-children_e7j","color-picker-container":"color-picker-container_bUs",colorPickerContainer:"color-picker-container_bUs","details-block":"details-block_E_n",detailsBlock:"details-block_E_n","error-label":"error-label_Tqk",errorLabel:"error-label_Tqk","error-border":"error-border_idd",errorBorder:"error-border_idd","label-right":"label-right__bo",labelRight:"label-right__bo"};oe.add("game-ui/editor/widgets/item/editor-item.module.scss",{get classes(){return FB},set classes(e){Object.assign(FB,e)}});const UB=FB;var GB=function(e){var t=e.disabled,n=e.centered,r=e.className,i=e.children;return(0,z.jsx)(Ap,{children:(0,z.jsx)("div",{className:_d()(UB.editorItem,t&&"disabled",n&&UB.centered,r),children:i})})},BB=function(e){var t=e.disabled,n=e.centered,r=e.className,i=e.focusKey,o=void 0===i?Kh:i,a=e.onFocusChange,s=e.children;return(0,z.jsx)(Yv,{focusKey:t?Hh:o,className:_d()(UB.editorItem,t&&"disabled",n&&UB.centered,r),onFocusChange:a,children:s})},VB=function(e){var t=e.label,n=e.summary,r=e.expanded,i=e.disabled,o=e.centered,a=e.className,s=e.children,l=e.onExpandedChange,c=(0,Y.useCallback)((function(){return l(!r)}),[r,l]);return(0,z.jsx)(Yv,{focusKey:i?Hh:Kh,className:_d()(UB.editorItemBase,i&&"disabled",o&&UB.centered,a),children:(0,z.jsxs)(Ap,{children:[(0,z.jsxs)(lb,{tinted:!0,src:r?"Media/Glyphs/ThickStrokeArrowDown.svg":"Media/Glyphs/ThickStrokeArrowRight.svg",className:_d()(UB.expandableHeader,r&&UB.expanded),onSelect:c,children:[(0,z.jsx)("div",{className:UB.headerLabel,children:t}),null!=n&&(0,z.jsx)("div",{className:UB.headerSummary,children:n})]}),r&&(0,z.jsx)("div",{className:UB.expandableChildren,children:s})]})})},HB=function(e){var t=e.label,n=e.onSelect,r=e.children;return(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)("div",{className:UB.label,onClick:n,children:t}),r&&(0,z.jsx)("div",{className:UB.control,children:r})]})},KB=function(e){var t=e.visible,n=e.children;return t?(0,z.jsx)("div",{className:UB.detailsBlock,children:n}):null};function WB(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function zB(e){var t=e.parent,n=e.path,r=e.props,i=RR(YR,uD(t,n));return(0,z.jsx)($B,{data:r,onChange:i})}function YB(e){var t=e.items,n=e.value,r=e.disabled,i=void 0!==r&&r,o=e.onChange,a=(0,Y.useMemo)((function(){return t.find((function(e){return e.value===n}))}),[t,n]);return(0,z.jsx)(SE,{theme:DB,content:t.map((function(e,t){return(0,z.jsx)(RE,{focusKey:t,value:e.value,selected:n===e.value,onChange:o,children:(0,z.jsx)(ku,{value:e.displayName})},t)})),children:(0,z.jsx)(CE,{sounds:qB,className:UB.dropdownToggle,disabled:i,children:(null==a?void 0:a.displayName)&&(0,z.jsx)(ku,{value:a.displayName})})})}function $B(e){var t=e.data,n=e.onChange;return(0,z.jsx)(BB,{disabled:t.disabled,children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)("div",{className:UB.label,children:(0,z.jsx)(ku,{value:t.displayName})}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsx)(YB,{items:t.items,value:t.value,disabled:t.disabled,onChange:n})})]})})}oe.add("game-ui/editor/widgets/item/editor-item.tsx",{get EditorItem(){return GB},set EditorItem(e){GB=e},get FocusableEditorItem(){return BB},set FocusableEditorItem(e){BB=e},get ExpandableEditorItem(){return VB},set ExpandableEditorItem(e){VB=e},get EditorItemControl(){return HB},set EditorItemControl(e){HB=e},get EditorItemDetails(){return KB},set EditorItemDetails(e){KB=e}});var qB=function(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){WB(e,t,n[t])}))}return e}({},Xp),{hover:null,focus:null});oe.add("game-ui/editor/widgets/fields/dropdown-field.tsx",{get BoundDropdownField(){return zB},set BoundDropdownField(e){zB=e},get DropdownField(){return YB},set DropdownField(e){YB=e}});var XB=function(e){var t=e.parent,n=e.path,r=e.props,i=RR(YR,uD(t,n));return r.hidden?null:(0,z.jsx)(BB,{disabled:r.disabled,children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)("div",{className:UB.label,children:(0,z.jsx)(ku,{value:r.displayName})}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsx)(ZB,{value:r.value,disabled:r.disabled,onChange:i,multiline:r.multiline>=1?r.multiline:void 0})})]})})},QB=function(e){var t=e.label,n=e.value,r=e.disabled,i=e.onChange,o=e.onChangeStart,a=e.onChangeEnd;return(0,z.jsx)(BB,{disabled:r,children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)("div",{className:UB.label,children:t}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsx)(ZB,{value:n,disabled:r,onChange:i,onChangeStart:o,onChangeEnd:a})})]})})},ZB=function(e){var t=e.value,n=e.disabled,r=e.onChange,i=e.onChangeStart,o=e.onChangeEnd,a=e.className,s=e.multiline,l=(0,Y.useCallback)((function(e){return r(e.target.value||"")}),[r]);return(0,z.jsx)(yb,{value:t,disabled:n,className:_d()(UB.input,a),onChange:l,onFocus:i,onBlur:o,multiline:s})};oe.add("game-ui/editor/widgets/fields/string-input-field.tsx",{get BoundEditorStringInputField(){return XB},set BoundEditorStringInputField(e){XB=e},get EditorStringInputField(){return QB},set EditorStringInputField(e){QB=e},get StringInputField(){return ZB},set StringInputField(e){ZB=e}});let JB={"editor-icon-button-group":"editor-icon-button-group_Qiw editor-widget_QQl",editorIconButtonGroup:"editor-icon-button-group_Qiw editor-widget_QQl",button:"button_qdd","large-icon-button":"large-icon-button_sBX",largeIconButton:"large-icon-button_sBX"};oe.add("game-ui/editor/widgets/icon-button/icon-button.module.scss",{get classes(){return JB},set classes(e){Object.assign(JB,e)}});const eV=JB;function tV(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function nV(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){tV(e,t,n[t])}))}return e}function rV(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var iV=function(e){return(0,z.jsx)(sV,{children:(0,z.jsx)(aV,nV({},e))})},oV=function(e){var t=e.parent,n=e.path,r=e.children,i=uD(t,n);return(0,z.jsx)(sV,{children:r.map((function(e){var t=e.path,n=rV(e,["path"]);return(0,z.jsx)(aV,nV({parent:i,path:t},n),t)}))})},aV=function(e){var t=e.parent,n=e.path,r=e.props,i=RR(zR,uD(t,n));return(0,z.jsx)(jh,{tooltip:r.tooltip&&(0,z.jsx)(ku,{value:r.tooltip}),children:(0,z.jsx)(lV,{src:r.icon,selected:r.selected,disabled:r.disabled,onSelect:i})})},sV=function(e){var t=e.children;return(0,z.jsx)("div",{className:eV.editorIconButtonGroup,children:t})},lV=function(e){var t=e.src,n=e.selected,r=e.disabled,i=e.tinted,o=e.className,a=e.onSelect;return(0,z.jsx)(lb,{src:t,selected:n,disabled:r,theme:SB,className:_d()(eV.button,o),onSelect:a,tinted:i})};oe.add("game-ui/editor/widgets/icon-button/icon-button.tsx",{get BoundIconButton(){return iV},set BoundIconButton(e){iV=e},get BoundIconButtonGroup(){return oV},set BoundIconButtonGroup(e){oV=e},get EditorIconButtonGroup(){return sV},set EditorIconButtonGroup(e){sV=e},get EditorIconButton(){return lV},set EditorIconButton(e){lV=e}}),oe.add("game-ui/editor/widgets/item/index.ts",{});let cV={label:"label_FW0",control:"control_jRy",input:"input_Qzq",button:"button_jGE"};oe.add("game-ui/editor/widgets/external-link-field/external-link-field.module.scss",{get classes(){return cV},set classes(e){Object.assign(cV,e)}});const uV=cV;var dV=function(e){var t=e.parent,n=e.path,r=e.props,i=uD(t,n),o=RR(_B,i),a=RR(OB,i),s=RR(jB,i);return(0,z.jsx)(fV,{data:r,onAdd:o,onChange:a,onRemove:s})},fV=function(e){var t=e.data,n=e.onAdd,r=e.onChange,i=e.onRemove,o=(0,Y.useMemo)((function(){return t.acceptedTypes.map((function(e){return{value:e,displayName:Nc("Menu.ASSET_EXTERNAL_LINK_TYPE["+e+"]")}}))}),[t.acceptedTypes]);return(0,z.jsxs)(z.Fragment,{children:[t.links.map((function(e,t){return(0,z.jsx)(mV,{link:e,index:t,items:o,onChange:r,onRemove:i},t)})),(0,z.jsx)(kB,{onSelect:n,disabled:t.links.length>=t.maxLinks,children:(0,z.jsx)(qc.Menu.ASSET_ADD_EXTERNAL_LINK,{})})]})},mV=function(e){var t=e.index,n=e.link,r=e.items,i=e.onChange,o=e.onRemove,a=(0,Y.useCallback)((function(e){return i(t,e,n.url)}),[t,n.url,i]),s=(0,Y.useCallback)((function(e){return i(t,n.type,e)}),[t,n.type,i]),l=(0,Y.useCallback)((function(){return o&&o(t)}),[t,o]);return(0,z.jsx)(GB,{children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)("div",{className:uV.label,children:(0,z.jsx)(YB,{items:r,value:n.type,disabled:n.lockType,onChange:a})}),(0,z.jsxs)("div",{className:uV.control,children:[(0,z.jsx)(ZB,{value:n.url,onChange:s,className:_d()(uV.input,n.error&&UB.errorBorder)}),(0,z.jsx)(lV,{src:"Media/Glyphs/Trash.svg",onSelect:l,disabled:void 0===o,className:uV.button,tinted:!0})]})]})})};function gV(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}oe.add("game-ui/editor/widgets/external-link-field/external-link-field.tsx",{get BoundExternalLinkField(){return dV},set BoundExternalLinkField(e){dV=e},get ExternalLinkField(){return fV},set ExternalLinkField(e){fV=e},get ExternalLinkItem(){return mV},set ExternalLinkItem(e){mV=e}});var hV=function(e){var t=e.props;return(0,z.jsx)(pV,function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){gV(e,t,n[t])}))}return e}({},t))},pV=function(e){return e.visible?(0,z.jsx)("div",{className:_d()(UB.errorLabel,e.className),children:(0,z.jsx)(ku,{value:e.displayName})}):null};oe.add("game-ui/editor/widgets/label/error-label.tsx",{get BoundErrorLabel(){return hV},set BoundErrorLabel(e){hV=e},get ErrorLabel(){return pV},set ErrorLabel(e){pV=e}});var vV=function(e){var t=RR(YR,uD(e.parent,e.path));return(0,z.jsxs)(BB,{disabled:e.props.disabled,children:[(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)("div",{className:UB.label,children:(0,z.jsx)(ku,{value:e.props.displayName})}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsx)(ZB,{className:e.props.error?UB.errorBorder:void 0,value:e.props.value,onChange:t,multiline:e.props.multiline>=1?e.props.multiline:void 0})})]}),(0,z.jsx)(pV,{visible:e.props.error,displayName:e.props.errorMessage,level:0,className:UB.labelRight})]})};oe.add("game-ui/editor/widgets/fields/string-input-field-with-error.tsx",{get BoundStringInputFieldWithError(){return vV},set BoundStringInputFieldWithError(e){vV=e}});var bV=function(e){var t=e.parent,n=e.path,r=e.props,i=RR(zR,uD(t,n)),o=(0,Y.useMemo)((function(){return"url("+r.icon+")"}),[r.icon]);return(0,z.jsx)(BB,{children:(0,z.jsx)(jh,{tooltip:r.tooltip&&(0,z.jsx)(ku,{value:r.tooltip}),children:(0,z.jsx)(Qp,{style:{backgroundImage:o},className:eV.largeIconButton,onSelect:i,theme:SB})})})};oe.add("game-ui/editor/widgets/icon-button/large-icon-button.tsx",{get BoundLargeIconButton(){return bV},set BoundLargeIconButton(e){bV=e}});var yV=function(e){var t=e.props;return(0,z.jsx)(GB,{children:(0,z.jsx)(ku,{value:t.displayName})})};oe.add("game-ui/editor/widgets/label/label.tsx",{get BoundLabel(){return yV},set BoundLabel(e){yV=e}});let xV={strokeWidth:"5","progress-circle":"progress-circle_OLN",progressCircle:"progress-circle_OLN",indeterminate:"indeterminate_UIQ",rotate:"rotate_UME",image:"image_AKd",progress:"progress_mlv"};oe.add("game-ui/common/progress-circle/progress-circle.module.scss",{get classes(){return xV},set classes(e){Object.assign(xV,e)}});const _V=xV;function jV(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var OV=function(e){var t=e.progress,n=e.max,r=e.indeterminate,i=e.theme,o=e.className,a=(0,Y.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){jV(e,t,n[t])}))}return e}({},_V,i)}),[i]),s=50,l=parseFloat(a.strokeWidth),c=(100-l)/2,u=2*Math.PI*of(t/n,0,.9999),d=s+c*Math.sin(u),f=s-c*Math.cos(u),m=u>Math.PI?1:0;return(0,z.jsx)("div",{className:_d()(a.progressCircle,r&&a.indeterminate,o),children:(0,z.jsxs)("svg",{viewBox:"0 0 100 100",className:a.image,children:[a.circle&&(0,z.jsx)("circle",{cx:s,cy:s,r:c,strokeWidth:l,className:a.circle}),r?(0,z.jsx)("path",{d:EV(s,c,10),strokeWidth:l,className:a.progress}):(0,z.jsx)("path",{d:"M ".concat(s," ").concat(s-c," A ").concat(c," ").concat(c,", 0, ").concat(m," 1, ").concat(d," ").concat(f),strokeWidth:l,className:a.progress})]})})};function EV(e,t,n){for(var r="",i=0;i<n;i++){var o=2*Math.PI*i/n,a=e+t*Math.sin(o),s=e-t*Math.cos(o),l=2*Math.PI*(i+.3)/n,c=e+t*Math.sin(l),u=e-t*Math.cos(l);r+="M ".concat(a," ").concat(s," A ").concat(t," ").concat(t,", 0, 0 1, ").concat(c," ").concat(u," ")}return r}oe.add("game-ui/common/progress-circle/progress-circle.tsx",{get ProgressCircle(){return OV},set ProgressCircle(e){OV=e}});let SV={"progress-circle":"progress-circle_VWp progress-circle_OLN",progressCircle:"progress-circle_VWp progress-circle_OLN",progress:"progress_sD7 progress_mlv",complete:"complete_om7",failure:"failure_ryc",container:"container_YQJ"};oe.add("game-ui/editor/widgets/progress-indicator/progress-indicator.module.scss",{get classes(){return SV},set classes(e){Object.assign(SV,e)}});const TV=SV;function IV(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var wV=function(e){var t=e.props;return(0,z.jsx)(PV,function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){IV(e,t,n[t])}))}return e}({},t))},PV=function(e){var t=e.progress,n=e.indeterminate,r=e.state;return e.hidden?null:(0,z.jsx)("div",{className:TV.container,children:(0,z.jsx)(OV,{progress:r===XG.Loading?t:1,max:1,theme:TV,indeterminate:r===XG.Loading&&n,className:_d()(r===XG.Success&&TV.complete,r===XG.Failure&&TV.failure)})})};function CV(e,t){return(0,Y.useMemo)((function(){return{flex:"".concat(e.grow," ").concat(e.shrink," ").concat(NV(e.basis)),flexWrap:t?"wrap":"nowrap"}}),[e.basis,e.grow,e.shrink,t])}function NV(e){return e<0?"auto":0===e?"0":"".concat(e,"rem")}oe.add("game-ui/editor/widgets/progress-indicator/progress-indicator.tsx",{get BoundProgressIndicator(){return wV},set BoundProgressIndicator(e){wV=e},get ProgressIndicator(){return PV},set ProgressIndicator(e){PV=e}}),oe.add("game-ui/widgets/components/flex-layout.ts",{get useFlexStyle(){return CV},set useFlexStyle(e){CV=e}});let AV={column:"column_iuw editor-widget_QQl"};oe.add("game-ui/editor/widgets/column/column.module.scss",{get classes(){return AV},set classes(e){Object.assign(AV,e)}});const LV=AV;var MV=function(e){var t=e.parent,n=e.path,r=e.props,i=e.children,o=uD(t,n),a=CV(r.flex),s=(0,Y.useContext)(ED);return(0,z.jsx)(kV,{style:a,children:(0,z.jsx)(OD,{parent:o,components:s,data:i})})},kV=function(e){var t=e.className,n=e.style,r=e.children;return(0,z.jsx)("div",{className:_d()(LV.column,t),style:n,children:(0,z.jsx)(Ap,{children:r})})};oe.add("game-ui/editor/widgets/column/column.tsx",{get BoundColumn(){return MV},set BoundColumn(e){MV=e},get Column(){return kV},set Column(e){kV=e}});let RV={compass:"compass_DU0",north:"north_meN",needle:"needle_PzX"};oe.add("game-ui/editor/widgets/compass/compass.module.scss",{get classes(){return RV},set classes(e){Object.assign(RV,e)}});const DV=RV;var FV=function(e){var t=e.props;return(0,z.jsx)(GB,{centered:!0,children:(0,z.jsx)(UV,{angle:t.angle})})},UV=function(e){var t=e.angle,n=e.className;return(0,z.jsxs)("div",{className:_d()(DV.compass,n),children:[(0,z.jsx)("div",{className:DV.north,children:"N"}),(0,z.jsx)("img",{src:"Media/Editor/CompassNeedle.svg",className:DV.needle,style:{transform:"rotate(".concat(t,"deg)")}})]})};oe.add("game-ui/editor/widgets/compass/compass.tsx",{get BoundCompass(){return FV},set BoundCompass(e){FV=e},get Compass(){return UV},set Compass(e){UV=e}});let GV={divider:"divider_FEz"};oe.add("game-ui/editor/widgets/divider/divider.module.scss",{get classes(){return GV},set classes(e){Object.assign(GV,e)}});const BV=GV;var VV=function(){return(0,z.jsx)("div",{className:BV.divider})};oe.add("game-ui/editor/widgets/divider/divider.tsx",{get Divider(){return VV},set Divider(e){VV=e}});var HV=(0,Y.createContext)({}),KV=function(){return(0,Y.useContext)(HV)};function WV(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function zV(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function YV(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){zV(e,t,n[t])}))}return e}function $V(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function qV(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return WV(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return WV(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/svg/svg-context.ts",{get SVGContext(){return HV},set SVGContext(e){HV=e},get useSVG(){return KV},set useSVG(e){KV=e}});var XV={x:0,y:0},QV=function(e,t,n){var r=KV(),i=r.events.bindElement,o=r.viewport,a=e.onDrag,s=e.onWindowMouseMove,l=(0,Y.useRef)(!1),c=qV((0,Y.useState)(!1),2),u=c[0],d=c[1],f=qV((0,Y.useState)(!1),2),m=f[0],g=f[1],h=(0,Y.useRef)(o);h.current=o,(0,Y.useEffect)((function(){if(e){var r=YV({},e),o=r.onMouseDown;if(r.onMouseDown=function(e,t){XV.x=e.clientX,XV.y=e.clientY,null==o||o(e,t)},r.onDrag){var a=r.onMouseDown;r.onMouseDown=function(e,t){null==a||a(e,t),t&&0===e.button&&!e.propagationStopped&&(e.propagationStopped=!0,d(!0))}}if(r.onMouseMove||n){var s=r.onMouseMove,c=r.onMouseEnter,u=r.onMouseLeave;r.onMouseMove=function(e,t){t?l.current||(null==c||c(e),l.current=!0,g(!0)):l.current&&(null==u||u(e),l.current=!1,g(!1)),null==s||s(e,t)}}if(r.onSelect||r.onClick||r.onDrag){var f=r.onClick;r.onClick=function(e,t){var n;t&&!e.propagationStopped&&(e.clientX===XV.x&&e.clientY===XV.y&&(e.propagationStopped=!0,null===(n=r.onSelect)||void 0===n||n.call(r,e),null==f||f(e)))}}return i(r,t)}}),[i,t,n,e]),(0,Y.useEffect)((function(){if(u){var e=function(e){var n=h.current;if(e.buttons>0&&n){var r=n.posFromMouse(e),i=n.pointFromPos(r);null==a||a({point:i,position:r,shiftKey:e.shiftKey,ctrlKey:e.ctrlKey,altKey:e.altKey})}else t()},t=function(){requestAnimationFrame((function(){d(!1),document.removeEventListener("mousemove",e),document.removeEventListener("mouseup",t)}))};return document.addEventListener("mousemove",e),document.addEventListener("mouseup",t),function(){document.removeEventListener("mousemove",e),window.removeEventListener("mouseup",t)}}}),[u,a]),(0,Y.useEffect)((function(){if(s){var e=function(e){var t=h.current;if(t){var n=t.posFromMouse(e),r=t.pointFromPos(n);s($V(YV({},e),{point:r,position:n,shiftKey:e.shiftKey,ctrlKey:e.ctrlKey,altKey:e.altKey}))}};return document.addEventListener("mousemove",e),function(){document.removeEventListener("mousemove",e)}}}),[s]),(0,Y.useEffect)((function(){var t=!!(e.focused||e.selected||m);null==n||n(t)}),[m,n,e.focused,e.selected])};function ZV(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function JV(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function eH(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}oe.add("game-ui/common/svg/utils/use-svg-event-handling.ts",{get useSVGEventHandling(){return QV},set useSVGEventHandling(e){QV=e}});var tH=(0,Y.forwardRef)((function(e,t){var n=e.interaction,r=e.viewport,i=e.children,o=eH(e,["interaction","viewport","children"]);QV(o);o.onWindowMouseMove;var a=eH(o,["onWindowMouseMove"]),s="0 0 ".concat(null==r?void 0:r.size.width," ").concat(null==r?void 0:r.size.height);return(0,z.jsx)("svg",JV(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){ZV(e,t,n[t])}))}return e}({ref:t,width:"100%",height:"100%",viewBox:s},a,n.bindings),{children:i}))}));oe.add("game-ui/common/svg/elements/svg.tsx",{get SVGcomponent(){return tH},set SVGcomponent(e){tH=e}});var nH=["onClick","onContextMenu","onDoubleClick","onMouseDown","onMouseEnter","onMouseLeave","onMouseMove","onMouseOut","onMouseOver","onMouseUp"];function rH(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function iH(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function oH(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function aH(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||lH(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function sH(e){return function(e){if(Array.isArray(e))return rH(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||lH(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function lH(e,t){if(e){if("string"==typeof e)return rH(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?rH(e,t):void 0}}oe.add("game-ui/common/svg/types.ts",{get INTERACTION_EVENTS(){return nH},set INTERACTION_EVENTS(e){nH=e}});var cH=function(){var e=(0,Y.useRef)();return(0,Y.useMemo)((function(){var t={},n=function(n,r){if(e.current){var i,o=oH(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){iH(e,t,n[t])}))}return e}({},r),{position:e.current.posFromMouse(r),point:e.current.pointFromMouse(r)});null===(i=sH(t[n]||[]))||void 0===i||i.forEach((function(e){return e(o)}))}};return{events:{bindElement:function(n,r){var i=[];return Object.entries(n).forEach((function(n){var o=aH(n,2),a=o[0],s=o[1];if(nH.includes(a)){var l=function(t){if(e.current){var n,i=!r||r(null===(n=e.current)||void 0===n?void 0:n.posFromMouse(t),t);t.propagationStopped||"function"!=typeof s||s(t,i)}};!function(e,n){t[e]=t[e]?sH(t[e]).concat([n]):[n]}(a,l),i.push([a,l])}})),function(){i.forEach((function(e){var n,r,i=aH(e,2),o=i[0],a=i[1];return r=a,void t[n=o].splice(t[n].indexOf(r),1)}))}}},bindings:{onWheel:function(e){return n("onWheel",e)},onClick:function(e){return n("onClick",e)},onDoubleClick:function(e){return n("onDoubleClick",e)},onMouseDown:function(e){return n("onMouseDown",e)},onMouseUp:function(e){return n("onMouseUp",e)},onMouseMove:function(e){return n("onMouseMove",e)}},updateViewport:function(t){e.current=t}}}),[])};oe.add("game-ui/common/svg/use-svg-interaction.tsx",{get useSVGInteraction(){return cH},set useSVGInteraction(e){cH=e}});var uH=function(e,t,n,r){var i,o,a,s;if("number"==typeof e?i=o=a=s=t(e):"x"in e?(i=a=t(e.y),s=o=t(e.x)):(i=t(e.top),o=t(e.right),a=t(e.bottom),s=t(e.left)),s+o>=n||i+a>=r)throw new Error("SVG paddings on given axis can't add up to more than the width or height of svg");return{top:i,right:o,bottom:a,left:s}};oe.add("game-ui/common/svg/utils/parse-paddings.ts",{get parsePadding(){return uH},set parsePadding(e){uH=e}});var dH=function(e){return function(){for(var t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];return 2===n.length?e({x:n[0],y:n[1]}):e(n[0])}};function fH(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function mH(e,t,n,r,i,o,a){try{var s=e[o](a),l=s.value}catch(e){return void n(e)}s.done?t(l):Promise.resolve(l).then(r,i)}function gH(e){return function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){mH(o,r,i,a,s,"next",e)}function s(e){mH(o,r,i,a,s,"throw",e)}a(void 0)}))}}function hH(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return fH(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return fH(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/svg/utils/point-conversion.ts",{get createPointConversion(){return dH},set createPointConversion(e){dH=e}});var pH=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}},vH={x:0,y:0},bH=function(e,t,n){var r=hH((0,Y.useState)(vH),2),i=r[0],o=r[1];(0,Y.useEffect)((function(){if(e.current&&t){var n,r=e.current,i={x:0,y:0},a=function(e){var r=e.shiftKey?2:e.ctrlKey?.5:1;o((function(o){return n=n||o,{x:"y"===t?0:n.x+(i.x-e.x)*r,y:"x"===t?0:n.y+(i.y-e.y)*r}}))},s=function(e){if(1===e.button){i=e;window.addEventListener("mousemove",a),window.addEventListener("mouseup",(function(){n=void 0,window.removeEventListener("mousemove",a),window.removeEventListener("mouseup",a)}))}};return r.addEventListener("mousedown",s),function(){r.removeEventListener("mousedown",s)}}}),[t,e]);var a=(0,Y.useCallback)((function(){return o(vH)}),[]);return Dk((0,Y.useCallback)(gH((function(){var e,r,i;return pH(this,(function(a){switch(a.label){case 0:return n?[4,n()]:[3,2];case 1:e=a.sent(),r="y"===t?0:e.x,i="x"===t?0:e.y,o((function(e){return{x:e.x+2*r,y:e.y+2*i}})),a.label=2;case 2:return[2]}}))})),[n,t]),t&&void 0!==n),(0,Y.useMemo)((function(){return[t?i:vH,a]}),[i,t,a])};function yH(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function xH(e,t,n,r,i,o,a){try{var s=e[o](a),l=s.value}catch(e){return void n(e)}s.done?t(l):Promise.resolve(l).then(r,i)}function _H(e){return function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){xH(o,r,i,a,s,"next",e)}function s(e){xH(o,r,i,a,s,"throw",e)}a(void 0)}))}}function jH(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return yH(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return yH(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/svg/utils/use-pan.ts",{get usePan(){return bH},set usePan(e){bH=e}});var OH=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}},EH={x:1,y:1},SH=function(e,t,n,r){var i=jH((0,Y.useState)(EH),2),o=i[0],a=i[1],s=(0,Y.useRef)(t),l=(0,Y.useCallback)((function(e,t,r,i){var o=arguments.length>4&&void 0!==arguments[4]&&arguments[4];a((function(a){var s=a.x,l=a.y;if("y"!==n&&!r)if(o)s=a.x+10*e;else{var c=e||t;s=a.x+.25*Math.sign(c)}"x"===n||i||(l=o?a.y+10*t:a.y+.25*Math.sign(t));var u={x:Math.min(100,Math.max(.1,s)),y:Math.min(100,Math.max(.1,l))};return u.x===a.x&&u.y===a.y?a:u}))}),[n]),c=(0,Y.useCallback)((function(){return a(EH)}),[]);return(0,Y.useEffect)((function(){if(n){var t=e.current,r=function(e){e.preventDefault(),l(e.deltaX,e.deltaY,e.ctrlKey,e.shiftKey)};return null==t||t.addEventListener("wheel",r),function(){null==t||t.removeEventListener("wheel",r)}}}),[l,e,n]),Dk((0,Y.useCallback)(_H((function(){var e;return OH(this,(function(t){switch(t.label){case 0:return r?[4,r()]:[3,2];case 1:e=t.sent(),l(e.x,e.y,!1,!1,!0),t.label=2;case 2:return[2]}}))})),[l,r]),n&&void 0!==r),(0,Y.useMemo)((function(){var n=e.current?function(e,t){var n=(e.max.x-e.min.x)/2*t.x,r=(e.max.x+e.min.x)/2,i=(e.max.y-e.min.y)/2*t.y,o=(e.max.y+e.min.y)/2;return{min:{x:r-n,y:o-i},max:{x:r+n,y:o+i}}}(t,o):t;return el(s.current,n,2)?n=s.current:s.current=n,[n,c]}),[t,c,e,o])};function TH(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function IH(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return TH(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return TH(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/svg/utils/use-zoom-bounds.ts",{get useZoomBounds(){return SH},set useZoomBounds(e){SH=e}});var wH=function(e,t){var n=IH((0,Y.useState)(),2),r=n[0],i=n[1],o=IH(SH(e,t.bounds,null==t?void 0:t.zoomable,t.zoomCallback),2),a=o[0],s=o[1],l=IH(bH(e,t.panable,t.panCallback),2),c=l[0],u=l[1],d=$O(),f=Wf(e),m=t||{},g=m.padding,h=void 0===g?0:g,p=m.inverted,v=void 0===p||p,b=(0,Y.useCallback)((function(){s(),u()}),[s,u]);return(0,Y.useEffect)((function(){if(f&&f.width&&f.height){var e=function(e){return e*d},t=f.width,n=f.height,r=uH(h,e,t,n),o=a||{min:{x:0,y:0},max:{x:t,y:n}},s=(t-(r.left+r.right))/(o.max.x-o.min.x),l=(n-(r.top+r.bottom))/(o.max.y-o.min.y);if(c&&(c.x||c.y)){var u={x:c.x/s,y:c.y/l*(v?-1:1)};o={min:{x:o.min.x+u.x,y:o.min.y+u.y},max:{x:o.max.x+u.x,y:o.max.y+u.y}}}var m={x:f.x,y:f.y},g=function(e){return r.left+(e-o.min.x)*s},p=function(e){return r.bottom+(e-o.min.y)*l},y=dH((function(e){return{x:g(e.x),y:p(e.y)}})),x=function(e){return(e-r.left)/s+o.min.x},_=function(e){return(e-r.bottom)/l+o.min.y},j=dH((function(e){return{x:x(e.x),y:_(e.y)}})),O=function(e){return e/s},E=function(e){return e/l},S=dH((function(e){return{x:O(e.x),y:E(e.y)}})),T=function(e){return e*s},I=function(e){return e*l},w=dH((function(e){return{x:T(e.x),y:I(e.y)}})),P=function(e){return{x:e.clientX-m.x,y:v?n-(e.clientY-m.y):e.clientY-m.y}};i({size:{width:t,height:n},bounds:o,offset:m,inverted:v,padding:r,px:x,py:_,vx:g,vy:p,sx:O,sy:E,svx:T,svy:I,rem:e,posFromPoint:y,pointFromPos:j,posFromMouse:P,pointFromMouse:function(e){return j(P(e))},scaleToPoint:S,scaleToViewport:w,resetViewport:b})}}),[a,h,v,c,d,b,f]),r};function PH(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function CH(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return PH(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return PH(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/svg/use-svg-setup.tsx",{get useSVGSetup(){return wH},set useSVGSetup(e){wH=e}});var NH=(0,Y.createContext)({registerSVGContext:function(){}}),AH=function(e){var t=e.children,n=CH((0,Y.useState)(),2),r=n[0],i=n[1],o=LH().registerSVGContext;return(0,Y.useEffect)((function(){r&&o&&o(r)}),[r,o]),(0,z.jsx)(NH.Provider,{value:{registerSVGContext:i,svg:r},children:t})},LH=function(){return(0,Y.useContext)(NH)};function MH(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function kH(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){MH(e,t,n[t])}))}return e}function RH(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function DH(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}oe.add("game-ui/common/svg/utils/svg-parent-context.tsx",{get SVGParentContextProvider(){return AH},set SVGParentContextProvider(e){AH=e},get useSVGParent(){return LH},set useSVGParent(e){LH=e}});var FH={min:{x:0,y:0},max:{x:1,y:1}},UH=function(e){var t=e.inverted,n=void 0===t||t,r=e.children,i=e.bounds,o=void 0===i?FH:i,a=e.zoomable,s=e.panable,l=e.padding,c=e.zoomCallback,u=e.panCallback,d=DH(e,["inverted","children","bounds","zoomable","panable","padding","zoomCallback","panCallback"]),f=(0,Y.useRef)(null),m=wH(f,{bounds:o,inverted:n,padding:l,zoomable:a,panable:s,zoomCallback:c,panCallback:u}),g=cH(),h=LH().registerSVGContext;(0,Y.useEffect)((function(){g.updateViewport(m)}),[g,m]);var p=(0,Y.useMemo)((function(){var e={viewport:m,events:g.events};return requestAnimationFrame((function(){return h(e)})),e}),[m,g,h]),v=n?"translate(0 ".concat(null==m?void 0:m.size.height,") scale(1 -1)"):"";return(0,z.jsx)(HV.Provider,{value:p,children:(0,z.jsx)(tH,RH(kH({interaction:g,viewport:m,ref:f},d),{children:!!p.viewport&&(0,z.jsx)("g",{transform:v,children:r})}))})};oe.add("game-ui/common/svg/svg.tsx",{get SVG(){return UH},set SVG(e){UH=e}}),oe.add("game-ui/common/svg/index.ts",{});const GH=Math.sqrt(50),BH=Math.sqrt(10),VH=Math.sqrt(2);function HH(e,t,n){const r=(t-e)/Math.max(0,n),i=Math.floor(Math.log10(r)),o=r/Math.pow(10,i),a=o>=GH?10:o>=BH?5:o>=VH?2:1;let s,l,c;return i<0?(c=Math.pow(10,-i)/a,s=Math.round(e*c),l=Math.round(t*c),s/c<e&&++s,l/c>t&&--l,c=-c):(c=Math.pow(10,i)*a,s=Math.round(e/c),l=Math.round(t/c),s*c<e&&++s,l*c>t&&--l),l<s&&.5<=n&&n<2?HH(e,t,2*n):[s,l,c]}function KH(e,t,n){return HH(e=+e,t=+t,n=+n)[2]}function WH(e,t){return null==e||null==t?NaN:e<t?-1:e>t?1:e>=t?0:NaN}function zH(e,t){return null==e||null==t?NaN:t<e?-1:t>e?1:t>=e?0:NaN}function YH(e){let t,n,r;function i(e,r,i=0,o=e.length){if(i<o){if(0!==t(r,r))return o;do{const t=i+o>>>1;n(e[t],r)<0?i=t+1:o=t}while(i<o)}return i}return 2!==e.length?(t=WH,n=(t,n)=>WH(e(t),n),r=(t,n)=>e(t)-n):(t=e===WH||e===zH?e:$H,n=e,r=e),{left:i,center:function(e,t,n=0,o=e.length){const a=i(e,t,n,o-1);return a>n&&r(e[a-1],t)>-r(e[a],t)?a-1:a},right:function(e,r,i=0,o=e.length){if(i<o){if(0!==t(r,r))return o;do{const t=i+o>>>1;n(e[t],r)<=0?i=t+1:o=t}while(i<o)}return i}}}function $H(){return 0}const qH=YH(WH),XH=qH.right,QH=(qH.left,YH((function(e){return null===e?NaN:+e})).center,XH);function ZH(e,t,n){e.prototype=t.prototype=n,n.constructor=e}function JH(e,t){var n=Object.create(e.prototype);for(var r in t)n[r]=t[r];return n}function eK(){}var tK=.7,nK=1/tK,rK="\\s*([+-]?\\d+)\\s*",iK="\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)\\s*",oK="\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)%\\s*",aK=/^#([0-9a-f]{3,8})$/,sK=new RegExp(`^rgb\\(${rK},${rK},${rK}\\)$`),lK=new RegExp(`^rgb\\(${oK},${oK},${oK}\\)$`),cK=new RegExp(`^rgba\\(${rK},${rK},${rK},${iK}\\)$`),uK=new RegExp(`^rgba\\(${oK},${oK},${oK},${iK}\\)$`),dK=new RegExp(`^hsl\\(${iK},${oK},${oK}\\)$`),fK=new RegExp(`^hsla\\(${iK},${oK},${oK},${iK}\\)$`),mK={aliceblue:15792383,antiquewhite:16444375,aqua:65535,aquamarine:8388564,azure:15794175,beige:16119260,bisque:16770244,black:0,blanchedalmond:16772045,blue:255,blueviolet:9055202,brown:10824234,burlywood:14596231,cadetblue:6266528,chartreuse:8388352,chocolate:13789470,coral:16744272,cornflowerblue:6591981,cornsilk:16775388,crimson:14423100,cyan:65535,darkblue:139,darkcyan:35723,darkgoldenrod:12092939,darkgray:11119017,darkgreen:25600,darkgrey:11119017,darkkhaki:12433259,darkmagenta:9109643,darkolivegreen:5597999,darkorange:16747520,darkorchid:10040012,darkred:9109504,darksalmon:15308410,darkseagreen:9419919,darkslateblue:4734347,darkslategray:3100495,darkslategrey:3100495,darkturquoise:52945,darkviolet:9699539,deeppink:16716947,deepskyblue:49151,dimgray:6908265,dimgrey:6908265,dodgerblue:2003199,firebrick:11674146,floralwhite:16775920,forestgreen:2263842,fuchsia:16711935,gainsboro:14474460,ghostwhite:16316671,gold:16766720,goldenrod:14329120,gray:8421504,green:32768,greenyellow:11403055,grey:8421504,honeydew:15794160,hotpink:16738740,indianred:13458524,indigo:4915330,ivory:16777200,khaki:15787660,lavender:15132410,lavenderblush:16773365,lawngreen:8190976,lemonchiffon:16775885,lightblue:11393254,lightcoral:15761536,lightcyan:14745599,lightgoldenrodyellow:16448210,lightgray:13882323,lightgreen:9498256,lightgrey:13882323,lightpink:16758465,lightsalmon:16752762,lightseagreen:2142890,lightskyblue:8900346,lightslategray:7833753,lightslategrey:7833753,lightsteelblue:11584734,lightyellow:16777184,lime:65280,limegreen:3329330,linen:16445670,magenta:16711935,maroon:8388608,mediumaquamarine:6737322,mediumblue:205,mediumorchid:12211667,mediumpurple:9662683,mediumseagreen:3978097,mediumslateblue:8087790,mediumspringgreen:64154,mediumturquoise:4772300,mediumvioletred:13047173,midnightblue:1644912,mintcream:16121850,mistyrose:16770273,moccasin:16770229,navajowhite:16768685,navy:128,oldlace:16643558,olive:8421376,olivedrab:7048739,orange:16753920,orangered:16729344,orchid:14315734,palegoldenrod:15657130,palegreen:10025880,paleturquoise:11529966,palevioletred:14381203,papayawhip:16773077,peachpuff:16767673,peru:13468991,pink:16761035,plum:14524637,powderblue:11591910,purple:8388736,rebeccapurple:6697881,red:16711680,rosybrown:12357519,royalblue:4286945,saddlebrown:9127187,salmon:16416882,sandybrown:16032864,seagreen:3050327,seashell:16774638,sienna:10506797,silver:12632256,skyblue:8900331,slateblue:6970061,slategray:7372944,slategrey:7372944,snow:16775930,springgreen:65407,steelblue:4620980,tan:13808780,teal:32896,thistle:14204888,tomato:16737095,turquoise:4251856,violet:15631086,wheat:16113331,white:16777215,whitesmoke:16119285,yellow:16776960,yellowgreen:10145074};function gK(){return this.rgb().formatHex()}function hK(){return this.rgb().formatRgb()}function pK(e){var t,n;return e=(e+"").trim().toLowerCase(),(t=aK.exec(e))?(n=t[1].length,t=parseInt(t[1],16),6===n?vK(t):3===n?new xK(t>>8&15|t>>4&240,t>>4&15|240&t,(15&t)<<4|15&t,1):8===n?bK(t>>24&255,t>>16&255,t>>8&255,(255&t)/255):4===n?bK(t>>12&15|t>>8&240,t>>8&15|t>>4&240,t>>4&15|240&t,((15&t)<<4|15&t)/255):null):(t=sK.exec(e))?new xK(t[1],t[2],t[3],1):(t=lK.exec(e))?new xK(255*t[1]/100,255*t[2]/100,255*t[3]/100,1):(t=cK.exec(e))?bK(t[1],t[2],t[3],t[4]):(t=uK.exec(e))?bK(255*t[1]/100,255*t[2]/100,255*t[3]/100,t[4]):(t=dK.exec(e))?TK(t[1],t[2]/100,t[3]/100,1):(t=fK.exec(e))?TK(t[1],t[2]/100,t[3]/100,t[4]):mK.hasOwnProperty(e)?vK(mK[e]):"transparent"===e?new xK(NaN,NaN,NaN,0):null}function vK(e){return new xK(e>>16&255,e>>8&255,255&e,1)}function bK(e,t,n,r){return r<=0&&(e=t=n=NaN),new xK(e,t,n,r)}function yK(e,t,n,r){return 1===arguments.length?((i=e)instanceof eK||(i=pK(i)),i?new xK((i=i.rgb()).r,i.g,i.b,i.opacity):new xK):new xK(e,t,n,null==r?1:r);var i}function xK(e,t,n,r){this.r=+e,this.g=+t,this.b=+n,this.opacity=+r}function _K(){return`#${SK(this.r)}${SK(this.g)}${SK(this.b)}`}function jK(){const e=OK(this.opacity);return`${1===e?"rgb(":"rgba("}${EK(this.r)}, ${EK(this.g)}, ${EK(this.b)}${1===e?")":`, ${e})`}`}function OK(e){return isNaN(e)?1:Math.max(0,Math.min(1,e))}function EK(e){return Math.max(0,Math.min(255,Math.round(e)||0))}function SK(e){return((e=EK(e))<16?"0":"")+e.toString(16)}function TK(e,t,n,r){return r<=0?e=t=n=NaN:n<=0||n>=1?e=t=NaN:t<=0&&(e=NaN),new wK(e,t,n,r)}function IK(e){if(e instanceof wK)return new wK(e.h,e.s,e.l,e.opacity);if(e instanceof eK||(e=pK(e)),!e)return new wK;if(e instanceof wK)return e;var t=(e=e.rgb()).r/255,n=e.g/255,r=e.b/255,i=Math.min(t,n,r),o=Math.max(t,n,r),a=NaN,s=o-i,l=(o+i)/2;return s?(a=t===o?(n-r)/s+6*(n<r):n===o?(r-t)/s+2:(t-n)/s+4,s/=l<.5?o+i:2-o-i,a*=60):s=l>0&&l<1?0:a,new wK(a,s,l,e.opacity)}function wK(e,t,n,r){this.h=+e,this.s=+t,this.l=+n,this.opacity=+r}function PK(e){return(e=(e||0)%360)<0?e+360:e}function CK(e){return Math.max(0,Math.min(1,e||0))}function NK(e,t,n){return 255*(e<60?t+(n-t)*e/60:e<180?n:e<240?t+(n-t)*(240-e)/60:t)}function AK(e,t,n,r,i){var o=e*e,a=o*e;return((1-3*e+3*o-a)*t+(4-6*o+3*a)*n+(1+3*e+3*o-3*a)*r+a*i)/6}ZH(eK,pK,{copy(e){return Object.assign(new this.constructor,this,e)},displayable(){return this.rgb().displayable()},hex:gK,formatHex:gK,formatHex8:function(){return this.rgb().formatHex8()},formatHsl:function(){return IK(this).formatHsl()},formatRgb:hK,toString:hK}),ZH(xK,yK,JH(eK,{brighter(e){return e=null==e?nK:Math.pow(nK,e),new xK(this.r*e,this.g*e,this.b*e,this.opacity)},darker(e){return e=null==e?tK:Math.pow(tK,e),new xK(this.r*e,this.g*e,this.b*e,this.opacity)},rgb(){return this},clamp(){return new xK(EK(this.r),EK(this.g),EK(this.b),OK(this.opacity))},displayable(){return-.5<=this.r&&this.r<255.5&&-.5<=this.g&&this.g<255.5&&-.5<=this.b&&this.b<255.5&&0<=this.opacity&&this.opacity<=1},hex:_K,formatHex:_K,formatHex8:function(){return`#${SK(this.r)}${SK(this.g)}${SK(this.b)}${SK(255*(isNaN(this.opacity)?1:this.opacity))}`},formatRgb:jK,toString:jK})),ZH(wK,(function(e,t,n,r){return 1===arguments.length?IK(e):new wK(e,t,n,null==r?1:r)}),JH(eK,{brighter(e){return e=null==e?nK:Math.pow(nK,e),new wK(this.h,this.s,this.l*e,this.opacity)},darker(e){return e=null==e?tK:Math.pow(tK,e),new wK(this.h,this.s,this.l*e,this.opacity)},rgb(){var e=this.h%360+360*(this.h<0),t=isNaN(e)||isNaN(this.s)?0:this.s,n=this.l,r=n+(n<.5?n:1-n)*t,i=2*n-r;return new xK(NK(e>=240?e-240:e+120,i,r),NK(e,i,r),NK(e<120?e+240:e-120,i,r),this.opacity)},clamp(){return new wK(PK(this.h),CK(this.s),CK(this.l),OK(this.opacity))},displayable(){return(0<=this.s&&this.s<=1||isNaN(this.s))&&0<=this.l&&this.l<=1&&0<=this.opacity&&this.opacity<=1},formatHsl(){const e=OK(this.opacity);return`${1===e?"hsl(":"hsla("}${PK(this.h)}, ${100*CK(this.s)}%, ${100*CK(this.l)}%${1===e?")":`, ${e})`}`}}));const LK=e=>()=>e;function MK(e,t){return function(n){return e+n*t}}function kK(e){return 1==(e=+e)?RK:function(t,n){return n-t?function(e,t,n){return e=Math.pow(e,n),t=Math.pow(t,n)-e,n=1/n,function(r){return Math.pow(e+r*t,n)}}(t,n,e):LK(isNaN(t)?n:t)}}function RK(e,t){var n=t-e;return n?MK(e,n):LK(isNaN(e)?t:e)}const DK=function e(t){var n=kK(t);function r(e,t){var r=n((e=yK(e)).r,(t=yK(t)).r),i=n(e.g,t.g),o=n(e.b,t.b),a=RK(e.opacity,t.opacity);return function(t){return e.r=r(t),e.g=i(t),e.b=o(t),e.opacity=a(t),e+""}}return r.gamma=e,r}(1);function FK(e){return function(t){var n,r,i=t.length,o=new Array(i),a=new Array(i),s=new Array(i);for(n=0;n<i;++n)r=yK(t[n]),o[n]=r.r||0,a[n]=r.g||0,s[n]=r.b||0;return o=e(o),a=e(a),s=e(s),r.opacity=1,function(e){return r.r=o(e),r.g=a(e),r.b=s(e),r+""}}}FK((function(e){var t=e.length-1;return function(n){var r=n<=0?n=0:n>=1?(n=1,t-1):Math.floor(n*t),i=e[r],o=e[r+1],a=r>0?e[r-1]:2*i-o,s=r<t-1?e[r+2]:2*o-i;return AK((n-r/t)*t,a,i,o,s)}})),FK((function(e){var t=e.length;return function(n){var r=Math.floor(((n%=1)<0?++n:n)*t),i=e[(r+t-1)%t],o=e[r%t],a=e[(r+1)%t],s=e[(r+2)%t];return AK((n-r/t)*t,i,o,a,s)}}));function UK(e,t){var n,r=t?t.length:0,i=e?Math.min(r,e.length):0,o=new Array(i),a=new Array(r);for(n=0;n<i;++n)o[n]=YK(e[n],t[n]);for(;n<r;++n)a[n]=t[n];return function(e){for(n=0;n<i;++n)a[n]=o[n](e);return a}}function GK(e,t){var n=new Date;return e=+e,t=+t,function(r){return n.setTime(e*(1-r)+t*r),n}}function BK(e,t){return e=+e,t=+t,function(n){return e*(1-n)+t*n}}function VK(e,t){var n,r={},i={};for(n in null!==e&&"object"==typeof e||(e={}),null!==t&&"object"==typeof t||(t={}),t)n in e?r[n]=YK(e[n],t[n]):i[n]=t[n];return function(e){for(n in r)i[n]=r[n](e);return i}}var HK=/[-+]?(?:\d+\.?\d*|\.?\d+)(?:[eE][-+]?\d+)?/g,KK=new RegExp(HK.source,"g");function WK(e,t){var n,r,i,o=HK.lastIndex=KK.lastIndex=0,a=-1,s=[],l=[];for(e+="",t+="";(n=HK.exec(e))&&(r=KK.exec(t));)(i=r.index)>o&&(i=t.slice(o,i),s[a]?s[a]+=i:s[++a]=i),(n=n[0])===(r=r[0])?s[a]?s[a]+=r:s[++a]=r:(s[++a]=null,l.push({i:a,x:BK(n,r)})),o=KK.lastIndex;return o<t.length&&(i=t.slice(o),s[a]?s[a]+=i:s[++a]=i),s.length<2?l[0]?function(e){return function(t){return e(t)+""}}(l[0].x):function(e){return function(){return e}}(t):(t=l.length,function(e){for(var n,r=0;r<t;++r)s[(n=l[r]).i]=n.x(e);return s.join("")})}function zK(e,t){t||(t=[]);var n,r=e?Math.min(t.length,e.length):0,i=t.slice();return function(o){for(n=0;n<r;++n)i[n]=e[n]*(1-o)+t[n]*o;return i}}function YK(e,t){var n,r,i=typeof t;return null==t||"boolean"===i?LK(t):("number"===i?BK:"string"===i?(n=pK(t))?(t=n,DK):WK:t instanceof pK?DK:t instanceof Date?GK:(r=t,!ArrayBuffer.isView(r)||r instanceof DataView?Array.isArray(t)?UK:"function"!=typeof t.valueOf&&"function"!=typeof t.toString||isNaN(t)?VK:BK:zK))(e,t)}function $K(e,t){return e=+e,t=+t,function(n){return Math.round(e*(1-n)+t*n)}}function qK(e){return+e}var XK=[0,1];function QK(e){return e}function ZK(e,t){return(t-=e=+e)?function(n){return(n-e)/t}:(n=isNaN(t)?NaN:.5,function(){return n});var n}function JK(e,t,n){var r=e[0],i=e[1],o=t[0],a=t[1];return i<r?(r=ZK(i,r),o=n(a,o)):(r=ZK(r,i),o=n(o,a)),function(e){return o(r(e))}}function eW(e,t,n){var r=Math.min(e.length,t.length)-1,i=new Array(r),o=new Array(r),a=-1;for(e[r]<e[0]&&(e=e.slice().reverse(),t=t.slice().reverse());++a<r;)i[a]=ZK(e[a],e[a+1]),o[a]=n(t[a],t[a+1]);return function(t){var n=QH(e,t,1,r)-1;return o[n](i[n](t))}}function tW(){var e,t,n,r,i,o,a=XK,s=XK,l=YK,c=QK;function u(){var e,t,n,l=Math.min(a.length,s.length);return c!==QK&&(e=a[0],t=a[l-1],e>t&&(n=e,e=t,t=n),c=function(n){return Math.max(e,Math.min(t,n))}),r=l>2?eW:JK,i=o=null,d}function d(t){return null==t||isNaN(t=+t)?n:(i||(i=r(a.map(e),s,l)))(e(c(t)))}return d.invert=function(n){return c(t((o||(o=r(s,a.map(e),BK)))(n)))},d.domain=function(e){return arguments.length?(a=Array.from(e,qK),u()):a.slice()},d.range=function(e){return arguments.length?(s=Array.from(e),u()):s.slice()},d.rangeRound=function(e){return s=Array.from(e),l=$K,u()},d.clamp=function(e){return arguments.length?(c=!!e||QK,u()):c!==QK},d.interpolate=function(e){return arguments.length?(l=e,u()):l},d.unknown=function(e){return arguments.length?(n=e,d):n},function(n,r){return e=n,t=r,u()}}function nW(e,t){switch(arguments.length){case 0:break;case 1:this.range(e);break;default:this.range(t).domain(e)}return this}var rW,iW=/^(?:(.)?([<>=^]))?([+\-( ])?([$#])?(0)?(\d+)?(,)?(\.\d+)?(~)?([a-z%])?$/i;function oW(e){if(!(t=iW.exec(e)))throw new Error("invalid format: "+e);var t;return new aW({fill:t[1],align:t[2],sign:t[3],symbol:t[4],zero:t[5],width:t[6],comma:t[7],precision:t[8]&&t[8].slice(1),trim:t[9],type:t[10]})}function aW(e){this.fill=void 0===e.fill?" ":e.fill+"",this.align=void 0===e.align?">":e.align+"",this.sign=void 0===e.sign?"-":e.sign+"",this.symbol=void 0===e.symbol?"":e.symbol+"",this.zero=!!e.zero,this.width=void 0===e.width?void 0:+e.width,this.comma=!!e.comma,this.precision=void 0===e.precision?void 0:+e.precision,this.trim=!!e.trim,this.type=void 0===e.type?"":e.type+""}function sW(e,t){if((n=(e=t?e.toExponential(t-1):e.toExponential()).indexOf("e"))<0)return null;var n,r=e.slice(0,n);return[r.length>1?r[0]+r.slice(2):r,+e.slice(n+1)]}function lW(e){return(e=sW(Math.abs(e)))?e[1]:NaN}function cW(e,t){var n=sW(e,t);if(!n)return e+"";var r=n[0],i=n[1];return i<0?"0."+new Array(-i).join("0")+r:r.length>i+1?r.slice(0,i+1)+"."+r.slice(i+1):r+new Array(i-r.length+2).join("0")}oW.prototype=aW.prototype,aW.prototype.toString=function(){return this.fill+this.align+this.sign+this.symbol+(this.zero?"0":"")+(void 0===this.width?"":Math.max(1,0|this.width))+(this.comma?",":"")+(void 0===this.precision?"":"."+Math.max(0,0|this.precision))+(this.trim?"~":"")+this.type};const uW={"%":(e,t)=>(100*e).toFixed(t),b:e=>Math.round(e).toString(2),c:e=>e+"",d:function(e){return Math.abs(e=Math.round(e))>=1e21?e.toLocaleString("en").replace(/,/g,""):e.toString(10)},e:(e,t)=>e.toExponential(t),f:(e,t)=>e.toFixed(t),g:(e,t)=>e.toPrecision(t),o:e=>Math.round(e).toString(8),p:(e,t)=>cW(100*e,t),r:cW,s:function(e,t){var n=sW(e,t);if(!n)return e+"";var r=n[0],i=n[1],o=i-(rW=3*Math.max(-8,Math.min(8,Math.floor(i/3))))+1,a=r.length;return o===a?r:o>a?r+new Array(o-a+1).join("0"):o>0?r.slice(0,o)+"."+r.slice(o):"0."+new Array(1-o).join("0")+sW(e,Math.max(0,t+o-1))[0]},X:e=>Math.round(e).toString(16).toUpperCase(),x:e=>Math.round(e).toString(16)};function dW(e){return e}var fW,mW,gW,hW=Array.prototype.map,pW=["y","z","a","f","p","n","µ","m","","k","M","G","T","P","E","Z","Y"];function vW(e){var t,n,r=void 0===e.grouping||void 0===e.thousands?dW:(t=hW.call(e.grouping,Number),n=e.thousands+"",function(e,r){for(var i=e.length,o=[],a=0,s=t[0],l=0;i>0&&s>0&&(l+s+1>r&&(s=Math.max(1,r-l)),o.push(e.substring(i-=s,i+s)),!((l+=s+1)>r));)s=t[a=(a+1)%t.length];return o.reverse().join(n)}),i=void 0===e.currency?"":e.currency[0]+"",o=void 0===e.currency?"":e.currency[1]+"",a=void 0===e.decimal?".":e.decimal+"",s=void 0===e.numerals?dW:function(e){return function(t){return t.replace(/[0-9]/g,(function(t){return e[+t]}))}}(hW.call(e.numerals,String)),l=void 0===e.percent?"%":e.percent+"",c=void 0===e.minus?"−":e.minus+"",u=void 0===e.nan?"NaN":e.nan+"";function d(e){var t=(e=oW(e)).fill,n=e.align,d=e.sign,f=e.symbol,m=e.zero,g=e.width,h=e.comma,p=e.precision,v=e.trim,b=e.type;"n"===b?(h=!0,b="g"):uW[b]||(void 0===p&&(p=12),v=!0,b="g"),(m||"0"===t&&"="===n)&&(m=!0,t="0",n="=");var y="$"===f?i:"#"===f&&/[boxX]/.test(b)?"0"+b.toLowerCase():"",x="$"===f?o:/[%p]/.test(b)?l:"",_=uW[b],j=/[defgprs%]/.test(b);function O(e){var i,o,l,f=y,O=x;if("c"===b)O=_(e)+O,e="";else{var E=(e=+e)<0||1/e<0;if(e=isNaN(e)?u:_(Math.abs(e),p),v&&(e=function(e){e:for(var t,n=e.length,r=1,i=-1;r<n;++r)switch(e[r]){case".":i=t=r;break;case"0":0===i&&(i=r),t=r;break;default:if(!+e[r])break e;i>0&&(i=0)}return i>0?e.slice(0,i)+e.slice(t+1):e}(e)),E&&0==+e&&"+"!==d&&(E=!1),f=(E?"("===d?d:c:"-"===d||"("===d?"":d)+f,O=("s"===b?pW[8+rW/3]:"")+O+(E&&"("===d?")":""),j)for(i=-1,o=e.length;++i<o;)if(48>(l=e.charCodeAt(i))||l>57){O=(46===l?a+e.slice(i+1):e.slice(i))+O,e=e.slice(0,i);break}}h&&!m&&(e=r(e,1/0));var S=f.length+e.length+O.length,T=S<g?new Array(g-S+1).join(t):"";switch(h&&m&&(e=r(T+e,T.length?g-O.length:1/0),T=""),n){case"<":e=f+e+O+T;break;case"=":e=f+T+e+O;break;case"^":e=T.slice(0,S=T.length>>1)+f+e+O+T.slice(S);break;default:e=T+f+e+O}return s(e)}return p=void 0===p?6:/[gprs]/.test(b)?Math.max(1,Math.min(21,p)):Math.max(0,Math.min(20,p)),O.toString=function(){return e+""},O}return{format:d,formatPrefix:function(e,t){var n=d(((e=oW(e)).type="f",e)),r=3*Math.max(-8,Math.min(8,Math.floor(lW(t)/3))),i=Math.pow(10,-r),o=pW[8+r/3];return function(e){return n(i*e)+o}}}}function bW(e,t,n,r){var i,o=function(e,t,n){n=+n;const r=(t=+t)<(e=+e),i=r?KH(t,e,n):KH(e,t,n);return(r?-1:1)*(i<0?1/-i:i)}(e,t,n);switch((r=oW(null==r?",f":r)).type){case"s":var a=Math.max(Math.abs(e),Math.abs(t));return null!=r.precision||isNaN(i=function(e,t){return Math.max(0,3*Math.max(-8,Math.min(8,Math.floor(lW(t)/3)))-lW(Math.abs(e)))}(o,a))||(r.precision=i),gW(r,a);case"":case"e":case"g":case"p":case"r":null!=r.precision||isNaN(i=function(e,t){return e=Math.abs(e),t=Math.abs(t)-e,Math.max(0,lW(t)-lW(e))+1}(o,Math.max(Math.abs(e),Math.abs(t))))||(r.precision=i-("e"===r.type));break;case"f":case"%":null!=r.precision||isNaN(i=function(e){return Math.max(0,-lW(Math.abs(e)))}(o))||(r.precision=i-2*("%"===r.type))}return mW(r)}function yW(e){var t=e.domain;return e.ticks=function(e){var n=t();return function(e,t,n){if(!((n=+n)>0))return[];if((e=+e)==(t=+t))return[e];const r=t<e,[i,o,a]=r?HH(t,e,n):HH(e,t,n);if(!(o>=i))return[];const s=o-i+1,l=new Array(s);if(r)if(a<0)for(let e=0;e<s;++e)l[e]=(o-e)/-a;else for(let e=0;e<s;++e)l[e]=(o-e)*a;else if(a<0)for(let e=0;e<s;++e)l[e]=(i+e)/-a;else for(let e=0;e<s;++e)l[e]=(i+e)*a;return l}(n[0],n[n.length-1],null==e?10:e)},e.tickFormat=function(e,n){var r=t();return bW(r[0],r[r.length-1],null==e?10:e,n)},e.nice=function(n){null==n&&(n=10);var r,i,o=t(),a=0,s=o.length-1,l=o[a],c=o[s],u=10;for(c<l&&(i=l,l=c,c=i,i=a,a=s,s=i);u-- >0;){if((i=KH(l,c,n))===r)return o[a]=l,o[s]=c,t(o);if(i>0)l=Math.floor(l/i)*i,c=Math.ceil(c/i)*i;else{if(!(i<0))break;l=Math.ceil(l*i)/i,c=Math.floor(c*i)/i}r=i}return e},e}function xW(){var e=tW()(QK,QK);return e.copy=function(){return function(e,t){return t.domain(e.domain()).range(e.range()).interpolate(e.interpolate()).clamp(e.clamp()).unknown(e.unknown())}(e,xW())},nW.apply(e,arguments),yW(e)}function _W(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function jW(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}fW=vW({thousands:",",grouping:[3],currency:["$",""]}),mW=fW.format,gW=fW.formatPrefix;var OW=function(e){var t=KV().viewport,n=t.posFromPoint,r=t.rem,i=e.d,o=e.strokeWidth,a=e.fill,s=void 0===a?"transparent":a,l=jW(e,["d","strokeWidth","fill"]),c=(0,Y.useMemo)((function(){return null==i?void 0:i.replace(/(-?\d+\.?\d*),(-?\d+\.?\d*)/g,(function(e,t,r){var i=n(Number(t),Number(r));return"".concat(i.x,",").concat(i.y)})).replace(/([HhVv])\s*?(-?\d+\.?\d*)/g,(function(e,t,r){var i="h"===t.toLowerCase(),o=n(Number(r),Number(r));return"".concat(t," ").concat(i?o.x:o.y)}))}),[i,n]);return(0,z.jsx)("path",function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){_W(e,t,n[t])}))}return e}({d:c,strokeWidth:o?r(o):void 0,fill:s},l))};oe.add("game-ui/common/svg/elements/path.tsx",{get Path(){return OW},set Path(e){OW=e}});let EW={"grid-lines":"grid-lines_BXH",gridLines:"grid-lines_BXH","axis-labels":"axis-labels_IjN",axisLabels:"axis-labels_IjN"};oe.add("game-ui/common/svg/svg.module.scss",{get classes(){return EW},set classes(e){Object.assign(EW,e)}});const SW=EW;var TW=function(e){var t,n,r=e.label,i=e.x,o=e.y,a=e.fontSize,s=e.color,l=e.rotation,c=void 0===l?0:l,u=e.onTop,d=e.textAnchor;switch(void 0===r?"undefined":(n=r)&&"undefined"!=typeof Symbol&&n.constructor===Symbol?"symbol":typeof n){case"string":case"object":t=r;break;default:t=e.label.toString().replace(/^(-)?0/,"$1")||"0"}return(0,z.jsx)("g",{transform:"translate(".concat(i+.5*a," ").concat(o+a*(u?.5:-1.5),") rotate(").concat(c,"deg)"),children:(0,z.jsx)("text",{transform:"scale(1 -1)",fontSize:a,fill:s,textAnchor:d,children:t})})},IW=function(e){var t=e.fixed,n=e.overdraw,r=void 0!==n&&n,i=e.textScale,o=void 0===i?1:i,a=e.tickWidth,s=void 0===a?100:a,l=e.tickHeight,c=void 0===l?100:l,u=e.formatLabelX,d=e.formatLabelY,f=KV().viewport,m=f.size,g=f.rem,h=f.bounds,p=f.posFromPoint,v=(0,Y.useMemo)((function(){if(!h)return{};for(var e="",n=Number(r)*Math.max(g(s)/m.width,g(c)/m.height)*2,i=1+2*n,a=[],l=[],f=Math.ceil(m.width*i/g(s)),v=Math.ceil(m.height*i/g(c)),b=h.max.x-h.min.x,y=h.max.y-h.min.y,x=h.min.x-b*n,_=h.max.x+b*n,j=h.min.y-y*n,O=h.max.y+y*n,E=xW().domain([x,_]).nice().ticks(f),S=0;S<E.length;S++){var T=p(E[S],0),I=u?u(E[S]):E[S],w=S===E.length-1?"end":"mid";a.push((0,z.jsx)(TW,{x:T.x,y:t?0:T.y,label:I,fontSize:g(11*o),onTop:t,textAnchor:w},"".concat(S,"-").concat(I,"-").concat(T.x)))}for(var P=xW().domain([j,O]).nice().ticks(v),C=0;C<P.length;C++){var N=p(0,P[C]),A=d?d(P[C]):P[C];l.push((0,z.jsx)(TW,{x:t?0:N.x,y:N.y,label:A,fontSize:g(11*o),onTop:t},"".concat(C,"-").concat(A,"-").concat(N.y)))}return t||(e+="M ".concat(x,",0 L ").concat(_,", 0 "),e+="M 0, ".concat(j," L 0, ").concat(O)),{axesPath:e,xLabels:a,yLabels:l}}),[h,r,g,s,m.width,m.height,c,t,p,u,o,d]),b=v.axesPath,y=v.xLabels,x=v.yLabels;return(0,z.jsxs)("g",{className:SW.axisLabels,children:[b&&(0,z.jsx)(OW,{d:b,strokeWidth:.5,stroke:"#fff7"}),(0,z.jsx)("g",{children:y}),(0,z.jsx)("g",{children:x})]})};oe.add("game-ui/common/svg/components/axis-labels.tsx",{get GridLineAxisTick(){return TW},set GridLineAxisTick(e){TW=e},get AxisLabels(){return IW},set AxisLabels(e){IW=e}});var wW=function(e){var t=e.halfSteps,n=e.overdraw,r=void 0!==n&&n,i=e.drawAxes,o=void 0===i||i,a=e.tickWidth,s=void 0===a?100:a,l=e.tickHeight,c=void 0===l?100:l,u=KV().viewport,d=u.size,f=u.rem,m=u.bounds,g=(0,Y.useMemo)((function(){if(!m||!o)return{};var e="\n",n="\n",i=Number(r)*Math.max(f(s)/d.width,f(c)/d.height)*2,a=1+2*i,l=m.max.x-m.min.x,u=m.max.y-m.min.y,g=m.min.x-l*i,h=m.max.x+l*i,p=m.min.y-u*i,v=m.max.y+u*i;if(!0===o||o.includes("x")){for(var b=Math.ceil(d.width*a/f(s)),y=xW().domain([g,h]).nice().ticks(b),x=(y[1]-y[0])/2,_=0;_<y.length;_++)e+="M ".concat(y[_],",").concat(p," V ").concat(v," "),e+="\n",t&&(n+="M ".concat(y[_]+x,",").concat(p," V ").concat(v," "),n+="\n");e+="\n",n+="\n"}if(!0===o||o.includes("y"))for(var j=Math.ceil(d.height*a/f(c)),O=xW().domain([p,v]).nice().ticks(j),E=(O[1]-O[0])/2,S=0;S<O.length;S++)e+="M ".concat(g,",").concat(O[S]," H ").concat(h," "),e+="\n",t&&(n+="M ".concat(g,",").concat(O[S]+E," H ").concat(h," "),n+="\n");return{gridPath:e,halfStepsGridPath:n,xLabels:[],yLabels:[]}}),[m,o,r,f,s,d.width,d.height,c,t]),h=g.gridPath,p=g.halfStepsGridPath;return(0,z.jsxs)("g",{className:SW.gridLines,children:[(0,z.jsx)(OW,{d:h,strokeWidth:.5,stroke:"#fff3"}),p&&(0,z.jsx)(OW,{d:p,strokeWidth:.5,stroke:"#fff1"})]})};oe.add("game-ui/common/svg/components/grid-lines.tsx",{get GridLines(){return wW},set GridLines(e){wW=e}});let PW={"tooltip-base":"tooltip-base_zwi",tooltipBase:"tooltip-base_zwi","tooltip-fade-in":"tooltip-fade-in_S9n",tooltipFadeIn:"tooltip-fade-in_S9n",fadeIn:"fadeIn_VY9",tooltip:"tooltip_xe4 tooltip-base_zwi tooltip-fade-in_S9n"};oe.add("game-ui/common/tooltip/floating-mouse-tooltip/floating-mouse-tooltip.module.scss",{get classes(){return PW},set classes(e){Object.assign(PW,e)}});const CW=PW;function NW(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function AW(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function LW(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return NW(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return NW(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var MW=0,kW=16,RW=function(e){var t=e.tooltip,n=e.disabled,r=e.theme,i=e.alwaysVisible,o=void 0!==i&&i,a=e.screenSpacePosition,s=void 0!==a&&a,l=e.style,c=e.className,u=e.children;if(!s&&!Y.isValidElement(u))throw new Error("Tooltip requires a single child react element!");var d=(0,Y.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){AW(e,t,n[t])}))}return e}({},CW,r)}),[r]),f=LW((0,Y.useState)(o),2),m=f[0],g=f[1],h=(0,Y.useRef)(lf),p=(0,Y.useRef)(null),v=(0,Y.useCallback)((function(e){p.current=e,null!=e&&DW(e,h.current)}),[]),b=(0,Y.useCallback)((function(e){h.current=jf(e),g(o||!0)}),[o]),y=(0,Y.useCallback)((function(e){h.current=jf(e),null!=p.current&&DW(p.current,h.current,s)}),[s]),x=(0,Y.useCallback)((function(e){return g(o||!1)}),[o]),_=(0,Y.useCallback)((function(e){return g(o||!1)}),[o]),j=(0,Y.useRef)(null),O=(0,Y.useCallback)((function(e){j.current!==e&&(null!=j.current&&(j.current.removeEventListener("mouseover",b),j.current.removeEventListener("mousemove",y),j.current.removeEventListener("mouseleave",x),j.current.removeEventListener("mousedown",_)),null!=e&&(e.addEventListener("mouseover",b),e.addEventListener("mousemove",y),e.addEventListener("mouseleave",x),e.addEventListener("mousedown",_)),j.current=e)}),[_,x,y,b]);(0,Y.useEffect)((function(){s&&O(document.body)}),[s]);var E=!!t&&(s||Y.Children.count(u)>0),S=(0,Y.useContext)(hh);return(0,z.jsxs)(z.Fragment,{children:[!s&&(0,z.jsx)(Zd,{ref:O,children:u}),E&&!n&&m&&!S&&(0,z.jsx)(tm,{children:(0,z.jsx)("div",{className:_d()(d.tooltip,c),style:l,ref:v,children:t})})]})};function DW(e,t,n){var r=t.x+MW,i=t.y+kW;if(n)return e.style.left="".concat(r,"px"),void(e.style.top="".concat(i,"px"));e.style.left="".concat(r,"px"),e.style.top="".concat(i,"px"),requestAnimationFrame((function(){var t=e.getBoundingClientRect(),n=window.innerWidth-t.width,o=window.innerHeight-t.height;r>n&&(e.style.left="".concat(n,"px")),i>o&&(e.style.top="".concat(o,"px"))}))}function FW(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function UW(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function GW(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){UW(e,t,n[t])}))}return e}function BW(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function VW(e){return function(e){if(Array.isArray(e))return FW(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return FW(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return FW(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/tooltip/floating-mouse-tooltip/floating-mouse-tooltip.tsx",{get FloatingMouseTooltip(){return RW},set FloatingMouseTooltip(e){RW=e}});var HW=function(e,t,n,r){return e+(t-n)*r},KW=function(e,t){return e&&e.min.y===t.min.y&&e.max.y===t.max.y&&e.min.x===t.min.x&&e.max.x===t.max.x?e:t},WW={inTangent:0,outTangent:0,inWeight:0,outWeight:0,weightedMode:0,readonly:!0},zW=function(e,t,n){e&&t.filter((function(e){return e.keys.length>0})).map((function(t){var r=t.keys;r[0].readonly&&r.splice(0,1),r[r.length-1].readonly&&r.splice(r.length-1,1);var i,o,a=r.length-1,s=r[0],l=r[1],c=r[a],u=r[a-1];s.time>n.min.x&&("clamp"===e?(s.inTangent=0,i=BW(GW({},WW),{time:n.min.x,value:s.value})):"loop"===e?(i=BW(GW({},WW,c),{time:s.time-(c.time-u.time)}),s.inTangent=c.inTangent,s.inWeight=c.inWeight):(i=BW(GW({},WW,l),{outTangent:-l.inTangent,outWeight:l.inWeight,time:s.time-(l.time-s.time)}),s.inTangent=-s.outTangent,s.inWeight=s.outWeight),i&&r.unshift(i));c.time<n.max.x&&("clamp"===e?(c.outTangent=0,o=BW(GW({},WW),{time:n.max.x,value:c.value})):"loop"===e?(o=BW(GW({},WW,s),{time:c.time+(l.time-s.time)}),c.outTangent=s.outTangent,c.outWeight=s.outWeight):(o=BW(GW({},WW,u),{inTangent:-u.outTangent,inWeight:u.outWeight,time:c.time+(c.time-u.time)}),c.outTangent=-c.inTangent,c.outWeight=c.inWeight),o&&r.push(o));t.keys=VW(r)}))};oe.add("game-ui/editor/widgets/fields/animation-curve-field/utils/helpers.ts",{get project(){return HW},set project(e){HW=e},get newBounds2IfChanged(){return KW},set newBounds2IfChanged(e){KW=e},get insertDummyWrapModeKeyframes(){return zW},set insertDummyWrapModeKeyframes(e){zW=e}});var YW=function(e){return e.reduce((function(t,n,r){if(0===r)t.push("M ".concat(n.time,",").concat(n.value));else{var i=e[r-1],o=isFinite(i.outTangent)&&isFinite(n.inTangent),a=i.time,s=i.value,l=n.time,c=n.value,u=i.outTangent,d=n.inTangent,f=i.outWeight,m=1-n.inWeight;if(o){var g=HW(a,l,a,f),h=HW(s,g,a,u),p=HW(a,l,a,m),v=HW(c,p,l,d);t.push("C".concat(g,",").concat(h," ").concat(p,",").concat(v," ").concat(l,",").concat(c))}else s===c?t.push("L".concat(l,",").concat(c)):u===Number.NEGATIVE_INFINITY&&d!==Number.POSITIVE_INFINITY||u!==Number.POSITIVE_INFINITY&&d===Number.NEGATIVE_INFINITY?t.push("L".concat(a,",").concat(c," ").concat(l,",").concat(c)):t.push("L ".concat(l,",").concat(s," ").concat(l,",").concat(c))}return t}),[])};oe.add("game-ui/editor/widgets/fields/animation-curve-field/utils/make-curve-path.ts",{get makeCurvePath(){return YW},set makeCurvePath(e){YW=e}});let $W={"animation-curve-editor":"animation-curve-editor_sfs",animationCurveEditor:"animation-curve-editor_sfs",editorItem:"editorItem_DvB",editor:"editor_Es7",row:"row_GIj row_d2o",controls:"controls_RpG",column:"column_MrW",label:"label_ozJ label_BbZ",control:"control_Ivd control_Hds","animation-curve-path":"animation-curve-path_TwV",animationCurvePath:"animation-curve-path_TwV","default-stroke":"default-stroke_Bng",defaultStroke:"default-stroke_Bng","animation-curve-control-point-arm":"animation-curve-control-point-arm_Wh2",animationCurveControlPointArm:"animation-curve-control-point-arm_Wh2","animation-curve-control-point-handle":"animation-curve-control-point-handle_qUn",animationCurveControlPointHandle:"animation-curve-control-point-handle_qUn","animation-curve-keyframe":"animation-curve-keyframe_DpO",animationCurveKeyframe:"animation-curve-keyframe_DpO","multiple-curves":"multiple-curves_HvS",multipleCurves:"multiple-curves_HvS","animation-curve-keyframes":"animation-curve-keyframes_TMk",animationCurveKeyframes:"animation-curve-keyframes_TMk","animation-curve-preview-path":"animation-curve-preview-path_VCR",animationCurvePreviewPath:"animation-curve-preview-path_VCR",hidden:"hidden_prB"};oe.add("game-ui/editor/widgets/fields/animation-curve-field/animation-curve-editor.module.scss",{get classes(){return $W},set classes(e){Object.assign($W,e)}});const qW=$W;function XW(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function QW(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var ZW=function(e){var t=e.keys,n=void 0===t?[]:t,r=e.base,i=e.color,o=e.className,a=(0,Y.useMemo)((function(){var e=YW(n),t=YW(n.map((function(e,t){return QW(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){XW(e,t,n[t])}))}return e}({},e),{value:r[t].value-(e.value-r[t].value)})})).reverse());return e.concat(t).join(" ").replace(" M"," L")+" z"}),[r,n]);return(0,z.jsx)(OW,{d:a,fill:i,className:_d()(o,0===n.length&&qW.hidden)})};function JW(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}oe.add("game-ui/editor/widgets/fields/animation-curve-field/components/animation-curve-deviation.tsx",{get AnimationCurveDeviation(){return ZW},set AnimationCurveDeviation(e){ZW=e}});var ez=function(e){var t=e.keys,n=void 0===t?[]:t,r=e.color,i=e.className,o=(0,Y.useMemo)((function(){return YW(n).join(" ")}),[n]);return(0,z.jsx)(OW,{d:o,stroke:r,className:_d()(qW.animationCurvePath,i,0===n.length&&qW.hidden,JW({},qW.defaultStroke,!r))})};oe.add("game-ui/editor/widgets/fields/animation-curve-field/components/animation-curve-path.tsx",{get AnimationCurvePath(){return ez},set AnimationCurvePath(e){ez=e}});let tz={"tooltip-row":"tooltip-row_zpQ",tooltipRow:"tooltip-row_zpQ","tooltip-label":"tooltip-label_JO7",tooltipLabel:"tooltip-label_JO7"};oe.add("game-ui/editor/widgets/fields/animation-curve-field/components/keyframe.module.scss",{get classes(){return tz},set classes(e){Object.assign(tz,e)}});const nz=tz;var rz,iz,oz=function(e){if(0===e)return"00.000s";var t=Math.floor(e/3600),n=Math.floor((e-3600*t)/60),r=Math.floor(e-3600*t-60*n),i=(e%1).toFixed(3).replace("0.",""),o="";return t&&(o+=t.toString().padStart(2,"0")+":"),n&&(o+=n.toString().padStart(2,"0")+":"),o+=r.toString().padStart(2,"0")+".",(o+=i)+"s"},az=function(e){var t=e.keyframe,n=e.hide;return t?(0,z.jsxs)("div",{children:["time"!==n&&"number"==typeof t.time&&(0,z.jsxs)("div",{className:nz.tooltipRow,children:[(0,z.jsxs)("div",{className:nz.tooltipLabel,children:[(0,z.jsx)(qc.AnimationCurve.TIME_LABEL,{}),":"]}),(0,z.jsx)("div",{children:oz(t.time)})]}),"value"!==n&&"number"==typeof t.value&&(0,z.jsxs)("div",{className:nz.tooltipRow,children:[(0,z.jsxs)("div",{className:nz.tooltipLabel,children:[(0,z.jsx)(qc.AnimationCurve.VALUE_LABEL,{}),":"]}),(0,z.jsx)("div",{children:t.value.toFixed(3)})]})]}):null};oe.add("game-ui/editor/widgets/fields/animation-curve-field/components/keyframe-tooltip.tsx",{get KeyframeTooltip(){return az},set KeyframeTooltip(e){az=e}}),function(e){e[e.None=0]="None",e[e.In=1]="In",e[e.Out=2]="Out",e[e.Both=3]="Both"}(rz||(rz={})),function(e){e[e.Default=0]="Default",e[e.Clamp=1]="Clamp",e[e.Once=1]="Once",e[e.Loop=2]="Loop",e[e.PingPong=4]="PingPong",e[e.ClampForever=8]="ClampForever"}(iz||(iz={}));var sz={time:0,value:0,inTangent:0,outTangent:0,inWeight:0,outWeight:0,weightedMode:rz.None};function lz(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function cz(e,t,n,r,i,o,a){try{var s=e[o](a),l=s.value}catch(e){return void n(e)}s.done?t(l):Promise.resolve(l).then(r,i)}function uz(e){return function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){cz(o,r,i,a,s,"next",e)}function s(e){cz(o,r,i,a,s,"throw",e)}a(void 0)}))}}function dz(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function fz(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return lz(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return lz(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/editor/data-binding/editor-types.ts",{get WeightedMode(){return rz},set WeightedMode(e){rz=e},get WrapMode(){return iz},set WrapMode(e){iz=e},get defaultKeyframe(){return sz},set defaultKeyframe(e){sz=e}});var mz=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}},gz={data:{curves:[{keys:[],preWrapMode:iz.Default,postWrapMode:iz.Default}],bounds:{min:{x:0,y:0},max:{x:0,y:0}}},activeKeyframe:-1,draggedKeyframeRef:{current:-1},activeCurve:0,activeProperty:0,canAddKeyframes:!1,smoothenOnMove:!1,isDraggingKeyframe:!1,selectActiveCurve:function(){},deselectKeyframes:function(){},selectKeyframe:function(){},setDraggedKeyframe:function(){},removeKeyframe:function(){},setKeyframes:function(){},updateKeyframe:uz((function(){return mz(this,(function(e){return[2,-1]}))})),addKeyframe:uz((function(){return mz(this,(function(e){return[2,-1]}))}))},hz=(0,Y.createContext)(gz),pz=function(e){var t=e.children,n=e.data,r=e.canAddKeyframes,i=e.smoothenOnMove,o=e.hideControlPoints,a=e.allowEditingAll,s=e.parseKeyframe,l=e.keyframeRenderer,c=e.onMoveKeyframe,u=e.onAddKeyframe,d=e.onRemoveKeyframe,f=e.onSetKeyframes,m=e.onSetActiveCurve,g=e.onSetActiveKeyFrame,h=fz((0,Y.useState)(-1),2),p=h[0],v=h[1],b=fz((0,Y.useState)(!1),2),y=b[0],x=b[1],_=fz((0,Y.useState)(0),2),j=_[0],O=_[1],E=(0,Y.useRef)(-1),S=(0,Y.useCallback)((function(e){E.current=e,x(!0);var t=function(){E.current=-1,document.removeEventListener("mouseup",t),x(!1)};document.addEventListener("mouseup",t)}),[]),T=(0,Y.useMemo)((function(){var e,t,r=null===(e=n.curves[j])||void 0===e?void 0:e.keys[0],i=(null==r?void 0:r.readonly)?1:0,o=(t=uz((function(e,t){return mz(this,(function(n){switch(n.label){case 0:if(!f)throw"onSetKeyframes not provided";return[4,f(e,t)];case 1:return n.sent(),a(-1),[2]}}))})),function(e,n){return t.apply(this,arguments)}),a=function(e,t){t&&j!==t&&O(t),v((function(t){return t===e?-1:e})),null==g||g(j,e-i)},s=function(){var e=uz((function(e,t,o){var a,s;return mz(this,(function(l){switch(l.label){case 0:if(!u)throw"onAddKeyframe not provided";return n.curves[o]?[4,u(e,t,o)]:[3,2];case 1:return a=l.sent(),s=a+(e>(null==r?void 0:r.time)?i:0),v(s),null==g||g(j,s),[2,s];case 2:return[2,-1]}}))}));return function(t,n,r){return e.apply(this,arguments)}}(),l=function(){var e=uz((function(e,t,n,o){var a,s,l;return mz(this,(function(u){switch(u.label){case 0:if(!c)throw"onMoveKeyframe not provided";return a=Math.max(0,e-i),[4,c(a,t,n,o)];case 1:return s=u.sent(),l=s+(t.time>(null==r?void 0:r.time)?i:0),v((function(e){return-1===e?-1:l})),[2,l]}}))}));return function(t,n,r,i){return e.apply(this,arguments)}}();return{selectActiveCurve:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:-1;O(e),null==m||m(e),a(t,e),null==g||g(e,t)},deselectKeyframes:function(){a(-1)},selectKeyframe:a,addKeyframe:s,updateKeyframe:l,removeKeyframe:function(e,t){if(!d)throw"onRemoveKeyframe not provided";var n=Math.max(0,e-i);d(n,t),a(-1)},setKeyframes:o}}),[j,n.curves,u,c,d,m,g,f]);(0,Y.useEffect)((function(){var e,t=(null===(e=n.curves[j])||void 0===e?void 0:e.keys.length)-1||-1;p>t&&v(t)}),[j,p,n.curves]);var I=(0,Y.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){dz(e,t,n[t])}))}return e}({data:n,activeKeyframe:p,draggedKeyframeRef:E,activeCurve:j,canAddKeyframes:r,smoothenOnMove:i,hideControlPoints:o,allowEditingAll:a,parseKeyframe:s,keyframeRenderer:l,setDraggedKeyframe:S,isDraggingKeyframe:y},T)}),[n,p,j,r,i,o,a,s,l,S,y,T]);return(0,z.jsx)(hz.Provider,{value:I,children:t})},vz=function(){return(0,Y.useContext)(hz)};oe.add("game-ui/editor/widgets/fields/animation-curve-field/utils/animation-curve-editor-context.tsx",{get AnimationCurveEditorProvider(){return pz},set AnimationCurveEditorProvider(e){pz=e},get useAnimationCurveEditor(){return vz},set useAnimationCurveEditor(e){vz=e}});var bz=function(e,t,n,r,i){var o=e.offset.x+t,a=e.offset.y+(e.inverted?e.size.height-n:n);return{x:o,y:a,width:r,height:i,left:o,top:a,right:r>0?o+r:o,bottom:i>0?a+i:a}};function yz(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function xz(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function _z(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function jz(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return yz(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return yz(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/svg/utils/get-svg-bounding-rect.ts",{get getSVGBoundingRect(){return bz},set getSVGBoundingRect(e){bz=e}});var Oz=(0,Y.forwardRef)((function(e,t){var n=e.cx,r=e.cy,i=e.r,o=e.rh,a=e.collisionThreshold,s=void 0===a?0:a,l=e.fill,c=e.fillh,u=e.stroke,d=e.strokeh,f=e.strokeWidth,m=(e.onSelect,e.focused,e.selected,e.className),g=_z(e,["cx","cy","r","rh","collisionThreshold","fill","fillh","stroke","strokeh","strokeWidth","onSelect","focused","selected","className"]),h=KV().viewport,p=h.posFromPoint,v=h.rem,b=jz((0,Y.useState)(!1),2),y=b[0],x=b[1],_=p(n,r),j=v(y&&o?o:i),O=v(f||1),E=v(s)+O/2,S=O/2+E+j;(0,Y.useEffect)((function(){t&&"current"in t&&t.current&&(t.current.getBoundingClientRect=function(){return bz(h,_.x-S/2,_.y-S/2,S,S)})}),[S,t,_.x,_.y,h]);var T=(0,Y.useCallback)((function(e){return Math.sqrt(Math.pow(e.x-_.x,2)+Math.pow(e.y-_.y,2))<j+E}),[_.x,_.y,j,E]);return QV(e,T,x),(0,z.jsx)("circle",function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){xz(e,t,n[t])}))}return e}({ref:t,cx:_.x,cy:_.y,r:j,fill:y&&c?c:l,stroke:y&&d?d:u,strokeWidth:O,className:_d()({hovered:y},m)},g),"circle")}));function Ez(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Sz(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Tz(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function Iz(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Ez(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ez(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/svg/elements/circle.tsx",{get Circle(){return Oz},set Circle(e){Oz=e}});var wz=function(e){var t=e.x1,n=e.y1,r=e.x2,i=e.y2,o=e.strokeWidth,a=e.stroke,s=e.strokeh,l=e.collisionThreshold,c=Tz(e,["x1","y1","x2","y2","strokeWidth","stroke","strokeh","collisionThreshold"]),u=KV().viewport,d=u.posFromPoint,f=u.rem,m=Iz((0,Y.useState)(!1),2),g=m[0],h=m[1],p=d(t,n),v=d(r,i),b=f(o||1),y=f(l||5)+b/2,x=(0,Y.useCallback)((function(e){return function(e,t,n){var r,i,o=e.x-t.x,a=e.y-t.y,s=n.x-t.x,l=n.y-t.y,c=s*s+l*l,u=0!==c?(o*s+a*l)/c:-1;u<0?(r=t.x,i=t.y):u>1?(r=n.x,i=n.y):(r=t.x+u*s,i=t.y+u*l);var d=e.x-r,f=e.y-i;return Math.sqrt(d*d+f*f)}(e,p,v)<y}),[y,p,v]);return QV(c,x,h),(0,z.jsx)("line",function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Sz(e,t,n[t])}))}return e}({x1:p.x,y1:p.y,x2:v.x,y2:v.y,strokeWidth:b,stroke:g&&null!=s?s:a},c))};function Pz(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Cz(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Nz(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function Az(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Pz(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Pz(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/svg/elements/line.tsx",{get Line(){return wz},set Line(e){wz=e}});var Lz=(0,Y.forwardRef)((function(e,t){var n=e.x,r=e.y,i=e.width,o=e.height,a=e.widthh,s=e.heighth,l=e.collisionThreshold,c=void 0===l?0:l,u=e.origin,d=e.fill,f=e.fillh,m=e.stroke,g=e.strokeh,h=e.strokeWidth,p=(e.onSelect,e.focused,e.selected,e.className),v=e.transform,b=Nz(e,["x","y","width","height","widthh","heighth","collisionThreshold","origin","fill","fillh","stroke","strokeh","strokeWidth","onSelect","focused","selected","className","transform"]),y=KV().viewport,x=y.posFromPoint,_=y.rem,j=Az((0,Y.useState)(!1),2),O=j[0],E=j[1],S=x(n,r),T=_(O&&a?a:i),I=_(O&&s?s:o);"center"===u&&(S={x:S.x-T/2,y:S.y-I/2});var w=_(h||1),P=_(c)+w/2,C=(0,Y.useCallback)((function(e){var t;return t="center"!==u?{x:(2*S.x+T)/2,y:(2*S.y+I)/2}:S,Math.abs(e.x-t.x)<=T/2+P&&Math.abs(e.y-t.y)<=I/2+P}),[u,T,P,I,S]);(0,Y.useEffect)((function(){t&&"current"in t&&t.current&&(t.current.getBoundingClientRect=function(){return bz(y,S.x-P/2,S.y-P/2,T+P/2,I+P/2)})}),[P,I,t,y,S.x,S.y,T]),QV(e,C,E);var N=null==v?void 0:v.replace(/rotate\((\d+)\)/,"rotate($1 ".concat(S.x+T/2," ").concat(S.y+I/2,")"));return(0,z.jsx)("rect",function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Cz(e,t,n[t])}))}return e}({ref:t,x:S.x,y:S.y,width:T,height:I,fill:O&&f?f:d,stroke:O&&g?g:m,strokeWidth:w,className:_d()({hovered:O},p),transform:N},b))}));function Mz(e,t,n,r,i,o,a){try{var s=e[o](a),l=s.value}catch(e){return void n(e)}s.done?t(l):Promise.resolve(l).then(r,i)}function kz(e){return function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){Mz(o,r,i,a,s,"next",e)}function s(e){Mz(o,r,i,a,s,"throw",e)}a(void 0)}))}}function Rz(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Dz(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Rz(e,t,n[t])}))}return e}function Fz(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}oe.add("game-ui/common/svg/elements/rect.tsx",{get Rect(){return Lz},set Rect(e){Lz=e}}),oe.add("game-ui/common/svg/elements/index.ts",{});var Uz=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}};var Gz=function(e){var t=e.keyframe,n=e.index,r=e.pos,i=e.type,o=e.isFocused,a=vz(),s=a.activeCurve,l=a.updateKeyframe,c=KV().viewport,u=c.rem,d=c.scaleToViewport,f=c.scaleToPoint,m=c.posFromPoint,g=c.pointFromPos,h=(0,Y.useMemo)((function(){var e={x:r.x-t.time,y:r.y-t.value},n=d(e),o=Math.sqrt(n.x*n.x+n.y*n.y),a=n.x<0?-1:1,s=n.x/o,l=isFinite(r.y)?n.y/o:Math.sign(r.y)*a,c=t["in"===i?"inWeight":"outWeight"]||.01,m=u(af(15,75,c)),g=f(s*m,l*m);return{x:t.time+g.x,y:t.value+g.y}}),[r.x,r.y,t,d,i,u,f]),p=(0,Y.useCallback)((function(e){var r=e.point,o=e.position,a=e.shiftKey,c=t.time,u=t.value,d=r.x-c,f=r.y-u,g=of(yf(pf(o,m(c,u))),15,75);if(!(g<15)){var h,p,v,b,y,x,_=Math.max((g-15)/60,.01);if("in"===i?(h="inTangent",p="inWeight",d>0&&(d=0)):(h="outTangent",p="outWeight",d<0&&(d=0)),b=d,y=0,v=Math.abs(y-b)<Math.max(1e-6*Math.max(Math.abs(b),Math.abs(y)),8*Number.EPSILON)?r.y>u?Number.POSITIVE_INFINITY:Number.NEGATIVE_INFINITY:f/d,a)l(n,Fz(Dz({},t),{inTangent:v,outTangent:v,inWeight:_,outWeight:_}),!1,s);else l(n,Fz(Dz({},t),(Rz(x={},h,v),Rz(x,p,_),x)),!1,s)}}),[s,n,t,m,i,l]),v=Pg();return Dk((0,Y.useCallback)(kz((function(){var e,t,n;return Uz(this,(function(r){switch(r.label){case 0:return[4,pT()];case 1:return e=r.sent(),t=m(h),n={x:t.x+100*e[0],y:t.y+100*e[1]},p({point:g(n),position:n}),[2]}}))})),[h,p,g,m]),v&&o),(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(wz,{strokeWidth:.5,x1:t.time,y1:t.value,x2:h.x,y2:h.y,className:qW.animationCurveControlPointArm}),(0,z.jsx)(Lz,{origin:"center",x:h.x,y:h.y,width:o?8:4,height:o?8:4,collisionThreshold:10,onDrag:p,className:qW.animationCurveControlPointHandle})]})};oe.add("game-ui/editor/widgets/fields/animation-curve-field/components/keyframe-control-point.tsx",{get KeyframeControlPoint(){return Gz},set KeyframeControlPoint(e){Gz=e}});var Bz=function(e){var t=e.index,n=e.data,r=e.keyframes,i=e.editTarget,o=e.curve,a=(0,Y.useMemo)((function(){return function(e,t){var n,r;if(t.length<2)return{};var i=t[e],o=i.time,a=i.value;if(o<t[t.length-1].time){var s=t[e+1].time,l=HW(o,s,o,i.outWeight||.1);r={x:l,y:HW(a,l,o,i.outTangent)}}if(o>0){var c=t[e-1].time,u=HW(o,c,o,1-i.inWeight||.1);n={x:u,y:HW(a,u,o,i.inTangent)}}return{in:n,out:r}}(t,r)}),[t,r]),s=Pg(),l=r[0].readonly?1:0,c=r[r.length-1].readonly?2:1;return(0,z.jsxs)(z.Fragment,{children:[a.in&&n.inWeight>=0&&(t>l||o.preWrapMode!==iz.Clamp&&o.preWrapMode!==iz.ClampForever)&&(0,z.jsx)(Gz,{index:t,keyframe:n,type:"in",pos:a.in,isFocused:s&&i===Jz.LeftTangent}),a.out&&n.outWeight>=0&&(t<r.length-c||o.postWrapMode!==iz.Clamp&&o.postWrapMode!==iz.ClampForever)&&(0,z.jsx)(Gz,{index:t,keyframe:n,type:"out",pos:a.out,isFocused:s&&i===Jz.RightTangent})]})};function Vz(e,t,n,r,i,o,a){try{var s=e[o](a),l=s.value}catch(e){return void n(e)}s.done?t(l):Promise.resolve(l).then(r,i)}function Hz(e){return function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){Vz(o,r,i,a,s,"next",e)}function s(e){Vz(o,r,i,a,s,"throw",e)}a(void 0)}))}}oe.add("game-ui/editor/widgets/fields/animation-curve-field/components/keyframe-control-points.tsx",{get KeyframeControlPoints(){return Bz},set KeyframeControlPoints(e){Bz=e}});var Kz=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}},Wz=function(e){var t=e.data,n=e.keyframes,r=e.isActive,i=e.index,o=e.curveIndex,a=void 0===o?0:o,s=e.curve,l=e.onSelect,c=e.onDragStart,u=e.keyframeRenderer,d=e.editTarget,f=e.isFocused,m=e.onControllerDrag,g=e.controllerDragCallback,h=(0,Y.useRef)(t),p=KV();h.current=t;var v=(0,Y.useCallback)((function(){t.readonly||null==l||l(i,a)}),[t.readonly,l,i,a]),b=(0,Y.useCallback)((function(e,t){t&&(null==c||c(i))}),[i,c]),y=Pg();return Dk((0,Y.useCallback)(Hz((function(){var e,n,r,o;return Kz(this,(function(a){switch(a.label){case 0:return m&&g?[4,g()]:[3,2];case 1:e=a.sent(),n={x:t.time,y:t.value},r=p.viewport.posFromPoint(n),o={x:r.x+100*e.x,y:r.y+100*e.y},m(p.viewport.pointFromPos(o),i),a.label=2;case 2:return[2]}}))})),[g,t.time,t.value,i,m,p.viewport]),y&&g&&m&&r&&d===Jz.Keyframe),t.readonly?null:(0,z.jsx)("g",{className:_d()(qW.animationCurveKeyframe,{active:r}),children:u?u(e,v,b):(0,z.jsxs)(z.Fragment,{children:[r&&(0,z.jsx)(Bz,{data:t,index:i,curve:s,keyframes:n,editTarget:d}),(0,z.jsx)(Oz,{cx:t.time,cy:t.value,r:zz(r,f,y),rh:3.5,onSelect:v,onMouseDown:b,collisionThreshold:12})]})})},zz=function(e,t,n){return n&&e?4.5:!n&&e||n&&t?3.5:2.5};oe.add("game-ui/editor/widgets/fields/animation-curve-field/components/keyframe.tsx",{get Keyframe(){return Wz},set Keyframe(e){Wz=e}});var Yz=function(e){var t,n=vz(),r=n.data,i=n.activeKeyframe,o=n.activeCurve,a=n.parseKeyframe,s=n.setDraggedKeyframe,l=n.selectKeyframe,c=n.keyframeRenderer,u=e.curveIndex,d=e.focusedKeyframe,f=e.editTarget,m=e.onControllerDrag,g=e.controllerDragCallback,h=null===(t=r.curves[u])||void 0===t?void 0:t.keys;return(0,z.jsx)("g",{children:r.curves.map((function(e,t){var n;return(0,z.jsx)("g",{className:qW.animationCurveKeyframes,children:u===t&&!!(null===(n=e.keys)||void 0===n?void 0:n.length)&&e.keys.map((function(n,r){return(0,z.jsx)(Wz,{data:n,index:r,curveIndex:u,curve:e,keyframes:h,isActive:i===r&&o===t,isFocused:d===r&&o===t,editTarget:f,onSelect:l,onDragStart:s,parseKeyframe:a,keyframeRenderer:c,onControllerDrag:m,controllerDragCallback:g},n.time)}))},t)}))})};function $z(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function qz(e,t,n,r,i,o,a){try{var s=e[o](a),l=s.value}catch(e){return void n(e)}s.done?t(l):Promise.resolve(l).then(r,i)}function Xz(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Qz(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Zz(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return $z(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return $z(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/editor/widgets/fields/animation-curve-field/components/keyframes.tsx",{get Keyframes(){return Yz},set Keyframes(e){Yz=e}});var Jz,eY=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}},tY=function(e){return(0,z.jsx)(az,{keyframe:e})},nY=function(e){return(0,z.jsx)(su,{value:e,unit:$c.FloatTwoFractions})};!function(e){e[e.None=0]="None",e[e.LeftTangent=1]="LeftTangent",e[e.Keyframe=2]="Keyframe",e[e.RightTangent=3]="RightTangent"}(Jz||(Jz={}));var rY=function(e){var t,n,r,i=e.children,o=e.style,a=e.zoomable,s=e.panable,l=e.padding,c=e.className,u=e.gridLines,d=void 0===u||u,f=e.drawPaths,m=void 0===f||f,g=e.showTooltipOnDrag,h=void 0!==g&&g,p=e.tooltipKeyframe,v=e.textScale,b=void 0===v?1:v,y=e.formatTooltip,x=void 0===y?tY:y,_=e.formatLabelX,j=void 0===_?nY:_,O=e.formatLabelY,E=void 0===O?nY:O,S=e.onClick,T=e.onMouseDown,I=e.onWindowMouseMove,w=e.keyframeMoveCallback,P=e.zoomCallback,C=e.panCallback,N=e.OnFocusChange,A=e.focusKey,L=vz(),M=L.data,k=L.canAddKeyframes,R=L.activeKeyframe,D=L.selectKeyframe,F=L.activeCurve,U=L.allowEditingAll,G=L.addKeyframe,B=L.removeKeyframe,V=L.deselectKeyframes,H=L.updateKeyframe,K=L.isDraggingKeyframe,W=L.draggedKeyframeRef,$=L.setDraggedKeyframe,q=L.parseKeyframe,X=L.smoothenOnMove,Q=(0,Y.useRef)(null),Z=(0,Y.useCallback)((function(e){var t=e.point,n=t.x,r=t.y;G(n,r,F)}),[F,G]),J=(0,Y.useCallback)((function(e){null==S||S(e),V()}),[V,S]),ee=(0,Y.useCallback)((n=function(e,t){var n,r,i,o,a,s,l=arguments;return eY(this,(function(c){switch(c.label){case 0:return n=l.length>2&&void 0!==l[2]&&l[2],t>-1?(r=M.curves[F].keys,i=r[t],o=Qz(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Xz(e,t,n[t])}))}return e}({},i),{time:e.x,value:e.y}),a=q?q(i,o,t,r,F):o,[4,H(t,a,!!X,F)]):[3,2];case 1:s=c.sent(),n&&$(s),c.label=2;case 2:return[2]}}))},r=function(){var e=this,t=arguments;return new Promise((function(r,i){var o=n.apply(e,t);function a(e){qz(o,r,i,a,s,"next",e)}function s(e){qz(o,r,i,a,s,"throw",e)}a(void 0)}))},function(e,t){return r.apply(this,arguments)}),[F,M.curves,q,$,X,H]),te=(0,Y.useCallback)((function(e){null==I||I(e),ee(e.point,W.current,!0)}),[W,ee,I]);(0,Y.useEffect)((function(){if(-1!==R){var e=function(e){"Backspace"!==e.code&&"Delete"!==e.code||B(R,F)};return document.addEventListener("keydown",e),function(){document.removeEventListener("keydown",e)}}}),[F,R,G,B]),(0,Y.useEffect)((function(){var e=function(e){var t;(null===(t=e.target)||void 0===t?void 0:t.parentNode)!==Q.current&&V()};return document.body.addEventListener("click",e),function(){document.body.removeEventListener("click",e)}}),[V]);var ne=p||(K?null===(t=M.curves[F])||void 0===t?void 0:t.keys[W.current]:void 0),re=ne?x(ne):void 0,ie=(0,Y.useMemo)((function(){return F>=0&&F<M.curves.length?M.curves[F].keys.findIndex((function(e){return!e.readonly})):-1}),[F,M.curves]),oe=Zz((0,Y.useState)(-1),2),ae=oe[0],se=oe[1],le=Zz((0,Y.useState)(Jz.Keyframe),2),ce=le[0],ue=le[1],de=Zz((0,Y.useState)(!1),2),fe=de[0],me=de[1],ge=(0,Y.useCallback)((function(e){if(me(e),N&&N(e),e&&F>=0&&F<M.curves.length&&ie>=0){var t=M.curves[F];R>=0&&R<t.keys.length&&!t.keys[R].readonly?se(R):(ae<0||ae>=t.keys.length||t.keys[ae].readonly)&&se(ie)}}),[N,F,R,M.curves,ie,ae]),he=(0,Y.useMemo)((function(){return{"Move Horizontal":F>=0&&F<M.curves.length&&M.curves[F].keys.length>1?function(e){if(F>=0&&F<M.curves.length){var t=M.curves[F];if(R>=0){var n=R>0&&!t.keys[R-1].readonly,r=R<t.keys.length-1&&!t.keys[R+1].readonly,i=of(ce+Math.sign(e),n?Jz.LeftTangent:Jz.Keyframe,r?Jz.RightTangent:Jz.Keyframe);if(i!==ce)return ue(i),!0}else{var o=t.keys.findIndex((function(e){return!e.readonly})),a=t.keys.length-Array.from(t.keys).reverse().findIndex((function(e){return!e.readonly}))-1;if(o>=0&&a>=0&&a>=o){var s=of(ae+Math.sign(e),o,a);if(s!==ae&&!M.curves[F].keys[s].readonly)return se(s),!0}}}return!1}:null,Back:function(){return F>=0&&F<M.curves.length&&R>=0&&R<M.curves[F].keys.length&&(V(),!0)},Select:function(){D(ae,F),ue(Jz.Keyframe)}}}),[F,R,M.curves,V,ce,ae,D]);return(0,z.jsx)(rp,{actions:he,children:(0,z.jsxs)(BB,{className:_d()(qW.column,qW.editorItem,c),focusKey:A,onFocusChange:ge,children:[(0,z.jsx)(RW,{disabled:!h,alwaysVisible:!0,screenSpacePosition:!0,tooltip:re}),(0,z.jsx)("div",{className:_d()(qW.editor,Xz({},qW.multipleCurves,M.curves.length>1)),ref:Q,children:(0,z.jsxs)(UH,{bounds:M.bounds,padding:l||12,onDoubleClick:k?Z:void 0,onClick:J,onMouseDown:T,onWindowMouseMove:te,style:o,zoomable:a,panable:s,zoomCallback:fe?P:void 0,panCallback:fe?C:void 0,children:[d&&(0,z.jsx)(wW,{overdraw:!0,halfSteps:!0}),m&&(0,z.jsx)("g",{children:M.curves.filter((function(e){return!e.hidePath})).map((function(e,t){return"number"==typeof e.deviationFrom?(0,z.jsx)(ZW,{keys:e.keys,base:M.curves[e.deviationFrom].keys,color:e.color,className:_d()({active:M.curves.length>1&&t===F})},t):(0,z.jsx)(ez,{keys:e.keys,color:e.color,className:_d()({active:M.curves.length>1&&t===F})},t)}))}),(F>=0||U)&&(0,z.jsx)(Yz,{curveIndex:F,focusedKeyframe:fe?ae:-1,editTarget:fe?ce:Jz.None,onControllerDrag:ee,controllerDragCallback:w}),i,(0,z.jsx)(IW,{fixed:!0,textScale:b,formatLabelX:j,formatLabelY:E})]})})]})})};oe.add("game-ui/editor/widgets/fields/animation-curve-field/animation-curve-editor.tsx",{get KeyframeEditTarget(){return Jz},set KeyframeEditTarget(e){Jz=e},get AnimationCurveEditor(){return rY},set AnimationCurveEditor(e){rY=e}});let iY={button:"button_UQQ"};oe.add("game-ui/editor/widgets/fields/animation-curve-field/animation-curve-editor-preview.module.scss",{get classes(){return iY},set classes(e){Object.assign(iY,e)}});const oY=iY;var aY={x:0,y:2},sY=function(e){var t=e.data,n=e.onSelect,r=e.className,i=(0,Y.useRef)(null);return(0,z.jsx)(Qp,{ref:i,theme:oY,onSelect:n,className:UB.dropdownToggle,children:(0,z.jsx)(UH,{className:r,bounds:t.bounds,padding:aY,children:t.curves.map((function(e,t){return(0,z.jsx)(ez,{keys:e.keys,className:qW.animationCurvePreviewPath},t)}))})})};oe.add("game-ui/editor/widgets/fields/animation-curve-field/animation-curve-editor-preview.tsx",{get AnimationCurvePreview(){return sY},set AnimationCurvePreview(e){sY=e}});var lY=function(e){var t=e.parent,n=e.path,r=e.props,i=e.children,o=uD(t,n),a=(0,Y.useContext)(ED);return(0,z.jsx)(uY,{label:(0,z.jsx)(ku,{value:r.displayName}),children:(0,z.jsx)(OD,{parent:o,components:a,data:i})})},cY=function(e){var t=e.parent,n=e.path,r=e.props,i=e.children,o=uD(t,n),a=(0,Y.useContext)(ED),s=RR($R,o);return(0,z.jsx)(dY,{label:(0,z.jsx)(ku,{value:r.displayName}),expanded:r.expanded,onExpandedChange:s,children:(0,z.jsx)(OD,{parent:o,components:a,data:i})})},uY=function(e){var t=e.label,n=e.children;return(0,z.jsxs)(GB,{children:[(0,z.jsx)("div",{className:UB.row,children:(0,z.jsx)("div",{className:UB.label,children:t})}),(0,z.jsx)("div",{className:UB.groupChildren,children:n})]})},dY=function(e){var t=e.label,n=e.expanded,r=e.children,i=e.onExpandedChange;return(0,z.jsx)(VB,{label:t,expanded:n,onExpandedChange:i,children:(0,z.jsx)("div",{className:UB.groupChildren,children:r})})};oe.add("game-ui/editor/widgets/group/editor-group.tsx",{get BoundGroup(){return lY},set BoundGroup(e){lY=e},get BoundExpandableGroup(){return cY},set BoundExpandableGroup(e){cY=e},get EditorGroup(){return uY},set EditorGroup(e){uY=e},get ExpandableEditorGroup(){return dY},set ExpandableEditorGroup(e){dY=e}});let fY={"draggable-value":"draggable-value_l2t",draggableValue:"draggable-value_l2t","draggable-value-cursor":"draggable-value-cursor_v5P",draggableValueCursor:"draggable-value-cursor_v5P",dragging:"dragging_d8v"};oe.add("game-ui/common/input/draggable-value/draggable-value.module.scss",{get classes(){return fY},set classes(e){Object.assign(fY,e)}});const mY=fY;function gY(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function hY(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function pY(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return gY(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return gY(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function vY(e,t){var n,r=e.value,i=e.disabled,o=e.className,a=e.dragTransformation,s=e.onChange,l=e.onDragStart,c=e.onDragEnd,u=e.children,d=(0,Y.useRef)(null),f=(0,Y.useCallback)((function(e){var t=e.clientX;return!i&&(function(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}(document.activeElement,HTMLElement)&&document.activeElement.blur(),d.current={clientX:t,value:r},l&&l(),!0)}),[i,r,l]),m=pY(sE(f,(0,Y.useCallback)((function(e){var t=e.clientX;if(!i&&null!=d.current){var n=(t-d.current.clientX)/window.innerWidth;s&&s(a(d.current.value,n))}}),[i,a,s]),(0,Y.useCallback)((function(){c&&c()}),[c])),2),g=m[0],h=m[1];return dR(g&&!i?mY.draggableValueCursor:void 0),(0,z.jsx)("div",{ref:t,className:_d()((n={},hY(n,mY.draggableValue,!i),hY(n,mY.dragging,g),n),o),onMouseDown:h,children:u})}var bY=(0,Y.forwardRef)(vY);function yY(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function xY(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function _Y(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function jY(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function OY(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return yY(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return yY(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function EY(e){var t=e.value,n=e.valueFormatter,r=e.inputValidator,i=e.inputTransformer,o=void 0===i?SY:i,a=e.inputParser,s=e.onChange,l=e.onFocus,c=e.onBlur,u=jY(e,["value","valueFormatter","inputValidator","inputTransformer","inputParser","onChange","onFocus","onBlur"]),d=OY((0,Y.useState)(null),2),f=d[0],m=d[1],g=(0,Y.useMemo)((function(){return n(t)}),[t,n]),h=(0,Y.useCallback)((function(e){var t=o(e.target.value||"");if(r(t)){var n=f;if(m(t),s){var i=null!==n?a(n):void 0,l=null!==t?a(t):void 0;if(void 0!==l&&l!==i)return s(l)}}}),[a,o,r,f,s]),p=(0,Y.useCallback)((function(e){m(n(t)),l&&l(e)}),[l,t,n]),v=(0,Y.useCallback)((function(e){m(null),c&&c(e)}),[c]);return(0,z.jsx)(yb,_Y(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){xY(e,t,n[t])}))}return e}({},u),{value:null!=f?f:g,onChange:h,onFocus:p,onBlur:v}))}function SY(e){return e}function TY(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function IY(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function wY(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}oe.add("game-ui/common/input/draggable-value/draggable-value.tsx",{get DraggableValue(){return bY},set DraggableValue(e){bY=e}}),oe.add("game-ui/common/input/text/data-input.tsx",{get DataInput(){return EY},set DataInput(e){EY=e}});var PY=function(e){var t=e.min,n=void 0===t?nf:t,r=e.max,i=void 0===r?rf:r,o=e.fractionDigits,a=void 0===o?3:o,s=wY(e,["min","max","fractionDigits"]),l=(0,Y.useCallback)((function(e){return function(e,t,n){if("-"===e||"."===e)return;if(""===e)return t<=0&&n>=0?0:void 0;var r=parseFloat(e);return isNaN(r)?void 0:of(r,t,n)}(e,n,i)}),[n,i]),c=(0,Y.useCallback)((function(e){return e.toFixed(a)}),[a]);return(0,z.jsx)(EY,IY(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){TY(e,t,n[t])}))}return e}({},s),{valueFormatter:c,inputParser:l,inputValidator:n<0?CY:NY}))};function CY(e){return/^-?[0-9]*\.?[0-9]*$/.test(e)}function NY(e){return/^[0-9]*\.?[0-9]*$/.test(e)}function AY(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function LY(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){AY(e,t,n[t])}))}return e}function MY(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}oe.add("game-ui/common/input/text/float-input.tsx",{get FloatInput(){return PY},set FloatInput(e){PY=e}});var kY=function(e){var t=e.label,n=e.value,r=e.min,i=void 0===r?nf:r,o=e.max,a=void 0===o?rf:o,s=e.fractionDigits,l=void 0===s?3:s,c=e.disabled,u=e.onChange,d=e.onChangeStart,f=e.onChangeEnd,m=(0,Y.useCallback)((function(e,t){return GY(e,t,i,a)}),[i,a]);return(0,z.jsx)(BB,{disabled:c,children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)(bY,{value:n,disabled:c,className:UB.label,dragTransformation:m,onChange:u,children:t}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsx)(PY,{value:n,min:i,max:a,fractionDigits:l,disabled:c,className:UB.input,onChange:u,onFocus:d,onBlur:f})})]})})},RY=function(e){var t=e.label,n=e.value,r=e.disabled,i=e.onChange,o=e.onChangeStart,a=e.onChangeEnd,s=(0,Y.useCallback)((function(e){return i(MY(LY({},n),{x:e}))}),[n,i]),l=(0,Y.useCallback)((function(e){return i(MY(LY({},n),{y:e}))}),[n,i]);return(0,z.jsx)(BB,{disabled:r,children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)(bY,{value:n,disabled:r,className:UB.label,dragTransformation:VY,onChange:i,children:t}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)(UY,{label:"X",value:n.x,disabled:r,onChange:s,onChangeStart:o,onChangeEnd:a}),(0,z.jsx)(UY,{label:"Y",value:n.y,disabled:r,onChange:l,onChangeStart:o,onChangeEnd:a})]})})]})})},DY=function(e){var t=e.label,n=e.value,r=e.disabled,i=e.onChange,o=e.onChangeStart,a=e.onChangeEnd,s=(0,Y.useCallback)((function(e){return i(MY(LY({},n),{x:e}))}),[n,i]),l=(0,Y.useCallback)((function(e){return i(MY(LY({},n),{y:e}))}),[n,i]),c=(0,Y.useCallback)((function(e){return i(MY(LY({},n),{z:e}))}),[n,i]);return(0,z.jsx)(BB,{disabled:r,children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)(bY,{value:n,disabled:r,className:UB.label,dragTransformation:HY,onChange:i,children:t}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)(UY,{label:"X",value:n.x,disabled:r,onChange:s,onChangeStart:o,onChangeEnd:a}),(0,z.jsx)(UY,{label:"Y",value:n.y,disabled:r,onChange:l,onChangeStart:o,onChangeEnd:a}),(0,z.jsx)(UY,{label:"Z",value:n.z,disabled:r,onChange:c,onChangeStart:o,onChangeEnd:a})]})})]})})},FY=function(e){var t=e.label,n=e.value,r=e.disabled,i=e.onChange,o=e.onChangeStart,a=e.onChangeEnd,s=(0,Y.useCallback)((function(e){return i(MY(LY({},n),{x:e}))}),[n,i]),l=(0,Y.useCallback)((function(e){return i(MY(LY({},n),{y:e}))}),[n,i]),c=(0,Y.useCallback)((function(e){return i(MY(LY({},n),{z:e}))}),[n,i]),u=(0,Y.useCallback)((function(e){return i(MY(LY({},n),{w:e}))}),[n,i]);return(0,z.jsx)(BB,{disabled:r,children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)(bY,{value:n,disabled:r,className:UB.label,dragTransformation:KY,onChange:i,children:t}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)(UY,{label:"X",value:n.x,disabled:r,onChange:s,onChangeStart:o,onChangeEnd:a}),(0,z.jsx)(UY,{label:"Y",value:n.y,disabled:r,onChange:l,onChangeStart:o,onChangeEnd:a}),(0,z.jsx)(UY,{label:"Z",value:n.z,disabled:r,onChange:c,onChangeStart:o,onChangeEnd:a}),(0,z.jsx)(UY,{label:"W",value:n.z,disabled:r,onChange:u,onChangeStart:o,onChangeEnd:a})]})})]})})},UY=function(e){var t=e.label,n=e.value,r=e.disabled,i=e.onChange,o=e.onChangeStart,a=e.onChangeEnd;return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(bY,{value:n,disabled:r,className:UB.vectorLabel,dragTransformation:BY,onChange:i,children:t}),(0,z.jsx)(PY,{value:n,disabled:r,onChange:i,onFocus:o,onBlur:a,className:UB.vectorInput})]})};function GY(e,t,n,r){return of(e+60*t,n,r)}function BY(e,t){return GY(e,t,nf,rf)}function VY(e,t){return{x:of(e.x+30*t,nf,rf),y:of(e.y+30*t,nf,rf)}}function HY(e,t){return{x:of(e.x+30*t,nf,rf),y:of(e.y+30*t,nf,rf),z:of(e.z+30*t,nf,rf)}}function KY(e,t){return{x:of(e.x+30*t,nf,rf),y:of(e.y+30*t,nf,rf),z:of(e.z+30*t,nf,rf),w:of(e.w+30*t,nf,rf)}}function WY(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function zY(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}oe.add("game-ui/editor/widgets/fields/float-input-field.tsx",{get FloatInputField(){return kY},set FloatInputField(e){kY=e},get Float2InputField(){return RY},set Float2InputField(e){RY=e},get Float3InputField(){return DY},set Float3InputField(e){DY=e},get Float4InputField(){return FY},set Float4InputField(e){FY=e}});var YY=function(){var e,t=vz(),n=t.activeKeyframe,r=t.activeCurve,i=t.data,o=t.canAddKeyframes,a=t.parseKeyframe,s=t.updateKeyframe,l=t.removeKeyframe,c=null===(e=i.curves[r])||void 0===e?void 0:e.keys[n],u=(0,Y.useMemo)((function(){var e=function(e,t){var o,l=zY(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){WY(e,t,n[t])}))}return e}({},c),WY({},e,t)),u=a?a(c,l,n,null===(o=i.curves[r])||void 0===o?void 0:o.keys,r):l;s(n,u,!1,r)};return{changeTime:function(t){return e("time",t)},changeValue:function(t){return e("value",t)},changeInTangent:function(t){return e("inTangent",t)},changeInWeight:function(t){return e("inWeight",t)},changeOutTangent:function(t){return e("outTangent",t)},changeOutWeight:function(t){return e("outWeight",t)},smoothenTangents:function(){return s(n,c,!0,r)},removeKeyframe:function(){return l(n,r)}}}),[r,n,i.curves,c,a,l,s]);if(!c)return null;var d=i.curves[r];return(0,z.jsxs)(uY,{label:"Keyframe ".concat(n),children:[(0,z.jsx)(kY,{label:(0,z.jsx)(qc.Editor.WIDGETS,{hash:"Time"}),value:c.time,onChange:u.changeTime}),(0,z.jsx)(kY,{label:(0,z.jsx)(qc.Editor.WIDGETS,{hash:"Value"}),value:c.value,onChange:u.changeValue}),n>0&&(0,z.jsxs)(uY,{label:(0,z.jsx)(qc.Editor.WIDGETS,{hash:"In"}),children:[(0,z.jsx)(kY,{label:(0,z.jsx)(qc.Editor.WIDGETS,{hash:"Tangent"}),value:c.inTangent,onChange:u.changeInTangent}),(0,z.jsx)(kY,{label:(0,z.jsx)(qc.Editor.WIDGETS,{hash:"Weight"}),value:c.inWeight,min:0,max:1,onChange:u.changeInWeight})]}),n<d.keys.length-1&&(0,z.jsxs)(uY,{label:(0,z.jsx)(qc.Editor.WIDGETS,{hash:"Out"}),children:[(0,z.jsx)(kY,{label:(0,z.jsx)(qc.Editor.WIDGETS,{hash:"Tangent"}),value:c.outTangent,onChange:u.changeOutTangent}),(0,z.jsx)(kY,{label:(0,z.jsx)(qc.Editor.WIDGETS,{hash:"Weight"}),value:c.outWeight,min:0,max:1,onChange:u.changeOutWeight})]}),(0,z.jsx)(GB,{children:(0,z.jsxs)("div",{className:_d()(qW.row,qW.controls),children:[(0,z.jsx)(Qp,{theme:SB,onSelect:u.smoothenTangents,children:"Smoothen"}),o&&(0,z.jsx)(Qp,{disabled:d.keys.length<3,theme:SB,onSelect:u.removeKeyframe,children:"Delete Keyframe"})]})})]})};oe.add("game-ui/editor/widgets/fields/animation-curve-field/keyframe-editor.tsx",{get KeyframeEditor(){return YY},set KeyframeEditor(e){YY=e}});var $Y={min:{x:0,y:0},max:{x:1,y:1}},qY=function(e,t){var n=(0,Y.useRef)(),r=(0,Y.useRef)(),i=(0,Y.useRef)(),o=(0,Y.useRef)(),a=(0,Y.useRef)(),s=(0,Y.useRef)(),l=t||{},c=l.autoUpdateBounds,u=l.minX,d=l.maxX,f=l.minY,m=l.maxY,g=l.wrapMode,h=l.hash;return(0,Y.useMemo)((function(){var t=Array.isArray(e)?e:[e],l=t.reduce((function(e,t){return t?{maxKeysCount:Math.max(t.keys.filter((function(e){return!e.readonly})).length,e.maxKeysCount),readOnlyCount:t.keys.reduce((function(e,t){return e+Number(!!t.readonly)}),0)}:{maxKeysCount:0,readOnlyCount:0}}),{maxKeysCount:0,readOnlyCount:0}),p=$Y;if(0===l.maxKeysCount)return{bounds:p={min:{x:null!=u?u:0,y:null!=f?f:0},max:{x:null!=d?d:1,y:null!=m?m:1}},curves:t};var v=r.current!==l.maxKeysCount,b=a.current||{},y=b.minX!==u||b.maxX!==d||b.minY!==f||b.maxY!==m,x=t.length!==o.current,_=s.current!==h;if(c||!n.current||v||y||g!==(null==b?void 0:b.wrapMode)||x||_){l.maxKeysCount>0&&(p={min:{x:null!=u?u:1/0,y:null!=f?f:1/0},max:{x:null!=d?d:-1/0,y:null!=m?m:-1/0}});var j="number"==typeof u,O="number"==typeof d,E="number"==typeof f,S="number"==typeof m;t.forEach((function(e){return e.keys.forEach((function(e){e.time<p.min.x&&(!j||c)&&(p.min.x=e.time),e.time>p.max.x&&(!O||c)&&(p.max.x=e.time),e.value<p.min.y&&(!E||c)&&(p.min.y=e.value),e.value>p.max.y&&(!S||c)&&(p.max.y=e.value)}))}));var T=p.max.x-p.min.x;if(T<1)p.min.x=Math.floor(p.min.x-(1-T)/2),p.max.x=Math.ceil(p.min.x+(1-T)/2);else if(0===T){var I=Math.max(1,Math.pow(10,Math.round(Math.log10(Math.abs(p.min.x)))));j&&S||!j&&!O?(p.min.x-=I/2,p.max.x+=I/2):j?p.max.x+=I:O&&(p.min.x-=I)}var w=p.max.y-p.min.y;if(w<1&&0!==w)p.min.y=Math.floor(p.min.y-(1-w)/2),p.max.y=Math.ceil(p.min.y+(1-w)/2);else if(0===w){var P=Math.max(1,Math.pow(10,Math.round(Math.log10(Math.abs(p.min.y)))));E&&S||!E&&!S?(p.min.y-=P/2,p.max.y+=P/2):E?p.max.y+=P:S&&(p.min.y-=P)}}else p=n.current;var C={bounds:KW(n.current,p),curves:t,maxKeysCount:l.maxKeysCount};return g&&zW(g,t,C.bounds),n.current=p,r.current=l.maxKeysCount,i.current=l.readOnlyCount,s.current=h,o.current=t.length,a.current={maxX:d,minX:u,maxY:m,minY:f,wrapMode:g},C}),[e,u,d,f,m,h,c,g])};function XY(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function QY(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function ZY(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){QY(e,t,n[t])}))}return e}function JY(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function e$(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return XY(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return XY(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/editor/widgets/fields/animation-curve-field/utils/use-animation-curve-data.tsx",{get useAnimationCurveData(){return qY},set useAnimationCurveData(e){qY=e}});var t$=function(e){var t=e.label,n=e.value,r=e.disabled,i=e.hidePreview,o=e.expanded,a=e.initialEditing,s=e.autoUpdateBounds,l=e.bounds,c=e.smoothenOnMove,u=e.canAddKeyframes,d=void 0===u||u,f=e.wrapMode,m=e.parseKeyframe,g=e.onAddKeyframe,h=e.onMoveKeyframe,p=e.onRemoveKeyframe,v=e.onSetKeyframes,b=qY(n,ZY({autoUpdateBounds:!0},l)),y=qY(n,JY(ZY({autoUpdateBounds:s},l),{wrapMode:f})),x=e$((0,Y.useState)(o||a),2),_=x[0],j=x[1],O=(0,Y.useMemo)((function(){if(!o&&!r)return function(){return j((function(e){return!e}))}}),[o,r]);return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(BB,{disabled:r,children:(0,z.jsx)(HB,{label:t,onSelect:O,children:!i&&(0,z.jsx)(sY,{data:b,onSelect:O})})}),(0,z.jsx)(KB,{visible:_,children:(0,z.jsxs)(pz,{data:y,onAddKeyframe:g,onMoveKeyframe:h,onRemoveKeyframe:p,onSetKeyframes:v,parseKeyframe:m,canAddKeyframes:d,smoothenOnMove:c,children:[(0,z.jsx)(rY,{zoomable:!0,panable:!0}),(0,z.jsx)(YY,{})]})})]})};function n$(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function r$(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}oe.add("game-ui/editor/widgets/fields/animation-curve-field/animation-curve-field.tsx",{get AnimationCurveField(){return t$},set AnimationCurveField(e){t$=e}});var i$=function(e){var t=function(e){var t=e.parent,n=e.path,r=(0,Y.useMemo)((function(){var e=HR(t.path,n);return{onAddKeyframe:function(n,r,i){return rD(t.group,e,n,r,i)},onMoveKeyframe:function(n,r,i,o){return nD(t.group,e,n,r,i,o)},onRemoveKeyframe:function(n,r){return iD(t.group,e,n,r)},onSetKeyframes:function(n,r){return oD(t.group,e,n,r)}}}),[t.group,t.path,n]);return r}(e);return(0,z.jsx)(t$,r$(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){n$(e,t,n[t])}))}return e}({},e.props,t),{smoothenOnMove:!1,label:(0,z.jsx)(ku,{value:e.props.displayName})}))};function o$(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function a$(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){o$(e,t,n[t])}))}return e}function s$(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}oe.add("game-ui/editor/widgets/fields/animation-curve-field/animation-curve-field.bound.tsx",{get BoundAnimationCurveField(){return i$},set BoundAnimationCurveField(e){i$=e}});var l$=function(e){var t=e.label,n=e.value,r=e.disabled,i=e.onChange,o=e.onChangeStart,a=e.onChangeEnd,s=(0,Y.useCallback)((function(e){return i(s$(a$({},n),{a:e}))}),[i,n]),l=(0,Y.useCallback)((function(e){return i(s$(a$({},n),{b:e}))}),[i,n]),c=(0,Y.useCallback)((function(e){return i(s$(a$({},n),{c:e}))}),[i,n]),u=(0,Y.useCallback)((function(e){return i(s$(a$({},n),{d:e}))}),[i,n]);return(0,z.jsxs)(uY,{label:t,children:[(0,z.jsx)(DY,{label:"A",value:n.a,disabled:r,onChange:s,onChangeStart:o,onChangeEnd:a}),(0,z.jsx)(DY,{label:"B",value:n.b,disabled:r,onChange:l,onChangeStart:o,onChangeEnd:a}),(0,z.jsx)(DY,{label:"C",value:n.c,disabled:r,onChange:c,onChangeStart:o,onChangeEnd:a}),(0,z.jsx)(DY,{label:"D",value:n.d,disabled:r,onChange:u,onChangeStart:o,onChangeEnd:a})]})};function c$(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function u$(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function d$(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}oe.add("game-ui/editor/widgets/fields/bezier4x3-field.tsx",{get Bezier4x3Field(){return l$},set Bezier4x3Field(e){l$=e}});var f$=function(e){var t=e.min,n=void 0===t?Jd:t,r=e.max,i=void 0===r?ef:r,o=d$(e,["min","max"]),a=(0,Y.useCallback)((function(e){return function(e,t,n){if("-"===e)return;if(""===e)return t<=0&&n>=0?0:void 0;var r=parseInt(e,10);return isNaN(r)?void 0:of(r,t,n)}(e,n,i)}),[n,i]);return(0,z.jsx)(EY,u$(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){c$(e,t,n[t])}))}return e}({},o),{valueFormatter:m$,inputParser:a,inputValidator:n<0?g$:h$}))};function m$(e){return Math.trunc(e).toString(10)}function g$(e){return/^-?[0-9]*$/.test(e)}function h$(e){return/^[0-9]*$/.test(e)}oe.add("game-ui/common/input/text/int-input.tsx",{get IntInput(){return f$},set IntInput(e){f$=e}});let p$={slider:"slider_KXG slider_pUS",compact:"compact_c2g",range:"range_nHO range_iUN",thumb:"thumb_kkL"};oe.add("game-ui/editor/themes/editor-slider.module.scss",{get classes(){return p$},set classes(e){Object.assign(p$,e)}});const v$=p$;var b$=function(e){var t=e.label,n=e.value,r=e.min,i=e.max,o=e.disabled,a=e.onChange,s=e.onChangeStart,l=e.onChangeEnd;return(0,z.jsx)(BB,{disabled:o,children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)("div",{className:UB.label,children:t}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)(zv,{className:UB.sliderContainer,children:(0,z.jsx)(HL,{children:(0,z.jsx)(oF,{value:n,start:r,end:i,disabled:o,theme:v$,className:UB.slider,valueTransformer:sF,onChange:a,onDragStart:s,onDragEnd:l})})}),(0,z.jsx)(f$,{value:n,min:r,max:i,disabled:o,onChange:a,onFocus:s,onBlur:l,className:UB.sliderInput})]})})]})})},y$=function(e){var t=e.label,n=e.value,r=e.min,i=e.max,o=e.fractionDigits,a=void 0===o?3:o,s=e.disabled,l=e.onChange,c=e.onChangeStart,u=e.onChangeEnd,d=lF(Math.pow(10,-a));return(0,z.jsx)(BB,{disabled:s,children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)("div",{className:UB.label,children:t}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)(zv,{className:UB.sliderContainer,children:(0,z.jsx)(HL,{children:(0,z.jsx)(oF,{value:n,start:r,end:i,disabled:s,theme:v$,className:UB.slider,valueTransformer:d,onChange:l,onDragStart:c,onDragEnd:u})})}),(0,z.jsx)(PY,{value:n,min:r,max:i,fractionDigits:a,disabled:s,onChange:l,onFocus:c,onBlur:u,className:UB.sliderInput})]})})]})})};function x$(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function _$(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function j$(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}oe.add("game-ui/editor/widgets/fields/number-slider-field.tsx",{get IntSliderField(){return b$},set IntSliderField(e){b$=e},get FloatSliderField(){return y$},set FloatSliderField(e){y$=e}});var O$=function(e){var t=e.min,n=void 0===t?0:t,r=e.max,i=void 0===r?1439/1440:r,o=j$(e,["min","max"]),a=(0,Y.useCallback)((function(e){return function(e,t,n){if("-"===e)return;if(""===e)return t<=0&&n>=0?0:void 0;var r=/^(-?)(\d+):(\d+)$/g.exec(e);if(null!=r){var i=("-"===r[1]?-1:1)*(60*parseInt(r[2])+parseInt(r[3]))/1440;if(!isNaN(i))return of(i,t,n)}var o=parseInt(e,10)/24;return isNaN(o)?void 0:of(o,t,n)}(e,n,i)}),[n,i]);return(0,z.jsx)(EY,_$(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){x$(e,t,n[t])}))}return e}({},o),{valueFormatter:E$,inputParser:a,inputValidator:n<0?S$:T$}))};function E$(e){var t=-1===Math.sign(e)?"-":"",n=Math.floor(24*(Math.abs(e)+1e-5)),r=Math.round(1440*Math.abs(e))%60;return"".concat(t).concat(Vu(n,2),":").concat(Vu(r,2))}function S$(e){return/^-?[0-9]*:?[0-9]*$/.test(e)}function T$(e){return/^[0-9]*:?[0-9]*$/.test(e)}oe.add("game-ui/common/input/text/time-input.tsx",{get TimeInput(){return O$},set TimeInput(e){O$=e}});var I$=function(e){var t=e.label,n=e.value,r=e.min,i=e.max,o=e.disabled,a=e.onChange,s=e.onChangeStart,l=e.onChangeEnd;return(0,z.jsx)(BB,{disabled:o,children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)("div",{className:UB.label,children:t}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)(zv,{className:UB.sliderContainer,children:(0,z.jsx)(HL,{children:(0,z.jsx)(oF,{value:n,start:r,end:i,disabled:o,theme:v$,className:UB.slider,valueTransformer:w$,onChange:a,onDragStart:s,onDragEnd:l})})}),(0,z.jsx)(O$,{value:n,min:r,max:i,disabled:o,onChange:a,onFocus:s,onBlur:l,className:UB.sliderInput})]})})]})})};function w$(e,t,n){return of(Math.round(96*(e+n*(t-e)))/96,Math.min(e,t),Math.max(e,t))}function P$(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function C$(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){P$(e,t,n[t])}))}return e}function N$(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}oe.add("game-ui/editor/widgets/fields/time-slider-field.tsx",{get TimeSliderField(){return I$},set TimeSliderField(e){I$=e},get quarterHourTransformer(){return w$},set quarterHourTransformer(e){w$=e}});var A$=function(e){var t=e.label,n=e.value,r=e.allowMinGreaterMax,i=e.disabled,o=e.onChange,a=e.onChangeStart,s=e.onChangeEnd,l=(0,Y.useCallback)((function(e){return o(N$(C$({},n),{min:r?e:Math.min(e,n.max)}))}),[o,r,n]),c=(0,Y.useCallback)((function(e){return o(N$(C$({},n),{max:r?e:Math.max(e,n.min)}))}),[o,r,n]);return(0,z.jsxs)(uY,{label:t,children:[(0,z.jsx)(kY,{disabled:i,label:(0,z.jsx)(qc.Editor.WIDGETS,{hash:"Min"}),value:n.min,onChange:l,onChangeStart:a,onChangeEnd:s}),(0,z.jsx)(kY,{disabled:i,label:(0,z.jsx)(qc.Editor.WIDGETS,{hash:"Max"}),value:n.max,onChange:c,onChangeStart:a,onChangeEnd:s})]})},L$=function(e){var t=e.label,n=e.value,r=e.allowMinGreaterMax,i=e.disabled,o=e.onChange,a=e.onChangeStart,s=e.onChangeEnd,l=(0,Y.useCallback)((function(e){o(N$(C$({},n),{min:{x:r?e.x:Math.min(e.x,n.max.x),y:r?e.y:Math.min(e.y,n.max.y)}}))}),[o,r,n]),c=(0,Y.useCallback)((function(e){o(N$(C$({},n),{max:{x:r?e.x:Math.max(e.x,n.min.x),y:r?e.y:Math.max(e.y,n.min.y)}}))}),[o,r,n]);return(0,z.jsxs)(uY,{label:t,children:[(0,z.jsx)(RY,{disabled:i,label:(0,z.jsx)(qc.Editor.WIDGETS,{hash:"Min"}),value:n.min,onChange:l,onChangeStart:a,onChangeEnd:s}),(0,z.jsx)(RY,{disabled:i,label:(0,z.jsx)(qc.Editor.WIDGETS,{hash:"Max"}),value:n.max,onChange:c,onChangeStart:a,onChangeEnd:s})]})},M$=function(e){var t=e.label,n=e.value,r=e.allowMinGreaterMax,i=e.disabled,o=e.onChange,a=e.onChangeStart,s=e.onChangeEnd,l=(0,Y.useCallback)((function(e){o(N$(C$({},n),{min:{x:r?e.x:Math.min(e.x,n.max.x),y:r?e.y:Math.min(e.y,n.max.y),z:r?e.z:Math.min(e.z,n.max.z)}}))}),[o,r,n]),c=(0,Y.useCallback)((function(e){o(N$(C$({},n),{max:{x:r?e.x:Math.max(e.x,n.min.x),y:r?e.y:Math.max(e.y,n.min.y),z:r?e.z:Math.max(e.z,n.min.z)}}))}),[o,r,n]);return(0,z.jsxs)(uY,{label:t,children:[(0,z.jsx)(DY,{disabled:i,label:(0,z.jsx)(qc.Editor.WIDGETS,{hash:"Min"}),value:n.min,onChange:l,onChangeStart:a,onChangeEnd:s}),(0,z.jsx)(DY,{disabled:i,label:(0,z.jsx)(qc.Editor.WIDGETS,{hash:"Max"}),value:n.max,onChange:c,onChangeStart:a,onChangeEnd:s})]})},k$=function(e){var t=e.label,n=e.value,r=e.min,i=e.max,o=e.fractionDigits,a=void 0===o?3:o,s=e.allowMinGreaterMax,l=e.disabled,c=e.onChange,u=e.onChangeStart,d=e.onChangeEnd,f=(0,Y.useCallback)((function(e){return c(N$(C$({},n),{min:s?e:Math.min(e,n.max)}))}),[c,s,n]),m=(0,Y.useCallback)((function(e){return c(N$(C$({},n),{max:s?e:Math.max(e,n.min)}))}),[c,s,n]);return(0,z.jsxs)(uY,{label:t,children:[(0,z.jsx)(y$,{label:(0,z.jsx)(qc.Editor.WIDGETS,{hash:"Min"}),value:n.min,min:r,max:i,fractionDigits:a,disabled:l,onChange:f,onChangeStart:u,onChangeEnd:d}),(0,z.jsx)(y$,{label:(0,z.jsx)(qc.Editor.WIDGETS,{hash:"Max"}),value:n.max,min:r,max:i,fractionDigits:a,disabled:l,onChange:m,onChangeStart:u,onChangeEnd:d})]})},R$=function(e){var t=e.label,n=e.value,r=e.min,i=e.max,o=e.allowMinGreaterMax,a=e.disabled,s=e.onChange,l=e.onChangeStart,c=e.onChangeEnd,u=(0,Y.useCallback)((function(e){return s(N$(C$({},n),{min:o?e:Math.min(e,n.max)}))}),[o,s,n]),d=(0,Y.useCallback)((function(e){return s(N$(C$({},n),{max:o?e:Math.max(e,n.min)}))}),[o,s,n]);return(0,z.jsxs)(uY,{label:t,children:[(0,z.jsx)(I$,{label:(0,z.jsx)(qc.Editor.WIDGETS,{hash:"Min"}),value:n.min,min:r,max:i,disabled:a,onChange:u,onChangeStart:l,onChangeEnd:c}),(0,z.jsx)(I$,{label:(0,z.jsx)(qc.Editor.WIDGETS,{hash:"Max"}),value:n.max,min:r,max:i,disabled:a,onChange:d,onChangeStart:l,onChangeEnd:c})]})};function D$(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function F$(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}oe.add("game-ui/editor/widgets/fields/bounds-field.tsx",{get Bounds1InputField(){return A$},set Bounds1InputField(e){A$=e},get Bounds2InputField(){return L$},set Bounds2InputField(e){L$=e},get Bounds3InputField(){return M$},set Bounds3InputField(e){M$=e},get Bounds1SliderField(){return k$},set Bounds1SliderField(e){k$=e},get TimeBoundsSliderField(){return R$},set TimeBoundsSliderField(e){R$=e}});var U$=function(e){return(0,z.jsx)(EY,F$(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){D$(e,t,n[t])}))}return e}({},e),{valueFormatter:G$,inputParser:B$,inputTransformer:V$,inputValidator:H$}))};function G$(e){return oP(e)}function B$(e){return sP(e)||void 0}function V$(e){return e.toUpperCase()}function H$(e){return/^#?([a-f0-9]{0,6})$/i.test(e)}oe.add("game-ui/common/input/text/hex-color-input.tsx",{get HexColorInput(){return U$},set HexColorInput(e){U$=e}});var K$=W$();function W$(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{h:1,s:1,v:1,a:1},t=e.s,n=e.v;return q$({h:0,s:t,v:n,a:1},{h:1,s:t,v:n,a:1},arguments.length>1&&void 0!==arguments[1]?arguments[1]:36)}function z$(e){var t=e.h,n=e.v;return q$({h:t,s:0,v:n,a:1},{h:t,s:1,v:n,a:1},2)}function Y$(e){var t=e.h,n=e.s;return q$({h:t,s:n,v:0,a:1},{h:t,s:n,v:1,a:1},2)}function $$(e){var t=e.h,n=e.s,r=e.v;return q$({h:t,s:n,v:r,a:0},{h:t,s:n,v:r,a:1},2)}function q$(e,t,n){for(var r=[],i=0;i<=n;i++)r.push({offset:i/n,color:rP(lP(dP(e,t,i/n)))});return{stops:r}}function X$(e,t){return{stops:[{offset:0,color:rP(e)},{offset:1,color:rP(t)}]}}oe.add("game-ui/common/input/color-picker/color-slider/slider-backgrounds.ts",{get hueSliderBackground(){return K$},set hueSliderBackground(e){K$=e},get buildHueSliderBackground(){return W$},set buildHueSliderBackground(e){W$=e},get buildSaturationSliderBackground(){return z$},set buildSaturationSliderBackground(e){z$=e},get buildValueSliderBackground(){return Y$},set buildValueSliderBackground(e){Y$=e},get buildAlphaSliderBackground(){return $$},set buildAlphaSliderBackground(e){$$=e},get buildHsvGradient(){return q$},set buildHsvGradient(e){q$=e},get buildRgbGradient(){return X$},set buildRgbGradient(e){X$=e}});let Q$={edge:"edge_xBb","start-edge":"start-edge_nii edge_xBb",startEdge:"start-edge_nii edge_xBb","end-edge":"end-edge_egi edge_xBb",endEdge:"end-edge_egi edge_xBb","track-bounds":"track-bounds_hs9 track-bounds_H8_",trackBounds:"track-bounds_hs9 track-bounds_H8_"};oe.add("game-ui/common/input/slider/gradient-slider/gradient-slider.module.scss",{get classes(){return Q$},set classes(e){Object.assign(Q$,e)}});const Z$=Q$;function J$(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function eq(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){J$(e,t,n[t])}))}return e}function tq(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function nq(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var rq=function(e){var t,n,r=e.gradient,i=e.theme,o=nq(e,["gradient","theme"]),a=(0,Y.useMemo)((function(){return eq({},Z$,i)}),[i]),s=(0,Y.useMemo)((function(){var e,i;return{"--startColor":null!==(t=null===(e=r.stops.find((function(e){return 0===e.offset})))||void 0===e?void 0:e.color)&&void 0!==t?t:"grey","--endColor":null!==(n=null===(i=r.stops.find((function(e){return 1===e.offset})))||void 0===i?void 0:i.color)&&void 0!==n?n:"grey","--gradient":fP(r)}}),[r]);return(0,z.jsxs)(oF,tq(eq({},o),{theme:a,style:s,children:[(0,z.jsx)("div",{className:a.startEdge}),(0,z.jsx)("div",{className:a.endEdge})]}))};oe.add("game-ui/common/input/slider/gradient-slider/gradient-slider.tsx",{get GradientSlider(){return rq},set GradientSlider(e){rq=e}});let iq={slider:"slider_fer slider_pUS","gamepad-active":"gamepad-active_Elg",gamepadActive:"gamepad-active_Elg",thumb:"thumb_z1a"};oe.add("game-ui/common/input/color-picker/color-slider/color-slider.module.scss",{get classes(){return iq},set classes(e){Object.assign(iq,e)}});const oq=iq;let aq={"color-component-input":"color-component-input_WeK",colorComponentInput:"color-component-input_WeK",label:"label_GH4","slider-container":"slider-container_NuQ",sliderContainer:"slider-container_NuQ",slider:"slider_xgT",alpha:"alpha_N_s",input:"input_zfe"};oe.add("game-ui/common/input/color-picker/component-input/component-input.module.scss",{get classes(){return aq},set classes(e){Object.assign(aq,e)}});const sq=aq;var lq=function(e){var t=e.label,n=e.value,r=e.scale,i=e.step,o=e.gradient,a=e.alpha,s=e.onChange,l=e.textField,c=void 0===l||l,u=(0,Y.useCallback)((function(e){return s(of(e/r,0,1))}),[s,r]),d=lF(i),f=Pg();return(0,z.jsxs)("div",{className:sq.colorComponentInput,children:[c&&(0,z.jsx)("div",{className:sq.label,children:t}),(0,z.jsx)("div",{className:_d()(sq.slider,a&&sq.alpha),children:(0,z.jsx)("div",{className:sq.sliderContainer,children:(0,z.jsx)(rq,{value:n*r,start:0,end:r,theme:oq,gradient:o,gamepadStep:r/50,valueTransformer:d,className:_d()(f&&oq.gamepadActive),onChange:u})})}),c&&(1!==i?(0,z.jsx)(PY,{value:n*r,onChange:u,className:sq.input}):(0,z.jsx)(f$,{value:Math.round(n*r),onChange:u,className:sq.input}))]})};function cq(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function uq(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){cq(e,t,n[t])}))}return e}function dq(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}oe.add("game-ui/common/input/color-picker/component-input/component-input.tsx",{get ComponentInput(){return lq},set ComponentInput(e){lq=e}});var fq=function(e){var t=e.color,n=e.onChange,r=e.textField,i=void 0===r||r,o=(0,Y.useCallback)((function(e){return n(dq(uq({},t),{h:e}))}),[t,n]),a=(0,Y.useCallback)((function(e){return n(dq(uq({},t),{s:e}))}),[t,n]),s=(0,Y.useCallback)((function(e){return n(dq(uq({},t),{v:e}))}),[t,n]);return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(lq,{label:"H",value:t.h,scale:360,step:1,gradient:K$,onChange:o,textField:i}),(0,z.jsx)(lq,{label:"S",value:t.s,scale:100,step:1,gradient:z$(t),onChange:a,textField:i}),(0,z.jsx)(lq,{label:"V",value:t.v,scale:100,step:1,gradient:Y$(t),onChange:s,textField:i})]})},mq=function(e){var t=e.color,n=e.onChange,r=e.scale,i=void 0===r?255:r,o=e.step,a=void 0===o?1:o,s=e.textField,l=void 0===s||s,c=lP(t),u=t.h,d=(0,Y.useCallback)((function(e){return n(cP(dq(uq({},c),{r:e}),u))}),[c,u,n]),f=(0,Y.useCallback)((function(e){return n(cP(dq(uq({},c),{g:e}),u))}),[c,u,n]),m=(0,Y.useCallback)((function(e){return n(cP(dq(uq({},c),{b:e}),u))}),[c,u,n]);return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(lq,{label:"R",value:c.r,scale:i,step:a,gradient:X$(dq(uq({},c),{r:0,a:1}),dq(uq({},c),{r:1,a:1})),onChange:d,textField:l}),(0,z.jsx)(lq,{label:"G",value:c.g,scale:i,step:a,gradient:X$(dq(uq({},c),{g:0,a:1}),dq(uq({},c),{g:1,a:1})),onChange:f,textField:l}),(0,z.jsx)(lq,{label:"B",value:c.b,scale:i,step:a,gradient:X$(dq(uq({},c),{b:0,a:1}),dq(uq({},c),{b:1,a:1})),onChange:m,textField:l})]})},gq=function(e){var t=e.color,n=e.scale,r=void 0===n?100:n,i=e.step,o=void 0===i?1:i,a=e.onChange,s=e.textField,l=void 0===s||s,c=(0,Y.useCallback)((function(e){return a(dq(uq({},t),{a:e}))}),[t,a]);return(0,z.jsx)(lq,{label:"A",value:t.a,scale:r,step:o,gradient:$$(t),alpha:!0,onChange:c,textField:l})};function hq(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function pq(e){return function(e){if(Array.isArray(e))return hq(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return hq(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return hq(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/input/color-picker/component-input/component-inputs.tsx",{get HsvComponentInputs(){return fq},set HsvComponentInputs(e){fq=e},get RgbComponentInputs(){return mq},set RgbComponentInputs(e){mq=e},get AlphaComponentInput(){return gq},set AlphaComponentInput(e){gq=e}});var vq=function(e){var t=e.s,n=void 0===t?1:t,r=e.v,i=void 0===r?1:r,o=e.outerRadius,a=e.innerRadius,s=e.className;return(0,Y.useMemo)((function(){var e=2*Math.PI/360+.02,t=o-1,r=a+1,l=2*o;return(0,z.jsx)("svg",{width:l,height:l,viewBox:"0 0 ".concat(l," ").concat(l),className:s,children:(0,z.jsx)("g",{transform:"translate(".concat(o," ").concat(o,")"),children:pq(Array(360)).map((function(o,a){var s=a/360,l=2*Math.PI*s,c=l+e,u=Math.sin(l),d=Math.cos(l),f=Math.sin(c),m=Math.cos(c),g=rP(lP({h:s,s:n,v:i,a:1})),h=[[u*t,-d*t],[u*t,-d*t],[f*t,-m*t],[f*r,-m*r]];return(0,z.jsx)("path",{d:"M".concat(h.join(" L"),"z"),fill:g,stroke:g,strokeWidth:2},a)}))})})}),[s,a,o,n,i])};oe.add("game-ui/common/input/color-picker/radial-hue-picker/radial-hue-wheel.tsx",{get RadialHueWheel(){return vq},set RadialHueWheel(e){vq=e}});let bq={"radial-hue-picker":"radial-hue-picker_TbV",radialHuePicker:"radial-hue-picker_TbV",active:"active_JI3",wheel:"wheel_aXq",thumb:"thumb_ydk"};oe.add("game-ui/common/input/color-picker/radial-hue-picker/radial-hue-picker.module.scss",{get classes(){return bq},set classes(e){Object.assign(bq,e)}});const yq=bq;function xq(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function _q(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return xq(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return xq(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var jq=function(e){var t=e.h,n=e.s,r=void 0===n?1:n,i=e.v,o=void 0===i?1:i,a=e.decimalPrecision,s=void 0===a?3:a,l=e.outerRadius,c=e.innerRadius,u=e.className,d=e.onChange,f=e.onDragStart,m=e.onDragEnd,g=(0,Y.useRef)(null),h=(0,Y.useCallback)((function(e){var t=e.clientX,n=e.clientY;return!(!g.current||!function(e,t,n,r,i){var o=e.getBoundingClientRect(),a=o.left,s=o.top,l=o.width,c=o.height,u=t-a-l/2,d=n-s-c/2,f=u*u+d*d,m=r*r,g=i*i;return f>=m&&f<=g}(g.current,t,n,c,l))&&(function(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}(document.activeElement,HTMLElement)&&document.activeElement.blur(),kp(Lp.grabSlider),f&&f(),d&&d(Oq(g.current,t,n,s)),!0)}),[c,l,f,d,s]),p=(0,Y.useCallback)((function(e){var t=e.clientX,n=e.clientY;g.current&&d&&(kp(Lp.dragSlider),d(Oq(g.current,t,n,s)))}),[d,s]),v=_q(sE(h,p,(0,Y.useCallback)((function(){m&&m()}),[m])),2),b=v[0],y=v[1],x={width:2*l,height:2*l},_=(c+l)/2,j=2*t*Math.PI,O={transform:"translate(".concat(_*Math.sin(j),"px, ").concat(-_*Math.cos(j),"px) translate(-50%, -50%)"),top:l,left:l,backgroundColor:rP(lP({h:t,s:r,v:o,a:1}))};return(0,z.jsxs)("div",{ref:g,className:_d()(yq.radialHuePicker,b&&yq.active,u),style:x,onMouseDown:y,children:[(0,z.jsx)(vq,{s:r,v:o,outerRadius:l,innerRadius:c,className:yq.wheel}),(0,z.jsx)("div",{className:yq.thumb,style:O})]})};function Oq(e,t,n,r){var i=e.getBoundingClientRect(),o=i.left,a=i.top,s=t-o-i.width/2,l=n-a-i.height/2;return of(sf(Math.atan2(-s,l)/(2*Math.PI)+.5,r),0,1)}function Eq(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Sq(e){return function(e){if(Array.isArray(e))return Eq(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return Eq(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Eq(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/input/color-picker/radial-hue-picker/radial-hue-picker.tsx",{get RadialHuePicker(){return jq},set RadialHuePicker(e){jq=e}});var Tq=function(e){var t=e.h,n=e.width,r=e.height,i=e.className,o=(0,Y.useId)(),a=(0,Y.useMemo)((function(){var e=Math.round(r/1);return(0,z.jsx)("svg",{width:n,height:r,viewBox:"0 0 ".concat(n," ").concat(r),className:i,children:Sq(Array(e)).map((function(r,i){var a=1-i/e,s=rP(lP({h:t,s:0,v:a,a:1})),l=rP(lP({h:t,s:1,v:a,a:1})),c="g-".concat(o,"-").concat(i),u=1*i;return(0,z.jsxs)("g",{children:[(0,z.jsxs)("linearGradient",{id:"".concat(c),gradientTransform:"rotate(90)",children:[(0,z.jsx)("stop",{offset:"0%",stopColor:s}),(0,z.jsx)("stop",{offset:"100%",stopColor:l})]}),(0,z.jsx)("rect",{y:u,width:2*n,height:1,fill:"url(#".concat(c,")")})]},i)}))})}),[i,t,r,o,n]);return a};oe.add("game-ui/common/input/color-picker/saturation-value-picker/saturation-value-gradient.tsx",{get SaturationValueGradient(){return Tq},set SaturationValueGradient(e){Tq=e}});let Iq={"saturation-gradient-picker":"saturation-gradient-picker_tkk",saturationGradientPicker:"saturation-gradient-picker_tkk",active:"active_LF5",gradient:"gradient_LME",thumb:"thumb_l7W"};oe.add("game-ui/common/input/color-picker/saturation-value-picker/saturation-value-picker.module.scss",{get classes(){return Iq},set classes(e){Object.assign(Iq,e)}});const wq=Iq;function Pq(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Cq(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||Aq(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Nq(e){return function(e){if(Array.isArray(e))return Pq(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||Aq(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Aq(e,t){if(e){if("string"==typeof e)return Pq(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Pq(e,t):void 0}}var Lq=function(e){var t=e.h,n=e.s,r=e.v,i=e.decimalPrecision,o=void 0===i?3:i,a=e.width,s=e.height,l=e.className,c=e.onChange,u=e.onDragStart,d=e.onDragEnd,f=(0,Y.useRef)(null),m=(0,Y.useCallback)((function(e){var n=e.clientX,r=e.clientY;return!!f.current&&(function(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}(document.activeElement,HTMLElement)&&document.activeElement.blur(),kp(Lp.grabSlider),u&&u(),c&&c.apply(void 0,Nq(Mq(f.current,n,r,t,o))),!0)}),[u,c,t,o]),g=(0,Y.useCallback)((function(e){var n=e.clientX,r=e.clientY;f.current&&c&&(kp(Lp.dragSlider),c.apply(void 0,Nq(Mq(f.current,n,r,t,o))))}),[c,t,o]),h=Cq(sE(m,g,(0,Y.useCallback)((function(){d&&d()}),[d])),2),p=h[0],v=h[1],b=_d()(wq.saturationGradientPicker,p&&wq.active,l),y={width:a,height:s},x={transform:"translate(".concat(n*a,"px, ").concat((1-r)*s,"px) translate(-50%, -50%)"),backgroundColor:rP(lP({h:t,s:n,v:r,a:1}))};return(0,z.jsxs)("div",{ref:f,className:b,style:y,onMouseDown:v,children:[(0,z.jsx)(Tq,{h:t,width:a,height:s,className:wq.gradient}),(0,z.jsx)("div",{className:wq.thumb,style:x})]})};function Mq(e,t,n,r,i){var o=e.getBoundingClientRect(),a=o.left,s=o.top,l=o.width,c=o.height;return[of(sf((t-a)/l,i),0,1),of(sf(1-(n-s)/c,i),0,1)]}oe.add("game-ui/common/input/color-picker/saturation-value-picker/saturation-value-picker.tsx",{get SaturationValuePicker(){return Lq},set SaturationValuePicker(e){Lq=e}});let kq={"color-picker":"color-picker_aNX",colorPicker:"color-picker_aNX",section:"section_cwE",preview:"preview_HmH","preview-swatch":"preview-swatch_fDW",previewSwatch:"preview-swatch_fDW",wheel:"wheel_lpH",sv:"sv_Nf5","sv-picker":"sv-picker_DTa",svPicker:"sv-picker_DTa",modes:"modes_ZSt","mode-dropdown":"mode-dropdown_fGC",modeDropdown:"mode-dropdown_fGC",sliders:"sliders_sCL",hex:"hex_c98","hex-label":"hex-label_yqK",hexLabel:"hex-label_yqK","hex-input":"hex-input_hFc",hexInput:"hex-input_hFc"};oe.add("game-ui/common/input/color-picker/color-picker/color-picker.module.scss",{get classes(){return kq},set classes(e){Object.assign(kq,e)}});const Rq=kq;function Dq(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Fq(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Uq(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Fq(e,t,n[t])}))}return e}function Gq(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Bq(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Dq(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Dq(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Vq,Hq;!function(e){e[e.None=0]="None",e[e.Current=1]="Current",e[e.CurrentAndLast=2]="CurrentAndLast"}(Vq||(Vq={})),function(e){e.Hsv="Hsv",e.RgbFloat="RgbFloat",e.RgbByte="RgbByte"}(Hq||(Hq={}));var Kq=function(e){var t=e.focusKey,n=e.color,r=e.alpha,i=e.colorWheel,o=void 0===i||i,a=e.sliderTextInput,s=void 0===a||a,l=e.preview,c=void 0===l?Vq.None:l,u=e.mode,d=e.hexInput,f=void 0===d||d,m=e.onChange;n=Gq(Uq({},n),{a:r?n.a:1});var g=(0,Y.useRef)(n),h=Bq((0,Y.useState)(u||Hq.Hsv),2),p=h[0],v=h[1],b=(0,Y.useCallback)((function(e){return m(Gq(Uq({},n),{h:e}))}),[m,n]),y=(0,Y.useCallback)((function(e,t){return m(Gq(Uq({},n),{s:e,v:t}))}),[m,n]),x=(0,Y.useCallback)((function(e){return m(cP(Gq(Uq({},e),{a:n.a}),n.h))}),[m,n]),_=(0,Y.useCallback)((function(){return m(g.current)}),[m]),j=$O();return(0,z.jsx)(Ap,{focusKey:t,children:(0,z.jsxs)("div",{className:Rq.colorPicker,children:[c!==Vq.None&&(0,z.jsxs)("div",{className:Rq.preview,children:[c===Vq.CurrentAndLast&&(0,z.jsx)("div",{className:Rq.previewSwatch,style:{backgroundColor:rP(lP(g.current))},onClick:_}),(0,z.jsx)("div",{className:Rq.previewSwatch,style:{backgroundColor:rP(lP(n))}})]}),o&&(0,z.jsxs)("div",{className:_d()(Rq.section,Rq.wheel),children:[(0,z.jsx)(jq,{h:n.h,outerRadius:93*j,innerRadius:70*j,onChange:b}),(0,z.jsx)("div",{className:Rq.sv,children:(0,z.jsx)(Lq,Gq(Uq({},n),{width:94*j,height:94*j,onChange:y,className:Rq.svPicker}))})]}),void 0===u&&(0,z.jsx)("div",{className:_d()(Rq.modes,Rq.section),children:(0,z.jsx)(SE,{theme:DB,content:Object.values(Hq).map((function(e){return(0,z.jsx)(RE,{focusKey:e,value:e,selected:p===e,onChange:v,children:Wq(e)},e)})),children:(0,z.jsx)(CE,{className:Rq.modeDropdown,children:Wq(p)})})}),(0,z.jsx)("div",{className:_d()(Rq.sliders,Rq.section),children:(0,z.jsx)(zq,{mode:p,color:n,alpha:r,onChange:m,textField:s})}),f&&(0,z.jsxs)("div",{className:_d()(Rq.hex,Rq.section),children:[(0,z.jsx)("div",{className:Rq.hexLabel,children:"Hex"}),(0,z.jsx)(U$,{value:lP(n),onChange:x,className:Rq.hexInput})]})]})})};function Wq(e){switch(e){case Hq.Hsv:return"HSV";case Hq.RgbFloat:return"RGB 0-1.0";case Hq.RgbByte:return"RGB 0-255"}}var zq=function(e){var t=e.mode,n=e.color,r=e.alpha,i=e.onChange,o=e.textField,a=void 0===o||o;switch(t){case Hq.Hsv:return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(fq,{color:n,onChange:i,textField:a}),r&&(0,z.jsx)(gq,{color:n,scale:100,step:1,onChange:i,textField:a})]});case Hq.RgbFloat:return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(mq,{color:n,scale:1,step:.001,onChange:i,textField:a}),r&&(0,z.jsx)(gq,{color:n,scale:1,step:.001,onChange:i,textField:a})]});case Hq.RgbByte:return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(mq,{color:n,scale:255,step:1,onChange:i,textField:a}),r&&(0,z.jsx)(gq,{color:n,scale:255,step:1,onChange:i,textField:a})]})}};function Yq(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function $q(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function qq(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Xq(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Yq(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Yq(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/input/color-picker/color-picker/color-picker.tsx",{get ColorPickerPreview(){return Vq},set ColorPickerPreview(e){Vq=e},get ColorPickerSliderMode(){return Hq},set ColorPickerSliderMode(e){Hq=e},get ColorPicker(){return Kq},set ColorPicker(e){Kq=e}});var Qq=new Wh("swatch"),Zq=new Wh("picker"),Jq=function(e){var t=e.label,n=e.value,r=e.showAlpha,i=e.disabled,o=e.onChange,a=Xq((0,Y.useState)(!1),2),s=a[0],l=a[1],c=(0,Y.useCallback)((function(){return l((function(e){return!e}))}),[]);(0,Y.useEffect)((function(){i&&l(!1)}),[i]);var u=Xq((0,Y.useState)(0),2),d=u[0],f=u[1],m=(0,Y.useCallback)((function(e){f(e.h),o(lP(e))}),[o]),g=(0,Y.useMemo)((function(){return function(e,t){var n=cP(e,t);if(0===n.h&&t>.99)return qq(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){$q(e,t,n[t])}))}return e}({},n),{h:1});return n}(n,d)}),[d,n]);return(0,z.jsx)(BB,{disabled:i,children:(0,z.jsxs)(pj,{focused:s?Zq:Qq,children:[(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)("div",{className:UB.label,children:t}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsx)(Qp,{focusKey:Qq,className:_d()(UB.swatch,n.a<1&&UB.alpha),onSelect:i?void 0:c,children:(0,z.jsx)("div",{style:{backgroundColor:rP(n)}})})})]}),s&&(0,z.jsx)("div",{className:UB.colorPickerContainer,children:(0,z.jsx)(Kq,{focusKey:Zq,color:g,alpha:r,onChange:m})})]})})};oe.add("game-ui/editor/widgets/fields/color-field.tsx",{get ColorField(){return Jq},set ColorField(e){Jq=e}});var eX=new Wh("FIELD"),tX=function(e){var t=e.parent,n=e.path,r=e.props,i=RR(qR,uD(t,n));return(0,z.jsx)(nX,{label:(0,z.jsx)(ku,{value:r.displayName}),value:r.displayValue,disabled:r.disabled,onOpenDirectoryBrowser:i})},nX=function(e){var t=e.label,n=e.value,r=e.disabled,i=e.onOpenDirectoryBrowser,o=(0,Y.useCallback)((function(){return i()}),[i]);return(0,z.jsx)(z.Fragment,{children:(0,z.jsx)(BB,{disabled:r,children:(0,z.jsx)(pj,{focused:eX,children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)("div",{className:UB.label,children:t}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsxs)(Qp,{focusKey:eX,className:_d()(UB.pickerToggle,UB.directoryButton),disabled:r,onSelect:o,children:[n,(0,z.jsx)("img",{src:"Media/Editor/Folder.svg",className:UB.directoryIcon})]})})]})})})})};oe.add("game-ui/editor/widgets/fields/directory-picker-button.tsx",{get BoundDirectoryPickerButton(){return tX},set BoundDirectoryPickerButton(e){tX=e},get DirectoryPickerButton(){return nX},set DirectoryPickerButton(e){nX=e}});let rX={"dropdown-flag-item":"dropdown-flag-item_EcT",dropdownFlagItem:"dropdown-flag-item_EcT",toggle:"toggle_RyX",label:"label_PwM"};oe.add("game-ui/common/input/dropdown/items/dropdown-flag-item.module.scss",{get classes(){return rX},set classes(e){Object.assign(rX,e)}});const iX=rX;function oX(e){var t=e.focusKey,n=e.value,r=e.checked,i=e.theme,o=void 0===i?iX:i,a=e.toggleComponent,s=void 0===a?fv:a,l=e.className,c=e.onChange,u=e.children,d=(0,Y.useCallback)((function(){c&&c(n,!r)}),[r,c,n]);return(0,z.jsx)(ip,{onAction:d,children:(0,z.jsxs)(Yv,{focusKey:t,className:_d()(o.dropdownFlagItem,r&&"checked",l),onClick:d,children:[Y.createElement(s,{checked:r,className:o.toggle}),(0,z.jsx)("div",{className:o.label,children:u})]})})}function aX(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function sX(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function lX(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return aX(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return aX(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/common/input/dropdown/items/dropdown-flag-item.tsx",{get DropdownFlagItem(){return oX},set DropdownFlagItem(e){oX=e}});var cX=function(e){var t=e.parent,n=e.path,r=e.props,i=uD(t,n),o=(0,Y.useMemo)((function(){return r.enumMembers.map(WR)}),[r.enumMembers]),a=(0,Y.useCallback)((function(e){return YR(i,Ff(e))}),[i]);return(0,z.jsx)(dX,{label:(0,z.jsx)(ku,{value:r.displayName}),value:Df(r.value),enumMembers:o,disabled:r.disabled,onChange:a})},uX=function(e){var t=e.parent,n=e.path,r=e.props,i=uD(t,n),o=(0,Y.useMemo)((function(){return r.enumMembers.map(WR)}),[r.enumMembers]),a=(0,Y.useCallback)((function(e){return YR(i,Ff(e))}),[i]);return(0,z.jsx)(fX,{label:(0,z.jsx)(ku,{value:r.displayName}),value:Df(r.value),enumMembers:o,disabled:r.disabled,onChange:a})},dX=function(e){var t=e.label,n=e.value,r=e.enumMembers,i=e.disabled,o=e.onChange,a=vc(),s=(0,Y.useMemo)((function(){return gX(a,r,n)}),[a,r,n]);return(0,z.jsx)(BB,{disabled:i,children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)("div",{className:UB.label,children:t}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsx)(SE,{theme:DB,initialFocused:s,content:null==r?void 0:r.map((function(e,t){return(0,z.jsx)(RE,{focusKey:t,value:e.value,selected:n===e.value,onChange:o,children:(0,z.jsx)(ku,{value:e.displayName})},t)})),children:(0,z.jsx)(CE,{sounds:mX,className:UB.dropdownToggle,disabled:i,children:s})})})]})})},fX=function(e){var t=e.label,n=e.value,r=e.enumMembers,i=e.disabled,o=e.onChange,a=vc(),s=(0,Y.useMemo)((function(){return function(e,t,n){if(0n!==n){var r=t.map((function(e){return e.value})).find((function(e){return e===n}));return r?gX(e,t,r):t.filter((function(e){return 0n!==e.value&&(n&e.value)===e.value})).map((function(t){return Ru(e,t.displayName)})).join(", ")||" "}return gX(e,t,0n)}(a,r,n)}),[a,r,n]),l=(0,Y.useCallback)((function(e,t){o(t?n|e:n&~e)}),[o,n]),c=(0,Y.useMemo)((function(){return r.map((function(e){return e.value})).reduce((function(e,t){return e|t}))}),[r]),u=c===n,d=(0,Y.useCallback)((function(){return o(c)}),[c,o]),f=(0,Y.useCallback)((function(){return o(0n)}),[o]);return(0,z.jsx)(BB,{disabled:i,children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)("div",{className:UB.label,children:t}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsx)(SE,{theme:DB,initialFocused:0,content:(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(Qp,{onSelect:u?f:d,selected:u,className:DB.toggleFlagsButton,children:"Select Nothing/Everything"}),r.map((function(e,t){return(0,z.jsx)(oX,{theme:DB,focusKey:t,value:e.value,checked:(e.value&n)===e.value,onChange:l,children:(0,z.jsx)(ku,{value:e.displayName})},t)}))]}),children:(0,z.jsx)(CE,{sounds:mX,className:UB.dropdownToggle,children:s})})})]})})},mX=function(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){sX(e,t,n[t])}))}return e}({},Xp),{hover:null,focus:null});function gX(e,t,n){var r=t.find((function(e){return e.value===n}));return null!=r?Ru(e,r.displayName):" "}function hX(e){return Object.entries(e).filter((function(e){return"number"==typeof e[1]})).map((function(e){var t=lX(e,2),n=t[0],r=t[1];return{displayName:Ac(n),value:BigInt(r)}}))}function pX(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function vX(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){pX(e,t,n[t])}))}return e}function bX(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function yX(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}oe.add("game-ui/editor/widgets/fields/enum-field.tsx",{get BoundEnumField(){return cX},set BoundEnumField(e){cX=e},get BoundFlagsField(){return uX},set BoundFlagsField(e){uX=e},get EnumField(){return dX},set EnumField(e){dX=e},get FlagsField(){return fX},set FlagsField(e){fX=e},get getEnumMembers(){return hX},set getEnumMembers(e){hX=e}});var xX=function(e){var t=e.label,n=e.value,r=e.min,i=void 0===r?Jd:r,o=e.max,a=void 0===o?ef:o,s=e.disabled,l=e.onChange,c=e.onChangeStart,u=e.onChangeEnd,d=(0,Y.useCallback)((function(e,t){return TX(e,t,i,a)}),[i,a]);return(0,z.jsx)(BB,{disabled:s,children:(0,z.jsxs)("div",{"data-type":"field",className:UB.row,children:[(0,z.jsx)(bY,{value:n,disabled:s,className:UB.label,dragTransformation:d,onChange:l,children:t}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsx)(f$,{value:n,min:i,max:a,disabled:s,className:UB.input,onChange:l,onFocus:c,onBlur:u})})]})})},_X=function(e){var t=e.min,n=void 0===t?0:t,r=e.max,i=void 0===r?tf:r,o=yX(e,["min","max"]);return(0,z.jsx)(xX,bX(vX({},o),{min:n,max:i}))},jX=function(e){var t=e.label,n=e.value,r=e.disabled,i=e.onChange,o=e.onChangeStart,a=e.onChangeEnd,s=(0,Y.useCallback)((function(e){return i(bX(vX({},n),{x:e}))}),[n,i]),l=(0,Y.useCallback)((function(e){return i(bX(vX({},n),{y:e}))}),[n,i]);return(0,z.jsx)(BB,{disabled:r,children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)(bY,{value:n,disabled:r,className:UB.label,dragTransformation:wX,onChange:i,children:t}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)(SX,{label:"X",value:n.x,disabled:r,onChange:s,onChangeStart:o,onChangeEnd:a}),(0,z.jsx)(SX,{label:"Y",value:n.y,disabled:r,onChange:l,onChangeStart:o,onChangeEnd:a})]})})]})})},OX=function(e){var t=e.label,n=e.value,r=e.disabled,i=e.onChange,o=e.onChangeStart,a=e.onChangeEnd,s=(0,Y.useCallback)((function(e){return i(bX(vX({},n),{x:e}))}),[n,i]),l=(0,Y.useCallback)((function(e){return i(bX(vX({},n),{y:e}))}),[n,i]),c=(0,Y.useCallback)((function(e){return i(bX(vX({},n),{z:e}))}),[n,i]);return(0,z.jsx)(BB,{disabled:r,children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)(bY,{value:n,disabled:r,className:UB.label,dragTransformation:PX,onChange:i,children:t}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)(SX,{label:"X",value:n.x,disabled:r,onChange:s,onChangeStart:o,onChangeEnd:a}),(0,z.jsx)(SX,{label:"Y",value:n.y,disabled:r,onChange:l,onChangeStart:o,onChangeEnd:a}),(0,z.jsx)(SX,{label:"Z",value:n.z,disabled:r,onChange:c,onChangeStart:o,onChangeEnd:a})]})})]})})},EX=function(e){var t=e.label,n=e.value,r=e.disabled,i=e.onChange,o=e.onChangeStart,a=e.onChangeEnd,s=(0,Y.useCallback)((function(e){return i(bX(vX({},n),{x:e}))}),[n,i]),l=(0,Y.useCallback)((function(e){return i(bX(vX({},n),{y:e}))}),[n,i]),c=(0,Y.useCallback)((function(e){return i(bX(vX({},n),{z:e}))}),[n,i]),u=(0,Y.useCallback)((function(e){return i(bX(vX({},n),{w:e}))}),[n,i]);return(0,z.jsx)(BB,{disabled:r,children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)(bY,{value:n,disabled:r,className:UB.label,dragTransformation:CX,onChange:i,children:t}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)(SX,{label:"X",value:n.x,disabled:r,onChange:s,onChangeStart:o,onChangeEnd:a}),(0,z.jsx)(SX,{label:"Y",value:n.y,disabled:r,onChange:l,onChangeStart:o,onChangeEnd:a}),(0,z.jsx)(SX,{label:"Z",value:n.z,disabled:r,onChange:c,onChangeStart:o,onChangeEnd:a}),(0,z.jsx)(SX,{label:"W",value:n.w,disabled:r,onChange:u,onChangeStart:o,onChangeEnd:a})]})})]})})},SX=function(e){var t=e.label,n=e.value,r=e.disabled,i=e.onChange,o=e.onChangeStart,a=e.onChangeEnd;return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(bY,{value:n,disabled:r,className:UB.vectorLabel,dragTransformation:IX,onChange:i,children:t}),(0,z.jsx)(f$,{value:n,disabled:r,className:UB.vectorInput,onChange:i,onFocus:o,onBlur:a})]})};function TX(e,t,n,r){return of(Math.trunc(e+30*t),n,r)}function IX(e,t){return TX(e,t,Jd,ef)}function wX(e,t){return{x:of(Math.trunc(e.x+60*t),Jd,ef),y:of(Math.trunc(e.y+60*t),Jd,ef)}}function PX(e,t){return{x:of(Math.trunc(e.x+60*t),Jd,ef),y:of(Math.trunc(e.y+60*t),Jd,ef),z:of(Math.trunc(e.z+60*t),Jd,ef)}}function CX(e,t){return{x:of(Math.trunc(e.x+60*t),Jd,ef),y:of(Math.trunc(e.y+60*t),Jd,ef),z:of(Math.trunc(e.z+60*t),Jd,ef),w:of(Math.trunc(e.w+60*t),Jd,ef)}}oe.add("game-ui/editor/widgets/fields/int-input-field.tsx",{get IntInputField(){return xX},set IntInputField(e){xX=e},get UIntInputField(){return _X},set UIntInputField(e){_X=e},get Int2InputField(){return jX},set Int2InputField(e){jX=e},get Int3InputField(){return OX},set Int3InputField(e){OX=e},get Int4InputField(){return EX},set Int4InputField(e){EX=e}});var NX=new Wh("FIELD"),AX=new Wh("PICKER"),LX=function(e){var t=e.parent,n=e.path,r=e.props,i=e.children,o=uD(t,n),a=(0,Y.useContext)(ED),s=RR($R,o);return(0,z.jsx)(MX,{label:(0,z.jsx)(ku,{value:r.displayName}),value:(0,z.jsx)(ku,{value:r.displayValue}),expanded:r.expanded,disabled:r.disabled,onExpandedChange:s,children:(0,z.jsx)(OD,{parent:o,components:a,data:i})})},MX=function(e){var t=e.label,n=e.value,r=e.expanded,i=e.disabled,o=e.children,a=e.onExpandedChange,s=(0,Y.useCallback)((function(){return a(!r)}),[r,a]),l=(0,Y.useCallback)((function(){return a(!1)}),[a]),c=YO(UB.pickerMinHeight),u=(0,z.jsx)(Ap,{focusKey:AX,children:o});return(0,z.jsxs)(z.Fragment,{children:[r&&(0,z.jsx)(tE,{onClick:l}),(0,z.jsx)(BB,{disabled:i,children:(0,z.jsx)(pj,{focused:r?AX:NX,children:(0,z.jsx)(QO,{visible:r,minHeight:c,content:u,className:UB.pickerPopup,minWidth:!0,children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)("div",{className:UB.label,children:t}),(0,z.jsx)("div",{className:UB.control,children:(0,z.jsx)(Qp,{focusKey:NX,className:_d()(UB.pickerToggle,r&&UB.expanded),disabled:i,onSelect:s,children:n})})]})})})})]})};oe.add("game-ui/editor/widgets/fields/popup-value-field.tsx",{get BoundPopupValueField(){return LX},set BoundPopupValueField(e){LX=e},get PopupValueField(){return MX},set PopupValueField(e){MX=e}});var kX=function(e){var t=e.seasons,n=e.tickHeight,r=void 0===n?50:n,i=KV().viewport,o=i.padding,a=i.rem,s=i.bounds,l=i.posFromPoint;return(0,z.jsxs)("g",{children:[t.map((function(e,t){var n=l(e.startTime,s.max.y);return(0,z.jsxs)("g",{children:[(0,z.jsx)(wz,{x1:e.startTime,x2:e.startTime,y1:s.min.y-o.bottom,y2:s.max.y+o.top,stroke:"#fff3",strokeWidth:1}),(0,z.jsx)(TW,{fontSize:a(12),x:Math.max(n.x-a(10),a(10)),y:n.y+a(o.top-10),label:e.name,color:"#fff6",rotation:90,textAnchor:"end"})]},"".concat(e.name).concat(t))})),(0,z.jsx)(wW,{overdraw:!0,halfSteps:!0,drawAxes:"y",tickHeight:r})]})};function RX(e,t,n,r,i,o,a){try{var s=e[o](a),l=s.value}catch(e){return void n(e)}s.done?t(l):Promise.resolve(l).then(r,i)}function DX(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}oe.add("game-ui/editor/widgets/fields/seasons-field/seasons-grid-lines.tsx",{get SeasonsGridLines(){return kX},set SeasonsGridLines(e){kX=e}});var FX=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}},UX={left:0,bottom:10,top:40,right:0},GX=function(){return""},BX=function(e){var t,n,r=e.label,i=e.data,o=e.type,a=e.seasons,s=e.editorClassName,l=e.curveDataOptions,c=e.gridLinesTickHeight,u=e.onAddKeyframe,d=e.onRemoveKeyframe,f=e.onUpdateSeasonProperty,m=qY(i[o],function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){DX(e,t,n[t])}))}return e}({minX:0,maxX:1,minY:0,maxY:100,autoUpdateBounds:!1,wrapMode:"loop"},l)),g=(0,Y.useCallback)((t=function(e,t,n,r){return FX(this,(function(n){return[2,f(e,o,r||0,t)]}))},n=function(){var e=this,n=arguments;return new Promise((function(r,i){var o=t.apply(e,n);function a(e){RX(o,r,i,a,s,"next",e)}function s(e){RX(o,r,i,a,s,"throw",e)}a(void 0)}))},function(e,t,r,i){return n.apply(this,arguments)}),[f,o]);return(0,z.jsxs)("div",{children:[(0,z.jsx)("p",{children:r}),(0,z.jsx)(pz,{data:m,onRemoveKeyframe:d,onAddKeyframe:u,onMoveKeyframe:g,canAddKeyframes:!0,hideControlPoints:!0,allowEditingAll:!0,children:(0,z.jsx)(rY,{padding:UX,gridLines:!1,formatLabelX:GX,className:s,children:(0,z.jsx)(kX,{seasons:a,tickHeight:c})})})]})};oe.add("game-ui/editor/widgets/fields/seasons-field/seasons-curve-editor.tsx",{get SeasonsCurveEditor(){return BX},set SeasonsCurveEditor(e){BX=e}});let VX={"seasons-field":"seasons-field_wTf",seasonsField:"seasons-field_wTf","cloudiness-editor":"cloudiness-editor_bcT",cloudinessEditor:"cloudiness-editor_bcT","fog-editor":"fog-editor_FS_",fogEditor:"fog-editor_FS_","temperature-gradient":"temperature-gradient_hNT",temperatureGradient:"temperature-gradient_hNT"};oe.add("game-ui/editor/widgets/fields/seasons-field/seasons.module.scss",{get classes(){return VX},set classes(e){Object.assign(VX,e)}});const HX=VX;function KX(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function WX(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){KX(e,t,n[t])}))}return e}function zX(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var YX=function(e){var t=e.value,n=e.seasons,r=e.label,i=zX(e,["value","seasons","label"]);return(0,z.jsxs)("div",{className:HX.seasonsField,children:[r&&(0,z.jsx)("p",{children:r}),(0,z.jsx)(BX,WX({data:t,label:"Temperature",type:"temperature",curveDataOptions:{minY:-40,maxY:40},seasons:n},i)),(0,z.jsx)(BX,WX({data:t,label:"Fog",type:"fog",seasons:n,gridLinesTickHeight:75,editorClassName:HX.fogEditor},i)),(0,z.jsx)(BX,WX({data:t,label:"Cloudiness",type:"cloudiness",seasons:n,editorClassName:HX.cloudinessEditor},i)),(0,z.jsx)(BX,WX({data:t,label:"Percipitation",type:"precipitation",seasons:n},i)),(0,z.jsx)(BX,WX({data:t,label:"Aurora",type:"aurora",seasons:n},i))]})};function $X(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function qX(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}oe.add("game-ui/editor/widgets/fields/seasons-field/seasons-field.tsx",{get SeasonsField(){return YX},set SeasonsField(e){YX=e}});var XX={inTangent:0,outTangent:0,inWeight:.33,outWeight:.33,weightedMode:rz.None},QX={temperature:["final","tempNightDay.y","tempDeviationNightDay.y","tempNightDay.x","tempDeviationNightDay.x"],cloudiness:["final","cloudAmount","cloudAmountDeviation","cloudChance","turbulence"],precipitation:["final","precipitationAmount","precipitationAmountDeviation","precipitationChance","turbulence"],aurora:["final","auroraAmount","auroraChance"],fog:["final"]},ZX=function(e,t){return QX[e][t]},JX=function(e,t,n,r){return{label:e,color:t,keys:[],preWrapMode:iz.Loop,postWrapMode:iz.Loop,deviationFrom:n,readonly:r}},eQ=function(){return{temperature:[JX("final","#f3f3f3",void 0,!0),JX("day","#f00f"),JX("dayDeviation","#f967",1),JX("night","#00ff"),JX("nightDeviation","#74f7",3)],cloudiness:[JX("final","#f3f3f3",void 0,!0),JX("amount","#00ff"),JX("amountDeviation","#aaf7",1),JX("chance","#0f0a"),JX("turbulence","#fffa")],precipitation:[JX("final","#f3f3f3",void 0,!0),JX("amount","#00ff"),JX("amountDeviation","#44f7",1),JX("chance","#0f0a"),JX("turbulence","#fffa")],aurora:[JX("final","#f3f3f3",void 0,!0),JX("amount","#00ff"),JX("chance","#0f0a")],fog:[JX("final","#f3f3f3",void 0,!0)]}},tQ=function(e,t){return qX(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){$X(e,t,n[t])}))}return e}({},XX),{time:e,value:t})},nQ=function(e){return(0,Y.useMemo)((function(){if(e&&e.seasons){var t,n,r,i,o,a=eQ();return a.temperature[0].keys=(null===(t=e.curves)||void 0===t?void 0:t.temperature.keys)||[],a.temperature[0].keys.forEach((function(e){return e.time=e.time/12})),a.fog[0].keys=(null===(n=e.curves)||void 0===n?void 0:n.fog.keys)||[],a.fog[0].keys.forEach((function(e){e.time=e.time/12,e.value=100*e.value})),a.cloudiness[0].keys=(null===(r=e.curves)||void 0===r?void 0:r.cloudiness.keys)||[],a.cloudiness[0].keys.forEach((function(e){e.time=e.time/12,e.value=100*e.value})),a.precipitation[0].keys=(null===(i=e.curves)||void 0===i?void 0:i.precipitation.keys)||[],a.precipitation[0].keys.forEach((function(e){e.time=e.time/12,e.value=100*e.value})),a.aurora[0].keys=(null===(o=e.curves)||void 0===o?void 0:o.aurora.keys)||[],a.aurora[0].keys.forEach((function(e){e.time=e.time/12,e.value=100*e.value})),e.seasons.reduce((function(t,n,r){var i=((r<e.seasons.length-1?e.seasons[r+1].startTime:1+e.seasons[0].startTime)+n.startTime)/2;return t.temperature[1].keys.push(tQ(i,n.tempNightDay.y)),t.temperature[2].keys.push(tQ(i,n.tempNightDay.y+n.tempDeviationNightDay.y)),t.temperature[3].keys.push(tQ(i,n.tempNightDay.x)),t.temperature[4].keys.push(tQ(i,n.tempNightDay.x+n.tempDeviationNightDay.x)),t.cloudiness[1].keys.push(tQ(i,n.cloudAmount)),t.cloudiness[2].keys.push(tQ(i,n.cloudAmount+n.cloudAmountDeviation)),t.cloudiness[3].keys.push(tQ(i,n.cloudChance)),t.cloudiness[4].keys.push(tQ(i,100*n.turbulence)),t.precipitation[1].keys.push(tQ(i,n.precipitationAmount)),t.precipitation[2].keys.push(tQ(i,n.precipitationAmount+n.precipitationAmountDeviation)),t.precipitation[3].keys.push(tQ(i,n.precipitationChance)),t.precipitation[4].keys.push(tQ(i,100*n.turbulence)),t.aurora[1].keys.push(tQ(i,100*n.auroraAmount)),t.aurora[2].keys.push(tQ(i,n.auroraChance)),t}),a)}return eQ()}),[e])};function rQ(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function iQ(e,t,n,r,i,o,a){try{var s=e[o](a),l=s.value}catch(e){return void n(e)}s.done?t(l):Promise.resolve(l).then(r,i)}function oQ(e){return function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){iQ(o,r,i,a,s,"next",e)}function s(e){iQ(o,r,i,a,s,"throw",e)}a(void 0)}))}}function aQ(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function sQ(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){aQ(e,t,n[t])}))}return e}function lQ(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function cQ(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return rQ(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return rQ(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/editor/widgets/fields/seasons-field/utils.ts",{get getSeasonProperty(){return ZX},set getSeasonProperty(e){ZX=e},get makeSeasonPropertyCurve(){return JX},set makeSeasonPropertyCurve(e){JX=e},get useCurvesForSeasonsData(){return nQ},set useCurvesForSeasonsData(e){nQ=e}});var uQ=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}},dQ=function(e){var t=e.props,n=nQ(t),r=function(e){var t=e.parent,n=e.path,r=e.props,i=(0,Y.useMemo)((function(){var e,i=HR(t.path,n);return{onAddKeyframe:(e=oQ((function(e){return uQ(this,(function(n){return[2,aD(t.group,i,e)]}))})),function(t){return e.apply(this,arguments)}),onRemoveKeyframe:function(e){lD(t.group,i,e)},onUpdateSeasonProperty:function(){var e=oQ((function(e,n,o,a){var s,l,c,u,d,f,m,g,h,p,v;return uQ(this,(function(b){return console.log("update season"),s=r.seasons,l=cQ(ZX(n,o).split("."),2),c=l[0],u=l[1],d=s[e],f=a.value,c.includes("Deviation")&&(m=d[c.replace("Deviation","")],f-=u&&"object"==typeof m?m[u]:m),"turbulence"!==c&&"auroraAmount"!==c||(f/=100),g=e<s.length-1?s[e+1].startTime:1+s[0].startTime,h=(g+d.startTime)/2,console.log("seasonIndex "+e),console.log(f+" "+u),v=lQ(sQ({},d),(aQ(p={},c,u?lQ(sQ({},d[c]),aQ({},u,f)):f),aQ(p,"startTime",d.startTime+(a.time-h)),p)),[2,sD(t.group,i,v)]}))}));return function(t,n,r,i){return e.apply(this,arguments)}}()}}),[t.group,t.path,n,r]);return i}(e);return(0,z.jsx)("div",{children:(0,z.jsx)(YX,lQ(sQ({},e.props,r),{value:n,seasons:t.seasons,label:(0,z.jsx)(ku,{value:Ac("Climate settings")})}))})};oe.add("game-ui/editor/widgets/fields/seasons-field/seasons-field.bound.tsx",{get updateSeasonProperty(){return updateSeasonProperty},set updateSeasonProperty(e){updateSeasonProperty=e},get BoundSeasonsField(){return dQ},set BoundSeasonsField(e){dQ=e}});var fQ=function(e){var t=e.label,n=e.value,r=e.disabled,i=e.onChange;return(0,z.jsx)(BB,{disabled:r,children:(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)("div",{className:UB.label,children:t}),(0,z.jsx)(fv,{checked:n,disabled:r,onChange:i,className:UB.toggle})]})})};function mQ(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}oe.add("game-ui/editor/widgets/fields/toggle-field.tsx",{get ToggleField(){return fQ},set ToggleField(e){fQ=e}});var gQ=function(e){return(0,z.jsx)(hQ,function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){mQ(e,t,n[t])}))}return e}({},e.props))},hQ=function(e){var t=e.value;return e.hidden?null:(0,z.jsx)(GB,{children:(0,z.jsx)(ku,{value:t})})};oe.add("game-ui/editor/widgets/fields/value-field.tsx",{get BoundLocalizedValueField(){return gQ},set BoundLocalizedValueField(e){gQ=e}});let pQ={"popup-content":"popup-content_QLL",popupContent:"popup-content_QLL","popup-content-scrollable":"popup-content-scrollable_clr",popupContentScrollable:"popup-content-scrollable_clr"};oe.add("game-ui/editor/widgets/filter-menu/filter-menu.module.scss",{get classes(){return pQ},set classes(e){Object.assign(pQ,e)}});const vQ=pQ;function bQ(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function yQ(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return bQ(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return bQ(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var xQ=function(e){var t=e.parent,n=e.path,r=e.props,i=uD(t,n),o=RR(pB,i),a=RR(vB,i);return(0,z.jsx)(_Q,{availableFilters:r.availableFilters,activeFilters:r.activeFilters,onToggleFilter:o,onClear:a})},_Q=function(e){var t=e.availableFilters,n=e.activeFilters,r=e.onToggleFilter,i=e.onClear,o=yQ((0,Y.useState)(!1),2),a=o[0],s=o[1],l=OQ(t,n),c=(0,Y.useMemo)((function(){return n.length>0?n.join(", "):(0,z.jsx)(qc.Common.NONE,{})}),[n]);return(0,z.jsx)(MX,{label:(0,z.jsx)(qc.Editor.FILTERS,{}),value:c,expanded:a,onExpandedChange:s,children:(0,z.jsxs)("div",{className:vQ.popupContent,children:[(0,z.jsx)(gE,{className:vQ.popupContentScrollable,children:l.map((function(e){return(0,z.jsx)(jQ,{filter:e.filter,active:e.active,onToggle:r},e.filter)}))}),(0,z.jsx)(kB,{onSelect:i,children:(0,z.jsx)(qc.Editor.CLEAR_ALL,{})})]})})},jQ=function(e){var t=e.filter,n=e.active,r=e.onToggle,i=(0,Y.useCallback)((function(){return r(t,!n)}),[n,t,r]);return(0,z.jsx)(fQ,{label:t,value:n,onChange:i})},OQ=function(e,t){return(0,Y.useMemo)((function(){return e.map((function(e){return{filter:e,active:t.includes(e)}}))}),[t,e])};oe.add("game-ui/editor/widgets/filter-menu/filter-menu.tsx",{get BoundFilterMenu(){return xQ},set BoundFilterMenu(e){xQ=e},get FilterMenu(){return _Q},set FilterMenu(e){_Q=e}});let EQ={"virtual-list":"virtual-list_Amj",virtualList:"virtual-list_Amj",vertical:"vertical_RRQ",horizontal:"horizontal_QEG"};oe.add("game-ui/common/scrolling/virtual-list/virtual-list.module.scss",{get classes(){return EQ},set classes(e){Object.assign(EQ,e)}});const SQ=EQ;function TQ(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function IQ(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return TQ(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return TQ(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var wQ=Y.forwardRef((function(e,t){var n=e.sizeProvider,r=e.direction,i=void 0===r?"vertical":r,o=e.controller,a=e.smooth,s=e.className,l=e.style,c=e.renderItem,u=e.onRenderedRangeChange,d=(0,Y.useRef)(null),f=Hd(t,d),m=PQ(d,n,i,void 0,c,u),g=m.list,h=m.onScroll,p="vertical"===i;return(0,z.jsx)(gE,{ref:f,vertical:p,horizontal:!p,controller:o,smooth:a,className:s,style:l,onScroll:h,children:g})}));function PQ(e,t,n,r,i,o){var a=Kf(e,Vf),s=Xf(),l=null!=a?a:s,c="vertical"===n,u=c?l.y:l.x,d=IQ((0,Y.useState)(0),2),f=d[0],m=d[1],g=(0,Y.useMemo)((function(){return t.getRenderedRange(f,u)}),[u,f,t]);(0,Y.useEffect)((function(){null!=o&&o(g.startIndex,g.endIndex)}),[o,g.endIndex,g.startIndex]);var h=(0,Y.useMemo)((function(){return"".concat(t.getTotalSize(),"px")}),[t]),p=(0,Y.useMemo)((function(){return"".concat(g.offset,"px")}),[g.offset]),v=(0,Y.useCallback)((function(){e.current&&m(c?e.current.scrollTop:e.current.scrollLeft)}),[e,c]);(0,Y.useEffect)((function(){return v()}),[v]),(0,Y.useEffect)((function(){var e=0;return function t(){v(),e=window.requestAnimationFrame(t)}(),function(){return window.cancelAnimationFrame(e)}}),[v]);var b=(0,Y.useMemo)((function(){for(var e=new Array(g.endIndex-g.startIndex),t=0;t<e.length;t++)e[t]=i(g.startIndex+t,t);return e}),[g.endIndex,g.startIndex,i]),y=(0,Y.useMemo)((function(){return(0,z.jsx)("div",{className:_d()(SQ.virtualList,r,c?SQ.vertical:SQ.horizontal),style:c?{height:h,paddingTop:p}:{width:h,paddingLeft:p},children:b})}),[c,h,p,b,r]);return(0,Y.useMemo)((function(){return{list:y,onScroll:v}}),[y,v])}oe.add("game-ui/common/scrolling/virtual-list/virtual-list.tsx",{get VirtualList(){return wQ},set VirtualList(e){wQ=e},get useVirtualList(){return PQ},set useVirtualList(e){PQ=e}});var CQ={getRenderedRange:function(){return{offset:0,size:0,startIndex:0,endIndex:0}},getTotalSize:function(){return 0}};function NQ(e,t,n){return(0,Y.useMemo)((function(){return{getRenderedRange:function(r,i){var o=of(Math.floor(r/e)-n,0,t),a=of(Math.ceil((r+i)/e)+n,o,t);return{offset:e*o,startIndex:o,endIndex:a}},getTotalSize:function(){return e*t}}}),[t,e,n])}function AQ(e,t,n){return(0,Y.useMemo)((function(){var r=function(e,t){for(var n=[],r=0,i=0;i<t;++i){var o=r;r+=e(i),n.push({x:o,y:r})}return n}((function(n){return e(t[n],n)}),t.length);return{getRenderedRange:function(e,i){var o=of(LQ(r,e)-n,0,t.length),a=of(LQ(r,i+e)+n,o,t.length);return{offset:r[o].x,startIndex:o,endIndex:a}},getTotalSize:function(){return r[r.length-1].y}}}),[t,n,e])}function LQ(e,t){for(var n=e.length-1;n>=0;--n)if(t>=e[n].x)return n;return 0}oe.add("game-ui/common/scrolling/virtual-list/virtual-list-size-provider.ts",{get emptySizeProvider(){return CQ},set emptySizeProvider(e){CQ=e},get useUniformSizeProvider(){return NQ},set useUniformSizeProvider(e){NQ=e},get useArraySizeProvider(){return AQ},set useArraySizeProvider(e){AQ=e}});let MQ={listItemHeight:"24rem",imageSize:"20rem",dirArrowSrc:"Media/Glyphs/ThickStrokeArrowRight.svg","hierarchy-menu":"hierarchy-menu_Tm_ editor-widget_QQl",hierarchyMenu:"hierarchy-menu_Tm_ editor-widget_QQl",item:"item_qWj","list-item":"list-item_eZG item_qWj",listItem:"list-item_eZG item_qWj",image:"image_IPH",name:"name_Mx8","icon-container":"icon-container_OHi",iconContainer:"icon-container_OHi","arrow-expanded":"arrow-expanded_Df1",arrowExpanded:"arrow-expanded_Df1","placeholder-margin":"placeholder-margin_S8d",placeholderMargin:"placeholder-margin_S8d","single-selection":"single-selection_s_l",singleSelection:"single-selection_s_l"};oe.add("game-ui/editor/widgets/hierarchy-menu/hierarchy-menu.module.scss",{get classes(){return MQ},set classes(e){Object.assign(MQ,e)}});const kQ=MQ;function RQ(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function DQ(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){RQ(e,t,n[t])}))}return e}function FQ(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var UQ,GQ=function(e){var t=e.parent,n=e.path,r=e.props,i=uD(t,n),o=RR(bB,i),a=RR(yB,i),s=RR(xB,i);return(0,z.jsx)(BQ,FQ(DQ({},r),{onSetExpanded:o,onSelect:a,onRenderedRangeChange:s}))},BQ=function(e){var t=e.viewport,n=e.flex,r=e.visibleCount,i=e.onSelect,o=e.onSetExpanded,a=e.singleSelection,s=e.onRenderedRangeChange,l=NQ(YO(kQ.listItemHeight),r,10),c=CV(n),u=(0,Y.useCallback)((function(e,n){if(n<0||n>=t.length)return null;var r=t[n];return(0,z.jsx)(VQ,FQ(DQ({},r),{viewportIndex:n,singleSelection:a,onSelect:i,onSetExpanded:o}),e)}),[i,o,a,t]);return(0,z.jsx)(wQ,{style:c,className:kQ.hierarchyMenu,sizeProvider:l,renderItem:u,onRenderedRangeChange:s})};!function(e){e[e.None=0]="None",e[e.Icon=1]="Icon",e[e.ExpandArrow=2]="ExpandArrow"}(UQ||(UQ={}));var VQ=function(e){var t=e.displayName,n=e.icon,r=e.tooltip,i=e.level,o=e.selectable,a=e.viewportIndex,s=e.selected,l=e.expandable,c=e.onSelect,u=e.expanded,d=e.onSetExpanded,f=e.singleSelection,m=(0,Y.useCallback)((function(){l&&d&&d(a,!u)}),[l,u,d,a]),g=(0,Y.useCallback)((function(){!o||!c||f&&s||c(a,!s)}),[o,c,f,s,a]),h=l?UQ.ExpandArrow:Zs(n)?UQ.None:UQ.Icon,p=(0,Y.useMemo)((function(){return RQ({},u?"Collapse Group":"Expand Group",l?m:null)}),[u,l,m]),v=(0,z.jsxs)(Qp,{style:{"--level":i},className:_d()(kQ.listItem,f&&kQ.singleSelection),onSelect:g,selected:s,children:[(0,z.jsx)("div",{className:_d()(kQ.name,h===UQ.None&&kQ.placeholderMargin),children:(0,z.jsx)(ku,{value:t})}),h===UQ.Icon?(0,z.jsx)("img",{src:n,className:kQ.image}):null,h===UQ.ExpandArrow?(0,z.jsx)(HQ,{expanded:u,onSelect:m}):null]});return(0,z.jsx)(rp,{actions:p,children:null!=r?(0,z.jsx)(jh,{tooltip:(0,z.jsx)(ku,{value:r}),children:v}):v})},HQ=function(e){var t=e.expanded,n=e.onSelect;return(0,z.jsx)("div",{className:kQ.iconContainer,children:(0,z.jsx)("img",{src:kQ.dirArrowSrc,className:_d()(kQ.image,t&&kQ.arrowExpanded),onClick:n})})};oe.add("game-ui/editor/widgets/hierarchy-menu/hierarchy-menu.tsx",{get BoundHierarchyMenu(){return GQ},set BoundHierarchyMenu(e){GQ=e},get HierarchyMenu(){return BQ},set HierarchyMenu(e){BQ=e}});let KQ={"image-field":"image-field_PPC",imageField:"image-field_PPC",label:"label_dKE","image-container":"image-container_jpQ",imageContainer:"image-container_jpQ",image:"image_xoS"};oe.add("game-ui/editor/widgets/image/image-field.module.scss",{get classes(){return KQ},set classes(e){Object.assign(KQ,e)}});const WQ=KQ;function zQ(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var YQ=function(e){return(0,z.jsx)($Q,function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){zQ(e,t,n[t])}))}return e}({},e.props))},$Q=function(e){var t=e.uri,n=e.label,r=e.tooltip;return(0,z.jsx)(jh,{tooltip:r&&(0,z.jsx)(ku,{value:r}),children:(0,z.jsxs)("div",{className:WQ.imageField,children:[(0,z.jsx)("div",{className:WQ.label,children:(0,z.jsx)(ku,{value:n})}),(0,z.jsx)("div",{className:WQ.imageContainer,children:(0,z.jsx)("img",{src:t,className:WQ.image})})]})})};oe.add("game-ui/editor/widgets/image/image-field.tsx",{get BoundImageField(){return YQ},set BoundImageField(e){YQ=e},get ImageField(){return $Q},set ImageField(e){$Q=e}});var qQ=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this._callback=null}var t=e.prototype;return t.scrollTo=function(e,t){null!=this._callback&&this._callback.scrollTo(e,t)},t.scrollBy=function(e,t){null!=this._callback&&this._callback.scrollBy(e,t)},t.smoothScrollTo=function(e,t){null!=this._callback&&this._callback.smoothScrollTo(e,t)},t.scrollIntoView=function(e){null!=this._callback&&this._callback.scrollIntoView(e)},t._attachCallback=function(e){null==this._callback?this._callback=e:console.warn("Scroll controller callback already attached!")},t._detachCallback=function(e){this._callback===e?this._callback=null:console.warn("Scroll controller callback not attached!")},e}();function XQ(){return(0,Y.useMemo)((function(){return new qQ}),[])}function QQ(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function ZQ(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return QQ(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return QQ(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function JQ(e,t){var n=ZQ((0,Y.useState)(!1),2),r=n[0],i=n[1];return(0,Y.useEffect)((function(){var t=function(t){t.button===e&&i(!1)};return window.addEventListener("mouseup",t),function(){return window.removeEventListener("mouseup",t)}}),[e]),(0,Y.useMemo)((function(){return null!=t?{mouseDown:r,onMouseDown:function(t){t.button===e&&i(!0)},onMouseUp:function(n){r&&n.button===e&&(i(!1),t(n))}}:{mouseDown:r}}),[e,t,r])}oe.add("game-ui/common/scrolling/scroll-controller.ts",{get ScrollController(){return qQ},set ScrollController(e){qQ=e}}),oe.add("game-ui/common/hooks/use-scroll-controller.tsx",{get useScrollController(){return XQ},set useScrollController(e){XQ=e}}),oe.add("game-ui/common/hooks/use-secondary-click.tsx",{get useSecondaryClick(){return JQ},set useSecondaryClick(e){JQ=e}});let eZ={listItemHeight:"24rem",horizontalPadding:"26rem",defaultImageSrc:"Media/Editor/DefaultObject.svg",dirArrowSrc:"Media/Glyphs/ThickStrokeArrowRight.svg","item-picker":"item-picker_ORP editor-widget_QQl",itemPicker:"item-picker_ORP editor-widget_QQl",item:"item_H00","grid-mode":"grid-mode_bUv",gridMode:"grid-mode_bUv","favorite-icon":"favorite-icon_bgV",favoriteIcon:"favorite-icon_bgV",favorite:"favorite_pLV","list-item":"list-item_qRg item_H00",listItem:"list-item_qRg item_H00",image:"image_scT",name:"name_u39","dir-arrow":"dir-arrow_DVY",dirArrow:"dir-arrow_DVY","grid-row":"grid-row_Uxw",gridRow:"grid-row_Uxw","grid-item":"grid-item_qEa item_H00",gridItem:"grid-item_qEa item_H00"};oe.add("game-ui/editor/widgets/item-picker/item-picker.module.scss",{get classes(){return eZ},set classes(e){Object.assign(eZ,e)}});const tZ=eZ;function nZ(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function rZ(e){return function(e){if(Array.isArray(e))return nZ(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return nZ(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return nZ(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var iZ=function(e){var t=e.parent,n=e.path,r=e.props,i=uD(t,n),o=(0,Y.useMemo)((function(){return{length:r.length,get:function(e){var t=e-r.visibleStartIndex;return t>=0&&t<r.visibleItems.length?r.visibleItems[t]:null}}}),[r.length,r.visibleItems,r.visibleStartIndex]),a=(0,Y.useCallback)((function(e,t){var n=e-e%64,o=Math.min(t-t%64+64,r.length);cB(i,n,o)}),[i,r.length]),s=RR(uB,i),l=(0,Y.useCallback)((function(e,t){dB(i,e,t),e===r.selectedIndex&&c.current&&c.current.scrollToSelected()}),[i,r.selectedIndex]),c=(0,Y.useRef)(null),u=(0,Y.useContext)(XO);(0,Y.useLayoutEffect)((function(){u&&c.current&&c.current.scrollToSelected()}),[r.columnCount,r.length,u]);var d=CV(r.flex);return(0,z.jsx)(oZ,{ref:c,selectedIndex:r.selectedIndex,columnCount:r.columnCount,hasImages:r.hasImages,data:o,style:d,onRenderedRangeChange:a,onSelect:s,onToggleFavorite:r.hasFavorites?l:void 0,selectOnFocus:r.selectOnFocus})},oZ=Y.forwardRef((function(e,t){var n=e.focusKey,r=e.selectedIndex,i=e.columnCount,o=e.hasImages,a=void 0===o||o,s=e.data,l=e.className,c=e.style,u=e.onRenderedRangeChange,d=e.onSelect,f=e.onToggleFavorite,m=e.selectOnFocus,g=void 0===m||m,h=(0,Y.useRef)(null),p=XQ(),v=(0,Y.useCallback)((function(e){g&&"number"==typeof e&&d(e)}),[d,g]),b=1===i,y=YO(tZ.listItemHeight),x=NQ(y,s.length,2),_=(0,Y.useCallback)((function(e,t){var n,i,o,l,c=s.get(e);return(0,z.jsx)(aZ,{index:e,name:null!=c?(0,z.jsx)(ku,{value:c.displayName}):" ",image:null!==(n=null==c?void 0:c.image)&&void 0!==n?n:null,hasImage:a,directory:null!==(i=null==c?void 0:c.directory)&&void 0!==i&&i,favorite:null!==(o=null==c?void 0:c.favorite)&&void 0!==o&&o,selected:r===e,className:tZ.listItem,onSelect:d,onToggleFavorite:f,tooltip:null!==(l=c&&c.tooltip&&(0,z.jsx)(ku,{value:c.tooltip}))&&void 0!==l?l:null,listMode:!0},t)}),[s,a,r,d,f]),j=Kf(h),O=YO(tZ.horizontalPadding),E=(null!=j?j.x-O:i)/i,S=null!=j?Math.ceil(s.length/i):0,T=NQ(E,S,2),I=(0,Y.useCallback)((function(e,t){var n=e*i,o=Math.min((e+1)*i,s.length);return(0,z.jsx)("div",{className:tZ.gridRow,style:{"--itemSize":E+"px"},children:rZ(Array(o-n).keys()).map((function(e){var t,i,o,l,c=n+e,u=s.get(c);return(0,z.jsx)(aZ,{index:c,name:null!=u?(0,z.jsx)(ku,{value:u.displayName}):" ",image:null!==(t=null==u?void 0:u.image)&&void 0!==t?t:null,hasImage:a,directory:null!==(i=null==u?void 0:u.directory)&&void 0!==i&&i,favorite:null!==(o=null==u?void 0:u.favorite)&&void 0!==o&&o,selected:r===c,className:tZ.gridItem,onSelect:d,onToggleFavorite:f,tooltip:null!==(l=u&&u.tooltip&&(0,z.jsx)(ku,{value:u.tooltip}))&&void 0!==l?l:null,listMode:!1},e)}))},t)}),[i,s,E,a,r,d,f]),w=(0,Y.useCallback)((function(e,t){u&&u(e*i,t*i)}),[i,u]),P=(0,Y.useRef)(0);P.current=-1===r||null===j?0:b?y*(r+.5)-j.y/2:E*(Math.floor(r/i)+.5)-j.y/2;var C=(0,Y.useRef)(0);return(0,Y.useImperativeHandle)(t,(function(){return{scrollToSelected:function(){window.cancelAnimationFrame(C.current),p.scrollTo(0,P.current),C.current=window.requestAnimationFrame((function(){p.scrollTo(0,P.current),C.current=window.requestAnimationFrame((function(){p.scrollTo(0,P.current)}))}))}}})),(0,Y.useEffect)((function(){return function(){return window.cancelAnimationFrame(C.current)}}),[]),(0,z.jsx)(Ip,{focusKey:n,focused:r,onChange:v,children:(0,z.jsx)(wQ,{ref:h,controller:p,smooth:!1,className:_d()(tZ.itemPicker,l),style:c,sizeProvider:null!=j?b?x:T:CQ,renderItem:b?_:I,onRenderedRangeChange:w})})})),aZ=function(e){var t=e.index,n=e.name,r=e.image,i=e.hasImage,o=e.directory,a=e.favorite,s=e.selected,l=e.className,c=e.onSelect,u=e.onToggleFavorite,d=e.tooltip,f=e.listMode,m=(0,Y.useCallback)((function(){return c(t)}),[t,c]),g=(0,Y.useMemo)((function(){return null!=u?function(){u(t,!a),kp(Lp.selectToggle)}:void 0}),[t,a,u]),h=JQ(2,g),p=h.onMouseUp,v=h.onMouseDown;return(0,z.jsx)(jh,{tooltip:d,children:(0,z.jsxs)(Qp,{focusKey:t,selected:s,className:_d()(l,a&&tZ.favorite),onClick:m,onMouseDown:v,onMouseUp:p,children:[i&&(0,z.jsx)("img",{src:null!=r?r:tZ.defaultImageSrc,className:tZ.image}),(0,z.jsx)("div",{className:tZ.name,children:n}),o&&(0,z.jsx)(tb,{src:tZ.dirArrowSrc,className:tZ.dirArrow}),null!=u&&(0,z.jsx)(tb,{className:_d()(l,!f&&tZ.gridMode,tZ.favoriteIcon,a&&tZ.favorite),onClick:g,src:a?"Media/Glyphs/StarFilled.svg":"Media/Glyphs/StarOutline.svg"})]})})};oe.add("game-ui/editor/widgets/item-picker/item-picker.tsx",{get BoundItemPicker(){return iZ},set BoundItemPicker(e){iZ=e},get ItemPicker(){return oZ},set ItemPicker(e){oZ=e}});let sZ={"item-picker-footer":"item-picker-footer_Hi4 editor-widget_QQl",itemPickerFooter:"item-picker-footer_Hi4 editor-widget_QQl",summary:"summary_gnF",slider:"slider_iLE"};oe.add("game-ui/editor/widgets/item-picker-footer/item-picker-footer.module.scss",{get classes(){return sZ},set classes(e){Object.assign(sZ,e)}});const lZ=sZ;var cZ=function(e){var t=e.parent,n=e.path,r=e.props,i=RR(YR,uD(t,n));return(0,z.jsx)(uZ,{length:r.length,columnCount:r.columnCount,onColumnCountChange:i})},uZ=function(e){var t=e.length,n=e.columnCount,r=e.onColumnCountChange,i=(0,Y.useCallback)((function(e){return r(e<=10?e:1)}),[r]);return(0,z.jsxs)("div",{className:lZ.itemPickerFooter,children:[(0,z.jsx)("div",{className:lZ.summary,children:(0,z.jsx)(qc.Editor.ELEMENT_COUNT,{COUNT:t.toString()})}),(0,z.jsx)(oF,{value:1===n?11:n,start:11,end:4,theme:v$,className:_d()(v$.compact,lZ.slider),valueTransformer:sF,onChange:i})]})};oe.add("game-ui/editor/widgets/item-picker-footer/item-picker-footer.tsx",{get BoundItemPickerFooter(){return cZ},set BoundItemPickerFooter(e){cZ=e},get ItemPickerFooter(){return uZ},set ItemPickerFooter(e){uZ=e}});let dZ={summary:"summary_sOH",section:"section_KBF",controls:"controls_kKZ",control:"control_p7u",children:"children_oyd section_KBF","list-item":"list-item_zT4",listItem:"list-item_zT4",header:"header_jkI",label:"label_Mi4",toggle:"toggle_IOi",action:"action_AoQ","toggle-label":"toggle-label_UK9",toggleLabel:"toggle-label_UK9"};oe.add("game-ui/editor/widgets/list/list.module.scss",{get classes(){return dZ},set classes(e){Object.assign(dZ,e)}});const fZ=dZ;function mZ(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function gZ(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){mZ(e,t,n[t])}))}return e}function hZ(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var pZ=function(e){var t=e.parent,n=e.path,r=e.props,i=e.children,o=uD(t,n),a=RR(XR,o),s=RR(eD,o),l=RR($R,o),c=RR(tD,o);return(0,z.jsx)(_Z,{expanded:r.expanded,label:(0,z.jsx)(ku,{value:r.displayName}),length:r.length,currentPageIndex:r.currentPageIndex,pageCount:r.pageCount,onAddItem:r.resizable?a:void 0,onClear:r.resizable?s:void 0,onExpandedChange:l,onCurrentPageChange:c,disabled:r.disabled,children:i.map((function(e,t){return e.props.__Type===FR.ExpandableGroup?(0,z.jsx)(bZ,{parent:o,index:r.childStartIndex+t,length:r.length,resizable:r.resizable,sortable:r.sortable,data:e,disabled:r.disabled},r.childStartIndex+t):(0,z.jsx)(vZ,{parent:o,index:r.childStartIndex+t,length:r.length,resizable:r.resizable,sortable:r.sortable,data:e,disabled:r.disabled},r.childStartIndex+t)}))})},vZ=function(e){var t=e.parent,n=e.index,r=e.length,i=e.resizable,o=e.sortable,a=e.data,s=e.disabled,l=(0,Y.useContext)(ED),c=yZ(t,n,o,i);return(0,z.jsx)(jZ,hZ(gZ({focusKey:n,first:0===n,last:n===r-1},c),{onExpandedChange:void 0,disabled:s,children:(0,z.jsx)(jD,{parent:t,components:l,data:a})}))},bZ=function(e){var t=e.parent,n=e.index,r=e.length,i=e.resizable,o=e.sortable,a=e.data,s=e.disabled,l=yZ(t,n,o,i),c=uD(t,a.path),u=(0,Y.useContext)(ED),d=RR($R,c);return(0,z.jsx)(jZ,hZ(gZ({focusKey:n,label:(0,z.jsx)(ku,{value:a.props.displayName}),first:0===n,last:n===r-1,expanded:a.props.expanded},l),{onExpandedChange:d,disabled:s,children:(0,z.jsx)(OD,{parent:c,components:u,data:a.children})}))};function yZ(e,t,n,r){return(0,Y.useMemo)((function(){return{onMoveUp:n?function(){return ZR(e,t,t-1)}:void 0,onMoveDown:n?function(){return ZR(e,t,t+1)}:void 0,onDuplicate:r?function(){return QR(e,t)}:void 0,onDelete:r?function(){return JR(e,t)}:void 0}}),[e,t,n,r])}var xZ=function(e){var t=e.label,n=e.disabled,r=e.children,i=e.onAddItem,o=e.onClear,a=Y.Children.count(r);return(0,z.jsxs)(GB,{disabled:n,children:[(0,z.jsxs)("div",{className:UB.row,children:[(0,z.jsx)("div",{className:UB.label,children:t}),(0,z.jsx)("div",{className:fZ.summary,children:(0,z.jsx)(qc.Editor.LIST_COUNT,{COUNT:(0,z.jsx)(su,{value:a,unit:$c.Integer})})})]}),a>0&&(0,z.jsx)("div",{className:fZ.children,children:r}),(null!=i||null!=o)&&(0,z.jsxs)("div",{className:fZ.controls,children:[null!=i&&(0,z.jsx)(Qp,{disabled:n,theme:SB,onSelect:i,children:(0,z.jsx)(qc.Editor.LIST_ADD_ITEM,{})}),null!=o&&(0,z.jsx)(Qp,{disabled:n||0===a,theme:SB,onSelect:o,children:(0,z.jsx)(qc.Editor.CLEAR,{})})]})]})},_Z=function(e){var t=e.label,n=e.expanded,r=e.length,i=e.currentPageIndex,o=e.pageCount,a=e.disabled,s=e.children,l=e.onAddItem,c=e.onClear,u=e.onExpandedChange,d=e.onCurrentPageChange,f=(0,Y.useCallback)((function(){return d(i-1)}),[i,d]),m=(0,Y.useCallback)((function(){return d(i+1)}),[i,d]),g=n&&o>1?(0,z.jsx)(qc.Editor.LIST_PAGE_COUNT,{PAGE:Bu(i+1),PAGE_COUNT:Bu(o),COUNT:Bu(r)}):(0,z.jsx)(qc.Editor.LIST_COUNT,{COUNT:Bu(r)});return(0,z.jsxs)(VB,{label:t,summary:g,expanded:n,disabled:a,onExpandedChange:u,children:[o>1&&(0,z.jsxs)("div",{className:fZ.controls,children:[(0,z.jsx)(Qp,{disabled:0===i,theme:SB,className:fZ.control,onSelect:f,children:(0,z.jsx)(qc.Editor.PREVIOUS_PAGE,{})}),(0,z.jsx)(Qp,{disabled:i>=o-1,theme:SB,className:fZ.control,onSelect:m,children:(0,z.jsx)(qc.Editor.NEXT_PAGE,{})})]}),r>0&&(0,z.jsx)("div",{className:fZ.children,children:s}),(null!=l||null!=c)&&(0,z.jsxs)("div",{className:fZ.controls,children:[null!=l&&(0,z.jsx)(Qp,{disabled:a,theme:SB,className:fZ.control,onSelect:l,children:(0,z.jsx)(qc.Editor.LIST_ADD_ITEM,{})}),null!=c&&(0,z.jsx)(Qp,{disabled:a||0===r,theme:SB,className:fZ.control,onSelect:c,children:(0,z.jsx)(qc.Editor.CLEAR,{})})]})]})},jZ=function(e){var t=e.focusKey,n=e.label,r=e.disabled,i=e.first,o=e.last,a=e.expanded,s=void 0===a||a,l=e.children,c=e.onMoveUp,u=e.onMoveDown,d=e.onDuplicate,f=e.onDelete,m=e.onExpandedChange,g=null!=m,h=(0,Y.useCallback)((function(){null!=m&&m(!s)}),[s,m]);return(0,z.jsxs)("div",{className:fZ.listItem,children:[(0,z.jsx)("div",{className:fZ.header,children:(0,z.jsxs)(Ap,{focusKey:t,direction:gp.Horizontal,children:[g?(0,z.jsx)(lb,{tinted:!0,src:s?"Media/Glyphs/ThickStrokeArrowDown.svg":"Media/Glyphs/ThickStrokeArrowRight.svg",className:_d()(fZ.toggle,s&&fZ.expanded),onSelect:h,children:(0,z.jsx)("div",{className:fZ.toggleLabel,children:n})}):(0,z.jsx)("div",{className:fZ.label,children:n}),c&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Editor.LIST_ITEM_MOVE_UP,{}),children:(0,z.jsx)(lb,{tinted:!0,src:"Media/Glyphs/StrokeArrowUp.svg",disabled:i||r,className:fZ.action,onSelect:c})}),u&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Editor.LIST_ITEM_MOVE_DOWN,{}),children:(0,z.jsx)(lb,{tinted:!0,src:"Media/Glyphs/StrokeArrowDown.svg",disabled:o||r,className:fZ.action,onSelect:u})}),d&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Editor.LIST_ITEM_DUPLICATE,{}),children:(0,z.jsx)(lb,{tinted:!0,src:"Media/Glyphs/Copy.svg",disabled:r,className:fZ.action,onSelect:d})}),f&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Editor.LIST_ITEM_DELETE,{}),children:(0,z.jsx)(lb,{tinted:!0,src:"Media/Glyphs/Trash.svg",disabled:r,className:fZ.action,onSelect:f})})]})}),l]})};oe.add("game-ui/editor/widgets/list/list.tsx",{get BoundPagedList(){return pZ},set BoundPagedList(e){pZ=e},get EditorList(){return xZ},set EditorList(e){xZ=e},get EditorPagedList(){return _Z},set EditorPagedList(e){_Z=e},get EditorListItem(){return jZ},set EditorListItem(e){jZ=e}});let OZ={"dropdown-toggle":"dropdown-toggle_ODx dropdown-toggle_prl",dropdownToggle:"dropdown-toggle_ODx dropdown-toggle_prl",indicator:"indicator_JII","dropdown-menu":"dropdown-menu_xq2 dropdown-menu_Swd",dropdownMenu:"dropdown-menu_xq2 dropdown-menu_Swd","dropdown-item":"dropdown-item_R_l undefined",dropdownItem:"dropdown-item_R_l undefined"};oe.add("game-ui/game/themes/game-dropdown.module.scss",{get classes(){return OZ},set classes(e){Object.assign(OZ,e)}});const EZ=OZ;let SZ={dropdown:"dropdown_zWC",item:"item_Bmu",thumb:"thumb_eC2",label:"label_jXx"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/route-sections/select-vehicles-section.module.scss",{get classes(){return SZ},set classes(e){Object.assign(SZ,e)}});const TZ=SZ;function IZ(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var wZ=function(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){IZ(e,t,n[t])}))}return e}({},Xp),{hover:null,focus:null});function PZ(e,t){bl("SelectVehiclesSection","selectVehicles",e,t)}var CZ=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.primaryVehicle,o=e.secondaryVehicle,a=e.primaryVehicles,s=e.secondaryVehicles,l=(0,Y.useCallback)((function(e){var t;PZ(e,null!==(t=null==o?void 0:o.entity)&&void 0!==t?t:ty)}),[null==o?void 0:o.entity]),c=(0,Y.useCallback)((function(e){var t;PZ(null!==(t=null==i?void 0:i.entity)&&void 0!==t?t:ty,e)}),[null==i?void 0:i.entity]),u=BC(t,n,r,!0);return(0,z.jsxs)(qE,{disableFocus:!0,className:TZ.selectVehiclesSection,tooltip:u&&(0,z.jsx)(Fv,{text:u}),children:[(0,z.jsx)(SS,{uppercase:!0,disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.SELECT_VEHICLE,{})}),(0,z.jsx)(SE,{focusKey:Kh,theme:EZ,initialFocused:i&&qs(i.entity),content:null==a?void 0:a.map((function(e){return(0,z.jsx)(RE,{value:e.entity,focusKey:e.id,onChange:l,children:(0,z.jsx)(NZ,{vehicle:e})},qs(e.entity))})),children:(0,z.jsx)(CE,{sounds:wZ,className:TZ.dropdown,children:(0,z.jsx)(NZ,{vehicle:null!=i?i:a[0]})})}),s&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(SS,{uppercase:!0,disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.SELECT_VEHICLE_SECONDARY,{hash:"Train"})}),(0,z.jsx)(SE,{theme:EZ,initialFocused:o&&qs(o.entity),content:null==s?void 0:s.map((function(e){return(0,z.jsx)(RE,{value:e.entity,focusKey:e.id,onChange:c,children:(0,z.jsx)(NZ,{vehicle:e})},qs(e.entity))})),children:(0,z.jsx)(CE,{sounds:wZ,className:TZ.dropdown,children:(0,z.jsx)(NZ,{vehicle:null!=o?o:s[0]})})})]})]})},NZ=function(e){var t=e.vehicle;return(0,z.jsxs)("div",{className:TZ.item,children:[(0,z.jsx)("img",{src:t.thumbnail,className:TZ.thumb}),(0,z.jsxs)("div",{className:TZ.label,children:[(0,z.jsx)(qc.Assets.NAME,{hash:t.id})," "]})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/route-sections/select-vehicles-section.tsx",{get dropdownSounds(){return wZ},set dropdownSounds(e){wZ=e},get SelectVehiclesSection(){return CZ},set SelectVehiclesSection(e){CZ=e}});let AZ={left:"left_vb1",right:"right_wuq","delete-button":"delete-button_iT6",deleteButton:"delete-button_iT6",input:"input_xcv"};oe.add("game-ui/editor/widgets/localization-field/localization-field.module.scss",{get classes(){return AZ},set classes(e){Object.assign(AZ,e)}});const LZ=AZ;function MZ(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function kZ(e){return function(e){if(Array.isArray(e))return MZ(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return MZ(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return MZ(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var RZ=function(e){var t=e.parent,n=e.path,r=e.props,i=uD(t,n),o=(0,Y.useCallback)((function(e,t,n){mB(i,e,t,n)}),[i]),a=xl(Tc),s=(0,Y.useCallback)((function(e){hB(i,e)}),[i]),l=(0,Y.useCallback)((function(){gB(i)}),[i]);return(0,z.jsx)(DZ,{localization:r.localization,supportedLocales:a,onChange:o,onAdd:l,onRemove:s,placeholder:r.placeholder})},DZ=function(e){var t=e.localization,n=e.supportedLocales,r=e.onChange,i=e.onAdd,o=e.onRemove,a=e.placeholder,s=(0,Y.useMemo)((function(){return n.filter((function(e){return t.findIndex((function(t){return t.localeId===e}))<0}))}),[t,n]);return(0,z.jsxs)(GB,{children:[t.map((function(e,t){return(0,z.jsx)(FZ,{index:t,localeId:e.localeId,text:e.text,unusedLocales:s,onChange:r,onRemove:o,placeholder:a,mandatory:e.mandatory},t)})),(0,z.jsx)("div",{children:(0,z.jsx)(MB,{children:(0,z.jsx)(kB,{disabled:0===s.length,onSelect:i,children:(0,z.jsx)(qc.Editor.ADD_TRANSLATION,{})})})})]})},FZ=function(e){var t=e.index,n=e.localeId,r=e.text,i=e.unusedLocales,o=e.onChange,a=e.onRemove,s=e.placeholder,l=e.mandatory,c=(0,Y.useMemo)((function(){return[n].concat(kZ(i))}),[n,i]),u=(0,Y.useCallback)((function(e){return o(t,c[e],r)}),[t,c,o,r]),d=(0,Y.useCallback)((function(e){return o(t,n,e.target.value||"")}),[t,n,o]),f=(0,Y.useCallback)((function(){return a(t)}),[t,a]),m=(0,Y.useMemo)((function(){return c.findIndex((function(e){return e===n}))}),[n,c]);return(0,z.jsx)(BB,{className:UB.row,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)("div",{className:LZ.left,children:(0,z.jsx)(SE,{theme:DB,initialFocused:t,content:c.map((function(e,t){return(0,z.jsx)(RE,{focusKey:t,value:t,selected:m===t,onChange:u,children:(0,z.jsx)(ku,{value:Ac(e)})},t)})),children:(0,z.jsx)(CE,{sounds:wZ,className:UB.dropdownToggle,disabled:l||c.length<=1,children:n})})}),(0,z.jsxs)("div",{className:LZ.right,children:[(0,z.jsx)(yb,{value:r,className:_d()(UB.input,LZ.input),onChange:d,placeholder:(0,z.jsx)(ku,{value:s})}),(0,z.jsx)(lV,{className:LZ.deleteButton,src:"media/glyphs/trash.svg",selected:!1,disabled:!1,onSelect:f,tinted:!0})]})]})})};oe.add("game-ui/editor/widgets/localization-field/localization-field.tsx",{get BoundLocalizationField(){return RZ},set BoundLocalizationField(e){RZ=e},get LocalizationField(){return DZ},set LocalizationField(e){DZ=e}});let UZ={backSrc:"Media/Glyphs/ThickStrokeArrowLeft.svg","page-layout":"page-layout_JSP editor-widget_QQl",pageLayout:"page-layout_JSP editor-widget_QQl",header:"header_u77","back-button":"back-button_rnO",backButton:"back-button_rnO",title:"title_zOE"};oe.add("game-ui/editor/widgets/page-layout/page-layout.module.scss",{get classes(){return UZ},set classes(e){Object.assign(UZ,e)}});const GZ=UZ;var BZ=function(e){var t=e.parent,n=e.path,r=e.props,i=e.children,o=uD(t,n),a=CV(r.flex),s=(0,Y.useContext)(ED),l=RR(zR,o);return(0,z.jsx)(VZ,{title:(0,z.jsx)(ku,{value:r.title}),style:a,onBack:r.hasBackAction?l:void 0,children:(0,z.jsx)(OD,{parent:o,components:s,data:i})})},VZ=function(e){var t=e.title,n=e.className,r=e.style,i=e.children,o=e.onBack,a=Pg();return(0,z.jsx)(ap,{onAction:o,children:(0,z.jsxs)("div",{className:_d()(GZ.pageLayout,n),style:r,children:[(0,z.jsxs)("div",{className:GZ.header,children:[!a&&null!=o&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Common.GO_BACK_TOOLTIP,{}),children:(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:GZ.backSrc,className:GZ.backButton,onSelect:o})}),(0,z.jsx)("div",{className:GZ.title,children:t})]}),i]})})};oe.add("game-ui/editor/widgets/page-layout/page-layout.tsx",{get BoundPageLayout(){return BZ},set BoundPageLayout(e){BZ=e},get PageLayout(){return VZ},set PageLayout(e){VZ=e}});var HZ=n(928),KZ=n.n(HZ);function WZ(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function zZ(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return WZ(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return WZ(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function YZ(e,t,n,r){var i=$Z(e,null!=n?n:t,r);return(0,Y.useEffect)((function(){i.setEndValue(t)}),[i,t]),qZ(i)}function $Z(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],r=(0,Y.useRef)(t),i=(0,Y.useMemo)((function(){return(new(KZ().SpringSystem)).createSpring().setCurrentValue(r.current).setAtRest()}),[]),o=Pj(e);return(0,Y.useEffect)((function(){i.setSpringConfig(o)}),[i,o]),(0,Y.useEffect)((function(){i.setOvershootClampingEnabled(n)}),[i,n]),i}function qZ(e){var t=zZ((0,Y.useState)(e.getCurrentValue()),2),n=t[0],r=t[1];return(0,Y.useEffect)((function(){var t={onSpringUpdate:function(e){r(e.getCurrentValue())}};return e.addListener(t),function(){e.removeListener(t)}}),[e]),n}oe.add("game-ui/common/animations/spring-hooks.tsx",{get useSpringAnimation(){return YZ},set useSpringAnimation(e){YZ=e},get useSpring(){return $Z},set useSpring(e){$Z=e},get useSpringValue(){return qZ},set useSpringValue(e){qZ=e}});let XZ={"page-view":"page-view_PUO editor-widget_QQl",pageView:"page-view_PUO editor-widget_QQl",page:"page_hHC",active:"active_xN8"};oe.add("game-ui/editor/widgets/page-view/page-view.module.scss",{get classes(){return XZ},set classes(e){Object.assign(XZ,e)}});const QZ=XZ;var ZZ=function(e){var t=e.parent,n=e.path,r=e.props,i=e.children,o=uD(t,n),a=CV(r.flex),s=(0,Y.useContext)(ED),l=(0,Y.useMemo)((function(){return i.map((function(e){return(0,z.jsx)(jD,{parent:o,components:s,data:e},e.path)}))}),[i,o,s]);return(0,z.jsx)(eJ,{currentPage:r.currentPage,pages:l,style:a})},JZ={tension:150,friction:15},eJ=function(e){var t=e.currentPage,n=e.pages,r=e.className,i=e.style,o=YZ(JZ,t,void 0,!0);return(0,z.jsx)("div",{className:_d()(QZ.pageView,r),style:i,children:(0,z.jsx)(pj,{focused:t,children:n.map((function(e,n){return(0,z.jsx)("div",{className:_d()(QZ.page,n===t&&QZ.active),style:{"--offset":n-o},children:(0,z.jsx)(Ap,{focusKey:n,children:e})},n)}))})})};oe.add("game-ui/editor/widgets/page-view/page-view.tsx",{get BoundPageView(){return ZZ},set BoundPageView(e){ZZ=e},get PageView(){return eJ},set PageView(e){eJ=e}});let tJ={row:"row_uw4 editor-widget_QQl"};oe.add("game-ui/editor/widgets/Row/row.module.scss",{get classes(){return tJ},set classes(e){Object.assign(tJ,e)}});const nJ=tJ;var rJ=function(e){var t=e.parent,n=e.path,r=e.props,i=e.children,o=uD(t,n),a=CV(r.flex),s=(0,Y.useContext)(ED);return(0,z.jsx)(iJ,{style:a,children:(0,z.jsx)(OD,{parent:o,components:s,data:i})})},iJ=function(e){var t=e.className,n=e.style,r=e.children;return(0,z.jsx)("div",{className:_d()(nJ.row,t),style:n,children:(0,z.jsx)(Ap,{children:r})})};oe.add("game-ui/editor/widgets/Row/row.tsx",{get BoundRow(){return rJ},set BoundRow(e){rJ=e},get Row(){return iJ},set Row(e){iJ=e}});let oJ={scrollable:"scrollable_VJQ editor-widget_QQl"};oe.add("game-ui/editor/widgets/scrollable/scrollable.module.scss",{get classes(){return oJ},set classes(e){Object.assign(oJ,e)}});const aJ=oJ;var sJ=function(e){var t=e.parent,n=e.path,r=e.props,i=e.children,o=uD(t,n),a=CV(r.flex),s=(0,Y.useContext)(ED);return(0,z.jsx)(lJ,{style:a,children:(0,z.jsx)(OD,{parent:o,components:s,data:i})})},lJ=function(e){var t=e.className,n=e.style,r=e.children,i=e.vertical,o=void 0===i||i,a=e.horizontal,s=void 0!==a&&a;return(0,z.jsx)(gE,{trackVisibility:"scrollable",className:_d()(aJ.scrollable,t),style:n,vertical:o,horizontal:s,children:(0,z.jsx)(Ap,{children:r})})};oe.add("game-ui/editor/widgets/scrollable/scrollable.tsx",{get BoundScrollable(){return sJ},set BoundScrollable(e){sJ=e},get EditorScrollable(){return lJ},set EditorScrollable(e){lJ=e}});let cJ={popupMinHeight:"300rem","search-field":"search-field_jRt editor-widget_QQl",searchField:"search-field_jRt editor-widget_QQl",input:"input_UVn",actions:"actions_qt8",action:"action_Qra",popup:"popup_OTO",item:"item_NeK",value:"value_Mug","favorite-action":"favorite-action_s2e",favoriteAction:"favorite-action_s2e","favorite-icon":"favorite-icon_JvS",favoriteIcon:"favorite-icon_JvS"};oe.add("game-ui/editor/widgets/search-field/search-field.module.scss",{get classes(){return cJ},set classes(e){Object.assign(cJ,e)}});const uJ=cJ;function dJ(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function fJ(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return dJ(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return dJ(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var mJ=function(e){var t=e.parent,n=e.path,r=e.props,i=uD(t,n),o=RR(YR,i),a=RR(fB,i);return(0,z.jsx)(gJ,{value:r.value,valueIsFavorite:r.valueIsFavorite,suggestions:r.suggestions,onChange:o,onChangeFavorite:r.hasFavorites?a:void 0})},gJ=function(e){var t=e.value,n=e.valueIsFavorite,r=e.suggestions,i=e.onChange,o=e.onChangeFavorite,a=Pg(),s=(0,Y.useRef)(null),l=fJ((0,Y.useState)(!1),2),c=l[0],u=l[1],d=(0,Y.useCallback)((function(e){return i(e.target.value||"")}),[i]),f=(0,Y.useCallback)((function(){return u(!0)}),[]),m=(0,Y.useCallback)((function(){return u(!1)}),[]),g=(0,Y.useMemo)((function(){return null!=o?function(){return o(t,!n)}:null}),[n,t,o]),h=(0,Y.useCallback)((function(){return i("")}),[i]),p=(0,Y.useCallback)((function(e){var t;i(e),null===(t=s.current)||void 0===t||t.blur()}),[i]),v=YO(uJ.popupMinHeight),b=(0,z.jsx)(gE,{className:uJ.scrollable,children:r.map((function(e,t){return(0,z.jsx)(hJ,{value:e.value,favorite:e.favorite,onSelect:p,onChangeFavorite:o},t)}))});return(0,z.jsx)(QO,{visible:!a&&c&&r.length>0,direction:"down",minHeight:v,className:uJ.popup,content:b,minWidth:!0,children:(0,z.jsx)(Qd,{children:(0,z.jsxs)("div",{className:uJ.searchField,children:[(0,z.jsx)(yb,{ref:s,value:t,placeholder:(0,z.jsx)(qc.Editor.SEARCH_PLACEHOLDER,{}),className:uJ.input,onChange:d,onFocus:f,onBlur:m}),!a&&t&&(0,z.jsxs)("div",{className:uJ.actions,children:[(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Common.CLEAR_SEARCH_TOOLTIP,{}),children:(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:"Media/Glyphs/Clear.svg",className:uJ.action,onSelect:h,onMouseDown:c?pJ:void 0})}),null!=g&&(0,z.jsx)(jh,{tooltip:n?(0,z.jsx)(qc.Editor.REMOVE_FAVORITE,{}):(0,z.jsx)(qc.Editor.ADD_FAVORITE,{}),children:(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:n?"Media/Glyphs/StarFilled.svg":"Media/Glyphs/StarOutline.svg",className:uJ.action,onSelect:g,onMouseDown:c?pJ:void 0})})]})]})})})},hJ=function(e){var t=e.value,n=e.favorite,r=e.onSelect,i=e.onChangeFavorite,o=RR(r,t),a=(0,Y.useMemo)((function(){return null!=i?function(){return i(t,!n)}:null}),[n,t,i]);return(0,z.jsxs)("div",{className:uJ.item,children:[(0,z.jsx)("div",{className:uJ.value,onMouseDown:pJ,onClick:o,children:t}),null!=a&&(0,z.jsx)("div",{className:uJ.favoriteAction,onMouseDown:pJ,onClick:a,children:(0,z.jsx)(tb,{src:n?"Media/Glyphs/StarFilled.svg":"Media/Glyphs/StarOutline.svg",className:uJ.favoriteIcon})})]})};function pJ(e){e.preventDefault()}oe.add("game-ui/editor/widgets/search-field/popup-search-field.tsx",{get BoundPopupSearchField(){return mJ},set BoundPopupSearchField(e){mJ=e},get PopupSearchField(){return gJ},set PopupSearchField(e){gJ=e}});var vJ=function(e){var t=e.parent,n=e.path,r=e.props,i=RR(YR,uD(t,n));return(0,z.jsx)(bJ,{value:r.value,onChange:i})},bJ=function(e){var t=e.value,n=e.onChange,r=Pg(),i=(0,Y.useRef)(null),o=(0,Y.useCallback)((function(e){return n(e.target.value||"")}),[n]),a=(0,Y.useCallback)((function(){return n("")}),[n]);return(0,z.jsxs)("div",{className:uJ.searchField,children:[(0,z.jsx)(yb,{ref:i,value:t,placeholder:(0,z.jsx)(qc.Editor.SEARCH_PLACEHOLDER,{}),className:uJ.input,onChange:o}),!r&&t&&(0,z.jsx)("div",{className:uJ.actions,children:(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Common.CLEAR_SEARCH_TOOLTIP,{}),children:(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:"Media/Glyphs/Clear.svg",className:uJ.action,onSelect:a,onMouseDown:yJ})})})]})};function yJ(e){e.preventDefault()}oe.add("game-ui/editor/widgets/search-field/search-field.tsx",{get BoundSearchField(){return vJ},set BoundSearchField(e){vJ=e},get SearchField(){return bJ},set SearchField(e){bJ=e}});var xJ=lP({h:.66,s:.75,v:.7,a:1}),_J=lP({h:.58,s:.7,v:.7,a:1}),jJ=lP({h:.3,s:.6,v:.7,a:1}),OJ=lP({h:0,s:.7,v:.7,a:1}),EJ={min:-40,max:40};function SJ(e){var t=EJ.min,n=EJ.max,r=n-t>0?3*(of(e,t,n)-t)/(n-t):1.5;return r<=1?uP(xJ,_J,r):r<=2?uP(_J,jJ,r-1):uP(jJ,OJ,r-2)}var TJ=fP({stops:[{color:rP(xJ),offset:0},{color:rP(_J),offset:.33},{color:rP(jJ),offset:.67},{color:rP(OJ),offset:1}]});oe.add("game-ui/editor/widgets/season-wheel/temperature-color.ts",{get tempColorRange(){return EJ},set tempColorRange(e){EJ=e},get getTempColor(){return SJ},set getTempColor(e){SJ=e},get temperatureGradient(){return TJ},set temperatureGradient(e){TJ=e}});let IJ={"season-wheel":"season-wheel_qNt",seasonWheel:"season-wheel_qNt",canvas:"canvas_PkU",thumb:"thumb_tno","month-label":"month-label_bLZ",monthLabel:"month-label_bLZ",legend:"legend_drE",gradient:"gradient_xVL",labels:"labels_F5a"};oe.add("game-ui/editor/widgets/season-wheel/season-wheel.module.scss",{get classes(){return IJ},set classes(e){Object.assign(IJ,e)}});const wJ=IJ;function PJ(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function CJ(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function NJ(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){CJ(e,t,n[t])}))}return e}function AJ(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function LJ(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function MJ(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||RJ(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function kJ(e){return function(e){if(Array.isArray(e))return PJ(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||RJ(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function RJ(e,t){if(e){if("string"==typeof e)return PJ(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?PJ(e,t):void 0}}var DJ,FJ=function(e){var t=e.parent,n=e.path,r=e.props,i=uD(t,n),o=RR(sB,i),a=RR(lB,i),s=$O();return(0,z.jsxs)(GB,{centered:!0,children:[(0,z.jsx)(GJ,{size:360*s,seasons:r.seasons,selectedSeason:r.selectedSeason,onSelect:o,onSeasonStartTimeOfYearChange:a}),(0,z.jsx)(YJ,{width:360*s})]})},UJ=.02;!function(e){e[e.rangeStart=0]="rangeStart",e[e.rangeEnd=1]="rangeEnd"}(DJ||(DJ={}));var GJ=Y.memo((function(e){var t=e.size,n=e.seasons,r=e.selectedSeason,i=e.className,o=e.onSelect,a=e.onSeasonStartTimeOfYearChange,s=(0,Y.useRef)(null),l=$O(),c=Math.floor(t),u=c/2-20*l,d=.9*u,f=.8*u,m=f,g=.6*u,h=.5*u,p=MJ((0,Y.useState)(ty),2),v=p[0],b=p[1],y=MJ((0,Y.useState)(!1),2),x=y[0],_=y[1],j=(0,Y.useRef)(null);(0,Y.useEffect)((function(){if(s.current){var e=s.current.getContext("2d"),t=2*l;e.clearRect(0,0,c,c),e.save(),e.translate(c/2,c/2),e.rotate(-.5*Math.PI),e.beginPath();for(var i=0;i<12;i++){var o=2*Math.PI*i/12;e.moveTo(h*Math.cos(o),h*Math.sin(o)),e.lineTo(m*Math.cos(o),m*Math.sin(o))}e.strokeStyle="rgba(255, 255, 255, 0.4)",e.lineWidth=2*l,e.stroke();for(var a=0;a<n.length;a++){var d=n[a],g=n[(a+1)%n.length],p=d.startTimeOfYear.max,b=d.startTimeOfYear.min,y=d===g?1:0,_=g.startTimeOfYear.max+y,j=g.startTimeOfYear.min+y;if(e.beginPath(),e.arc(0,0,u,2*Math.PI*b+t/u,2*Math.PI*j-t/u,!1),!KJ(j,_))for(var O=j,E=j+(_-j+1)%1,S=0;S<2;S++){var T=af(u,f,(S+1)/3)-t,I=af(O,E,S/2),w=af(O,E,(S+1)/2);e.arc(0,0,T,2*Math.PI*I-t/T,2*Math.PI*w-t/T,!1)}if(e.arc(0,0,f,2*Math.PI*_-t/f,2*Math.PI*p+t/f,!0),!KJ(p,b))for(var P=p,C=p+(b-p-1)%1,N=0;N<2;N++){var A=af(f,u,(N+1)/3)+t,L=af(P,C,N/2),M=af(P,C,(N+1)/2);e.arc(0,0,A,2*Math.PI*L+t/A,2*Math.PI*M+t/A,!0)}e.closePath();var k=.5;Qs(d.entity,r)?k=1:Qs(d.entity,v)&&!x&&(k=.6),e.fillStyle=rP(nP(SJ(d.temperature),k)),e.fill(),Qs(d.entity,r)&&(e.strokeStyle="rgb(255, 255, 255)",e.lineWidth=2*l,e.stroke())}e.restore()}}),[x,c,v,f,h,m,u,l,n,r]);var O=(0,Y.useCallback)((function(e,t,r){if(s.current){var i=n.findIndex((function(t){return Qs(t.entity,e)}));if(-1!==i){var o=function(e,t){return t===DJ.rangeStart?e.startTimeOfYear.min:e.startTimeOfYear.max}(n[i],t),a=BJ(s.current,r.clientX,r.clientY)-o;j.current={seasonEntity:e,type:t,angleOffset:a},function(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}(document.activeElement,HTMLElement)&&document.activeElement.blur(),r.preventDefault(),_(!0),kp(Lp.grabSlider)}}}),[n]),E=(0,Y.useCallback)((function(e){if(j.current&&s.current){e.preventDefault();var t=(BJ(s.current,e.clientX,e.clientY)+j.current.angleOffset+1)%1,r=j.current.seasonEntity,i=n.findIndex((function(e){return Qs(e.entity,r)}));if(-1!==i){var o=n[i],l=function(e,t,n,r){var i=e[t],o=e[(t+e.length-1)%e.length],a=e[(t+1)%e.length];if(n===DJ.rangeStart)return{min:VJ(r,(o.startTimeOfYear.max+UJ+1)%1,i.startTimeOfYear.max),max:i.startTimeOfYear.max};var s=i.startTimeOfYear.min,l=(a.startTimeOfYear.min-UJ+1)%1;return{min:i.startTimeOfYear.min,max:VJ(r,s,l)}}(n,i,j.current.type,t);Cf(l,o.startTimeOfYear)||(kp(Lp.dragSlider),a(r,l))}}}),[a,n]),S=(0,Y.useCallback)((function(e){e.preventDefault(),_(!1)}),[]);(0,Y.useEffect)((function(){if(x)return document.addEventListener("mousemove",E),document.addEventListener("mouseup",S),function(){document.removeEventListener("mousemove",E),document.removeEventListener("mouseup",S)}}),[x,E,S]);var T=(0,Y.useCallback)((function(e){if(null!=s.current){var t=s.current.getBoundingClientRect(),r=t.left,i=t.top,o=t.width,a=t.height,l=e.clientX-r-o/2,c=e.clientY-i-a/2,m=Math.sqrt(l*l+c*c),g=BJ(s.current,e.clientX,e.clientY),h=ty;if(m>d&&m<u){for(var p=0;p<n.length;p++)if(HJ(g,n[p].startTimeOfYear.min,n[(p+1)%n.length].startTimeOfYear.min)){h=n[p].entity;break}}else if(m>f&&m<=d)for(var v=0;v<n.length;v++)if(HJ(g,n[v].startTimeOfYear.max,n[(v+1)%n.length].startTimeOfYear.max)){h=n[v].entity;break}b(h)}}),[f,d,u,n]),I=(0,Y.useCallback)((function(){return b(ty)}),[]),w=(0,Y.useCallback)((function(){Qs(v,ty)||o(v)}),[v,o]),P={top:c/2,left:c/2};return(0,z.jsxs)("div",{style:{width:c,height:c},className:_d()(wJ.seasonWheel,i),children:[(0,z.jsx)("canvas",{ref:s,width:c,height:c,className:wJ.canvas,onMouseMove:T,onMouseLeave:I,onMouseDown:w}),n.map((function(e){return(0,z.jsxs)(Y.Fragment,{children:[(0,z.jsx)(WJ,{seasonEntity:e.entity,type:DJ.rangeStart,angle:e.startTimeOfYear.min,radius:u,style:P,onMouseDown:O}),(0,z.jsx)(WJ,{seasonEntity:e.entity,type:DJ.rangeEnd,angle:e.startTimeOfYear.max,radius:f,style:P,onMouseDown:O})]},qs(e.entity))})),kJ(Array(12).keys()).map((function(e){return(0,z.jsx)(zJ,{monthIndex:e,radius:g,style:P},e)}))]})}),(function(e,t){var n=e.seasons,r=LJ(e,["seasons"]),i=t.seasons;return el(r,LJ(t,["seasons"]),2)&&function(e,t){if(e.length!==t.length)return!1;for(var n=0;n<e.length;n++){if(!Cf(e[n].startTimeOfYear,t[n].startTimeOfYear))return!1;if(e[n].temperature!==t[n].temperature)return!1}return!0}(n,i)}));function BJ(e,t,n){var r=e.getBoundingClientRect(),i=r.left,o=r.top,a=t-i-r.width/2,s=n-o-r.height/2;return of(Math.atan2(-a,s)/(2*Math.PI)+.5,0,1)}function VJ(e,t,n){return HJ(e,t,n)?e:(t-e+1)%1<(e-n+1)%1?t:n}function HJ(e,t,n){if(KJ(t,n))return!1;if(t<n){if(e>=t&&e<n)return!0}else if(e>=t||e<n)return!0;return!1}function KJ(e,t){var n=Math.abs(e-t)%1;return n<1e-4||n>.9999}var WJ=function(e){var t=e.seasonEntity,n=e.type,r=e.angle,i=e.radius,o=e.style,a=e.onMouseDown,s=(0,Y.useCallback)((function(e){return a(t,n,e)}),[a,t,n]),l=i*Math.sin(2*r*Math.PI),c=-i*Math.cos(2*r*Math.PI),u=360*r-(n===DJ.rangeEnd?180:0);return(0,z.jsx)(tb,{src:"Media/Editor/SeasonThumb.svg",className:wJ.thumb,style:AJ(NJ({},o),{transform:"translate(-50%, -100%) translate(".concat(l.toFixed(2),"px, ").concat(c.toFixed(2),"px) rotate(").concat(u.toFixed(2),"deg)")}),onMouseDown:s})},zJ=function(e){var t=e.monthIndex,n=e.radius,r=e.style,i=(t+.5)/12,o=n*Math.sin(2*i*Math.PI),a=-n*Math.cos(2*i*Math.PI);return(0,z.jsx)("div",{className:wJ.monthLabel,style:AJ(NJ({},r),{transform:"translate(-50%, -50%) translate(".concat(o.toFixed(2),"px, ").concat(a.toFixed(2),"px)")}),children:Vu(t+1,2)})},YJ=function(e){var t=e.width;return(0,z.jsxs)("div",{className:wJ.legend,style:{width:"".concat(t,"rem")},children:[(0,z.jsx)("div",{className:wJ.gradient,style:{backgroundImage:TJ}}),(0,z.jsxs)("div",{className:wJ.labels,children:[(0,z.jsx)("div",{children:(0,z.jsx)(su,{value:EJ.min,unit:$c.Temperature,signed:!0})}),(0,z.jsx)("div",{children:(0,z.jsx)(su,{value:0,unit:$c.Temperature})}),(0,z.jsx)("div",{children:(0,z.jsx)(su,{value:EJ.max,unit:$c.Temperature,signed:!0})})]})]})};oe.add("game-ui/editor/widgets/season-wheel/season-wheel.tsx",{get BoundSeasonWheel(){return FJ},set BoundSeasonWheel(e){FJ=e},get SeasonWheel(){return GJ},set SeasonWheel(e){GJ=e},get TemperatureLegend(){return YJ},set TemperatureLegend(e){YJ=e}});let $J={toggle:"toggle_GUy",checkmark:"checkmark_Bc3"};oe.add("game-ui/editor/themes/editor-small-checkbox.module.scss",{get classes(){return $J},set classes(e){Object.assign($J,e)}});const qJ=$J;let XJ={"editor-section":"editor-section_zoX",editorSection:"editor-section_zoX",header:"header_MLk",primary:"primary_j00",toggle:"toggle_XlP",action:"action_T_m",icon:"icon_v5n",label:"label_OqN","action-checkbox":"action-checkbox_Z8G",actionCheckbox:"action-checkbox_Z8G",content:"content_yUv"};oe.add("game-ui/editor/widgets/section/editor-section.module.scss",{get classes(){return XJ},set classes(e){Object.assign(XJ,e)}});const QJ=XJ;function ZJ(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function JJ(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function e0(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function t0(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return ZJ(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return ZJ(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var n0=function(e){var t=e.parent,n=e.path,r=e.props,i=e.children,o=uD(t,n),a=(0,Y.useContext)(ED),s=RR(oB,o),l=RR($R,o),c=RR(aB,o);return(0,z.jsx)(i0,{title:(0,z.jsx)(ku,{value:r.displayName}),active:r.active,primary:r.primary,headerColor:null!=r.color?rP(r.color):void 0,expanded:r.expanded,onDelete:r.deletable?s:void 0,onActiveChange:r.activatable?c:void 0,onExpandedChange:r.expandable?l:void 0,disabled:r.disabled,children:(0,z.jsx)(OD,{parent:o,components:a,data:i})})},r0=function(e){var t=t0((0,Y.useState)(!0),2),n=t[0],r=t[1];return(0,z.jsx)(i0,e0(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){JJ(e,t,n[t])}))}return e}({},e),{expanded:n,onExpandedChange:r}))},i0=function(e){var t=e.title,n=e.active,r=void 0===n||n,i=e.primary,o=e.headerColor,a=e.expanded,s=e.className,l=e.children,c=e.onDelete,u=e.onActiveChange,d=e.onExpandedChange,f=e.disabled,m=(0,Y.useCallback)((function(){null!=d&&d(!a)}),[a,d]),g=(0,Y.useCallback)((function(){null!=u&&u(!r)}),[r,u]);return(0,z.jsxs)("div",{className:_d()(QJ.editorSection,i&&QJ.primary,s),children:[(0,z.jsx)("div",{className:QJ.header,style:{backgroundColor:o},children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[null!=d?(0,z.jsx)(PO,{src:a?"Media/Glyphs/ThickStrokeArrowDown.svg":"Media/Glyphs/ThickStrokeArrowRight.svg",theme:QJ,className:QJ.toggle,onSelect:m,children:t}):(0,z.jsx)(PO,{src:"Media/Glyphs/Circle.svg",theme:QJ,className:QJ.toggle,disabled:!0,children:t}),c&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Common.DELETE_TOOLTIP,{}),children:(0,z.jsx)(lb,{tinted:!0,src:"Media/Glyphs/Trash.svg",className:QJ.action,onSelect:c,disabled:f})}),u&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Editor.ACTIVE_TOOLTIP,{}),children:(0,z.jsx)(Qp,{className:QJ.action,onSelect:g,disabled:f,children:(0,z.jsx)(fv,{focusKey:Hh,checked:r,theme:qJ,className:QJ.actionCheckbox,onChange:u,disabled:f})})})]})}),null!=d&&a&&(0,z.jsx)("div",{className:QJ.content,children:l})]})};oe.add("game-ui/editor/widgets/section/editor-section.tsx",{get BoundEditorSection(){return n0},set BoundEditorSection(e){n0=e},get EditorSection(){return r0},set EditorSection(e){r0=e},get EditorSectionBase(){return i0},set EditorSectionBase(e){i0=e}});let o0={chart:"chart_SQk"};oe.add("game-ui/editor/widgets/time-of-day-weights-chart/time-of-day-weights-chart.module.scss",{get classes(){return o0},set classes(e){Object.assign(o0,e)}});const a0=o0;var s0=function(e){var t=e.props,n=(0,Y.useMemo)((function(){return{datasets:[{data:[t.value.x,t.value.y,t.value.z,t.value.w,t.value.x]}]}}),[t.value.x,t.value.y,t.value.z,t.value.w]),r=function(){var e=xl(Xl);return(0,Y.useMemo)((function(){return{layout:{padding:{top:8,right:8,bottom:0,left:8}},elements:{line:{fill:!0,tension:0,borderWidth:2,borderColor:"#ffb543",backgroundColor:"rgba(255, 181, 67, 0.3)"},point:{radius:4,backgroundColor:"#ffb543"}},scales:{y:{display:!1,min:0,suggestedMax:1,labels:[],grid:{color:"rgba(255, 255, 255, 0.5)",lineWidth:function(e){return 0===e.tick.value?2:1}}},x:{labels:["00","06","12","18","00"],grid:{color:"rgba(255, 255, 255, 0.4)",borderColor:"rgba(255, 255, 255, 0.4)",lineWidth:1,borderWidth:1},ticks:{font:{size:14*e,weight:"bold"},color:"rgba(255, 255, 255, 0.6)",padding:0,autoSkip:!1},beginAtZero:!0}}}}),[e])}();return(0,z.jsx)(GB,{children:(0,z.jsx)(OU,{type:"line",data:n,options:r,className:a0.chart})})};function l0(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function c0(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}oe.add("game-ui/editor/widgets/time-of-day-weights-chart/time-of-day-weights-chart.tsx",{get TimeOfDayWeightsChart(){return s0},set TimeOfDayWeightsChart(e){s0=e}});var u0,d0=function(e){var t=e.parent,n=e.data;return(0,z.jsx)(OD,{parent:t,components:f0,data:n})},f0=(l0(u0={},FR.Column,MV),l0(u0,FR.Row,rJ),l0(u0,FR.Scrollable,sJ),l0(u0,FR.PageView,ZZ),l0(u0,FR.PageLayout,BZ),l0(u0,qG.ItemPicker,iZ),l0(u0,qG.ItemPickerFooter,cZ),l0(u0,qG.SearchField,vJ),l0(u0,qG.PopupSearchField,mJ),l0(u0,FR.Divider,VV),l0(u0,FR.Button,NB),l0(u0,FR.ButtonRow,AB),l0(u0,FR.IconButton,iV),l0(u0,FR.IconButtonGroup,oV),l0(u0,FR.Group,lY),l0(u0,FR.ExpandableGroup,cY),l0(u0,FR.PagedList,pZ),l0(u0,FR.ValueField,(function(e){var t=e.props;return(0,z.jsx)(BB,{children:(0,z.jsxs)("div",{style:{color:"red",whiteSpace:"pre",fontSize:"12px"},children:[(0,z.jsx)(ku,{value:t.displayName}),t.value]})})})),l0(u0,FR.ToggleField,m0(fQ)),l0(u0,FR.IntInputField,m0(xX)),l0(u0,FR.IntSliderField,m0(b$)),l0(u0,FR.UIntInputField,m0(_X)),l0(u0,FR.UIntSliderField,m0(b$)),l0(u0,FR.TimeBoundsSliderField,m0(R$)),l0(u0,FR.Int2InputField,m0(jX)),l0(u0,FR.Int3InputField,m0(OX)),l0(u0,FR.Int4InputField,m0(EX)),l0(u0,FR.FloatInputField,m0(kY)),l0(u0,FR.FloatSliderField,m0(y$)),l0(u0,FR.TimeSliderField,m0(I$)),l0(u0,FR.Float2InputField,m0(RY)),l0(u0,FR.Float3InputField,m0(DY)),l0(u0,FR.EulerAnglesField,m0(DY)),l0(u0,FR.Float4InputField,m0(FY)),l0(u0,FR.StringInputField,XB),l0(u0,FR.Bounds1SliderField,m0(k$)),l0(u0,FR.Bounds1InputField,m0(A$)),l0(u0,FR.Bounds2InputField,m0(L$)),l0(u0,FR.Bounds3InputField,m0(M$)),l0(u0,FR.ColorField,m0(Jq)),l0(u0,FR.Bezier4x3Field,m0(l$)),l0(u0,FR.EnumField,cX),l0(u0,FR.FlagsField,uX),l0(u0,FR.DropdownField,zB),l0(u0,FR.AnimationCurveField,i$),l0(u0,FR.PopupValueField,LX),l0(u0,FR.DirectoryPickerButton,tX),l0(u0,FR.ImageField,YQ),l0(u0,FR.LocalizedValueField,gQ),l0(u0,FR.Label,yV),l0(u0,qG.EditorSection,n0),l0(u0,qG.Compass,FV),l0(u0,qG.SeasonWheel,FJ),l0(u0,qG.TimeOfDayWeightsChart,s0),l0(u0,qG.LocalizationField,RZ),l0(u0,qG.FilterMenu,xQ),l0(u0,qG.HierarchyMenu,GQ),l0(u0,qG.SeasonsField,dQ),l0(u0,qG.ModdingBetaBanner,YG),l0(u0,qG.ErrorLabel,hV),l0(u0,qG.StringInputFieldWithError,vV),l0(u0,qG.ExternalLinkField,dV),l0(u0,qG.ProgressIndicator,wV),l0(u0,qG.LargeIconButton,bV),u0);function m0(e){var t,n=function(t){var n=t.parent,r=t.path,i=t.props,o=RR(YR,uD(n,r));return(0,z.jsx)(e,c0(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){l0(e,t,n[t])}))}return e}({},i),{label:(0,z.jsx)(ku,{value:i.displayName}),onChange:o}))};return n.displayName=null!==(t=e.displayName)&&void 0!==t?t:e.name,n}oe.add("game-ui/editor/widgets/editor-widget-renderer.tsx",{get EditorWidgetListRenderer(){return d0},set EditorWidgetListRenderer(e){d0=e},get editorWidgetComponents(){return f0},set editorWidgetComponents(e){f0=e}});var g0="assetUploadPanel",h0=fl(g0,"children"),p0=fl(g0,"visible"),v0=pl(g0,"close");oe.add("game-ui/menu/data-binding/asset-upload-bindings.ts",{get assetUploadWidgets(){return assetUploadWidgets},set assetUploadWidgets(e){assetUploadWidgets=e},get assetUploadPanelVisible(){return assetUploadPanelVisible},set assetUploadPanelVisible(e){assetUploadPanelVisible=e},get closeAssetUploadPanel(){return closeAssetUploadPanel},set closeAssetUploadPanel(e){closeAssetUploadPanel=e}});let b0={panel:"panel_ezY"};oe.add("game-ui/menu/components/asset-upload-panel/asset-upload-panel-renderer.module.scss",{get classes(){return b0},set classes(e){Object.assign(b0,e)}});const y0=b0;var x0=new Wh("DIALOG"),_0=new Wh("CHILDREN"),j0=function(e){var t=e.children,n=xl(p0);return(0,z.jsxs)(pj,{focused:n?x0:_0,children:[(0,z.jsx)(hj,{focusKey:_0,children:t}),n&&(0,z.jsx)(hj,{focusKey:x0,children:(0,z.jsx)(O0,{})})]})},O0=function(){return(0,z.jsx)(tm,{children:(0,z.jsx)(ij,{children:(0,z.jsx)(qj,{theme:Qj,className:y0.panel,onClose:v0,header:(0,z.jsx)(tO,{children:(0,z.jsx)(qc.Menu.ASSET_UPLOAD,{})}),children:(0,z.jsx)(E0,{})})})},"AssetUploadPanel")},E0=function(){var e=cD("assetUploadPanel"),t=xl(h0);return(0,z.jsx)(d0,{parent:e,data:t})};oe.add("game-ui/menu/components/asset-upload-panel/asset-upload-panel-renderer.tsx",{get AssetUploadPanelRenderer(){return j0},set AssetUploadPanelRenderer(e){j0=e}});var S0=new Wh("DIALOG"),T0=new Wh("CHILDREN"),I0=new Wh("NO_KEY"),w0=function(e){var t=e.children,n=xl(Wl),r=xl(zl);return(0,z.jsxs)(pj,{focused:n?S0:T0,children:[n&&(0,z.jsx)(tm,{children:(0,z.jsx)(ij,{children:(0,z.jsxs)(qj,{focusKey:S0,theme:Qj,className:rO.dialog,children:[(0,z.jsx)("div",{className:rO.message,children:(0,z.jsx)(qc.Options.DISPLAY_SETTINGS_PROMPT,{})}),(0,z.jsx)("div",{className:rO.buttons,children:(0,z.jsxs)(Ap,{initialFocused:I0,children:[(0,z.jsx)(Qp,{theme:Jp,className:rO.button,onSelect:mc,children:(0,z.jsx)(qc.Options.DISPLAY_SETTINGS_CONFIRM,{})}),(0,z.jsx)(Qp,{focusKey:I0,theme:Jp,className:_d()(rO.button,Jp.negative),onSelect:gc,children:(0,z.jsx)(qc.Options.DISPLAY_SETTINGS_REVERT,{TIME:(0,z.jsx)(su,{value:r,unit:$c.Integer})})})]})})]})})},"displayConfirmationDialog"),(0,z.jsx)(hj,{focusKey:T0,children:t})]})};oe.add("game-ui/menu/components/options-screen/display-confirmation-dialog/display-confirmation-dialog.tsx",{get DisplayConfirmationDialogRenderer(){return w0},set DisplayConfirmationDialogRenderer(e){w0=e}});var P0="inputRebinding",C0=fl(P0,"activeRebinding"),N0=fl(P0,"activeConflict"),A0=pl(P0,"cancelRebinding"),L0=pl(P0,"completeAndSwapConflicts"),M0=pl(P0,"completeAndUnsetConflicts");function k0(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function R0(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){k0(e,t,n[t])}))}return e}oe.add("game-ui/menu/data-binding/input-rebinding-bindings.ts",{get activeRebinding(){return activeRebinding},set activeRebinding(e){activeRebinding=e},get activeConflict(){return activeConflict},set activeConflict(e){activeConflict=e},get cancelRebinding(){return A0},set cancelRebinding(e){A0=e},get completeRebindAndSwapConflicts(){return L0},set completeRebindAndSwapConflicts(e){L0=e},get completeRebindAndUnsetConflicts(){return M0},set completeRebindAndUnsetConflicts(e){M0=e}});var D0=new Wh("CHILDREN_KEY"),F0=new Wh("DIALOG_KEY"),U0=function(e){var t=e.children,n=xl(C0),r=xl(N0),i=null!=n&&null==r;return(0,z.jsx)(z.Fragment,{children:(0,z.jsx)(mb,{excludes:[],disabled:!i,children:(0,z.jsxs)(pj,{focused:null!=n?F0:D0,children:[(0,z.jsx)(hj,{focusKey:D0,children:t}),null!=n&&(0,z.jsx)(tm,{children:(0,z.jsx)(hj,{focusKey:F0,children:null==r?(0,z.jsx)(G0,{binding:n,onClose:A0}):(0,z.jsx)(B0,{binding:r.binding,conflicts:r.conflicts,onConfirmSwap:r.canSwap?L0:void 0,onConfirmUnset:r.canUnset?M0:void 0,onClose:A0})})},"inputRebindingDialog")]})})})},G0=function(e){var t=e.binding,n=e.onClose,r=Pg(),i=yk();return(0,z.jsx)(ij,{children:(0,z.jsx)(ap,{disabled:"Gamepad"===t.group,onAction:n,children:(0,z.jsx)(qj,{theme:Qj,className:rO.dialog,header:(0,z.jsx)(tO,{onCloseOverride:"Mouse"!==t.group?n:void 0,children:(0,z.jsx)(qc.Options.INPUT_REBIND_TITLE,{BINDING:(0,z.jsx)(qc.Options.OPTION,{hash:t.title})})}),children:(0,z.jsx)("div",{className:rO.message,children:(0,z.jsx)(Fv,{theme:rO,children:r&&i===zm.PS?(0,z.jsx)(qc.Options.INPUT_REBIND_PROMPT_PS,{hash:t.group}):(0,z.jsx)(qc.Options.INPUT_REBIND_PROMPT,{hash:t.group})})})})})})},B0=function(e){var t=e.binding,n=e.conflicts,r=e.onConfirmSwap,i=e.onConfirmUnset,o=e.onClose,a=yk(),s={BINDING:(0,z.jsx)(qc.Options.OPTION,{hash:t.title}),CONTROL:(0,z.jsx)(hM,{group:t.group,path:t.path,gamepadType:a})};return(0,z.jsx)(ij,{children:(0,z.jsx)(ap,{onAction:o,children:(0,z.jsxs)(qj,{theme:Qj,className:rO.dialog,header:(0,z.jsx)(tO,{children:(0,z.jsx)(qc.Options.INPUT_CONFLICT_TITLE,{})}),onClose:A0,children:[(0,z.jsx)("div",{className:rO.message,children:(0,z.jsx)(Fv,{theme:rO,children:null!=r?(0,z.jsx)(qc.Options.INPUT_CONFLICT_PROMPT,R0({},s)):(0,z.jsx)(qc.Options.INPUT_CONFLICT_NO_RESOLUTION,R0({},s))})}),(0,z.jsx)("div",{className:rO.errorDetails,children:(0,z.jsx)(gE,{className:rO.content,children:n.map((function(e,t){return(0,z.jsx)("div",{children:(0,z.jsx)(qc.Options.OPTION,{hash:e.title})},t)}))})}),(0,z.jsx)(Ap,{initialFocused:"cancel",children:(0,z.jsxs)("div",{className:rO.buttonsVertical,children:[null!=r&&(0,z.jsx)(Qp,{theme:Jp,className:rO.button,onSelect:r,children:(0,z.jsx)(qc.Options.SWAP_BINDINGS,{})}),null!=i&&(0,z.jsx)(Qp,{theme:Jp,className:rO.button,onSelect:i,children:(0,z.jsx)(qc.Options.UNSET_BINDINGS,{})}),(0,z.jsx)(Qp,{focusKey:"cancel",theme:Jp,className:_d()(rO.button,Jp.negative),onSelect:o,children:(0,z.jsx)(qc.Common.CANCEL,{})})]})})]})})})};oe.add("game-ui/menu/components/options-screen/input-rebinding-dialog/input-rebinding-dialog.tsx",{get InputRebindingDialogRenderer(){return U0},set InputRebindingDialogRenderer(e){U0=e}});var V0=function(e){var t=e.children,n=e.activeUiClassName,r=xl(Yl);(0,Y.useEffect)((function(){return UU(r)}),[r]);var i=xl($l);(0,Y.useEffect)((function(){return GU(i)}),[i]);var o=xl(Xl);(0,Y.useEffect)((function(){return VU(o)}),[o]);var a=xl(ql);return(0,Y.useEffect)((function(){return HU(a)}),[a]),H0(n),YU(false),(0,z.jsxs)(Rk,{children:[(0,z.jsx)(Uk,{}),(0,z.jsx)(RU,{children:(0,z.jsx)(lR,{children:(0,z.jsx)(mO,{children:(0,z.jsx)(w0,{children:(0,z.jsx)(j0,{children:(0,z.jsxs)(U0,{children:[t,false]})})})})})})]})};function H0(e){var t=xl(Ph);dR("".concat(t," ").concat(e))}function K0(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function W0(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function z0(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){W0(e,t,n[t])}))}return e}function Y0(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function $0(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return K0(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return K0(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var q0={default:"Overpass","ru-RU":"Noto Sans","ko-KR":"Noto Sans KR","ja-JP":"Noto Sans JP","zh-HANS":"Noto Sans SC","zh-HANT":"Noto Sans TC"},X0=function(e){var t=e.children,n=xl(Ic),r=xl(ic),i=xl(Ah),o=(0,Y.useMemo)((function(){return function(e){switch(e){case Oc.Id:return Z0;case Oc.Fallback:return J0;default:return Q0}}(n)}),[n]),a=$0((0,Y.useState)({translate:o,unitSettings:r}),2),s=a[0],l=a[1];return(0,Y.useEffect)((function(){return l((function(e){return Y0(z0({},e),{unitSettings:r})}))}),[r]),(0,Y.useEffect)((function(){var e=wc.subscribe((function(){return l((function(e){return z0({},e)}))}));return function(){return e.dispose()}}),[]),Ko.defaults.font.family=q0[i]||q0.default,function(e){dR("locale-".concat(e))}(i),(0,z.jsx)(pc.Provider,{value:s,children:t})};function Q0(e,t){var n=Ys().translate(e);return n===e?null!=t?t:null:n}function Z0(e,t){return e}function J0(e,t){return null!=t?t:null}oe.add("game-ui/common/localization/localization-provider.tsx",{get LocalizationProvider(){return X0},set LocalizationProvider(e){X0=e}});var e1=new Wh("NO_KEY");function t1(){var e=(0,Y.useContext)(dO);return(0,Y.useCallback)((function(){return e.showDialog((0,z.jsx)(n1,{}))}),[e])}var n1=function(){var e=(0,Y.useContext)(fO),t=(0,Y.useCallback)((function(){e.onClose(),NG()}),[e]),n=(0,Y.useCallback)((function(){e.onClose(),Fh()}),[e]),r=xl(fG);return(0,z.jsx)(lO,{wide:!0,title:(0,z.jsx)(qc.Common.EXIT_DIALOG_TITLE,{}),buttons:(0,z.jsx)(Ap,{initialFocused:e1,children:(0,z.jsxs)("div",{className:rO.buttons,children:[(0,z.jsx)(Qp,{theme:Jp,className:rO.button,onSelect:t,children:(0,z.jsx)(qc.Common.EXIT_TO_MENU,{})}),r&&(0,z.jsx)(Qp,{theme:Jp,className:rO.button,onSelect:n,children:(0,z.jsx)(qc.Common.EXIT_TO_DESKTOP,{})}),(0,z.jsx)(Qp,{focusKey:e1,theme:Jp,className:_d()(rO.button,Jp.negative),onSelect:e.onClose,children:(0,z.jsx)(qc.Common.CANCEL,{})})]})}),onClose:e.onClose,children:(0,z.jsx)(Fv,{theme:rO,children:(0,z.jsx)(qc.Common.EXIT_DIALOG_TEXT,{})})})};oe.add("game-ui/menu/components/pause-menu/exit-dialog/exit-dialog.tsx",{get useExitDialogCallback(){return t1},set useExitDialogCallback(e){t1=e},get ExitDialog(){return n1},set ExitDialog(e){n1=e}});let r1={enter:"enter_eIx enter_kO6","enter-active":"enter-active_Y4y enter-active_lrI",enterActive:"enter-active_Y4y enter-active_lrI",exit:"exit_PzK exit_Von","exit-active":"exit-active_jCs exit-active_jtN",exitActive:"exit-active_jCs exit-active_jtN",base:"base_D7z"};oe.add("game-ui/menu/transitions/expand-fade-children.module.scss",{get classes(){return r1},set classes(e){Object.assign(r1,e)}});const i1=r1;let o1={"master-screen":"master-screen_B69",masterScreen:"master-screen_B69"};oe.add("game-ui/menu/components/shared/master-screen/master-screen.module.scss",{get classes(){return o1},set classes(e){Object.assign(o1,e)}});const a1=o1;var s1=Y.forwardRef((function(e,t){var n=e.focusKey,r=e.className,i=e.children;return(0,z.jsx)(hj,{focusKey:n,children:(0,z.jsx)(wj,{children:(0,z.jsx)(Cm,{styles:i1,children:(0,z.jsx)("div",{ref:t,className:_d()(a1.masterScreen,r),children:i})})})})}));oe.add("game-ui/menu/components/shared/master-screen/master-screen.tsx",{get MasterScreen(){return s1},set MasterScreen(e){s1=e}});let l1={content:"content_Y6b",menu:"menu_ZQW",item:"item_Psh"};oe.add("game-ui/menu/components/editor-pause-screen/editor-pause-screen.module.scss",{get classes(){return l1},set classes(e){Object.assign(l1,e)}});const c1=l1;var u1=Y.forwardRef((function(e,t){var n=e.focusKey,r=e.className,i=e.onSelectScreen,o=e.onClose,a=e.onNewMap,s=(0,Y.useMemo)((function(){return{"Pause Menu":o,Back:o}}),[o]),l=t1();return(0,z.jsx)(s1,{ref:t,focusKey:n,className:r,children:(0,z.jsx)(mb,{children:(0,z.jsx)(rp,{actions:s,children:(0,z.jsx)("div",{className:c1.content,children:(0,z.jsx)("div",{className:c1.menu,children:(0,z.jsxs)(Ap,{direction:gp.Vertical,children:[(0,z.jsx)(PO,{tinted:!0,src:"Media/Glyphs/ArrowRight.svg",theme:DO,onSelect:o,children:(0,z.jsx)(qc.Editor.BACK_TO_EDITOR,{})}),(0,z.jsx)(PO,{tinted:!0,src:"Media/Glyphs/Pen.svg",theme:DO,onSelect:a,children:(0,z.jsx)(qc.Editor.NEW_MAP,{})}),(0,z.jsx)(PO,{tinted:!0,src:"Media/Glyphs/Gear.svg",theme:DO,onSelect:function(){return i(pte.options)},children:(0,z.jsx)(qc.Menu.OPTIONS,{})}),(0,z.jsx)(PO,{tinted:!0,src:"Media/Glyphs/Close.svg",theme:DO,onSelect:l,children:(0,z.jsx)(qc.Menu.EXIT_GAME,{})})]})})})})})})}));oe.add("game-ui/menu/components/editor-pause-screen/editor-pause-screen.tsx",{get EditorPauseScreen(){return u1},set EditorPauseScreen(e){u1=e}});let d1={"beta-pill":"beta-pill_OSA",betaPill:"beta-pill_OSA"};oe.add("game-ui/common/beta-element/beta-pill/beta-pill.module.scss",{get classes(){return d1},set classes(e){Object.assign(d1,e)}});const f1=d1;function m1(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function g1(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){m1(e,t,n[t])}))}return e}function h1(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var p1=function(e){return(0,z.jsx)(HG,{children:(0,z.jsx)(v1,h1(g1({},e),{children:(0,z.jsx)(qc.Menu.BETA_LABEL,{})}))})},v1=function(e){var t=e.children,n=e.className;return(0,z.jsx)("div",{className:_d()(f1.betaPill,n),children:t})};oe.add("game-ui/common/beta-element/beta-pill/beta-pill.tsx",{get ModdingBetaPill(){return p1},set ModdingBetaPill(e){p1=e},get BetaPill(){return v1},set BetaPill(e){v1=e}});let b1={"locked-badge":"locked-badge_hmR",lockedBadge:"locked-badge_hmR"};oe.add("game-ui/game/components/asset-menu/badges/locked-badge.module.scss",{get classes(){return b1},set classes(e){Object.assign(b1,e)}});const y1=b1;var x1=Cj({Lock:"Media/Glyphs/Lock.svg"}),_1=function(e){var t=e.style,n=e.className;return(0,z.jsx)(tb,{src:x1.Lock,className:_d()(y1.lockedBadge,n),style:t})};oe.add("game-ui/game/components/asset-menu/badges/locked-badge.tsx",{get LockedBadge(){return _1},set LockedBadge(e){_1=e}});let j1={"tab-bar":"tab-bar_oPw",tabBar:"tab-bar_oPw",tab:"tab_Hrb",lock:"lock_F5I"};oe.add("game-ui/common/tabs/tabs.module.scss",{get classes(){return j1},set classes(e){Object.assign(j1,e)}});const O1=j1;function E1(e){var t=e.tabs,n=e.selectedTab,r=e.selectPreviousSound,i=void 0===r?Lp.selectPreviousItem:r,o=e.selectNextSound,a=void 0===o?Lp.selectNextItem:o,s=e.children,l=e.onSelect,c=0===t.length||1===t.length&&t[0]===n,u=(0,Y.useMemo)((function(){return{"Switch Tab":function(e){if(0!==e){var r=null!=n?t.indexOf(n):-1,o=e<0?lC(t,r,!0):aC(t,r,!0);null!=o&&o!==n&&(l(o),kp(e<0?i:a))}}}}),[l,a,i,n,t]);return(0,z.jsx)(rp,{actions:u,disabled:c,children:s})}var S1=function(e){var t=e.className,n=e.children;return(0,z.jsx)("div",{className:_d()(O1.tabBar,t),children:n})};function T1(e){var t=e.id,n=e.selectedId,r=e.uiTag,i=e.disabled,o=e.locked,a=e.selectSound,s=e.className,l=e.children,c=e.onSelect,u=t===n,d=(0,Y.useCallback)((function(){c(t),r&&nh(r)}),[t,c,r]);return(0,z.jsx)(tk,{uiTag:r,active:!i,children:(0,z.jsxs)(Qp,{focusKey:Hh,disabled:i,selectSound:a,className:_d()(O1.tab,u&&"selected",s),onSelect:d,children:[l,o&&(0,z.jsx)(_1,{className:O1.lock})]})})}function I1(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function w1(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function P1(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function C1(e){var t=e.component,n=e.value,r=e.groupValue,i=e.onChange,o=e.onToggleSelected,a=P1(e,["component","value","groupValue","onChange","onToggleSelected"]),s=(0,Y.useCallback)((function(e){e?i&&i(n):o&&o(n)}),[n,i,o]);return Y.createElement(t,w1(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){I1(e,t,n[t])}))}return e}({},a),{checked:n===r,onChange:s}))}oe.add("game-ui/common/tabs/tabs.tsx",{get TabNav(){return E1},set TabNav(e){E1=e},get TabBar(){return S1},set TabBar(e){S1=e},get Tab(){return T1},set Tab(e){T1=e}}),oe.add("game-ui/common/input/toggle/group-toggle.tsx",{get GroupToggle(){return C1},set GroupToggle(e){C1=e}});let N1={toggle:"toggle_H7r item-mouse-states_Fmi",bullet:"bullet_rDK"};oe.add("game-ui/common/input/toggle/radio-toggle/radio-toggle.module.scss",{get classes(){return N1},set classes(e){Object.assign(N1,e)}});const A1=N1;function L1(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function M1(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){L1(e,t,n[t])}))}return e}function k1(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function R1(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var D1=function(e){var t=e.checked,n=e.disabled,r=e.theme,i=e.style,o=e.className,a=R1(e,["checked","disabled","theme","style","className"]),s=(0,Y.useMemo)((function(){return M1({},A1,r)}),[r]);return(0,z.jsx)(ov,k1(M1({},a),{checked:t,disabled:n,style:i,className:_d()(s.toggle,o),children:(0,z.jsx)("div",{className:_d()(s.bullet,t&&"checked",n&&"disabled")})}))};oe.add("game-ui/common/input/toggle/radio-toggle/radio-toggle.tsx",{get RadioToggle(){return D1},set RadioToggle(e){D1=e}});var F1=Y.createContext({onOptionMouseEnter:function(){},onOptionMouseLeave:function(){}});oe.add("game-ui/menu/components/options-screen/option-page/option-page-context.ts",{get OptionSectionContext(){return F1},set OptionSectionContext(e){F1=e}});let U1={field:"field_amr field_cjf",label:"label_VSW label_T__"};oe.add("game-ui/menu/components/shared/game-options/field/row-field.module.scss",{get classes(){return U1},set classes(e){Object.assign(U1,e)}});const G1=U1;function B1(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var V1=function(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){B1(e,t,n[t])}))}return e}({},Xp),{hover:null,focus:null}),H1=function(e){var t=e.id,n=e.label,r=e.theme,i=void 0===r?G1:r,o=e.disabled,a=e.className,s=e.children,l=e.onClick,c=(0,Y.useContext)(F1),u=(0,Y.useCallback)((function(){t&&c.onOptionMouseEnter(t),kp(Lp.hoverItem)}),[t,c]),d=(0,Y.useCallback)((function(){return t&&c.onOptionMouseLeave(t)}),[t,c]),f=(0,Y.useCallback)((function(e){!o&&l&&l(e)}),[o,l]);return(0,z.jsxs)(Yv,{focusKey:o?Hh:t,focusSound:Lp.hoverItem,className:_d()(i.field,o&&"disabled",a),onMouseEnter:u,onMouseLeave:d,onClick:f,children:[(0,z.jsx)("div",{className:i.label,children:null!=n?n:null!=t&&(0,z.jsx)(qc.Options.OPTION,{hash:t})}),s]})};oe.add("game-ui/menu/components/shared/game-options/field/field.tsx",{get optionButtonSounds(){return V1},set optionButtonSounds(e){V1=e},get OptionField(){return H1},set OptionField(e){H1=e}});let K1={toggle:"toggle_ATa","radio-toggle":"radio-toggle_TY5 toggle_H7r item-mouse-states_Fmi",radioToggle:"radio-toggle_TY5 toggle_H7r item-mouse-states_Fmi",bullet:"bullet_DoE bullet_rDK"};oe.add("game-ui/menu/components/shared/game-options/toggle-field/toggle-field.module.scss",{get classes(){return K1},set classes(e){Object.assign(K1,e)}});const W1=K1;function z1(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Y1(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){z1(e,t,n[t])}))}return e}function $1(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function q1(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var X1=function(e){var t=e.value,n=e.disabled,r=e.onChange,i=q1(e,["value","disabled","onChange"]),o=(0,Y.useCallback)((function(){r(!t)}),[r,t]);return(0,z.jsx)(H1,$1(Y1({},i),{onClick:o,disabled:n,children:(0,z.jsx)(fv,{checked:t,className:W1.toggle,onChange:r,disabled:n})}))};function Q1(e){var t=e.value,n=e.groupValue,r=e.disabled,i=e.onChange,o=e.onToggleSelected,a=q1(e,["value","groupValue","disabled","onChange","onToggleSelected"]),s=(0,Y.useCallback)((function(){i(t)}),[i,t]);return(0,z.jsx)(H1,$1(Y1({},a),{onClick:s,disabled:r,children:(0,z.jsx)(C1,{theme:{toggle:W1.radioToggle,bullet:W1.bullet},component:D1,onChange:i,onToggleSelected:o,value:t,groupValue:n,disabled:r,className:W1.radioToggle})}))}oe.add("game-ui/menu/components/shared/game-options/toggle-field/toggle-field.tsx",{get ToggleField(){return X1},set ToggleField(e){X1=e},get RadioGroupToggleField(){return Q1},set RadioGroupToggleField(e){Q1=e}});let Z1={enter:"enter_vUK enter_kO6","enter-active":"enter-active_K1n enter-active_lrI",enterActive:"enter-active_K1n enter-active_lrI",exit:"exit_NNr exit_Von","exit-active":"exit-active_kYK exit-active_jtN",exitActive:"exit-active_kYK exit-active_jtN",base:"base_V9Q"};oe.add("game-ui/menu/transitions/shrink-fade-children.module.scss",{get classes(){return Z1},set classes(e){Object.assign(Z1,e)}});const J1=Z1;let e2={"sub-screen":"sub-screen__iU",subScreen:"sub-screen__iU",header:"header_DFK child-opacity-transition_nkS",title:"title_TgD","header-button":"header-button_Hid",headerButton:"header-button_Hid","back-button":"back-button_sEa header-button_Hid",backButton:"back-button_sEa header-button_Hid",content:"content_Ds0","header-aside":"header-aside_Pkh",headerAside:"header-aside_Pkh"};oe.add("game-ui/menu/components/shared/sub-screen/sub-screen.module.scss",{get classes(){return e2},set classes(e){Object.assign(e2,e)}});const t2=e2;var n2=new Wh("CONTENT_KEY"),r2=Y.forwardRef((function(e,t){var n=e.focusKey,r=e.title,i=e.header,o=e.className,a=e.children,s=e.onClose;yj(bj);var l=Pg();return(0,z.jsx)(hj,{focusKey:n,children:(0,z.jsx)(wj,{children:(0,z.jsx)(ap,{onAction:s,children:(0,z.jsx)(Cm,{styles:J1,children:(0,z.jsx)(Yv,{ref:t,className:_d()(t2.subScreen,o),children:(0,z.jsxs)(Ap,{initialFocused:n2,children:[(0,z.jsxs)("div",{className:t2.header,children:[!l&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Menu.BACK,{}),children:(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:"Media/Glyphs/TriangleArrowLeft.svg",className:t2.backButton,onSelect:s})}),(0,z.jsx)("div",{className:t2.title,children:r}),!!i&&(0,z.jsx)("div",{className:t2.headerAside,children:i})]}),(0,z.jsx)(Yv,{focusKey:n2,className:t2.content,children:a})]})})})})})})}));oe.add("game-ui/menu/components/shared/sub-screen/sub-screen.tsx",{get SubScreen(){return r2},set SubScreen(e){r2=e}});let i2={"empty-state":"empty-state_GEy",emptyState:"empty-state_GEy"};oe.add("game-ui/common/empty-state/empty-state.module.scss",{get classes(){return i2},set classes(e){Object.assign(i2,e)}});const o2=i2;var a2=function(e){var t=e.children,n=e.className;return(0,z.jsx)("div",{className:_d()(o2.emptyState,n),children:t})};oe.add("game-ui/common/empty-state/empty-state.tsx",{get EmptyState(){return a2},set EmptyState(e){a2=e}});let s2={label:"label_sAz",container:"container_R_O","beta-pill":"beta-pill_E9M",betaPill:"beta-pill_E9M"};oe.add("game-ui/menu/widgets/label/label.module.scss",{get classes(){return s2},set classes(e){Object.assign(s2,e)}});const l2=s2;var c2=function(e){var t=e.props,n=(0,z.jsxs)("div",{className:l2.container,children:[(0,z.jsx)("div",{className:_d()(l2.label,"label-level-"+t.level),children:(0,z.jsx)(ku,{value:t.displayName})}),t.beta&&(0,z.jsx)(p1,{className:l2.betaPill})]});return t.tooltip?(0,z.jsx)(jh,{tooltip:(0,z.jsx)(ku,{value:t.tooltip}),children:n}):n};oe.add("game-ui/menu/widgets/label/Label.tsx",{get Label(){return c2},set Label(e){c2=e}});let u2={breadcrumbs:"breadcrumbs_xcd"};oe.add("game-ui/menu/widgets/breadcrumbs/breadcrumbs.module.scss",{get classes(){return u2},set classes(e){Object.assign(u2,e)}});const d2=u2;var f2=function(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}({},FR.Label,c2),m2=function(e){var t=e.children,n=e.parent;return(0,z.jsx)("div",{className:d2.breadcrumbs,children:(0,z.jsx)(OD,{parent:n,data:t,components:f2})})};oe.add("game-ui/menu/widgets/breadcrumbs/breadcrumbs.tsx",{get Breadcrumbs(){return m2},set Breadcrumbs(e){m2=e}});let g2={button:"button_WWa",icon:"icon_OPJ",label:"label_vrX"};oe.add("game-ui/menu/themes/secondary-button.module.scss",{get classes(){return g2},set classes(e){Object.assign(g2,e)}});const h2=g2;let p2={buttons:"buttons_hd7",button:"button_SH8"};oe.add("game-ui/menu/widgets/button/button.module.scss",{get classes(){return p2},set classes(e){Object.assign(p2,e)}});const v2=p2;function b2(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function y2(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){b2(e,t,n[t])}))}return e}function x2(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var _2=function(e){return(0,z.jsx)(E2,{children:(0,z.jsx)(S2,y2({},e))})},j2=function(e){return(0,z.jsx)(E2,{children:(0,z.jsx)(S2,y2({},e))})},O2=function(e){var t=uD(e.parent,e.path);return(0,z.jsx)(E2,{children:e.children.map((function(e){return(0,Y.createElement)(S2,x2(y2({},e),{key:e.path,parent:t,path:e.path}))}))})},E2=function(e){var t=e.children;return(0,z.jsx)("div",{className:v2.buttons,children:t})},S2=function(e){var t=RR(zR,uD(e.parent,e.path));return(0,z.jsx)(T2,{id:e.path,disabled:e.props.disabled,onSelect:t,confirmationMessage:null!=e.props.confirmationMessage?(0,z.jsx)(ku,{value:e.props.confirmationMessage}):null,children:(0,z.jsx)(ku,{value:e.props.displayName})})},T2=function(e){var t=e.id,n=e.disabled,r=e.confirmationMessage,i=e.children,o=e.onSelect,a=(0,Y.useContext)(dO),s=(0,Y.useContext)(F1),l=(0,Y.useCallback)((function(){"string"==typeof t&&s.onOptionMouseEnter(t)}),[t,s]),c=(0,Y.useCallback)((function(){"string"==typeof t&&s.onOptionMouseLeave(t)}),[t,s]),u=(0,Y.useCallback)((function(){null!=r?a.showDialog((0,z.jsx)(OO,{title:(0,z.jsx)(qc.Common.WARNING,{}),message:r,onConfirm:o})):o()}),[a,r,o]);return(0,z.jsx)(Qp,{focusKey:t,disabled:n,theme:h2,className:v2.button,onSelect:u,onMouseEnter:l,onMouseLeave:c,children:i})};oe.add("game-ui/menu/widgets/button/button.tsx",{get BoundButton(){return _2},set BoundButton(e){_2=e},get BoundButtonWithConfirmation(){return j2},set BoundButtonWithConfirmation(e){j2=e},get BoundButtonRow(){return O2},set BoundButtonRow(e){O2=e}});let I2={divider:"divider_wuh"};oe.add("game-ui/menu/widgets/divider/divider.module.scss",{get classes(){return I2},set classes(e){Object.assign(I2,e)}});const w2=I2;var P2=function(){return(0,z.jsx)("div",{className:w2.divider})};oe.add("game-ui/menu/widgets/divider/divider.tsx",{get Divider(){return P2},set Divider(e){P2=e}});let C2={"dropdown-toggle":"dropdown-toggle_V9z dropdown-toggle_prl value-field_yJi value_PW_",dropdownToggle:"dropdown-toggle_V9z dropdown-toggle_prl value-field_yJi value_PW_",indicator:"indicator_Xmj","dropdown-menu":"dropdown-menu_jf2 dropdown-menu_Swd",dropdownMenu:"dropdown-menu_jf2 dropdown-menu_Swd","dropdown-item":"dropdown-item_sZT undefined",dropdownItem:"dropdown-item_sZT undefined"};oe.add("game-ui/menu/themes/dropdown.module.scss",{get classes(){return C2},set classes(e){Object.assign(C2,e)}});const N2=C2;let A2={field:"field_MBO field_UuC",label:"label_DGc label_ZLb"};oe.add("game-ui/menu/widgets/field/row-field.module.scss",{get classes(){return A2},set classes(e){Object.assign(A2,e)}});const L2=A2;function M2(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function k2(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){M2(e,t,n[t])}))}return e}function R2(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var D2=R2(k2({},Xp),{hover:null,focus:null});function F2(e){return(0,z.jsx)(G2,R2(k2({},e.props),{id:e.path,label:(0,z.jsx)(ku,{value:e.props.displayName}),children:e.props.value}))}function U2(e){return(0,z.jsx)(G2,R2(k2({},e.props),{id:e.path,label:(0,z.jsx)(ku,{value:e.props.displayName}),children:(0,z.jsx)(ku,{value:e.props.value})}))}var G2=function(e){var t=e.id,n=e.label,r=e.theme,i=void 0===r?L2:r,o=e.disabled,a=e.className,s=e.children,l=e.onClick,c=(0,Y.useContext)(F1),u=(0,Y.useCallback)((function(){"string"==typeof t&&c.onOptionMouseEnter(t),kp(Lp.hoverItem)}),[t,c]),d=(0,Y.useCallback)((function(){"string"==typeof t&&c.onOptionMouseLeave(t)}),[t,c]),f=(0,Y.useCallback)((function(e){!o&&l&&l(e)}),[o,l]);return(0,z.jsxs)(Yv,{className:_d()(i.field,o&&"disabled",a),focusKey:o?Hh:t,focusSound:Lp.hoverItem,onMouseEnter:u,onMouseLeave:d,onClick:f,children:[(0,z.jsx)("div",{className:i.label,children:n}),s]})};oe.add("game-ui/menu/widgets/field/field.tsx",{get optionButtonSounds(){return D2},set optionButtonSounds(e){D2=e},get ValueField(){return F2},set ValueField(e){F2=e},get LocalizedValueField(){return U2},set LocalizedValueField(e){U2=e},get OptionField(){return G2},set OptionField(e){G2=e}});let B2={dropdown:"dropdown_iVn"};oe.add("game-ui/menu/widgets/dropdown-field/dropdown-field.module.scss",{get classes(){return B2},set classes(e){Object.assign(B2,e)}});const V2=B2;function H2(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function K2(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){H2(e,t,n[t])}))}return e}function W2(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function z2(e){return(0,z.jsx)($2,K2({items:e.props.enumMembers,value:e.props.value},e))}function Y2(e){return(0,z.jsx)($2,K2({items:e.props.items,value:e.props.value},e))}function $2(e){var t=e.items.findIndex((function(t){return el(t.value,e.value)})),n=-1!==t?e.items[t]:null,r=RR(YR,uD(e.parent,e.path));return(0,z.jsx)(G2,W2(K2({},e.props),{id:e.path,label:(0,z.jsx)(ku,{value:e.props.displayName}),children:(0,z.jsx)(SE,{focusKey:e.props.disabled?Hh:Kh,initialFocused:t,theme:N2,content:e.items.filter((function(e){return!e.disabled})).map((function(e,t){return(0,z.jsx)(RE,{focusKey:t,value:e.value,selected:!!n&&el(n.value,e.value),onChange:r,children:q2(e)},t)})),children:(0,z.jsx)(CE,{disabled:e.props.disabled,sounds:D2,className:V2.dropdown,children:q2(n)})})}))}function q2(e){return e?(0,z.jsx)(ku,{value:e.displayName}):null}oe.add("game-ui/menu/widgets/dropdown-field/dropdown-field.tsx",{get BoundEnumField(){return z2},set BoundEnumField(e){z2=e},get BoundDropdownField(){return Y2},set BoundDropdownField(e){Y2=e}});let X2={field:"field_G2v value-field_yJi",value:"value_kpD value_PW_",unset:"unset_Ksk","clear-button":"clear-button_wAo secondary-button_Kvj",clearButton:"clear-button_wAo secondary-button_Kvj"};oe.add("game-ui/menu/widgets/input-binding-field/input-binding-field.module.scss",{get classes(){return X2},set classes(e){Object.assign(X2,e)}});const Q2=X2;function Z2(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function J2(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Z2(e,t,n[t])}))}return e}function e3(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function t3(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function n3(e){var t=uD(e.parent,e.path),n=RR(oc,t),r=RR(ac,t);return(0,z.jsx)(r3,e3(J2({},e.props),{id:e.path,label:(0,z.jsx)(ku,{value:e.props.displayName}),onSelect:n,onUnset:e.props.canBeEmpty?r:void 0}))}var r3=function(e){var t=e.group,n=(e.canBeEmpty,e.value),r=e.disabled,i=e.onSelect,o=e.onUnset,a=t3(e,["group","canBeEmpty","value","disabled","onSelect","onUnset"]),s=(0,Y.useMemo)((function(){return{"Unset Binding":o}}),[o]),l=Pg(),c=yk();return(0,z.jsx)(rp,{actions:s,children:(0,z.jsx)(G2,e3(J2({},a),{disabled:r,onClick:i,children:(0,z.jsxs)("div",{className:_d()(Q2.field,0===n.length&&Q2.unset),children:[(0,z.jsx)(Qp,{className:Q2.value,onSelect:i,onClick:iv,children:(0,z.jsx)(hM,{group:t,path:n,gamepadType:c})}),!l&&null!=o&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Options.UNSET_BINDING_TOOLTIP,{}),children:(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:"Media/Glyphs/Close.svg",className:Q2.clearButton,onSelect:o,onClick:iv})})]})}))})};oe.add("game-ui/menu/widgets/input-binding-field/input-binding-field.tsx",{get BoundInputBindingField(){return n3},set BoundInputBindingField(e){n3=e}});let i3={"modding-toolchain-button":"modding-toolchain-button_mVF",moddingToolchainButton:"modding-toolchain-button_mVF","beta-pill":"beta-pill_Wos",betaPill:"beta-pill_Wos",status:"status_dNw",button:"button_lOS","progress-circle":"progress-circle_D98",progressCircle:"progress-circle_D98"};oe.add("game-ui/menu/widgets/modding/modding-toolchain-button.module.scss",{get classes(){return i3},set classes(e){Object.assign(i3,e)}});const o3=i3;let a3={strokeWidth:"10","progress-circle":"progress-circle_RB6 progress-circle_OLN",progressCircle:"progress-circle_RB6 progress-circle_OLN",circle:"circle_mrY",progress:"progress_bCu progress_mlv"};oe.add("game-ui/menu/widgets/modding/progress-circle.module.scss",{get classes(){return a3},set classes(e){Object.assign(a3,e)}});const s3=a3;function l3(e){var t=xl(ec),n=xl(tc),r=xl(rc),i=xl(nc),o=RR(zR,uD(e.parent,e.path));return(0,z.jsxs)("div",{className:o3.moddingToolchainButton,children:[i!==Rl.Idle&&(0,z.jsx)("div",{className:o3.status,children:(0,z.jsx)(qc.Options.MOD_TOOLCHAIN_STATUS,{hash:Rl[i]})}),c3(n,t),(0,z.jsx)(u3,{id:e.path,state:r,disabled:e.props.disabled,onSelect:o})]})}function c3(e,t){switch(e){case Ml.Bar:return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)("div",{className:o3.status,children:(0,z.jsx)(su,{value:100*t,unit:$c.Percentage})}),(0,z.jsx)("div",{className:o3.progressCircle,children:(0,z.jsx)(OV,{progress:t,max:1,theme:s3})})]});case Ml.Spin:return(0,z.jsx)("div",{className:o3.progressCircle,children:(0,z.jsx)(OV,{progress:100,max:100,indeterminate:!0,theme:s3})});default:return null}}var u3=function(e){var t=e.id,n=e.state,r=e.disabled,i=e.onSelect,o=(0,Y.useCallback)((function(){i(t)}),[t,i]),a=(0,Y.useContext)(F1),s=(0,Y.useCallback)((function(){return a.onOptionMouseEnter("ModdingToolchain.".concat(Dl[n]))}),[a,n]),l=(0,Y.useCallback)((function(){return a.onOptionMouseLeave("ModdingToolchain.".concat(Dl[n]))}),[a,n]);return(0,z.jsxs)(Qp,{focusKey:"ModdingToolchain",disabled:r,theme:h2,className:o3.button,onSelect:o,onMouseEnter:s,onMouseLeave:l,children:[(0,z.jsx)(qc.Options.OPTION,{hash:"ModdingToolchain.".concat(Dl[n])}),(0,z.jsx)(p1,{className:o3.betaPill})]})};oe.add("game-ui/menu/widgets/modding/modding-toolchain-button.tsx",{get BoundModdingToolchainButton(){return l3},set BoundModdingToolchainButton(e){l3=e}});let d3={expandIcon:'"Media/Glyphs/ThickStrokeArrowDown.svg"',collapseIcon:'"Media/Glyphs/ThickStrokeArrowUp.svg"',section:"section_gUk",content:"content_owQ",expandable:"expandable_gK1","title-bar":"title-bar_wU9",titleBar:"title-bar_wU9",title:"title_bwV","toggle-button":"toggle-button_sQk",toggleButton:"toggle-button_sQk","button-space":"button-space_Iht",buttonSpace:"button-space_Iht"};oe.add("game-ui/common/section/section.module.scss",{get classes(){return d3},set classes(e){Object.assign(d3,e)}});const f3=d3;var m3={theme:f3,expanded:!1},g3=Y.createContext(m3);function h3(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function p3(e){return(0,Y.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){h3(e,t,n[t])}))}return e}({},f3,e)}),[e])}oe.add("game-ui/common/section/section-context.ts",{get defaultSectionContext(){return m3},set defaultSectionContext(e){m3=e},get SectionContext(){return g3},set SectionContext(e){g3=e}}),oe.add("game-ui/common/section/section-theme.tsx",{get useSectionTheme(){return p3},set useSectionTheme(e){p3=e}});let v3={section:"section_sop section_gUk",header:"header_l0j undefined",content:"content_flM content_owQ",locked:"locked_UXm",first:"first_l25",last:"last_ZNw","title-bar":"title-bar_J7X title-bar_wU9",titleBar:"title-bar_J7X title-bar_wU9",title:"title_PYv title_bwV","toggle-button":"toggle-button_UA2 toggle-button_sQk",toggleButton:"toggle-button_UA2 toggle-button_sQk"};oe.add("game-ui/common/section/themes/panel-section.module.scss",{get classes(){return v3},set classes(e){Object.assign(v3,e)}});const b3=v3;let y3={base:"base_BM7",enter:"enter_lhm","exit-active":"exit-active_gO8",exitActive:"exit-active_gO8","enter-active":"enter-active_kU5",enterActive:"enter-active_kU5",exit:"exit_MDH"};oe.add("game-ui/common/section/themes/transition.module.scss",{get classes(){return y3},set classes(e){Object.assign(y3,e)}});const x3=y3;function _3(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function j3(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return _3(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _3(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var O3=function(e){var t=e.focusKey,n=e.initialExpanded,r=void 0!==n&&n,i=e.header,o=e.theme,a=void 0===o?b3:o,s=e.transition,l=void 0===s?x3:s,c=e.className,u=e.children,d=e.onToggleExpanded,f=p3(a),m=Y.Children.toArray(u).filter(Boolean).length>0,g=j3((0,Y.useState)(r),2),h=g[0],p=g[1],v=(0,Y.useCallback)((function(){p((function(e){return!e})),kp(Lp.expandPanel),d&&d(!h)}),[h,d]),b=(0,Y.useMemo)((function(){return{theme:f,expandable:m,expanded:h,toggleExpanded:m?v:void 0}}),[m,h,f,v]);return(0,z.jsx)(zv,{className:_d()(f.section,m&&f.expandable,m&&f.expanded,c),children:(0,z.jsx)(g3.Provider,{value:b,children:(0,z.jsx)(op,{expanded:h,expandable:m,onAction:v,children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)(Yv,{focusKey:m?t:Hh,className:_d()(f.header,m&&f.expandable,f.first,(!m||!h)&&f.last),children:i}),m&&(0,z.jsx)(cS,{in:h,children:(0,z.jsx)(aS,{styles:l,children:(0,z.jsx)("div",{children:(0,z.jsx)(zv,{className:_d()(f.content,f.last,f.expandable),children:u})})})})]})})})})};oe.add("game-ui/common/section/expandable-section.tsx",{get ExpandableSection(){return O3},set ExpandableSection(e){O3=e}});var E3=function(e){var t=e.tooltip,n=e.className,r=e.children,i=(0,Y.useContext)(g3),o=i.expanded,a=i.toggleExpanded,s=i.theme,l=null!=a;return(0,z.jsx)(jh,{tooltip:t,children:(0,z.jsxs)(Yv,{focusKey:l?Kh:Hh,className:_d()(s.titleBar,l&&s.expandable,n),onClick:a,children:[l&&(0,z.jsx)("div",{className:s.buttonSpace}),(0,z.jsx)("div",{className:s.title,children:r}),l&&(0,z.jsx)(tb,{src:o?s.collapseIcon:s.expandIcon,className:s.toggleButton})]})})};oe.add("game-ui/common/section/section-header.tsx",{get SectionHeader(){return E3},set SectionHeader(e){E3=e}});let S3={buttons:"buttons_vR9",button:"button_GlF"};oe.add("game-ui/menu/components/shared/game-options/button/buttons-row.module.scss",{get classes(){return S3},set classes(e){Object.assign(S3,e)}});const T3=S3;var I3=function(e){var t=e.buttons,n=e.onSelect;return(0,z.jsx)("div",{className:T3.buttons,children:t.map((function(e){return(0,z.jsx)(w3,{item:e,onSelect:n},e.id)}))})},w3=function(e){var t=e.item,n=e.onSelect,r=(0,Y.useContext)(dO),i=(0,Y.useContext)(F1),o=(0,Y.useCallback)((function(){return i.onOptionMouseEnter(t.id)}),[t.id,i]),a=(0,Y.useCallback)((function(){return i.onOptionMouseLeave(t.id)}),[t.id,i]),s=(0,Y.useCallback)((function(){return n(t.id)}),[t.id,n]),l=(0,Y.useCallback)((function(){t.confirm?r.showDialog((0,z.jsx)(OO,{title:(0,z.jsx)(qc.Common.WARNING,{}),message:(0,z.jsx)(qc.Options.WARNING,{hash:t.id}),onConfirm:s})):n(t.id)}),[r,s,t.confirm,t.id,n]);return(0,z.jsx)(Qp,{focusKey:t.id,disabled:t.disabled,theme:h2,className:T3.button,onSelect:l,onMouseEnter:o,onMouseLeave:a,children:(0,z.jsx)(qc.Options.OPTION,{hash:t.id})})};oe.add("game-ui/menu/components/shared/game-options/button/buttons-row.tsx",{get ButtonRow(){return I3},set ButtonRow(e){I3=e}});let P3={"progress-container":"progress-container_aIu",progressContainer:"progress-container_aIu","progress-label":"progress-label_dOe",progressLabel:"progress-label_dOe","progress-circle":"progress-circle_kUT progress-circle_OLN",progressCircle:"progress-circle_kUT progress-circle_OLN",progress:"progress_Xe2 progress_mlv",complete:"complete_pGO",failure:"failure_D8R",waiting:"waiting_d9O"};oe.add("game-ui/menu/widgets/progress.module.scss",{get classes(){return P3},set classes(e){Object.assign(P3,e)}});const C3=P3;let N3={checkmark:"checkmark_avN",icon:"icon_uou",dependency:"dependency_kvS","dependency-label":"dependency-label_H4z",dependencyLabel:"dependency-label_H4z","dependency-children":"dependency-children_rpG",dependencyChildren:"dependency-children_rpG","dependency-field":"dependency-field_HfG",dependencyField:"dependency-field_HfG",details:"details_G6M",row:"row_kQ3","title-bar":"title-bar_CZv",titleBar:"title-bar_CZv","button-space":"button-space_vdm",buttonSpace:"button-space_vdm","has-children":"has-children_xUg",hasChildren:"has-children_xUg","dependency-status":"dependency-status_V5W",dependencyStatus:"dependency-status_V5W"};oe.add("game-ui/menu/widgets/modding/modding-toolchain-dependency.module.scss",{get classes(){return N3},set classes(e){Object.assign(N3,e)}});const A3=N3;function L3(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function M3(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){L3(e,t,n[t])}))}return e}function k3(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var R3=function(e){var t=e.state,n=e.progress;switch(t){case Ul.Installing:case Ul.Downloading:case Ul.Removing:case Ul.Queued:return(0,z.jsxs)("div",{className:_d()(C3.progressContainer,L3({},C3.waiting,t===Ul.Queued)),children:[(0,z.jsx)(OV,{progress:t!==Ul.Queued?n:100,max:100,theme:C3,indeterminate:-1===n&&t!==Ul.Queued}),-1!==n&&(0,z.jsx)("div",{className:C3.progressLabel,children:(0,z.jsx)(su,{value:n,unit:$c.Percentage})})]});case Ul.Installed:return(0,z.jsx)("div",{className:A3.icon,children:(0,z.jsx)(tb,{className:A3.checkmark,src:"Media/Glyphs/Checkmark.svg"})});case Ul.NotInstalled:return(0,z.jsx)("img",{className:A3.icon,src:"Media/Misc/Error.svg"});case Ul.Outdated:case Ul.Unknown:return(0,z.jsx)("img",{className:A3.icon,src:"Media/Misc/Warning.svg"})}return null},D3={"ModdingSettings.installModdingToolchain":Fl.Install,"ModdingSettings.uninstallModdingToolchain":Fl.Uninstall,"ModdingSettings.repairModdingToolchain":Fl.Repair,"ModdingSettings.updateModdingToolchain":Fl.Update},F3=new Wh("DROPDOWN_TOGGLE"),U3=function(e){var t=e.onAction,n=e.displayName,r=e.value,i=e.children,o=(0,Y.useCallback)((function(e){var n=D3[e];n&&t(n)}),[t]),a=(0,Y.useMemo)((function(){var e=[];return r.action&&(e.push({id:"ModdingSettings.installModdingToolchain",disabled:!(r.action&Fl.Install),confirm:!1}),e.push({id:"ModdingSettings.updateModdingToolchain",disabled:!(r.action&Fl.Update),confirm:!1}),e.push({id:"ModdingSettings.repairModdingToolchain",disabled:!(r.action&Fl.Repair),confirm:!1}),e.push({id:"ModdingSettings.uninstallModdingToolchain",disabled:!(r.action&Fl.Uninstall),confirm:!1})),e.filter((function(e){return!e.disabled}))}),[r.action]);return(0,z.jsxs)(O3,{focusKey:F3,className:_d()(A3.dependencyField,L3({},A3.hasChildren,!!i)),theme:A3,header:(0,z.jsx)(E3,{children:(0,z.jsxs)("div",{className:A3.dependency,children:[(0,z.jsxs)("div",{className:A3.dependencyLabel,cohinline:"cohinline",children:[(0,z.jsx)(ku,{value:n}),(0,z.jsx)("small",{children:(0,z.jsx)(ku,{value:r.version})})]}),(0,z.jsxs)("div",{className:A3.dependencyStatus,children:[(0,z.jsx)("small",{children:(0,z.jsx)(ku,{value:r.details})}),(0,z.jsx)(R3,M3({},r))]})]})}),children:[(e.children||!!a.length)&&(0,z.jsx)("div",{className:A3.details,children:(0,z.jsx)("div",{className:A3.row,children:a.length?(0,z.jsx)(Ap,{children:(0,z.jsx)(I3,{buttons:a,onSelect:o})}):(0,z.jsx)("div",{})})}),e.children]})},G3=function(e){var t=uD(e.parent,e.path),n=(0,Y.useCallback)((function(e){"number"==typeof e&&cc(t,e)}),[t]);return(0,z.jsx)(U3,k3(M3({},e.props),{onAction:n,children:!!e.children.length&&(0,z.jsx)("div",{className:A3.dependencyChildren,children:(0,z.jsx)(Ap,{children:(0,z.jsx)(a5,{parent:e.parent,data:e.children})})})}))};oe.add("game-ui/menu/widgets/modding/modding-toolchain-dependency.tsx",{get KEY(){return F3},set KEY(e){F3=e},get ModdingToolchainDependency(){return U3},set ModdingToolchainDependency(e){U3=e},get BoundModdingToolchainDependency(){return G3},set BoundModdingToolchainDependency(e){G3=e}});let B3={slider:"slider_fKm slider_pUS",range:"range_KXa range_iUN"};oe.add("game-ui/menu/themes/slider.module.scss",{get classes(){return B3},set classes(e){Object.assign(B3,e)}});const V3=B3;let H3={value:"value_hdd",slider:"slider_KjX"};oe.add("game-ui/menu/widgets/slider-field/slider-field.module.scss",{get classes(){return H3},set classes(e){Object.assign(H3,e)}});const K3=H3;function W3(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function z3(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){W3(e,t,n[t])}))}return e}function Y3(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function $3(e){return(0,z.jsx)(X3,z3({},e))}function q3(e){return(0,z.jsx)(X3,z3({},e))}var X3=function(e){var t,n=(0,Y.useMemo)((function(){return Object.values($c).find((function(t){return t===e.props.unit}))}),[e.props.unit]),r=lF(null!==(t=e.props.step)&&void 0!==t?t:1),i=e.props.scaleDragVolume?iF:rF,o=RR(YR,uD(e.parent,e.path));return(0,z.jsxs)(G2,Y3(z3({},e.props),{id:e.path,label:(0,z.jsx)(ku,{value:e.props.displayName}),children:[(0,z.jsx)("div",{className:K3.value,children:(0,z.jsx)(su,{value:e.props.value,unit:n})}),(0,z.jsx)(HL,{children:(0,z.jsx)(oF,{value:e.props.value,start:e.props.min,end:e.props.max,gamepadStep:e.props.step,disabled:e.props.disabled,valueTransformer:r,sounds:i,theme:V3,className:K3.slider,onChange:o})})]}))};oe.add("game-ui/menu/widgets/slider-field/slider-field.tsx",{get BoundIntSliderField(){return $3},set BoundIntSliderField(e){$3=e},get BoundFloatSliderField(){return q3},set BoundFloatSliderField(e){q3=e}});let Q3={toggle:"toggle_th_","radio-toggle":"radio-toggle_M9z toggle_H7r item-mouse-states_Fmi",radioToggle:"radio-toggle_M9z toggle_H7r item-mouse-states_Fmi",bullet:"bullet_TAG bullet_rDK"};oe.add("game-ui/menu/widgets/toggle-field/toggle-field.module.scss",{get classes(){return Q3},set classes(e){Object.assign(Q3,e)}});const Z3=Q3;function J3(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function e5(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function t5(e){var t=RR(YR,uD(e.parent,e.path)),n=(0,Y.useCallback)((function(){kp(Lp.selectToggle),t(!e.props.value)}),[t,e.props.value]);return(0,z.jsx)(G2,e5(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){J3(e,t,n[t])}))}return e}({},e.props),{id:e.path,label:(0,z.jsx)(ku,{value:e.props.displayName}),onClick:n,children:(0,z.jsx)(fv,{checked:e.props.value,className:Z3.toggle,onChange:t,disabled:e.props.disabled})}))}function n5(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function r5(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){n5(e,t,n[t])}))}return e}function i5(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}oe.add("game-ui/menu/widgets/toggle-field/toggle-field.tsx",{get BoundToggleField(){return t5},set BoundToggleField(e){t5=e}});var o5,a5=function(e){var t=e.parent,n=e.data,r=(0,Y.useMemo)((function(){var e,r=-1;return n.reduce((function(n,i,o){if(i.props.__Type===FR.Label){var a=i.props.level,s=t+".breadcrumbs."+o;0===a?(e=i5(r5({},i),{path:s,props:{__Type:FR.Breadcrumbs},children:[i5(r5({},i),{path:s+"."+o})]}),n.push(e)):e&&a===r?(e=i5(r5({},e),{path:s,children:e.children.filter((function(e){return e.props.level!==a})).concat(i)}),n.push(e)):null==e||e.children.push(i5(r5({},i),{path:s+"."+o})),r=a}else n.push(i);return n}),[])}),[n,t]);return(0,z.jsx)(OD,{parent:t,components:s5,data:r})},s5=(n5(o5={},FR.Button,_2),n5(o5,FR.ButtonRow,O2),n5(o5,Nl.ButtonWithConfirmation,j2),n5(o5,FR.FloatSliderField,q3),n5(o5,FR.IntSliderField,$3),n5(o5,FR.Divider,P2),n5(o5,FR.Label,c2),n5(o5,FR.Breadcrumbs,m2),n5(o5,FR.ToggleField,t5),n5(o5,FR.EnumField,z2),n5(o5,Nl.InputBindingField,n3),n5(o5,Nl.DropdownField,Y2),n5(o5,FR.ValueField,F2),n5(o5,FR.LocalizedValueField,U2),n5(o5,Nl.ScreenResolutionDropdownField,Y2),n5(o5,Nl.ModdingToolchainButton,l3),n5(o5,Nl.ModdingToolchainDependency,G3),o5);oe.add("game-ui/menu/widgets/option-widget-renderer.tsx",{get OptionWidgetListRenderer(){return a5},set OptionWidgetListRenderer(e){a5=e},get optionsWidgetComponents(){return s5},set optionsWidgetComponents(e){s5=e}});let l5={"option-page-header":"option-page-header_fSe",optionPageHeader:"option-page-header_fSe","option-page-sub-header":"option-page-sub-header_FIo",optionPageSubHeader:"option-page-sub-header_FIo","sections-tabs":"sections-tabs_EK2",sectionsTabs:"sections-tabs_EK2",tab:"tab_P7S",first:"first_vLK",last:"last_BSJ"};oe.add("game-ui/menu/components/options-screen/option-page/option-page-header.module.scss",{get classes(){return l5},set classes(e){Object.assign(l5,e)}});const c5=l5;var u5=function(e){var t=e.sections,n=e.subHeader,r=e.selectedId,i=e.className,o=e.onSelect;return(0,z.jsxs)("div",{className:_d()(c5.optionPageHeader,i),children:[t.length>1?(0,z.jsx)("div",{className:_d()(c5.sectionsTabs),children:t.map((function(e,n){return(0,z.jsx)(Qp,{focusKey:Hh,selected:r===e.id,className:_d()(c5.tab,0===n&&c5.first,n===t.length-1&&c5.last),onSelect:function(){return o(e.id)},children:(0,z.jsx)(qc.Options.TAB,{hash:e.id})},n)}))}):(0,z.jsx)("div",{}),!!n&&(0,z.jsx)("div",{className:c5.optionPageSubHeader,children:n})]})};oe.add("game-ui/menu/components/options-screen/option-page/option-page-header.tsx",{get OptionPageHeader(){return u5},set OptionPageHeader(e){u5=e}});let d5={"option-page":"option-page_CW8",optionPage:"option-page_CW8","main-column":"main-column_D0A",mainColumn:"main-column_D0A",scrollable:"scrollable_Ptf","info-column":"info-column_uQ0",infoColumn:"info-column_uQ0","info-title":"info-title_a3p",infoTitle:"info-title_a3p","info-description":"info-description_wwd",infoDescription:"info-description_wwd"};oe.add("game-ui/menu/components/options-screen/option-page/option-page.module.scss",{get classes(){return d5},set classes(e){Object.assign(d5,e)}});const f5=d5;function m5(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function g5(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return m5(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return m5(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var h5=function(e){var t=e.page,n=e.selectedSectionId,r=e.className,i=e.isSearch,o=e.subHeader,a=e.onSelectSection,s=t.sections.find((function(e){return e.id===n})),l=g5((0,Y.useState)(!1),2),c=l[0],u=l[1],d=g5((0,Y.useState)(null),2),f=d[0],m=d[1],g=(0,Y.useCallback)((function(e){"string"==typeof e&&m(e)}),[]),h=Pg(),p=g5((0,Y.useState)(null),2),v=p[0],b=p[1],y=null!=v?v:c&&h?f:null,x=(0,Y.useMemo)((function(){return{onOptionMouseEnter:function(e){b(e)},onOptionMouseLeave:function(e){b((function(t){return t===e?null:t}))}}}),[]),_=cD("options"),j=xl(Vl);return(0,z.jsx)(Tg,{onFocusChange:u,children:(0,z.jsxs)("div",{className:_d()(f5.optionPage,r),children:[(0,z.jsx)("div",{className:f5.mainColumn,children:(0,z.jsxs)(Ap,{children:[!i&&(o||t.sections.length>1)&&(0,z.jsx)(u5,{sections:t.sections,selectedId:n,className:f5.header,onSelect:a,subHeader:o}),i&&!j.length?(0,z.jsx)(a2,{children:(0,z.jsx)("div",{children:(0,z.jsx)(qc.Options.SEARCH,{hash:"nothing found"})})}):(0,z.jsx)(gE,{className:f5.scrollable,children:null!=s&&(0,z.jsx)(F1.Provider,{value:x,children:(0,z.jsx)(Ip,{focused:f,direction:gp.Vertical,onChange:g,onRefocus:wp,children:(0,z.jsx)(a5,{parent:_,data:j})})})},n)]})}),(0,z.jsx)("div",{className:f5.infoColumn,children:null!=y&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)("div",{className:f5.infoTitle,children:(0,z.jsx)(qc.Options.OPTION,{hash:y})}),(0,z.jsx)("div",{className:f5.infoDescription,children:(0,z.jsx)(qc.Options.OPTION_DESCRIPTION,{hash:y})})]})})]})})};oe.add("game-ui/menu/components/options-screen/option-page/option-page.tsx",{get OptionPage(){return h5},set OptionPage(e){h5=e}});let p5={input:"input_sYI",label:"label_FEo",container:"container_Hgg"};oe.add("game-ui/common/input/text/ellipsis-text-input/themes/default.module.scss",{get classes(){return p5},set classes(e){Object.assign(p5,e)}});const v5=p5;function b5(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function y5(e){return(0,Y.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){b5(e,t,n[t])}))}return e}({},v5,e)}),[e])}oe.add("game-ui/common/input/text/ellipsis-text-input/ellipsis-text-input-theme.tsx",{get useTextInputTheme(){return y5},set useTextInputTheme(e){y5=e}});let x5={"search-input":"search-input_Z06",searchInput:"search-input_Z06","search-input-clear":"search-input-clear_VxJ",searchInputClear:"search-input-clear_VxJ"};oe.add("game-ui/menu/components/options-screen/options-search.module.scss",{get classes(){return x5},set classes(e){Object.assign(x5,e)}});const _5=x5;function j5(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function O5(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return j5(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return j5(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var E5=Cj({Clear:"Media/Glyphs/Clear.svg"}),S5=function(){var e=vc(),t=xl(Bl),n=O5((0,Y.useState)(""),2),r=n[0],i=n[1],o=O5((0,Y.useState)(),2),a=o[0],s=o[1],l=O5((0,Y.useState)((function(){return new Set})),2),c=l[0],u=l[1],d=(0,Y.useCallback)((function(e){e.length<2&&s(void 0),i(e)}),[]);return(0,Y.useEffect)((function(){var n=[],i=new Set;r.length>=2?(t.forEach((function(t){return t.sections.forEach((function(o){o.items.forEach((function(o){if("id"in o.displayName&&!o.searchHidden){var s,l=null===(s=e.translate(o.displayName.id||""))||void 0===s?void 0:s.toLowerCase();(null==l?void 0:l.includes(r.trim().toLowerCase()))&&(a&&t.id!==a||n.push(o.id),i.add(t.id))}}))}))})),lc(n,r),u(i)):(lc([]),u(i))}),[t,r,a,e]),{setSearchQuery:d,searchQuery:r,matchingPages:c,focusedPage:a,setFocusedPage:s,isSearching:r.length>=2}},T5=function(e){var t=e.search,n=t.isSearching,r=t.focusedPage,i=t.setFocusedPage,o=t.matchingPages,a=null;if(n&&(o.size>1||r&&!o.has(r)&&o.size>0)){var s={id:"All results",sections:[]};a=(0,z.jsx)(k5,{item:s,selected:!r,beta:s.beta,onSelect:function(){r&&i(void 0)}},s.id)}return a},I5=function(e){var t=e.search,n=t.searchQuery,r=t.setSearchQuery,i=y5(),o=(0,Y.useCallback)((function(e){r(e)}),[r]);return(0,z.jsxs)(Ap,{children:[(0,z.jsx)(yb,{value:n,onChange:function(e){return r(e.target.value)},placeholder:(0,z.jsx)(qc.Options.SEARCH,{hash:"input placeholder"}),className:_d()(i.input,_5.searchInput)}),n&&(0,z.jsx)(lb,{tinted:!0,src:E5.Clear,className:_5.searchInputClear,onSelect:function(){return o("")}})]})};oe.add("game-ui/menu/components/options-screen/options-search.tsx",{get useSearch(){return S5},set useSearch(e){S5=e},get AllResultsMenuItem(){return T5},set AllResultsMenuItem(e){T5=e},get OptionsSearch(){return I5},set OptionsSearch(e){I5=e}});let w5={content:"content_Mtn",menu:"menu_hb1 child-opacity-transition_nkS",scrollable:"scrollable_Fma",item:"item_pq7",primary:"primary_Q54",detail:"detail_eTp child-opacity-transition_nkS","option-section":"option-section_VzQ",optionSection:"option-section_VzQ","advanced-toggle":"advanced-toggle_fyX",advancedToggle:"advanced-toggle_fyX","advanced-toggle-checked":"advanced-toggle-checked_FFb",advancedToggleChecked:"advanced-toggle-checked_FFb","menu-item-left":"menu-item-left_g1u",menuItemLeft:"menu-item-left_g1u","menu-item-right":"menu-item-right_vNX",menuItemRight:"menu-item-right_vNX"};oe.add("game-ui/menu/components/options-screen/options-screen.module.scss",{get classes(){return w5},set classes(e){Object.assign(w5,e)}});const P5=w5;function C5(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function N5(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function A5(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return C5(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return C5(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var L5=new Wh("menu"),M5=Y.forwardRef((function(e,t){var n=e.focusKey,r=e.className,i=e.onClose,o=xl(Bl),a=xl(Hl),s=o.find((function(e){return e.id===a})),l=xl(Kl),c=null==s?void 0:s.sections.find((function(e){return e.id===l})),u=xl(Vl),d=A5((0,Y.useState)(!1),2),f=d[0],m=d[1],g=S5(),h=g.isSearching,p=g.setSearchQuery,v=g.focusedPage,b=g.setFocusedPage,y=g.matchingPages,x=(0,Y.useCallback)((function(){p(""),i()}),[i,p]),_=(0,Y.useCallback)((function(e){var t,n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"",r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],i=o.find((function(t){return t.id===e})),a=n||null!=i&&i.sections.length>0?null===(t=null==i?void 0:i.sections[0])||void 0===t?void 0:t.id:null;i&&(h?b(i.id):a&&v!==i.id&&sc(i.id,a,r))}),[v,h,o,b]),j=(0,Y.useCallback)((function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(s){var n=s.sections.find((function(t){return t.id===e}));n&&sc(s.id,n.id,t)}}),[s]);(0,Y.useEffect)((function(){var e=u.filter((function(e){return e.props.__Type!==FR.Breadcrumbs})).reduce((function(e,t){return e+(t.props.__Type===FR.ButtonRow?t.children.length:1)}),0)===(null==c?void 0:c.items.length);m(e)}),[u,a,null==c?void 0:c.items,l]);var O=FL(_),E=(0,Y.useCallback)((function(e){l&&(m(e),j(l,e))}),[j,l]),S=(0,Y.useMemo)((function(){return null!=s?s.sections.map((function(e){return e.id})):[]}),[s]),T=(0,Y.useMemo)((function(){var e;return!!(null===(e=null==s?void 0:s.sections.find((function(e){return e.id===l})))||void 0===e?void 0:e.items.some((function(e){return e.isAdvanced})))}),[s,l]);return(0,z.jsx)(r2,{ref:t,focusKey:n,title:(0,z.jsx)(qc.Options.SCREEN_TITLE,{}),className:r,onClose:x,header:(0,z.jsx)(I5,{search:g}),children:(0,z.jsx)("div",{className:P5.content,children:(0,z.jsx)(E1,{tabs:S,selectedTab:l,onSelect:j,children:(0,z.jsxs)(Ap,{initialFocused:L5,direction:gp.Horizontal,children:[(0,z.jsx)(zv,{className:P5.menu,children:(0,z.jsx)(gE,{className:P5.scrollable,children:(0,z.jsxs)(Ip,{focusKey:L5,focused:a,direction:gp.Vertical,onChange:O,children:[(0,z.jsx)(T5,{search:g}),o.filter((function(e){return!h||y.has(e.id)||v===e.id})).map((function(e,t,n){return(0,z.jsx)(k5,{item:e,beta:e.beta,selected:v===e.id||!h&&a===e.id||1===n.length,onSelect:_},e.id)}))]})})}),(0,z.jsx)(zv,{className:P5.detail,children:null!=s&&(0,z.jsx)(h5,{page:s,selectedSectionId:l,onSelectSection:j,className:P5.optionSection,isSearch:h,subHeader:T&&(0,z.jsx)(X1,{label:(0,z.jsx)(qc.Options.SEARCH,{hash:f?"hide advanced":"show advanced"}),value:f,onChange:E,className:_d()(P5.advancedToggle,N5({},P5.advancedToggleChecked,f))})},a)})]})})})})})),k5=function(e){var t=e.item,n=e.selected,r=e.suffix,i=e.beta,o=e.onSelect,a=(0,Y.useCallback)((function(){return o(t.id)}),[t.id,o]),s=Pg();return(0,z.jsxs)(Qp,{focusKey:t.id,selected:n,className:_d()(P5.item,!s&&P5.primary),onSelect:a,children:[(0,z.jsxs)("div",{className:P5.menuItemLeft,children:[(0,z.jsx)("span",{children:(0,z.jsx)(qc.Options.SECTION,{hash:t.id})}),r&&(0,z.jsx)("span",{children:r})]}),i&&(0,z.jsx)("div",{className:P5.menuItemRight,children:(0,z.jsx)(p1,{})})]})};oe.add("game-ui/menu/components/options-screen/options-screen.tsx",{get OptionsScreen(){return M5},set OptionsScreen(e){M5=e},get MenuItem(){return k5},set MenuItem(e){k5=e}});let R5={base:"base_KL3",enter:"enter_VtK","exit-active":"exit-active_ZDb",exitActive:"exit-active_ZDb","enter-active":"enter-active_VOn",enterActive:"enter-active_VOn",exit:"exit_qAg"};oe.add("game-ui/menu/transitions/shrink-fade.module.scss",{get classes(){return R5},set classes(e){Object.assign(R5,e)}});const D5=R5;let F5={"pause-menu":"pause-menu_uzz menu-theme_k91",pauseMenu:"pause-menu_uzz menu-theme_k91","content-container":"content-container_Ake",contentContainer:"content-container_Ake",content:"content_X6U","action-hints":"action-hints_o79 child-opacity-transition_nkS",actionHints:"action-hints_o79 child-opacity-transition_nkS",version:"version_Vtb"};oe.add("game-ui/menu/components/pause-menu/pause-menu.module.scss",{get classes(){return F5},set classes(e){Object.assign(F5,e)}});const U5=F5;function G5(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function B5(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return G5(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return G5(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var V5=function(e){var t=e.className,n=e.children;yj(bj);var r=B5((0,Y.useState)(!1),2),i=r[0],o=r[1],a=Pg(),s=xl(JU);return Jb(!i),ey(!i),(0,z.jsx)(Tg,{onFocusChange:o,children:(0,z.jsx)(mb,{children:(0,z.jsx)(Cm,{styles:D5,children:(0,z.jsxs)("div",{className:_d()(U5.pauseMenu,t),children:[(0,z.jsxs)("div",{className:U5.contentContainer,children:[(0,z.jsx)("div",{className:U5.content,children:n}),a&&(0,z.jsx)(dk,{className:U5.actionHints})]}),(0,z.jsx)("div",{className:U5.version,children:s})]})})})})};oe.add("game-ui/menu/components/pause-menu/pause-menu.tsx",{get PauseMenu(){return V5},set PauseMenu(e){V5=e}});var H5=function(e){return(0,z.jsx)(Ud,{children:e.children})};oe.add("game-ui/modding/modding-hook.tsx",{get ModdingHook(){return H5},set ModdingHook(e){H5=e}});var K5,W5,z5,Y5="tooltip",$5=fl(Y5,"groups");!function(e){e[e.Start=0]="Start",e[e.Center=1]="Center",e[e.End=2]="End"}(K5||(K5={})),function(e){e[e.Info=0]="Info",e[e.Success=1]="Success",e[e.Warning=2]="Warning",e[e.Error=3]="Error"}(W5||(W5={})),function(e){e.Number="Game.UI.Tooltip.NumberTooltip",e.Progress="Game.UI.Tooltip.ProgressTooltip",e.String="Game.UI.Tooltip.StringTooltip",e.Name="Game.UI.Tooltip.NameTooltip",e.Notification="Game.UI.Tooltip.NotificationTooltip",e.ZoningEvaluation="Game.UI.Tooltip.ZoningEvaluationTooltip"}(z5||(z5={})),oe.add("game-ui/common/data-binding/tooltip-bindings.ts",{get tooltipGroup(){return Y5},set tooltipGroup(e){Y5=e},get tooltipGroups(){return tooltipGroups},set tooltipGroups(e){tooltipGroups=e},get TooltipGroupAlignment(){return K5},set TooltipGroupAlignment(e){K5=e},get TooltipColor(){return W5},set TooltipColor(e){W5=e},get TooltipType(){return z5},set TooltipType(e){z5=e}});let q5={title:"title_lCJ",description:"description_dNa",content:"content_OhK"};oe.add("game-ui/common/tooltip/description-tooltip/description-tooltip.module.scss",{get classes(){return q5},set classes(e){Object.assign(q5,e)}});const X5=q5;function Q5(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Z5(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function J5(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var e8=function(e){var t=e.title,n=e.description,r=e.content,i=e.children,o=J5(e,["title","description","content","children"]),a=(0,z.jsx)(t8,{title:t,description:n,content:r});return(0,z.jsx)(jh,Z5(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Q5(e,t,n[t])}))}return e}({},o),{tooltip:a,children:i}))},t8=function(e){var t=e.title,n=e.description,r=e.content,i=e.className,o=Y.Children.count(t)>0,a=Y.Children.count(n)>0,s=Y.Children.count(r)>0;return(0,z.jsxs)("div",{className:_d()(X5.layout,i),children:[o&&(0,z.jsx)("div",{className:X5.title,children:t}),a&&(0,z.jsx)(Fv,{className:X5.description,children:n}),s&&(0,z.jsx)("div",{className:X5.content,children:r})]})};oe.add("game-ui/common/tooltip/description-tooltip/description-tooltip.tsx",{get DescriptionTooltip(){return e8},set DescriptionTooltip(e){e8=e},get TooltipLayout(){return t8},set TooltipLayout(e){t8=e}});let n8={"group-container":"group-container_Fl2 tooltip-fade-in_S9n",groupContainer:"group-container_Fl2 tooltip-fade-in_S9n",group:"group_zcS",gamepad:"gamepad_kHF",item:"item_k3Z tooltip-base_zwi","row-item":"row-item_oHU item_k3Z tooltip-base_zwi",rowItem:"row-item_oHU item_k3Z tooltip-base_zwi",icon:"icon_Blg","score-indicator":"score-indicator_i6X",scoreIndicator:"score-indicator_i6X",positive:"positive_Uf2",negative:"negative_pRC",label:"label_zet",value:"value_uLz",success:"success_bHA",warning:"warning_e1p",error:"error_NkQ"};oe.add("game-ui/common/tooltip/tooltip-renderer/tooltip-renderer.module.scss",{get classes(){return n8},set classes(e){Object.assign(n8,e)}});const r8=n8;function i8(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function o8(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){i8(e,t,n[t])}))}return e}function a8(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function s8(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var l8=function(e){var t=e.disabled,n=e.children,r=cD(Y5),i=xl($5),o=Xf();return(0,z.jsxs)(z.Fragment,{children:[n,!t&&i.map((function(e){return function(e,t){return e.x>-.1*t.x&&e.x<1.1*t.x&&e.y>-.1*t.y&&e.y<1.1*t.y}(e.props.position,o)?(0,z.jsx)(c8,o8({parent:r},e),e.path):void 0}))]})},c8=function(e){var t=e.parent,n=e.path,r=e.props,i=e.children,o=uD(t,n),a=Pg(),s=(0,Y.useMemo)((function(){return{top:r.position.y,left:r.position.x,justifyContent:u8(r.verticalAlignment),alignItems:u8(r.horizontalAlignment)}}),[r]),l=(0,Y.useMemo)((function(){return{alignItems:u8(r.horizontalAlignment)}}),[r.horizontalAlignment]);return(0,z.jsx)(tm,{children:(0,z.jsx)("div",{className:r8.groupContainer,style:s,children:(0,z.jsx)("div",{className:_d()(r8.group,a&&r8.gamepad),style:l,children:(0,z.jsx)(OD,{parent:o,components:h8,data:i})})})})};function u8(e){switch(e){case K5.Start:return"flex-start";case K5.Center:return"center";case K5.End:return"flex-end";default:return"center"}}function d8(e){return e>0?"+":e<0?"−":"±"}var f8,m8=function(e){var t=e.icon,n=e.label,r=e.color,i=void 0===r?W5.Info:r,o=e.className,a=e.children;return(0,z.jsxs)("div",{className:_d()(r8.rowItem,o),children:[t&&(0,z.jsx)("img",{src:t,className:r8.icon}),n&&(0,z.jsx)("div",{className:r8.label,children:(0,z.jsx)(ku,{value:n})}),(0,z.jsx)("div",{className:_d()(r8.value,g8[i]),children:a})]})},g8=[void 0,r8.success,r8.warning,r8.error],h8=(i8(f8={},z5.Number,p8((function(e){var t=e.value,n=e.unit,r=e.signed,i=s8(e,["value","unit","signed"]);return(0,z.jsx)(m8,a8(o8({},i),{children:(0,z.jsx)(su,{value:t,unit:n,signed:r})}))}))),i8(f8,z5.Progress,p8((function(e){var t=e.value,n=e.max,r=e.unit,i=e.omitMax,o=s8(e,["value","max","unit","omitMax"]),a=!i||t!==n;return(0,z.jsx)(m8,a8(o8({},o),{children:a?(0,z.jsx)(Pu,{value:t,total:n,unit:r}):(0,z.jsx)(su,{value:t,unit:r})}))}))),i8(f8,z5.String,p8((function(e){var t=e.value,n=s8(e,["value"]);return(0,z.jsx)(m8,a8(o8({},n),{children:(0,z.jsx)(ku,{value:t})}))}))),i8(f8,z5.Name,p8((function(e){var t=e.icon,n=e.name;return(0,z.jsx)(m8,{icon:t,children:(0,z.jsx)(gd,{value:n})})}))),i8(f8,z5.Notification,p8((function(e){var t=e.name,n=e.color;return e.verbose?(0,z.jsx)("div",{className:r8.item,children:(0,z.jsx)(t8,{title:(0,z.jsx)(qc.Notifications.TITLE,{hash:t}),description:(0,z.jsx)(qc.Notifications.DESCRIPTION,{hash:t})})}):(0,z.jsx)(m8,{color:n,children:(0,z.jsx)(qc.Notifications.TITLE,{hash:t})})}))),i8(f8,z5.ZoningEvaluation,p8((function(e){var t=e.factor,n=e.score;return(0,z.jsxs)("div",{className:r8.rowItem,children:[(0,z.jsx)("div",{className:_d()(r8.scoreIndicator,n>=0?r8.positive:r8.negative),children:d8(n)}),(0,z.jsx)("div",{className:r8.value,children:n>=0?(0,z.jsx)(qc.ZoningFactors.POSITIVE,{hash:t}):(0,z.jsx)(qc.ZoningFactors.NEGATIVE,{hash:t})})]})}))),f8);function p8(e){var t,n=function(t){var n=t.props;return Y.createElement(e,n)};return n.displayName=null!==(t=e.displayName)&&void 0!==t?t:e.name,Y.memo(n,(function(e,t){return el(e,t,4)}))}oe.add("game-ui/common/tooltip/tooltip-renderer/tooltip-renderer.tsx",{get TooltipRenderer(){return l8},set TooltipRenderer(e){l8=e},get BoundTooltipGroup(){return c8},set BoundTooltipGroup(e){c8=e},get tooltipComponents(){return h8},set tooltipComponents(e){h8=e}});var v8,b8,y8="editorHierarchy";!function(e){e[e.None=0]="None",e[e.Map=1]="Map",e[e.Climate=2]="Climate",e[e.Water=3]="Water",e[e.Resources=4]="Resources",e[e.ObjectContainer=5]="ObjectContainer",e[e.Object=6]="Object",e[e.SubMesh=7]="SubMesh"}(v8||(v8={})),function(e){e[e.Default=0]="Default",e[e.FirstPerson=1]="FirstPerson",e[e.Orbit=2]="Orbit"}(b8||(b8={}));var x8=fl(y8,"width"),_8=fl(y8,"totalCount"),j8=fl(y8,"selectedId"),O8=fl(y8,"viewport"),E8=vl(y8,"setWidth"),S8=vl(y8,"setViewportRange"),T8=vl(y8,"setSelectedId"),I8=vl(y8,"setExpanded"),w8=vl(y8,"bulldoze"),P8=vl(y8,"save"),C8=fl(y8,"cameraMode"),N8=vl(y8,"toggleCameraMode");function A8(e,t){return e.type===t.type&&Qs(e.entity,t.entity)&&e.subIndex===t.subIndex}oe.add("game-ui/editor/data-binding/editor-hierarchy-bindings.ts",{get ItemType(){return v8},set ItemType(e){v8=e},get EditorCameraMode(){return b8},set EditorCameraMode(e){b8=e},get hierarchyWidth(){return hierarchyWidth},set hierarchyWidth(e){hierarchyWidth=e},get totalCount(){return totalCount},set totalCount(e){totalCount=e},get selectedId(){return selectedId},set selectedId(e){selectedId=e},get viewport(){return viewport},set viewport(e){viewport=e},get setWidth(){return E8},set setWidth(e){E8=e},get setViewportRange(){return S8},set setViewportRange(e){S8=e},get setSelectedId(){return T8},set setSelectedId(e){T8=e},get setExpanded(){return I8},set setExpanded(e){I8=e},get bulldoze(){return w8},set bulldoze(e){w8=e},get save(){return P8},set save(e){P8=e},get editorCameraMode(){return editorCameraMode},set editorCameraMode(e){editorCameraMode=e},get toggleEditorCameraMode(){return N8},set toggleEditorCameraMode(e){N8=e},get itemIdEquals(){return A8},set itemIdEquals(e){A8=e}});let L8={field:"field_eKJ",blinkOnSelect:"blinkOnSelect_Lbx",content:"content_syM",selectable:"selectable_otQ",divider:"divider_GbU"};oe.add("game-ui/game/components/toolbar/components/field/field.module.scss",{get classes(){return L8},set classes(e){Object.assign(L8,e)}});const M8=L8;var k8=function(e){var t=e.contentClassName,n=e.className,r=e.children,i=e.onSelect,o=_d()(M8.field,null!=i&&M8.selectable,n),a=(0,z.jsx)("div",{className:_d()(M8.content,t),children:r});return null!=i?(0,z.jsx)(Qp,{className:o,onSelect:i,children:a}):(0,z.jsx)(Yv,{className:o,children:a})},R8=function(){return(0,z.jsx)("div",{className:M8.divider})};oe.add("game-ui/game/components/toolbar/components/field/field.tsx",{get Field(){return k8},set Field(e){k8=e},get Divider(){return R8},set Divider(e){R8=e}});let D8={"time-controls":"time-controls_TVa field_eKJ",timeControls:"time-controls_TVa field_eKJ",period:"period_iJ_",button:"button_w1a",paused:"paused_DLu","secondary-active":"secondary-active_X5T",secondaryActive:"secondary-active_X5T","play-pause":"play-pause_Z_u",playPause:"play-pause_Z_u",speed:"speed_O0e","date-time-container":"date-time-container_UTv",dateTimeContainer:"date-time-container_UTv","date-time":"date-time_mlZ",dateTime:"date-time_mlZ",alternate2:"alternate2_ZMf","disable-pause-animation":"disable-pause-animation_GSc",disablePauseAnimation:"disable-pause-animation_GSc","paused-label":"paused-label_YTz",pausedLabel:"paused-label_YTz",none:"none_rxc","time-hours":"time-hours_w20",timeHours:"time-hours_w20","time-colon":"time-colon_t_C",timeColon:"time-colon_t_C","time-minutes":"time-minutes_QOr",timeMinutes:"time-minutes_QOr","time-period":"time-period_Qyj",timePeriod:"time-period_Qyj","date-container":"date-container_Avy",dateContainer:"date-container_Avy",date:"date_fBv",alternate1:"alternate1_Am9"};oe.add("game-ui/game/components/toolbar/bottom/time-controls/time-controls.module.scss",{get classes(){return D8},set classes(e){Object.assign(D8,e)}});const F8=D8;function U8(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var G8=Cj({pause:"Media/Glyphs/SimulationPause.svg",play:"Media/Glyphs/SimulationPlay.svg",speed1:"Media/Glyphs/SimulationSpeed1.svg",speed2:"Media/Glyphs/SimulationSpeed2.svg",speed3:"Media/Glyphs/SimulationSpeed3.svg"}),B8=function(e){var t,n,r,i,o=e.disablePauseAnimation,a=xl(CN),s=xl(NN),l=UN(xl(TN),xl(IN)),c=xl(ic).timeFormat===uc.TwentyFourHours,u=(0,Y.useMemo)((function(){return Vu(c?l.hour:l.hour%12||12,2)}),[l.hour,c]),d=(0,Y.useMemo)((function(){return Vu(l.minute,2)}),[l.minute]),f=JQ(2,K8);return(0,z.jsxs)("div",{className:_d()(F8.timeControls,(i={},U8(i,F8.period,!c),U8(i,F8.disablePauseAnimation,o),i)),children:[(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.toolbarSimulationToggle,children:(0,z.jsx)(e8,{title:a?(0,z.jsx)(qc.Main.TOOLTIP_TITLE_PLAY,{}):(0,z.jsx)(qc.Main.TOOLTIP_TITLE_PAUSE,{}),description:a?(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_PLAY,{}):(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_PAUSE,{}),children:(0,z.jsx)(lb,{tinted:!0,src:a?G8.pause:G8.play,selectSound:null,className:_d()(F8.button,F8.playPause,a&&F8.paused),onSelect:V8})})}),(0,z.jsx)(R8,{}),(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.toolbarSimulationDateTime,children:(0,z.jsx)(e8,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_DATE,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_DATE,{}),children:(0,z.jsx)(Qd,{children:(0,z.jsxs)("div",{className:F8.dateTimeContainer,children:[(0,z.jsxs)("div",{className:_d()(F8.dateTime,a&&F8.paused),children:[(0,z.jsx)("div",{className:F8.timeHours,children:u}),(0,z.jsx)("div",{className:F8.timeColon,children:":"}),(0,z.jsx)("div",{className:F8.timeMinutes,children:d}),!c&&(0,z.jsx)("div",{className:F8.timePeriod,children:l.hour<12?(0,z.jsx)(qc.Common.TIME_PERIOD_AM,{}):(0,z.jsx)(qc.Common.TIME_PERIOD_PM,{})}),(0,z.jsx)("div",{className:F8.date,children:(0,z.jsx)(Yu,{value:l})})]}),a&&(0,z.jsx)("div",{className:F8.pausedLabel,children:(0,z.jsx)(qc.Toolbar.SIMULATION_PAUSED,{})})]})})})}),(0,z.jsx)(R8,{}),(0,z.jsx)(tk,{uiTag:null===(r=Ew.value)||void 0===r?void 0:r.toolbarSimulationSpeed,children:(0,z.jsx)(e8,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_GAME_SPEED,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_GAME_SPEED,{}),children:(0,z.jsx)(lb,{tinted:!0,src:X8(s),selectSound:null,className:_d()(F8.button,F8.speed,a&&F8.paused,f.mouseDown&&F8.secondaryActive),onSelect:H8,onMouseDown:f.onMouseDown,onMouseUp:f.onMouseUp})})})]})};function V8(){var e=!CN.value;kp(e?Lp.pauseSimulation:Lp.resumeSimulation),LN(e)}function H8(){q8(NN.value+1)}function K8(){q8(NN.value+3-1)}function W8(){q8(0)}function z8(){q8(1)}function Y8(){q8(2)}function $8(){if(CN.value)kp(Lp.resumeSimulation),MN(0);else{var e=NN.value;e<2?q8(e+1):(kp(Lp.pauseSimulation),LN(!0))}}function q8(e){var t=e%3;kp(function(e){return e<.5?Lp.simulationSpeed1:e<1.5?Lp.simulationSpeed2:Lp.simulationSpeed3}(t)),MN(t)}function X8(e){return e<.5?G8.speed1:e<1.5?G8.speed2:G8.speed3}function Q8(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Z8(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function J8(){var e=xl(w_),t=xl(R_),n=xl(VN),r=xl(rA),i=xl(nA),o=!(r&&i),a=xl(tA),s=xl(ry),l=(0,Y.useRef)(xA),c=e4(),u=t4(),d=(0,Y.useCallback)((function(){return lA(function(e){var t=e.modes.reduce((function(t,n){return n.index>e.modeIndex&&(void 0===t||n.index<t)?n.index:t}),void 0);if(void 0!==t)return t;var n=e.modes.reduce((function(e,t){return void 0===e||t.index<e?t.index:e}),void 0);return void 0!==n?n:e.modeIndex}(n))}),[n]),f=Kw("Map Tiles"),m=xl(zN),g=xl(WN),h=(0,Y.useCallback)((function(){hA((g&m)===m?g&~m:g|m)}),[m,g]),p=(null==t?void 0:t.__Type)===M_.PhotoMode;return(0,Y.useMemo)((function(){return Z8(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Q8(e,t,n[t])}))}return e}({},c,u),{"Change Elevation":o?function(e){e>0?r||(kp(Lp.increaseElevation),dA()):e<0&&(i||(kp(Lp.decreaseElevation),fA()))}:null,Bulldozer:function(){n.id===yA?(kp(Lp.bulldozeEnd),sA(l.current)):(l.current=n.id,kp(Lp.bulldoze),sA(yA))},Back:n.id!==xA?function(){n.id===yA&&kp(Lp.bulldozeEnd),sA(xA)}:null,"Leave Underground Mode":a?function(){kp(Lp.increaseElevation),bA(!1)}:null,"Leave Info View":null!=s?oy:null,"Pause Menu":e!==S_.pauseMenu?A_:null,"Switch Toolmode":d,"Toggle Snapping":h,"Hide UI":function(){return P_(w_.value!==S_.freeCamera?S_.freeCamera:S_.main)},"Map Tile Purchase Panel":f.locked||p?null:function(){return $I(!GI.value)}})}),[c,u,o,n.id,a,s,e,d,h,f.locked,p,r,i])}function e4(){var e=xl(CN);return(0,Y.useMemo)((function(){return{"Switch Speed":$8,"Speed 1":W8,"Speed 2":z8,"Speed 3":Y8,"Pause Simulation":e?null:function(){kp(Lp.pauseSimulation),LN(!0)},"Resume Simulation":e?function(){kp(Lp.resumeSimulation),LN(!1)}:null}}),[e])}function t4(){var e=Kw("Progression Panel"),t=Kw("City Budget"),n=Kw("City Info Panel"),r=Kw("City Statistics"),i=Kw("Transportation Overview"),o=Kw("Chirper"),a=Kw("Followed Citizens"),s=Kw("Event Journal"),l=Kw("Radio"),c=Kw("Photo Mode"),u=xl(AP);return(0,Y.useMemo)((function(){return{"Progression Panel":n4(M_.Progression,e),"Economy Panel":n4(M_.Economy,t),"City Information Panel":n4(M_.CityInfo,n),"Statistic Panel":n4(M_.Statistics,r),"Transportation Overview Panel":n4(M_.TransportationOverview,i),"Chirper Panel":n4(M_.Chirper,o),"Lifepath Panel":n4(M_.LifePath,a),"Event Journal Panel":n4(M_.Journal,s),"Radio Panel":u?n4(M_.Radio,l):null,"Photo Mode Panel":n4(M_.PhotoMode,c)}}),[o,n,t,s,a,c,e,u,l,r,i])}function n4(e,t){return void 0!==t&&t.locked?null:function(){return cd(R_.value,e)?B_(e):G_(e)}}oe.add("game-ui/game/components/toolbar/bottom/time-controls/time-controls.tsx",{get TimeControls(){return B8},set TimeControls(e){B8=e},get togglePause(){return V8},set togglePause(e){V8=e},get switchSpeed(){return H8},set switchSpeed(e){H8=e},get switchSpeedReverse(){return K8},set switchSpeedReverse(e){K8=e},get speed1(){return W8},set speed1(e){W8=e},get speed2(){return z8},set speed2(e){z8=e},get speed3(){return Y8},set speed3(e){Y8=e},get switchSpeedOrPause(){return $8},set switchSpeedOrPause(e){$8=e}}),oe.add("game-ui/game/components/game-input-actions.tsx",{get useGameInputActions(){return J8},set useGameInputActions(e){J8=e},get useSimSpeedInputActions(){return e4},set useSimSpeedInputActions(e){e4=e},get useGamePanelShortcuts(){return t4},set useGamePanelShortcuts(e){t4=e}});let r4={"bulldoze-cursor":"bulldoze-cursor_uNU",bulldozeCursor:"bulldoze-cursor_uNU","replace-cursor":"replace-cursor_jgP",replaceCursor:"replace-cursor_jgP","complex-curve-cursor":"complex-curve-cursor_N47",complexCurveCursor:"complex-curve-cursor_N47","continuous-cursor":"continuous-cursor_wVn",continuousCursor:"continuous-cursor_wVn","grid-cursor":"grid-cursor_zBe",gridCursor:"grid-cursor_zBe","parallel-mode-cursor":"parallel-mode-cursor_kzY",parallelModeCursor:"parallel-mode-cursor_kzY","simple-curve-cursor":"simple-curve-cursor_JKS",simpleCurveCursor:"simple-curve-cursor_JKS","straight-cursor":"straight-cursor_AcO",straightCursor:"straight-cursor_AcO",crosshair:"crosshair_gJi","crosshair-default":"crosshair-default_S39 crosshair_gJi",crosshairDefault:"crosshair-default_S39 crosshair_gJi","bulldoze-crosshair":"bulldoze-crosshair_C1X crosshair_gJi",bulldozeCrosshair:"bulldoze-crosshair_C1X crosshair_gJi","replace-crosshair":"replace-crosshair_VpJ crosshair_gJi",replaceCrosshair:"replace-crosshair_VpJ crosshair_gJi","complex-curve-crosshair":"complex-curve-crosshair_Yhl crosshair_gJi",complexCurveCrosshair:"complex-curve-crosshair_Yhl crosshair_gJi","continuous-crosshair":"continuous-crosshair_DwR crosshair_gJi",continuousCrosshair:"continuous-crosshair_DwR crosshair_gJi","grid-crosshair":"grid-crosshair_V69 crosshair_gJi",gridCrosshair:"grid-crosshair_V69 crosshair_gJi","parallel-mode-crosshair":"parallel-mode-crosshair_lYy crosshair_gJi",parallelModeCrosshair:"parallel-mode-crosshair_lYy crosshair_gJi","simple-curve-crosshair":"simple-curve-crosshair_BYp crosshair_gJi",simpleCurveCrosshair:"simple-curve-crosshair_BYp crosshair_gJi","straight-crosshair":"straight-crosshair_IEJ crosshair_gJi",straightCrosshair:"straight-crosshair_IEJ crosshair_gJi"};oe.add("game-ui/game/components/tool-cursors/tool-cursors.module.scss",{get classes(){return r4},set classes(e){Object.assign(r4,e)}});const i4=r4;function o4(){var e=xl(VN),t=xl($m),n=xl(ZN);fR(t?void 0:s4(n,e,"Cursor"))}function a4(){var e=xl(VN);return s4(xl(ZN),e,"Crosshair")}function s4(e,t,n){var r,i,o,a,s,l;return t.id===OA&&e?"Cursor"===n?i4.parallelModeCursor:i4.parallelModeCrosshair:t.id===yA?"Cursor"===n?i4.bulldozeCursor:i4.bulldozeCrosshair:t.id===OA&&"Replace"===(null===(r=t.modes.find((function(e){return e.index===t.modeIndex})))||void 0===r?void 0:r.id)?"Cursor"===n?i4.replaceCursor:i4.replaceCrosshair:t.id===OA&&"Straight"===(null===(i=t.modes.find((function(e){return e.index===t.modeIndex})))||void 0===i?void 0:i.id)?"Cursor"===n?i4.straightCursor:i4.straightCrosshair:t.id===OA&&"SimpleCurve"===(null===(o=t.modes.find((function(e){return e.index===t.modeIndex})))||void 0===o?void 0:o.id)?"Cursor"===n?i4.simpleCurveCursor:i4.simpleCurveCrosshair:t.id===OA&&"ComplexCurve"===(null===(a=t.modes.find((function(e){return e.index===t.modeIndex})))||void 0===a?void 0:a.id)?"Cursor"===n?i4.complexCurveCursor:i4.complexCurveCrosshair:t.id===OA&&"Continuous"===(null===(s=t.modes.find((function(e){return e.index===t.modeIndex})))||void 0===s?void 0:s.id)?"Cursor"===n?i4.continuousCursor:i4.continuousCrosshair:t.id===OA&&"Grid"===(null===(l=t.modes.find((function(e){return e.index===t.modeIndex})))||void 0===l?void 0:l.id)?"Cursor"===n?i4.gridCursor:i4.gridCrosshair:"Cursor"===n?void 0:i4.crosshairDefault}oe.add("game-ui/game/components/tool-cursors/tool-cursors.tsx",{get useToolCursor(){return o4},set useToolCursor(e){o4=e},get useToolCrosshair(){return a4},set useToolCrosshair(e){a4=e}});let l4={"color-field":"color-field_due",colorField:"color-field_due",alpha:"alpha_R9X",disabled:"disabled_QDB","color-picker-container":"color-picker-container_Sj5",colorPickerContainer:"color-picker-container_Sj5"};oe.add("game-ui/common/input/color-picker/color-field/color-field.module.scss",{get classes(){return l4},set classes(e){Object.assign(l4,e)}});const c4=l4;function u4(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function d4(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function f4(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function m4(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return u4(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return u4(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var g4=new Wh("BUTTON_KEY"),h4=new Wh("PICKER_KEY");function p4(e){var t=RR(YR,uD(e.parent,e.path));return(0,z.jsx)(v4,{value:e.props.value,onChange:t,disabled:e.props.disabled,alpha:e.props.showAlpha,popupDirection:"up"})}var v4=function(e){var t=e.focusKey,n=e.disabled,r=e.value,i=e.className,o=e.selectAction,a=void 0===o?"Select":o,s=e.alpha,l=void 0!==s&&s,c=e.popupDirection,u=void 0===c?"down":c,d=e.onChange,f=e.onClick,m=e.onMouseEnter,g=e.onMouseLeave,h=m4((0,Y.useState)(!1),2),p=h[0],v=h[1],b=(0,Y.useCallback)((function(){return v((function(e){return!e}))}),[]),y=(0,Y.useCallback)((function(){return v(!1)}),[]);(0,Y.useEffect)((function(){n&&p&&v(!1)}),[n,p]);var x,_=(0,Y.useRef)(0),j=(0,Y.useCallback)((function(e){_.current=e.h,d(lP(e))}),[d]),O=(0,Y.useMemo)((function(){var e;return d4(e={},a,(function(){return b()})),d4(e,"Back",y),e}),[y,b,a]),E=(0,Y.useRef)(null),S=(0,z.jsx)(rp,{actions:O,children:(0,z.jsx)("div",{ref:E,className:c4.colorPickerContainer,children:(0,z.jsx)(Kq,{focusKey:h4,color:b4(r,_.current),alpha:l,onChange:j,colorWheel:!1,sliderTextInput:!1,mode:Hq.Hsv,hexInput:!1})})}),T=(0,Y.useCallback)((function(){return v(!1)}),[]);return(0,z.jsxs)(z.Fragment,{children:[p&&(0,z.jsx)(tE,{onClick:T}),(0,z.jsx)(pj,{focusKey:t,focused:p?h4:g4,children:(0,z.jsx)(QO,{visible:p,content:S,direction:u,children:(0,z.jsx)(Qp,{focusKey:g4,selectAction:a,onClick:f,onMouseEnter:m,onMouseLeave:g,className:_d()(i,c4.colorField,(x={},d4(x,c4.disabled,n),d4(x,c4.alpha,r.a<1),x)),onSelect:n?void 0:b,children:(0,z.jsx)("div",{style:{backgroundColor:rP(r)}})})})})]})};function b4(e,t){var n=cP(e,t);return 0===n.h&&t>.99?f4(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){d4(e,t,n[t])}))}return e}({},n),{h:1}):n}oe.add("game-ui/common/input/color-picker/color-field/color-field.tsx",{get BoundColorField(){return p4},set BoundColorField(e){p4=e},get ColorField(){return v4},set ColorField(e){v4=e},get rgbaToHsvaWithStrongFallbackHue(){return b4},set rgbaToHsvaWithStrongFallbackHue(e){b4=e}});let y4={"unlock-highlight-badge":"unlock-highlight-badge_D9D",unlockHighlightBadge:"unlock-highlight-badge_D9D"};oe.add("game-ui/game/components/asset-menu/badges/unlock-highlight-badge.module.scss",{get classes(){return y4},set classes(e){Object.assign(y4,e)}});const x4=y4;var _4=function(e){var t=e.className;return xl(Ql)?(0,z.jsx)("div",{className:_d()(x4.unlockHighlightBadge,t)}):null};oe.add("game-ui/game/components/asset-menu/badges/unlock-highlight-badge.tsx",{get UnlockHighlightBadge(){return _4},set UnlockHighlightBadge(e){_4=e}});let j4={indicatorNormalColor:"#424242",indicatorSelectedColor:"#1e83aa",button:"button_KVN",icon:"icon_Ysc","multi-select":"multi-select_Roq",multiSelect:"multi-select_Roq",badge:"badge_IEE",indicator:"indicator_ySy"};oe.add("game-ui/game/components/tool-options/tool-button/tool-button.module.scss",{get classes(){return j4},set classes(e){Object.assign(j4,e)}});const O4=j4;var E4=function(e){var t=e.focusKey,n=e.src,r=e.selected,i=e.multiSelect,o=e.disabled,a=e.tooltip,s=e.selectSound,l=e.uiTag,c=e.className,u=e.children,d=e.onSelect,f=(0,Y.useCallback)((function(){d&&d(),l&&nh(l)}),[d,l]);return(0,z.jsx)(tk,{uiTag:l,children:(0,z.jsx)(jh,{tooltip:a,children:(0,z.jsx)(lb,{focusKey:t,src:n,disabled:o,selected:r,theme:O4,selectSound:s,className:_d()(i&&O4.multiSelect,c),onSelect:f,children:u})})})};function S4(e){var t=e.focusKey,n=e.value,r=e.src,i=e.selected,o=e.highlight,a=e.multiSelect,s=e.uiTag,l=e.className,c=e.children,u=e.onSelect,d=e.onClick,f=(0,Y.useCallback)((function(){u&&u(n),s&&nh(s)}),[u,n,s]),m=(0,Y.useCallback)((function(e){d&&(e.stopPropagation(),d(n))}),[n,d]);return(0,z.jsx)(tk,{uiTag:s,children:(0,z.jsxs)(lb,{focusKey:t,src:r,selected:i,theme:O4,className:_d()(a&&O4.multiSelect,l),onSelect:f,onClick:m,children:[c,o&&(0,z.jsx)(_4,{className:O4.badge})]})})}var T4=function(e){var t=e.focusKey,n=e.selectedValue,r=e.values,i=e.tooltip,o=e.uiTag,a=e.onSelect,s=(0,Y.useCallback)((function(){a(function(e,t){if(0===t.length)return e;var n=!0,r=!1,i=void 0;try{for(var o,a=t[Symbol.iterator]();!(n=(o=a.next()).done);n=!0){var s=o.value;if(s<e)return s}}catch(e){r=!0,i=e}finally{try{n||null==a.return||a.return()}finally{if(r)throw i}}return t[0]}(n,r)),o&&nh(o)}),[a,n,o,r]),l=r.findIndex((function(e){return e<=n}));return(0,z.jsx)(tk,{uiTag:o,children:(0,z.jsx)(jh,{tooltip:i,children:(0,z.jsx)(Qp,{focusKey:t,theme:O4,onSelect:s,children:(0,z.jsxs)("svg",{viewBox:"0 0 20 16",className:O4.indicator,children:[(0,z.jsx)("path",{d:"M0,12h4v4h-4Z",fill:l<=3?O4.indicatorSelectedColor:O4.indicatorNormalColor}),(0,z.jsx)("path",{d:"M5,8h4v8h-4Z",fill:l<=2?O4.indicatorSelectedColor:O4.indicatorNormalColor}),(0,z.jsx)("path",{d:"M10,4h4v12h-4Z",fill:l<=1?O4.indicatorSelectedColor:O4.indicatorNormalColor}),(0,z.jsx)("path",{d:"M15,0h4v16h-4Z",fill:l<=0?O4.indicatorSelectedColor:O4.indicatorNormalColor})]})})})})};oe.add("game-ui/game/components/tool-options/tool-button/tool-button.tsx",{get ToolButton(){return E4},set ToolButton(e){E4=e},get ValueToolButton(){return S4},set ValueToolButton(e){S4=e},get StepToolButton(){return T4},set StepToolButton(e){T4=e}});let I4={group:"group_fXk",item:"item_RBL item-focused_FuT","item-content":"item-content__FJ",itemContent:"item-content__FJ",readonly:"readonly_jlY",label:"label_EcW",content:"content_I1Y","arrow-button":"arrow-button_V0s",arrowButton:"arrow-button_V0s",field:"field_hZA",hidden:"hidden_o8e","color-field":"color-field_zGk",colorField:"color-field_zGk"};oe.add("game-ui/game/components/tool-options/gamepad-tool-options/gamepad-tool-options.module.scss",{get classes(){return I4},set classes(e){Object.assign(I4,e)}});const w4=I4;function P4(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function C4(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return P4(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return P4(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var N4=function(){var e=Pg(),t=C4((0,Y.useState)(!1),2),n=t[0],r=t[1],i=e&&!n;return(0,z.jsx)(Tg,{onFocusChange:r,children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)(L4,{readonly:i}),(0,z.jsx)(M4,{readonly:i}),(0,z.jsx)(k4,{readonly:i}),(0,z.jsx)(B4,{readonly:i}),(0,z.jsx)(G4,{readonly:i}),(0,z.jsx)(H4,{readonly:i}),(0,z.jsx)(D4,{readonly:i}),(0,z.jsx)(K4,{})]})})},A4=function(e){var t=e.focusKey,n=e.title,r=e.readonly,i=e.hidden,o=e.leftDisabled,a=e.rightDisabled,s=e.uiTag,l=e.uiTagLeft,c=e.uiTagRight,u=e.children,d=e.onSelectLeft,f=e.onSelectRight,m=(o||!d)&&(a||!f),g=(0,Y.useMemo)((function(){return{"Change Tool Option":m?null:function(e){kp(Lp.dragSlider),e<0?d&&!o&&(d(),l&&nh(l)):e>0&&f&&!a&&(f(),c&&nh(c))}}}),[m,o,d,f,a,l,c]);return(0,z.jsx)(rp,{actions:g,children:(0,z.jsx)(Yv,{focusKey:t,className:_d()(w4.item,r&&w4.readonly,i&&w4.hidden),children:(0,z.jsxs)("div",{className:w4.itemContent,children:[null!=n&&(0,z.jsx)("div",{className:w4.label,children:n}),(0,z.jsx)(tk,{uiTag:i?void 0:s,disableBlinking:!0,children:(0,z.jsxs)("div",{className:w4.content,children:[!r&&(0,z.jsx)(tk,{uiTag:l,children:(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:"Media/Glyphs/ThickStrokeArrowLeft.svg",disabled:o,className:w4.arrowButton,onSelect:d})}),u,!r&&(0,z.jsx)(tk,{uiTag:c,children:(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:"Media/Glyphs/ThickStrokeArrowRight.svg",disabled:a,className:w4.arrowButton,onSelect:f})})]})})]})})})},L4=function(e){var t,n=e.readonly,r=xl(YA),i=xl(zA),o=(0,Y.useCallback)((function(){var e=lC(i,i.findIndex((function(e){return Qs(e.entity,r)})),!0);e&&QA(e.entity)}),[r,i]),a=(0,Y.useCallback)((function(){var e=aC(i,i.findIndex((function(e){return Qs(e.entity,r)})),!0);e&&QA(e.entity)}),[r,i]);return(0,z.jsx)(YL,{children:i.length>1&&(0,z.jsx)("div",{className:w4.group,children:(0,z.jsx)(A4,{title:(0,z.jsx)(qc.Toolbar.THEME_PANEL_TITLE,{}),readonly:n,uiTag:null===(t=Ew.value)||void 0===t?void 0:t.toolOptionsThemes,onSelectLeft:o,onSelectRight:a,children:i.map((function(e){return(0,z.jsx)(e8,{title:(0,z.jsx)(qc.ToolOptions.TOOLTIP_TITLE,{hash:e.name}),description:(0,z.jsx)(qc.ToolOptions.TOOLTIP_DESCRIPTION,{hash:e.name}),children:(0,z.jsx)(S4,{focusKey:Hh,value:e.entity,src:e.icon,selected:Qs(e.entity,r),highlight:e.highlight,onClick:QA})},qs(e.entity))}))})})})},M4=function(e){var t,n,r=e.readonly,i=xl(VN);ih(null===(t=Ew.value)||void 0===t?void 0:t.toolOptionsModes);var o=(0,Y.useCallback)((function(e){return lA(e)}),[]),a=(0,Y.useCallback)((function(){var e=lC(i.modes,i.modes.findIndex((function(e){return e.index===i.modeIndex})),!0);e&&o(e.index)}),[i.modeIndex,i.modes,o]),s=(0,Y.useCallback)((function(){var e=aC(i.modes,i.modes.findIndex((function(e){return e.index===i.modeIndex})),!0);e&&o(e.index)}),[i.modeIndex,i.modes,o]);return(0,z.jsx)(YL,{children:i.modes.length>1&&(0,z.jsx)("div",{className:w4.group,children:(0,z.jsx)(A4,{title:i.modes.length<=7?(0,z.jsx)(qc.Toolbar.TOOL_MODE_TITLE,{}):null,readonly:r,uiTag:null===(n=Ew.value)||void 0===n?void 0:n.toolOptionsModes,onSelectLeft:a,onSelectRight:s,children:i.modes.map((function(e){var t;return(0,z.jsx)(e8,{title:(0,z.jsx)(qc.ToolOptions.TOOLTIP_TITLE,{hash:e.id}),description:(0,z.jsx)(qc.ToolOptions.TOOLTIP_DESCRIPTION,{hash:e.id}),children:(0,z.jsx)(S4,{focusKey:Hh,value:e.index,src:e.icon,selected:e.index===i.modeIndex,onSelect:o,uiTag:(null===(t=Ew.value)||void 0===t?void 0:t.toolOptionsModes)+e.id})},e.id)}))})})})},k4=function(e){var t,n,r=e.readonly,i=xl(CA),o=xl(AA),a=xl(LA),s=xl(kA),l=xl(RA),c=o<=s,u=o>=l,d=(0,Y.useCallback)((function(){FA(of(R4(o,-(o>550?100:o>125?50:10)),s,l))}),[o,s,l]),f=(0,Y.useCallback)((function(){FA(of(R4(o,o>475?100:o>95?50:10),s,l))}),[o,l,s]),m=a<=.01,g=a>=1,h=(0,Y.useCallback)((function(){UA(of(R4(a,-(a>.11?.05:.01)),.01,1))}),[a]),p=(0,Y.useCallback)((function(){UA(of(R4(a,+(a>.095?.05:.01)),.01,1))}),[a]);return(0,z.jsx)(YL,{children:!Qs(i,ty)&&(0,z.jsxs)("div",{className:w4.group,children:[(0,z.jsx)(A4,{title:(0,z.jsx)(qc.Toolbar.BRUSH_SIZE,{}),readonly:r,uiTag:null===(t=Ew.value)||void 0===t?void 0:t.toolOptionsBrushSize,leftDisabled:c,onSelectLeft:d,rightDisabled:u,onSelectRight:f,children:(0,z.jsx)("div",{className:w4.field,children:(0,z.jsx)(su,{value:o,unit:$c.Integer})})}),(0,z.jsx)(A4,{title:(0,z.jsx)(qc.Toolbar.BRUSH_STRENGTH,{}),readonly:r,uiTag:null===(n=Ew.value)||void 0===n?void 0:n.toolOptionsBrushStrength,leftDisabled:m,onSelectLeft:h,rightDisabled:g,onSelectRight:p,children:(0,z.jsx)("div",{className:w4.field,children:(0,z.jsx)(su,{value:100*a,unit:$c.Percentage})})})]})})};function R4(e,t){return t*Math.round(e/t)+t}var D4=function(e){var t,n=e.readonly,r=xl(KN),i=xl(zN),o=xl(WN),a=xl(YN),s=F4(r),l=(o&i)===i,c=(0,Y.useCallback)((function(){hA(l?o&~i:o|i)}),[l,i,o]),u=(0,Y.useCallback)((function(e){var t=1<<e;hA(0!=(o&t)?o&~t:o|t)}),[o]);return(0,z.jsx)(YL,{children:s.length>0&&(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.toolOptionsSnapping,children:(0,z.jsxs)("div",{className:w4.group,children:[n&&(0,z.jsxs)(A4,{title:s.length<=6?(0,z.jsx)(qc.Toolbar.SNAPPING_TITLE,{}):null,readonly:!0,children:[(0,z.jsx)(E4,{focusKey:Hh,src:"Media/Tools/Snap Options/All.svg",selected:l}),s.map((function(e){return(0,z.jsx)(S4,{focusKey:Hh,value:e,src:"Media/Tools/Snap Options/"+a[e]+".svg",selected:0!=(o&1<<e)},e)}))]}),(0,z.jsx)(A4,{title:(0,z.jsx)(qc.ToolOptions.TOOLTIP_SNAP_ALL,{}),readonly:n,hidden:n,onSelectLeft:c,onSelectRight:c,children:(0,z.jsx)(E4,{src:"Media/Tools/Snap Options/All.svg",selected:l,onSelect:c})}),s.map((function(e){var t=function(){return u(e)};return(0,z.jsx)(A4,{title:(0,z.jsx)(qc.ToolOptions.TOOLTIP,{hash:a[e]}),readonly:n,hidden:n,onSelectLeft:t,onSelectRight:t,children:(0,z.jsx)(S4,{value:e,src:"Media/Tools/Snap Options/"+a[e]+".svg",selected:0!=(o&1<<e),onSelect:u})},e)}))]})})})},F4=function(e){return(0,Y.useMemo)((function(){for(var t=[],n=0;e>>n>0;)0!=(e>>n&1)&&t.push(n),n++;return t}),[e])},U4=[10,5,2.5,1.25],G4=function(e){var t,n,r,i,o=e.readonly,a=xl($N),s=xl(qN),l=xl(XN),c=s<=a.min,u=s>=a.max,d=l<=U4[U4.length-1],f=(0,Y.useCallback)((function(){for(var e=0;e<U4.length;e++)if(U4[e]<l){var t,n;gA(U4[e]),kp(Lp.decreaseElevation),(null===(t=Ew.value)||void 0===t?void 0:t.toolOptionsElevationStep)&&nh(null===(n=Ew.value)||void 0===n?void 0:n.toolOptionsElevationStep);break}}),[l]),m=l>=U4[0],g=(0,Y.useCallback)((function(){for(var e=U4.length-1;e>=0;e--)if(U4[e]>l){var t,n;gA(U4[e]),kp(Lp.increaseElevation),(null===(t=Ew.value)||void 0===t?void 0:t.toolOptionsElevationStep)&&nh(null===(n=Ew.value)||void 0===n?void 0:n.toolOptionsElevationStep);break}}),[l]);return(0,z.jsx)(YL,{children:a.min<a.max&&(0,z.jsxs)("div",{className:w4.group,children:[(0,z.jsx)(A4,{title:(0,z.jsx)(qc.Toolbar.ELEVATION_TITLE,{}),uiTag:null===(t=Ew.value)||void 0===t?void 0:t.toolOptionsElevation,uiTagLeft:null===(n=Ew.value)||void 0===n?void 0:n.toolOptionsElevationDecrease,uiTagRight:null===(r=Ew.value)||void 0===r?void 0:r.toolOptionsElevationIncrease,readonly:o,leftDisabled:c,onSelectLeft:fA,rightDisabled:u,onSelectRight:dA,children:(0,z.jsx)("div",{className:w4.field,children:(0,z.jsx)(su,{value:s,unit:$c.NetElevation})})},"elevation"),(0,z.jsx)(A4,{title:(0,z.jsx)(qc.ToolOptions.TOOLTIP_ELEVATION_STEP,{}),hidden:o,uiTag:null===(i=Ew.value)||void 0===i?void 0:i.toolOptionsElevationStep,onSelectLeft:d?void 0:f,onSelectRight:m?void 0:g,children:(0,z.jsx)("div",{className:w4.field,children:(0,z.jsx)(su,{value:l,unit:$c.NetElevation})})},"elevationStep")]})})},B4=function(e){var t,n=e.readonly,r=xl(VN),i=xl(eA),o=xl(tA),a=(0,Y.useCallback)((function(){bA(!o),kp(o?Lp.increaseElevation:Lp.decreaseElevation)}),[o]);return(0,z.jsx)(YL,{children:r.id!==xA&&i&&(0,z.jsx)("div",{className:w4.group,children:(0,z.jsx)(A4,{title:(0,z.jsx)(qc.Toolbar.UNDERGROUND_MODE_TITLE,{}),readonly:n,uiTag:null===(t=Ew.value)||void 0===t?void 0:t.toolOptionsUnderground,onSelectLeft:a,onSelectRight:a,children:(0,z.jsx)(E4,{src:"Media/Tools/Net Tool/Underground.svg",disabled:!i,selected:o,onSelect:a})})})})},V4=[2,4,8,16,24,32,40,48,56,64,72,80,88,96],H4=function(e){var t,n,r,i,o=e.readonly,a=xl(QN),s=xl(ZN),l=xl(JN),c=V4,u=l<=c[0],d=(0,Y.useCallback)((function(){for(var e=c.length-1;e>=0;e--)if(c[e]<l){vA(c[e]);break}}),[l,c]),f=l>=c[c.length-1],m=(0,Y.useCallback)((function(){for(var e=0;e<c.length;e++)if(c[e]>l){vA(c[e]);break}}),[l,c]);return(0,z.jsx)(YL,{children:a&&(0,z.jsxs)("div",{className:_d()(w4.group,o&&!s&&w4.hidden),children:[(0,z.jsx)(A4,{title:(0,z.jsx)(qc.Toolbar.PARALLEL_MODE_TITLE,{}),hidden:o,onSelectLeft:pA,onSelectRight:pA,children:(0,z.jsx)(E4,{src:"Media/Tools/Net Tool/Parallel.svg",selected:s,onSelect:pA,uiTag:o||null===(t=Ew.value)||void 0===t?void 0:t.toolOptionsParallelMode})},"parallelMode"),s&&(0,z.jsx)(A4,{title:(0,z.jsx)(qc.Toolbar.PARALLEL_OFFSET_TITLE,{}),readonly:o,leftDisabled:u,onSelectLeft:d,rightDisabled:f,onSelectRight:m,uiTag:null===(n=Ew.value)||void 0===n?void 0:n.toolOptionsParallelModeOffset,uiTagLeft:null===(r=Ew.value)||void 0===r?void 0:r.toolOptionsParallelModeOffsetDecrease,uiTagRight:null===(i=Ew.value)||void 0===i?void 0:i.toolOptionsParallelModeOffsetIncrease,children:(0,z.jsx)("div",{className:w4.field,children:(0,z.jsx)(su,{value:l/8,unit:$c.FloatTwoFractions})})},"parallelOffset")]})})},K4=function(){var e=xl(VN),t=xl(iA),n=xl(oA),r=(0,Y.useCallback)((function(e){return aA(e)}),[]);return(0,z.jsx)(YL,{children:e.id!==xA&&t&&(0,z.jsx)("div",{className:w4.group,children:(0,z.jsx)(Yv,{className:_d()(w4.item,w4.readonly),children:(0,z.jsxs)("div",{className:w4.itemContent,children:[(0,z.jsx)("div",{className:w4.label,children:(0,z.jsx)(qc.ToolOptions.COLOR_TITLE,{hash:e.id})}),(0,z.jsx)("div",{className:w4.content,children:(0,z.jsx)(v4,{className:w4.colorField,selectAction:"Toggle Tool Color Picker",popupDirection:"up",value:n,onChange:r})})]})})})})};oe.add("game-ui/game/components/tool-options/gamepad-tool-options/gamepad-tool-options.tsx",{get GamepadToolOptions(){return N4},set GamepadToolOptions(e){N4=e},get Section(){return A4},set Section(e){A4=e}});let W4={item:"item_bZY","item-content":"item-content_nNz",itemContent:"item-content_nNz",label:"label_RZX",content:"content_ZIz","number-field":"number-field__Hd",numberField:"number-field__Hd","start-button":"start-button_F6t",startButton:"start-button_F6t","end-button":"end-button_ztm",endButton:"end-button_ztm"};oe.add("game-ui/game/components/tool-options/mouse-tool-options/mouse-tool-options.module.scss",{get classes(){return W4},set classes(e){Object.assign(W4,e)}});const z4=W4;var Y4=function(){return(0,z.jsxs)(Ap,{children:[(0,z.jsx)(q4,{}),(0,z.jsx)(X4,{}),(0,z.jsx)(Q4,{}),(0,z.jsx)(r6,{}),(0,z.jsx)(n6,{}),(0,z.jsx)(a6,{}),(0,z.jsx)(J4,{}),(0,z.jsx)(s6,{})]})},$4=function(e){var t=e.title,n=e.uiTag,r=e.children;return(0,z.jsx)(Yv,{className:z4.item,children:(0,z.jsxs)("div",{className:z4.itemContent,children:[(0,z.jsx)("div",{className:z4.label,children:t}),(0,z.jsx)(tk,{uiTag:n,children:(0,z.jsx)("div",{className:z4.content,children:r})})]})})},q4=function(){var e,t=xl(YA),n=xl(zA),r=DL(QA);return(0,z.jsx)(YL,{children:n.length>1&&(0,z.jsx)($4,{title:(0,z.jsx)(qc.Toolbar.THEME_PANEL_TITLE,{}),uiTag:null===(e=Ew.value)||void 0===e?void 0:e.toolOptionsThemes,children:(0,z.jsx)(Ip,{focused:qs(t),direction:gp.Horizontal,onChange:r,children:n.map((function(e){return(0,z.jsx)(e8,{title:(0,z.jsx)(qc.ToolOptions.TOOLTIP_TITLE,{hash:e.name}),description:(0,z.jsx)(qc.ToolOptions.TOOLTIP_DESCRIPTION,{hash:e.name}),children:(0,z.jsx)(S4,{focusKey:qs(e.entity),value:e.entity,src:e.icon,selected:Qs(e.entity,t),highlight:e.highlight,onClick:QA})},qs(e.entity))}))})})})},X4=function(){var e,t;ih(null===(e=Ew.value)||void 0===e?void 0:e.toolOptionsModes);var n=xl(VN),r=(0,Y.useCallback)((function(e){return lA(e)}),[]),i=(0,Y.useCallback)((function(e){"number"==typeof e&&r(e)}),[r]);return(0,z.jsx)(YL,{children:n.modes.length>1&&(0,z.jsx)($4,{title:n.modes.length<=7?(0,z.jsx)(qc.Toolbar.TOOL_MODE_TITLE,{}):null,uiTag:null===(t=Ew.value)||void 0===t?void 0:t.toolOptionsModes,children:(0,z.jsx)(Ip,{focused:n.modeIndex,direction:gp.Horizontal,onChange:i,children:n.modes.map((function(e){var t;return(0,z.jsx)(e8,{title:(0,z.jsx)(qc.ToolOptions.TOOLTIP_TITLE,{hash:e.id}),description:(0,z.jsx)(qc.ToolOptions.TOOLTIP_DESCRIPTION,{hash:e.id}),children:(0,z.jsx)(S4,{uiTag:(null===(t=Ew.value)||void 0===t?void 0:t.toolOptionsModes)+e.id,focusKey:e.index,value:e.index,src:e.icon,selected:e.index===n.modeIndex,onSelect:r})},e.id)}))})})})},Q4=function(){var e,t,n=xl(CA),r=xl(AA),i=xl(LA),o=xl(kA),a=xl(RA),s=r<=o,l=r>=a,c=(0,Y.useCallback)((function(){FA(of(Z4(r,-(r>550?100:r>125?50:10)),o,a))}),[r,o,a]),u=(0,Y.useCallback)((function(){FA(of(Z4(r,r>475?100:r>95?50:10),o,a))}),[r,a,o]),d=i<=.01,f=i>=1,m=(0,Y.useCallback)((function(){UA(of(Z4(i,-(i>.11?.05:.01)),.01,1))}),[i]),g=(0,Y.useCallback)((function(){UA(of(Z4(i,+(i>.095?.05:.01)),.01,1))}),[i]);return(0,z.jsx)(YL,{children:!Qs(n,ty)&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)($4,{title:(0,z.jsx)(qc.Toolbar.BRUSH_SIZE,{}),uiTag:null===(e=Ew.value)||void 0===e?void 0:e.toolOptionsBrushSize,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)(E4,{src:"Media/Glyphs/ThickStrokeArrowDown.svg",disabled:s,tooltip:(0,z.jsx)(qc.ToolOptions.TOOLTIP_DECREASE_BRUSH_SIZE,{}),selectSound:Lp.decreaseElevation,className:z4.startButton,onSelect:c}),(0,z.jsx)("div",{className:z4.numberField,children:(0,z.jsx)(su,{value:r,unit:$c.Integer})}),(0,z.jsx)(E4,{src:"Media/Glyphs/ThickStrokeArrowUp.svg",disabled:l,tooltip:(0,z.jsx)(qc.ToolOptions.TOOLTIP_INCREASE_BRUSH_SIZE,{}),selectSound:Lp.increaseElevation,className:z4.endButton,onSelect:u})]})}),(0,z.jsx)($4,{title:(0,z.jsx)(qc.Toolbar.BRUSH_STRENGTH,{}),uiTag:null===(t=Ew.value)||void 0===t?void 0:t.toolOptionsBrushStrength,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)(E4,{src:"Media/Glyphs/ThickStrokeArrowDown.svg",disabled:d,tooltip:(0,z.jsx)(qc.ToolOptions.TOOLTIP_DECREASE_BRUSH_STRENGTH,{}),selectSound:Lp.decreaseElevation,className:z4.startButton,onSelect:m}),(0,z.jsx)("div",{className:z4.numberField,children:(0,z.jsx)(su,{value:100*i,unit:$c.Percentage})}),(0,z.jsx)(E4,{src:"Media/Glyphs/ThickStrokeArrowUp.svg",disabled:f,tooltip:(0,z.jsx)(qc.ToolOptions.TOOLTIP_INCREASE_BRUSH_STRENGTH,{}),selectSound:Lp.increaseElevation,className:z4.endButton,onSelect:g})]})})]})})};function Z4(e,t){return t*Math.round(e/t)+t}var J4=function(){var e,t=xl(KN),n=xl(zN),r=xl(WN),i=xl(YN),o=e6(t),a=(r&n)===n,s=(0,Y.useCallback)((function(){hA(a?r&~n:r|n)}),[a,n,r]),l=(0,Y.useCallback)((function(e){var t=1<<e;hA(0!=(r&t)?r&~t:r|t)}),[r]);return(0,z.jsx)(YL,{children:o.length>0&&(0,z.jsx)($4,{title:o.length<=6?(0,z.jsx)(qc.Toolbar.SNAPPING_TITLE,{}):null,uiTag:null===(e=Ew.value)||void 0===e?void 0:e.toolOptionsSnapping,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[o.length>1&&(0,z.jsx)(E4,{multiSelect:!0,src:"Media/Tools/Snap Options/All.svg",selected:a,tooltip:(0,z.jsx)(qc.ToolOptions.TOOLTIP_SNAP_ALL,{}),onSelect:s}),o.map((function(e){return(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.ToolOptions.TOOLTIP,{hash:i[e]}),children:(0,z.jsx)(S4,{focusKey:e,value:e,src:"Media/Tools/Snap Options/"+i[e]+".svg",selected:0!=(r&1<<e),multiSelect:!0,onSelect:l},e)},e)}))]})})})},e6=function(e){return(0,Y.useMemo)((function(){for(var t=[],n=0;e>>n>0;)0!=(e>>n&1)&&t.push(n),n++;return t}),[e])},t6=[10,5,2.5,1.25],n6=function(){var e,t,n,r,i=xl($N),o=xl(qN),a=xl(XN),s=o<=i.min,l=o>=i.max,c=(0,Y.useCallback)((function(e){return gA(e)}),[]),u=(0,Y.useCallback)((function(){return fA()}),[]),d=(0,Y.useCallback)((function(){return dA()}),[]);return(0,z.jsx)(YL,{children:i.min<i.max&&(0,z.jsx)($4,{title:(0,z.jsx)(qc.Toolbar.ELEVATION_TITLE,{}),uiTag:null===(e=Ew.value)||void 0===e?void 0:e.toolOptionsElevation,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)(E4,{src:"Media/Glyphs/ThickStrokeArrowDown.svg",disabled:s,tooltip:(0,z.jsx)(qc.ToolOptions.TOOLTIP_DECREASE_ELEVATION,{}),selectSound:Lp.decreaseElevation,uiTag:null===(t=Ew.value)||void 0===t?void 0:t.toolOptionsElevationDecrease,className:z4.startButton,onSelect:u}),(0,z.jsx)("div",{className:z4.numberField,children:(0,z.jsx)(su,{value:o,unit:$c.NetElevation})}),(0,z.jsx)(E4,{src:"Media/Glyphs/ThickStrokeArrowUp.svg",disabled:l,tooltip:(0,z.jsx)(qc.ToolOptions.TOOLTIP_INCREASE_ELEVATION,{}),selectSound:Lp.increaseElevation,uiTag:null===(n=Ew.value)||void 0===n?void 0:n.toolOptionsElevationIncrease,className:z4.endButton,onSelect:d}),(0,z.jsx)(T4,{selectedValue:a,values:t6,uiTag:null===(r=Ew.value)||void 0===r?void 0:r.toolOptionsElevationStep,tooltip:(0,z.jsx)(qc.ToolOptions.TOOLTIP_ELEVATION_STEP,{}),onSelect:c})]})})})},r6=function(){var e,t=xl(VN),n=xl(eA),r=xl(tA),i=(0,Y.useCallback)((function(){return bA(!r)}),[r]);return(0,z.jsx)(YL,{children:t.id!==xA&&n&&(0,z.jsx)($4,{title:(0,z.jsx)(qc.Toolbar.UNDERGROUND_MODE_TITLE,{}),children:(0,z.jsx)(E4,{src:"Media/Tools/Net Tool/Underground.svg",disabled:!n,selected:r,multiSelect:!0,uiTag:null===(e=Ew.value)||void 0===e?void 0:e.toolOptionsUnderground,tooltip:(0,z.jsx)(qc.Toolbar.TOGGLE_UNDERGROUND_MODE,{}),selectSound:r?Lp.increaseElevation:Lp.decreaseElevation,onSelect:i})})})},i6=new Wh("PARALLEL_MODE_TOGGLE"),o6=[2,4,8,16,24,32,40,48,56,64,72,80,88,96],a6=function(){var e,t,n,r,i=xl(QN),o=xl(ZN),a=xl(JN),s=(0,Y.useMemo)((function(){return o6.sort((function(e,t){return e-t}))}),[]),l=a<=s[0],c=(0,Y.useCallback)((function(){for(var e=s.length-1;e>=0;e--)if(s[e]<a){vA(s[e]);break}}),[a,s]),u=a>=s[s.length-1],d=(0,Y.useCallback)((function(){for(var e=0;e<s.length;e++)if(s[e]>a){vA(s[e]);break}}),[a,s]);return(0,z.jsx)(YL,{children:i&&(0,z.jsx)($4,{title:(0,z.jsx)(qc.Toolbar.PARALLEL_MODE_TITLE,{}),children:(0,z.jsxs)(Ap,{initialFocused:i6,direction:gp.Horizontal,children:[o&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(E4,{src:"Media/Tools/Net Tool/ParallelMinus.svg",tooltip:(0,z.jsx)(qc.Toolbar.DECREASE_PARALLEL_OFFSET,{}),className:z4.startButton,disabled:l,onSelect:c,uiTag:null===(e=Ew.value)||void 0===e?void 0:e.toolOptionsParallelModeOffsetDecrease}),(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.toolOptionsParallelModeOffset,children:(0,z.jsx)("div",{className:z4.numberField,children:(0,z.jsx)(su,{value:a/8,unit:$c.FloatTwoFractions})})}),(0,z.jsx)(E4,{src:"Media/Tools/Net Tool/ParallelPlus.svg",tooltip:(0,z.jsx)(qc.Toolbar.INCREASE_PARALLEL_OFFSET,{}),className:z4.endButton,disabled:u,onSelect:d,uiTag:null===(n=Ew.value)||void 0===n?void 0:n.toolOptionsParallelModeOffsetIncrease})]}),(0,z.jsx)(E4,{focusKey:i6,src:"Media/Tools/Net Tool/Parallel.svg",tooltip:(0,z.jsx)(qc.Toolbar.TOGGLE_PARALLEL_MODE,{}),selected:o,multiSelect:!0,onSelect:pA,uiTag:null===(r=Ew.value)||void 0===r?void 0:r.toolOptionsParallelMode})]})})})},s6=function(){var e=xl(VN),t=xl(iA),n=xl(oA),r=(0,Y.useCallback)((function(e){return aA(e)}),[]);return(0,z.jsx)(YL,{children:e.id!==xA&&t&&(0,z.jsx)($4,{title:(0,z.jsx)(qc.ToolOptions.COLOR_TITLE,{hash:e.id}),children:(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.ToolOptions.COLOR_TOOLTIP,{hash:e.id}),children:(0,z.jsx)(v4,{popupDirection:"up",value:n,onChange:r})})})})};oe.add("game-ui/game/components/tool-options/mouse-tool-options/mouse-tool-options.tsx",{get MouseToolOptions(){return Y4},set MouseToolOptions(e){Y4=e},get Section(){return $4},set Section(e){$4=e}});let l6={"tool-options-panel":"tool-options-panel_Se6",toolOptionsPanel:"tool-options-panel_Se6","gamepad-active":"gamepad-active_Qvi",gamepadActive:"gamepad-active_Qvi",enter:"enter_YDH","exit-active":"exit-active_hKG",exitActive:"exit-active_hKG","enter-active":"enter-active_bG3",enterActive:"enter-active_bG3",exit:"exit_oe7"};oe.add("game-ui/game/components/tool-options/tool-options-panel.module.scss",{get classes(){return l6},set classes(e){Object.assign(l6,e)}});const c6=l6;var u6=Y.forwardRef((function(e,t){var n,r=e.focusKey,i=e.className,o=e.onClose,a=Pg();return(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.toolOptions,disableBlinking:!0,children:(0,z.jsx)(hj,{focusKey:r,children:(0,z.jsx)(ap,{onAction:o,children:(0,z.jsx)(Cm,{styles:c6,children:(0,z.jsx)(zv,{ref:t,className:_d()(c6.toolOptionsPanel,a&&c6.gamepadActive,i),children:a?(0,z.jsx)(N4,{}):(0,z.jsx)(Y4,{})})})})})})}));function d6(){var e=xl(zA),t=xl(VN),n=xl(CA),r=xl(KN),i=xl($N),o=xl(QN),a=xl(eA),s=xl(iA);return t.id!==IA&&(e.length>1||t.modes.length>1||0!==r||i.min<i.max||o||s||t.id!==xA&&a||!Qs(n,ty))}oe.add("game-ui/game/components/tool-options/tool-options-panel.tsx",{get ToolOptionsPanel(){return u6},set ToolOptionsPanel(e){u6=e},get useToolOptionsVisible(){return d6},set useToolOptionsVisible(e){d6=e}});let f6={"background-process-indicator":"background-process-indicator_NS7",backgroundProcessIndicator:"background-process-indicator_NS7",spinner:"spinner_TZP",rotate:"rotate_dOE",message:"message_UX3"};oe.add("game-ui/common/background-process-indicator/background-process-indicator.module.scss",{get classes(){return f6},set classes(e){Object.assign(f6,e)}});const m6=f6;var g6=function(e){var t=e.className,n=xl(Mh);return n?(0,z.jsxs)("div",{className:_d()(m6.backgroundProcessIndicator,t),children:[(0,z.jsx)("div",{className:m6.message,children:(0,z.jsx)(kc,{id:n})}),(0,z.jsx)(tb,{src:"Media/Glyphs/ArrowCircular.svg",className:m6.spinner})]}):null};oe.add("game-ui/common/background-process-indicator/background-process-indicator.tsx",{get BackgroundProcessIndicator(){return g6},set BackgroundProcessIndicator(e){g6=e}});let h6={"climate-field":"climate-field_dIy field_eKJ",climateField:"climate-field_dIy field_eKJ",weather:"weather_dXo","weather-container":"weather-container_L1D",weatherContainer:"weather-container_L1D","celestial-object":"celestial-object_su7",celestialObject:"celestial-object_su7",active:"active_k1G",obstructed:"obstructed_oBa",sun:"sun_XMt celestial-object_su7",moon:"moon_TlF celestial-object_su7","weather-icon":"weather-icon_BeV",weatherIcon:"weather-icon_BeV",temperature:"temperature_CiN",season:"season_js3","season-hidden":"season-hidden_Y_1",seasonHidden:"season-hidden_Y_1"};oe.add("game-ui/game/components/toolbar/bottom/climate-field/climate-field.module.scss",{get classes(){return h6},set classes(e){Object.assign(h6,e)}});const p6=h6;function v6(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var b6=function(e){var t=e.hideSeason,n=e.theme,r=xl($T),i=xl(qT),o=xl(XT),a=function(e){switch(e){case EN.Sunrise:case EN.Day:case EN.Sunset:return!1;default:return!0}}(xl(PN));return(0,z.jsx)(e8,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_WEATHER,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_WEATHER,{}),children:(0,z.jsxs)(Yv,{className:_d()(p6.climateField,null==n?void 0:n.climateField,v6({},p6.seasonHidden,t)),children:[(0,z.jsx)("div",{className:_d()(p6.weather,null==n?void 0:n.weather),children:(0,z.jsxs)("div",{className:p6.weatherContainer,children:[(0,z.jsx)("img",{src:"Media/Game/Climate/Sun.svg",className:_d()(p6.sun,!a&&p6.active,i>zT.Few&&p6.obstructed)}),(0,z.jsx)("img",{src:"Media/Game/Climate/Moon.svg",className:_d()(p6.moon,a&&p6.active,i>zT.Few&&p6.obstructed)}),(0,z.jsx)("img",{src:"Media/Game/Climate/Few.svg",className:_d()(p6.weatherIcon,i===zT.Few&&p6.active)}),(0,z.jsx)("img",{src:"Media/Game/Climate/Scattered.svg",className:_d()(p6.weatherIcon,i===zT.Scattered&&p6.active)}),(0,z.jsx)("img",{src:"Media/Game/Climate/Broken.svg",className:_d()(p6.weatherIcon,i===zT.Broken&&p6.active)}),(0,z.jsx)("img",{src:"Media/Game/Climate/Overcast.svg",className:_d()(p6.weatherIcon,i===zT.Overcast&&p6.active)}),(0,z.jsx)("img",{src:"Media/Game/Climate/Rain.svg",className:_d()(p6.weatherIcon,i===zT.Rain&&p6.active)}),(0,z.jsx)("img",{src:"Media/Game/Climate/Snow.svg",className:_d()(p6.weatherIcon,i===zT.Snow&&p6.active)}),(0,z.jsx)("img",{src:"Media/Game/Climate/Hail.svg",className:_d()(p6.weatherIcon,i===zT.Hail&&p6.active)}),(0,z.jsx)("img",{src:"Media/Game/Climate/Storm.svg",className:_d()(p6.weatherIcon,i===zT.Storm&&p6.active)}),(0,z.jsx)("div",{className:_d()(p6.temperature,null==n?void 0:n.temperature),children:(0,z.jsx)(su,{value:o,unit:$c.Temperature})})]})}),!t&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(R8,{}),(0,z.jsx)("div",{className:_d()(p6.season,null==n?void 0:n.season),children:null!=r&&(0,z.jsx)(kc,{id:r})})]})]})})};oe.add("game-ui/game/components/toolbar/bottom/climate-field/climate-field.tsx",{get ClimateField(){return b6},set ClimateField(e){b6=e}});var y6="editorBottomBar",x6=fl(y6,"timeOfDay",0),_6=fl(y6,"date",0),j6=fl(y6,"cloudiness",0),O6=function(e){return bl(y6,"setTimeOfDay",e)},E6=function(){return bl(y6,"resetTimeOfDay")},S6=function(e){return bl(y6,"setDate",e)},T6=function(){return bl(y6,"resetDate")},I6=function(e){return bl(y6,"setCloudiness",e)},w6=function(){return bl(y6,"resetCloudiness")};oe.add("game-ui/editor/data-binding/editor-bottom-bar-bindings.ts",{get timeOfDay(){return timeOfDay},set timeOfDay(e){timeOfDay=e},get date(){return date},set date(e){date=e},get cloudiness(){return cloudiness},set cloudiness(e){cloudiness=e},get setTimeOfDay(){return O6},set setTimeOfDay(e){O6=e},get resetTimeOfDay(){return E6},set resetTimeOfDay(e){E6=e},get setDate(){return S6},set setDate(e){S6=e},get resetDate(){return T6},set resetDate(e){T6=e},get setCloudiness(){return I6},set setCloudiness(e){I6=e},get resetCloudiness(){return w6},set resetCloudiness(e){w6=e}});let P6={"bottom-bar":"bottom-bar_ODl",bottomBar:"bottom-bar_ODl","bp-indicator":"bp-indicator_RBs",bpIndicator:"bp-indicator_RBs",space:"space_u2B",button:"button_wKY","button-highlight":"button-highlight_lZc",buttonHighlight:"button-highlight_lZc",sliders:"sliders_H5X",slider:"slider_aPR","slider-container":"slider-container_Fkn",sliderContainer:"slider-container_Fkn",aside:"aside_uAL",icon:"icon_KvW item-mouse-states_Fmi item-focused_FuT",controls:"controls_tq0",modes:"modes_Bd5","inspector-modes":"inspector-modes_ur5",inspectorModes:"inspector-modes_ur5"};oe.add("game-ui/editor/components/bottom-bar/bottom-bar.module.scss",{get classes(){return P6},set classes(e){Object.assign(P6,e)}});const C6=P6;var N6=function(e){var t=e.className,n=e.onPauseMenuToggle,r=xl(_6),i=xl(x6),o=xl(j6);return(0,z.jsx)(Ap,{children:(0,z.jsxs)("div",{className:_d()(C6.bottomBar,t),children:[(0,z.jsxs)("div",{className:C6.controls,children:[(0,z.jsxs)("div",{className:C6.aside,children:[(0,z.jsx)(B8,{disablePauseAnimation:!0}),(0,z.jsx)(GL,{children:(0,z.jsx)(b6,{hideSeason:!0})})]}),(0,z.jsxs)("div",{className:C6.sliders,children:[(0,z.jsx)(A6,{value:i,onChange:O6,icon:"Media/Editor/Time.svg",onReset:E6,sliderTooltip:(0,z.jsx)(qc.Editor.TIME_OF_DAY,{}),resetTooltip:(0,z.jsx)(qc.Editor.RESET_TIME_OF_DAY,{})}),(0,z.jsx)(A6,{value:r,onChange:S6,icon:"Media/Editor/Date.svg",onReset:T6,sliderTooltip:(0,z.jsx)(qc.Editor.TIME_OF_YEAR,{}),resetTooltip:(0,z.jsx)(qc.Editor.RESET_TIME_OF_YEAR,{})}),(0,z.jsx)(A6,{value:o,onChange:I6,icon:"Media/Editor/Weather.svg",onReset:w6,sliderTooltip:(0,z.jsx)(qc.Editor.CLOUDINESS,{}),resetTooltip:(0,z.jsx)(qc.Editor.RESET_CLOUDINESS,{})})]}),(0,z.jsx)("div",{children:(0,z.jsx)(g6,{className:C6.bpIndicator})})]}),(0,z.jsxs)("div",{className:C6.modes,children:[(0,z.jsxs)("div",{className:C6.inspectorModes,children:[(0,z.jsx)(L6,{cameraMode:b8.FirstPerson,icon:"Media/Editor/CinematicCameraOn.svg",offIcon:"Media/Editor/CinematicCameraOff.svg",tooltip:(0,z.jsx)(qc.PhotoMode.TOGGLE_FIRST_PERSON_MODE,{})}),(0,z.jsx)(L6,{cameraMode:b8.Orbit,icon:"Media/Game/Icons/Orbit.svg",tooltip:(0,z.jsx)(qc.PhotoMode.TOGGLE_ORBIT_MODE,{})})]}),(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Common.PAUSE_MENU_TOGGLE_TOOLTIP,{}),children:(0,z.jsx)(lb,{tinted:!0,src:"Media/Glyphs/Gear.svg",className:C6.button,onSelect:n})})]})]})})},A6=function(e){var t=e.value,n=e.onChange,r=e.icon,i=e.onReset,o=e.sliderTooltip,a=e.resetTooltip;return(0,z.jsxs)("div",{className:C6.slider,children:[(0,z.jsx)(jh,{tooltip:a,children:(0,z.jsx)(lb,{src:r,className:C6.icon,onSelect:i})}),(0,z.jsx)(zv,{className:C6.sliderContainer,children:(0,z.jsx)(HL,{children:(0,z.jsx)(jh,{tooltip:o,children:(0,z.jsx)(oF,{value:t,start:0,end:1,noFill:!0,onChange:n})})})})]})},L6=function(e){var t=e.cameraMode,n=e.icon,r=e.offIcon,i=e.tooltip,o=xl(C8)===t,a=(0,Y.useCallback)((function(){N8(o?b8.Default:t)}),[o,t]),s=void 0===r||o?n:r;return(0,z.jsx)(jh,{tooltip:i,children:(0,z.jsx)(lb,{src:s,className:_d()(C6.button,o&&C6.buttonHighlight),onSelect:a})})};function M6(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function k6(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function R6(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){k6(e,t,n[t])}))}return e}function D6(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function F6(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function U6(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return M6(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return M6(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/editor/components/bottom-bar/bottom-bar.tsx",{get BottomBar(){return N6},set BottomBar(e){N6=e}});var G6=Y.forwardRef((function(e,t){var n=e.theme,r=void 0===n?Uj:n,i=e.onClose,o=e.expanded,a=void 0===o||o,s=e.headerText,l=e.onToggleExpanded,c=e.className,u=e.children,d=e.isFocusRoot,f=F6(e,["theme","onClose","expanded","headerText","onToggleExpanded","className","children","isFocusRoot"]),m=Dj(r),g=U6((0,Y.useState)(a),2),h=g[0],p=g[1],v=(0,Y.useCallback)((function(){kp(Lp.expandPanel),p((function(e){return!e})),l&&l(!h)}),[h,l]),b=(0,Y.useMemo)((function(){return{theme:m,onClose:i,expanded:h,toggleExpanded:v}}),[m,i,h,v]);(0,Y.useEffect)((function(){p(a)}),[a]);var y=d?wj:Tg;return(0,z.jsx)(y,{children:(0,z.jsx)(ap,{onAction:i,children:(0,z.jsx)(kj.Provider,{value:b,children:(0,z.jsx)(qj,D6(R6({theme:m,ref:t,header:(0,z.jsx)(B6,{children:s})},f),{className:_d()(h?"expanded":"collapsed","collapsible",c),children:h?u:void 0}))})})})})),B6=function(e){var t=e.icon,n=e.theme,r=e.className,i=e.children,o=(0,Y.useContext)(kj),a=!Pg()&&null!=o.onClose,s=null!=n?n:o.theme;return(0,z.jsxs)("div",{onClick:o.toggleExpanded,className:_d()(s.titleBar,r),children:[null!=t?(0,z.jsx)("img",{src:t,className:s.icon}):a&&(0,z.jsx)("div",{className:s.iconSpace}),(0,z.jsx)("div",{className:s.iconSpace}),(0,z.jsx)("div",{className:s.title,children:i}),(0,z.jsx)(tb,{className:s.toggle,src:o.expanded?s.toggleIconExpanded:s.toggleIcon}),a?(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:s.closeIcon,theme:ub,className:s.closeButton,onSelect:o.onClose,onClick:iv}):null!=t&&(0,z.jsx)("div",{className:s.iconSpace})]})};oe.add("game-ui/common/panel/collapsible-panel.tsx",{get CollapsiblePanel(){return G6},set CollapsiblePanel(e){G6=e}});var V6="editorToolOptions",H6=fl(V6,"children");oe.add("game-ui/editor/data-binding/editor-tool-options-bindings.ts",{get toolOptionsGroup(){return V6},set toolOptionsGroup(e){V6=e},get toolOptions(){return toolOptions},set toolOptions(e){toolOptions=e}});let K6={panel:"panel_WVw panel_YqS",header:"header_IuN header_Bpo child-opacity-transition_nkS",content:"content_yeu content_AD7 child-opacity-transition_nkS",footer:"footer_j9m footer_pD5 child-opacity-transition_nkS",title:"title_q1x title_zQN"};oe.add("game-ui/editor/themes/editor-panel.module.scss",{get classes(){return K6},set classes(e){Object.assign(K6,e)}});const W6=K6;let z6={"resize-container":"resize-container_AAw",resizeContainer:"resize-container_AAw","drag-handle":"drag-handle_enz",dragHandle:"drag-handle_enz",left:"left_jHP",right:"right_fxN","resize-cursor":"resize-cursor_YOy",resizeCursor:"resize-cursor_YOy"};oe.add("game-ui/editor/components/resize-container/resize-container.module.scss",{get classes(){return z6},set classes(e){Object.assign(z6,e)}});const Y6=z6;function $6(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function q6(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return $6(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return $6(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var X6=function(e){var t=e.width,n=e.minWidth,r=e.maxWidth,i=e.direction,o=e.className,a=e.children,s=e.onResize,l="left"===i?-1:1,c=q6((0,Y.useState)(0),2),u=c[0],d=c[1],f=(0,Y.useCallback)((function(e){return d(e)}),[]),m=(0,Y.useCallback)((function(){return d(0)}),[]),g=(0,Y.useCallback)((function(e){s(of(t+l*e,n,r)),d(0)}),[s,t,l,n,r]);return(0,z.jsxs)("div",{className:_d()(Y6.resizeContainer,o),style:{width:of(t+l*u,n,r)},children:[a,"none"!==i&&(0,z.jsx)(Q6,{className:Y6[i],onChange:f,onDragStart:m,onDragEnd:g})]})},Q6=function(e){var t=e.className,n=e.onChange,r=e.onDragStart,i=e.onDragEnd,o=(0,Y.useRef)(null),a=(0,Y.useCallback)((function(e){var t=e.clientX;return function(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}(document.activeElement,HTMLElement)&&document.activeElement.blur(),o.current=t,r(),!0}),[r]),s=(0,Y.useCallback)((function(e){var t=e.clientX;null!=o.current&&(i(t-o.current),o.current=null)}),[i]),l=(0,Y.useCallback)((function(e){var t=e.clientX;null!=o.current&&n(t-o.current)}),[n]),c=q6(sE(a,l,s),2),u=c[0],d=c[1];return dR(u?Y6.resizeCursor:void 0),(0,z.jsx)("div",{className:_d()(Y6.dragHandle,u&&"dragging",t),onMouseDown:d})};oe.add("game-ui/editor/components/resize-container/resize-container.tsx",{get ResizeContainer(){return X6},set ResizeContainer(e){X6=e}});let Z6={minWidth:"250rem",maxWidth:"800rem",panel:"panel_R8J",content:"content_Mxn"};oe.add("game-ui/editor/components/editor-panel/editor-panel.module.scss",{get classes(){return Z6},set classes(e){Object.assign(Z6,e)}});const J6=Z6;function e7(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function t7(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return e7(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return e7(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var n7=function(e){var t=e.resizeDirection,n=e.className,r=t7((0,Y.useState)(!0),2),i=r[0],o=r[1],a=YO(J6.minWidth),s=YO(J6.maxWidth),l=xl(eB),c=$O(),u=(0,Y.useCallback)((function(e){nB(Math.round(e/c))}),[c]),d=xl(JG),f=xl(tB),m=cD(QG),g=xl(H6),h=cD(V6),p=g.length>0?(0,z.jsx)(Ap,{focusKey:Hh,children:(0,z.jsx)(d0,{parent:h,data:g})}):void 0;return(0,z.jsx)(X6,{width:l*c,minWidth:a,maxWidth:s,direction:i?t:"none",className:n,onResize:u,children:(0,z.jsx)(G6,{expanded:i,headerText:null!=d&&(0,z.jsx)(ku,{value:d}),footer:p,theme:W6,className:J6.panel,contentClassName:J6.content,onToggleExpanded:o,onClose:iB,allowFocusExit:!0,children:(0,z.jsx)(ap,{onAction:rB,children:(0,z.jsx)(Ap,{children:(0,z.jsx)(d0,{parent:m,data:f})})})})})};function r7(e){var t=cd(xl(R_),e),n=(0,Y.useCallback)((function(){return U_(e)}),[e]);return(0,Y.useMemo)((function(){return{visible:t,toggle:n}}),[t,n])}oe.add("game-ui/editor/components/editor-panel/editor-panel.tsx",{get EditorPanel(){return n7},set EditorPanel(e){n7=e}}),oe.add("game-ui/common/hooks/use-game-panel-state.tsx",{get useGamePanelState(){return r7},set useGamePanelState(e){r7=e}});let i7={button:"button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT","toggle-states":"toggle-states_DTm",toggleStates:"toggle-states_DTm",icon:"icon_soN icon_Iwk",locked:"locked_H2O locked_dBl"};oe.add("game-ui/game/themes/transparent-button.module.scss",{get classes(){return i7},set classes(e){Object.assign(i7,e)}});const o7=i7;let a7={"infomode-item":"infomode-item_K8b item-focused_FuT item-mouse-states_Fmi",infomodeItem:"infomode-item_K8b item-focused_FuT item-mouse-states_Fmi",checkbox:"checkbox_JWP",header:"header_dAd",title:"title_tX0","title-text":"title-text_uCA",titleText:"title-text_uCA",active:"active_m64",color:"color_Q5Z",legend:"legend_K3N","color-legend":"color-legend_PQU legend_K3N",colorLegend:"color-legend_PQU legend_K3N","color-legend-item":"color-legend-item__ty",colorLegendItem:"color-legend-item__ty",label:"label_oSR",gradient:"gradient_HaQ",type:"type_puL"};oe.add("game-ui/game/components/infoviews/active-infoview-panel/components/infomode-item/infomode-item.module.scss",{get classes(){return a7},set classes(e){Object.assign(a7,e)}});const s7=a7;function l7(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function c7(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){l7(e,t,n[t])}))}return e}var u7=function(e){var t=e.focusKey,n=e.infomode,r=n.id,i=n.active,o=(0,Y.useCallback)((function(){ay(n.entity,!n.active,n.priority)}),[n.entity,n.active,n.priority]);return(0,z.jsx)(jh,{direction:"right",tooltip:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.Infoviews.INFOMODE_TOOLTIP,{hash:r})}),children:(0,z.jsxs)(Qp,{focusKey:t,onSelect:o,theme:o7,selectSound:Lp.toggleInfoMode,selectAction:i?"Disable Info Mode":"Enable Info Mode",className:_d()(s7.infomodeItem,i&&s7.active),children:[(0,z.jsxs)("div",{className:s7.header,children:[(0,z.jsxs)("div",{className:s7.title,children:[n.color&&(0,z.jsx)(pU,{color:rP(n.color),className:s7.color}),(0,z.jsx)("div",{className:s7.titleText,children:(0,z.jsx)(qc.Infoviews.INFOMODE,{hash:r})})]}),(0,z.jsxs)("div",{className:s7.type,children:[(0,z.jsx)(qc.Infoviews.INFOMODE_TYPE,{hash:n.type}),(0,z.jsx)(fv,{checked:i,focusKey:Hh,className:s7.checkbox})]})]}),n.gradientLegend&&(0,z.jsx)(d7,c7({},n.gradientLegend)),n.colorLegends.length>0&&(0,z.jsx)("div",{className:s7.colorLegend,children:n.colorLegends.map((function(e,t){return(0,z.jsx)(hU,{color:rP(e.color),label:(0,z.jsx)(ku,{value:e.label}),className:s7.colorLegendItem},t)}))})]})})},d7=function(e){var t=e.lowLabel,n=e.highLabel,r=e.gradient;return(0,z.jsxs)("div",{className:s7.legend,children:[t&&(0,z.jsx)("div",{className:s7.label,children:(0,z.jsx)(ku,{value:t})}),(0,z.jsx)("div",{className:s7.gradient,style:{backgroundImage:fP(r)}}),n&&(0,z.jsx)("div",{className:s7.label,children:(0,z.jsx)(ku,{value:n})})]})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/components/infomode-item/infomode-item.tsx",{get InfomodeItem(){return u7},set InfomodeItem(e){u7=e}});let f7={"small-space":"small-space_DCq",smallSpace:"small-space_DCq",space:"space_uKL"};oe.add("game-ui/game/components/infoviews/active-infoview-panel/components/infoview-panel-space.module.scss",{get classes(){return f7},set classes(e){Object.assign(f7,e)}});const m7=f7;var g7=function(e){var t=e.small,n=void 0!==t&&t;return(0,z.jsx)("div",{className:n?m7.smallSpace:m7.space})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/components/infoview-panel-space.tsx",{get InfoviewPanelSpace(){return g7},set InfoviewPanelSpace(e){g7=e}});let h7={labels:"labels_L7Q",row:"row_S2v","left-icon":"left-icon_fKY",leftIcon:"left-icon_fKY",left:"left_Lgw",uppercase:"uppercase_RJI",right:"right_k3O",centered:"centered_j4I",small:"small_ExK",label:"label_NuH",tiny:"tiny_m9B","icon-label":"icon-label_J_h",iconLabel:"icon-label_J_h",icon:"icon_W7O"};oe.add("game-ui/game/components/infoviews/active-infoview-panel/components/labels/labels.module.scss",{get classes(){return h7},set classes(e){Object.assign(h7,e)}});const p7=h7;var v7=function(e){var t=e.icon,n=e.text,r=e.rightText,i=e.uppercase,o=void 0!==i&&i,a=e.centered,s=void 0!==a&&a,l=e.small,c=void 0!==l&&l,u=e.tiny,d=void 0!==u&&u;return(0,z.jsxs)("div",{className:_d()(p7.labels,p7.row,o&&p7.uppercase,s&&p7.centered,c&&p7.small,d&&p7.tiny),children:[t&&(0,z.jsx)("img",{src:t,className:p7.leftIcon}),n&&(0,z.jsx)("div",{className:_d()(p7.left,p7.row),children:n}),r&&(0,z.jsx)("div",{className:_d()(p7.right,p7.row),children:r})]})},b7=function(e){var t=e.icon,n=e.label;return(0,z.jsxs)("div",{className:p7.iconLabel,children:[(0,z.jsx)(tb,{src:t,className:p7.icon}),(0,z.jsx)("div",{className:p7.label,children:n})]})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/components/labels/labels.tsx",{get InfoviewPanelLabel(){return v7},set InfoviewPanelLabel(e){v7=e},get InfoviewPanelIconLabel(){return b7},set InfoviewPanelIconLabel(e){b7=e}});var y7={stops:[{color:"#0331fc",offset:0},{color:"#0331fc",offset:.333},{color:"#fcba03",offset:.333},{color:"#fcba03",offset:.666},{color:"#a15800",offset:.666},{color:"#a15800",offset:1}]},x7={stops:[{color:"#479436",offset:0},{color:"#63B506",offset:.66},{color:"#FF831B",offset:.33},{color:"#FF4E18",offset:1}]},_7={stops:[{color:"#FF4E18",offset:0},{color:"#FF831B",offset:.33},{color:"#63B506",offset:.66},{color:"#479436",offset:1}]},j7={stops:[{color:"#FF4E18",offset:0},{color:"#FF4E18",offset:.9},{color:"#479436",offset:1}]},O7={stops:[{color:"#e8f6e5",offset:0},{color:"#479436",offset:1}]},E7={stops:[{color:"#FF4E18",offset:0},{color:"#FF4E18",offset:.4},{color:"#FF831B",offset:.4},{color:"#FF831B",offset:.5},{color:"#63B506",offset:.5},{color:"#63B506",offset:.6},{color:"#479436",offset:.6},{color:"#479436",offset:1}]},S7={stops:[{color:"#FF4E18",offset:0},{color:"#FF4E18",offset:.8},{color:"#FF831B",offset:.8},{color:"#FF831B",offset:.9},{color:"#63B506",offset:.9},{color:"#63B506",offset:1}]};oe.add("game-ui/game/components/infoviews/active-infoview-panel/components/infoview-panels-util.tsx",{get pollutionGradient(){return y7},set pollutionGradient(e){y7=e},get malusGradient(){return x7},set malusGradient(e){x7=e},get bonusGradient(){return _7},set bonusGradient(e){_7=e},get transmissionGradient(){return j7},set transmissionGradient(e){j7=e},get greenGradient(){return O7},set greenGradient(e){O7=e},get availabilityGradient(){return E7},set availabilityGradient(e){E7=e},get exportGradient(){return S7},set exportGradient(e){S7=e}});let T7={bar:"bar_nW3",gradient:"gradient_P8C",overlay:"overlay_UV7",diagonalMask:"diagonalMask_osp",pointer:"pointer_SV2",pointerIcon:"pointerIcon_i8i"};oe.add("game-ui/game/components/infoviews/active-infoview-panel/components/bars/bars.module.scss",{get classes(){return T7},set classes(e){Object.assign(T7,e)}});const I7=T7;var w7=function(e){var t=e.value,n=e.gradient,r=void 0===n?E7:n;return(0,z.jsxs)("div",{className:I7.bar,children:[(0,z.jsx)("div",{className:_d()(I7.gradient),style:{backgroundImage:fP(r)}}),(0,z.jsx)("div",{className:I7.pointer,style:C7(t),children:(0,z.jsx)("img",{src:"Media/Misc/IndicatorBarPointer.svg",className:I7.pointerIcon})})]})},P7=function(e){var t=e.gradient,n=e.value,r=(0,Y.useMemo)((function(){var e=n.max-n.min,t=n.current-n.min;return{left:"".concat(t/e*100,"%")}}),[n]);return(0,z.jsxs)("div",{className:I7.bar,children:[(0,z.jsx)("div",{className:I7.gradient,style:{backgroundImage:fP(t)}}),(0,z.jsx)("div",{className:I7.pointer,style:r,children:(0,z.jsx)("img",{src:"Media/Misc/IndicatorBarPointer.svg",className:I7.pointerIcon})})]})};function C7(e){return(0,Y.useMemo)((function(){var t=e.max-e.min,n=e.current-e.min;return{left:"".concat(n/t*100,"%")}}),[e])}oe.add("game-ui/game/components/infoviews/active-infoview-panel/components/bars/bars.tsx",{get AvailabilityBar(){return w7},set AvailabilityBar(e){w7=e},get ValueBar(){return P7},set ValueBar(e){P7=e}});let N7={"infoview-panel-section":"infoview-panel-section_RXJ",infoviewPanelSection:"infoview-panel-section_RXJ",content:"content_1xS","focusable-border":"focusable-border_rVm",focusableBorder:"focusable-border_rVm",focusable:"focusable_GEc item-focused_FuT"};oe.add("game-ui/game/components/infoviews/active-infoview-panel/components/sections/infoview-panel-section.module.scss",{get classes(){return N7},set classes(e){Object.assign(N7,e)}});const A7=N7;var L7=function(e){var t=e.disableFocus,n=void 0!==t&&t,r=e.tooltip,i=e.focusableBorder,o=e.children,a=Y.Children.count(r)>0;return(0,z.jsx)(jh,{tooltip:a?(0,z.jsx)(Fv,{children:r}):void 0,direction:"right",children:(0,z.jsx)("div",{className:A7.infoviewPanelSection,children:n?(0,z.jsx)("div",{className:A7.content,children:o}):(0,z.jsx)(Yv,{className:_d()(A7.content,i?A7.focusableBorder:A7.focusable),children:o})})})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/components/sections/infoview-panel-section.tsx",{get InfoviewPanelSection(){return L7},set InfoviewPanelSection(e){L7=e}});var M7=function(e){var t=e.title,n=e.value,r=e.gradient,i=e.tooltip,o=e.children;return(0,z.jsxs)(L7,{tooltip:i,children:[t,(0,z.jsx)(P7,{gradient:r,value:n}),o]})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/components/sections/value-bar-section.tsx",{get ValueBarSection(){return M7},set ValueBarSection(e){M7=e}});var k7=function(){var e=xl(mx);return(0,z.jsx)(M7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.AirPollutionInfoPanel.AVERAGE_AIR_POLLUTION,{}),rightText:(0,z.jsx)(bd,{value:e.current,max:e.max})}),tooltip:(0,z.jsx)(qc.Infoviews.AVERAGE_AIR_POLLUTION_TOOLTIP,{}),value:e,gradient:y7})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/air-pollution-infoview-panel.tsx",{get AirPollutionInfoviewPanel(){return k7},set AirPollutionInfoviewPanel(e){k7=e}});var R7=function(){return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(D7,{}),(0,z.jsx)(F7,{}),(0,z.jsx)(U7,{})]})},D7=function(){var e=xl(t_);return(0,z.jsx)(M7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.CompanyInfoPanel.COMMERCIAL_PROFITABILITY,{}),rightText:(0,z.jsx)(bd,{value:e.current,max:e.max})}),tooltip:(0,z.jsx)(qc.Infoviews.AVERAGE_COMMERCIAL_PROFIT_TOOLTIP,{}),value:e,gradient:_7})},F7=function(){var e=xl(n_);return(0,z.jsx)(M7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.CompanyInfoPanel.INDUSTRIAL_PROFITABILITY,{}),rightText:(0,z.jsx)(bd,{value:e.current,max:e.max})}),tooltip:(0,z.jsx)(qc.Infoviews.AVERAGE_INDUSTRIAL_PROFIT_TOOLTIP,{}),value:e,gradient:_7})},U7=function(){var e=xl(r_);return(0,z.jsx)(M7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.CompanyInfoPanel.OFFICE_PROFITABILITY,{}),rightText:(0,z.jsx)(bd,{value:e.current,max:e.max})}),tooltip:(0,z.jsx)(qc.Infoviews.AVERAGE_OFFICE_PROFIT_TOOLTIP,{}),value:e,gradient:_7})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/company-infoview-panel.tsx",{get CompanyInfoviewPanel(){return R7},set CompanyInfoviewPanel(e){R7=e}});var G7=function(){var e=xl(Fx),t=xl(Rx),n=xl(Dx);return(0,z.jsxs)(M7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.DisasterInfoPanel.SHELTER_AVAILABILITY,{}),rightText:(0,z.jsx)(bd,{value:e.current,max:e.max})}),tooltip:(0,z.jsx)(qc.Infoviews.SHELTER_AVAILABILITY_TOOLTIP,{}),value:e,gradient:_7,children:[(0,z.jsx)(g7,{small:!0}),(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.DisasterInfoPanel.EVACUATED,{}),rightText:t}),(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.DisasterInfoPanel.CAPACITY,{}),rightText:n})]})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/disaster-infoview-panel.tsx",{get DisasterInfoviewPanel(){return G7},set DisasterInfoviewPanel(e){G7=e}});var B7=["#808080","#b09868","#368a2e","#b981c0","#5796d1"],V7=[(0,z.jsx)(qc.EducationInfoPanel.LEVEL,{hash:"Uneducated"}),(0,z.jsx)(qc.EducationInfoPanel.LEVEL,{hash:"Poorly Educated"}),(0,z.jsx)(qc.EducationInfoPanel.LEVEL,{hash:"Educated"}),(0,z.jsx)(qc.EducationInfoPanel.LEVEL,{hash:"Well Educated"}),(0,z.jsx)(qc.EducationInfoPanel.LEVEL,{hash:"Highly Educated"})];oe.add("game-ui/common/charts/pie-chart/education-pie-chart.tsx",{get educationPieChartColors(){return B7},set educationPieChartColors(e){B7=e},get educationPieChartLabels(){return V7},set educationPieChartLabels(e){V7=e}});let H7={"pie-chart":"pie-chart_NVJ",pieChart:"pie-chart_NVJ",label:"label_pdq"};oe.add("game-ui/common/charts/pie-chart/pie-chart.module.scss",{get classes(){return H7},set classes(e){Object.assign(H7,e)}});const K7=H7;var W7={tension:30,friction:10},z7=Y.memo((function(e){var t=e.data,n=e.size,r=void 0===n?200:n,i=e.startAngle,o=void 0===i?-.5*Math.PI:i,a=e.defaultBackground,s=void 0===a?"rgba(255, 255, 255, 0.2)":a,l=e.total,c=void 0===l?t.reduce((function(e,t){return e+t.value}),0):l,u=e.className,d=e.labelOffset,f=void 0===d?.75:d,m=e.innerRadius,g=void 0===m?.6:m,h=e.labelAngleThreshold,p=void 0===h?0:h,v=e.animate,b=void 0===v||v,y=$O(),x=Math.trunc(r*y),_=(0,Y.useRef)(null),j=YZ(W7,1,b?0:1,!0);(0,Y.useEffect)((function(){if(null!==_.current){var e=_.current.getContext("2d");if(null!=e){e.clearRect(0,0,x,x);var n=x/2;e.save(),e.translate(n,n),e.rotate(o);var r=0;c>0&&t.forEach((function(t){var i=t.background,o=t.value,a=Math.min(Y7(o,c),2*Math.PI-r)*j;a>=0&&($7(e,r,r+a,n,g,i,.5*y),r+=a)})),r<2*Math.PI&&$7(e,r,2*Math.PI,n,g,s,.5*y),e.restore()}}}),[t,r,y,c,g,o,s,j,x]);var O=0;return(0,z.jsxs)("div",{className:_d()(u,K7.pieChart),style:{width:r*y,height:r*y},children:[x>0&&(0,z.jsx)("canvas",{ref:_,width:x,height:x}),c>0&&t.filter((function(e){return e.value>=0})).map((function(e,t){var n=Math.min(Y7(e.value,c),2*Math.PI-O),i=j*(O+n/2)+o;return O+=n,e.label&&n>p&&(0,z.jsx)("div",{className:K7.label,style:{left:r*y/2+Math.cos(i)*r*y/2*f,top:r*y/2+Math.sin(i)*r*y/2*f},children:e.label},t)}))]})}),(function(e,t){return el(e,t,3)})),Y7=function(e,t){return e/t*2*Math.PI},$7=function(e,t,n,r,i,o,a){if(!(n<t)){var s=t+a/r,l=n-a/r,c=t+a/(i*r),u=n-a/(i*r);l-s<.01||u-c<.01||(e.fillStyle=o,e.beginPath(),e.arc(0,0,r,s,l),e.arc(0,0,r*i,u,c,!0),e.closePath(),e.fill())}};oe.add("game-ui/common/charts/pie-chart/pie-chart.tsx",{get PieChart(){return z7},set PieChart(e){z7=e}});let q7={"info-piechart":"info-piechart_wXd",infoPiechart:"info-piechart_wXd",content:"content__L_",pie:"pie_WkN",legends:"legends_pVz",legend:"legend_fqG"};oe.add("game-ui/common/charts/pie-chart/info-piechart.module.scss",{get classes(){return q7},set classes(e){Object.assign(q7,e)}});const X7=q7;var Q7=function(e){var t=e.title,n=e.colors,r=e.labels,i=e.data,o=e.ignoreZero,a=void 0!==o&&o,s=e.usePercentageValue,l=void 0!==s&&s,c=e.customLegend,u=e.className,d=l&&i.total>0?100/i.total:1;return(0,z.jsxs)("div",{className:_d()(X7.infoPiechart,u),children:[t&&(0,z.jsx)(TS,{uppercase:!0,left:t}),(0,z.jsxs)("div",{className:X7.content,children:[(0,z.jsx)("div",{className:X7.pie,children:(0,z.jsx)(z7,{data:Z7(i,n),innerRadius:.6,size:125})}),(0,z.jsx)("div",{className:X7.legends,children:c||i.values.filter((function(e){return!a||e>0})).map((function(e,t){return(0,z.jsxs)("div",{className:X7.legend,children:[(0,z.jsx)(hU,{color:n[t],label:r[t]}),(0,z.jsx)(su,{value:e*d,unit:l?$c.PercentageSingleFraction:$c.Integer})]},t)}))})]})]})},Z7=function(e,t){return e.values.map((function(n,r){return{value:e.values[r],background:t[r]}}))};oe.add("game-ui/common/charts/pie-chart/info-piechart.tsx",{get InfoPieChart(){return Q7},set InfoPieChart(e){Q7=e}});var J7=function(e){var t=e.title,n=e.supplyLabel,r=e.demandLabel,i=e.supplyValue,o=e.demandValue,a=e.availability,s=e.gradient,l=e.tooltip,c=e.children;return(0,z.jsxs)(L7,{tooltip:l,children:[t,(0,z.jsx)(w7,{value:a,gradient:s}),(0,z.jsx)(v7,{tiny:!0,text:(0,z.jsx)(qc.Infoviews.LABEL_VALUE_FORMAT,{LABEL:r,VALUE:o}),rightText:(0,z.jsx)(qc.Infoviews.LABEL_VALUE_FORMAT,{LABEL:n,VALUE:i})}),(0,z.jsx)(g7,{small:!0}),c]})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/components/sections/availability-bar-section.tsx",{get AvailabilityBarSection(){return J7},set AvailabilityBarSection(e){J7=e}});var e9=function(){var e=xl(ky),t=xl(Ry),n=xl(Dy),r=xl(Fy),i=xl(Ty),o=xl(Iy),a=xl(wy),s=xl(Py),l=xl(Cy),c=xl(Ny),u=xl(Ay),d=xl(Ly),f=xl(Uy),m=xl(Gy),g=xl(By),h=xl(Vy),p=xl(My);return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(t9,{localeKey:"Elementary",availability:f,eligible:i,capacity:l,students:e,tooltip:(0,z.jsx)(qc.Infoviews.ELEMENTARY_SCHOOL_AVAILABILITY_TOOLTIP,{})}),(0,z.jsx)(t9,{localeKey:"High School",availability:m,eligible:o,capacity:c,students:t,tooltip:(0,z.jsx)(qc.Infoviews.HIGH_SCHOOL_AVAILABILITY_TOOLTIP,{})}),(0,z.jsx)(t9,{localeKey:"College",availability:g,eligible:a,capacity:u,students:n,tooltip:(0,z.jsx)(qc.Infoviews.COLLEGE_AVAILABILITY_TOOLTIP,{})}),(0,z.jsx)(t9,{localeKey:"University",availability:h,eligible:s,capacity:d,students:r,tooltip:(0,z.jsx)(qc.Infoviews.UNIVERSITY_AVAILABILITY_TOOLTIP,{})}),(0,z.jsxs)(L7,{tooltip:(0,z.jsx)(qc.Infoviews.EDUCATION_DISTRIBUTION_TOOLTIP,{}),children:[(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.EducationInfoPanel.EDUCATION_DISTRIBUTION,{})}),(0,z.jsx)(Q7,{usePercentageValue:!0,colors:B7,labels:V7,data:p})]})]})},t9=function(e){var t=e.localeKey,n=e.availability,r=e.eligible,i=e.capacity,o=e.students,a=e.tooltip;return(0,z.jsx)(z.Fragment,{children:(0,z.jsx)(J7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.EducationInfoPanel.EDUCATION_LEVEL,{hash:t}),rightText:(0,z.jsx)(b7,{icon:"Media/Game/Icons/Citizen.svg",label:(0,z.jsx)(su,{value:o,unit:$c.Integer})})}),demandLabel:(0,z.jsx)(qc.EducationInfoPanel.ELIGIBLE,{}),demandValue:(0,z.jsx)(su,{value:r,unit:$c.Integer}),supplyLabel:(0,z.jsx)(qc.InfoPanels.CAPACITY,{}),supplyValue:(0,z.jsx)(su,{value:i,unit:$c.Integer}),availability:n,tooltip:a})})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/education-infoview-panel.tsx",{get EducationInfoviewPanel(){return e9},set EducationInfoviewPanel(e){e9=e}});var n9=function(){var e=xl(sy),t=xl(ly),n=xl(uy),r=xl(dy),i=xl(fy),o=xl(gy),a=xl(hy);return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(J7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.ElectricityInfoPanel.ELECTRICITY_AVAILABILITY,{})}),tooltip:(0,z.jsx)(qc.Infoviews.ELECTRICITY_AVAILABILITY_TOOLTIP,{}),availability:i,supplyLabel:(0,z.jsx)(qc.InfoPanels.PRODUCTION,{}),supplyValue:(0,z.jsx)(su,{value:t,unit:$c.Power}),demandLabel:(0,z.jsx)(qc.InfoPanels.CONSUMPTION,{}),demandValue:(0,z.jsx)(su,{value:e,unit:$c.Power})}),(0,z.jsx)(J7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.ElectricityInfoPanel.ELECTRICITY_TRADE,{})}),tooltip:(0,z.jsx)(qc.Infoviews.ELECTRICITY_TRADE_TOOLTIP,{}),availability:o,supplyLabel:(0,z.jsx)(qc.ElectricityInfoPanel.ELECTRICITY_EXPORT,{}),supplyValue:(0,z.jsx)(su,{value:n,unit:$c.Power}),demandLabel:(0,z.jsx)(qc.ElectricityInfoPanel.ELECTRICITY_IMPORT,{}),demandValue:(0,z.jsx)(su,{value:r,unit:$c.Power})}),(0,z.jsx)(M7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.ElectricityInfoPanel.BATTERY_CHARGE,{}),rightText:(0,z.jsx)(Pu,{value:a.current,total:a.max,unit:$c.Energy})}),tooltip:(0,z.jsx)(qc.Infoviews.BATTERY_CHARGE_TOOLTIP,{}),value:a,gradient:O7})]})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/electricity-infoview-panel.tsx",{get ElectricityInfoviewPanel(){return n9},set ElectricityInfoviewPanel(e){n9=e}});var r9=function(){var e,t=xl(px);return(0,z.jsx)(tk,{uiTag:null===(e=Ew.value)||void 0===e?void 0:e.infoviewsFireHazard,children:(0,z.jsx)(M7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.FireAndRescueInfoPanel.AVERAGE_FIRE_HAZARD,{}),rightText:(0,z.jsx)(bd,{value:t.current,max:t.max})}),value:t,gradient:x7,tooltip:(0,z.jsx)(qc.Infoviews.AVERAGE_FIRE_HAZARD_TOOLTIP,{})})})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/fire-and-rescue-infoview-panel.tsx",{get FireAndRescueInfoPanel(){return r9},set FireAndRescueInfoPanel(e){r9=e}});var i9=function(){return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(o9,{}),(0,z.jsx)(a9,{})]})},o9=function(){var e=xl(ox),t=xl(tx),n=xl(rx);return(0,z.jsx)(J7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.GarbageInfoPanel.PROCESSING_STATUS,{})}),demandLabel:(0,z.jsx)(qc.GarbageInfoPanel.GARBAGE_RATE,{}),demandValue:(0,z.jsx)(su,{value:e,unit:$c.WeightPerMonth}),supplyLabel:(0,z.jsx)(qc.InfoPanels.PROCESSING,{}),supplyValue:(0,z.jsx)(su,{value:t,unit:$c.WeightPerMonth}),availability:n,tooltip:(0,z.jsx)(qc.Infoviews.GARBAGE_PROCESSING_STATUS_TOOLTIP,{})})},a9=function(){var e=xl(nx),t=xl(ax),n=xl(ix);return(0,z.jsx)(M7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.GarbageInfoPanel.LANDFILL_AVAILABILITY,{}),rightText:(0,z.jsx)(su,{value:100*n.current,unit:$c.Percentage})}),tooltip:(0,z.jsx)(qc.Infoviews.LANDFILL_AVAILABILITY_TOOLTIP,{}),value:n,gradient:_7,children:(0,z.jsx)(v7,{tiny:!0,text:(0,z.jsx)(qc.Infoviews.LABEL_VALUE_FORMAT,{LABEL:(0,z.jsx)(qc.GarbageInfoPanel.STORED_GARBAGE,{}),VALUE:(0,z.jsx)(su,{value:t,unit:$c.Weight})}),rightText:(0,z.jsx)(qc.Infoviews.LABEL_VALUE_FORMAT,{LABEL:(0,z.jsx)(qc.InfoPanels.CAPACITY,{}),VALUE:(0,z.jsx)(su,{value:e,unit:$c.Weight})})})})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/garbage-infoview-panel.tsx",{get GarbageInfoviewPanel(){return i9},set GarbageInfoviewPanel(e){i9=e}});var s9=function(){var e=xl(fx);return(0,z.jsx)(z.Fragment,{children:(0,z.jsx)(M7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.GroundPollutionInfoPanel.AVERAGE_GROUND_POLLUTION,{}),rightText:(0,z.jsx)(bd,{value:e.current,max:e.max})}),tooltip:(0,z.jsx)(qc.Infoviews.AVERAGE_GROUND_POLLUTION_TOOLTIP,{}),value:e,gradient:y7})})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/ground-pollution-infoview-panel.tsx",{get GroundPollutionInfoviewPanel(){return s9},set GroundPollutionInfoviewPanel(e){s9=e}});let l9={positive:"positive_zrK",negative:"negative_YWY"};oe.add("game-ui/game/themes/sign-style-theme.module.scss",{get classes(){return l9},set classes(e){Object.assign(l9,e)}});const c9=l9;var u9=function(){var e=xl(WT);return(0,z.jsxs)(L7,{tooltip:(0,z.jsx)(qc.Infoviews.HAPPINESS_FACTORS_TOOLTIP,{}),children:[(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.Common.HAPPINESS_FACTORS,{})}),(0,z.jsx)(g7,{}),e.map((function(e,t){return(0,z.jsx)(v7,{small:!0,text:e.weight>0?(0,z.jsx)(qc.Common.HAPPINESS_FACTOR_POSITIVE,{hash:e.factor}):(0,z.jsx)(qc.Common.HAPPINESS_FACTOR_NEGATIVE,{hash:e.factor}),rightText:(0,z.jsx)("div",{className:uR(c9,e.weight),children:(0,z.jsx)(su,{value:e.weight,signed:!0})})},t)}))]})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/happiness-infoview-panel.tsx",{get HappinessInfoviewPanel(){return u9},set HappinessInfoviewPanel(e){u9=e}});var d9=function(){return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(f9,{}),(0,z.jsx)(m9,{}),(0,z.jsx)(g9,{})]})},f9=function(){var e=xl(Xy),t=xl(Qy),n=xl(Zy),r=xl(Ky),i=xl(qy);return(0,z.jsxs)(J7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.HealthcareInfoPanel.HEALTHCARE_AVAILABILITY,{})}),tooltip:(0,z.jsx)(qc.Infoviews.HEALTHCARE_AVAILABILITY_TOOLTIP,{}),demandLabel:(0,z.jsx)(qc.HealthcareInfoPanel.SICK_OR_INJURED,{}),demandValue:(0,z.jsx)(su,{value:i,unit:$c.Integer}),supplyLabel:(0,z.jsx)(qc.InfoPanels.CAPACITY,{}),supplyValue:(0,z.jsx)(su,{value:t,unit:$c.Integer}),availability:n,children:[(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.HealthcareInfoPanel.AVERAGE_HEALTH,{}),rightText:(0,z.jsx)(su,{value:r,unit:$c.Percentage})}),(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.HealthcareInfoPanel.PATIENTS,{}),rightText:(0,z.jsx)(su,{value:e,unit:$c.Integer})})]})},m9=function(){var e=xl(Yy),t=xl($y),n=xl(Jy);return(0,z.jsx)(J7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.HealthcareInfoPanel.CREMATORIUM_AVAILABILITY,{})}),tooltip:(0,z.jsx)(qc.Infoviews.CREMATORIUM_AVAILABILITY_TOOLTIP,{}),demandLabel:(0,z.jsx)(qc.HealthcareInfoPanel.DEATH_RATE,{}),demandValue:(0,z.jsx)(su,{value:e,unit:$c.IntegerPerMonth}),supplyLabel:(0,z.jsx)(qc.HealthcareInfoPanel.PROCESSING_RATE,{}),supplyValue:(0,z.jsx)(su,{value:t,unit:$c.IntegerPerMonth}),availability:n})},g9=function(){var e=xl(Wy),t=xl(zy),n=xl(ex);return(0,z.jsx)(M7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.HealthcareInfoPanel.CEMETERY_AVAILABILITY,{}),rightText:(0,z.jsx)(bd,{value:t-e,max:t})}),tooltip:(0,z.jsx)(qc.Infoviews.CEMETERY_AVAILABILITY_TOOLTIP,{}),value:n,gradient:_7,children:(0,z.jsx)(v7,{tiny:!0,text:(0,z.jsx)(qc.Infoviews.LABEL_VALUE_FORMAT,{LABEL:(0,z.jsx)(qc.HealthcareInfoPanel.OCCUPIED,{}),VALUE:(0,z.jsx)(su,{value:e,unit:$c.Integer})}),rightText:(0,z.jsx)(qc.Infoviews.LABEL_VALUE_FORMAT,{LABEL:(0,z.jsx)(qc.InfoPanels.CAPACITY,{}),VALUE:(0,z.jsx)(su,{value:t,unit:$c.Integer})})})})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/healthcare-infoview-panel.tsx",{get HealthcareInfoviewPanel(){return d9},set HealthcareInfoviewPanel(e){d9=e}});var h9=function(){var e=xl(Nx);return(0,z.jsx)(L7,{tooltip:(0,z.jsx)(qc.Infoviews.AVERAGE_LAND_VALUE_TOOLTIP,{}),children:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.LandValueInfoPanel.AVERAGE_LAND_VALUE,{}),rightText:(0,z.jsx)(su,{value:240*e,unit:$c.MoneyPerCell})})})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/landvalue-infoview-panel.tsx",{get LandValueInfoviewPanel(){return h9},set LandValueInfoviewPanel(e){h9=e}});let p9={"requirement-field":"requirement-field_e7h",requirementField:"requirement-field_e7h","progress-bounds":"progress-bounds_MkW",progressBounds:"progress-bounds_MkW",progress:"progress_jYy",content:"content_OHh",icon:"icon_IKb",label:"label_DwS",checkmark:"checkmark_Nhp"};oe.add("game-ui/game/components/progression/requirement-field/requirement-field.module.scss",{get classes(){return p9},set classes(e){Object.assign(p9,e)}});const v9=p9;function b9(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function y9(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){b9(e,t,n[t])}))}return e}var x9,_9=function(e){var t=xl(pP);return(0,z.jsx)(w9,{icon:"Media/Game/Icons/Trophy.svg",progress:e.locked?t:e.index,max:e.index,locked:e.locked,children:(0,z.jsx)(qc.Progression.MILESTONE_UNLOCK_REQUIREMENT,{INDEX:(0,z.jsx)(su,{value:e.index,unit:$c.Integer}),NAME:(0,z.jsx)(qc.Progression.MILESTONE_NAME,{index:e.index})})})},j9=function(e){return(0,z.jsx)(w9,{icon:"Media/Game/Icons/DevPoint.svg",progress:e.locked?0:1,max:1,locked:e.locked,children:(0,z.jsx)(qc.Progression.NODE_UNLOCK_REQUIREMENT,{NAME:(0,z.jsx)(qc.Progression.NODE_NAME,{hash:e.name})})})},O9=function(e){var t=(0,Y.useMemo)((function(){var t={NAME:(0,z.jsx)(qc.Assets.NAME,{hash:e.requirement}),CURRENT:(0,z.jsx)(su,{value:e.progress,unit:$c.Integer}),TARGET:(0,z.jsx)(su,{value:e.minimumCount,unit:$c.Integer})};return null!=e.labelId?(0,z.jsx)(kc,{id:e.labelId,args:t}):(0,z.jsx)(qc.Progression.STRICT_OBJECT_BUILT_REQUIREMENT,y9({},t))}),[e.labelId,e.requirement,e.progress,e.minimumCount]);return(0,z.jsx)(w9,{icon:e.icon,progress:e.progress,max:e.minimumCount,locked:e.locked,children:t})},E9=function(e){var t=(0,Y.useMemo)((function(){var t={ZONE:null!=e.requiredZone?(0,z.jsx)(qc.Assets.NAME,{hash:e.requiredZone}):"",CURRENT:(0,z.jsx)(su,{value:e.progress,unit:$c.Integer}),TARGET:(0,z.jsx)(su,{value:e.minimumSquares>0?e.minimumSquares:e.minimumCount,unit:$c.Integer}),LEVEL:(0,z.jsx)(su,{value:e.minimumLevel,unit:$c.Integer})};return null!=e.labelId?(0,z.jsx)(kc,{id:e.labelId,args:t}):e.minimumSquares>0||0===e.minimumCount?e.minimumLevel>1?(0,z.jsx)(qc.Progression.ZONE_BUILT_REQUIREMENT_CELLS_LEVEL,y9({},t)):(0,z.jsx)(qc.Progression.ZONE_BUILT_REQUIREMENT_CELLS,y9({},t)):e.minimumLevel>1?(0,z.jsx)(qc.Progression.ZONE_BUILT_REQUIREMENT_COUNT_LEVEL,y9({},t)):(0,z.jsx)(qc.Progression.ZONE_BUILT_REQUIREMENT_COUNT,y9({},t))}),[e.labelId,e.minimumCount,e.minimumLevel,e.minimumSquares,e.progress,e.requiredZone]);return(0,z.jsx)(w9,{icon:e.icon,progress:e.progress,max:e.minimumSquares>0?e.minimumSquares:e.minimumCount,locked:e.locked,children:t})},S9=function(e){var t=(0,Y.useMemo)((function(){if(e.minimumPopulation>0||0===e.minimumHappiness){var t={VALUE:(0,z.jsx)(su,{value:e.minimumPopulation,unit:$c.Integer})};return null!=e.labelId?(0,z.jsx)(kc,{id:e.labelId,args:t}):(0,z.jsx)(qc.Progression.POPULATION_REQUIREMENT,y9({},t))}var n={VALUE:(0,z.jsx)(su,{value:e.minimumHappiness,unit:$c.PercentageSingleFraction})};return null!=e.labelId?(0,z.jsx)(kc,{id:e.labelId,args:n}):(0,z.jsx)(qc.Progression.HAPPINESS_REQUIREMENT,y9({},n))}),[e.minimumPopulation,e.minimumHappiness,e.labelId]);return(0,z.jsx)(w9,{icon:e.minimumPopulation>0||0===e.minimumHappiness?"Media/Game/Icons/Citizen.svg":"Media/Game/Icons/Happy.svg",progress:e.progress,max:e.minimumPopulation>0?e.minimumPopulation:e.minimumHappiness,locked:e.locked,children:t})},T9=function(e){var t=(0,Y.useMemo)((function(){var t={RESOURCE:(0,z.jsx)(qc.Resources.TITLE,{hash:e.resourceType}),CURRENT:(0,z.jsx)(su,{value:e.progress,unit:$c.Integer}),TARGET:(0,z.jsx)(su,{value:e.minimumProducedAmount,unit:$c.Integer})};return null!=e.labelId?(0,z.jsx)(kc,{id:e.labelId,args:t}):(0,z.jsx)(qc.Progression.PROCESSING_REQUIREMENT,y9({},t))}),[e.labelId,e.resourceType,e.progress,e.minimumProducedAmount]);return(0,z.jsx)(w9,{icon:"Media/Game/Icons/Company.svg",progress:e.progress,max:e.minimumProducedAmount,locked:e.locked,children:t})},I9=function(e){var t=(0,Y.useMemo)((function(){var t={CURRENT:(0,z.jsx)(su,{value:e.progress,unit:$c.Integer}),TARGET:(0,z.jsx)(su,{value:e.minimumCount,unit:$c.Integer})};return null!=e.labelId?(0,z.jsx)(kc,{id:e.labelId,args:t}):(0,z.jsx)(qc.Progression.OBJECT_BUILT_REQUIREMENT,y9({hash:e.name},t))}),[e.labelId,e.name,e.progress,e.minimumCount]);return(0,z.jsx)(w9,{icon:"Media/Game/Icons/Build.svg",progress:e.progress,max:e.minimumCount,locked:e.locked,children:t})},w9=function(e){var t=e.icon,n=e.progress,r=e.max,i=e.locked,o=e.children,a=i?of(n/r,0,1):r;return(0,z.jsxs)("div",{className:v9.requirementField,children:[(0,z.jsx)("div",{className:v9.progressBounds,style:{width:"".concat(100*a,"%")},children:(0,z.jsx)("div",{className:v9.progress,style:{width:"".concat(a>0?100/a:0,"%")}})}),(0,z.jsxs)("div",{className:v9.content,children:[t&&(0,z.jsx)("img",{src:t,className:v9.icon}),(0,z.jsx)("div",{className:v9.label,children:o}),!i&&(0,z.jsx)(tb,{src:"Media/Glyphs/Checkmark.svg",className:v9.checkmark})]})]})},P9=function(e){var t=e.locked;return(0,z.jsx)(w9,{icon:"Media/Game/Icons/Build.svg",progress:0,max:1,locked:t,children:(0,z.jsx)(qc.Progression.TUTORIAL_REQUIREMENT,{})})},C9=(b9(x9={},Aw.Milestone,_9),b9(x9,Aw.DevTreeNode,j9),b9(x9,Aw.StrictObjectBuilt,O9),b9(x9,Aw.ZoneBuilt,E9),b9(x9,Aw.Citizen,S9),b9(x9,Aw.Processing,T9),b9(x9,Aw.ObjectBuilt,I9),b9(x9,Aw.Unlock,(function(){return null})),b9(x9,Aw.Tutorial,P9),x9);oe.add("game-ui/game/components/progression/requirement-field/requirement-field.tsx",{get MilestoneRequirementField(){return _9},set MilestoneRequirementField(e){_9=e},get DevTreeNodeRequirementField(){return j9},set DevTreeNodeRequirementField(e){j9=e},get StrictObjectBuiltRequirementField(){return O9},set StrictObjectBuiltRequirementField(e){O9=e},get ZoneBuiltRequirementField(){return E9},set ZoneBuiltRequirementField(e){E9=e},get CitizenRequirementField(){return S9},set CitizenRequirementField(e){S9=e},get ProcessingRequirementField(){return T9},set ProcessingRequirementField(e){T9=e},get ObjectBuiltRequirementField(){return I9},set ObjectBuiltRequirementField(e){I9=e},get RequirementField(){return w9},set RequirementField(e){w9=e},get TutorialRequirementField(){return P9},set TutorialRequirementField(e){P9=e},get prefabRequirementComponents(){return C9},set prefabRequirementComponents(e){C9=e}});let N9={"unlocking-requirements":"unlocking-requirements_xaC",unlockingRequirements:"unlocking-requirements_xaC",row:"row_fam",title:"title_grF",divider:"divider_Cqj"};oe.add("game-ui/game/components/progression/unlocking-requirements/unlocking-requirements.module.scss",{get classes(){return N9},set classes(e){Object.assign(N9,e)}});const A9=N9;function L9(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var M9=function(e){var t=e.requirements,n=e.theme,r=e.className,i=(0,Y.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){L9(e,t,n[t])}))}return e}({},A9,n)}),[n]),o=t.requireAny.length>0,a=t.requireAll.length>0;return(0,z.jsxs)("div",{className:_d()(i.unlockingRequirements,r),children:[o&&(0,z.jsxs)("div",{className:i.row,children:[(0,z.jsx)("div",{className:i.title,children:(0,z.jsx)(qc.Progression.REQUIRES_ANY,{})}),(0,z.jsx)(vD,{components:C9,data:t.requireAny})]}),o&&a&&(0,z.jsx)("div",{className:A9.divider}),a&&(0,z.jsxs)("div",{className:i.row,children:[(0,z.jsx)("div",{className:i.title,children:o?(0,z.jsx)(qc.Progression.REQUIRES_ALL,{}):t.requireAll.length>1?(0,z.jsx)(qc.Progression.REQUIREMENTS,{}):(0,z.jsx)(qc.Progression.REQUIREMENT,{})}),(0,z.jsx)(vD,{components:C9,data:t.requireAll})]})]})};function k9(e){return e.requireAll.length>0||e.requireAny.length>0}oe.add("game-ui/game/components/progression/unlocking-requirements/unlocking-requirements.tsx",{get Requirements(){return M9},set Requirements(e){M9=e},get hasRequirements(){return k9},set hasRequirements(e){k9=e}});let R9={balloon:"balloon_ltu balloon_qJY balloon_H23",enter:"enter_tT_ enter_ZTk","enter-active":"enter-active_r4U enter-active_AJs",enterActive:"enter-active_r4U enter-active_AJs",exit:"exit_OtI undefined","exit-active":"exit-active_Dqt exit-active_RfZ",exitActive:"exit-active_Dqt exit-active_RfZ",container:"container_eNL container_zgM container_jfe",locked:"locked_UbY",arrow:"arrow_R9U arrow_SVb arrow_Xfn",content:"content_wfU content_A82 content_JQV",main:"main_F2U",lock:"lock_Gqk",requirements:"requirements_dsk"};oe.add("game-ui/game/components/progression/unlocking-tooltip/unlocking-tooltip.module.scss",{get classes(){return R9},set classes(e){Object.assign(R9,e)}});const D9=R9;function F9(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function U9(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function G9(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var B9=function(e){var t=e.title,n=e.description,r=e.content,i=e.locked,o=void 0!==i&&i,a=e.requirements,s=e.className,l=e.children,c=G9(e,["title","description","content","locked","requirements","className","children"]),u=Y.Children.count(t)>0||Y.Children.count(n)>0||Y.Children.count(r)>0,d=(0,Y.useMemo)((function(){return o&&a&&a.requireAll.length+a.requireAny.length>0}),[o,a]);return(0,z.jsx)(jh,U9(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){F9(e,t,n[t])}))}return e}({},c),{theme:D9,className:_d()(d&&D9.locked,s),tooltip:u||d?(0,z.jsxs)(z.Fragment,{children:[u&&(0,z.jsx)(t8,{title:t,description:n,content:r,className:D9.main}),u&&d&&(0,z.jsx)(_1,{className:D9.lock}),d&&a&&(0,z.jsx)(M9,{requirements:a,className:D9.requirements})]}):void 0,children:l}))};oe.add("game-ui/game/components/progression/unlocking-tooltip/unlocking-tooltip.tsx",{get UnlockingTooltip(){return B9},set UnlockingTooltip(e){B9=e}});var V9=function(){var e=xl(Ax),t=xl(Lx),n=xl(Mx),r=xl(kx),i=Kw("ZonesOffice"),o=[(0,z.jsx)(qc.LevelInfoPanel.LEVEL1,{}),(0,z.jsx)(qc.LevelInfoPanel.LEVEL2,{}),(0,z.jsx)(qc.LevelInfoPanel.LEVEL3,{}),(0,z.jsx)(qc.LevelInfoPanel.LEVEL4,{}),(0,z.jsx)(qc.LevelInfoPanel.LEVEL5,{})];return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsxs)(L7,{tooltip:(0,z.jsx)(qc.Infoviews.RESIDENTIAL_LEVEL_TOOLTIP,{}),children:[(0,z.jsx)(v7,{uppercase:!0,centered:!0,text:(0,z.jsx)(qc.LevelInfoPanel.RESIDENTIAL,{})}),(0,z.jsx)(Q7,{colors:["#86FB14","#64B805","#3C8F1A","#2F7512","#20550C"],labels:o,data:e,usePercentageValue:!0})]}),(0,z.jsxs)(L7,{tooltip:(0,z.jsx)(qc.Infoviews.COMMERCIAL_LEVEL_TOOLTIP,{}),children:[(0,z.jsx)(v7,{uppercase:!0,centered:!0,text:(0,z.jsx)(qc.LevelInfoPanel.COMMERCIAL,{})}),(0,z.jsx)(Q7,{colors:["#43D4FF","#2393B8","#1B748E","#116075","#0A4254"],labels:o,data:t,usePercentageValue:!0})]}),(0,z.jsxs)(L7,{tooltip:(0,z.jsx)(qc.Infoviews.INDUSTRIAL_LEVEL_TOOLTIP,{}),children:[(0,z.jsx)(v7,{uppercase:!0,centered:!0,text:(0,z.jsx)(qc.LevelInfoPanel.INDUSTRIAL,{})}),(0,z.jsx)(Q7,{colors:["#FCCE1A","#B59923","#90781C","#766315","#55450D"],labels:o,data:n,usePercentageValue:!0})]}),(0,z.jsx)(B9,{locked:i.locked,requirements:i.requirements,children:(0,z.jsxs)(L7,{tooltip:(0,z.jsx)(qc.Infoviews.OFFICE_LEVEL_TOOLTIP,{}),children:[(0,z.jsx)(v7,{uppercase:!0,centered:!0,text:(0,z.jsx)(qc.LevelInfoPanel.OFFICE,{})}),(0,z.jsx)(Q7,{colors:["#7941FF","#4E22B3","#3D1C92","#311376","#200B54"],labels:o,data:r,usePercentageValue:!0})]})})]})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/level-infoview-panel.tsx",{get LevelInfoviewPanel(){return V9},set LevelInfoviewPanel(e){V9=e}});var H9=function(){var e=xl(u_),t=xl(d_),n=xl(f_),r=xl(m_),i=xl(g_),o=xl(h_),a=xl(p_),s=xl(v_),l=xl(b_),c=xl(y_);return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(K9,{text:(0,z.jsx)(v7,{icon:"Media/Game/Icons/Fertility.svg",text:(0,z.jsx)(qc.NaturalResourcesInfoPanel.FERTILITY,{}),uppercase:!0}),tooltip:(0,z.jsx)(qc.Infoviews.FERTILE_LAND_RESOURCE_TOOLTIP,{}),available:(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.NaturalResourcesInfoPanel.AVAILABLE,{}),rightText:r>0?(0,z.jsx)(su,{value:r,unit:$c.Area}):0}),extractionRate:(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.NaturalResourcesInfoPanel.RATE,{}),rightText:s>0?(0,z.jsx)(su,{value:s,unit:$c.WeightPerMonth}):0}),renewalRate:(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.NaturalResourcesInfoPanel.RENEWAL_RATE,{}),rightText:c>0?(0,z.jsx)(su,{value:c,unit:$c.WeightPerMonth}):0})}),(0,z.jsx)(K9,{text:(0,z.jsx)(v7,{icon:"Media/Game/Icons/Forest.svg",text:(0,z.jsx)(qc.NaturalResourcesInfoPanel.FOREST,{}),uppercase:!0}),tooltip:(0,z.jsx)(qc.Infoviews.WOOD_RESOURCE_TOOLTIP,{}),available:(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.NaturalResourcesInfoPanel.AVAILABLE,{}),rightText:n>0?(0,z.jsx)(su,{value:n,unit:$c.Weight}):0}),extractionRate:(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.NaturalResourcesInfoPanel.RATE,{}),rightText:a>0?(0,z.jsx)(su,{value:a,unit:$c.WeightPerMonth}):0}),renewalRate:(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.NaturalResourcesInfoPanel.RENEWAL_RATE,{}),rightText:l>0?(0,z.jsx)(su,{value:l,unit:$c.WeightPerMonth}):0})}),(0,z.jsx)(K9,{text:(0,z.jsx)(v7,{icon:"Media/Game/Icons/Ore.svg",text:(0,z.jsx)(qc.NaturalResourcesInfoPanel.ORE,{}),uppercase:!0}),tooltip:(0,z.jsx)(qc.Infoviews.ORE_RESOURCE_TOOLTIP,{}),available:(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.NaturalResourcesInfoPanel.AVAILABLE,{}),rightText:t>0?(0,z.jsx)(su,{value:t,unit:$c.Weight}):0}),extractionRate:(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.NaturalResourcesInfoPanel.RATE,{}),rightText:o>0?(0,z.jsx)(su,{value:o,unit:$c.WeightPerMonth}):0})}),(0,z.jsx)(K9,{text:(0,z.jsx)(v7,{icon:"Media/Game/Icons/Oil.svg",text:(0,z.jsx)(qc.NaturalResourcesInfoPanel.OIL,{}),uppercase:!0}),tooltip:(0,z.jsx)(qc.Infoviews.OIL_RESOURCE_TOOLTIP,{}),available:(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.NaturalResourcesInfoPanel.AVAILABLE,{}),rightText:e>0?(0,z.jsx)(su,{value:e,unit:$c.Weight}):0}),extractionRate:(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.NaturalResourcesInfoPanel.RATE,{}),rightText:i>0?(0,z.jsx)(su,{value:i,unit:$c.WeightPerMonth}):0})})]})},K9=function(e){var t=e.text,n=e.available,r=e.extractionRate,i=e.renewalRate,o=e.tooltip;return(0,z.jsxs)(L7,{tooltip:o,children:[t,n,r,i]})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/natural-resources-infoview-panel.tsx",{get NaturalResourcesInfoviewPanel(){return H9},set NaturalResourcesInfoviewPanel(e){H9=e}});var W9=function(){var e=xl(hx);return(0,z.jsx)(z.Fragment,{children:(0,z.jsx)(M7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.NoisePollutionInfoPanel.AVERAGE_NOISE_POLLUTION,{}),rightText:(0,z.jsx)(bd,{value:e.current,max:e.max})}),tooltip:(0,z.jsx)(qc.Infoviews.AVERAGE_NOISE_POLLUTION_TOOLTIP,{}),value:e,gradient:z9})})},z9={stops:[{color:"#FFF",offset:0},{color:"#F00",offset:1}]};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/noise-infoview-panel.tsx",{get NoiseInfoviewPanel(){return W9},set NoiseInfoviewPanel(e){W9=e}});var Y9=function(){var e=xl(i_),t=xl(o_),n=xl(a_),r=xl(s_),i=xl(l_),o=xl(c_);return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsxs)(L7,{tooltip:(0,z.jsx)(qc.Infoviews.IMPORT_DISTRIBUTION_TOOLTIP,{}),children:[(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.OutsideConnectionsInfoPanel.TOP_IMPORTS,{})}),(0,z.jsx)(Q7,{colors:t,data:n,labels:e.map((function(e){return(0,z.jsx)(qc.Resources.TITLE,{hash:e.replace("Resource","")},e)})),ignoreZero:!0,usePercentageValue:!0})]}),(0,z.jsxs)(L7,{tooltip:(0,z.jsx)(qc.Infoviews.EXPORT_DISTRIBUTION_TOOLTIP,{}),children:[(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.OutsideConnectionsInfoPanel.TOP_EXPORTS,{})}),(0,z.jsx)(Q7,{colors:i,data:o,labels:r.map((function(e){return(0,z.jsx)(qc.Resources.TITLE,{hash:e.replace("Resource","")},e)})),ignoreZero:!0,usePercentageValue:!0})]})]})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/outside-connections-infoview-panel.tsx",{get OutsideConnectionsInfoviewPanel(){return Y9},set OutsideConnectionsInfoviewPanel(e){Y9=e}});var $9=function(){var e=xl(vx),t=xl(bx),n=xl(yx),r=xl(jx),i=xl(Ox),o=xl(Ex),a=xl(Ix),s=xl(wx),l=xl(Px),c=xl(Cx),u=xl(Sx),d=xl(Tx);return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(J7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.PoliceInfoPanel.JAIL_AVAILABILITY,{})}),tooltip:(0,z.jsx)(qc.Infoviews.JAIL_AVAILABILITY_TOOLTIP,{}),demandLabel:(0,z.jsx)(qc.PoliceInfoPanel.ARRESTED_CRIMINALS,{}),demandValue:(0,z.jsx)(su,{value:i,unit:$c.Integer}),supplyLabel:(0,z.jsx)(qc.InfoPanels.CAPACITY,{}),supplyValue:(0,z.jsx)(su,{value:r,unit:$c.Integer}),availability:t,children:(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.PoliceInfoPanel.IN_JAIL,{}),rightText:(0,z.jsx)(su,{value:o,unit:$c.Integer})})}),(0,z.jsx)(J7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.PoliceInfoPanel.PRISON_AVAILABILITY,{})}),tooltip:(0,z.jsx)(qc.Infoviews.PRISON_AVAILABILITY_TOOLTIP,{}),demandLabel:(0,z.jsx)(qc.PoliceInfoPanel.PRISONERS,{}),demandValue:(0,z.jsx)(su,{value:d,unit:$c.Integer}),supplyLabel:(0,z.jsx)(qc.InfoPanels.CAPACITY,{}),supplyValue:(0,z.jsx)(su,{value:u,unit:$c.Integer}),availability:n,children:(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.PoliceInfoPanel.IN_PRISON,{}),rightText:(0,z.jsx)(su,{value:a,unit:$c.Integer})})}),(0,z.jsxs)(M7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.PoliceInfoPanel.AVERAGE_CRIME_PROBABILITY,{}),rightText:(0,z.jsx)(bd,{value:e.current,max:e.max})}),tooltip:(0,z.jsx)(qc.Infoviews.CRIME_PROBABILITY_TOOLTIP,{}),value:e,gradient:x7,children:[(0,z.jsx)(g7,{small:!0}),(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.PoliceInfoPanel.CURRENT_NUMBER_OF_CRIMINALS,{}),rightText:(0,z.jsx)(su,{value:s,unit:$c.Integer})}),(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.PoliceInfoPanel.NUMBER_OF_CRIMES_PER_MONTH,{}),rightText:(0,z.jsx)(su,{value:l,unit:$c.IntegerPerMonth})}),(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.PoliceInfoPanel.CRIME_SUCCESS_RATE,{}),rightText:(0,z.jsx)(su,{value:c,unit:$c.PercentageSingleFraction})})]})]})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/police-infoview-panel.tsx",{get PoliceInfoviewPanel(){return $9},set PoliceInfoviewPanel(e){$9=e}});var q9=["#3a91c7","#8bb9d6","#5fb844","#a3b844"],X9=[(0,z.jsx)(qc.PopulationInfoPanel.CHILDREN,{}),(0,z.jsx)(qc.PopulationInfoPanel.TEENS,{}),(0,z.jsx)(qc.PopulationInfoPanel.ADULTS,{}),(0,z.jsx)(qc.PopulationInfoPanel.SENIORS,{})];oe.add("game-ui/common/charts/pie-chart/age-pie-chart.tsx",{get agePieChartColors(){return q9},set agePieChartColors(e){q9=e},get agePieChartLabels(){return X9},set agePieChartLabels(e){X9=e}});var Q9=function(){var e=xl(Yx),t=xl($x),n=xl(qx),r=xl(Xx),i=xl(Qx),o=xl(Yy),a=xl(Zx),s=xl(Jx),l=xl(e_);return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsxs)(L7,{tooltip:(0,z.jsx)(qc.Infoviews.POPULATION_STATISTICS_TOOLTIP,{}),children:[(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.PopulationInfoPanel.POPULATION,{}),rightText:(0,z.jsx)(su,{value:e,unit:$c.Integer})}),(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.PopulationInfoPanel.BIRTH_RATE,{}),rightText:(0,z.jsx)(su,{value:i,unit:$c.IntegerPerMonth})}),(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.PopulationInfoPanel.DEATH_RATE,{}),rightText:(0,z.jsx)(su,{value:o,unit:$c.IntegerPerMonth})}),(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.PopulationInfoPanel.MOVED_IN,{}),rightText:(0,z.jsx)(su,{value:a,unit:$c.IntegerPerMonth})}),(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.PopulationInfoPanel.MOVED_AWAY,{}),rightText:(0,z.jsx)(su,{value:s,unit:$c.IntegerPerMonth})}),(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.PopulationInfoPanel.JOBS,{}),rightText:(0,z.jsx)(su,{value:n,unit:$c.Integer})}),(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.PopulationInfoPanel.EMPLOYED,{}),rightText:(0,z.jsx)(su,{value:t,unit:$c.Integer})}),(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.PopulationInfoPanel.UNEMPLOYMENT,{}),rightText:(0,z.jsx)(su,{value:r,unit:$c.PercentageSingleFraction})})]}),(0,z.jsxs)(L7,{tooltip:(0,z.jsx)(qc.Infoviews.POPULATION_DISTRIBUTION_TOOLTIP,{}),children:[(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.PopulationInfoPanel.AGE_DISTRIBUTION,{})}),(0,z.jsx)(g7,{small:!0}),(0,z.jsx)(Q7,{usePercentageValue:!0,colors:q9,labels:X9,data:l})]})]})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/population-infoview-panel.tsx",{get PopulationInfoviewPanel(){return Q9},set PopulationInfoviewPanel(e){Q9=e}});var Z9=function(){var e=xl(Hx),t=xl(Kx),n=xl(Wx),r=xl(zx);return(0,z.jsx)(z.Fragment,{children:(0,z.jsx)(J7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.PostInfoPanel.MAIL_SERVICE_AVAILABILITY,{})}),tooltip:(0,z.jsx)(qc.Infoviews.MAIL_SERVICE_AVAILABILITY_TOOLTIP,{}),demandLabel:(0,z.jsx)(qc.PostInfoPanel.MAIL_RATE,{}),demandValue:(0,z.jsx)(su,{value:e,unit:$c.IntegerPerMonth}),supplyLabel:(0,z.jsx)(qc.InfoPanels.PROCESSING,{}),supplyValue:(0,z.jsx)(su,{value:t+n,unit:$c.IntegerPerMonth}),availability:r})})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/post-infoview-panel.tsx",{get PostInfoviewPanel(){return Z9},set PostInfoviewPanel(e){Z9=e}});var J9=function(){var e=xl(sx),t=xl(cx),n=xl(ux),r=xl(lx);return(0,z.jsx)(z.Fragment,{children:(0,z.jsx)(J7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.RoadsInfoPanel.PARKING_AVAILABILITY,{})}),tooltip:(0,z.jsx)(qc.Infoviews.PARKING_AVAILABILITY_TOOLTIP,{}),demandLabel:(0,z.jsx)(qc.RoadsInfoPanel.PARKED_CARS,{}),demandValue:(0,z.jsx)(su,{value:t,unit:$c.Integer}),supplyLabel:(0,z.jsx)(qc.InfoPanels.CAPACITY,{}),supplyValue:(0,z.jsx)(su,{value:e,unit:$c.Integer}),availability:n,children:(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.RoadsInfoPanel.PARKING_INCOME,{}),rightText:(0,z.jsx)(su,{value:r,unit:$c.MoneyPerMonth})})})})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/roads-infoview-panel.tsx",{get RoadsInfoviewPanel(){return J9},set RoadsInfoviewPanel(e){J9=e}});var eee=function(){var e=xl(Bx),t=xl(Gx),n=xl(Ux),r=xl(Vx);return(0,z.jsx)(z.Fragment,{children:(0,z.jsxs)(M7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.TourismInfoPanel.ATTRACTIVENESS,{}),rightText:(0,z.jsx)(su,{value:n.current})}),tooltip:(0,z.jsx)(qc.Infoviews.CITY_ATTRACTIVENESS_TOOLTIP,{}),value:n,gradient:O7,children:[(0,z.jsx)(g7,{small:!0}),(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.TourismInfoPanel.TOURISM_RATE,{}),rightText:(0,z.jsx)(su,{value:e,unit:$c.IntegerPerMonth})}),(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.TourismInfoPanel.WEATHER_EFFECT,{}),rightText:(0,z.jsx)(su,{value:r,unit:$c.Percentage,signed:!0})}),(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.TourismInfoPanel.AVERAGE_HOTEL_PRICE,{}),rightText:(0,z.jsx)(su,{value:t,unit:$c.Money})})]})})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/tourism-infoview-panel.tsx",{get TourismInfoviewPanel(){return eee},set TourismInfoviewPanel(e){eee=e}});let tee={chartFontColor:"rgba(255, 255, 255, 0.6)",chartLineColor:"rgba(255, 255, 255, 0.1)",trafficVolumeBorderColor:"rgba(29, 130, 184, 1)",trafficVolumeBackgroundColor:"rgba(29, 130, 184, 0.5)",trafficFlowBorderColor:"rgba(30, 179, 184, 1)",trafficFlowBackgroundColor:"rgba(30, 179, 184, 0.5)","traffic-chart":"traffic-chart_r8c",trafficChart:"traffic-chart_r8c"};oe.add("game-ui/game/components/selected-info-panel/shared-components/traffic-charts/traffic-chart.module.scss",{get classes(){return tee},set classes(e){Object.assign(tee,e)}});const nee=tee;var ree=function(e){var t=e.data,n=e.className,r=lee(t),i=see($c.IntegerPerHour,5,nee.trafficVolumeBorderColor,nee.trafficVolumeBackgroundColor);return(0,z.jsx)(OU,{type:"line",data:r,options:i,className:_d()(nee.trafficChart,n)})},iee=function(e){var t=e.data,n=e.className,r=lee(t),i=see($c.Percentage,100,nee.trafficFlowBorderColor,nee.trafficFlowBackgroundColor);return(0,z.jsx)(OU,{type:"line",data:r,options:i,className:_d()(nee.trafficChart,n)})},oee=10,aee=10;function see(e,t,n,r){var i=lu(e),o=xl(Xl);return(0,Y.useMemo)((function(){var e={elements:{line:{borderColor:n,backgroundColor:r,borderWidth:2,fill:!0},point:{borderColor:n,backgroundColor:n,radius:2,hoverRadius:2,borderWidth:2,hoverBorderWidth:2}},scales:{x:{beginAtZero:!0,grid:{lineWidth:2,color:nee.chartLineColor},ticks:{font:{size:oee*o,weight:"bold"},color:nee.chartFontColor,padding:aee,autoSkip:!1}},y:{min:0,suggestedMax:t,grid:{lineWidth:2,color:nee.chartLineColor},ticks:{font:{size:oee*o,weight:"bold"},color:nee.chartFontColor,padding:aee,autoSkip:!1,callback:function(e){return i(e)},maxTicksLimit:6}}}};return e}),[r,n,i,t,o])}function lee(e){var t=Qu();return(0,Y.useMemo)((function(){return{labels:[t({hour:0,minute:0}),t({hour:6,minute:0}),t({hour:12,minute:0}),t({hour:18,minute:0}),t({hour:0,minute:0})],datasets:[{label:"data",data:e}]}}),[e,t])}oe.add("game-ui/game/components/selected-info-panel/shared-components/traffic-charts/traffic-chart.tsx",{get TrafficVolumeChart(){return ree},set TrafficVolumeChart(e){ree=e},get TrafficFlowChart(){return iee},set TrafficFlowChart(e){iee=e}});var cee=function(){var e=xl(dx);return(0,z.jsxs)(L7,{focusableBorder:!0,tooltip:(0,z.jsx)(qc.Infoviews.TRAFFIC_FLOW,{}),children:[(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.SelectedInfoPanel.ROAD_TRAFFIC_FLOW,{})}),(0,z.jsx)(iee,{data:e})]})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/traffic-infoview-panel.tsx",{get TrafficInfoviewPanel(){return cee},set TrafficInfoviewPanel(e){cee=e}});let uee={"line-summary":"line-summary_tW5",lineSummary:"line-summary_tW5",row:"row_Pqo","disable-states":"disable-states_FlS",disableStates:"disable-states_FlS",locked:"locked_dOC",header:"header_Sxm","secondary-row":"secondary-row_bfC",secondaryRow:"secondary-row_bfC",value:"value_p4t","fifty-percent":"fifty-percent_dQ2",fiftyPercent:"fifty-percent_dQ2","thirty-percent":"thirty-percent_pPg",thirtyPercent:"thirty-percent_pPg","total-label":"total-label_QwL",totalLabel:"total-label_QwL",icon:"icon_Rph icon_Iwk",lock:"lock_eZg"};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/transport-infoview-panel/transport-infoview-panel.module.scss",{get classes(){return uee},set classes(e){Object.assign(uee,e)}});const dee=uee;var fee=function(e){var t=e.summaries;return(0,z.jsxs)(L7,{disableFocus:!0,children:[(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.TransportInfoPanel.CARGO_TRANSPORT_TITLE,{})}),(0,z.jsx)(mee,{}),(0,z.jsxs)(Ap,{children:[t.map((function(e){return(0,z.jsx)(gee,{summary:e},e.id)})),(0,z.jsx)(gee,{lastRow:!0,summary:t.reduce((function(e,t){return{id:"Total",icon:"",locked:!1,cargoCount:e.cargoCount+t.cargoCount,lineCount:e.lineCount+t.lineCount,requirements:{requireAny:[],requireAll:[]}}}))})]})]})},mee=function(){return(0,z.jsxs)("div",{className:_d()(dee.row,dee.disableStates,dee.header),children:[(0,z.jsx)("div",{className:dee.icon}),(0,z.jsxs)("div",{className:dee.secondaryRow,children:[(0,z.jsx)("div",{className:_d()(dee.value,dee.fiftyPercent),children:(0,z.jsx)(qc.TransportInfoPanel.ROUTES_LABEL,{})}),(0,z.jsx)("div",{className:_d()(dee.value,dee.fiftyPercent),children:(0,z.jsx)(qc.TransportInfoPanel.CARGO_LABEL,{})})]})]})},gee=function(e){var t=e.summary,n=e.lastRow,r=void 0!==n&&n,i=!r&&"Bus"!==t.id,o=(0,Y.useCallback)((function(){wL(t.id),X_($_.Cargo)}),[t.id]);return(0,z.jsx)(B9,{description:(0,z.jsx)(qc.TransportInfoPanel.SUMMARY_TOOLTIP_CARGO,{hash:t.id}),locked:t.locked,requirements:t.requirements,direction:"right",children:(0,z.jsxs)(Qp,{focusKey:Kh,theme:o7,onSelect:i?o:void 0,disabled:t.locked,className:_d()(dee.row,t.locked&&o7.locked,t.locked&&dee.locked,!i&&dee.disableStates),children:[r?(0,z.jsx)("div",{className:dee.totalLabel,children:(0,z.jsx)(qc.TransportInfoPanel.TOTAL,{})}):(0,z.jsx)("img",{src:t.icon,className:_d()(o7.icon,dee.icon)}),t.locked&&(0,z.jsx)(_1,{className:dee.lock}),(0,z.jsxs)("div",{className:dee.secondaryRow,children:[(0,z.jsx)("div",{className:_d()(dee.value,dee.fiftyPercent),children:"Bus"===t.id||0===t.lineCount&&!r?"—":t.lineCount}),(0,z.jsx)("div",{className:_d()(dee.value,dee.fiftyPercent),children:t.cargoCount>0||r?(0,z.jsx)(su,{value:t.cargoCount,unit:$c.WeightPerMonth}):"—"})]})]})})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/transport-infoview-panel/cargo-transport-summary.tsx",{get CargoTransportSummary(){return fee},set CargoTransportSummary(e){fee=e}});var hee=function(e){var t=e.summaries;return(0,z.jsxs)(L7,{disableFocus:!0,children:[(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.TransportInfoPanel.PUBLIC_TRANSPORT_TITLE,{})}),(0,z.jsx)(pee,{}),(0,z.jsxs)(Ap,{children:[t.map((function(e){return(0,z.jsx)(vee,{summary:e},e.id)})),(0,z.jsx)(vee,{lastRow:!0,summary:t.reduce((function(e,t){return{id:"Total",icon:"",locked:!1,touristCount:e.touristCount+t.touristCount,citizenCount:e.citizenCount+t.citizenCount,lineCount:e.lineCount+t.lineCount,requirements:{requireAny:[],requireAll:[]}}}))})]})]})},pee=function(){return(0,z.jsxs)("div",{className:_d()(dee.row,dee.disableStates,dee.header),children:[(0,z.jsx)("div",{className:dee.icon}),(0,z.jsxs)("div",{className:dee.secondaryRow,children:[(0,z.jsx)("div",{className:_d()(dee.value,dee.thirtyPercent),children:(0,z.jsx)(qc.TransportInfoPanel.LINES,{})}),(0,z.jsx)("div",{className:_d()(dee.value,dee.thirtyPercent),children:(0,z.jsx)(qc.TransportInfoPanel.TOURISTS,{})}),(0,z.jsx)("div",{className:_d()(dee.value,dee.thirtyPercent),children:(0,z.jsx)(qc.TransportInfoPanel.CITIZENS,{})})]})]})},vee=function(e){var t=e.summary,n=e.lastRow,r=void 0!==n&&n,i=!r&&"Taxi"!==t.id,o=(0,Y.useCallback)((function(){IL(t.id),X_($_.PublicTransport)}),[t.id]);return(0,z.jsx)(B9,{description:(0,z.jsx)(qc.TransportInfoPanel.SUMMARY_TOOLTIP_PUBLICTRANSPORT,{hash:t.id}),locked:t.locked,requirements:t.requirements,direction:"right",children:(0,z.jsxs)(Qp,{focusKey:Kh,onSelect:i?o:void 0,disabled:t.locked,theme:o7,className:_d()(dee.row,t.locked&&o7.locked,t.locked&&dee.locked,!i&&dee.disableStates),children:[r?(0,z.jsx)("div",{className:dee.totalLabel,children:(0,z.jsx)(qc.TransportInfoPanel.TOTAL,{})}):(0,z.jsx)("img",{src:t.icon,className:_d()(o7.icon,dee.icon)}),t.locked&&(0,z.jsx)(_1,{className:dee.lock}),(0,z.jsxs)("div",{className:dee.secondaryRow,children:[(0,z.jsx)("div",{className:_d()(dee.value,dee.thirtyPercent),children:"Taxi"===t.id||0===t.lineCount&&!r?"—":t.lineCount}),(0,z.jsx)("div",{className:_d()(dee.value,dee.thirtyPercent),children:t.touristCount>0||r?(0,z.jsx)(su,{value:t.touristCount,unit:$c.IntegerPerMonth}):"—"}),(0,z.jsx)("div",{className:_d()(dee.value,dee.thirtyPercent),children:t.citizenCount>0||r?(0,z.jsx)(su,{value:t.citizenCount,unit:$c.IntegerPerMonth}):"—"})]})]})})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/transport-infoview-panel/public-transport-summary.tsx",{get PublicTransportSummary(){return hee},set PublicTransportSummary(e){hee=e}});var bee=function(){var e=xl(Hy);return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(hee,{summaries:e.passengerSummaries}),(0,z.jsx)(fee,{summaries:e.cargoSummaries})]})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/transport-infoview-panel/transport-infoview-panel.tsx",{get TransportInfoviewPanel(){return bee},set TransportInfoviewPanel(e){bee=e}});var yee=function(){return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(xee,{}),(0,z.jsx)(jee,{}),(0,z.jsx)(_ee,{}),(0,z.jsx)(Oee,{})]})},xee=function(){var e=xl(py),t=xl(vy),n=xl(Ey);return(0,z.jsx)(J7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.WaterInfoPanel.WATER_AVAILABILITY,{})}),tooltip:(0,z.jsx)(qc.Infoviews.WATER_AVAILABILITY_TOOLTIP,{}),supplyLabel:(0,z.jsx)(qc.InfoPanels.OUTPUT,{}),supplyValue:(0,z.jsx)(su,{value:e,unit:$c.VolumePerMonth}),demandLabel:(0,z.jsx)(qc.InfoPanels.CONSUMPTION,{}),demandValue:(0,z.jsx)(su,{value:t,unit:$c.VolumePerMonth}),availability:n})},_ee=function(){var e=xl(by),t=xl(yy),n=xl(Oy);return(0,z.jsx)(J7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.WaterInfoPanel.SEWAGE_TREATMENT,{})}),tooltip:(0,z.jsx)(qc.Infoviews.SEWAGE_TREATMENT_TOOLTIP,{}),supplyLabel:(0,z.jsx)(qc.InfoPanels.PROCESSING,{}),supplyValue:(0,z.jsx)(su,{value:e,unit:$c.VolumePerMonth}),demandLabel:(0,z.jsx)(qc.InfoPanels.PRODUCTION,{}),demandValue:(0,z.jsx)(su,{value:t,unit:$c.VolumePerMonth}),availability:n})},jee=function(){var e=xl(xy),t=xl(_y),n=xl(Sy);return(0,z.jsx)(J7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.WaterInfoPanel.WATER_TRADE,{})}),tooltip:(0,z.jsx)(qc.Infoviews.WATER_TRADE_TOOLTIP,{}),supplyLabel:(0,z.jsx)(qc.WaterInfoPanel.WATER_EXPORT,{}),supplyValue:(0,z.jsx)(su,{value:e,unit:$c.VolumePerMonth}),demandLabel:(0,z.jsx)(qc.WaterInfoPanel.WATER_IMPORT,{}),demandValue:(0,z.jsx)(su,{value:t,unit:$c.VolumePerMonth}),availability:n})},Oee=function(){var e=xl(jy),t={min:xl(yy),max:0,current:e};return(0,z.jsx)(M7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.WaterInfoPanel.SEWAGE_TRADE,{}),rightText:(0,z.jsx)(su,{value:e,unit:$c.VolumePerMonth})}),tooltip:(0,z.jsx)(qc.Infoviews.SEWAGE_TRADE_TOOLTIP,{}),value:t,gradient:S7})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/water-infoview-panel.tsx",{get WaterInfoviewPanel(){return yee},set WaterInfoviewPanel(e){yee=e}});var Eee=function(){var e=xl(gx);return(0,z.jsx)(M7,{title:(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.WaterPollutionInfoPanel.AVERAGE_WATER_POLLUTION,{}),rightText:(0,z.jsx)(bd,{value:e.current,max:e.max})}),tooltip:(0,z.jsx)(qc.Infoviews.AVERAGE_WATER_POLLUTION_TOOLTIP,{}),value:e,gradient:y7})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/water-pollution-infoview-panel.tsx",{get WaterPollutionInfoviewPanel(){return Eee},set WaterPollutionInfoviewPanel(e){Eee=e}});var See=["#808080","#b09868","#368a2e","#b981c0","#5796d1","#FFFFFF33"],Tee=[(0,z.jsx)(qc.EducationInfoPanel.LEVEL,{hash:"Uneducated"}),(0,z.jsx)(qc.EducationInfoPanel.LEVEL,{hash:"Poorly Educated"}),(0,z.jsx)(qc.EducationInfoPanel.LEVEL,{hash:"Educated"}),(0,z.jsx)(qc.EducationInfoPanel.LEVEL,{hash:"Well Educated"}),(0,z.jsx)(qc.EducationInfoPanel.LEVEL,{hash:"Highly Educated"}),(0,z.jsx)(qc.SelectedInfoPanel.OPEN_POSITIONS,{})];oe.add("game-ui/common/charts/pie-chart/workplaces-pie-charts.tsx",{get workplacesPieChartColors(){return See},set workplacesPieChartColors(e){See=e},get workplacesPieChartLabels(){return Tee},set workplacesPieChartLabels(e){Tee=e}});var Iee=function(){var e=xl(x_),t=xl(__),n=xl(j_),r=xl(O_);return(0,z.jsxs)(L7,{tooltip:(0,z.jsx)(qc.Infoviews.WORKPLACE_DISTRIBUTION_TOOLTIP,{}),children:[(0,z.jsx)(v7,{uppercase:!0,text:(0,z.jsx)(qc.WorkplacesInfoPanel.WORKPLACE_DISTRIBUTION,{})}),(0,z.jsx)(Q7,{colors:See,labels:Tee,data:t,customLegend:t.values.map((function(n,r){return(e.values[r]>0||r===t.values.length-1)&&(0,z.jsxs)("div",{className:X7.legend,children:[(0,z.jsx)(hU,{color:See[r],label:Tee[r]}),r<t.values.length-1?(0,z.jsx)(Pu,{value:n,total:e.values[r],unit:$c.Integer}):(0,z.jsx)(su,{value:n,unit:$c.Integer})]},r)}))}),(0,z.jsx)(g7,{}),(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.WorkplacesInfoPanel.WORKPLACES,{}),rightText:(0,z.jsx)(su,{value:n,unit:$c.Integer})}),(0,z.jsx)(v7,{small:!0,text:(0,z.jsx)(qc.WorkplacesInfoPanel.WORKERS,{}),rightText:(0,z.jsx)(su,{value:r,unit:$c.Integer})})]})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/panels/workplaces-infoview-panel.tsx",{get WorkplacesInfoviewPanel(){return Iee},set WorkplacesInfoviewPanel(e){Iee=e}});let wee={title:"title_HFc","active-infoview-panel":"active-infoview-panel_aTq",activeInfoviewPanel:"active-infoview-panel_aTq","infomodes-panel":"infomodes-panel_B0O",infomodesPanel:"infomodes-panel_B0O",scrollable:"scrollable_wt8"};oe.add("game-ui/game/components/infoviews/active-infoview-panel/active-infoview-panel.module.scss",{get classes(){return wee},set classes(e){Object.assign(wee,e)}});const Pee=wee;var Cee=function(e){var t=e.focusKey,n=e.className,r=e.onClose,i=e.transition,o=e.allowFocusExit,a=e.scrollable,s=void 0===a||a,l=r7(M_.PhotoMode),c=zL(xl(ry)),u=(0,Y.useMemo)((function(){return function(e){switch(null==e?void 0:e.id){case"Electricity":return(0,z.jsx)(n9,{});case"WaterPipes":return(0,z.jsx)(yee,{});case"Transport":return(0,z.jsx)(bee,{});case"Education":return(0,z.jsx)(e9,{});case"Healthcare":return(0,z.jsx)(d9,{});case"Garbage":return(0,z.jsx)(i9,{});case"Roads":return(0,z.jsx)(J9,{});case"Traffic":return(0,z.jsx)(cee,{});case"AirPollution":return(0,z.jsx)(k7,{});case"GroundPollution":return(0,z.jsx)(s9,{});case"WaterPollution":return(0,z.jsx)(Eee,{});case"NoisePollution":return(0,z.jsx)(W9,{});case"FireRescue":return(0,z.jsx)(r9,{});case"Police":return(0,z.jsx)($9,{});case"LandValue":return(0,z.jsx)(h9,{});case"Level":return(0,z.jsx)(V9,{});case"DisasterControl":return(0,z.jsx)(G7,{});case"Tourism":return(0,z.jsx)(eee,{});case"PostService":return(0,z.jsx)(Z9,{});case"Population":return(0,z.jsx)(Q9,{});case"Extractors":return(0,z.jsx)(H9,{});case"OutsideConnections":return(0,z.jsx)(Y9,{});case"Profitability":return(0,z.jsx)(R7,{});case"Workplaces":return(0,z.jsx)(Iee,{});case"Happiness":return(0,z.jsx)(u9,{});default:return null}}(c)}),[c]),d=(0,Y.useCallback)((function(){return r()}),[r]),f=(0,Y.useMemo)((function(){var e;return c?"".concat(null===(e=Ew.value)||void 0===e?void 0:e.infoviewsPanel,"+").concat(c.uiTag):void 0}),[c]);ih(f,null!=c);var m=c&&!l.visible,g=m&&(0,z.jsx)(ap,{onAction:d,children:(0,z.jsxs)(Ap,{children:[u,c.infomodes.length>0&&(0,z.jsxs)("div",{className:Pee.infomodesPanel,children:[(0,z.jsx)(v7,{text:(0,z.jsx)(qc.Infoviews.MAP_LEGEND,{}),uppercase:!0}),(0,z.jsx)(g7,{}),null==c?void 0:c.infomodes.map((function(e){return(0,z.jsx)(u7,{focusKey:e.id,infomode:e},e.id)}))]})]})});return(0,z.jsx)(z.Fragment,{children:m&&(0,z.jsx)(tk,{uiTag:f,children:(0,z.jsx)(qj,{focusKey:t,className:_d()(Pee.activeInfoviewPanel,n),onClose:d,header:(0,z.jsx)(tO,{icon:null==c?void 0:c.icon,className:Pee.title,children:(0,z.jsx)(qc.Infoviews.INFOVIEW,{hash:(null==c?void 0:c.id)||""})}),transition:i,allowFocusExit:o,children:s?(0,z.jsx)(gE,{className:Pee.scrollable,children:g}):g})})})};oe.add("game-ui/game/components/infoviews/active-infoview-panel/active-infoview-panel.tsx",{get ActiveInfoviewPanel(){return Cee},set ActiveInfoviewPanel(e){Cee=e}});let Nee={button:"button_FBo button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT toggle-states_DTm",icon:"icon_ZjN icon_soN icon_Iwk",locked:"locked_Tjl locked_H2O locked_dBl",item:"item_IYJ",lock:"lock_OBe"};oe.add("game-ui/game/components/infoviews/infoviews-button/infoview-button.module.scss",{get classes(){return Nee},set classes(e){Object.assign(Nee,e)}});const Aee=Nee;var Lee=function(e){var t,n=e.infoview,r=e.selected,i=e.onSelect,o=e.bypassLocking,a=(0,Y.useCallback)((function(){i(r?ty:n.entity),nh(n.uiTag)}),[i,r,n.entity,n.uiTag]),s=!o&&n.locked;return(0,z.jsx)(tk,{uiTag:n.uiTag,children:(0,z.jsx)(B9,{title:(0,z.jsx)(qc.Infoviews.INFOVIEW,{hash:n.id}),locked:s,requirements:n.requirements,direction:"up",alignment:"end",children:(0,z.jsx)(lb,{focusKey:n.id,src:null!==(t=n.icon)&&void 0!==t?t:"Media/Placeholder.svg",disabled:s,selected:r,theme:Aee,onSelect:a,className:_d()(Aee.item,s&&Aee.locked),children:s&&(0,z.jsx)(_1,{className:Aee.lock})})})})};oe.add("game-ui/game/components/infoviews/infoviews-button/infoview-button.tsx",{get InfoviewButton(){return Lee},set InfoviewButton(e){Lee=e}});let Mee={"infoview-menu":"infoview-menu_LhU",infoviewMenu:"infoview-menu_LhU","menu-column":"menu-column_VJk",menuColumn:"menu-column_VJk",menu:"menu_O_M",content:"content_Hzl",row:"row_B8G"};oe.add("game-ui/game/components/infoviews/infoview-menu.module.scss",{get classes(){return Mee},set classes(e){Object.assign(Mee,e)}});const kee=Mee;function Ree(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Dee(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Ree(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ree(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Fee=new Wh("INFOVIEWS"),Uee=new Wh("ACTIVE_INFOVIEW"),Gee=function(e){var t=e.className,n=e.onClose,r=Pg(),i=Dee((0,Y.useState)(!1),2),o=i[0],a=i[1];ey(!o||!r);var s=xl(ry),l=(0,Y.useCallback)((function(){null!=s?iy(ty):n()}),[s,n]),c=(0,Y.useCallback)((function(){return iy(ty)}),[]);return(0,z.jsx)(ap,{onAction:l,children:(0,z.jsx)(Tg,{onFocusChange:a,children:(0,z.jsx)(pj,{focused:null!=s?Uee:Fee,children:(0,z.jsxs)("div",{className:_d()(kee.infoviewMenu,t),children:[(0,z.jsx)(Bee,{focusKey:Fee}),(0,z.jsx)(cS,{in:null!=s,children:(0,z.jsx)(Cee,{focusKey:Uee,onClose:c})})]})})})})},Bee=function(e){var t,n,r,i=e.focusKey,o=e.className;rh(null===(t=Ew.value)||void 0===t?void 0:t.infoviewsMenu),ih(null===(n=Ew.value)||void 0===n?void 0:n.infoviewsMenu);var a,s=xl(ny),l=xl(ry),c=null!==(a=null==l?void 0:l.id)&&void 0!==a?a:null,u=Dee((0,Y.useState)(c),2),d=u[0],f=u[1];return(0,Y.useEffect)((function(){null!=c&&f(c)}),[c]),(0,z.jsx)(tk,{uiTag:null===(r=Ew.value)||void 0===r?void 0:r.infoviewsMenu,children:(0,z.jsx)(qj,{focusKey:i,transitionSounds:vj,className:_d()(kee.menu,o),contentClassName:kee.content,children:(0,z.jsxs)(Ip,{focused:d,onChange:f,onRefocus:wp,children:[(0,z.jsx)("div",{className:kee.row,children:Vee(s,0,c)}),(0,z.jsx)("div",{className:kee.row,children:Vee(s,1,c)}),(0,z.jsx)("div",{className:kee.row,children:Vee(s,2,c)}),(0,z.jsx)("div",{className:kee.row,children:Vee(s,3,c)}),(0,z.jsx)("div",{className:kee.row,children:Vee(s,4,c)}),(0,z.jsx)("div",{className:kee.row,children:Vee(s,5,c)}),(0,z.jsx)("div",{className:kee.row,children:Vee(s,6,c)}),(0,z.jsx)("div",{className:kee.row,children:Vee(s,7,c)}),(0,z.jsx)("div",{className:kee.row,children:Vee(s,8,c)})]})})})};function Vee(e,t,n){return e.filter((function(e){return e.group===t})).map((function(e){return(0,z.jsx)(Lee,{infoview:e,selected:e.id===n,onSelect:iy},e.id)}))}var Hee=function(e){var t,n=e.className,r=e.onSelect,i=xl(ny),o=xl(ry),a=null!==(t=null==o?void 0:o.id)&&void 0!==t?t:null,s=Dee((0,Y.useState)(a),2),l=s[0],c=s[1],u=i.filter((function(e){return e.editor})).map((function(e){return(0,z.jsx)(Lee,{infoview:e,selected:e.id===a,onSelect:r,bypassLocking:!0},e.id)}));return 0===u.length?null:(0,z.jsx)(qj,{transitionSounds:vj,className:n,contentClassName:kee.content,allowFocusExit:!0,children:(0,z.jsx)(Ip,{focused:l,onChange:c,direction:gp.Horizontal,children:(0,z.jsx)(gE,{horizontal:!0,vertical:!1,children:(0,z.jsx)("div",{className:kee.row,children:u})})})})};oe.add("game-ui/game/components/infoviews/infoview-menu.tsx",{get InfoviewMenu(){return Gee},set InfoviewMenu(e){Gee=e},get EditorInfoviewMenu(){return Hee},set EditorInfoviewMenu(e){Hee=e}});let Kee={itemHeight:"30rem",hierarchy:"hierarchy_vuK",item:"item_Ksl","item-label":"item-label_GTI",itemLabel:"item-label_GTI","arrow-container":"arrow-container_Mio",arrowContainer:"arrow-container_Mio",arrow:"arrow_wix",expanded:"expanded_YQt",bullet:"bullet_B3F",title:"title_THo",placeholder:"placeholder_bdR",actions:"actions_Qtv","action-button":"action-button_irO item-states_QjV",actionButton:"action-button_irO item-states_QjV"};oe.add("game-ui/editor/components/hierarchy/hierarchy.module.scss",{get classes(){return Kee},set classes(e){Object.assign(Kee,e)}});const Wee=Kee;function zee(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var Yee=function(e){var t=e.className,n=xl(_8),r=NQ(YO(Wee.itemHeight),n,10),i=xl(O8),o=xl(j8),a=function(e,t){var n=e.items.findIndex((function(e){return A8(e.id,t)}));return-1!==n?e.startIndex+n:null}(i,o),s=(0,Y.useCallback)((function(e){var t=e-i.startIndex;if(t>=0&&t<i.items.length){var n=i.items[t];return(0,z.jsx)($ee,{index:e,data:n,selected:A8(n.id,o),onSelect:T8,onToggleExpanded:I8},e)}return(0,z.jsx)(qee,{},e)}),[o,i.items,i.startIndex]),l=(0,Y.useCallback)((function(e,t){S8(e,t)}),[]),c=(0,Y.useCallback)((function(e){if("number"==typeof e){var t=e-i.startIndex;t>=0&&t<i.items.length&&T8(i.items[t].id)}}),[i]);return(0,z.jsx)(Ip,{direction:gp.Vertical,focused:a,onChange:c,children:(0,z.jsx)(wQ,{className:_d()(Wee.hierarchy,t),sizeProvider:r,renderItem:s,onRenderedRangeChange:l})})},$ee=function(e){var t,n=e.index,r=e.data,i=e.selected,o=e.onSelect,a=e.onToggleExpanded,s=Pg(),l=(0,Y.useCallback)((function(){r.selectable||s?o(r.id):r.expandable&&a(r.id,!r.expanded)}),[r.expandable,r.expanded,r.id,r.selectable,s,o,a]),c=(0,Y.useCallback)((function(){a(r.id,!r.expanded),kp(Lp.expandPanel)}),[r.expanded,r.id,a]),u=(0,Y.useMemo)((function(){return zee({},r.expanded?"Collapse Group":"Expand Group",r.expandable?c:null)}),[r.expanded,r.expandable,c]),d=(0,Y.useCallback)((function(){P8(r.id.entity)}),[r.id.entity]);return(0,z.jsx)("div",{className:_d()(Wee.item,(t={},zee(t,Wee.expanded,r.expanded),zee(t,"selected",i),t)),style:{"--level":r.level},onClick:l,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,focusKey:n,children:[(0,z.jsx)(rp,{actions:u,children:(0,z.jsxs)(Qp,{className:Wee.itemLabel,selected:i,onSelect:l,children:[r.expandable?(0,z.jsx)("div",{className:Wee.arrowContainer,children:(0,z.jsx)("img",{src:"Media/Editor/HierarchyExpand.svg",className:Wee.arrow,onClick:c})}):(0,z.jsx)("img",{src:"Media/Editor/HierarchyNode.svg",className:Wee.bullet}),(0,z.jsx)("div",{className:Wee.title,children:(0,z.jsx)(ku,{value:r.name})})]})}),(0,z.jsx)("div",{className:Wee.actions,children:r.id.type===v8.Object&&!Qs(r.id.entity,ty)&&(0,z.jsx)(z.Fragment,{children:r.saveable&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Editor.SAVE,{}),children:(0,z.jsx)(lb,{src:"Media\\Editor\\Save.svg",className:Wee.actionButton,onSelect:d})})})})]})})},qee=function(){return(0,z.jsx)("div",{className:Wee.placeholder})};oe.add("game-ui/editor/components/hierarchy/hierarchy.tsx",{get Hierarchy(){return Yee},set Hierarchy(e){Yee=e}});let Xee={panel:"panel_Qoc",content:"content_taQ",hierarchy:"hierarchy_QwS"};oe.add("game-ui/editor/components/hierarchy/hierarchy-panel.module.scss",{get classes(){return Xee},set classes(e){Object.assign(Xee,e)}});const Qee=Xee;var Zee=function(e){var t=e.onClose,n=e.forceExpanded;return(0,z.jsx)(GL,{disabled:!1===n,children:(0,z.jsx)(ap,{onAction:t,children:(0,z.jsx)(G6,{theme:W6,headerText:(0,z.jsx)(qc.Editor.WORKSPACE,{}),className:Qee.panel,contentClassName:Qee.content,onClose:t,allowFocusExit:!0,expanded:n,children:(0,z.jsx)(Yee,{className:Qee.hierarchy})})})})};oe.add("game-ui/editor/components/hierarchy/hierarchy-panel.tsx",{get HierarchyPanel(){return Zee},set HierarchyPanel(e){Zee=e}});let Jee={minWidth:"200rem",maxWidth:"500rem","top-panel-row":"top-panel-row_NFs",topPanelRow:"top-panel-row_NFs","top-panel-column":"top-panel-column_zGK",topPanelColumn:"top-panel-column_zGK","infoview-menu":"infoview-menu_CKL",infoviewMenu:"infoview-menu_CKL","infoview-panel-transition-wrapper":"infoview-panel-transition-wrapper_mRB",infoviewPanelTransitionWrapper:"infoview-panel-transition-wrapper_mRB",enter:"enter_y8_","exit-active":"exit-active_vMy",exitActive:"exit-active_vMy","enter-active":"enter-active_wJ0",enterActive:"enter-active_wJ0",exit:"exit_AML","active-infoview-menu":"active-infoview-menu_ds8",activeInfoviewMenu:"active-infoview-menu_ds8"};oe.add("game-ui/editor/components/editor-top-panels.module.scss",{get classes(){return Jee},set classes(e){Object.assign(Jee,e)}});const ete=Jee;var tte=function(){var e=xl(ry),t=(0,Y.useCallback)((function(){iy(ty)}),[]),n=(0,Y.useCallback)((function(e){iy(e)}),[]),r=YO(ete.minWidth),i=YO(ete.maxWidth),o=xl(x8),a=$O(),s=(0,Y.useCallback)((function(e){return E8(Math.round(e/a))}),[a]);return(0,z.jsx)("div",{className:ete.topPanelRow,children:(0,z.jsxs)(X6,{width:o*a,minWidth:r,maxWidth:i,direction:"right",onResize:s,className:ete.topPanelColumn,children:[(0,z.jsx)(Hee,{className:ete.infoviewMenu,onSelect:n}),(0,z.jsx)(cS,{in:null!==e,children:(0,z.jsx)(aS,{styles:ete,children:(0,z.jsx)("div",{className:ete.infoviewPanelTransitionWrapper,children:(0,z.jsx)(Cee,{className:ete.activeInfoviewMenu,onClose:t,transition:null,scrollable:!1,allowFocusExit:!0})})})}),(0,z.jsx)(Zee,{forceExpanded:null===e&&void 0})]})})};oe.add("game-ui/editor/components/editor-top-panels.tsx",{get EditorTopPanels(){return tte},set EditorTopPanels(e){tte=e}});var nte="editorTool",rte=fl(nte,"tools"),ite=fl(nte,"activeTool"),ote=vl(nte,"selectTool");oe.add("game-ui/editor/data-binding/editor-tool-bindings.ts",{get tools(){return tools},set tools(e){tools=e},get activeTool(){return activeTool},set activeTool(e){activeTool=e},get selectTool(){return ote},set selectTool(e){ote=e}});let ate={button:"button_iZC",icon:"icon_oET"};oe.add("game-ui/editor/themes/editor-tool-button.module.scss",{get classes(){return ate},set classes(e){Object.assign(ate,e)}});const ste=ate;let lte={"editor-toolbar":"editor-toolbar_i1J",editorToolbar:"editor-toolbar_i1J",button:"button_i0V"};oe.add("game-ui/editor/components/toolbar/toolbar.module.scss",{get classes(){return lte},set classes(e){Object.assign(lte,e)}});const cte=lte;var ute=function(e){var t=e.className,n=xl(rte),r=xl(ite),i=(0,Y.useCallback)((function(e){return ote(ite.value!==e?e:null)}),[]);return(0,z.jsx)("div",{className:_d()(cte.editorToolbar,t),children:(0,z.jsx)(Ap,{direction:gp.Horizontal,children:n.map((function(e){var t=e.id,n=e.icon,o=e.disabled;return(0,z.jsx)(dte,{id:t,icon:n,tooltip:(0,z.jsx)(qc.Editor.TOOL,{hash:t}),selected:r===t,disabled:o,onSelect:i},t)}))})})},dte=function(e){var t=e.id,n=e.icon,r=e.tooltip,i=e.selected,o=e.disabled,a=e.onSelect,s=(0,Y.useCallback)((function(){return a(t)}),[t,a]);return(0,z.jsx)(jh,{tooltip:r,children:(0,z.jsx)(lb,{src:n,disabled:o,theme:ste,selected:i,className:cte.button,onSelect:s})})};oe.add("game-ui/editor/components/toolbar/toolbar.tsx",{get Toolbar(){return ute},set Toolbar(e){ute=e}});let fte={"editor-main-screen":"editor-main-screen_m89",editorMainScreen:"editor-main-screen_m89",main:"main_k4u","top-layout":"top-layout_cRm",topLayout:"top-layout_cRm","tool-options":"tool-options_Cqd",toolOptions:"tool-options_Cqd",toolbar:"toolbar_Qbd","editor-panel":"editor-panel_oDZ",editorPanel:"editor-panel_oDZ"};oe.add("game-ui/editor/components/editor-main-screen.module.scss",{get classes(){return fte},set classes(e){Object.assign(fte,e)}});const mte=fte;function gte(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function hte(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var pte,vte=function(e){var t=e.focusKey,n=e.className,r=e.onPauseMenuToggle,i=xl(ZG),o=xl(C8),a=d6(),s=e4(),l=xl(VN),c=(0,Y.useRef)(l.id),u=(0,Y.useRef)(),d=l.id===xA,f=xl(ry);(0,Y.useEffect)((function(){l&&(c.current===yA&&u.current&&sA(u.current),l.id===yA&&iB(),l.id===yA&&(u.current=c.current),c.current=l.id)}),[l]);var m=(0,Y.useCallback)((function(){var e=Object.keys(b8).length/2;N8((o+1)%e)}),[o]),g=(0,Y.useMemo)((function(){return hte(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){gte(e,t,n[t])}))}return e}({},s),{Back:!d||i||null!==f?function(){d?i?iB():null!==f&&iy(ty):(l.id===yA&&kp(Lp.bulldozeEnd),sA(xA))}:null,"Pause Menu":r,Bulldozer:function(){l.id===yA?(kp(Lp.bulldozeEnd),sA(u.current||xA)):(kp(Lp.bulldoze),sA(yA))},"Change Elevation":uA,"Photo Mode Panel":m})}),[f,l.id,d,i,r,m,s]);return o4(),(0,z.jsx)(rp,{actions:g,children:(0,z.jsx)(em,{children:(0,z.jsx)(Ap,{focusKey:t,activation:yd.Always,children:(0,z.jsx)(Qd,{children:(0,z.jsxs)("div",{className:_d()(mte.editorMainScreen,n),children:[(0,z.jsxs)("div",{className:mte.main,children:[(0,z.jsxs)("div",{className:mte.topLayout,children:[(0,z.jsx)(YG,{}),(0,z.jsx)(tte,{})]}),(0,z.jsx)(ute,{className:mte.toolbar}),i&&(0,z.jsx)(n7,{resizeDirection:"left",className:mte.editorPanel}),a&&(0,z.jsx)(u6,{className:mte.toolOptions})]}),(0,z.jsx)(N6,{onPauseMenuToggle:r}),(0,z.jsx)(H5,{name:"Editor"}),(0,z.jsx)(l8,{})]})})})})})};function bte(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function yte(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function xte(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return bte(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return bte(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/editor/components/editor-main-screen.tsx",{get EditorMainScreen(){return vte},set EditorMainScreen(e){vte=e}}),function(e){e[e.main=0]="main",e[e.pauseMenu=1]="pauseMenu",e[e.options=2]="options"}(pte||(pte={}));var _te=function(){var e=xte((0,Y.useState)(pte.main),2),t=e[0],n=e[1],r=t!==pte.main,i=(0,Y.useCallback)((function(){n((function(e){return e!==pte.pauseMenu?pte.pauseMenu:pte.main}))}),[]),o=(0,Y.useCallback)((function(){return n(pte.main)}),[]),a=(0,Y.useCallback)((function(){return n(pte.pauseMenu)}),[]),s=(0,Y.useMemo)((function(){return{}}),[]),l=(0,Y.useContext)(dO);(0,Y.useEffect)((function(){var e=kh.subscribe((function(e){l.showDialog((0,z.jsx)(_O,function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){yte(e,t,n[t])}))}return e}({},e)))}));return function(){return e.dispose()}}),[l]);var c=(0,Y.useCallback)((function(){l.showDialog((0,z.jsx)(OO,{message:(0,z.jsx)(qc.Common.DIALOG_MESSAGE,{hash:"ProgressLoss"}),onConfirm:CG}))}),[l]);return(0,z.jsx)(rp,{actions:s,children:(0,z.jsxs)(pj,{focused:t,activation:yd.Always,children:[(0,z.jsx)(vte,{focusKey:pte.main,onPauseMenuToggle:i}),(0,z.jsx)(Ud,{children:r&&(0,z.jsx)(V5,{children:(0,z.jsxs)(Ud,{children:[t===pte.pauseMenu&&(0,z.jsx)(u1,{focusKey:pte.pauseMenu,onSelectScreen:n,onClose:o,onNewMap:c},pte.pauseMenu),t===pte.options&&(0,z.jsx)(M5,{focusKey:pte.options,onClose:a},pte.options)]})},"pause")})]})})};function jte(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];(0,Y.useEffect)((function(){if(!e){var t=AN.subscribe((function(){}));return function(){null==t||t.dispose()}}}),[e])}oe.add("game-ui/editor/components/editor-ui.tsx",{get EditorScreen(){return pte},set EditorScreen(e){pte=e},get EditorUI(){return _te},set EditorUI(e){_te=e}}),oe.add("game-ui/common/hooks/use-simulation-paused-barrier.tsx",{get useSimulationPausedBarrier(){return jte},set useSimulationPausedBarrier(e){jte=e}});let Ote={"debug-prefab-tool-panel":"debug-prefab-tool-panel_xQO",debugPrefabToolPanel:"debug-prefab-tool-panel_xQO"};oe.add("game-ui/debug/components/debug-prefab-tool/debug-prefab-tool.module.scss",{get classes(){return Ote},set classes(e){Object.assign(Ote,e)}});const Ete=Ote;var Ste=new Wh("CHILDREN"),Tte=function(e){var t=e.children,n=xl(vR),r=xl(ZG),i=(0,Y.useMemo)((function(){return{"Debug Prefab Tool":function(){return ote(r?null:"PrefabTool")}}}),[r]);return n?(0,z.jsx)(rp,{actions:i,children:(0,z.jsxs)(pj,{focused:Ste,children:[(0,z.jsx)(hj,{focusKey:Ste,children:t}),r&&(0,z.jsx)(n7,{resizeDirection:"left",className:Ete.debugPrefabToolPanel})]})}):(0,z.jsx)(z.Fragment,{children:t})};oe.add("game-ui/debug/components/debug-prefab-tool/debug-prefab-tool.tsx",{get DebugPrefabToolRenderer(){return Tte},set DebugPrefabToolRenderer(e){Tte=e}});var Ite,wte="notification",Pte=fl(wte,"notifications");function Cte(e){bl(wte,"selectNotification",e)}!function(e){e[e.None=0]="None",e[e.Progressing=1]="Progressing",e[e.Indeterminate=2]="Indeterminate",e[e.Complete=3]="Complete",e[e.Failure=4]="Failure",e[e.Warning=5]="Warning"}(Ite||(Ite={})),oe.add("game-ui/menu/data-binding/notification-bindings.ts",{get notifications(){return notifications},set notifications(e){notifications=e},get selectNotification(){return Cte},set selectNotification(e){Cte=e},get ProgressState(){return Ite},set ProgressState(e){Ite=e}});let Nte={"progress-circle":"progress-circle_lIZ progress-circle_OLN",progressCircle:"progress-circle_lIZ progress-circle_OLN",progress:"progress_EdA progress_mlv",complete:"complete_yk6",failure:"failure_Zlz"};oe.add("game-ui/menu/components/notifications-panel/notification-progress.module.scss",{get classes(){return Nte},set classes(e){Object.assign(Nte,e)}});const Ate=Nte;let Lte={"notifications-panel":"notifications-panel_AtV",notificationsPanel:"notifications-panel_AtV",header:"header_JLb",scrollable:"scrollable_aqz","item-transition":"item-transition_kWi",itemTransition:"item-transition_kWi",enter:"enter_imo","enter-active":"enter-active_KuO",enterActive:"enter-active_KuO",exit:"exit_Dv6","exit-active":"exit-active_QeX",exitActive:"exit-active_QeX",item:"item_tYE",thumbnail:"thumbnail_MaF","main-column":"main-column_j77",mainColumn:"main-column_j77",title:"title_wMV",text:"text__0z","progress-container":"progress-container_Trw",progressContainer:"progress-container_Trw","progress-circle":"progress-circle_MKN",progressCircle:"progress-circle_MKN","progress-label":"progress-label_bgv",progressLabel:"progress-label_bgv","progress-icon":"progress-icon_KDy",progressIcon:"progress-icon_KDy","complete-icon":"complete-icon_CuU progress-icon_KDy",completeIcon:"complete-icon_CuU progress-icon_KDy","failure-icon":"failure-icon_Pny progress-icon_KDy",failureIcon:"failure-icon_Pny progress-icon_KDy","warning-icon":"warning-icon_dBU progress-icon_KDy",warningIcon:"warning-icon_dBU progress-icon_KDy"};oe.add("game-ui/menu/components/notifications-panel/notifications-panel.module.scss",{get classes(){return Lte},set classes(e){Object.assign(Lte,e)}});const Mte=Lte;var kte=Cj({Checkmark:"Media/Glyphs/Checkmark.svg",Close:"Media/Glyphs/Close.svg",Warning:"Media/Glyphs/Warning.svg"}),Rte=function(e){var t=e.className,n=xl(Pte);return(0,z.jsxs)("div",{className:_d()(Mte.notificationsPanel,t),children:[(0,z.jsx)("div",{className:Mte.header,children:(0,z.jsx)(qc.Menu.NOTIFICATIONS_TITLE,{})}),(0,z.jsx)(gE,{className:Mte.scrollable,children:(0,z.jsx)(Ap,{children:(0,z.jsx)(Ud,{children:n.map((function(e){return(0,z.jsx)(Fte,{item:e},e.id)}))})})})]})},Dte={tension:30,friction:10},Fte=function(e){var t=e.item,n=YZ(Dte,t.progress,t.progress,!0),r=(0,Y.useCallback)((function(){Cte(t.id)}),[t.id]);return(0,z.jsx)(aS,{styles:Mte,children:(0,z.jsx)("div",{className:Mte.itemTransition,children:(0,z.jsxs)(Qp,{onSelect:r,className:Mte.item,children:[t.thumbnail&&(0,z.jsx)("img",{src:t.thumbnail,className:Mte.thumbnail}),(0,z.jsxs)("div",{className:Mte.mainColumn,children:[(0,z.jsx)("div",{className:Mte.title,children:Ute(t)}),(0,z.jsx)("div",{className:Mte.text,children:Gte(t)})]}),t.progressState!==Ite.None&&(0,z.jsxs)("div",{className:Mte.progressContainer,children:[(0,z.jsx)(OV,{progress:t.progressState!==Ite.Complete?n:100,max:100,indeterminate:t.progressState===Ite.Indeterminate,theme:Ate,className:_d()(Mte.progressCircle,Bte(t))}),Vte(t)]})]})})})};function Ute(e){return null!=e.title?(0,z.jsx)(ku,{value:e.title}):void 0}function Gte(e){return null!=e.text?(0,z.jsx)(ku,{value:e.text}):void 0}function Bte(e){switch(e.progressState){case Ite.Complete:return Ate.complete;case Ite.Failure:return Ate.failure;default:return}}function Vte(e){switch(e.progressState){case Ite.Complete:return(0,z.jsx)(tb,{src:kte.Checkmark,className:Mte.completeIcon});case Ite.Failure:return(0,z.jsx)(tb,{src:kte.Close,className:Mte.failureIcon});case Ite.Warning:return(0,z.jsx)(tb,{src:kte.Warning,className:Mte.warningIcon});case Ite.Indeterminate:return;default:return(0,z.jsx)("div",{className:Mte.progressLabel,children:(0,z.jsx)(su,{value:e.progress,unit:$c.Percentage})})}}oe.add("game-ui/menu/components/notifications-panel/notifications-panel.tsx",{get NotificationsPanel(){return Rte},set NotificationsPanel(e){Rte=e},get NotificationItem(){return Fte},set NotificationItem(e){Fte=e}});let Hte={button:"button_Qvi item-mouse-states_Fmi",icon:"icon_Z6Y",label:"label_yYE"};oe.add("game-ui/menu/components/paradox-panel/account-link-button.module.scss",{get classes(){return Hte},set classes(e){Object.assign(Hte,e)}});const Kte=Hte;let Wte={"paradox-panel":"paradox-panel_iFS",paradoxPanel:"paradox-panel_iFS","incentive-container":"incentive-container_e7Y",incentiveContainer:"incentive-container_e7Y","incentive-image":"incentive-image_Qzc",incentiveImage:"incentive-image_Qzc","incentive-main":"incentive-main_IhA",incentiveMain:"incentive-main_IhA","incentive-prompt":"incentive-prompt_k0u",incentivePrompt:"incentive-prompt_k0u","incentive-footer":"incentive-footer_UuL",incentiveFooter:"incentive-footer_UuL","incentive-legal":"incentive-legal_MJN",incentiveLegal:"incentive-legal_MJN",header:"header_MiJ",logo:"logo_opg",title:"title_S09",content:"content_VTM","user-name":"user-name_GiO",userName:"user-name_GiO","button-row":"button-row_LTO",buttonRow:"button-row_LTO","button-container":"button-container_sgE",buttonContainer:"button-container_sgE",button:"button_o5e","legal-row":"legal-row_qI2",legalRow:"legal-row_qI2","legal-row-center":"legal-row-center_ZHk",legalRowCenter:"legal-row-center_ZHk","legal-link":"legal-link_Cxy item-states_QjV",legalLink:"legal-link_Cxy item-states_QjV"};oe.add("game-ui/menu/components/paradox-panel/paradox-panel.module.scss",{get classes(){return Wte},set classes(e){Object.assign(Wte,e)}});const zte=Wte;var Yte=function(e){var t=e.className,n=xl(jb),r=xl(Tb),i=xl(Ib);return(0,z.jsx)("div",{className:_d()(zte.paradoxPanel,t),children:r&&i?n?(0,z.jsx)(qte,{}):(0,z.jsx)($te,{}):(0,z.jsx)(Qte,{label:i?(0,z.jsx)(qc.Paradox.NO_INTERNET_CONNECTION,{}):(0,z.jsx)(qc.Paradox.SDK_DISABLED,{})})})},$te=function(){var e=xl(Tb);return(0,z.jsxs)("div",{className:zte.incentiveContainer,children:[(0,z.jsxs)("div",{className:zte.incentiveMain,children:[(0,z.jsx)("div",{className:zte.incentiveImage}),(0,z.jsx)("div",{className:zte.incentivePrompt,children:(0,z.jsx)(qc.Paradox.LOGIN_INCENTIVE,{})})]}),(0,z.jsxs)("div",{className:zte.incentiveFooter,children:[(0,z.jsx)(jh,{tooltip:e?null:(0,z.jsx)(qc.Paradox.NO_INTERNET_CONNECTION,{}),children:(0,z.jsx)(PO,{tinted:e,src:"Media/Menu/Paradox/ParadoxLogoNoText.svg",theme:h2,onSelect:Mb,disabled:!e,children:(0,z.jsx)(qc.Paradox.LOGIN_BUTTON,{})})}),(0,z.jsx)("div",{className:zte.incentiveLegal,children:(0,z.jsx)(Zte,{className:zte.legalRowCenter})})]})]})},qte=function(){var e=xl(Ob),t=xl(Eb),n=function(e){return(0,Y.useMemo)((function(){return null!==e&&e.length>=3&&e.indexOf("@")>=1?e[0]+"***@***"+e[e.length-1]:e}),[e])}(xl(Sb));return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsxs)("div",{className:zte.header,children:[(0,z.jsx)(tb,{src:"Media/Menu/Paradox/ParadoxLogoNoText.svg",className:zte.logo}),(0,z.jsx)("div",{className:zte.title,children:(0,z.jsx)(qc.Paradox.PARADOX_ACCOUNT,{})})]}),(0,z.jsxs)("div",{className:zte.content,children:[(0,z.jsx)("div",{className:zte.userName,children:n}),(0,z.jsxs)("div",{className:zte.buttonContainer,children:[(0,z.jsxs)("div",{className:zte.buttonRow,children:[e===Db.unlinked&&(0,z.jsx)(Xte,{accountLinkProvider:t,className:zte.button}),e===Db.linked&&(0,z.jsx)(Qp,{theme:h2,className:zte.button,onSelect:Pb,children:(0,z.jsx)(qc.Paradox.UNLINK_ACCOUNT_BUTTON,{})}),(0,z.jsx)(Qp,{theme:h2,className:zte.button,onSelect:Cb,children:(0,z.jsx)(qc.Paradox.LOGOUT_BUTTON,{})})]}),(0,z.jsx)(Zte,{})]})]})]})},Xte=function(e){var t=e.accountLinkProvider,n=e.className;return"PSN"!==t.toLowerCase()?(0,z.jsx)(PO,{src:"Media/Menu/Platforms/".concat(t,".svg"),theme:Kte,style:{backgroundColor:Jte(t)},className:n,onSelect:wb,children:(0,z.jsx)(qc.Paradox.ACCOUNT_LINK_PROMPT_SHORT,{hash:t})}):(0,z.jsx)(Qp,{theme:Kte,style:{backgroundColor:Jte(t)},className:n,onSelect:wb,children:(0,z.jsx)(qc.Paradox.ACCOUNT_LINK_PROMPT_SHORT,{hash:t})})},Qte=function(e){var t=e.label;return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsxs)("div",{className:zte.header,children:[(0,z.jsx)(tb,{src:"Media/Menu/Paradox/ParadoxLogoNoText.svg",className:zte.logo}),(0,z.jsx)("div",{className:zte.title,children:(0,z.jsx)(qc.Paradox.PARADOX_ACCOUNT,{})})]}),(0,z.jsx)("div",{className:zte.content,children:(0,z.jsx)("div",{className:zte.userName,children:t})})]})},Zte=function(e){var t=e.className;return(0,z.jsxs)("div",{className:_d()(zte.legalRow,t),children:[(0,z.jsx)(Qp,{className:zte.legalLink,onSelect:Wb,children:(0,z.jsx)(qc.Paradox.TERMS_OF_USE,{})}),(0,z.jsx)(Qp,{className:zte.legalLink,onSelect:zb,children:(0,z.jsx)(qc.Paradox.PRIVACY_POLICY,{})})]})};function Jte(e){switch(e){case"PSN":return"#003087";case"XboxLive":return"#107C10";default:return"#555"}}oe.add("game-ui/menu/components/paradox-panel/paradox-panel.tsx",{get ParadoxPanel(){return Yte},set ParadoxPanel(e){Yte=e}});let ene={logo:"logo_xOs child-opacity-transition_nkS",content:"content_LhM",column:"column_y44",panel:"panel_H2O child-opacity-transition_nkS","paradox-panel":"paradox-panel_t14 child-opacity-transition_nkS",paradoxPanel:"paradox-panel_t14 child-opacity-transition_nkS","notifications-panel":"notifications-panel_c5F child-opacity-transition_nkS",notificationsPanel:"notifications-panel_c5F child-opacity-transition_nkS","button-label-left":"button-label-left_YKT",buttonLabelLeft:"button-label-left_YKT","button-label-right":"button-label-right_ZdY",buttonLabelRight:"button-label-right_ZdY"};oe.add("game-ui/menu/components/main-menu-screen/main-menu-screen.module.scss",{get classes(){return ene},set classes(e){Object.assign(ene,e)}});const tne=ene;var nne=(0,z.jsx)(OO,{title:(0,z.jsx)(qc.Common.CONFIRMATION,{}),message:(0,z.jsx)(qc.Menu.APPLICATION_QUIT_MESSAGE,{}),onConfirm:function(){return Fh()}}),rne=function(e){return(0,z.jsx)("div",{className:tne.column,children:e.children})},ine=Y.forwardRef((function(e,t){var n=e.focusKey,r=e.className,i=(0,Y.useContext)(dO),o=xl(eG),a=xl(yG),s=xl(oG),l=xl(fG);return(0,z.jsx)(z.Fragment,{children:(0,z.jsxs)(s1,{ref:t,focusKey:n,className:r,children:[(0,z.jsx)("img",{src:"Media/Menu/GameLogo.svg",className:tne.logo}),(0,z.jsxs)(Ap,{children:[(0,z.jsxs)("div",{className:tne.content,children:[(0,z.jsx)("div",{className:tne.column}),(0,z.jsxs)(rne,{children:[(0,z.jsx)(PO,{tinted:!0,disabled:!o,src:"Media/Glyphs/ArrowRight.svg",theme:DO,onSelect:OG,children:(0,z.jsx)(qc.Menu.CONTINUE_GAME,{})}),(0,z.jsx)(PO,{tinted:!0,src:"Media/Glyphs/Plus.svg",theme:DO,onSelect:function(){return jG($U.NewGame)},children:(0,z.jsx)(qc.Menu.NEW_GAME,{})}),(0,z.jsx)(PO,{tinted:!0,disabled:0===a.length,src:"Media/Glyphs/Progress.svg",theme:DO,onSelect:function(){return jG($U.LoadGame)},children:(0,z.jsx)(qc.Menu.LOAD_GAME,{})}),!s&&(0,z.jsxs)(PO,{tinted:!0,src:"Media/Glyphs/Pen.svg",theme:DO,onSelect:CG,children:[(0,z.jsx)("div",{className:tne.buttonLabelLeft,children:(0,z.jsx)(qc.Menu.EDITOR,{})}),(0,z.jsx)("div",{className:tne.buttonLabelRight,children:(0,z.jsx)(p1,{})})]}),(0,z.jsx)(one,{fallbackToLogin:!0}),(0,z.jsx)(PO,{tinted:!0,src:"Media/Glyphs/Gear.svg",theme:DO,onSelect:function(){return jG($U.Options)},children:(0,z.jsx)(qc.Menu.OPTIONS,{})}),(0,z.jsx)(PO,{tinted:!0,src:"Media/Glyphs/Credits.svg",theme:DO,onSelect:function(){return jG($U.Credits)},children:(0,z.jsx)(qc.Menu.CREDITS,{})}),l&&(0,z.jsx)(PO,{tinted:!0,src:"Media/Glyphs/Close.svg",theme:DO,onSelect:function(){return i.showDialog(nne)},children:(0,z.jsx)(qc.Menu.EXIT_APPLICATION,{})})]}),(0,z.jsxs)("div",{className:tne.column,children:[(0,z.jsx)(Yte,{className:tne.paradoxPanel}),(0,z.jsx)(Rte,{className:tne.notificationsPanel})]}),(0,z.jsx)("div",{className:tne.column})]}),(0,z.jsx)(H5,{name:"Menu"})]})]})})}));var one=function(e){var t=e.fallbackToLogin,n=xl(jb),r=xl(Tb),i=xl(Ib),o=xl(iG),a=function(e,t,n){return e?t?n?null:(0,z.jsx)(qc.Paradox.NO_INTERNET_CONNECTION,{}):(0,z.jsx)(qc.Paradox.UGC_DISABLED,{}):(0,z.jsx)(qc.Paradox.SDK_DISABLED,{})}(i,o,r),s=xl(aG);return(0,z.jsx)(z.Fragment,{children:!s&&(0,z.jsx)(jh,{tooltip:a,children:(0,z.jsxs)(PO,{tinted:!0,src:"Media/Menu/Paradox/ParadoxLogoNoText.svg",theme:DO,disabled:!o||!r||!i||!t&&!n,onSelect:n?AG:Mb,children:[(0,z.jsx)("div",{className:tne.buttonLabelLeft,children:(0,z.jsx)(qc.Menu.PDX_MODS,{})}),(0,z.jsx)("div",{className:tne.buttonLabelRight,children:(0,z.jsx)(p1,{})})]})})})};function ane(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function sne(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}oe.add("game-ui/menu/components/main-menu-screen/main-menu-screen.tsx",{get MainMenuNavigation(){return rne},set MainMenuNavigation(e){rne=e},get MainMenuScreen(){return ine},set MainMenuScreen(e){ine=e},get ModsUIButton(){return one},set ModsUIButton(e){one=e}});var lne=function(e){return(0,z.jsxs)(Xb,sne(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){ane(e,t,n[t])}))}return e}({},e),{children:[(0,z.jsxs)("div",{className:$b.buttonRow,children:[(0,z.jsx)(Qp,{theme:rv,onSelect:Wb,children:(0,z.jsx)(qc.Paradox.TERMS_OF_USE,{})}),(0,z.jsx)(Qp,{theme:rv,onSelect:zb,children:(0,z.jsx)(qc.Paradox.PRIVACY_POLICY,{})})]}),(0,z.jsxs)("div",{className:$b.buttonRow,children:[(0,z.jsx)(Qp,{theme:tv,onSelect:Vb,children:(0,z.jsx)(qc.Paradox.LINK_ACCOUNT_BUTTON,{})}),(0,z.jsx)(Qp,{theme:rv,onSelect:Lb,children:(0,z.jsx)(qc.Paradox.SKIP_BUTTON,{})})]})]}))};function cne(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function une(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}oe.add("game-ui/menu/components/paradox/dialogs/account-link-dialog.tsx",{get AccountLinkDialog(){return lne},set AccountLinkDialog(e){lne=e}});var dne=function(e){return(0,z.jsx)(Xb,une(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){cne(e,t,n[t])}))}return e}({},e),{children:(0,z.jsxs)("div",{className:$b.buttonRow,children:[(0,z.jsx)(Qp,{theme:tv,onSelect:Hb,children:(0,z.jsx)(qc.Common.YES,{})}),(0,z.jsx)(Qp,{theme:rv,onSelect:Lb,children:(0,z.jsx)(qc.Common.NO,{})})]})}))};function fne(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function mne(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}oe.add("game-ui/menu/components/paradox/dialogs/account-link-overwrite-dialog.tsx",{get AccountLinkOverwriteDialog(){return dne},set AccountLinkOverwriteDialog(e){dne=e}});var gne=function(e){return(0,z.jsx)(Xb,mne(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){fne(e,t,n[t])}))}return e}({},e),{children:(0,z.jsx)("div",{className:$b.buttonRow,children:(0,z.jsx)(Qp,{theme:tv,onSelect:Lb,children:(0,z.jsx)(qc.Common.OK,{})})})}))};oe.add("game-ui/menu/components/paradox/dialogs/confirmation-dialog.tsx",{get ConfirmationDialog(){return gne},set ConfirmationDialog(e){gne=e}});var hne=function(e){var t=e.messageId,n=e.message;return(0,z.jsxs)(qb,{onClose:Lb,children:[null!=t&&(0,z.jsx)("p",{children:(0,z.jsx)(kc,{id:t})}),null!=n&&(0,z.jsx)("p",{children:n}),null==t&&null==n&&(0,z.jsx)("p",{children:(0,z.jsx)(qc.Paradox.UNKNOWN_ERROR,{})}),(0,z.jsx)("div",{className:$b.buttonRow,children:(0,z.jsx)(Qp,{theme:tv,onSelect:Lb,children:(0,z.jsx)(qc.Common.CLOSE,{})})})]})};oe.add("game-ui/menu/components/paradox/dialogs/error-dialog.tsx",{get ErrorDialog(){return hne},set ErrorDialog(e){hne=e}});var pne=function(e){var t=e.controller,n=e.children,r=$O(),i=(0,Y.useRef)(0),o=(0,Y.useMemo)((function(){return{"Scroll Vertical":function(e){i.current=300*-e}}}),[]);return(0,Y.useEffect)((function(){var e=performance.now(),n=0,o=function(a){if(0!==i.current){var s=(a-e)/1e3;t.scrollBy(0,i.current*s*r)}e=a,n=window.requestAnimationFrame(o)};return n=window.requestAnimationFrame(o),function(){return window.cancelAnimationFrame(n)}}),[t,r]),(0,z.jsx)(rp,{actions:o,children:n})};oe.add("game-ui/common/scrolling/scroll-action-consumer/scroll-action-consumer.tsx",{get ScrollActionConsumer(){return pne},set ScrollActionConsumer(e){pne=e}});var vne,bne=function(e){var t=e.text,n=e.agreementRequired,r=XQ(),i=DS();return(0,Y.useEffect)((function(){return r.scrollTo(0,0)}),[r,t]),(0,z.jsx)(qb,{wide:!0,onClose:n?void 0:Lb,children:(0,z.jsxs)(pne,{controller:r,children:[(0,z.jsx)(gE,{controller:r,className:$b.documentScrollable,trackVisibility:"always",children:(0,z.jsx)("div",{className:$b.documentText,children:(0,z.jsx)(GL,{children:(0,z.jsx)(Fv,{text:t,renderer:i,onLinkSelect:Gb})})})}),(0,z.jsx)("div",{className:$b.buttonRow,children:(0,z.jsx)(Qp,{theme:tv,onSelect:n?Kb:Lb,children:(0,z.jsx)(qc.Common.OK,{})})})]})})};function yne(e){return/^[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/i.test(e)}function xne(e){return e.replace(/[<>:;,?"*|/\\]/g,"")}function _ne(e){return!Zs(e)&&/^[^<>:;,?"*|/\\]+$/g.test(e)}function jne(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function One(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return jne(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return jne(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/menu/components/paradox/dialogs/legal-document-dialog.tsx",{get LegalDocumentDialog(){return bne},set LegalDocumentDialog(e){bne=e}}),oe.add("game-ui/common/utils/validation.ts",{get validateEmailAddress(){return yne},set validateEmailAddress(e){yne=e},get sanitizeFileName(){return xne},set sanitizeFileName(e){xne=e},get validateFileName(){return _ne},set validateFileName(e){_ne=e}}),function(e){e[e.None=0]="None",e[e.ForgotPassword=1]="ForgotPassword",e[e.Login=2]="Login"}(vne||(vne={}));var Ene=function(){var e=One((0,Y.useState)(""),2),t=e[0],n=e[1],r=!yne(t),i=One((0,Y.useState)(""),2),o=i[0],a=i[1],s=0===o.length,l=One((0,Y.useState)(vne.None),2),c=l[0],u=l[1],d=(0,Y.useCallback)((function(){r||s?u(vne.Login):(u(vne.None),Rb({email:t,password:o}))}),[t,r,o,s]),f=(0,Y.useCallback)((function(){r?u(vne.ForgotPassword):(u(vne.None),kb(t))}),[t,r]);return(0,z.jsx)(qb,{onClose:Lb,children:(0,z.jsx)("div",{className:$b.formContainer,children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)("div",{className:$b.iconRow,children:(0,z.jsx)("img",{src:"Media/Menu/Paradox/ParadoxLogoNoText.svg",className:$b.icon})}),(0,z.jsx)("div",{className:$b.title,children:(0,z.jsx)(qc.Paradox.LOGIN_FORM_TITLE,{})}),(0,z.jsx)("div",{className:_d()($b.formRow,$b.lightField),children:(0,z.jsx)(Qb,{type:"email",value:t,placeholder:(0,z.jsx)(qc.Paradox.EMAIL_FIELD_LABEL,{}),invalid:c!==vne.None&&r,onChange:n})}),(0,z.jsxs)("div",{className:_d()($b.formRow,$b.flexRow,$b.lightField),children:[(0,z.jsx)("div",{style:{flex:1},children:(0,z.jsx)(Qb,{type:"password",placeholder:(0,z.jsx)(qc.Paradox.PASSWORD_FIELD_LABEL,{}),value:o,invalid:c===vne.Login&&s,onChange:a})}),(0,z.jsx)(Qp,{onSelect:f,className:$b.forgotPasswordLink,children:(0,z.jsx)(qc.Paradox.FORGOT_PASSWORD_LINK,{})})]}),(0,z.jsx)(Yv,{className:$b.buttonRow,style:{justifyContent:"flex-end"},children:(0,z.jsx)(Qp,{theme:tv,onSelect:d,children:(0,z.jsx)(qc.Paradox.LOGIN_BUTTON,{})})}),(0,z.jsx)("div",{className:$b.divider}),(0,z.jsxs)("div",{className:$b.buttonRow,children:[(0,z.jsx)("div",{className:$b.hint,children:(0,z.jsx)(qc.Paradox.REGISTRATION_HINT,{})}),(0,z.jsx)(Qp,{theme:rv,onSelect:Ub,children:(0,z.jsx)(qc.Paradox.REGISTRATION_FROM_LOGIN_LINK,{})})]})]})})})};function Sne(e,t){return new Date(t,e,0).getDate()}function Tne(e,t,n){return"".concat(Vu(e,4),"-").concat(Vu(t,2),"-").concat(Vu(n,2))}oe.add("game-ui/menu/components/paradox/dialogs/login-dialog.tsx",{get LoginDialog(){return Ene},set LoginDialog(e){Ene=e}}),oe.add("game-ui/common/utils/date.ts",{get getDaysInMonth(){return Sne},set getDaysInMonth(e){Sne=e},get formatIso8601Date(){return Tne},set formatIso8601Date(e){Tne=e}});let Ine={"dropdown-toggle":"dropdown-toggle_th2 dropdown-toggle_prl",dropdownToggle:"dropdown-toggle_th2 dropdown-toggle_prl",invalid:"invalid_rQd",indicator:"indicator_Iwz","dropdown-menu":"dropdown-menu_uEW dropdown-menu_Swd",dropdownMenu:"dropdown-menu_uEW dropdown-menu_Swd",scrollable:"scrollable_NAI undefined","dropdown-item":"dropdown-item_IIB undefined",dropdownItem:"dropdown-item_IIB undefined"};oe.add("game-ui/menu/components/paradox/dialogs/paradox-dropdown.module.scss",{get classes(){return Ine},set classes(e){Object.assign(Ine,e)}});const wne=Ine;function Pne(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Cne(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||Ane(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Nne(e){return function(e){if(Array.isArray(e))return Pne(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||Ane(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Ane(e,t){if(e){if("string"==typeof e)return Pne(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Pne(e,t):void 0}}var Lne=function(){var e=Cne((0,Y.useState)(""),2),t=e[0],n=e[1],r=!yne(t),i=Cne((0,Y.useState)(""),2),o=i[0],a=i[1],s=0===o.length,l=xl(Fb),c=Cne((0,Y.useState)(null),2),u=c[0],d=c[1],f=Cne((0,Y.useState)(null),2),m=f[0],g=f[1],h=Cne((0,Y.useState)(null),2),p=h[0],v=h[1],b=Cne((0,Y.useState)(null),2),y=b[0],x=b[1],_=null!=p&&null!=m?Sne(p,m):31,j=Math.min((new Date).getFullYear(),2020);(0,Y.useEffect)((function(){null!=y&&y>_&&x(null)}),[y,_]);var O=Cne((0,Y.useState)(!1),2),E=O[0],S=O[1],T=Cne((0,Y.useState)(!1),2),I=T[0],w=T[1],P=(0,Y.useCallback)((function(){if(r||s||null==u||null==m||null==p||null==y)w(!0);else{w(!1);var e=Tne(null!=m?m:0,p,y);Bb({email:t,password:o,country:u,dateOfBirth:e,marketingPermission:E})}}),[r,s,m,p,y,t,o,u,E]);return(0,z.jsx)(qb,{onClose:Lb,children:(0,z.jsx)("div",{className:$b.formContainer,children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)("div",{className:$b.iconRow,children:(0,z.jsx)("img",{src:"Media/Menu/Paradox/ParadoxLogoNoText.svg",className:$b.icon})}),(0,z.jsx)("div",{className:$b.title,children:(0,z.jsx)(qc.Paradox.REGISTRATION_FORM_TITLE,{})}),(0,z.jsx)("div",{className:_d()($b.formRow,$b.darkField),children:(0,z.jsx)(Qb,{value:t,placeholder:(0,z.jsx)(qc.Paradox.EMAIL_FIELD_LABEL,{}),onChange:n,vkTitle:(0,z.jsx)(qc.VirtualKeyboard.TITLE,{hash:"ParadoxAccountEmail"}),invalid:I&&r})}),(0,z.jsx)("div",{className:_d()($b.formRow,$b.darkField),children:(0,z.jsx)(Qb,{type:"password",value:o,placeholder:(0,z.jsx)(qc.Paradox.PASSWORD_FIELD_LABEL,{}),onChange:a,vkTitle:(0,z.jsx)(qc.VirtualKeyboard.TITLE,{hash:"ParadoxAccountPassword"}),invalid:I&&s})}),(0,z.jsx)("div",{className:_d()($b.formRow,$b.darkField),children:(0,z.jsx)(SE,{theme:wne,content:l.map((function(e,t){return(0,z.jsx)(RE,{focusKey:e,value:e,onChange:d,children:(0,z.jsx)(qc.ISO.COUNTRY,{hash:e})},t)})),children:(0,z.jsx)(CE,{className:_d()(I&&null==u&&wne.invalid),children:null==u?(0,z.jsx)(qc.Paradox.COUNTRY_FIELD_LABEL,{}):(0,z.jsx)(qc.ISO.COUNTRY,{hash:u})})})}),(0,z.jsxs)("div",{className:$b.formRow,children:[(0,z.jsx)("div",{className:$b.formRowLabel,children:(0,z.jsx)(qc.Paradox.BIRTH_DATE_FIELD_LABEL,{})}),(0,z.jsx)(Yv,{className:$b.flexRow,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)("div",{className:_d()($b.yearField,$b.darkField),children:(0,z.jsx)(SE,{initialFocused:m,theme:wne,content:Nne(Array(j-1901).keys()).map((function(e,t){return(0,z.jsx)(RE,{focusKey:j-e,value:j-e,onChange:g,children:Bu(j-e)},t)})),children:(0,z.jsx)(CE,{className:_d()(I&&null==m&&wne.invalid),children:null==m?(0,z.jsx)(qc.Paradox.BIRTH_DATE_YEAR_FIELD_LABEL,{}):Bu(m)})})}),(0,z.jsx)("div",{className:_d()($b.monthField,$b.darkField),children:(0,z.jsx)(SE,{initialFocused:p,theme:wne,content:Nne(Array(12).keys()).map((function(e,t){return(0,z.jsx)(RE,{focusKey:e+1,value:e+1,onChange:v,children:(0,z.jsx)(qc.Common.MONTH,{index:e})},t)})),children:(0,z.jsx)(CE,{className:_d()(I&&null==p&&wne.invalid),children:null==p?(0,z.jsx)(qc.Paradox.BIRTH_DATE_MONTH_FIELD_LABEL,{}):(0,z.jsx)(qc.Common.MONTH,{index:p-1})})})}),(0,z.jsx)("div",{className:_d()($b.dayField,$b.darkField),children:(0,z.jsx)(SE,{initialFocused:y,theme:wne,content:Nne(Array(_).keys()).map((function(e,t){return(0,z.jsx)(RE,{focusKey:e+1,value:e+1,onChange:x,children:Bu(e+1)},t)})),children:(0,z.jsx)(CE,{className:_d()(I&&null==y&&wne.invalid),children:null==y?(0,z.jsx)(qc.Paradox.BIRTH_DATE_DAY_FIELD_LABEL,{}):Bu(y)})})})]})})]}),(0,z.jsx)("div",{children:(0,z.jsx)(Zb,{value:E,label:(0,z.jsx)(qc.Paradox.MARKETING_PERMISSION_TOGGLE_LABEL,{}),onChange:S})}),(0,z.jsxs)(Yv,{activation:yd.AnyChildren,children:[(0,z.jsx)(Fv,{}),(0,z.jsx)(Iv,{text:(0,z.jsx)(qc.Paradox.TERMS_PRIVACY_NOTICE,{}),className:$b.terms,onLinkSelect:Gb})]}),(0,z.jsx)("div",{className:$b.buttonRow,children:(0,z.jsx)(Qp,{theme:tv,onSelect:P,children:(0,z.jsx)(qc.Paradox.SUBMIT_REGISTRATION_BUTTON,{})})}),(0,z.jsx)("div",{className:$b.divider}),(0,z.jsx)("div",{className:$b.buttonRow,children:(0,z.jsx)(Qp,{theme:rv,onSelect:Mb,children:(0,z.jsx)(qc.Paradox.LOGIN_FROM_REGISTRATION_LINK,{})})})]})})})};oe.add("game-ui/menu/components/paradox/dialogs/registration-dialog.tsx",{get RegistrationDialog(){return Lne},set RegistrationDialog(e){Lne=e}});let Mne={"loading-overlay":"loading-overlay_ica",loadingOverlay:"loading-overlay_ica",disabled:"disabled_AdS"};oe.add("game-ui/menu/components/paradox/paradox-dialog-renderer.module.scss",{get classes(){return Mne},set classes(e){Object.assign(Mne,e)}});const kne=Mne;function Rne(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var Dne,Fne=new Wh("CHILDREN"),Une=(Rne(Dne={},Nb.Login,Ene),Rne(Dne,Nb.Registration,Lne),Rne(Dne,Nb.AccountLink,lne),Rne(Dne,Nb.AccountLinkOverwrite,dne),Rne(Dne,Nb.LegalDocument,bne),Rne(Dne,Nb.Confirmation,gne),Rne(Dne,Nb.Error,hne),Dne),Gne=function(e){var t,n=e.children,r=xl(_b),i=xl(Ab).map((function(e){return bD(Une,e,void 0)})).filter((function(e){return null!=e}));return t=r?null:i.length>0?i.length-1:Fne,(0,z.jsxs)(pj,{focused:t,children:[(0,z.jsx)(hj,{focusKey:Fne,children:n}),i.map((function(e,t){return(0,z.jsx)(hj,{focusKey:t,children:(0,z.jsx)(ij,{children:e})},t)})),r&&(0,z.jsx)(Bne,{})]})},Bne=function(){return(0,z.jsx)("div",{className:kne.loadingOverlay,children:(0,z.jsx)(qc.Paradox.LOADING,{})})};oe.add("game-ui/menu/components/paradox/paradox-dialog-renderer.tsx",{get ParadoxDialogRenderer(){return Gne},set ParadoxDialogRenderer(e){Gne=e}});let Vne={logo:"logo_C34 child-opacity-transition_nkS",content:"content_reP",column:"column_cmR",panel:"panel_X0A child-opacity-transition_nkS",last:"last_ljC","paradox-panel":"paradox-panel_CK7 child-opacity-transition_nkS",paradoxPanel:"paradox-panel_CK7 child-opacity-transition_nkS","notifications-panel":"notifications-panel_AGm child-opacity-transition_nkS",notificationsPanel:"notifications-panel_AGm child-opacity-transition_nkS"};oe.add("game-ui/menu/components/game-pause-screen/game-pause-screen.module.scss",{get classes(){return Vne},set classes(e){Object.assign(Vne,e)}});const Hne=Vne;var Kne=Y.forwardRef((function(e,t){var n=e.focusKey,r=e.className,i=e.onClose,o=xl(yG),a=xl(C_),s=(0,Y.useMemo)((function(){return{Back:i,"Pause Menu":i}}),[i]),l=t1();return(0,z.jsx)(s1,{ref:t,focusKey:n,className:r,children:(0,z.jsx)(Gne,{children:(0,z.jsx)(mb,{children:(0,z.jsxs)(rp,{actions:s,children:[(0,z.jsx)("img",{src:"Media/Menu/GameLogo.svg",className:Hne.logo}),(0,z.jsx)(Ap,{children:(0,z.jsxs)("div",{className:Hne.content,children:[(0,z.jsx)("div",{className:Hne.column}),(0,z.jsxs)("div",{className:Hne.column,children:[(0,z.jsx)(PO,{tinted:!0,src:"Media/Glyphs/ArrowRight.svg",theme:DO,onSelect:i,children:(0,z.jsx)(qc.Menu.RESUME_GAME,{})}),(0,z.jsx)(PO,{tinted:!0,src:"Media/Glyphs/Save.svg",theme:DO,onSelect:function(){return P_(S_.saveGame)},children:(0,z.jsx)(qc.Menu.SAVE_GAME,{})}),(0,z.jsx)(PO,{tinted:!0,src:"Media/Glyphs/Plus.svg",theme:DO,onSelect:function(){return P_(S_.newGame)},children:(0,z.jsx)(qc.Menu.NEW_GAME,{})}),(0,z.jsx)(PO,{tinted:!0,disabled:0===o.length,src:"Media/Glyphs/Progress.svg",theme:DO,onSelect:function(){return P_(S_.loadGame)},children:(0,z.jsx)(qc.Menu.LOAD_GAME,{})}),(0,z.jsx)(one,{fallbackToLogin:!1}),(0,z.jsx)(PO,{tinted:!0,src:"Media/Glyphs/Gear.svg",theme:DO,onSelect:function(){return P_(S_.options)},children:(0,z.jsx)(qc.Menu.OPTIONS,{})}),(0,z.jsx)(PO,{tinted:!0,src:"Media/Glyphs/Close.svg",theme:DO,onSelect:l,disabled:!a,children:(0,z.jsx)(qc.Menu.EXIT_GAME,{})})]}),(0,z.jsxs)("div",{className:Hne.column,children:[(0,z.jsx)(Yte,{className:Hne.paradoxPanel}),(0,z.jsx)(Rte,{className:Hne.notificationsPanel})]}),(0,z.jsx)("div",{className:Hne.column})]})})]})})})})}));oe.add("game-ui/menu/components/game-pause-screen/game-pause-screen.tsx",{get GamePauseScreen(){return Kne},set GamePauseScreen(e){Kne=e}});let Wne={base:"base_USz",enter:"enter_HYB","exit-active":"exit-active_hp7",exitActive:"exit-active_hp7","enter-active":"enter-active_fw8",enterActive:"enter-active_fw8",exit:"exit_N8B"};oe.add("game-ui/menu/transitions/expand-fade.module.scss",{get classes(){return Wne},set classes(e){Object.assign(Wne,e)}});const zne=Wne;let Yne={base:"base_mxi",enter:"enter_H6J","exit-active":"exit-active_jeC",exitActive:"exit-active_jeC","enter-active":"enter-active_YSl",enterActive:"enter-active_YSl",exit:"exit_OM8","achievements-warning-row":"achievements-warning-row_p2C",achievementsWarningRow:"achievements-warning-row_p2C","achievements-warning":"achievements-warning_Gp9",achievementsWarning:"achievements-warning_Gp9",space:"space_qhY"};oe.add("game-ui/menu/components/shared/game-options/achievements-warning.module.scss",{get classes(){return Yne},set classes(e){Object.assign(Yne,e)}});const $ne=Yne;var qne=function(e){var t=e.modsEnabled,n=void 0!==t&&t,r=e.unlockAll,i=void 0!==r&&r,o=e.unlimitedMoney,a=void 0!==o&&o;return(0,z.jsx)(cS,{in:n||i||a,children:(0,z.jsx)(aS,{styles:$ne,children:(0,z.jsxs)("div",{className:$ne.achievementsWarningRow,children:[(0,z.jsx)(Xne,{modsEnabled:n,unlimitedMoney:a,unlockAll:i,autoHide:!1}),(0,z.jsx)("div",{className:$ne.space})]})})})},Xne=function(e){var t=e.modsEnabled,n=e.unlockAll,r=e.unlimitedMoney,i=e.className,o=e.autoHide,a=void 0===o||o,s=e.loadGame,l=void 0!==s&&s;return!a||t||n||r?(0,z.jsx)("div",{className:_d()($ne.achievementsWarning,i),children:t?(0,z.jsx)(qc.Menu.ACHIEVEMENTS_WARNING_MODS,{}):l?(0,z.jsx)(qc.Menu.ACHIEVEMENTS_WARNING_PAST_OPTIONS,{}):(0,z.jsx)(qc.Menu.ACHIEVEMENTS_WARNING_GAME_OPTIONS,{})}):null};oe.add("game-ui/menu/components/shared/game-options/achievements-warning.tsx",{get AchievementsWarning(){return qne},set AchievementsWarning(e){qne=e},get AchievementsWarningBanner(){return Xne},set AchievementsWarningBanner(e){Xne=e}});let Qne={"ellipsis-text-input":"ellipsis-text-input_h9o",ellipsisTextInput:"ellipsis-text-input_h9o",input:"input_MMV",label:"label_qsp"};oe.add("game-ui/common/input/text/ellipsis-text-input/ellipsis-text-input.module.scss",{get classes(){return Qne},set classes(e){Object.assign(Qne,e)}});const Zne=Qne;function Jne(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function ere(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Jne(e,t,n[t])}))}return e}function tre(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var nre=Y.forwardRef((function(e,t){var n=e.value,r=e.maxLength,i=void 0===r?64:r,o=e.theme,a=void 0===o?v5:o,s=e.className,l=tre(e,["value","maxLength","theme","className"]),c=y5(a);return(0,z.jsxs)(zv,{className:_d()(Zne.ellipsisTextInput,c.container,s),children:[(0,z.jsx)(yb,ere({ref:t,value:n,maxLength:i,className:_d()(Zne.input,c.input)},l)),(0,z.jsx)("div",{className:_d()(Zne.label,c.label),children:n||" "})]})}));oe.add("game-ui/common/input/text/ellipsis-text-input/ellipsis-text-input.tsx",{get EllipsisTextInput(){return nre},set EllipsisTextInput(e){nre=e}});var rre=function(e,t){return e<t?-1:e>t?1:0},ire=function(e,t){var n=e.localeCompare(t);return n?n/Math.abs(n):0},ore=/(^0x[\da-fA-F]+$|^([+-]?(?:\d+(?:\.\d*)?|\.\d+)(?:[eE][+-]?\d+)?(?!\.\d+)(?=\D|\s|$))|\d+)/g,are=/^\s+|\s+$/g,sre=/\s+/g,lre=/^[+-]?(?:\d+(?:\.\d*)?|\.\d+)(?:[eE][+-]?\d+)?$/,cre=/(^([\w ]+,?[\w ]+)?[\w ]+,?[\w ]+\d+:\d+(:\d+)?[\w ]?|^\d{1,4}[/-]\d{1,4}[/-]\d{1,4}|^\w+, \w+ \d+, \d{4})/,ure=/^0+[1-9]{1}[0-9]*$/,dre=/[^\x00-\x80]/,fre=function(e,t){return e<t?-1:e>t?1:0},mre=function(e,t){return e.value===t.value?0:void 0!==e.parsedNumber&&void 0!==t.parsedNumber?rre(e.parsedNumber,t.parsedNumber):e.chunks&&t.chunks?function(e,t){for(var n=e.length,r=t.length,i=Math.min(n,r),o=0;o<i;o++){var a=e[o],s=t[o];if(a.normalizedString!==s.normalizedString){if(""===a.normalizedString!=(""===s.normalizedString))return""===a.normalizedString?-1:1;if(void 0!==a.parsedNumber&&void 0!==s.parsedNumber){var l=rre(a.parsedNumber,s.parsedNumber);return 0===l?fre(a.normalizedString,s.normalizedString):l}return void 0!==a.parsedNumber||void 0!==s.parsedNumber?void 0!==a.parsedNumber?-1:1:dre.test(a.normalizedString+s.normalizedString)?ire(a.normalizedString,s.normalizedString):fre(a.normalizedString,s.normalizedString)}}return n>i||r>i?n<=i?-1:1:0}(e.chunks,t.chunks):function(e,t){return(e.chunks?!t.chunks:t.chunks)?e.chunks?-1:1:(e.isNaN?!t.isNaN:t.isNaN)?e.isNaN?-1:1:(e.isSymbol?!t.isSymbol:t.isSymbol)?e.isSymbol?-1:1:(e.isObject?!t.isObject:t.isObject)?e.isObject?-1:1:(e.isArray?!t.isArray:t.isArray)?e.isArray?-1:1:(e.isFunction?!t.isFunction:t.isFunction)?e.isFunction?-1:1:(e.isNull?!t.isNull:t.isNull)?e.isNull?-1:1:0}(e,t)},gre=function(e){return e.replace(sre," ").replace(are,"")},hre=function(e){if(0!==e.length){var t=Number(e);if(!Number.isNaN(t))return t}},pre=function(e,t,n){if(lre.test(e)&&(!ure.test(e)||0===t||"."!==n[t-1]))return hre(e)||0},vre=function(e,t,n){return{parsedNumber:pre(e,t,n),normalizedString:gre(e)}},bre=function(e){var t=function(e){return e.replace(ore,"\0$1\0").replace(/\0$/,"").replace(/^\0/,"").split("\0")}(e).map(vre);return t},yre=function(e){return"function"==typeof e},xre=function(e){return Number.isNaN(e)||e instanceof Number&&Number.isNaN(e.valueOf())},_re=function(e){return null===e},jre=function(e){return!(null===e||"object"!=typeof e||Array.isArray(e)||e instanceof Number||e instanceof String||e instanceof Boolean||e instanceof Date)},Ore=function(e){return"symbol"==typeof e},Ere=function(e){return void 0===e},Sre=function(e){var t=hre(e);return void 0!==t?t:function(e){if(cre.test(e)){var t=Date.parse(e);if(!Number.isNaN(t))return t}}(e)},Tre=function(e){if("string"==typeof e||e instanceof String||("number"==typeof e||e instanceof Number)&&!xre(e)||"boolean"==typeof e||e instanceof Boolean||e instanceof Date){var t=function(e){return"boolean"==typeof e||e instanceof Boolean?Number(e).toString():"number"==typeof e||e instanceof Number?e.toString():e instanceof Date?e.getTime().toString():"string"==typeof e||e instanceof String?e.toLowerCase().replace(are,""):""}(e),n=Sre(t);return{parsedNumber:n,chunks:bre(n?""+n:t),value:e}}return{isArray:Array.isArray(e),isFunction:yre(e),isNaN:xre(e),isNull:_re(e),isObject:jre(e),isSymbol:Ore(e),isUndefined:Ere(e),value:e}},Ire=function(e){return function(t,n){var r=Tre(t),i=Tre(n);return mre(r,i)*("desc"===e.order?-1:1)}},wre=function(e){return"string"==typeof e&&("asc"===e||"desc"===e)},Pre=function(e){var t="asc";return"string"==typeof e&&wre(e)?t=e:e&&"object"==typeof e&&e.order&&wre(e.order)&&(t=e.order),{order:t}};function Cre(e){var t=Pre(e);return Ire(t)}let Nre={"theme-icon":"theme-icon_YTM",themeIcon:"theme-icon_YTM",icon:"icon_QMC"};oe.add("game-ui/common/image/theme-icon.module.scss",{get classes(){return Nre},set classes(e){Object.assign(Nre,e)}});const Are=Nre;var Lre=function(e){var t=e.src,n=e.className;return(0,z.jsx)("div",{className:_d()(Are.themeIcon,n),children:(0,z.jsx)("img",{src:t,className:Are.icon})})};oe.add("game-ui/common/image/theme-icon.tsx",{get ThemeIcon(){return Lre},set ThemeIcon(e){Lre=e}});let Mre={field:"field_zMw",header:"header__eC",icon:"icon_Aag",label:"label_aUL",content:"content_KQe"};oe.add("game-ui/common/property-field/themes/resource-field.module.scss",{get classes(){return Mre},set classes(e){Object.assign(Mre,e)}});const kre=Mre;var Rre=Y.createContext(kre),Dre=function(e){var t=e.icon,n=e.tinted,r=e.label,i=e.theme,o=e.focusable,a=void 0!==o&&o,s=e.className,l=e.children,c=(0,Y.useContext)(Rre),u=null!=i?i:c;return(0,z.jsx)(Qd,{children:(0,z.jsxs)(Yv,{focusKey:a?Kh:Hh,className:_d()(u.field,s),children:[(t||r)&&(0,z.jsxs)("div",{className:u.header,children:[t&&(n?(0,z.jsx)(tb,{src:t,className:u.icon}):(0,z.jsx)("img",{src:t,className:u.icon})),r&&(0,z.jsx)("div",{className:u.label,children:r})]}),(0,z.jsx)("div",{className:u.content,children:l})]})})};oe.add("game-ui/common/property-field/property-field.tsx",{get PropertyFieldThemeContext(){return Rre},set PropertyFieldThemeContext(e){Rre=e},get PropertyField(){return Dre},set PropertyField(e){Dre=e}});let Fre={"detail-section":"detail-section_aIw child-opacity-transition_nkS",detailSection:"detail-section_aIw child-opacity-transition_nkS",title:"title_eSB",image:"image_xzf",scrollable:"scrollable_zgX","scrollable-content":"scrollable-content_lJB",scrollableContent:"scrollable-content_lJB",description:"description_dxc",field:"field_rvA",label:"label_Sfx",value:"value_TJa","theme-icon":"theme-icon_mTh",themeIcon:"theme-icon_mTh","humidity-icon":"humidity-icon_jtJ",humidityIcon:"humidity-icon_jtJ","scrollable-footer":"scrollable-footer_VMh",scrollableFooter:"scrollable-footer_VMh",footer:"footer_uQp","footer-button":"footer-button_d4A",footerButton:"footer-button_d4A","achievement-warning-banner":"achievement-warning-banner_lKw",achievementWarningBanner:"achievement-warning-banner_lKw","achievement-warning-banner-container":"achievement-warning-banner-container_e0d",achievementWarningBannerContainer:"achievement-warning-banner-container_e0d"};oe.add("game-ui/menu/components/shared/detail-section/detail-section.module.scss",{get classes(){return Fre},set classes(e){Object.assign(Fre,e)}});const Ure=Fre;var Gre=function(e){var t=e.title,n=e.preview,r=e.content,i=e.footer,o=e.className,a=Y.Children.count(t)>0,s=Y.Children.count(r)>0,l=Y.Children.count(i)>0;return(0,z.jsxs)("div",{className:_d()(Ure.detailSection,o),children:[a&&(0,z.jsx)("div",{className:Ure.title,children:t}),null!=n&&(0,z.jsx)(mM,{src:n,className:Ure.image}),(0,z.jsx)(gE,{autoScroll:!0,className:Ure.scrollable,children:s&&(0,z.jsxs)("div",{className:Ure.scrollableContent,children:[r,!l&&(0,z.jsx)("div",{className:Ure.scrollableFooter})]})}),l&&(0,z.jsx)("div",{className:Ure.footer,children:i})]})},Bre=function(e){var t=e.label,n=e.children;return(0,z.jsxs)("div",{className:Ure.field,children:[(0,z.jsx)("div",{className:Ure.label,children:t}),(0,z.jsx)("div",{className:Ure.value,children:n})]})},Vre=function(e){var t=e.disabled,n=e.children,r=e.className,i=e.onSelect;return(0,z.jsx)(Qp,{focusKey:Hh,theme:kO,className:_d()(Ure.footerButton,r),disabled:t,onSelect:i,children:n})};oe.add("game-ui/menu/components/shared/detail-section/detail-section.tsx",{get DetailSection(){return Gre},set DetailSection(e){Gre=e},get Field(){return Bre},set Field(e){Bre=e},get FooterButton(){return Vre},set FooterButton(e){Vre=e}});let Hre={field:"field_xlu",header:"header_iiq",icon:"icon_lom",label:"label_BcU",content:"content_q4e"};oe.add("game-ui/menu/components/new-game-screen/map-detail/resource-list-item.module.scss",{get classes(){return Hre},set classes(e){Object.assign(Hre,e)}});const Kre=Hre;function Wre(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function zre(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Wre(e,t,n[t])}))}return e}function Yre(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var $re=function(e){var t=e.selectedMap,n=e.selectedTheme,r=e.activeStep,i=e.className,o=e.onContinue,a=e.onStartGameSelect,s=Pg(),l=xl(C_);return(0,z.jsx)(Gre,{className:i,title:null!=t?(0,z.jsx)(qc.Maps.MAP_TITLE,{hash:t.displayName,fallback:t.displayName}):void 0,preview:null==t?void 0:t.preview,content:null!=t?(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)("div",{className:Ure.description,children:(0,z.jsx)(qc.Maps.MAP_DESCRIPTION,{hash:t.displayName,fallback:""})}),null!=n&&(0,z.jsxs)(Bre,{label:(0,z.jsx)(qc.GameListScreen.THEME_LABEL,{}),children:[(0,z.jsx)(Lre,{src:n.icon,className:Ure.themeIcon}),(0,z.jsx)(qc.Assets.THEME,{hash:n.id})]}),(0,z.jsxs)(Bre,{label:(0,z.jsx)(qc.GameListScreen.CLIMATE_LABEL,{}),children:[(0,z.jsx)("img",{src:qre(t.cloudiness,t.precipitation),className:Ure.humidityIcon}),(0,z.jsx)(Ou,Yre(zre({},t.temperatureRange),{unit:$c.Temperature}))]}),(0,z.jsx)(Bre,{label:(0,z.jsx)(qc.GameListScreen.LATITUDE_LABEL,{}),children:Xre(t.latitude)}),(0,z.jsx)(Bre,{label:(0,z.jsx)(qc.GameListScreen.BUILDABLE_AREA_LABEL,{}),children:(0,z.jsx)(su,{value:Math.round(t.area>0?t.buildableLand/t.area*100:0),unit:$c.Percentage})}),(0,z.jsxs)(Bre,{label:(0,z.jsx)(qc.GameListScreen.CONNECTIONS_LABEL,{}),children:[t.connections.road&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Maps.OUTSIDE_CONNECTIONS,{hash:"Road"}),children:(0,z.jsx)(Dre,{icon:"Media/Game/Icons/Roads.svg",theme:Kre})}),t.connections.train&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Maps.OUTSIDE_CONNECTIONS,{hash:"Train"}),children:(0,z.jsx)(Dre,{icon:"Media/Game/Icons/Train.svg",theme:Kre})}),t.connections.ship&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Maps.OUTSIDE_CONNECTIONS,{hash:"Ship"}),children:(0,z.jsx)(Dre,{icon:"Media/Game/Icons/Ship.svg",theme:Kre})}),t.connections.air&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Maps.OUTSIDE_CONNECTIONS,{hash:"Air"}),children:(0,z.jsx)(Dre,{icon:"Media/Game/Icons/Airplane.svg",theme:Kre})}),t.connections.electricity&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Maps.OUTSIDE_CONNECTIONS,{hash:"Electricity"}),children:(0,z.jsx)(Dre,{icon:"Media/Game/Icons/Electricity.svg",theme:Kre})}),t.connections.water&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Maps.OUTSIDE_CONNECTIONS,{hash:"Water"}),children:(0,z.jsx)(Dre,{icon:"Media/Game/Icons/Water.svg",theme:Kre})})]}),(0,z.jsxs)(Bre,{label:(0,z.jsx)(qc.GameListScreen.RESOURCES_LABEL,{}),children:[t.resources.fertile>=.1&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Maps.RESOURCE,{hash:"Fertility"}),children:(0,z.jsx)(Dre,{icon:"Media/Game/Icons/Fertility.svg",theme:Kre,children:(0,z.jsx)(su,{value:t.resources.fertile,unit:$c.Area})})}),t.resources.forest>=.1&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Maps.RESOURCE,{hash:"Forest"}),children:(0,z.jsx)(Dre,{icon:"Media/Game/Icons/Forest.svg",theme:Kre,children:(0,z.jsx)(su,{value:t.resources.forest,unit:$c.Weight})})}),t.resources.ore>=.1&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Maps.RESOURCE,{hash:"Ore"}),children:(0,z.jsx)(Dre,{icon:"Media/Game/Icons/Ore.svg",theme:Kre,children:(0,z.jsx)(su,{value:t.resources.ore,unit:$c.Weight})})}),t.resources.oil>=.1&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Maps.RESOURCE,{hash:"Oil"}),children:(0,z.jsx)(Dre,{icon:"Media/Game/Icons/Oil.svg",theme:Kre,children:(0,z.jsx)(su,{value:t.resources.oil,unit:$c.Weight})})})]})]}):void 0,footer:null==t||s?void 0:r===lie.mapSelection?(0,z.jsx)(Vre,{onSelect:o,children:(0,z.jsx)(qc.Menu.SELECT_MAP_BUTTON,{})}):(0,z.jsx)(Vre,{onSelect:a,disabled:!l,children:(0,z.jsx)(qc.Menu.START_GAME_BUTTON,{})})},null==t?void 0:t.id)};function qre(e,t){var n=.25*e+.75*t;return n<.1?"Media/Game/Icons/Arid.svg":n<.15?"Media/Game/Icons/SemiArid.svg":n<.2?"Media/Game/Icons/SemiHumid.svg":"Media/Game/Icons/Humid.svg"}function Xre(e){return e>15?(0,z.jsx)(qc.GameListScreen.HEMISPHERE_N,{}):e<-15?(0,z.jsx)(qc.GameListScreen.HEMISPHERE_S,{}):(0,z.jsx)(qc.GameListScreen.EQUATOR,{})}oe.add("game-ui/menu/components/new-game-screen/map-detail/map-detail.tsx",{get MapDetail(){return $re},set MapDetail(e){$re=e}});let Qre={item:"item_6bQ",locked:"locked_llh",thumbnail:"thumbnail_jir","theme-icon":"theme-icon__ST",themeIcon:"theme-icon__ST","thumbnail-container":"thumbnail-container_JcP",thumbnailContainer:"thumbnail-container_JcP",vignette:"vignette_Gss",title:"title_DFa"};oe.add("game-ui/menu/components/new-game-screen/map-grid/map-item.module.scss",{get classes(){return Qre},set classes(e){Object.assign(Qre,e)}});const Zre=Qre;var Jre=function(e){var t=e.map,n=e.locked,r=e.selected,i=e.onClick,o=(0,Y.useCallback)((function(){return i(t.id)}),[t.id,i]);return(0,z.jsxs)(Qp,{focusKey:t.id,selected:r,className:_d()(Zre.item,n&&Zre.locked),onClick:o,children:[(0,z.jsxs)("div",{className:Zre.thumbnailContainer,children:[(0,z.jsx)(mM,{src:t.thumbnail,className:Zre.thumbnail}),(0,z.jsx)("div",{className:Zre.vignette})]}),(0,z.jsx)("div",{className:Zre.title,children:(0,z.jsx)(qc.Maps.MAP_TITLE,{hash:t.displayName,fallback:t.displayName})})]})};oe.add("game-ui/menu/components/new-game-screen/map-grid/map-item.tsx",{get MapItem(){return Jre},set MapItem(e){Jre=e}});let eie={"map-grid":"map-grid_EhO child-opacity-transition_nkS",mapGrid:"map-grid_EhO child-opacity-transition_nkS",scrollable:"scrollable_Wdh",content:"content_V7r"};oe.add("game-ui/menu/components/new-game-screen/map-grid/map-grid.module.scss",{get classes(){return eie},set classes(e){Object.assign(eie,e)}});const tie=eie;var nie=Y.forwardRef((function(e,t){var n=e.focusKey,r=e.maps,i=e.selectedMap,o=e.className,a=e.onSelectMap,s=(0,Y.useCallback)((function(e){"string"==typeof e&&a(e)}),[a]);return(0,z.jsx)("div",{ref:t,className:_d()(tie.mapGrid,o),children:(0,z.jsx)(gE,{className:tie.scrollable,children:(0,z.jsx)("div",{className:tie.content,children:(0,z.jsx)(Ip,{focusKey:n,focused:i,onChange:s,children:r.map((function(e){return(0,z.jsx)(Jre,{map:e,locked:e.locked,selected:e.id===i,onClick:a},e.id)}))})})})})}));oe.add("game-ui/menu/components/new-game-screen/map-grid/map-grid.tsx",{get MapGrid(){return nie},set MapGrid(e){nie=e}});let rie={content:"content_bgM","step-container":"step-container_NnT",stepContainer:"step-container_NnT",step:"step_QIP",detail:"detail_OCx",header:"header_mQE","no-gamepad":"no-gamepad_nYD",noGamepad:"no-gamepad_nYD",title:"title_KQ_",tabs:"tabs_BJl",tab:"tab_COL",selected:"selected_s7w"};oe.add("game-ui/menu/components/new-game-screen/new-game-screen.module.scss",{get classes(){return rie},set classes(e){Object.assign(rie,e)}});const iie=rie;function oie(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function aie(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function sie(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return oie(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return oie(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var lie,cie="Assets.CITY_NAME";!function(e){e[e.mapSelection=0]="mapSelection",e[e.mapOptions=1]="mapOptions"}(lie||(lie={}));var uie=Y.forwardRef((function(e,t){var n,r=e.focusKey,i=e.className,o=e.onClose,a=sie((0,Y.useState)(lie.mapSelection),2),s=a[0],l=a[1],c=gie(),u=sie((0,Y.useState)(oC(c,"id")),2),d=u[0],f=u[1];(0,Y.useEffect)((function(){null!==d&&c.findIndex((function(e){return e.id===d}))<0&&f(oC(c,"id"))}),[c,d]);var m,g=null!==(n=c.find((function(e){return e.id===d})))&&void 0!==n?n:null,h=xl(hG),p=xl(dG),v=vc(),b=hie(),y=sie((0,Y.useState)(""),2),x=y[0],_=y[1],j=sie((0,Y.useState)(""),2),O=j[0],E=j[1],S=sie((0,Y.useState)(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){aie(e,t,n[t])}))}return e}({},p)),2),T=S[0],I=S[1],w=null!==(m=h.find((function(e){return e.id===O})))&&void 0!==m?m:null,P=xl(aG),C=xl(jb),N=xl(vG),A=xl(bG);(0,Y.useEffect)((function(){null!=(null==g?void 0:g.theme)&&E(null==g?void 0:g.theme)}),[null==g?void 0:g.theme]),(0,Y.useEffect)((function(){var e;null!=(null==g?void 0:g.displayName)&&(g.nameAsCityName?_(null!==(e=qc.Maps.MAP_TITLE.renderString(v,{hash:g.displayName}))&&void 0!==e?e:b()):_(b()))}),[b,v,null==g?void 0:g.displayName,null==g?void 0:g.nameAsCityName]);var L=(0,Y.useCallback)((function(){s===lie.mapOptions?(l(lie.mapSelection),kp(Lp.closeMenu)):o()}),[s,o]),M=(0,Y.useCallback)((function(){l(lie.mapOptions),kp(Lp.openMenu)}),[]),k=(0,Y.useCallback)((function(){PG(g.id)}),[g]),R=sie(kG(),2),D=R[0],F=R[1],U=(0,Y.useCallback)((function(){null!=d&&(MG(D),EG({mapId:d,cityName:x,theme:O,options:T}))}),[d,D,x,O,T]),G=(0,Y.useMemo)((function(){return{Select:s===lie.mapSelection?function(){kp(Lp.selectItem),M()}:null,"Start Game":s===lie.mapOptions?function(){kp(Lp.selectItem),U()}:null,"Switch Tab":s===lie.mapSelection&&N.length>=2?function(e){var t=N.indexOf(A);VG(t>=0?N[(t+e+N.length)%N.length]:N[0])}:null}}),[s,N,M,U,A]);return(0,z.jsx)(r2,{ref:t,focusKey:r,title:die(s),className:i,onClose:L,children:(0,z.jsx)(rp,{actions:G,children:(0,z.jsx)(pj,{focused:s,activation:yd.Always,children:(0,z.jsxs)("div",{className:iie.content,children:[(0,z.jsx)("div",{className:iie.stepContainer,children:(0,z.jsxs)(Ud,{children:[s===lie.mapSelection&&(0,z.jsx)(Cm,{styles:zne,children:(0,z.jsx)(nie,{focusKey:lie.mapSelection,maps:c,selectedMap:d,className:iie.step,onSelectMap:f})},lie.mapSelection),s===lie.mapOptions&&(0,z.jsx)(Cm,{styles:D5,children:(0,z.jsx)(Die,{focusKey:lie.mapOptions,cityName:x,theme:O,options:T,className:iie.step,onCityNameChange:_,onThemeChange:E,onOptionsChange:I,tutorialState:D,setTutorialState:F,onShareGame:P||(null==g?void 0:g.isReadonly)||!C?void 0:k,shareGameLocaleKey:"shareMap"})},lie.mapOptions)]})}),(0,z.jsx)($re,{selectedMap:g,selectedTheme:w,activeStep:s,className:iie.detail,onContinue:M,onStartGameSelect:U})]})})})})}));function die(e){return e===lie.mapSelection?(0,z.jsx)(fie,{}):e===lie.mapOptions?(0,z.jsx)(qc.Menu.MAP_OPTIONS,{}):null}var fie=function(){var e=Pg(),t=xl(vG),n=xl(bG);return(0,z.jsxs)("div",{className:_d()(iie.header,!e&&iie.noGamepad),children:[(0,z.jsx)("div",{className:iie.title,children:(0,z.jsx)(qc.Menu.NEW_GAME,{})}),t.length>=2&&(0,z.jsx)("div",{className:iie.tabs,children:t.map((function(e){return(0,z.jsx)(mie,{filter:e,selectedFilter:n},e)}))})]})},mie=function(e){var t=e.filter,n=e.selectedFilter,r=(0,Y.useCallback)((function(){return VG(t)}),[t]);return(0,z.jsx)(Qp,{className:_d()(iie.tab,t2.headerButton,n===t&&iie.selected),onSelect:r,focusKey:Hh,children:(0,z.jsx)(qc.GameListScreen.MAP_FILTER,{hash:qU[t]})})};function gie(){var e=vc(),t=xl(pG),n=Cre();return(0,Y.useMemo)((function(){return t.map((function(t){return{value:t,name:qc.Maps.MAP_TITLE.renderString(e,{hash:t.displayName})}})).sort((function(e,t){return n(e.name,t.name)})).map((function(e){return e.value}))}),[e,t,n])}function hie(){var e=vc(),t=Ol(Pc,cie);return(0,Y.useCallback)((function(n){if(0===t)return"";var r=Math.floor(Math.random()*t),i=qc.Assets.CITY_NAME.renderString(e,{index:r});return i===n&&(r=(r+1)%t,i=qc.Assets.CITY_NAME.renderString(e,{index:r})),i}),[t,e])}oe.add("game-ui/menu/components/new-game-screen/new-game-screen.tsx",{get cityNameLocId(){return cie},set cityNameLocId(e){cie=e},get NewGameStep(){return lie},set NewGameStep(e){lie=e},get NewGameScreen(){return uie},set NewGameScreen(e){uie=e},get useSortedMaps(){return gie},set useSortedMaps(e){gie=e},get useCityNameGenerator(){return hie},set useCityNameGenerator(e){hie=e}});let pie={container:"container_AwD",input:"input_Hft",label:"label_lus"};oe.add("game-ui/menu/themes/menu-input-field.module.scss",{get classes(){return pie},set classes(e){Object.assign(pie,e)}});const vie=pie;let bie={field:"field_iTK field_cjf",label:"label_TLv label_T__"};oe.add("game-ui/menu/components/shared/game-options/field/column-field.module.scss",{get classes(){return bie},set classes(e){Object.assign(bie,e)}});const yie=bie;let xie={"city-name-field":"city-name-field_H7e value-field_yJi",cityNameField:"city-name-field_H7e value-field_yJi",input:"input_RLt","dice-button":"dice-button_U3N secondary-button_Kvj",diceButton:"dice-button_U3N secondary-button_Kvj"};oe.add("game-ui/menu/components/shared/game-options/city-name-field/city-name-field.module.scss",{get classes(){return xie},set classes(e){Object.assign(xie,e)}});const _ie=xie;function jie(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Oie(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return jie(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return jie(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Eie=function(e){var t=e.id,n=e.label,r=e.value,i=e.disabled,o=e.onChange,a=Oie((0,Y.useState)(r),2),s=a[0],l=a[1];(0,Y.useEffect)((function(){return l(r)}),[r]);var c=(0,Y.useCallback)((function(e){l(e.target.value),o(e.target.value)}),[o]),u=hie(),d=(0,Y.useCallback)((function(){return o(u(r))}),[u,o,r]);return(0,z.jsx)(H1,{id:t,label:n,theme:yie,disabled:i,children:(0,z.jsx)("div",{className:_ie.cityNameField,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)(nre,{value:s,vkTitle:(0,z.jsx)(qc.VirtualKeyboard.TITLE,{hash:"CityName"}),className:_ie.input,theme:vie,onChange:c,maxLength:85}),(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Menu.RANDOM_CITY_NAME_BUTTON_TOOLTIP,{}),children:(0,z.jsx)(lb,{tinted:!0,src:"Media/Glyphs/Dice.svg",sounds:V1,selectSound:Lp.generateRandomName,className:_ie.diceButton,onSelect:d})})]})})})};oe.add("game-ui/menu/components/shared/game-options/city-name-field/city-name-field.tsx",{get CityNameField(){return Eie},set CityNameField(e){Eie=e}});let Sie={"theme-item":"theme-item_qct",themeItem:"theme-item_qct","theme-icon":"theme-icon_jJ9",themeIcon:"theme-icon_jJ9","theme-name":"theme-name_hYf",themeName:"theme-name_hYf"};oe.add("game-ui/menu/components/shared/game-options/theme-field/theme-field.module.scss",{get classes(){return Sie},set classes(e){Object.assign(Sie,e)}});const Tie=Sie;var Iie=function(e){var t,n=e.id,r=e.label,i=e.value,o=e.disabled,a=e.onChange,s=xl(hG),l=s.find((function(e){return e.id===i}));return(0,z.jsx)(H1,{id:n,label:r,theme:yie,disabled:o,className:Tie.themeField,children:(0,z.jsx)(SE,{focusKey:o?Hh:Kh,initialFocused:i,theme:N2,content:s.map((function(e){return(0,z.jsxs)(RE,{focusKey:e.id,value:e.id,className:Tie.themeItem,onChange:a,children:[(0,z.jsx)(Lre,{src:e.icon,className:Tie.themeIcon}),(0,z.jsx)("div",{className:Tie.themeName,children:(0,z.jsx)(qc.Assets.THEME,{hash:e.id})})]},e.id)})),children:(0,z.jsx)(CE,{disabled:o,sounds:V1,children:(0,z.jsxs)("div",{className:Tie.themeItem,children:[(0,z.jsx)(Lre,{src:null!==(t=null==l?void 0:l.icon)&&void 0!==t?t:"Media/Placeholder.svg",className:Tie.themeIcon}),(0,z.jsx)("div",{className:Tie.themeName,children:(0,z.jsx)(qc.Assets.THEME,{hash:i})})]})})})})};oe.add("game-ui/menu/components/shared/game-options/theme-field/theme-field.tsx",{get ThemeField(){return Iie},set ThemeField(e){Iie=e}});let wie={"game-options":"game-options_iDr child-opacity-transition_nkS",gameOptions:"game-options_iDr child-opacity-transition_nkS","main-row":"main-row_a1n",mainRow:"main-row_a1n","options-column":"options-column_l0j",optionsColumn:"options-column_l0j","city-name-field":"city-name-field_L2K",cityNameField:"city-name-field_L2K","city-name-input":"city-name-input_aS0",cityNameInput:"city-name-input_aS0","dice-button":"dice-button_W27 item-mouse-states_Fmi",diceButton:"dice-button_W27 item-mouse-states_Fmi","theme-item":"theme-item_W3X",themeItem:"theme-item_W3X","theme-icon":"theme-icon_h7K",themeIcon:"theme-icon_h7K","theme-name":"theme-name_gDK",themeName:"theme-name_gDK","toggle-item":"toggle-item_uwk",toggleItem:"toggle-item_uwk","info-column":"info-column_IaC",infoColumn:"info-column_IaC","info-title":"info-title_oAQ",infoTitle:"info-title_oAQ","tutorial-options-title":"tutorial-options-title_qO8 info-title_oAQ",tutorialOptionsTitle:"tutorial-options-title_qO8 info-title_oAQ","info-description":"info-description_NL4",infoDescription:"info-description_NL4"};oe.add("game-ui/menu/components/shared/game-options/game-options.module.scss",{get classes(){return wie},set classes(e){Object.assign(wie,e)}});const Pie=wie;function Cie(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Nie(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Aie(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Lie(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Cie(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Cie(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Mie,kie="cityName",Rie="theme",Die=Y.forwardRef((function(e,t){var n=e.focusKey,r=e.cityName,i=e.theme,o=e.options,a=e.tutorialState,s=e.disabledOptions,l=void 0===s?[]:s,c=e.className,u=e.onCityNameChange,d=e.onThemeChange,f=e.onOptionsChange,m=e.onDeleteGame,g=e.onShareGame,h=e.setTutorialState,p=e.shareGameLocaleKey,v=Lie((0,Y.useState)(!1),2),b=v[0],y=v[1],x=Pg(),_=xl(rG),j=xl(iG),O=(0,Y.useCallback)((function(e,t){f&&f(Aie(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Nie(e,t,n[t])}))}return e}({},o),Nie({},e,t)))}),[o,f]),E=Lie((0,Y.useState)(kie),2),S=E[0],T=E[1],I=(0,Y.useCallback)((function(e){"string"==typeof e&&T(e)}),[]),w=Lie((0,Y.useState)(null),2),P=w[0],C=w[1],N=(0,Y.useMemo)((function(){return{onOptionMouseEnter:function(e){return C(e)},onOptionMouseLeave:function(e){return C((function(t){return t===e?null:t}))}}}),[]),A=null!=P?P:b&&x?S:null,L=xl(tG),M=null!=p?p:"shareSave",k=(0,Y.useCallback)((function(e){"deleteSave"===e&&m(),e===M&&g()}),[m,g,M]);return(0,z.jsx)(Tg,{onFocusChange:y,children:(0,z.jsxs)("div",{ref:t,className:_d()(Pie.gameOptions,c),children:[(0,z.jsxs)("div",{className:Pie.mainRow,children:[(0,z.jsx)("div",{className:Pie.optionsColumn,children:(0,z.jsx)(F1.Provider,{value:N,children:(0,z.jsxs)(Ip,{focusKey:n,focused:S,onChange:I,direction:gp.Both,children:[(0,z.jsx)(Eie,{id:kie,label:(0,z.jsx)(qc.GameListScreen.GAME_OPTION,{hash:kie}),value:r,disabled:l.includes(kie),onChange:u}),(0,z.jsx)(Iie,{id:Rie,label:(0,z.jsx)(qc.GameListScreen.GAME_OPTION,{hash:Rie}),value:i,disabled:l.includes(Rie),onChange:d}),(0,z.jsx)(P2,{}),Object.entries(o).filter((function(e){var t=Lie(e,2),n=t[0];t[1];return"__Type"!==n})).map((function(e){var t=Lie(e,2),n=t[0],r=t[1];return(0,z.jsx)(Fie,{id:n,value:r,disabled:l.includes(n),onChange:O},n)})),(0,z.jsx)(P2,{}),(0,z.jsx)("div",{className:_d()(Pie.infoTitle,Pie.tutorialOptionsTitle),children:(0,z.jsx)(qc.GameListScreen.TUTORIAL_OPTIONS,{})}),(0,z.jsx)(Q1,{id:L?"continueTutorials":"beginTutorials",label:(0,z.jsx)(qc.GameListScreen.GAME_OPTION,{hash:L?"continueTutorials":"beginTutorials"}),value:QU.Continue,groupValue:a,className:Pie.toggleItem,onChange:h}),L&&(0,z.jsx)(Q1,{id:"restartTutorials",label:(0,z.jsx)(qc.GameListScreen.GAME_OPTION,{hash:"restartTutorials"}),value:QU.Reset,groupValue:a,className:Pie.toggleItem,onChange:h}),(0,z.jsx)(Q1,{id:"disableTutorials",label:(0,z.jsx)(qc.GameListScreen.GAME_OPTION,{hash:"disableTutorials"}),value:QU.Disable,groupValue:a,className:Pie.toggleItem,onChange:h}),(null!=m||null!=g)&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(P2,{}),(0,z.jsx)(I3,{buttons:[null!=m?{id:"deleteSave",disabled:!1,confirm:!0}:null,null!=g?{id:M,disabled:!j,confirm:!1}:null].filter(fC),onSelect:k})]})]})})}),(0,z.jsx)("div",{className:Pie.infoColumn,children:null!=A&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)("div",{className:Pie.infoTitle,children:(0,z.jsx)(qc.GameListScreen.GAME_OPTION,{hash:A})}),(0,z.jsx)("div",{className:Pie.infoDescription,children:(0,z.jsx)(qc.GameListScreen.GAME_OPTION_DESCRIPTION,{hash:A})})]})})]}),(0,z.jsx)(qne,{modsEnabled:_,unlockAll:o.unlockAll,unlimitedMoney:o.unlimitedMoney})]})})})),Fie=function(e){var t=e.id,n=e.value,r=e.disabled,i=e.onChange,o=(0,Y.useCallback)((function(e){return i(t,e)}),[t,i]);return(0,z.jsx)(X1,{id:t,value:n,label:(0,z.jsx)(qc.GameListScreen.GAME_OPTION,{hash:t}),disabled:r,className:Pie.toggleItem,onChange:o})};function Uie(e,t){var n=Cre();return e.sort((function(e,r){switch(t){case Mie.LastModified:return new Date(r.lastModified).getTime()-new Date(e.lastModified).getTime()||n(e.displayName,r.displayName);case Mie.Population:return r.population-e.population||n(e.displayName,r.displayName);default:return n(e.displayName,r.displayName)}}))}oe.add("game-ui/menu/components/shared/game-options/game-options.tsx",{get GameOptions(){return Die},set GameOptions(e){Die=e},get ToggleItem(){return Fie},set ToggleItem(e){Fie=e}}),function(e){e[e.Name=0]="Name",e[e.LastModified=1]="LastModified",e[e.Population=2]="Population"}(Mie||(Mie={})),oe.add("game-ui/menu/components/shared/save-list-header/save-list-ordering.ts",{get Ordering(){return Mie},set Ordering(e){Mie=e},get sort(){return Uie},set sort(e){Uie=e}});var Gie=function(e){var t,n=e.save,r=e.activeStep,i=e.className,o=e.onOptionsToggle,a=e.onLoadGameSelect,s=xl(C_),l=Pg(),c=null!=n&&n.locked,u=null!==(t=xl(hG).find((function(e){return e.id===(null==n?void 0:n.theme)})))&&void 0!==t?t:null,d=xl(rG);return(0,z.jsx)(Gre,{className:i,title:null!=n?n.displayName:void 0,preview:null==n?void 0:n.preview,content:null!=n?(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)("div",{className:Ure.achievementWarningBannerContainer,children:(0,z.jsx)(Xne,{modsEnabled:d,unlockAll:n.options.unlockAll,unlimitedMoney:n.options.unlimitedMoney,loadGame:!0,className:Ure.achievementWarningBanner})}),(0,z.jsx)(Bre,{label:(0,z.jsx)(qc.Menu.CITY_NAME_LABEL,{}),children:n.cityName}),(0,z.jsx)(Bre,{label:(0,z.jsx)(qc.GameListScreen.POPULATION_LABEL,{}),children:(0,z.jsx)(su,{value:n.population,unit:$c.Integer})}),(0,z.jsx)(Bre,{label:(0,z.jsx)(qc.Menu.SIMULATION_DATE_LABEL,{}),children:(0,z.jsx)(Ju,{value:n.simulationDate})}),(0,z.jsx)(Bre,{label:(0,z.jsx)(qc.GameListScreen.MONEY_LABEL,{}),children:n.options.unlimitedMoney?(0,z.jsx)(qc.Menu.UNLIMITED_MONEY_LABEL,{}):(0,z.jsx)(su,{value:n.money,unit:$c.Money})}),(0,z.jsx)(Bre,{label:(0,z.jsx)(qc.GameListScreen.XP_LABEL,{}),children:(0,z.jsx)(su,{value:n.xp,unit:$c.Integer})}),null!=n.mapName&&(0,z.jsx)(Bre,{label:(0,z.jsx)(qc.GameListScreen.MAP_LABEL,{}),children:(0,z.jsx)(qc.Maps.MAP_TITLE,{hash:n.mapName})}),null!=u&&(0,z.jsxs)(Bre,{label:(0,z.jsx)(qc.GameListScreen.THEME_LABEL,{}),children:[(0,z.jsx)(Lre,{src:u.icon,className:Ure.themeIcon}),(0,z.jsx)(qc.Assets.THEME,{hash:u.id})]})]}):void 0,footer:null==n||l?void 0:(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(Vre,{disabled:c||!s,onSelect:a,children:(0,z.jsx)(qc.Menu.LOAD_GAME_BUTTON,{})}),(0,z.jsx)(Vre,{disabled:c,onSelect:o,children:r===tae.options?(0,z.jsx)(qc.Menu.SAVE_LIST,{}):(0,z.jsx)(qc.Menu.SAVE_OPTIONS,{})})]})})};oe.add("game-ui/menu/components/load-game-screen/save-detail/save-detail.tsx",{get SaveDetail(){return Gie},set SaveDetail(e){Gie=e}});let Bie={"save-list-header":"save-list-header_f5S",saveListHeader:"save-list-header_f5S","sort-label":"sort-label_KDJ",sortLabel:"sort-label_KDJ","sort-buttons":"sort-buttons_vQU",sortButtons:"sort-buttons_vQU","sort-button":"sort-button_UDY",sortButton:"sort-button_UDY"};oe.add("game-ui/menu/components/shared/save-list-header/save-list-header.module.scss",{get classes(){return Bie},set classes(e){Object.assign(Bie,e)}});const Vie=Bie;var Hie=[Mie.Name,Mie.LastModified,Mie.Population],Kie=function(e){var t=e.selectedOrdering,n=e.className,r=e.onSelectOrdering;return(0,z.jsx)(zie,{label:(0,z.jsx)(qc.Menu.SAVE_ORDERING_LABEL,{}),options:Hie,selectedOption:t,onSelectOption:r,getOptionLabel:function(e){return(0,z.jsx)(qc.Menu.SAVE_ORDERING,{hash:Mie[e]})},className:n})},Wie=function(e){var t=e.targets,n=e.selectedTarget,r=e.className,i=e.onSelectTarget;return(0,z.jsx)(zie,{label:(0,z.jsx)(qc.Menu.CLOUD_TARGET_LABEL,{}),options:t,selectedOption:n,onSelectOption:i,getOptionLabel:function(e){return(0,z.jsx)(qc.Menu.CLOUD_TARGET,{hash:e})},className:r})};function zie(e){var t=e.label,n=e.options,r=e.selectedOption,i=e.className,o=e.onSelectOption,a=e.getOptionLabel;return(0,z.jsxs)("div",{className:_d()(Vie.saveListHeader,i),children:[(0,z.jsx)("div",{className:Vie.sortLabel,children:t}),(0,z.jsx)("div",{className:Vie.sortButtons,children:n.map((function(e,t){return(0,z.jsx)(Qp,{focusKey:Hh,selected:r===e,className:Vie.sortButton,onSelect:function(){return o(e)},children:a(e)},t)}))})]})}oe.add("game-ui/menu/components/shared/save-list-header/save-list-header.tsx",{get orderings(){return Hie},set orderings(e){Hie=e},get OrderingSaveListHeader(){return Kie},set OrderingSaveListHeader(e){Kie=e},get CloudTargetSaveListHeader(){return Wie},set CloudTargetSaveListHeader(e){Wie=e}});let Yie={"full-width-digits":"full-width-digits_dns",fullWidthDigits:"full-width-digits_dns",digits:"digits_a1g",blind:"blind_u0R"};oe.add("game-ui/common/text/full-width-digits/full-width-digits.module.scss",{get classes(){return Yie},set classes(e){Object.assign(Yie,e)}});const $ie=Yie;var qie=/([\d:-]+)|([^\d:-]+)/g,Xie=/\d/g,Qie=function(e){var t=e.className,n=bc(e.children),r=(0,Y.useMemo)((function(){var e;return null===(e=n.match(qie))||void 0===e?void 0:e.map((function(e,t){return Xie.test(e)?(0,z.jsxs)("div",{className:$ie.digits,children:[e,(0,z.jsx)("div",{className:$ie.blind,children:e.replace(Xie,"0")})]},t):e}))}),[n]);return(0,z.jsx)("div",{className:_d()($ie.fullWidthDigits,t),children:r})};oe.add("game-ui/common/text/full-width-digits/full-width-digits.tsx",{get FullWidthDigits(){return Qie},set FullWidthDigits(e){Qie=e}});let Zie={item:"item_OsC",locked:"locked_Yoi","theme-icon":"theme-icon_yUd",themeIcon:"theme-icon_yUd",title:"title_qyE","population-value":"population-value_yQT",populationValue:"population-value_yQT","population-icon":"population-icon_PF9",populationIcon:"population-icon_PF9",date:"date_OyK","state-icon":"state-icon_YfD",stateIcon:"state-icon_YfD","title-inner":"title-inner_io2",titleInner:"title-inner_io2",space:"space_Mad",tooltip:"tooltip_cZx"};oe.add("game-ui/menu/components/shared/save-item/save-item.module.scss",{get classes(){return Zie},set classes(e){Object.assign(Zie,e)}});const Jie=Zie;var eoe=function(e){var t,n=e.save,r=e.selected,i=e.locked,o=e.tooltipsInactive,a=e.onClick,s=(0,Y.useCallback)((function(){return a(n)}),[n,a]),l=xl(hG).find((function(e){return e.id===n.theme})),c=toe(n.cloudTarget,n.isReadonly);return(0,z.jsxs)(Qp,{focusKey:n.id,selected:r,className:_d()(Jie.item,i&&Jie.locked),onClick:s,children:[(0,z.jsx)(Lre,{src:null!==(t=null==l?void 0:l.icon)&&void 0!==t?t:"",className:Jie.themeIcon}),null!=c&&(0,z.jsx)(RW,{tooltip:noe(n),disabled:o,className:Jie.tooltip,children:(0,z.jsx)(tb,{src:c,className:Jie.stateIcon})}),(0,z.jsx)("div",{className:Jie.title,children:(0,z.jsx)(RW,{tooltip:roe(n.path),disabled:o,className:Jie.tooltip,style:{maxWidth:screen.availWidth},children:(0,z.jsx)("div",{className:Jie.titleInner,children:n.displayName})})}),(0,z.jsx)("div",{className:Jie.populationValue,children:(0,z.jsx)(su,{value:n.population,unit:$c.Integer})}),(0,z.jsx)(tb,{src:"Media/Game/Icons/Citizen.svg",className:Jie.populationIcon}),(0,z.jsx)(Qie,{className:Jie.date,children:(0,z.jsx)(nd,{value:n.lastModified})})]})};function toe(e,t){return"PdxSdk"===e?"Media/Glyphs/PDXCloud.svg":"Steamworks"===e?"Media/Glyphs/SteamCloud.svg":"Gdk"===e?"Media/Glyphs/GdkCloud.svg":t?"Media/Glyphs/Lock.svg":null}function noe(e){return"PdxSdk"===e.cloudTarget?(0,z.jsx)(qc.Menu.PARADOXCLOUD_SAVE,{}):"Steamworks"===e.cloudTarget?(0,z.jsx)(qc.Menu.STEAMCLOUD_SAVE,{}):"Gdk"===e.cloudTarget?(0,z.jsx)(qc.Menu.GDKCLOUD_SAVE,{}):e.isReadonly?(0,z.jsx)(qc.Menu.READONLY_SAVE,{}):null}function roe(e){return null==e?void 0:e.replaceAll(/([/\\])/g,"$1​")}oe.add("game-ui/menu/components/shared/save-item/save-item.tsx",{get SaveItem(){return eoe},set SaveItem(e){eoe=e},get getStateIcon(){return toe},set getStateIcon(e){toe=e},get withZeroSpaces(){return roe},set withZeroSpaces(e){roe=e}});let ioe={itemHeight:"42rem","save-list":"save-list_gdH child-opacity-transition_nkS",saveList:"save-list_gdH child-opacity-transition_nkS",scrollable:"scrollable_C4r"};oe.add("game-ui/menu/components/load-game-screen/save-list/save-list.module.scss",{get classes(){return ioe},set classes(e){Object.assign(ioe,e)}});const ooe=ioe;var aoe=(0,Y.forwardRef)((function(e,t){var n=e.selectedSave,r=e.ordering,i=e.className,o=e.onSelectSave,a=e.onSelectOrdering,s=xl(yG),l=(0,Y.useMemo)((function(){return Uie(s,r)}),[r,s]),c=NQ(YO(ooe.itemHeight),l.length,3),u=(0,Y.useMemo)((function(){return{"Switch Ordering":function(e){var t;if(kp(Lp.dragSlider),e<0)kp(Lp.selectPreviousItem),a(null!==(t=lC(Hie,Hie.indexOf(r),!0))&&void 0!==t?t:r);else if(e>0){var n;kp(Lp.selectNextItem),a(null!==(n=aC(Hie,Hie.indexOf(r),!0))&&void 0!==n?n:r)}}}}),[a,r]),d=(0,Y.useCallback)((function(e){"string"==typeof e&&o(e)}),[o]),f=(0,Y.useCallback)((function(e){return o(e.id)}),[o]),m=(0,Y.useCallback)((function(e){var t=l[e];return(0,z.jsx)(eoe,{save:t,selected:n===t.displayName||n===t.id,locked:!1,tooltipsInactive:!0,onClick:f},t.id)}),[f,n,l,r]);return(0,z.jsx)(rp,{actions:u,children:(0,z.jsxs)("div",{ref:t,className:_d()(ooe.saveList,i),children:[(0,z.jsx)(Kie,{selectedOrdering:r,onSelectOrdering:a}),(0,z.jsx)(Ip,{focused:n,onChange:d,children:(0,z.jsx)(wQ,{className:_d()(ooe.scrollable),sizeProvider:c,renderItem:m})})]})})}));oe.add("game-ui/menu/components/load-game-screen/save-list/save-list.tsx",{get SaveList(){return aoe},set SaveList(e){aoe=e}});var soe=function(e){var t=e.title,n=e.message,r=e.onConfirm,i=(0,Y.useContext)(fO),o=(0,Y.useCallback)((function(){i.onClose(),r&&r()}),[i,r]);return(0,z.jsx)(lO,{title:t,buttons:(0,z.jsx)("div",{className:rO.buttons,children:(0,z.jsx)(Ap,{children:(0,z.jsx)(Qp,{theme:Jp,className:rO.buttonOk,onSelect:o,children:(0,z.jsx)(qc.Common.OK,{})})})}),onClose:i.onClose,children:(0,z.jsx)(Fv,{theme:rO,children:n})})};oe.add("game-ui/common/panel/dialog/message-dialog.tsx",{get MessageDialog(){return soe},set MessageDialog(e){soe=e}});var loe=function(e){var t=e.className,n=e.onSaveGameSelect,r=Pg(),i=xl(C_),o=xl(lG),a=xl(aL),s=xl(nL),l=xl(iL),c=xl(yP),u=xl(cG),d=UN(xl(TN),xl(IN)),f=xl(sL),m=xl(_G);return(0,z.jsx)(Gre,{className:t,title:a,preview:o,content:(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(Bre,{label:(0,z.jsx)(qc.Menu.CITY_NAME_LABEL,{}),children:a}),(0,z.jsx)(Bre,{label:(0,z.jsx)(qc.GameListScreen.POPULATION_LABEL,{}),children:(0,z.jsx)(su,{value:s,unit:$c.Integer})}),(0,z.jsx)(Bre,{label:(0,z.jsx)(qc.Menu.SIMULATION_DATE_LABEL,{}),children:(0,z.jsx)(Ju,{value:d})}),(0,z.jsx)(Bre,{label:(0,z.jsx)(qc.GameListScreen.MONEY_LABEL,{}),children:f?(0,z.jsx)(qc.Menu.UNLIMITED_MONEY_LABEL,{}):(0,z.jsx)(su,{value:l,unit:$c.Money})}),(0,z.jsx)(Bre,{label:(0,z.jsx)(qc.GameListScreen.XP_LABEL,{}),children:(0,z.jsx)(su,{value:c,unit:$c.Integer})}),null!=u&&(0,z.jsx)(Bre,{label:(0,z.jsx)(qc.GameListScreen.MAP_LABEL,{}),children:(0,z.jsx)(qc.Maps.MAP_TITLE,{hash:u})})]}),footer:r?void 0:(0,z.jsx)(jh,{tooltip:m.reasonHash&&(0,z.jsx)(qc.Common.SAVEABILITY_REASON,{hash:m.reasonHash}),children:(0,z.jsx)(Vre,{onSelect:n,disabled:!m.canSave||!i,children:(0,z.jsx)(qc.GameListScreen.SAVE_GAME_BUTTON,{})})})})};oe.add("game-ui/menu/components/save-game-screen/game-detail/game-detail.tsx",{get GameDetail(){return loe},set GameDetail(e){loe=e}});let coe={itemHeight:"42rem","save-list":"save-list_zHX child-opacity-transition_nkS",saveList:"save-list_zHX child-opacity-transition_nkS",scrollable:"scrollable_t4Z","name-field":"name-field_FGr",nameField:"name-field_FGr","name-input":"name-input_nrm",nameInput:"name-input_nrm"};oe.add("game-ui/menu/components/save-game-screen/save-list/save-list.module.scss",{get classes(){return coe},set classes(e){Object.assign(coe,e)}});const uoe=coe;function doe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function foe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return doe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return doe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var moe=new Wh("nameField"),goe=Y.forwardRef((function(e,t){var n=e.saveName,r=e.cloudTarget,i=e.className,o=e.onSaveNameChange,a=e.onSelectCloudTarget,s=xl(FG),l=foe((0,Y.useState)(moe),2),c=l[0],u=l[1],d=xl(yG),f=(0,Y.useMemo)((function(){return Uie(d.filter((function(e){return!e.isReadonly&&e.cloudTarget===r&&!e.autoSave})),Mie.LastModified)}),[r,d]),m=(0,Y.useRef)(null),g=NQ(YO(uoe.itemHeight),f.length,3);(0,Y.useEffect)((function(){if(m.current){m.current.focus();var e=m.current.value.length;m.current.setSelectionRange(0,e)}}),[]);var h=(0,Y.useMemo)((function(){return s.length>1?{"Switch Savegame Location":function(e){var t;if(kp(Lp.dragSlider),e<0)kp(Lp.selectPreviousItem),a(null!==(t=lC(s,s.indexOf(r),!0))&&void 0!==t?t:r);else if(e>0){var n;kp(Lp.selectNextItem),a(null!==(n=aC(s,s.indexOf(r),!0))&&void 0!==n?n:r)}}}:{}}),[a,s,r]),p=(0,Y.useCallback)((function(e){if("string"!=typeof e)u(moe);else{var t=d.find((function(t){return t.id===e}));null!=t&&(u(e),o(t.displayName),m.current&&m.current.blur())}}),[o,d]),v=(0,Y.useCallback)((function(e){u(e.id),o(e.displayName),m.current&&m.current.blur()}),[o]),b=(0,Y.useCallback)((function(e){return o(e.target.value)}),[o]),y=(0,Y.useCallback)((function(e){var t=f[e];return(0,z.jsx)(eoe,{save:t,selected:n===t.displayName&&c===t.id,locked:!1,tooltipsInactive:!0,onClick:v},t.id)}),[c,v,n,f]);return(0,z.jsx)(rp,{actions:h,children:(0,z.jsxs)("div",{ref:t,className:_d()(uoe.saveList,i),children:[s.length>1&&(0,z.jsx)(Wie,{targets:s,selectedTarget:r,onSelectTarget:a}),(0,z.jsxs)(Ip,{focused:c,onChange:p,children:[(0,z.jsx)(wQ,{className:_d()(uoe.scrollable),sizeProvider:g,renderItem:y}),(0,z.jsx)("div",{className:uoe.nameField,children:(0,z.jsx)(nre,{ref:m,maxLength:85,focusKey:moe,placeholder:(0,z.jsx)(qc.Menu.NAME_FIELD_PLACEHOLDER,{}),value:n,onChange:b,vkTitle:(0,z.jsx)(qc.VirtualKeyboard.TITLE,{hash:"SaveName"}),theme:vie})})]})]})})}));oe.add("game-ui/menu/components/save-game-screen/save-list/save-list.tsx",{get SaveList(){return goe},set SaveList(e){goe=e}});let hoe={"save-slot-list":"save-slot-list_MCn child-opacity-transition_nkS",saveSlotList:"save-slot-list_MCn child-opacity-transition_nkS",scrollable:"scrollable_W3E","name-field":"name-field__Sm",nameField:"name-field__Sm","name-input":"name-input_khn",nameInput:"name-input_khn"};oe.add("game-ui/menu/components/save-game-screen/save-slot-list/save-slot-list.module.scss",{get classes(){return hoe},set classes(e){Object.assign(hoe,e)}});const poe=hoe;var voe=Y.forwardRef((function(e,t){var n=e.sortedSaves,r=e.saveName,i=e.cloudTarget,o=e.slots,a=e.selectedSlotId,s=e.className,l=e.onSaveNameChange,c=e.onSelectCloudTarget,u=e.onSelectSlot,d=xl(FG),f=(0,Y.useMemo)((function(){return d.length>1?{"Switch Savegame Location":function(e){var t;if(kp(Lp.dragSlider),e<0)kp(Lp.selectPreviousItem),c(null!==(t=lC(d,d.indexOf(i),!0))&&void 0!==t?t:i);else if(e>0){var n;kp(Lp.selectNextItem),c(null!==(n=aC(d,d.indexOf(i),!0))&&void 0!==n?n:i)}}}:{}}),[c,d,i]);return(0,z.jsx)(rp,{actions:f,children:(0,z.jsxs)("div",{ref:t,className:_d()(poe.saveSlotList,s),children:[d.length>1&&(0,z.jsx)(Wie,{targets:d,selectedTarget:i,onSelectTarget:c}),(0,z.jsx)(Ap,{initialFocused:a>n.length-1?"Save->Empty:".concat(a):"Save->".concat(n[a].id),children:(0,z.jsx)(gE,{className:poe.scrollable,children:Array.from({length:o},(function(e,t){return t>n.length-1?(0,z.jsx)(Foe,{focusKey:"Save->Empty:".concat(t),slotId:t,selected:a===t,saveName:r,onSaveNameChange:l,onSelect:u},t):(0,z.jsx)(Foe,{focusKey:"Save->".concat(n[t].id),slotId:t,selected:a===t,saveGame:n[t],saveName:r,onSaveNameChange:l,onSelect:u},t)}))})})]})})}));oe.add("game-ui/menu/components/save-game-screen/save-slot-list/save-slot-list.tsx",{get SaveSlotList(){return voe},set SaveSlotList(e){voe=e}});let boe={container:"container_K3P",input:"input_f_x",label:"label_OFp"};oe.add("game-ui/menu/themes/save-slot-input-field.module.scss",{get classes(){return boe},set classes(e){Object.assign(boe,e)}});const yoe=boe;let xoe={"save-slot":"save-slot_vY4 child-opacity-transition_nkS",saveSlot:"save-slot_vY4 child-opacity-transition_nkS",locked:"locked_GCS","theme-icon":"theme-icon_lGm",themeIcon:"theme-icon_lGm","humidity-icon":"humidity-icon_zZV",humidityIcon:"humidity-icon_zZV",title:"title_L43",field:"field_Yxz","population-icon":"population-icon_mlk",populationIcon:"population-icon_mlk",date:"date_tTu","empty-label":"empty-label_OR4",emptyLabel:"empty-label_OR4",input:"input_q53","title-content":"title-content_SFM",titleContent:"title-content_SFM",image:"image_u6c",scrollable:"scrollable_khn","scrollable-content":"scrollable-content_hzP",scrollableContent:"scrollable-content_hzP",description:"description_DTi",label:"label_out",value:"value_wmH","scrollable-footer":"scrollable-footer_nav",scrollableFooter:"scrollable-footer_nav"};oe.add("game-ui/menu/components/save-game-screen/save-slots/save-slot/save-slot.module.scss",{get classes(){return xoe},set classes(e){Object.assign(xoe,e)}});const _oe=xoe;var joe=function(e){var t=e.focusKey,n=e.slotId,r=e.saveName,i=e.saveGame,o=e.selected,a=void 0!==o&&o,s=e.className,l=e.onSaveNameChange,c=e.onSelect,u=(0,Y.useRef)(null);(0,Y.useEffect)((function(){if(a){if(u.current){u.current.focus();var e=u.current.value.length;u.current.setSelectionRange(0,e)}i?l&&l(i.displayName):r&&l&&l(r)}}),[l,c,i,r,a]);var d,f,m,g,h,p=xl(lG),v=xl(aL),b=xl(nL),y=xl(iL),x=xl(yP),_=xl(cG),j=UN(xl(TN),xl(IN)),O=xl(sL),E=(0,Y.useCallback)((function(e){return l&&l(e.target.value)}),[l]),S=(0,Y.useCallback)((function(e){e&&(c(n),i&&l&&l(i.displayName))}),[l,c,i,n]),T=(0,Y.useCallback)((function(){i&&l&&l(i.displayName),u.current&&u.current.focus(),c(n)}),[l,c,i,n]),I=(0,Y.useCallback)((function(){if(!r){var e=Aoe();l&&l(e)}}),[l,r]);return(0,z.jsxs)(Yv,{focusKey:t,onFocusChange:S,onClick:T,className:_d()(_oe.saveSlot,a&&"selected",s),children:[(i||a)&&(0,z.jsx)("div",{className:_oe.title,children:(0,z.jsx)("div",{className:_oe.titleContent,children:!i&&a?(0,z.jsx)(nre,{ref:u,maxLength:85,placeholder:(0,z.jsx)(qc.Menu.NAME_FIELD_PLACEHOLDER,{}),value:r,onChange:E,onBlur:I,vkTitle:(0,z.jsx)(qc.VirtualKeyboard.TITLE,{hash:"SaveName"}),theme:yoe}):null==i?void 0:i.displayName})}),i?a?null!=p&&(0,z.jsx)(mM,{src:p,className:_oe.image}):(0,z.jsx)(mM,{src:null==i?void 0:i.preview,className:_oe.image}):null!=p&&a&&(0,z.jsx)(mM,{src:p,className:_oe.image}),(0,z.jsx)(gE,{autoScroll:!0,className:_oe.scrollable,children:(0,z.jsxs)("div",{className:_oe.scrollableContent,children:[i||a?(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(Ooe,{label:(0,z.jsx)(qc.Menu.CITY_NAME_LABEL,{}),children:null!==(d=null==i?void 0:i.cityName)&&void 0!==d?d:v}),(0,z.jsx)(Ooe,{label:(0,z.jsx)(qc.GameListScreen.POPULATION_LABEL,{}),children:(0,z.jsx)(su,{value:null!==(f=null==i?void 0:i.population)&&void 0!==f?f:b,unit:$c.Integer})}),(0,z.jsx)(Ooe,{label:(0,z.jsx)(qc.Menu.SIMULATION_DATE_LABEL,{}),children:(0,z.jsx)(Ju,{value:null!==(m=null==i?void 0:i.simulationDate)&&void 0!==m?m:j})}),(0,z.jsx)(Ooe,{label:(0,z.jsx)(qc.GameListScreen.MONEY_LABEL,{}),children:!i&&O?(0,z.jsx)(qc.Menu.UNLIMITED_MONEY_LABEL,{}):(0,z.jsx)(su,{value:null!==(g=null==i?void 0:i.money)&&void 0!==g?g:y,unit:$c.Money})}),(0,z.jsx)(Ooe,{label:(0,z.jsx)(qc.GameListScreen.XP_LABEL,{}),children:(0,z.jsx)(su,{value:null!==(h=null==i?void 0:i.xp)&&void 0!==h?h:x,unit:$c.Integer})}),null!=(null==i?void 0:i.mapName)?(0,z.jsx)(Ooe,{label:(0,z.jsx)(qc.GameListScreen.MAP_LABEL,{}),children:(0,z.jsx)(qc.Maps.MAP_TITLE,{hash:i.mapName})}):null!=_&&(0,z.jsx)(Ooe,{label:(0,z.jsx)(qc.GameListScreen.MAP_LABEL,{}),children:(0,z.jsx)(qc.Maps.MAP_TITLE,{hash:_})})]}):(0,z.jsx)("div",{className:_oe.emptyLabel,children:(0,z.jsx)(qc.Menu.EMPTY_SLOT,{})}),(0,z.jsx)("div",{className:_oe.scrollableFooter})]})})]})},Ooe=function(e){var t=e.label,n=e.children;return(0,z.jsxs)("div",{className:_oe.field,children:[(0,z.jsx)("div",{className:_oe.label,children:t}),(0,z.jsx)("div",{className:_oe.value,children:n})]})};oe.add("game-ui/menu/components/save-game-screen/save-slots/save-slot/save-slot.tsx",{get SaveSlot(){return joe},set SaveSlot(e){joe=e}});let Eoe={"save-game-slots":"save-game-slots_y4R",saveGameSlots:"save-game-slots_y4R",header:"header_iE9 child-opacity-transition_nkS",slots:"slots_s__",slot:"slot_DnC","name-field":"name-field_E4B child-opacity-transition_nkS",nameField:"name-field_E4B child-opacity-transition_nkS",footer:"footer_TH2 child-opacity-transition_nkS","footer-button":"footer-button_qPc",footerButton:"footer-button_qPc"};oe.add("game-ui/menu/components/save-game-screen/save-slots/save-slots.module.scss",{get classes(){return Eoe},set classes(e){Object.assign(Eoe,e)}});const Soe=Eoe;var Toe=function(e){var t=e.sortedSaves,n=e.saveName,r=e.cloudTarget,i=e.slots,o=e.selectedSlotId,a=e.className,s=e.onSaveNameChange,l=e.onSelectCloudTarget,c=e.onSelectSlot,u=xl(FG),d=(0,Y.useMemo)((function(){return u.length>1?{"Switch Savegame Location":function(e){var t;if(kp(Lp.dragSlider),e<0)kp(Lp.selectPreviousItem),l(null!==(t=lC(u,u.indexOf(r),!0))&&void 0!==t?t:r);else if(e>0){var n;kp(Lp.selectNextItem),l(null!==(n=aC(u,u.indexOf(r),!0))&&void 0!==n?n:r)}}}:{}}),[l,u,r]),f=(0,Y.useMemo)((function(){var e;return!t||0===t.length||o>t.length-1?"Save->Empty:".concat(o):"Save->".concat(null===(e=t[o])||void 0===e?void 0:e.id)}),[o,t]);return(0,z.jsx)(rp,{actions:d,children:(0,z.jsxs)("div",{className:_d()(Soe.saveGameSlots,a),children:[u.length>1&&(0,z.jsx)(Wie,{targets:u,selectedTarget:r,onSelectTarget:l,className:Soe.header}),(0,z.jsx)("div",{className:Soe.slots,children:(0,z.jsx)(Ap,{initialFocused:f,children:Array.from({length:i},(function(e,r){return!t||0===t.length||r>t.length-1?(0,z.jsx)(joe,{slotId:r,saveName:n,focusKey:"Save->Empty:".concat(r),className:Soe.slot,selected:o===r,onSelect:c,onSaveNameChange:s},r):(0,z.jsx)(joe,{slotId:r,focusKey:"Save->".concat(t[r].id),saveGame:t[r],selected:o===r,className:Soe.slot,onSelect:c,onSaveNameChange:s},r)}))})})]})})};oe.add("game-ui/menu/components/save-game-screen/save-slots/save-slots.tsx",{get SaveSlots(){return Toe},set SaveSlots(e){Toe=e}});let Ioe={content:"content_ZK4",list:"list_Lyo",detail:"detail_LOs"};oe.add("game-ui/menu/components/save-game-screen/save-game-screen.module.scss",{get classes(){return Ioe},set classes(e){Object.assign(Ioe,e)}});const woe=Ioe;function Poe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Coe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Poe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Poe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Noe=Y.forwardRef((function(e,t){var n=e.focusKey,r=e.className,i=e.onClose;(0,Y.useEffect)((function(){return LG(!0),function(){return LG(!1)}}),[]);var o=xl(mG),a=xl(yG),s=xl(UG),l=(0,Y.useMemo)((function(){return Uie(a.filter((function(e){return!e.isReadonly&&e.cloudTarget===s&&!e.autoSave})),Mie.LastModified)}),[s,a]),c=Coe((0,Y.useState)(Aoe),2),u=c[0],d=c[1],f=Coe((0,Y.useState)(function(e,t){var n=e.findIndex((function(e){return e.displayName===t}));return n>0?n:0}(l,u)),2),m=f[0],g=f[1],h=(0,Y.useContext)(dO),p=(0,Y.useCallback)((function(){var e=u.trim();Zs(u)?h.showDialog((0,z.jsx)(soe,{title:(0,z.jsx)(qc.Common.ERROR,{}),message:(0,z.jsx)(qc.GameListScreen.INVALID_NAME_MESSAGE,{})})):TG(e)}),[h,u]),v=xl(_G),b=(0,Y.useMemo)((function(){return v.canSave?{"Save Game":function(){kp(Lp.selectItem),p()}}:{}}),[p,v.canSave]);return(0,z.jsx)(r2,{ref:t,focusKey:n,title:(0,z.jsx)(qc.Menu.SAVE_GAME,{}),className:r,onClose:i,children:(0,z.jsx)(rp,{actions:b,children:(0,z.jsx)("div",{className:woe.content,children:o>3?(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(voe,{slots:o,selectedSlotId:m,sortedSaves:l,saveName:u,cloudTarget:s,onSelectCloudTarget:BG,onSaveNameChange:d,onSelectSlot:g,className:woe.list}),(0,z.jsx)(loe,{className:woe.detail,onSaveGameSelect:p})]}):o>0?(0,z.jsx)(Toe,{slots:o,selectedSlotId:m,sortedSaves:l,saveName:u,cloudTarget:s,onSaveNameChange:d,onSelectCloudTarget:BG,onSelectSlot:g}):(0,z.jsxs)(Ap,{children:[(0,z.jsx)(goe,{saveName:u,cloudTarget:s,onSelectCloudTarget:BG,onSaveNameChange:d,className:woe.list}),(0,z.jsx)(loe,{className:woe.detail,onSaveGameSelect:p})]})})})})}));function Aoe(){var e;return null!==(e=uG.value)&&void 0!==e?e:aL.value}function Loe(){var e=xl(uG);return(0,Y.useCallback)((function(){Zs(e)?P_(S_.saveGame):RG()}),[e])}oe.add("game-ui/menu/components/save-game-screen/save-game-screen.tsx",{get SaveGameScreen(){return Noe},set SaveGameScreen(e){Noe=e},get getInitialSaveName(){return Aoe},set getInitialSaveName(e){Aoe=e},get useQuicksave(){return Loe},set useQuicksave(e){Loe=e}});let Moe={container:"container_vNp",input:"input_Lfn",label:"label_F5D"};oe.add("game-ui/menu/themes/save-slot-list-item-input-field.module.scss",{get classes(){return Moe},set classes(e){Object.assign(Moe,e)}});const koe=Moe;let Roe={"save-slot-item":"save-slot-item_oai",saveSlotItem:"save-slot-item_oai",locked:"locked_k9Y","theme-icon":"theme-icon_tB3",themeIcon:"theme-icon_tB3",title:"title_Y9K","population-value":"population-value_XhI",populationValue:"population-value_XhI","population-icon":"population-icon_aqa",populationIcon:"population-icon_aqa",date:"date_Oac","state-icon":"state-icon_zkF",stateIcon:"state-icon_zkF","title-inner":"title-inner_nf4",titleInner:"title-inner_nf4",space:"space_evY",tooltip:"tooltip_N74"};oe.add("game-ui/menu/components/shared/save-slot-item/save-slot-item.module.scss",{get classes(){return Roe},set classes(e){Object.assign(Roe,e)}});const Doe=Roe;var Foe=function(e){var t=e.focusKey,n=e.locked,r=void 0!==n&&n,i=e.selected,o=void 0!==i&&i,a=e.saveName,s=e.saveGame,l=e.slotId,c=e.onSaveNameChange,u=e.onSelectSave,d=e.onSelect,f=(0,Y.useRef)(null),m=xl(hG).find((function(e){return e.id===(null==s?void 0:s.theme)})),g=s?toe(s.cloudTarget,s.isReadonly):null;(0,Y.useEffect)((function(){if(o){if(f.current){f.current.focus();var e=f.current.value.length;f.current.setSelectionRange(0,e)}s?(c&&c(s.displayName),u&&u(s)):a&&c&&c(a)}}),[c,d,u,s,a,o]);var h,p=(0,Y.useCallback)((function(e){return c&&c(e.target.value)}),[c]),v=(0,Y.useCallback)((function(e){e&&(s&&(u&&u(s),c&&c(s.displayName)),d&&d(l))}),[c,d,u,s,l]),b=(0,Y.useCallback)((function(){s&&(r||u&&u(s),c&&c(s.displayName)),r||d&&d(l)}),[r,c,d,u,s,l]),y=(0,Y.useCallback)((function(){if(!a){var e=Aoe();c&&c(e)}}),[c,a]);return(0,z.jsxs)(Yv,{onClick:b,focusKey:r?Hh:t||Hh,className:_d()(Doe.saveSlotItem,r&&Doe.locked,o&&"selected"),onFocusChange:v,children:[s&&(0,z.jsx)(Lre,{src:null!==(h=null==m?void 0:m.icon)&&void 0!==h?h:"",className:Doe.themeIcon}),null!=g&&(0,z.jsx)(tb,{src:g,className:Doe.stateIcon}),(0,z.jsx)("div",{className:Doe.title,children:!s&&o?(0,z.jsx)(nre,{ref:f,maxLength:85,placeholder:(0,z.jsx)(qc.Menu.NAME_FIELD_PLACEHOLDER,{}),value:a,onChange:p,onBlur:y,vkTitle:(0,z.jsx)(qc.VirtualKeyboard.TITLE,{hash:"SaveName"}),theme:koe}):(0,z.jsx)("div",{className:Doe.titleInner,children:s?s.displayName:(0,z.jsx)(qc.Menu.EMPTY_SLOT,{})})}),s&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)("div",{className:Doe.populationValue,children:(0,z.jsx)(su,{value:s.population,unit:$c.Integer})}),(0,z.jsx)(tb,{src:"Media/Game/Icons/Citizen.svg",className:Doe.populationIcon}),(0,z.jsx)(Qie,{className:Doe.date,children:(0,z.jsx)(nd,{value:s.lastModified})})]})]})};oe.add("game-ui/menu/components/shared/save-slot-item/save-slot-item.tsx",{get SaveSlotItem(){return Foe},set SaveSlotItem(e){Foe=e}});let Uoe={"save-slot-list":"save-slot-list_QCI child-opacity-transition_nkS",saveSlotList:"save-slot-list_QCI child-opacity-transition_nkS",scrollable:"scrollable_yF6","name-field":"name-field_c6v",nameField:"name-field_c6v","name-input":"name-input_NmH",nameInput:"name-input_NmH"};oe.add("game-ui/menu/components/load-game-screen/save-slot-list/save-slot-list.module.scss",{get classes(){return Uoe},set classes(e){Object.assign(Uoe,e)}});const Goe=Uoe;var Boe=(0,Y.forwardRef)((function(e,t){var n=e.slots,r=e.selectedSlot,i=e.sortedSaves,o=e.ordering,a=e.className,s=e.onSelectSave,l=e.onSelectOrdering,c=e.onSelectSlot,u=(0,Y.useMemo)((function(){return{"Switch Ordering":function(e){var t;if(kp(Lp.dragSlider),e<0)kp(Lp.selectPreviousItem),l(null!==(t=lC(Hie,Hie.indexOf(o),!0))&&void 0!==t?t:o);else if(e>0){var n;kp(Lp.selectNextItem),l(null!==(n=aC(Hie,Hie.indexOf(o),!0))&&void 0!==n?n:o)}}}}),[l,o]),d=(0,Y.useCallback)((function(e){return s(e.id)}),[s]);return(0,z.jsx)(rp,{actions:u,children:(0,z.jsxs)("div",{ref:t,className:_d()(Goe.saveSlotList,a),children:[(0,z.jsx)(Kie,{selectedOrdering:o,onSelectOrdering:l}),(0,z.jsx)(Ap,{initialFocused:r<i.length?"Save->".concat(i[r].id):void 0,children:(0,z.jsx)(gE,{className:Goe.scrollable,children:Array.from({length:n},(function(e,t){return t>i.length-1?(0,z.jsx)(Foe,{slotId:t,locked:!0},t):(0,z.jsx)(Foe,{slotId:t,focusKey:"Save->".concat(i[t].id),locked:i[t].locked,selected:r===t,saveGame:i[t],onSelectSave:d,onSelect:c},t)}))})})]})})}));oe.add("game-ui/menu/components/load-game-screen/save-slot-list/save-slot-list.tsx",{get SaveSlotList(){return Boe},set SaveSlotList(e){Boe=e}});let Voe={"save-slot":"save-slot_w9I child-opacity-transition_nkS",saveSlot:"save-slot_w9I child-opacity-transition_nkS",locked:"locked_ZDr","theme-icon":"theme-icon_I6O",themeIcon:"theme-icon_I6O","humidity-icon":"humidity-icon_cuF",humidityIcon:"humidity-icon_cuF",title:"title_BPq",field:"field_tWJ","population-icon":"population-icon_TMS",populationIcon:"population-icon_TMS",date:"date_vy3","empty-label":"empty-label_w3f",emptyLabel:"empty-label_w3f",input:"input_XA8","title-content":"title-content_PH_",titleContent:"title-content_PH_",image:"image_H0A",scrollable:"scrollable_wz4","scrollable-content":"scrollable-content_VzH",scrollableContent:"scrollable-content_VzH",description:"description_EAs",label:"label_W0E",value:"value_Azu","scrollable-footer":"scrollable-footer_TG4",scrollableFooter:"scrollable-footer_TG4"};oe.add("game-ui/menu/components/load-game-screen/save-slots/save-slot/save-slot.module.scss",{get classes(){return Voe},set classes(e){Object.assign(Voe,e)}});const Hoe=Voe;var Koe=function(e){var t=e.focusKey,n=e.locked,r=void 0!==n&&n,i=e.saveGame,o=e.selected,a=void 0!==o&&o,s=e.slotId,l=e.className,c=e.onSelectSave,u=e.onSelect,d=(0,Y.useCallback)((function(e){e&&(u&&u(s),i&&c&&c(i))}),[u,c,i,s]),f=(0,Y.useCallback)((function(){r||(i&&c&&c(i),u&&u(s))}),[r,u,c,i,s]);return(0,z.jsxs)(Yv,{focusKey:r?Hh:t||Hh,onClick:f,onFocusChange:d,className:_d()(Hoe.saveSlot,r&&Hoe.locked,a&&"selected",l),children:[i&&(0,z.jsx)("div",{className:Hoe.title,children:(0,z.jsx)("div",{className:Hoe.titleContent,children:null==i?void 0:i.displayName})}),null!=i&&(0,z.jsx)(mM,{src:null==i?void 0:i.preview,className:Hoe.image}),(0,z.jsx)(gE,{autoScroll:!0,className:Hoe.scrollable,children:(0,z.jsxs)("div",{className:Hoe.scrollableContent,children:[i?(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(Woe,{label:(0,z.jsx)(qc.Menu.CITY_NAME_LABEL,{}),children:null==i?void 0:i.cityName}),(0,z.jsx)(Woe,{label:(0,z.jsx)(qc.GameListScreen.POPULATION_LABEL,{}),children:(0,z.jsx)(su,{value:null==i?void 0:i.population,unit:$c.Integer})}),(0,z.jsx)(Woe,{label:(0,z.jsx)(qc.Menu.SIMULATION_DATE_LABEL,{}),children:(0,z.jsx)(Ju,{value:null==i?void 0:i.simulationDate})}),(0,z.jsx)(Woe,{label:(0,z.jsx)(qc.GameListScreen.MONEY_LABEL,{}),children:(0,z.jsx)(su,{value:null==i?void 0:i.money,unit:$c.Money})}),(0,z.jsx)(Woe,{label:(0,z.jsx)(qc.GameListScreen.XP_LABEL,{}),children:(0,z.jsx)(su,{value:null==i?void 0:i.xp,unit:$c.Integer})}),null!=(null==i?void 0:i.mapName)&&(0,z.jsx)(Woe,{label:(0,z.jsx)(qc.GameListScreen.MAP_LABEL,{}),children:(0,z.jsx)(qc.Maps.MAP_TITLE,{hash:i.mapName})})]}):(0,z.jsx)("div",{className:_d()(Hoe.emptyLabel,Hoe.locked),children:(0,z.jsx)(qc.Menu.EMPTY_SLOT,{})}),(0,z.jsx)("div",{className:Hoe.scrollableFooter})]})})]})},Woe=function(e){var t=e.label,n=e.children;return(0,z.jsxs)("div",{className:Hoe.field,children:[(0,z.jsx)("div",{className:Hoe.label,children:t}),(0,z.jsx)("div",{className:Hoe.value,children:n})]})};oe.add("game-ui/menu/components/load-game-screen/save-slots/save-slot/save-slot.tsx",{get SaveSlot(){return Koe},set SaveSlot(e){Koe=e}});let zoe={"save-game-slots":"save-game-slots_bkN",saveGameSlots:"save-game-slots_bkN",header:"header_bYW child-opacity-transition_nkS",slots:"slots_qGG",slot:"slot_yiX","name-field":"name-field_Tyf child-opacity-transition_nkS",nameField:"name-field_Tyf child-opacity-transition_nkS",footer:"footer_x7R child-opacity-transition_nkS","footer-button":"footer-button_OFi",footerButton:"footer-button_OFi"};oe.add("game-ui/menu/components/load-game-screen/save-slots/save-slots.module.scss",{get classes(){return zoe},set classes(e){Object.assign(zoe,e)}});const Yoe=zoe;var $oe=(0,Y.forwardRef)((function(e,t){var n=e.slots,r=e.selectedSlot,i=e.sortedSaves,o=e.selectedSave,a=e.ordering,s=e.className,l=e.onSelectOrdering,c=e.onSelectSave,u=e.onLoadGameSelect,d=e.onOptionsToggle,f=e.onSelectSlot,m=Pg(),g=null!=o&&o.locked,h=(0,Y.useMemo)((function(){return{"Switch Ordering":function(e){var t;if(kp(Lp.dragSlider),e<0)kp(Lp.selectPreviousItem),l(null!==(t=lC(Hie,Hie.indexOf(a),!0))&&void 0!==t?t:a);else if(e>0){var n;kp(Lp.selectNextItem),l(null!==(n=aC(Hie,Hie.indexOf(a),!0))&&void 0!==n?n:a)}}}}),[l,a]),p=(0,Y.useCallback)((function(e){return c(e.id)}),[c]),v=(0,Y.useMemo)((function(){var e;return!i||0===i.length||r>i.length-1?"Save->Empty:".concat(r):"Save->".concat(null===(e=i[r])||void 0===e?void 0:e.id)}),[r,i]);return(0,z.jsx)(rp,{actions:h,children:(0,z.jsxs)("div",{ref:t,className:_d()(Yoe.saveGameSlots,s),children:[(0,z.jsx)(Kie,{selectedOrdering:a,onSelectOrdering:l,className:Yoe.header}),(0,z.jsx)("div",{className:Yoe.slots,children:(0,z.jsx)(Ap,{initialFocused:v,children:Array.from({length:n},(function(e,t){return!i||0===i.length||t>i.length-1?(0,z.jsx)(Koe,{slotId:t,locked:!0,className:Yoe.slot},t):(0,z.jsx)(Koe,{slotId:t,selected:r===t,focusKey:"Save->".concat(i[t].id),locked:i[t].locked,saveGame:i[t],className:Yoe.slot,onSelectSave:p,onSelect:f},t)}))})}),(0,z.jsx)("div",{className:Yoe.footer,children:null==o||m?void 0:(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(Vre,{className:Yoe.footerButton,disabled:g,onSelect:u,children:(0,z.jsx)(qc.Menu.LOAD_GAME_BUTTON,{})}),(0,z.jsx)(Vre,{className:Yoe.footerButton,disabled:g,onSelect:d,children:(0,z.jsx)(qc.Menu.SAVE_OPTIONS,{})})]})})]})})}));oe.add("game-ui/menu/components/load-game-screen/save-slots/save-slots.tsx",{get SaveSlots(){return $oe},set SaveSlots(e){$oe=e}});let qoe={content:"content_xXo","step-container":"step-container_Cmk",stepContainer:"step-container_Cmk",step:"step_buR",detail:"detail_T2m"};oe.add("game-ui/menu/components/load-game-screen/load-game-screen.module.scss",{get classes(){return qoe},set classes(e){Object.assign(qoe,e)}});const Xoe=qoe;function Qoe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Zoe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Joe(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Zoe(e,t,n[t])}))}return e}function eae(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Qoe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Qoe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var tae;!function(e){e[e.selection=0]="selection",e[e.options=1]="options"}(tae||(tae={}));var nae=Y.forwardRef((function(e,t){var n,r,i,o,a=e.focusKey,s=e.className,l=e.onClose,c=e.requireConfirmation,u=void 0!==c&&c,d=eae((0,Y.useState)(tae.selection),2),f=d[0],m=d[1],g=eae((0,Y.useState)(Mie.LastModified),2),h=g[0],p=g[1],v=xl(yG),b=(0,Y.useMemo)((function(){return Uie(v,h)}),[h,v]),y=eae((0,Y.useState)((function(){return function(e){var t=Uie(yG.value,e);return oC(t,"id")}(h)})),2),x=y[0],_=y[1],j=eae((0,Y.useState)(b.findIndex((function(e){return e.id===x}))),2),O=j[0],E=j[1],S=xl(mG),T=(0,Y.useMemo)((function(){return null!==(n=v.find((function(e){return e.id===x})))&&void 0!==n?n:null}),[v,x]),I=eae((0,Y.useState)(null!==(r=null==T?void 0:T.cityName)&&void 0!==r?r:""),2),w=I[0],P=I[1],C=eae((0,Y.useState)(null!==(i=null==T?void 0:T.theme)&&void 0!==i?i:""),2),N=C[0],A=C[1],L=xl(dG),M=eae((0,Y.useState)(null!==(o=Joe({},L,null==T?void 0:T.options))&&void 0!==o?o:Joe({},L)),2),k=M[0],R=M[1],D=function(e){var t=["theme","leftHandTraffic"];null!=e&&(e.options.unlockAll&&t.push("unlockAll"),e.options.unlimitedMoney&&t.push("unlimitedMoney"));return t}(T),F=eae(kG(),2),U=F[0],G=F[1],B=(0,Y.useContext)(dO),V=xl(aG),H=xl(jb),K=(0,Y.useCallback)((function(e){var t=v.find((function(t){return t.id===e}));null!=t&&(P(t.cityName),A(t.theme),R(Joe({},L,t.options)),_(e))}),[L,v]),W=(0,Y.useCallback)((function(){f===tae.options?(m(tae.selection),kp(Lp.closeMenu)):l()}),[f,l]),$=(0,Y.useCallback)((function(){f===tae.selection?(m(tae.options),kp(Lp.openMenu)):(m(tae.selection),kp(Lp.closeMenu))}),[f]),q=xl(GG),X=(0,Y.useCallback)((function(){if(x){var e=function(e){MG(U),SG({saveId:x,cityName:w,options:k},e)};if(u&&!q)return void B.showDialog((0,z.jsx)(OO,{title:(0,z.jsx)(qc.Common.WARNING,{}),message:(0,z.jsx)(qc.GameListScreen.CONFIRM_UNSAVED_MESSAGE,{}),onConfirm:e,dismissable:!0}));e(!1)}}),[w,B,q,k,u,x,U]),Q=(0,Y.useCallback)((function(){IG(T.id),m(tae.selection)}),[T]),Z=(0,Y.useCallback)((function(){wG(T.id)}),[T]),J=(0,Y.useMemo)((function(){return{"Save Options":function(){kp(Lp.selectItem),$()},"Load Game":function(){kp(Lp.selectItem),X()}}}),[X,$]);return(0,z.jsx)(r2,{ref:t,focusKey:a,title:rae(f),className:s,onClose:W,children:(0,z.jsx)(rp,{actions:J,children:3!==S?(0,z.jsx)("div",{className:Xoe.content,children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)("div",{className:Xoe.stepContainer,children:(0,z.jsxs)(Ud,{children:[f===tae.selection&&(0,z.jsx)(Cm,{styles:zne,children:-1===S?(0,z.jsx)(aoe,{selectedSave:x,ordering:h,className:Xoe.step,onSelectSave:K,onSelectOrdering:p}):(0,z.jsx)(Boe,{slots:S,selectedSlot:O,ordering:h,sortedSaves:b,className:Xoe.step,onSelectSave:K,onSelectOrdering:p,onSelectSlot:E})},tae.selection),f===tae.options&&(0,z.jsx)(Cm,{styles:D5,children:(0,z.jsx)(Die,{cityName:w,theme:N,options:k,disabledOptions:D,className:Xoe.step,onCityNameChange:P,onThemeChange:A,onOptionsChange:R,tutorialState:U,setTutorialState:G,onDeleteGame:(null==T?void 0:T.isReadonly)?void 0:Q,onShareGame:V||(null==T?void 0:T.isReadonly)||!H?void 0:Z})},tae.options)]})}),(0,z.jsx)(Gie,{save:T,activeStep:f,className:Xoe.detail,onOptionsToggle:$,onLoadGameSelect:X})]})}):(0,z.jsx)(Ap,{children:(0,z.jsxs)(Ud,{children:[f===tae.selection&&(0,z.jsx)(Cm,{styles:zne,children:(0,z.jsx)("div",{className:Xoe.content,children:(0,z.jsx)($oe,{slots:S,selectedSlot:O,sortedSaves:b,ordering:h,selectedSave:T,onSelectSave:K,onLoadGameSelect:X,onOptionsToggle:$,onSelectOrdering:p,onSelectSlot:E})})}),f===tae.options&&(0,z.jsx)(Cm,{styles:D5,children:(0,z.jsxs)("div",{className:Xoe.content,children:[(0,z.jsx)("div",{className:Xoe.stepContainer,children:(0,z.jsx)(Die,{cityName:w,theme:N,options:k,disabledOptions:D,className:Xoe.step,onCityNameChange:P,onThemeChange:A,onOptionsChange:R,tutorialState:U,setTutorialState:G,onDeleteGame:(null==T?void 0:T.isReadonly)?void 0:Q,onShareGame:V||(null==T?void 0:T.isReadonly)||!H?void 0:Z})}),(0,z.jsx)(Gie,{save:T,className:Xoe.detail,onOptionsToggle:$,onLoadGameSelect:X})]})})]})})})})}));function rae(e){return e===tae.selection?(0,z.jsx)(qc.Menu.LOAD_GAME,{}):e===tae.options?(0,z.jsx)(qc.Menu.SAVE_OPTIONS,{}):null}function iae(){var e=(0,Y.useContext)(dO),t=xl(GG),n=xl(eG);return(0,Y.useCallback)((function(){n&&(t?DG(!1):e.showDialog((0,z.jsx)(OO,{title:(0,z.jsx)(qc.Common.WARNING,{}),message:(0,z.jsx)(qc.GameListScreen.CONFIRM_UNSAVED_MESSAGE,{}),onConfirm:DG,dismissable:!0})))}),[e,t,n])}function oae(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function aae(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function sae(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return oae(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return oae(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/menu/components/load-game-screen/load-game-screen.tsx",{get LoadGameStep(){return tae},set LoadGameStep(e){tae=e},get LoadGameScreen(){return nae},set LoadGameScreen(e){nae=e},get useQuickLoad(){return iae},set useQuickLoad(e){iae=e}});var lae=function(e){var t=e.onClose,n=e.focusKey,r=xl(JI),i=sae((0,Y.useState)(r),1)[0];cae(),(0,Y.useEffect)((function(){if(ew(!0),!i)return function(){return ew(!1)}}),[i]);var o=e4(),a=(0,Y.useMemo)((function(){return function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){aae(e,t,n[t])}))}return e}({Back:t,"Take Photo":function(){kp(Lp.takePhoto),rw()},"Hide UI":t},o)}),[t,o]);return(0,z.jsx)(mb,{children:(0,z.jsx)(rp,{actions:a,children:(0,z.jsx)(pj,{focusKey:n,focused:null,activation:yd.Always})})})};function cae(){fR(!(arguments.length>0&&void 0!==arguments[0])||arguments[0]?"hide-ui":void 0)}function uae(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function dae(){return dae=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},dae.apply(this,arguments)}function fae(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}oe.add("game-ui/game/components/free-camera-screen/free-camera-screen.tsx",{get FreeCameraScreen(){return lae},set FreeCameraScreen(e){lae=e},get useUIHidden(){return cae},set useUIHidden(e){cae=e}});var mae=function(e){var t=dae({},function(e){if(null==e)throw new TypeError("Cannot destructure "+e);return e}(e));return(0,z.jsx)(lb,fae(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){uae(e,t,n[t])}))}return e}({},t),{tinted:!0,theme:SO}))};oe.add("game-ui/common/input/button/floating-icon-button.tsx",{get FloatingIconButton(){return mae},set FloatingIconButton(e){mae=e}});let gae={enter:"enter_C0S enter_kO6","enter-active":"enter-active_ule enter-active_lrI",enterActive:"enter-active_ule enter-active_lrI",exit:"exit_TO8 exit_Von","exit-active":"exit-active_KS9 exit-active_jtN",exitActive:"exit-active_KS9 exit-active_jtN"};oe.add("game-ui/game/transitions/toolbar-panel-children.module.scss",{get classes(){return gae},set classes(e){Object.assign(gae,e)}});const hae=gae;var pae=Y.createContext(null);oe.add("game-ui/game/components/asset-menu/asset-detail-panel/asset-detail-panel-context.ts",{get AssetDetailPanelContext(){return pae},set AssetDetailPanelContext(e){pae=e}});let vae={"asset-category-tab-bar":"asset-category-tab-bar_IGA",assetCategoryTabBar:"asset-category-tab-bar_IGA","tab-icon":"tab-icon_YCN",tabIcon:"tab-icon_YCN",locked:"locked_u4O",lock:"lock_4IG",items:"items_gPf","close-button":"close-button_kMj",closeButton:"close-button_kMj"};oe.add("game-ui/game/components/asset-menu/asset-category-tab-bar/asset-category-tab-bar.module.scss",{get classes(){return vae},set classes(e){Object.assign(vae,e)}});const bae=vae;let yae={button:"button_Yym",icon:"icon_LAz",locked:"locked_jsF","item-inner":"item-inner_NKx",itemInner:"item-inner_NKx",highlight:"highlight_Y8Z",lock:"lock_HjE"};oe.add("game-ui/game/components/asset-menu/asset-category-tab-bar/category-item.module.scss",{get classes(){return yae},set classes(e){Object.assign(yae,e)}});const xae=yae;var _ae=function(e){var t=e.categories,n=e.selectedCategory,r=e.onChange,i=e.onClose,o=Pg();return(0,z.jsxs)("div",{className:bae.assetCategoryTabBar,children:[(0,z.jsx)("div",{className:bae.items,children:t.map((function(e){return(0,z.jsx)(jae,{singleTab:1===t.length,subCategory:e,selected:Qs(n,e.entity),onSelect:r},qs(e.entity))}))}),!o&&(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:Lj.closeIcon,theme:ub,className:_d()(Lj.closeButton,bae.closeButton),onSelect:i})]})},jae=function(e){var t=e.subCategory,n=e.selected,r=e.singleTab,i=void 0!==r&&r,o=e.onSelect;rh(t.uiTag,n&&!t.locked),ih(t.uiTag,n&&!t.locked);var a=(0,Y.useCallback)((function(){return o(t.entity)}),[o,t.entity]),s=(0,Y.useContext)(pae),l=(0,Y.useCallback)((function(){return s&&s.showDetails(t.entity)}),[t.entity,s]),c=(0,Y.useCallback)((function(){return s&&s.hideDetails(t.entity)}),[t.entity,s]);return(0,z.jsx)(tk,{uiTag:t.uiTag,active:!t.locked,disableBlinking:i,children:(0,z.jsx)(jh,{tooltip:!s&&(0,z.jsx)(qc.SubServices.NAME,{hash:t.name}),children:i?(0,z.jsxs)("div",{style:{position:"relative"},onMouseOver:l,onMouseLeave:c,children:[(0,z.jsx)("img",{src:t.icon,className:_d()(bae.tabIcon,t.locked&&bae.locked)}),t.locked&&(0,z.jsx)(_1,{className:bae.lock})]}):(0,z.jsxs)(lb,{focusKey:Hh,src:t.icon,selected:n,theme:xae,className:_d()(t.locked&&xae.locked),onSelect:a,onMouseOver:l,onMouseLeave:c,children:[(0,z.jsx)("div",{className:xae.itemInner}),t.highlight&&(0,z.jsx)(_4,{className:xae.highlight}),t.locked&&(0,z.jsx)(_1,{className:xae.lock})]})})})};oe.add("game-ui/game/components/asset-menu/asset-category-tab-bar/asset-category-tab-bar.tsx",{get AssetCategoryTabBar(){return _ae},set AssetCategoryTabBar(e){_ae=e}});let Oae={field:"field_AjF",icon:"icon_WOc",content:"content_dov"};oe.add("game-ui/game/components/asset-menu/asset-detail-panel/effect-field.module.scss",{get classes(){return Oae},set classes(e){Object.assign(Oae,e)}});const Eae=Oae;function Sae(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Tae(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Sae(e,t,n[t])}))}return e}var Iae=function(e){var t=e.type,n=e.delta,r=e.unit,i=(0,Y.useMemo)((function(){return function(e){switch(e){case yw.Attractiveness:return"Media/Game/Icons/Tourism.svg";case yw.CrimeAccumulation:case yw.PoliceStationUpkeep:return"Media/Game/Icons/Police.svg";case yw.DisasterWarningTime:case yw.DisasterDamageRate:return"Media/Game/Icons/Disaster.svg";case yw.DiseaseProbability:return"Media/Game/Icons/Healthcare.svg";case yw.ParkEntertainment:return"Media/Game/Icons/ParksAndRecreation.svg";case yw.CriminalMonitorProbability:return"Media/Game/Icons/Police.svg";case yw.IndustrialAirPollution:return"Media/Game/Icons/AirPollution.svg";case yw.IndustrialGroundPollution:return"Media/Game/Icons/GroundPollution.svg";case yw.IndustrialGarbage:return"Media/Game/Icons/Garbage.svg";case yw.RecoveryFailChange:return"Media/Game/Icons/Healthcare.svg";case yw.OreResourceAmount:return"Media/Game/Icons/Coal.svg";case yw.OilResourceAmount:return"Media/Game/Icons/Oil.svg";case yw.UniversityInterest:return"Media/Game/Icons/Education.svg";case yw.OfficeSoftwareDemand:return"Media/Game/Icons/ZoneOfficeHigh.svg";case yw.IndustrialElectronicsDemand:return"Media/Game/Icons/ZoneIndustrialManufacturing.svg";case yw.OfficeSoftwareEfficiency:return"Media/Game/Icons/ZoneOfficeHigh.svg";case yw.IndustrialElectronicsEfficiency:return"Media/Game/Icons/ZoneIndustrialManufacturing.svg";case yw.TelecomCapacity:return"Media/Game/Icons/Telecom.svg";case yw.Entertainment:return"Media/Game/Icons/Leisure.svg";case yw.HighwayTrafficSafety:return"Media/Game/Icons/Roads.svg";case yw.PrisonTime:case yw.CrimeProbability:return"Media/Game/Icons/Police.svg";case yw.CollegeGraduation:case yw.UniversityGraduation:return"Media/Game/Icons/Graduation.svg";case yw.ImportCost:return"Media/Game/Icons/OutsideConnections.svg";case yw.LoanInterest:return"Media/Game/Icons/Money.svg";case yw.BuildingLevelingCost:return"Media/Game/Icons/BuildingLevel.svg";case yw.ExportCost:return"Media/Game/Icons/OutsideConnections.svg";case yw.TaxiStartingFee:return"Media/Game/Icons/Taxi.svg";case yw.IndustrialEfficiency:return"Media/Game/Icons/ZoneIndustrial.svg";case yw.OfficeEfficiency:return"Media/Game/Icons/ZoneOffice.svg";case yw.PollutionHealthAffect:return"Media/Game/Icons/AirPollution.svg";case yw.HospitalEfficiency:return"Media/Game/Icons/Healthcare.svg";default:return console.warn("Missing icon for CityModifierType.".concat(e,"!")),"Media/Placeholder.svg"}}(t)}),[t]);return(0,z.jsxs)("div",{className:Eae.field,children:[(0,z.jsx)("img",{src:i,className:Eae.icon}),(0,z.jsx)("div",{className:Eae.content,children:(0,z.jsx)(qc.Properties.CITY_MODIFIER_EFFECT,{TYPE:(0,z.jsx)(qc.Properties.CITY_MODIFIER,{hash:t}),DELTA:(0,z.jsx)(su,{value:n,unit:r,signed:!0})})})]})};var wae=function(e){var t=e.type,n=e.delta,r=e.unit,i=e.radius,o=(0,Y.useMemo)((function(){return function(e){switch(e){case xw.CrimeAccumulation:return"Media/Game/Icons/Police.svg";case xw.ForestFireResponseTime:case xw.ForestFireHazard:return"Media/Game/Icons/FireSafety.svg";case xw.Wellbeing:return"Media/Game/Icons/WellBeing.svg";case xw.Health:return"Media/Game/Icons/Healthcare.svg";default:return console.warn("Missing icon for LocalModifierType.".concat(e,"!")),"Media/Placeholder.svg"}}(t)}),[t]);return(0,z.jsxs)("div",{className:Eae.field,children:[(0,z.jsx)("img",{src:o,className:Eae.icon}),(0,z.jsx)("div",{className:Eae.content,children:(0,z.jsx)(qc.Properties.LOCAL_MODIFIER_EFFECT,{TYPE:(0,z.jsx)(qc.Properties.LOCAL_MODIFIER,{hash:t}),DELTA:(0,z.jsx)(su,{value:n,unit:r,signed:!0}),RADIUS:(0,z.jsx)(su,{value:i,unit:$c.Length})})})]})};var Pae,Cae=function(e){var t=e.effect,n=e.targetKey,r=e.icon,i=e.typeKey;return(0,z.jsxs)("div",{className:Eae.field,children:[(0,z.jsx)("img",{src:r,className:Eae.icon}),(0,z.jsx)("div",{className:Eae.content,children:(0,z.jsx)(qc.Properties.ADJUST_HAPPINESS_MODIFIER_EFFECT,{TYPE:(0,z.jsx)(qc.Properties.ADJUST_HAPPINESS_MODIFIER_TYPE,{hash:i}),DELTA:(0,z.jsx)(su,{value:t,unit:$c.Percentage,signed:!0}),TARGET:(0,z.jsx)(qc.Properties.ADJUST_HAPPINESS_MODIFIER_TARGET,{hash:n})})})]})},Nae=(Sae(Pae={},bw.CityModifier,(function(e){var t=e.modifiers;return(0,z.jsx)(z.Fragment,{children:t.map((function(e,t){return(0,z.jsx)(Iae,Tae({},e),t)}))})})),Sae(Pae,bw.LocalModifier,(function(e){var t=e.modifiers;return(0,z.jsx)(z.Fragment,{children:t.map((function(e,t){return(0,z.jsx)(wae,Tae({},e),t)}))})})),Sae(Pae,bw.LeisureProvider,(function(e){var t=e.type,n=e.efficiency;return(0,z.jsxs)("div",{className:Eae.field,children:[(0,z.jsx)("img",{src:"Media/Game/Icons/Leisure.svg",className:Eae.icon}),(0,z.jsx)("div",{className:Eae.content,children:(0,z.jsx)(qc.Properties.LEISURE_PROVIDER_EFFECT,{TYPE:(0,z.jsx)(qc.Properties.LEISURE_TYPE,{hash:t}),EFFICIENCY:(0,z.jsx)(su,{value:n,unit:$c.Integer,signed:!0})})})]})})),Sae(Pae,bw.AdjustHappinessEffect,(function(e){var t=e.wellbeingEffect,n=e.healthEffect,r=e.targets;return(0,z.jsxs)(z.Fragment,{children:[t>0&&r.map((function(e){return(0,z.jsx)(Cae,{effect:t,targetKey:e,icon:"Media/Game/Icons/WellBeing.svg",typeKey:"Wellbeing"},e)})),n>0&&r.map((function(e){return(0,z.jsx)(Cae,{effect:n,targetKey:e,icon:"Media/Game/Icons/Healthcare.svg",typeKey:"Health"},e)}))]})})),Pae);oe.add("game-ui/game/components/asset-menu/asset-detail-panel/effect-field.tsx",{get prefabEffectComponents(){return Nae},set prefabEffectComponents(e){Nae=e}});var Aae="Game.UI.Common.NumberProperty",Lae="Game.UI.Common.Number2Property",Mae="Game.UI.Common.StringProperty";function kae(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}oe.add("game-ui/common/property-field/typed-property.ts",{get NUMBER_PROPERTY(){return Aae},set NUMBER_PROPERTY(e){Aae=e},get NUMBER2_PROPERTY(){return Lae},set NUMBER2_PROPERTY(e){Lae=e},get STRING_PROPERTY(){return Mae},set STRING_PROPERTY(e){Mae=e}});var Rae,Dae=function(e){var t=e.labelId,n=e.unit,r=e.value,i=e.signed;return(0,z.jsx)(Dre,{label:(0,z.jsx)(kc,{id:t}),children:(0,z.jsx)(su,{value:r,unit:n,signed:i})})},Fae=function(e){var t=e.labelId,n=e.unit,r=e.value,i=e.signed,o=n.includes("money");return(0,z.jsxs)(Dre,{label:(0,z.jsx)(kc,{id:t}),children:[(0,z.jsx)(su,{value:r.x,unit:o?$c.Money:void 0}),"–",(0,z.jsx)(su,{value:r.y,unit:n,signed:i})]})},Uae=function(e){var t=e.labelId,n=e.valueId;return(0,z.jsx)(Dre,{label:(0,z.jsx)(kc,{id:t}),children:(0,z.jsx)(kc,{id:n})})},Gae=(kae(Rae={},Aae,Dae),kae(Rae,Lae,Fae),kae(Rae,Mae,Uae),Rae);oe.add("game-ui/common/property-field/typed-property-field.tsx",{get NumberPropertyField(){return Dae},set NumberPropertyField(e){Dae=e},get Number2PropertyField(){return Fae},set Number2PropertyField(e){Fae=e},get StringPropertyField(){return Uae},set StringPropertyField(e){Uae=e},get propertyFieldComponents(){return Gae},set propertyFieldComponents(e){Gae=e}});let Bae={field:"field_rIn",header:"header_lrj",content:"content_RIT",icon:"icon_tiy",value:"value_Yc3"};oe.add("game-ui/game/components/asset-menu/asset-detail-panel/property-field.module.scss",{get classes(){return Bae},set classes(e){Object.assign(Bae,e)}});const Vae=Bae;function Hae(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Kae(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Wae(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Hae(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Hae(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var zae,Yae=function(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Kae(e,t,n[t])}))}return e}({},Gae),(Kae(zae={},Iw,(function(e){var t=e.electricityConsumption,n=e.waterConsumption,r=e.garbageAccumulation;return(0,z.jsxs)(z.Fragment,{children:[t>0&&(0,z.jsx)(Dre,{label:(0,z.jsx)(qc.Properties.ELECTRICITY_CONSUMPTION,{}),children:(0,z.jsx)(su,{value:t,unit:$c.Power})}),n>0&&(0,z.jsx)(Dre,{label:(0,z.jsx)(qc.Properties.WATER_CONSUMPTION,{}),children:(0,z.jsx)(su,{value:n,unit:$c.VolumePerMonth})}),r>0&&(0,z.jsx)(Dre,{label:(0,z.jsx)(qc.Properties.GARBAGE_ACCUMULATION,{}),children:(0,z.jsx)(su,{value:r,unit:$c.WeightPerMonth})})]})})),Kae(zae,ww,(function(e){var t=e.groundPollution,n=e.airPollution,r=e.noisePollution;return(0,z.jsxs)(z.Fragment,{children:[t>Tw.none&&(0,z.jsxs)(Dre,{label:(0,z.jsx)(qc.SelectedInfoPanel.POLLUTION_LEVELS_GROUND,{}),children:[(0,z.jsx)("img",{src:"Media/Game/Icons/GroundPollution.svg",className:Vae.icon}),(0,z.jsx)("div",{className:Vae.value,children:(0,z.jsx)(qc.SelectedInfoPanel.POLLUTION_LEVELS,{index:t})})]}),n>Tw.none&&(0,z.jsxs)(Dre,{label:(0,z.jsx)(qc.SelectedInfoPanel.POLLUTION_LEVELS_AIR,{}),children:[(0,z.jsx)("img",{src:"Media/Game/Icons/AirPollution.svg",className:Vae.icon}),(0,z.jsx)("div",{className:Vae.value,children:(0,z.jsx)(qc.SelectedInfoPanel.POLLUTION_LEVELS,{index:n})})]}),r>Tw.none&&(0,z.jsxs)(Dre,{label:(0,z.jsx)(qc.SelectedInfoPanel.POLLUTION_LEVELS_NOISE,{}),children:[(0,z.jsx)("img",{src:"Media/Game/Icons/NoisePollution.svg",className:Vae.icon}),(0,z.jsx)("div",{className:Vae.value,children:(0,z.jsx)(qc.SelectedInfoPanel.POLLUTION_LEVELS,{index:r})})]})]})})),Kae(zae,Cw,(function(e){var t=e.labelId,n=e.minCapacity,r=e.maxCapacity,i=e.voltage;return(0,z.jsx)(Dre,{label:(0,z.jsx)(kc,{id:t}),children:(0,z.jsx)(qc.Properties.POWER_VOLTAGE_FORMAT,{VALUE:(0,z.jsx)(Ou,{min:n,max:r,unit:$c.Power}),VOLTAGE:(0,z.jsx)(qc.Properties.VOLTAGE,{index:i})})})})),Kae(zae,Lw,(function(e){var t=e.stops;return(0,z.jsx)(z.Fragment,{children:Object.entries(t).map((function(e,t){var n=Wae(e,2),r=n[0],i=n[1];return i>0&&(0,z.jsx)(Dre,{label:(0,z.jsx)(qc.Properties.TRANSPORT_STOP_COUNT,{hash:r}),children:(0,z.jsx)(su,{value:i,unit:$c.Integer})},t)}))})})),zae)),$ae=function(e){var t=e.data;return(0,z.jsx)(Rre.Provider,{value:Vae,children:(0,z.jsx)(vD,{components:Yae,data:t})})};oe.add("game-ui/game/components/asset-menu/asset-detail-panel/property-field.tsx",{get PrefabPropertyFields(){return $ae},set PrefabPropertyFields(e){$ae=e}});let qae={"asset-detail-panel":"asset-detail-panel_hf8",assetDetailPanel:"asset-detail-panel_hf8","title-bar":"title-bar_I7O child-opacity-transition_nkS",titleBar:"title-bar_I7O child-opacity-transition_nkS",title:"title_qub","construction-cost-field":"construction-cost-field_I8G",constructionCostField:"construction-cost-field_I8G","not-enough-money":"not-enough-money_vtd",notEnoughMoney:"not-enough-money_vtd","construction-cost-icon":"construction-cost-icon_hgB",constructionCostIcon:"construction-cost-icon_hgB",row:"row_H0d child-opacity-transition_nkS",content:"content_rep row_H0d child-opacity-transition_nkS","preview-container":"preview-container_sPA",previewContainer:"preview-container_sPA",preview:"preview_MDY",column:"column_dTT",description:"description_ZQn",effects:"effects_y8n","stats-row":"stats-row_Q3F row_H0d child-opacity-transition_nkS",statsRow:"stats-row_Q3F row_H0d child-opacity-transition_nkS","requirements-row":"requirements-row_yaX row_H0d child-opacity-transition_nkS",requirementsRow:"requirements-row_yaX row_H0d child-opacity-transition_nkS","already-built-row":"already-built-row_NJp row_H0d child-opacity-transition_nkS",alreadyBuiltRow:"already-built-row_NJp row_H0d child-opacity-transition_nkS"};oe.add("game-ui/game/components/asset-menu/asset-detail-panel/asset-detail-panel.module.scss",{get classes(){return qae},set classes(e){Object.assign(qae,e)}});const Xae=qae;var Qae=Y.forwardRef((function(e,t){var n,r,i=e.entity,o=e.className,a=e.upgrade,s=void 0!==a&&a,l=null!==(n=Ol(Ow,i))&&void 0!==n?n:Sw,c=null!==(r=Ol(NL,i))&&void 0!==r?r:Sw,u=s?c:l,d=u.properties.length>0,f=u.uniquePlaced||u.locked&&u.requirements.requireAll.length+u.requirements.requireAny.length>0;return(0,z.jsxs)("div",{ref:t,className:_d()(Xae.assetDetailPanel,o),children:[(0,z.jsxs)("div",{className:Xae.titleBar,children:[(0,z.jsx)("div",{className:Xae.title,children:(0,z.jsx)(kc,{id:u.titleId})}),null!=u.constructionCost&&("number"==typeof u.constructionCost.value?(0,z.jsx)(Zae,{value:u.constructionCost.value,unit:u.constructionCost.unit}):(0,z.jsx)(Jae,{value:u.constructionCost.value,unit:u.constructionCost.unit}))]}),(0,z.jsxs)("div",{className:Xae.content,children:[(0,z.jsx)("div",{className:Xae.previewContainer,children:(0,z.jsx)("img",{src:u.icon,className:Xae.preview})}),(0,z.jsxs)("div",{className:Xae.column,children:[null!=u.descriptionId&&(0,z.jsx)(Fv,{className:Xae.description,children:(0,z.jsx)(kc,{id:u.descriptionId})}),u.effects.length>0&&(0,z.jsx)("div",{className:Xae.effects,children:(0,z.jsx)(vD,{components:Nae,data:u.effects})})]})]}),d&&(0,z.jsx)("div",{className:Xae.statsRow,children:(0,z.jsx)($ae,{data:u.properties})}),!u.uniquePlaced&&f&&(0,z.jsx)(M9,{requirements:u.requirements,className:Xae.requirementsRow}),u.uniquePlaced&&(0,z.jsx)("div",{className:Xae.alreadyBuiltRow,children:(0,z.jsx)(qc.Toolbar.ASSET_ALREADY_BUILT,{})})]})})),Zae=function(e){var t=e.value,n=e.unit,r=xl(iL);return(0,z.jsxs)("div",{className:_d()(Xae.constructionCostField,r<t&&Xae.notEnoughMoney),children:[(0,z.jsx)("div",{children:(0,z.jsx)(su,{value:t,unit:n})}),(0,z.jsx)(tb,{src:"Media/Glyphs/Money.svg",className:Xae.constructionCostIcon})]})},Jae=function(e){var t=e.value,n=e.unit,r=xl(iL);return(0,z.jsxs)("div",{className:_d()(Xae.constructionCostField,r<t.x&&Xae.notEnoughMoney),children:[(0,z.jsx)("div",{children:(0,z.jsx)(su,{value:t.y,unit:n})}),(0,z.jsx)(tb,{src:"Media/Glyphs/Money.svg",className:Xae.constructionCostIcon})]})};function ese(e,t,n){return(0,Y.useMemo)((function(){if(null==n)return[];var r=n*t;if(r>=e.length)return[];var i=Math.min(r+t,e.length);return e.slice(r,i)}),[n,t,e])}oe.add("game-ui/game/components/asset-menu/asset-detail-panel/asset-detail-panel.tsx",{get AssetDetailPanel(){return Qae},set AssetDetailPanel(e){Qae=e},get ConstructionCost(){return Zae},set ConstructionCost(e){Zae=e},get NetConstructionCost(){return Jae},set NetConstructionCost(e){Jae=e}}),oe.add("game-ui/common/hooks/use-page-items.ts",{get usePageItems(){return ese},set usePageItems(e){ese=e}});let tse={"dlc-badge":"dlc-badge_bHS",dlcBadge:"dlc-badge_bHS"};oe.add("game-ui/game/components/asset-menu/badges/dlc-badge.module.scss",{get classes(){return tse},set classes(e){Object.assign(tse,e)}});const nse=tse;var rse=function(e){var t=e.icon,n=e.style,r=e.className;return(0,z.jsx)("img",{src:t,className:_d()(nse.dlcBadge,r),style:n})};oe.add("game-ui/game/components/asset-menu/badges/dlc-badge.tsx",{get DlcBadge(){return rse},set DlcBadge(e){rse=e}});let ise={"asset-grid":"asset-grid_H7_",assetGrid:"asset-grid_H7_",content:"content_O28",row:"row_nrc",item:"item_KJ3 item-hover_WK8 item-active_Spn",thumbnail:"thumbnail_kkU","not-enough-money":"not-enough-money__6E",notEnoughMoney:"not-enough-money__6E","item-inner":"item-inner_hCN",itemInner:"item-inner_hCN",highlight:"highlight_VDQ",lock:"lock_w5T",dlc:"dlc_iKq","already-built":"already-built_NqB",alreadyBuilt:"already-built_NqB","not-enough-money-badge":"not-enough-money-badge_S3U",notEnoughMoneyBadge:"not-enough-money-badge_S3U","page-indicators":"page-indicators_Z3v",pageIndicators:"page-indicators_Z3v","page-indicator":"page-indicator_zOa",pageIndicator:"page-indicator_zOa"};oe.add("game-ui/game/components/asset-menu/asset-grid/asset-grid.module.scss",{get classes(){return ise},set classes(e){Object.assign(ise,e)}});const ose=ise;function ase(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function sse(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||cse(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function lse(e){return function(e){if(Array.isArray(e))return ase(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||cse(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function cse(e,t){if(e){if("string"==typeof e)return ase(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?ase(e,t):void 0}}var use=18,dse=function(e){var t=e.className,n=xl(qA),r=xl(XA),i=Ol(WA,n),o=DL(eL),a=Math.ceil(i.length/use),s=mse(i,use,r),l=ese(i,use,s),c=(0,Y.useMemo)((function(){return{"Move Vertical":function(e){var t=i.findIndex((function(e){return Qs(e.entity,r)}))%2;if(e<0){if(s<a-1){var n=Math.min((s+1)*use+t,i.length-1);return eL(i[n].entity),!0}}else if(e>0){if(s>0)return eL(i[(s-1)*use+9+t].entity),!0}return!1}}}),[i,a,r,s]),u=(0,Y.useMemo)((function(){return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)("div",{className:ose.content,children:(0,z.jsx)(Ip,{focused:qs(r),onChange:o,children:lse(Array(2)).map((function(e,t){return(0,z.jsx)("div",{className:ose.row,children:l.slice(9*t,9*(t+1)).map((function(e){return(0,z.jsx)(fse,{asset:e,selected:Qs(e.entity,r),onSelect:eL},qs(e.entity))}))},t)}))})}),(0,z.jsx)("div",{className:ose.pageIndicators,children:a>1&&lse(Array(a).keys()).map((function(e){return(0,z.jsx)("div",{onClick:function(){return eL(i[e*use].entity)},className:_d()(ose.pageIndicator,e===s&&"selected")},e)}))})]})}),[i,o,a,l,r,s]);return(0,z.jsx)(z.Fragment,{children:(0,z.jsx)(rp,{actions:c,disabled:a<2,children:(0,z.jsx)("div",{className:_d()(ose.assetGrid,t),children:zL(u)})})})},fse=function(e){var t=e.asset,n=e.selected,r=e.onSelect;rh(t.uiTag,n&&!t.locked),ih(t.uiTag,n&&!t.locked);var i=sse((0,Y.useState)(!1),2),o=i[0],a=i[1],s=(0,Y.useContext)(pae),l=xl(iL),c=(0,Y.useCallback)((function(){return r(t.entity)}),[t.entity,r]),u=(0,Y.useCallback)((function(){return s&&s.showDetails(t.entity)}),[t.entity,s]),d=(0,Y.useCallback)((function(){return s&&s.hideDetails(t.entity)}),[t.entity,s]),f=!(t.locked||t.uniquePlaced)&&null!=t.constructionCost&&("number"==typeof t.constructionCost.value?l<t.constructionCost.value:l<t.constructionCost.value.x),m=Pg()&&o;return(0,Y.useEffect)((function(){null!=s&&(m?s.showDetails(t.entity):s.hideDetails(t.entity))}),[t.entity,s,m]),(0,z.jsx)(tk,{uiTag:t.uiTag,disableBlinking:n,active:!t.locked,children:(0,z.jsx)(Tg,{onFocusChange:a,children:(0,z.jsx)(jh,{tooltip:!s&&(0,z.jsx)(qc.Assets.NAME,{hash:t.name}),children:(0,z.jsxs)(Qp,{focusKey:qs(t.entity),selected:n,className:_d()(ose.item,f&&ose.notEnoughMoney),onClick:c,disabled:t.locked||t.uniquePlaced,onMouseOver:u,onMouseLeave:d,children:[(0,z.jsx)("div",{className:ose.itemInner}),(0,z.jsx)("img",{src:t.icon,onError:$v,className:ose.thumbnail}),t.uniquePlaced&&(0,z.jsx)("img",{src:"Media/Game/Icons/AlreadyBuilt.svg",className:ose.alreadyBuilt}),f&&(0,z.jsx)("img",{src:"Media/Game/Icons/NoMoney.svg",className:ose.notEnoughMoneyBadge}),t.highlight&&(0,z.jsx)(_4,{className:ose.highlight}),t.locked&&(0,z.jsx)(_1,{className:ose.lock}),t.dlc&&(0,z.jsx)(rse,{icon:t.dlc,className:ose.dlc})]})})})})};function mse(e,t,n){if(0===t)return 0;var r=e.findIndex((function(e){return Qs(e.entity,n)}));return-1===r?0:Math.trunc(r/t)}oe.add("game-ui/game/components/asset-menu/asset-grid/asset-grid.tsx",{get AssetGrid(){return dse},set AssetGrid(e){dse=e},get getSelectedPage(){return mse},set getSelectedPage(e){mse=e}});let gse={"asset-panel":"asset-panel_VFR",assetPanel:"asset-panel_VFR","gamepad-active":"gamepad-active_KKW",gamepadActive:"gamepad-active_KKW","detail-container":"detail-container_E9q",detailContainer:"detail-container_E9q","detail-panel":"detail-panel_izf",detailPanel:"detail-panel_izf"};oe.add("game-ui/game/components/asset-menu/asset-menu.module.scss",{get classes(){return gse},set classes(e){Object.assign(gse,e)}});const hse=gse;function pse(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function vse(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return pse(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return pse(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var bse=function(e){var t=e.focusKey,n=e.className,r=e.onClose;yj(vj);var i=Pg(),o=vse((0,Y.useState)(ty),2),a=o[0],s=o[1],l=!Qs(a,ty),c=(0,Y.useMemo)((function(){return{showDetails:function(e){return s(e)},hideDetails:function(e){return s((function(t){return Qs(t,e)?ty:t}))}}}),[]);(0,Y.useEffect)((function(){if(i&&l){var e=Qm.subscribe((function(e){e&&s(ty)}));return function(){return e.dispose()}}}),[i,l]);var u=zL(xl($A)),d=zL(xl(qA)),f=Ol(KA,u),m=Ol(Ow,u);rh(null==m?void 0:m.uiTag,!(null==m?void 0:m.locked)),ih(null==m?void 0:m.uiTag);var g=(0,Y.useMemo)((function(){return{Back:r,"Switch Tab":f.length>=2?function(e){var t=f.findIndex((function(e){return Qs(e.entity,d)}));if(e<0){var n=cC(t,f.length,!0);null!=n&&(JA(f[n].entity),kp(Lp.selectPreviousItem))}else if(e>0){var r=sC(t,f.length,!0);null!=r&&(JA(f[r].entity),kp(Lp.selectNextItem))}}:null}}),[f,r,d]);return(0,z.jsx)(rp,{actions:g,children:(0,z.jsx)(Cm,{styles:hae,children:(0,z.jsxs)(Yv,{focusKey:t,className:n,children:[(0,z.jsx)("div",{className:hse.detailContainer,children:l&&(0,z.jsx)(Qae,{entity:a,className:hse.detailPanel},"details")}),(0,z.jsx)(pae.Provider,{value:c,children:(0,z.jsx)(qj,{className:_d()(hse.assetPanel,i&&hse.gamepadActive),header:f.length>0?(0,z.jsx)(_ae,{categories:f,selectedCategory:d,onChange:JA,onClose:r}):void 0,children:(0,z.jsx)(dse,{})})})]})})})};oe.add("game-ui/game/components/asset-menu/asset-menu.tsx",{get AssetMenu(){return bse},set AssetMenu(e){bse=e}});let yse={header:"header_emp header_Bpo child-opacity-transition_nkS",content:"content__Ej content_AD7 child-opacity-transition_nkS",footer:"footer_kk9 footer_pD5 child-opacity-transition_nkS",title:"title_h2h title_zQN"};oe.add("game-ui/common/panel/themes/light-opaque.module.scss",{get classes(){return yse},set classes(e){Object.assign(yse,e)}});const xse=yse;let _se={"chirp-layout":"chirp-layout_IRk",chirpLayout:"chirp-layout_IRk",avatar:"avatar_h3G",padded:"padded_FS6",content:"content_ysS",header:"header_eEy",sender:"sender_lDZ",date:"date_GKh",message:"message_Y0C",footer:"footer_3qO","like-button":"like-button_LNZ",likeButton:"like-button_LNZ",liked:"liked_F9N"};oe.add("game-ui/game/components/chirper/items/chirp-layout.module.scss",{get classes(){return _se},set classes(e){Object.assign(_se,e)}});const jse=_se;var Ose=["#571f1f","#841212","#9c1a4b","#cd3c73","#ec7692","#8a7c17","#bf9e04","#e7a415","#fdc61e","#fcdb56","#2a571f","#13900a","#57b12b","#2eb077","#40dbae","#1f4057","#0f5c91","#3d7ac4","#3599ff","#7db0ea","#491f57","#671284","#a148ab","#c660ca","#d687e2"];function Ese(e){return e>0?Ose[e%Ose.length]:void 0}var Sse={tension:30,friction:10},Tse=function(e){var t,n,r=e.focusKey,i=e.chirp,o=e.className,a=(0,Y.useCallback)((function(){i.liked?YS(i.entity):zS(i.entity)}),[i.entity,i.liked]),s=(0,Y.useCallback)((function(){$S(i.sender.link.target)}),[i]),l=(0,Y.useMemo)((function(){return{"Select Chirp Sender":function(){kp(Lp.selectItem),s()},"Like Chirp":i.liked?null:function(){kp(Lp.likeChirp),zS(i.entity)},"Unlike Chirp":i.liked?function(){kp(Lp.likeChirp),YS(i.entity)}:null}}),[i.entity,i.liked,s]),c=xl(TN),u=DN(c,xl(wN)),d=(0,Y.useMemo)((function(){return UN(c,i.date)}),[i.date,c]),f=pd(),m=(0,Y.useMemo)((function(){return f(i.sender.link.name)}),[i.sender.link.name,f]),g=function(e,t){var n=(0,Y.useMemo)((function(){return e.links.reduce((function(e,n,r){var i=t(n.name);return e["LINK_".concat(r)]="<".concat(n.target,"|").concat(i,">"),e["LINK_NAME_".concat(r)]=i,e["LINK_TARGET_".concat(r)]=n.target,e}),{})}),[e.links,t]);return(0,z.jsx)(Fv,{onLinkSelect:$S,children:(0,z.jsx)(kc,{id:e.messageId,args:n})})}(i,f),h=Math.round(YZ(Sse,i.likes,void 0,!0));return(0,z.jsx)(rp,{actions:l,children:(0,z.jsxs)(Yv,{focusKey:r,className:_d()(jse.chirpLayout,o),children:[(0,z.jsx)(lb,{focusKey:Hh,src:null!==(n=i.sender.avatar)&&void 0!==n?n:"Media/Game/Misc/ChirperBlankAvatar.svg",disabled:""===i.sender.link.target,className:_d()(jse.avatar,(null===(t=i.sender.avatar)||void 0===t?void 0:t.endsWith(".svg"))&&jse.padded),style:{backgroundColor:Ese(i.sender.randomIndex)},onSelect:s}),(0,z.jsxs)("div",{className:jse.content,children:[(0,z.jsxs)("div",{className:jse.header,children:[(0,z.jsx)(Qp,{focusKey:Hh,className:jse.sender,onSelect:s,disabled:""===i.sender.link.target,children:m}),(0,z.jsx)("div",{className:jse.date,children:kN(u,d)?(0,z.jsx)(Xu,{value:d}):(0,z.jsx)(Yu,{value:d})})]}),(0,z.jsx)("div",{className:jse.message,children:g}),(0,z.jsxs)("div",{className:jse.footer,children:[(0,z.jsx)(su,{value:i.liked?h+1:h,unit:$c.IntegerRounded}),(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:i.liked?"Media/Glyphs/HeartFilled.svg":"Media/Glyphs/HeartOutline.svg",className:_d()(jse.likeButton,i.liked&&jse.liked),selectSound:Lp.likeChirp,onSelect:a})]})]})]})})};oe.add("game-ui/game/components/chirper/items/chirp-layout.tsx",{get getRandomAvatarColor(){return Ese},set getRandomAvatarColor(e){Ese=e},get ChirpLayout(){return Tse},set ChirpLayout(e){Tse=e}});let Ise={"item-transition":"item-transition_UXZ",itemTransition:"item-transition_UXZ",enter:"enter_eca","enter-active":"enter-active_bH4",enterActive:"enter-active_bH4",exit:"exit_Jp9","exit-active":"exit-active_rih",exitActive:"exit-active_rih",container:"container_Z2a",space:"space_emJ","event-item":"event-item_q35",eventItem:"event-item_q35","event-date":"event-date_xTF",eventDate:"event-date_xTF","event-label":"event-label_BDa container_Z2a",eventLabel:"event-label_BDa container_Z2a"};oe.add("game-ui/game/components/chirper/items/chirper-items.module.scss",{get classes(){return Ise},set classes(e){Object.assign(Ise,e)}});const wse=Ise;var Pse=function(e){var t=e.focusKey,n=e.style,r=e.children;return(0,z.jsx)(aS,{styles:wse,children:(0,z.jsxs)("div",{className:wse.itemTransition,style:n,children:[(0,z.jsx)(Yv,{focusKey:t,focusSound:Lp.hoverItem,className:wse.container,children:r}),(0,z.jsx)("div",{className:wse.space})]})})},Cse=function(e){var t=e.focusKey,n=e.date,r=e.children;return(0,z.jsx)(aS,{styles:wse,children:(0,z.jsxs)("div",{className:wse.itemTransition,children:[(0,z.jsxs)("div",{className:wse.eventItem,children:[(0,z.jsx)("div",{className:wse.eventDate,children:(0,z.jsx)(Yu,{value:n})}),(0,z.jsx)(Yv,{focusKey:t,focusSound:Lp.hoverItem,className:wse.eventLabel,children:r})]}),(0,z.jsx)("div",{className:wse.space})]})})};oe.add("game-ui/game/components/chirper/items/chirper-items.tsx",{get ContainerItem(){return Pse},set ContainerItem(e){Pse=e},get EventItem(){return Cse},set EventItem(e){Cse=e}});let Nse={"chirper-panel":"chirper-panel_kDN",chirperPanel:"chirper-panel_kDN",scrollable:"scrollable_SAp"};oe.add("game-ui/game/components/chirper/chirper-panel.module.scss",{get classes(){return Nse},set classes(e){Object.assign(Nse,e)}});const Ase=Nse;var Lse=function(e){var t,n,r,i=e.className,o=e.onClose,a=xl(KS),s=XQ(),l=(0,Y.useContext)(Md);return rh(null===(t=Ew.value)||void 0===t?void 0:t.chirperPanel,a.length>0),(0,Y.useEffect)((function(){if(!l){var e=WS.subscribe((function(){s.smoothScrollTo(0,0),kp(Lp.chirpEvent)}));return function(){return e.dispose()}}}),[l,s]),(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.chirperPanel,disableBlinking:!0,children:(0,z.jsx)(qj,{theme:xse,header:(0,z.jsx)(tO,{children:(0,z.jsx)(qc.Chirper.PANEL_TITLE,{})}),transitionSounds:vj,className:_d()(Ase.chirperPanel,i),onClose:o,children:a.length>0?(0,z.jsx)(tk,{uiTag:null===(r=Ew.value)||void 0===r?void 0:r.chirperPanelChirps,children:(0,z.jsx)(gE,{controller:s,className:Ase.scrollable,children:(0,z.jsx)(Ap,{children:(0,z.jsx)(Ud,{children:a.map((function(e){return(0,z.jsx)(Pse,{children:(0,z.jsx)(Tse,{chirp:e})},qs(e.entity))}))})})})}):(0,z.jsx)(a2,{children:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.Chirper.OPENING_MESSAGE,{})})})})})};oe.add("game-ui/game/components/chirper/chirper-panel.tsx",{get ChirperPanel(){return Lse},set ChirperPanel(e){Lse=e}});let Mse={"detail-layout":"detail-layout_vME",detailLayout:"detail-layout_vME",scrollable:"scrollable_sRo",header:"header_Vle","icon-container":"icon-container_FJv",iconContainer:"icon-container_FJv",icon:"icon_IKT",title:"title_UOl",description:"description_VWf",content:"content_AGf",bottom:"bottom_fjL"};oe.add("game-ui/common/section/detail-layout/detail-layout.module.scss",{get classes(){return Mse},set classes(e){Object.assign(Mse,e)}});const kse=Mse;var Rse=function(e){var t=e.icon,n=e.title,r=e.description,i=e.bottom,o=e.className,a=e.children,s=Y.Children.count(a)>0,l=Y.Children.count(i)>0;return(0,z.jsxs)("div",{className:_d()(kse.detailLayout,o),children:[(0,z.jsxs)(gE,{autoScroll:!0,className:kse.scrollable,children:[(0,z.jsxs)("div",{className:kse.header,children:[t&&(0,z.jsx)("div",{className:kse.iconContainer,children:(0,z.jsx)("img",{src:t,className:kse.icon})}),(0,z.jsx)("div",{className:kse.title,children:n})]}),(0,z.jsx)("div",{className:kse.description,children:(0,z.jsx)(Fv,{children:r})}),s&&(0,z.jsx)("div",{className:kse.content,children:a})]}),l&&(0,z.jsx)("div",{className:kse.bottom,children:i})]})};function Dse(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Fse(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Dse(e,t,n[t])}))}return e}function Use(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Gse(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}oe.add("game-ui/common/section/detail-layout/detail-layout.tsx",{get DetailLayout(){return Rse},set DetailLayout(e){Rse=e}});var Bse=Y.forwardRef((function(e,t){var n=e.focusKey,r=e.header,i=e.tooltip,o=e.theme,a=void 0===o?b3:o,s=e.className,l=e.children,c=e.onFocusChange,u=Gse(e,["focusKey","header","tooltip","theme","className","children","onFocusChange"]),d=p3(a),f=Y.Children.count(r)>0,m=Y.Children.count(l)>0,g=(0,Y.useMemo)((function(){return{theme:d,expanded:m}}),[m,d]);return(0,z.jsx)(jh,{tooltip:i,children:(0,z.jsx)(Yv,Use(Fse({ref:t,focusKey:n,className:_d()(d.section,s),onFocusChange:c},u),{children:(0,z.jsx)(g3.Provider,{value:g,children:(0,z.jsxs)(Ap,{direction:gp.Vertical,children:[f&&(0,z.jsx)("div",{className:_d()(d.header,d.first),children:r}),(0,z.jsx)("div",{className:_d()(d.content,!f&&d.first,d.last),children:l})]})})}))})}));oe.add("game-ui/common/section/section.tsx",{get Section(){return Bse},set Section(e){Bse=e}});let Vse={"unlocking-label":"unlocking-label_ctB",unlockingLabel:"unlocking-label_ctB",locked:"locked_rgX",unlocked:"unlocked_rws"};oe.add("game-ui/game/components/progression/unlocking-label/unlocking-label.module.scss",{get classes(){return Vse},set classes(e){Object.assign(Vse,e)}});const Hse=Vse;var Kse=function(e){var t=e.state;return(0,z.jsx)("div",{className:_d()("Locked"===t?Hse.locked:Hse.unlocked,Hse.unlockingLabel),children:"Locked"===t?(0,z.jsx)(qc.Common.LOCKED,{}):(0,z.jsx)(qc.Common.UNLOCKED,{})})};oe.add("game-ui/game/components/progression/unlocking-label/unlocking-label.tsx",{get UnlockingLabel(){return Kse},set UnlockingLabel(e){Kse=e}});let Wse={"unlocking-requirements":"unlocking-requirements_Usp",unlockingRequirements:"unlocking-requirements_Usp"};oe.add("game-ui/game/components/progression/unlocking-requirements/themes/detail-layout-unlocking-requirements.module.scss",{get classes(){return Wse},set classes(e){Object.assign(Wse,e)}});const zse=Wse;let Yse={"demand-bar":"demand-bar_WmU",demandBar:"demand-bar_WmU",icon:"icon_b9Y",locked:"locked_Lrk",lock:"lock_ezp"};oe.add("game-ui/game/components/city-info-panel/city-info-demand/demand-section/demand-bar.module.scss",{get classes(){return Yse},set classes(e){Object.assign(Yse,e)}});const $se=Yse;var qse=function(e){var t=e.icon,n=e.color,r=e.demand,i=e.locked,o=void 0!==i&&i,a=$O(),s=99*a,l=444*a,c=s/2,u=l-c,d=r*l,f=d<s?d-c*(d/s):d-c;return(0,z.jsxs)("div",{className:$se.demandBar,children:[(0,z.jsx)("img",{src:t,onError:$v,className:_d()($se.icon,o&&$se.locked)}),(0,z.jsxs)("svg",{viewBox:"0 0 ".concat(l," ").concat(s),className:$se.svg,height:"".concat(s),width:"".concat(l),children:[(0,z.jsxs)("linearGradient",{id:"monochrome",gradientUnits:"userSpaceOnUse",x1:0,x2:l,y1:0,y2:0,children:[(0,z.jsx)("stop",{offset:"0%",stopColor:"rgba(0, 0, 0, 0.2)"}),(0,z.jsx)("stop",{offset:"100%",stopColor:"rgba(0, 0, 0, 0)"})]}),(0,z.jsx)("polygon",{points:"0,0 0,".concat(s," ").concat(u,",").concat(s," ").concat(l,",").concat(c," ").concat(u,",0 0,0"),fill:o?"rgb(45, 46, 54)":"rgba(0, 0, 0, 0.45)"}),!o&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)("polygon",{points:"0,0 0,".concat(s," ").concat([f],",").concat(s," ").concat([d],",").concat(c," ").concat([f],",0 0,0"),fill:n}),(0,z.jsx)("polygon",{points:"0,0 0,".concat(s," ").concat([f],",").concat(s," ").concat([d],",").concat(c," ").concat([f],",0 0,0"),fill:"url(#monochrome)"})]})]}),o&&(0,z.jsx)(_1,{className:$se.lock})]})};oe.add("game-ui/game/components/city-info-panel/city-info-demand/demand-section/demand-bar.tsx",{get DemandBar(){return qse},set DemandBar(e){qse=e}});let Xse={"demand-factors":"demand-factors_RlK",demandFactors:"demand-factors_RlK",factor:"factor_iZk",label:"label_qWr",icon:"icon_d3_"};oe.add("game-ui/game/components/city-info-panel/city-info-demand/demand-section/demand-factors.module.scss",{get classes(){return Xse},set classes(e){Object.assign(Xse,e)}});const Qse=Xse;var Zse=function(e){var t=e.factors,n=e.locked,r=void 0!==n&&n;return(0,z.jsx)("div",{className:Qse.demandFactors,children:!r&&t.filter((function(e){return null!=e.factor})).map((function(e,t){return(0,z.jsx)(Jse,{factor:e},t)}))})},Jse=function(e){var t=e.factor;return(0,z.jsxs)("div",{className:Qse.factor,children:[(0,z.jsx)("img",{className:Qse.icon,src:t.weight<0?"Media/Game/Misc/DemandFactorNegative.svg":"Media/Game/Misc/DemandFactorPositive.svg",onError:$v}),(0,z.jsx)("div",{className:Qse.label,children:t.weight<0?(0,z.jsx)(qc.CityInfoPanel.DEMAND_FACTOR_NEGATIVE,{hash:t.factor}):(0,z.jsx)(qc.CityInfoPanel.DEMAND_FACTOR_POSITIVE,{hash:t.factor})})]})};oe.add("game-ui/game/components/city-info-panel/city-info-demand/demand-section/demand-factors.tsx",{get DemandFactors(){return Zse},set DemandFactors(e){Zse=e},get DemandFactorDetail(){return Jse},set DemandFactorDetail(e){Jse=e}});let ele={"demand-section":"demand-section_xG1",demandSection:"demand-section_xG1",title:"title_TAF title_PYv title_bwV",content:"content_Bmx"};oe.add("game-ui/game/components/city-info-panel/city-info-demand/demand-section/demand-section.module.scss",{get classes(){return ele},set classes(e){Object.assign(ele,e)}});const tle=ele;let nle={section:"section_egX section_sop section_gUk",header:"header_LLa header_l0j undefined",content:"content_lbR content_flM content_owQ",locked:"locked_dpm"};oe.add("game-ui/game/components/city-info-panel/city-info-demand/demand-section/demand-section-theme.module.scss",{get classes(){return nle},set classes(e){Object.assign(nle,e)}});const rle=nle;function ile(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var ole=function(e){var t=e.type,n=e.demand,r=e.unlocking,i=e.factors,o=e.className,a=e.onSelect,s=e.onHover,l=(0,Y.useCallback)((function(){return s(t)}),[s,t]),c=(0,Y.useCallback)((function(){return kp(Lp.hoverItem)}),[]),u=(0,Y.useCallback)((function(){return s(ule.None)}),[s]),d=(0,Y.useCallback)((function(e){e&&(a(t),kp(Lp.hoverItem))}),[a,t]),f=(0,Y.useCallback)((function(){a(t),kp(Lp.selectItem)}),[a,t]),m=function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){ile(e,t,n[t])}))}return e}({},b3,rle);return(0,z.jsx)(Bse,{theme:m,header:(0,z.jsx)("div",{className:tle.title,children:(0,z.jsx)(qc.CityInfoPanel.DEMAND_TITLE,{hash:ule[t]})}),onClick:f,onMouseOver:l,onMouseEnter:c,onMouseLeave:u,onFocusChange:d,className:_d()(tle.demandSection,(null==r?void 0:r.locked)&&m.locked,o),children:(0,z.jsxs)("div",{className:tle.content,children:[(0,z.jsx)(qse,{icon:fle[t],color:dle[t],demand:(null==r?void 0:r.locked)?0:n,locked:null==r?void 0:r.locked}),(0,z.jsx)(Zse,{factors:i,locked:null==r?void 0:r.locked})]})})};oe.add("game-ui/game/components/city-info-panel/city-info-demand/demand-section/demand-section.tsx",{get DemandSection(){return ole},set DemandSection(e){ole=e}});let ale={"demand-page":"demand-page_X1J",demandPage:"demand-page_X1J","main-column":"main-column_cMY",mainColumn:"main-column_cMY",scrollable:"scrollable_VIF","info-column":"info-column_dEc",infoColumn:"info-column_dEc","demand-row":"demand-row_CQi",demandRow:"demand-row_CQi"};oe.add("game-ui/game/components/city-info-panel/city-info-demand/demand-page.module.scss",{get classes(){return ale},set classes(e){Object.assign(ale,e)}});const sle=ale;function lle(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function cle(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return lle(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return lle(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var ule;!function(e){e[e.None=0]="None",e[e.ResidentialLow=1]="ResidentialLow",e[e.ResidentialMedium=2]="ResidentialMedium",e[e.ResidentialHigh=3]="ResidentialHigh",e[e.Commercial=4]="Commercial",e[e.Industrial=5]="Industrial",e[e.Office=6]="Office"}(ule||(ule={}));var dle=["","#8BDB46","#00AE1A","#2B7600","#46B2DB","#DBC246","#8D44AD"],fle=["","Media/Game/Icons/ZoneResidentialLow.svg","Media/Game/Icons/ZoneResidentialMedium.svg","Media/Game/Icons/ZoneResidentialHigh.svg","Media/Game/Icons/ZoneCommercial.svg","Media/Game/Icons/ZoneIndustrial.svg","Media/Game/Icons/ZoneOffice.svg"];function mle(){var e,t=xl(AT),n=xl(LT),r=xl(MT),i=xl(kT),o=xl(RT),a=xl(DT),s=xl(FT),l=xl(UT),c=xl(GT),u=xl(BT),d=xl(VT),f=xl(HT),m=Kw("ZonesOffice"),g=Kw("Residential Medium"),h=Kw("Residential High"),p=cle((0,Y.useState)(ule.ResidentialLow),2),v=p[0],b=p[1],y=cle((0,Y.useState)(ule.None),2),x=y[0],_=y[1],j=(0,Y.useMemo)((function(){return x!==ule.None?x:v}),[x,v]);return(0,z.jsx)(tk,{uiTag:null===(e=Ew.value)||void 0===e?void 0:e.cityInfoPanelDemandPage,children:(0,z.jsx)("div",{className:sle.demandPage,children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)("div",{className:sle.mainColumn,children:(0,z.jsxs)(gE,{className:sle.scrollable,children:[(0,z.jsx)(ole,{type:ule.ResidentialLow,demand:t,factors:s,onHover:_,onSelect:b,className:_d()(v===ule.ResidentialLow&&"selected",sle.demandRow)}),(0,z.jsx)(ole,{type:ule.ResidentialMedium,demand:n,factors:l,unlocking:g,onHover:_,onSelect:b,className:_d()(v===ule.ResidentialMedium&&"selected",sle.demandRow)}),(0,z.jsx)(ole,{type:ule.ResidentialHigh,demand:r,factors:c,unlocking:h,onHover:_,onSelect:b,className:_d()(v===ule.ResidentialHigh&&"selected",sle.demandRow)}),(0,z.jsx)(ole,{type:ule.Commercial,demand:i,factors:u,onHover:_,onSelect:b,className:_d()(v===ule.Commercial&&"selected",sle.demandRow)}),(0,z.jsx)(ole,{type:ule.Industrial,demand:o,factors:d,onHover:_,onSelect:b,className:_d()(v===ule.Industrial&&"selected",sle.demandRow)}),(0,z.jsx)(ole,{type:ule.Office,demand:a,factors:f,unlocking:m,onHover:_,onSelect:b,className:_d()(v===ule.Office&&"selected",sle.demandRow)})]})}),(0,z.jsx)(gle,{id:ule[j],icon:fle[j],unlocking:j===ule.Office&&m||j===ule.ResidentialMedium&&g||j===ule.ResidentialHigh&&h||void 0})]})})})}var gle=function(e){var t=e.id,n=e.icon,r=e.unlocking;return(0,z.jsx)(Bse,{focusKey:Hh,theme:b3,className:sle.infoColumn,children:(0,z.jsx)(Rse,{icon:n,title:(0,z.jsx)(qc.CityInfoPanel.DEMAND_TITLE,{hash:t}),description:(0,z.jsx)(qc.CityInfoPanel.DEMAND_DESCRIPTION,{hash:t}),bottom:null!=r&&k9(r.requirements)?(0,z.jsx)(M9,{theme:zse,requirements:r.requirements}):void 0,children:(null==r?void 0:r.locked)?(0,z.jsx)(Kse,{state:"Locked"}):void 0},t)})};oe.add("game-ui/game/components/city-info-panel/city-info-demand/demand-page.tsx",{get DemandType(){return ule},set DemandType(e){ule=e},get demandColors(){return dle},set demandColors(e){dle=e},get demandIcons(){return fle},set demandIcons(e){fle=e},get CityInfoDemand(){return mle},set CityInfoDemand(e){mle=e}});let hle={"city-policy":"city-policy_QlE item-states_QjV",cityPolicy:"city-policy_QlE item-states_QjV","disable-mouse-states":"disable-mouse-states_O0k",disableMouseStates:"disable-mouse-states_O0k",content:"content_Epe",left:"left_MRp",right:"right_Xny",icon:"icon_pZC",disabled:"disabled_mRJ",locked:"locked_qsG",lock:"lock_q6f",checkbox:"checkbox_nNF",control:"control_box",slider:"slider_RcP",label:"label_SXQ"};oe.add("game-ui/game/components/city-info-panel/city-info-policies/city-policy.module.scss",{get classes(){return hle},set classes(e){Object.assign(hle,e)}});const ple=hle;function vle(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function ble(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return vle(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return vle(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var yle=function(e){var t,n,r=e.policy,i=e.selected,o=e.className,a=e.onSelect,s=e.onHover,l=ble((0,Y.useState)(r.active),2),c=l[0],u=l[1],d=ble((0,Y.useState)(null!==(n=null===(t=r.data)||void 0===t?void 0:t.value)&&void 0!==n?n:0),2),f=d[0],m=d[1],g=ble((0,Y.useState)(!1),2),h=g[0],p=g[1],v=ble((0,Y.useState)(!1),2),b=v[0],y=v[1],x=Pg(),_=(0,Y.useCallback)((function(){hw(r.entity,!c,f),u(!c)}),[c,r,f]),j=(0,Y.useCallback)((function(e){m(e),x&&hw(r.entity,c,e)}),[c,x,r]),O=(0,Y.useCallback)((function(){return y(!0)}),[]),E=(0,Y.useCallback)((function(){hw(r.entity,c,f),y(!1)}),[c,r,f]),S=(0,Y.useCallback)((function(){_(),kp(Lp.selectItem)}),[_]),T=(0,Y.useCallback)((function(){return kp(Lp.hoverItem)}),[]),I=(0,Y.useCallback)((function(){return s(null)}),[s]),w=(0,Y.useCallback)((function(){return s(r)}),[s,r]),P=(0,Y.useCallback)((function(e){return e&&a(r)}),[a,r]),C=(0,Y.useCallback)((function(){a(r),kp(Lp.selectItem)}),[a,r]),N=(0,Y.useCallback)((function(){return p(!1)}),[]),A=(0,Y.useCallback)((function(){return p(!0)}),[]);return(0,z.jsx)(tk,{uiTag:r.uiTag,children:(0,z.jsx)(ip,{onAction:S,children:(0,z.jsx)(Yv,{onClick:C,onFocusChange:P,onMouseOver:w,onMouseEnter:T,onMouseLeave:I,className:_d()(ple.cityPolicy,i&&"selected",r.locked&&ple.locked,!c&&ple.disabled,(h||b)&&ple.disableMouseStates,o),children:(0,z.jsxs)("div",{className:ple.content,children:[(0,z.jsxs)("div",{className:ple.left,children:[(0,z.jsx)("img",{src:r.icon,className:ple.icon}),(0,z.jsx)("div",{className:ple.label,children:(0,z.jsx)(qc.Policy.TITLE,{hash:r.id})})]}),(0,z.jsxs)("div",{className:ple.right,children:[r.data&&f&&(0,z.jsxs)("div",{className:ple.control,children:[(0,z.jsx)("div",{className:ple.label,children:(0,z.jsx)(su,{value:!r.locked&&c?f:0,unit:r.data.unit})}),(0,z.jsx)(oF,{value:!r.locked&&c?f:0,start:!r.locked&&c?r.data.range.min:0,end:!r.locked&&c?r.data.range.max:1,gamepadStep:r.data.step,onDragEnd:E,onDragStart:O,onChange:j,onMouseOver:A,onMouseLeave:N,disabled:!c||r.locked,className:ple.slider})]}),r.locked&&(0,z.jsx)(_1,{className:ple.lock}),!r.locked&&(0,z.jsx)(fv,{onMouseOver:A,onMouseLeave:N,checked:c,onChange:_,focusKey:Hh,className:ple.checkbox})]})]})})})})};oe.add("game-ui/game/components/city-info-panel/city-info-policies/city-policy.tsx",{get CityPolicy(){return yle},set CityPolicy(e){yle=e}});let xle={"policies-page":"policies-page_YYY",policiesPage:"policies-page_YYY","main-column":"main-column_Pve",mainColumn:"main-column_Pve","info-column":"info-column_G8F",infoColumn:"info-column_G8F",scrollable:"scrollable_SFL"};oe.add("game-ui/game/components/city-info-panel/city-info-policies/policies-page.module.scss",{get classes(){return xle},set classes(e){Object.assign(xle,e)}});const _le=xle;function jle(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Ole(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return jle(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return jle(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Ele=function(){var e,t,n=xl(mw),r=Ole((0,Y.useState)(n.length>0?null!==(t=n.find((function(e){return!e.locked})))&&void 0!==t?t:n[0]:null),2),i=r[0],o=r[1],a=Ole((0,Y.useState)(null),2),s=a[0],l=a[1],c=(0,Y.useMemo)((function(){return null!=s?s:i}),[s,i]);return(0,z.jsx)(tk,{uiTag:null===(e=Ew.value)||void 0===e?void 0:e.cityInfoPanelPoliciesPage,children:(0,z.jsxs)("div",{className:_le.policiesPage,children:[(0,z.jsx)(Bse,{theme:b3,className:_le.mainColumn,children:(0,z.jsx)(Ap,{children:(0,z.jsx)(gE,{className:_le.scrollable,children:n.map((function(e){return(0,z.jsx)(yle,{policy:e,selected:Qs(e.entity,null==i?void 0:i.entity),onSelect:o,onHover:l},e.id)}))})})}),(0,z.jsx)(Sle,{policy:c})]})})},Sle=function(e){var t=e.policy;return(0,z.jsx)(Bse,{focusKey:Hh,theme:b3,className:_le.infoColumn,children:t&&(0,z.jsx)(Rse,{icon:t.icon,title:(0,z.jsx)(qc.Policy.TITLE,{hash:t.id}),description:(0,z.jsx)(qc.Policy.DESCRIPTION,{hash:t.id}),bottom:t.locked&&(0,z.jsx)(M9,{theme:zse,requirements:t.requirements}),children:t.locked&&(0,z.jsx)(Kse,{state:"Locked"})},qs(t.entity))})};oe.add("game-ui/game/components/city-info-panel/city-info-policies/policies-page.tsx",{get CityInfoPolicies(){return Ele},set CityInfoPolicies(e){Ele=e}});let Tle={"city-info-panel":"city-info-panel_Eha",cityInfoPanel:"city-info-panel_Eha"};oe.add("game-ui/game/components/city-info-panel/city-info-panel.module.scss",{get classes(){return Tle},set classes(e){Object.assign(Tle,e)}});const Ile=Tle;var wle=function(e){var t,n,r,i=e.selectedTab,o=e.onSelectTab,a=e.onClose;oh(null===(t=Ew.value)||void 0===t?void 0:t.cityInfoPanel);var s=Kw("Policies");return(0,z.jsx)(qj,{header:(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(tO,{children:(0,z.jsx)(qc.CityInfoPanel.TITLE,{})}),(0,z.jsxs)(S1,{children:[(0,z.jsx)(T1,{id:z_.Demand,uiTag:null===(n=Ew.value)||void 0===n?void 0:n.cityInfoPanelDemandTab,selectedId:i,onSelect:o,children:(0,z.jsx)(qc.CityInfoPanel.TAB,{hash:z_[z_.Demand]})}),(0,z.jsx)(B9,{locked:s.locked,requirements:s.requirements,children:(0,z.jsx)(T1,{id:z_.Policies,uiTag:null===(r=Ew.value)||void 0===r?void 0:r.cityInfoPanelPoliciesTab,selectedId:i,disabled:s.locked,locked:s.locked,onSelect:o,children:(0,z.jsx)(qc.CityInfoPanel.TAB,{hash:z_[z_.Policies]})})})]})]}),transitionSounds:vj,className:Ile.cityInfoPanel,onClose:a,children:(0,z.jsx)(E1,{tabs:[z_.Demand,z_.Policies],selectedTab:i,onSelect:o,children:Ple(i)})})};function Ple(e){switch(e){case z_.Demand:return(0,z.jsx)(mle,{});case z_.Policies:return(0,z.jsx)(Ele,{});default:return}}oe.add("game-ui/game/components/city-info-panel/city-info-panel.tsx",{get CityInfoPanel(){return wle},set CityInfoPanel(e){wle=e}});let Cle={"money-field":"money-field_bzk",moneyField:"money-field_bzk",primary:"primary__xr",secondary:"secondary_HCa",positive:"positive_HL9",negative:"negative_PiU",sign:"sign__wn",content:"content_pa5"};oe.add("game-ui/game/components/economy-panel/components/money-field/money-field.module.scss",{get classes(){return Cle},set classes(e){Object.assign(Cle,e)}});const Nle=Cle;var Ale=function(e){var t=e.value,n=e.importance,r=e.className;return(0,z.jsxs)("div",{className:_d()(Nle.moneyField,n&&Nle[n],uR(Nle,t),r),children:[(0,z.jsx)("div",{className:Nle.sign,children:Lle(t)}),(0,z.jsx)("div",{className:Nle.content,children:(0,z.jsx)(su,{value:Math.abs(t),unit:$c.Money})})]})};function Lle(e){return e<0?"−":e>0?"+":""}oe.add("game-ui/game/components/economy-panel/components/money-field/money-field.tsx",{get NumberField(){return Ale},set NumberField(e){Ale=e},get sign(){return Lle},set sign(e){Lle=e}});let Mle={chartFontColor:"rgba(255, 255, 255, 0.6)",chartLineColor:"rgba(255, 255, 255, 0.1)","budget-chart":"budget-chart_CSi",budgetChart:"budget-chart_CSi",chart:"chart_xgb"};oe.add("game-ui/game/components/economy-panel/budget-page/budget-chart/budget-chart.module.scss",{get classes(){return Mle},set classes(e){Object.assign(Mle,e)}});const kle=Mle;function Rle(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Dle(e){return function(e){if(Array.isArray(e))return Rle(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return Rle(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Rle(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Fle=function(e){var t=e.selectedId,n=e.className,r=xl(eI),i=Pj(xl(tI),1),o=xl(nI),a=Pj(xl(rI),1),s=(0,Y.useMemo)((function(){return{labels:["Budget"],datasets:Dle(Ule(r,i,1,"income",t)).concat(Dle(Ule(o,a,-1,"expenses",t)))}}),[r,i,t,o,a]),l=function(){var e=lu($c.Money),t=xl(Xl);return{layout:{padding:{top:12,right:24,bottom:0,left:12}},scales:{y:{stacked:!0,suggestedMax:1e3,beginAtZero:!0,grid:{color:kle.chartLineColor,lineWidth:2},border:{color:kle.chartLineColor,width:2},ticks:{maxTicksLimit:10,font:{size:10*t},color:kle.chartFontColor,padding:10,autoSkip:!1,callback:function(t){return e(t)}}},x:{stacked:!0,grid:{display:!1},ticks:{display:!1}}}}}();return(0,z.jsx)(Bse,{focusKey:Hh,theme:b3,className:_d()(kle.budgetChart,n),children:(0,z.jsx)(OU,{type:"bar",data:s,options:l,className:kle.chart})})};function Ule(e,t,n,r,i){return e.map((function(e){return{label:e.id,data:[n*iI(e,t)],backgroundColor:rP(e.color),barPercentage:e.id===i?.9:.5,categoryPercentage:.7,stack:r}})).reverse()}oe.add("game-ui/game/components/economy-panel/budget-page/budget-chart/budget-chart.tsx",{get BudgetChart(){return Fle},set BudgetChart(e){Fle=e}});let Gle={field:"field_ZZV",header:"header_FoF",icon:"icon_Vso",label:"label_XR5",content:"content_N5U",positive:"positive_Deq",negative:"negative_iIx"};oe.add("game-ui/game/components/economy-panel/components/table-row/table-row.module.scss",{get classes(){return Gle},set classes(e){Object.assign(Gle,e)}});const Ble=Gle;let Vle={"detail-layout":"detail-layout_TAz",detailLayout:"detail-layout_TAz"};oe.add("game-ui/game/components/economy-panel/budget-page/budget-item-detail/budget-item-detail.module.scss",{get classes(){return Vle},set classes(e){Object.assign(Vle,e)}});const Hle=Vle;var Kle=function(e){var t=e.item,n=e.values,r=e.className;return(0,z.jsx)(Bse,{focusKey:Hh,theme:b3,className:_d()(Hle.budgetItemDetail,r),children:null!=t&&(0,z.jsx)(Rse,{icon:t.icon,title:(0,z.jsx)(qc.EconomyPanel.BUDGET_ITEM,{hash:t.id}),description:(0,z.jsx)(qc.EconomyPanel.BUDGET_ITEM_DESCRIPTION,{hash:t.id}),bottom:t.sources.map((function(e,t){return(0,z.jsx)(Dre,{label:(0,z.jsx)(qc.EconomyPanel.BUDGET_SUB_ITEM,{hash:e.id}),theme:Ble,className:uR(Ble,n[e.index]),children:(0,z.jsx)(su,{value:n[e.index],unit:$c.Money})},t)})),className:Hle.detailLayout},t.id)})};oe.add("game-ui/game/components/economy-panel/budget-page/budget-item-detail/budget-item-detail.tsx",{get BudgetItemDetail(){return Kle},set BudgetItemDetail(e){Kle=e}});let Wle={"budget-section":"budget-section_F_L",budgetSection:"budget-section_F_L",header:"header__ZM",item:"item_fWX item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT",selected:"selected_yiI","title-column":"title-column_u4_",titleColumn:"title-column_u4_",title:"title_XJK","legend-color":"legend-color_jK2",legendColor:"legend-color_jK2","value-column":"value-column_Tid",valueColumn:"value-column_Tid","value-field":"value-field_M8j",valueField:"value-field_M8j","value-column-divider":"value-column-divider_afM",valueColumnDivider:"value-column-divider_afM"};oe.add("game-ui/game/components/economy-panel/budget-page/budget-section/budget-section.module.scss",{get classes(){return Wle},set classes(e){Object.assign(Wle,e)}});const zle=Wle;var Yle=Y.memo((function(e){var t=e.title,n=e.total,r=e.items,i=e.values,o=e.className,a=e.onMouseEnter,s=e.onMouseLeave,l=e.uiTag,c=e.selectedItem,u=e.onItemSelected,d=(0,Y.useContext)(jd);return(0,z.jsx)(Bse,{focusKey:Hh,theme:b3,className:_d()(zle.budgetSection,o),header:(0,z.jsx)(tk,{uiTag:l,children:(0,z.jsxs)("div",{className:zle.header,children:[(0,z.jsx)("div",{className:zle.titleColumn,children:t}),(0,z.jsx)("div",{className:zle.valueColumn,children:(0,z.jsx)(Ale,{value:n,importance:"secondary",className:zle.valueField})})]})}),children:(0,z.jsxs)(jd.Provider,{value:d,children:[r.map((function(e){return(0,z.jsx)($le,{item:e,values:i,onMouseEnter:a,onMouseLeave:s,selected:c===e.id,onSelect:u},e.id)})),(0,z.jsx)("div",{className:zle.valueColumnDivider})]})})}),(function(e,t){return el(e,t,5)})),$le=function(e){var t=e.item,n=e.values,r=e.onMouseEnter,i=e.onMouseLeave,o=e.selected,a=e.onSelect,s=iI(t,n),l=(0,Y.useCallback)((function(){return r(t.id)}),[r,t.id]),c=(0,Y.useCallback)((function(){return i(t.id)}),[i,t.id]),u=(0,Y.useCallback)((function(){return a(o?null:t.id)}),[t.id,a,o]);return(0,z.jsxs)(Yv,{focusKey:t.id,className:_d()(zle.item,o&&zle.selected),onMouseEnter:l,onMouseLeave:c,onClick:u,children:[(0,z.jsxs)("div",{className:zle.titleColumn,children:[(0,z.jsx)("div",{className:zle.legendColor,style:{backgroundColor:rP(t.color)}}),(0,z.jsx)("div",{className:zle.title,children:(0,z.jsx)(qc.EconomyPanel.BUDGET_ITEM,{hash:t.id})})]}),(0,z.jsx)("div",{className:zle.valueColumn,children:(0,z.jsx)(Ale,{value:s,className:zle.valueField})})]})};oe.add("game-ui/game/components/economy-panel/budget-page/budget-section/budget-section.tsx",{get BudgetSection(){return Yle},set BudgetSection(e){Yle=e}});let qle={"budget-page":"budget-page_SIZ",budgetPage:"budget-page_SIZ","chart-column":"chart-column_Y0V",chartColumn:"chart-column_Y0V","main-column":"main-column_unC",mainColumn:"main-column_unC","info-column":"info-column_K89",infoColumn:"info-column_K89","budget-section":"budget-section_zaZ",budgetSection:"budget-section_zaZ","total-section":"total-section_TGf",totalSection:"total-section_TGf","total-content":"total-content_GKQ",totalContent:"total-content_GKQ","total-label":"total-label_Uhe",totalLabel:"total-label_Uhe","total-column":"total-column_Ikw",totalColumn:"total-column_Ikw","total-field":"total-field_zjM",totalField:"total-field_zjM"};oe.add("game-ui/game/components/economy-panel/budget-page/budget-page.module.scss",{get classes(){return qle},set classes(e){Object.assign(qle,e)}});const Xle=qle;function Qle(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Zle(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Qle(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Qle(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Jle=function(){var e,t,n,r;oh(null===(e=Ew.value)||void 0===e?void 0:e.economyPanelBudgetPage);var i,o=xl(eI),a=Pj(xl(tI),1),s=xl(nI),l=Pj(xl(rI),1),c=xl(ZT),u=xl(JT),d=c+u,f=Zle((0,Y.useState)(null),2),m=f[0],g=f[1],h=Zle((0,Y.useState)(oC(o,"id")),2),p=h[0],v=h[1],b=Zle((0,Y.useState)(null),2),y=b[0],x=b[1],_=(0,Y.useCallback)((function(e){return x(e)}),[]),j=(0,Y.useCallback)((function(e){return x((function(t){return t===e?null:t}))}),[]),O=(0,Y.useCallback)((function(e){return"string"==typeof e&&v(e)}),[]),E=Pg(),S=E?p:y||m,T=o.find((function(e){return e.id===S})),I=s.find((function(e){return e.id===S}));return(0,z.jsxs)("div",{className:Xle.budgetPage,children:[(0,z.jsx)(Fle,{selectedId:S,className:Xle.chartColumn}),(0,z.jsx)("div",{className:Xle.mainColumn,children:(0,z.jsxs)(Ip,{focused:p,direction:gp.Vertical,onChange:O,onRefocus:wp,children:[(0,z.jsx)(Yle,{title:(0,z.jsx)(qc.EconomyPanel.INCOME_SECTION_TITLE,{}),total:c,items:o,values:a,className:Xle.budgetSection,onMouseEnter:_,onMouseLeave:j,selectedItem:E?null:m,onItemSelected:g,uiTag:null===(t=Ew.value)||void 0===t?void 0:t.economyPanelBudgetRevenue}),(0,z.jsx)(Yle,{title:(0,z.jsx)(qc.EconomyPanel.EXPENSES_SECTION_TITLE,{}),total:u,items:s,values:l,className:Xle.budgetSection,onMouseEnter:_,onMouseLeave:j,selectedItem:E?null:m,onItemSelected:g,uiTag:null===(n=Ew.value)||void 0===n?void 0:n.economyPanelBudgetExpenses}),(0,z.jsx)(tk,{uiTag:null===(r=Ew.value)||void 0===r?void 0:r.economyPanelBudgetBalance,children:(0,z.jsx)(Bse,{focusKey:Hh,theme:b3,className:Xle.totalSection,children:(0,z.jsxs)("div",{className:Xle.totalContent,children:[(0,z.jsx)("div",{className:Xle.totalLabel,children:(0,z.jsx)(qc.EconomyPanel.MONTHLY_BALANCE,{})}),(0,z.jsx)("div",{className:Xle.totalColumn,children:(0,z.jsx)(Ale,{value:d,importance:"primary",className:Xle.totalField})})]})})})]})}),(0,z.jsx)(Kle,{item:null!==(i=null!=T?T:I)&&void 0!==i?i:null,values:null!=T?a:l,className:Xle.infoColumn})]})};oe.add("game-ui/game/components/economy-panel/budget-page/budget-page.tsx",{get BudgetPage(){return Jle},set BudgetPage(e){Jle=e}});let ece={"loan-form":"loan-form_Ohg",loanForm:"loan-form_Ohg","slider-column":"slider-column_kts",sliderColumn:"slider-column_kts",balloon:"balloon_Jlj",positive:"positive_WFM",negative:"negative_NTL","balloon-content":"balloon-content_QEH",balloonContent:"balloon-content_QEH",limit:"limit_ZPi","direction-labels":"direction-labels_KdN",directionLabels:"direction-labels_KdN",arrow:"arrow_AXM","less-label":"less-label_ZOG",lessLabel:"less-label_ZOG","less-arrow":"less-arrow_Oio arrow_AXM",lessArrow:"less-arrow_Oio arrow_AXM",space:"space_zFI","more-label":"more-label_PtR",moreLabel:"more-label_PtR","more-arrow":"more-arrow_odN arrow_AXM",moreArrow:"more-arrow_odN arrow_AXM","button-column":"button-column_mFb",buttonColumn:"button-column_mFb",button:"button_aQu","accept-button":"accept-button_uUd button_aQu button_SsC",acceptButton:"accept-button_uUd button_aQu button_SsC","reset-button":"reset-button_I2B button_aQu button_eqb item-states_QjV",resetButton:"reset-button_I2B button_aQu button_eqb item-states_QjV"};oe.add("game-ui/game/components/economy-panel/loan-page/loan-adjustment/loan-form/loan-form.module.scss",{get classes(){return ece},set classes(e){Object.assign(ece,e)}});const tce=ece;let nce={slider:"slider_iN8 slider_pUS",edge:"edge_Qvg",positive:"positive_kiJ",negative:"negative_HpK","left-edge":"left-edge_Rrm edge_Qvg",leftEdge:"left-edge_Rrm edge_Qvg","right-edge":"right-edge_ocL edge_Qvg",rightEdge:"right-edge_ocL edge_Qvg","track-bounds":"track-bounds_Bp4",trackBounds:"track-bounds_Bp4",thumb:"thumb_yXN thumb_WZt"};oe.add("game-ui/game/components/economy-panel/loan-page/loan-adjustment/loan-form/loan-slider.module.scss",{get classes(){return nce},set classes(e){Object.assign(nce,e)}});const rce=nce;let ice={balloon:"balloon__3G balloon_H23",container:"container_VsE container_jfe",arrow:"arrow_cyp arrow_Xfn",content:"content_tDr content_JQV"};oe.add("game-ui/game/components/economy-panel/loan-page/loan-adjustment/loan-form/loan-slider-balloon.module.scss",{get classes(){return ice},set classes(e){Object.assign(ice,e)}});const oce=ice;var ace=function(){var e,t,n=xl(aI),r=xl(sI),i=xl(lI),o=i.amount-r.amount,a=Math.abs(o)>.5,s=function(e){var t=Math.pow(10,Math.max(lce(e)-lce(sce/5),0)),n=t/2,r=t,i=5*t;return e/n<=sce?Math.max(n,1):e/r<=sce?Math.max(r,1):Math.max(i,1)}(n),l=(0,Y.useCallback)((function(e,t,n){var i=e+n*(t-e),o=e+Math.round(n*(t-e)/s)*s;return Math.abs(r.amount-i)<Math.abs(o-i)?r.amount:of(o,Math.min(e,t),Math.max(e,t))}),[r.amount,s]),c=(0,Y.useMemo)((function(){return{"Change Slider Value":function(e){var t=i.amount;e>0?t=Math.floor((i.amount+s)/s)*s:e<0&&(t=Math.ceil((i.amount-s)/s)*s),(r.amount>i.amount&&t>r.amount||r.amount<i.amount&&t<r.amount)&&(t=r.amount),cI(t),kp(rF.drag)}}}),[r.amount,i.amount,s]);return(0,z.jsx)(rp,{actions:c,children:(0,z.jsxs)(Yv,{className:tce.loanForm,children:[(0,z.jsxs)("div",{className:tce.sliderColumn,children:[(0,z.jsx)("div",{className:tce.limit,children:(0,z.jsx)(qc.EconomyPanel.LOAN_FORM_LIMIT,{LOAN_LIMIT:(0,z.jsx)(su,{value:n,unit:$c.Money})})}),(0,z.jsx)(tk,{uiTag:null===(e=Ew.value)||void 0===e?void 0:e.economyPanelLoansSlider,children:(0,z.jsxs)(oF,{focusKey:Hh,value:i.amount,start:0,end:n,valueTransformer:l,thumb:(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)("div",{className:rce.thumb}),a&&(0,z.jsx)(Rm,{alignment:"center",direction:"down",theme:oce,className:tce.balloon,children:(0,z.jsx)("div",{className:_d()(tce.balloonContent,uR(tce,o)),children:(0,z.jsx)(su,{value:o,unit:$c.Money,signed:!0})})})]}),theme:rce,className:tce.slider,style:{"--stopPos":"".concat(100*of(r.amount/Math.max(n,1),0,1),"%")},onChange:cI,children:[(0,z.jsx)("div",{className:_d()(rce.leftEdge,r.amount>0?rce.negative:rce.positive)}),(0,z.jsx)("div",{className:_d()(rce.rightEdge,r.amount<n?rce.positive:rce.negative)})]})}),(0,z.jsxs)("div",{className:tce.directionLabels,children:[r.amount>0&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)("div",{className:tce.lessLabel,children:(0,z.jsx)(qc.EconomyPanel.LOAN_FORM_LESS_LABEL,{})}),(0,z.jsx)(tb,{src:"Media/Glyphs/ThickStrokeArrowLeft.svg",className:tce.lessArrow})]}),(0,z.jsx)("div",{className:tce.space}),r.amount<n&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(tb,{src:"Media/Glyphs/ThickStrokeArrowRight.svg",className:tce.moreArrow}),(0,z.jsx)("div",{className:tce.moreLabel,children:(0,z.jsx)(qc.EconomyPanel.LOAN_FORM_MORE_LABEL,{})})]})]})]}),(0,z.jsx)("div",{className:tce.buttonColumn,children:(0,z.jsxs)(Ap,{direction:gp.Vertical,children:[(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.economyPanelLoansAccept,children:(0,z.jsx)(Qp,{selectSound:Lp.takeLoan,className:tce.acceptButton,disabled:!a,onSelect:uI,children:(0,z.jsx)(qc.EconomyPanel.LOAN_FORM_ACCEPT,{})})}),(0,z.jsx)(Qp,{className:tce.resetButton,disabled:!a,onSelect:dI,children:(0,z.jsx)(qc.EconomyPanel.LOAN_FORM_RESET,{})})]})})]})})},sce=75;function lce(e){return Math.max(Math.floor(Math.log10(Math.abs(e))),0)+1}oe.add("game-ui/game/components/economy-panel/loan-page/loan-adjustment/loan-form/loan-form.tsx",{get LoanForm(){return ace},set LoanForm(e){ace=e}});let cce={"table-header":"table-header_wsv",tableHeader:"table-header_wsv","header-cell":"header-cell_ymh",headerCell:"header-cell_ymh","table-content":"table-content_YfG",tableContent:"table-content_YfG","content-cell":"content-cell_MZC",contentCell:"content-cell_MZC","amount-column":"amount-column_kN8",amountColumn:"amount-column_kN8","interest-rate-column":"interest-rate-column_jcI",interestRateColumn:"interest-rate-column_jcI","monthly-cost-column":"monthly-cost-column_BPo",monthlyCostColumn:"monthly-cost-column_BPo","monthly-cost-field":"monthly-cost-field_eRh",monthlyCostField:"monthly-cost-field_eRh","new-value":"new-value_keh",newValue:"new-value_keh",negative:"negative_qB0","loan-number":"loan-number_Mcp",loanNumber:"loan-number_Mcp","current-value":"current-value_SLp",currentValue:"current-value_SLp",modified:"modified_rG6","strikethrough-line":"strikethrough-line_Yh8",strikethroughLine:"strikethrough-line_Yh8",hidden:"hidden_RHn"};oe.add("game-ui/game/components/economy-panel/loan-page/loan-adjustment/loan-table/loan-table.module.scss",{get classes(){return cce},set classes(e){Object.assign(cce,e)}});const uce=cce;var dce=function(){return(0,z.jsxs)("div",{className:uce.tableHeader,children:[(0,z.jsx)("div",{className:_d()(uce.headerCell,uce.amountColumn),children:(0,z.jsx)(qc.EconomyPanel.LOAN_TABLE_AMOUNT,{})}),(0,z.jsx)("div",{className:_d()(uce.headerCell,uce.interestRateColumn),children:(0,z.jsx)(qc.EconomyPanel.LOAN_TABLE_INTEREST_RATE,{})}),(0,z.jsx)("div",{className:_d()(uce.headerCell,uce.monthlyCostColumn),children:(0,z.jsx)(qc.EconomyPanel.LOAN_TABLE_MONTHLY_COST,{})})]})},fce=function(){var e=xl(sI),t=xl(lI),n=Math.abs(t.amount-e.amount)>.5;return(0,z.jsxs)("div",{className:uce.tableContent,children:[(0,z.jsx)("div",{className:_d()(uce.contentCell,uce.amountColumn),children:(0,z.jsx)(mce,{currentValue:e.amount,newValue:t.amount,unit:$c.Money,modified:n})}),(0,z.jsx)("div",{className:_d()(uce.contentCell,uce.interestRateColumn),children:(0,z.jsx)(mce,{currentValue:100*e.dailyInterestRate,newValue:100*t.dailyInterestRate,unit:$c.PercentageSingleFraction,modified:n})}),(0,z.jsxs)("div",{className:_d()(uce.contentCell,uce.monthlyCostColumn),children:[(0,z.jsxs)("div",{className:_d()(Nle.moneyField,Nle.primary,uce.monthlyCostField),children:[(0,z.jsx)("div",{className:_d()(Nle.sign,uR(uce,-t.dailyPayment)),children:xu(-t.dailyPayment,!0)}),(0,z.jsx)("div",{className:_d()(Nle.content,uR(uce,-e.dailyPayment)),children:(0,z.jsx)(mce,{currentValue:e.dailyPayment,newValue:t.dailyPayment,unit:$c.Money,modified:n,newClassName:uR(uce,-t.dailyPayment)})})]}),(0,z.jsx)("div",{})]})]})},mce=function(e){var t=e.currentValue,n=e.newValue,r=e.unit,i=e.modified,o=e.newClassName;return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsxs)("div",{className:_d()(uce.currentValue,i&&uce.modified),children:[(0,z.jsx)(su,{value:t,unit:r}),i&&(0,z.jsx)("div",{className:uce.strikethroughLine})]}),(0,z.jsx)("div",{className:_d()(uce.newValue,!i&&uce.hidden,o),children:(0,z.jsx)(su,{value:n,unit:r})})]})};oe.add("game-ui/game/components/economy-panel/loan-page/loan-adjustment/loan-table/loan-table.tsx",{get LoanTableHeader(){return dce},set LoanTableHeader(e){dce=e},get LoanTableContent(){return fce},set LoanTableContent(e){fce=e}});let gce={"loan-adjustment":"loan-adjustment_mqe",loanAdjustment:"loan-adjustment_mqe"};oe.add("game-ui/game/components/economy-panel/loan-page/loan-adjustment/loan-adjustment.module.scss",{get classes(){return gce},set classes(e){Object.assign(gce,e)}});const hce=gce;var pce=function(e){var t=e.className;return(0,z.jsxs)(Bse,{header:(0,z.jsx)(dce,{}),theme:b3,className:_d()(hce.loanAdjustment,t),children:[(0,z.jsx)(fce,{}),(0,z.jsx)(ace,{})]})};oe.add("game-ui/game/components/economy-panel/loan-page/loan-adjustment/loan-adjustment.tsx",{get LoanAdjustment(){return pce},set LoanAdjustment(e){pce=e}});let vce={chartFontColor:"rgba(255, 255, 255, 0.6)",chartLineColor:"rgba(255, 255, 255, 0.1)",cityIncomeColor:"rgba(139, 219, 70, 0.6)",cityExpensesColor:"rgba(233, 95, 74, 0.6)",loanInterestColor:"rgba(233, 95, 74, 1)","loan-chart":"loan-chart_IIu",loanChart:"loan-chart_IIu",content:"content_K6K","chart-column":"chart-column_YvP",chartColumn:"chart-column_YvP",chart:"chart_nml","summary-column":"summary-column_Wm0",summaryColumn:"summary-column_Wm0","summary-item":"summary-item__T7",summaryItem:"summary-item__T7",warning:"warning_aXt",divider:"divider_s9s",legend:"legend_ots","legend-item":"legend-item_OSA",legendItem:"legend-item_OSA"};oe.add("game-ui/game/components/economy-panel/loan-page/loan-chart/loan-chart.module.scss",{get classes(){return vce},set classes(e){Object.assign(vce,e)}});const bce=vce;var yce=function(e){var t=e.className,n=xl(sI),r=xl(lI),i=xl(ZT),o=i>0?r.dailyPayment/i*100:Number.MAX_VALUE,a=Math.abs(xl(JT))-n.dailyPayment,s=a+r.dailyPayment,l=i-s,c=(0,Y.useMemo)((function(){return{labels:["Budget"],datasets:[{label:"cityIncome",data:[i],backgroundColor:bce.cityIncomeColor,barPercentage:.8,categoryPercentage:.5,stack:"income"},{label:"cityExpenses",data:[a],backgroundColor:bce.cityExpensesColor,barPercentage:.8,categoryPercentage:.5,stack:"expenses"},{label:"loanInterest",data:[r.dailyPayment],backgroundColor:bce.loanInterestColor,barPercentage:.8,categoryPercentage:.5,stack:"expenses"}]}}),[a,i,r.dailyPayment]),u=function(){var e=lu($c.Money),t=xl(Xl);return{layout:{padding:{top:24,right:36,bottom:0,left:12}},scales:{y:{stacked:!0,suggestedMax:1e3,beginAtZero:!0,grid:{color:bce.chartLineColor,lineWidth:2},border:{color:bce.chartLineColor,width:2},ticks:{maxTicksLimit:10,font:{size:10*t},color:bce.chartFontColor,padding:10,autoSkip:!1,callback:function(t){return e(t)}}},x:{display:!1,stacked:!0}}}}();return(0,z.jsx)(Bse,{focusKey:Hh,theme:b3,className:_d()(bce.loanChart,t),children:(0,z.jsxs)("div",{className:bce.content,children:[(0,z.jsxs)("div",{className:bce.chartColumn,children:[(0,z.jsx)(OU,{type:"bar",data:c,options:u,className:bce.chart}),(0,z.jsxs)("div",{className:bce.legend,children:[(0,z.jsx)(hU,{color:bce.cityIncomeColor,label:(0,z.jsx)(qc.EconomyPanel.LOAN_CHART_LEGEND_INCOME,{}),className:bce.legendItem}),(0,z.jsx)(hU,{color:bce.cityExpensesColor,label:(0,z.jsx)(qc.EconomyPanel.LOAN_CHART_LEGEND_EXPENSES,{}),className:bce.legendItem}),r.dailyPayment>0&&(0,z.jsx)(hU,{color:bce.loanInterestColor,label:(0,z.jsx)(qc.EconomyPanel.LOAN_CHART_LEGEND_LOAN_INTEREST,{}),className:bce.legendItem})]})]}),(0,z.jsxs)("div",{className:bce.summaryColumn,children:[o<=100&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(_ce,{children:(0,z.jsx)(qc.EconomyPanel.LOAN_CHART_RELATIVE_COST,{RELATIVE_LOAN_COST:(0,z.jsx)(su,{value:o,unit:$c.PercentageSingleFraction})})}),(0,z.jsx)("div",{className:bce.divider})]}),(0,z.jsx)(_ce,{warning:l<=0,children:xce(l,r.amount)}),.85*i<s&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)("div",{className:bce.divider}),(0,z.jsx)(_ce,{warning:!0,children:s>i?(0,z.jsx)(qc.EconomyPanel.LOAN_CHART_BUDGET_WARNING,{}):(0,z.jsx)(qc.EconomyPanel.LOAN_CHART_BUDGET_WARNING_MODIFIED,{})})]})]})]})})};function xce(e,t){var n=(0,z.jsx)(su,{value:e,unit:$c.MoneyPerMonth});return e>=0?t>0?(0,z.jsx)(qc.EconomyPanel.LOAN_CHART_REMAINING_SURPLUS,{TOTAL:n}):(0,z.jsx)(qc.EconomyPanel.LOAN_CHART_SURPLUS,{TOTAL:n}):(0,z.jsx)(qc.EconomyPanel.LOAN_CHART_DEFICIT,{TOTAL:n})}var _ce=function(e){var t=e.warning,n=e.children;return(0,z.jsx)(Fv,{className:_d()(bce.summaryItem,t&&bce.warning),children:n})};oe.add("game-ui/game/components/economy-panel/loan-page/loan-chart/loan-chart.tsx",{get LoanChart(){return yce},set LoanChart(e){yce=e}});let jce={"loan-page":"loan-page_cyR",loanPage:"loan-page_cyR","main-column":"main-column_NUx",mainColumn:"main-column_NUx","info-column":"info-column_c8_",infoColumn:"info-column_c8_",chart:"chart_Dc8"};oe.add("game-ui/game/components/economy-panel/loan-page/loan-page.module.scss",{get classes(){return jce},set classes(e){Object.assign(jce,e)}});const Oce=jce;var Ece=function(){var e;return oh(null===(e=Ew.value)||void 0===e?void 0:e.economyPanelLoansPage),(0,Y.useEffect)((function(){return dI(),function(){return dI()}}),[]),(0,z.jsxs)("div",{className:Oce.loanPage,children:[(0,z.jsxs)("div",{className:Oce.mainColumn,children:[(0,z.jsx)(pce,{className:Oce.adjustment}),(0,z.jsx)(yce,{className:Oce.chart})]}),(0,z.jsx)(Bse,{focusKey:Hh,theme:b3,className:Oce.infoColumn,children:(0,z.jsx)(Rse,{icon:"Media/Game/Icons/Money.svg",title:(0,z.jsx)(qc.EconomyPanel.LOAN_PAGE_TITLE,{}),description:(0,z.jsx)(qc.EconomyPanel.LOAN_PAGE_DESCRIPTION,{})})})]})};oe.add("game-ui/game/components/economy-panel/loan-page/loan-page.tsx",{get LoanPage(){return Ece},set LoanPage(e){Ece=e}});var Sce=Y.createContext({onFocusChange:function(){},onMouseEnter:function(){},onMouseLeave:function(){}});function Tce(e){var t=(0,Y.useContext)(Sce);return{handleFocusChange:(0,Y.useCallback)((function(n){return t.onFocusChange(e,n)}),[e,t]),handleMouseEnter:(0,Y.useCallback)((function(){return t.onMouseEnter(e)}),[e,t]),handleMouseLeave:(0,Y.useCallback)((function(){return t.onMouseLeave(e)}),[e,t])}}oe.add("game-ui/game/components/economy-panel/production-page/production-page-context.ts",{get ProductionPageContext(){return Sce},set ProductionPageContext(e){Sce=e},get useItemListeners(){return Tce},set useItemListeners(e){Tce=e}});let Ice={detail:"detail_sbO",chart:"chart_Eey",column:"column_N8A","left-column":"left-column_GbN",leftColumn:"left-column_GbN","right-column":"right-column_hq1",rightColumn:"right-column_hq1","center-column":"center-column_M5Z",centerColumn:"center-column_M5Z",row:"row_PNm","double-row":"double-row_kpL",doubleRow:"double-row_kpL",label:"label_qcd","resource-label":"resource-label_b8b",resourceLabel:"resource-label_b8b","left-label":"left-label_aR5",leftLabel:"left-label_aR5","right-label":"right-label_q7r",rightLabel:"right-label_q7r","label-padding":"label-padding_TU1",labelPadding:"label-padding_TU1","label-extra-padding":"label-extra-padding_qhR",labelExtraPadding:"label-extra-padding_qhR",image:"image_k4T",icon:"icon_DSu","resource-icon":"resource-icon_GIT",resourceIcon:"resource-icon_GIT","icon-container":"icon-container_iMp",iconContainer:"icon-container_iMp","left-icon-container":"left-icon-container_V3g",leftIconContainer:"left-icon-container_V3g","icon-container-padding":"icon-container-padding_NGu",iconContainerPadding:"icon-container-padding_NGu","icon-container-extra-padding":"icon-container-extra-padding_DY7",iconContainerExtraPadding:"icon-container-extra-padding_DY7","right-icon-container":"right-icon-container_zrI",rightIconContainer:"right-icon-container_zrI","top-icon-container":"top-icon-container_vrp",topIconContainer:"top-icon-container_vrp","bottom-icon-container":"bottom-icon-container_Wzp",bottomIconContainer:"bottom-icon-container_Wzp"};oe.add("game-ui/game/components/economy-panel/production-page/resource-detail/resource-detail.module.scss",{get classes(){return Ice},set classes(e){Object.assign(Ice,e)}});const wce=Ice;var Pce=function(e){var t=e.entity,n=e.className;return(0,z.jsx)(Bse,{focusKey:Hh,theme:b3,className:_d()(wce.resourceDetail,n),children:!Qs(t,ty)&&(0,z.jsx)(Cce,{entity:t})})},Cce=function(e){var t=e.entity,n=Ol(pI,t),r=Ol(hI,t),i=function(e,t){var n=t.inputs.flatMap((function(e){return e})),r=Math.max(n.length,1),i=t.outputs.length+t.serviceOutputs.length+e.consumers.length;e.tradable&&(r++,i++);return Math.max(r,i)}(n,r),o=(40*i+8*(i-1))*$O();return(0,z.jsx)("div",{className:wce.detail,children:(0,z.jsxs)("div",{className:wce.chart,style:{height:o},children:[(0,z.jsx)(Nce,{resource:n,details:r}),(0,z.jsx)(Mce,{resource:n,details:r}),(0,z.jsx)(kce,{resource:n,details:r})]})})},Nce=function(e){var t=e.resource,n=e.details;return(0,z.jsxs)("div",{className:_d()(wce.column,wce.leftColumn),children:[0===(null==n?void 0:n.inputs.length)&&(0,z.jsx)(Gce,{icon:t.producer.icon,arrow:"ProductionArrow",children:(0,z.jsx)(qc.EconomyPanel.PRODUCTION_PAGE_PRODUCTIONLINK,{hash:t.producer.name})}),null==n?void 0:n.inputs.map((function(e,n){return(0,z.jsx)(Ace,{resource:t,entities:e},n)})),t.tradable&&(0,z.jsx)(Lce,{})]})},Ace=function(e){var t=e.resource,n=e.entities,r=El(pI,n);return(0,z.jsxs)("div",{className:_d()(wce.row,r.length>1&&wce.doubleRow),style:{flex:r.length},children:[r.map((function(e,t){return(0,z.jsx)("div",{className:wce.row,children:(0,z.jsx)("div",{className:_d()(wce.iconContainer,wce.leftIconContainer,r.length>1&&(0===t?wce.topIconContainer:wce.bottomIconContainer)),children:(0,z.jsx)("img",{src:e.icon,className:wce.icon})})},qs(e.entity))})),(0,z.jsx)("div",{className:_d()(wce.label,wce.rightLabel,wce.labelPadding,r.length>1&&wce.labelExtraPadding),children:(0,z.jsx)(qc.EconomyPanel.PRODUCTION_PAGE_PRODUCTIONLINK,{hash:t.producer.name})}),(0,z.jsx)("div",{className:_d()(wce.iconContainer,wce.leftIconContainer,wce.iconContainerPadding,r.length>1&&wce.iconContainerExtraPadding),children:(0,z.jsx)("img",{src:t.producer.icon,className:wce.icon})}),(0,z.jsx)("img",{src:"Media/Game/Resources/Production/".concat(1===r.length?"Input":"DoubleInput","Arrow.png"),className:wce.image})]})},Lce=function(){return(0,z.jsxs)("div",{className:wce.row,children:[(0,z.jsx)("img",{src:"Media/Game/Resources/Production/ImportArrow.png",className:wce.image}),(0,z.jsx)("div",{className:_d()(wce.iconContainer,wce.leftIconContainer),children:(0,z.jsx)("img",{src:"Media/Game/Icons/Import.svg",className:wce.icon})}),(0,z.jsx)("div",{className:_d()(wce.label,wce.leftLabel),children:(0,z.jsx)(qc.EconomyPanel.PRODUCTION_PAGE_IMPORT,{})})]})},Mce=function(e){var t=e.resource;return(0,z.jsx)("div",{className:_d()(wce.column,wce.centerColumn),children:(0,z.jsxs)("div",{className:_d()(wce.label,wce.resourceLabel),children:[(0,z.jsx)("img",{src:t.icon,className:_d()(wce.icon,wce.resourceIcon)}),(0,z.jsx)(qc.Resources.TITLE,{hash:t.name})]})})},kce=function(e){var t=e.resource,n=e.details;return(0,z.jsxs)("div",{className:_d()(wce.column,wce.rightColumn),children:[null==n?void 0:n.serviceOutputs.map((function(e){return(0,z.jsx)(Fce,{entity:e},qs(e))})),(0,z.jsx)(Dce,{resource:t,details:n}),null==n?void 0:n.outputs.map((function(e,t){return(0,z.jsx)(Rce,{entity:e},t)})),t.tradable&&(0,z.jsx)(Uce,{})]})},Rce=function(e){var t=e.entity,n=Ol(pI,t);return(0,z.jsxs)("div",{className:wce.row,children:[(0,z.jsx)("img",{src:"Media/Game/Resources/Production/OutputArrow.png",className:wce.image}),(0,z.jsx)("div",{className:_d()(wce.iconContainer,wce.leftIconContainer),children:(0,z.jsx)("img",{src:n.producer.icon,className:wce.icon})}),(0,z.jsx)("div",{className:_d()(wce.label,wce.leftLabel),children:(0,z.jsx)(qc.EconomyPanel.PRODUCTION_PAGE_PRODUCTIONLINK,{hash:n.producer.name})}),(0,z.jsx)("div",{className:_d()(wce.iconContainer,wce.rightIconContainer),children:(0,z.jsx)("img",{src:n.icon,className:wce.icon})})]})},Dce=function(e){var t=e.resource;return(0,z.jsx)(z.Fragment,{children:t.consumers.map((function(e,t){return(0,z.jsx)(Gce,{icon:e.icon,arrow:"ConsumptionArrow",children:(0,z.jsx)(qc.EconomyPanel.PRODUCTION_PAGE_PRODUCTIONLINK,{hash:e.name})},t)}))})},Fce=function(e){var t=e.entity,n=Ol(vI,t);return(0,z.jsx)(Gce,{icon:n.icon,arrow:"ConsumptionArrow",children:(0,z.jsx)(qc.Services.NAME,{hash:n.name})})},Uce=function(){return(0,z.jsxs)("div",{className:wce.row,children:[(0,z.jsx)("img",{src:"Media/Game/Resources/Production/ExportArrow.png",className:wce.image}),(0,z.jsx)("div",{className:_d()(wce.iconContainer,wce.leftIconContainer),children:(0,z.jsx)("img",{src:"Media/Game/Icons/Export.svg",className:wce.icon})}),(0,z.jsx)("div",{className:_d()(wce.label,wce.leftLabel),children:(0,z.jsx)(qc.EconomyPanel.PRODUCTION_PAGE_EXPORT,{})})]})},Gce=function(e){var t=e.icon,n=e.arrow,r=e.children;return(0,z.jsxs)("div",{className:wce.row,children:[(0,z.jsx)("img",{src:"Media/Game/Resources/Production/".concat(n,".png"),className:wce.image}),(0,z.jsx)("div",{className:_d()(wce.iconContainer,wce.leftIconContainer),children:(0,z.jsx)("img",{src:t,className:wce.icon})}),(0,z.jsx)("div",{className:_d()(wce.label,wce.rightLabel),children:r})]})};oe.add("game-ui/game/components/economy-panel/production-page/resource-detail/resource-detail.tsx",{get ResourceDetail(){return Pce},set ResourceDetail(e){Pce=e},get Detail(){return Cce},set Detail(e){Cce=e},get InputsColumn(){return Nce},set InputsColumn(e){Nce=e},get Input(){return Ace},set Input(e){Ace=e},get Import(){return Lce},set Import(e){Lce=e},get ResourceColumn(){return Mce},set ResourceColumn(e){Mce=e},get OutputsColumn(){return kce},set OutputsColumn(e){kce=e},get Output(){return Rce},set Output(e){Rce=e},get Consumptions(){return Dce},set Consumptions(e){Dce=e},get Export(){return Uce},set Export(e){Uce=e},get ThroughPut(){return Gce},set ThroughPut(e){Gce=e}});let Bce={"progress-bar":"progress-bar_xWR",progressBar:"progress-bar_xWR","progress-bounds":"progress-bounds_Fjq",progressBounds:"progress-bounds_Fjq",progress:"progress_JAQ",label:"label_nBK"};oe.add("game-ui/common/progress-bar/progress-bar.module.scss",{get classes(){return Bce},set classes(e){Object.assign(Bce,e)}});const Vce=Bce;let Hce={"progress-bar":"progress-bar_d6t progress-bar_xWR",progressBar:"progress-bar_d6t progress-bar_xWR",progress:"progress_egi progress_JAQ"};oe.add("game-ui/common/progress-bar/themes/default-progress-bar.module.scss",{get classes(){return Hce},set classes(e){Object.assign(Hce,e)}});const Kce=Hce;function Wce(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function zce(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Wce(e,t,n[t])}))}return e}function Yce(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function $ce(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var qce=function(e){var t=e.progress,n=e.max,r=e.theme,i=void 0===r?Kce:r,o=e.className,a=e.style,s=e.children,l=$ce(e,["progress","max","theme","className","style","children"]),c=(0,Y.useMemo)((function(){return zce({},Vce,i)}),[i]),u=n>0?100*of(t/n,0,1):0;return(0,z.jsxs)("div",Yce(zce({},l),{className:_d()(c.progressBar,o),style:a,children:[c.progressLabel&&null!=s&&(0,z.jsx)("div",{className:c.label,children:s}),(0,z.jsx)("div",{className:c.progressBounds,style:{width:u+"%"},children:(0,z.jsx)("div",{className:c.progress,style:{width:(u>0?100/u*100:0)+"%"},children:c.progressLabel&&null!=s&&(0,z.jsx)("div",{className:c.progressLabel,children:s})})}),!c.progressLabel&&null!=s&&(0,z.jsx)("div",{className:c.label,children:s})]}))};oe.add("game-ui/common/progress-bar/progress-bar.tsx",{get ProgressBar(){return qce},set ProgressBar(e){qce=e}});let Xce={"resource-list":"resource-list_Ra6",resourceList:"resource-list_Ra6",category:"category_nho",categoryHeader:"categoryHeader_YGs","table-header":"table-header_Qbg",tableHeader:"table-header_Qbg","header-cell":"header-cell_k7Z",headerCell:"header-cell_k7Z",table:"table_KZC",scrollable:"scrollable_Tuh","table-lines":"table-lines_PGv",tableLines:"table-lines_PGv",name:"name_IJ7",production:"production_iuR","surplus-deficit":"surplus-deficit_oEQ",surplusDeficit:"surplus-deficit_oEQ","deficit-label":"deficit-label_CkA",deficitLabel:"deficit-label_CkA","surplus-label":"surplus-label_U6j",surplusLabel:"surplus-label_U6j","resource-item":"resource-item_oLG item-hover_WK8 item-focused_FuT",resourceItem:"resource-item_oLG item-hover_WK8 item-focused_FuT","icon-container":"icon-container_Bnw",iconContainer:"icon-container_Bnw",icon:"icon_J9H icon_Iwk",title:"title_l1U","name-column":"name-column_Jt4",nameColumn:"name-column_Jt4","data-column":"data-column_k1t",dataColumn:"data-column_k1t","production-bar":"production-bar_PrU",productionBar:"production-bar_PrU"};oe.add("game-ui/game/components/economy-panel/production-page/resource-list/resource-list.module.scss",{get classes(){return Xce},set classes(e){Object.assign(Xce,e)}});const Qce=Xce;let Zce={"progress-bar":"progress-bar_oCn progress-bar_RG2 progress-bar_xWR",progressBar:"progress-bar_oCn progress-bar_RG2 progress-bar_xWR",progress:"progress_gQv progress_GLS progress_JAQ"};oe.add("game-ui/game/components/economy-panel/production-page/resource-list/themes/negative-progress-bar.module.scss",{get classes(){return Zce},set classes(e){Object.assign(Zce,e)}});const Jce=Zce;let eue={"progress-bar":"progress-bar_P_j progress-bar_RG2 progress-bar_xWR",progressBar:"progress-bar_P_j progress-bar_RG2 progress-bar_xWR",progress:"progress_zGB progress_GLS progress_JAQ"};oe.add("game-ui/game/components/economy-panel/production-page/resource-list/themes/positive-progress-bar.module.scss",{get classes(){return eue},set classes(e){Object.assign(eue,e)}});const tue=eue;let nue={"progress-bar":"progress-bar_RG2 progress-bar_xWR",progressBar:"progress-bar_RG2 progress-bar_xWR",progress:"progress_GLS progress_JAQ"};oe.add("game-ui/game/components/economy-panel/production-page/resource-list/themes/production-progress-bar.module.scss",{get classes(){return nue},set classes(e){Object.assign(nue,e)}});const rue=nue;var iue=function(e){var t,n=e.className,r=xl(gI),i=xl(mI);return(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.economyPanelProductionResources,children:(0,z.jsx)(gE,{className:_d()(Qce.resourceList,Qce.scrollable,n),children:(0,z.jsx)(Ap,{direction:gp.Vertical,children:r.map((function(e,t){return(0,z.jsx)(oue,{max:i,category:e,initialExpanded:0===t},qs(e.entity))}))})})})},oue=function(e){var t=e.category,n=e.max,r=e.initialExpanded;return(0,z.jsxs)(O3,{focusKey:qs(t.entity),initialExpanded:r,header:(0,z.jsx)(E3,{className:Qce.categoryHeader,children:(0,z.jsx)(qc.EconomyPanel.RESOURCE_CATEGORY,{hash:t.name})}),theme:b3,className:Qce.category,children:[(0,z.jsxs)("div",{className:Qce.tableHeader,children:[(0,z.jsx)("div",{className:_d()(Qce.headerCell,Qce.name)}),(0,z.jsx)("div",{className:_d()(Qce.headerCell,Qce.production),children:(0,z.jsx)(qc.EconomyPanel.PRODUCTION_PAGE_PRODUCTION,{})}),(0,z.jsx)("div",{className:_d()(Qce.headerCell,Qce.surplusDeficit),children:(0,z.jsx)("span",{className:Qce.surplusLabel,children:(0,z.jsx)(qc.EconomyPanel.PRODUCTION_PAGE_SURPLUS,{})})}),(0,z.jsx)("div",{className:_d()(Qce.headerCell,Qce.surplusDeficit),children:(0,z.jsx)("span",{className:Qce.deficitLabel,children:(0,z.jsx)(qc.EconomyPanel.PRODUCTION_PAGE_DEFICIT,{})})})]}),(0,z.jsx)(Ap,{direction:gp.Vertical,children:t.resources.map((function(e){return(0,z.jsx)(aue,{resource:e,max:n},qs(e.entity))}))}),(0,z.jsxs)("div",{className:Qce.tableLines,children:[(0,z.jsx)("div",{className:Qce.name}),(0,z.jsx)("div",{className:Qce.production}),(0,z.jsx)("div",{className:Qce.surplusDeficit}),(0,z.jsx)("div",{className:Qce.surplusDeficit})]})]})},aue=function(e){var t=e.resource,n=e.max,r=Tce(t.entity),i=r.handleFocusChange,o=r.handleMouseEnter,a=r.handleMouseLeave,s=Ol(bI,t.entity);return(0,z.jsx)(Tg,{onFocusChange:i,children:(0,z.jsxs)(Yv,{focusKey:qs(t.entity),className:Qce.resourceItem,onMouseEnter:o,onMouseLeave:a,children:[(0,z.jsx)("div",{className:_d()(Qce.nameColumn),children:(0,z.jsx)("div",{className:Qce.iconContainer,children:(0,z.jsx)("img",{src:t.icon,className:Qce.icon})})}),(0,z.jsx)("div",{className:_d()(Qce.dataColumn),children:(0,z.jsx)(qce,{progress:s.production,max:n,theme:rue,className:Qce.productionBar,children:(0,z.jsx)(su,{value:s.production,unit:$c.WeightPerMonth})})}),(0,z.jsx)("div",{className:_d()(Qce.dataColumn),children:(0,z.jsx)(qce,{progress:s.surplus,max:n,theme:tue,className:Qce.productionBar,children:(0,z.jsx)(su,{value:s.surplus,unit:$c.WeightPerMonth})})}),(0,z.jsx)("div",{className:_d()(Qce.dataColumn),children:(0,z.jsx)(qce,{progress:s.deficit,max:n,theme:Jce,className:Qce.productionBar,children:(0,z.jsx)(su,{value:s.deficit,unit:$c.WeightPerMonth})})})]})})};oe.add("game-ui/game/components/economy-panel/production-page/resource-list/resource-list.tsx",{get ResourceList(){return iue},set ResourceList(e){iue=e}});let sue={"production-page":"production-page_A9T",productionPage:"production-page_A9T","main-column":"main-column_FBD",mainColumn:"main-column_FBD","info-column":"info-column_jLZ",infoColumn:"info-column_jLZ"};oe.add("game-ui/game/components/economy-panel/production-page/production-page.module.scss",{get classes(){return sue},set classes(e){Object.assign(sue,e)}});const lue=sue;function cue(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function uue(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return cue(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return cue(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var due,fue=function(){var e;oh(null===(e=Ew.value)||void 0===e?void 0:e.economyPanelProductionPage);var t=uue((0,Y.useState)(ty),2),n=t[0],r=t[1],i=(0,Y.useMemo)((function(){return{onFocusChange:function(e,t){return t&&r(e)},onMouseEnter:function(e){return r(e)},onMouseLeave:function(e){return r((function(t){return Qs(t,e)?ty:t}))}}}),[]);return(0,z.jsxs)("div",{className:lue.productionPage,children:[(0,z.jsx)(Sce.Provider,{value:i,children:(0,z.jsx)(iue,{className:lue.mainColumn})}),(0,z.jsx)(Pce,{entity:n,className:lue.infoColumn})]})};oe.add("game-ui/game/components/economy-panel/production-page/production-page.tsx",{get ProductionPage(){return fue},set ProductionPage(e){fue=e}}),function(e){e[e.Service=0]="Service",e[e.BudgetSlider=1]="BudgetSlider",e[e.ServiceFee=2]="ServiceFee",e[e.FeeRevenue=3]="FeeRevenue",e[e.ExportRevenue=4]="ExportRevenue",e[e.ServiceUpkeep=5]="ServiceUpkeep",e[e.ImportExpense=6]="ImportExpense"}(due||(due={}));var mue={type:due.BudgetSlider},gue={type:due.FeeRevenue},hue={type:due.ExportRevenue},pue={type:due.ServiceUpkeep},vue={type:due.ImportExpense},bue=Y.createContext({onFocusChange:function(){},onMouseEnter:function(){},onMouseLeave:function(){}});function yue(e){var t=(0,Y.useContext)(bue);return{handleFocusChange:(0,Y.useCallback)((function(n){return t.onFocusChange(e,n)}),[e,t]),handleMouseEnter:(0,Y.useCallback)((function(){return t.onMouseEnter(e)}),[e,t]),handleMouseLeave:(0,Y.useCallback)((function(){return t.onMouseLeave(e)}),[e,t])}}oe.add("game-ui/game/components/economy-panel/service-page/service-page-context.ts",{get ServicePageItemType(){return due},set ServicePageItemType(e){due=e},get BUDGET_SLIDER(){return mue},set BUDGET_SLIDER(e){mue=e},get FEE_REVENUE_FIELD(){return gue},set FEE_REVENUE_FIELD(e){gue=e},get EXPORT_REVENUE_FIELD(){return hue},set EXPORT_REVENUE_FIELD(e){hue=e},get SERVICE_UPKEEP_FIELD(){return pue},set SERVICE_UPKEEP_FIELD(e){pue=e},get IMPORT_EXPENSE_FIELD(){return vue},set IMPORT_EXPENSE_FIELD(e){vue=e},get ServicePageContext(){return bue},set ServicePageContext(e){bue=e},get useItemListeners(){return yue},set useItemListeners(e){yue=e}});let xue={"service-item-detail":"service-item-detail_iHg",serviceItemDetail:"service-item-detail_iHg","detail-layout":"detail-layout_yS8",detailLayout:"detail-layout_yS8"};oe.add("game-ui/game/components/economy-panel/service-page/item-detail/service-item-detail.module.scss",{get classes(){return xue},set classes(e){Object.assign(xue,e)}});const _ue=xue;var jue=function(e){var t=e.service,n=e.itemId,r=e.className,i=Ol(_I,t);return(0,z.jsx)(Bse,{focusKey:Hh,theme:b3,className:_d()(_ue.serviceItemDetail,r),children:Oue(n,i)})};function Oue(e,t){switch(null==e?void 0:e.type){case due.Service:return(0,z.jsx)(Eue,{entity:e.entity});case due.BudgetSlider:return null!=t?(0,z.jsx)(Sue,{serviceDetails:t}):null;case due.ServiceFee:if(null!=t){var n=t.fees.find((function(t){return t.name===e.name}));if(null!=n)return(0,z.jsx)(Tue,{fee:n,serviceDetails:t})}return null;case due.FeeRevenue:return(0,z.jsx)(Iue,{});case due.ExportRevenue:return(0,z.jsx)(wue,{});case due.ServiceUpkeep:return(0,z.jsx)(Pue,{});case due.ImportExpense:return(0,z.jsx)(Cue,{});default:return null}}var Eue=function(e){var t=e.entity,n=Ol(Ow,t);return n?(0,z.jsx)(Rse,{icon:n.icon,title:(0,z.jsx)(kc,{id:n.titleId}),description:n.descriptionId?(0,z.jsx)(kc,{id:n.descriptionId}):void 0}):null},Sue=function(e){var t=e.serviceDetails,n=t.efficiency-100;return(0,z.jsx)(Rse,{icon:t.icon,title:(0,z.jsx)(qc.EconomyPanel.SERVICE_BUDGET_SLIDER_TITLE,{hash:t.name}),description:(0,z.jsx)(qc.EconomyPanel.SERVICE_BUDGET_SLIDER_DESCRIPTION,{hash:t.name}),className:_ue.detailLayout,bottom:(0,z.jsx)(Dre,{label:(0,z.jsx)(qc.EconomyPanel.SERVICE_BUDGET_EFFICIENCY,{}),theme:Ble,className:uR(Ble,n),children:(0,z.jsx)(su,{signed:!0,value:n,unit:$c.Percentage})})},"budget")},Tue=function(e){var t=e.serviceDetails,n=e.fee,r=100*(n.consumptionMultiplier-1),i=100*(n.efficiencyMultiplier-1);return n?(0,z.jsx)(Rse,{icon:t.icon,title:(0,z.jsx)(qc.EconomyPanel.SERVICES_RESOURCE_FEE_LABEL,{hash:n.name}),description:(0,z.jsx)(qc.EconomyPanel.SERVICES_RESOURCE_FEE_DESCRIPTION,{hash:n.name}),bottom:(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(Dre,{label:(0,z.jsx)(qc.EconomyPanel.SERVICES_RESOURCE_FEE_CONSUMPTION,{hash:n.name}),theme:Ble,className:uR(Ble,-r),children:(0,z.jsx)(su,{signed:!0,value:r,unit:$c.Percentage})}),(0,z.jsx)(Dre,{label:(0,z.jsx)(qc.EconomyPanel.SERVICES_RESOURCE_FEE_EFFICIENCY,{}),theme:Ble,className:uR(Ble,i),children:(0,z.jsx)(su,{signed:!0,value:i,unit:$c.Percentage})}),(0,z.jsx)(Dre,{label:(0,z.jsx)(qc.EconomyPanel.SERVICES_RESOURCE_FEE_HAPPINESS,{}),theme:Ble,className:uR(Ble,n.happinessEffect),children:(0,z.jsx)(su,{signed:!0,value:n.happinessEffect,unit:$c.Integer})})]}),className:_ue.detailLayout}):null},Iue=function(){return(0,z.jsx)(Rse,{icon:"Media/Game/Icons/ServiceFees.svg",title:(0,z.jsx)(qc.EconomyPanel.SERVICES_FEES_LABEL_FEES,{}),description:(0,z.jsx)(qc.EconomyPanel.SERVICE_FEES_REVENUE_DESCRIPTION,{}),className:_ue.detailLayout})},wue=function(){return(0,z.jsx)(Rse,{icon:"Media/Game/Icons/Export.svg",title:(0,z.jsx)(qc.EconomyPanel.SERVICES_FEES_LABEL_EXPORT,{}),description:(0,z.jsx)(qc.EconomyPanel.SERVICE_EXPORT_REVENUE_DESCRIPTION,{}),className:_ue.detailLayout})},Pue=function(){return(0,z.jsx)(Rse,{icon:"Media/Game/Icons/ServiceUpkeep.svg",title:(0,z.jsx)(qc.EconomyPanel.SERVICES_TITLE_EXPENSES,{}),description:(0,z.jsx)(qc.EconomyPanel.SERVICE_UPKEEP_EXPENSE_DESCRIPTION,{}),className:_ue.detailLayout})},Cue=function(){return(0,z.jsx)(Rse,{icon:"Media/Game/Icons/Import.svg",title:(0,z.jsx)(qc.EconomyPanel.SERVICES_FEES_LABEL_IMPORT,{}),description:(0,z.jsx)(qc.EconomyPanel.SERVICE_IMPORT_EXPENSE_DESCRIPTION,{}),className:_ue.detailLayout})};oe.add("game-ui/game/components/economy-panel/service-page/item-detail/service-item-detail.tsx",{get ServiceItemDetail(){return jue},set ServiceItemDetail(e){jue=e}});let Nue={"budget-item":"budget-item_b_g item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT",budgetItem:"budget-item_b_g item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT",label:"label_vC7",field:"field_s_O"};oe.add("game-ui/game/components/economy-panel/service-page/service-detail/budget-item/budget-item.module.scss",{get classes(){return Nue},set classes(e){Object.assign(Nue,e)}});const Aue=Nue;var Lue=function(e){var t=e.identifier,n=e.label,r=e.value,i=yue(t),o=i.handleFocusChange,a=i.handleMouseEnter,s=i.handleMouseLeave;return(0,z.jsx)(Tg,{onFocusChange:o,children:(0,z.jsxs)(Yv,{className:Aue.budgetItem,onMouseEnter:a,onMouseLeave:s,children:[(0,z.jsx)("div",{className:Aue.label,children:n}),(0,z.jsx)(Ale,{value:r,className:Aue.field})]})})};oe.add("game-ui/game/components/economy-panel/service-page/service-detail/budget-item/budget-item.tsx",{get BudgetItem(){return Lue},set BudgetItem(e){Lue=e}});let Mue={slider:"slider_Pjj slider_pUS",thumb:"thumb_skm"};oe.add("game-ui/game/components/economy-panel/components/gradient-slider/gradient-slider.module.scss",{get classes(){return Mue},set classes(e){Object.assign(Mue,e)}});const kue=Mue;let Rue={"slider-item":"slider-item_pCt item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT",sliderItem:"slider-item_pCt item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT",label:"label_IRx",value:"value_jjh",slider:"slider_TyY"};oe.add("game-ui/game/components/economy-panel/service-page/service-detail/slider-item/slider-item.module.scss",{get classes(){return Rue},set classes(e){Object.assign(Rue,e)}});const Due=Rue;var Fue=function(e){var t=e.identifier,n=e.label,r=e.value,i=e.min,o=e.max,a=e.gradient,s=e.locked,l=e.onValueChange,c=yue(t),u=c.handleFocusChange,d=c.handleMouseEnter,f=c.handleMouseLeave,m=lF(2);return(0,z.jsx)(Tg,{onFocusChange:u,children:(0,z.jsxs)(Yv,{className:Due.sliderItem,onMouseEnter:d,onMouseLeave:f,children:[(0,z.jsx)("div",{className:Due.label,children:n}),(0,z.jsx)("div",{className:Due.value,children:(0,z.jsx)(su,{value:r,unit:$c.Percentage})}),(0,z.jsx)(HL,{children:(0,z.jsx)(rq,{value:r,start:i,end:o,gamepadStep:2,valueTransformer:m,gradient:a,theme:kue,className:Due.slider,disabled:s,onChange:l})})]})})};oe.add("game-ui/game/components/economy-panel/service-page/service-detail/slider-item/slider-item.tsx",{get SliderItem(){return Fue},set SliderItem(e){Fue=e}});var Uue={stops:[{offset:0,color:"var(--negativeColor)"},{offset:.5,color:"#bfac6f"},{offset:1,color:"var(--positiveColor)"}]},Gue=function(e){var t,n=e.service,r=e.value,i=e.locked,o=(0,Y.useCallback)((function(e){return jI(n,e)}),[n]);return(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.economyPanelServicesBudget,children:(0,z.jsx)(Fue,{identifier:mue,label:(0,z.jsx)(qc.EconomyPanel.SERVICES_TITLE_BUDGET,{}),value:r,min:50,max:150,gradient:Uue,locked:i,onValueChange:o})})};oe.add("game-ui/game/components/economy-panel/service-page/service-detail/slider-item/budget-slider-item.tsx",{get BudgetSliderItem(){return Gue},set BudgetSliderItem(e){Gue=e}});var Bue={stops:[{offset:0,color:"var(--positiveColor)"},{offset:.5,color:"#bfac6f"},{offset:1,color:"var(--negativeColor)"}]},Vue=function(e){var t=e.item,n=e.locked,r=(0,Y.useCallback)((function(e){OI(t.resource,af(t.min,t.max,e/200))}),[t.max,t.min,t.resource]),i=(0,Y.useMemo)((function(){return{type:due.ServiceFee,name:t.name}}),[t.name]),o=200*(t.fee-t.min)/(t.max-t.min);return(0,z.jsx)(Fue,{identifier:i,label:(0,z.jsx)(qc.EconomyPanel.SERVICES_RESOURCE_FEE_LABEL,{hash:t.name}),value:o,min:0,max:200,gradient:Bue,locked:n,onValueChange:r})};oe.add("game-ui/game/components/economy-panel/service-page/service-detail/slider-item/service-fee-slider-item.tsx",{get ServiceFeeSliderItem(){return Vue},set ServiceFeeSliderItem(e){Vue=e}});let Hue={header:"header_hMN",title:"title_mu8","reset-button":"reset-button_UEO button_eqb item-states_QjV",resetButton:"reset-button_UEO button_eqb item-states_QjV",scrollable:"scrollable_S7e",content:"content_SjM",adjustment:"adjustment_mUK",space:"space_nob",budget:"budget_EG1","budget-title":"budget-title_Qqo",budgetTitle:"budget-title_Qqo"};oe.add("game-ui/game/components/economy-panel/service-page/service-detail/service-detail.module.scss",{get classes(){return Hue},set classes(e){Object.assign(Hue,e)}});const Kue=Hue;var Wue=function(e){var t=e.service,n=e.className,r=(0,Y.useCallback)((function(){return EI(t)}),[t]),i=Ol(_I,t),o=null!=i&&(i.budgetAdjustable||i.fees.some((function(e){return e.adjustable})));return(0,z.jsx)(Bse,{theme:b3,className:_d()(Kue.serviceDetail,(null==i?void 0:i.locked)&&b3.locked,n),header:i&&(0,z.jsxs)("div",{className:Kue.header,children:[(0,z.jsx)("div",{className:Kue.title,children:(0,z.jsx)(qc.Services.NAME,{hash:i.name})}),o?(0,z.jsx)(Qp,{className:Kue.resetButton,disabled:!1,onSelect:r,children:"Reset"}):null]}),children:(0,z.jsx)(gE,{className:Kue.scrollable,children:(0,z.jsx)(Ap,{direction:gp.Vertical,children:i&&(0,z.jsxs)("div",{className:Kue.content,children:[o?(0,z.jsx)(z.Fragment,{children:(0,z.jsxs)("div",{className:Kue.adjustment,children:[i.budgetAdjustable&&(0,z.jsx)(Gue,{service:i.entity,value:i.budgetPercentage,locked:i.locked}),i.fees.filter((function(e){return e.adjustable})).map((function(e){return(0,z.jsx)(Vue,{item:e,locked:i.locked},e.resource)}))]})}):null,(0,z.jsx)("div",{className:Kue.space}),i.fees.length>0&&(0,z.jsxs)("div",{className:Kue.budget,children:[(0,z.jsx)("div",{className:Kue.budgetTitle,children:(0,z.jsx)(qc.EconomyPanel.SERVICES_TITLE_INCOME,{})}),(0,z.jsx)(zue,{fees:i.fees})]}),(0,z.jsxs)("div",{className:Kue.budget,children:[(0,z.jsx)("div",{className:Kue.budgetTitle,children:(0,z.jsx)(qc.EconomyPanel.SERVICES_TITLE_EXPENSES,{})}),(0,z.jsx)(Lue,{identifier:pue,label:(0,z.jsx)(qc.EconomyPanel.SERVICES_LABEL_UPKEEP,{}),value:i.upkeep}),(0,z.jsx)(Yue,{fees:i.fees})]})]})})})})},zue=function(e){var t=e.fees;if(t.length>0){var n=t.reduce((function(e,t){return e+t.incomeInternal}),0),r=t.reduce((function(e,t){return e+t.incomeExports}),0);return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(Lue,{identifier:gue,label:(0,z.jsx)(qc.EconomyPanel.SERVICES_FEES_LABEL_FEES,{}),value:n}),t.some((function(e){return e.exportable||0!==e.incomeExports}))&&(0,z.jsx)(Lue,{identifier:hue,label:(0,z.jsx)(qc.EconomyPanel.SERVICES_FEES_LABEL_EXPORT,{}),value:r})]})}return null},Yue=function(e){var t=e.fees;if(t.some((function(e){return e.importable||0!==e.expenseImports}))){var n=t.reduce((function(e,t){return e+t.expenseImports}),0);return(0,z.jsx)(z.Fragment,{children:(0,z.jsx)(Lue,{identifier:vue,label:(0,z.jsx)(qc.EconomyPanel.SERVICES_FEES_LABEL_IMPORT,{}),value:n})})}return null};oe.add("game-ui/game/components/economy-panel/service-page/service-detail/service-detail.tsx",{get ServiceDetail(){return Wue},set ServiceDetail(e){Wue=e},get FeeRevenues(){return zue},set FeeRevenues(e){zue=e},get FeeExpenses(){return Yue},set FeeExpenses(e){Yue=e}});let $ue={"service-list":"service-list_xm3",serviceList:"service-list_xm3","list-section":"list-section_BJP",listSection:"list-section_BJP",scrollable:"scrollable_rmv",item:"item_JFN button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT",locked:"locked_ZXT locked_H2O locked_dBl",icon:"icon_HoD icon_soN icon_Iwk",title:"title_sB9",field:"field_Edk","value-column-divider":"value-column-divider_PmA",valueColumnDivider:"value-column-divider_PmA","total-section":"total-section_VPy",totalSection:"total-section_VPy","total-content":"total-content_gSd",totalContent:"total-content_gSd","total-label":"total-label_mVx",totalLabel:"total-label_mVx","total-column":"total-column_k3X",totalColumn:"total-column_k3X","total-field":"total-field_rfq",totalField:"total-field_rfq"};oe.add("game-ui/game/components/economy-panel/service-page/service-list/service-list.module.scss",{get classes(){return $ue},set classes(e){Object.assign($ue,e)}});const que=$ue;var Xue=function(e){var t,n=e.selectedService,r=e.className,i=e.onSelectService,o=xl(xI),a=DL(i),s=o.reduce((function(e,t){return e+t.budget}),0);return(0,z.jsxs)("div",{className:_d()(que.serviceList,r),children:[(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.economyPanelServicesList,children:(0,z.jsx)(Bse,{theme:b3,className:que.listSection,children:(0,z.jsx)(gE,{className:que.scrollable,children:(0,z.jsx)(Ip,{focused:qs(n),direction:gp.Vertical,onChange:a,children:o.map((function(e){return(0,z.jsx)(Que,{item:e,selected:Qs(e.entity,n),onSelect:i},qs(e.entity))}))})})})}),(0,z.jsx)(Bse,{focusKey:Hh,theme:b3,className:que.totalSection,children:(0,z.jsxs)("div",{className:que.totalContent,children:[(0,z.jsx)("div",{className:que.totalLabel,children:(0,z.jsx)(qc.EconomyPanel.MONTHLY_BALANCE,{})}),(0,z.jsx)("div",{className:que.totalColumn,children:(0,z.jsx)(Ale,{value:s,importance:"primary",className:que.totalField})})]})})]})},Que=function(e){var t=e.item,n=e.selected,r=e.onSelect,i=(0,Y.useCallback)((function(){return r(t.entity)}),[t.entity,r]),o=yue((0,Y.useMemo)((function(){return{type:due.Service,entity:t.entity}}),[t.entity])),a=o.handleFocusChange,s=o.handleMouseEnter,l=o.handleMouseLeave;return(0,z.jsx)(Tg,{onFocusChange:a,children:(0,z.jsxs)(Qp,{focusKey:qs(t.entity),selected:n,className:_d()(que.item,t.locked&&que.locked),onSelect:i,onMouseEnter:s,onMouseLeave:l,children:[(0,z.jsx)("img",{src:t.icon,className:que.icon}),(0,z.jsx)("div",{className:que.title,children:(0,z.jsx)(qc.Services.NAME,{hash:t.name})}),(0,z.jsx)(Ale,{value:t.budget,importance:"secondary",className:que.field})]})})};oe.add("game-ui/game/components/economy-panel/service-page/service-list/service-list.tsx",{get ServiceList(){return Xue},set ServiceList(e){Xue=e}});let Zue={"service-page":"service-page_a6r",servicePage:"service-page_a6r","list-column":"list-column_PCc",listColumn:"list-column_PCc","main-column":"main-column_WYi",mainColumn:"main-column_WYi","info-column":"info-column_oLC",infoColumn:"info-column_oLC"};oe.add("game-ui/game/components/economy-panel/service-page/service-page.module.scss",{get classes(){return Zue},set classes(e){Object.assign(Zue,e)}});const Jue=Zue;function ede(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function tde(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return ede(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return ede(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var nde=function(){var e;oh(null===(e=Ew.value)||void 0===e?void 0:e.economyPanelServicesPage);var t=tde((0,Y.useState)(rde),2),n=t[0],r=t[1],i=Pg(),o=tde((0,Y.useState)(null),2),a=o[0],s=o[1],l=tde((0,Y.useState)(null),2),c=l[0],u=l[1],d=(0,Y.useMemo)((function(){return{onFocusChange:function(e,t){s(t?e:function(t){return el(e,t,2)?null:t})},onMouseEnter:function(e){return u(e)},onMouseLeave:function(e){return u((function(t){return el(e,t,2)?null:t}))}}}),[]),f=i?a:c;return(0,z.jsx)("div",{className:Jue.servicePage,children:(0,z.jsx)(bue.Provider,{value:d,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)(Xue,{selectedService:n,className:Jue.listColumn,onSelectService:r}),(0,z.jsx)(Wue,{service:n,className:Jue.mainColumn}),(0,z.jsx)(jue,{service:n,itemId:f,className:Jue.infoColumn})]})})})};function rde(){var e,t;return null!==(t=null===(e=iC(xI.value))||void 0===e?void 0:e.entity)&&void 0!==t?t:ty}oe.add("game-ui/game/components/economy-panel/service-page/service-page.tsx",{get ServicePage(){return nde},set ServicePage(e){nde=e}});let ide={colorMinus10:"#1e83aa",colorMinus0:"#4bc3f1",colorPlus0:"#8bdb46",colorPlus30:"#e95f4a","tax-slider":"tax-slider_HNg",taxSlider:"tax-slider_HNg",rate:"rate_lAq",range:"range_EHE","slider-column":"slider-column_XmW",sliderColumn:"slider-column_XmW",slider:"slider_lZg","estimate-column":"estimate-column_DQB",estimateColumn:"estimate-column_DQB","estimate-value":"estimate-value_grH",estimateValue:"estimate-value_grH","estimate-value-disabled":"estimate-value-disabled__q3",estimateValueDisabled:"estimate-value-disabled__q3"};oe.add("game-ui/game/components/economy-panel/taxation-page/tax-slider.module.scss",{get classes(){return ide},set classes(e){Object.assign(ide,e)}});const ode=ide;var ade=function(e){var t=e.min,n=e.max,r=e.rate,i=e.income,o=e.range,a=e.primary,s=e.className,l=e.onValueChanged,c=e.disabled,u=(0,Y.useMemo)((function(){return function(e,t){var n,r,i,o,a=null!==(n=sP(ode.colorMinus10))&&void 0!==n?n:qw,s=null!==(r=sP(ode.colorMinus0))&&void 0!==r?r:qw,l=null!==(i=sP(ode.colorPlus0))&&void 0!==i?i:qw,c=null!==(o=sP(ode.colorPlus30))&&void 0!==o?o:qw;if(e<0&&t<=0)return{stops:[{offset:0,color:rP(uP(s,a,of(e/-10,0,1)))},{offset:1,color:rP(uP(s,a,of(t/-10,0,1)))}]};if(e<0&&t>0){var u=e/(e-t);return{stops:[{offset:0,color:rP(uP(s,a,of(e/-10,0,1)))},{offset:u,color:rP(s)},{offset:u,color:rP(l)},{offset:1,color:rP(uP(l,c,of(t/30,0,1)))}]}}return{stops:[{offset:0,color:rP(uP(l,c,of(e/30,0,1)))},{offset:1,color:rP(uP(l,c,of(t/30,0,1)))}]}}(t,n)}),[t,n]);return(0,z.jsxs)("div",{className:_d()(ode.taxSlider,a&&ode.primary,s),children:[(0,z.jsxs)("div",{className:ode.sliderColumn,onClick:iv,children:[(0,z.jsx)("div",{className:_d()(ode.rate,null!=o&&o.max-o.min>.1&&ode.range),children:sde(r,o)}),(0,z.jsx)(rq,{value:r,start:t,end:n,gamepadStep:1,valueTransformer:sF,theme:kue,className:ode.slider,gradient:u,onChange:l,disabled:c})]}),(0,z.jsx)("div",{className:ode.estimateColumn,children:(0,z.jsx)(Ale,{value:i,importance:a?"secondary":void 0,className:_d()(ode.estimateValue,c&&ode.estimateValueDisabled)})})]})};function sde(e,t){return null==t?(0,z.jsx)(su,{value:e,unit:$c.PercentageSingleFraction}):t.max-t.min>.1?(0,z.jsx)(Ou,{min:t.min,max:t.max,unit:$c.PercentageSingleFraction}):(0,z.jsx)(su,{value:t.min,unit:$c.PercentageSingleFraction})}oe.add("game-ui/game/components/economy-panel/taxation-page/tax-slider.tsx",{get TaxSlider(){return ade},set TaxSlider(e){ade=e}});let lde={"taxation-item":"taxation-item_p0I item-hover_WK8 item-focused_FuT",taxationItem:"taxation-item_p0I item-hover_WK8 item-focused_FuT",icon:"icon_Eeh",title:"title_EA9",slider:"slider_rbN"};oe.add("game-ui/game/components/economy-panel/taxation-page/taxation-item.module.scss",{get classes(){return lde},set classes(e){Object.assign(lde,e)}});const cde=lde;var ude=function(e){var t=e.areaType,n=e.resource,r=Ol(bN,n),i=Ol(yN,n),o=Ol(xN,n),a=(0,Y.useCallback)((function(e){return ON(n.resource,n.area,e)}),[n]);return(0,z.jsxs)(Yv,{className:cde.taxationItem,children:[(0,z.jsx)("img",{className:cde.icon,src:o.icon}),(0,z.jsx)("div",{className:cde.title,children:1!==t.index?(0,z.jsx)(qc.Resources.TITLE,{hash:o.id}):(0,z.jsx)(qc.EconomyPanel.TAXATION_RESIDENTIAL_SLIDER_JOBLEVEL,{index:n.resource})}),(0,z.jsx)(ade,{effect:0,rate:r,min:t.resourceTaxRateMin,max:t.resourceTaxRateMax,income:i,className:cde.slider,onValueChanged:a})]})};oe.add("game-ui/game/components/economy-panel/taxation-page/taxation-item.tsx",{get TaxationItem(){return ude},set TaxationItem(e){ude=e}});let dde={"taxation-group":"taxation-group_aQb",taxationGroup:"taxation-group_aQb",header:"header_cPd item-hover_WK8 item-focused_FuT",icon:"icon_vPX","icon-disabled":"icon-disabled_lo2",iconDisabled:"icon-disabled_lo2",title:"title_WQ0","toggle-button":"toggle-button_hTU",toggleButton:"toggle-button_hTU","header-slider":"header-slider_wLI",headerSlider:"header-slider_wLI",content:"content_NUa",enter:"enter_C0R","exit-active":"exit-active_CJ6",exitActive:"exit-active_CJ6","enter-active":"enter-active_kty",enterActive:"enter-active_kty",exit:"exit_xDo",item:"item_YKG"};oe.add("game-ui/game/components/economy-panel/taxation-page/taxation-group.module.scss",{get classes(){return dde},set classes(e){Object.assign(dde,e)}});const fde=dde;function mde(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function gde(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return mde(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return mde(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var hde=function(e){var t=e.focusKey,n=e.areaType,r=e.onMouseEnter,i=e.onMouseLeave,o=gde((0,Y.useState)(!1),2),a=o[0],s=o[1],l=(0,Y.useCallback)((function(){s((function(e){return!e})),kp(Lp.expandPanel)}),[]),c=Ol(mN,n.index),u=Ol(pN,n.index),d=Ol(gN,n.index),f=Ol(hN,n.index),m=(0,Y.useCallback)((function(e){return jN(n.index,e)}),[n]),g=Ol(vN,n.index),h=g.length>0&&!n.locked,p=(0,Y.useCallback)((function(){return r(n.id)}),[r,n.id]),v=(0,Y.useCallback)((function(){return i(n.id)}),[i,n.id]);return(0,z.jsx)(op,{expanded:a,expandable:h,onAction:l,children:(0,z.jsx)(Yv,{focusKey:t,className:fde.taxationGroup,onMouseEnter:p,onMouseLeave:v,children:(0,z.jsxs)(Ap,{children:[(0,z.jsxs)(Yv,{className:fde.header,children:[(0,z.jsx)("img",{className:_d()(fde.icon,n.locked&&fde.iconDisabled),src:n.icon}),(0,z.jsx)("div",{className:fde.title,children:(0,z.jsx)(qc.EconomyPanel.TAX_AREA_TITLE,{hash:n.id})}),h&&(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:a?"Media/Glyphs/ThickStrokeArrowUp.svg":"Media/Glyphs/ThickStrokeArrowDown.svg",theme:ub,className:fde.toggleButton,onSelect:l}),(0,z.jsx)(ade,{primary:!0,effect:f,rate:c,min:n.taxRateMin,max:n.taxRateMax,income:d,range:u,className:fde.headerSlider,onValueChanged:m,disabled:n.locked})]}),h&&(0,z.jsx)(cS,{in:a,children:(0,z.jsx)(aS,{styles:fde,children:(0,z.jsx)("div",{className:fde.content,children:g.map((function(e){return(0,z.jsx)(ude,{areaType:n,resource:e},e.resource)}))})})})]})})})};oe.add("game-ui/game/components/economy-panel/taxation-page/taxation-group.tsx",{get TaxationGroup(){return hde},set TaxationGroup(e){hde=e}});let pde={"taxation-page":"taxation-page_hmd",taxationPage:"taxation-page_hmd","main-column":"main-column_JuD",mainColumn:"main-column_JuD","info-column":"info-column_e7N",infoColumn:"info-column_e7N","table-section":"table-section_D_X",tableSection:"table-section_D_X","table-header":"table-header_qcq",tableHeader:"table-header_qcq","header-cell":"header-cell_ori",headerCell:"header-cell_ori",table:"table_Gl9",scrollable:"scrollable_Xqt","table-lines":"table-lines_Abv",tableLines:"table-lines_Abv",name:"name_DfR",rate:"rate_U86",estimate:"estimate_d79","total-section":"total-section_IIZ",totalSection:"total-section_IIZ","total-content":"total-content_a5i",totalContent:"total-content_a5i","total-label":"total-label_hxK",totalLabel:"total-label_hxK","total-column":"total-column_rXB",totalColumn:"total-column_rXB","total-value":"total-value_hzh",totalValue:"total-value_hzh"};oe.add("game-ui/game/components/economy-panel/taxation-page/taxation-page.module.scss",{get classes(){return pde},set classes(e){Object.assign(pde,e)}});const vde=pde;function bde(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function yde(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return bde(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return bde(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var xde=function(){var e,t,n,r,i=xl(fN),o=xl(cN),a=yde((0,Y.useState)(oC(i,"id")),2),s=a[0],l=a[1],c=yde((0,Y.useState)(null),2),u=c[0],d=c[1],f=(0,Y.useCallback)((function(e){return d(e)}),[]),m=(0,Y.useCallback)((function(e){return d((function(t){return t===e?null:t}))}),[]),g=(0,Y.useCallback)((function(e){"string"==typeof e&&l(e)}),[]),h=Pg()?s:u,p=i.find((function(e){return e.id===h}));return rh(null===(e=Ew.value)||void 0===e?void 0:e.economyPanelTaxationPage),(0,z.jsxs)("div",{className:vde.taxationPage,children:[(0,z.jsxs)("div",{className:vde.mainColumn,children:[(0,z.jsxs)(Bse,{header:(0,z.jsxs)("div",{className:vde.tableHeader,children:[(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.economyPanelTaxationType,children:(0,z.jsx)("div",{className:_d()(vde.headerCell,vde.name),children:(0,z.jsx)(qc.EconomyPanel.TAX_AREA_COLUMN_TITLE,{})})}),(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.economyPanelTaxationRate,children:(0,z.jsx)("div",{className:_d()(vde.headerCell,vde.rate),children:(0,z.jsx)(qc.EconomyPanel.TAX_RATE_TITLE,{})})}),(0,z.jsx)(tk,{uiTag:null===(r=Ew.value)||void 0===r?void 0:r.economyPanelTaxationEstimate,children:(0,z.jsx)("div",{className:_d()(vde.headerCell,vde.estimate),children:(0,z.jsx)(qc.EconomyPanel.TAX_INCOME_ESTIMATE_TITLE,{})})})]}),theme:b3,className:vde.tableSection,children:[(0,z.jsx)(gE,{className:vde.scrollable,children:(0,z.jsx)(Ip,{focused:s,onChange:g,onRefocus:wp,children:i.map((function(e){return(0,z.jsx)(hde,{focusKey:e.id,areaType:e,onMouseEnter:f,onMouseLeave:m},e.id)}))})}),(0,z.jsxs)("div",{className:vde.tableLines,children:[(0,z.jsx)("div",{className:vde.name}),(0,z.jsx)("div",{className:vde.rate}),(0,z.jsx)("div",{className:vde.estimate})]})]}),(0,z.jsx)(Bse,{focusKey:Hh,theme:b3,className:vde.totalSection,children:(0,z.jsxs)("div",{className:vde.totalContent,children:[(0,z.jsx)("div",{className:vde.totalLabel,children:(0,z.jsx)(qc.EconomyPanel.TAX_INCOME_TOTAL_TITLE,{})}),(0,z.jsx)("div",{className:vde.totalColumn,children:(0,z.jsx)(Ale,{value:o,importance:"primary",className:vde.totalValue})})]})})]}),(0,z.jsx)(Bse,{focusKey:Hh,theme:b3,className:vde.infoColumn,children:p&&(0,z.jsx)(Rse,{icon:p.icon,title:(0,z.jsx)(qc.EconomyPanel.TAX_AREA_TITLE,{hash:p.id}),description:(0,z.jsx)(qc.EconomyPanel.TAX_AREA_DESCRIPTION,{hash:p.id})})})]})};oe.add("game-ui/game/components/economy-panel/taxation-page/taxation-page.tsx",{get TaxationPage(){return xde},set TaxationPage(e){xde=e}});let _de={"economy-panel":"economy-panel_e08",economyPanel:"economy-panel_e08"};oe.add("game-ui/game/components/economy-panel/economy-panel.module.scss",{get classes(){return _de},set classes(e){Object.assign(_de,e)}});const jde=_de;var Ode=function(e){var t=e.selectedTab,n=e.onSelectTab,r=e.onClose,i=xl(sL),o=(0,Y.useMemo)((function(){var e,t,n,r,i;return[{tab:K_.Budget,feature:"City Budget",uiTag:null===(e=Ew.value)||void 0===e?void 0:e.economyPanelBudgetTab},{tab:K_.Loan,feature:"Loan",uiTag:null===(t=Ew.value)||void 0===t?void 0:t.economyPanelLoansTab},{tab:K_.Taxation,feature:"Taxation",uiTag:null===(n=Ew.value)||void 0===n?void 0:n.economyPanelTaxationTab},{tab:K_.Services,feature:"Service Budgets",uiTag:null===(r=Ew.value)||void 0===r?void 0:r.economyPanelServicesTab},{tab:K_.Production,feature:"Production Panel",uiTag:null===(i=Ew.value)||void 0===i?void 0:i.economyPanelProductionTab}]}),[]),a=(0,Y.useMemo)((function(){return o.filter((function(e){return!i||e.tab!==K_.Loan}))}),[o,i]),s=(0,Y.useMemo)((function(){return{"Switch Tab":function(e){if(0!==e){var r=a.findIndex((function(e){return e.tab===t})),i=Tde(e,a,r);i>=0&&i<a.length&&i!==r&&(n(a[i].tab),kp(e<0?Lp.selectPreviousItem:Lp.selectNextItem))}}}}),[a,n,t]);return(0,z.jsx)(qj,{header:(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(tO,{children:(0,z.jsx)(qc.EconomyPanel.TITLE,{})}),(0,z.jsx)(S1,{children:a.map((function(e){return(0,z.jsx)(Ede,{tab:e.tab,onSelect:n,selectedTab:t,feature:e.feature,uiTag:e.uiTag},e.tab)}))})]}),transitionSounds:vj,className:jde.economyPanel,onClose:r,children:(0,z.jsx)(rp,{actions:s,children:Sde(t)})})};var Ede=function(e){var t=e.tab,n=e.selectedTab,r=e.feature,i=e.uiTag,o=e.onSelect,a=Kw(r);return(0,z.jsx)(B9,{locked:a.locked,requirements:a.requirements,children:(0,z.jsx)(T1,{id:t,uiTag:i,selectedId:n,selectSound:Lp.economy,disabled:a.locked,locked:a.locked,onSelect:o,children:(0,z.jsx)(qc.EconomyPanel.TAB,{hash:K_[t]})})})};function Sde(e){switch(e){case K_.Budget:return(0,z.jsx)(Jle,{});case K_.Loan:return(0,z.jsx)(Ece,{});case K_.Taxation:return(0,z.jsx)(xde,{});case K_.Services:return(0,z.jsx)(nde,{});case K_.Production:return(0,z.jsx)(fue,{});default:return null}}var Tde=function(e,t,n){for(var r=n<0?e<0?0:-1:n,i=1;i<=t.length;i+=1){var o=((e<0?r-i:r+i)+t.length)%t.length;if(!zw(t[o].feature))return o}return-1};oe.add("game-ui/game/components/economy-panel/economy-panel.tsx",{get EconomyPanel(){return Ode},set EconomyPanel(e){Ode=e}});let Ide={"event-journal-entry":"event-journal-entry_swm",eventJournalEntry:"event-journal-entry_swm",header:"header_YTt",icon:"icon_TDT",title:"title_CGf",date:"date_euC",info:"info_fKt",entry:"entry_oxi"};oe.add("game-ui/game/components/event-journal/event-journal-entry.module.scss",{get classes(){return Ide},set classes(e){Object.assign(Ide,e)}});const wde=Ide;var Pde=function(e){var t,n,r=e.event,i=Ol(TI,r),o=xl(TN),a=DN(o,xl(wN)),s=(0,Y.useMemo)((function(){return UN(o,i.date)}),[i.date,o]),l=0;return(0,z.jsxs)(Qp,{className:wde.eventJournalEntry,children:[(0,z.jsxs)("div",{className:wde.header,children:[(0,z.jsx)("img",{className:wde.icon,src:""!==i.icon?i.icon:"Media/Game/Icons/Calendar.svg"}),(0,z.jsx)("div",{className:wde.title,children:(0,z.jsx)(qc.EventJournal.EVENT_TITLE,{hash:i.id})}),(0,z.jsx)("div",{className:wde.date,children:kN(a,s)?(0,z.jsx)(Xu,{value:s}):(0,z.jsx)(Yu,{value:s})})]}),(0,z.jsxs)("div",{className:wde.info,children:[null===(t=i.data)||void 0===t?void 0:t.map((function(e){return(0,z.jsxs)("div",{className:wde.entry,children:[(0,z.jsx)(qc.EventJournal.EFFECT,{hash:e.type})," : ",e.value]},l++)})),null===(n=i.effects)||void 0===n?void 0:n.map((function(e){return(0,z.jsxs)("div",{className:wde.entry,children:[(0,z.jsx)(qc.EventJournal.EFFECT,{hash:e.type})," : ",(0,z.jsx)(su,{value:e.value,unit:$c.PercentageSingleFraction})]},l++)}))]})]})};oe.add("game-ui/game/components/event-journal/event-journal-entry.tsx",{get EventJournalEntry(){return Pde},set EventJournalEntry(e){Pde=e}});let Cde={"event-journal":"event-journal_yee",eventJournal:"event-journal_yee",scrollable:"scrollable_XJ4"};oe.add("game-ui/game/components/event-journal/event-journal.module.scss",{get classes(){return Cde},set classes(e){Object.assign(Cde,e)}});const Nde=Cde;var Ade=function(e){var t,n,r=e.onClose;rh(null===(t=Ew.value)||void 0===t?void 0:t.eventJournalPanel);var i=xl(II),o=(0,Y.useCallback)((function(){PI(),r()}),[r]);return(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.eventJournalPanel,children:(0,z.jsx)(qj,{theme:xse,transitionSounds:vj,className:Nde.eventJournal,header:(0,z.jsx)(tO,{children:(0,z.jsx)(qc.EventJournal.PANEL_TITLE,{})}),onClose:o,children:(0,z.jsx)(Ap,{children:i.length>0?(0,z.jsx)(gE,{className:Nde.scrollable,children:i.map((function(e){return(0,z.jsx)(Pde,{event:e},qs(e))}))}):(0,z.jsx)(a2,{children:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.EventJournal.OPENING_MESSAGE,{})})})})})})};oe.add("game-ui/game/components/event-journal/event-journal.tsx",{get EventJournal(){return Ade},set EventJournal(e){Ade=e}});let Lde={"placeholder-chirp-layout":"placeholder-chirp-layout_BAl",placeholderChirpLayout:"placeholder-chirp-layout_BAl",avatar:"avatar_Cbz",content:"content_fgv",header:"header_LnA",sender:"sender_mvI",date:"date_IvA",message:"message_F8E",word:"word_ift",footer:"footer_jEC",likes:"likes_Bzb"};oe.add("game-ui/game/components/chirper/items/placeholder-chirp-layout.module.scss",{get classes(){return Lde},set classes(e){Object.assign(Lde,e)}});const Mde=Lde;var kde=[1,4,2,7,3,3,5,4,2,3,4,2,8,5,6,3,1,2,3],Rde=function(e){var t=e.length,n=e.className;return(0,z.jsxs)("div",{className:_d()(Mde.placeholderChirpLayout,n),children:[(0,z.jsx)("div",{className:Mde.avatar}),(0,z.jsxs)("div",{className:Mde.content,children:[(0,z.jsxs)("div",{className:Mde.header,children:[(0,z.jsx)("div",{className:Mde.sender,style:{width:"".concat(25+t%4*6,"%")}}),(0,z.jsx)("div",{className:Mde.date})]}),(0,z.jsx)("div",{className:Mde.message,children:Array.from(Array(t).keys()).map((function(e,n){return(0,z.jsx)("div",{className:Mde.word,style:{width:"".concat(5*kde[(e+t)%kde.length],"%")}},n)}))}),(0,z.jsx)("div",{className:Mde.footer,children:(0,z.jsx)("div",{className:Mde.likes})})]})]})};oe.add("game-ui/game/components/chirper/items/placeholder-chirp-layout.tsx",{get PlaceholderChirpLayout(){return Rde},set PlaceholderChirpLayout(e){Rde=e}});let Dde={"life-path-detail":"life-path-detail_PR3",lifePathDetail:"life-path-detail_PR3","info-column":"info-column_pYj",infoColumn:"info-column_pYj",avatar:"avatar_FMV",name:"name_I32",age:"age_Wdj",description:"description_svN",activity:"activity_QvV",status:"status_JZS","status-item":"status-item_aJC",statusItem:"status-item_aJC","status-icon":"status-icon_ftq",statusIcon:"status-icon_ftq","status-label":"status-label_oIB",statusLabel:"status-label_oIB","icon-label":"icon-label_HgD",iconLabel:"icon-label_HgD",link:"link_Zls",icon:"icon_b3A",label:"label_lMl","feed-column":"feed-column_Idv",feedColumn:"feed-column_Idv","back-button":"back-button_HMQ",backButton:"back-button_HMQ"};oe.add("game-ui/game/components/life-path/life-path-detail/life-path-detail.module.scss",{get classes(){return Dde},set classes(e){Object.assign(Dde,e)}});const Fde=Dde;function Ude(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var Gde,Bde=new Wh("FEED"),Vde=(Ude(Gde={},CI.Chirp,(function(e){return(0,z.jsx)(Pse,{focusKey:qs(e.entity),children:(0,z.jsx)(Tse,{chirp:e})})})),Ude(Gde,CI.LogEntry,(function(e){var t=xl(TN);return(0,z.jsx)(Cse,{focusKey:qs(e.entity),date:FN(t,e.date),children:(0,z.jsx)(kc,{id:e.messageId})})})),Gde),Hde=Y.forwardRef((function(e,t){var n,r,i,o,a,s=e.selectedCitizen,l=e.details,c=e.className,u=e.onBack;oh(null===(n=Ew.value)||void 0===n?void 0:n.lifePathPanelDetail);var d,f,m,g,h=xl(TN),p=zL(Ol(MI,s)),v=hd(null!==(d=null==l?void 0:l.name)&&void 0!==d?d:null),b=hd(null!==(f=null==l?void 0:l.workplaceName)&&void 0!==f?f:null),y=hd(null!==(m=null==l?void 0:l.schoolName)&&void 0!==m?m:null),x=hd(null!==(g=null==l?void 0:l.residenceName)&&void 0!==g?g:null),_=(0,Y.useCallback)((function(){return(null==l?void 0:l.entity)&&LC(null==l?void 0:l.entity)}),[l]),j=(0,Y.useCallback)((function(){return(null==l?void 0:l.residenceEntity)&&LC(null==l?void 0:l.residenceEntity)}),[l]),O=(0,Y.useCallback)((function(){return(null==l?void 0:l.schoolEntity)&&LC(null==l?void 0:l.schoolEntity)}),[l]),E=(0,Y.useCallback)((function(){return(null==l?void 0:l.workplaceEntity)&&LC(null==l?void 0:l.workplaceEntity)}),[l]),S=XQ(),T=(0,Y.useRef)(!0),I=Pj(oC(p,"entity"));(0,Y.useEffect)((function(){T.current?T.current=!1:S.smoothScrollTo(0,0)}),[I,S]);var w,P=Pg();return(0,z.jsx)(tk,{uiTag:null===(r=Ew.value)||void 0===r?void 0:r.lifePathPanelDetail,children:(0,z.jsxs)("div",{ref:t,className:_d()(Fde.lifePathDetail,c),children:[(0,z.jsxs)(Ap,{initialFocused:Bde,children:[(0,z.jsx)(Ap,{children:(0,z.jsxs)("div",{className:Fde.infoColumn,children:[(0,z.jsx)("div",{className:Fde.avatar,style:{backgroundColor:Ese(l.randomIndex)},children:(0,z.jsx)("img",{src:null!==(w=l.avatar)&&void 0!==w?w:"Media/Game/Misc/ChirperBlankAvatar.svg"})}),(0,z.jsx)(Qp,{className:Fde.name,onSelect:_,children:v}),(0,z.jsx)("div",{className:Fde.age,children:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_AGE,{hash:l.age})}),(l.happiness||l.conditions.length>0)&&(0,z.jsxs)("div",{className:Fde.status,children:[l.happiness&&(0,z.jsx)(Kde,{icon:l.happiness.iconPath,label:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_HAPPINESS_TITLE,{hash:l.happiness.key})}),l.conditions.length>0?null===(i=l.conditions)||void 0===i?void 0:i.map((function(e){return(0,z.jsx)(Kde,{icon:e.iconPath,label:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_CONDITION_TITLE,{hash:e.key})},e.key)})):void 0]}),(0,z.jsx)("div",{className:Fde.activity,children:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_STATE,{hash:l.state})}),(0,z.jsxs)("div",{className:Fde.iconLabel,children:[(0,z.jsx)(tb,{className:Fde.icon,src:"Media/Glyphs/Education.svg"}),(0,z.jsx)("div",{className:Fde.label,children:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_EDUCATION,{hash:l.education})})]}),(0,z.jsxs)("div",{className:Fde.iconLabel,children:[(0,z.jsx)(tb,{className:Fde.icon,src:"Student"===(null==l?void 0:l.occupation)?"Media/Glyphs/School.svg":"Media/Glyphs/Workplace.svg"}),(0,z.jsx)("div",{className:Fde.label,children:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_OCCUPATION,{hash:l.occupation})})]}),("Student"===(null==l?void 0:l.occupation)||"Worker"===(null==l?void 0:l.occupation))&&(0,z.jsxs)("div",{className:Fde.iconLabel,children:[(0,z.jsx)(tb,{className:Fde.icon,src:"Student"===(null==l?void 0:l.occupation)?"Media/Glyphs/School.svg":"Media/Glyphs/Workplace.svg"}),(0,z.jsx)("div",{className:Fde.label,children:(0,z.jsx)(Qp,{className:Fde.link,onSelect:"Student"===(null==l?void 0:l.occupation)?O:E,children:"Student"===(null==l?void 0:l.occupation)?y:b})})]}),null!=l.residenceEntity&&(0,z.jsxs)("div",{className:Fde.iconLabel,children:[(0,z.jsx)(tb,{className:Fde.icon,src:"Media/Glyphs/Residence.svg"}),(0,z.jsx)("div",{className:Fde.label,children:(0,z.jsx)(Qp,{className:Fde.link,onSelect:j,children:x})})]}),(0,z.jsxs)("div",{className:Fde.iconLabel,children:[(0,z.jsx)(tb,{className:Fde.icon,src:"Media/Glyphs/Money.svg"}),(0,z.jsx)("div",{className:Fde.label,children:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_WEALTH,{hash:l.wealth})})]})]})}),(0,z.jsx)(tk,{uiTag:null===(o=Ew.value)||void 0===o?void 0:o.lifePathPanelChirps,children:(0,z.jsx)(gE,{controller:S,className:Fde.feedColumn,children:(0,z.jsxs)(Ap,{focusKey:Bde,direction:gp.Vertical,children:[(0,z.jsx)(vD,{components:Vde,data:p,keyProvider:hD}),(0,z.jsx)(Pse,{focusKey:Hh,style:{opacity:.75},children:(0,z.jsx)(Rde,{length:7})},"placeholder1"),(0,z.jsx)(Pse,{focusKey:Hh,style:{opacity:.4},children:(0,z.jsx)(Rde,{length:12})},"placeholder2"),(0,z.jsx)(Cse,{focusKey:Hh,date:DN(h,l.birthDay),children:(0,z.jsx)(qc.LifePath.CITIZEN_BIRTH,{})},"birth")]})})})]}),u&&!P&&(0,z.jsx)(tk,{uiTag:null===(a=Ew.value)||void 0===a?void 0:a.lifePathPanelBackButton,children:(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.LifePath.BACK_BUTTON_TOOLTIP,{}),children:(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:"Media/Glyphs/ArrowLeft.svg",className:Fde.backButton,onSelect:u})})})]})})})),Kde=function(e){var t=e.icon,n=e.label;return(0,z.jsxs)("div",{className:Fde.statusItem,children:[(0,z.jsx)("img",{className:Fde.statusIcon,src:t}),(0,z.jsx)("div",{className:Fde.statusLabel,children:n})]})};oe.add("game-ui/game/components/life-path/life-path-detail/life-path-detail.tsx",{get LifePathDetail(){return Hde},set LifePathDetail(e){Hde=e}});let Wde={scrollable:"scrollable_ANx",item:"item_nV8",avatar:"avatar_K_x","main-column":"main-column_Dzj",mainColumn:"main-column_Dzj",name:"name_ALg",description:"description_UGS",action:"action_oRB"};oe.add("game-ui/game/components/life-path/life-path-list/life-path-list.module.scss",{get classes(){return Wde},set classes(e){Object.assign(Wde,e)}});const zde=Wde;function Yde(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var $de=function(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Yde(e,t,n[t])}))}return e}({},Xp),{hover:null,focus:null}),qde=Y.forwardRef((function(e,t){var n=e.selectedCitizen,r=e.className,i=e.onSelectCitizen,o=xl(AI),a=xl(BS);return(0,z.jsx)("div",{ref:t,className:r,children:o.length>0?(0,z.jsx)(gE,{className:zde.scrollable,children:(0,z.jsx)(Ap,{children:o.map((function(e){return(0,z.jsx)(Xde,{item:e,selected:Qs(e.entity,n),focused:Qs(e.entity,a),onSelect:i},qs(e.entity))}))})}):(0,z.jsx)(a2,{children:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.LifePath.OPENING_MESSAGE,{})})})})})),Xde=function(e){var t,n=e.item,r=e.selected,i=e.focused,o=e.onSelect,a=hd(n.name),s=Ig(),l=(0,Y.useCallback)((function(){kp(Lp.selectItem),o(n.entity)}),[n.entity,o]),c=(0,Y.useCallback)((function(){VS(i?ty:n.entity)}),[i,n.entity]),u=(0,Y.useCallback)((function(){return DI(n.entity)}),[n.entity]),d=(0,Y.useCallback)((function(){kp(Lp.hoverItem)}),[]),f=(0,Y.useMemo)((function(){return{Select:l,"Unfollow Citizen":function(){kp(Lp.removeItem),u()}}}),[l,u]);return(0,z.jsx)(rp,{actions:f,children:(0,z.jsxs)(Yv,{className:_d()(zde.item,r&&"selected"),onClick:l,onMouseEnter:d,children:[(0,z.jsx)("div",{className:zde.avatar,style:{backgroundColor:Ese(n.randomIndex)},children:(0,z.jsx)("img",{src:null!==(t=n.avatar)&&void 0!==t?t:"Media/Game/Misc/ChirperBlankAvatar.svg"})}),(0,z.jsxs)("div",{className:zde.mainColumn,children:[(0,z.jsx)("div",{className:zde.name,children:a}),(0,z.jsx)("div",{className:zde.description,children:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_AGE,{hash:n.age})})]}),(s||i)&&(0,z.jsx)(jh,{tooltip:i?(0,z.jsx)(qc.SelectedInfoPanel.UNFOCUS,{}):(0,z.jsx)(qc.SelectedInfoPanel.FOCUS,{}),children:(0,z.jsx)(lb,{focusKey:Hh,selected:i,src:"Media/Game/Icons/MapMarker.svg",sounds:$de,className:zde.action,onSelect:c,onClick:iv})}),s&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.LifePath.UNFOLLOW_BUTTON_TOOLTIP,{}),children:(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,src:"Media/Game/Icons/Unfollow.svg",sounds:$de,selectSound:Lp.removeItem,className:zde.action,onSelect:u,onClick:iv})})]})})};oe.add("game-ui/game/components/life-path/life-path-list/life-path-list.tsx",{get LifePathList(){return qde},set LifePathList(e){qde=e}});let Qde={"life-path-panel":"life-path-panel_C3E",lifePathPanel:"life-path-panel_C3E",content:"content_auJ","detail-visible":"detail-visible_Hku",detailVisible:"detail-visible_Hku",list:"list_V2f",detail:"detail_H5A",inactive:"inactive_OSs",enter:"enter_w5W","exit-active":"exit-active_c34",exitActive:"exit-active_c34","enter-active":"enter-active_Qj1",enterActive:"enter-active_Qj1",exit:"exit_hrP"};oe.add("game-ui/game/components/life-path/life-path-panel/life-path-panel.module.scss",{get classes(){return Qde},set classes(e){Object.assign(Qde,e)}});const Zde=Qde;var Jde=new Wh("LIST"),efe=new Wh("DETAIL"),tfe=function(e){var t,n,r=e.selectedCitizen,i=e.onClose;oh(null===(t=Ew.value)||void 0===t?void 0:t.lifePathPanel);var o=Ol(LI,r),a=null!=o&&!Qs(r,ty);return(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.lifePathPanel,disableBlinking:!0,children:(0,z.jsx)(qj,{theme:xse,header:(0,z.jsx)(tO,{children:(0,z.jsx)(qc.LifePath.LIST_PANEL_TITLE,{})}),transitionSounds:vj,className:Zde.lifePathPanel,contentClassName:_d()(Zde.content,a&&Zde.detailVisible),onClose:i,children:(0,z.jsx)(ap,{onAction:a?Z_:void 0,children:(0,z.jsxs)(pj,{focused:a?efe:Jde,children:[(0,z.jsx)(hj,{focusKey:efe,children:(0,z.jsx)(Ud,{children:o&&(0,z.jsx)(Cm,{styles:Zde,children:(0,z.jsx)(Hde,{selectedCitizen:r,details:o,className:Zde.detail,onBack:Z_})},"detail")})}),(0,z.jsx)(hj,{focusKey:Jde,children:(0,z.jsx)(qde,{selectedCitizen:r,className:_d()(Zde.list,a&&Zde.inactive),onSelectCitizen:J_})})]})})})})};oe.add("game-ui/game/components/life-path/life-path-panel/life-path-panel.tsx",{get LifePathPanel(){return tfe},set LifePathPanel(e){tfe=e}});let nfe={"notifications-panel":"notifications-panel_LaL",notificationsPanel:"notifications-panel_LaL",content:"content_QBu",empty:"empty_KiN"};oe.add("game-ui/game/components/notifications-panel/notifications-panel.module.scss",{get classes(){return nfe},set classes(e){Object.assign(nfe,e)}});const rfe=nfe;var ife=function(e){var t=e.className,n=e.onClose,r=xl(Pte);return(0,z.jsxs)(qj,{header:(0,z.jsx)(tO,{children:(0,z.jsx)(qc.Menu.NOTIFICATIONS_TITLE,{})}),transitionSounds:vj,className:_d()(rfe.notificationsPanel,t),onClose:n,children:[(0,z.jsx)(gE,{className:rfe.content,children:(0,z.jsx)(Ap,{children:(0,z.jsx)(Ud,{children:r.map((function(e){return(0,z.jsx)(Fte,{item:e},e.id)}))})})}),(0,z.jsx)(cS,{in:!r.length,children:(0,z.jsx)(Cm,{styles:zne,children:(0,z.jsx)(a2,{className:rfe.empty,children:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.Menu.NOTIFICATIONS_OPENING_MESSAGE,{})})})})})]})};oe.add("game-ui/game/components/notifications-panel/notifications-panel.tsx",{get NotificationsPanel(){return ife},set NotificationsPanel(e){ife=e}});var ofe=["#DF2E3890","#5D9C5990","#0081C990"],afe=["#DF2E38","#5D9C59","#0081C9"],sfe=function(e){var t=arguments.length>2?arguments[2]:void 0,n=(arguments.length>1&&void 0!==arguments[1]?arguments[1]:[]).length>1?e:1;return t?afe[n%afe.length]:ofe[n%ofe.length]};oe.add("game-ui/editor/widgets/fields/animation-curve-field/utils/animation-curve-colors.ts",{get getCurveColorForIndex(){return sfe},set getCurveColorForIndex(e){sfe=e}});let lfe={hiddenIcon:'"Media/PhotoMode/Dropdown.svg"',visibleIcon:'"Media/PhotoMode/Dropdown.svg"',"dropdown-toggle":"dropdown-toggle_oMB dropdown-toggle_prl",dropdownToggle:"dropdown-toggle_oMB dropdown-toggle_prl",indicator:"indicator_czv","dropdown-menu":"dropdown-menu_m7l dropdown-menu_Swd",dropdownMenu:"dropdown-menu_m7l dropdown-menu_Swd","dropdown-item":"dropdown-item_JVW undefined",dropdownItem:"dropdown-item_JVW undefined"};oe.add("game-ui/game/components/cinematic-camera/cinematic-camera-dropdown.theme.module.scss",{get classes(){return lfe},set classes(e){Object.assign(lfe,e)}});const cfe=lfe;let ufe={"cinematic-camera-main-panel":"cinematic-camera-main-panel_jpU",cinematicCameraMainPanel:"cinematic-camera-main-panel_jpU","curve-editor":"curve-editor_Ay4",curveEditor:"curve-editor_Ay4","curve-editor-wrapper":"curve-editor-wrapper__lJ item-selected_tAM item-focused_FuT",curveEditorWrapper:"curve-editor-wrapper__lJ item-selected_tAM item-focused_FuT",timeline:"timeline_Zcy",title:"title_MaW","curve-selector":"curve-selector_YdT",curveSelector:"curve-selector_YdT","curve-controls":"curve-controls_AqW",curveControls:"curve-controls_AqW",toggle:"toggle_Mkg","button-panel":"button-panel_UUV",buttonPanel:"button-panel_UUV",button:"button_R8g","control-icon-button":"control-icon-button_ga5 item-states_QjV",controlIconButton:"control-icon-button_ga5 item-states_QjV","controls-group":"controls-group_nLN",controlsGroup:"controls-group_nLN","controls-separator":"controls-separator_eet",controlsSeparator:"controls-separator_eet",icon:"icon__8f",label:"label_Heh",spacing:"spacing_l1z",bottom:"bottom__Hh",left:"left_gIb",right:"right_fUY","dropdown-toggle":"dropdown-toggle_Fww item-states_QjV",dropdownToggle:"dropdown-toggle_Fww item-states_QjV","property-legend":"property-legend_yOI",propertyLegend:"property-legend_yOI","property-component":"property-component_Y36 item-states_QjV",propertyComponent:"property-component_Y36 item-states_QjV","property-component-indicator":"property-component-indicator_TYv",propertyComponentIndicator:"property-component-indicator_TYv"};oe.add("game-ui/game/components/cinematic-camera/cinematic-camera-main-panel.module.scss",{get classes(){return ufe},set classes(e){Object.assign(ufe,e)}});const dfe=ufe;var ffe=function(e){var t,n=e.groupedModifierData,r=e.onSelectProperty,i=e.activePropertyIndex,o=vz(),a=o.selectActiveCurve,s=o.data,l=LH().svg,c=(0,Y.useRef)(i),u=(0,Y.useRef)(n.length),d=n[i];if((0,Y.useEffect)((function(){var e;i!==c.current&&(null==l||null===(e=l.viewport)||void 0===e||e.resetViewport(),a(0),c.current=i)}),[i,a,l]),(0,Y.useEffect)((function(){u.current&&u.current!==n.length&&n.length>0&&r(n.length-1),u.current=n.length}),[n.length,r]),!s.curves.length||!d)return null;var f=!!(null==d?void 0:d.children);return(0,z.jsxs)("div",{className:dfe.curveSelector,children:[(0,z.jsx)(SE,{theme:cfe,content:n.map((function(e,t){var n=t===i;return(0,z.jsx)(RE,{focusKey:t,value:t,selected:n,onChange:function(){return r(t)},children:(0,z.jsx)(qc.PhotoMode.PROPERTY_TITLE,{hash:e.id})},t)})),children:(0,z.jsx)(CE,{className:dfe.dropdownToggle,children:(0,z.jsx)(qc.PhotoMode.PROPERTY_TITLE,{hash:d.id})})}),f&&(0,z.jsx)("div",{className:dfe.propertyLegend,children:null===(t=d.children)||void 0===t?void 0:t.map((function(e,t){return(0,z.jsx)(mfe,{index:t,onSelect:a,id:e.id,color:sfe(t,s.curves,!0)},e.id)}))})]})},mfe=function(e){var t=e.index,n=e.onSelect,r=e.id,i=e.color,o=(0,Y.useCallback)((function(){return n(t)}),[t,n]),a=(0,Y.useMemo)((function(){return r.endsWith("/r")?"Red":r.endsWith("/g")?"Green":r.endsWith("/b")?"Blue":r.endsWith("/a")?"Alpha":r}),[r]);return(0,z.jsxs)(Qp,{className:dfe.propertyComponent,onSelect:o,children:[(0,z.jsx)("div",{className:dfe.propertyComponentIndicator,style:{backgroundColor:i}}),(0,z.jsx)(qc.PhotoMode.PROPERTY_TITLE,{hash:a})]})};function gfe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function hfe(e,t,n,r,i,o,a){try{var s=e[o](a),l=s.value}catch(e){return void n(e)}s.done?t(l):Promise.resolve(l).then(r,i)}function pfe(e){return function(){var t=this,n=arguments;return new Promise((function(r,i){var o=e.apply(t,n);function a(e){hfe(o,r,i,a,s,"next",e)}function s(e){hfe(o,r,i,a,s,"throw",e)}a(void 0)}))}}function vfe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function bfe(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){vfe(e,t,n[t])}))}return e}function yfe(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function xfe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return gfe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return gfe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/game/components/cinematic-camera/components/curve-selector.tsx",{get CurveSelector(){return ffe},set CurveSelector(e){ffe=e}});var _fe=function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=a.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}},jfe=function(){return""},Ofe={top:50,left:10,right:10,bottom:10},Efe=new Wh("CINEMATIC CURVE CONTROLS"),Sfe=new Wh("CINEMATIC CURVE EDITOR"),Tfe=function(e){var t=e.label,n=e.modifierData,r=e.canAddKeyframes,i=e.tutorialTag,o=xl(JS),a=xfe((0,Y.useState)(0),2),s=a[0],l=a[1],c=xfe((0,Y.useState)(0),2),u=c[0],d=c[1],f=xl(Xl),m=n.grouped[u],g=(0,Y.useMemo)((function(){return m?m.children?m.children.map((function(e){return e.curve})):[m.curve]:[]}),[m]),h="".concat(u,"-").concat(s),p=qY(g,{minX:0,maxX:o,minY:isFinite(null==m?void 0:m.min)&&(null==m?void 0:m.min)!==(null==m?void 0:m.max)?m.min:void 0,maxY:isFinite(null==m?void 0:m.max)&&(null==m?void 0:m.min)!==(null==m?void 0:m.max)?m.max:void 0,wrapMode:"clamp",hash:h}),v=CT(t,s),b=(0,Y.useCallback)((function(e,t){var n=t.time;return n=Math.max(0,n),n=Math.min(o,n),yfe(bfe({},t),{time:n})}),[o]),y=xfe((0,Y.useState)(Efe),2),x=y[0],_=y[1],j=(0,Y.useMemo)((function(){return{"Move Vertical":function(){_((function(e){return e===Efe?Sfe:Efe}))}}}),[]),O=(0,Y.useCallback)(pfe((function(){var e;return _fe(this,(function(t){switch(t.label){case 0:return[4,pT()];case 1:return e=t.sent(),[2,{x:e[0],y:e[1]}]}}))})),[]),E=(0,Y.useCallback)(pfe((function(){var e;return _fe(this,(function(t){switch(t.label){case 0:return[4,bT()];case 1:return e=t.sent(),[2,{x:e[0],y:e[1]}]}}))})),[]),S=(0,Y.useCallback)(pfe((function(){var e;return _fe(this,(function(t){switch(t.label){case 0:return[4,vT()];case 1:return e=t.sent(),[2,{x:e,y:e}]}}))})),[]),T=Pg();return(0,z.jsx)(tk,{uiTag:i,children:(0,z.jsx)(Yv,{className:dfe.curveEditorWrapper,children:(0,z.jsx)(HL,{children:(0,z.jsx)(rp,{actions:j,children:(0,z.jsx)(pj,{focused:x,children:(0,z.jsx)(AH,{children:(0,z.jsxs)(pz,yfe(bfe({data:p,parseKeyframe:b,canAddKeyframes:r,onSetActiveCurve:function(e){l(m.index+e)}},v),{children:[(0,z.jsxs)(Ap,{direction:gp.Horizontal,focusKey:Efe,children:[(g.length>0||"Position"===t)&&(0,z.jsx)(Ife,{label:t,property:m?m.id:""}),(0,z.jsx)(ffe,{activePropertyIndex:u,onSelectProperty:function(e){l(n.grouped[e].index),d(e)},groupedModifierData:n.grouped})]}),(0,z.jsx)(rY,{zoomable:"y",panable:"y",showTooltipOnDrag:!0,className:dfe.curveEditor,padding:Ofe,formatLabelX:jfe,textScale:f,keyframeMoveCallback:T?O:void 0,panCallback:T?E:void 0,zoomCallback:T?S:void 0,OnFocusChange:yT,focusKey:Sfe})]}))})})})})})})},Ife=function(e){var t,n=e.label,r=e.property,i=vz(),o=i.activeKeyframe,a=i.activeCurve,s=i.removeKeyframe,l=(0,Y.useCallback)((function(){s(o,a)}),[s,o,a]),c=(0,Y.useCallback)((function(){uT(n,r)}),[n,r]);return(0,z.jsx)("div",{className:dfe.curveControls,children:(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.cinematicCameraPanelCaptureKey,children:o<0?(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.CinematicCamera.CAPTURE,{}),children:(0,z.jsx)(lb,{src:"Media/PhotoMode/AddKeyframe.svg",onSelect:c,className:dfe.controlIconButton})}):(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.CinematicCamera.DELETE_KEY,{}),children:(0,z.jsx)(lb,{src:"Media/PhotoMode/DeleteKeyframe.svg",onSelect:l,className:dfe.controlIconButton})})})})};oe.add("game-ui/game/components/cinematic-camera/cinematic-camera-curve-editor.tsx",{get CinematicCameraCurveEditor(){return Tfe},set CinematicCameraCurveEditor(e){Tfe=e}});let wfe={"curve-timeline-editor":"curve-timeline-editor_pYg",curveTimelineEditor:"curve-timeline-editor_pYg",wrapper:"wrapper_aL2 item-selected_tAM item-focused_FuT"};oe.add("game-ui/game/components/cinematic-camera/cinematic-camera-curve-timeline.module.scss",{get classes(){return wfe},set classes(e){Object.assign(wfe,e)}});const Pfe=wfe;function Cfe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Nfe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Afe(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Lfe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Cfe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Cfe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Mfe={left:0,right:0,top:0,bottom:15},kfe=function(e){return(0,z.jsx)(az,{keyframe:e,hide:"value"})},Rfe=function(e,t,n){var r=e.data;return(0,z.jsx)("g",{children:(0,z.jsx)(Lz,{origin:"center",x:r.time,y:-1.8,fill:"#eee",width:10,height:17,onSelect:t,collisionThreshold:12,children:(0,z.jsx)(Lz,{x:r.time,y:-.525,origin:"center",fill:"#eee",width:7.8,height:7.8,transform:"rotate(45)"})})})},Dfe=function(){var e=xl(eT),t=xl(JS),n=(0,Y.useRef)(!1),r=Lfe((0,Y.useState)(),2),i=r[0],o=r[1],a=xl(Xl),s=(0,Y.useMemo)((function(){return{parseKeyframe:function(e,n){return Afe(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Nfe(e,t,n[t])}))}return e}({},n),{value:0,time:Math.min(Math.max(n.time,0),t||1)})},emptyString:function(){return""},labelFormatter:function(e){return"".concat(Math.round(10*e)/10,"s")},goToPoint:function(e){var t=e.point;sT(t.x)}}}),[t]),l=s.parseKeyframe,c=s.emptyString,u=s.labelFormatter,d=s.goToPoint,f=(0,Y.useCallback)((function(){n.current=!0;var e=function(){n.current=!1,o(void 0),window.removeEventListener("mouseup",e)};window.addEventListener("mouseup",e)}),[]),m=(0,Y.useCallback)((function(e){var r=e.point;if(n.current){var i=Math.max(0,Math.min(r.x,t));sT(i),o({time:i})}}),[t]),g=(0,Y.useMemo)((function(){return{bounds:{min:{x:0,y:-1},max:{x:t||1,y:1}},curves:[{keys:[{time:e,value:0,inTangent:1/0,outTangent:1/0,inWeight:.33,outWeight:.33,weightedMode:rz.Both}],postWrapMode:iz.Default,preWrapMode:iz.Default}]}}),[t,e]),h=(0,Y.useMemo)((function(){return{"Move Horizontal":function(n){var r=of(e+n*(t/30),0,t);sT(r)}}}),[t,e]);return(0,z.jsx)(Yv,{className:Pfe.wrapper,children:(0,z.jsx)(HL,{children:(0,z.jsx)(rp,{actions:h,children:(0,z.jsx)(pz,{data:g,parseKeyframe:l,keyframeRenderer:Rfe,children:(0,z.jsx)(rY,{formatLabelX:u,formatLabelY:c,className:Pfe.curveTimelineEditor,padding:Mfe,gridLines:!1,onClick:d,showTooltipOnDrag:!0,tooltipKeyframe:i,formatTooltip:kfe,onMouseDown:f,onWindowMouseMove:m,textScale:a,children:(0,z.jsx)(wW,{drawAxes:"x"})})})})})})};oe.add("game-ui/game/components/cinematic-camera/cinematic-camera-curve-timeline.tsx",{get CinematicCameraCurveTimeline(){return Dfe},set CinematicCameraCurveTimeline(e){Dfe=e}});let Ffe={"cinematic-camera-slider":"cinematic-camera-slider_yuq",cinematicCameraSlider:"cinematic-camera-slider_yuq","slider-container":"slider-container_GDX",sliderContainer:"slider-container_GDX",value:"value_uvb"};oe.add("game-ui/game/components/cinematic-camera/cinematic-camera-slider.module.scss",{get classes(){return Ffe},set classes(e){Object.assign(Ffe,e)}});const Ufe=Ffe;var Gfe=function(e){var t=e.focusKey,n=e.value,r=e.start,i=e.end,o=e.className,a=e.onChange,s=e.onDragEnd;return(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.CinematicCamera.SEGMENT_DURATION,{}),children:(0,z.jsxs)(zv,{className:_d()(Ufe.cinematicCameraSlider,o),children:[(0,z.jsx)("div",{className:Ufe.sliderContainer,children:(0,z.jsx)(HL,{children:(0,z.jsx)(oF,{focusKey:t,value:n,start:r,end:i,onChange:a,onDragEnd:s})})}),(0,z.jsxs)("div",{className:Ufe.value,children:[n.toFixed(1),"s"]})]})})};oe.add("game-ui/game/components/cinematic-camera/cinematic-camera-slider.tsx",{get CinematicCameraSlider(){return Gfe},set CinematicCameraSlider(e){Gfe=e}});var Bfe=function(){var e,t,n=xl(iT)?"Pause":"Play";return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(tk,{uiTag:null===(e=Ew.value)||void 0===e?void 0:e.cinematicCameraPanelPlay,children:(0,z.jsx)(lb,{src:"Media/PhotoMode/".concat(n,".svg"),className:dfe.controlIconButton,onSelect:cT})}),(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.cinematicCameraPanelStop,children:(0,z.jsx)(lb,{src:"Media/PhotoMode/Stop.svg",className:dfe.controlIconButton,onSelect:lT})})]})};oe.add("game-ui/game/components/cinematic-camera/components/cinematic-camera-playback-controls.tsx",{get CinematicCameraPlaybackControls(){return Bfe},set CinematicCameraPlaybackControls(e){Bfe=e}});let Vfe={"toggle-field":"toggle-field_UCG",toggleField:"toggle-field_UCG","cinematic-camera-toggle":"cinematic-camera-toggle_sP4",cinematicCameraToggle:"cinematic-camera-toggle_sP4",toggle:"toggle_PDp",checkmark:"checkmark_jEL",label:"label_cwG"};oe.add("game-ui/game/components/cinematic-camera/components/cinematic-camera-loop-toggle.module.scss",{get classes(){return Vfe},set classes(e){Object.assign(Vfe,e)}});const Hfe=Vfe;let Kfe={"toggle-field":"toggle-field_LYp",toggleField:"toggle-field_LYp","cinematic-camera-toggle":"cinematic-camera-toggle_OVw",cinematicCameraToggle:"cinematic-camera-toggle_OVw",toggle:"toggle_kFw",checkmark:"checkmark_zMx",label:"label__3Z"};oe.add("game-ui/game/components/cinematic-camera/components/cinematic-camera-ui-toggle.module.scss",{get classes(){return Kfe},set classes(e){Object.assign(Kfe,e)}});const Wfe=Kfe;var zfe=function(e){var t=e.checked,n=e.onChange,r=e.focusKey,i=e.className;return(0,z.jsx)(zv,{className:_d()(Wfe.cinematicCameraToggle,i),children:(0,z.jsx)(fv,{theme:Wfe,checked:t,onChange:n,focusKey:r})})},Yfe=function(e){var t=e.checked,n=e.onChange,r=e.focusKey,i=e.className;return(0,z.jsx)(zv,{className:_d()(Hfe.cinematicCameraToggle,i),children:(0,z.jsx)(fv,{theme:Hfe,checked:t,onChange:n,focusKey:r})})};function $fe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function qfe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Xfe(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){qfe(e,t,n[t])}))}return e}function Qfe(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Zfe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return $fe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return $fe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/game/components/cinematic-camera/components/cinematic-camera-ui-toggle.tsx",{get CinematicCameraUIToggle(){return zfe},set CinematicCameraUIToggle(e){zfe=e},get CinematicCameraLoopToggle(){return Yfe},set CinematicCameraLoopToggle(e){Yfe=e}});var Jfe=function(e){var t=xl(e);return(0,Y.useMemo)((function(){var e={},n=[],r=Array.isArray(t)?t.reduce((function(t,r,i){var o,a,s=r.id?null===(o=r.id.match(/^(Position|Rotation|(\w|\.)+\/)/))||void 0===o?void 0:o[1]:null;if(s){var l=e[s];e[s]||(l=Qfe(Xfe({},r),{index:i,children:[],id:s.replace("/","")}),e[s]=l,t.push(e[s])),a=Qfe(Xfe({},r),{index:i,groupIndex:t.length-1,curveIndex:l.children.length}),l.children.push(a)}else a=Qfe(Xfe({},r),{index:i,curveIndex:0}),t.push(a);return n.push(a),t}),[]):[];return{grouped:r,flat:n}}),[t])},eme=function(e){var t,n,r,i,o,a,s,l=e.toggleSaveLoadPopupVisibility,c=xl(JS),u=xl(nT),d=xl(iT),f=Zfe((0,Y.useState)(!0),2),m=f[0],g=f[1],h=Jfe(wT),p=Jfe(PT);cae(d&&m),(0,Y.useEffect)((function(){return function(){lT(),ZI()}}),[]);var v=(0,Y.useMemo)((function(){return{Back:d?function(){lT()}:null}}),[d]);return(0,z.jsx)(rp,{actions:v,children:(0,z.jsx)(Ap,{direction:gp.Vertical,children:(0,z.jsxs)("div",{className:dfe.cinematicCameraMainPanel,children:[(0,z.jsx)(Ap,{direction:gp.Horizontal,children:(0,z.jsxs)("div",{className:dfe.buttonPanel,children:[(0,z.jsxs)("div",{className:dfe.controlsGroup,children:[(0,z.jsx)(Bfe,{}),(0,z.jsx)("div",{className:dfe.controlsSeparator}),(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.CinematicCamera.SAVE_LOAD_TOOLTIP,{}),children:(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.cinematicCameraPanelSaveLoad,children:(0,z.jsx)(lb,{src:"Media/Glyphs/Save.svg",onSelect:l,className:dfe.controlIconButton,tinted:!0})})}),(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.CinematicCamera.RESET_TOOLTIP,{}),children:(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.cinematicCameraPanelReset,children:(0,z.jsx)(lb,{src:"Media/Glyphs/Trash.svg",onSelect:hT,className:dfe.controlIconButton,tinted:!0})})})]}),(0,z.jsxs)("div",{className:dfe.controlsGroup,children:[(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.CinematicCamera.HIDE_UI,{}),children:(0,z.jsx)(tk,{uiTag:null===(r=Ew.value)||void 0===r?void 0:r.cinematicCameraPanelHideUI,children:(0,z.jsx)(zfe,{className:dfe.toggle,checked:m,onChange:g})})}),(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.CinematicCamera.LOOP,{}),children:(0,z.jsx)(Yfe,{className:dfe.toggle,checked:u,onChange:rT})}),(0,z.jsx)(tk,{uiTag:null===(i=Ew.value)||void 0===i?void 0:i.cinematicCameraPanelPlaybackDurationSlider,children:(0,z.jsx)(Gfe,{label:(0,z.jsx)(qc.CinematicCamera.PLAYBACK_DURATION,{}),value:c,start:1,end:120,onChange:oT,onDragEnd:aT})})]})]})}),(0,z.jsx)(Tfe,{label:"Position",canAddKeyframes:!0,modifierData:h,tutorialTag:null===(o=Ew.value)||void 0===o?void 0:o.cinematicCameraPanelTransformCurves}),(0,z.jsx)(Tfe,{label:"Property",canAddKeyframes:!0,modifierData:p,tutorialTag:null===(a=Ew.value)||void 0===a?void 0:a.cinematicCameraPanelPropertyCurves}),(0,z.jsx)(tk,{uiTag:null===(s=Ew.value)||void 0===s?void 0:s.cinematicCameraPanelTimelineSlider,children:(0,z.jsx)(Dfe,{})})]})})})};oe.add("game-ui/game/components/cinematic-camera/cinematic-camera-main-panel.tsx",{get CinematicCameraMainPanel(){return eme},set CinematicCameraMainPanel(e){eme=e}});let tme={"item-picker-section":"item-picker-section_y66",itemPickerSection:"item-picker-section_y66","panel-content":"panel-content_vkN",panelContent:"panel-content_vkN","button-row":"button-row_odR",buttonRow:"button-row_odR",input:"input_xwy item-states_QjV","control-button":"control-button_t0_ item-states_QjV",controlButton:"control-button_t0_ item-states_QjV","cloud-picker":"cloud-picker_mqV item-states_QjV",cloudPicker:"cloud-picker_mqV item-states_QjV","cloud-picker-dropdown":"cloud-picker-dropdown_ibN",cloudPickerDropdown:"cloud-picker-dropdown_ibN"};oe.add("game-ui/game/components/cinematic-camera/cinematic-camera-save-load-panel.module.scss",{get classes(){return tme},set classes(e){Object.assign(tme,e)}});const nme=tme;function rme(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function ime(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return rme(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return rme(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function ome(e){var t=e.onClose,n=xl(ET),r=xl(OT),i=ime((0,Y.useState)(function(e,t){if(!Zs(e)){var n=t.findIndex((function(t){return t.guid===e}));return n>=0?n:0}return 0}(null!==r?r.guid:null,n)),2),o=i[0],a=i[1],s=function(e){var t=(0,Y.useCallback)((function(t){var n=e[t],r=toe(n.cloudTarget,n.isReadOnly);return{displayName:Ac(n.name),image:null!=r?r:"",directory:!1,favorite:!1}}),[e]);return{length:e.length,get:t}}(n),l=bc((0,z.jsx)(qc.CinematicCamera.NEW_SEQUENCE_PLACEHOLDER,{})),c=ime((0,Y.useState)(n.length>o?n[o].name:l),2),u=c[0],d=c[1],f=(0,Y.useContext)(dO),m=xl(ST),g=xl(TT),h=(0,Y.useCallback)((function(e){return d(e.target.value)}),[]),p=(0,Y.useCallback)((function(){o>=0&&o<n.length&&f.showDialog((0,z.jsx)(OO,{title:(0,z.jsx)(qc.Common.WARNING,{}),message:(0,z.jsx)(qc.CinematicCamera.UNSAVED_DISCLAIMER,{}),onConfirm:function(){return _T(n[o].guid,n[o].cloudTarget)}}))}),[o,n,f]),v=(0,Y.useCallback)((function(){o>=0&&o<n.length&&f.showDialog((0,z.jsx)(OO,{title:(0,z.jsx)(qc.Common.WARNING,{}),message:(0,z.jsx)(qc.CinematicCamera.DELETE_DISCLAIMER,{NAME:n[o].name}),onConfirm:function(){return jT(n[o].guid,n[o].cloudTarget)}}))}),[o,n,f]),b=(0,Y.useCallback)((function(){if(!Zs(u)){var e=n.find((function(e){return!e.isReadOnly&&e.cloudTarget===g&&e.name===u}));e?f.showDialog((0,z.jsx)(OO,{title:(0,z.jsx)(qc.Common.WARNING,{}),message:(0,z.jsx)(qc.CinematicCamera.OVERRIDE_DISCLAIMER,{NAME:u}),onConfirm:function(){return xT(u,e.guid)}})):xT(u,null)}}),[u,n,f,g]),y=(0,Y.useCallback)((function(e){a(e),d(n[e].name)}),[n]),x=y5(),_=xl(_G);return(0,z.jsx)(qj,{onClose:t,header:(0,z.jsx)(tO,{children:(0,z.jsx)(qc.CinematicCamera.SAVE_LOAD_TOOLTIP,{})}),contentClassName:nme.panelContent,allowFocusExit:!0,children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)(ame,{targets:m,selectedTarget:g,onSelectTarget:IT}),(0,z.jsx)(Bse,{className:nme.itemPickerSection,children:(0,z.jsx)(HL,{children:(0,z.jsx)(oZ,{selectedIndex:o,columnCount:1,data:s,onSelect:y,hasImages:!0})})}),(0,z.jsx)(yb,{value:u,onChange:h,className:_d()(x.input,nme.input)}),(0,z.jsxs)("div",{className:nme.buttonRow,children:[(0,z.jsx)(jh,{tooltip:_.reasonHash?(0,z.jsx)(qc.Common.SAVEABILITY_REASON,{hash:_.reasonHash}):(0,z.jsx)(qc.CinematicCamera.SAVE_TOOLTIP,{}),children:(0,z.jsx)(lb,{src:"Media/Glyphs/Save.svg",onSelect:b,disabled:!_.canSave||Zs(u),tinted:!0,className:nme.controlButton})}),(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.CinematicCamera.LOAD_TOOLTIP,{}),children:(0,z.jsx)(lb,{src:"Media/Glyphs/School.svg",disabled:o<0||o>=n.length,onSelect:p,tinted:!0,className:nme.controlButton})}),(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.CinematicCamera.DELETE_TOOLTIP,{}),children:(0,z.jsx)(lb,{src:"Media/Glyphs/Trash.svg",disabled:o<0||o>=n.length||n[o].isReadOnly,onSelect:v,tinted:!0,className:nme.controlButton})})]})]})})}function ame(e){var t=e.targets,n=e.selectedTarget,r=e.onSelectTarget;return(0,z.jsxs)(zv,{className:nme.cloudPicker,children:[(0,z.jsx)("div",{children:(0,z.jsx)(qc.Menu.CLOUD_TARGET_LABEL,{})}),(0,z.jsx)("div",{className:nme.cloudPickerDropdown,children:(0,z.jsx)(SE,{content:t.map((function(e,t){return(0,z.jsx)(RE,{value:e,onChange:r,children:(0,z.jsx)(qc.Menu.CLOUD_TARGET,{hash:e})},t)})),theme:EZ,children:(0,z.jsx)(CE,{value:n,children:(0,z.jsx)(qc.Menu.CLOUD_TARGET,{hash:n})})})})]})}oe.add("game-ui/game/components/cinematic-camera/cinematic-camera-save-load-panel.tsx",{get CinematicCameraSaveLoadPanel(){return ome},set CinematicCameraSaveLoadPanel(e){ome=e}});let sme={"cinematic-panel-layout":"cinematic-panel-layout_e2g",cinematicPanelLayout:"cinematic-panel-layout_e2g",title:"title_eom"};oe.add("game-ui/game/components/cinematic-camera/cinematic-camera-panel.module.scss",{get classes(){return sme},set classes(e){Object.assign(sme,e)}});const lme=sme;let cme={base:"base_iGt",enter:"enter_F0S","exit-active":"exit-active__9F",exitActive:"exit-active__9F","enter-active":"enter-active_Dkv",enterActive:"enter-active_Dkv",exit:"exit_tDP",wrapper:"wrapper_bAS"};oe.add("game-ui/game/components/cinematic-camera/cinematic-camera-panel-transitions.module.scss",{get classes(){return cme},set classes(e){Object.assign(cme,e)}});const ume=cme;function dme(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function fme(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return dme(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return dme(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var mme=function(e){var t,n,r=e.isVisible,i=e.onClose;rh(null===(t=Ew.value)||void 0===t?void 0:t.cinematicCameraPanel);var o=fme((0,Y.useState)(!1),2),a=o[0],s=o[1];(0,Y.useEffect)((function(){r||s(!1)}),[r]);var l=(0,Y.useCallback)((function(){return s((function(e){return!e}))}),[]);return(0,z.jsxs)("div",{className:lme.cinematicPanelLayout,children:[(0,z.jsx)(Ud,{children:a&&(0,z.jsx)(ome,{onClose:l},"CinematicCameraSaveLoad")}),(0,z.jsx)(Ud,{children:r&&(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.cinematicCameraPanel,children:(0,z.jsx)(qj,{transitionSounds:vj,onClose:i,transition:ume,allowFocusExit:!0,children:(0,z.jsx)(eme,{toggleSaveLoadPopupVisibility:l})},"CinematicCameraPanel")})})]},"CinematicCameraLayout")};oe.add("game-ui/game/components/cinematic-camera/cinematic-camera-panel.tsx",{get CinematicCameraPanel(){return mme},set CinematicCameraPanel(e){mme=e}});let gme={field:"field_Y9F undefined",label:"label_6SZ label_eX_"};oe.add("game-ui/game/widgets/field/row-field.module.scss",{get classes(){return gme},set classes(e){Object.assign(gme,e)}});const hme=gme;function pme(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function vme(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){pme(e,t,n[t])}))}return e}function bme(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var yme=bme(vme({},Xp),{hover:null,focus:null});function xme(e){return(0,z.jsx)(_me,bme(vme({},e.props),{children:e.props.value}))}var _me=function(e){var t=e.theme,n=void 0===t?hme:t,r=e.disabled,i=e.className,o=e.children,a=e.onClick,s=(0,Y.useCallback)((function(e){!r&&a&&a(e)}),[r,a]);return(0,z.jsx)(Yv,{focusKey:r?Hh:void 0,focusSound:Lp.hoverItem,className:_d()(n.field,r&&"disabled",i),onClick:s,children:(0,z.jsx)("div",{children:o})})};oe.add("game-ui/game/widgets/field/field.tsx",{get optionButtonSounds(){return yme},set optionButtonSounds(e){yme=e},get ValueField(){return xme},set ValueField(e){xme=e},get Field(){return _me},set Field(e){_me=e}});let jme={container:"container_eL2",dropdown:"dropdown_pJu item-states_QjV"};oe.add("game-ui/game/widgets/dropdown-field/dropdown-field.module.scss",{get classes(){return jme},set classes(e){Object.assign(jme,e)}});const Ome=jme;function Eme(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Sme(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Eme(e,t,n[t])}))}return e}function Tme(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Ime(e){return(0,z.jsx)(Pme,Sme({items:e.props.enumMembers,value:e.props.value},e))}function wme(e){return(0,z.jsx)(Pme,Sme({items:e.props.items,value:e.props.value},e))}function Pme(e){var t=e.items.findIndex((function(t){return el(t.value,e.value)})),n=-1!==t?e.items[t]:null,r=RR(YR,uD(e.parent,e.path));return(0,z.jsx)(_me,Tme(Sme({},e.props),{className:Ome.container,children:(0,z.jsx)(SE,{focusKey:e.props.disabled?Hh:Kh,initialFocused:t,theme:N2,content:e.items.filter((function(e,n){return!e.disabled&&(0!==n||0===t)})).map((function(e,t){return(0,z.jsx)(RE,{focusKey:t,value:e.value,selected:!!n&&el(n.value,e.value),onChange:r,children:Cme(e)},t)})),children:(0,z.jsx)(CE,{disabled:e.props.disabled,sounds:yme,className:Ome.dropdown,children:Cme(n)})})}))}function Cme(e){return e?(0,z.jsx)(ku,{value:e.displayName}):null}oe.add("game-ui/game/widgets/dropdown-field/dropdown-field.tsx",{get BoundEnumField(){return Ime},set BoundEnumField(e){Ime=e},get BoundDropdownField(){return wme},set BoundDropdownField(e){wme=e}});let Nme={row:"row_l3P",input:"input_JvC item-states_QjV",label:"label_eX_",checkbox:"checkbox_mm1"};oe.add("game-ui/game/widgets/field/field.module.scss",{get classes(){return Nme},set classes(e){Object.assign(Nme,e)}});const Ame=Nme;var Lme=function(e){var t=RR(YR,uD(e.parent,e.path));return(0,z.jsx)(Yv,{className:"".concat(Ame.row," row-number-input"),focusKey:e.props.disabled?Hh:Kh,children:(0,z.jsx)(PY,{value:e.props.value,min:e.props.min,max:e.props.max,fractionDigits:e.props.fractionDigits,disabled:e.props.disabled,className:Ame.input,onChange:t})})};oe.add("game-ui/game/widgets/field/float-input-field.tsx",{get BoundFloatInputField(){return Lme},set BoundFloatInputField(e){Lme=e}});var Mme=function(e){var t=RR(YR,uD(e.parent,e.path));return(0,z.jsx)(Yv,{focusKey:e.props.disabled?Hh:Kh,className:"".concat(Ame.row," row-number-input"),children:(0,z.jsx)(f$,{value:e.props.value,min:e.props.min,max:e.props.max,disabled:e.props.disabled,className:Ame.input,onChange:t})})};oe.add("game-ui/game/widgets/field/int-input-field.tsx",{get BoundIntInputField(){return Mme},set BoundIntInputField(e){Mme=e}});let kme={"game-icon-button-group":"game-icon-button-group_RE4",gameIconButtonGroup:"game-icon-button-group_RE4",button:"button_C2v"};oe.add("game-ui/game/widgets/icon-button/icon-button.module.scss",{get classes(){return kme},set classes(e){Object.assign(kme,e)}});const Rme=kme;function Dme(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Fme(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Dme(e,t,n[t])}))}return e}function Ume(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var Gme=function(e){return(0,z.jsx)(Hme,{children:(0,z.jsx)(Vme,Fme({},e))})},Bme=function(e){var t=e.parent,n=e.path,r=e.children,i=uD(t,n);return(0,z.jsx)(Hme,{children:r.map((function(e){var t=e.path,n=Ume(e,["path"]);return(0,z.jsx)(Vme,Fme({parent:i,path:t},n),t)}))})},Vme=function(e){var t=e.parent,n=e.path,r=e.props,i=RR(zR,uD(t,n));return(0,z.jsx)(jh,{tooltip:null!=r.tooltip?(0,z.jsx)(ku,{value:r.tooltip}):null,children:(0,z.jsx)(tk,{uiTag:r.tutorialTag||void 0,children:(0,z.jsx)(Kme,{src:r.icon,selected:r.selected,disabled:r.disabled,onSelect:i})})})},Hme=function(e){var t=e.children;return(0,z.jsx)("div",{className:Rme.gameIconButtonGroup,children:t})},Kme=function(e){var t=e.src,n=e.selected,r=e.disabled,i=e.className,o=e.onSelect;return(0,z.jsx)(lb,{tinted:!0,src:t,selected:n,disabled:r,theme:o7,className:_d()(Rme.button,i),onSelect:o})};oe.add("game-ui/game/widgets/icon-button/icon-button.tsx",{get BoundIconButton(){return Gme},set BoundIconButton(e){Gme=e},get BoundIconButtonGroup(){return Bme},set BoundIconButtonGroup(e){Bme=e},get GameIconButtonGroup(){return Hme},set GameIconButtonGroup(e){Hme=e},get GameIconButton(){return Kme},set GameIconButton(e){Kme=e}});let Wme={"toggle-field":"toggle-field_D6P",toggleField:"toggle-field_D6P",toggle:"toggle_CGE"};oe.add("game-ui/game/widgets/toggle-field/toggle-field.module.scss",{get classes(){return Wme},set classes(e){Object.assign(Wme,e)}});const zme=Wme;function Yme(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function $me(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function qme(e){var t=RR(YR,uD(e.parent,e.path)),n=(0,Y.useCallback)((function(){t(!e.props.value)}),[t,e.props.value]);return(0,z.jsx)(_me,$me(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Yme(e,t,n[t])}))}return e}({},e.props),{onClick:n,children:(0,z.jsx)(tk,{uiTag:e.props.tutorialTag||void 0,active:!e.props.disabled,children:(0,z.jsx)("div",{className:zme.toggleField,children:(0,z.jsx)(jh,{tooltip:e.props.tooltip&&(0,z.jsx)(ku,{value:e.props.tooltip}),children:(0,z.jsx)(fv,{checked:e.props.value,className:zme.toggle,onChange:t,disabled:e.props.disabled})})})})}))}oe.add("game-ui/game/widgets/toggle-field/toggle-field.tsx",{get BoundToggleField(){return qme},set BoundToggleField(e){qme=e}});let Xme={container:"container_HLA",group:"group_CmM",title:"title_vqR","group-title":"group-title_vnJ",groupTitle:"group-title_vnJ",children:"children_wvV",draggable:"draggable__cr","before-title-group":"before-title-group_JPn",beforeTitleGroup:"before-title-group_JPn",active:"active_ZKV",tooltip:"tooltip_mo_","tooltip-content":"tooltip-content_Eri",tooltipContent:"tooltip-content_Eri","tooltip-content-row":"tooltip-content-row_aco",tooltipContentRow:"tooltip-content-row_aco"};oe.add("game-ui/game/components/photo-mode/widgets/photo-mode-widgets.module.scss",{get classes(){return Xme},set classes(e){Object.assign(Xme,e)}});const Qme=Xme;function Zme(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Jme(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function ege(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Zme(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Zme(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var tge=(0,Y.memo)((function(e){var t,n=e.parent,r=e.path,i=e.children,o=e.props,a=uD(n,r),s=!1,l=ege(i.reduce((function(e,t){var n,r,i="Game.UI.Widgets.IconButton"===t.props.__Type,o="Game.UI.Widgets.ToggleField"===t.props.__Type&&t.path<2;i||o?("PhotoMode.ENABLE_PROPERTY_TOOLTIP"===(null===(n=t.props)||void 0===n||null===(r=n.tooltip)||void 0===r?void 0:r.id)&&(s=!!t.props.value),e[0].push(t)):e[1].push(t);return e}),[[],[]]),2),c=l[0],u=l[1],d=(0,z.jsx)(ku,{value:o.displayName}),f=o.tooltip&&(0,z.jsx)(ku,{value:o.tooltip});return(0,z.jsx)(zv,{className:_d()(Qme.container,(t={},Jme(t,Qme.active,s),Jme(t,Qme.group,!u.length),t)),children:(0,z.jsx)(Ap,{direction:gp.Horizontal,children:(0,z.jsxs)("div",{className:Qme.children,children:[!!c.length&&(0,z.jsx)("div",{className:Qme.beforeTitleGroup,children:(0,z.jsx)(OD,{parent:a,components:bge,data:c})}),(0,z.jsx)(e8,{alignment:"start",direction:"left",title:d,description:f,className:Qme.tooltip,children:(0,z.jsx)("div",{className:_d()(Qme.title,Jme({},Qme.groupTitle,!u.length)),children:d})}),(0,z.jsx)(OD,{parent:a,components:bge,data:u})]})})})}),(function(e,t){return el(e,t,20)})),nge=function(e){var t=e.title,n=e.tooltip,r=e.tooltipPos,i=void 0===r?GR.Cotnainer:r,o=e.children,a=null;t&&(a=i===GR.Title&&n?(0,z.jsx)(jh,{tooltip:n,children:(0,z.jsx)("div",{className:Qme.title,children:t})}):(0,z.jsx)("div",{className:Qme.title,children:t}));var s=(0,z.jsx)(Yv,{className:Qme.container,children:(0,z.jsx)(Ap,{children:(0,z.jsxs)("div",{className:Qme.children,children:[a,o]})})});return n&&i!==GR.Title?(0,z.jsx)(jh,{tooltip:n,children:s}):s};function rge(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function ige(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function oge(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){ige(e,t,n[t])}))}return e}function age(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function sge(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return rge(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return rge(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/game/components/photo-mode/widgets/photo-mode-container.tsx",{get BoundPhotoModeContainer(){return tge},set BoundPhotoModeContainer(e){tge=e},get PhotoModeContainer(){return nge},set PhotoModeContainer(e){nge=e}});var lge=1e4,cge=function(e,t){return[isFinite(e)?e:Math.sign(e)*lge,isFinite(t)?t>e?t:lge:Math.sign(t)*lge]},uge=function(e,t){return Math.pow(Math.abs(e)/t,3)};function dge(e){var t=sge((0,Y.useMemo)((function(){return cge(e.props.min,e.props.max)}),[e.props.min,e.props.max]),2),n=t[0],r=t[1],i=(0,Y.useCallback)((function(e,t){return of(e+(t<0?n-e:r-e)*uge(t,.1),n,r)}),[n,r]);return(0,z.jsx)(mge,age(oge({},e),{dragTransformation:i}))}function fge(e){var t=sge((0,Y.useMemo)((function(){return cge(e.props.min,e.props.max)}),[e.props.min,e.props.max]),2),n=t[0],r=t[1],i=(0,Y.useCallback)((function(e,t){return of(e+(t<0?n-e:r-e)*uge(t,.1),n,r)}),[n,r]);return(0,z.jsx)(mge,age(oge({},e),{dragTransformation:i}))}var mge=function(e){var t=e.parent,n=e.path,r=e.props,i=e.dragTransformation,o=RR(YR,uD(t,n)),a=(0,z.jsx)(bY,{className:Qme.draggable,value:r.value,disabled:r.disabled,dragTransformation:i,onChange:o}),s=(0,z.jsx)(ku,{value:r.displayName}),l=r.tooltip&&(0,z.jsx)(ku,{value:r.tooltip}),c=(0,z.jsx)(gge,{min:r.min,max:r.max,fractionDigits:0});return s||l||c?(0,z.jsx)(e8,{alignment:"start",direction:"left",title:s,description:l,content:c,className:Qme.tooltip,children:a}):a};function gge(e){var t=e.min,n=e.max,r=e.fractionDigits,i=isFinite(t),o=isFinite(n)&&(n>t||!i);return i||o?(0,z.jsxs)("div",{className:Qme.tooltipContent,children:[i&&(0,z.jsxs)("div",{className:Qme.tooltipContentRow,children:[(0,z.jsx)("div",{children:(0,z.jsx)(qc.PhotoMode.PROPERTY_LIMIT_MIN,{})}),(0,z.jsx)("div",{children:t.toFixed(r)})]}),o&&(0,z.jsxs)("div",{className:Qme.tooltipContentRow,children:[(0,z.jsx)("div",{children:(0,z.jsx)(qc.PhotoMode.PROPERTY_LIMIT_MAX,{})}),(0,z.jsx)("div",{children:n.toFixed(r)})]})]}):null}function hge(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}oe.add("game-ui/game/components/photo-mode/widgets/photo-mode-draggable-slider.tsx",{get BoundIntDraggableSliderField(){return dge},set BoundIntDraggableSliderField(e){dge=e},get BoundFloatDraggableSliderField(){return fge},set BoundFloatDraggableSliderField(e){fge=e}});var pge,vge=function(e){var t=e.displayName,n=e.parent,r=e.data,i=(0,Y.useContext)(Rp).scrollTo;return(0,Y.useEffect)((function(){i(0,0)}),[t,i]),(0,z.jsx)(OD,{parent:n,components:bge,data:r},t)},bge=(hge(pge={},FR.Group,tge),hge(pge,FR.FloatSliderField,fge),hge(pge,FR.IntSliderField,dge),hge(pge,FR.ToggleField,qme),hge(pge,FR.IconButton,Gme),hge(pge,aw.DropdownField,wme),hge(pge,FR.FloatInputField,Lme),hge(pge,FR.IntInputField,Mme),hge(pge,FR.EnumField,Ime),hge(pge,FR.ColorField,p4),pge);oe.add("game-ui/game/components/photo-mode/photo-widget-renderer.tsx",{get PhotoWidgetListRenderer(){return vge},set PhotoWidgetListRenderer(e){vge=e},get photoModeWidgetComponents(){return bge},set photoModeWidgetComponents(e){bge=e}});let yge={"panel-layout":"panel-layout_eys",panelLayout:"panel-layout_eys",title:"title_Rbz","panel-title-bar":"panel-title-bar_Vge",panelTitleBar:"panel-title-bar_Vge","tab-label":"tab-label_TD9",tabLabel:"tab-label_TD9",label:"label_fnL","photo-mode-panel":"photo-mode-panel_oo_",photoModePanel:"photo-mode-panel_oo_","simulation-warning":"simulation-warning_t8O",simulationWarning:"simulation-warning_t8O",scrollable:"scrollable_eMn","button-panel":"button-panel_dnD",buttonPanel:"button-panel_dnD","cinematic-camera-button":"cinematic-camera-button_ctq item-states_QjV",cinematicCameraButton:"cinematic-camera-button_ctq item-states_QjV","tab-bar":"tab-bar_wDc",tabBar:"tab-bar_wDc",tabs:"tabs_asW","tab-button":"tab-button_D0T",tabButton:"tab-button_D0T",icon:"icon_KWo",locked:"locked_y0b"};oe.add("game-ui/game/components/photo-mode/photo-mode-panel.module.scss",{get classes(){return yge},set classes(e){Object.assign(yge,e)}});const xge=yge;var _ge=function(e){var t,n,r=e.onClose,i=xl(dw),o=xl(sw),a=xl(iT),s=cD(QI);oh(null===(t=Ew.value)||void 0===t?void 0:t.photoModePanel);var l=xl(lw),c=xl(cw),u=(0,Y.useCallback)((function(){ow(!o)}),[o]),d=(0,Y.useCallback)((function(){ow(!1)}),[]),f=(0,Y.useCallback)((function(){a?lT():o?d():r()}),[o,d,r,a]);(0,Y.useEffect)((function(){return ew(!0),function(){ZI(),ew(!1)}}),[]);var m=(0,Y.useCallback)((function(e){var t=l.findIndex((function(e){return e.id===c}));if(t>=0){var n=(t+e)%l.length;iw(l[n<0?n+l.length:n].id)}else iw(l[l.length-1].id)}),[c,l]),g=(0,Y.useMemo)((function(){return function(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}({"Switch Tab":m},o?"Photo Mode":"Cinematic Mode",u)}),[o,m,u]);return(0,z.jsx)(ap,{onAction:f,children:(0,z.jsx)(rp,{actions:g,children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)(mme,{isVisible:o,onClose:d}),(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.photoModePanel,children:(0,z.jsx)(qj,{transitionSounds:vj,className:xge.title,onClose:f,allowFocusExit:!0,header:(0,z.jsx)(jge,{toggleCinematicCameraPanel:u}),children:(0,z.jsx)(Ap,{children:(0,z.jsxs)("div",{className:xge.photoModePanel,children:["Environment"===c&&(0,z.jsx)("div",{className:xge.simulationWarning,children:(0,z.jsx)(qc.PhotoMode.ENVIRONMENT_DISCLAIMER,{})}),(0,z.jsx)(gE,{className:xge.scrollable,children:null!=i&&(0,z.jsx)(vge,{displayName:c,parent:s,data:i})}),(0,z.jsx)(Oge,{})]})})})})]})})})},jge=function(e){var t,n,r=e.toggleCinematicCameraPanel,i=xl(sw),o=xl(cw),a=xl(lw),s=(0,Y.useCallback)((function(e){return iw(e)}),[]),l=i?"ExpandRight":"ExpandLeft";return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.photoModePanelTitle,children:(0,z.jsx)(tO,{className:xge.panelTitleBar,children:i?(0,z.jsx)(qc.CinematicCamera.TITLE,{}):(0,z.jsx)(qc.PhotoMode.TITLE,{})})}),(0,z.jsx)("div",{className:xge.tabBar,children:(0,z.jsxs)("div",{className:xge.tabs,children:[(0,z.jsx)(GL,{children:a.map((function(e,t){var n;return(0,z.jsx)(Ege,{id:e.id,icon:e.icon,tooltip:(0,z.jsx)(qc.PhotoMode.TAB,{hash:e.id}),selected:e.id===o,onSelect:s,tutorialTag:0===t?null===(n=Ew.value)||void 0===n?void 0:n.photoModeTab:void 0},t)}))}),(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.photoModeCinematicCameraToggle,children:(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.CinematicCamera.TITLE,{}),children:(0,z.jsx)(lb,{src:"Media/PhotoMode/".concat(l,".svg"),onSelect:r,className:xge.cinematicCameraButton})})})]})})]})},Oge=function(){var e,t,n=xl(tw);return(0,z.jsx)(z.Fragment,{children:(0,z.jsx)("div",{className:xge.buttonPanel,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)(tk,{uiTag:null===(e=Ew.value)||void 0===e?void 0:e.photoModePanelTakePicture,children:(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.PhotoMode.TAKE_PHOTO,{}),children:(0,z.jsx)(lb,{tinted:!0,theme:o7,src:"Media/PhotoMode/TakePicture.svg",onSelect:rw,selectSound:Lp.takePhoto})})}),(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.photoModePanelHideUI,children:(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.PhotoMode.HIDE_UI,{}),children:(0,z.jsx)(lb,{tinted:!0,theme:o7,src:"Media/PhotoMode/HideUIOn.svg",onSelect:L_})})}),(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.PhotoMode.TOGGLE_ORBIT_MODE,{}),children:(0,z.jsx)(lb,{tinted:!0,theme:o7,selected:n,src:"Media/Game/Icons/Orbit.svg",onSelect:nw})})]})})})},Ege=function(e){var t=e.id,n=e.icon,r=e.tooltip,i=e.selected,o=e.disabled,a=e.className,s=e.onSelect,l=e.tutorialTag,c=(0,Y.useCallback)((function(){return s(t)}),[t,s]),u=(0,Y.useMemo)((function(){return"PhotoModeTab+"+t}),[t]);return(0,z.jsx)(jh,{tooltip:r,children:(0,z.jsx)(tk,{uiTag:l,children:(0,z.jsx)(tk,{uiTag:u,children:(0,z.jsx)(lb,{src:n,disabled:o,selected:i,className:_d()(a,xge.tabButton),onSelect:c})})})})};oe.add("game-ui/game/components/photo-mode/photo-mode-panel.tsx",{get PhotoModePanel(){return _ge},set PhotoModePanel(e){_ge=e}});var Sge="achievements",Tge=fl(Sge,"showAchievementsTab"),Ige=fl(Sge,"achievements");oe.add("game-ui/game/data-binding/achievement-bindings.ts",{get showAchievementsTab(){return showAchievementsTab},set showAchievementsTab(e){showAchievementsTab=e},get achievements(){return achievements},set achievements(e){achievements=e}});let wge={"progress-bar":"progress-bar_VAk",progressBar:"progress-bar_VAk","progress-bounds":"progress-bounds_aKD",progressBounds:"progress-bounds_aKD",progress:"progress_gG0",label:"label_D0Y","progress-label":"progress-label_SHL",progressLabel:"progress-label_SHL"};oe.add("game-ui/game/components/progression/progression-panel/shared-components/progress-bar/progress-bar.module.scss",{get classes(){return wge},set classes(e){Object.assign(wge,e)}});const Pge=wge;let Cge={achievement:"achievement_BUQ item-states_QjV",content:"content_n2n",left:"left_tyE",right:"right_wLd",icon:"icon_fbN",disabled:"disabled_Jh2",locked:"locked_tfQ",label:"label_hdQ","progress-bar":"progress-bar_MqT",progressBar:"progress-bar_MqT"};oe.add("game-ui/game/components/progression/progression-panel/achievements-page/achievement.module.scss",{get classes(){return Cge},set classes(e){Object.assign(Cge,e)}});const Nge=Cge;var Age=function(e){var t=e.achievement,n=e.selected,r=e.onHover,i=e.onSelect,o=(0,Y.useCallback)((function(){return r(t)}),[r,t]),a=(0,Y.useCallback)((function(){return kp(Lp.hoverItem)}),[]),s=(0,Y.useCallback)((function(){return r(null)}),[r]),l=(0,Y.useCallback)((function(e){e&&(i(t),kp(Lp.hoverItem))}),[t,i]),c=(0,Y.useCallback)((function(){i(t),kp(Lp.selectItem)}),[t,i]);return(0,z.jsx)(Yv,{onClick:c,onMouseOver:o,onMouseEnter:a,onMouseLeave:s,onFocusChange:l,className:_d()(Nge.achievement,n&&"selected",t.locked&&Nge.locked),children:(0,z.jsxs)("div",{className:Nge.content,children:[(0,z.jsxs)("div",{className:Nge.left,children:[(0,z.jsx)("img",{className:Nge.icon,src:t.imagePath}),(0,z.jsx)("div",{className:Nge.label,children:(0,z.jsx)(qc.Achievements.TITLE,{hash:t.localeKey})})]}),(0,z.jsx)("div",{className:Nge.right,children:t.isIncremental&&(0,z.jsx)(qce,{theme:Pge,className:Nge.progressBar,progress:t.locked?t.progress:t.maxProgress,max:t.maxProgress,children:(0,z.jsx)(Pu,{value:t.locked?t.progress:t.maxProgress,total:t.maxProgress,unit:$c.Integer})})})]})})};oe.add("game-ui/game/components/progression/progression-panel/achievements-page/achievement.tsx",{get Achievement(){return Age},set Achievement(e){Age=e}});let Lge={"achievements-page":"achievements-page_jWM",achievementsPage:"achievements-page_jWM","main-column":"main-column_tzh",mainColumn:"main-column_tzh","info-column":"info-column_Ufp",infoColumn:"info-column_Ufp",scrollable:"scrollable_AyZ"};oe.add("game-ui/game/components/progression/progression-panel/achievements-page/achievements-page.module.scss",{get classes(){return Lge},set classes(e){Object.assign(Lge,e)}});const Mge=Lge;function kge(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Rge(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return kge(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return kge(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Dge=function(){var e=xl(Ige),t=Rge((0,Y.useState)(e[0]),2),n=t[0],r=t[1],i=Rge((0,Y.useState)(null),2),o=i[0],a=i[1],s=(0,Y.useMemo)((function(){return null!=o?o:n}),[o,n]);return(0,z.jsxs)("div",{className:Mge.achievementsPage,children:[(0,z.jsx)(Bse,{theme:b3,className:Mge.mainColumn,children:(0,z.jsx)(gE,{className:Mge.scrollable,children:(0,z.jsx)(Ap,{children:e.map((function(e){return(0,z.jsx)(Age,{selected:n.localeKey===e.localeKey,achievement:e,onSelect:r,onHover:a},e.localeKey)}))})})}),(0,z.jsx)(Fge,{achievement:s})]})},Fge=function(e){var t=e.achievement;return(0,z.jsx)(Bse,{focusKey:Hh,theme:b3,className:Mge.infoColumn,children:t&&(0,z.jsx)(Rse,{icon:t.imagePath,title:(0,z.jsx)(qc.Achievements.TITLE,{hash:t.localeKey}),description:(0,z.jsx)(qc.Achievements.DESCRIPTION,{hash:t.localeKey})})})};function Uge(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Gge(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Uge(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Uge(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Bge(){return(0,Y.createContext)({onItemMouseOver:function(){},onItemMouseLeave:function(){},onItemSelect:function(){},clear:function(){}})}function Vge(e){var t=Gge((0,Y.useState)(null),2),n=t[0],r=t[1],i=Gge((0,Y.useState)(null),2),o=i[0],a=i[1],s=Pg();return[(0,Y.useMemo)((function(){return{onItemMouseOver:function(e){return r(e)},onItemMouseLeave:function(t){return r((function(n){return null===n||e(t,n)?null:n}))},onItemSelect:function(e){return a(e)},clear:function(){r(null),a(null)}}}),[e]),o,s?o:null!=n?n:o]}function Hge(e,t){var n=(0,Y.useContext)(e);return(0,Y.useMemo)((function(){return{onMouseOver:function(){return n.onItemMouseOver(t)},onMouseLeave:function(){return n.onItemMouseLeave(t)},onClick:function(){return n.onItemSelect(t)}}}),[n,t])}oe.add("game-ui/game/components/progression/progression-panel/achievements-page/achievements-page.tsx",{get AchievementsPage(){return Dge},set AchievementsPage(e){Dge=e}}),oe.add("game-ui/common/section/detail-layout/detail-context.ts",{get createDetailContext(){return Bge},set createDetailContext(e){Bge=e},get useDetailContext(){return Vge},set useDetailContext(e){Vge=e},get useElementCallbacks(){return Hge},set useElementCallbacks(e){Hge=e}});var Kge=Bge(),Wge=0;function zge(e,t){return"number"==typeof e||"number"==typeof t?e===t:Qs(e,t)}function Yge(e){return"number"==typeof e?e:qs(e)}function $ge(e){return e===Wge?Wge:Xs(e)}oe.add("game-ui/game/components/progression/progression-panel/milestone-page/milestone-page-context.ts",{get MilestonePageContext(){return Kge},set MilestonePageContext(e){Kge=e},get LOAN_LIMIT(){return Wge},set LOAN_LIMIT(e){Wge=e},get idEquals(){return zge},set idEquals(e){zge=e},get idKey(){return Yge},set idKey(e){Yge=e},get parseIdKey(){return $ge},set parseIdKey(e){$ge=e}});let qge={"milestone-detail-header":"milestone-detail-header_CQr",milestoneDetailHeader:"milestone-detail-header_CQr","progress-bar":"progress-bar_jbW",progressBar:"progress-bar_jbW",subtitle:"subtitle_qwG",title:"title_oo7",rewards:"rewards_du7","reward-field":"reward-field_SPU",rewardField:"reward-field_SPU"};oe.add("game-ui/game/components/progression/progression-panel/milestone-page/milestone-detail/milestone-detail-header/milestone-detail-header.module.scss",{get classes(){return qge},set classes(e){Object.assign(qge,e)}});const Xge=qge;function Qge(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Zge(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Qge(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Qge(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Jge=function(e){var t,n,r,i=e.details;return(0,z.jsx)(zv,{className:Xge.milestoneDetailHeader,style:{backgroundImage:i.image?"url(".concat(i.image,")"):void 0,backgroundColor:rP(i.backgroundColor),color:rP(i.textColor)},children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)(the,{xpRequirement:i.xpRequirement}),(0,z.jsx)("div",{className:Xge.subtitle,children:(0,z.jsx)(qc.Progression.MILESTONE_DETAIL_SUBTITLE,{INDEX:(0,z.jsx)(su,{value:i.index,unit:$c.Integer})})}),(0,z.jsx)("div",{className:Xge.title,children:(0,z.jsx)(qc.Progression.MILESTONE_NAME,{index:i.index})}),(0,z.jsxs)("div",{className:Xge.rewards,children:[i.reward>0&&(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.progressionPanelMilestoneRewardsMoney,children:(0,z.jsx)(e8,{title:(0,z.jsx)(qc.Progression.TOOLTIP_TITLE_MONEY,{}),description:(0,z.jsx)(qc.Progression.TOOLTIP_DESCRIPTION_MONEY,{}),children:(0,z.jsx)(Dre,{focusable:!0,icon:"Media/Game/Icons/Money.svg",className:Xge.rewardField,children:(0,z.jsx)(su,{value:i.reward,unit:$c.Money})})})}),i.devTreePoints>0&&(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.progressionPanelMilestoneRewardsDevPoints,children:(0,z.jsx)(e8,{title:(0,z.jsx)(qc.Progression.TOOLTIP_TITLE_POINTS,{}),description:(0,z.jsx)(qc.Progression.TOOLTIP_DESCRIPTION_POINTS,{}),children:(0,z.jsx)(Dre,{focusable:!0,icon:"Media/Game/Icons/DevPoint.svg",className:Xge.rewardField,children:(0,z.jsx)(su,{value:i.devTreePoints,unit:$c.Integer,signed:!0})})})}),i.mapTiles>0&&(0,z.jsx)(tk,{uiTag:null===(r=Ew.value)||void 0===r?void 0:r.progressionPanelMilestoneRewardsMapTiles,children:(0,z.jsx)(e8,{title:(0,z.jsx)(qc.Progression.TOOLTIP_TITLE_EXPANSION_PERMITS,{}),description:(0,z.jsx)(qc.Progression.TOOLTIP_DESCRIPTION_EXPANSION_PERMITS,{}),children:(0,z.jsx)(Dre,{focusable:!0,icon:"Media/Game/Icons/ExpansionPermit.svg",className:Xge.rewardField,children:(0,z.jsx)(su,{value:i.mapTiles,unit:$c.Integer,signed:!0})})})})]})]})})},ehe={tension:150,friction:20},the=function(e){var t,n=e.xpRequirement,r=xl(yP),i=of(r,0,n),o=of(YZ(ehe,r),0,n),a=Zge((0,Y.useState)(!1),2),s=a[0],l=a[1];return(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.progressionPanelMilestoneXP,children:(0,z.jsx)(e8,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_XP,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_XP,{}),children:(0,z.jsx)(Tg,{onFocusChange:l,children:(0,z.jsx)(Yv,{children:(0,z.jsx)(qce,{progress:o,max:n,theme:Pge,className:_d()(Xge.progressBar,s&&"focused"),children:(0,z.jsx)(Pu,{value:i,total:n,unit:$c.XP})})})})})})};oe.add("game-ui/game/components/progression/progression-panel/milestone-page/milestone-detail/milestone-detail-header/milestone-detail-header.tsx",{get MilestoneDetailHeader(){return Jge},set MilestoneDetailHeader(e){Jge=e}});let nhe={"unlock-item":"unlock-item_cKn item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT item-states_QjV",unlockItem:"unlock-item_cKn item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT item-states_QjV",icon:"icon_dN7",small:"small_cfi",title:"title_tnS"};oe.add("game-ui/game/components/progression/progression-panel/milestone-page/milestone-detail/unlock-item/unlock-item.module.scss",{get classes(){return nhe},set classes(e){Object.assign(nhe,e)}});const rhe=nhe;function ihe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function ohe(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var ahe=function(e){var t=e.id,n=e.selected,r=e.small,i=e.icon,o=e.title,a=e.children,s=Hge(Kge,t);return(0,z.jsxs)(Qp,ohe(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){ihe(e,t,n[t])}))}return e}({focusKey:Yge(t),selected:n,className:_d()(rhe.unlockItem,r&&rhe.small)},s),{children:[(0,z.jsx)("div",{className:rhe.icon,children:(0,z.jsx)("img",{src:i})}),(0,z.jsx)("div",{className:rhe.title,children:o}),a]}))};oe.add("game-ui/game/components/progression/progression-panel/milestone-page/milestone-detail/unlock-item/unlock-item.tsx",{get UnlockItem(){return ahe},set UnlockItem(e){ahe=e}});let she={"milestone-detail":"milestone-detail_kYc",milestoneDetail:"milestone-detail_kYc",scrollable:"scrollable_uML",badge:"badge_Dd7",theme:"theme_CAs","theme-icon":"theme-icon_c1W",themeIcon:"theme-icon_c1W"};oe.add("game-ui/game/components/progression/progression-panel/milestone-page/milestone-detail/milestone-detail.module.scss",{get classes(){return she},set classes(e){Object.assign(she,e)}});const lhe=she;function che(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function uhe(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var dhe,fhe,mhe=new Wh("UnlocksList"),ghe=function(e){var t,n=e.details,r=e.unlocks,i=e.selectedUnlock,o=e.className,a=RL($ge,(0,Y.useContext)(Kge).onItemSelect);return(0,z.jsx)(Bse,{theme:b3,className:_d()(lhe.milestoneDetail,o),children:(0,z.jsxs)(Ap,{initialFocused:mhe,children:[null!=n&&(0,z.jsx)(Jge,{details:n}),(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.progressionPanelMilestoneRewards,children:(0,z.jsx)(gE,{className:lhe.scrollable,children:(0,z.jsxs)(Ip,{focusKey:mhe,focused:null!=i?Yge(i):null,direction:gp.Vertical,onChange:a,onRefocus:wp,children:[n&&n.loanLimit>0&&(0,z.jsx)(phe,{loanLimit:n.loanLimit,selected:zge(i,Wge)}),(0,z.jsx)(vD,{components:hhe,data:r,props:{selectedUnlock:i}})]})})})]})})},hhe=(che(fhe={},mP.Feature,(function(e){var t=e.selectedUnlock,n=uhe(e,["selectedUnlock"]);return(0,z.jsx)(vhe,{entity:n.entity,icon:n.icon,title:(0,z.jsx)(qc.Assets.NAME,{hash:n.name}),devTreeUnlocked:!1,selected:zge(n.entity,t)})})),che(fhe,mP.Policy,(function(e){var t=e.selectedUnlock,n=uhe(e,["selectedUnlock"]);return(0,z.jsx)(vhe,{entity:n.entity,icon:n.icon,title:(0,z.jsx)(qc.Policy.TITLE,{hash:n.name}),devTreeUnlocked:!1,selected:zge(n.entity,t)})})),che(fhe,mP.Service,(function(e){var t=e.selectedUnlock,n=uhe(e,["selectedUnlock"]);return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(vhe,{entity:n.entity,icon:n.icon,title:(0,z.jsx)(qc.Services.NAME,{hash:n.name}),devTreeUnlocked:null!==(dhe=n.devTreeUnlocked)&&void 0!==dhe&&dhe,selected:zge(n.entity,t)}),n.assets.map((function(e){return(0,z.jsx)(bhe,{item:e,selected:zge(e.entity,t)},qs(e.entity))}))]})})),che(fhe,mP.Zone,(function(e){var t=e.selectedUnlock,n=uhe(e,["selectedUnlock"]);return(0,z.jsx)(bhe,{zone:!0,item:n,selected:zge(n.entity,t)})})),fhe),phe=function(e){var t=e.loanLimit,n=e.selected;return(0,z.jsx)(ahe,{id:Wge,icon:"Media/Game/Icons/Money.svg",title:(0,z.jsx)(qc.Progression.LOAN_LIMIT,{}),selected:n,children:(0,z.jsx)("div",{className:lhe.badge,children:(0,z.jsx)(su,{value:t,unit:$c.Money,signed:!0})})})},vhe=function(e){var t=e.entity,n=e.icon,r=e.title,i=e.devTreeUnlocked,o=e.selected;return(0,z.jsx)(ahe,{id:t,selected:o,icon:n,title:r,children:i&&(0,z.jsx)("div",{className:lhe.badge,children:(0,z.jsx)(qc.Progression.DEV_TREE_UNLOCK_BADGE,{})})})},bhe=function(e){var t=e.item,n=e.selected,r=e.zone,i=xl(jw).filter((function(e){return t.themes.some((function(t){return Qs(t,e.entity)}))}));return(0,z.jsx)(ahe,{small:!r,id:t.entity,selected:n,icon:t.icon,title:(0,z.jsx)(qc.Assets.NAME,{hash:t.name}),children:i.map((function(e){return(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Assets.THEME,{hash:e.name}),children:(0,z.jsx)("div",{className:lhe.theme,children:(0,z.jsx)("img",{src:e.icon,className:lhe.themeIcon})})},qs(e.entity))}))})};oe.add("game-ui/game/components/progression/progression-panel/milestone-page/milestone-detail/milestone-detail.tsx",{get MilestoneDetail(){return ghe},set MilestoneDetail(e){ghe=e}});let yhe={"milestone-list":"milestone-list_tfM",milestoneList:"milestone-list_tfM",scrollable:"scrollable_UGT",item:"item_LnT item-states_QjV","circle-layout":"circle-layout_Xmw",circleLayout:"circle-layout_Xmw",line:"line_jbQ",unlocked:"unlocked_gJI",first:"first_JVl",last:"last_gAq",circle:"circle_yGr",major:"major_RSg",title:"title_UOA"};oe.add("game-ui/game/components/progression/progression-panel/milestone-page/milestone-list/milestone-list.module.scss",{get classes(){return yhe},set classes(e){Object.assign(yhe,e)}});const xhe=yhe;function _he(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function jhe(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function Ohe(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var Ehe=function(e){var t,n=e.selectedMilestone,r=e.className,i=e.onSelectMilestone,o=DL(i),a=xl(jP),s=(0,Y.useRef)(null),l=XQ();return(0,Y.useEffect)((function(){window.requestAnimationFrame((function(){null!=s.current&&l.scrollIntoView(s.current)}))}),[l]),(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.progressionPanelMilestonesList,children:(0,z.jsx)(Bse,{theme:b3,className:_d()(xhe.milestoneList,r),children:(0,z.jsx)(gE,{className:xhe.scrollable,controller:l,children:(0,z.jsx)(Ip,{focused:qs(n),direction:gp.Vertical,onChange:o,children:a.map((function(e,t){return(0,z.jsx)(She,{ref:a.length>t+1&&!a[t+1].locked?s:void 0,milestone:e,nextUnlocked:a.length>t+1&&!a[t+1].locked,selected:Qs(e.entity,n),first:0===t,last:a.length===t+1,onSelect:i},qs(e.entity))}))})})})})},She=Y.forwardRef((function(e,t){var n=e.milestone,r=e.nextUnlocked,i=e.selected,o=e.first,a=e.last,s=e.onSelect,l=Ohe(e,["milestone","nextUnlocked","selected","first","last","onSelect"]),c=(0,Y.useCallback)((function(){return s(n.entity)}),[n.entity,s]);return(0,z.jsxs)(Qp,jhe(function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){_he(e,t,n[t])}))}return e}({ref:t,focusKey:qs(n.entity),selected:i,className:_d()(xhe.item,n.major&&xhe.major,!n.locked&&xhe.unlocked),onClick:c},l),{children:[(0,z.jsxs)("div",{className:xhe.circleLayout,children:[(0,z.jsx)("div",{className:_d()(xhe.line,!n.locked&&xhe.unlocked,o&&xhe.first)}),(0,z.jsx)("div",{className:xhe.circle}),(0,z.jsx)("div",{className:_d()(xhe.line,r&&xhe.unlocked,a&&xhe.last)})]}),(0,z.jsx)("div",{className:xhe.title,children:(0,z.jsx)(qc.Progression.MILESTONE_NAME,{index:n.index})})]}))}));oe.add("game-ui/game/components/progression/progression-panel/milestone-page/milestone-list/milestone-list.tsx",{get MilestoneList(){return Ehe},set MilestoneList(e){Ehe=e}});var The=function(e){var t=e.id,n=e.milestoneDetails,r=e.className;return(0,z.jsx)(Bse,{focusKey:Hh,theme:b3,className:r,children:Ihe(t,n)})};function Ihe(e,t){return e===Wge?(0,z.jsx)(Phe,{milestoneDetails:t}):null!=e?(0,z.jsx)(whe,{entity:e}):null}var whe=function(e){var t=e.entity,n=Ol(IP,t);return null!=n?(0,z.jsx)(Rse,{icon:n.icon,title:(0,z.jsx)(kc,{id:n.titleId}),description:(0,z.jsx)(kc,{id:n.descriptionId}),children:(0,z.jsx)(Kse,{state:n.locked?"Locked":"Unlocked"})}):null},Phe=function(e){var t=e.milestoneDetails;return(0,z.jsx)(Rse,{icon:"Media/Game/Icons/Money.svg",title:(0,z.jsx)(qc.Progression.LOAN_LIMIT,{}),description:(0,z.jsx)(qc.EconomyPanel.LOAN_PAGE_DESCRIPTION,{}),children:(0,z.jsx)(Kse,{state:(null==t?void 0:t.locked)?"Locked":"Unlocked"})})};oe.add("game-ui/game/components/progression/progression-panel/milestone-page/unlock-detail/unlock-detail.tsx",{get UnlockDetail(){return The},set UnlockDetail(e){The=e}});let Che={"milestone-page":"milestone-page_dL2",milestonePage:"milestone-page_dL2","milestone-list":"milestone-list_C7c",milestoneList:"milestone-list_C7c","milestone-detail":"milestone-detail_zdr",milestoneDetail:"milestone-detail_zdr","unlock-detail":"unlock-detail_LWQ",unlockDetail:"unlock-detail_LWQ"};oe.add("game-ui/game/components/progression/progression-panel/milestone-page/milestone-page.module.scss",{get classes(){return Che},set classes(e){Object.assign(Che,e)}});const Nhe=Che;function Ahe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Lhe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Ahe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ahe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Mhe=function(){var e;oh(null===(e=Ew.value)||void 0===e?void 0:e.progressionPanelMilestonesPage);var t=Lhe((0,Y.useState)(khe),2),n=t[0],r=t[1],i=Lhe(Vge(zge),3),o=i[0],a=i[1],s=i[2],l=Ol(SP,n),c=Ol(TP,n),u=(0,Y.useCallback)((function(e){r(e),o.clear()}),[o]);return(0,z.jsxs)("div",{className:Nhe.milestonePage,children:[(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)(Ehe,{selectedMilestone:n,onSelectMilestone:u,className:Nhe.milestoneList}),(0,z.jsx)(Kge.Provider,{value:o,children:(0,z.jsx)(ghe,{details:l,unlocks:c,selectedUnlock:a,className:Nhe.milestoneDetail},qs(n))})]}),(0,z.jsx)(The,{id:s,milestoneDetails:l,className:Nhe.unlockDetail})]})};function khe(){var e=jP.value;if(0===e.length)return ty;var t=e.findIndex((function(e){return e.locked}));return e[t>1?t-1:-1===t?e.length-1:0].entity}oe.add("game-ui/game/components/progression/progression-panel/milestone-page/milestone-page.tsx",{get MilestonePage(){return Mhe},set MilestonePage(e){Mhe=e}});let Rhe={"dev-tree-node-detail":"dev-tree-node-detail_k9G",devTreeNodeDetail:"dev-tree-node-detail_k9G",content:"content_w8i","detail-layout":"detail-layout_dX7",detailLayout:"detail-layout_dX7",button:"button_cM0","gamepad-hint":"gamepad-hint_EXG",gamepadHint:"gamepad-hint_EXG","button-label":"button-label_mXV",buttonLabel:"button-label_mXV",cost:"cost_DHr","cost-dp-icon":"cost-dp-icon_C7u",costDpIcon:"cost-dp-icon_C7u","unlock-hint":"unlock-hint_PFh",unlockHint:"unlock-hint_PFh","points-display":"points-display_S2s",pointsDisplay:"points-display_S2s","points-icon":"points-icon_f8_",pointsIcon:"points-icon_f8_","points-value":"points-value_cTm",pointsValue:"points-value_cTm"};oe.add("game-ui/game/components/progression/progression-panel/service-page/dev-tree-node-detail/dev-tree-node-detail.module.scss",{get classes(){return Rhe},set classes(e){Object.assign(Rhe,e)}});const Dhe=Rhe;var Fhe=function(e){var t,n=e.node,r=e.className,i=Ol(Uw,n),o=xl(kw),a=(0,Y.useCallback)((function(){var e,t;Vw(n),(null===(e=Ew.value)||void 0===e?void 0:e.progressionPanelDevelopmentUnlockNode)&&nh(null===(t=Ew.value)||void 0===t?void 0:t.progressionPanelDevelopmentUnlockNode)}),[n]),s=function(e,t){if(null===e)return null;if(e.unlockable)return t<e.cost?(0,z.jsx)(qc.Progression.NODE_DEV_POINTS_REQUIREMENT,{}):null;if(e.requirementCount>0)return(0,z.jsx)(qc.Progression.NODE_PARENT_REQUIREMENT,{});if(e.milestoneRequirement>0)return(0,z.jsx)(qc.Progression.NODE_MILESTONE_REQUIREMENT,{INDEX:(0,z.jsx)(su,{value:e.milestoneRequirement,unit:$c.Integer})})}(i,o);return(0,z.jsx)(Bse,{focusKey:Hh,theme:b3,className:_d()(Dhe.devTreeNodeDetail,r),children:(0,z.jsxs)("div",{className:Dhe.content,children:[null!=i&&(0,z.jsxs)(Rse,{icon:i.icon,title:(0,z.jsx)(qc.Progression.NODE_NAME,{hash:i.name}),description:(0,z.jsx)(qc.Progression.NODE_DESCRIPTION,{hash:i.name}),children:[(0,z.jsx)(Kse,{state:i.locked?"Locked":"Unlocked"}),i.locked&&(0,z.jsxs)(z.Fragment,{children:[i.cost>0&&(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.progressionPanelDevelopmentUnlockNode,children:(0,z.jsxs)(Qp,{theme:kO,selectSound:Lp.purchase,className:Dhe.button,disabled:!i.unlockable||i.cost>o,onSelect:a,children:[(0,z.jsx)("div",{className:Dhe.buttonLabel,children:(0,z.jsx)(qc.Progression.UNLOCK_NODE_BUTTON,{})}),(0,z.jsxs)("div",{className:Dhe.cost,children:[(0,z.jsx)(su,{value:i.cost,unit:$c.Integer}),(0,z.jsx)("img",{src:"Media/Game/Icons/DevPoint.svg",className:Dhe.costDpIcon})]})]})}),null!=s&&(0,z.jsx)("div",{className:Dhe.unlockHint,children:s})]})]}),(0,z.jsxs)("div",{className:Dhe.pointsDisplay,children:[(0,z.jsx)("img",{src:"Media/Game/Icons/DevPoint.svg",className:Dhe.pointsIcon}),(0,z.jsx)("div",{className:Dhe.pointsValue,children:(0,z.jsx)(qc.Progression.AVAILABLE_DEV_POINTS,{VALUE:(0,z.jsx)(su,{value:o,unit:$c.Integer})})})]})]})})};oe.add("game-ui/game/components/progression/progression-panel/service-page/dev-tree-node-detail/dev-tree-node-detail.tsx",{get DevTreeNodeDetail(){return Fhe},set DevTreeNodeDetail(e){Fhe=e}});let Uhe={"service-detail-header":"service-detail-header_uCS",serviceDetailHeader:"service-detail-header_uCS",title:"title_XWg","progress-bar":"progress-bar_PBl",progressBar:"progress-bar_PBl"};oe.add("game-ui/game/components/progression/progression-panel/service-page/service-detail/service-detail-header.module.scss",{get classes(){return Uhe},set classes(e){Object.assign(Uhe,e)}});const Ghe=Uhe;var Bhe=function(e){var t=e.details,n=xl(pP);return(0,z.jsxs)("div",{className:Ghe.serviceDetailHeader,children:[(0,z.jsx)("div",{className:Ghe.title,children:(0,z.jsx)(qc.Services.NAME,{hash:t.name})}),t.milestoneRequirement>n&&(0,z.jsx)(Vhe,{currentMilestone:n,targetMilestone:t.milestoneRequirement})]})},Vhe=function(e){var t=e.currentMilestone,n=e.targetMilestone;return(0,z.jsx)(qce,{progress:t,max:n,theme:Pge,className:Ghe.progressBar,children:(0,z.jsx)(qc.Progression.MILESTONE_UNLOCK_REQUIREMENT,{INDEX:(0,z.jsx)(su,{value:n,unit:$c.Integer}),NAME:(0,z.jsx)(qc.Progression.MILESTONE_NAME,{index:n})})})};oe.add("game-ui/game/components/progression/progression-panel/service-page/service-detail/service-detail-header.tsx",{get ServiceDetailHeader(){return Bhe},set ServiceDetailHeader(e){Bhe=e}});let Hhe={"service-dev-tree":"service-dev-tree_Azt",serviceDevTree:"service-dev-tree_Azt",canvas:"canvas_xTK","node-layer":"node-layer_Qxl",nodeLayer:"node-layer_Qxl",node:"node_qXI",container:"container_Y6w",title:"title_iof",selected:"selected_tgO","circle-outline":"circle-outline_wOz",circleOutline:"circle-outline_wOz",circle:"circle_wRS",unlockable:"unlockable_RZR",locked:"locked_g7f","cost-container":"cost-container_RMQ",costContainer:"cost-container_RMQ",cost:"cost_x8o","cost-dp-icon":"cost-dp-icon_sWc",costDpIcon:"cost-dp-icon_sWc"};oe.add("game-ui/game/components/progression/progression-panel/service-page/service-detail/service-dev-tree.module.scss",{get classes(){return Hhe},set classes(e){Object.assign(Hhe,e)}});const Khe=Hhe;function Whe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function zhe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Whe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Whe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Yhe=function(e){var t,n=e.service,r=e.selectedNode,i=e.locked,o=e.className,a=e.onHoverNode,s=e.onSelectNode,l=(0,Y.useRef)(null),c=bf(null!==(t=Kf(l))&&void 0!==t?t:lf),u=$O(),d=Ol(Fw,n),f=d.reduce((function(e,t){return{x:Math.max(e.x,t.position.x+1),y:Math.max(e.y,t.position.y+1)}}),{x:5,y:0});(0,Y.useEffect)((function(){if(null==r||!d.some((function(e){return Qs(e.entity,r)}))){var e=d.reduce((function(e,t){return null==e||t.position.x<e.position.x||t.position.x===e.position.x&&t.position.y<e.position.y?t:e}),null);null!=e&&s(e.entity)}}),[d,s,r]);var m=DL(s),g=c.x/f.x,h=128*u,p=h*f.y,v=.5*(c.y-p);return(0,z.jsxs)("div",{ref:l,className:_d()(Khe.serviceDevTree,o),children:[(0,z.jsx)($he,{canvasWidth:c.x,canvasHeight:c.y,columnCount:f.x,columnWidth:g,rowHeight:h,verticalOffset:v,lineWidth:4*u,nodeRadius:31*u,locked:i,nodes:d}),(0,z.jsx)("div",{className:Khe.nodeLayer,children:(0,z.jsx)(Ip,{focused:qs(r),onChange:m,children:!mf(c,lf)&&d.map((function(e){return(0,z.jsx)(Zhe,{node:e,selected:Qs(r,e.entity),style:{top:v+e.position.y*h+"px",left:g*e.position.x+"px",width:g+"px",height:h+"px"},onHover:a,onSelect:s},qs(e.entity))}))})})]})},$he=function(e){var t,n=e.canvasWidth,r=e.canvasHeight,i=e.columnWidth,o=e.rowHeight,a=e.verticalOffset,s=e.lineWidth,l=e.nodeRadius,c=e.columnCount,u=e.locked,d=e.nodes,f=zhe((0,Y.useState)(null),2),m=f[0],g=f[1],h=(0,Y.useCallback)((function(e){return g(null!==(t=null==e?void 0:e.getContext("2d"))&&void 0!==t?t:null)}),[]);return(0,Y.useEffect)((function(){if(m){m.clearRect(0,0,n,r),m.fillStyle="#ffffff",m.globalAlpha=.05;for(var e=1;e<c;e+=2)m.fillRect(e*i,0,i,r);m.globalAlpha=1,m.lineWidth=s;var t=d.sort(qhe),u=!0,f=!1,g=void 0;try{for(var h,p=function(){var e=h.value,t=(e.position.x+.5)*i,n=a+(e.position.y+.5)*o,r=e.requirements;if(r.length>0){var s=r.map((function(e){return d.find((function(t){return Qs(e,t.entity)}))})).filter((function(e){return null!=e})).sort(qhe).reverse(),c=!0,u=!1,f=void 0;try{for(var g,p=s[Symbol.iterator]();!(c=(g=p.next()).done);c=!0){var v=g.value;if(!(mf(v.position,e.position)||v.position.x>e.position.x)){m.strokeStyle=Xhe(v,e);var b=(v.position.x+.5)*i,y=a+(v.position.y+.5)*o;if(e.position.x>v.position.x){var x=b+l,_=t-l,j=Qhe(v,e),O=x+(_-x)*j,E=x+(_-x)*(1-j),S=y,T=n;m.beginPath(),m.moveTo(b+l,y),m.bezierCurveTo(O,S,E,T,_,n),m.stroke()}else{var I=Math.sign(e.position.y-v.position.y),w=y+I*l,P=n-I*l;m.beginPath(),m.moveTo(b,w),m.lineTo(t,P),m.stroke()}}}}catch(e){u=!0,f=e}finally{try{c||null==p.return||p.return()}finally{if(u)throw f}}}else if(0===e.position.x){m.strokeStyle=Xhe(null,e);var C=t-l;m.beginPath(),m.moveTo(0,n),m.lineTo(C,n),m.stroke()}},v=t[Symbol.iterator]();!(u=(h=v.next()).done);u=!0)p()}catch(e){f=!0,g=e}finally{try{u||null==v.return||v.return()}finally{if(f)throw g}}}}),[m,r,n,d,c,i,a,o,s,l,u]),n>0&&r>0?(0,z.jsx)("canvas",{ref:h,width:n,height:r,className:Khe.canvas}):null};function qhe(e,t){return!e.locked&&t.locked?1:e.locked&&!t.locked?-1:e.unlockable&&!t.unlockable?1:!e.unlockable&&t.unlockable?-1:0}function Xhe(e,t){return t.locked?(null!=e?!e.locked:t.unlockable)?"#2378CD":"#555":"#8bdb46"}function Qhe(e,t){return t.position.x-e.position.x<=1?.7:.4}var Zhe=function(e){var t=e.node,n=e.selected,r=e.style,i=e.className,o=e.onHover,a=e.onSelect,s=xl(kw),l=(0,Y.useCallback)((function(){kp(Lp.selectItem),a(t.entity)}),[t.entity,a]),c=Jhe(t,s),u=(0,Y.useMemo)((function(){return{"Purchase Dev Tree Node":c?function(){kp(Lp.purchase),Vw(t.entity)}:null}}),[t.entity,c]),d=(0,Y.useCallback)((function(){return kp(Lp.hoverItem)}),[]),f=(0,Y.useCallback)((function(){return o(t.entity)}),[t.entity,o]),m=(0,Y.useCallback)((function(){return o(ty)}),[o]),g=(0,Y.useMemo)((function(){var e,n;return t.unlockable&&t.cost>0&&s>=t.cost?null===(e=Ew.value)||void 0===e?void 0:e.progressionPanelDevelopmentUnlockableNode:null===(n=Ew.value)||void 0===n?void 0:n.progressionPanelDevelopmentNode}),[s,t.cost,t.unlockable]);return(0,z.jsx)(rp,{actions:u,children:(0,z.jsx)(Yv,{focusKey:qs(t.entity),focusSound:Lp.hoverItem,className:_d()(i,Khe.node,n&&Khe.selected,t.locked&&(t.unlockable?Khe.unlockable:Khe.locked)),style:r,onClick:l,onMouseOver:f,onMouseEnter:d,onMouseLeave:m,children:(0,z.jsxs)("div",{className:Khe.container,children:[(0,z.jsx)("div",{className:Khe.circleOutline,children:(0,z.jsx)(tk,{uiTag:g,children:(0,z.jsx)("div",{className:Khe.circle,children:(0,z.jsx)("img",{src:t.icon})})})}),(0,z.jsx)("div",{className:Khe.title,children:(0,z.jsx)(qc.Progression.NODE_NAME,{hash:t.name})}),(0,z.jsx)("div",{className:Khe.costContainer,children:t.locked&&t.cost>0&&(0,z.jsx)(e8,{title:(0,z.jsx)(qc.Progression.TOOLTIP_TITLE_POINTS_COST,{}),description:(0,z.jsx)(qc.Progression.TOOLTIP_DESCRIPTION_POINTS_COST,{}),children:(0,z.jsxs)("div",{className:Khe.cost,children:[(0,z.jsx)(su,{value:t.cost,unit:$c.Integer}),(0,z.jsx)("img",{src:"Media/Game/Icons/DevPoint.svg",className:Khe.costDpIcon})]})})})]})})})},Jhe=function(e,t){return!(!e.locked||!e.unlockable||t<e.cost)};oe.add("game-ui/game/components/progression/progression-panel/service-page/service-detail/service-dev-tree.tsx",{get ServiceDevTree(){return Yhe},set ServiceDevTree(e){Yhe=e}});let epe={"service-detail":"service-detail_Cba",serviceDetail:"service-detail_Cba","dev-tree":"dev-tree_af6",devTree:"dev-tree_af6"};oe.add("game-ui/game/components/progression/progression-panel/service-page/service-detail/service-detail.module.scss",{get classes(){return epe},set classes(e){Object.assign(epe,e)}});const tpe=epe;var npe=function(e){var t,n=e.service,r=e.selectedNode,i=e.className,o=e.onHoverNode,a=e.onSelectNode,s=Ol(Dw,n),l=null!==(t=null==s?void 0:s.locked)&&void 0!==t&&t;return(0,z.jsx)(Bse,{theme:b3,header:null!=s&&(0,z.jsx)(Bhe,{details:s}),className:_d()(tpe.serviceDetail,l&&b3.locked,i),children:(0,z.jsx)(Yhe,{service:n,selectedNode:r,locked:l,className:tpe.devTree,onHoverNode:o,onSelectNode:a})})};oe.add("game-ui/game/components/progression/progression-panel/service-page/service-detail/service-detail.tsx",{get ServiceDetail(){return npe},set ServiceDetail(e){npe=e}});let rpe={button:"button_Sxm button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT","toggle-states":"toggle-states_q6D",toggleStates:"toggle-states_q6D",icon:"icon_FKY icon_soN icon_Iwk",locked:"locked_K2j locked_H2O locked_dBl"};oe.add("game-ui/game/themes/panel-service-button.module.scss",{get classes(){return rpe},set classes(e){Object.assign(rpe,e)}});const ipe=rpe;let ope={"service-list":"service-list_RLT",serviceList:"service-list_RLT",lock:"lock_H9c"};oe.add("game-ui/game/components/progression/progression-panel/service-page/service-list/service-list.module.scss",{get classes(){return ope},set classes(e){Object.assign(ope,e)}});const ape=ope;var spe=function(e){var t=e.selectedService,n=e.className,r=e.onSelectService,i=DL(r),o=xl(Rw);return(0,z.jsx)(Bse,{theme:b3,className:_d()(ape.serviceList,n),children:(0,z.jsx)(Ip,{focused:qs(t),direction:gp.Vertical,onChange:i,onRefocus:wp,children:o.map((function(e,n){return(0,z.jsx)(lpe,{index:n,service:e,selected:Qs(e.entity,t),onSelect:r},qs(e.entity))}))})})},lpe=function(e){var t=e.index,n=e.service,r=e.selected,i=e.onSelect,o=$O(),a=(0,Y.useCallback)((function(){return i(n.entity)}),[n.entity,i]),s=(0,Y.useMemo)((function(){var e;return"".concat(null===(e=Ew.value)||void 0===e?void 0:e.progressionPanelDevelopmentService,"+").concat(n.uiTag)}),[n.uiTag]);return(0,z.jsx)(tk,{uiTag:s,children:(0,z.jsx)(B9,{title:(0,z.jsx)(qc.Services.NAME,{hash:n.name}),description:(0,z.jsx)(qc.Services.DESCRIPTION,{hash:n.name}),locked:n.locked,requirements:n.requirements,children:(0,z.jsx)(lb,{focusKey:qs(n.entity),src:n.icon,selected:r,theme:ipe,className:_d()(n.locked&&ipe.locked),onClick:a,children:n.locked&&(0,z.jsx)(_1,{className:ape.lock,style:{top:(48*(t+1)-12)*o}})})})})};oe.add("game-ui/game/components/progression/progression-panel/service-page/service-list/service-list.tsx",{get ServiceList(){return spe},set ServiceList(e){spe=e}});let cpe={"service-page":"service-page_Rls",servicePage:"service-page_Rls","list-column":"list-column_KaJ",listColumn:"list-column_KaJ","main-column":"main-column_vAd",mainColumn:"main-column_vAd","info-column":"info-column_Za4",infoColumn:"info-column_Za4"};oe.add("game-ui/game/components/progression/progression-panel/service-page/service-page.module.scss",{get classes(){return cpe},set classes(e){Object.assign(cpe,e)}});const upe=cpe;function dpe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function fpe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return dpe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return dpe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var mpe=function(){var e;oh(null===(e=Ew.value)||void 0===e?void 0:e.progressionPanelDevelopmentPage);var t=xl(Rw),n=xl(Gw),r=Qs(n,ty)?t.length>0?t[0].entity:ty:n,i=xl(Bw),o=fpe((0,Y.useState)(ty),2),a=o[0],s=o[1];return(0,z.jsx)(Ap,{children:(0,z.jsxs)("div",{className:upe.servicePage,children:[(0,z.jsx)(spe,{selectedService:r,onSelectService:Gw.update,className:upe.listColumn}),(0,z.jsx)(npe,{service:r,selectedNode:i,onHoverNode:s,onSelectNode:Bw.update,className:upe.mainColumn}),(0,z.jsx)(Fhe,{node:Qs(a,ty)?i:a,className:upe.infoColumn})]})})};oe.add("game-ui/game/components/progression/progression-panel/service-page/service-page.tsx",{get ServicePage(){return mpe},set ServicePage(e){mpe=e}});let gpe={"progression-panel":"progression-panel_vIm",progressionPanel:"progression-panel_vIm"};oe.add("game-ui/game/components/progression/progression-panel/progression-panel.module.scss",{get classes(){return gpe},set classes(e){Object.assign(gpe,e)}});const hpe=gpe;function ppe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function vpe(e){return function(e){if(Array.isArray(e))return ppe(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return ppe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return ppe(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var bpe=function(e){var t,n,r,i=e.selectedTab,o=e.onSelectTab,a=e.onClose;oh(null===(t=Ew.value)||void 0===t?void 0:t.progressionPanel);var s=xl(Tge);return(0,z.jsx)(qj,{header:(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(tO,{children:(0,z.jsx)(qc.Progression.PANEL_TITLE,{})}),(0,z.jsxs)(S1,{children:[(0,z.jsx)(ype,{tab:k_.Development,uiTag:null===(n=Ew.value)||void 0===n?void 0:n.progressionPanelDevelopmentTab,selectedTab:i,onSelect:o}),(0,z.jsx)(ype,{tab:k_.Milestones,uiTag:null===(r=Ew.value)||void 0===r?void 0:r.progressionPanelMilestonesTab,selectedTab:i,onSelect:o}),s&&(0,z.jsx)(ype,{tab:k_.Achievements,selectedTab:i,onSelect:o})]})]}),transitionSounds:vj,className:hpe.progressionPanel,onClose:a,children:(0,z.jsx)(E1,{tabs:[k_.Development,k_.Milestones].concat(vpe(s?[k_.Achievements]:[])),selectedTab:i,onSelect:o,children:xpe(i)})})},ype=function(e){var t=e.tab,n=e.uiTag,r=e.selectedTab,i=e.onSelect,o=e.className;return(0,z.jsx)(e8,{title:(0,z.jsx)(qc.Progression.TOOLTIP_TITLE_TAB,{hash:k_[t]}),description:(0,z.jsx)(qc.Progression.TOOLTIP_DESCRIPTION_TAB,{hash:k_[t]}),children:(0,z.jsx)(T1,{id:t,uiTag:n,selectedId:r,onSelect:i,className:o,children:(0,z.jsx)(qc.Progression.TAB_TITLE,{hash:k_[t]})})})};function xpe(e){switch(e){case k_.Development:return(0,z.jsx)(mpe,{});case k_.Milestones:return(0,z.jsx)(Mhe,{});case k_.Achievements:return(0,z.jsx)(Dge,{});default:return null}}function _pe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function jpe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return _pe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _pe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/game/components/progression/progression-panel/progression-panel.tsx",{get ProgressionPanel(){return bpe},set ProgressionPanel(e){bpe=e}});var Ope={focusController:Od,inputController:qh},Epe=Y.createContext(Ope),Spe=Y.createContext({attach:function(){},detach:function(){}}),Tpe=function(e){var t=e.children,n=jpe((0,Y.useState)(Ope),2),r=n[0],i=n[1],o=(0,Y.useMemo)((function(){return{attach:function(e){return i(e)},detach:function(e){return i((function(t){return t===e?Ope:t}))}}}),[]);return(0,z.jsx)(Spe.Provider,{value:o,children:(0,z.jsx)(Epe.Provider,{value:r,children:t})})},Ipe=function(e){var t=e.children,n=(0,Y.useContext)(Spe),r=(0,Y.useContext)(jd),i=(0,Y.useContext)(Xh);return(0,Y.useEffect)((function(){var e={focusController:r,inputController:i};return n.attach(e),function(){return n.detach(e)}}),[n,i,r]),(0,z.jsx)(jd.Provider,{value:Od,children:(0,z.jsx)(Xh.Provider,{value:qh,children:t})})},wpe=function(e){var t=e.enabled,n=e.children,r=(0,Y.useContext)(Epe),i=(0,Y.useContext)(jd),o=(0,Y.useContext)(Xh);return(0,z.jsx)(jd.Provider,{value:t?r.focusController:i,children:(0,z.jsx)(Xh.Provider,{value:t?r.inputController:o,children:n})})};function Ppe(){return Pj(UN(xl(TN),xl(IN)))}function Cpe(){return GN(xl(TN),xl(IN))}oe.add("game-ui/game/components/radio/radio-context-override.tsx",{get RadioContextOverrideProvider(){return Tpe},set RadioContextOverrideProvider(e){Tpe=e},get RadioContextRedirector(){return Ipe},set RadioContextRedirector(e){Ipe=e},get RadioContextOverride(){return wpe},set RadioContextOverride(e){wpe=e}}),oe.add("game-ui/common/hooks/use-simulation-date-time.tsx",{get useSimulationDateTime(){return Ppe},set useSimulationDateTime(e){Ppe=e},get useSimulationMinutesSinceMidnight(){return Cpe},set useSimulationMinutesSinceMidnight(e){Cpe=e}});let Npe={"progress-bar":"progress-bar_sYi progress-bar_xWR",progressBar:"progress-bar_sYi progress-bar_xWR",progress:"progress_y5v progress_JAQ"};oe.add("game-ui/common/progress-bar/themes/light-progress-bar.module.scss",{get classes(){return Npe},set classes(e){Object.assign(Npe,e)}});const Ape=Npe;let Lpe={"station-detail":"station-detail_zWr",stationDetail:"station-detail_zWr",header:"header_gDJ","station-name":"station-name_T0f",stationName:"station-name_T0f","section-title":"section-title_lV4",sectionTitle:"section-title_lV4",list:"list_Kl3","program-item":"program-item_KE_",programItem:"program-item_KE_",time:"time_A1a",column:"column_p_F",title:"title_nsV",description:"description_knq",progress:"progress_eLk"};oe.add("game-ui/game/components/radio/radio-panel/station-detail/station-detail.module.scss",{get classes(){return Lpe},set classes(e){Object.assign(Lpe,e)}});const Mpe=Lpe;var kpe=function(e){var t,n=e.className,r=xl(BP),i=xl(HP).find((function(e){return e.name===r})),o=null!==(t=null==i?void 0:i.schedule)&&void 0!==t?t:[];return(0,z.jsxs)("div",{className:_d()(Mpe.stationDetail,n),children:[(0,z.jsxs)("div",{className:Mpe.header,children:[(0,z.jsx)("div",{className:Mpe.stationName,children:(null==i?void 0:i.nameId)?(0,z.jsx)(kc,{id:i.nameId}):null==i?void 0:i.name}),(0,z.jsx)("div",{className:Mpe.sectionTitle,children:(0,z.jsx)(qc.Radio.PROGRAM_TITLE,{})})]}),(0,z.jsx)(gE,{className:Mpe.list,children:o.map((function(e,t){return(0,z.jsx)(Rpe,{item:e},t)}))})]})},Rpe=function(e){var t=e.item,n=xl(KP);return(0,z.jsx)(e8,{disabled:null==n,title:null==n?void 0:n.title,description:null==n?void 0:n.info,children:(0,z.jsxs)("div",{className:Mpe.programItem,children:[(0,z.jsx)("div",{className:Mpe.time,children:(0,z.jsx)(Xu,{value:RN(t.startTime)})}),(0,z.jsxs)("div",{className:Mpe.column,children:[(0,z.jsx)("div",{className:Mpe.title,children:t.name}),(0,z.jsx)("div",{className:Mpe.description,children:t.description}),t.active&&(0,z.jsx)(Dpe,{startTime:t.startTime,duration:t.duration})]})]})})},Dpe=function(e){var t=e.startTime,n=e.duration,r=(Cpe()-t+1440)%1440;return(0,z.jsx)(qce,{progress:r,max:n,theme:Ape,className:Mpe.progress})};oe.add("game-ui/game/components/radio/radio-panel/station-detail/station-detail.tsx",{get StationDetail(){return kpe},set StationDetail(e){kpe=e}});let Fpe={"stations-menu":"stations-menu_kAr",stationsMenu:"stations-menu_kAr",networks:"networks_SQ5",stations:"stations_mU1","network-item":"network-item_tGo",networkItem:"network-item_tGo","station-item":"station-item_cOt",stationItem:"station-item_cOt",icon:"icon_Yr0",column:"column_j5W",title:"title_Bsq",program:"program_xd2",progress:"progress_zBM"};oe.add("game-ui/game/components/radio/radio-panel/stations-menu/stations-menu.module.scss",{get classes(){return Fpe},set classes(e){Object.assign(Fpe,e)}});const Upe=Fpe;var Gpe=function(e){var t,n,r=e.className,i=xl(GP),o=xl(BP),a=xl(VP),s=xl(HP).filter((function(e){return e.network===i}));return(0,z.jsxs)("div",{className:_d()(Upe.stationsMenu,r),children:[(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.radioPanelNetworks,children:(0,z.jsx)("div",{className:Upe.networks,children:a.map((function(e){return(0,z.jsx)(Bpe,{item:e,selected:e.name===i,onSelect:nC},e.name)}))})}),(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.radioPanelStations,children:(0,z.jsx)(gE,{className:Upe.stations,children:s.map((function(e){return(0,z.jsx)(Vpe,{item:e,selected:e.name===o,onSelect:rC},e.name)}))})})]})},Bpe=function(e){var t=e.item,n=e.selected,r=e.onSelect,i=(0,Y.useCallback)((function(){return r(t.name)}),[r,t.name]);return(0,z.jsx)(jh,{tooltip:(0,z.jsx)(t8,{title:t.nameId?(0,z.jsx)(kc,{id:t.nameId}):t.name,description:t.descriptionId?(0,z.jsx)(kc,{id:t.descriptionId}):t.description}),children:(0,z.jsx)(lb,{src:t.icon,selected:n,selectSound:n?null:Lp.selectRadioNetwork,className:Upe.networkItem,onSelect:n?void 0:i})})},Vpe=function(e){var t,n,r,i,o,a=e.item,s=e.selected,l=e.onSelect,c=(0,Y.useCallback)((function(){return l(a.name)}),[l,a.name]),u=Cpe(),d=(u-(null!==(i=null===(t=a.currentProgram)||void 0===t?void 0:t.startTime)&&void 0!==i?i:u)+1440)%1440,f=null!==(o=null===(n=a.currentProgram)||void 0===n?void 0:n.duration)&&void 0!==o?o:0;return(0,z.jsxs)(Qp,{selected:s,selectSound:Lp.selectRadioStation,className:Upe.stationItem,onSelect:s?void 0:c,children:[(0,z.jsx)("img",{src:a.icon,className:Upe.icon}),(0,z.jsxs)("div",{className:Upe.column,children:[(0,z.jsx)("div",{className:Upe.title,children:a.nameId?(0,z.jsx)(kc,{id:a.nameId}):a.name}),(0,z.jsx)("div",{className:Upe.program,children:null===(r=a.currentProgram)||void 0===r?void 0:r.name}),(0,z.jsx)(qce,{progress:d,max:f,theme:Ape,className:Upe.progress})]})]})};oe.add("game-ui/game/components/radio/radio-panel/stations-menu/stations-menu.tsx",{get StationsMenu(){return Gpe},set StationsMenu(e){Gpe=e}});let Hpe={"radio-panel":"radio-panel_rXp",radioPanel:"radio-panel_rXp",enter:"enter_TNo","exit-active":"exit-active_hJq",exitActive:"exit-active_hJq","enter-active":"enter-active_cuF",enterActive:"enter-active_cuF",exit:"exit_B88",content:"content_r9x","stations-menu":"stations-menu_m2f",stationsMenu:"stations-menu_m2f","station-detail":"station-detail_KRp",stationDetail:"station-detail_KRp"};oe.add("game-ui/game/components/radio/radio-panel/radio-panel.module.scss",{get classes(){return Hpe},set classes(e){Object.assign(Hpe,e)}});const Kpe=Hpe;var Wpe=function(e){var t,n,r=e.className,i=e.onClose;oh(null===(t=Ew.value)||void 0===t?void 0:t.radioPanel);var o=xl(VP),a=xl(GP),s=xl(HP),l=(0,Y.useMemo)((function(){return s.filter((function(e){return e.network===a}))}),[a,s]),c=xl(BP),u=(0,Y.useMemo)((function(){return{"Switch Radio Network":o.length>=2?function(e){var t=o.findIndex((function(e){return e.name===a})),n=e<0?cC(t,o.length,!1):sC(t,o.length,!1);null!=n&&n!==t&&(nC(o[n].name),kp(Lp.selectRadioNetwork))}:null,"Switch Radio Station":l.length>=2?function(e){var t=l.findIndex((function(e){return e.name===c})),n=e<0?sC(t,l.length,!1):cC(t,l.length,!1);null!=n&&n!==t&&(rC(l[n].name),kp(Lp.selectRadioStation))}:null}}),[o,a,c,l]);return(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.radioPanel,children:(0,z.jsx)(qj,{header:(0,z.jsx)(tO,{children:(0,z.jsx)(qc.Radio.PANEL_TITLE,{})}),theme:xse,transitionSounds:vj,className:_d()(Kpe.radioPanel,r),contentClassName:Kpe.content,onClose:i,children:(0,z.jsx)(rp,{actions:u,children:(0,z.jsxs)(Ipe,{children:[(0,z.jsx)(Gpe,{className:Kpe.stationsMenu}),(0,z.jsx)(kpe,{className:Kpe.stationDetail})]})})})})};function zpe(e,t,n){return zpe="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(e,t,n){var r=function(e,t){for(;!Object.prototype.hasOwnProperty.call(e,t)&&null!==(e=Ype(e)););return e}(e,t);if(r){var i=Object.getOwnPropertyDescriptor(r,t);return i.get?i.get.call(n):i.value}},zpe(e,t,n||e)}function Ype(e){return Ype=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)},Ype(e)}function $pe(e,t){return!t||"object"!==Qpe(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function qpe(e,t){return qpe=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e},qpe(e,t)}oe.add("game-ui/game/components/radio/radio-panel/radio-panel.tsx",{get RadioPanel(){return Wpe},set RadioPanel(e){Wpe=e}});var Xpe,Qpe=function(e){return e&&"undefined"!=typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};function Zpe(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,r=Ype(e);if(t){var i=Ype(this).constructor;n=Reflect.construct(r,arguments,i)}else n=r.apply(this,arguments);return $pe(this,n)}}!function(e){e[e.HourMonth=0]="HourMonth",e[e.Date=1]="Date",e[e.Year=2]="Year"}(Xpe||(Xpe={}));var Jpe=function(e){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&qpe(e,t)}(n,e);var t=Zpe(n);function n(e){var r;return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,n),(r=t.call(this,e))._startValue=0,r._valueRange=0,r._tickFormat=Xpe.HourMonth,r._majorTickInterval=1,r._firstMajorTickValue=0,r._tickInterval=1,r._firstTickValue=0,r}var r=n.prototype;return r.determineDataLimits=function(){var e=this.getMinMax(!0),t=e.min,n=e.max;this.min=isFinite(t)?t:0,this.max=isFinite(n)?n:0},r.beforeBuildTicks=function(){zpe(Ype(n.prototype),"beforeBuildTicks",this).call(this);var e=this.options.ticks.maxTicksLimit,t=this.options.timeSettings,r=0,i=(this.max-this.min)/t.ticksPerDay*24;if(this._tickFormat=Xpe.HourMonth,this._tickInterval=t.ticksPerDay/24,this._majorTickInterval=t.ticksPerDay,i>=e&&(i/=3,this._tickInterval=t.ticksPerDay/8),i>=e&&(i/=2,this._tickInterval=t.ticksPerDay/4),i>=e&&(i/=2,this._tickInterval=t.ticksPerDay/2),i>=e&&(i/=2,this._tickFormat=Xpe.Date,this._tickInterval=t.ticksPerDay),i>=e&&(i/=3,this._tickInterval=3*t.ticksPerDay),i>=e&&(i/=4,this._tickFormat=Xpe.Year,this._tickInterval=t.daysPerYear*t.ticksPerDay),i>=e){var o=1;do{i/=5,o*=5,this._tickInterval*=5,i>=e&&(i/=2,o*=2,this._tickInterval*=2)}while(i>=e&&o<1e3);r=(o-t.epochYear%o)%o*t.ticksPerDay*t.daysPerYear}var a=t.epochTicks-r,s=this.min+a;this._firstMajorTickValue=Math.ceil(s/this._majorTickInterval)*this._majorTickInterval-a,this._firstTickValue=Math.ceil(s/this._tickInterval)*this._tickInterval-a},r.buildTicks=function(){for(var e=[],t=this._tickInterval,n=this._firstTickValue;n<=this.max;n+=t){var r=Math.abs((n-this._firstMajorTickValue)%this._majorTickInterval/this._majorTickInterval)<.001;e.push({value:n,major:r})}return e},r.generateTickLabels=function(e){var t,n,r;for(t=0,n=e.length;t<n;t++)(r=e[t]).label=this.generateTickLabel(r.value,r.major)},r.generateTickLabel=function(e,t){var n=UN(this.options.timeSettings,Math.ceil(e));return this._tickFormat===Xpe.HourMonth?t?[this.options.ticks.timeFormat(n),this.options.ticks.dateFormat(n)]:this.options.ticks.timeFormat(n):this._tickFormat===Xpe.Date?this.options.ticks.dateFormat(n):n.year.toFixed(0)},r.configure=function(){zpe(Ype(n.prototype),"configure",this).call(this),this._startValue=this.min,this._valueRange=this.max-this.min},r.getPixelForValue=function(e){return this.getPixelForDecimal((e-this._startValue)/this._valueRange)},r.getValueForPixel=function(e){return this._startValue+this.getDecimalForPixel(e)*this._valueRange},n}(ho);function eve(){Ko.register(Jpe)}Jpe.id="simulationTime",Jpe.defaults={timeSettings:{daysPerYear:12,ticksPerDay:1<<17,epochTicks:0,epochYear:0},ticks:{_scriptable:function(e){return"timeFormat"!==e&&"dateFormat"!==e},timeFormat:function(e){return JSON.stringify(["hhmm",e.hour,e.minute])},dateFormat:function(e){return JSON.stringify(["MMyy",e.month,e.year])},maxTicksLimit:11}},oe.add("game-ui/common/charts/simulation-time-scale.ts",{get registerSimulationTimeScale(){return eve},set registerSimulationTimeScale(e){eve=e}});let tve={chartFontColor:"rgba(255, 255, 255, 0.6)",chartLineColor:"rgba(255, 255, 255, 0.1)",content:"content_nkU",legend:"legend_nMX","legend-item":"legend-item_all",legendItem:"legend-item_all",graph:"graph_zE6","time-scale":"time-scale_ShR",timeScale:"time-scale_ShR","time-scale-label":"time-scale-label_VSV",timeScaleLabel:"time-scale-label_VSV","time-scale-field":"time-scale-field_lEQ",timeScaleField:"time-scale-field_lEQ","time-scale-title":"time-scale-title_Ow0",timeScaleTitle:"time-scale-title_Ow0","action-icon":"action-icon_T6_",actionIcon:"action-icon_T6_",slider:"slider_mN3"};oe.add("game-ui/game/components/statistics-panel/graph/statistics-graph.module.scss",{get classes(){return tve},set classes(e){Object.assign(tve,e)}});const nve=tve;function rve(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function ive(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){rve(e,t,n[t])}))}return e}function ove(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}eve();var ave=function(e){var t,n=e.data,r=e.selectedStatistics,i=e.timeScale,o=e.stepCount,a=e.onSetTimeScale,s=e.className,l=lu($c.Money),c=lu($c.Integer),u=xl($C),d=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0,r=Qu(),i=$u(),o=xl(KC),a=xl(IN),s=xl(TN),l=xl(Xl),c=xl(tN),u=a-s.ticksPerDay/c*o,d=a+s.ticksPerDay/1440+1;return(0,Y.useMemo)((function(){var o={layout:{padding:{top:0,right:50,bottom:0,left:25}},elements:{line:{fill:t,borderWidth:3,tension:0},point:{radius:0}},scales:{x:{type:"simulationTime",min:u,max:d,grid:{color:nve.chartLineColor,lineWidth:1},border:{color:nve.chartLineColor,width:1},timeSettings:s,ticks:{maxTicksLimit:11,font:{size:sve*l},color:nve.chartFontColor,padding:lve,timeFormat:r,dateFormat:i}},y:{beginAtZero:!0,max:n,grid:{color:nve.chartLineColor,lineWidth:1},border:{color:nve.chartLineColor,width:1},ticks:{font:{size:sve*l},maxTicksLimit:10,color:nve.chartFontColor,padding:lve,autoSkip:!1,callback:function(t){return e?e(t):t}},stacked:t}}};return o}),[t,u,d,s,l,r,i,n,e])}(r.length>0&&1===r[0].unitType?l:c,u,r.length>0&&2===r[0].unitType?100:void 0),f=function(){var e=xl(KC),t=xl(IN),n=xl(tN),r=xl(TN);return{x:t-r.ticksPerDay/n*e,y:t+r.ticksPerDay/1440+1}}(),m=(0,Y.useMemo)((function(){return ove(ive({},n),{datasets:n.datasets.map((function(e){var t=e.data.map((function(e,t,n){if(0===t){var r,i,o=n.length>1&&n[0].x<f.x?function(e,t,n){var r=e.x,i=e.y,o=t.x,a=t.y,s=i+(n-r)*(a-i)/(o-r);return{x:n,y:s}}(n[0],n[1],f.x):null;return{x:null!==(r=null==o?void 0:o.x)&&void 0!==r?r:Math.max(e.x,f.x),y:null!==(i=null==o?void 0:o.y)&&void 0!==i?i:e.y}}return t===n.length-1?{x:f.y,y:e.y}:e}));return ove(ive({},e),{data:t})}))})}),[n,f.x,f.y]);return(0,z.jsx)(Bse,{focusKey:Hh,theme:b3,className:_d()(nve.statisticsGraph,s),children:(0,z.jsxs)("div",{className:nve.content,children:[(0,z.jsx)("div",{className:nve.legend,children:r.map((function(e,t){return(0,z.jsx)(hU,{color:rP(e.color),label:(0,z.jsx)(qc.StatisticsPanel.STAT_TITLE,{hash:e.key}),className:nve.legendItem},t)}))}),(0,z.jsx)(OU,{type:"line",data:m,options:d,className:nve.graph}),(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.statisticsPanelTimeScale,children:(0,z.jsxs)("div",{className:nve.timeScale,children:[(0,z.jsx)("div",{className:nve.timeScaleTitle,children:(0,z.jsx)(qc.StatisticsPanel.TIME_SCALE_TITLE,{})}),(0,z.jsx)(oF,{focusKey:Hh,theme:JD,className:nve.slider,start:0,end:0===o?1:o,value:i,gamepadStep:1,disabled:0===o,onChange:a,valueTransformer:sF}),(0,z.jsx)("div",{className:nve.timeScaleLabel,children:(0,z.jsx)("div",{className:nve.timeScaleField,children:(0,z.jsx)(qc.StatisticsPanel.TIME_SCALE,{index:i})})})]})})]})})};var sve=10,lve=10;oe.add("game-ui/game/components/statistics-panel/graph/statistics-graph.tsx",{get StatisticsGraph(){return ave},set StatisticsGraph(e){ave=e}});let cve={"foldout-item":"foldout-item_dah foldout-item_wOF",foldoutItem:"foldout-item_dah foldout-item_wOF",header:"header_MP_ header_8H_ item-mouse-states_Fmi item-focused_FuT","disable-active-state":"disable-active-state_G7o disable-active-state_w8a",disableActiveState:"disable-active-state_G7o disable-active-state_w8a","header-content":"header-content_SqG header-content_wUX",headerContent:"header-content_SqG header-content_wUX",icon:"icon_nAL icon_I32",toggle:"toggle_RV4 toggle_yQv"};oe.add("game-ui/common/foldout/themes/statistics-item.module.scss",{get classes(){return cve},set classes(e){Object.assign(cve,e)}});const uve=cve;let dve={toggle:"toggle_GGm toggle_cca item-mouse-states_Fmi"};oe.add("game-ui/game/components/statistics-panel/menu/item/statistics-checkbox.module.scss",{get classes(){return dve},set classes(e){Object.assign(dve,e)}});const fve=dve;let mve={locked:"locked_XuG",label:"label_VRN"};oe.add("game-ui/game/components/statistics-panel/menu/item/statistics-item.module.scss",{get classes(){return mve},set classes(e){Object.assign(mve,e)}});const gve=mve;let hve={size:"size_DD8",toggle:"toggle_mte size_DD8 toggle_H7r item-mouse-states_Fmi"};oe.add("game-ui/game/components/statistics-panel/menu/item/statistics-toggle.module.scss",{get classes(){return hve},set classes(e){Object.assign(hve,e)}});const pve=hve;function vve(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function bve(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return vve(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return vve(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var yve=function(e){var t=e.statItem,n=e.selectedStatistics,r=e.nesting,i=void 0===r?0:r,o=bve((0,Y.useState)(!1),2),a=o[0],s=o[1],l=(0,Y.useCallback)((function(){return s(!0)}),[]),c=(0,Y.useCallback)((function(){return s(!1)}),[]),u=Ol(QC,t.entity),d=xl(zC),f=(0,Y.useMemo)((function(){return function(e,t,n){return e.isGroup||e.isSubgroup?n.index===e.entity.index||void 0!==t.find((function(t){return t.entity.index===e.entity.index})):void 0!==t.find((function(t){return t.key===e.key}))||void 0!==t.find((function(t){return t.isSubgroup&&t.entity.index===e.entity.index}))}(t,n,d)}),[d,n,t]),m=(0,Y.useCallback)((function(){f?rN(t):nN(t)}),[f,t]),g=Ol(eN,t.entity),h=(0,Y.useMemo)((function(){return i+1}),[i]),p=(0,Y.useMemo)((function(){return-1!==n.findIndex((function(e){return Qs(e.entity,t.entity)}))||n.some((function(e){return-1!==u.findIndex((function(t){return Qs(e.entity,t.entity)}))}))}),[u,n,t.entity]);return(0,z.jsx)(vS,{initialExpanded:p,type:(t.isGroup||t.isSubgroup)&&u.length>0?"Group":"Item",className:_d()(gve.statisticsItem,t.locked&&"locked",a&&uve.disableActiveState),theme:uve,nesting:i,header:(0,z.jsx)(B9,{locked:t.locked,requirements:g,direction:"right",children:(0,z.jsx)(bS,{icon:t.locked?(0,z.jsx)(_1,{className:pve.size}):t.isGroup?(0,z.jsx)(D1,{theme:pve,disabled:t.locked,onChange:m,onMouseOver:l,onMouseLeave:c,checked:f,focusKey:t.key,style:{borderColor:rP(t.color)}}):(0,z.jsx)(fv,{theme:fve,disabled:t.locked,onChange:m,onMouseOver:l,onMouseLeave:c,checked:f,focusKey:t.key,style:{borderColor:rP(t.color)}}),children:(0,z.jsx)("div",{className:_d()(gve.label,t.locked&&gve.locked),children:(0,z.jsx)(qc.StatisticsPanel.STAT_TITLE,{hash:t.key})})})}),children:(t.isGroup||t.isSubgroup)&&u.length>0?u.map((function(e){return(0,z.jsx)(yve,{statItem:e,nesting:h,selectedStatistics:n},e.key)})):void 0})};oe.add("game-ui/game/components/statistics-panel/menu/item/statistics-item.tsx",{get StatisticsItem(){return yve},set StatisticsItem(e){yve=e}});let xve={"statistics-category-item":"statistics-category-item_qVI",statisticsCategoryItem:"statistics-category-item_qVI",items:"items_AIY",header:"header_Ld7"};oe.add("game-ui/game/components/statistics-panel/menu/category/statistics-category-item.module.scss",{get classes(){return xve},set classes(e){Object.assign(xve,e)}});const _ve=xve;var jve=function(e){var t=e.category,n=e.selectedStatistics,r=Ol(QC,t.entity);return(0,z.jsxs)("div",{className:_ve.statisticsCategoryItem,children:[(0,z.jsx)("div",{className:_ve.header,children:(0,z.jsx)(qc.StatisticsPanel.STAT_TITLE,{hash:t.key})}),(0,z.jsx)("div",{className:_ve.items,children:r.map((function(e){return(0,z.jsx)(yve,{statItem:e,selectedStatistics:n},e.key)}))})]})};oe.add("game-ui/game/components/statistics-panel/menu/category/statistics-category-item.tsx",{get StatisticsCategory(){return jve},set StatisticsCategory(e){jve=e}});let Ove={"statistics-menu":"statistics-menu_y86",statisticsMenu:"statistics-menu_y86",content:"content_Q1O",scrollable:"scrollable_By7"};oe.add("game-ui/game/components/statistics-panel/menu/statistics-menu.module.scss",{get classes(){return Ove},set classes(e){Object.assign(Ove,e)}});const Eve=Ove;var Sve=function(e){var t,n=e.selectedStatistics,r=xl(qC);return(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.statisticsPanelMenu,children:(0,z.jsx)(Bse,{theme:b3,className:Eve.statisticsMenu,children:(0,z.jsx)(gE,{className:Eve.scrollable,children:(0,z.jsx)("div",{className:Eve.content,children:(0,z.jsx)(Ap,{direction:gp.Vertical,children:r.map((function(e){return(0,z.jsx)(jve,{category:e,selectedStatistics:n},e.key)}))})})})})})};oe.add("game-ui/game/components/statistics-panel/menu/statistics-menu.tsx",{get StatisticsMenu(){return Sve},set StatisticsMenu(e){Sve=e}});let Tve={"city-statistics-panel":"city-statistics-panel_ECW",cityStatisticsPanel:"city-statistics-panel_ECW",content:"content_BIL",graph:"graph_Qba"};oe.add("game-ui/game/components/statistics-panel/statistics-panel.module.scss",{get classes(){return Tve},set classes(e){Object.assign(Tve,e)}});const Ive=Tve;var wve=function(e){var t,n,r=e.onClose;oh(null===(t=Ew.value)||void 0===t?void 0:t.statisticsPanel);var i=xl(JC),o=xl(ZC),a=(0,Y.useMemo)((function(){return{datasets:o}}),[o]),s=xl(tN),l=xl(WC),c=xl(KC),u=(0,Y.useMemo)((function(){return function(e,t){var n=e/t,r=n/12;return r>1e3?9:r>500?8:r>100?7:r>50?6:r>10?5:r>5?4:n>12?3:n>6?2:n>1?1:0}(l,s)}),[l,s]),d=(0,Y.useMemo)((function(){return function(e,t){switch(e){case t:return 0;case 6*t:return 1;case 12*t:return 2;case 60*t:return 3;case 120*t:return 4;case 600*t:return 5;case 1200*t:return 6;case 6e3*t:return 7;case 12e3*t:return 8;default:return 9}}(c,s)}),[c,s]),f=(0,Y.useMemo)((function(){return{"Change Time Scale":u>0?function(e){if(kp(Lp.dragSlider),e<0)oN(Pve(Math.max(0,d-1),l,s));else if(e>0){oN(Pve(Math.min(u,d+1),l,s))}}:null}}),[l,u,d,s]),m=(0,Y.useCallback)((function(e){oN(Pve(e,l,s))}),[l,s]),g=(0,Y.useCallback)((function(){r()}),[r]);return(0,Y.useEffect)((function(){if(0===JC.value.length){var e=qC.value;if(e.length>0){var t=QC.getValue(e[0].entity);t.length>0&&nN(t[0])}}}),[]),(0,z.jsx)(rp,{actions:f,children:(0,z.jsxs)(qj,{transitionSounds:vj,header:(0,z.jsx)(tO,{children:(0,z.jsx)(qc.Statistics.PANEL_TITLE,{})}),className:Ive.cityStatisticsPanel,contentClassName:Ive.content,onClose:g,children:[(0,z.jsx)(Sve,{selectedStatistics:i}),(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.statisticsPanel,children:(0,z.jsx)(ave,{data:a,selectedStatistics:i,timeScale:d,stepCount:u,onSetTimeScale:m,className:Ive.graph})})]})})};function Pve(e,t,n){switch(e){case 0:return n;case 1:return 6*n;case 2:return 12*n;case 3:return 60*n;case 4:return 120*n;case 5:return 600*n;case 6:return 1200*n;case 7:return 6e3*n;case 8:return 12e3*n;default:return t}}function Cve(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Nve(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Cve(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Cve(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Ave(e){switch(e){case 0:return"Media/Game/Misc/ScheduleDay.svg";case 1:return"Media/Game/Misc/ScheduleNight.svg";default:return"Media/Game/Misc/ScheduleDayNight.svg"}}function Lve(e){var t=Nve((0,Y.useState)(),2),n=t[0],r=t[1],i=Nve((0,Y.useState)(),2),o=i[0],a=i[1],s=hd(e.name);(0,Y.useEffect)((function(){null!=e&&n!==s&&(r(s),a(s))}),[e,n,s]);var l=(0,Y.useCallback)((function(e){return a(e.target.value)}),[]),c=(0,Y.useCallback)((function(){null!=e&&o&&""!==o?yL(e.lineData.entity,o):a(n)}),[e,n,o]),u=(0,Y.useCallback)((function(){return a(n)}),[n]);return[null!=o?o:"",l,c,u]}oe.add("game-ui/game/components/statistics-panel/statistics-panel.tsx",{get StatisticsPanel(){return wve},set StatisticsPanel(e){wve=e}}),oe.add("game-ui/game/components/transportation-overview-panel/lines-utils.ts",{get getScheduleIcon(){return Ave},set getScheduleIcon(e){Ave=e},get useLineName(){return Lve},set useLineName(e){Lve=e}});let Mve={"transportation-overview-page":"transportation-overview-page_NsJ",transportationOverviewPage:"transportation-overview-page_NsJ",types:"types_Mco",lines:"lines_iup",scrollable:"scrollable_lwl","no-lines":"no-lines_xtM",noLines:"no-lines_xtM",header:"header_cSe",title:"title_kUy","sort-indicator":"sort-indicator_ToO",sortIndicator:"sort-indicator_ToO",legends:"legends_mcP",button:"button_cuw item-mouse-states_Fmi item-focused_FuT icon-focused_FJS","buton-label":"buton-label_mGB",butonLabel:"buton-label_mGB",cell:"cell_geG","cell-single":"cell-single_qTE cell_geG",cellSingle:"cell-single_qTE cell_geG","cell-double":"cell-double_hmA cell_geG",cellDouble:"cell-double_hmA cell_geG","cell-wide":"cell-wide_yZB cell_geG",cellWide:"cell-wide_yZB cell_geG",visibilityButton:"visibilityButton_mnO"};oe.add("game-ui/game/components/transportation-overview-panel/transportation-overview-page.module.scss",{get classes(){return Mve},set classes(e){Object.assign(Mve,e)}});const kve=Mve;let Rve={input:"input_hDw",label:"label_NCg",container:"container_sRs"};oe.add("game-ui/game/components/transportation-overview-panel/transport-line-item/text-input/text-input.module.scss",{get classes(){return Rve},set classes(e){Object.assign(Rve,e)}});const Dve=Rve;let Fve={"transportation-line-item":"transportation-line-item_ZFw",transportationLineItem:"transportation-line-item_ZFw",container:"container_G2A item-normal_Wb_ item-hover_WK8 item-focused_FuT","color-field":"color-field_jwA",colorField:"color-field_jwA",eye:"eye_jyX",button:"button_PV4 item-mouse-states_Fmi item-focused_FuT",scheduleButton:"scheduleButton_PYR",visibilityButton:"visibilityButton_zW9",toggle:"toggle__VM",toggleOff:"toggleOff_nKd"};oe.add("game-ui/game/components/transportation-overview-panel/transport-line-item/transport-line-item.module.scss",{get classes(){return Fve},set classes(e){Object.assign(Fve,e)}});const Uve=Fve;function Gve(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Bve(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Gve(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Gve(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Vve=function(e){var t=e.focusKey,n=e.line,r=Bve(Lve(n),3),i=r[0],o=r[1],a=r[2],s=Bve((0,Y.useState)(!1),2),l=s[0],c=s[1],u=(0,Y.useContext)(dO),d=(0,Y.useCallback)((function(){return bL(n.lineData.entity)}),[n]),f=(0,Y.useCallback)((function(e){return xL(n.lineData.entity,e)}),[n]),m=(0,Y.useCallback)((function(){return _L(n.lineData.entity,!n.lineData.active)}),[n]),g=(0,Y.useCallback)((function(){u.showDialog((0,z.jsx)(OO,{title:(0,z.jsx)(qc.Common.WARNING,{}),message:(0,z.jsx)(qc.SelectedInfoPanel.CONFIRM_DELETE_WARNING,{}),onConfirm:d}))}),[u,d]),h=(0,Y.useCallback)((function(){n.lineData.visible?OL(n.lineData.entity,!1):jL(n.lineData.entity,!1)}),[n]),p=(0,Y.useCallback)((function(){vL(n.lineData.entity)}),[n]),v=(0,Y.useCallback)((function(e){e!==l&&TL(n.lineData.entity),c(e)}),[l,n.lineData.entity]),b=(0,Y.useCallback)((function(){TL(n.lineData.entity)}),[n.lineData.entity]),y=(0,Y.useCallback)((function(){switch(n.lineData.schedule){case 0:EL(n.lineData.entity,1);break;case 1:EL(n.lineData.entity,2);break;default:EL(n.lineData.entity,0)}}),[n]),x=(0,Y.useMemo)((function(){return n.lineData.isCargo?"Route":"Line"}),[n.lineData.isCargo]);return(0,z.jsx)(Tg,{onFocusChange:v,children:(0,z.jsx)("div",{className:Uve.transportationLineItem,children:(0,z.jsx)(Yv,{focusKey:t,onMouseEnter:b,onMouseLeave:b,className:Uve.container,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)("div",{className:kve.cellWide,children:(0,z.jsx)(nre,{value:i,onChange:o,onBlur:a,onClick:iv,theme:Dve,vkTitle:(0,z.jsx)(qc.VirtualKeyboard.TITLE,{hash:"LineName"})})}),(0,z.jsx)("div",{className:kve.cellDouble,children:(0,z.jsx)(su,{value:n.lineData.length,unit:$c.Length})}),(0,z.jsx)("div",{className:kve.cellDouble,children:n.lineData.stops}),(0,z.jsx)("div",{className:kve.cellDouble,children:n.lineData.vehicles}),(0,z.jsx)("div",{className:kve.cellDouble,children:n.lineData.isCargo?(0,z.jsx)(su,{value:n.lineData.cargo,unit:$c.Weight}):n.lineData.cargo}),(0,z.jsx)("div",{className:kve.cellDouble,children:(0,z.jsx)(su,{value:100*n.lineData.usage,unit:$c.Percentage})}),(0,z.jsx)("div",{className:kve.cellSingle,children:(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Transport.TOOLTIP_COLOR,{hash:x}),children:(0,z.jsx)(v4,{value:n.lineData.color,className:Uve.colorField,onChange:f,onClick:iv})})}),(0,z.jsx)("div",{className:kve.cellSingle,children:(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP_TITLE,{hash:n.lineData.active?"Deactivate":"Reactivate"}),children:(0,z.jsx)(Qp,{className:Uve.button,onSelect:m,onClick:iv,children:(0,z.jsx)(tb,{src:"Media/Glyphs/OnOff.svg",className:_d()(Uve.toggle,!n.lineData.active&&Uve.toggleOff)})})})}),(0,z.jsx)("div",{className:kve.cellSingle,children:(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Transport.TOOLTIP_SCHEDULE,{hash:x}),children:(0,z.jsx)(lb,{src:Ave(n.lineData.schedule),onSelect:y,className:_d()(Uve.button,Uve.scheduleButton),onClick:iv})})}),(0,z.jsx)("div",{className:kve.cellSingle,children:(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Transport.TOOLTIP_VISIBLE,{hash:x}),children:(0,z.jsx)(lb,{tinted:!0,src:n.lineData.visible?"Media/Glyphs/EyeOpen.svg":"Media/Glyphs/EyeClosed.svg",onSelect:h,className:_d()(Uve.button,Uve.visibilityButton),onClick:iv})})}),(0,z.jsx)("div",{className:kve.cellSingle,children:(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Transport.TOOLTIP_DETAILS,{hash:x}),children:(0,z.jsx)(lb,{tinted:!0,src:"Media/Glyphs/ViewInfo.svg",onSelect:p,className:Uve.button,onClick:iv})})}),(0,z.jsx)("div",{className:kve.cellSingle,children:(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Transport.TOOLTIP_DELETE,{hash:x}),children:(0,z.jsx)(lb,{tinted:!0,src:"Media/Glyphs/Trash.svg",onSelect:g,className:Uve.button,onClick:iv})})})]})})})})};oe.add("game-ui/game/components/transportation-overview-panel/transport-line-item/transport-line-item.tsx",{get TransportLineItem(){return Vve},set TransportLineItem(e){Vve=e}});let Hve={"transport-type-item":"transport-type-item__xs",transportTypeItem:"transport-type-item__xs",lock:"lock_GRv"};oe.add("game-ui/game/components/transportation-overview-panel/transport-type-item/transport-type-item.module.scss",{get classes(){return Hve},set classes(e){Object.assign(Hve,e)}});const Kve=Hve;var Wve,zve=function(e){var t=e.type,n=e.cargo,r=e.selected,i=e.focusKey,o=e.onSelect,a=(0,Y.useCallback)((function(){return o(t.id)}),[o,t]);return(0,z.jsx)(B9,{title:n?(0,z.jsx)(qc.Transport.ROUTES,{hash:t.id}):(0,z.jsx)(qc.Transport.LINES,{hash:t.id}),locked:t.locked,requirements:t.requirements,direction:"right",children:(0,z.jsx)(lb,{focusKey:i,src:t.icon,selected:!t.locked&&r,disabled:t.locked,theme:ipe,className:_d()(Kve.transportTypeItem,t.locked&&ipe.locked),onSelect:a,children:t.locked&&(0,z.jsx)(_1,{className:Kve.lock})})})};function Yve(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function $ve(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Yve(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Yve(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/game/components/transportation-overview-panel/transport-type-item/transport-type-item.tsx",{get TransportTypeItem(){return zve},set TransportTypeItem(e){zve=e}}),function(e){e[e.Name=0]="Name",e[e.Length=1]="Length",e[e.Stops=2]="Stops",e[e.Vehicles=3]="Vehicles",e[e.Cargo=4]="Cargo",e[e.Usage=5]="Usage"}(Wve||(Wve={}));var qve=function(e){var t,n,r,i=e.cargo,o=e.lines,a=e.types,s=e.selectedType,l=e.setSelectedType;oh(null===(t=Ew.value)||void 0===t?void 0:t.transportationOverviewPanelLines);var c=$ve((0,Y.useState)(Wve.Name),2),u=c[0],d=c[1],f=$ve((0,Y.useState)(!0),2),m=f[0],g=f[1],h=(0,Y.useCallback)((function(e){"string"==typeof e&&l(e)}),[l]),p=(0,Y.useCallback)((function(e){l(e)}),[l]),v=(0,Y.useCallback)((function(e){g(e!==u||!m),d(e)}),[m,u]),b=pd(),y=(0,Y.useMemo)((function(){return function(e,t,n,r){var i=Cre({order:n?"asc":"desc"});switch(t){case Wve.Name:return e.sort((function(e,t){return i(r(e.name),r(t.name))}));case Wve.Length:return e.sort((function(e,t){return i(e.lineData.length,t.lineData.length)}));case Wve.Stops:return e.sort((function(e,t){return i(e.lineData.stops,t.lineData.stops)}));case Wve.Vehicles:return e.sort((function(e,t){return i(e.lineData.vehicles,t.lineData.vehicles)}));case Wve.Cargo:return e.sort((function(e,t){return i(e.lineData.cargo,t.lineData.cargo)}));case Wve.Usage:return e.sort((function(e,t){return i(e.lineData.usage,t.lineData.usage)}))}}(o,u,m,b)}),[m,o,b,u]),x=$ve((0,Y.useState)(y.some((function(e){return e.lineData.visible}))||0===y.length),2),_=x[0],j=x[1],O=(0,Y.useCallback)((function(){for(var e=0;e<y.length;e++){var t=y[e];_?OL(t.lineData.entity,!1):jL(t.lineData.entity,!1)}j(!_)}),[_,y]);return(0,Y.useEffect)((function(){j(y.some((function(e){return e.lineData.visible}))||0===y.length)}),[y]),(0,z.jsx)(Ap,{direction:gp.Horizontal,children:(0,z.jsxs)("div",{className:kve.transportationOverviewPage,children:[(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.transportationOverviewPanelTransportTypes,children:(0,z.jsx)(Bse,{theme:b3,className:kve.types,children:(0,z.jsx)(Ip,{focused:s,onChange:h,onRefocus:wp,children:(0,z.jsx)(gE,{children:a.map((function(e){return(0,z.jsx)(zve,{type:e,cargo:i,focusKey:e.id,selected:e.id===s,onSelect:p},e.id)}))})})})}),(0,z.jsx)(tk,{uiTag:null===(r=Ew.value)||void 0===r?void 0:r.transportationOverviewPanelLines,children:(0,z.jsx)(Bse,{theme:b3,className:kve.lines,header:(0,z.jsx)(Xve,{type:s,cargo:i,sortBy:u,ascending:m,someVisible:_,onSort:v,toggleVisibility:O}),children:(0,z.jsx)(gE,{className:kve.scrollable,children:(0,z.jsx)(Ap,{direction:gp.Vertical,children:y.length>0?y.map((function(e){return(0,z.jsx)(Vve,{focusKey:qs(e.lineData.entity),line:e},qs(e.lineData.entity))})):(0,z.jsx)("div",{className:kve.noLines,children:i?(0,z.jsx)(qc.Transport.NO_ROUTES,{}):(0,z.jsx)(qc.Transport.NO_LINES,{})})})})})})]})})},Xve=function(e){var t,n=e.type,r=e.cargo,i=e.sortBy,o=e.ascending,a=e.someVisible,s=e.onSort,l=e.toggleVisibility,c=(0,Y.useCallback)((function(){s(Wve.Name)}),[s]),u=(0,Y.useCallback)((function(){s(Wve.Stops)}),[s]),d=(0,Y.useCallback)((function(){s(Wve.Vehicles)}),[s]),f=(0,Y.useCallback)((function(){s(Wve.Cargo)}),[s]),m=(0,Y.useCallback)((function(){s(Wve.Usage)}),[s]),g=(0,Y.useCallback)((function(){s(Wve.Length)}),[s]),h=(0,z.jsx)(tb,{className:kve.sortIndicator,src:"Media/Glyphs/ThickStrokeArrow".concat(o?"Down":"Up",".svg")});return(0,z.jsx)(Yv,{focusKey:"Header",className:kve.header,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsx)("div",{className:kve.title,children:r?(0,z.jsx)(qc.Transport.ROUTES,{hash:n}):(0,z.jsx)(qc.Transport.LINES,{hash:n})}),(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.transportationOverviewPanelLegend,children:(0,z.jsxs)("div",{className:kve.legends,children:[(0,z.jsx)("div",{className:kve.cellWide,children:(0,z.jsxs)(Qp,{onSelect:c,className:kve.button,children:[(0,z.jsx)("div",{className:kve.butonLabel,children:(0,z.jsx)(qc.Transport.LEGEND_NAME,{})}),i===Wve.Name&&h]})}),(0,z.jsx)("div",{className:kve.cellDouble,children:(0,z.jsxs)(Qp,{onSelect:g,className:kve.button,children:[(0,z.jsx)("div",{className:kve.butonLabel,children:(0,z.jsx)(qc.Transport.LEGEND_LENGTH,{})}),i===Wve.Length&&h]})}),(0,z.jsx)("div",{className:kve.cellDouble,children:(0,z.jsxs)(Qp,{onSelect:u,className:kve.button,children:[(0,z.jsx)("div",{className:kve.butonLabel,children:(0,z.jsx)(qc.Transport.LEGEND_STOPS,{hash:n})}),i===Wve.Stops&&h]})}),(0,z.jsx)("div",{className:kve.cellDouble,children:(0,z.jsxs)(Qp,{onSelect:d,className:kve.button,children:[(0,z.jsx)("div",{className:kve.butonLabel,children:(0,z.jsx)(qc.Transport.LEGEND_VEHICLES,{hash:n})}),i===Wve.Vehicles&&h]})}),(0,z.jsx)("div",{className:kve.cellDouble,children:(0,z.jsxs)(Qp,{onSelect:f,className:kve.button,children:[(0,z.jsx)("div",{className:kve.butonLabel,children:r?(0,z.jsx)(qc.Transport.LEGEND_CARGO,{}):(0,z.jsx)(qc.Transport.LEGEND_PASSENGERS,{hash:n})}),i===Wve.Cargo&&h]})}),(0,z.jsx)("div",{className:kve.cellDouble,children:(0,z.jsxs)(Qp,{onSelect:m,className:kve.button,children:[(0,z.jsx)("div",{className:kve.butonLabel,children:(0,z.jsx)(qc.Transport.LEGEND_USAGE,{})}),i===Wve.Usage&&h]})}),(0,z.jsx)("div",{className:kve.cellSingle}),(0,z.jsx)("div",{className:kve.cellSingle}),(0,z.jsx)("div",{className:kve.cellSingle}),(0,z.jsx)("div",{className:kve.cellSingle,children:(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Transport.TOOLTIP_VISIBLE,{hash:r?"Route":"Line"}),children:(0,z.jsx)(lb,{tinted:!0,src:a?"Media/Glyphs/EyeOpen.svg":"Media/Glyphs/EyeClosed.svg",onSelect:l,className:_d()(kve.button,kve.visibilityButton),onClick:iv})})}),(0,z.jsx)("div",{className:kve.cellSingle}),(0,z.jsx)("div",{className:kve.cellSingle})]})})]})})};oe.add("game-ui/game/components/transportation-overview-panel/transportation-overview-page.tsx",{get TransportationOverviewPage(){return qve},set TransportationOverviewPage(e){qve=e}});let Qve={"transportation-overview-panel":"transportation-overview-panel_VlO",transportationOverviewPanel:"transportation-overview-panel_VlO"};oe.add("game-ui/game/components/transportation-overview-panel/transportation-overview-panel.module.scss",{get classes(){return Qve},set classes(e){Object.assign(Qve,e)}});const Zve=Qve;var Jve=[$_.PublicTransport,$_.Cargo],ebe=function(e){var t,n,r,i,o=e.selectedTab,a=e.onSelectTab,s=e.onClose;oh(null===(t=Ew.value)||void 0===t?void 0:t.transportationOverviewPanel);var l=xl(fL),c=xl(mL),u=xl(gL),d=xl(hL),f=xl(pL),m=(0,Y.useMemo)((function(){return o===$_.Cargo?c:l}),[o,c,l]),g=(0,Y.useMemo)((function(){return o===$_.Cargo?f:d}),[f,o,d]),h=(0,Y.useMemo)((function(){return o===$_.Cargo?u.filter((function(e){var t;return null===(t=e.lineData)||void 0===t?void 0:t.isCargo})).filter((function(e){var t;return(null===(t=e.lineData)||void 0===t?void 0:t.type)===f})):u.filter((function(e){var t;return!(null===(t=e.lineData)||void 0===t?void 0:t.isCargo)})).filter((function(e){var t;return(null===(t=e.lineData)||void 0===t?void 0:t.type)===d}))}),[f,o,d,u]),p=(0,Y.useCallback)((function(){s(),SL()}),[s]),v=Kw("Cargo Transport");return(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.transportationOverviewPanel,children:(0,z.jsx)(qj,{header:(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(tO,{children:(0,z.jsx)(qc.Transport.LINES_OVERVIEW_TITLE,{})}),(0,z.jsxs)(S1,{children:[(0,z.jsx)(T1,{uiTag:null===(r=Ew.value)||void 0===r?void 0:r.transportationOverviewPanelTabPublicTransport,id:$_.PublicTransport,selectedId:o,onSelect:a,children:(0,z.jsx)(qc.Transport.TAB,{hash:$_[$_.PublicTransport]})}),(0,z.jsx)(B9,{locked:v.locked,requirements:v.requirements,children:(0,z.jsx)(T1,{uiTag:null===(i=Ew.value)||void 0===i?void 0:i.transportationOverviewPanelTabCargo,disabled:v.locked,locked:v.locked,id:$_.Cargo,selectedId:o,onSelect:a,children:(0,z.jsx)(qc.Transport.TAB,{hash:$_[$_.Cargo]})})})]})]}),className:Zve.transportationOverviewPanel,transitionSounds:vj,onClose:p,children:(0,z.jsx)(E1,{tabs:Jve,selectedTab:o,onSelect:a,children:(0,z.jsx)(qve,{lines:h,types:m,selectedType:g,setSelectedType:o===$_.Cargo?wL:IL,cargo:o===$_.Cargo},o)})})})};oe.add("game-ui/game/components/transportation-overview-panel/transportation-overview-panel.tsx",{get TransportationOverviewPanel(){return ebe},set TransportationOverviewPanel(e){ebe=e}});let tbe={"game-main-screen":"game-main-screen_TRK child-opacity-transition_nkS",gameMainScreen:"game-main-screen_TRK child-opacity-transition_nkS","main-container":"main-container__E2",mainContainer:"main-container__E2","main-column":"main-column_g42",mainColumn:"main-column_g42","action-hints":"action-hints_sBV",actionHints:"action-hints_sBV","center-panel-layout":"center-panel-layout_X2p",centerPanelLayout:"center-panel-layout_X2p","info-menu-layout":"info-menu-layout_E8i",infoMenuLayout:"info-menu-layout_E8i","info-layout":"info-layout_BVk",infoLayout:"info-layout_BVk","tool-options-visible":"tool-options-visible_EaE",toolOptionsVisible:"tool-options-visible_EaE","infoview-menu":"infoview-menu_VQI",infoviewMenu:"infoview-menu_VQI","selected-info-panel":"selected-info-panel_iIe",selectedInfoPanel:"selected-info-panel_iIe","tool-layout":"tool-layout_SqM",toolLayout:"tool-layout_SqM","tool-side-column":"tool-side-column_l9i",toolSideColumn:"tool-side-column_l9i","tool-main-column":"tool-main-column_PaC",toolMainColumn:"tool-main-column_PaC","tool-panel":"tool-panel_V_j",toolPanel:"tool-panel_V_j","social-panel-layout":"social-panel-layout_JFt",socialPanelLayout:"social-panel-layout_JFt","emergency-mode":"emergency-mode_zZ8",emergencyMode:"emergency-mode_zZ8","photo-mode-panel-layout":"photo-mode-panel-layout_poh",photoModePanelLayout:"photo-mode-panel-layout_poh","radio-panel":"radio-panel_otL",radioPanel:"radio-panel_otL","bp-indicator":"bp-indicator_dvA",bpIndicator:"bp-indicator_dvA","pause-menu-layout":"pause-menu-layout_eGE",pauseMenuLayout:"pause-menu-layout_eGE","advisor-menu-toggle":"advisor-menu-toggle_Fpe",advisorMenuToggle:"advisor-menu-toggle_Fpe","pause-overlay":"pause-overlay_rOw",pauseOverlay:"pause-overlay_rOw",paused:"paused_kMX","tutorials-renderer":"tutorials-renderer_uj6",tutorialsRenderer:"tutorials-renderer_uj6"};oe.add("game-ui/game/components/game-main-screen.module.scss",{get classes(){return tbe},set classes(e){Object.assign(tbe,e)}});const nbe=tbe;function rbe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var ibe,obe=(rbe(ibe={},M_.InfoviewMenu,(function(e){var t=e.onClose;return(0,z.jsx)("div",{className:nbe.infoLayout,children:(0,z.jsx)(Gee,{className:nbe.infoviewMenu,onClose:t})})})),rbe(ibe,M_.Progression,(function(e){var t=e.selectedTab,n=e.onClose;return(0,z.jsx)("div",{className:nbe.centerPanelLayout,children:(0,z.jsx)(bpe,{selectedTab:t,onSelectTab:W_,onClose:n})})})),rbe(ibe,M_.Economy,(function(e){var t=e.selectedTab,n=e.onClose;return(0,z.jsx)("div",{className:nbe.centerPanelLayout,children:(0,z.jsx)(Ode,{selectedTab:t,onSelectTab:Y_,onClose:n})})})),rbe(ibe,M_.CityInfo,(function(e){var t=e.selectedTab,n=e.onClose;return(0,z.jsx)("div",{className:nbe.centerPanelLayout,children:(0,z.jsx)(wle,{selectedTab:t,onSelectTab:q_,onClose:n})})})),rbe(ibe,M_.Statistics,(function(e){var t=e.onClose;return(0,z.jsx)("div",{className:nbe.centerPanelLayout,children:(0,z.jsx)(wve,{onClose:t})})})),rbe(ibe,M_.TransportationOverview,(function(e){var t=e.selectedTab,n=e.onClose;return(0,z.jsx)("div",{className:nbe.centerPanelLayout,children:(0,z.jsx)(ebe,{selectedTab:t,onSelectTab:X_,onClose:n})})})),rbe(ibe,M_.Chirper,(function(e){var t=e.onClose;return(0,z.jsx)(sbe,{children:(0,z.jsx)(Lse,{onClose:t})})})),rbe(ibe,M_.LifePath,(function(e){var t=e.selectedEntity,n=e.onClose;return(0,z.jsx)(sbe,{children:(0,z.jsx)(tfe,{selectedCitizen:t,onClose:n})})})),rbe(ibe,M_.Journal,(function(e){var t=e.onClose;return(0,z.jsx)(sbe,{children:(0,z.jsx)(Ade,{onClose:t})})})),rbe(ibe,M_.Radio,(function(e){var t=e.onClose;return(0,z.jsx)(Wpe,{className:nbe.radioPanel,onClose:t})})),rbe(ibe,M_.PhotoMode,(function(e){var t=e.onClose;return(0,z.jsx)(lbe,{children:(0,z.jsx)(_ge,{onClose:t})})})),rbe(ibe,M_.Notifications,(function(e){var t=e.onClose;return(0,z.jsx)(sbe,{children:(0,z.jsx)(ife,{onClose:t})})})),ibe),abe=function(e){var t=e.panel,n=(0,Y.useCallback)((function(){return B_(t.__Type)}),[t.__Type]);return(0,z.jsx)(pD,{components:obe,data:t,props:{onClose:n}})},sbe=function(e){var t=e.children,n=xl(DP);return(0,z.jsx)("div",{className:_d()(nbe.socialPanelLayout,n&&nbe.emergencyMode),children:t})},lbe=function(e){var t=e.children;return(0,z.jsx)("div",{className:_d()(nbe.photoModePanelLayout),children:t})};oe.add("game-ui/game/components/game-panel-renderer.tsx",{get gamePanelComponents(){return obe},set gamePanelComponents(e){obe=e},get GamePanelRenderer(){return abe},set GamePanelRenderer(e){abe=e},get SocialPanelLayout(){return sbe},set SocialPanelLayout(e){sbe=e},get PhotoModePanelLayout(){return lbe},set PhotoModePanelLayout(e){lbe=e}});let cbe={"infoview-menu-toggle":"infoview-menu-toggle_bYF",infoviewMenuToggle:"infoview-menu-toggle_bYF",button:"button_H9N","mini-panel-visible":"mini-panel-visible_mDg",miniPanelVisible:"mini-panel-visible_mDg","active-infoview":"active-infoview_J2h",activeInfoview:"active-infoview_J2h",exit:"exit_Oop","enter-active":"enter-active_Wti",enterActive:"enter-active_Wti",enter:"enter_zBP","exit-active":"exit-active__MZ",exitActive:"exit-active__MZ",label:"label_UhV","close-button":"close-button_TMO",closeButton:"close-button_TMO",lock:"lock_Mbc"};oe.add("game-ui/game/components/infoviews/infoview-menu-toggle/infoview-menu-toggle.module.scss",{get classes(){return cbe},set classes(e){Object.assign(cbe,e)}});const ube=cbe;var dbe=function(e){var t,n=e.miniPanelVisible,r=e.className,i=cd(xl(R_),M_.InfoviewMenu),o=xl(ry),a=Kw("Infoviews"),s=(0,Y.useCallback)((function(){var e;!i&&(null===(e=Ew.value)||void 0===e?void 0:e.infoviewsButton)&&nh(Ew.value.infoviewsButton),o&&!i?oy():H_()}),[o,i]),l=Pg();return(0,z.jsxs)("div",{className:_d()(ube.infoviewMenuToggle,n&&ube.miniPanelVisible,r),children:[(0,z.jsx)(Ud,{children:null!=o&&n&&(0,z.jsx)(Cm,{styles:ube,children:(0,z.jsxs)("div",{className:ube.activeInfoview,children:[(0,z.jsx)("div",{className:ube.label,children:(0,z.jsx)(qc.Infoviews.INFOVIEW,{hash:o.id})}),!l&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Infoviews.CLOSE_INFO_VIEW,{}),children:(0,z.jsx)(lb,{tinted:!0,src:"Media/Glyphs/Close.svg",theme:ub,className:ube.closeButton,onSelect:oy})})]})})}),(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.infoviewsButton,children:(0,z.jsx)(B9,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_INFO_VIEWS,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_INFO_VIEWS,{}),requirements:a.requirements,locked:a.locked,children:(0,z.jsx)(mae,{src:"Media/Glyphs/Info.svg",className:ube.button,selected:i,onSelect:s,disabled:a.locked,children:a.locked&&(0,z.jsx)(_1,{className:ube.lock})})})})]})};oe.add("game-ui/game/components/infoviews/infoview-menu-toggle/infoview-menu-toggle.tsx",{get InfoviewMenuToggle(){return dbe},set InfoviewMenuToggle(e){dbe=e}});let fbe={field:"field_eZ6",header:"header_oa2",icon:"icon_t1n",label:"label_pzR",content:"content_DHv",error:"error_XxO"};oe.add("game-ui/game/components/map-tile-purchase-panel/map-tile-purchase-field.module.scss",{get classes(){return fbe},set classes(e){Object.assign(fbe,e)}});const mbe=fbe;let gbe={section:"section_JVp",resources:"resources_F7B","resource-item":"resource-item_xdp",resourceItem:"resource-item_xdp","resource-icon":"resource-icon_sHE",resourceIcon:"resource-icon_sHE","resource-title":"resource-title_UvF",resourceTitle:"resource-title_UvF",purchase:"purchase_qTi","cost-row":"cost-row_F5P",costRow:"cost-row_F5P",button:"button_adT",problems:"problems_b5X",problem:"problem_d8F","cost-icon":"cost-icon_Tn1",costIcon:"cost-icon_Tn1","cost-icon-disabled":"cost-icon-disabled_Dzu",costIconDisabled:"cost-icon-disabled_Dzu",label:"label_ASS",field:"field_z8Y"};oe.add("game-ui/game/components/map-tile-purchase-panel/map-tile-purchase-panel.module.scss",{get classes(){return gbe},set classes(e){Object.assign(gbe,e)}});const hbe=gbe;function pbe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function vbe(e){return function(e){if(Array.isArray(e))return pbe(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return pbe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return pbe(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var bbe={enter:Lp.mapTilePurchaseMode,exit:Lp.mapTilePurchaseModeEnd},ybe=function(e){var t,n,r,i=e.focusKey,o=e.className,a=e.onClose;rh(null===(t=Ew.value)||void 0===t?void 0:t.mapTilePanel);var s=xl(BI),l=xl(VI),c=xl(HI),u=xl(WI)===FI.None,d=(0,Y.useMemo)((function(){return{"Purchase Map Tile":u?function(){var e,t;kp(Lp.purchase),XI(),(null===(e=Ew.value)||void 0===e?void 0:e.mapTilePanelPurchase)&&nh(null===(t=Ew.value)||void 0===t?void 0:t.mapTilePanelPurchase)}:null}}),[u]);return(0,z.jsx)(rp,{actions:d,children:(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.mapTilePanel,children:(0,z.jsxs)(qj,{focusKey:i,className:_d()(hbe.mapTilePurchasePanel,o),header:(0,z.jsx)(tO,{children:(0,z.jsx)(qc.MapTilePurchase.TITLE,{})}),transitionSounds:bbe,onClose:a,children:[(0,z.jsx)(tk,{uiTag:null===(r=Ew.value)||void 0===r?void 0:r.mapTilePanelResources,children:(0,z.jsx)("div",{className:_d()(hbe.section,hbe.resources),children:[s,l].concat(vbe(c)).map((function(e){return(0,z.jsx)(xbe,{resource:e},e.id)}))})}),(0,z.jsx)(_be,{purchaseEnabled:u})]})})})},xbe=function(e){var t=e.resource;return(0,z.jsx)(e8,{title:(0,z.jsx)(qc.MapTilePurchase.TOOLTIP_TITLE_RESOURCE,{hash:t.id}),description:(0,z.jsx)(qc.MapTilePurchase.TOOLTIP_RESOURCE,{hash:t.id}),children:(0,z.jsxs)("div",{className:hbe.resourceItem,children:[(0,z.jsxs)("div",{className:hbe.resourceTitle,children:[(0,z.jsx)("img",{src:t.icon,className:hbe.resourceIcon}),(0,z.jsx)(qc.MapTilePurchase.RESOURCE,{hash:t.id})]}),(0,z.jsx)("div",{className:hbe.resourceValue,children:(0,z.jsx)(su,{value:t.value,unit:t.unit})})]})})},_be=function(e){var t,n=e.purchaseEnabled,r=Pg(),i=(0,Y.useCallback)((function(){var e,t;XI(),(null===(e=Ew.value)||void 0===e?void 0:e.mapTilePanelPurchase)&&nh(null===(t=Ew.value)||void 0===t?void 0:t.mapTilePanelPurchase)}),[]);return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsxs)("div",{className:_d()(hbe.section,hbe.purchase),children:[(0,z.jsx)(jbe,{}),!r&&(0,z.jsx)(jh,{tooltip:Ebe(WI.value),children:(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.mapTilePanelPurchase,children:(0,z.jsx)(Qp,{focusKey:Hh,theme:kO,selectSound:Lp.purchase,className:hbe.button,disabled:!n,onSelect:i,children:(0,z.jsx)(qc.MapTilePurchase.PURCHASE_STATUS,{hash:FI[FI.None]})})})})]}),r&&0!=(WI.value&(FI.InsufficientFunds|FI.InsufficientPermits))&&(0,z.jsx)("div",{className:hbe.problems,children:Obe(WI.value)})]})},jbe=function(){var e=xl(zI),t=xl(YI),n=xl(KI),r=0!=(WI.value&FI.InsufficientFunds),i=0!=(WI.value&FI.InsufficientPermits),o=0!=(WI.value&FI.NoSelection);return(0,z.jsx)("div",{className:hbe.costRow,children:o?Obe(FI.NoSelection):(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(Dre,{theme:mbe,label:(0,z.jsx)(qc.MapTilePurchase.PERMITS_USED,{}),icon:"Media/Game/Icons/ExpansionPermit.svg",className:_d()(hbe.field,i&&mbe.error),children:(0,z.jsx)(Pu,{value:t,total:e})}),(0,z.jsx)(Dre,{theme:mbe,label:(0,z.jsx)(qc.MapTilePurchase.COST,{}),icon:"Media/Game/Icons/Money.svg",className:_d()(hbe.field,r&&mbe.error),children:(0,z.jsx)(su,{value:n,unit:$c.Money})})]})})};function Obe(e){switch(e){case FI.NoSelection:return(0,z.jsx)("div",{className:hbe.problem,children:(0,z.jsx)(qc.MapTilePurchase.PURCHASE_STATUS,{hash:FI[FI.NoSelection]})});case FI.InsufficientPermits|FI.InsufficientFunds:return(0,z.jsx)("div",{className:hbe.problem,children:(0,z.jsx)(qc.MapTilePurchase.PURCHASE_STATUS,{hash:"".concat(FI[FI.InsufficientPermits]).concat(FI[FI.InsufficientFunds])})});case FI.InsufficientPermits:return(0,z.jsx)("div",{className:hbe.problem,children:(0,z.jsx)(qc.MapTilePurchase.PURCHASE_STATUS,{hash:FI[FI.InsufficientPermits]})});case FI.InsufficientFunds:return(0,z.jsx)("div",{className:hbe.problem,children:(0,z.jsx)(qc.MapTilePurchase.PURCHASE_STATUS,{hash:FI[FI.InsufficientFunds]})})}}function Ebe(e){switch(e){case FI.NoSelection:return(0,z.jsx)(qc.MapTilePurchase.PURCHASE_STATUS_TOOLTIP,{hash:FI[FI.NoSelection]});case FI.InsufficientPermits|FI.InsufficientFunds:return(0,z.jsx)(qc.MapTilePurchase.PURCHASE_STATUS_TOOLTIP,{hash:"".concat(FI[FI.InsufficientPermits]).concat(FI[FI.InsufficientFunds])});case FI.InsufficientPermits:return(0,z.jsx)(qc.MapTilePurchase.PURCHASE_STATUS_TOOLTIP,{hash:FI[FI.InsufficientPermits]});case FI.InsufficientFunds:return(0,z.jsx)(qc.MapTilePurchase.PURCHASE_STATUS_TOOLTIP,{hash:FI[FI.InsufficientFunds]})}}oe.add("game-ui/game/components/map-tile-purchase-panel/map-tile-purchase-panel.tsx",{get MapTilePurchasePanel(){return ybe},set MapTilePurchasePanel(e){ybe=e}});let Sbe={"button-row":"button-row_Idj",buttonRow:"button-row_Idj"};oe.add("game-ui/common/input/button/button-row.module.scss",{get classes(){return Sbe},set classes(e){Object.assign(Sbe,e)}});const Tbe=Sbe;var Ibe=function(e){var t=e.className,n=e.children;return(0,z.jsx)("div",{className:_d()(Tbe.buttonRow,t),children:n})};oe.add("game-ui/common/input/button/button-row.tsx",{get ButtonRow(){return Ibe},set ButtonRow(e){Ibe=e}});let wbe={"milestone-trophy-animation":"milestone-trophy-animation_ZMt",milestoneTrophyAnimation:"milestone-trophy-animation_ZMt",waterdrop:"waterdrop_Qpf",scale:"scale_v4R",MILESTONE_WATERDROP_FADE:"MILESTONE_WATERDROP_FADE_WQi",milestoneWaterdropFade:"MILESTONE_WATERDROP_FADE_WQi",two:"two_RoL",three:"three_pjZ",trophy:"trophy_RwE"};oe.add("game-ui/game/components/progression/milestone-unlock-event-panel/milestone-trophy-animation.module.scss",{get classes(){return wbe},set classes(e){Object.assign(wbe,e)}});const Pbe=wbe;var Cbe=function(e){var t=e.className;return(0,z.jsxs)("div",{className:_d()(Pbe.milestoneTrophyAnimation,t),children:[(0,z.jsx)("div",{className:Pbe.waterdrop}),(0,z.jsx)("div",{className:_d()(Pbe.waterdrop,Pbe.two)}),(0,z.jsx)("div",{className:_d()(Pbe.waterdrop,Pbe.three)}),(0,z.jsx)("img",{src:"Media/Game/Icons/Trophy.svg",className:Pbe.trophy})]})};oe.add("game-ui/game/components/progression/milestone-unlock-event-panel/milestone-trophy-animation.tsx",{get MilestoneTrophyAnimation(){return Cbe},set MilestoneTrophyAnimation(e){Cbe=e}});let Nbe={"milestone-unlock-event-panel":"milestone-unlock-event-panel_zd2",milestoneUnlockEventPanel:"milestone-unlock-event-panel_zd2",title:"title_K9M","title-primary":"title-primary_m30",titlePrimary:"title-primary_m30","title-secondary":"title-secondary_mRY",titleSecondary:"title-secondary_mRY",header:"header_Uqs","header-layer":"header-layer_ChU",headerLayer:"header-layer_ChU",cityscape:"cityscape_b4P",trophy:"trophy_Q30","city-title":"city-title_U_b",cityTitle:"city-title_U_b",description:"description_Iei","rewards-label":"rewards-label_q85",rewardsLabel:"rewards-label_q85",rewards:"rewards_cr_","reward-field":"reward-field_v6Q",rewardField:"reward-field_v6Q",actions:"actions_YbO"};oe.add("game-ui/game/components/progression/milestone-unlock-event-panel/milestone-unlock-event-panel.module.scss",{get classes(){return Nbe},set classes(e){Object.assign(Nbe,e)}});const Abe=Nbe;var Lbe=new Wh("continueButton"),Mbe=function(e){var t,n=e.focusKey,r=e.milestone,i=e.onClose,o=(0,Y.useCallback)((function(){i(),W_(k_.Milestones)}),[i]),a=null!==(t=Ol(SP,r))&&void 0!==t?t:hP;return(0,Y.useEffect)((function(){kp(Lp.milestoneEvent)}),[]),(0,z.jsx)("div",{className:Abe.milestoneUnlockEventPanel,children:(0,z.jsx)(ap,{onAction:i,children:(0,z.jsxs)(Ap,{focusKey:n,initialFocused:Lbe,children:[(0,z.jsxs)("div",{className:Abe.title,children:[(0,z.jsx)("div",{className:Abe.titlePrimary,children:(0,z.jsx)(qc.Progression.MILESTONE_UNLOCK_PANEL_TITLE_PRIMARY,{INDEX:(0,z.jsx)(su,{value:a.index,unit:$c.Integer})})}),(0,z.jsx)("div",{className:Abe.titleSecondary,children:(0,z.jsx)(qc.Progression.MILESTONE_UNLOCK_PANEL_TITLE_SECONDARY,{})})]}),(0,z.jsxs)("div",{className:Abe.header,children:[(0,z.jsx)("img",{src:a.image,className:Abe.cityscape}),(0,z.jsx)(Cbe,{className:Abe.trophy})]}),(0,z.jsx)("div",{className:Abe.cityTitle,children:(0,z.jsx)(qc.Progression.MILESTONE_NAME,{index:a.index})}),(0,z.jsx)("div",{className:Abe.description,children:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.Progression.MILESTONE_DESCRIPTION,{index:a.index})})}),(0,z.jsx)("div",{className:Abe.rewardsLabel,children:(0,z.jsx)(qc.Progression.MILESTONE_REWARDS_LABEL,{})}),(0,z.jsxs)("div",{className:Abe.rewards,children:[a.reward>0&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Progression.REWARD_FIELD_LABEL,{}),children:(0,z.jsx)(Dre,{icon:"Media/Game/Icons/Money.svg",className:Abe.rewardField,children:(0,z.jsx)(su,{value:a.reward,unit:$c.Money})})}),a.devTreePoints>0&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Progression.DEVELOPMENT_POINTS_FIELD_LABEL,{}),children:(0,z.jsx)(Dre,{icon:"Media/Game/Icons/DevPoint.svg",className:Abe.rewardField,children:(0,z.jsx)(su,{value:a.devTreePoints,unit:$c.Integer,signed:!0})})}),a.mapTiles>0&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Progression.MAP_TILES_FIELD_LABEL,{}),children:(0,z.jsx)(Dre,{icon:"Media/Game/Icons/ExpansionPermit.svg",className:Abe.rewardField,children:(0,z.jsx)(su,{value:a.mapTiles,unit:$c.Integer,signed:!0})})})]}),(0,z.jsxs)(Ibe,{className:Abe.actions,children:[(0,z.jsx)(Qp,{theme:Jp,onSelect:o,children:(0,z.jsx)(qc.Progression.PROGRESSION_PANEL_BUTTON,{})}),(0,z.jsx)(Qp,{focusKey:Lbe,theme:Jp,onSelect:i,children:(0,z.jsx)(qc.Common.CLOSE,{})})]})]})})})};oe.add("game-ui/game/components/progression/milestone-unlock-event-panel/milestone-unlock-event-panel.tsx",{get MilestoneUnlockEventPanel(){return Mbe},set MilestoneUnlockEventPanel(e){Mbe=e}});let kbe={"signature-unlock-event-panel":"signature-unlock-event-panel_f8P",signatureUnlockEventPanel:"signature-unlock-event-panel_f8P",image:"image_Pwi",content:"content_vd9",title:"title_vLU",description:"description_cRG",stats:"stats_FqV","stat-field":"stat-field_yOa",statField:"stat-field_yOa",actions:"actions_kVJ"};oe.add("game-ui/game/components/progression/signature-unlock-event-panel/signature-unlock-event-panel.module.scss",{get classes(){return kbe},set classes(e){Object.assign(kbe,e)}});const Rbe=kbe;function Dbe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Fbe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Dbe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Dbe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Ube=function(e){var t,n,r=e.focusKey,i=e.entities,o=e.onClose,a=Fbe((0,Y.useState)(0),2),s=a[0],l=a[1],c=i.length>s?i[s]:ty,u=null!==(t=Ol(Ow,c))&&void 0!==t?t:Sw;return(0,Y.useEffect)((function(){return kp(Lp.signatureBuildingEvent)}),[]),(0,Y.useEffect)((function(){i.length<=s&&(i.length>0?l(0):o())}),[s,i.length,o]),(0,z.jsx)(qj,{focusKey:r,theme:Qj,header:(0,z.jsx)(tO,{icon:"Media/Game/Icons/ZoneSignature.svg",children:(0,z.jsx)(qc.Progression.BUILDING_UNLOCK_EVENT_PANEL_TITLE,{})}),className:Rbe.signatureUnlockEventPanel,onClose:o,children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)(mM,{src:null!==(n=null==u?void 0:u.preview)&&void 0!==n?n:"",className:Rbe.image}),(0,z.jsxs)("div",{className:Rbe.content,children:[(0,z.jsx)("div",{className:Rbe.title,children:(0,z.jsx)(kc,{id:u.titleId})}),u.descriptionId&&(0,z.jsx)("div",{className:Rbe.description,children:(0,z.jsx)(kc,{id:u.descriptionId})}),(0,z.jsx)("div",{className:Rbe.stats,children:null!=u.constructionCost&&(0,z.jsx)(Dre,{label:(0,z.jsx)(qc.Properties.CONSTRUCTION_COST,{}),className:Rbe.statField,children:(0,z.jsx)(su,{value:"number"==typeof u.constructionCost.value?u.constructionCost.value:u.constructionCost.value.y,unit:u.constructionCost.unit})})}),(0,z.jsx)(Ibe,{className:Rbe.actions,children:(0,z.jsx)(Qp,{theme:Jp,onSelect:o,children:(0,z.jsx)(qc.Common.OK,{})})})]})]})})};function Gbe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Bbe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Gbe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Gbe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/game/components/progression/signature-unlock-event-panel/signature-unlock-event-panel.tsx",{get SignatureUnlockEventPanel(){return Ube},set SignatureUnlockEventPanel(e){Ube=e}});const Vbe=function(e){var t=Bbe((0,Y.useState)(),2),n=t[0],r=t[1];return(0,Y.useEffect)((function(){var t=0,n=function(){e.current?r(e.current.getBoundingClientRect()):r(void 0),t=window.requestAnimationFrame(n)};return setTimeout((function(){return n()}),0),function(){return window.cancelAnimationFrame(t)}}),[e]),n};oe.add("game-ui/common/hooks/use-bounding-client-rect.ts",{});let Hbe={scrollable:"scrollable_A57",value:"value_GiO",button:"button_kAx"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/developer-section/developer-section.module.scss",{get classes(){return Hbe},set classes(e){Object.assign(Hbe,e)}});const Kbe=Hbe;let Wbe={section:"section_Czw section_gUk","title-bar":"title-bar_tE1 title-bar_wU9",titleBar:"title-bar_tE1 title-bar_wU9",expandable:"expandable_HXj",title:"title_dyN title_bwV",content:"content_YjM content_owQ"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/developer-section/section.module.scss",{get classes(){return Wbe},set classes(e){Object.assign(Wbe,e)}});const zbe=Wbe;var Ybe=function(e){var t=e.label,n=e.value,r=e.max;return(0,z.jsx)(Bse,{header:(0,z.jsx)(E3,{children:t}),theme:zbe,className:Kbe.capacityInfo,children:(0,z.jsx)(qce,{progress:n,max:r,children:"".concat(n,"/").concat(r)})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/developer-section/capacity-info.tsx",{get CapacityInfo(){return Ybe},set CapacityInfo(e){Ybe=e}});var $be=function(e){var t=e.label,n=e.value,r=e.target,i=(0,Y.useCallback)((function(){null!=r&&LC(r)}),[r]);return(0,z.jsx)(Bse,{className:Kbe.genericInfo,theme:zbe,header:(0,z.jsx)(E3,{children:t}),children:(0,z.jsx)(Qp,{className:_d()(Kbe.button,null!=r&&Kbe.link),disabled:null==r||0===(null==r?void 0:r.index),onSelect:i,children:n})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/developer-section/generic-info.tsx",{get GenericInfo(){return $be},set GenericInfo(e){$be=e}});var qbe=function(e){var t=e.label,n=e.list;return(0,z.jsx)(O3,{header:(0,z.jsx)(E3,{children:t}),theme:zbe,className:Kbe.infoList,transition:null,children:(0,z.jsx)(Ap,{children:n.map((function(e,t){return(0,z.jsx)(Xbe,{item:e},t)}))})})},Xbe=function(e){var t=e.item,n=(0,Y.useCallback)((function(){null!=t.entity&&LC(t.entity)}),[t.entity]);return(0,z.jsx)(Qp,{className:_d()(Kbe.button,null!=(null==t?void 0:t.entity)&&Kbe.link),disabled:null==(null==t?void 0:t.entity)||0===(null==t?void 0:t.entity.index),onSelect:n,children:t.text})};function Qbe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/developer-section/info-list.tsx",{get InfoList(){return qbe},set InfoList(e){qbe=e}});var Zbe,Jbe=function(e){var t=e.focusKey,n=e.subsections;return(0,z.jsx)(gE,{className:Kbe.scrollable,children:(0,z.jsx)(Ap,{focusKey:t,children:(0,z.jsx)(vD,{components:eye,data:n})})})},eye=(Qbe(Zbe={},bC.GenericInfo,$be),Qbe(Zbe,bC.CapacityInfo,Ybe),Qbe(Zbe,bC.InfoList,qbe),Zbe);oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/developer-section/developer-section.tsx",{get DeveloperSection(){return Jbe},set DeveloperSection(e){Jbe=e},get developerSubsectionComponents(){return eye},set developerSubsectionComponents(e){eye=e}});let tye={"developer-info-panel":"developer-info-panel_GEQ",developerInfoPanel:"developer-info-panel_GEQ"};oe.add("game-ui/game/components/selected-info-panel/developer-info-panel.module.scss",{get classes(){return tye},set classes(e){Object.assign(tye,e)}});const nye=tye;function rye(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function iye(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){rye(e,t,n[t])}))}return e}var oye=function(e){var t=e.onClose,n=e.developerInfoSection,r=xl(VN),i=(0,Y.useRef)(null),o=function(e){var t=xl(OC),n=Xf(),r=$O();if(e&&t&&n)return{x:Math.trunc(of(t.x*n.x+aye*r,0,n.x-e.width-70)),y:Math.trunc(of((1-t.y)*n.y+aye*r,90,n.y-e.height-120))};return}(Vbe(i)),a=(0,Y.useCallback)((function(){t()}),[t]);return(0,z.jsx)(z.Fragment,{children:"Default Tool"===r.id&&(0,z.jsx)(qj,{ref:i,className:nye.developerInfoPanel,style:sye(o),onClose:a,header:(0,z.jsx)(tO,{children:(0,z.jsx)(qc.SelectedInfoPanel.DEVELOPER_INFO_TITLE,{})}),children:(0,z.jsx)(Jbe,iye({},n))})})},aye=10;function sye(e){return e?{left:e.x+"px",top:e.y+"px"}:{visibility:"hidden"}}oe.add("game-ui/game/components/selected-info-panel/developer-info-panel.tsx",{get DeveloperInfoPanel(){return oye},set DeveloperInfoPanel(e){oye=e}});var lye="DistrictsSection",cye=fl(lye,"selecting"),uye=vl(lye,"removeDistrict"),dye=pl(lye,"toggleSelectionTool"),fye=pl(lye,"toggleDistrictTool");oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/districts-section/districts-section-bindings.ts",{get selecting(){return selecting},set selecting(e){selecting=e},get removeDistrict(){return uye},set removeDistrict(e){uye=e},get toggleSelectionTool(){return dye},set toggleSelectionTool(e){dye=e},get toggleDistrictTool(){return fye},set toggleDistrictTool(e){fye=e}});var mye=18,gye=26;function hye(e,t,n,r,i,o){var a=yye(r,i,n.position),s=12*o,l=(Pye/2+wye)*o,c=a.x+l,u=a.y+l;return(e-c)*(e-c)+(t-u)*(t-u)<=s*s}function pye(e,t,n,r,i,o,a,s,l,c){var u=12*c,d=2*c,f=yye(r,i,t.position),m=l?1.25*u:s?1.125*u:u,g=l?1.25*d:s?1.125*d:d,h=(Pye/2+wye)*c,p=n>0?Math.min(t.cargo/n,1):0,v=Math.sqrt(p)*(m-g),b={r:a.r,g:a.g,b:a.b,a:p},y=rP(o),x=rP(b);e.beginPath(),e.arc(f.x+h,f.y+h,m,2*Math.PI,0,!1),e.closePath(),e.fillStyle=y,e.fill(),e.beginPath(),e.arc(f.x+h,f.y+h,v,2*Math.PI,0,!1),e.closePath(),e.fillStyle=x,e.fill()}function vye(e,t,n,r,i,o,a,s){var l=yye(o,a,n.position),c=xye(s,r,i),u=xye(s,r,i),d=(Pye/2+wye)*s;return function(e,t,n,r,i,o,a){var s=e-n,l=t-r,c=(o*o+a*a)/4;if(s*s+l*l>c)return!1;var u=Math.sin(-i),d=Math.cos(-i);return l=(s=s*d-l*u)*u+l*d,s+=n,l+=r,s>=n-o/2&&s<=n+o/2&&l>=r-a/2&&l<=r+o/2}(e,t,l.x+d,l.y+d,l.z,c,u)}function bye(e,t,n,r,i,o,a,s,l){var c=2*l,u=3*l,d=yye(n,r,t.position),f=xye(l,s,a),m=function(e,t,n){return gye*e*(t?1.25:n?1.125:1)}(l,s,a),g=(Pye/2+wye)*l,h=f/2,p=m/2,v=t.capacity>0?t.cargo/t.capacity:0,b=6*Math.min(v,1),y=s?1.25*c:a?1.125*c:c,x=s?1.25*u:a?1.125*u:u,_=y/2+x,j=y+2*x,O=rP(i),E=rP(o);e.save(),e.translate(d.x+g,d.y+g),e.rotate(d.z),e.fillStyle=O,e.fillRect(-h,-p,f,m),b>0&&(e.beginPath(),e.moveTo(-_,-j),e.arc(-_,-j,x,0,2*Math.PI),b>1&&(e.moveTo(_,-j),e.arc(_,-j,x,0,2*Math.PI)),b>2&&(e.moveTo(-_,0),e.arc(-_,0,x,0,2*Math.PI)),b>3&&(e.moveTo(_,0),e.arc(_,0,x,0,2*Math.PI)),b>4&&(e.moveTo(-_,j),e.arc(-_,j,x,0,2*Math.PI)),b>5&&(e.moveTo(_,j),e.arc(_,j,x,0,2*Math.PI)),e.fillStyle=E,e.fill()),e.restore()}function yye(e,t,n){var r=e*Math.PI,i=t-2*e,o=2*r+2*i,a=r/o,s=i/o;if(n<a/2){var l=Math.PI*n/a;return{x:e+e*Math.sin(l),y:e-e*Math.cos(l),z:l+Math.PI/2}}if((n-=a/2)<s)return{x:2*e,y:e+n/s*i,z:Math.PI};if((n-=s)<a){var c=Math.PI*(n/a+.5);return{x:e+e*Math.sin(c),y:e-e*Math.cos(c)+i,z:c+Math.PI/2}}if((n-=a)<s)return{x:0,y:e+i-n/s*i,z:0};n-=s;var u=Math.PI*(n/a+1.5);return{x:e+e*Math.sin(u),y:e-e*Math.cos(u),z:u+Math.PI/2}}function xye(e,t,n){return mye*e*(t?1.25:n?1.125:1)}function _ye(e,t,n,r,i,o){o.broken?function(e,t,n,r,i,o,a,s){for(var l=r*Math.PI*2+2*(i-2*r),c=l/Math.max(2*Math.floor(l/(2*s)),2)/l,u=2*c,d=o-o%u;d<a;d+=u){jye(e,t,n,r,i,Math.max(d,o),Math.min(d+c,a))}}(e,t,n,r,i,o.start,o.end,10):jye(e,t,n,r,i,o.start,o.end)}function jye(e,t,n,r,i,o,a){if(!(a<=o)){var s=r*Math.PI,l=i-2*r,c=2*s+2*l,u=s/c,d=l/c,f=a-o;a=(o=(o+u/2)%1)+f;for(var m=!0;!(!(a>0)||(o<u&&(Oye(e,t,n-l/2,Math.PI,r,o/u,a/u,m),m=!1),o-=u,(a-=u)<0)||(a>0&&o<d&&(Eye(e,t+r,n,-l,o/d,a/d,m),m=!1),o-=d,(a-=d)<0)||(o<u&&(Oye(e,t,n+l/2,0,r,o/u,a/u,m),m=!1),o-=u,(a-=u)<0));)a>0&&o<d&&(Eye(e,t-r,n,l,o/d,a/d,m),m=!1),o-=d,a-=d}}function Oye(e,t,n,r,i,o,a,s){var l=Math.PI*Math.max(o,0)+r,c=Math.max(Math.PI*Math.min(a,1),o)+r;s&&e.moveTo(t+i*Math.cos(l),n+i*Math.sin(l)),e.arc(t,n,i,l,c)}function Eye(e,t,n,r,i,o,a){if(a){var s=-r*of(i-.5,-.5,.5);e.moveTo(t,n+s)}var l=-r*of(o-.5,-.5,.5);e.lineTo(t,n+l)}function Sye(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Tye(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function Iye(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Sye(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Sye(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/route-sections/line-visualizer-section/items.tsx",{get mouseOverStop(){return hye},set mouseOverStop(e){hye=e},get drawStop(){return pye},set drawStop(e){pye=e},get mouseOverVehicle(){return vye},set mouseOverVehicle(e){vye=e},get drawVehicle(){return bye},set drawVehicle(e){bye=e}}),oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/route-sections/line-visualizer-section/segments.tsx",{get segment(){return _ye},set segment(e){_ye=e}});var wye=20,Pye=8,Cye=Jw(255,255,255,.75),Nye=Jw(255,255,255,1),Aye=Y.memo((function(e){var t=e.canvasHeight,n=e.canvasWidth,r=e.color,i=e.stops,o=e.vehicles,a=e.segments,s=e.stopCapacity,l=Iye((0,Y.useState)(null),2),c=l[0],u=l[1],d=Iye((0,Y.useState)(null),2),f=d[0],m=d[1],g=(0,Y.useRef)(null),h=$O(),p=n,v=t,b=p/2,y=wye*h,x=Pye*h,_=(p-x-2*y)/2,j=v-2*y-x,O=xl(xC),E=(0,Y.useCallback)((function(e){if(null!=g.current){for(var t=g.current.getBoundingClientRect(),n=e.clientX-t.left,r=e.clientY-t.top,a=0;a<i.length;a++){var s=i[a];if(hye(n,r,s,_,j,h))return void LC(s.entity)}for(var l=0;l<o.length;l++){var u=o[l];if(vye(n,r,u,!!f&&f.entity===u.entity,!!c&&c.entity===u.entity,_,j,h))return void LC(u.entity)}}}),[c,j,_,h,f,i,o]),S=(0,Y.useCallback)((function(e){if(null!=g.current){for(var t=g.current.getBoundingClientRect(),n=e.clientX-t.left,r=e.clientY-t.top,a=0;a<i.length;a++){var s=i[a];if(hye(n,r,s,_,j,h))return void u(s)}for(var l=0;l<o.length;l++){var d=o[l];if(vye(n,r,d,!!f&&f.entity===d.entity,!!c&&c.entity===d.entity,_,j,h))return void u(d)}u(null)}}),[c,j,_,h,f,i,o]),T=(0,Y.useCallback)((function(){u(null)}),[]);return(0,Y.useEffect)((function(){var e=o.find((function(e){return Qs(e.entity,O)}))||i.find((function(e){return Qs(e.entity,O)}));m(void 0!==e?e:null)}),[O,i,o]),(0,Y.useEffect)((function(){if(g.current){var e=g.current.getContext("2d");if(e.clearRect(0,0,p,v),e.save(),e.beginPath(),a&&a.length>0)for(var t=0;t<a.length;t++)_ye(e,p/2,v/2,_,j,a[t]);if(e.lineWidth=x,e.strokeStyle=rP(Lye(null,f,c,r)),e.stroke(),o&&o.length>0)for(var n=0;n<o.length;n++){var l=o[n],u=Lye(l,f,c,r),d=Lye(l,f,c,Cye);bye(e,l,_,j,u,d,Qs(null==c?void 0:c.entity,l.entity),Qs(O,l.entity),h)}if(e.setTransform(1,0,0,1,0,0),i&&i.length>0)for(var m=0;m<i.length;m++){var b=i[m],y=Lye(b,f,c,Nye),E=Lye(b,f,c,r);pye(e,b,s,_,j,y,E,Qs(null==c?void 0:c.entity,b.entity),Qs(O,b.entity),h)}}}),[r,v,c,j,_,y,b,h,a,O,s,i,x,o,p,f]),(0,z.jsx)(RW,{tooltip:c&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(gd,{value:c.name}),(0,z.jsx)(SS,{left:c.isCargo?(0,z.jsx)(qc.SelectedInfoPanel.CARGO_TOOLTIP,{}):(0,z.jsx)(qc.SelectedInfoPanel.PASSENGERS_TOOLTIP,{}),right:c.__Type===DC?(0,z.jsx)(su,{value:c.cargo,unit:c.isCargo?$c.Weight:$c.Integer}):(0,z.jsx)(Pu,{value:c.cargo,total:c.capacity,unit:c.isCargo?$c.Weight:$c.Integer})})]}),children:(0,z.jsx)("canvas",{ref:g,width:p,height:v,onClick:E,onMouseMove:S,onMouseLeave:T})})}),(function(e,t){var n=e.vehicles,r=e.stops,i=Tye(e,["vehicles","stops"]),o=t.vehicles,a=t.stops,s=Tye(t,["vehicles","stops"]);return function(e,t){if(e.length!==t.length)return!1;for(var n=0;n<t.length;n++){if(t[n].position!==e[n].position)return!1;if(t[n].cargo!==e[n].cargo)return!1;if(t[n].capacity!==e[n].capacity)return!1;if(!Qs(t[n].entity,e[n].entity))return!1;if(!vd(t[n].name,e[n].name))return!1}return!0}(n,o)&&function(e,t){if(e.length!==t.length)return!1;for(var n=0;n<t.length;n++){if(t[n].position!==e[n].position)return!1;if(t[n].cargo!==e[n].cargo)return!1;if(!Qs(t[n].entity,e[n].entity))return!1;if(!vd(t[n].name,e[n].name))return!1}return!0}(r,a)&&el(i,s,3)}));function Lye(e,t,n,r){return null==t||Qs(null==e?void 0:e.entity,t.entity)?null==n||Qs(null==e?void 0:e.entity,n.entity)?r:Mye(-.35,r):null!=n&&Qs(null==e?void 0:e.entity,n.entity)?r:Mye(-.5,r)}function Mye(e,t){var n=[t.r,t.g,t.b,t.a],r=e<0,i=r?0:e,o=r?1+e:1-e;return{r:n[0]*o+i,g:n[1]*o+i,b:n[2]*o+i,a:n[3]}}oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/route-sections/line-visualizer-section/line-visualizer-canvas.tsx",{get LINE_VISUALIZER_PADDING(){return wye},set LINE_VISUALIZER_PADDING(e){wye=e},get LINE_VISUALIZER_TRACKWIDTH(){return Pye},set LINE_VISUALIZER_TRACKWIDTH(e){Pye=e},get LineVisualizerCanvas(){return Aye},set LineVisualizerCanvas(e){Aye=e}});let kye={"line-visualizer-section":"line-visualizer-section_MKT",lineVisualizerSection:"line-visualizer-section_MKT","gamepad-active":"gamepad-active_YL5",gamepadActive:"gamepad-active_YL5","track-container":"track-container_c4L",trackContainer:"track-container_c4L"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/route-sections/line-visualizer-section/line-visualizer-section.module.scss",{get classes(){return kye},set classes(e){Object.assign(kye,e)}});const Rye=kye;function Dye(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Fye(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Dye(e,t,n[t])}))}return e}function Uye(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var Gye=function(e){var t,n=e.focusKey,r=e.stops,i=Uye(e,["focusKey","stops"]),o=Pg(),a=(0,Y.useRef)(null),s=bf(null!==(t=Kf(a))&&void 0!==t?t:lf);return(0,z.jsx)(qj,{focusKey:n,header:(0,z.jsx)(tO,{children:r.find((function(e){return e.isCargo}))?(0,z.jsx)(qc.SelectedInfoPanel.ROUTE,{}):(0,z.jsx)(qc.SelectedInfoPanel.LINE,{})}),className:_d()(Rye.lineVisualizerSection,o&&Rye.gamepadActive),children:(0,z.jsx)("div",{ref:a,className:Rye.trackContainer,children:s.x>0&&s.y>0&&(0,z.jsx)(Aye,Fye({canvasWidth:s.x,canvasHeight:s.y,stops:r},i))})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/route-sections/line-visualizer-section/line-visualizer-section.tsx",{get LineVisualizerSection(){return Gye},set LineVisualizerSection(e){Gye=e}});let Bye={"attractiveness-factors":"attractiveness-factors_CDA",attractivenessFactors:"attractiveness-factors_CDA",positive:"positive_KO_",negative:"negative_gWG"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/attractiveness-section/attractiveness-section.module.scss",{get classes(){return Bye},set classes(e){Object.assign(Bye,e)}});const Vye=Bye;var Hye=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.attractiveness,o=e.baseAttractiveness,a=e.factors,s=BC(t,n,r);return(0,z.jsx)(qE,{tooltip:(0,z.jsxs)(z.Fragment,{children:[s&&(0,z.jsx)(Fv,{text:s}),a.length>0&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(XE,{}),(0,z.jsxs)("div",{className:Vye.attractivenessFactors,children:[(0,z.jsx)(TS,{left:(0,z.jsx)(qc.SelectedInfoPanel.ATTRACTIVENESS_BASE,{}),right:(0,z.jsx)(su,{value:o,unit:$c.Integer})}),a.map((function(e,t){return(0,z.jsx)(TS,{left:(0,z.jsx)(qc.SelectedInfoPanel.ATTRACTIVENESS_FACTORS,{hash:e.localeKey}),right:(0,z.jsx)("div",{className:uR(Vye,e.delta),children:(0,z.jsx)(su,{value:e.delta,unit:$c.Percentage,signed:!0})})},t)}))]})]})]}),children:(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.ATTRACTIVENESS,{}),right:(0,z.jsx)(su,{value:i,unit:$c.Integer})})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/attractiveness-section/attractiveness-section.tsx",{get AttractivenessSection(){return Hye},set AttractivenessSection(e){Hye=e}});let Kye={"capacity-bar":"capacity-bar_uEN",capacityBar:"capacity-bar_uEN","progress-bar":"progress-bar_AtB",progressBar:"progress-bar_AtB",excellent:"excellent_cFG",good:"good_f9U",medium:"medium_P2l",bad:"bad_BRS",critical:"critical_cqP","progress-bounds":"progress-bounds_D6g",progressBounds:"progress-bounds_D6g",progress:"progress_EvF",label:"label_y0j","progress-label":"progress-label_DqS",progressLabel:"progress-label_DqS"};oe.add("game-ui/game/components/selected-info-panel/shared-components/capacity-bar/capacity-bar.module.scss",{get classes(){return Kye},set classes(e){Object.assign(Kye,e)}});const Wye=Kye;var zye=function(e){var t=e.progress,n=e.max,r=e.plain,i=void 0!==r&&r,o=e.invertColorCodes,a=void 0!==o&&o,s=e.children,l=e.className,c=n>0?100*of(t/n,0,1):0,u=xl(xC);return(0,z.jsx)("div",{className:_d()(Wye.capacityBar,l),children:(0,z.jsx)(qce,{progress:t,max:n,theme:Wye,className:_d()(!i&&Yye(c,a)),children:s},qs(u))})};function Yye(e,t){return e>90?t?Wye.excellent:Wye.critical:e>80?t?Wye.good:Wye.bad:e>50?Wye.medium:e>20?t?Wye.bad:Wye.good:t?Wye.critical:Wye.excellent}oe.add("game-ui/game/components/selected-info-panel/shared-components/capacity-bar/capacity-bar.tsx",{get CapacityBar(){return zye},set CapacityBar(e){zye=e}});var $ye=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.batteryCharge,o=e.batteryCapacity,a=e.flow,s=e.remainingTime,l=BC(t,n,r),c=function(e){return e<0?(0,z.jsx)(qc.SelectedInfoPanel.BATTERY_STATE_DISCHARGING,{}):e>0?(0,z.jsx)(qc.SelectedInfoPanel.BATTERY_STATE_CHARGING,{}):(0,z.jsx)(qc.SelectedInfoPanel.BATTERY_STATE_IDLE,{})}(a),u=function(e,t){var n=xl(TN);return e<0?(0,z.jsx)(qc.SelectedInfoPanel.EMPTY_IN,{DURATION:(0,z.jsx)(od,{value:t,daysPerYear:n.daysPerYear})}):e>0?(0,z.jsx)(qc.SelectedInfoPanel.FULL_IN,{DURATION:(0,z.jsx)(od,{value:t,daysPerYear:n.daysPerYear})}):""}(a,s);return(0,z.jsxs)(qE,{tooltip:l&&(0,z.jsx)(Fv,{text:l}),children:[(0,z.jsx)(SS,{uppercase:!0,disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.ELECTRICITY_BATTERY_STATE,{}),right:c}),(0,z.jsx)(SS,{subRow:!0,disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.ELECTRICITY_BATTERY_FLOW,{}),right:(0,z.jsx)(su,{signed:!0,value:a,unit:$c.Power})}),(0,z.jsx)(SS,{subRow:!0,disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.ELECTRICITY_BATTERY_CHARGE,{}),right:u}),(0,z.jsx)(zye,{progress:i,max:o,invertColorCodes:!0,children:(0,z.jsx)(Pu,{value:i,total:o,unit:$c.Energy})})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/battery-section.tsx",{get BatterySection(){return $ye},set BatterySection(e){$ye=e}});var qye=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.comfort,o=BC(t,r,n);return(0,z.jsx)(qE,{tooltip:o&&(0,z.jsx)(Fv,{text:o}),children:(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.Properties.COMFORT,{}),right:(0,z.jsx)(su,{value:i,unit:$c.Integer})})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/comfort-section.tsx",{get ComfortSection(){return qye},set ComfortSection(e){qye=e}});let Xye={icon:"icon_BF2",concatenator:"concatenator_bTa"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/company-section/company-section.module.scss",{get classes(){return Xye},set classes(e){Object.assign(Xye,e)}});const Qye=Xye;var Zye=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.companyName,o=e.input1,a=e.input2,s=e.output,l=e.sells,c=e.stores,u=BC(t,n,r);return(0,z.jsxs)(qE,{tooltip:u&&(0,z.jsx)(Fv,{text:u}),children:[(0,z.jsx)(SS,{disableFocus:!0,uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.COMPANY,{}),right:i?(0,z.jsx)(gd,{value:i}):(0,z.jsx)(qc.Common.NONE,{})}),null==i&&(0,z.jsx)(SS,{disableFocus:!0,subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.BUILDING_FOR_RENT,{})}),(o||a)&&(0,z.jsx)(SS,{disableFocus:!0,subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.COMPANY_REQUIRES,{}),right:(0,z.jsxs)(z.Fragment,{children:[o&&(0,z.jsx)("img",{src:"Media/Game/Resources/".concat(o,".svg"),className:Qye.icon}),o&&(0,z.jsx)(qc.Resources.TITLE,{hash:o}),a&&(0,z.jsx)("div",{className:Qye.concatenator,children:"+"}),a&&(0,z.jsx)("img",{src:"Media/Game/Resources/".concat(a,".svg"),className:Qye.icon}),a&&(0,z.jsx)(qc.Resources.TITLE,{hash:a})]})}),s&&(0,z.jsx)(SS,{disableFocus:!0,subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.COMPANY_PRODUCES,{}),right:(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)("img",{src:"Media/Game/Resources/".concat(s,".svg"),className:Qye.icon}),(0,z.jsx)(qc.Resources.TITLE,{hash:s})]})}),l&&(0,z.jsx)(SS,{disableFocus:!0,subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.COMPANY_SELLS,{}),right:(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)("img",{src:"Media/Game/Resources/".concat(l,".svg"),className:Qye.icon}),(0,z.jsx)(qc.Resources.TITLE,{hash:l})]})}),c&&(0,z.jsx)(SS,{disableFocus:!0,subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.COMPANY_STORES,{}),right:(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)("img",{src:"Media/Game/Resources/".concat(c,".svg"),className:Qye.icon}),(0,z.jsx)(qc.Resources.TITLE,{hash:c})]})})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/company-section/company-section.tsx",{get CompanySection(){return Zye},set CompanySection(e){Zye=e}});var Jye=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.bodyCount,o=e.bodyCapacity,a=e.processingSpeed,s=e.processingCapacity,l=BC(t,n,r);return(0,z.jsxs)(qE,{tooltip:l&&(0,z.jsx)(Fv,{text:l}),children:[(0,z.jsx)(SS,{uppercase:!0,left:"Cemetery"===t?(0,z.jsx)(qc.SelectedInfoPanel.GRAVES_IN_USE,{}):(0,z.jsx)(qc.SelectedInfoPanel.DEATHCARE_BODIES,{})}),(0,z.jsx)(zye,{progress:i,max:o,children:(0,z.jsx)(Pu,{value:i,total:o})}),s>0?(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(NOe,{small:!0}),(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DEATHCARE_PROCESSING_SPEED,{})}),(0,z.jsx)(zye,{invertColorCodes:!0,progress:a,max:s,children:(0,z.jsx)(Pu,{value:a,total:s,unit:$c.BodiesPerMonth})})]}):void 0]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/deathcare-section.tsx",{get DeathcareSection(){return Jye},set DeathcareSection(e){Jye=e}});let exe={"description-row":"description-row_Xb1 info-row_QQ9 item-focused_FuT",descriptionRow:"description-row_Xb1 info-row_QQ9 item-focused_FuT"};oe.add("game-ui/game/components/selected-info-panel/shared-components/description-row/description-row.module.scss",{get classes(){return exe},set classes(e){Object.assign(exe,e)}});const txe=exe;var nxe=function(e){var t=e.children;return(0,z.jsx)("div",{className:txe.descriptionRow,children:t})};oe.add("game-ui/game/components/selected-info-panel/shared-components/description-row/description-row.tsx",{get DescriptionRow(){return nxe},set DescriptionRow(e){nxe=e}});let rxe={button:"button_ibf button_YEx item-states_QjV toggle-states_oKG",icon:"icon__uJ icon_vbQ",label:"label_KgQ"};oe.add("game-ui/game/components/selected-info-panel/shared-components/primary-button/section-primary-button.module.scss",{get classes(){return rxe},set classes(e){Object.assign(rxe,e)}});const ixe=rxe;let oxe={"info-button":"info-button_n9m",infoButton:"info-button_n9m",button:"button_hTp"};oe.add("game-ui/game/components/selected-info-panel/shared-components/info-button/info-button.module.scss",{get classes(){return oxe},set classes(e){Object.assign(oxe,e)}});const axe=oxe;var sxe=function(e){var t=e.label,n=e.icon,r=e.selected,i=e.onSelect;return(0,z.jsx)("div",{className:axe.infoButton,children:n?(0,z.jsx)(PO,{src:n,selected:r,onSelect:i,onClick:iv,className:axe.button,theme:ixe,children:t}):(0,z.jsx)(Qp,{selected:r,onSelect:i,onClick:iv,className:axe.button,theme:ixe,children:t})})};oe.add("game-ui/game/components/selected-info-panel/shared-components/info-button/info-button.tsx",{get InfoButton(){return sxe},set InfoButton(e){sxe=e}});var lxe=fl("DestroyedBuildingSection","rebuilding");function cxe(){bl("DestroyedBuildingSection","toggleRebuild")}oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/destroyed-building-section/destroyed-building-section-bindings.ts",{get rebuilding(){return rebuilding},set rebuilding(e){rebuilding=e},get toggleRebuild(){return cxe},set toggleRebuild(e){cxe=e}});var uxe=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.destroyer,o=e.cleared,a=e.progress,s=e.status,l=BC(t,n,r),c=xl(lxe),u=(0,Y.useCallback)((function(){return cxe()}),[]);return(0,z.jsxs)(qE,{disableFocus:o,tooltip:l&&(0,z.jsx)(Fv,{text:l}),children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DESTROYED,{})}),null!=i&&(0,z.jsx)(nxe,{children:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.DESTROYED_DESCRIPTION,{hash:i})})}),"None"!==s&&"Rebuild"!==s&&(0,z.jsx)(SS,{left:(0,z.jsx)(qc.SelectedInfoPanel.DESTROYED_STATUS,{hash:s})}),!o&&"Searching"===s&&(0,z.jsx)(zye,{plain:!0,progress:a,max:100,children:(0,z.jsx)(su,{value:a,unit:$c.Percentage})}),o&&(0,z.jsx)(sxe,{label:(0,z.jsx)(qc.SelectedInfoPanel.REBUILD,{}),selected:c,onSelect:u})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/destroyed-building-section/destroyed-building-section.tsx",{get DestroyedBuildingSection(){return uxe},set DestroyedBuildingSection(e){uxe=e}});let dxe={"info-link":"info-link_Mpc item-focused_FuT",infoLink:"info-link_Mpc item-focused_FuT",row:"row_Q8R",ellipsis:"ellipsis_C0N",smallText:"smallText_DnB",uppercase:"uppercase_qZ8",icon:"icon_hE2"};oe.add("game-ui/game/components/selected-info-panel/shared-components/info-link/info-link.module.scss",{get classes(){return dxe},set classes(e){Object.assign(dxe,e)}});const fxe=dxe;var mxe=function(e){var t=e.icon,n=e.tooltip,r=e.uppercase,i=void 0!==r&&r,o=e.onSelect,a=e.children;return(0,z.jsx)(jh,{tooltip:n,children:(0,z.jsxs)(Qp,{onSelect:o,onClick:iv,className:_d()(fxe.row,fxe.infoLink,i&&fxe.uppercase),children:[(0,z.jsx)("img",{src:"Media/Glyphs/ViewInfo.svg",className:fxe.icon}),t&&(0,z.jsx)("img",{src:t,className:fxe.icon}),(0,z.jsx)("div",{className:fxe.ellipsis,children:a})]})})};oe.add("game-ui/game/components/selected-info-panel/shared-components/info-link/info-link.tsx",{get InfoLink(){return mxe},set InfoLink(e){mxe=e}});let gxe={"districts-section":"districts-section_UaO",districtsSection:"districts-section_UaO",details:"details_abN",detail:"detail_DhZ","delete-button":"delete-button_UKV",deleteButton:"delete-button_UKV"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/districts-section/districts-section.module.scss",{get classes(){return gxe},set classes(e){Object.assign(gxe,e)}});const hxe=gxe;var pxe=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.districtMissing,o=e.districts,a=BC(t,n,r),s=xl(cye);return(0,z.jsxs)(qE,{disableFocus:!0,tooltip:a&&(0,z.jsx)(Fv,{text:a}),className:hxe.districtsSection,children:[(0,z.jsx)(SS,{uppercase:!0,disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.OPERATING_DISTRICTS,{})}),(0,z.jsx)(Ap,{children:o.length>0&&(0,z.jsx)("div",{className:hxe.details,children:o.map((function(e,t){return(0,z.jsx)(vxe,{district:e},t)}))})}),i?(0,z.jsx)(sxe,{label:(0,z.jsx)(qc.SelectedInfoPanel.CREATE_DISTRICT,{}),icon:"Media/Game/Icons/Districts.svg",selected:s,onSelect:fye}):(0,z.jsx)(sxe,{label:(0,z.jsx)(qc.SelectedInfoPanel.SELECT_OPERATING_DISTRICT,{}),icon:"Media/Game/Icons/Districts.svg",selected:s,onSelect:dye})]})},vxe=function(e){var t=e.district,n=(0,Y.useCallback)((function(){return LC(t.entity)}),[t]),r=(0,Y.useCallback)((function(){return uye(t.entity)}),[t]),i=(0,Y.useMemo)((function(){return{Select:function(){kp(Lp.selectItem),n()},"Remove Operating District":function(){kp(Lp.removeItem),r()}}}),[r,n]),o=Pg();return(0,z.jsx)(rp,{actions:i,children:(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(gd,{value:t.name}),link:(0,z.jsx)(mxe,{onSelect:n,children:(0,z.jsx)(qc.SelectedInfoPanel.DETAILS,{})}),right:!o&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.SelectedInfoPanel.REMOVE_OPERATING_DISTRICT,{}),children:(0,z.jsx)(lb,{tinted:!0,focusKey:Hh,onClick:iv,onSelect:r,src:"Media/Glyphs/Trash.svg",className:hxe.deleteButton})})})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/districts-section/districts-section.tsx",{get DistrictsSection(){return pxe},set DistrictsSection(e){pxe=e}});var bxe=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.studentCount,o=e.studentCapacity,a=e.graduationTime,s=e.failProbability,l=xl(TN),c=BC(t,n,r);return(0,z.jsxs)(qE,{tooltip:c&&(0,z.jsx)(Fv,{text:c}),children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.EDUCATION_STUDENTS,{})}),(0,z.jsx)(zye,{progress:i,max:o,children:(0,z.jsx)(Pu,{value:i,total:o,unit:$c.Integer})}),(0,z.jsx)(SS,{disableFocus:!0,uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.EDUCATION_GRADUATION_TIME,{}),right:s<1?(0,z.jsx)(od,{value:a*l.daysPerYear,daysPerYear:l.daysPerYear,maxMonths:3*l.daysPerYear}):(0,z.jsx)(qc.SelectedInfoPanel.EDUCATION_NO_GRADUATIONS,{})}),(0,z.jsx)(SS,{disableFocus:!0,uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.EDUCATION_DROPOUT_RATE,{}),right:(0,z.jsx)(bd,{value:s,max:1})})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/education-section.tsx",{get EducationSection(){return bxe},set EducationSection(e){bxe=e}});let yxe={"efficiency-factors":"efficiency-factors_QAK",efficiencyFactors:"efficiency-factors_QAK","factor-item":"factor-item_vlO",factorItem:"factor-item_vlO",name:"name_enb",value:"value_A66",result:"result_QHn"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/efficiency-section/efficiency-section.module.scss",{get classes(){return yxe},set classes(e){Object.assign(yxe,e)}});const xxe=yxe;var _xe=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.efficiency,o=e.factors,a=BC(t,n,r);return(0,z.jsx)(qE,{tooltip:(0,z.jsxs)(z.Fragment,{children:[o.length>0&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(jxe,{factors:o}),(0,z.jsx)(XE,{})]}),a&&(0,z.jsx)(Fv,{text:a})]}),children:(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.EFFICIENCY,{}),right:(0,z.jsx)(su,{value:i,unit:$c.PercentageSingleFraction})})})},jxe=function(e){var t=e.factors;return(0,z.jsx)("div",{className:xxe.efficiencyFactors,children:t.map((function(e,t){return(0,z.jsxs)("div",{className:xxe.factorItem,children:[(0,z.jsx)("div",{className:xxe.name,children:(0,z.jsx)(qc.SelectedInfoPanel.EFFICIENCY_FACTORS,{hash:e.factor})}),(0,z.jsx)("div",{className:_d()(xxe.value,uR(c9,e.value)),children:(0,z.jsx)(su,{value:e.value,unit:$c.Percentage,signed:!0})}),(0,z.jsx)("div",{className:xxe.result,children:(0,z.jsx)(su,{value:e.result,unit:$c.Percentage})})]},t)}))})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/efficiency-section/efficiency-section.tsx",{get EfficiencySection(){return _xe},set EfficiencySection(e){_xe=e}});var Oxe=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.capacity,o=e.production,a=BC(t,n,r),s=o>0&&i>0?of(100*o/i,1,100):0;return(0,z.jsxs)(qE,{tooltip:a&&(0,z.jsx)(Fv,{text:a}),children:[(0,z.jsx)(SS,{disableFocus:!0,uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.ELECTRICITY_POWER_PRODUCTION,{}),right:(0,z.jsx)(su,{value:i,unit:$c.Power})}),(0,z.jsx)(SS,{disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.ELECTRICITY_POWER_USAGE,{}),right:(0,z.jsx)(su,{value:s,unit:$c.Percentage})})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/electricity-section.tsx",{get ElectricitySection(){return Oxe},set ElectricitySection(e){Oxe=e}});var Exe=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.employeeCount,o=e.maxEmployees,a=e.educationDataEmployees,s=e.educationDataWorkplaces,l=BC(t,r,n);return(0,z.jsx)(qE,{tooltip:(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(Q7,{colors:See,labels:Tee,data:a,customLegend:a.values.map((function(e,t){return(s.values[t]>0||t===a.values.length-1)&&(0,z.jsx)(hU,{color:See[t],label:Tee[t],children:t<a.values.length-1?(0,z.jsx)(Pu,{value:e,total:s.values[t],unit:$c.Integer}):(0,z.jsx)(su,{value:e,unit:$c.Integer})},t)}))}),(0,z.jsx)(NOe,{}),l&&(0,z.jsx)(Fv,{text:l})]}),children:(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.EMPLOYEES,{}),right:(0,z.jsx)(Pu,{value:i,total:o,unit:$c.Integer})})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/employees-section.tsx",{get EmployeesSection(){return Exe},set EmployeesSection(e){Exe=e}});var Sxe=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.vehicleEfficiency,o=BC(t,n,r);return(0,z.jsx)(qE,{tooltip:o&&(0,z.jsx)(Fv,{text:o}),children:(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.EFFICIENCY,{}),right:i})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/fire-section.tsx",{get FireSection(){return Sxe},set FireSection(e){Sxe=e}});var Txe=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.garbage,o=e.garbageCapacity,a=e.processingSpeed,s=e.processingCapacity,l=e.loadKey,c=BC(t,r,n);return(0,z.jsxs)(qE,{tooltip:c&&(0,z.jsx)(Fv,{text:c}),children:[o>0?(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(SS,{disableFocus:!0,uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.GARBAGE_MANAGEMENT_STORAGE_LABEL,{hash:l})}),(0,z.jsx)(zye,{progress:i,max:o,children:(0,z.jsx)(Pu,{value:i,total:o,unit:$c.Weight})})]}):void 0,s>0?(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(NOe,{small:!0}),(0,z.jsx)(SS,{disableFocus:!0,uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.GARBAGE_MANAGEMENT_PROCESSING_SPEED,{})}),(0,z.jsx)(zye,{invertColorCodes:!0,progress:a,max:s,children:(0,z.jsx)(Pu,{value:a,total:s,unit:$c.WeightPerMonth})})]}):void 0]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/garbage-section.tsx",{get GarbageSection(){return Txe},set GarbageSection(e){Txe=e}});var Ixe=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.patientCount,o=e.patientCapacity,a=BC(t,n,r);return(0,z.jsxs)(qE,{tooltip:a&&(0,z.jsx)(Fv,{text:a}),children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.HEALTHCARE_PATIENTS,{})}),(0,z.jsxs)(zye,{progress:i,max:o,children:[i,"/",o]})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/healthcare-section.tsx",{get HealthcareSection(){return Ixe},set HealthcareSection(e){Ixe=e}});let wxe={"progress-bar":"progress-bar_H27 progress-bar_xWR",progressBar:"progress-bar_H27 progress-bar_xWR",progress:"progress_Yn6 progress_JAQ"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/level-section/level-progress-bar.module.scss",{get classes(){return wxe},set classes(e){Object.assign(wxe,e)}});const Pxe=wxe;let Cxe={bar:"bar_PEM","level-segment":"level-segment_Reo",levelSegment:"level-segment_Reo","construction-segment":"construction-segment_skQ",constructionSegment:"construction-segment_skQ",label:"label_qUU"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/level-section/level-section.module.scss",{get classes(){return Cxe},set classes(e){Object.assign(Cxe,e)}});const Nxe=Cxe;function Axe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Lxe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Mxe(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Lxe(e,t,n[t])}))}return e}function kxe(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}function Rxe(e){return function(e){if(Array.isArray(e))return Axe(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return Axe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Axe(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Dxe=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=kxe(e,["group","tooltipKeys","tooltipTags"]),o=BC(t,n,r,i.isUnderConstruction);return(0,z.jsx)(qE,{tooltip:o&&(0,z.jsx)(Fv,{text:o}),children:(0,z.jsx)(SS,{uppercase:!0,left:i.isUnderConstruction?(0,z.jsx)(qc.SelectedInfoPanel.UNDER_CONSTRUCTION,{}):(0,z.jsx)(qc.SelectedInfoPanel.LEVEL,{}),right:(0,z.jsx)(Fxe,Mxe({group:t,tooltipKeys:n,tooltipTags:r},i))})})},Fxe=function(e){var t=e.level,n=e.maxLevel,r=e.isUnderConstruction,i=e.progress,o=(0,Y.useMemo)((function(){return n-t}),[t,n]);return(0,z.jsxs)("div",{className:Nxe.bar,children:[(0,z.jsx)("div",{className:Nxe.label,children:r?(0,z.jsx)(bd,{value:i,max:100}):(0,z.jsx)(Pu,{value:t,total:n,unit:$c.Integer})}),r?(0,z.jsx)(Uxe,{progress:i,max:100,className:Nxe.constructionSegment}):(0,z.jsxs)(z.Fragment,{children:[Rxe(Array(t).keys()).map((function(e){return(0,z.jsx)(Uxe,{progress:100,className:Nxe.levelSegment},e)})),o>0&&(0,z.jsx)(Uxe,{progress:i,className:Nxe.levelSegment}),o>1&&Rxe(Array(o-1).keys()).map((function(e){return(0,z.jsx)(Uxe,{progress:0,className:Nxe.levelSegment},e)}))]})]})},Uxe=function(e){var t=e.progress,n=e.max,r=void 0===n?100:n,i=e.className;return(0,z.jsx)(qce,{progress:t,max:r,className:i,theme:Pxe})};function Gxe(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.sortingRate,o=e.sortingCapacity,a=e.localAmount,s=e.unsortedAmount,l=e.outgoingAmount,c=e.storedAmount,u=e.storageCapacity,d=e.localKey,f=e.unsortedKey,m=e.type,g=BC(t,r,n);return(0,z.jsxs)(qE,{tooltip:g&&(0,z.jsx)(Fv,{text:g}),children:[m===vC.PostFacility&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.MAIL_STORED_MAIL,{hash:d}),right:a}),o>0||l>0?(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.MAIL_STORED_MAIL,{hash:"Outgoing"}),right:l}):void 0,(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.MAIL_STORED_MAIL,{hash:f}),right:s}),o>0?(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.MAIL_SORTING_SPEED,{})}),(0,z.jsx)(zye,{progress:i,max:o,children:(0,z.jsx)(Pu,{value:i,total:o,unit:$c.IntegerPerMonth})})]}):void 0]}),u>0?(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.MAIL_STORED_MAIL,{hash:"Stored"})}),(0,z.jsxs)(zye,{progress:c,max:u,children:[c,"/",u]})]}):void 0]})}oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/level-section/level-section.tsx",{get LevelSection(){return Dxe},set LevelSection(e){Dxe=e}}),oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/mail-section.tsx",{get MailSection(){return Gxe},set MailSection(e){Gxe=e}});var Bxe=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.maintenance,o=BC(t,n,r);return(0,z.jsxs)(qE,{tooltip:o&&(0,z.jsx)(Fv,{text:o}),children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.PARK_MAINTENANCE,{})}),(0,z.jsx)(zye,{progress:i,max:100,invertColorCodes:!0,children:(0,z.jsx)(su,{value:i,unit:$c.Percentage})})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/park-section.tsx",{get ParkSection(){return Bxe},set ParkSection(e){Bxe=e}});var Vxe=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.parkedCars,o=e.parkingCapacity,a=BC(t,r,n);return(0,z.jsx)(qE,{tooltip:a&&(0,z.jsx)(Fv,{text:a}),children:o>0?(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.PARKING_PARKED,{})}),(0,z.jsx)(zye,{progress:i,max:o,children:(0,z.jsx)(Pu,{value:i,total:o,unit:$c.Integer})})]}):(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.PARKING_PARKED,{}),right:(0,z.jsx)(su,{value:i,unit:$c.Integer})})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/parking-section.tsx",{get ParkingSection(){return Vxe},set ParkingSection(e){Vxe=e}});var Hxe=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.prisonerCount,o=e.prisonerCapacity,a=BC(t,r,n);return(0,z.jsxs)(qE,{tooltip:a&&(0,z.jsx)(Fv,{text:a}),children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.POLICE_PRISONERS,{})}),(0,z.jsxs)(zye,{progress:i,max:o,children:[i,"/",o]})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/police-section.tsx",{get PoliceSection(){return Hxe},set PoliceSection(e){Hxe=e}});let Kxe={disabled:"disabled__qz",icon:"icon_rxa",indicator:"indicator_DKN",label:"label_Pzb",pollution:"pollution_USw"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/pollution-section/pollution-section.module.scss",{get classes(){return Kxe},set classes(e){Object.assign(Kxe,e)}});const Wxe=Kxe;var zxe=function(e){var t=e.groundPollutionKey,n=e.airPollutionKey,r=e.noisePollutionKey;return(0,z.jsx)(qE,{disableFocus:!0,children:(0,z.jsxs)(Ap,{children:[t!==pC.none&&(0,z.jsx)(SS,{uppercase:!0,tooltip:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:"PollutionSectionGround"})}),left:(0,z.jsx)(qc.SelectedInfoPanel.POLLUTION_LEVELS_GROUND,{}),right:(0,z.jsx)(Yxe,{pollutionKey:t,icon:"Media/Game/Icons/GroundPollution.svg"})}),n!==pC.none&&(0,z.jsx)(SS,{uppercase:!0,tooltip:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:"PollutionSectionAir"})}),left:(0,z.jsx)(qc.SelectedInfoPanel.POLLUTION_LEVELS_AIR,{}),right:(0,z.jsx)(Yxe,{pollutionKey:n,icon:"Media/Game/Icons/AirPollution.svg"})}),r!==pC.none&&(0,z.jsx)(SS,{uppercase:!0,tooltip:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:"PollutionSectionNoise"})}),left:(0,z.jsx)(qc.SelectedInfoPanel.POLLUTION_LEVELS_NOISE,{}),right:(0,z.jsx)(Yxe,{pollutionKey:r,icon:"Media/Game/Icons/NoisePollution.svg"})})]})})},Yxe=function(e){var t=e.pollutionKey,n=e.icon;return(0,z.jsxs)("div",{className:Wxe.indicator,children:[(0,z.jsx)("div",{className:Wxe.label,children:(0,z.jsx)(qc.SelectedInfoPanel.POLLUTION_LEVELS,{index:t})}),(0,z.jsx)("img",{src:n,className:_d()(Wxe.icon,$xe(0,t))}),(0,z.jsx)("img",{src:n,className:_d()(Wxe.icon,$xe(1,t))}),(0,z.jsx)("img",{src:n,className:_d()(Wxe.icon,$xe(2,t))})]})};function $xe(e,t){switch(t){case pC.none:return Wxe.disabled;case pC.low:return e>0?Wxe.disabled:void 0;case pC.medium:return e>1?Wxe.disabled:void 0;default:return}}oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/pollution-section/pollution-section.tsx",{get PollutionSection(){return zxe},set PollutionSection(e){zxe=e}});var qxe=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.prisonerCount,o=e.prisonerCapacity,a=BC(t,r,n);return(0,z.jsxs)(qE,{tooltip:a&&(0,z.jsx)(Fv,{text:a}),children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.PRISON_PRISONERS,{})}),(0,z.jsxs)(zye,{progress:i,max:o,children:[i,"/",o]})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/prison-section.tsx",{get PrisonSection(){return qxe},set PrisonSection(e){qxe=e}});var Xxe=function(e){var t=e.isHousehold,n=e.householdCount,r=e.maxHouseholds,i=e.residentCount,o=e.petCount,a=e.wealthKey,s=e.residence,l=e.residenceEntity,c=e.residenceKey,u=e.educationData,d=e.ageData,f=(0,Y.useCallback)((function(){return l&&LC(l)}),[l]);return(0,z.jsxs)(z.Fragment,{children:[null!=s&&(0,z.jsx)(qE,{tooltip:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:"ResidentsSectionResidence"})}),children:(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_RESIDENCE,{hash:c}),link:(0,z.jsx)(mxe,{onSelect:f,children:(0,z.jsx)(gd,{value:s})})})}),r>1&&(0,z.jsx)(qE,{tooltip:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:"ResidentsSectionHouseholds"})}),children:(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.HOUSEHOLDS,{}),right:(0,z.jsx)(Pu,{value:n,total:r,unit:$c.Integer})})}),(0,z.jsxs)(qE,{tooltip:(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:t?"ResidentsSectionHouseholdMembers":"ResidentsSectionResidents"})}),(0,z.jsx)(XE,{}),(0,z.jsx)(Q7,{colors:q9,labels:X9,data:d}),(0,z.jsx)(NOe,{}),(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:"ResidentsSectionAge"})}),(0,z.jsx)(XE,{}),(0,z.jsx)(Q7,{colors:B7,labels:V7,data:u}),(0,z.jsx)(NOe,{}),(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:"ResidentsSectionEducation"})})]}),children:[(0,z.jsx)(SS,{disableFocus:!0,uppercase:!0,left:t?(0,z.jsx)(qc.SelectedInfoPanel.HOUSEHOLD_MEMBERS,{}):(0,z.jsx)(qc.SelectedInfoPanel.RESIDENTS,{}),right:i}),o>0&&(0,z.jsx)(SS,{disableFocus:!0,subRow:!0,icon:"Media/Game/Icons/Pet.svg",left:(0,z.jsx)(su,{value:o})})]}),(t||1===r&&n>0||r>1&&n>0)&&(0,z.jsx)(qE,{tooltip:r>1?(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:"ResidentsSectionAverageHouseholdWealth"})}):(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:"ResidentsSectionHouseholdWealth"})}),children:(0,z.jsx)(SS,{uppercase:!0,left:r>1?(0,z.jsx)(qc.SelectedInfoPanel.AVERAGE_HOUSEHOLD_WEALTH,{}):(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_WEALTH_TITLE,{}),right:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_WEALTH,{hash:a})})})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/residents-section.tsx",{get ResidentsSection(){return Xxe},set ResidentsSection(e){Xxe=e}});var Qxe=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.capacity,o=e.lastProcessed,a=e.purification,s=BC(t,n,r),l=o>0&&i>0?of(100*o/i,1,100):0;return(0,z.jsxs)(qE,{tooltip:s&&(0,z.jsx)(Fv,{text:s}),children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.SEWAGE_PROCESSING_CAPACITY,{}),right:(0,z.jsx)(su,{value:i,unit:$c.VolumePerMonth})}),(0,z.jsx)(SS,{disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.SEWAGE_OUTLET_USAGE,{}),right:(0,z.jsx)(su,{value:l,unit:$c.Percentage})}),a>0&&(0,z.jsx)(SS,{disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.SEWAGE_PURIFICATION_RATE,{}),right:(0,z.jsx)(su,{value:100*a,unit:$c.Percentage})})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/sewage-section.tsx",{get SewageSection(){return Qxe},set SewageSection(e){Qxe=e}});var Zxe=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.sheltered,o=e.shelterCapacity,a=BC(t,r,n);return(0,z.jsxs)(qE,{tooltip:a&&(0,z.jsx)(Fv,{text:a}),children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.SHELTER_OCCUPANTS,{})}),(0,z.jsxs)(zye,{progress:i,max:o,children:[i,"/",o]})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/shelter-section.tsx",{get ShelterSection(){return Zxe},set ShelterSection(e){Zxe=e}});var Jxe=function(e){var t=e.children,n=e.className;return(0,z.jsx)("div",{className:_d()($E.infoWrapBox,n),children:t})};oe.add("game-ui/game/components/selected-info-panel/shared-components/info-section/info-wrap-box.tsx",{get InfoWrapBox(){return Jxe},set InfoWrapBox(e){Jxe=e}});let e_e={field:"field_lUX",header:"header_WRn",icon:"icon__9P",label:"label_vVZ",content:"content_n5J",last:"last_uXj"};oe.add("game-ui/game/components/selected-info-panel/shared-components/resource-item/resource-item.module.scss",{get classes(){return e_e},set classes(e){Object.assign(e_e,e)}});const t_e=e_e;var n_e=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.stored,o=e.capacity,a=e.resources,s=BC(t,r,n),l=null==a?void 0:a.filter((function(e){return"NoResource"!==e.key&&e.amount>0}));return(0,z.jsxs)(qE,{tooltip:s&&(0,z.jsx)(Fv,{text:s}),children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.WAREHOUSE_STORAGE,{})}),(0,z.jsx)(zye,{plain:!0,progress:i,max:o,children:(0,z.jsx)(Pu,{value:i,total:o,unit:$c.Weight})}),l.length>0&&(0,z.jsx)(Jxe,{children:null==l?void 0:l.map((function(e,t){return(0,z.jsx)(Dre,{theme:t_e,className:_d()(l.length>1&&l.length%2==1&&t===l.length-1&&t_e.last),icon:"Media/Game/Resources/".concat(e.key,".svg"),label:(0,z.jsx)(qc.Resources.TITLE,{hash:e.key}),children:(0,z.jsx)(su,{value:e.amount,unit:$c.Weight})},e.key)}))})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/storage-section.tsx",{get StorageSection(){return n_e},set StorageSection(e){n_e=e}});var r_e=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.capacity,o=e.flow,a=BC(t,n,r),s=Math.abs(o)>0&&i>0?of(100*Math.abs(o)/i,1,100):0;return(0,z.jsxs)(qE,{tooltip:a&&(0,z.jsx)(Fv,{text:a}),children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.ELECTRICITY_TRANSFORMER_CAPACITY,{}),right:(0,z.jsx)(su,{value:i,unit:$c.Power})}),(0,z.jsx)(SS,{left:(0,z.jsx)(qc.SelectedInfoPanel.ELECTRICITY_POWER_USAGE,{}),right:(0,z.jsx)(su,{value:s,unit:$c.Percentage})})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/transformer-section.tsx",{get TransformerSection(){return r_e},set TransformerSection(e){r_e=e}});var i_e=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.upkeeps,o=e.total,a=e.inactive,s=BC(t,r,n);return(0,z.jsx)(qE,{tooltip:(0,z.jsxs)(z.Fragment,{children:[i.map((function(e,t){return(0,z.jsx)(o_e,{upkeep:e,inactive:a},t)})),(0,z.jsx)(XE,{}),s&&(0,z.jsx)(Fv,{text:s})]}),children:(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.UPKEEP,{}),right:(0,z.jsx)(su,{value:o,unit:$c.MoneyPerMonth})})})},o_e=function(e){var t=e.upkeep,n=e.inactive;return(0,z.jsx)(TS,{left:a_e(t,n),right:(0,z.jsx)(su,{value:t.price,unit:$c.Money})})};function a_e(e,t){return"Money"===e.localeKey?t?(0,z.jsx)(qc.SelectedInfoPanel.UPKEEP_MAINTENANCE_INACTIVE,{BUILDING:(0,z.jsx)(kc,{id:e.prefabNameID})}):(0,z.jsx)(qc.SelectedInfoPanel.UPKEEP_MAINTENANCE,{BUILDING:(0,z.jsx)(kc,{id:e.prefabNameID})}):(0,z.jsx)(qc.SelectedInfoPanel.UPKEEPFORMAT,{RESOURCE:(0,z.jsx)(qc.Resources.TITLE,{hash:e.localeKey}),AMOUNT:(0,z.jsx)(su,{value:e.amount,unit:s_e(e.localeKey)})})}function s_e(e){switch(e){case"Money":return $c.Money;case"Telecom":case"Financial":case"Media":case"Entertainment":case"Recreation":return $c.Integer;default:return $c.Weight}}oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/upkeep-section.tsx",{get UpkeepSection(){return i_e},set UpkeepSection(e){i_e=e}});var l_e=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.capacity,o=e.lastProduction,a=e.pollution,s=BC(t,r,n),l=o>0&&i>0?of(100*o/i,1,100):0;return(0,z.jsxs)(qE,{tooltip:s&&(0,z.jsx)(Fv,{text:s}),children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.WATER_OUTPUT,{}),right:(0,z.jsx)(su,{value:i,unit:$c.VolumePerMonth})}),(0,z.jsx)(SS,{disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.WATER_PUMP_USAGE,{}),right:(0,z.jsx)(su,{value:l,unit:$c.Percentage})}),(0,z.jsx)(SS,{disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.WATER_PUMP_POLLUTION,{}),right:(0,z.jsx)(bd,{value:a,max:1})})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/building-sections/water-section.tsx",{get WaterSection(){return l_e},set WaterSection(e){l_e=e}});var c_e=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.typeKey,o=e.owner,a=e.ownerEntity,s=e.destination,l=e.destinationEntity,c=(0,Y.useCallback)((function(){return a&&LC(a)}),[a]),u=(0,Y.useCallback)((function(){return l&&LC(l)}),[l]),d=BC(t,n,r,!0);return(0,z.jsx)(qE,{disableFocus:!0,tooltip:d&&(0,z.jsx)(Fv,{text:d}),children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.ANIMAL_TYPE,{hash:i})}),null!=o&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.OWNED_BY,{}),link:(0,z.jsx)(mxe,{onSelect:c,children:(0,z.jsx)(gd,{value:o})})}),null!=s&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DESTINATION,{}),link:(0,z.jsx)(mxe,{onSelect:u,children:(0,z.jsx)(gd,{value:s})})})]})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/citizen-sections/animal-section.tsx",{get AnimalSection(){return c_e},set AnimalSection(e){c_e=e}});var u_e=function(e){var t=e.citizenKey,n=e.stateKey,r=e.household,i=e.householdEntity,o=e.residence,a=e.residenceEntity,s=e.residenceKey,l=e.workplace,c=e.workplaceEntity,u=e.workplaceKey,d=e.schoolLevel,f=e.tooltipTags,m=e.school,g=e.schoolEntity,h=e.destination,p=e.destinationEntity,v=e.educationKey,b=e.ageKey,y=e.wealthKey,x=e.occupationKey,_=e.jobLevelKey,j=(0,Y.useCallback)((function(){return i&&LC(i)}),[i]),O=(0,Y.useCallback)((function(){return a&&LC(a)}),[a]),E=(0,Y.useCallback)((function(){return c&&LC(c)}),[c]),S=(0,Y.useCallback)((function(){return g&&LC(g)}),[g]),T=(0,Y.useCallback)((function(){return p&&LC(p)}),[p]),I=GC(["CitizenSectionOccupation","Unknown"!==_?"CitizenSectionJobTitle":null]),w=f.includes("Male");return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsxs)(qE,{disableFocus:null!=m,tooltip:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:"CitizenSection"+t})}),children:[(0,z.jsx)(SS,{uppercase:!0,left:w?(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_TYPE_MALE,{hash:t}):(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_TYPE_FEMALE,{hash:t}),right:w?(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_STATE_MALE,{hash:n}):(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_STATE_FEMALE,{hash:n})}),(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_AGE_TITLE,{}),right:w?(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_AGE_MALE,{hash:b}):(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_AGE_FEMALE,{hash:b})}),(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_EDUCATION_TITLE,{}),right:w?(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_EDUCATION_MALE,{hash:v}):(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_EDUCATION_FEMALE,{hash:v})}),null!=m&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_SCHOOL_TITLE,{index:d}),link:(0,z.jsx)(mxe,{onSelect:S,children:(0,z.jsx)(gd,{value:m})})})]}),(0,z.jsx)(qE,{disableFocus:!0,tooltip:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:"CitizenSectionHousehold"+t})}),children:(0,z.jsxs)(Ap,{direction:gp.Vertical,children:[null!=r&&(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_HOUSEHOLD,{}),link:(0,z.jsx)(mxe,{onSelect:j,children:(0,z.jsx)(gd,{value:r})})}),(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_WEALTH_TITLE,{}),right:w?(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_WEALTH_MALE,{hash:y}):(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_WEALTH_FEMALE,{hash:y})}),null!=o&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_RESIDENCE,{hash:s}),link:(0,z.jsx)(mxe,{onSelect:O,children:(0,z.jsx)(gd,{value:o})})})]})}),"Tourist"!==x&&(0,z.jsxs)(qE,{disableFocus:null!=l,tooltip:null!=I&&(0,z.jsx)(Fv,{children:I}),children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_OCCUPATION_TITLE,{}),right:w?(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_OCCUPATION_MALE,{hash:x}):(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_OCCUPATION_FEMALE,{hash:x})}),"Unknown"!==_&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_JOB_TITLE,{}),right:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_JOB_LEVEL,{hash:_})}),null!=l&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_WORKPLACE,{hash:u}),link:(0,z.jsx)(mxe,{onSelect:E,children:(0,z.jsx)(gd,{value:l})})})]}),null!=h&&(0,z.jsx)(qE,{disableFocus:!0,tooltip:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:"CitizenSectionDestination"})}),children:(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DESTINATION,{}),link:(0,z.jsx)(mxe,{onSelect:T,children:(0,z.jsx)(gd,{value:h})})})})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/citizen-sections/citizen-section.tsx",{get CitizenSection(){return u_e},set CitizenSection(e){u_e=e}});var d_e=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.origin,o=e.originEntity,a=e.destination,s=e.destinationEntity,l=(0,Y.useCallback)((function(){return o&&LC(o)}),[o]),c=(0,Y.useCallback)((function(){return s&&LC(s)}),[s]),u=BC(t,n,r,!0);return(0,z.jsx)(qE,{disableFocus:!0,tooltip:u&&(0,z.jsx)(Fv,{text:u}),children:(0,z.jsxs)(Ap,{children:[null!=i&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.ORIGIN,{}),link:(0,z.jsx)(mxe,{onSelect:l,children:(0,z.jsx)(gd,{value:i})})}),null!=a&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DESTINATION,{}),link:(0,z.jsx)(mxe,{onSelect:c,children:(0,z.jsx)(gd,{value:a})})})]})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/citizen-sections/dummy-human-section.tsx",{get DummyHumanSection(){return d_e},set DummyHumanSection(e){d_e=e}});let f_e={notification:"notification_CLy item-focused_FuT","full-width":"full-width_Qk1",fullWidth:"full-width_Qk1",icon:"icon_UMr",label:"label_RLF",badge:"badge_ooc","badge-icon":"badge-icon_ubF",badgeIcon:"badge-icon_ubF"};oe.add("game-ui/game/components/selected-info-panel/shared-components/notification/notification.module.scss",{get classes(){return f_e},set classes(e){Object.assign(f_e,e)}});const m_e=f_e;var g_e=function(e){var t=e.notification;return(0,z.jsx)(jh,{direction:"right",tooltip:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.Notifications.DESCRIPTION,{hash:t.key})}),children:(0,z.jsxs)(Yv,{className:_d()(m_e.notification,m_e.fullWidth),children:[(0,z.jsx)("img",{src:t.iconPath,className:m_e.icon}),(0,z.jsxs)("div",{className:m_e.label,children:[(0,z.jsx)(qc.Notifications.TITLE,{hash:t.key}),t.count>1&&(0,z.jsx)(y_e,{className:m_e.badge,children:(0,z.jsx)(su,{value:t.count})})]})]})})},h_e=function(e){var t=e.notification,n=e.tooltipTags,r=null==n?void 0:n.includes("Male");return(0,z.jsx)(z.Fragment,{children:(0,z.jsx)(jh,{tooltip:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_HAPPINESS_DESCRIPTION,{hash:t.key})}),children:(0,z.jsxs)(Yv,{className:m_e.notification,children:[(0,z.jsx)("img",{src:t.iconPath,className:m_e.icon}),(0,z.jsx)("div",{className:m_e.label,children:r?(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_HAPPINESS_TITLE_MALE,{hash:t.key}):(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_HAPPINESS_TITLE_FEMALE,{hash:t.key})})]})})})},p_e=function(e){var t=e.notification;return(0,z.jsxs)(Yv,{className:m_e.notification,children:[(0,z.jsx)("img",{src:t.iconPath,className:m_e.icon}),(0,z.jsx)("div",{className:m_e.label,children:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_HAPPINESS_TITLE,{hash:t.key})})]})},v_e=function(e){var t=e.notification;return(0,z.jsxs)(Yv,{className:m_e.notification,children:[(0,z.jsx)("img",{src:t.iconPath,className:m_e.icon}),(0,z.jsx)("div",{className:m_e.label,children:(0,z.jsx)(qc.SelectedInfoPanel.COMPANY_PROFITABILITY_TITLE,{hash:t.key})})]})},b_e=function(e){var t=e.notification,n=e.tooltipTags,r=null==n?void 0:n.includes("Male");return(0,z.jsx)(z.Fragment,{children:(0,z.jsx)(jh,{tooltip:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_CONDITION_DESCRIPTION,{hash:t.key})}),children:(0,z.jsxs)(Yv,{className:m_e.notification,children:[(0,z.jsx)("img",{src:t.iconPath,className:m_e.icon}),(0,z.jsx)("div",{className:m_e.label,children:r?(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_CONDITION_TITLE_MALE,{hash:t.key}):(0,z.jsx)(qc.SelectedInfoPanel.CITIZEN_CONDITION_TITLE_FEMALE,{hash:t.key})})]})})})},y_e=function(e){var t=e.className,n=e.children;return(0,z.jsxs)("div",{className:_d()(m_e.badge,t),children:[n,(0,z.jsx)(tb,{src:"Media/Game/Icons/Citizen.svg",className:m_e.badgeIcon})]})};oe.add("game-ui/game/components/selected-info-panel/shared-components/notification/notification.tsx",{get Notification(){return g_e},set Notification(e){g_e=e},get HappinessNotification(){return h_e},set HappinessNotification(e){h_e=e},get AverageHappinessNotification(){return p_e},set AverageHappinessNotification(e){p_e=e},get ProfitabilityNotification(){return v_e},set ProfitabilityNotification(e){v_e=e},get ConditionNotification(){return b_e},set ConditionNotification(e){b_e=e},get NotificationBadge(){return y_e},set NotificationBadge(e){y_e=e}});let x_e={"status-section":"status-section_J1G notifications-section_cKq",statusSection:"status-section_J1G notifications-section_cKq",row:"row_Azp",bottom:"bottom_Xm5"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/citizen-sections/status-section.module.scss",{get classes(){return x_e},set classes(e){Object.assign(x_e,e)}});const __e=x_e;var j_e=function(e){var t=e.conditions,n=e.notifications,r=e.happiness,i=e.focusKey,o=e.tooltipTags;return(0,z.jsx)(Yv,{focusKey:i,className:__e.statusSection,children:(0,z.jsxs)(Ap,{children:[(0,z.jsxs)("div",{className:_d()(__e.row,__e.top),children:[r&&(0,z.jsx)(h_e,{notification:r,tooltipTags:o}),(null==t?void 0:t.length)>0&&(null==t?void 0:t.map((function(e){return(0,z.jsx)(b_e,{notification:e,tooltipTags:o},e.key)})))]}),(null==n?void 0:n.length)>0&&(null==n?void 0:n.map((function(e,t){return(0,z.jsx)("div",{className:_d()(__e.row,__e.bottom),children:(0,z.jsx)(g_e,{notification:e,tooltipTags:o})},t)})))]})})};function O_e(e){bl("ColorSection","setColor",ud(e,"Game.UI.Common.UIColor"))}oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/citizen-sections/status-section.tsx",{get StatusSection(){return j_e},set StatusSection(e){j_e=e}}),oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/color-section/color-section-bindings.ts",{get setColor(){return O_e},set setColor(e){O_e=e}});var E_e=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.color,o=BC(t,r,n);return(0,z.jsx)(qE,{disableFocus:!0,tooltip:o&&(0,z.jsx)(Fv,{text:o}),children:(0,z.jsx)(SS,{uppercase:!0,disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.COLOR,{}),right:(0,z.jsx)(v4,{value:i,onChange:O_e})})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/color-section/color-section.tsx",{get ColorSection(){return E_e},set ColorSection(e){E_e=e}});let S_e={detail:"detail_dEX item-focused_FuT",color:"color_YMp",toggle:"toggle_MTW",button:"button_UgX item-mouse-states_Fmi item-focused_FuT",row:"row_aZw","focusable-toggle":"focusable-toggle_EKK",focusableToggle:"focusable-toggle_EKK","space-between":"space-between_r5l",spaceBetween:"space-between_r5l",icon:"icon_BuO icon_hE2"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/lines-section/lines-section.module.scss",{get classes(){return S_e},set classes(e){Object.assign(S_e,e)}});const T_e=S_e;var I_e=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.hasLines,o=e.lines,a=e.hasPassengers,s=e.passengers,l=BC(t,r,n,!0),c=Pg();return(0,z.jsxs)(z.Fragment,{children:[a&&(0,z.jsx)(qE,{tooltip:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:"LinesSectionWaitingPassengers"})}),children:(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.WAITING_PASSENGERS,{}),right:(0,z.jsx)(su,{value:s,unit:$c.Integer})})}),i&&(0,z.jsxs)(qE,{disableFocus:!0,tooltip:l&&(0,z.jsx)(Fv,{text:l}),children:[(0,z.jsx)(SS,{uppercase:!0,disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.LINES,{}),right:o.length}),(0,z.jsx)(Yv,{children:(0,z.jsx)(Ap,{children:o&&o.length>0&&o.map((function(e,t){return(0,z.jsx)(w_e,{line:e},t)}))})}),c&&(0,z.jsx)(sxe,{label:(0,z.jsx)(qc.Transport.LINES_OVERVIEW_BUTTON,{}),onSelect:tj})]})]})},w_e=function(e){var t=e.line,n=xl(AC),r=(0,Y.useMemo)((function(){return Qs(t.entity,n)}),[t.entity,n]),i=(0,Y.useCallback)((function(){return LC(t.entity)}),[t.entity]),o=(0,Y.useCallback)((function(){return MC(t.entity)}),[t.entity]),a=(0,Y.useMemo)((function(){return{Select:i,"Select Route":o}}),[i,o]),s=Pg();return(0,z.jsx)(zv,{className:_d()(T_e.detail,T_e.row,T_e.spaceBetween),children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)(rp,{actions:a,children:(0,z.jsxs)(Yv,{className:_d()(T_e.focusableToggle,T_e.row),children:[(0,z.jsx)(D1,{focusKey:Hh,className:T_e.toggle,onChange:o,checked:r,style:{borderColor:rP(t.color)}}),(0,z.jsx)(gd,{value:t.name})]})}),!s&&(0,z.jsxs)(Qp,{onSelect:i,onClick:iv,className:T_e.button,children:[(0,z.jsx)("img",{src:"Media/Glyphs/ViewInfo.svg",className:T_e.icon}),(0,z.jsx)(qc.SelectedInfoPanel.DETAILS,{})]})]})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/lines-section/lines-section.tsx",{get LinesSection(){return I_e},set LinesSection(e){I_e=e},get LineItem(){return w_e},set LineItem(e){w_e=e}});var P_e=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.localServiceBuildings,o=BC(t,r,n);return(0,z.jsxs)(qE,{disableFocus:i.length>0,tooltip:o&&(0,z.jsx)(Fv,{text:o}),children:[(0,z.jsx)(SS,{uppercase:!0,disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.LOCAL_SERVICES_TITLE,{}),right:i.length}),i.length>0?(0,z.jsx)(Ap,{children:i.map((function(e,t){return(0,z.jsx)(C_e,{building:e},t)}))}):(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.LOCAL_SERVICES_NONE_ASSIGNED,{})})]})},C_e=function(e){var t,n=e.building,r=(0,Y.useCallback)((function(){return LC(n.entity)}),[n]);return(0,z.jsx)(SS,{subRow:!0,icon:null!==(t=n.serviceIcon)&&void 0!==t?t:void 0,left:(0,z.jsx)(gd,{value:n.name}),link:(0,z.jsx)(mxe,{onSelect:r,children:(0,z.jsx)(qc.SelectedInfoPanel.DETAILS,{})})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/local-services-section/local-services-section.tsx",{get LocalServicesSection(){return P_e},set LocalServicesSection(e){P_e=e}});var N_e=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.destroyer,o=BC(t,n,r);return(0,z.jsxs)(qE,{tooltip:o&&(0,z.jsx)(Fv,{text:o}),children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DESTROYED_TREE,{})}),null!=i&&(0,z.jsx)(nxe,{children:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.DESTROYED_TREE_DESCRIPTION,{hash:i})})})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/object-sections/destroyed-tree-section.tsx",{get DestroyedTreeSection(){return N_e},set DestroyedTreeSection(e){N_e=e}});var A_e=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.resourceAmount,o=e.resourceKey,a=BC(t,n,r);return(0,z.jsx)(qE,{tooltip:a&&(0,z.jsx)(Fv,{text:a}),children:(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.RESOURCE,{hash:o}),right:i})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/resource-section.tsx",{get ResourceSection(){return A_e},set ResourceSection(e){A_e=e}});let L_e={"border-highlight":"border-highlight_ze2",borderHighlight:"border-highlight_ze2"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/road-section/road-section.module.scss",{get classes(){return L_e},set classes(e){Object.assign(L_e,e)}});const M_e=L_e;var k_e=function(e){var t=e.volumeData,n=e.flowData,r=e.length,i=e.bestCondition,o=e.worstCondition,a=e.condition,s=e.upkeep,l=UC("RoadSectionLength"),c=UC("RoadSectionCondition"),u=UC("RoadSectionUpkeep"),d=UC("RoadSectionFlow"),f=UC("RoadSectionVolume");return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(qE,{tooltip:u&&(0,z.jsx)(Fv,{text:u}),children:(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.ROAD_UPKEEP,{}),right:(0,z.jsx)(su,{value:s,unit:$c.MoneyPerMonth})})}),(0,z.jsx)(qE,{tooltip:l&&(0,z.jsx)(Fv,{text:l}),children:(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.ROAD_LENGTH,{}),right:(0,z.jsx)(su,{value:r,unit:$c.Length})})}),(0,z.jsx)(qE,{tooltip:c&&(0,z.jsx)(Fv,{text:c}),children:(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.ROAD_CONDITION,{}),right:i===a||o===i||a===i?(0,z.jsx)(su,{value:i,unit:$c.Percentage}):(0,z.jsx)(qc.SelectedInfoPanel.ROAD_CONDITION_FORMAT,{WORST:(0,z.jsx)(su,{value:o,unit:$c.Percentage}),BEST:(0,z.jsx)(su,{value:i,unit:$c.Percentage}),AVG:(0,z.jsx)(su,{value:a,unit:$c.Percentage})})})}),(0,z.jsx)(qE,{disableFocus:!0,tooltip:d&&(0,z.jsx)(Fv,{text:d}),children:(0,z.jsxs)(Yv,{className:M_e.borderHighlight,children:[(0,z.jsx)(SS,{uppercase:!0,disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.ROAD_TRAFFIC_FLOW,{})}),(0,z.jsx)(iee,{data:n})]})}),(0,z.jsx)(qE,{disableFocus:!0,tooltip:f&&(0,z.jsx)(Fv,{text:f}),children:(0,z.jsxs)(Yv,{className:M_e.borderHighlight,children:[(0,z.jsx)(SS,{uppercase:!0,disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.ROAD_TRAFFIC_VOLUME,{})}),(0,z.jsx)(ree,{data:t})]})})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/road-section/road-section.tsx",{get RoadSection(){return k_e},set RoadSection(e){k_e=e}});var R_e=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.stops,o=e.length,a=e.usage,s=e.cargo,l=Pg(),c=BC(t,n,r,!0),u=xl(NC).includes("CargoRoute");return(0,z.jsx)(z.Fragment,{children:(0,z.jsxs)(qE,{disableFocus:!0,tooltip:c&&(0,z.jsx)(Fv,{text:c}),children:[(0,z.jsx)(SS,{uppercase:!0,disableFocus:!0,left:u?(0,z.jsx)(qc.SelectedInfoPanel.CARGO_TRANSPORT_ROUTE,{}):(0,z.jsx)(qc.SelectedInfoPanel.PUBLIC_TRANSPORT_LINE,{})}),(0,z.jsx)(SS,{subRow:!0,disableFocus:!0,right:(0,z.jsx)(su,{value:o,unit:$c.Length}),left:(0,z.jsx)(qc.SelectedInfoPanel.LINE_VISUALIZER_LENGTH,{})}),(0,z.jsx)(SS,{subRow:!0,disableFocus:!0,right:(0,z.jsx)(su,{value:i,unit:$c.Integer}),left:(0,z.jsx)(qc.SelectedInfoPanel.LINE_VISUALIZER_STOPS,{})}),(0,z.jsx)(SS,{subRow:!0,disableFocus:!0,right:(0,z.jsx)(su,{value:s,unit:u?$c.Weight:$c.Integer}),left:u?(0,z.jsx)(qc.Transport.LEGEND_CARGO,{}):(0,z.jsx)(qc.SelectedInfoPanel.PASSENGERS_TITLE,{})}),(0,z.jsx)(SS,{subRow:!0,disableFocus:!0,right:(0,z.jsx)(su,{value:100*a,unit:$c.Percentage}),left:(0,z.jsx)(qc.SelectedInfoPanel.LINE_USAGE,{})}),l&&(0,z.jsx)(sxe,{label:(0,z.jsx)(qc.Transport.LINES_OVERVIEW_BUTTON,{}),onSelect:tj})]})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/route-sections/line-section.tsx",{get LineSection(){return R_e},set LineSection(e){R_e=e}});let D_e={button:"button_YEx item-states_QjV","toggle-states":"toggle-states_oKG",toggleStates:"toggle-states_oKG",icon:"icon_vbQ",locked:"locked_Q0p"};oe.add("game-ui/game/themes/primary-button.module.scss",{get classes(){return D_e},set classes(e){Object.assign(D_e,e)}});const F_e=D_e;function U_e(e){bl("ScheduleSection","setSchedule",e)}oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/route-sections/schedule-section/schedule-bindings.ts",{get setSchedule(){return U_e},set setSchedule(e){U_e=e}});let G_e={buttons:"buttons_XOL",button:"button_kxx",left:"left_X6Y",right:"right_IAC",icon:"icon_Sz0"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/route-sections/schedule-section/schedule-section.module.scss",{get classes(){return G_e},set classes(e){Object.assign(G_e,e)}});const B_e=G_e;var V_e=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.schedule,o=(0,Y.useCallback)((function(){return U_e(0)}),[]),a=(0,Y.useCallback)((function(){return U_e(1)}),[]),s=(0,Y.useCallback)((function(){return U_e(2)}),[]),l=BC(t,r,n,!0),c=xl(NC),u=(0,Y.useMemo)((function(){return c.includes("CargoRoute")?"CargoRoute":"TransportLine"}),[c]);return(0,z.jsx)(qE,{disableFocus:!0,tooltip:l&&(0,z.jsx)(Fv,{text:l}),children:(0,z.jsx)(SS,{uppercase:!0,disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.SCHEDULE,{}),right:(0,z.jsx)("div",{className:B_e.buttons,children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.SelectedInfoPanel.SCHEDULE_DAY_TOOLTIP,{hash:u}),children:(0,z.jsx)(Qp,{theme:F_e,onSelect:o,selected:0===i,className:_d()(B_e.button,B_e.left),children:(0,z.jsx)("img",{src:Ave(0),className:B_e.icon})})}),(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.SelectedInfoPanel.SCHEDULE_NIGHT_TOOLTIP,{hash:u}),children:(0,z.jsx)(Qp,{theme:F_e,onSelect:a,selected:1===i,className:B_e.button,children:(0,z.jsx)("img",{src:Ave(1),className:B_e.icon})})}),(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.SelectedInfoPanel.SCHEDULE_CONTINUOUS_TOOLTIP,{hash:u}),children:(0,z.jsx)(Qp,{theme:F_e,onSelect:s,selected:2===i,className:_d()(B_e.button,B_e.right),children:(0,z.jsx)("img",{src:Ave(2),className:B_e.icon})})})]})})})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/route-sections/schedule-section/schedule-section.tsx",{get ScheduleSection(){return V_e},set ScheduleSection(e){V_e=e}});let H_e={"route-slider":"route-slider__kp",routeSlider:"route-slider__kp"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/route-sections/route-slider.module.scss",{get classes(){return H_e},set classes(e){Object.assign(H_e,e)}});const K_e=H_e;function W_e(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function z_e(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return W_e(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return W_e(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Y_e(e){bl("TicketPriceSection","setTicketPrice",e)}var $_e=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.sliderData,o=z_e((0,Y.useState)(i.value),2),a=o[0],s=o[1],l=Pg(),c=(0,Y.useCallback)((function(e){s(e),l&&Y_e(e)}),[l]),u=(0,Y.useCallback)((function(){Y_e(a)}),[a]),d=lF(i.step),f=BC(t,n,r);return(0,z.jsxs)(qE,{tooltip:f&&(0,z.jsx)(Fv,{text:f}),children:[(0,z.jsx)(SS,{uppercase:!0,disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.TICKET_PRICE,{}),right:0===a?(0,z.jsx)(qc.SelectedInfoPanel.TICKET_PRICE_FREE,{}):(0,z.jsx)(su,{value:a,unit:$c.Money})}),(0,z.jsx)("div",{className:K_e.routeSlider,children:(0,z.jsx)(oF,{valueTransformer:d,value:a,start:0,end:i.range.max,gamepadStep:i.step,onDragEnd:u,onChange:c})})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/route-sections/ticket-price-section.tsx",{get TicketPriceSection(){return $_e},set TicketPriceSection(e){$_e=e}});var q_e=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.vehicleCount,o=e.activeVehicles,a=e.vehicleCounts,s=BC(t,n,r,!0),l=(0,Y.useCallback)((function(e){bl("VehicleCountSection","setVehicleCount",a[e].x)}),[a]),c=lF(1),u=(0,Y.useMemo)((function(){return a.length>0?a[a.length-1].y:1}),[a]);return(0,z.jsxs)(qE,{tooltip:s&&(0,z.jsx)(Fv,{text:s}),children:[(0,z.jsx)(SS,{uppercase:!0,disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.VEHICLE_COUNT,{}),right:(0,z.jsx)(Pu,{value:i,total:u,unit:$c.Integer})}),(0,z.jsx)("div",{className:K_e.routeSlider,children:(0,z.jsx)(oF,{valueTransformer:c,value:a.findIndex((function(e){return e.y===i})),start:0,end:a.length-1,gamepadStep:1,onChange:l})}),(0,z.jsx)(SS,{subRow:!0,disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.ACTIVE_VEHICLES,{}),right:(0,z.jsx)(su,{value:o})})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/route-sections/vehicle-count-section.tsx",{get VehicleCountSection(){return q_e},set VehicleCountSection(e){q_e=e}});var X_e="ActionsSection",Q_e=(fl(X_e,"moveableObjectName"),fl(X_e,"moving")),Z_e=fl(X_e,"editingLot"),J_e=pl(X_e,"focus"),eje=pl(X_e,"toggleMove"),tje=pl(X_e,"follow"),nje=pl(X_e,"delete"),rje=pl(X_e,"toggle"),ije=pl(X_e,"toggleEmptying"),oje=pl(X_e,"toggleLotTool");oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/shared-sections/actions-section/actions-section-bindings.ts",{get moveableObjectName(){return moveableObjectName},set moveableObjectName(e){moveableObjectName=e},get moving(){return moving},set moving(e){moving=e},get editingLot(){return editingLot},set editingLot(e){editingLot=e},get focusSelectedEntity(){return J_e},set focusSelectedEntity(e){J_e=e},get toggleMove(){return eje},set toggleMove(e){eje=e},get followSelectedEntity(){return tje},set followSelectedEntity(e){tje=e},get deleteSelectedEntity(){return nje},set deleteSelectedEntity(e){nje=e},get toggleSelectedEntity(){return rje},set toggleSelectedEntity(e){rje=e},get toggleEmptying(){return ije},set toggleEmptying(e){ije=e},get toggleLotTool(){return oje},set toggleLotTool(e){oje=e}});let aje={button:"button_Z9O button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT",icon:"icon_Tdt icon_soN icon_Iwk"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/shared-sections/actions-section/action-button.module.scss",{get classes(){return aje},set classes(e){Object.assign(aje,e)}});const sje=aje;let lje={"actions-section":"actions-section_X1x",actionsSection:"actions-section_X1x",button:"button_xGY",toggle:"toggle_LKL",off:"off_X4Y","out-of-service":"out-of-service_Kfh",outOfService:"out-of-service_Kfh",label:"label_y4N"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/shared-sections/actions-section/actions-section.module.scss",{get classes(){return lje},set classes(e){Object.assign(lje,e)}});const cje=lje;var uje=new Wh("FOCUS_BUTTON"),dje=function(e){var t=e.focusing,n=e.following,r=e.followable,i=e.moveable,o=e.deletable,a=e.disabled,s=e.disableable,l=e.emptying,c=e.emptiable,u=e.hasLotTool,d=e.focusKey,f=xl(Q_e),m=xl(Z_e),g=(0,Y.useContext)(dO),h=xl(AI),p=xl(kI),v=xl(NC),b=xl(_C),y=(0,Y.useMemo)((function(){var e;return"".concat(null===(e=Ew.value)||void 0===e?void 0:e.selectedInfoPanelDelete,"+").concat(b)}),[b]);oh(y,o);var x=(0,Y.useCallback)((function(){g.showDialog((0,z.jsx)(OO,{title:(0,z.jsx)(qc.Common.WARNING,{}),message:(0,z.jsx)(qc.SelectedInfoPanel.CONFIRM_DELETE_WARNING,{}),onConfirm:nje}))}),[g]),_=(0,Y.useCallback)((function(){oje()}),[]),j=(0,Y.useMemo)((function(){return v.includes("Destroyed")}),[v]),O=(0,Y.useCallback)((function(){return tje()}),[]);return(0,z.jsx)("div",{className:cje.actionsSection,children:(0,z.jsxs)(Ap,{focusKey:d,initialFocused:uje,children:[(0,z.jsx)(e8,{title:t?(0,z.jsx)(qc.SelectedInfoPanel.UNFOCUS,{}):(0,z.jsx)(qc.SelectedInfoPanel.FOCUS,{}),description:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:t?"ActionsSectionUnfocus":"ActionsSectionFocus"}),children:(0,z.jsx)(lb,{focusKey:uje,theme:sje,className:cje.button,selected:t,src:"Media/Game/Icons/MapMarker.svg",onSelect:J_e,onClick:iv})}),i&&(0,z.jsx)(e8,{title:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP_TITLE,{hash:"ActionsSectionRelocate"}),description:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:"ActionsSectionRelocate"}),children:(0,z.jsx)(lb,{theme:sje,className:cje.button,selected:f,disabled:j,src:"Media/Game/Icons/Relocate.svg",selectSound:Lp.relocateBuilding,onSelect:eje,onClick:iv})}),r&&(0,z.jsx)(e8,{title:n?(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP_TITLE,{hash:"ActionsSectionUnfollowCitizen"}):h.length===p?(0,z.jsx)(qc.SelectedInfoPanel.MAX_FOLLOWED_CITIZENS_REACHED,{}):(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP_TITLE,{hash:"ActionsSectionFollowCitizen"}),description:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:n?"ActionsSectionUnfollowCitizen":"ActionsSectionFollowCitizen"}),children:(0,z.jsx)(lb,{disabled:!n&&h.length===p,theme:sje,selected:n,className:cje.button,src:n?"Media/Game/Icons/Unfollow.svg":"Media/Game/Icons/Follow.svg",onSelect:O,onClick:iv})}),c&&(0,z.jsx)(e8,{title:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP_TITLE,{hash:l?"ActionsSectionStopEmptying":"ActionsSectionStartEmptying"}),description:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:l?"ActionsSectionStopEmptying":"ActionsSectionStartEmptying"}),children:(0,z.jsx)(lb,{selected:l,disabled:j,theme:sje,className:cje.button,onSelect:ije,onClick:iv,src:"Media/Game/Icons/Empty.svg"})}),u&&(0,z.jsx)(e8,{title:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP_TITLE,{hash:"ActionsSectionAreaTool"}),description:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:"ActionsSectionAreaTool"}),children:(0,z.jsx)(lb,{selected:m,disabled:j,theme:sje,className:cje.button,onSelect:_,onClick:iv,src:"Media/Game/Icons/LotTool.svg"})}),o&&(0,z.jsx)(e8,{title:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP_TITLE,{hash:"ActionsSectionDelete"}),description:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:"ActionsSectionDelete"}),children:(0,z.jsx)(tk,{uiTag:y,children:(0,z.jsx)(lb,{tinted:!0,theme:sje,className:cje.button,src:"Media/Glyphs/Trash.svg",onSelect:x,onClick:iv})})}),s&&(0,z.jsxs)("div",{className:cje.outOfService,children:[a&&(0,z.jsx)("div",{className:cje.label,children:(0,z.jsx)(qc.SelectedInfoPanel.OUT_OF_SERVICE,{})}),(0,z.jsx)(e8,{title:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP_TITLE,{hash:a?"Reactivate":"Deactivate"}),description:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:fje(a,v)}),children:(0,z.jsx)(lb,{tinted:!0,src:"Media/Glyphs/OnOff.svg",theme:sje,disabled:j,className:_d()(cje.button,cje.toggle,a&&cje.off),selectSound:a?Lp.enableBuilding:Lp.disableBuilding,onSelect:rje,onClick:iv})})]})]})})};function fje(e,t){return t.includes("TransportLine")?t.includes("CargoRoute")?e?"ReactivateCargoRoute":"DeactivateCargoRoute":e?"ReactivatePublicTransportLine":"DeactivatePublicTransportLine":e?"Reactivate":"Deactivate"}oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/shared-sections/actions-section/actions-section.tsx",{get ActionsSection(){return dje},set ActionsSection(e){dje=e}});let mje={"description-section":"description-section_wKs",descriptionSection:"description-section_wKs",description:"description_jgm","effects-row":"effects-row_FPw",effectsRow:"effects-row_FPw"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/shared-sections/description-section/description-section.module.scss",{get classes(){return mje},set classes(e){Object.assign(mje,e)}});const gje=mje;var hje=function(e){var t=e.localeKey,n=e.effects;return(0,z.jsxs)(qE,{focusKey:Hh,className:gje.descriptionSection,children:[(0,z.jsx)("div",{className:gje.description,children:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.Assets.DESCRIPTION,{hash:t})})}),n&&(0,z.jsx)("div",{className:gje.effectsRow,children:(0,z.jsx)(vD,{components:Nae,data:n})})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/shared-sections/description-section/description-section.tsx",{get DescriptionSection(){return hje},set DescriptionSection(e){hje=e}});let pje={"notifications-section":"notifications-section_cKq",notificationsSection:"notifications-section_cKq",factors:"factors_Y7i"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/shared-sections/notification-sections/notifications-section.module.scss",{get classes(){return pje},set classes(e){Object.assign(pje,e)}});const vje=pje;var bje=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.averageHappiness,o=e.happinessFactors,a=BC(t,r,n,!0);return(0,z.jsx)(jh,{direction:"right",tooltip:(0,z.jsxs)(z.Fragment,{children:[o.length>0&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)("div",{className:vje.factors,children:o.map((function(e,t){return(0,z.jsx)(TS,{left:e.weight>0?(0,z.jsx)(qc.Common.HAPPINESS_FACTOR_POSITIVE,{hash:e.factor}):(0,z.jsx)(qc.Common.HAPPINESS_FACTOR_NEGATIVE,{hash:e.factor}),right:(0,z.jsx)("div",{className:uR(c9,e.weight),children:(0,z.jsx)(su,{value:e.weight,signed:!0})})},t)}))}),(0,z.jsx)(XE,{})]}),a&&(0,z.jsx)(Fv,{text:a})]}),children:(0,z.jsx)(zv,{className:vje.notificationsSection,children:(0,z.jsx)(p_e,{notification:i})})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/shared-sections/notification-sections/average-happiness-section.tsx",{get AverageHappinessSection(){return bje},set AverageHappinessSection(e){bje=e}});var yje=function(e){var t=e.focusKey,n=e.notifications;return(0,z.jsx)(Yv,{focusKey:t,className:vje.notificationsSection,children:n.length>0&&(0,z.jsx)(Ap,{children:null==n?void 0:n.map((function(e){return(0,z.jsx)(g_e,{notification:e},e.key)}))})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/shared-sections/notification-sections/notifications-section.tsx",{get NotificationsSection(){return yje},set NotificationsSection(e){yje=e}});var xje=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.profitability,o=e.profitabilityFactors,a=BC(t,r,n,!0);return(0,z.jsx)(jh,{direction:"right",tooltip:(0,z.jsxs)(z.Fragment,{children:[o.length>0&&(0,z.jsx)(z.Fragment,{children:(0,z.jsx)("div",{className:vje.factors,children:o.map((function(e,t){return(0,z.jsx)(TS,{left:e.weight>0?(0,z.jsx)(qc.Common.HAPPINESS_FACTOR_POSITIVE,{hash:e.factor}):(0,z.jsx)(qc.Common.HAPPINESS_FACTOR_NEGATIVE,{hash:e.factor}),right:(0,z.jsx)("div",{className:uR(c9,e.weight),children:(0,z.jsx)(su,{value:e.weight,signed:!0})})},t)}))})}),(0,z.jsx)(XE,{}),a&&(0,z.jsx)(Fv,{text:a})]}),children:(0,z.jsx)(zv,{className:vje.notificationsSection,children:(0,z.jsx)(v_e,{notification:i})})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/shared-sections/notification-sections/profitability-section.tsx",{get ProfitabilitySection(){return xje},set ProfitabilitySection(e){xje=e}});let _je={policy:"policy_oHN item-focused_FuT","pad-first":"pad-first_WSR",padFirst:"pad-first_WSR",lock:"lock_uXt",compact:"compact_QL9",top:"top_LI4 item-mouse-states_Fmi",expanded:"expanded_g0B","active-disabled":"active-disabled_HoS",activeDisabled:"active-disabled_HoS",locked:"locked_ihM",bottom:"bottom_qDc",disabled:"disabled_NSK",icon:"icon_BTB",label:"label_obe","slider-wrapper":"slider-wrapper_Sx6",sliderWrapper:"slider-wrapper_Sx6",slider:"slider_jk5",value:"value_vMh",checkbox:"checkbox_OrD","space-between":"space-between_mx0",spaceBetween:"space-between_mx0"};oe.add("game-ui/game/components/policy/policy.module.scss",{get classes(){return _je},set classes(e){Object.assign(_je,e)}});const jje=_je;function Oje(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Eje(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Oje(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Oje(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Sje=function(e){var t,n,r=e.policy,i=e.className,o=e.onAdjust,a=Eje((0,Y.useState)(r.active),2),s=a[0],l=a[1],c=Eje((0,Y.useState)(null!==(n=null===(t=r.data)||void 0===t?void 0:t.value)&&void 0!==n?n:0),2),u=c[0],d=c[1],f=Eje((0,Y.useState)(!1),2),m=f[0],g=f[1],h=Pg();(0,Y.useEffect)((function(){var e,t,n=null!==(t=null===(e=r.data)||void 0===e?void 0:e.value)&&void 0!==t?t:0;m||u===n||d(n)}),[r,m,u]);var p=(0,Y.useCallback)((function(){o(r.entity,!s,u),l(!s)}),[s,o,r,u]),v=(0,Y.useCallback)((function(){g(!0)}),[]),b=(0,Y.useCallback)((function(e){d(e),h&&o(r.entity,s,e)}),[s,h,o,r]),y=(0,Y.useCallback)((function(){o(r.entity,s,u),g(!1)}),[s,o,r,u]),x=(0,Y.useCallback)((function(){p(),kp(Lp.selectItem)}),[p]),_=!r.locked&&r.active&&r.data&&u;return(0,z.jsx)(tk,{uiTag:r.uiTag,children:(0,z.jsx)(B9,{title:(0,z.jsx)(qc.Policy.TITLE,{hash:r.id}),description:(0,z.jsx)(qc.Policy.DESCRIPTION,{hash:r.id}),locked:r.locked,direction:"right",requirements:r.requirements,children:(0,z.jsx)(Yv,{className:_d()(jje.policy,i),children:(0,z.jsxs)(ip,{onAction:x,children:[(0,z.jsx)(Ije,{focusKey:_?Hh:Kh,policy:r,active:s,onToggle:p,className:_d()(jje.top,_&&jje.expanded)}),_&&r.data&&u&&(0,z.jsxs)("div",{className:jje.bottom,children:[(0,z.jsx)("div",{className:jje.sliderWrapper,children:(0,z.jsx)(oF,{value:u,start:r.data.range.min,end:r.data.range.max,gamepadStep:r.data.step,onDragStart:v,onDragEnd:y,onChange:b,disabled:!r.active,className:jje.slider})}),(0,z.jsx)("div",{className:jje.value,children:(0,z.jsx)(su,{value:u,unit:r.data.unit})})]})]})})})})},Tje=function(e){var t,n=e.policy,r=e.onAdjust,i=e.onMouseOver,o=e.onMouseLeave,a=Eje((0,Y.useState)(n.active),2),s=a[0],l=a[1],c=(0,Y.useCallback)((function(){var e,t;r(n.entity,!s,null!==(t=null===(e=n.data)||void 0===e?void 0:e.value)&&void 0!==t?t:0),l(!s)}),[s,r,n.entity,null===(t=n.data)||void 0===t?void 0:t.value]);return(0,z.jsx)(tk,{uiTag:n.uiTag,children:(0,z.jsx)(B9,{title:(0,z.jsx)(qc.Policy.TITLE,{hash:n.id}),description:(0,z.jsx)(qc.Policy.DESCRIPTION,{hash:n.id}),locked:n.locked,direction:"down",alignment:"end",requirements:n.requirements,children:(0,z.jsx)(Ije,{compact:!0,onMouseOver:i,onMouseLeave:o,className:jje.compact,focusKey:Hh,policy:n,active:s,onToggle:c})})})},Ije=function(e){var t=e.focusKey,n=e.policy,r=e.active,i=e.compact,o=void 0!==i&&i,a=e.className,s=e.onToggle,l=e.onMouseOver,c=e.onMouseLeave,u=Eje((0,Y.useState)(!1),2),d=u[0],f=u[1],m=(0,Y.useCallback)((function(){return f(!0)}),[]),g=(0,Y.useCallback)((function(){return f(!1)}),[]);return(0,z.jsxs)(Qp,{focusKey:t,onSelect:s,onClick:iv,onMouseOver:l,onMouseLeave:c,selectSound:Lp.togglePolicy,disabled:n.locked,className:_d()(n.locked&&jje.locked,d&&jje.activeDisabled,a),children:[(0,z.jsx)("img",{src:n.icon,className:_d()(jje.icon,!n.locked&&!n.active&&jje.disabled)}),n.locked&&(0,z.jsx)(_1,{className:jje.lock}),!o&&(0,z.jsxs)("div",{className:jje.spaceBetween,children:[(0,z.jsx)("div",{className:jje.label,children:(0,z.jsx)(qc.Policy.TITLE,{hash:n.id})}),!n.locked&&(0,z.jsx)(fv,{checked:r,focusKey:Hh,className:jje.checkbox,onMouseOver:m,onMouseLeave:g})]})]})};oe.add("game-ui/game/components/policy/policy.tsx",{get Policy(){return Sje},set Policy(e){Sje=e},get CompactPolicy(){return Tje},set CompactPolicy(e){Tje=e}});let wje={"compact-policies":"compact-policies_qEr",compactPolicies:"compact-policies_qEr",label:"label_wgk"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/shared-sections/policies-section/policies-section.module.scss",{get classes(){return wje},set classes(e){Object.assign(wje,e)}});const Pje=wje;function Cje(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Nje(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Cje(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Cje(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Aje=function(e){var t=e.policies,n=e.group,r=e.tooltipKeys,i=e.tooltipTags,o=Nje((0,Y.useState)((null==t?void 0:t.length)<3),2),a=o[0],s=o[1],l=Nje((0,Y.useState)(!1),2),c=l[0],u=l[1],d=(0,Y.useCallback)((function(){return u(!0)}),[]),f=(0,Y.useCallback)((function(){return u(!1)}),[]),m=BC(n,r,i,!0),g=xl(_C),h=(0,Y.useMemo)((function(){var e;return"".concat(null===(e=Ew.value)||void 0===e?void 0:e.selectedInfoPanelPolicies,"+").concat(g)}),[g]);return oh(h),(0,z.jsx)(tk,{uiTag:h,children:(0,z.jsx)(jS,{disableFocus:!0,initialExpanded:(null==t?void 0:t.length)<3,tooltip:a&&m&&(0,z.jsx)(Fv,{text:m}),className:c?_S.disableActiveState:void 0,expandFromContent:!0,onToggleExpanded:s,header:a?(0,z.jsx)(SS,{uppercase:!0,disableFocus:!0,className:Pje.label,left:(0,z.jsx)(qc.SelectedInfoPanel.POLICIES,{})}):(0,z.jsx)("div",{className:Pje.compactPolicies,children:null==t?void 0:t.map((function(e){return(0,z.jsx)(Tje,{policy:e,onAdjust:vw,onMouseOver:d,onMouseLeave:f},qs(e.entity))}))}),children:(0,z.jsx)(Ap,{children:null==t?void 0:t.map((function(e,t){return(0,z.jsx)(Sje,{policy:e,onAdjust:vw,className:0===t?jje.padFirst:void 0},qs(e.entity))}))})})})};function Lje(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.vehicleKey,o=e.vehicleCount,a=e.availableVehicleCount,s=e.vehicleCapacity,l=e.vehicleList,c=BC(t,r,n,!0);return s>0?(0,z.jsxs)(qE,{disableFocus:!0,children:[s-a>0&&(0,z.jsx)(SS,{uppercase:!0,tooltip:c&&(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:"VehiclesInMaintenance"})}),left:(0,z.jsx)(qc.SelectedInfoPanel.MAINTENANCED_VEHICLES,{}),right:(0,z.jsx)(su,{value:s-a})}),(0,z.jsx)(SS,{uppercase:!0,tooltip:c&&(0,z.jsx)(Fv,{text:c}),left:(0,z.jsx)(qc.SelectedInfoPanel.VEHICLES,{hash:i}),right:0===s?(0,z.jsx)(su,{value:o}):(0,z.jsx)(Pu,{value:o,total:s})}),l.length>0&&(0,z.jsx)(Ap,{children:l.map((function(e,t){return(0,z.jsx)(Mje,{vehicle:e},t)}))})]}):null}oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/shared-sections/policies-section/policies-section.tsx",{get PoliciesSection(){return Aje},set PoliciesSection(e){Aje=e}});var Mje=function(e){var t=e.vehicle,n=(0,Y.useCallback)((function(){return LC(t.entity)}),[t.entity]);return(0,z.jsx)(SS,{subRow:!0,tooltip:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.SelectedInfoPanel.TOOLTIP,{hash:t.vehicleKey})}),left:(0,z.jsx)(gd,{value:t.name}),link:(0,z.jsx)(mxe,{onSelect:n,children:(0,z.jsx)(qc.SelectedInfoPanel.VEHICLE_STATES,{hash:t.stateKey})})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/shared-sections/vehicles-section/vehicles-section.tsx",{get VehiclesSection(){return Lje},set VehiclesSection(e){Lje=e},get VehicleItem(){return Mje},set VehicleItem(e){Mje=e}});var kje=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.vehicleList,o=BC(t,r,n);return(0,z.jsxs)(qE,{disableFocus:!0,children:[(0,z.jsx)(SS,{uppercase:!0,tooltip:o&&(0,z.jsx)(Fv,{text:o}),left:(0,z.jsx)(qc.SelectedInfoPanel.DISPATCHED_VEHICLES,{}),right:(0,z.jsx)(su,{value:i.length})}),i.length>0&&(0,z.jsx)(Ap,{children:i.map((function(e,t){return(0,z.jsx)(Mje,{vehicle:e},t)}))})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/shared-sections/vehicles-section/dispatched-vehicles-section.tsx",{get DispatchedVehiclesSection(){return kje},set DispatchedVehiclesSection(e){kje=e}});var Rje=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.cargo,o=e.capacity,a=e.resources,s=e.cargoKey,l=BC(t,r,n),c=null==a?void 0:a.filter((function(e){return"NoResource"!==e.key&&e.amount>0}));return(0,z.jsxs)(qE,{tooltip:l&&(0,z.jsx)(Fv,{text:l}),children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.CARGO_TITLE,{hash:s})}),(0,z.jsx)(zye,{plain:!0,progress:i,max:o,children:(0,z.jsx)(Pu,{value:i,total:o,unit:$c.Weight})}),(null==c?void 0:c.length)>0&&(0,z.jsx)(Jxe,{children:null==c?void 0:c.map((function(e,t){return(0,z.jsx)(Dre,{theme:t_e,className:_d()(c.length>1&&c.length%2==1&&t===c.length-1&&t_e.last),icon:"NoResource"!==e.key?"Media/Game/Resources/".concat(e.key,".svg"):null,label:(0,z.jsx)(qc.Resources.TITLE,{hash:e.key}),children:(0,z.jsx)(su,{value:e.amount,unit:$c.Weight})},e.key)}))})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/vehicle-sections/cargo-section.tsx",{get CargoSection(){return Rje},set CargoSection(e){Rje=e}});var Dje=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.owner,o=e.fromOutside,a=e.line,s=e.lineEntity,l=e.nextStop,c=e.stateKey,u=(0,Y.useCallback)((function(){return i.entity&&LC(i.entity)}),[i]),d=(0,Y.useCallback)((function(){return s&&LC(s)}),[s]),f=(0,Y.useCallback)((function(){return l.entity&&LC(l.entity)}),[l]),m=BC(t,n,r);return(0,z.jsx)(qE,{tooltip:m&&(0,z.jsx)(Fv,{text:m}),disableFocus:null!=s||null!=l.entity||null!=i.entity,children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.CARGO_TRANSPORT_VEHICLE_TITLE,{}),right:(0,z.jsx)(qc.SelectedInfoPanel.VEHICLE_STATES,{hash:c})}),null!=i.entity&&(0,z.jsx)(SS,{subRow:!0,left:o?(0,z.jsx)(qc.SelectedInfoPanel.ORIGIN,{}):(0,z.jsx)(qc.SelectedInfoPanel.OWNED_BY,{}),link:(0,z.jsx)(mxe,{onSelect:u,children:(0,z.jsx)(gd,{value:i.name})})}),null!=l.entity&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DESTINATION,{}),link:(0,z.jsx)(mxe,{onSelect:f,children:(0,z.jsx)(gd,{value:l.name})})}),null!=a&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.ROUTE,{}),link:(0,z.jsx)(mxe,{onSelect:d,children:(0,z.jsx)(gd,{value:a})})})]})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/vehicle-sections/cargo-transport-vehicle-section.tsx",{get CargoTransportVehicleSection(){return Dje},set CargoTransportVehicleSection(e){Dje=e}});var Fje=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.owner,o=e.fromOutside,a=e.nextStop,s=e.dead,l=e.deadEntity,c=e.stateKey,u=(0,Y.useCallback)((function(){return i.entity&&LC(i.entity)}),[i]),d=(0,Y.useCallback)((function(){return l&&LC(l)}),[l]),f=(0,Y.useCallback)((function(){return a.entity&&LC(a.entity)}),[a]),m=BC(t,n,r);return(0,z.jsx)(qE,{tooltip:m&&(0,z.jsx)(Fv,{text:m}),disableFocus:null!=l||null!=a.entity||null!=i.entity,children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DEATHCARE_VEHICLE_TITLE,{}),right:(0,z.jsx)(qc.SelectedInfoPanel.VEHICLE_STATES,{hash:c})}),null!=i.entity&&(0,z.jsx)(SS,{subRow:!0,left:o?(0,z.jsx)(qc.SelectedInfoPanel.ORIGIN,{}):(0,z.jsx)(qc.SelectedInfoPanel.OWNED_BY,{}),link:(0,z.jsx)(mxe,{onSelect:u,children:(0,z.jsx)(gd,{value:i.name})})}),null!=a.entity&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DESTINATION,{}),link:(0,z.jsx)(mxe,{onSelect:f,children:(0,z.jsx)(gd,{value:a.name})})}),null!=s&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DEATHCARE_VEHICLE_DEAD,{}),link:(0,z.jsx)(mxe,{onSelect:d,children:(0,z.jsx)(gd,{value:s})})})]})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/vehicle-sections/deathcare-vehicle-section.tsx",{get DeathcareVehicleSection(){return Fje},set DeathcareVehicleSection(e){Fje=e}});var Uje=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.owner,o=e.fromOutside,a=e.nextStop,s=e.stateKey,l=e.vehicleKey,c=(0,Y.useCallback)((function(){return i.entity&&LC(i.entity)}),[i]),u=(0,Y.useCallback)((function(){return a.entity&&LC(a.entity)}),[a]),d=BC(t,n,r,!0);return(0,z.jsx)(qE,{tooltip:d&&(0,z.jsx)(Fv,{text:d}),disableFocus:!0,children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)(SS,{uppercase:!0,disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DELIVERY_VEHICLE_TITLE,{hash:l}),right:(0,z.jsx)(qc.SelectedInfoPanel.VEHICLE_STATES,{hash:s})}),null!=i.entity&&(0,z.jsx)(SS,{subRow:!0,disableFocus:!0,left:o?(0,z.jsx)(qc.SelectedInfoPanel.ORIGIN,{}):(0,z.jsx)(qc.SelectedInfoPanel.OWNED_BY,{}),link:(0,z.jsx)(mxe,{onSelect:c,children:(0,z.jsx)(gd,{value:i.name})})}),null!=a.entity&&(0,z.jsx)(SS,{subRow:!0,disableFocus:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DESTINATION,{}),link:(0,z.jsx)(mxe,{onSelect:u,children:(0,z.jsx)(gd,{value:a.name})})})]})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/vehicle-sections/delivery-vehicle-section.tsx",{get DeliveryVehicleSection(){return Uje},set DeliveryVehicleSection(e){Uje=e}});var Gje=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.owner,o=e.fromOutside,a=e.nextStop,s=e.stateKey,l=e.vehicleKey,c=(0,Y.useCallback)((function(){return i.entity&&LC(i.entity)}),[i]),u=(0,Y.useCallback)((function(){return a.entity&&LC(a.entity)}),[a]),d=BC(t,n,r,!0);return(0,z.jsx)(qE,{tooltip:d&&(0,z.jsx)(Fv,{text:d}),disableFocus:null!=a.entity||null!=i.entity,children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.FIRE_VEHICLE_TITLE,{hash:l}),right:(0,z.jsx)(qc.SelectedInfoPanel.VEHICLE_STATES,{hash:s})}),null!=i.entity&&(0,z.jsx)(SS,{subRow:!0,left:o?(0,z.jsx)(qc.SelectedInfoPanel.ORIGIN,{}):(0,z.jsx)(qc.SelectedInfoPanel.OWNED_BY,{}),link:(0,z.jsx)(mxe,{onSelect:c,children:(0,z.jsx)(gd,{value:i.name})})}),null!=a.entity&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DESTINATION,{}),link:(0,z.jsx)(mxe,{onSelect:u,children:(0,z.jsx)(gd,{value:a.name})})})]})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/vehicle-sections/fire-vehicle-section.tsx",{get FireVehicleSection(){return Gje},set FireVehicleSection(e){Gje=e}});var Bje=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.owner,o=e.fromOutside,a=e.nextStop,s=e.stateKey,l=e.vehicleKey,c=(0,Y.useCallback)((function(){return i.entity&&LC(i.entity)}),[i]),u=(0,Y.useCallback)((function(){return a.entity&&LC(a.entity)}),[a]),d=BC(t,n,r,!0);return(0,z.jsxs)(qE,{tooltip:d&&(0,z.jsx)(Fv,{text:d}),disableFocus:null!=a.entity||null!=i.entity,children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.GARBAGE_VEHICLE_TITLE,{hash:l}),right:(0,z.jsx)(qc.SelectedInfoPanel.VEHICLE_STATES,{hash:s})}),null!=i.entity&&(0,z.jsx)(SS,{subRow:!0,left:o?(0,z.jsx)(qc.SelectedInfoPanel.ORIGIN,{}):(0,z.jsx)(qc.SelectedInfoPanel.OWNED_BY,{}),link:(0,z.jsx)(mxe,{onSelect:c,children:(0,z.jsx)(gd,{value:i.name})})}),null!=a.entity&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DESTINATION,{}),link:(0,z.jsx)(mxe,{onSelect:u,children:(0,z.jsx)(gd,{value:a.name})})})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/vehicle-sections/garbage-vehicle-section.tsx",{get GarbageVehicleSection(){return Bje},set GarbageVehicleSection(e){Bje=e}});var Vje=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.owner,o=e.fromOutside,a=e.nextStop,s=e.patient,l=e.patientEntity,c=e.stateKey,u=e.vehicleKey,d=(0,Y.useCallback)((function(){return i.entity&&LC(i.entity)}),[i]),f=(0,Y.useCallback)((function(){return l&&LC(l)}),[l]),m=(0,Y.useCallback)((function(){return a.entity&&LC(a.entity)}),[a]),g=BC(t,n,r,!0);return(0,z.jsx)(qE,{tooltip:g&&(0,z.jsx)(Fv,{text:g}),disableFocus:null!=l||null!=a.entity||null!=i.entity,children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.HEALTHCARE_VEHICLE_TITLE,{hash:u}),right:(0,z.jsx)(qc.SelectedInfoPanel.VEHICLE_STATES,{hash:c})}),null!=i.entity&&(0,z.jsx)(SS,{subRow:!0,left:o?(0,z.jsx)(qc.SelectedInfoPanel.ORIGIN,{}):(0,z.jsx)(qc.SelectedInfoPanel.OWNED_BY,{}),link:(0,z.jsx)(mxe,{onSelect:d,children:(0,z.jsx)(gd,{value:i.name})})}),null!=a.entity&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DESTINATION,{}),link:(0,z.jsx)(mxe,{onSelect:m,children:(0,z.jsx)(gd,{value:a.name})})}),null!=s&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.HEALTHCARE_VEHICLE_PATIENT,{}),link:(0,z.jsx)(mxe,{onSelect:f,children:(0,z.jsx)(gd,{value:s})})})]})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/vehicle-sections/healthcare-vehicle-section.tsx",{get HealthcareVehicleSection(){return Vje},set HealthcareVehicleSection(e){Vje=e}});var Hje=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.load,o=e.capacity,a=e.loadKey,s=BC(t,n,r);return(0,z.jsxs)(qE,{tooltip:s&&(0,z.jsx)(Fv,{text:s}),children:[(0,z.jsx)(SS,{left:(0,z.jsx)(qc.SelectedInfoPanel.LOAD_TITLE,{hash:a})}),(0,z.jsx)(zye,{progress:i,max:o,plain:!0,children:(0,z.jsx)(Pu,{value:i,total:o,unit:Kje(a)})})]})};function Kje(e){return"Water"===e?$c.Volume:$c.Weight}oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/vehicle-sections/load-section.tsx",{get LoadSection(){return Hje},set LoadSection(e){Hje=e}});var Wje=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.workShift,o=e.owner,a=e.fromOutside,s=e.nextStop,l=e.stateKey,c=(0,Y.useCallback)((function(){return o.entity&&LC(o.entity)}),[o]),u=(0,Y.useCallback)((function(){return s.entity&&LC(s.entity)}),[s]),d=BC(t,n,r),f=UC("MaintenanceVehicleSectionWorkshift");return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsxs)(qE,{tooltip:d&&(0,z.jsx)(Fv,{text:d}),disableFocus:null!=s.entity||null!=o.entity,children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.MAINTENANCE_VEHICLE_TITLE,{}),right:(0,z.jsx)(qc.SelectedInfoPanel.VEHICLE_STATES,{hash:l})}),null!=o.entity&&(0,z.jsx)(SS,{subRow:!0,left:a?(0,z.jsx)(qc.SelectedInfoPanel.ORIGIN,{}):(0,z.jsx)(qc.SelectedInfoPanel.OWNED_BY,{}),link:(0,z.jsx)(mxe,{onSelect:c,children:(0,z.jsx)(gd,{value:o.name})})}),null!=s.entity&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DESTINATION,{}),link:(0,z.jsx)(mxe,{onSelect:u,children:(0,z.jsx)(gd,{value:s.name})})})]}),(0,z.jsxs)(qE,{tooltip:f&&(0,z.jsx)(Fv,{text:f}),children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.WORK_SHIFT,{})}),(0,z.jsx)(zye,{progress:i,max:100,plain:!0,children:(0,z.jsx)(su,{value:i,unit:$c.Percentage})})]})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/vehicle-sections/maintenance-vehicle-section.tsx",{get MaintenanceVehicleSection(){return Wje},set MaintenanceVehicleSection(e){Wje=e}});var zje=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.passengers,o=e.maxPassengers,a=e.pets,s=e.vehiclePassengerKey,l=BC(t,n,r);return(0,z.jsxs)(qE,{tooltip:l&&(0,z.jsx)(Fv,{text:l}),children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.PASSENGERS,{hash:s})}),(0,z.jsx)(zye,{progress:i,max:o,plain:!0,children:(0,z.jsx)(Pu,{value:i,total:o,unit:$c.Integer})}),a>0&&(0,z.jsx)(SS,{subRow:!0,icon:"Media/Game/Icons/Pet.svg",left:(0,z.jsx)(su,{value:a,unit:$c.Integer})})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/vehicle-sections/passengers-section.tsx",{get PassengersSection(){return zje},set PassengersSection(e){zje=e}});var Yje=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.owner,o=e.fromOutside,a=e.nextStop,s=e.criminal,l=e.criminalEntity,c=e.stateKey,u=e.vehicleKey,d=(0,Y.useCallback)((function(){return i.entity&&LC(i.entity)}),[i]),f=(0,Y.useCallback)((function(){return l&&LC(l)}),[l]),m=(0,Y.useCallback)((function(){return a.entity&&LC(a.entity)}),[a]),g=BC(t,n,r,!0);return(0,z.jsx)(qE,{tooltip:g&&(0,z.jsx)(Fv,{text:g}),disableFocus:null!=l||null!=a.entity||null!=i.entity,children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.POLICE_VEHICLE_TITLE,{hash:u}),right:(0,z.jsx)(qc.SelectedInfoPanel.VEHICLE_STATES,{hash:c})}),null!=i.entity&&(0,z.jsx)(SS,{subRow:!0,left:o?(0,z.jsx)(qc.SelectedInfoPanel.ORIGIN,{}):(0,z.jsx)(qc.SelectedInfoPanel.OWNED_BY,{}),link:(0,z.jsx)(mxe,{onSelect:d,children:(0,z.jsx)(gd,{value:i.name})})}),null!=a.entity&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DESTINATION,{}),link:(0,z.jsx)(mxe,{onSelect:m,children:(0,z.jsx)(gd,{value:a.name})})}),null!=s&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.POLICE_VEHICLE_CRIMINAL,{}),link:(0,z.jsx)(mxe,{onSelect:f,children:(0,z.jsx)(gd,{value:s})})})]})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/vehicle-sections/police-vehicle-section.tsx",{get PoliceVehicleSection(){return Yje},set PoliceVehicleSection(e){Yje=e}});var $je=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.owner,o=e.fromOutside,a=e.nextStop,s=e.stateKey,l=(0,Y.useCallback)((function(){return i.entity&&LC(i.entity)}),[i.entity]),c=(0,Y.useCallback)((function(){return a.entity&&LC(a.entity)}),[a]),u=BC(t,n,r);return(0,z.jsxs)(qE,{tooltip:u&&(0,z.jsx)(Fv,{text:u}),disableFocus:null!=i.entity,children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.POST_VEHICLE_TITLE,{}),right:(0,z.jsx)(qc.SelectedInfoPanel.VEHICLE_STATES,{hash:s})}),null!=i.entity&&(0,z.jsx)(SS,{subRow:!0,left:o?(0,z.jsx)(qc.SelectedInfoPanel.ORIGIN,{}):(0,z.jsx)(qc.SelectedInfoPanel.OWNED_BY,{}),link:(0,z.jsx)(mxe,{onSelect:l,children:(0,z.jsx)(gd,{value:i.name})})}),null!=a.entity&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DESTINATION,{}),link:(0,z.jsx)(mxe,{onSelect:c,children:(0,z.jsx)(gd,{value:a.name})})})]})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/vehicle-sections/post-vehicle-section.tsx",{get PostVehicleSection(){return $je},set PostVehicleSection(e){$je=e}});var qje=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.owner,o=e.fromOutside,a=e.keeper,s=e.keeperEntity,l=e.nextStop,c=e.stateKey,u=e.vehicleKey,d=(0,Y.useCallback)((function(){return i.entity&&LC(i.entity)}),[i]),f=(0,Y.useCallback)((function(){return s&&LC(s)}),[s]),m=(0,Y.useCallback)((function(){return l.entity&&LC(l.entity)}),[l]),g=BC(t,n,r,!0);return(0,z.jsx)(qE,{tooltip:g&&(0,z.jsx)(Fv,{text:g}),disableFocus:null!=a||null!=l.entity||null!=i.entity,children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.PRIVATE_VEHICLE_TITLE,{hash:u}),right:(0,z.jsx)(qc.SelectedInfoPanel.VEHICLE_STATES,{hash:c})}),null!=i.entity&&(0,z.jsx)(SS,{subRow:!0,left:o?(0,z.jsx)(qc.SelectedInfoPanel.ORIGIN,{}):(0,z.jsx)(qc.SelectedInfoPanel.OWNED_BY,{}),link:(0,z.jsx)(mxe,{onSelect:d,children:(0,z.jsx)(gd,{value:i.name})})}),null!=l.entity&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DESTINATION,{}),link:(0,z.jsx)(mxe,{onSelect:m,children:(0,z.jsx)(gd,{value:l.name})})}),null!=a&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DRIVER,{}),link:(0,z.jsx)(mxe,{onSelect:f,children:(0,z.jsx)(gd,{value:a})})})]})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/vehicle-sections/private-vehicle-section.tsx",{get PrivateVehicleSection(){return qje},set PrivateVehicleSection(e){qje=e}});var Xje,Qje=function(e){var t=e.group,n=e.tooltipKeys,r=e.tooltipTags,i=e.owner,o=e.fromOutside,a=e.line,s=e.lineEntity,l=e.nextStop,c=e.stateKey,u=e.vehicleKey,d=(0,Y.useCallback)((function(){return i.entity&&LC(i.entity)}),[i]),f=(0,Y.useCallback)((function(){return s&&LC(s)}),[s]),m=(0,Y.useCallback)((function(){return l.entity&&LC(l.entity)}),[l]),g=BC(t,n,r,!0);return(0,z.jsx)(qE,{tooltip:g&&(0,z.jsx)(Fv,{text:g}),disableFocus:null!=s||null!=l.entity||null!=i.entity,children:(0,z.jsxs)(Ap,{children:[(0,z.jsx)(SS,{uppercase:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.PUBLIC_TRANSPORT_VEHICLE_TITLE,{hash:u}),right:(0,z.jsx)(qc.SelectedInfoPanel.VEHICLE_STATES,{hash:c})}),null!=i.entity&&(0,z.jsx)(SS,{subRow:!0,left:o?(0,z.jsx)(qc.SelectedInfoPanel.ORIGIN,{}):(0,z.jsx)(qc.SelectedInfoPanel.OWNED_BY,{}),link:(0,z.jsx)(mxe,{onSelect:d,children:(0,z.jsx)(gd,{value:i.name})})}),null!=l.entity&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.DESTINATION,{}),link:(0,z.jsx)(mxe,{onSelect:m,children:(0,z.jsx)(gd,{value:l.name})})}),null!=a&&(0,z.jsx)(SS,{subRow:!0,left:(0,z.jsx)(qc.SelectedInfoPanel.LINE,{}),link:(0,z.jsx)(mxe,{onSelect:f,children:(0,z.jsx)(gd,{value:a})})})]})})};function Zje(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/vehicle-sections/public-transport-vehicle-section.tsx",{get PublicTransportVehicleSection(){return Qje},set PublicTransportVehicleSection(e){Qje=e}});var Jje=(Zje(Xje={},hC.Resource,A_e),Zje(Xje,hC.LocalServices,P_e),Zje(Xje,hC.Actions,dje),Zje(Xje,hC.Description,hje),Zje(Xje,hC.Developer,(function(){return null})),Zje(Xje,hC.Residents,Xxe),Zje(Xje,hC.HouseholdSidebar,(function(){return null})),Zje(Xje,hC.Districts,pxe),Zje(Xje,hC.Title,(function(){return null})),Zje(Xje,hC.Notifications,yje),Zje(Xje,hC.Policies,Aje),Zje(Xje,hC.Profitability,xje),Zje(Xje,hC.AverageHappiness,bje),Zje(Xje,hC.Schedule,V_e),Zje(Xje,hC.Line,R_e),Zje(Xje,hC.Lines,I_e),Zje(Xje,hC.Color,E_e),Zje(Xje,hC.LineVisualizer,(function(){return null})),Zje(Xje,hC.TicketPrice,$_e),Zje(Xje,hC.VehicleCount,q_e),Zje(Xje,hC.Attractiveness,Hye),Zje(Xje,hC.Efficiency,_xe),Zje(Xje,hC.Employees,Exe),Zje(Xje,hC.Upkeep,i_e),Zje(Xje,hC.Level,Dxe),Zje(Xje,hC.Education,bxe),Zje(Xje,hC.Pollution,zxe),Zje(Xje,hC.Healthcare,Ixe),Zje(Xje,hC.Deathcare,Jye),Zje(Xje,hC.Garbage,Txe),Zje(Xje,hC.Police,Hxe),Zje(Xje,hC.Vehicles,Lje),Zje(Xje,hC.DispatchedVehicles,kje),Zje(Xje,hC.Electricity,Oxe),Zje(Xje,hC.Transformer,r_e),Zje(Xje,hC.Battery,$ye),Zje(Xje,hC.Water,l_e),Zje(Xje,hC.Sewage,Qxe),Zje(Xje,hC.Fire,Sxe),Zje(Xje,hC.Prison,qxe),Zje(Xje,hC.Shelter,Zxe),Zje(Xje,hC.Parking,Vxe),Zje(Xje,hC.Park,Bxe),Zje(Xje,hC.Mail,Gxe),Zje(Xje,hC.Road,k_e),Zje(Xje,hC.Company,Zye),Zje(Xje,hC.Storage,n_e),Zje(Xje,hC.PrivateVehicle,qje),Zje(Xje,hC.PublicTransportVehicle,Qje),Zje(Xje,hC.CargoTransportVehicle,Dje),Zje(Xje,hC.DeliveryVehicle,Uje),Zje(Xje,hC.HealthcareVehicle,Vje),Zje(Xje,hC.FireVehicle,Gje),Zje(Xje,hC.PoliceVehicle,Yje),Zje(Xje,hC.MaintenanceVehicle,Wje),Zje(Xje,hC.DeathcareVehicle,Fje),Zje(Xje,hC.PostVehicle,$je),Zje(Xje,hC.GarbageVehicle,Bje),Zje(Xje,hC.Passengers,zje),Zje(Xje,hC.Cargo,Rje),Zje(Xje,hC.Load,Hje),Zje(Xje,hC.Status,j_e),Zje(Xje,hC.Citizen,u_e),Zje(Xje,hC.DummyHuman,d_e),Zje(Xje,hC.Animal,c_e),Zje(Xje,hC.SelectVehicles,CZ),Zje(Xje,hC.DestroyedBuilding,uxe),Zje(Xje,hC.DestroyedTree,N_e),Zje(Xje,hC.Comfort,qye),Xje);oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/selected-info-sections.tsx",{get selectedInfoSectionComponents(){return Jje},set selectedInfoSectionComponents(e){Jje=e}});let eOe={virtualListWidth:"46","household-sidebar-section":"household-sidebar-section_Pp8",householdSidebarSection:"household-sidebar-section_Pp8","gamepad-active":"gamepad-active_M6w",gamepadActive:"gamepad-active_M6w",content:"content_uZM","fixed-list":"fixed-list_leU",fixedList:"fixed-list_leU","virtual-list":"virtual-list_kom",virtualList:"virtual-list_kom",item:"item_Pjq button_eqb item-states_QjV",icon:"icon_cU0",household:"household_aFZ",divider:"divider_hD0",badge:"badge_PNB"};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/shared-sections/household-sidebar-section/household-sidebar-section.module.scss",{get classes(){return eOe},set classes(e){Object.assign(eOe,e)}});const tOe=eOe;function nOe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function rOe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||oOe(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function iOe(e){return function(e){if(Array.isArray(e))return nOe(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||oOe(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function oOe(e,t){if(e){if("string"==typeof e)return nOe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?nOe(e,t):void 0}}var aOe={length:0,visibleStartIndex:0,visibleItems:[]},sOe=function(e){var t=e.householdSidebarVariant,n=e.residence,r=e.households,i=e.householdMembers,o=e.householdPets,a=e.focusKey,s=e.className,l=Pg(),c=rOe((0,Y.useState)(aOe),2),u=c[0],d=c[1],f=(0,Y.useMemo)((function(){return t===RC.Building&&r.length>1?r:iOe(i).concat(iOe(o))}),[i,o,r,t]),m=(0,Y.useCallback)((function(e,t){for(var n=new Array(t-e),r=0;r<n.length;r++)n[r]=f[e+r];d({length:f.length,visibleStartIndex:e,visibleItems:n})}),[f]),g=(0,Y.useMemo)((function(){return function(e,t){return e===RC.Citizen||e===RC.Household||1===t.length}(t,r)}),[t,r]);return(0,z.jsx)(qj,{focusKey:a,className:_d()(tOe.householdSidebarSection,l&&tOe.gamepadActive,s),contentClassName:tOe.content,children:(0,z.jsxs)(Ap,{direction:gp.Vertical,children:[(0,z.jsxs)("div",{className:tOe.fixedList,children:[null!=n.entity&&(0,z.jsx)(cOe,{item:n}),g&&(0,z.jsx)(cOe,{item:r[0]})]}),(0,z.jsx)("div",{className:tOe.divider}),(0,z.jsx)(lOe,{data:u,handleRenderedRangeChange:m},f.length>0&&qs(f[0].entity)||void 0)]})})},lOe=function(e){var t=e.data,n=e.handleRenderedRangeChange,r=$O(),i=NQ(parseFloat(tOe.virtualListWidth)*r,t.length,2),o=(0,Y.useCallback)((function(e){var n=e-t.visibleStartIndex;return n>=0&&n<t.length?(0,z.jsx)(cOe,{item:t.visibleItems[n]},n):null}),[t.length,t.visibleItems,t.visibleStartIndex]);return(0,z.jsx)(wQ,{renderItem:o,onRenderedRangeChange:n,sizeProvider:i,className:tOe.virtualList})};var cOe=function(e){var t=e.item,n=hd(null==t?void 0:t.name),r=(0,Y.useCallback)((function(){!(null==t?void 0:t.selected)&&LC(null==t?void 0:t.entity)}),[t]);return(0,z.jsx)(jh,{direction:"right",tooltip:n,children:(0,z.jsxs)(Qp,{selected:null==t?void 0:t.selected,onSelect:r,className:_d()(tOe.item,(null==t?void 0:t.memberCount)&&tOe.household),children:[(0,z.jsx)(tb,{src:null==t?void 0:t.iconPath,className:tOe.icon}),(null==t?void 0:t.memberCount)&&(0,z.jsx)("div",{className:tOe.badge,children:null==t?void 0:t.memberCount})]})})};function uOe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function dOe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return uOe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return uOe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function fOe(e,t){var n=hd(e),r=dOe((0,Y.useState)(null),2),i=r[0],o=r[1],a=(0,Y.useCallback)((function(e){o(e.target.value)}),[o]),s=(0,Y.useCallback)((function(){null!=i&&i!==n&&t(i),o(null)}),[i,n,t]),l=(0,Y.useCallback)((function(){o(null)}),[]);return[null!=i?i:n,a,s,l]}function mOe(e){bl("TitleSection","renameEntity",e)}oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/shared-sections/household-sidebar-section/household-sidebar-section.tsx",{get HouseholdSidebarSection(){return sOe},set HouseholdSidebarSection(e){sOe=e}}),oe.add("game-ui/common/hooks/use-input-name.ts",{get useInputName(){return fOe},set useInputName(e){fOe=e}}),oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/shared-sections/title-section/title-section-bindings.ts",{get renameSelectedEntity(){return mOe},set renameSelectedEntity(e){mOe=e}});let gOe={input:"input_lbJ",label:"label_GFm",container:"container_Q9t"};oe.add("game-ui/game/components/selected-info-panel/shared-components/text-input/text-input.module.scss",{get classes(){return gOe},set classes(e){Object.assign(gOe,e)}});const hOe=gOe;function pOe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function vOe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return pOe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return pOe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var bOe=function(e){var t=e.group,n=e.tooltipTags,r=e.tooltipKeys,i=e.focusKey,o=e.name,a=e.vkLocaleKey,s=e.icon,l=vOe(fOe(o,mOe),3),c=l[0],u=l[1],d=l[2],f=BC(t,r,n),m=xl(_C),g=(0,Y.useMemo)((function(){var e;return"".concat(null===(e=Ew.value)||void 0===e?void 0:e.selectedInfoPanelTitle,"+").concat(m)}),[m]);return oh(g),(0,z.jsx)(tO,{icon:s||void 0,children:(0,z.jsx)(jh,{direction:"right",alignment:"start",tooltip:f&&(0,z.jsx)(Fv,{text:f}),children:(0,z.jsx)(tk,{uiTag:g,children:(0,z.jsx)(nre,{theme:hOe,focusKey:i,value:c,vkTitle:(0,z.jsx)(qc.VirtualKeyboard.TITLE,{hash:a}),onChange:u,onBlur:d})})})})};oe.add("game-ui/game/components/selected-info-panel/selected-info-sections/shared-sections/title-section/title-section.tsx",{get TitleSection(){return bOe},set TitleSection(e){bOe=e}});let yOe={"selected-info-panel":"selected-info-panel_gG8",selectedInfoPanel:"selected-info-panel_gG8","gamepad-active":"gamepad-active_TBU",gamepadActive:"gamepad-active_TBU",scrollable:"scrollable_gsV",space:"space_N1X",smallSpace:"smallSpace_Bas",row:"row_OqM","household-sidebar":"household-sidebar_v9l",householdSidebar:"household-sidebar_v9l"};oe.add("game-ui/game/components/selected-info-panel/selected-info-panel.module.scss",{get classes(){return yOe},set classes(e){Object.assign(yOe,e)}});const xOe=yOe;function _Oe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function jOe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function OOe(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){jOe(e,t,n[t])}))}return e}function EOe(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function SOe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return _Oe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _Oe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var TOe=new Wh("SelectedInfoPanel"),IOe=new Wh("LineVisualizer"),wOe=new Wh("HouseholdSidebar"),POe=function(e){var t=e.focusKey,n=e.className,r=e.onClose,i=Pg(),o=_l(EC,COe,new Array),a=_l(SC,COe,new Array),s=_l(TC,COe,new Array),l=xl(IC),c=xl(PC),u=xl(CC),d=null!=c||null!=u,f=s.some((function(e){return e.__Type===hC.Actions})),m=xl(Z_e),g=xl(cye),h=xl(Q_e),p=xl(AL),v=null!=c?IOe:wOe,b=SOe((0,Y.useState)(TOe),2),y=b[0],x=b[1],_=(0,Y.useMemo)((function(){return{Back:function(){m||g||h?sA(xA):Qs(p,ty)?r():kL()},"Move Horizontal":d?function(e){return x(e<0?v:TOe),!0}:void 0,"Focus Selected Object":f?J_e:null}}),[v,m,f,d,h,r,p,g]);(0,Y.useEffect)((function(){d||x(TOe)}),[d]);var j=xl(xC),O=xl(AC),E=(0,Y.useMemo)((function(){return null==u?void 0:u.residence.entity}),[null==u?void 0:u.residence.entity]),S=(0,Y.useMemo)((function(){var e;return null===(e=null==u?void 0:u.households[0])||void 0===e?void 0:e.entity}),[null==u?void 0:u.households]),T=(0,Y.useMemo)((function(){return Qs(O,ty)?Qs(E,j)||!S?"".concat(null==E?void 0:E.index).concat(j.version).concat(j.index).concat(null==E?void 0:E.version):S&&qs(S):"".concat(qs(j),"->SIP")}),[S,E,O,j]),I=xl(_C),w=!Qs(ty,j)&&""!==I,P=(0,Y.useMemo)((function(){var e;return"".concat(null===(e=Ew.value)||void 0===e?void 0:e.selectedInfoPanel,"+").concat(I)}),[I]);return oh(P,w),(0,z.jsx)(Yv,{focusKey:t,className:_d()(xOe.row,n),children:(0,z.jsx)(rp,{actions:_,children:(0,z.jsxs)(pj,{focused:y,children:[c&&(0,z.jsx)(Gye,OOe({focusKey:IOe},c),"".concat(qs(O),"->LV")),u&&(0,z.jsx)(sOe,EOe(OOe({focusKey:wOe},u),{className:xOe.householdSidebar}),E&&qs(E)),(0,z.jsx)(tk,{uiTag:P,active:w,children:(0,z.jsx)(qj,{focusKey:TOe,header:l&&(0,z.jsx)(bOe,OOe({},l)),footer:(0,z.jsx)(vD,{components:Jje,data:s}),transitionSounds:vj,className:_d()(xOe.selectedInfoPanel,i&&xOe.gamepadActive),onClose:r,children:(0,z.jsxs)(Ap,{direction:gp.Vertical,children:[(0,z.jsx)(vD,{components:Jje,data:o}),(0,z.jsx)(gE,{className:xOe.scrollable,children:(0,z.jsx)(vD,{components:Jje,data:a})})]})},1===(null==u?void 0:u.households.length)?S&&qs(S):T)})]})})})};function COe(e,t){return t.filter(fC)}var NOe=function(e){var t=e.small;return(0,z.jsx)("div",{className:_d()(t?xOe.smallSpace:xOe.space)})};function AOe(){var e=xl(qA),t=xl(xC),n=xl(VN),r=xl(Q_e),i=xl(cye),o=xl(LL),a=xl(Z_e);if(Qs(t,ty))return!1;if(!Qs(e,ty))return!1;switch(n.id){case xA:return!0;case IA:return i;case EA:return o||r;case jA:return a;case SA:return!0;default:return!1}}oe.add("game-ui/game/components/selected-info-panel/selected-info-panel.tsx",{get SelectedInfoPanel(){return POe},set SelectedInfoPanel(e){POe=e},get PanelSpace(){return NOe},set PanelSpace(e){NOe=e},get useSelectedInfoPanelVisible(){return AOe},set useSelectedInfoPanelVisible(e){AOe=e}});let LOe={"left-menu":"left-menu_L1D",leftMenu:"left-menu_L1D"};oe.add("game-ui/game/components/left-menu/left-menu.module.scss",{get classes(){return LOe},set classes(e){Object.assign(LOe,e)}});const MOe=LOe;var kOe=function(e){var t=e.className;return(0,z.jsx)("div",{className:_d()(MOe.leftMenu,t),children:(0,z.jsx)(H5,{name:"GameBottomLeft"})})};oe.add("game-ui/game/components/left-menu/left-menu.tsx",{get LeftMenu(){return kOe},set LeftMenu(e){kOe=e}});let ROe={"chirper-popup":"chirper-popup_pEX",chirperPopup:"chirper-popup_pEX",item:"item_Pf8",enter:"enter_is9","enter-active":"enter-active_pX6",enterActive:"enter-active_pX6","exit-active":"exit-active_Mg7",exitActive:"exit-active_Mg7","item-inner":"item-inner_Xwb",itemInner:"item-inner_Xwb","chirp-layout":"chirp-layout_xHZ",chirpLayout:"chirp-layout_xHZ"};oe.add("game-ui/game/components/chirper/chirper-popup.module.scss",{get classes(){return ROe},set classes(e){Object.assign(ROe,e)}});const DOe=ROe;function FOe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function UOe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||BOe(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function GOe(e){return function(e){if(Array.isArray(e))return FOe(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||BOe(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function BOe(e,t){if(e){if("string"==typeof e)return FOe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?FOe(e,t):void 0}}var VOe=function(e){var t=e.disabled,n=e.className,r=e.onClick,i=UOe((0,Y.useState)([]),2),o=i[0],a=i[1],s=UOe((0,Y.useState)(null),2),l=s[0],c=s[1],u=o.length>0;return(0,Y.useEffect)((function(){if(!t){var e=WS.subscribe((function(e){return a((function(t){return GOe(t).concat([e])}))})),n=0;if(u){var r=function(){a((function(e){return e.slice(1,e.length)})),n=window.setTimeout(r,7e3)};n=window.setTimeout(r,7e3)}return function(){e.dispose(),window.clearTimeout(n)}}a([])}),[t,u]),(0,Y.useEffect)((function(){Qs(null!==l?l.entity:ty,o.length>0?o[0].entity:ty)||(o.length>0?(c(o[0]),kp(Lp.chirpEvent)):c(null))}),[l,o]),(0,z.jsx)("div",{className:_d()(DOe.chirperPopup,n),children:(0,z.jsx)(Ud,{skipInitial:!1,children:l&&(0,z.jsx)(Cm,{styles:DOe,children:(0,z.jsx)("div",{className:DOe.item,onClick:r,children:(0,z.jsx)("div",{className:DOe.itemInner,children:(0,z.jsx)(Tse,{focusKey:Hh,chirp:l,className:DOe.chirpLayout})})})},qs(l.entity))})})};oe.add("game-ui/game/components/chirper/chirper-popup.tsx",{get ChirperPopup(){return VOe},set ChirperPopup(e){VOe=e}});let HOe={button:"button_iKo button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT","emergency-mode":"emergency-mode_MW7",emergencyMode:"emergency-mode_MW7","toggle-states":"toggle-states_Yz9 toggle-states_DTm",toggleStates:"toggle-states_Yz9 toggle-states_DTm",icon:"icon_qLJ icon_soN icon_Iwk"};oe.add("game-ui/game/components/right-menu/right-menu-button.module.scss",{get classes(){return HOe},set classes(e){Object.assign(HOe,e)}});const KOe=HOe;let WOe={"horizontal-scroller":"horizontal-scroller_lkP",horizontalScroller:"horizontal-scroller_lkP",space:"space_FBs",content:"content_LaN"};oe.add("game-ui/game/components/radio/horizontal-scroller/horizontal-scroller.module.scss",{get classes(){return WOe},set classes(e){Object.assign(WOe,e)}});const zOe=WOe;var YOe=function(e){var t=e.className,n=e.children,r=(0,Y.useRef)(null),i=$O();return(0,Y.useEffect)((function(){var e=performance.now(),t=0,n=function(o){if(r.current){var a=Math.max(r.current.scrollWidth,1);r.current.scrollLeft=.08*(o-e)*i%(a/2),t=window.requestAnimationFrame(n)}};return t=window.requestAnimationFrame(n),function(){return window.cancelAnimationFrame(t)}}),[i]),(0,z.jsxs)("div",{ref:r,className:_d()(zOe.horizontalScroller,t),children:[(0,z.jsx)("div",{className:zOe.space}),(0,z.jsx)("div",{className:zOe.content,children:n}),(0,z.jsx)("div",{className:zOe.space}),(0,z.jsx)("div",{className:zOe.content,children:n}),(0,z.jsx)("div",{className:zOe.space}),(0,z.jsx)("div",{className:zOe.content,children:n}),(0,z.jsx)("div",{className:zOe.space}),(0,z.jsx)("div",{className:zOe.content,children:n})]})};oe.add("game-ui/game/components/radio/horizontal-scroller/horizontal-scroller.tsx",{get HorizontalScroller(){return YOe},set HorizontalScroller(e){YOe=e}});let $Oe={"emergency-radio-player":"emergency-radio-player_v9P",emergencyRadioPlayer:"emergency-radio-player_v9P",expanded:"expanded_G9_","right-space":"right-space_TPn",rightSpace:"right-space_TPn",controls:"controls_mbB","volume-controls":"volume-controls_Pqk",volumeControls:"volume-controls_Pqk","volume-slider":"volume-slider_jT_",volumeSlider:"volume-slider_jT_","center-controls":"center-controls_rY1",centerControls:"center-controls_rY1","message-field":"message-field_Qua",messageField:"message-field_Qua",space:"space_MTH",button:"button_Hpo"};oe.add("game-ui/game/components/radio/emergency-radio-player/emergency-radio-player.module.scss",{get classes(){return $Oe},set classes(e){Object.assign($Oe,e)}});const qOe=$Oe;var XOe=new Wh("FOCUS_EMERGENCY"),QOe=new Wh("MUTE"),ZOe=new Wh("VOLUME"),JOe=(0,Y.forwardRef)((function(e,t){var n,r=e.expanded,i=e.className,o=xl(kP),a=xl(LP),s=xl(FP),l=xl(UP);return(0,z.jsx)(wpe,{enabled:r,children:(0,z.jsx)("div",{ref:t,className:_d()(qOe.emergencyRadioPlayer,r&&qOe.expanded,i),children:(0,z.jsx)(YL,{children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,children:[(0,z.jsxs)("div",{className:qOe.controls,children:[s&&(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Radio.FOCUS_EMERGENCY,{}),children:(0,z.jsx)(lb,{tinted:!0,focusKey:XOe,src:"Media/Radio/MapMarker.svg",className:qOe.button,onSelect:tC})}),(0,z.jsx)(jh,{tooltip:o?(0,z.jsx)(qc.Radio.UNMUTE,{}):(0,z.jsx)(qc.Radio.MUTE,{}),children:(0,z.jsx)(lb,{tinted:!0,focusKey:QOe,src:o?"Media/Radio/VolumeMuted.svg":"Media/Radio/Volume.svg",className:qOe.button,onSelect:XP})}),(0,z.jsx)(zv,{focusSound:Lp.hoverItem,className:qOe.volumeControls,children:(0,z.jsx)(HL,{children:(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.radioPanelVolumeSlider,children:(0,z.jsx)(oF,{focusKey:r?ZOe:Hh,start:0,end:1,value:a,onChange:zP,sounds:iF,className:qOe.volumeSlider})})})}),(0,z.jsx)("div",{className:qOe.centerControls,children:(0,z.jsx)(YOe,{className:qOe.messageField,children:null!=l&&(0,z.jsx)(ku,{value:l})})})]}),(0,z.jsx)("div",{className:qOe.rightSpace})]})})})})}));oe.add("game-ui/game/components/radio/emergency-radio-player/emergency-radio-player.tsx",{get EmergencyRadioPlayer(){return JOe},set EmergencyRadioPlayer(e){JOe=e}});let eEe={"radio-player":"radio-player_FIM",radioPlayer:"radio-player_FIM",expanded:"expanded_feM","right-space":"right-space_BDk",rightSpace:"right-space_BDk","segment-field":"segment-field_jsn item-mouse-states_Fmi",segmentField:"segment-field_jsn item-mouse-states_Fmi","segment-field-scroller":"segment-field-scroller_sCs",segmentFieldScroller:"segment-field-scroller_sCs","segment-title":"segment-title_OlY",segmentTitle:"segment-title_OlY","segment-subtitle":"segment-subtitle_S9e",segmentSubtitle:"segment-subtitle_S9e","controls-bounds":"controls-bounds_ty4",controlsBounds:"controls-bounds_ty4","controls-visible":"controls-visible_Rcf",controlsVisible:"controls-visible_Rcf",controls:"controls_YUi","volume-controls":"volume-controls_PII",volumeControls:"volume-controls_PII","volume-slider":"volume-slider_daK",volumeSlider:"volume-slider_daK","ads-control":"ads-control_pkw",adsControl:"ads-control_pkw","ads-control-inner":"ads-control-inner_NuT",adsControlInner:"ads-control-inner_NuT","ads-label":"ads-label_XQP",adsLabel:"ads-label_XQP","center-controls":"center-controls_IeA",centerControls:"center-controls_IeA",button:"button_hbJ button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT","play-pause-button":"play-pause-button_s9V button_hbJ button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT",playPauseButton:"play-pause-button_s9V button_hbJ button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT"};oe.add("game-ui/game/components/radio/radio-player/radio-player.module.scss",{get classes(){return eEe},set classes(e){Object.assign(eEe,e)}});const tEe=eEe;function nEe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function rEe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return nEe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return nEe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var iEe=new Wh("SEGMENT_FIELD"),oEe=new Wh("MUTE"),aEe=new Wh("VOLUME"),sEe=new Wh("PREVIOUS"),lEe=new Wh("PLAY_PAUSE"),cEe=new Wh("NEXT"),uEe=new Wh("ADS"),dEe=Lp.selectToggle,fEe=Y.forwardRef((function(e,t){var n,r,i=e.controlsVisible,o=e.expanded,a=e.className,s=xl(KP),l=xl(MP),c=xl(kP),u=xl(LP),d=xl(RP),f=rEe((0,Y.useState)(cEe),2),m=f[0],g=f[1];(0,Y.useEffect)((function(){g(o?lEe:cEe)}),[o]);var h=(0,Y.useCallback)((function(){kp(dEe),ZP()}),[]);return(0,z.jsx)(wpe,{enabled:o,children:(0,z.jsx)("div",{ref:t,className:_d()(tEe.radioPlayer,i&&tEe.controlsVisible,o&&tEe.expanded,a),children:(0,z.jsx)(YL,{children:(0,z.jsxs)(Ip,{focused:m,direction:gp.Horizontal,onChange:g,onRefocus:wp,children:[s&&(0,z.jsx)(Qp,{focusKey:iEe,className:tEe.segmentField,onSelect:ej,children:(0,z.jsxs)(YOe,{className:tEe.segmentFieldScroller,children:[(0,z.jsx)("div",{className:tEe.segmentTitle,children:s.title}),(0,z.jsx)("div",{className:tEe.segmentSubtitle,children:s.info})]},o?1:0)}),(0,z.jsx)("div",{className:tEe.controlsBounds,children:(0,z.jsxs)("div",{className:tEe.controls,children:[(0,z.jsx)(jh,{tooltip:c?(0,z.jsx)(qc.Radio.UNMUTE,{}):(0,z.jsx)(qc.Radio.MUTE,{}),children:(0,z.jsx)(lb,{tinted:!0,focusKey:oEe,src:c?"Media/Radio/VolumeMuted.svg":"Media/Radio/Volume.svg",className:tEe.button,onSelect:XP})}),(0,z.jsx)(zv,{focusSound:Lp.hoverItem,className:tEe.volumeControls,children:(0,z.jsx)(HL,{children:(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.radioPanelVolumeSlider,children:(0,z.jsx)(oF,{focusKey:aEe,start:0,end:1,value:u,onChange:zP,sounds:iF,className:tEe.volumeSlider})})})}),(0,z.jsxs)("div",{className:tEe.centerControls,children:[(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Radio.PREVIOUS_BUTTON_TOOLTIP,{}),children:(0,z.jsx)(lb,{tinted:!0,focusKey:sEe,src:"Media/Radio/Previous.svg",className:tEe.button,onSelect:JP})}),(0,z.jsx)(jh,{tooltip:l?(0,z.jsx)(qc.Radio.PLAY_BUTTON_TOOLTIP,{}):(0,z.jsx)(qc.Radio.PAUSE_BUTTON_TOOLTIP,{}),children:(0,z.jsx)(lb,{tinted:!0,focusKey:lEe,src:l?"Media/Radio/Play.svg":"Media/Radio/Pause.svg",className:tEe.playPauseButton,onSelect:$P})}),(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Radio.NEXT_BUTTON_TOOLTIP,{}),children:(0,z.jsx)(lb,{tinted:!0,focusKey:cEe,src:"Media/Radio/Next.svg",className:tEe.button,onSelect:eC})})]}),(0,z.jsx)(tk,{uiTag:null===(r=Ew.value)||void 0===r?void 0:r.radioPanelAdsToggle,children:(0,z.jsx)("div",{className:tEe.adsControl,onClick:h,children:(0,z.jsx)(jh,{tooltip:(0,z.jsx)(qc.Radio.ADS_BUTTON_TOOLTIP,{}),children:(0,z.jsxs)(Yv,{focusKey:o?uEe:Hh,className:tEe.adsControlInner,children:[(0,z.jsx)("div",{className:tEe.adsLabel,children:"Ads"}),(0,z.jsx)(D1,{checked:!d,className:tEe.adsToggle,onChange:ZP,toggleSound:dEe})]})})})})]})}),(0,z.jsx)("div",{className:tEe.rightSpace})]})})})})}));oe.add("game-ui/game/components/radio/radio-player/radio-player.tsx",{get RadioPlayer(){return fEe},set RadioPlayer(e){fEe=e}});let mEe={"station-icon":"station-icon_PgB",stationIcon:"station-icon_PgB","warning-icon":"warning-icon_VOz",warningIcon:"warning-icon_VOz",anchor:"anchor_tuN","anchor-inner":"anchor-inner_KV5",anchorInner:"anchor-inner_KV5",expanded:"expanded_SgP","player-bounds":"player-bounds_x19",playerBounds:"player-bounds_x19",player:"player_rRd",enter:"enter_eXw","enter-active":"enter-active_zDg",enterActive:"enter-active_zDg","exit-active":"exit-active_gQZ",exitActive:"exit-active_gQZ"};oe.add("game-ui/game/components/radio/radio-player-button/radio-player-button.module.scss",{get classes(){return mEe},set classes(e){Object.assign(mEe,e)}});const gEe=mEe;function hEe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function pEe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return hEe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return hEe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var vEe=new Wh("RADIO_BUTTON"),bEe=new Wh("PLAYER"),yEe=function(e){var t,n=e.className,r=xl(DP),i=r7(M_.Radio),o=Ww("Radio"),a=xl(HP),s=xl(BP),l=a.find((function(e){return e.name===s})),c=null==l?void 0:l.icon,u=pEe((0,Y.useState)(!1),2),d=u[0],f=u[1],m=pEe((0,Y.useState)(!1),2),g=m[0],h=m[1],p=(0,Y.useCallback)((function(){return h(!0)}),[]),v=(0,Y.useCallback)((function(){f(!1),h(!1)}),[]);(0,Y.useEffect)((function(){var e=0,t=WP.subscribe((function(){window.clearTimeout(e),f(!0),e=window.setTimeout((function(){return f(!1)}),3e3)}));return function(){window.clearTimeout(e),t.dispose()}}),[]);var b=Pg(),y=pEe((0,Y.useState)(!1),2),x=y[0],_=y[1],j=pEe((0,Y.useState)(!1),2),O=j[0],E=j[1],S=O?bEe:vEe,T=(0,Y.useMemo)((function(){return{"Move Horizontal":function(e){var t=e<0;return O!==t&&(E(t),!0)}}}),[O]),I=(0,Y.useCallback)((function(e){_(e),e||E(!1)}),[]),w=g||x&&b;return(0,z.jsx)("div",{className:_d()(gEe.anchor,n),onMouseEnter:p,onMouseLeave:v,children:(0,z.jsx)(rp,{actions:T,children:(0,z.jsx)(Tg,{onFocusChange:I,children:(0,z.jsxs)(pj,{focused:S,children:[(0,z.jsx)(hj,{focusKey:bEe,children:(0,z.jsxs)(Ud,{children:[(i.visible||d||w)&&!r&&!o&&(0,z.jsx)("div",{className:_d()(gEe.anchorInner,i.visible&&gEe.expanded),children:(0,z.jsx)("div",{className:gEe.playerBounds,children:(0,z.jsx)(Cm,{styles:gEe,children:(0,z.jsx)(fEe,{controlsVisible:w,expanded:i.visible,className:gEe.player})})})}),r&&(0,z.jsx)("div",{className:_d()(gEe.anchorInner,i.visible&&gEe.expanded),children:(0,z.jsx)("div",{className:gEe.playerBounds,children:(0,z.jsx)(Cm,{styles:gEe,children:(0,z.jsx)(JOe,{expanded:i.visible,className:gEe.player})})})})]})},"player"),(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.radioPanelButton,children:(0,z.jsx)(Qp,{focusKey:vEe,theme:KOe,selected:i.visible,className:_d()(gEe.button,KOe.toggleStates,r&&KOe.emergencyMode),disabled:o,onSelect:i.toggle,children:r?(0,z.jsx)(tb,{src:"Media/Glyphs/Warning.svg",className:gEe.warningIcon}):(0,z.jsx)("img",{src:c,className:gEe.stationIcon})})})]})})})})};oe.add("game-ui/game/components/radio/radio-player-button/radio-player-button.tsx",{get RadioPlayerButton(){return yEe},set RadioPlayerButton(e){yEe=e}});let xEe={"number-badge":"number-badge__VH",numberBadge:"number-badge__VH",animated:"animated_mNr",pulsate:"pulsate_TNZ","map-tile-badge":"map-tile-badge_wN7",mapTileBadge:"map-tile-badge_wN7","dev-point-badge":"dev-point-badge_B9x",devPointBadge:"dev-point-badge_B9x"};oe.add("game-ui/game/components/toolbar/components/number-badge/number-badge.module.scss",{get classes(){return xEe},set classes(e){Object.assign(xEe,e)}});const _Ee=xEe;function jEe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function OEe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return jEe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return jEe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var EEe=function(e){var t=e.className,n=e.children;return(0,z.jsx)("div",{className:_d()(_Ee.numberBadge,t),children:n})},SEe=function(e){var t=e.value,n=e.className,r=xl(Vg),i=xl(OP),o=r||!Qs(i,ty),a=OEe((0,Y.useState)(!1),2),s=a[0],l=a[1],c=(0,Y.useRef)(null);return(0,Y.useEffect)((function(){if(null!=c.current&&(l(!0),t>c.current)){c.current=t;var e=window.setTimeout((function(){return l(!1)}),100);return function(){return window.clearTimeout(e)}}c.current=t}),[t]),(0,z.jsx)(EEe,{className:_d()(!o&&!s&&_Ee.animated,n),children:Bu(t)})};oe.add("game-ui/game/components/toolbar/components/number-badge/number-badge.tsx",{get ButtonBadge(){return EEe},set ButtonBadge(e){EEe=e},get AnimatedNumberBadge(){return SEe},set AnimatedNumberBadge(e){SEe=e}});let TEe={"right-menu":"right-menu_u58",rightMenu:"right-menu_u58",item:"item_sWO","chirper-popup-anchor":"chirper-popup-anchor_p7b",chirperPopupAnchor:"chirper-popup-anchor_p7b","chirper-popup":"chirper-popup_H95",chirperPopup:"chirper-popup_H95",lock:"lock_IUS lock_EMU"};oe.add("game-ui/game/components/right-menu/right-menu.module.scss",{get classes(){return TEe},set classes(e){Object.assign(TEe,e)}});const IEe=TEe;let wEe={base:"base_GQv",enter:"enter_ZkJ","exit-active":"exit-active__eD",exitActive:"exit-active__eD","enter-active":"enter-active_x_X",enterActive:"enter-active_x_X",exit:"exit_B1r"};oe.add("game-ui/game/components/right-menu/right-menu-notifications.module.scss",{get classes(){return wEe},set classes(e){Object.assign(wEe,e)}});const PEe=wEe;function CEe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function NEe(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){CEe(e,t,n[t])}))}return e}function AEe(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}var LEe={direction:"left",alignment:"center"},MEe=Cj({chirper:"Media/Game/Icons/Chirper.svg",notifications:"Media/Game/Icons/Notifications.svg",lifepath:"Media/Game/Icons/Lifepath.svg",journal:"Media/Game/Icons/Journal.svg"}),kEe=function(e){var t,n,r,i=e.className,o=_l(Pte,DEe,0),a=r7(M_.Notifications),s=r7(M_.Chirper),l=r7(M_.Journal),c=r7(M_.LifePath),u=r7(M_.CinematicCamera),d=xl(GI),f=Kw("Chirper"),m=Kw("Followed Citizens"),g=Kw("Event Journal"),h=xl(AP),p=xl(DP),v=xl(Zl),b=xl(w_),y=xl(D_),x=v&&!y&&!s.visible&&!l.visible&&!c.visible&&!u.visible&&!d&&b===S_.main,_=(0,Y.useCallback)((function(){l.visible?PI():wI(),l.toggle()}),[l]);return(0,z.jsxs)("div",{className:_d()(IEe.rightMenu,i),children:[(0,z.jsx)(H5,{name:"GameBottomRight"}),(0,z.jsx)(cS,{in:o>0||a.visible,children:(0,z.jsx)(e8,AEe(NEe({},LEe),{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_NOTIFICATIONS,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_NOTIFICATIONS,{}),children:(0,z.jsx)(Cm,{styles:PEe,children:(0,z.jsx)(REe,{src:MEe.notifications,selected:a.visible,onSelect:a.toggle,children:o>0&&(0,z.jsx)(EEe,{children:(0,z.jsx)(su,{value:o,unit:$c.Integer})})})})}),"notifications-button")}),(0,z.jsxs)("div",{className:_d()(IEe.item,IEe.chirperPopupAnchor),children:[(0,z.jsx)(VOe,{disabled:!x,className:IEe.chirperPopup,onClick:s.toggle}),(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.chirperPanelButton,children:(0,z.jsx)(B9,AEe(NEe({},LEe),{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_CHIRPER,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_CHIRPER,{}),locked:f.locked,requirements:f.requirements,children:(0,z.jsx)(REe,{src:MEe.chirper,selected:s.visible,selectSound:Lp.chirper,locked:f.locked,onSelect:s.toggle})}))})]}),(0,z.jsx)(tk,{uiTag:null===(n=Ew.value)||void 0===n?void 0:n.lifePathPanelButton,children:(0,z.jsx)(B9,AEe(NEe({},LEe),{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_FOLLOWED_CITIZENS,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_FOLLOWED_CITIZENS,{}),locked:m.locked,requirements:m.requirements,children:(0,z.jsx)(REe,{src:MEe.lifepath,selected:c.visible,locked:m.locked,onSelect:c.toggle})}))}),(0,z.jsx)(tk,{uiTag:null===(r=Ew.value)||void 0===r?void 0:r.eventJournalPanelButton,children:(0,z.jsx)(B9,AEe(NEe({},LEe),{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_EVENT_JOURNAL,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_EVENT_JOURNAL,{}),locked:g.locked,requirements:g.requirements,children:(0,z.jsx)(REe,{src:MEe.journal,selected:l.visible,locked:g.locked,onSelect:_})}))}),(h||p)&&(0,z.jsx)(yEe,{className:IEe.item})]})},REe=Y.forwardRef((function(e,t){var n=e.src,r=e.selected,i=e.locked,o=e.selectSound,a=e.children,s=e.className,l=e.onSelect;return(0,z.jsx)("div",{ref:t,className:_d()(IEe.item,s),children:(0,z.jsxs)(lb,{src:n,selected:r,disabled:i,selectSound:o,theme:KOe,className:KOe.toggleStates,onSelect:l,children:[a,i&&(0,z.jsx)(_1,{className:IEe.lock})]})})}));function DEe(e,t){return t.length}oe.add("game-ui/game/components/right-menu/right-menu.tsx",{get RightMenu(){return kEe},set RightMenu(e){kEe=e}});let FEe={"city-name-field":"city-name-field_XDy field_eKJ selectable_otQ",cityNameField:"city-name-field_XDy field_eKJ selectable_otQ",container:"container_MC3",input:"input_JJ_ content_syM",label:"label_mWz content_syM"};oe.add("game-ui/game/components/toolbar/bottom/city-name-field/city-name-field.module.scss",{get classes(){return FEe},set classes(e){Object.assign(FEe,e)}});const UEe=FEe;function GEe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function BEe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return GEe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return GEe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var VEe=function(){var e=xl(aL),t=(0,Y.useCallback)((function(e){return uL(e.target.value)}),[]),n=BEe((0,Y.useState)(!1),2),r=n[0],i=n[1],o=(0,Y.useCallback)((function(){return i(!0)}),[]),a=(0,Y.useCallback)((function(){return i(!1)}),[]);return(0,z.jsx)(e8,{disabled:r,title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_CITY_NAME,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_CITY_NAME,{}),children:(0,z.jsx)(Yv,{className:UEe.cityNameField,children:(0,z.jsx)(nre,{value:e,vkTitle:(0,z.jsx)(qc.VirtualKeyboard.TITLE,{hash:"CityName"}),theme:UEe,onChange:t,onFocus:o,onBlur:a})})})};oe.add("game-ui/game/components/toolbar/bottom/city-name-field/city-name-field.tsx",{get CityNameField(){return VEe},set CityNameField(e){VEe=e}});let HEe={content:"content_B0O",indicators:"indicators_ZC7",icon:"icon_Tkh",active:"active_nrD",trend:"trend_NRr",visible:"visible__qP","dev-info":"dev-info_PVK",devInfo:"dev-info_PVK",factors:"factors_IuM"};oe.add("game-ui/game/components/toolbar/bottom/happiness-field/happiness-field.module.scss",{get classes(){return HEe},set classes(e){Object.assign(HEe,e)}});const KEe=HEe;function WEe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function zEe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return WEe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return WEe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var YEe=["Media/Game/Icons/Depressed.svg","Media/Game/Icons/Sad.svg","Media/Game/Icons/Neutral.svg","Media/Game/Icons/Content.svg","Media/Game/Icons/Happy.svg"],$Ee=function(){var e=xl(SR),t=xl(KT),n=function(e){return e>70?4:e>55?3:e>40?2:e>25?1:0}(t),r=function(e){var t=zEe((0,Y.useState)(0),2),n=t[0],r=t[1],i=(0,Y.useRef)(e),o=(0,Y.useRef)(e),a=(0,Y.useRef)(null),s=(0,Y.useRef)(null),l=(0,Y.useMemo)((function(){var e=function(){r(0),s.current=null},t=function(){var n=o.current-i.current;Math.abs(n)>0?(i.current=o.current,r(n),s.current&&window.clearTimeout(s.current),s.current=window.setTimeout(e,XEe),a.current=window.setTimeout(t,qEe)):a.current=null};return t}),[]);return(0,Y.useEffect)((function(){o.current=e,null==a.current&&l()}),[l,e]),(0,Y.useEffect)((function(){return function(){null!=a.current&&window.clearTimeout(a.current),null!=s.current&&window.clearTimeout(s.current)}}),[]),n}(t),i=E_("Happiness"),o=xl(WT);return(0,z.jsx)(e8,{title:(0,z.jsx)(qc.CityInfoPanel.TOOLTIP_HAPPINESS_TITLE,{}),description:(0,z.jsx)(qc.CityInfoPanel.TOOLTIP_HAPPINESS_DESCRIPTION,{}),content:o.length>0&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)(XE,{}),(0,z.jsx)("div",{className:KEe.factors,children:o.map((function(e,t){return(0,z.jsx)(TS,{left:e.weight>0?(0,z.jsx)(qc.Common.HAPPINESS_FACTOR_POSITIVE,{hash:e.factor}):(0,z.jsx)(qc.Common.HAPPINESS_FACTOR_NEGATIVE,{hash:e.factor}),right:(0,z.jsx)("div",{className:uR(c9,e.weight),children:(0,z.jsx)(su,{value:e.weight,signed:!0})})},t)}))})]}),children:(0,z.jsxs)(k8,{contentClassName:KEe.content,onSelect:i,children:[(0,z.jsx)("img",{src:"Media/Game/Misc/HappinessMinus.svg",className:_d()(KEe.trend,r<0&&KEe.visible)}),(0,z.jsx)("div",{className:KEe.indicators,children:YEe.map((function(e,t){return(0,z.jsx)("img",{src:e,className:_d()(KEe.icon,t===n&&KEe.active)},t)}))}),(0,z.jsx)("img",{src:"Media/Game/Misc/HappinessPlus.svg",className:_d()(KEe.trend,r>0&&KEe.visible)}),e&&(0,z.jsx)("div",{className:KEe.devInfo,children:t})]})})},qEe=15e3,XEe=1e4;oe.add("game-ui/game/components/toolbar/bottom/happiness-field/happiness-field.tsx",{get HappinessField(){return $Ee},set HappinessField(e){$Ee=e}});let QEe={content:"content_QTZ",icon:"icon_bCS",value:"value_ruP",negative:"negative_xQP",trend:"trend_IAr","trend-icon":"trend-icon_AgE",trendIcon:"trend-icon_AgE",positive:"positive_PUr",unlimited:"unlimited_Dsm"};oe.add("game-ui/game/components/toolbar/components/stat-field/stat-field.module.scss",{get classes(){return QEe},set classes(e){Object.assign(QEe,e)}});const ZEe=QEe;var JEe=function(e){var t=e.icon,n=e.value,r=e.valueUnit,i=e.trend,o=e.trendIcon,a=e.unlimited,s=void 0!==a&&a,l=e.className,c=e.onSelect;return(0,z.jsxs)(k8,{contentClassName:ZEe.content,onSelect:c,className:_d()(ZEe.statField,l),children:[(0,z.jsx)("img",{src:t,className:ZEe.icon}),s?(0,z.jsx)("div",{className:ZEe.unlimited,children:"∞"}):(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)("div",{className:_d()(ZEe.value,n<0&&ZEe.negative),children:(0,z.jsx)(su,{value:n,unit:r})}),o&&(0,z.jsx)("div",{className:ZEe.trend,children:(0,z.jsx)(tb,{src:o,className:_d()(ZEe.trendIcon,uR(ZEe,i))})})]})]})};oe.add("game-ui/game/components/toolbar/components/stat-field/stat-field.tsx",{get StatField(){return JEe},set StatField(e){JEe=e}});let eSe={trend:"trend_K7y",positive:"positive_n5t",negative:"negative_Moc"};oe.add("game-ui/game/components/toolbar/bottom/money-field/money-field.module.scss",{get classes(){return eSe},set classes(e){Object.assign(eSe,e)}});const tSe=eSe;var nSe=function(){var e=xl(iL),t=xl(oL),n=Ww("City Budget"),r=xl(sL),i=function(e,t){var n=xl(cL),r=Math.abs(e),i=Math.abs(t);return 0===i?void 0:i<=r*n.x?"Media/Glyphs/".concat(t<0?"TrendDown":"TrendUp",".svg"):i<=r*n.y?"Media/Glyphs/".concat(t<0?"TrendDownMedium":"TrendUpMedium",".svg"):"Media/Glyphs/".concat(t<0?"TrendDownHigh":"TrendUpHigh",".svg")}(e,t);return(0,z.jsx)(e8,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_MONEY,{}),description:r?(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_UNLIMITED_MONEY,{}):(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_MONEY,{}),content:(0,z.jsxs)("div",{className:tSe.trend,children:[(0,z.jsx)(qc.Toolbar.CURRENT_TREND,{}),(0,z.jsx)("div",{className:uR(tSe,t),children:(0,z.jsx)(su,{value:t,unit:$c.MoneyPerHour,signed:!0})})]}),children:(0,z.jsx)(JEe,{icon:"Media/Game/Icons/Money.svg",value:e,valueUnit:$c.Money,trend:t,trendIcon:i,unlimited:r,onSelect:n?void 0:rSe,className:tSe.moneyField})})};function rSe(){U_(M_.Economy)}oe.add("game-ui/game/components/toolbar/bottom/money-field/money-field.tsx",{get MoneyField(){return nSe},set MoneyField(e){nSe=e}});let iSe={trend:"trend_IdP",positive:"positive_yei",negative:"negative_LzO"};oe.add("game-ui/game/components/toolbar/bottom/population-field/population-field.module.scss",{get classes(){return iSe},set classes(e){Object.assign(iSe,e)}});const oSe=iSe;var aSe=function(){var e=xl(nL),t=xl(rL),n=E_("Population"),r=function(e,t){var n=xl(lL),r=Math.abs(e),i=Math.abs(t);return 0===i?void 0:i<=r*n.x?"Media/Glyphs/".concat(t<0?"TrendDown":"TrendUp",".svg"):i<=r*n.y?"Media/Glyphs/".concat(t<0?"TrendDownMedium":"TrendUpMedium",".svg"):"Media/Glyphs/".concat(t<0?"TrendDownHigh":"TrendUpHigh",".svg")}(e,t);return(0,z.jsx)(e8,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_POPULATION,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_POPULATION,{}),content:(0,z.jsxs)("div",{className:oSe.trend,children:[(0,z.jsx)(qc.Toolbar.CURRENT_TREND,{}),(0,z.jsx)("div",{className:uR(oSe,t),children:(0,z.jsx)(su,{value:t,unit:$c.IntegerPerHour,signed:!0})})]}),children:(0,z.jsx)(JEe,{icon:"Media/Game/Icons/Citizen.svg",value:e,valueUnit:$c.Integer,trend:t,trendIcon:r,onSelect:n,className:oSe.populationField})})};oe.add("game-ui/game/components/toolbar/bottom/population-field/population-field.tsx",{get PopulationField(){return aSe},set PopulationField(e){aSe=e}});let sSe={width:"116px",height:"36px",shadowHeight:"1.5px",rangeFill:"rgba(255, 255, 255, 0.08)",shadowFill:"rgba(0, 0, 0, 0.2)",image:"image_E3g"};oe.add("game-ui/game/components/toolbar/top/city-info-field/demand-bars.module.scss",{get classes(){return sSe},set classes(e){Object.assign(sSe,e)}});const lSe=sSe;var cSe=function(e){var t=e.items,n=e.className,r=YO(lSe.width),i=YO(lSe.height),o=i/Math.max(1,t.length),a=o/2,s=YO(lSe.shadowHeight);return(0,z.jsx)(Qd,{children:(0,z.jsx)("div",{className:_d()(lSe.demandBars,n),children:(0,z.jsxs)("svg",{viewBox:"0 0 ".concat(r," ").concat(i),className:lSe.image,children:[(0,z.jsxs)("linearGradient",{id:"shadow",gradientUnits:"objectBoundingBox",x1:0,x2:0,y1:1,y2:0,children:[(0,z.jsx)("stop",{offset:"0",stopColor:lSe.shadowFill}),(0,z.jsx)("stop",{offset:s/o,stopColor:lSe.shadowFill}),(0,z.jsx)("stop",{offset:s/o,stopColor:"rgba(0, 0, 0, 0)"}),(0,z.jsx)("stop",{offset:"1",stopColor:"rgba(0, 0, 0, 0)"})]}),t.map((function(e,t){return(0,z.jsxs)(Y.Fragment,{children:[(0,z.jsx)("clipPath",{id:e.key,children:(0,z.jsx)("rect",{x:"0",y:t*o,width:r,height:o,rx:a,ry:a})}),(0,z.jsx)("rect",{x:"0",y:t*o,width:r,height:o,rx:a,ry:a,fill:lSe.rangeFill}),(0,z.jsx)("rect",{x:-o,y:t*o,width:Math.round(o+of(e.value,0,1)*r),height:o,rx:a,ry:a,clipPath:"url(#".concat(e.key,")"),fill:e.color}),(0,z.jsx)("rect",{x:"0",y:t*o,width:r,height:o,rx:a,ry:a,fill:"url(#shadow)"})]},e.key)}))]})})})};oe.add("game-ui/game/components/toolbar/top/city-info-field/demand-bars.tsx",{get DemandBars(){return cSe},set DemandBars(e){cSe=e}});let uSe={button:"button_s2g button_ECf item_It6 item-mouse-states_Fmi item-selected_tAM item-focused_FuT","no-border":"no-border_Kqc",noBorder:"no-border_Kqc","toggle-states":"toggle-states_X82 toggle-states_DTm",toggleStates:"toggle-states_X82 toggle-states_DTm",icon:"icon_KJZ icon_soN icon_Iwk"};oe.add("game-ui/game/components/toolbar/components/feature-button/toolbar-feature-button.module.scss",{get classes(){return uSe},set classes(e){Object.assign(uSe,e)}});const dSe=uSe;let fSe={"city-info-field":"city-info-field_kp7",cityInfoField:"city-info-field_kp7",field:"field_OvX","unlocking-tooltip":"unlocking-tooltip_WHX",unlockingTooltip:"unlocking-tooltip_WHX",toggle:"toggle_kzL","small-lock":"small-lock_k2N",smallLock:"small-lock_k2N",lock:"lock_D8i lock_EMU",legend:"legend_wn_"};oe.add("game-ui/game/components/toolbar/top/city-info-field/city-info-field.module.scss",{get classes(){return fSe},set classes(e){Object.assign(fSe,e)}});const mSe=fSe;function gSe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function hSe(e){return function(e){if(Array.isArray(e))return gSe(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return gSe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return gSe(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var pSe=Cj({City:"Media/Game/Icons/City.svg"}),vSe=function(){var e,t,n=xl(AT),r=xl(LT),i=xl(MT),o=xl(kT),a=xl(RT),s=xl(DT),l=r7(M_.CityInfo),c=Kw("City Info Panel"),u=Ww("Residential Medium"),d=Ww("Residential High"),f=Ww("ZonesOffice"),m=[{key:"ResidentialLow",color:dle[ule.ResidentialLow],value:n}].concat(hSe(u?[]:[{key:"ResidentialMedium",color:dle[ule.ResidentialMedium],value:r}]),hSe(d?[]:[{key:"ResidentialHigh",color:dle[ule.ResidentialHigh],value:i}]),[{key:"Commercial",color:dle[ule.Commercial],value:o},{key:"Industrial",color:dle[ule.Industrial],value:a}],hSe(f?[]:[{key:"Office",color:dle[ule.Office],value:s}]));return(0,z.jsxs)("div",{className:mSe.cityInfoField,children:[(0,z.jsx)(tk,{uiTag:null===(e=Ew.value)||void 0===e?void 0:e.cityInfoPanelButton,children:(0,z.jsx)(B9,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_CITY_INFO,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_CITY_INFO,{}),locked:c.locked,requirements:c.requirements,children:(0,z.jsx)(lb,{src:pSe.City,selected:l.visible,disabled:c.locked,theme:dSe,className:_d()(mSe.toggle,dSe.toggleStates),onSelect:l.toggle,children:c.locked&&(0,z.jsx)(_1,{className:mSe.lock})})})}),(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.toolbarDemand,children:(0,z.jsx)(e8,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_DEMAND,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_DEMAND,{}),content:(0,z.jsxs)("div",{className:mSe.legend,children:[(0,z.jsx)(bSe,{type:ule.ResidentialLow}),!u&&(0,z.jsx)(bSe,{type:ule.ResidentialMedium}),!d&&(0,z.jsx)(bSe,{type:ule.ResidentialHigh}),(0,z.jsx)(bSe,{type:ule.Commercial}),(0,z.jsx)(bSe,{type:ule.Industrial}),!f&&(0,z.jsx)(bSe,{type:ule.Office})]}),children:(0,z.jsx)(cSe,{items:m,className:mSe.field})})})]})},bSe=function(e){var t=e.type;return(0,z.jsx)(hU,{color:dle[t],label:(0,z.jsx)(qc.CityInfoPanel.DEMAND_TITLE,{hash:ule[t]})})};oe.add("game-ui/game/components/toolbar/top/city-info-field/city-info-field.tsx",{get CityInfoField(){return vSe},set CityInfoField(e){vSe=e}});let ySe={"progression-message-feed":"progression-message-feed_P4X",progressionMessageFeed:"progression-message-feed_P4X","item-transition":"item-transition_ugO",itemTransition:"item-transition_ugO",enter:"enter_nmi","enter-active":"enter-active_bWQ",enterActive:"enter-active_bWQ",exit:"exit_mXQ","exit-active":"exit-active_SEi",exitActive:"exit-active_SEi",item:"item_XMq",amount:"amount_nbC",reason:"reason_tLs",space:"space_m_Q"};oe.add("game-ui/game/components/toolbar/top/progression-field/progression-message-feed.module.scss",{get classes(){return ySe},set classes(e){Object.assign(ySe,e)}});const xSe=ySe;function _Se(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function jSe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||ESe(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function OSe(e){return function(e){if(Array.isArray(e))return _Se(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||ESe(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function ESe(e,t){if(e){if("string"==typeof e)return _Se(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?_Se(e,t):void 0}}var SSe=function(e){var t=e.className,n=jSe((0,Y.useState)([]),2),r=n[0],i=n[1];return(0,Y.useEffect)((function(){var e=new ISe(i);return function(){return e.dispose()}}),[]),(0,z.jsx)("div",{className:_d()(xSe.progressionMessageFeed,t),children:(0,z.jsx)(Ud,{children:r.map((function(e){return(0,z.jsx)(TSe,{data:e},e.time)}))})})},TSe=function(e){var t=e.data;return(0,Y.useEffect)((function(){return kp(Lp.xpEvent)}),[]),(0,z.jsx)(aS,{styles:xSe,exitCollapseHeight:!1,children:(0,z.jsxs)("div",{className:xSe.itemTransition,children:[(0,z.jsxs)("div",{className:xSe.item,children:[(0,z.jsx)("div",{className:xSe.amount,children:(0,z.jsx)(su,{signed:!0,value:t.message.amount,unit:$c.XP})}),(0,z.jsx)("div",{className:xSe.reason,children:(0,z.jsx)(qc.Progression.XP_REASON,{hash:t.message.reason})})]}),(0,z.jsx)("div",{className:xSe.space})]})})},ISe=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.listener=t,this.activeMessages=[],this.pendingMessages=[],this.updateTimeoutHandle=0,this.subscription=xP.subscribe(this.handleMessageAdded.bind(this))}var t=e.prototype;return t.handleMessageAdded=function(e){this.pendingMessages.unshift(e),window.clearTimeout(this.updateTimeoutHandle),this.update()},t.update=function(){for(var e=performance.now(),t=!1,n=this.activeMessages.length-1;n>=0;n--){var r=this.activeMessages[n];(r.time+4e3<e||r.time>e)&&(this.activeMessages.splice(n,1),t=!0)}var i=this.activeMessages.reduce((function(e,t){return Math.max(e,t.time)}),0);if(this.activeMessages.length<4&&e-i>500){var o=this.pendingMessages.pop();null!=o&&(this.activeMessages.push({message:o,time:e}),i=e,t=!0)}t&&this.listener(OSe(this.activeMessages));var a=null;if(this.activeMessages.length>0){var s=this.activeMessages.reduce((function(e,t){return Math.min(e,t.time)}),e);a=Math.min(s+4e3,null!=a?a:Number.MAX_VALUE)}this.pendingMessages.length>0&&(a=Math.min(e+500,null!=a?a:Number.MAX_VALUE)),null!=a&&window.setTimeout(this.update.bind(this),a-e)},t.dispose=function(){window.clearTimeout(this.updateTimeoutHandle),this.subscription.dispose()},e}();oe.add("game-ui/game/components/toolbar/top/progression-field/progression-message-feed.tsx",{get ProgressionMessageFeed(){return SSe},set ProgressionMessageFeed(e){SSe=e}});let wSe={strokeWidth:"6","progress-circle":"progress-circle_jvw progress-circle_OLN",progressCircle:"progress-circle_jvw progress-circle_OLN",progress:"progress_i1E progress_mlv",circle:"circle_Apc"};oe.add("game-ui/game/components/toolbar/top/progression-field/progress-circle.module.scss",{get classes(){return wSe},set classes(e){Object.assign(wSe,e)}});const PSe=wSe;let CSe={"progression-field":"progression-field_Lho",progressionField:"progression-field_Lho",field:"field_p2F","max-milestone-reached":"max-milestone-reached___5",maxMilestoneReached:"max-milestone-reached___5",toggle:"toggle_bAE",icon:"icon_Gzn",progress:"progress_NK4",feed:"feed_zoj",lock:"lock_YHO lock_EMU",milestone:"milestone_Eev"};oe.add("game-ui/game/components/toolbar/top/progression-field/progression-field.module.scss",{get classes(){return CSe},set classes(e){Object.assign(CSe,e)}});const NSe=CSe;var ASe={tension:150,friction:20},LSe=function(){var e,t=r7(M_.Progression),n=Kw("Progression Panel"),r=xl(pP),i=xl(vP),o=xl(bP),a=xl(yP),s=YZ(ASe,a),l=xl(_P),c=xl(kw),u=Math.max(o-i,0),d=of(s-i,0,u),f=!l&&!n.locked;return(0,z.jsxs)("div",{className:NSe.progressionField,children:[(0,z.jsx)(tk,{uiTag:null===(e=Ew.value)||void 0===e?void 0:e.progressionPanelButton,children:(0,z.jsx)(B9,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_PROGRESSION,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_PROGRESSION,{}),content:l?void 0:(0,z.jsx)(Pu,{value:d,total:u,unit:$c.XP}),locked:n.locked,requirements:n.requirements,children:(0,z.jsxs)(Qp,{selected:t.visible,disabled:n.locked,className:_d()(NSe.toggle,dSe.toggleStates,f&&dSe.noBorder),theme:dSe,onSelect:t.toggle,children:[l?(0,z.jsx)("img",{src:"Media/Game/Icons/Trophy.svg",className:dSe.icon}):(0,z.jsx)("div",{className:NSe.milestone,children:(0,z.jsx)(su,{value:r})}),f&&(0,z.jsx)(OV,{progress:d,max:u,theme:PSe,className:NSe.progress}),c>0&&(0,z.jsx)(SEe,{value:c,className:_Ee.devPointBadge}),n.locked&&(0,z.jsx)(_1,{className:NSe.lock})]})})}),(0,z.jsx)(e8,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_CURRENT_MILESTONE,{}),description:l?(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_MAX_MILESTONE,{}):(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_CURRENT_MILESTONE,{}),children:(0,z.jsx)("div",{className:_d()(NSe.field,l&&NSe.maxMilestoneReached),children:(0,z.jsx)(qc.Progression.MILESTONE_NAME,{index:r})})}),!l&&(0,z.jsx)(SSe,{className:NSe.feed})]})};oe.add("game-ui/game/components/toolbar/top/progression-field/progression-field.tsx",{get ProgressionField(){return LSe},set ProgressionField(e){LSe=e}});let MSe={lock:"lock_EMU"};oe.add("game-ui/game/components/toolbar/top/toggles.module.scss",{get classes(){return MSe},set classes(e){Object.assign(MSe,e)}});const kSe=MSe;var RSe=Cj({Economy:"Media/Game/Icons/Economy.svg",TransportationOverview:"Media/Game/Icons/TransportationOverview.svg",CityStatistics:"Media/Game/Icons/CityStatistics.svg",MapTile:"Media/Game/Icons/MapTile.svg",PhotoMode:"Media/Game/Icons/PhotoMode.svg"}),DSe=function(){var e,t=r7(M_.Economy),n=Kw("City Budget");return(0,z.jsx)(B9,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_CITY_ECONOMY,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_CITY_ECONOMY,{}),locked:n.locked,requirements:n.requirements,children:(0,z.jsx)(tk,{uiTag:null===(e=Ew.value)||void 0===e?void 0:e.economyPanelButton,children:(0,z.jsx)(lb,{src:RSe.Economy,selected:t.visible,disabled:n.locked,selectSound:Lp.economy,theme:dSe,className:dSe.toggleStates,onSelect:t.toggle,children:n.locked&&(0,z.jsx)(_1,{className:kSe.lock})})})})},FSe=function(){var e,t=r7(M_.TransportationOverview),n=Kw("Transportation Overview");return(0,z.jsx)(tk,{uiTag:null===(e=Ew.value)||void 0===e?void 0:e.transportationOverviewPanelButton,children:(0,z.jsx)(B9,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_LINES_OVERVIEW,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_LINES_OVERVIEW,{}),locked:n.locked,requirements:n.requirements,children:(0,z.jsx)(lb,{src:RSe.TransportationOverview,selected:t.visible,disabled:n.locked,theme:dSe,className:dSe.toggleStates,onSelect:t.toggle,children:n.locked&&(0,z.jsx)(_1,{className:kSe.lock})})})})},USe=function(){var e,t=r7(M_.Statistics),n=Kw("City Statistics");return(0,z.jsx)(tk,{uiTag:null===(e=Ew.value)||void 0===e?void 0:e.statisticsPanelButton,children:(0,z.jsx)(B9,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_CITY_STATISTICS,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_CITY_STATISTICS,{}),locked:n.locked,requirements:n.requirements,children:(0,z.jsx)(lb,{src:RSe.CityStatistics,selected:t.visible,disabled:n.locked,theme:dSe,className:dSe.toggleStates,onSelect:t.toggle,children:n.locked&&(0,z.jsx)(_1,{className:kSe.lock})})})})},GSe=function(){var e,t=xl(GI),n=xl(zI),r=Kw("Map Tiles"),i=(0,Y.useCallback)((function(){return $I(!t)}),[t]);return(0,z.jsx)(tk,{uiTag:null===(e=Ew.value)||void 0===e?void 0:e.mapTilePanelButton,children:(0,z.jsx)(B9,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_MAP_TILES,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_MAP_TILES,{}),locked:r.locked,requirements:r.requirements,children:(0,z.jsxs)(lb,{src:RSe.MapTile,selected:t,disabled:r.locked,theme:dSe,className:dSe.toggleStates,onSelect:i,children:[!r.locked&&n>0&&(0,z.jsx)(SEe,{value:n,className:_Ee.mapTileBadge}),r.locked&&(0,z.jsx)(_1,{className:kSe.lock})]})})})},BSe=function(){var e,t=r7(M_.PhotoMode),n=Kw("Photo Mode");return(0,z.jsx)(B9,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_PHOTO_MODE,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_PHOTO_MODE,{}),locked:n.locked,requirements:n.requirements,children:(0,z.jsx)(tk,{uiTag:null===(e=Ew.value)||void 0===e?void 0:e.photoModePanelButton,children:(0,z.jsx)(lb,{src:RSe.PhotoMode,selected:t.visible,disabled:n.locked,theme:dSe,className:dSe.toggleStates,onSelect:t.toggle,children:n.locked&&(0,z.jsx)(_1,{className:kSe.lock})})})})};oe.add("game-ui/game/components/toolbar/top/toggles.tsx",{get EconomyPanelToggle(){return DSe},set EconomyPanelToggle(e){DSe=e},get TransportationOverviewToggle(){return FSe},set TransportationOverviewToggle(e){FSe=e},get CityStatisticsToggle(){return USe},set CityStatisticsToggle(e){USe=e},get MapTilePurchaseToggle(){return GSe},set MapTilePurchaseToggle(e){GSe=e},get PhotoModeToggle(){return BSe},set PhotoModeToggle(e){BSe=e}});let VSe={"toolbar-button-strip":"toolbar-button-strip_CoK",toolbarButtonStrip:"toolbar-button-strip_CoK",group:"group_i85",button:"button_cBV",highlight:"highlight_XBc",lock:"lock_bNk"};oe.add("game-ui/game/components/toolbar/top/toolbar-button-strip/toolbar-button-strip.module.scss",{get classes(){return VSe},set classes(e){Object.assign(VSe,e)}});const HSe=VSe;var KSe=function(e){var t=e.focusKey,n=e.className,r=xl(HA),i=xl(XA),o=xl($A),a=(0,Y.useMemo)((function(){var e=Math.min(r.length-1,1);return-1!==e&&r[e].children.length>0?qs(r[e].children[0].entity):null}),[r]);return(0,z.jsx)("div",{className:_d()(HSe.toolbarButtonStrip,n),children:(0,z.jsx)(Ap,{focusKey:t,initialFocused:a,direction:gp.Horizontal,children:r.map((function(e){return(0,z.jsx)("div",{className:HSe.group,children:e.children.map((function(e){return(0,z.jsx)(WSe,{item:e,selected:Qs(e.entity,i)||Qs(e.entity,o)},qs(e.entity))}))},qs(e.entity))}))})})},WSe=function(e){var t,n=e.item,r=e.selected,i=(0,Y.useCallback)((function(){n.type===BA.menu?ZA(n.entity):(eL(n.entity),th(n.uiTag,!0))}),[n.entity,n.type,n.uiTag]),o=Ol(Ow,n.entity);return(0,z.jsx)(tk,{uiTag:n.uiTag,active:!(n.locked&&n.type===BA.asset),children:(0,z.jsx)(B9,{title:null!=o?(0,z.jsx)(kc,{id:o.titleId}):n.name,description:null!=o?(0,z.jsx)(kc,{id:o.descriptionId}):void 0,locked:n.locked,requirements:n.requirements,children:(0,z.jsxs)(lb,{focusKey:qs(n.entity),src:n.icon,selected:r,disabled:n.locked&&n.type===BA.asset,selectSound:null!==(t=r?n.deselectSound:n.selectSound)&&void 0!==t?t:void 0,theme:o7,className:_d()(HSe.button,o7.toggleStates,n.locked&&o7.locked),onSelect:r?tL:i,children:[n.highlight&&(0,z.jsx)("div",{className:HSe.highlight}),n.locked&&(0,z.jsx)(_1,{className:HSe.lock})]})})})};oe.add("game-ui/game/components/toolbar/top/toolbar-button-strip/toolbar-button-strip.tsx",{get ToolbarButtonStrip(){return KSe},set ToolbarButtonStrip(e){KSe=e}});let zSe={icon:"icon_rqi icon_KJZ icon_soN icon_Iwk",underground:"underground_heZ",lock:"lock_okm lock_EMU"};oe.add("game-ui/game/components/toolbar/top/undergound-mode-toggle/underground-mode-toggle.module.scss",{get classes(){return zSe},set classes(e){Object.assign(zSe,e)}});const YSe=zSe;Cj({underground:"Media/Game/Misc/Underground.svg",undergroundMask:"Media/Game/Misc/UndergroundToggleMask.svg"});var $Se=function(){var e,t,n=xl(eA),r=xl(tA),i=(0,Y.useCallback)((function(){return bA(!r)}),[r]),o=Kw("Underground Mode");return rh(null===(e=Ew.value)||void 0===e?void 0:e.toolbarUnderground,r),(0,z.jsx)(B9,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_UNDERGROUND,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_UNDERGROUND,{}),locked:o.locked,requirements:o.requirements,children:(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.toolbarUnderground,children:(0,z.jsxs)(Qp,{selected:r,disabled:o.locked||!n,selectSound:r?Lp.increaseElevation:Lp.decreaseElevation,theme:dSe,className:dSe.toggleStates,onSelect:i,children:[(0,z.jsx)("div",{className:_d()(YSe.icon,r&&YSe.underground)}),o.locked&&(0,z.jsx)(_1,{className:YSe.lock})]})})})};oe.add("game-ui/game/components/toolbar/top/undergound-mode-toggle/underground-mode-toggle.tsx",{get UndergroundModeToggle(){return $Se},set UndergroundModeToggle(e){$Se=e}});let qSe={toolbar:"toolbar_QYu",hidden:"hidden__OM","social-menu-anchor":"social-menu-anchor_oJe",socialMenuAnchor:"social-menu-anchor_oJe","social-menu":"social-menu_nHI",socialMenu:"social-menu_nHI","left-side-menu":"left-side-menu_DLV",leftSideMenu:"left-side-menu_DLV",top:"top_ZSs",bottom:"bottom_vae",paused:"paused_ICO",container:"container_yy5","top-inner":"top-inner_v2o container_yy5",topInner:"top-inner_v2o container_yy5","bottom-inner":"bottom-inner_ZYV container_yy5",bottomInner:"bottom-inner_ZYV container_yy5",spacer:"spacer_oEi",start:"start_hR7",end:"end_G0e",divider:"divider_GaZ","large-divider":"large-divider_XGP",largeDivider:"large-divider_XGP","extra-large-divider":"extra-large-divider_Bc3",extraLargeDivider:"extra-large-divider_Bc3","bulldoze-bar":"bulldoze-bar_D37",bulldozeBar:"bulldoze-bar_D37",active:"active_hed"};oe.add("game-ui/game/components/toolbar/toolbar.module.scss",{get classes(){return qSe},set classes(e){Object.assign(qSe,e)}});const XSe=qSe;function QSe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var ZSe=new Wh("toolbar_top"),JSe=new Wh("toolbar_bottom"),eTe=new Wh("button_strip"),tTe=(0,z.jsx)("div",{className:XSe.divider}),nTe=(0,z.jsx)("div",{className:XSe.spacer}),rTe=function(e){var t=e.focusKey,n=e.className;xl(Ew);var r=r7(M_.PhotoMode);return(0,z.jsx)(wj,{children:(0,z.jsx)(Ap,{focusKey:t,initialFocused:ZSe,direction:gp.Vertical,onRefocus:wp,children:(0,z.jsxs)("div",{className:_d()(XSe.toolbar,n,QSe({},XSe.hidden,r.visible)),children:[(0,z.jsxs)("div",{className:XSe.socialMenuAnchor,children:[(0,z.jsx)(kOe,{className:XSe.leftSideMenu}),(0,z.jsx)(kEe,{className:XSe.socialMenu})]}),(0,z.jsx)(iTe,{}),(0,z.jsx)(oTe,{}),(0,z.jsx)(aTe,{})]})})})},iTe=function(){var e,t=xl(VN).id===yA;return oh(null===(e=Ew.value)||void 0===e?void 0:e.toolbarBulldozerBar,t),(0,z.jsx)("div",{className:_d()(XSe.bulldozeBar,t&&XSe.active)})},oTe=function(){return(0,z.jsx)("div",{className:XSe.top,children:(0,z.jsx)("div",{className:XSe.topInner,children:(0,z.jsxs)(Ap,{focusKey:ZSe,initialFocused:eTe,direction:gp.Horizontal,children:[(0,z.jsxs)("div",{className:XSe.start,children:[(0,z.jsx)(GSe,{}),tTe,(0,z.jsx)(LSe,{}),tTe,(0,z.jsx)(vSe,{})]}),(0,z.jsx)(KSe,{focusKey:eTe}),(0,z.jsxs)("div",{className:XSe.end,children:[nTe,(0,z.jsx)(DSe,{}),tTe,(0,z.jsx)(FSe,{}),tTe,(0,z.jsx)(USe,{}),tTe,(0,z.jsx)($Se,{}),nTe,(0,z.jsx)(BSe,{})]})]})})})},aTe=function(){var e=xl(CN);return(0,z.jsx)("div",{className:_d()(XSe.bottom,e&&XSe.paused),children:(0,z.jsx)("div",{className:XSe.bottomInner,children:(0,z.jsxs)(Ap,{focusKey:JSe,children:[(0,z.jsx)(B8,{}),(0,z.jsx)(b6,{}),(0,z.jsx)(VEe,{}),(0,z.jsx)(aSe,{}),(0,z.jsx)(nSe,{}),(0,z.jsx)($Ee,{})]})})})};oe.add("game-ui/game/components/toolbar/toolbar.tsx",{get Toolbar(){return rTe},set Toolbar(e){rTe=e}});var sTe=function(e){var t=e.children,n=xl(Vg),r=xl(Hg),i=xl(Mg),o=GM(),a=(0,Y.useMemo)((function(){return{"Continue Tutorial":Xg}}),[]),s=(0,Y.useMemo)((function(){return{"Previous Tutorial Phase":FM}}),[]),l=(0,Y.useMemo)((function(){return{"Focus Tutorial List":qg}}),[]),c=(0,Y.useMemo)((function(){return{Advisor:ch}}),[]);(0,Y.useEffect)((function(){null!==r&&Gg(!1)}),[r]);var u=null!=i&&null==r,d=null!=n&&null!=r&&kM(n,r),f=null!=n&&null!=r&&RM(n,r);return(0,z.jsx)(rp,{actions:c,disabled:!o,children:(0,z.jsx)(rp,{actions:l,disabled:!u,children:(0,z.jsx)(rp,{actions:a,disabled:!d,children:(0,z.jsx)(rp,{actions:s,disabled:!f,children:t})})})})};oe.add("game-ui/game/components/tutorials/tutorial-action-consumer.tsx",{get TutorialActionConsumer(){return sTe},set TutorialActionConsumer(e){sTe=e}});let lTe={header:"header_Quv header_Bpo child-opacity-transition_nkS",content:"content_OGC content_AD7 child-opacity-transition_nkS",footer:"footer_H3w footer_pD5 child-opacity-transition_nkS"};oe.add("game-ui/common/panel/themes/light.module.scss",{get classes(){return lTe},set classes(e){Object.assign(lTe,e)}});const cTe=lTe;let uTe={wrapper:"wrapper_GJY",wide:"wide_RVn","image-layout":"image-layout_DU8",imageLayout:"image-layout_DU8",image:"image_KoE",chirper:"chirper_KjN",logo:"logo_igH",content:"content_vpm",title:"title_QRS",subtitle:"subtitle_gN8",description:"description_VKr","checkbox-container":"checkbox-container_ety",checkboxContainer:"checkbox-container_ety","checkbox-label":"checkbox-label_YsL",checkboxLabel:"checkbox-label_YsL",checkbox:"checkbox_OCf",divider:"divider_agt","button-container":"button-container_vXF",buttonContainer:"button-container_vXF",button:"button_b9w","dialog-button":"dialog-button_iCQ",dialogButton:"dialog-button_iCQ"};oe.add("game-ui/game/components/tutorials/tutorial-intro-panel/tutorial-intro-panel.module.scss",{get classes(){return uTe},set classes(e){Object.assign(uTe,e)}});const dTe=uTe;function fTe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function mTe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return fTe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return fTe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var gTe,hTe=new Wh("BEGIN");!function(e){e[e.Welcome=0]="Welcome",e[e.Preface=1]="Preface",e[e.TutorialConfirmation=2]="TutorialConfirmation"}(gTe||(gTe={}));var pTe=function(e){var t=e.focusKey,n=mTe((0,Y.useState)(gTe.Welcome),2),r=n[0],i=n[1],o=(0,Y.useCallback)((function(e){return i(e?gTe.Preface:gTe.TutorialConfirmation)}),[]),a=(0,Y.useCallback)((function(e){e?i(gTe.Welcome):Zg(!1)}),[]),s=(0,Y.useCallback)((function(){return Zg(!0)}),[]);return(0,z.jsx)(qj,{focusKey:t,theme:cTe,className:dTe.tutorialIntroPanel,contentClassName:dTe.content,children:(0,z.jsxs)(Ap,{initialFocused:hTe,children:[r===gTe.Welcome&&(0,z.jsx)(vTe,{onContinue:o}),r===gTe.Preface&&(0,z.jsx)(bTe,{onContinue:s}),r===gTe.TutorialConfirmation&&(0,z.jsx)(yTe,{onContinue:a})]})})},vTe=function(e){var t=e.onContinue,n=mTe((0,Y.useState)(!0),2),r=n[0],i=n[1],o=(0,Y.useCallback)((function(){t(r)}),[r,t]);return(0,z.jsxs)("div",{className:_d()(dTe.wrapper,dTe.wide),children:[(0,z.jsxs)("div",{className:dTe.imageLayout,children:[(0,z.jsx)("img",{src:"Media/Game/Milestones/Cityscape01.svg",className:dTe.image}),(0,z.jsx)("img",{src:"Media/Tutorials/GameLogo.svg",className:dTe.logo})]}),(0,z.jsx)("div",{className:dTe.title,children:(0,z.jsx)(qc.Tutorials.INTRO_TITLE,{})}),(0,z.jsx)("div",{className:dTe.subtitle,children:(0,z.jsx)(qc.Tutorials.INTRO_SUBTITLE,{})}),(0,z.jsx)("div",{className:dTe.description,children:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.Tutorials.INTRO,{})})}),(0,z.jsx)(Qp,{focusKey:hTe,theme:Jp,className:dTe.button,onSelect:o,children:(0,z.jsx)(qc.Tutorials.BEGIN_WITH_TUTORIALS,{})}),(0,z.jsxs)(zv,{className:dTe.checkboxContainer,children:[(0,z.jsx)(fv,{checked:r,onChange:i,className:dTe.checkbox}),(0,z.jsx)("div",{className:dTe.checkboxLabel,children:(0,z.jsx)(qc.Tutorials.ENABLE_TUTORIALS_CONFIRM,{})})]})]})},bTe=function(e){var t=e.onContinue,n=(0,Y.useCallback)((function(){return t(!0)}),[t]);return(0,z.jsxs)("div",{className:dTe.wrapper,children:[(0,z.jsxs)("div",{className:dTe.imageLayout,children:[(0,z.jsx)("img",{src:"Media/Tutorials/GameLogo.svg",className:dTe.logo}),(0,z.jsx)("img",{src:"Media/Game/Icons/Chirper.svg",className:dTe.chirper})]}),(0,z.jsx)("div",{className:dTe.divider}),(0,z.jsx)("div",{className:dTe.description,children:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.Tutorials.BEFORE_STARTING,{})})}),(0,z.jsx)(Qp,{theme:Jp,className:dTe.button,onSelect:n,children:(0,z.jsx)(qc.Tutorials.BEFORE_STARTING_CONFIRM,{})})]})},yTe=function(e){var t=e.onContinue,n=(0,Y.useCallback)((function(){return t(!1)}),[t]),r=(0,Y.useCallback)((function(){return t(!0)}),[t]),i=Pg();return(0,z.jsxs)("div",{className:dTe.wrapper,children:[(0,z.jsxs)("div",{className:dTe.imageLayout,children:[(0,z.jsx)("img",{src:"Media/Tutorials/GameLogo.svg",className:dTe.logo}),(0,z.jsx)("img",{src:"Media/Game/Icons/Chirper.svg",className:dTe.chirper})]}),(0,z.jsx)("div",{className:dTe.divider}),(0,z.jsx)("div",{className:dTe.description,children:(0,z.jsx)(Fv,{renderer:_M,children:i?(0,z.jsx)(qc.Tutorials.DISABLE_CONFIRMATION_TEXT_GAMEPAD,{}):(0,z.jsx)(qc.Tutorials.DISABLE_CONFIRMATION_TEXT,{})})}),(0,z.jsxs)("div",{className:dTe.buttonContainer,children:[(0,z.jsx)(Qp,{theme:Jp,className:_d()(dTe.button,dTe.dialogButton),onSelect:n,children:(0,z.jsx)(qc.Common.YES,{})}),(0,z.jsx)(Qp,{theme:Jp,className:_d()(dTe.button,dTe.dialogButton,Jp.negative),onSelect:r,children:(0,z.jsx)(qc.Common.NO,{})})]})]})};oe.add("game-ui/game/components/tutorials/tutorial-intro-panel/tutorial-intro-panel.tsx",{get TutorialIntroPanel(){return pTe},set TutorialIntroPanel(e){pTe=e}});var xTe=new Wh("BEGIN"),_Te=function(e){var t=e.focusKey;return(0,z.jsx)(qj,{focusKey:t,theme:cTe,className:dTe.tutorialIntroPanel,contentClassName:dTe.content,children:(0,z.jsx)(Ap,{initialFocused:xTe,children:(0,z.jsxs)("div",{className:dTe.wrapper,children:[(0,z.jsxs)("div",{className:dTe.imageLayout,children:[(0,z.jsx)("img",{src:"Media/Tutorials/GameLogo.svg",className:dTe.logo}),(0,z.jsx)("img",{src:"Media/Game/Icons/Chirper.svg",className:dTe.chirper})]}),(0,z.jsx)("div",{className:dTe.divider}),(0,z.jsx)("div",{className:dTe.description,children:(0,z.jsx)(Fv,{children:(0,z.jsx)(qc.Tutorials.TODO_INTRO,{})})}),(0,z.jsx)(Qp,{theme:Jp,className:dTe.button,onSelect:Jg,children:(0,z.jsx)(qc.Tutorials.TODO_INTRO_CONFIRM,{})})]})})})};oe.add("game-ui/game/components/tutorials/tutorial-intro-panel/tutorial-list-intro-panel.tsx",{get TutorialListIntroPanel(){return _Te},set TutorialListIntroPanel(e){_Te=e}});var jTe=new Wh("BEGIN"),OTe=function(e){var t=e.focusKey,n=Pg(),r=(0,Y.useCallback)((function(){P_(S_.newGame),eh()}),[]);return(0,z.jsx)(qj,{focusKey:t,theme:cTe,className:dTe.tutorialIntroPanel,contentClassName:dTe.content,children:(0,z.jsx)(Ap,{initialFocused:jTe,children:(0,z.jsxs)("div",{className:_d()(dTe.wrapper,dTe.wide),children:[(0,z.jsxs)("div",{className:dTe.imageLayout,children:[(0,z.jsx)("img",{src:"Media/Tutorials/GameLogo.svg",className:dTe.logo}),(0,z.jsx)("img",{src:"Media/Game/Icons/Chirper.svg",className:dTe.chirper})]}),(0,z.jsx)("div",{className:dTe.divider}),(0,z.jsx)("div",{className:dTe.description,children:(0,z.jsx)(Fv,{renderer:_M,children:n?(0,z.jsx)(qc.Tutorials.TODO_OUTRO_GAMEPAD,{}):(0,z.jsx)(qc.Tutorials.TODO_OUTRO,{})})}),(0,z.jsxs)("div",{className:dTe.buttonContainer,children:[(0,z.jsx)(Qp,{theme:Jp,className:_d()(dTe.button,dTe.dialogButton),onSelect:eh,children:(0,z.jsx)(qc.Tutorials.TODO_OUTRO_CONTINUE,{})}),(0,z.jsx)(Qp,{theme:Jp,className:_d()(dTe.button,dTe.dialogButton,Jp.negative),onSelect:r,children:(0,z.jsx)(qc.Tutorials.TODO_OUTRO_NEW_CITY,{})})]})]})})})};oe.add("game-ui/game/components/tutorials/tutorial-intro-panel/tutorial-list-outro-panel.tsx",{get TutorialListOutroPanel(){return OTe},set TutorialListOutroPanel(e){OTe=e}});let ETe={"foldout-item":"foldout-item_EBr foldout-item_wOF",foldoutItem:"foldout-item_EBr foldout-item_wOF",category:"category_Zf1",header:"header_h0B header_8H_ item-mouse-states_Fmi item-focused_FuT","header-content":"header-content_owU header-content_wUX",headerContent:"header-content_owU header-content_wUX",icon:"icon_pQQ icon_I32",toggle:"toggle_NYV toggle_yQv"};oe.add("game-ui/common/foldout/themes/advisor-item.module.scss",{get classes(){return ETe},set classes(e){Object.assign(ETe,e)}});const STe=ETe;let TTe={"advisor-panel":"advisor-panel_dXi",advisorPanel:"advisor-panel_dXi",scrollable:"scrollable_jAA",content:"content_Q2v"};oe.add("game-ui/game/components/advisor-panel/advisor-panel.module.scss",{get classes(){return TTe},set classes(e){Object.assign(TTe,e)}});const ITe=TTe;var wTe=function(e){var t=e.expanded,n=e.className,r=e.focusKey,i=e.onClose,o=e.onToggle,a=xl(Dg),s=xl(Ag);return(0,z.jsx)(G6,{isFocusRoot:!0,onClose:i,expanded:t,onToggleExpanded:o,focusKey:r,headerText:(0,z.jsx)(qc.Tutorials.ADVISOR_TITLE,{}),transitionSounds:vj,className:_d()(ITe.advisorPanel,n),children:(0,z.jsx)(Ap,{children:(0,z.jsx)(gE,{className:ITe.scrollable,children:a.filter((function(e){return!s||e.shown&&!e.locked})).map((function(e,t){return(0,z.jsx)(PTe,{category:e,showAll:!s},t)}))})})})},PTe=function(e){var t=e.category,n=e.showAll;return(0,z.jsx)(vS,{initialExpanded:!0,header:(0,z.jsx)(bS,{children:(0,z.jsx)(qc.Tutorials.TITLE,{hash:t.name})}),theme:STe,type:"Category",children:t.children.filter((function(e){return(n||e.shown)&&!e.locked})).map((function(e,t){return e.type===ah.Tutorial?(0,z.jsx)(NTe,{item:e,showAll:n},t):(0,z.jsx)(CTe,{item:e,showAll:n},t)}))})},CTe=function(e){var t=e.item,n=e.type,r=void 0===n?"Group":n,i=e.nesting,o=void 0===i?1:i,a=e.showAll,s=(0,Y.useMemo)((function(){return o+1}),[o]);return(0,z.jsx)(vS,{header:(0,z.jsx)(bS,{icon:t.icon&&(0,z.jsx)("img",{src:t.icon}),children:(0,z.jsx)(qc.Tutorials.TITLE,{hash:t.name})}),theme:STe,nesting:o,type:r,children:t.children.filter((function(e){return(a||e.shown)&&!e.locked})).map((function(e,t){return e.type===ah.Tutorial?(0,z.jsx)(NTe,{item:e,showAll:a,nesting:s},t):(0,z.jsx)(CTe,{item:e,showAll:a,nesting:s},t)}))})},NTe=function(e){var t=e.item,n=e.type,r=void 0===n?"Item":n,i=e.nesting,o=void 0===i?1:i,a=e.showAll,s=Ol(Bg,t.entity),l=xl(qm),c=(0,Y.useMemo)((function(){return o+1}),[o]),u=(0,Y.useCallback)((function(){(null==s?void 0:s.active)?zg(ty):$g(t.entity,ty,!0)}),[t.entity,null==s?void 0:s.active]);return(0,z.jsx)(z.Fragment,{children:s&&LTe(s,l)?(0,z.jsx)(vS,{header:(0,z.jsx)(bS,{icon:t.icon&&(0,z.jsx)("img",{src:t.icon}),children:(0,z.jsx)(qc.Tutorials.TITLE,{hash:t.name})}),theme:STe,nesting:o,type:r,onSelect:s.phases.length>1?void 0:u,children:s.phases.length>1?s.phases.filter((function(e){return a||e.shown})).map((function(e,t){return(0,z.jsx)(ATe,{tutorial:s,phase:e,nesting:c},t)})):void 0}):void 0})},ATe=function(e){var t=e.tutorial,n=e.phase,r=e.nesting,i=(0,Y.useCallback)((function(){(null==n?void 0:n.active)?zg(ty):$g(t.entity,n.entity,!0)}),[t,n]),o=t.phases.findIndex((function(e){return Qs(e.entity,n.entity)})),a=t.phases.findIndex((function(e){var t;return null===(t=e.trigger)||void 0===t?void 0:t.phaseBranching})),s=a>=0&&o>a?n.isBranch?r+1:r+2:r;return(0,z.jsx)(vS,{header:(0,z.jsx)(bS,{icon:(0,z.jsx)("img",{src:"Media/Game/Icons/TutorialPhase.svg"}),children:(0,z.jsx)(qc.Tutorials.TITLE,{hash:n.name})}),theme:STe,nesting:s,onSelect:i,className:_d()((null==n?void 0:n.active)&&"selected")})},LTe=function(e,t){switch(t){case Wm.gamepad:var n;return!(null===(n=e.filters)||void 0===n?void 0:n.includes("KeyboardAndMouse"));case Wm.keyboardAndMouse:var r;return!(null===(r=e.filters)||void 0===r?void 0:r.includes("Gamepad"));default:return!1}};oe.add("game-ui/game/components/advisor-panel/advisor-panel.tsx",{get AdvisorPanel(){return wTe},set AdvisorPanel(e){wTe=e}});let MTe={enter:"enter_wwI","enter-active":"enter-active_p_T",enterActive:"enter-active_p_T",exit:"exit_rZO","exit-active":"exit-active_vTx",exitActive:"exit-active_vTx"};oe.add("game-ui/game/components/tutorials/tutorial-panel-transition.module.scss",{get classes(){return MTe},set classes(e){Object.assign(MTe,e)}});const kTe=MTe;let RTe={"panel-content":"panel-content_p59",panelContent:"panel-content_p59","tutorial-layout":"tutorial-layout_dTO tutorial-layout_iuN",tutorialLayout:"tutorial-layout_dTO tutorial-layout_iuN",image:"image_e92 image_NyN",columns:"columns_WiK columns_ITy",scrollable:"scrollable_pas scrollable_ErH"};oe.add("game-ui/game/components/tutorials/tutorial-card/tutorial-card.module.scss",{get classes(){return RTe},set classes(e){Object.assign(RTe,e)}});const DTe=RTe;var FTe=function(e){var t=e.tutorial,n=e.phase,r=e.className,i=e.expanded,o=e.onToggle,a=e.onClose,s=(null==t?void 0:t.completed)||(null==t?void 0:t.advisorActivation)||!(null==t?void 0:t.mandatory);return(0,z.jsx)(G6,{isFocusRoot:!0,headerText:n&&(0,z.jsx)(qc.Tutorials.TITLE,{hash:n.name}),theme:xse,expanded:i,transition:kTe,transitionSounds:vj,className:_d()(DTe.tutorialCard,r),contentClassName:DTe.panelContent,onToggleExpanded:o,onClose:s?a:void 0,children:t&&n&&(0,z.jsx)(zM,{pagesVisible:!0,tutorial:t,phase:n,theme:DTe,scrollable:!0})})};oe.add("game-ui/game/components/tutorials/tutorial-card/tutorial-card.tsx",{get TutorialCard(){return FTe},set TutorialCard(e){FTe=e}});let UTe={"tutorial-center-card":"tutorial-center-card_j6a",tutorialCenterCard:"tutorial-center-card_j6a",image:"image_khW image_NyN"};oe.add("game-ui/game/components/tutorials/tutorial-center-card/tutorial-center-card.module.scss",{get classes(){return UTe},set classes(e){Object.assign(UTe,e)}});const GTe=UTe;var BTe=function(e){var t=e.tutorial,n=e.phase,r=e.className,i=e.onClose,o=(null==t?void 0:t.completed)||(null==t?void 0:t.advisorActivation)||!(null==t?void 0:t.mandatory);return(0,z.jsx)(qj,{header:t&&(0,z.jsx)(tO,{children:(0,z.jsx)(qc.Tutorials.TITLE,{hash:t.name})}),theme:xse,transitionSounds:vj,className:_d()(GTe.tutorialCenterCard,r),onClose:o?i:void 0,children:t&&n&&(0,z.jsx)(zM,{theme:GTe,tutorial:t,phase:n,pagesVisible:!1})})};oe.add("game-ui/game/components/tutorials/tutorial-center-card/tutorial-center-card.tsx",{get TutorialCenterCard(){return BTe},set TutorialCenterCard(e){BTe=e}});let VTe={toggle:"toggle_Tm5"};oe.add("game-ui/game/components/tutorials/tutorial-list-panel/tutorial-list-checkbox.module.scss",{get classes(){return VTe},set classes(e){Object.assign(VTe,e)}});const HTe=VTe;let KTe={"tutorial-list-panel":"tutorial-list-panel_lGU",tutorialListPanel:"tutorial-list-panel_lGU",header:"header_GVY",content:"content_oLZ tutorial-layout_iuN",hints:"hints_enS tutorial-layout_iuN","hints-content":"hints-content_Mmn",hintsContent:"hints-content_Mmn",item:"item_GYF",selected:"selected_txY",checkbox:"checkbox_y4W",title:"title_SfK",label:"label_nNX","play-button":"play-button_Zaj",playButton:"play-button_Zaj",blink:"blink_hSS",completed:"completed_tbu",none:"none_tvP","play-icon":"play-icon_Bax",playIcon:"play-icon_Bax"};oe.add("game-ui/game/components/tutorials/tutorial-list-panel/tutorial-list-panel.module.scss",{get classes(){return KTe},set classes(e){Object.assign(KTe,e)}});const WTe=KTe;var zTe=function(e){var t=e.list,n=e.className,r=e.expanded,i=e.onToggle,o=e.focusKey,a=xl(Vg),s=xl(kg),l=(0,Y.useMemo)((function(){var e,n;return null==t?void 0:t.hints.filter((function(e){return null!=e&&e.completed})).sort((function(t,r){return(null!==(e=null==t?void 0:t.priority)&&void 0!==e?e:0)-(null!==(n=null==r?void 0:r.priority)&&void 0!==n?n:0)}))}),[null==t?void 0:t.hints]),c=(0,Y.useMemo)((function(){return{Back:function(){Gg(!1)}}}),[]),u=xl(Ug),d=Pg();return ey(!u||!d),(0,z.jsx)(rp,{actions:c,children:(0,z.jsx)(G6,{isFocusRoot:!0,expanded:r,focusKey:o,headerText:t&&(0,z.jsx)(qc.Tutorials.TITLE,{hash:t.name}),theme:xse,onToggleExpanded:i,transition:kTe,transitionSounds:vj,className:_d()(WTe.tutorialListPanel,n),children:(0,z.jsxs)(Ap,{children:[(0,z.jsxs)("div",{className:WTe.content,children:[(0,z.jsx)("div",{className:WTe.header,children:(0,z.jsx)(qc.Tutorials.TASKS,{})}),null==t?void 0:t.tutorials.map((function(e){var t,n=null==e||null===(t=e.alternatives)||void 0===t?void 0:t.some((function(e){return Qs(e,s)})),r=null==e||!Qs(e.entity,s)&&!n&&!(e.active||e.completed);return null!=e&&(0,z.jsx)(YTe,{tutorial:e,active:Qs(e.entity,null==a?void 0:a.entity),disabled:r},qs(e.entity))}))]}),l&&l.length>0&&(0,z.jsx)($Te,{activeTutorial:a,hints:l})]})})})},YTe=function(e){var t=e.tutorial,n=e.disabled,r=void 0!==n&&n,i=e.active,o=void 0!==i&&i,a=e.hint,s=void 0!==a&&a,l=(0,Y.useCallback)((function(){return!o&&$g(t.entity,ty,!1)}),[o,t.entity]);return(0,z.jsxs)(Qp,{disabled:r,className:_d()(WTe.item,t.completed&&WTe.completed,o&&WTe.selected),onSelect:l,children:[(0,z.jsx)("div",{className:_d()(WTe.playButton,r&&"disabled"),children:(0,z.jsx)(tb,{src:"Media/Radio/Play.svg",className:WTe.playIcon})}),(0,z.jsxs)("div",{className:WTe.title,children:[(0,z.jsx)("div",{className:WTe.label,children:(0,z.jsx)(qc.Tutorials.TITLE,{hash:t.name})}),!s&&(0,z.jsx)(fv,{focusKey:Hh,checked:t.completed,disabled:r,theme:HTe,className:WTe.checkbox})]})]})},$Te=function(e){var t=e.activeTutorial,n=e.hints;return(0,z.jsxs)("div",{className:WTe.hints,children:[(0,z.jsx)("div",{className:WTe.header,children:(0,z.jsx)(qc.Tutorials.HINTS_TITLE,{})}),(0,z.jsx)(gE,{className:WTe.hintsContent,children:n.map((function(e){return e&&(0,z.jsx)(YTe,{hint:!0,tutorial:e,active:Qs(null==t?void 0:t.entity,e.entity)},qs(e.entity))}))})]})};oe.add("game-ui/game/components/tutorials/tutorial-list-panel/tutorial-list-panel.tsx",{get TutorialListPanel(){return zTe},set TutorialListPanel(e){zTe=e}});var qTe=function(e){var t=e.onClose,n=e.className;return(0,z.jsx)(qj,{onClose:t,header:(0,z.jsx)(tO,{children:(0,z.jsx)(qc.Tutorials.LIST_REMINDER_TITLE,{})}),theme:xse,transitionSounds:vj,className:_d()(GTe.tutorialCenterCard,n),children:(0,z.jsx)(YM,{image:"Media/Tutorials/ReminderPanel.png",description:(0,z.jsx)(qc.Tutorials.LIST_REMINDER_DESCRIPTION,{}),nextVisible:!0,handleActivateNextPhase:t})})};oe.add("game-ui/game/components/tutorials/tutorial-list-reminder.tsx",{get TutorialListReminder(){return qTe},set TutorialListReminder(e){qTe=e}});let XTe={"top-right-layout":"top-right-layout_sSC",topRightLayout:"top-right-layout_sSC","top-right-panel":"top-right-panel_A2r",topRightPanel:"top-right-panel_A2r","list-panel":"list-panel_MBq top-right-panel_A2r",listPanel:"list-panel_MBq top-right-panel_A2r","advisor-panel":"advisor-panel_mrr top-right-panel_A2r",advisorPanel:"advisor-panel_mrr top-right-panel_A2r","card-panel":"card-panel_UGb top-right-panel_A2r",cardPanel:"card-panel_UGb top-right-panel_A2r","center-layout":"center-layout_Uqg",centerLayout:"center-layout_Uqg","tutorial-renderer":"tutorial-renderer_wve",tutorialRenderer:"tutorial-renderer_wve"};oe.add("game-ui/game/components/tutorials/tutorial-renderer/tutorial-renderer.module.scss",{get classes(){return XTe},set classes(e){Object.assign(XTe,e)}});const QTe=XTe;function ZTe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function JTe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return ZTe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return ZTe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var eIe=function(e){var t=e.className,n=e.tutorialListFocusKey,r=xl(Mg),i=xl(Vg),o=xl(Hg),a=(null==o?void 0:o.type)===sh.Card,s=(null==o?void 0:o.type)===sh.CenterCard,l=xl(Lg),c=xl(Kg),u=xl(Wg),d=xl(F_),f=xl(Rg),m=(0,Y.useMemo)((function(){if(null!==r){if(null!==i)return!r.tutorials.find((function(e){return Qs(e.entity,i.entity)}))&&!r.hints.find((function(e){return Qs(e.entity,i.entity)}));if(!Qs(f,ty))return!r.tutorials.find((function(e){return Qs(e.entity,f)}))&&!r.hints.find((function(e){return Qs(e.entity,f)}))}return!1}),[i,r,f]),g=d===I_.Center||d===I_.Right,h=JTe((0,Y.useState)(!1),2),p=h[0],v=h[1],b=JTe((0,Y.useState)(!1),2),y=b[0],x=b[1],_=JTe((0,Y.useState)(!1),2),j=_[0],O=_[1],E=(0,Y.useCallback)((function(e){v(e),e&&(x(!1),O(!1)),e&&!cd(R_,M_.InfoviewMenu)&&V_()}),[]),S=(0,Y.useCallback)((function(e){x(e),e&&(v(!1),O(!1)),e&&!cd(R_,M_.InfoviewMenu)&&V_()}),[]),T=(0,Y.useCallback)((function(e){O(e),e&&(v(!1),x(!1)),e&&!cd(R_,M_.InfoviewMenu)&&V_()}),[]),I=!(null===r||l||m||c||u),w=xl(lh),P=(0,Y.useMemo)((function(){return!g&&!j&&!p&&(y||a)}),[p,g,y,a,j]),C=(0,Y.useMemo)((function(){return!g&&!p&&(!a||!P||!a&&j)}),[p,g,P,a,j]),N=(0,Y.useMemo)((function(){return!g&&(!P||!a)&&(!C||!I)&&w}),[w,g,P,C,a,I]),A=JTe(tIe(i,r),2),L=A[0],M=A[1];return(0,z.jsxs)("div",{className:_d()(QTe.tutorialRenderer,t),children:[(0,z.jsxs)("div",{className:QTe.topRightLayout,children:[(0,z.jsx)(cS,{in:w,children:(0,z.jsx)(wTe,{focusKey:"AdvisorPanel",expanded:N,onToggle:E,onClose:ch,className:QTe.advisorPanel})}),(0,z.jsx)(cS,{in:I,children:(0,z.jsx)(zTe,{focusKey:n,list:r,expanded:C,onToggle:T,className:QTe.listPanel})}),(0,z.jsx)(cS,{in:a,children:(0,z.jsx)(FTe,{tutorial:i,phase:o,expanded:P,onToggle:S,onClose:Qg,className:QTe.cardPanel})})]}),(0,z.jsxs)("div",{className:QTe.centerLayout,children:[(0,z.jsx)(cS,{in:s,children:(0,z.jsx)(BTe,{tutorial:i,phase:o,onClose:Qg,className:QTe.phasePanel})}),(0,z.jsx)(cS,{in:L,children:(0,z.jsx)(qTe,{onClose:M,className:QTe.phasePanel})})]})]})},tIe=function(e,t){var n=JTe((0,Y.useState)(0),2),r=n[0],i=n[1],o=xl(Kg),a=xl(w_)!==S_.main;return(0,Y.useEffect)((function(){if(!e&&t&&t.intro&&!o){if(!a){var n=0,r=performance.now(),s=function(e){var t=e-r;r=e,i((function(e){return e+t})),n=window.requestAnimationFrame(s)};return n=window.requestAnimationFrame(s),function(){return window.cancelAnimationFrame(n)}}}else i(0)}),[e,t,o,a]),[r>6e4,(0,Y.useCallback)((function(){i(0)}),[])]};oe.add("game-ui/game/components/tutorials/tutorial-renderer/tutorial-renderer.tsx",{get TutorialRenderer(){return eIe},set TutorialRenderer(e){eIe=e}});let nIe={enter:"enter_iKV enter_kO6","enter-active":"enter-active_qll enter-active_lrI",enterActive:"enter-active_qll enter-active_lrI",exit:"exit_pg6 exit_Von","exit-active":"exit-active_feg exit-active_jtN",exitActive:"exit-active_feg exit-active_jtN"};oe.add("game-ui/game/transitions/asset-detail-panel.module.scss",{get classes(){return nIe},set classes(e){Object.assign(nIe,e)}});const rIe=nIe;let iIe={rowCount:"2",columnCount:"10","upgrades-grid":"upgrades-grid_RYy",upgradesGrid:"upgrades-grid_RYy",content:"content_TtB",row:"row_KSZ",item:"item_jVa item-hover_WK8 item-active_Spn",thumbnail:"thumbnail_aLl","not-enough-money":"not-enough-money_YuH",notEnoughMoney:"not-enough-money_YuH",highlight:"highlight_hy5",lock:"lock_W9x",dlc:"dlc_LZ3","already-built":"already-built_J1f",alreadyBuilt:"already-built_J1f","not-enough-money-badge":"not-enough-money-badge_pBb",notEnoughMoneyBadge:"not-enough-money-badge_pBb","page-indicators":"page-indicators_Oap",pageIndicators:"page-indicators_Oap","page-indicator":"page-indicator_y1n",pageIndicator:"page-indicator_y1n"};oe.add("game-ui/game/components/upgrades-menu/upgrade-grid/upgrade-grid.module.scss",{get classes(){return iIe},set classes(e){Object.assign(iIe,e)}});const oIe=iIe;function aIe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function sIe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||cIe(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function lIe(e){return function(e){if(Array.isArray(e))return aIe(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||cIe(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function cIe(e,t){if(e){if("string"==typeof e)return aIe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?aIe(e,t):void 0}}var uIe=function(e){var t,n=e.className,r=e.upgrades,i=e.selectedUpgrade,o=e.onSelectUpgrade,a=DL(o),s=Math.ceil(r.length/9),l=mse(r,9,i),c=ese(r,9,l);rh(null===(t=Ew.value)||void 0===t?void 0:t.upgradeGrid);var u=(0,Y.useMemo)((function(){return(0,z.jsxs)(z.Fragment,{children:[(0,z.jsx)("div",{className:oIe.content,children:(0,z.jsx)(Ip,{focused:qs(i),onChange:a,children:(0,z.jsx)("div",{className:oIe.row,children:c.map((function(e){return(0,z.jsx)(dIe,{upgrade:e,selected:Qs(e.entity,i),onSelect:o},qs(e.entity))}))})})}),(0,z.jsx)("div",{className:oIe.pageIndicators,children:s>1&&lIe(Array(s).keys()).map((function(e){return(0,z.jsx)("div",{onClick:function(){return o(r[9*e].entity)},className:_d()(oIe.pageIndicator,e===l&&"selected")},e)}))})]})}),[a,o,s,c,l,i,r]);return(0,z.jsx)("div",{className:_d()(oIe.upgradesGrid,n),children:zL(u)})},dIe=function(e){var t=e.upgrade,n=e.selected,r=e.onSelect,i=sIe((0,Y.useState)(!1),2),o=i[0],a=i[1],s=(0,Y.useContext)(pae),l=xl(iL),c=(0,Y.useCallback)((function(){return r(t.entity)}),[t.entity,r]),u=(0,Y.useCallback)((function(){return s&&s.showDetails(t.entity)}),[t.entity,s]),d=(0,Y.useCallback)((function(){return s&&s.hideDetails(t.entity)}),[t.entity,s]),f=!(t.locked||t.uniquePlaced)&&null!=t.constructionCost&&("number"==typeof t.constructionCost.value?l<t.constructionCost.value:l<t.constructionCost.value.x),m=Pg()&&o;return(0,Y.useEffect)((function(){null!=s&&(m?s.showDetails(t.entity):s.hideDetails(t.entity))}),[t.entity,s,m]),(0,z.jsx)(Tg,{onFocusChange:a,children:(0,z.jsx)(jh,{tooltip:!s&&(0,z.jsx)(qc.Assets.NAME,{hash:t.name}),children:(0,z.jsxs)(Qp,{focusKey:qs(t.entity),selected:n,className:_d()(oIe.item,f&&oIe.notEnoughMoney),onClick:c,disabled:t.locked||t.uniquePlaced,onMouseOver:u,onMouseLeave:d,children:[(0,z.jsx)("img",{src:t.icon,onError:$v,className:oIe.thumbnail}),t.uniquePlaced&&(0,z.jsx)("img",{src:"Media/Game/Icons/AlreadyBuilt.svg",className:oIe.alreadyBuilt}),f&&(0,z.jsx)("img",{src:"Media/Game/Icons/NoMoney.svg",className:oIe.notEnoughMoneyBadge}),t.highlight&&(0,z.jsx)(_4,{className:oIe.highlight}),t.locked&&(0,z.jsx)(_1,{className:oIe.lock}),t.dlc&&(0,z.jsx)(rse,{icon:t.dlc,className:oIe.dlc})]})})})};oe.add("game-ui/game/components/upgrades-menu/upgrade-grid/upgrade-grid.tsx",{get UpgradeGrid(){return uIe},set UpgradeGrid(e){uIe=e}});let fIe={"asset-panel":"asset-panel_BKG",assetPanel:"asset-panel_BKG","gamepad-active":"gamepad-active_dUD",gamepadActive:"gamepad-active_dUD","detail-container":"detail-container_J4D",detailContainer:"detail-container_J4D","detail-panel":"detail-panel_qkF",detailPanel:"detail-panel_qkF","title-bar":"title-bar_L4S title-bar_I7O child-opacity-transition_nkS",titleBar:"title-bar_L4S title-bar_I7O child-opacity-transition_nkS",title:"title_vx4 title_qub"};oe.add("game-ui/game/components/upgrades-menu/upgrades-menu.module.scss",{get classes(){return fIe},set classes(e){Object.assign(fIe,e)}});const mIe=fIe;function gIe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function hIe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return gIe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return gIe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var pIe,vIe=function(e){var t=e.focusKey,n=e.className,r=e.onClose;yj(vj);var i=Pg(),o=hIe((0,Y.useState)(!1),2),a=o[0],s=o[1],l=xl(xC),c=xl(AL),u=Ol(CL,l),d=(0,Y.useCallback)((function(e){ML(l,e)}),[l]),f=(0,Y.useCallback)((function(){Qs(c,ty)?r():(i&&r(),kL())}),[i,r,c]),m=hIe((0,Y.useState)(ty),2),g=m[0],h=m[1],p=!Qs(g,ty),v=(0,Y.useMemo)((function(){return{showDetails:function(e){return h(e)},hideDetails:function(e){return h((function(t){return Qs(t,e)?ty:t}))}}}),[]);return(0,Y.useEffect)((function(){if(i&&p){var e=Qm.subscribe((function(e){e&&h(ty)}));return function(){return e.dispose()}}}),[i,p]),(0,Y.useEffect)((function(){i&&(a?u.length>0&&ML(l,u[0].entity):kL())}),[a,i,l,u]),(0,z.jsx)(Tg,{onFocusChange:s,children:(0,z.jsx)(ap,{onAction:f,children:(0,z.jsx)(Cm,{styles:hae,children:(0,z.jsxs)(Yv,{focusKey:t,className:n,children:[(0,z.jsx)("div",{className:mIe.detailContainer,children:(0,z.jsx)(Ud,{children:p&&(0,z.jsx)(Cm,{styles:rIe,children:(0,z.jsx)(Qae,{entity:g,className:mIe.detailPanel,upgrade:!0})},"details")})}),(0,z.jsx)(pae.Provider,{value:v,children:(0,z.jsx)(qj,{className:_d()(mIe.assetPanel,i&&mIe.gamepadActive),header:(0,z.jsx)("div",{className:mIe.titleBar,children:(0,z.jsx)("div",{className:mIe.title,children:(0,z.jsx)(qc.UpgradesMenu.TITLE,{})})}),children:(0,z.jsx)(uIe,{upgrades:u,selectedUpgrade:c,onSelectUpgrade:d})})})]})})})})};function bIe(){var e=AOe(),t=xl(xC),n=Ol(CL,t),r=xl(Q_e);return e&&n&&n.length>0&&!r}function yIe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function xIe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return yIe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return yIe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}oe.add("game-ui/game/components/upgrades-menu/upgrades-menu.tsx",{get UpgradesMenu(){return vIe},set UpgradesMenu(e){vIe=e},get useUpgradesMenuVisible(){return bIe},set useUpgradesMenuVisible(e){bIe=e}}),function(e){e[e.none=0]="none",e[e.toolbar=1]="toolbar",e[e.toolOptions=2]="toolOptions",e[e.assetMenu=3]="assetMenu",e[e.upgradesMenu=4]="upgradesMenu",e[e.mapTilePurchase=5]="mapTilePurchase",e[e.selectedInfo=6]="selectedInfo",e[e.infoViews=7]="infoViews",e[e.tutorialIntro=8]="tutorialIntro",e[e.tutorialListIntro=9]="tutorialListIntro",e[e.tutorialListOutro=10]="tutorialListOutro",e[e.tutorialList=11]="tutorialList",e[e.signatureUnlocks=12]="signatureUnlocks",e[e.milestoneUnlocks=13]="milestoneUnlocks",e[e.activeTool=14]="activeTool"}(pIe||(pIe={}));var _Ie=function(e){var t,n=e.focusKey,r=xIe((0,Y.useState)(!1),2),i=r[0],o=r[1],a=xl(CN),s=!Qs(xl(qA),ty),l=d6(),c=xIe((0,Y.useState)(!1),2),u=c[0],d=c[1];(0,Y.useEffect)((function(){l||d(!1)}),[l]);var f=xl(R_),m=cd(f,M_.InfoviewMenu),g=xl(GI),h=xl(wC),p=xl(OP),v=!Qs(p,ty),b=xl(PP),y=!v&&b.length>0,x=xl(VN),_=Pg(),j=xl(D_),O=xl(Lg),E=xl(Vg),S=xl(Kg)&&null===E,T=xl(Wg),I=xl(lh),w=GM(),P=xl(Ug),C=xl(Ag),N=P&&C;(0,Y.useEffect)((function(){!C&&N&&qg()}),[C,N]);var A=AOe(),L=xl(Q_e),M=bIe(),k=xl(xC),R=xIe((0,Y.useState)(!1),2),D=R[0],F=R[1];(0,Y.useEffect)((function(){M||F(!1)}),[M]);var U=(0,Y.useRef)(k);A&&(U.current=k);var G=Kw("Infoviews"),B=_l(ry,jIe,!1),V=B&&!j&&!A&&!m,H=B&&!m&&!V,K=xIe((0,Y.useState)(!1),2),W=K[0],$=K[1];(0,Y.useEffect)((function(){B||$(!1)}),[B]);var q=xl(w_);jte(!((y||v||O||S||T)&&q!==S_.freeCamera));var X=M&&(x.id===xA||D),Q=Loe(),Z=iae(),J=(0,Y.useMemo)((function(){return{"Info View":function(){cd(R_.value,M_.InfoviewMenu)?B_(M_.InfoviewMenu):B?W?(G_(M_.InfoviewMenu),$(!0)):$((function(e){return!e})):G.locked||G_(M_.InfoviewMenu)},"Tool Options":!u&&l?function(){d((function(e){return!e}))}:null,"Upgrades Menu":X?function(){F((function(e){return!e}))}:null,"Move Horizontal":X?function(e){F(e>0)}:null,Quicksave:Q,Quickload:Z}}),[B,G.locked,W,Z,Q,u,l,X]),ee=(0,Y.useCallback)((function(){return d(!1)}),[]),te=(0,Y.useCallback)((function(){return F(!1)}),[]),ne=(0,Y.useCallback)((function(){return kC()}),[]),re=(0,Y.useCallback)((function(){return iy(ty)}),[]);o4();var ie,oe=a4();return ie=O?pIe.tutorialIntro:S?pIe.tutorialListIntro:T?pIe.tutorialListOutro:N?pIe.tutorialList:v?pIe.milestoneUnlocks:y?pIe.signatureUnlocks:null!=f?f.__Type:B&&W?pIe.infoViews:I?"AdvisorPanel":l&&u?pIe.toolOptions:A&&L?pIe.none:A&&!D?pIe.selectedInfo:M&&D?pIe.upgradesMenu:g?pIe.mapTilePurchase:s?pIe.assetMenu:x.id!==xA?pIe.activeTool:pIe.toolbar,(0,z.jsx)(Tg,{onFocusChange:o,children:(0,z.jsx)(Tpe,{children:(0,z.jsx)(sTe,{children:(0,z.jsx)(rp,{actions:J,children:(0,z.jsx)(em,{children:(0,z.jsxs)("div",{className:_d()(nbe.gameMainScreen,_&&!j&&oe,l&&nbe.toolOptionsVisible),children:[(0,z.jsxs)(pj,{focusKey:n,focused:ie,activation:yd.Always,debugName:"GameMainScreen",children:[(0,z.jsxs)("div",{className:nbe.mainContainer,children:[(!_||H)&&(0,z.jsxs)("div",{className:nbe.infoMenuLayout,children:[(0,z.jsx)(dbe,{miniPanelVisible:H}),(0,z.jsx)(H5,{name:"GameTopLeft"})]}),(0,z.jsx)("div",{className:nbe.infoLayout,children:(0,z.jsx)(cS,{in:A,children:(0,z.jsx)(POe,{focusKey:x.id===xA?pIe.selectedInfo:Hh,className:nbe.selectedInfoPanel,onClose:ne})})}),(0,z.jsx)("div",{className:nbe.infoLayout,children:(0,z.jsx)(cS,{in:V,children:(0,z.jsx)(Cee,{focusKey:pIe.infoViews,className:nbe.infoviewMenu,onClose:re})})}),(0,z.jsxs)("div",{className:nbe.toolLayout,children:[(0,z.jsx)("div",{className:nbe.toolSideColumn,children:(0,z.jsx)(cS,{in:l,children:(0,z.jsx)(u6,{focusKey:pIe.toolOptions,onClose:ee})})}),(0,z.jsxs)("div",{className:nbe.toolMainColumn,children:[(0,z.jsx)(cS,{in:s,children:(0,z.jsx)(bse,{focusKey:pIe.assetMenu,onClose:tL,className:nbe.toolPanel})}),(0,z.jsx)(cS,{in:M,children:(0,z.jsx)(vIe,{focusKey:pIe.upgradesMenu,className:nbe.toolPanel,onClose:te})}),(0,z.jsx)(cS,{in:g,children:(0,z.jsx)(ybe,{focusKey:pIe.mapTilePurchase,className:nbe.mapTilePurchasePanel,onClose:qI})})]}),(0,z.jsx)("div",{className:nbe.toolSideColumn})]}),(0,z.jsx)(Ud,{children:f&&(0,z.jsx)(hj,{focusKey:f.__Type,children:(0,z.jsx)(abe,{panel:f})},f.__Type)}),(0,z.jsx)(g6,{className:nbe.bpIndicator}),!_&&(0,z.jsxs)("div",{className:nbe.pauseMenuLayout,children:[(0,z.jsx)(H5,{name:"GameTopRight"}),w&&(0,z.jsx)(e8,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_ADVISOR,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_ADVISOR,{}),children:(0,z.jsx)(mae,{src:"Media/Glyphs/Advisor.svg",className:nbe.advisorMenuToggle,selected:I,onSelect:ch})}),(0,z.jsx)(tk,{uiTag:null===(t=Ew.value)||void 0===t?void 0:t.pauseMenuButton,children:(0,z.jsx)(e8,{title:(0,z.jsx)(qc.Main.TOOLTIP_TITLE_PAUSE_MENU,{}),description:(0,z.jsx)(qc.Main.TOOLTIP_DESCRIPTION_PAUSE_MENU,{}),children:(0,z.jsx)(mae,{src:"Media/Glyphs/Gear.svg",onSelect:A_})})})]})]}),(0,z.jsx)(rTe,{focusKey:pIe.toolbar}),(0,z.jsx)(cS,{in:A&&null!==h,children:A&&h&&(0,z.jsx)(oye,{onClose:ne,developerInfoSection:h})}),(0,z.jsx)("div",{className:_d()(nbe.pauseOverlay,a&&nbe.paused)}),O&&(0,z.jsx)(ij,{children:(0,z.jsx)(pTe,{focusKey:pIe.tutorialIntro})}),S&&(0,z.jsx)(ij,{children:(0,z.jsx)(_Te,{focusKey:pIe.tutorialListIntro})}),T&&(0,z.jsx)(ij,{children:(0,z.jsx)(OTe,{focusKey:pIe.tutorialListOutro})}),y&&(0,z.jsx)(ij,{children:(0,z.jsx)(Ube,{focusKey:pIe.signatureUnlocks,entities:b,onClose:CP})}),v&&(0,z.jsx)(ij,{children:(0,z.jsx)(Mbe,{focusKey:pIe.milestoneUnlocks,milestone:p,onClose:EP})}),i&&_&&(0,z.jsx)(dk,{className:nbe.actionHints}),(0,z.jsx)(eIe,{className:nbe.tutorialsRenderer,tutorialListFocusKey:pIe.tutorialList}),(0,z.jsx)(H5,{name:"Game"})]}),(0,z.jsx)(l8,{})]})})})})})})};function jIe(e,t){return null!=t}function OIe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}oe.add("game-ui/game/components/game-main-screen.tsx",{get GameMainScreen(){return _Ie},set GameMainScreen(e){_Ie=e}});var EIe=function(){var e=xl(w_),t=e!==S_.main&&e!==S_.freeCamera,n=J8();jte(!t);var r=(0,Y.useContext)(dO);(0,Y.useEffect)((function(){var e=kh.subscribe((function(e){r.showDialog((0,z.jsx)(_O,function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){OIe(e,t,n[t])}))}return e}({},e)))}));return function(){return e.dispose()}}),[r]);var i=xl(gG);return(0,Y.useEffect)((function(){!t&&i&&A_()}),[t,i]),(0,z.jsx)(Tte,{children:(0,z.jsx)(ph,{children:(0,z.jsx)(rp,{actions:n,children:(0,z.jsx)(pj,{focused:e,activation:yd.Always,debugName:"GameUI",children:(0,z.jsxs)(Ud,{children:[!t&&(0,z.jsx)(_Ie,{focusKey:S_.main}),t&&(0,z.jsx)(V5,{children:(0,z.jsxs)(Ud,{children:[e===S_.pauseMenu&&(0,z.jsx)(Kne,{focusKey:S_.pauseMenu,onClose:N_},S_.pauseMenu),e===S_.saveGame&&(0,z.jsx)(Noe,{focusKey:S_.saveGame,onClose:A_},S_.saveGame),e===S_.newGame&&(0,z.jsx)(uie,{focusKey:S_.newGame,onClose:A_},S_.newGame),e===S_.loadGame&&(0,z.jsx)(nae,{focusKey:S_.loadGame,onClose:A_,requireConfirmation:!0},S_.loadGame),e===S_.options&&(0,z.jsx)(M5,{focusKey:S_.options,onClose:A_},S_.options)]})},"pause"),e===S_.freeCamera&&(0,z.jsx)(lae,{focusKey:S_.freeCamera,onClose:N_},S_.freeCamera)]})})})})})};oe.add("game-ui/game/components/game-ui.tsx",{get GameUI(){return EIe},set GameUI(e){EIe=e}});var SIe=function(e){var t=e.children,n=xl(qL),r=(0,Y.useMemo)((function(){return{"Switch User":function(){kp(Lp.selectItem),JL()}}}),[]);return(0,z.jsx)(rp,{actions:r,disabled:!n,children:t})};oe.add("game-ui/menu/components/user-switch-prompt/user-switch-prompt-consumer.tsx",{get UserSwitchPromptConsumer(){return SIe},set UserSwitchPromptConsumer(e){SIe=e}});let TIe={"credits-renderer":"credits-renderer_BaD",creditsRenderer:"credits-renderer_BaD",h1:"h1_z8F",h2:"h2_xgG",h3:"h3_LtF",line:"line_hIW","image-line":"image-line_lv2",imageLine:"image-line_lv2",image:"image_idP"};oe.add("game-ui/menu/components/credits-screen/credits-renderer/credits-renderer.module.scss",{get classes(){return TIe},set classes(e){Object.assign(TIe,e)}});const IIe=TIe;function wIe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function PIe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||NIe(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function CIe(e){return function(e){if(Array.isArray(e))return wIe(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||NIe(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function NIe(e,t){if(e){if("string"==typeof e)return wIe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?wIe(e,t):void 0}}var AIe=function(e){var t=e.lines,n=e.images,r=e.onComplete,i=(0,Y.useRef)(null),o=(0,Y.useMemo)((function(){return[[null,Ev.None,[]]].concat(CIe(t),[[null,Ev.None,[]]])}),[t]),a=function(e,t){var n=$O(),r=(0,Y.useCallback)((function(r,i){var o=PIe(r,3),a=(o[0],o[1]),s=o[2];return 0===i?RIe*n:i===e.length-1?DIe*n:s.length>0?(VIe(a,s,t)+kIe)*n:LIe[a]*n}),[n,e.length,t]);return AQ(r,e,1)}(o,n),s=function(e,t){var n=$O();return(0,Y.useCallback)((function(r){if(0===r)return(0,z.jsx)("div",{style:UIe},"start");if(r===e.length-1)return(0,z.jsx)("div",{style:GIe},"end");var i=PIe(e[r],3),o=i[0],a=i[1],s=i[2];if(s.length>0){var l=VIe(a,s,t);return(0,z.jsx)("div",{className:IIe.imageLine,style:{height:(l+kIe)*n},children:s.map((function(e,r){var i=HIe(a,e,t);return(0,z.jsx)("img",{src:e,width:i.x*n,height:i.y*n,className:IIe.image},r)}))},r)}return(0,z.jsx)("div",{className:FIe[a],style:{height:LIe[a]*n},children:o},r)}),[t,e,n])}(o,n),l=PQ(i,a,"vertical",void 0,s),c=l.list,u=l.onScroll,d=$O(),f=(0,Y.useMemo)((function(){return performance.now()}),[]);return(0,Y.useEffect)((function(){if(i.current){var e=0,t=function(n){if(i.current){var o=(n-f)/1e3,a=Math.round(100*o*d),s=i.current.scrollHeight-i.current.offsetHeight;i.current.scrollTop=a,u(),a<s?e=window.requestAnimationFrame(t):r()}};return e=window.requestAnimationFrame(t),function(){return window.cancelAnimationFrame(e)}}}),[u,r,d,f]),(0,z.jsx)("div",{ref:i,className:IIe.creditsRenderer,onScroll:u,children:c})},LIe=[32,160,80,68,32,32,32],MIe=[240,720,480,312,240,240,240],kIe=80,RIe=700,DIe=920;var FIe=[IIe.line,IIe.h1,IIe.h2,IIe.h3,IIe.line,IIe.line,IIe.line],UIe=BIe(RIe),GIe=BIe(DIe);function BIe(e){return{height:"".concat(e,"rem")}}function VIe(e,t,n){var r=0,i=!0,o=!1,a=void 0;try{for(var s,l=t[Symbol.iterator]();!(i=(s=l.next()).done);i=!0){var c=s.value;r=Math.max(r,HIe(e,c,n).y)}}catch(e){o=!0,a=e}finally{try{i||null==l.return||l.return()}finally{if(o)throw a}}return r}function HIe(e,t,n){var r=n.get(t),i=MIe[e];if(null!=r&&r.width>0&&r.height>0){var o=Math.sqrt(i*i/(r.width*r.height));return{x:o*r.width,y:o*r.height}}return{x:MIe[e],y:MIe[e]}}oe.add("game-ui/menu/components/credits-screen/credits-renderer/credits-renderer.tsx",{get CreditsRenderer(){return AIe},set CreditsRenderer(e){AIe=e}});let KIe={content:"content_qY6 child-opacity-transition_nkS"};oe.add("game-ui/menu/components/credits-screen/credits-screen.module.scss",{get classes(){return KIe},set classes(e){Object.assign(KIe,e)}});const WIe=KIe;function zIe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function YIe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return zIe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return zIe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var $Ie=Y.forwardRef((function(e,t){var n,r,i,o,a,s=e.focusKey,l=e.className,c=e.onClose,u=xl(xG),d=(n=u,r=YIe((0,Y.useState)(null),2),i=r[0],o=r[1],a=Array.isArray(n)?n:[n],(0,Y.useEffect)((function(){var e=0,t=[],n=a.map((function(n,r){return qIe(n,(function(n){t[r]=n,++e===a.length&&o(t.flat())}))}));return function(){n.forEach((function(e){return e()}))}}),[a.join(" ")]),i),f=function(e){var t=YIe((0,Y.useState)(null),2),n=t[0],r=t[1];return(0,Y.useEffect)((function(){var t=0,n=new Map,i=function(){++t===n.size&&r(n)};if(null!=e){var o=!0,a=!1,s=void 0;try{for(var l,c=e[Symbol.iterator]();!(o=(l=c.next()).done);o=!0){var u=YIe(l.value,3)[2],d=!0,f=!1,m=void 0;try{for(var g,h=u[Symbol.iterator]();!(d=(g=h.next()).done);d=!0){var p=g.value;if(!n.has(p)){var v=new Image;v.src=p,v.addEventListener("load",i),v.addEventListener("error",i),n.set(p,v)}}}catch(e){f=!0,m=e}finally{try{d||null==h.return||h.return()}finally{if(f)throw m}}}}catch(e){a=!0,s=e}finally{try{o||null==c.return||c.return()}finally{if(a)throw s}}}return 0===n.size&&r(n),function(){var e=!0,t=!1,r=void 0;try{for(var o,a=n.values()[Symbol.iterator]();!(e=(o=a.next()).done);e=!0){var s=o.value;s.removeEventListener("load",i),s.removeEventListener("error",i)}}catch(e){t=!0,r=e}finally{try{e||null==a.return||a.return()}finally{if(t)throw r}}}}),[e]),n}(d);return(0,z.jsx)(r2,{ref:t,focusKey:s,title:(0,z.jsx)(qc.Menu.CREDITS,{}),className:l,onClose:c,children:(0,z.jsx)("div",{className:WIe.content,children:(null==d?void 0:d.length)&&null!=f&&(0,z.jsx)(AIe,{lines:d,images:f,onComplete:c})})})})),qIe=function(e,t){var n=new XMLHttpRequest;return n.open("GET",e),n.onload=function(){var e=new FS,r=Bv(n.responseText,!0,!0,250,150).map((function(t){return e.render(t)}));t(r)},n.send(),function(){n.abort()}};oe.add("game-ui/menu/components/credits-screen/credits-screen.tsx",{get CreditsScreen(){return $Ie},set CreditsScreen(e){$Ie=e}});let XIe={"user-switch-prompt":"user-switch-prompt_UJI",userSwitchPrompt:"user-switch-prompt_UJI",avatar:"avatar_MH0",label:"label_deh",action:"action_J_6"};oe.add("game-ui/menu/components/user-switch-prompt/user-switch-prompt.module.scss",{get classes(){return XIe},set classes(e){Object.assign(XIe,e)}});const QIe=XIe;function ZIe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function JIe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return ZIe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return ZIe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var ewe="Media/AvatarFallback.svg",twe=function(e){var t=e.className,n=Pg(),r=xl(XL),i=xl(QL),o=JIe(function(e){var t=JIe((0,Y.useState)(null),2),n=t[0],r=t[1];(0,Y.useEffect)((function(){return r((function(t){return e!==t?null:e}))}),[e]);var i=null!==e&&e!==n?e:ewe,o=(0,Y.useCallback)((function(){return e!==ewe&&r(e)}),[e]);return[i,o]}(r),2),a=o[0],s=o[1];return(0,z.jsxs)(Qp,{focusKey:Hh,className:_d()(QIe.userSwitchPrompt,t),onSelect:JL,children:[(0,z.jsx)("img",{src:a||void 0,onError:s,className:QIe.avatar}),(0,z.jsx)("div",{className:QIe.label,children:Zs(i)?(0,z.jsx)(qc.Menu.SWITCH_USER,{}):i}),n&&(0,z.jsx)(dk,{specifiedActions:["Switch User"],labels:!1})]})};oe.add("game-ui/menu/components/user-switch-prompt/user-switch-prompt.tsx",{get UserSwitchPrompt(){return twe},set UserSwitchPrompt(e){twe=e}});var nwe,rwe="whatsnew",iwe=fl(rwe,"panel"),owe=fl(rwe,"visible"),awe=fl(rwe,"initialTab"),swe=vl(rwe,"close");!function(e){e[e.Left=0]="Left",e[e.Center=1]="Center",e[e.Right=2]="Right"}(nwe||(nwe={})),oe.add("game-ui/menu/data-binding/whats-new-bindings.ts",{get whatsNewPanel(){return whatsNewPanel},set whatsNewPanel(e){whatsNewPanel=e},get whatsNewPanelVisible(){return whatsNewPanelVisible},set whatsNewPanelVisible(e){whatsNewPanelVisible=e},get whatsNewPanelInitialTab(){return whatsNewPanelInitialTab},set whatsNewPanelInitialTab(e){whatsNewPanelInitialTab=e},get closeWhatsNewPanel(){return swe},set closeWhatsNewPanel(e){swe=e},get Justify(){return nwe},set Justify(e){nwe=e}});let lwe={"page-switcher":"page-switcher_dTl",pageSwitcher:"page-switcher_dTl",page:"page_pOh"};oe.add("game-ui/common/animations/paging/page-switcher.module.scss",{get classes(){return lwe},set classes(e){Object.assign(lwe,e)}});const cwe=lwe;function uwe(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function dwe(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){uwe(e,t,n[t])}))}return e}function fwe(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}(Object(t)).forEach((function(n){Object.defineProperty(e,n,Object.getOwnPropertyDescriptor(t,n))})),e}function mwe(e,t){if(null==e)return{};var n,r,i=function(e,t){if(null==e)return{};var n,r,i={},o=Object.keys(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||(i[n]=e[n]);return i}(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(r=0;r<o.length;r++)n=o[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(i[n]=e[n])}return i}var gwe,hwe=Y.createContext(null),pwe=Y.createContext(null),vwe=Y.forwardRef((function(e,t){var n=e.activePage,r=e.transitionStyles,i=e.className,o=e.children,a=(0,Y.useRef)({activePage:n,previousPage:n});a.current.activePage!==n&&(a.current={activePage:n,previousPage:a.current.activePage});var s=a.current.previousPage,l=(0,Y.useMemo)((function(){return{activePage:n,previousPage:s,transitionStyles:r}}),[n,s,r]);return(0,z.jsx)("div",{ref:t,className:_d()(cwe.pageSwitcher,i),children:(0,z.jsx)(hwe.Provider,{value:l,children:(0,z.jsx)(pj,{focused:n,children:(0,z.jsx)(Ud,{children:(0,z.jsx)(pwe.Provider,{value:n,children:(0,z.jsx)(hj,{focusKey:n,children:o})},n)})})})})}));!function(e){e[e.None=0]="None",e[e.Previous=1]="Previous",e[e.Next=2]="Next"}(gwe||(gwe={}));var bwe=function(e){var t,n,r=e.className,i=e.children,o=mwe(e,["className","children"]),a=(0,Y.useContext)(hwe),s=(0,Y.useContext)(pwe),l=(0,Y.useMemo)((function(){return null==a||null==s?gwe.None:a.activePage===s?a.previousPage>s?gwe.Previous:gwe.Next:a.previousPage===s?a.activePage>s?gwe.Previous:gwe.Next:gwe.None}),[a,s]);return(0,z.jsx)(Cm,{styles:l!==gwe.None&&null!=a?a.transitionStyles:null,children:(0,z.jsx)("div",fwe(dwe({},o),{className:_d()(cwe.page,r,l===gwe.Previous&&(null==a||null===(t=a.transitionStyles)||void 0===t?void 0:t.previous),l===gwe.Next&&(null==a||null===(n=a.transitionStyles)||void 0===n?void 0:n.next)),children:i}))})};oe.add("game-ui/common/animations/paging/page-switcher.tsx",{get PageSwitcher(){return vwe},set PageSwitcher(e){vwe=e},get Page(){return bwe},set Page(e){bwe=e}});let ywe={enter:"enter_bXD","enter-active":"enter-active_vgh",enterActive:"enter-active_vgh",exit:"exit_XFe","exit-active":"exit-active_BSo",exitActive:"exit-active_BSo",previous:"previous_IPO",next:"next_K_o"};oe.add("game-ui/common/animations/paging/transitions/horizontal-transition.module.scss",{get classes(){return ywe},set classes(e){Object.assign(ywe,e)}});const xwe=ywe;let _we={"dlc-selector":"dlc-selector_tES",dlcSelector:"dlc-selector_tES",button:"button_Sv_",header:"header_fRa",icon:"icon_m9v",title:"title_eie",page:"page_dx1","page-content":"page-content_glG",pageContent:"page-content_glG",spacer:"spacer_YWX"};oe.add("game-ui/menu/components/whats-new-panel/dlc-selector/dlc-selector.module.scss",{get classes(){return _we},set classes(e){Object.assign(_we,e)}});const jwe=_we;var Owe=Cj({ArrowLeft:"Media/Glyphs/ThickStrokeArrowLeft.svg",ArrowRight:"Media/Glyphs/ThickStrokeArrowRight.svg"}),Ewe=function(e){var t=e.selected,n=e.onSelect,r=iwe.value[t].dlc,i=(0,Y.useCallback)((function(){n(Math.max(0,t-1))}),[n,t]),o=(0,Y.useCallback)((function(){n(Math.min(iwe.value.length-1,t+1))}),[n,t]);return(0,z.jsxs)(Yv,{className:jwe.dlcSelector,children:[iwe.value.length>1&&(0,z.jsx)(lb,{focusKey:Hh,tinted:!0,disabled:0===t,src:Owe.ArrowLeft,className:jwe.button,onSelect:i}),(0,z.jsx)("div",{className:jwe.spacer}),(0,z.jsx)(vwe,{transitionStyles:xwe,className:jwe.header,activePage:t,children:(0,z.jsx)(bwe,{className:jwe.page,children:(0,z.jsxs)("div",{className:jwe.pageContent,children:[(0,z.jsx)(mM,{src:"Media/DLC/".concat(r,".svg"),className:jwe.icon}),(0,z.jsx)("div",{className:jwe.title,children:(0,z.jsx)(qc.Common.DLC_TITLE,{hash:r})})]})})}),iwe.value.length>1&&(0,z.jsx)(lb,{focusKey:Hh,tinted:!0,disabled:t===iwe.value.length-1,src:Owe.ArrowRight,className:jwe.button,onSelect:o})]})};oe.add("game-ui/menu/components/whats-new-panel/dlc-selector/dlc-selector.tsx",{get DlcSelector(){return Ewe},set DlcSelector(e){Ewe=e}});let Swe={"page-selector":"page-selector_JA1",pageSelector:"page-selector_JA1",toggle:"toggle_nf2"};oe.add("game-ui/menu/components/whats-new-panel/page-selector/page-selector.module.scss",{get classes(){return Swe},set classes(e){Object.assign(Swe,e)}});const Twe=Swe;var Iwe=function(e){var t=e.pages,n=e.selected,r=e.onSelect;return(0,z.jsx)("div",{className:Twe.pageSelector,children:t>1&&Array.from({length:t},(function(e,t){return(0,z.jsx)(D1,{focusKey:Hh,checked:n===t,className:Twe.toggle,onChange:function(){return r(t)}},t)}))})};oe.add("game-ui/menu/components/whats-new-panel/page-selector/page-selector.tsx",{get PageSelector(){return Iwe},set PageSelector(e){Iwe=e}});let wwe={"whats-new-page":"whats-new-page_s08",whatsNewPage:"whats-new-page_s08",scrollable:"scrollable_xNZ",item:"item_ze5",images:"images_cAd",text:"text_pzC",title:"title_kTI","sub-title":"sub-title_ltz",subTitle:"sub-title_ltz",paragraphs:"paragraphs_pOF",paragraphsLeft:"paragraphsLeft_AkP",paragraphsRight:"paragraphsRight_HVa",paragraphsCenter:"paragraphsCenter_PXp"};oe.add("game-ui/menu/components/whats-new-panel/whats-new-page/whats-new-page.module.scss",{get classes(){return wwe},set classes(e){Object.assign(wwe,e)}});const Pwe=wwe;var Cwe=function(e){var t,n=e.page,r=Pg();return(0,z.jsx)(bwe,{className:Pwe.whatsNewPage,children:(0,z.jsx)(gE,{className:Pwe.scrollable,autoScroll:r,children:null===(t=n.items)||void 0===t?void 0:t.map((function(e,t){return(0,z.jsx)(Nwe,{item:e},t)}))})})},Nwe=function(e){var t,n=e.item;return(0,z.jsxs)("div",{className:Pwe.item,style:{alignItems:n.justify===nwe.Left?"flex-start":n.justify===nwe.Right?"flex-end":"center"},children:[(null===(t=n.images)||void 0===t?void 0:t.length)>0&&(0,z.jsx)("div",{className:Pwe.images,children:n.images.map((function(e,t){return(0,z.jsx)(mM,{src:e.image,className:Pwe.image,style:Awe(n.justify,e)},t)}))}),n.title&&(0,z.jsx)("div",{className:_d()(Pwe.title,Pwe.text,Pwe.heading),children:(0,z.jsx)(kc,{id:n.title})}),n.subtitle&&(0,z.jsx)("div",{className:_d()(Pwe.subTitle,Pwe.text,Pwe.heading),children:(0,z.jsx)(kc,{id:n.subtitle})}),n.paragraphs&&(0,z.jsx)("div",{className:_d()(Pwe.paragraphs,Pwe.text),children:(0,z.jsx)(Fv,{className:_d()(n.justify===nwe.Left?Pwe.paragraphsLeft:n.justify===nwe.Right?Pwe.paragraphsRight:Pwe.paragraphsCenter),children:(0,z.jsx)(kc,{id:n.paragraphs})})})]})};function Awe(e,t){return{marginLeft:e===nwe.Right?"2%":e===nwe.Left?void 0:"1%",marginRight:e===nwe.Left?"2%":e===nwe.Right?void 0:"1%",width:"".concat(t.width,"%"),"--w":t.aspectRatio.x,"--h":t.aspectRatio.y}}oe.add("game-ui/menu/components/whats-new-panel/whats-new-page/whats-new-page.tsx",{get WhatsNewPage(){return Cwe},set WhatsNewPage(e){Cwe=e}});let Lwe={"whats-new-tab":"whats-new-tab_F6q",whatsNewTab:"whats-new-tab_F6q",fadeIn:"fadeIn_VdL"};oe.add("game-ui/menu/components/whats-new-panel/whats-new-tab/whats-new-tab.module.scss",{get classes(){return Lwe},set classes(e){Object.assign(Lwe,e)}});const Mwe=Lwe;var kwe=function(e){var t=e.tab,n=e.selectedPage;return(0,z.jsx)(vwe,{activePage:n,transitionStyles:xwe,className:Mwe.whatsNewTab,children:(0,z.jsx)(Cwe,{page:t.pages[n]})},t.id)};oe.add("game-ui/menu/components/whats-new-panel/whats-new-tab/whats-new-tab.tsx",{get WhatsNewTab(){return kwe},set WhatsNewTab(e){kwe=e}});let Rwe={"whats-new-panel":"whats-new-panel_hJt menu-theme_k91",whatsNewPanel:"whats-new-panel_hJt menu-theme_k91","button-container":"button-container_iYr",buttonContainer:"button-container_iYr",button:"button__xS",dismiss:"dismiss_Z9k",checkbox:"checkbox_WJa",label:"label_Zni"};oe.add("game-ui/menu/components/whats-new-panel/whats-new-panel.module.scss",{get classes(){return Rwe},set classes(e){Object.assign(Rwe,e)}});const Dwe=Rwe;function Fwe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function Uwe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Fwe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Fwe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Gwe=new Wh("CHILDREN"),Bwe=new Wh("WHATS_NEW_KEY"),Vwe=new Wh("OK"),Hwe=new Wh("DISMISS"),Kwe=function(e){var t,n,r=e.children,i=xl(iwe),o=xl(awe),a=Uwe((0,Y.useState)(o),2),s=a[0],l=a[1],c=Uwe((0,Y.useState)(0),2),u=c[0],d=c[1],f=Uwe((0,Y.useState)(!1),2),m=f[0],g=f[1],h=xl(owe)&&i.length>0,p=(0,Y.useCallback)((function(){return swe(m)}),[m]);n=h?Bwe:Gwe;var v=(0,Y.useMemo)((function(){var e;return{"Switch Slide":(null==i?void 0:i.length)>0&&(null===(e=i[s].pages)||void 0===e?void 0:e.length)>1?function(e){var t;if(e<0&&u>0)kp(Lp.selectPreviousItem),d(Math.max(0,u-1));else if(e>0&&u<(null===(t=iwe.value[s].pages)||void 0===t?void 0:t.length)-1){var n;kp(Lp.selectNextItem),d(Math.min((null===(n=iwe.value[s].pages)||void 0===n?void 0:n.length)-1,u+1))}}:null,"Switch DLC":(null==i?void 0:i.length)>1?function(e){e<0&&s>0?(kp(Lp.selectPreviousItem),d(0),l(Math.max(0,s-1))):e>0&&s<iwe.value.length-1&&(kp(Lp.selectNextItem),d(0),l(Math.min(iwe.value.length-1,s+1)))}:null}}),[u,s,i]),b=(0,Y.useCallback)((function(e){d(0),l(e)}),[]);return(0,z.jsxs)(pj,{focused:n,children:[(0,z.jsx)(hj,{focusKey:Gwe,children:r}),h&&(0,z.jsx)(hj,{focusKey:Bwe,children:(0,z.jsx)(ij,{children:(0,z.jsx)(ap,{onAction:p,children:(0,z.jsx)(rp,{actions:v,children:(0,z.jsx)(wj,{children:(0,z.jsx)(Cm,{styles:zne,children:(0,z.jsx)(zv,{className:Dwe.whatsNewPanel,children:(0,z.jsxs)(Ap,{direction:gp.Horizontal,initialFocused:Vwe,children:[(0,z.jsx)(Ewe,{selected:s,onSelect:b}),(0,z.jsx)(kwe,{tab:i[s],selectedPage:u}),(0,z.jsx)(zv,{className:Dwe.buttonContainer,children:(0,z.jsx)(Qp,{focusKey:Vwe,theme:Jp,onSelect:p,className:Dwe.button,children:(0,z.jsx)(qc.Common.OK,{})})}),(0,z.jsx)(Iwe,{selected:u,onSelect:d,pages:null===(t=i[s].pages)||void 0===t?void 0:t.length}),(0,z.jsxs)(zv,{className:Dwe.dismiss,children:[(0,z.jsx)(fv,{focusKey:Hwe,checked:m,onChange:g,className:Dwe.checkbox}),(0,z.jsx)("div",{className:Dwe.label,children:(0,z.jsx)(qc.Common.DONT_SHOW_AGAIN,{})})]})]})})})})})})})})]})};oe.add("game-ui/menu/components/whats-new-panel/whats-new-panel.tsx",{get WhatsNewPanel(){return Kwe},set WhatsNewPanel(e){Kwe=e}});let Wwe={"menu-ui":"menu-ui_I8X menu-theme_k91",menuUi:"menu-ui_I8X menu-theme_k91","content-container":"content-container_DDJ",contentContainer:"content-container_DDJ",content:"content_fc3","action-hints":"action-hints_qUT child-opacity-transition_nkS",actionHints:"action-hints_qUT child-opacity-transition_nkS",version:"version_VJt",corner:"corner_Uxw","bp-indicator":"bp-indicator_E_n",bpIndicator:"bp-indicator_E_n","user-switch-prompt":"user-switch-prompt_m_H",userSwitchPrompt:"user-switch-prompt_m_H"};oe.add("game-ui/menu/components/menu-ui.module.scss",{get classes(){return Wwe},set classes(e){Object.assign(Wwe,e)}});const zwe=Wwe;function Ywe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function $we(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function qwe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return Ywe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ywe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Xwe=function(){var e=qwe((0,Y.useState)(!1),2),t=e[0],n=e[1],r=Pg(),i=xl(JU),o=xl(ZU),a=xl(qL),s=(0,Y.useCallback)((function(){return jG($U.Menu)}),[]),l=(0,Y.useContext)(dO);return(0,Y.useEffect)((function(){var e=kh.subscribe((function(e){l.showDialog((0,z.jsx)(_O,function(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){$we(e,t,n[t])}))}return e}({},e)))}));return function(){return e.dispose()}}),[l]),(0,z.jsxs)(Tg,{onFocusChange:n,children:[(0,z.jsx)(Kwe,{children:(0,z.jsx)(Gne,{children:(0,z.jsx)(SIe,{children:(0,z.jsxs)("div",{className:zwe.menuUi,children:[(0,z.jsx)("div",{className:zwe.contentContainer,children:(0,z.jsx)("div",{className:zwe.content,children:(0,z.jsx)(pj,{focused:o,activation:yd.Always,children:(0,z.jsxs)(Ud,{children:[o===$U.Menu&&(0,z.jsx)(ine,{focusKey:$U.Menu},$U.Menu),o===$U.NewGame&&(0,z.jsx)(uie,{focusKey:$U.NewGame,onClose:s},$U.NewGame),o===$U.LoadGame&&(0,z.jsx)(nae,{focusKey:$U.LoadGame,onClose:s},$U.LoadGame),o===$U.Options&&(0,z.jsx)(M5,{focusKey:$U.Options,onClose:s},$U.Options),o===$U.Credits&&(0,z.jsx)($Ie,{focusKey:$U.Credits,onClose:s},$U.Credits)]})})})}),(0,z.jsx)("div",{className:zwe.version,children:i}),(0,z.jsxs)("div",{className:zwe.corner,children:[a&&(0,z.jsx)(twe,{className:zwe.userSwitchPrompt}),(0,z.jsx)(g6,{className:zwe.bpIndicator})]})]})})})}),r&&(0,z.jsx)(dk,{disabled:!t,className:zwe.actionHints})]})};oe.add("game-ui/menu/components/menu-ui.tsx",{get MenuUI(){return Xwe},set MenuUI(e){Xwe=e}});let Qwe={"engagement-screen":"engagement-screen_EQg",engagementScreen:"engagement-screen_EQg",pulse:"pulse_kns",icon:"icon_D4A"};oe.add("game-ui/overlay/engagement-screen/engagement-screen.module.scss",{get classes(){return Qwe},set classes(e){Object.assign(Qwe,e)}});const Zwe=Qwe;var Jwe=function(){var e=ePe();return(0,z.jsx)(vk,{className:Zwe.engagementScreen,disabled:!0,children:e})},ePe=function(){var e=Pg(),t=bc((0,z.jsx)(qc.Overlay.ENGAGEMENT_PROMPT_KEYBOARD,{})),n=bc((0,z.jsx)(qc.Overlay.ENGAGEMENT_PROMPT_GAMEPAD,{}));return(0,Y.useMemo)((function(){return e?tPe(n,"<KEY>",(0,z.jsx)(mk,{path:"<Gamepad>/buttonSouth"})):t}),[e,n,t])},tPe=function(e,t,n){var r=e.indexOf(t);return r>=0?(0,z.jsxs)(z.Fragment,{children:[e.substring(0,r),n,e.substring(r+t.length)]}):e};oe.add("game-ui/overlay/engagement-screen/engagement-screen.tsx",{get Engagement(){return Jwe},set Engagement(e){Jwe=e}});let nPe={"overlay-action":"overlay-action_CD_",overlayAction:"overlay-action_CD_",icon:"icon_Cu3","action-hints":"action-hints_TjM",actionHints:"action-hints_TjM"};oe.add("game-ui/overlay/overlay-actions/action/overlay-action.module.scss",{get classes(){return nPe},set classes(e){Object.assign(nPe,e)}});const rPe=nPe;var iPe=function(e){var t=e.displayButtonHints,n=void 0===t||t,r=e.text,i=e.className;return(0,z.jsxs)("div",{className:_d()(rPe.overlayAction,i),children:[n?(0,z.jsx)(dk,{className:rPe.actionHints}):null,r]})};oe.add("game-ui/overlay/overlay-actions/action/overlay-action.tsx",{get OverlayAction(){return iPe},set OverlayAction(e){iPe=e}});let oPe={"overlay-actions":"overlay-actions_epi",overlayActions:"overlay-actions_epi"};oe.add("game-ui/overlay/overlay-actions/overlay-actions.module.scss",{get classes(){return oPe},set classes(e){Object.assign(oPe,e)}});const aPe=oPe;var sPe=function(e){var t=e.className,n=e.children;return(0,z.jsx)("div",{className:_d()(aPe.overlayActions,t),children:n})};oe.add("game-ui/overlay/overlay-actions/overlay-actions.tsx",{get OverlayActions(){return sPe},set OverlayActions(e){sPe=e}});let lPe={"overlay-content":"overlay-content_AYd",overlayContent:"overlay-content_AYd",content:"content_HTa"};oe.add("game-ui/overlay/overlay-content/overlay-content.module.scss",{get classes(){return lPe},set classes(e){Object.assign(lPe,e)}});const cPe=lPe;var uPe=function(e){var t=e.actions,n=e.className,r=e.children;return(0,z.jsxs)("div",{className:_d()(cPe.overlayContent,n),children:[(0,z.jsx)("div",{className:cPe.content,children:r}),t&&t]})};oe.add("game-ui/overlay/overlay-content/overlay-content.tsx",{get OverlayScreen(){return uPe},set OverlayScreen(e){uPe=e}});let dPe={"overlay-text":"overlay-text_AzR",overlayText:"overlay-text_AzR"};oe.add("game-ui/overlay/overlay-text/overlay-text.module.scss",{get classes(){return dPe},set classes(e){Object.assign(dPe,e)}});const fPe=dPe;var mPe=function(e){var t=e.className,n=e.children;return(0,z.jsx)("div",{className:_d()(fPe.overlayText,t),children:n})};oe.add("game-ui/overlay/overlay-text/overlay-text.tsx",{get OverlayText(){return mPe},set OverlayText(e){mPe=e}});var gPe=function(){return(0,z.jsx)(uPe,{actions:(0,z.jsx)(sPe,{children:(0,z.jsx)(iPe,{})}),children:(0,z.jsx)(mPe,{children:(0,z.jsx)(qc.Overlay.CONTROLLER_DISCONNECTED,{})})})};oe.add("game-ui/overlay/logo-screen/controller-disconnected.tsx",{get ControllerDisconnected(){return gPe},set ControllerDisconnected(e){gPe=e}});var hPe=function(){return(0,z.jsx)(uPe,{actions:(0,z.jsx)(sPe,{children:(0,z.jsx)(iPe,{})}),children:(0,z.jsxs)(mPe,{children:[(0,z.jsx)(qc.Overlay.CONTROLLER_PAIRING_CHANGED,{}),(0,z.jsx)(qc.Overlay.SWITCH_USER,{})]})})};oe.add("game-ui/overlay/logo-screen/controller-pairing-changed.tsx",{get ControllerPairingChanged(){return hPe},set ControllerPairingChanged(e){hPe=e}});var pPe,vPe="overlay";!function(e){e[e.None=0]="None",e[e.Splash1=1]="Splash1",e[e.Splash2=2]="Splash2",e[e.Splash3=3]="Splash3",e[e.Splash4=4]="Splash4",e[e.Wait=5]="Wait",e[e.UserLoggedOut=6]="UserLoggedOut",e[e.ControllerDisconnected=7]="ControllerDisconnected",e[e.ControllerPairingChanged=8]="ControllerPairingChanged",e[e.Engagement=9]="Engagement",e[e.Loading=10]="Loading",e[e.CorruptSaveData=11]="CorruptSaveData",e[e.Validation=12]="Validation"}(pPe||(pPe={}));var bPe=fl(vPe,"activeScreen"),yPe=fl(vPe,"progress"),xPe=fl(vPe,"hintMessages"),_Pe=fl(vPe,"corruptDataMessages");oe.add("game-ui/overlay/overlay-bindings.tsx",{get OverlayScreen(){return pPe},set OverlayScreen(e){pPe=e},get activeScreen(){return activeScreen},set activeScreen(e){activeScreen=e},get progress(){return progress},set progress(e){progress=e},get hintMessages(){return hintMessages},set hintMessages(e){hintMessages=e},get corruptDataMessages(){return corruptDataMessages},set corruptDataMessages(e){corruptDataMessages=e}});let jPe={title:"title_oqw",messages:"messages_v_4",message:"message_LOu"};oe.add("game-ui/overlay/logo-screen/corrupt-save-data/corrupt-save-data.module.scss",{get classes(){return jPe},set classes(e){Object.assign(jPe,e)}});const OPe=jPe;var EPe=function(){var e=xl(_Pe),t=(0,Y.useRef)(null),n=$O();return(0,Y.useEffect)((function(){var e=performance.now(),r=0,i=function(o){if(t.current){var a=t.current.scrollHeight;t.current.scrollTop=.08*(o-e)*n%(a/2),r=window.requestAnimationFrame(i)}};return r=window.requestAnimationFrame(i),function(){return window.cancelAnimationFrame(r)}}),[n]),(0,z.jsxs)(uPe,{actions:(0,z.jsx)(sPe,{children:(0,z.jsx)(iPe,{displayButtonHints:!1,text:(0,z.jsx)(qc.Overlay.PRESS_ANY_KEY_ACTION,{})})}),children:[(0,z.jsxs)(mPe,{children:[(0,z.jsx)(qc.Overlay.CORRUPT_SAVE_DATA,{}),(0,z.jsx)("div",{className:OPe.title,children:(0,z.jsx)(qc.Overlay.DELETED_ITEMS,{})})]}),(0,z.jsx)("div",{ref:t,className:OPe.messages,children:null==e?void 0:e.map((function(e,t){return(0,z.jsx)("div",{className:OPe.message,children:e},t)}))})]})};oe.add("game-ui/overlay/logo-screen/corrupt-save-data/corrupt-save-data.tsx",{get CorruptSaveData(){return EPe},set CorruptSaveData(e){EPe=e}});var SPe={tension:30,friction:10},TPe=function(e){var t=e.size,n=e.lineWidth,r=e.progress,i=e.progressColors,o=e.className,a=of(YZ(SPe,r[0],0),.01,1),s=of(YZ(SPe,r[1],0),.01,1),l=of(YZ(SPe,r[2],0),.01,1),c=r.length>0?r.reduce((function(e,t){return e+t}))/r.length:0,u=$O(),d=t*u,f=Math.ceil(d),m=(0,Y.useRef)(null);return(0,Y.useEffect)((function(){if(m.current){var e=m.current.getContext("2d");e.clearRect(0,0,f,f);var t=.5*f-n*u,r=.5*f;e.lineCap="round",e.lineWidth=n*u;for(var o=[a,s,l],c=0;c<o.length;++c){e.beginPath();var d=c*Math.PI;e.arc(r,r,t,d,d+2*o[c]*Math.PI),e.strokeStyle=i[c],e.stroke(),t-=(n+2)*u}}}),[f,n,i,u,a,s,l]),(0,z.jsx)("div",{children:(0,z.jsx)("canvas",{ref:m,width:f,height:f,className:o,style:{width:d,height:d,opacity:of(20*c,0,1)}})})};oe.add("game-ui/overlay/logo-screen/loading/loading-progress.tsx",{get LoadingProgress(){return TPe},set LoadingProgress(e){TPe=e}});let IPe={"overlay-loading":"overlay-loading_xAc",overlayLoading:"overlay-loading_xAc",title:"title_xw2",progress:"progress_xKD",hint:"hint_KWz"};oe.add("game-ui/overlay/logo-screen/loading/loading.module.scss",{get classes(){return IPe},set classes(e){Object.assign(IPe,e)}});const wPe=IPe;function PPe(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function CPe(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var r,i,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(r=n.next()).done)&&(o.push(r.value),!t||o.length!==t);a=!0);}catch(e){s=!0,i=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw i}}return o}}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return PPe(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(n);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return PPe(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var NPe=["#E1F8FF","#84E2FF","#12C8FF"],APe=function(){var e=xl(yPe),t=xl(xPe),n=CPe((0,Y.useState)(0),2),r=n[0],i=n[1];return(0,Y.useEffect)((function(){i(Math.floor(Math.random()*t.length));var e=window.setInterval((function(){i(Math.floor(Math.random()*t.length))}),1e4);return function(){window.clearInterval(e)}}),[t.length]),(0,z.jsxs)("div",{className:wPe.overlayLoading,children:[(0,z.jsx)("div",{className:wPe.title,children:(0,z.jsx)(qc.Loading.LOADING_TITLE,{})}),(0,z.jsx)(TPe,{progress:e,progressColors:NPe,size:128,lineWidth:8,className:wPe.progress}),(0,z.jsx)("div",{className:wPe.hint,children:t.length>r&&(0,z.jsx)(kc,{id:t[r]})})]})};oe.add("game-ui/overlay/logo-screen/loading/loading.tsx",{get LoadingScreen(){return APe},set LoadingScreen(e){APe=e}});let LPe={enter:"enter_Hgx","enter-active":"enter-active_hYc",enterActive:"enter-active_hYc",exit:"exit_mhm","exit-active":"exit-active_via",exitActive:"exit-active_via"};oe.add("game-ui/overlay/transitions/screen.module.scss",{get classes(){return LPe},set classes(e){Object.assign(LPe,e)}});const MPe=LPe;let kPe={"logo-screen":"logo-screen_KLI",logoScreen:"logo-screen_KLI",logo:"logo_IpH",content:"content_sOm"};oe.add("game-ui/overlay/logo-screen/logo-screen.module.scss",{get classes(){return kPe},set classes(e){Object.assign(kPe,e)}});const RPe=kPe;var DPe=function(e){var t=e.children;return(0,z.jsx)(Cm,{styles:MPe,children:(0,z.jsxs)("div",{className:RPe.logoScreen,children:[(0,z.jsx)("img",{src:"Media/Menu/GameLogo.svg",className:RPe.logo}),(0,z.jsx)("div",{className:RPe.content,children:t})]})})};oe.add("game-ui/overlay/logo-screen/logo-screen.tsx",{get LogoScreen(){return DPe},set LogoScreen(e){DPe=e}});var FPe=function(){return(0,z.jsx)(uPe,{children:(0,z.jsxs)(mPe,{children:[(0,z.jsx)(qc.Overlay.USER_LOGGED_OUT,{}),(0,z.jsx)(qc.Overlay.PLEASE_LOG_IN,{})]})})};oe.add("game-ui/overlay/logo-screen/user-logged-out.tsx",{get UserLoggedOut(){return FPe},set UserLoggedOut(e){FPe=e}});var UPe=function(){return(0,z.jsx)(uPe,{actions:(0,z.jsx)(sPe,{children:(0,z.jsx)(iPe,{})}),children:(0,z.jsx)(mPe,{children:(0,z.jsx)(qc.Overlay.VALIDATION,{})})})};oe.add("game-ui/overlay/logo-screen/validation.tsx",{get Validation(){return UPe},set Validation(e){UPe=e}});var GPe=function(){return(0,z.jsx)(uPe,{children:(0,z.jsx)(mPe,{children:(0,z.jsx)(qc.Overlay.PLEASE_WAIT,{})})})};oe.add("game-ui/overlay/logo-screen/wait.tsx",{get Wait(){return GPe},set Wait(e){GPe=e}});let BPe={"splash-screen":"splash-screen_vso",splashScreen:"splash-screen_vso","step-container":"step-container_CQz",stepContainer:"step-container_CQz",enter:"enter_A2e","enter-active":"enter-active_IRn",enterActive:"enter-active_IRn",exit:"exit_qYD","exit-active":"exit-active_Fge",exitActive:"exit-active_Fge",logo:"logo_ceO",splashLogoScale:"splashLogoScale_CGf","splash3-container":"splash3-container_iqq",splash3Container:"splash3-container_iqq","legal-text":"legal-text_p0a",legalText:"legal-text_p0a","coherent-logo":"coherent-logo_ykj logo_ceO",coherentLogo:"coherent-logo_ykj logo_ceO","didimo-logo":"didimo-logo_ar3 logo_ceO",didimoLogo:"didimo-logo_ar3 logo_ceO","instalod-logo":"instalod-logo_Iyq logo_ceO",instalodLogo:"instalod-logo_Iyq logo_ceO","unity-logo":"unity-logo_WZ0 logo_ceO",unityLogo:"unity-logo_WZ0 logo_ceO","colossal-logo":"colossal-logo_gge logo_ceO",colossalLogo:"colossal-logo_gge logo_ceO","paradox-logo":"paradox-logo_FKO logo_ceO",paradoxLogo:"paradox-logo_FKO logo_ceO","sega-logo":"sega-logo_yCR logo_ceO",segaLogo:"sega-logo_yCR logo_ceO"};oe.add("game-ui/overlay/splash-screen/splash-screen.module.scss",{get classes(){return BPe},set classes(e){Object.assign(BPe,e)}});const VPe=BPe;var HPe=function(e){var t=e.screen;return(0,z.jsx)(Cm,{styles:MPe,children:(0,z.jsx)("div",{className:VPe.splashScreen,children:(0,z.jsx)(Ud,{skipInitial:!1,children:(0,z.jsx)(Cm,{styles:VPe,children:(0,z.jsxs)("div",{className:VPe.stepContainer,children:[t===pPe.Splash1&&(0,z.jsx)("img",{src:"Media/Menu/ParadoxLogo.svg",className:VPe.paradoxLogo}),t===pPe.Splash2&&(0,z.jsx)("img",{src:"Media/Menu/ColossalLogo.svg",className:VPe.colossalLogo}),t===pPe.Splash3&&(0,z.jsx)("img",{src:"Media/Menu/SegaLogo.svg",className:VPe.segaLogo}),t===pPe.Splash4&&(0,z.jsxs)(z.Fragment,{children:[(0,z.jsxs)("div",{className:VPe.splash3Container,children:[(0,z.jsx)("img",{src:"Media/Menu/CL_logo_full_horizontal_white.svg",className:VPe.coherentLogo}),(0,z.jsx)("img",{src:"Media/Menu/InstaLOD-Logo-BW-WhiteOnBlack.svg",className:VPe.instalodLogo}),(0,z.jsx)("img",{src:"Media/Menu/U_Logo_MadeWith_RichBlack_Knockout_RGB.svg",className:VPe.unityLogo}),(0,z.jsx)("img",{src:"Media/Menu/Didimo_logo_White_Flat.svg",className:VPe.didimoLogo})]}),(0,z.jsxs)("div",{className:VPe.legalText,children:[(0,z.jsx)("p",{children:"Cities: Skylines II uses Coherent Labs user interface technology. Copyright © 2012-2024 Coherent Labs. All Rights Reserved."}),(0,z.jsx)("p",{children:"Cities: Skylines II uses Didimo Popul8™ characters technology. Copyright © 2023 Didimo, Inc. All Rights Reserved."}),(0,z.jsx)("p",{children:"Cities: Skylines II uses InstaLOD. Copyright © 2016-2024 InstaLOD GmbH. All Rights Reserved."}),(0,z.jsx)("p",{children:"Powered by the Unity Engine. Copyright © 2024 Unity Technologies. All Rights Reserved."})]})]})]})},t)})})})};oe.add("game-ui/overlay/splash-screen/splash-screen.tsx",{get SplashScreen(){return HPe},set SplashScreen(e){HPe=e}});let KPe={"overlay-ui":"overlay-ui_UIz",overlayUi:"overlay-ui_UIz","exit-active":"exit-active_iXm",exitActive:"exit-active_iXm"};oe.add("game-ui/overlay/overlay-ui.module.scss",{get classes(){return KPe},set classes(e){Object.assign(KPe,e)}});const WPe=KPe;var zPe=function(e){var t=e.forcedScreen,n=xl(bPe),r=t||n,i=r!==pPe.None;return H0(),(0,z.jsx)(cS,{in:i,children:(0,z.jsx)(Cm,{styles:WPe,children:(0,z.jsx)("div",{className:WPe.overlayUi,children:(0,z.jsx)(Ud,{children:YPe(r)})})})})};function YPe(e){switch(e){case pPe.Splash1:case pPe.Splash2:case pPe.Splash3:case pPe.Splash4:return(0,z.jsx)(HPe,{screen:e},"splashScreen");case pPe.None:return null;default:return(0,z.jsx)(DPe,{children:(0,z.jsx)(Ud,{children:$Pe(e)})},"logoScreen")}}function $Pe(e){switch(e){case pPe.Loading:return(0,z.jsx)(APe,{},pPe[pPe.Loading]);case pPe.Engagement:return(0,z.jsx)(Jwe,{},pPe[pPe.Engagement]);case pPe.Wait:return(0,z.jsx)(GPe,{},pPe[pPe.Wait]);case pPe.Validation:return(0,z.jsx)(UPe,{},pPe[pPe.Validation]);case pPe.ControllerDisconnected:return(0,z.jsx)(gPe,{},pPe[pPe.ControllerDisconnected]);case pPe.ControllerPairingChanged:return(0,z.jsx)(hPe,{},pPe[pPe.ControllerPairingChanged]);case pPe.UserLoggedOut:return(0,z.jsx)(FPe,{},pPe[pPe.UserLoggedOut]);case pPe.CorruptSaveData:return(0,z.jsx)(EPe,{},pPe[pPe.CorruptSaveData]);default:return null}}oe.add("game-ui/overlay/overlay-ui.tsx",{get OverlayUI(){return zPe},set OverlayUI(e){zPe=e},get renderLogoScreenContent(){return $Pe},set renderLogoScreenContent(e){$Pe=e}});var qPe=function(){var e=xl(wh),t=nR().ready?e:null;return(0,z.jsxs)(X0,{children:[t&&(0,z.jsx)(V0,{activeUiClassName:String(t).toLowerCase(),children:"Menu"===t?(0,z.jsx)(Xwe,{}):"Game"===t?(0,z.jsx)(EIe,{}):"Editor"===t&&(0,z.jsx)(_te,{})}),(0,z.jsx)(zPe,{},"overlayUI")]})};Ys().whenReady.then((function(){var e=function(e){e&&(t.dispose(),function(){var e=(0,ae.createRoot)(ce());e.render((0,z.jsx)(qPe,{}))}())},t=Ih.subscribe(e);e(t.value)})),oe.add("game-ui/index.tsx",{})})()})();